/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const e=/^(https?:\/\/|mailto:|[^:/?#]*(?:[/?#]|$))/i;class t{constructor(t){if(!e.test(t))throw new Error(`URL not marked as safe: ${t}`);this._url=t}toString(){return this._url}}const n={};class i{constructor(){this._experiments=this._loadExperiments()}isEnabled(e){return this._experiments.has(e)}_loadExperiments(){return new Set(window.ENABLED_EXPERIMENTS)}get enabledExperiments(){return[...this._experiments]}}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */function o(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function s(e,t){throw console.error(t,e),new Error(t)}const r="timing-report",a={UI_LATENCY:"UI Latency",RPC:"RPC Timing"},l={APP_STARTED:"App Started"},c="lifecycle",d={DEFAULT:"Default",EXTENSION_DETECTED:"Extension detected",PLUGINS_INSTALLED:"Plugins installed",VISIBILITY:"Visibility"},h="interaction",p={DEFAULT:"Default",VISIBILITY:"Visibility"},u="nav-report",g={LOCATION_CHANGED:"Location Changed"},m={PAGE:"Page"},_="error",f={EXCEPTION:"exception",ERROR_DIALOG:"Error Dialog"},v="ChangeDisplayed",y="ChangeFullyLoaded",b="DashboardDisplayed",w="DiffViewOnlyContent",C="DiffViewDisplayed",E="DiffViewFullyLoaded",S="FileListDisplayed",A="PluginsLoaded",x="StartupChangeDisplayed",P="StartupChangeFullyLoaded",R="StartupDashboardDisplayed",T="StartupDiffViewOnlyContent",I="StartupDiffViewDisplayed",k="StartupDiffViewFullyLoaded",O="StartupFileListDisplayed",N="WebComponentsReady",L="MetricsPluginLoaded",D={[A]:0,[L]:0,[x]:0,[P]:0,[R]:0,[T]:0,[I]:0,[k]:0,[O]:0,[l.APP_STARTED]:0,[N]:0};class ${constructor(){this.accHiddenDurationMs=0,this.lastVisibleTimestampMs=null,this.reset()}reset(){this.accHiddenDurationMs=0,this.lastVisibleTimestampMs=0}onVisibilityChange(){"hidden"===document.visibilityState?this.lastVisibleTimestampMs=M():"visible"===document.visibilityState&&null!==this.lastVisibleTimestampMs&&(this.accHiddenDurationMs+=M()-this.lastVisibleTimestampMs,this.lastVisibleTimestampMs=null)}get hiddenDurationMs(){return"hidden"===document.visibilityState&&null!==this.lastVisibleTimestampMs?this.accHiddenDurationMs+M()-this.lastVisibleTimestampMs:this.accHiddenDurationMs}}function M(){return Math.round(window.performance.now())}class F{constructor(e){this._baselines=D,this._timers={timeBetweenDraftActions:null},this._pending=[],this._slowRpcList=[],this.hiddenDurationTimer=new $,this._flagsService=e}get performanceTiming(){return window.performance.timing}get slowRpcSnapshot(){return(this._slowRpcList||[]).slice()}_arePluginsLoaded(){return this._baselines&&!o(this._baselines,A)}_isMetricsPluginLoaded(){return this._arePluginsLoaded()||this._baselines&&!o(this._baselines,L)}reporter(e,t,n,i,o,s){const r=this._createEventInfo(e,t,n,i,o);e===_&&t===f.EXCEPTION&&console.error(i&&i.error||n),this._isMetricsPluginLoaded()&&!this._pending.length?this._reportEvent(r,s):(this._pending.push([r,s]),this._isMetricsPluginLoaded()&&(this._pending.forEach(([e,t])=>{this._reportEvent(e,t)}),this._pending=[]))}_reportEvent(e,t){const{type:n,value:i,name:o}=e;document.dispatchEvent(new CustomEvent(n,{detail:e})),t||n!==_&&(void 0!==i?console.info(`Reporting: ${o}: ${i}`):console.info(`Reporting: ${o}`))}_createEventInfo(e,t,n,i,o){const s={type:e,category:t,name:n,value:i,eventStart:M()};"object"==typeof o&&0!==Object.entries(o).length&&(s.eventDetails=JSON.stringify(o)),this._reportRepoName&&(s.repoName=this._reportRepoName);const r="hidden"===document.visibilityState;return void 0!==r&&(s.inBackgroundTab=r),this._flagsService.enabledExperiments.length&&(s.enabledExperiments=JSON.stringify(this._flagsService.enabledExperiments)),s}appStarted(){this.timeEnd(l.APP_STARTED),this._reportNavResTimes()}onVisibilityChange(){this.hiddenDurationTimer.onVisibilityChange();const e=`Visibility changed to ${document.visibilityState}`;this.reporter(c,d.VISIBILITY,e,void 0,{hiddenDurationMs:this.hiddenDurationTimer.hiddenDurationMs},!0)}_reportNavResTimes(){Object.keys(this.performanceTiming.toJSON()).forEach(e=>this._reportPerformanceTiming(e))}_reportPerformanceTiming(e,t){const n=this.performanceTiming[e];if(n>0){const i=n-this.performanceTiming.navigationStart;this.reporter(r,a.UI_LATENCY,`NavResTime - ${e}`,i,t,!0)}}beforeLocationChanged(){for(const e of Object.keys(this._baselines))delete this._baselines[e];this.time(v),this.time(y),this.time(b),this.time(w),this.time(C),this.time(E),this.time(S),this._reportRepoName=void 0,this._slowRpcList=[],this.hiddenDurationTimer.reset()}locationChanged(e){this.reporter(u,g.LOCATION_CHANGED,m.PAGE,e)}dashboardDisplayed(){o(this._baselines,R)?this.timeEnd(R,this._pageLoadDetails()):this.timeEnd(b,this._pageLoadDetails())}changeDisplayed(){o(this._baselines,x)?this.timeEnd(x,this._pageLoadDetails()):this.timeEnd(v,this._pageLoadDetails())}changeFullyLoaded(){o(this._baselines,P)?this.timeEnd(P):this.timeEnd(y)}diffViewDisplayed(){o(this._baselines,I)?this.timeEnd(I,this._pageLoadDetails()):this.timeEnd(C,this._pageLoadDetails())}diffViewFullyLoaded(){o(this._baselines,k)?this.timeEnd(k):this.timeEnd(E)}diffViewContentDisplayed(){o(this._baselines,T)?this.timeEnd(T):this.timeEnd(w)}fileListDisplayed(){o(this._baselines,O)?this.timeEnd(O):this.timeEnd(S)}_pageLoadDetails(){var e;const t={rpcList:this.slowRpcSnapshot,hiddenDurationMs:this.hiddenDurationTimer.accHiddenDurationMs};if(window.screen&&(t.screenSize={width:window.screen.width,height:window.screen.height}),(null===document||void 0===document?void 0:document.documentElement)&&(t.viewport={width:document.documentElement.clientWidth,height:document.documentElement.clientHeight}),null===(e=window.performance)||void 0===e?void 0:e.memory){const e=e=>Math.round(e/1048576*100)/100;t.usedJSHeapSizeMb=e(window.performance.memory.usedJSHeapSize)}return t.hiddenDurationMs=this.hiddenDurationTimer.hiddenDurationMs,t}reportExtension(e){this.reporter(c,d.EXTENSION_DETECTED,e)}pluginLoaded(e){e.startsWith("metrics-")&&this.timeEnd(L)}pluginsLoaded(e){this.timeEnd(A),this.reporter(c,d.PLUGINS_INSTALLED,d.PLUGINS_INSTALLED,void 0,{pluginsList:e||[]},!0)}time(e){this._baselines[e]=M(),window.performance.mark(`${e}-start`)}timeEnd(e,t){if(!o(this._baselines,e))return;const n=this._baselines[e];delete this._baselines[e],this._reportTiming(e,M()-n,t),0!==n?window.performance.measure(e,`${e}-start`):window.performance.measure(e)}timeEndWithAverage(e,t,n){if(!o(this._baselines,e))return;const i=this._baselines[e];if(this.timeEnd(e),!n)return;const s=M()-i;this._reportTiming(t,s/n)}_reportTiming(e,t,n){this.reporter(r,a.UI_LATENCY,e,t,n)}getTimer(e){let t,n=!1,i=null;const o={reset:()=>(n=!1,t=M(),o),end:()=>{if(n)throw new Error(`Timer for "${e}" already ended.`);n=!0;const s=M()-t;return i&&s>i?o:(this._reportTiming(e,s),o)},withMaximum:e=>(i=e,o)};return o.reset()}reportRpcTiming(e,t){this.reporter(r,a.RPC,"RPC-"+e,t,{},!0),t>=500&&this._slowRpcList.push({anonymizedUrl:e,elapsed:t})}reportLifeCycle(e,t){this.reporter(c,d.DEFAULT,e,void 0,t,!0)}reportInteraction(e,t){this.reporter(h,p.DEFAULT,e,void 0,t,!0)}recordDraftInteraction(){const e=this._timers.timeBetweenDraftActions;e?e.end().reset():this._timers.timeBetweenDraftActions=this.getTimer("TimeBetweenDraftActions").withMaximum(12e4)}reportErrorDialog(e){this.reporter(_,f.ERROR_DIALOG,"ErrorDialog: "+e,{error:new Error(e)})}setRepoName(e){this._reportRepoName=e}}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class B{constructor(){this._listenersMap=new Map}addListener(e,t){if(!e||!t)return console.warn("A valid eventname and callback is required!"),()=>{};const n=this._listenersMap.get(e)||[];return n.push(t),this._listenersMap.set(e,n),()=>{this.off(e,t)}}on(e,t){return this.addListener(e,t)}once(e,t){const n=(...i)=>{t(...i),this.off(e,n)};return this.on(e,n)}removeListener(e,t){let n=this._listenersMap.get(e)||[];n=n.filter(e=>e!==t),this._listenersMap.set(e,n)}off(e,t){this.removeListener(e,t)}emit(e,t){const n=this._listenersMap.get(e)||[];for(const e of n)try{e(t)}catch(e){console.error(e)}return 0!==n.length}dispatch(e,t){return this.emit(e,t)}removeAllListeners(e){e?this._listenersMap.set(e,[]):this._listenersMap=new Map}}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */function j(){return window.CANONICAL_PATH||""}let H;function U(e,t){return H||(H=new Promise(n=>{var i;(null===(i=null==e?void 0:e.gerrit)||void 0===i?void 0:i.doc_url)?n(e.gerrit.doc_url):t.probePath(j()+"/Documentation/index.html").then(e=>{n(e?j()+"/Documentation":null)})})),H}function G(e,t){let n=encodeURIComponent(encodeURIComponent(e));return n=n.replace(/%253A/g,":"),n=n.replace(/%2520/g,"+"),t&&(n=n.replace(/%252F/g,"/")),n}function V(e){const t=e.replace(/\+/g,"%20");return decodeURIComponent(t)}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */var z,W;!function(e){e.XSRF_TOKEN="xsrf_token",e.ACCESS_TOKEN="access_token"}(z||(z={})),function(e){e[e.UNDETERMINED=0]="UNDETERMINED",e[e.AUTHED=1]="AUTHED",e[e.NOT_AUTHED=2]="NOT_AUTHED",e[e.ERROR=3]="ERROR"}(W||(W={}));class q{constructor(e){this._last_auth_check_time=Date.now(),this._status=W.UNDETERMINED,this._retriesLeft=2,this._cachedTokenPromise=null,this._defaultOptions={},this._getToken=()=>Promise.resolve(this._cachedTokenPromise),this.eventEmitter=e}get baseUrl(){return j()}authCheck(){return(!this._authCheckPromise||Date.now()-this._last_auth_check_time>3e4)&&(this._authCheckPromise=fetch(`${this.baseUrl}/auth-check`),this._last_auth_check_time=Date.now()),this._authCheckPromise.then(e=>204===e.status?(this._setStatus(q.STATUS.AUTHED),!0):(this._setStatus(q.STATUS.NOT_AUTHED),!1)).catch(()=>(this._setStatus(W.ERROR),this._authCheckPromise=void 0,!1))}clearCache(){this._authCheckPromise=void 0}_setStatus(e){this._status!==e&&(this._status===W.AUTHED&&this.eventEmitter.emit("auth-error",{message:q.CREDS_EXPIRED_MSG,action:"Refresh credentials"}),this._status=e)}get status(){return this._status}get isAuthed(){return this._status===q.STATUS.AUTHED}setup(e,t){this._retriesLeft=2,e&&(this._type=z.ACCESS_TOKEN,this._cachedTokenPromise=null,this._getToken=e),this._defaultOptions={},t&&(this._defaultOptions.credentials=t.credentials)}fetch(e,t){const n={headers:new Headers,...this._defaultOptions,...t};return this._type===z.ACCESS_TOKEN?this._getAccessToken().then(t=>this._fetchWithAccessToken(e,n,t)):this._fetchWithXsrfToken(e,n)}_getCookie(e){const t=e+"=";let n="";return document.cookie.split(";").some(e=>!!(e=e.trim()).startsWith(t)&&(n=e.substring(t.length),!0)),n}_isTokenValid(e){if(!e)return!1;if(!e.access_token||!e.expires_at)return!1;const t=new Date(1e3*parseInt(e.expires_at,10));return!(Date.now()>=t.getTime())}_fetchWithXsrfToken(e,t){if(t.method&&"GET"!==t.method){const e=this._getCookie("XSRF_TOKEN");e&&t.headers.append("X-Gerrit-Auth",e)}return t.credentials="same-origin",fetch(e,t)}_getAccessToken(){return this._cachedTokenPromise||(this._cachedTokenPromise=this._getToken()),this._cachedTokenPromise.then(e=>this._isTokenValid(e)?(this._retriesLeft=2,e.access_token):this._retriesLeft>0?(this._retriesLeft--,this._cachedTokenPromise=null,this._getAccessToken()):null)}_fetchWithAccessToken(e,t,n){const i=[];if(n){i.push(`access_token=${n}`);const t=this.baseUrl,o=t?e.substring(e.indexOf(t)+t.length):e;o.startsWith("/a/")||(e=e.replace(o,"/a"+o))}const o=t.method||"GET";let s=t.headers.get("Content-Type");return!s&&t.body&&(s="application/json"),"GET"!==o&&(t.method="POST",i.push(`$m=${o}`),s||(s="text/plain")),s&&(t.headers.set("Content-Type","text/plain"),i.push(`$ct=${encodeURIComponent(s)}`)),i.length&&(e=e+(-1===e.indexOf("?")?"?":"&")+i.join("&")),fetch(e,t)}}q.TYPE={XSRF_TOKEN:z.XSRF_TOKEN,ACCESS_TOKEN:z.ACCESS_TOKEN},q.STATUS={UNDETERMINED:W.UNDETERMINED,AUTHED:W.AUTHED,NOT_AUTHED:W.NOT_AUTHED,ERROR:W.ERROR},q.CREDS_EXPIRED_MSG="Credentials expired.";
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const K=new Map;
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
window.Polymer||(window.Polymer={lazyRegister:!0}),window.Gerrit=window.Gerrit||{},function(e){const t=Object.keys(e).reduce((t,n)=>{const i=n,o=e[i];return t[i]={configurable:!0,get:()=>function(e,t){return K.has(e)||K.set(e,t()),K.get(e)}(i,o)},t},{});Object.defineProperties(n,t)}({flagsService:()=>new i,reportingService:()=>new F(n.flagsService),eventEmitter:()=>new B,authService:()=>new q(n.eventEmitter)}),function(e){const t=e.reportingService;document.addEventListener("visibilitychange",()=>{t.onVisibilityChange()})}(n),function(e){const t=e.reportingService;if(window.PerformanceObserver){if((PerformanceObserver.supportedEntryTypes||[]).includes("longtask")){new PerformanceObserver(e=>{for(const n of e.getEntries())n.duration>200&&t.reporter(r,a.UI_LATENCY,`Task ${n.name}`,Math.round(n.duration),{},!1)}).observe({entryTypes:["longtask"]})}}}(n),function(e){const t=e.reportingService,n=function(e){const n=e||window,i=n.onerror;n.onerror=(e,n,o,s,r)=>function(e,n,i,o,s,r){if(e&&e(n,i,o,s,r),r){o=o||r.lineNumber,s=s||r.columnNumber;let e=n;if(r.stack){const t=r.stack.split("\n");e=t.slice(0,Math.min(3,t.length)).join("\n")}n=e||r.toString()}const a={url:i,line:o,column:s,error:r};return t.reporter(_,f.EXCEPTION,`${n}`,a),!0}(i,e,n,o,s,r),n.addEventListener("unhandledrejection",e=>{const n=e.reason.message,i={error:e.reason};t.reporter(_,f.EXCEPTION,n,i)})};n()}(n);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Y=new URL("..",document.baseURI).href,X=document.createElement("style");X.textContent=`\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-Thin.ttf",Y)}) format("truetype");\n  font-weight: 100;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-ThinItalic.ttf",Y)}) format("truetype");\n  font-weight: 100;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-Light.ttf",Y)}) format("truetype");\n  font-weight: 300;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-LightItalic.ttf",Y)}) format("truetype");\n  font-weight: 300;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-Regular.ttf",Y)}) format("truetype");\n  font-weight: 400;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-Italic.ttf",Y)}) format("truetype");\n  font-weight: 400;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-Medium.ttf",Y)}) format("truetype");\n  font-weight: 500;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-MediumItalic.ttf",Y)}) format("truetype");\n  font-weight: 500;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-Bold.ttf",Y)}) format("truetype");\n  font-weight: 700;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-BoldItalic.ttf",Y)}) format("truetype");\n  font-weight: 700;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-Black.ttf",Y)}) format("truetype");\n  font-weight: 900;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto";\n  src: url(${new URL("fonts/roboto/Roboto-BlackItalic.ttf",Y)}) format("truetype");\n  font-weight: 900;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-Thin.ttf",Y)}) format("truetype");\n  font-weight: 100;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-ThinItalic.ttf",Y)}) format("truetype");\n  font-weight: 100;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-Light.ttf",Y)}) format("truetype");\n  font-weight: 300;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-LightItalic.ttf",Y)}) format("truetype");\n  font-weight: 300;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-Regular.ttf",Y)}) format("truetype");\n  font-weight: 400;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-Italic.ttf",Y)}) format("truetype");\n  font-weight: 400;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-Medium.ttf",Y)}) format("truetype");\n  font-weight: 500;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-MediumItalic.ttf",Y)}) format("truetype");\n  font-weight: 500;\n  font-style: italic;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-Bold.ttf",Y)}) format("truetype");\n  font-weight: 700;\n  font-style: normal;\n  }\n  @font-face {\n  font-family: "Roboto Mono";\n  src: url(${new URL("fonts/robotomono/RobotoMono-BoldItalic.ttf",Y)}) format("truetype");\n  font-weight: 700;\n  font-style: italic;\n  }`,document.head.appendChild(X),
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
window.JSCompiler_renameProperty=function(e,t){return e},
/**
@license
Copyright (c) 2019 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
window.COMPILED=window.COMPILED||!1,COMPILED||window.goog||(window.goog={require(e){if("webcomponentsjs.custom_elements.auto_es5_shim"!==e)throw new Error("Called goog.require without loading //javascript/closure:base")}},window.goog.require.isDevModeNoOpImpl=!0),goog.require("webcomponentsjs.custom_elements.auto_es5_shim"),COMPILED||
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
function(){let e=window.goog&&window.goog.declareModuleId||(()=>{});const t=function(t){if(goog.isInEs6ModuleLoader_())return e(t)};window.goog.declareModuleId?goog.declareModuleId=t:(window.goog.isInEs6ModuleLoader_=()=>!1,Object.defineProperty(window.goog,"declareModuleId",{get:()=>t,set:n=>(e=n,t)}))}(),goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Boot");const J=window.Polymer;window.Polymer=function(e){return window.Polymer._polymerFn(e)},J&&Object.assign(Polymer,J),Polymer._polymerFn=function(e){throw new Error("Load polymer.html to use the Polymer() function.")};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let Z,Q,ee=/(url\()([^)]*)(\))/g,te=/(^\/[^\/])|(^#)|(^[\w-\d]*:)/;function ne(e,t){if(e&&te.test(e))return e;if("//"===e)return e;if(void 0===Z){Z=!1;try{const e=new URL("b","http://a");e.pathname="c%20d",Z="http://a/c%20d"===e.href}catch(e){}}if(t||(t=document.baseURI||window.location.href),Z)try{return new URL(e,t).href}catch(t){return e}return Q||(Q=document.implementation.createHTMLDocument("temp"),Q.base=Q.createElement("base"),Q.head.appendChild(Q.base),Q.anchor=Q.createElement("a"),Q.body.appendChild(Q.anchor)),Q.base.href=t,Q.anchor.href=e,Q.anchor.href||e}function ie(e,t){return e.replace(ee,(function(e,n,i,o){return n+"'"+ne(i.replace(/["']/g,""),t)+"'"+o}))}function oe(e){return e.substring(0,e.lastIndexOf("/")+1)}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/const se=oe,re=ie,ae=ne;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.ResolveUrl"),Polymer.ResolveUrl={resolveCss:re,resolveUrl:ae,pathFromUrl:se};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const le=!window.ShadyDOM||!window.ShadyDOM.inUse,ce=Boolean(!window.ShadyCSS||window.ShadyCSS.nativeCss),de=!window.customElements.polyfillWrapFlushCallback,he=le&&"adoptedStyleSheets"in Document.prototype&&"replaceSync"in CSSStyleSheet.prototype&&(()=>{try{const e=new CSSStyleSheet;e.replaceSync("");const t=document.createElement("div");return t.attachShadow({mode:"open"}),t.shadowRoot.adoptedStyleSheets=[e],t.shadowRoot.adoptedStyleSheets[0]===e}catch(e){return!1}})();let pe=window.Polymer&&window.Polymer.rootPath||oe(document.baseURI||window.location.href);const ue=function(e){pe=e};let ge=window.Polymer&&window.Polymer.sanitizeDOMValue||void 0;const me=function(e){ge=e};let _e=window.Polymer&&window.Polymer.setPassiveTouchGestures||!1;const fe=function(e){_e=e};let ve=window.Polymer&&window.Polymer.strictTemplatePolicy||!1;const ye=function(e){ve=e};let be=window.Polymer&&window.Polymer.allowTemplateFromDomModule||!1;const we=function(e){be=e};let Ce=window.Polymer&&window.Polymer.legacyOptimizations||!1;const Ee=function(e){Ce=e};let Se=window.Polymer&&window.Polymer.legacyWarnings||!1;let Ae=window.Polymer&&window.Polymer.syncInitialRender||!1;const xe=function(e){Ae=e};let Pe=window.Polymer&&window.Polymer.legacyUndefined||!1;let Re=window.Polymer&&window.Polymer.orderedComputed||!1;let Te=!0;let Ie=window.Polymer&&window.Polymer.removeNestedTemplates||!1;let ke=window.Polymer&&window.Polymer.fastDomIf||!1;let Oe=window.Polymer&&window.Polymer.suppressTemplateNotifications||!1;let Ne=window.Polymer&&window.Polymer.legacyNoObservedAttributes||!1;let Le=window.Polymer&&window.Polymer.useAdoptedStyleSheetsWithBuiltCSS||!1;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Settings"),Polymer.Settings={useShadow:le,useNativeCSSProperties:ce,useNativeCustomElements:de,get rootPath(){return pe},setRootPath:ue,get sanitizeDOMValue(){return ge},setSanitizeDOMValue:me,get passiveTouchGestures(){return _e},setPassiveTouchGestures:fe,get strictTemplatePolicy(){return ve},setStrictTemplatePolicy:ye,get allowTemplateFromDomModule(){return be},setAllowTemplateFromDomModule:we,get legacyOptimizations(){return Ce},setLegacyOptimizations:Ee,get syncInitialRender(){return Ae},setSyncInitialRender:xe},void 0!==Polymer.rootPath&&ue(Polymer.rootPath),void 0!==Polymer.sanitizeDOMValue&&me(Polymer.sanitizeDOMValue),void 0!==Polymer.passiveTouchGestures&&fe(Polymer.passiveTouchGestures),void 0!==Polymer.strictTemplatePolicy&&ye(Polymer.strictTemplatePolicy),void 0!==Polymer.allowTemplateFromDomModule?we(Polymer.allowTemplateFromDomModule):we(!0),void 0!==Polymer.legacyOptimizations&&Ee(Polymer.legacyOptimizations),void 0!==Polymer.syncInitialRender&&xe(Polymer.syncInitialRender),Object.defineProperty(Polymer,"sanitizeDOMValue",{get:()=>ge,set(e){me(e)}});
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let De=0;function $e(){}$e.prototype.__mixinApplications,$e.prototype.__mixinSet;const Me=function(e){let t=e.__mixinApplications;t||(t=new WeakMap,e.__mixinApplications=t);let n=De++;return function(i){let o=i.__mixinSet;if(o&&o[n])return i;let s=t,r=s.get(i);if(!r){r=e(i),s.set(i,r);let t=Object.create(r.__mixinSet||o||null);t[n]=!0,r.__mixinSet=t}return r}},Fe=Me;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Mixin"),Polymer.dedupingMixin=Fe;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let Be={},je={};function He(e,t){Be[e]=je[e.toLowerCase()]=t}function Ue(e){return Be[e]||je[e.toLowerCase()]}class Ge extends HTMLElement{static get observedAttributes(){return["id"]}static import(e,t){if(e){let n=Ue(e);return n&&t?n.querySelector(t):n}return null}attributeChangedCallback(e,t,n,i){t!==n&&this.register()}get assetpath(){if(!this.__assetpath){const e=window.HTMLImports&&HTMLImports.importForElement?HTMLImports.importForElement(this)||document:this.ownerDocument,t=ne(this.getAttribute("assetpath")||"",e.baseURI);this.__assetpath=oe(t)}return this.__assetpath}register(e){if(e=e||this.id){if(ve&&void 0!==Ue(e))throw He(e,null),new Error(`strictTemplatePolicy: dom-module ${e} re-registered`);this.id=e,He(e,this),(t=this).querySelector("style")&&console.warn("dom-module %s has style outside template",t.id)}var t}}Ge.prototype.modules=Be,customElements.define("dom-module",Ge),
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Elements.DomModule"),Polymer.DomModule=Ge;function Ve(e){return Ge.import(e)}function ze(e){const t=ie((e.body?e.body:e).textContent,e.baseURI),n=document.createElement("style");return n.textContent=t,n}function We(e){const t=e.trim().split(/\s+/),n=[];for(let e=0;e<t.length;e++)n.push(...qe(t[e]));return n}function qe(e){const t=Ve(e);if(!t)return console.warn("Could not find style data in module named",e),[];if(void 0===t._styles){const e=[];e.push(...Xe(t));const n=t.querySelector("template");n&&e.push(...Ke(n,t.assetpath)),t._styles=e}return t._styles}function Ke(e,t){if(!e._styles){const n=[],i=e.content.querySelectorAll("style");for(let e=0;e<i.length;e++){let o=i[e],s=o.getAttribute("include");s&&n.push(...We(s).filter((function(e,t,n){return n.indexOf(e)===t}))),t&&(o.textContent=ie(o.textContent,t)),n.push(o)}e._styles=n}return e._styles}function Ye(e){let t=Ve(e);return t?Xe(t):[]}function Xe(e){const t=[],n=e.querySelectorAll("link[rel=import][type~=css]");for(let e=0;e<n.length;e++){let i=n[e];if(i.import){const e=i.import,n=i.hasAttribute("shady-unscoped");if(n&&!e._unscopedStyle){const t=ze(e);t.setAttribute("shady-unscoped",""),e._unscopedStyle=t}else e._style||(e._style=ze(e));t.push(n?e._unscopedStyle:e._style)}}return t}function Je(e){let t=e.trim().split(/\s+/),n="";for(let e=0;e<t.length;e++)n+=Ze(t[e]);return n}function Ze(e){let t=Ve(e);if(t&&void 0===t._cssText){let e=et(t),n=t.querySelector("template");n&&(e+=Qe(n,t.assetpath)),t._cssText=e||null}return t||console.warn("Could not find style data in module named",e),t&&t._cssText||""}function Qe(e,t){let n="";const i=Ke(e,t);for(let e=0;e<i.length;e++){let t=i[e];t.parentNode&&t.parentNode.removeChild(t),n+=t.textContent}return n}function et(e){let t="",n=Xe(e);for(let e=0;e<n.length;e++)t+=n[e].textContent;return t}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.StyleGather");const tt=Ze,nt=function(e){let t=Ve(e);return t?et(t):""},it=Je,ot=Qe,st=qe,rt=Ye,at=We,lt=Ke;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
function ct(e){return e.indexOf(".")>=0}function dt(e){let t=e.indexOf(".");return-1===t?e:e.slice(0,t)}function ht(e,t){return 0===e.indexOf(t+".")}function pt(e,t){return 0===t.indexOf(e+".")}function ut(e,t,n){return t+n.slice(e.length)}function gt(e,t){return e===t||ht(e,t)||pt(e,t)}function mt(e){if(Array.isArray(e)){let t=[];for(let n=0;n<e.length;n++){let i=e[n].toString().split(".");for(let e=0;e<i.length;e++)t.push(i[e])}return t.join(".")}return e}function _t(e){return Array.isArray(e)?mt(e).split("."):e.toString().split(".")}function ft(e,t,n){let i=e,o=_t(t);for(let e=0;e<o.length;e++){if(!i)return;i=i[o[e]]}return n&&(n.path=o.join(".")),i}function vt(e,t,n){let i=e,o=_t(t),s=o[o.length-1];if(o.length>1){for(let e=0;e<o.length-1;e++){if(i=i[o[e]],!i)return}i[s]=n}else i[t]=n;return o.join(".")}Polymer.StyleGather={stylesFromModules:at,stylesFromModule:st,stylesFromTemplate:lt,stylesFromModuleImports:rt,cssFromModules:it,cssFromModule:tt,cssFromTemplate:ot,cssFromModuleImports:nt};const yt=ct,bt=dt,wt=ht,Ct=pt,Et=ut,St=gt,At=mt,xt=_t,Pt=ft,Rt=vt,Tt=ct;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Path"),Polymer.Path={isPath:yt,root:bt,isAncestor:wt,isDescendant:Ct,translate:Et,matches:St,normalize:At,split:xt,get:Pt,set:Rt,isDeep:Tt};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const It={},kt=/-[a-z]/g,Ot=/([A-Z])/g;function Nt(e){return It[e]||(It[e]=e.indexOf("-")<0?e:e.replace(kt,e=>e[1].toUpperCase()))}function Lt(e){return It[e]||(It[e]=e.replace(Ot,"-$1").toLowerCase())}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.CaseMap");const Dt=Nt,$t=Lt;Polymer.CaseMap={dashToCamelCase:Dt,camelToDashCase:$t};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let Mt=0,Ft=0,Bt=[],jt=0,Ht=!1,Ut=document.createTextNode("");new window.MutationObserver((function(){Ht=!1;const e=Bt.length;for(let t=0;t<e;t++){let e=Bt[t];if(e)try{e()}catch(e){setTimeout(()=>{throw e})}}Bt.splice(0,e),Ft+=e})).observe(Ut,{characterData:!0});const Gt={after:e=>({run:t=>window.setTimeout(t,e),cancel(e){window.clearTimeout(e)}}),run:(e,t)=>window.setTimeout(e,t),cancel(e){window.clearTimeout(e)}},Vt={run:e=>window.requestAnimationFrame(e),cancel(e){window.cancelAnimationFrame(e)}},zt={run:e=>window.requestIdleCallback?window.requestIdleCallback(e):window.setTimeout(e,16),cancel(e){window.cancelIdleCallback?window.cancelIdleCallback(e):window.clearTimeout(e)}},Wt={run:e=>(Ht||(Ht=!0,Ut.textContent=jt++),Bt.push(e),Mt++),cancel(e){const t=e-Ft;if(t>=0){if(!Bt[t])throw new Error("invalid async handle: "+e);Bt[t]=null}}};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Async"),Polymer.Async={timeOut:Gt,animationFrame:Vt,idlePeriod:zt,microTask:Wt};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const qt=window.ShadyDOM&&window.ShadyDOM.noPatch&&window.ShadyDOM.wrap?window.ShadyDOM.wrap:window.ShadyDOM?e=>ShadyDOM.patch(e):e=>e;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Wrap"),Polymer.wrap=qt;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const Kt=Wt,Yt=Me(e=>class extends e{static createProperties(e){const t=this.prototype;for(let n in e)n in t||t._createPropertyAccessor(n)}static attributeNameForProperty(e){return e.toLowerCase()}static typeForProperty(e){}_createPropertyAccessor(e,t){this._addPropertyToAttributeMap(e),this.hasOwnProperty(JSCompiler_renameProperty("__dataHasAccessor",this))||(this.__dataHasAccessor=Object.assign({},this.__dataHasAccessor)),this.__dataHasAccessor[e]||(this.__dataHasAccessor[e]=!0,this._definePropertyAccessor(e,t))}_addPropertyToAttributeMap(e){this.hasOwnProperty(JSCompiler_renameProperty("__dataAttributes",this))||(this.__dataAttributes=Object.assign({},this.__dataAttributes));let t=this.__dataAttributes[e];return t||(t=this.constructor.attributeNameForProperty(e),this.__dataAttributes[t]=e),t}_definePropertyAccessor(e,t){Object.defineProperty(this,e,{get(){return this.__data[e]},set:t?function(){}:function(t){this._setPendingProperty(e,t,!0)&&this._invalidateProperties()}})}constructor(){super(),this.__dataEnabled=!1,this.__dataReady=!1,this.__dataInvalid=!1,this.__data={},this.__dataPending=null,this.__dataOld=null,this.__dataInstanceProps=null,this.__dataCounter=0,this.__serializing=!1,this._initializeProperties()}ready(){this.__dataReady=!0,this._flushProperties()}_initializeProperties(){for(let e in this.__dataHasAccessor)this.hasOwnProperty(e)&&(this.__dataInstanceProps=this.__dataInstanceProps||{},this.__dataInstanceProps[e]=this[e],delete this[e])}_initializeInstanceProperties(e){Object.assign(this,e)}_setProperty(e,t){this._setPendingProperty(e,t)&&this._invalidateProperties()}_getProperty(e){return this.__data[e]}_setPendingProperty(e,t,n){let i=this.__data[e],o=this._shouldPropertyChange(e,t,i);return o&&(this.__dataPending||(this.__dataPending={},this.__dataOld={}),!this.__dataOld||e in this.__dataOld||(this.__dataOld[e]=i),this.__data[e]=t,this.__dataPending[e]=t),o}_isPropertyPending(e){return!(!this.__dataPending||!this.__dataPending.hasOwnProperty(e))}_invalidateProperties(){!this.__dataInvalid&&this.__dataReady&&(this.__dataInvalid=!0,Kt.run(()=>{this.__dataInvalid&&(this.__dataInvalid=!1,this._flushProperties())}))}_enableProperties(){this.__dataEnabled||(this.__dataEnabled=!0,this.__dataInstanceProps&&(this._initializeInstanceProperties(this.__dataInstanceProps),this.__dataInstanceProps=null),this.ready())}_flushProperties(){this.__dataCounter++;const e=this.__data,t=this.__dataPending,n=this.__dataOld;this._shouldPropertiesChange(e,t,n)&&(this.__dataPending=null,this.__dataOld=null,this._propertiesChanged(e,t,n)),this.__dataCounter--}_shouldPropertiesChange(e,t,n){return Boolean(t)}_propertiesChanged(e,t,n){}_shouldPropertyChange(e,t,n){return n!==t&&(n==n||t==t)}attributeChangedCallback(e,t,n,i){t!==n&&this._attributeToProperty(e,n),super.attributeChangedCallback&&super.attributeChangedCallback(e,t,n,i)}_attributeToProperty(e,t,n){if(!this.__serializing){const i=this.__dataAttributes,o=i&&i[e]||e;this[o]=this._deserializeValue(t,n||this.constructor.typeForProperty(o))}}_propertyToAttribute(e,t,n){this.__serializing=!0,n=arguments.length<3?this[e]:n,this._valueToNodeAttribute(this,n,t||this.constructor.attributeNameForProperty(e)),this.__serializing=!1}_valueToNodeAttribute(e,t,n){const i=this._serializeValue(t);"class"!==n&&"name"!==n&&"slot"!==n||(e=qt(e)),void 0===i?e.removeAttribute(n):e.setAttribute(n,i)}_serializeValue(e){switch(typeof e){case"boolean":return e?"":void 0;default:return null!=e?e.toString():void 0}}_deserializeValue(e,t){switch(t){case Boolean:return null!==e;case Number:return Number(e);default:return e}}}),Xt=Yt;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.PropertiesChanged"),Polymer.PropertiesChanged=Xt;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const Jt={};let Zt=HTMLElement.prototype;for(;Zt;){let e=Object.getOwnPropertyNames(Zt);for(let t=0;t<e.length;t++)Jt[e[t]]=!0;Zt=Object.getPrototypeOf(Zt)}const Qt=Me(e=>{const t=Yt(e);return class extends t{static createPropertiesForAttributes(){let e=this.observedAttributes;for(let t=0;t<e.length;t++)this.prototype._createPropertyAccessor(Nt(e[t]))}static attributeNameForProperty(e){return Lt(e)}_initializeProperties(){this.__dataProto&&(this._initializeProtoProperties(this.__dataProto),this.__dataProto=null),super._initializeProperties()}_initializeProtoProperties(e){for(let t in e)this._setProperty(t,e[t])}_ensureAttribute(e,t){const n=this;n.hasAttribute(e)||this._valueToNodeAttribute(n,t,e)}_serializeValue(e){switch(typeof e){case"object":if(e instanceof Date)return e.toString();if(e)try{return JSON.stringify(e)}catch(e){return""}default:return super._serializeValue(e)}}_deserializeValue(e,t){let n;switch(t){case Object:try{n=JSON.parse(e)}catch(t){n=e}break;case Array:try{n=JSON.parse(e)}catch(t){n=null,console.warn(`Polymer::Attributes: couldn't decode Array as JSON: ${e}`)}break;case Date:n=isNaN(e)?String(e):Number(e),n=new Date(n);break;default:n=super._deserializeValue(e,t)}return n}_definePropertyAccessor(e,t){!function(e,t){if(!Jt[t]){let n=e[t];void 0!==n&&(e.__data?e._setPendingProperty(t,n):(e.__dataProto?e.hasOwnProperty(JSCompiler_renameProperty("__dataProto",e))||(e.__dataProto=Object.create(e.__dataProto)):e.__dataProto={},e.__dataProto[t]=n))}}(this,e),super._definePropertyAccessor(e,t)}_hasAccessor(e){return this.__dataHasAccessor&&this.__dataHasAccessor[e]}_isPropertyPending(e){return Boolean(this.__dataPending&&e in this.__dataPending)}}}),en=Qt;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.PropertyAccessors"),Polymer.PropertyAccessors=en;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const tn={"dom-if":!0,"dom-repeat":!0};let nn=!1,on=!1;function sn(e){(function(){if(!nn){nn=!0;const e=document.createElement("textarea");e.placeholder="a",on=e.placeholder===e.textContent}return on})()&&"textarea"===e.localName&&e.placeholder&&e.placeholder===e.textContent&&(e.textContent=null)}function rn(e){let t=e.getAttribute("is");if(t&&tn[t]){let n=e;for(n.removeAttribute("is"),e=n.ownerDocument.createElement(t),n.parentNode.replaceChild(e,n),e.appendChild(n);n.attributes.length;)e.setAttribute(n.attributes[0].name,n.attributes[0].value),n.removeAttribute(n.attributes[0].name)}return e}function an(e,t){let n=t.parentInfo&&an(e,t.parentInfo);if(!n)return e;for(let e=n.firstChild,i=0;e;e=e.nextSibling)if(t.parentIndex===i++)return e}function ln(e,t,n,i){i.id&&(t[i.id]=n)}function cn(e,t,n){if(n.events&&n.events.length)for(let i,o=0,s=n.events;o<s.length&&(i=s[o]);o++)e._addMethodEventListenerToNode(t,i.name,i.value,e)}function dn(e,t,n,i){n.templateInfo&&(t._templateInfo=n.templateInfo,t._parentTemplateInfo=i)}const hn=Me(e=>class extends e{static _parseTemplate(e,t){if(!e._templateInfo){let n=e._templateInfo={};n.nodeInfoList=[],n.nestedTemplate=Boolean(t),n.stripWhiteSpace=t&&t.stripWhiteSpace||e.hasAttribute("strip-whitespace"),this._parseTemplateContent(e,n,{parent:null})}return e._templateInfo}static _parseTemplateContent(e,t,n){return this._parseTemplateNode(e.content,t,n)}static _parseTemplateNode(e,t,n){let i=!1,o=e;return"template"!=o.localName||o.hasAttribute("preserve-content")?"slot"===o.localName&&(t.hasInsertionPoint=!0):i=this._parseTemplateNestedTemplate(o,t,n)||i,sn(o),o.firstChild&&this._parseTemplateChildNodes(o,t,n),o.hasAttributes&&o.hasAttributes()&&(i=this._parseTemplateNodeAttributes(o,t,n)||i),i||n.noted}static _parseTemplateChildNodes(e,t,n){if("script"!==e.localName&&"style"!==e.localName)for(let i,o=e.firstChild,s=0;o;o=i){if("template"==o.localName&&(o=rn(o)),i=o.nextSibling,o.nodeType===Node.TEXT_NODE){let n=i;for(;n&&n.nodeType===Node.TEXT_NODE;)o.textContent+=n.textContent,i=n.nextSibling,e.removeChild(n),n=i;if(t.stripWhiteSpace&&!o.textContent.trim()){e.removeChild(o);continue}}let r={parentIndex:s,parentInfo:n};this._parseTemplateNode(o,t,r)&&(r.infoIndex=t.nodeInfoList.push(r)-1),o.parentNode&&s++}}static _parseTemplateNestedTemplate(e,t,n){let i=e,o=this._parseTemplate(i,t);return(o.content=i.content.ownerDocument.createDocumentFragment()).appendChild(i.content),n.templateInfo=o,!0}static _parseTemplateNodeAttributes(e,t,n){let i=!1,o=Array.from(e.attributes);for(let s,r=o.length-1;s=o[r];r--)i=this._parseTemplateNodeAttribute(e,t,n,s.name,s.value)||i;return i}static _parseTemplateNodeAttribute(e,t,n,i,o){return"on-"===i.slice(0,3)?(e.removeAttribute(i),n.events=n.events||[],n.events.push({name:i.slice(3),value:o}),!0):"id"===i&&(n.id=o,!0)}static _contentForTemplate(e){let t=e._templateInfo;return t&&t.content||e.content}_stampTemplate(e,t){e&&!e.content&&window.HTMLTemplateElement&&HTMLTemplateElement.decorate&&HTMLTemplateElement.decorate(e);let n=(t=t||this.constructor._parseTemplate(e)).nodeInfoList,i=t.content||e.content,o=document.importNode(i,!0);o.__noInsertionPoint=!t.hasInsertionPoint;let s=o.nodeList=new Array(n.length);o.$={};for(let e,i=0,r=n.length;i<r&&(e=n[i]);i++){let n=s[i]=an(o,e);ln(0,o.$,n,e),dn(0,n,e,t),cn(this,n,e)}return o=o,o}_addMethodEventListenerToNode(e,t,n,i){let o=function(e,t,n){return e=e._methodHost||e,function(t){e[n]?e[n](t,t.detail):console.warn("listener method `"+n+"` not defined")}}(i=i||e,0,n);return this._addEventListenerToNode(e,t,o),o}_addEventListenerToNode(e,t,n){e.addEventListener(t,n)}_removeEventListenerFromNode(e,t,n){e.removeEventListener(t,n)}}),pn=hn;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.TemplateStamp"),Polymer.TemplateStamp=pn;
/**
 * @fileoverview
 * @suppress {checkPrototypalTypes}
 * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
 * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
 * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
 * Google as part of the polymer project is also subject to an additional IP
 * rights grant found at http://polymer.github.io/PATENTS.txt
 */
let un=0;const gn=[],mn={COMPUTE:"__computeEffects",REFLECT:"__reflectEffects",NOTIFY:"__notifyEffects",PROPAGATE:"__propagateEffects",OBSERVE:"__observeEffects",READ_ONLY:"__readOnly"},_n=/[A-Z]/;function fn(e,t,n){let i=e[t];if(i){if(!e.hasOwnProperty(t)&&(i=e[t]=Object.create(e[t]),n))for(let e in i){let t=i[e],n=i[e]=Array(t.length);for(let e=0;e<t.length;e++)n[e]=t[e]}}else i=e[t]={};return i}function vn(e,t,n,i,o,s){if(t){let r=!1;const a=un++;for(let l in n){let c=t[o?dt(l):l];if(c)for(let t,d=0,h=c.length;d<h&&(t=c[d]);d++)t.info&&t.info.lastRun===a||o&&!bn(l,t.trigger)||(t.info&&(t.info.lastRun=a),t.fn(e,l,n,i,t.info,o,s),r=!0)}return r}return!1}function yn(e,t,n,i,o,s,r,a){let l=!1,c=t[r?dt(i):i];if(c)for(let t,d=0,h=c.length;d<h&&(t=c[d]);d++)t.info&&t.info.lastRun===n||r&&!bn(i,t.trigger)||(t.info&&(t.info.lastRun=n),t.fn(e,i,o,s,t.info,r,a),l=!0);return l}function bn(e,t){if(t){let n=t.name;return n==e||!(!t.structured||!ht(n,e))||!(!t.wildcard||!pt(n,e))}return!0}function wn(e,t,n,i,o){let s="string"==typeof o.method?e[o.method]:o.method,r=o.property;s?s.call(e,e.__data[r],i[r]):o.dynamicFn||console.warn("observer method `"+o.method+"` not defined")}function Cn(e,t,n){let i=dt(t);if(i!==t){return En(e,Lt(i)+"-changed",n[t],t),!0}return!1}function En(e,t,n,i){let o={value:n,queueProperty:!0};i&&(o.path=i),qt(e).dispatchEvent(new CustomEvent(t,{detail:o}))}function Sn(e,t,n,i,o,s){let r=(s?dt(t):t)!=t?t:null,a=r?ft(e,r):e.__data[t];r&&void 0===a&&(a=n[t]),En(e,o.eventName,a,r)}function An(e,t,n,i,o){let s=e.__data[t];ge&&(s=ge(s,o.attrName,"attribute",e)),e._propertyToAttribute(t,o.attrName,s)}function xn(e,t,n,i){let o=e[mn.COMPUTE];if(o)if(Re){un++;const s=function(e){let t=e.constructor.__orderedComputedDeps;if(!t){t=new Map;const n=e[mn.COMPUTE];let i,{counts:o,ready:s,total:r}=function(e){const t=e.__computeInfo,n={},i=e[mn.COMPUTE],o=[];let s=0;for(let e in t){const i=t[e];s+=n[e]=i.args.filter(e=>!e.literal).length+(i.dynamicFn?1:0)}for(let e in i)t[e]||o.push(e);return{counts:n,ready:o,total:s}}(e);for(;i=s.shift();){t.set(i,t.size);const e=n[i];e&&e.forEach(e=>{const t=e.info.methodInfo;--r,0==--o[t]&&s.push(t)})}if(0!==r){const t=e;console.warn(`Computed graph for ${t.localName} incomplete; circular?`)}e.constructor.__orderedComputedDeps=t}return t}(e),r=[];for(let e in t)Rn(e,o,r,s,i);let a;for(;a=r.shift();)Tn(e,"",t,n,a)&&Rn(a.methodInfo,o,r,s,i);Object.assign(n,e.__dataOld),Object.assign(t,e.__dataPending),e.__dataPending=null}else{let s=t;for(;vn(e,o,s,n,i);)Object.assign(n,e.__dataOld),Object.assign(t,e.__dataPending),s=e.__dataPending,e.__dataPending=null}}const Pn=(e,t,n)=>{let i=0,o=t.length-1,s=-1;for(;i<=o;){const r=i+o>>1,a=n.get(t[r].methodInfo)-n.get(e.methodInfo);if(a<0)i=r+1;else{if(!(a>0)){s=r;break}o=r-1}}s<0&&(s=o+1),t.splice(s,0,e)},Rn=(e,t,n,i,o)=>{const s=t[o?dt(e):e];if(s)for(let t=0;t<s.length;t++){const r=s[t];r.info.lastRun===un||o&&!bn(e,r.trigger)||(r.info.lastRun=un,Pn(r.info,n,i))}};function Tn(e,t,n,i,o){let s=$n(e,t,n,i,o);if(s===gn)return!1;let r=o.methodInfo;return e.__dataHasAccessor&&e.__dataHasAccessor[r]?e._setPendingProperty(r,s,!0):(e[r]=s,!1)}function In(e,t,n,i,o,s,r){n.bindings=n.bindings||[];let a={kind:i,target:o,parts:s,literal:r,isCompound:1!==s.length};if(n.bindings.push(a),function(e){return Boolean(e.target)&&"attribute"!=e.kind&&"text"!=e.kind&&!e.isCompound&&"{"===e.parts[0].mode}(a)){let{event:e,negate:t}=a.parts[0];a.listenerEvent=e||Lt(o)+"-changed",a.listenerNegate=t}let l=t.nodeInfoList.length;for(let n=0;n<a.parts.length;n++){let i=a.parts[n];i.compoundIndex=n,kn(e,t,a,i,l)}}function kn(e,t,n,i,o){if(!i.literal)if("attribute"===n.kind&&"-"===n.target[0])console.warn("Cannot set attribute "+n.target+' because "-" is not a valid attribute starting character');else{let s=i.dependencies,r={index:o,binding:n,part:i,evaluator:e};for(let n=0;n<s.length;n++){let i=s[n];"string"==typeof i&&(i=Hn(i),i.wildcard=!0),e._addTemplatePropertyEffect(t,i.rootProperty,{fn:On,info:r,trigger:i})}}}function On(e,t,n,i,o,s,r){let a=r[o.index],l=o.binding,c=o.part;if(s&&c.source&&t.length>c.source.length&&"property"==l.kind&&!l.isCompound&&a.__isPropertyEffectsClient&&a.__dataHasAccessor&&a.__dataHasAccessor[l.target]){let i=n[t];t=ut(c.source,l.target,t),a._setPendingPropertyOrPath(t,i,!1,!0)&&e._enqueueClient(a)}else{let r=o.evaluator._evaluateBinding(e,c,t,n,i,s);r!==gn&&function(e,t,n,i,o){o=function(e,t,n,i){if(n.isCompound){let o=e.__dataCompoundStorage[n.target];o[i.compoundIndex]=t,t=o.join("")}"attribute"!==n.kind&&("textContent"!==n.target&&("value"!==n.target||"input"!==e.localName&&"textarea"!==e.localName)||(t=null==t?"":t));return t}(t,o,n,i),ge&&(o=ge(o,n.target,n.kind,t));if("attribute"==n.kind)e._valueToNodeAttribute(t,o,n.target);else{let i=n.target;t.__isPropertyEffectsClient&&t.__dataHasAccessor&&t.__dataHasAccessor[i]?t[mn.READ_ONLY]&&t[mn.READ_ONLY][i]||t._setPendingProperty(i,o)&&e._enqueueClient(t):e._setUnmanagedPropertyToNode(t,i,o)}}(e,a,l,c,r)}}function Nn(e,t){if(t.isCompound){let n=e.__dataCompoundStorage||(e.__dataCompoundStorage={}),i=t.parts,o=new Array(i.length);for(let e=0;e<i.length;e++)o[e]=i[e].literal;let s=t.target;n[s]=o,t.literal&&"property"==t.kind&&("className"===s&&(e=qt(e)),e[s]=t.literal)}}function Ln(e,t,n){if(n.listenerEvent){let i=n.parts[0];e.addEventListener(n.listenerEvent,(function(e){!function(e,t,n,i,o){let s,r=e.detail,a=r&&r.path;a?(i=ut(n,i,a),s=r&&r.value):s=e.currentTarget[n],s=o?!s:s,t[mn.READ_ONLY]&&t[mn.READ_ONLY][i]||!t._setPendingPropertyOrPath(i,s,!0,Boolean(a))||r&&r.queueProperty||t._invalidateProperties()}(e,t,n.target,i.source,i.negate)}))}}function Dn(e,t,n,i,o,s){s=t.static||s&&("object"!=typeof s||s[t.methodName]);let r={methodName:t.methodName,args:t.args,methodInfo:o,dynamicFn:s};for(let o,s=0;s<t.args.length&&(o=t.args[s]);s++)o.literal||e._addPropertyEffect(o.rootProperty,n,{fn:i,info:r,trigger:o});return s&&e._addPropertyEffect(t.methodName,n,{fn:i,info:r}),r}function $n(e,t,n,i,o){let s=e._methodHost||e,r=s[o.methodName];if(r){let i=e._marshalArgs(o.args,t,n);return i===gn?gn:r.apply(s,i)}o.dynamicFn||console.warn("method `"+o.methodName+"` not defined")}const Mn=[],Fn=new RegExp("(\\[\\[|{{)\\s*(?:(!)\\s*)?((?:[a-zA-Z_$][\\w.:$\\-*]*)\\s*(?:\\(\\s*(?:(?:(?:((?:[a-zA-Z_$][\\w.:$\\-*]*)|(?:[-+]?[0-9]*\\.?[0-9]+(?:[eE][-+]?[0-9]+)?)|(?:(?:'(?:[^'\\\\]|\\\\.)*')|(?:\"(?:[^\"\\\\]|\\\\.)*\")))\\s*)(?:,\\s*(?:((?:[a-zA-Z_$][\\w.:$\\-*]*)|(?:[-+]?[0-9]*\\.?[0-9]+(?:[eE][-+]?[0-9]+)?)|(?:(?:'(?:[^'\\\\]|\\\\.)*')|(?:\"(?:[^\"\\\\]|\\\\.)*\")))\\s*))*)?)\\)\\s*)?)(?:]]|}})","g");function Bn(e){let t="";for(let n=0;n<e.length;n++){t+=e[n].literal||""}return t}function jn(e){let t=e.match(/([^\s]+?)\(([\s\S]*)\)/);if(t){let e={methodName:t[1],static:!0,args:Mn};if(t[2].trim()){return function(e,t){return t.args=e.map((function(e){let n=Hn(e);return n.literal||(t.static=!1),n}),this),t}(t[2].replace(/\\,/g,"&comma;").split(","),e)}return e}return null}function Hn(e){let t=e.trim().replace(/&comma;/g,",").replace(/\\(.)/g,"$1"),n={name:t,value:"",literal:!1},i=t[0];switch("-"===i&&(i=t[1]),i>="0"&&i<="9"&&(i="#"),i){case"'":case'"':n.value=t.slice(1,-1),n.literal=!0;break;case"#":n.value=Number(t),n.literal=!0}return n.literal||(n.rootProperty=dt(t),n.structured=ct(t),n.structured&&(n.wildcard=".*"==t.slice(-2),n.wildcard&&(n.name=t.slice(0,-2)))),n}function Un(e,t,n){let i=ft(e,n);return void 0===i&&(i=t[n]),i}function Gn(e,t,n,i){const o={indexSplices:i};Pe&&!e._overrideLegacyUndefined&&(t.splices=o),e.notifyPath(n+".splices",o),e.notifyPath(n+".length",t.length),Pe&&!e._overrideLegacyUndefined&&(o.indexSplices=[])}function Vn(e,t,n,i,o,s){Gn(e,t,n,[{index:i,addedCount:o,removed:s,object:t,type:"splice"}])}const zn=Me(e=>{const t=hn(Qt(e));return class extends t{constructor(){super(),this.__isPropertyEffectsClient=!0,this.__dataClientsReady,this.__dataPendingClients,this.__dataToNotify,this.__dataLinkedPaths,this.__dataHasPaths,this.__dataCompoundStorage,this.__dataHost,this.__dataTemp,this.__dataClientsInitialized,this.__data,this.__dataPending,this.__dataOld,this.__computeEffects,this.__computeInfo,this.__reflectEffects,this.__notifyEffects,this.__propagateEffects,this.__observeEffects,this.__readOnly,this.__templateInfo,this._overrideLegacyUndefined}get PROPERTY_EFFECT_TYPES(){return mn}_initializeProperties(){super._initializeProperties(),this._registerHost(),this.__dataClientsReady=!1,this.__dataPendingClients=null,this.__dataToNotify=null,this.__dataLinkedPaths=null,this.__dataHasPaths=!1,this.__dataCompoundStorage=this.__dataCompoundStorage||null,this.__dataHost=this.__dataHost||null,this.__dataTemp={},this.__dataClientsInitialized=!1}_registerHost(){if(Wn.length){let e=Wn[Wn.length-1];e._enqueueClient(this),this.__dataHost=e}}_initializeProtoProperties(e){this.__data=Object.create(e),this.__dataPending=Object.create(e),this.__dataOld={}}_initializeInstanceProperties(e){let t=this[mn.READ_ONLY];for(let n in e)t&&t[n]||(this.__dataPending=this.__dataPending||{},this.__dataOld=this.__dataOld||{},this.__data[n]=this.__dataPending[n]=e[n])}_addPropertyEffect(e,t,n){this._createPropertyAccessor(e,t==mn.READ_ONLY);let i=fn(this,t,!0)[e];i||(i=this[t][e]=[]),i.push(n)}_removePropertyEffect(e,t,n){let i=fn(this,t,!0)[e],o=i.indexOf(n);o>=0&&i.splice(o,1)}_hasPropertyEffect(e,t){let n=this[t];return Boolean(n&&n[e])}_hasReadOnlyEffect(e){return this._hasPropertyEffect(e,mn.READ_ONLY)}_hasNotifyEffect(e){return this._hasPropertyEffect(e,mn.NOTIFY)}_hasReflectEffect(e){return this._hasPropertyEffect(e,mn.REFLECT)}_hasComputedEffect(e){return this._hasPropertyEffect(e,mn.COMPUTE)}_setPendingPropertyOrPath(e,t,n,i){if(i||dt(Array.isArray(e)?e[0]:e)!==e){if(!i){let n=ft(this,e);if(!(e=vt(this,e,t))||!super._shouldPropertyChange(e,t,n))return!1}if(this.__dataHasPaths=!0,this._setPendingProperty(e,t,n))return function(e,t,n){let i=e.__dataLinkedPaths;if(i){let o;for(let s in i){let r=i[s];pt(s,t)?(o=ut(s,r,t),e._setPendingPropertyOrPath(o,n,!0,!0)):pt(r,t)&&(o=ut(r,s,t),e._setPendingPropertyOrPath(o,n,!0,!0))}}}(this,e,t),!0}else{if(this.__dataHasAccessor&&this.__dataHasAccessor[e])return this._setPendingProperty(e,t,n);this[e]=t}return!1}_setUnmanagedPropertyToNode(e,t,n){n===e[t]&&"object"!=typeof n||("className"===t&&(e=qt(e)),e[t]=n)}_setPendingProperty(e,t,n){let i=this.__dataHasPaths&&ct(e),o=i?this.__dataTemp:this.__data;return!!this._shouldPropertyChange(e,t,o[e])&&(this.__dataPending||(this.__dataPending={},this.__dataOld={}),e in this.__dataOld||(this.__dataOld[e]=this.__data[e]),i?this.__dataTemp[e]=t:this.__data[e]=t,this.__dataPending[e]=t,(i||this[mn.NOTIFY]&&this[mn.NOTIFY][e])&&(this.__dataToNotify=this.__dataToNotify||{},this.__dataToNotify[e]=n),!0)}_setProperty(e,t){this._setPendingProperty(e,t,!0)&&this._invalidateProperties()}_invalidateProperties(){this.__dataReady&&this._flushProperties()}_enqueueClient(e){this.__dataPendingClients=this.__dataPendingClients||[],e!==this&&this.__dataPendingClients.push(e)}_flushClients(){this.__dataClientsReady?this.__enableOrFlushClients():(this.__dataClientsReady=!0,this._readyClients(),this.__dataReady=!0)}__enableOrFlushClients(){let e=this.__dataPendingClients;if(e){this.__dataPendingClients=null;for(let t=0;t<e.length;t++){let n=e[t];n.__dataEnabled?n.__dataPending&&n._flushProperties():n._enableProperties()}}}_readyClients(){this.__enableOrFlushClients()}setProperties(e,t){for(let n in e)!t&&this[mn.READ_ONLY]&&this[mn.READ_ONLY][n]||this._setPendingPropertyOrPath(n,e[n],!0);this._invalidateProperties()}ready(){this._flushProperties(),this.__dataClientsReady||this._flushClients(),this.__dataPending&&this._flushProperties()}_propertiesChanged(e,t,n){let i,o=this.__dataHasPaths;this.__dataHasPaths=!1,xn(this,t,n,o),i=this.__dataToNotify,this.__dataToNotify=null,this._propagatePropertyChanges(t,n,o),this._flushClients(),vn(this,this[mn.REFLECT],t,n,o),vn(this,this[mn.OBSERVE],t,n,o),i&&function(e,t,n,i,o){let s,r,a=e[mn.NOTIFY],l=un++;for(let r in t)t[r]&&(a&&yn(e,a,l,r,n,i,o)?s=!0:o&&Cn(e,r,n)&&(s=!0));s&&(r=e.__dataHost)&&r._invalidateProperties&&r._invalidateProperties()}(this,i,t,n,o),1==this.__dataCounter&&(this.__dataTemp={})}_propagatePropertyChanges(e,t,n){this[mn.PROPAGATE]&&vn(this,this[mn.PROPAGATE],e,t,n),this.__templateInfo&&this._runEffectsForTemplate(this.__templateInfo,e,t,n)}_runEffectsForTemplate(e,t,n,i){const o=(t,i)=>{vn(this,e.propertyEffects,t,n,i,e.nodeList);for(let o=e.firstChild;o;o=o.nextSibling)this._runEffectsForTemplate(o,t,n,i)};e.runEffects?e.runEffects(o,t,i):o(t,i)}linkPaths(e,t){e=mt(e),t=mt(t),this.__dataLinkedPaths=this.__dataLinkedPaths||{},this.__dataLinkedPaths[e]=t}unlinkPaths(e){e=mt(e),this.__dataLinkedPaths&&delete this.__dataLinkedPaths[e]}notifySplices(e,t){let n={path:""};Gn(this,ft(this,e,n),n.path,t)}get(e,t){return ft(t||this,e)}set(e,t,n){n?vt(n,e,t):this[mn.READ_ONLY]&&this[mn.READ_ONLY][e]||this._setPendingPropertyOrPath(e,t,!0)&&this._invalidateProperties()}push(e,...t){let n={path:""},i=ft(this,e,n),o=i.length,s=i.push(...t);return t.length&&Vn(this,i,n.path,o,t.length,[]),s}pop(e){let t={path:""},n=ft(this,e,t),i=Boolean(n.length),o=n.pop();return i&&Vn(this,n,t.path,n.length,0,[o]),o}splice(e,t,n,...i){let o,s={path:""},r=ft(this,e,s);return t<0?t=r.length-Math.floor(-t):t&&(t=Math.floor(t)),o=2===arguments.length?r.splice(t):r.splice(t,n,...i),(i.length||o.length)&&Vn(this,r,s.path,t,i.length,o),o}shift(e){let t={path:""},n=ft(this,e,t),i=Boolean(n.length),o=n.shift();return i&&Vn(this,n,t.path,0,0,[o]),o}unshift(e,...t){let n={path:""},i=ft(this,e,n),o=i.unshift(...t);return t.length&&Vn(this,i,n.path,0,t.length,[]),o}notifyPath(e,t){let n;if(1==arguments.length){let i={path:""};t=ft(this,e,i),n=i.path}else n=Array.isArray(e)?mt(e):e;this._setPendingPropertyOrPath(n,t,!0,!0)&&this._invalidateProperties()}_createReadOnlyProperty(e,t){var n;this._addPropertyEffect(e,mn.READ_ONLY),t&&(this["_set"+(n=e,n[0].toUpperCase()+n.substring(1))]=function(t){this._setProperty(e,t)})}_createPropertyObserver(e,t,n){let i={property:e,method:t,dynamicFn:Boolean(n)};this._addPropertyEffect(e,mn.OBSERVE,{fn:wn,info:i,trigger:{name:e}}),n&&this._addPropertyEffect(t,mn.OBSERVE,{fn:wn,info:i,trigger:{name:t}})}_createMethodObserver(e,t){let n=jn(e);if(!n)throw new Error("Malformed observer expression '"+e+"'");Dn(this,n,mn.OBSERVE,$n,null,t)}_createNotifyingProperty(e){this._addPropertyEffect(e,mn.NOTIFY,{fn:Sn,info:{eventName:Lt(e)+"-changed",property:e}})}_createReflectedProperty(e){let t=this.constructor.attributeNameForProperty(e);"-"===t[0]?console.warn("Property "+e+" cannot be reflected to attribute "+t+' because "-" is not a valid starting attribute name. Use a lowercase first letter for the property instead.'):this._addPropertyEffect(e,mn.REFLECT,{fn:An,info:{attrName:t}})}_createComputedProperty(e,t,n){let i=jn(t);if(!i)throw new Error("Malformed computed expression '"+t+"'");const o=Dn(this,i,mn.COMPUTE,Tn,e,n);fn(this,"__computeInfo")[e]=o}_marshalArgs(e,t,n){const i=this.__data,o=[];for(let s=0,r=e.length;s<r;s++){let{name:r,structured:a,wildcard:l,value:c,literal:d}=e[s];if(!d)if(l){const e=pt(r,t),o=Un(i,n,e?t:r);c={path:e?t:r,value:o,base:e?ft(i,r):o}}else c=a?Un(i,n,r):i[r];if(Pe&&!this._overrideLegacyUndefined&&void 0===c&&e.length>1)return gn;o[s]=c}return o}static addPropertyEffect(e,t,n){this.prototype._addPropertyEffect(e,t,n)}static createPropertyObserver(e,t,n){this.prototype._createPropertyObserver(e,t,n)}static createMethodObserver(e,t){this.prototype._createMethodObserver(e,t)}static createNotifyingProperty(e){this.prototype._createNotifyingProperty(e)}static createReadOnlyProperty(e,t){this.prototype._createReadOnlyProperty(e,t)}static createReflectedProperty(e){this.prototype._createReflectedProperty(e)}static createComputedProperty(e,t,n){this.prototype._createComputedProperty(e,t,n)}static bindTemplate(e){return this.prototype._bindTemplate(e)}_bindTemplate(e,t){let n=this.constructor._parseTemplate(e),i=this.__preBoundTemplateInfo==n;if(!i)for(let e in n.propertyEffects)this._createPropertyAccessor(e);if(t)if(n=Object.create(n),n.wasPreBound=i,this.__templateInfo){const t=e._parentTemplateInfo||this.__templateInfo,i=t.lastChild;n.parent=t,t.lastChild=n,n.previousSibling=i,i?i.nextSibling=n:t.firstChild=n}else this.__templateInfo=n;else this.__preBoundTemplateInfo=n;return n}static _addTemplatePropertyEffect(e,t,n){(e.hostProps=e.hostProps||{})[t]=!0;let i=e.propertyEffects=e.propertyEffects||{};(i[t]=i[t]||[]).push(n)}_stampTemplate(e,t){t=t||this._bindTemplate(e,!0),Wn.push(this);let n=super._stampTemplate(e,t);if(Wn.pop(),t.nodeList=n.nodeList,!t.wasPreBound){let e=t.childNodes=[];for(let t=n.firstChild;t;t=t.nextSibling)e.push(t)}return n.templateInfo=t,function(e,t){let{nodeList:n,nodeInfoList:i}=t;if(i.length)for(let t=0;t<i.length;t++){let o=i[t],s=n[t],r=o.bindings;if(r)for(let t=0;t<r.length;t++){let n=r[t];Nn(s,n),Ln(s,e,n)}s.__dataHost=e}}(this,t),this.__dataClientsReady&&(this._runEffectsForTemplate(t,this.__data,null,!1),this._flushClients()),n}_removeBoundDom(e){const t=e.templateInfo,{previousSibling:n,nextSibling:i,parent:o}=t;n?n.nextSibling=i:o&&(o.firstChild=i),i?i.previousSibling=n:o&&(o.lastChild=n),t.nextSibling=t.previousSibling=null;let s=t.childNodes;for(let e=0;e<s.length;e++){let t=s[e];qt(qt(t).parentNode).removeChild(t)}}static _parseTemplateNode(e,n,i){let o=t._parseTemplateNode.call(this,e,n,i);if(e.nodeType===Node.TEXT_NODE){let t=this._parseBindings(e.textContent,n);t&&(e.textContent=Bn(t)||" ",In(this,n,i,"text","textContent",t),o=!0)}return o}static _parseTemplateNodeAttribute(e,n,i,o,s){let r=this._parseBindings(s,n);if(r){let t=o,s="property";_n.test(o)?s="attribute":"$"==o[o.length-1]&&(o=o.slice(0,-1),s="attribute");let a=Bn(r);return a&&"attribute"==s&&("class"==o&&e.hasAttribute("class")&&(a+=" "+e.getAttribute(o)),e.setAttribute(o,a)),"attribute"==s&&"disable-upgrade$"==t&&e.setAttribute(o,""),"input"===e.localName&&"value"===t&&e.setAttribute(t,""),e.removeAttribute(t),"property"===s&&(o=Nt(o)),In(this,n,i,s,o,r,a),!0}return t._parseTemplateNodeAttribute.call(this,e,n,i,o,s)}static _parseTemplateNestedTemplate(e,n,i){let o=t._parseTemplateNestedTemplate.call(this,e,n,i);const s=e.parentNode,r=i.templateInfo,a="dom-if"===s.localName,l="dom-repeat"===s.localName;Ie&&(a||l)&&(s.removeChild(e),(i=i.parentInfo).templateInfo=r,i.noted=!0,o=!1);let c=r.hostProps;if(ke&&a)c&&(n.hostProps=Object.assign(n.hostProps||{},c),Ie||(i.parentInfo.noted=!0));else{let e="{";for(let t in c){In(this,n,i,"property","_host_"+t,[{mode:e,source:t,dependencies:[t],hostProp:!0}])}}return o}static _parseBindings(e,t){let n,i=[],o=0;for(;null!==(n=Fn.exec(e));){n.index>o&&i.push({literal:e.slice(o,n.index)});let s=n[1][0],r=Boolean(n[2]),a=n[3].trim(),l=!1,c="",d=-1;"{"==s&&(d=a.indexOf("::"))>0&&(c=a.substring(d+2),a=a.substring(0,d),l=!0);let h=jn(a),p=[];if(h){let{args:e,methodName:n}=h;for(let t=0;t<e.length;t++){let n=e[t];n.literal||p.push(n)}let i=t.dynamicFns;(i&&i[n]||h.static)&&(p.push(n),h.dynamicFn=!0)}else p.push(a);i.push({source:a,mode:s,negate:r,customEvent:l,signature:h,dependencies:p,event:c}),o=Fn.lastIndex}if(o&&o<e.length){let t=e.substring(o);t&&i.push({literal:t})}return i.length?i:null}static _evaluateBinding(e,t,n,i,o,s){let r;return r=t.signature?$n(e,n,i,0,t.signature):n!=t.source?ft(e,t.source):s&&ct(n)?ft(e,n):e.__data[n],t.negate&&(r=!r),r}}}),Wn=[],qn=zn;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.PropertyEffects"),Polymer.PropertyEffects=qn;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let Kn=0;function Yn(){Kn++}const Xn=[];function Jn(e){console.log("["+e.is+"]: registered")}function Zn(e){Xn.push(e)}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Qn=Yn,ei=Xn,ti=Zn,ni=function(){Xn.forEach(Jn)};goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Telemetry"),Polymer.telemetry={instanceCount:Kn,incrementInstanceCount:Qn,registrations:ei,register:ti,dumpRegistrations:ni};const ii=Me(e=>{const t=Yt(e);function n(e){const t=Object.getPrototypeOf(e);return t.prototype instanceof o?t:null}function i(e){if(!e.hasOwnProperty(JSCompiler_renameProperty("__ownProperties",e))){let t=null;if(e.hasOwnProperty(JSCompiler_renameProperty("properties",e))){const n=e.properties;n&&(t=
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
function(e){const t={};for(let n in e){const i=e[n];t[n]="function"==typeof i?{type:i}:i}return t}(n))}e.__ownProperties=t}return e.__ownProperties}class o extends t{static get observedAttributes(){if(!this.hasOwnProperty(JSCompiler_renameProperty("__observedAttributes",this))){Zn(this.prototype);const e=this._properties;this.__observedAttributes=e?Object.keys(e).map(e=>this.prototype._addPropertyToAttributeMap(e)):[]}return this.__observedAttributes}static finalize(){if(!this.hasOwnProperty(JSCompiler_renameProperty("__finalized",this))){const e=n(this);e&&e.finalize(),this.__finalized=!0,this._finalizeClass()}}static _finalizeClass(){const e=i(this);e&&this.createProperties(e)}static get _properties(){if(!this.hasOwnProperty(JSCompiler_renameProperty("__properties",this))){const e=n(this);this.__properties=Object.assign({},e&&e._properties,i(this))}return this.__properties}static typeForProperty(e){const t=this._properties[e];return t&&t.type}_initializeProperties(){Yn(),this.constructor.finalize(),super._initializeProperties()}connectedCallback(){super.connectedCallback&&super.connectedCallback(),this._enableProperties()}disconnectedCallback(){super.disconnectedCallback&&super.disconnectedCallback()}}return o}),oi=ii;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.PropertiesMixin"),Polymer.PropertiesMixin=oi;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
class si{constructor(){this._asyncModule=null,this._callback=null,this._timer=null}setConfig(e,t){this._asyncModule=e,this._callback=t,this._timer=this._asyncModule.run(()=>{this._timer=null,ri.delete(this),this._callback()})}cancel(){this.isActive()&&(this._cancelAsync(),ri.delete(this))}_cancelAsync(){this.isActive()&&(this._asyncModule.cancel(this._timer),this._timer=null)}flush(){this.isActive()&&(this.cancel(),this._callback())}isActive(){return null!=this._timer}static debounce(e,t,n){return e instanceof si?e._cancelAsync():e=new si,e.setConfig(t,n),e}}let ri=new Set;const ai=function(e){ri.add(e)},li=function(){const e=Boolean(ri.size);return ri.forEach(e=>{try{e.flush()}catch(e){setTimeout(()=>{throw e})}}),e};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Debounce");const ci=si;Polymer.Debouncer=ci;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let di="string"==typeof document.head.style.touchAction,hi="__polymerGesturesHandled",pi="__polymerGesturesTouchAction",ui=["mousedown","mousemove","mouseup","click"],gi=[0,1,4,2],mi=function(){try{return 1===new MouseEvent("test",{buttons:1}).buttons}catch(e){return!1}}();function _i(e){return ui.indexOf(e)>-1}let fi=!1;function vi(e){if(!_i(e)&&"touchend"!==e)return di&&fi&&_e?{passive:!0}:void 0}!function(){try{let e=Object.defineProperty({},"passive",{get(){fi=!0}});window.addEventListener("test",null,e),window.removeEventListener("test",null,e)}catch(e){}}();let yi=navigator.userAgent.match(/iP(?:[oa]d|hone)|Android/);const bi=[],wi={button:!0,input:!0,keygen:!0,meter:!0,output:!0,textarea:!0,progress:!0,select:!0},Ci={button:!0,command:!0,fieldset:!0,input:!0,keygen:!0,optgroup:!0,option:!0,select:!0,textarea:!0};function Ei(e){let t=Array.prototype.slice.call(e.labels||[]);if(!t.length){t=[];let n=e.getRootNode();if(e.id){let i=n.querySelectorAll(`label[for = ${e.id}]`);for(let e=0;e<i.length;e++)t.push(i[e])}}return t}let Si=function(e){let t=e.sourceCapabilities;var n;if((!t||t.firesTouchEvents)&&(e[hi]={skip:!0},"click"===e.type)){let t=!1,i=Ii(e);for(let e=0;e<i.length;e++){if(i[e].nodeType===Node.ELEMENT_NODE)if("label"===i[e].localName)bi.push(i[e]);else if(n=i[e],wi[n.localName]){let n=Ei(i[e]);for(let e=0;e<n.length;e++)t=t||bi.indexOf(n[e])>-1}if(i[e]===Pi.mouse.target)return}if(t)return;e.preventDefault(),e.stopPropagation()}};function Ai(e){let t=yi?["click"]:ui;for(let n,i=0;i<t.length;i++)n=t[i],e?(bi.length=0,document.addEventListener(n,Si,!0)):document.removeEventListener(n,Si,!0)}function xi(e){let t=e.type;if(!_i(t))return!1;if("mousemove"===t){let t=void 0===e.buttons?1:e.buttons;return e instanceof window.MouseEvent&&!mi&&(t=gi[e.which]||0),Boolean(1&t)}return 0===(void 0===e.button?0:e.button)}let Pi={mouse:{target:null,mouseIgnoreJob:null},touch:{x:0,y:0,id:-1,scrollDecided:!1}};function Ri(e,t,n){e.movefn=t,e.upfn=n,document.addEventListener("mousemove",t),document.addEventListener("mouseup",n)}function Ti(e){document.removeEventListener("mousemove",e.movefn),document.removeEventListener("mouseup",e.upfn),e.movefn=null,e.upfn=null}Te&&document.addEventListener("touchend",(function(e){if(!Te)return;Pi.mouse.mouseIgnoreJob||Ai(!0),Pi.mouse.target=Ii(e)[0],Pi.mouse.mouseIgnoreJob=si.debounce(Pi.mouse.mouseIgnoreJob,Gt.after(2500),(function(){Ai(),Pi.mouse.target=null,Pi.mouse.mouseIgnoreJob=null}))}),!!fi&&{passive:!0});const Ii=window.ShadyDOM&&window.ShadyDOM.noPatch?window.ShadyDOM.composedPath:e=>e.composedPath&&e.composedPath()||[],ki={},Oi=[];function Ni(e,t){let n=document.elementFromPoint(e,t),i=n;for(;i&&i.shadowRoot&&!window.ShadyDOM;){let o=i;if(i=i.shadowRoot.elementFromPoint(e,t),o===i)break;i&&(n=i)}return n}function Li(e){const t=Ii(e);return t.length>0?t[0]:e.target}function Di(e){let t,n=e.type,i=e.currentTarget.__polymerGestures;if(!i)return;let o=i[n];if(o){if(!e[hi]&&(e[hi]={},"touch"===n.slice(0,5))){let t=(e=e).changedTouches[0];if("touchstart"===n&&1===e.touches.length&&(Pi.touch.id=t.identifier),Pi.touch.id!==t.identifier)return;di||"touchstart"!==n&&"touchmove"!==n||function(e){let t=e.changedTouches[0],n=e.type;if("touchstart"===n)Pi.touch.x=t.clientX,Pi.touch.y=t.clientY,Pi.touch.scrollDecided=!1;else if("touchmove"===n){if(Pi.touch.scrollDecided)return;Pi.touch.scrollDecided=!0;let n=function(e){let t="auto",n=Ii(e);for(let e,i=0;i<n.length;i++)if(e=n[i],e[pi]){t=e[pi];break}return t}(e),i=!1,o=Math.abs(Pi.touch.x-t.clientX),s=Math.abs(Pi.touch.y-t.clientY);e.cancelable&&("none"===n?i=!0:"pan-x"===n?i=s>o:"pan-y"===n&&(i=o>s)),i?e.preventDefault():Hi("track")}}(e)}if(t=e[hi],!t.skip){for(let n,i=0;i<Oi.length;i++)n=Oi[i],o[n.name]&&!t[n.name]&&n.flow&&n.flow.start.indexOf(e.type)>-1&&n.reset&&n.reset();for(let i,s=0;s<Oi.length;s++)i=Oi[s],o[i.name]&&!t[i.name]&&(t[i.name]=!0,i[n](e))}}}function $i(e,t,n){return!!ki[t]&&(function(e,t,n){let i=ki[t],o=i.deps,s=i.name,r=e.__polymerGestures;r||(e.__polymerGestures=r={});for(let t,n,i=0;i<o.length;i++)t=o[i],yi&&_i(t)&&"click"!==t||(n=r[t],n||(r[t]=n={_count:0}),0===n._count&&e.addEventListener(t,Di,vi(t)),n[s]=(n[s]||0)+1,n._count=(n._count||0)+1);e.addEventListener(t,n),i.touchAction&&Bi(e,i.touchAction)}(e,t,n),!0)}function Mi(e,t,n){return!!ki[t]&&(function(e,t,n){let i=ki[t],o=i.deps,s=i.name,r=e.__polymerGestures;if(r)for(let t,n,i=0;i<o.length;i++)t=o[i],n=r[t],n&&n[s]&&(n[s]=(n[s]||1)-1,n._count=(n._count||1)-1,0===n._count&&e.removeEventListener(t,Di,vi(t)));e.removeEventListener(t,n)}(e,t,n),!0)}function Fi(e){Oi.push(e);for(let t=0;t<e.emits.length;t++)ki[e.emits[t]]=e}function Bi(e,t){di&&e instanceof HTMLElement&&Wt.run(()=>{e.style.touchAction=t}),e[pi]=t}function ji(e,t,n){let i=new Event(t,{bubbles:!0,cancelable:!0,composed:!0});if(i.detail=n,qt(e).dispatchEvent(i),i.defaultPrevented){let e=n.preventer||n.sourceEvent;e&&e.preventDefault&&e.preventDefault()}}function Hi(e){let t=function(e){for(let t,n=0;n<Oi.length;n++){t=Oi[n];for(let n,i=0;i<t.emits.length;i++)if(n=t.emits[i],n===e)return t}return null}(e);t.info&&(t.info.prevent=!0)}function Ui(e,t,n,i){t&&ji(t,e,{x:n.clientX,y:n.clientY,sourceEvent:n,preventer:i,prevent:function(e){return Hi(e)}})}function Gi(e,t,n){if(e.prevent)return!1;if(e.started)return!0;let i=Math.abs(e.x-t),o=Math.abs(e.y-n);return i>=5||o>=5}function Vi(e,t,n){if(!t)return;let i,o=e.moves[e.moves.length-2],s=e.moves[e.moves.length-1],r=s.x-e.x,a=s.y-e.y,l=0;o&&(i=s.x-o.x,l=s.y-o.y),ji(t,"track",{state:e.state,x:n.clientX,y:n.clientY,dx:r,dy:a,ddx:i,ddy:l,sourceEvent:n,hover:function(){return Ni(n.clientX,n.clientY)}})}function zi(e,t,n){let i=Math.abs(t.clientX-e.x),o=Math.abs(t.clientY-e.y),s=Li(n||t);!s||Ci[s.localName]&&s.hasAttribute("disabled")||(isNaN(i)||isNaN(o)||i<=25&&o<=25||function(e){if("click"===e.type){if(0===e.detail)return!0;let t=Li(e);if(!t.nodeType||t.nodeType!==Node.ELEMENT_NODE)return!0;let n=t.getBoundingClientRect(),i=e.pageX,o=e.pageY;return!(i>=n.left&&i<=n.right&&o>=n.top&&o<=n.bottom)}return!1}(t))&&(e.prevent||ji(s,"tap",{x:t.clientX,y:t.clientY,sourceEvent:t,preventer:n}))}Fi({name:"downup",deps:["mousedown","touchstart","touchend"],flow:{start:["mousedown","touchstart"],end:["mouseup","touchend"]},emits:["down","up"],info:{movefn:null,upfn:null},reset:function(){Ti(this.info)},mousedown:function(e){if(!xi(e))return;let t=Li(e),n=this;Ri(this.info,(function(e){xi(e)||(Ui("up",t,e),Ti(n.info))}),(function(e){xi(e)&&Ui("up",t,e),Ti(n.info)})),Ui("down",t,e)},touchstart:function(e){Ui("down",Li(e),e.changedTouches[0],e)},touchend:function(e){Ui("up",Li(e),e.changedTouches[0],e)}}),Fi({name:"track",touchAction:"none",deps:["mousedown","touchstart","touchmove","touchend"],flow:{start:["mousedown","touchstart"],end:["mouseup","touchend"]},emits:["track"],info:{x:0,y:0,state:"start",started:!1,moves:[],addMove:function(e){this.moves.length>2&&this.moves.shift(),this.moves.push(e)},movefn:null,upfn:null,prevent:!1},reset:function(){this.info.state="start",this.info.started=!1,this.info.moves=[],this.info.x=0,this.info.y=0,this.info.prevent=!1,Ti(this.info)},mousedown:function(e){if(!xi(e))return;let t=Li(e),n=this,i=function(e){let i=e.clientX,o=e.clientY;Gi(n.info,i,o)&&(n.info.state=n.info.started?"mouseup"===e.type?"end":"track":"start","start"===n.info.state&&Hi("tap"),n.info.addMove({x:i,y:o}),xi(e)||(n.info.state="end",Ti(n.info)),t&&Vi(n.info,t,e),n.info.started=!0)};Ri(this.info,i,(function(e){n.info.started&&i(e),Ti(n.info)})),this.info.x=e.clientX,this.info.y=e.clientY},touchstart:function(e){let t=e.changedTouches[0];this.info.x=t.clientX,this.info.y=t.clientY},touchmove:function(e){let t=Li(e),n=e.changedTouches[0],i=n.clientX,o=n.clientY;Gi(this.info,i,o)&&("start"===this.info.state&&Hi("tap"),this.info.addMove({x:i,y:o}),Vi(this.info,t,n),this.info.state="track",this.info.started=!0)},touchend:function(e){let t=Li(e),n=e.changedTouches[0];this.info.started&&(this.info.state="end",this.info.addMove({x:n.clientX,y:n.clientY}),Vi(this.info,t,n))}}),Fi({name:"tap",deps:["mousedown","click","touchstart","touchend"],flow:{start:["mousedown","touchstart"],end:["click","touchend"]},emits:["tap"],info:{x:NaN,y:NaN,prevent:!1},reset:function(){this.info.x=NaN,this.info.y=NaN,this.info.prevent=!1},mousedown:function(e){xi(e)&&(this.info.x=e.clientX,this.info.y=e.clientY)},click:function(e){xi(e)&&zi(this.info,e)},touchstart:function(e){const t=e.changedTouches[0];this.info.x=t.clientX,this.info.y=t.clientY},touchend:function(e){zi(this.info,e.changedTouches[0],e)}});const Wi=ki,qi=Oi,Ki=Ni,Yi=$i,Xi=Mi,Ji=Fi,Zi=Bi,Qi=Hi,eo=function(){Pi.mouse.mouseIgnoreJob&&Pi.mouse.mouseIgnoreJob.flush()},to=Li,no=$i,io=Mi;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Gestures"),Polymer.Gestures={gestures:Wi,recognizers:qi,deepTargetFind:Ki,addListener:Yi,removeListener:Xi,register:Ji,setTouchAction:Zi,prevent:Qi,resetMouseCanceller:eo,findOriginalTarget:to,add:no,remove:io};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const oo=Me(e=>class extends e{_addEventListenerToNode(e,t,n){$i(e,t,n)||super._addEventListenerToNode(e,t,n)}_removeEventListenerFromNode(e,t,n){Mi(e,t,n)||super._removeEventListenerFromNode(e,t,n)}}),so=oo;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.GestureEventListeners"),Polymer.GestureEventListeners=so;
/**
 * @fileoverview
 * @suppress {checkPrototypalTypes}
 * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
 * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
 * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
 * Google as part of the polymer project is also subject to an additional IP
 * rights grant found at http://polymer.github.io/PATENTS.txt
 */
const ro=/:host\(:dir\((ltr|rtl)\)\)/g,ao=/([\s\w-#\.\[\]\*]*):dir\((ltr|rtl)\)/g,lo=/:dir\((?:ltr|rtl)\)/,co=Boolean(window.ShadyDOM&&window.ShadyDOM.inUse),ho=[];let po=null,uo="";function go(){uo=document.documentElement.getAttribute("dir")}function mo(e){if(!e.__autoDirOptOut){e.setAttribute("dir",uo)}}function _o(){go(),uo=document.documentElement.getAttribute("dir");for(let e=0;e<ho.length;e++)mo(ho[e])}const fo=Me(e=>{co||po||(go(),po=new MutationObserver(_o),po.observe(document.documentElement,{attributes:!0,attributeFilter:["dir"]}));const t=Qt(e);class n extends t{static _processStyleText(e,n){return e=t._processStyleText.call(this,e,n),!co&&lo.test(e)&&(e=this._replaceDirInCssText(e),this.__activateDir=!0),e}static _replaceDirInCssText(e){let t=e;return t=t.replace(ro,':host([dir="$1"])'),t=t.replace(ao,':host([dir="$2"]) $1'),t}constructor(){super(),this.__autoDirOptOut=!1}ready(){super.ready(),this.__autoDirOptOut=this.hasAttribute("dir")}connectedCallback(){t.prototype.connectedCallback&&super.connectedCallback(),this.constructor.__activateDir&&(po&&po.takeRecords().length&&_o(),ho.push(this),mo(this))}disconnectedCallback(){if(t.prototype.disconnectedCallback&&super.disconnectedCallback(),this.constructor.__activateDir){const e=ho.indexOf(this);e>-1&&ho.splice(e,1)}}}return n.__activateDir=!1,n}),vo=fo;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.DirMixin"),Polymer.DirMixin=vo;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let yo=!1,bo=[],wo=[];function Co(){yo=!0,requestAnimationFrame((function(){yo=!1,Eo(bo),setTimeout((function(){!function(e){for(let t=0,n=e.length;t<n;t++)So(e.shift())}(wo)}))}))}function Eo(e){for(;e.length;)So(e.shift())}function So(e){const t=e[0],n=e[1],i=e[2];try{n.apply(t,i)}catch(e){setTimeout(()=>{throw e})}}function Ao(e,t,n){yo||Co(),wo.push([e,t,n])}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/const xo=function(e,t,n){yo||Co(),bo.push([e,t,n])},Po=Ao,Ro=function(){for(;bo.length||wo.length;)Eo(bo),Eo(wo);yo=!1};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
function To(){document.body.removeAttribute("unresolved")}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
function Io(e,t,n){return{index:e,removed:t,addedCount:n}}goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.RenderStatus"),Polymer.RenderStatus={beforeNextRender:xo,afterNextRender:Po,flush:Ro},"interactive"===document.readyState||"complete"===document.readyState?To():window.addEventListener("DOMContentLoaded",To)
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/,goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Unresolved");function ko(e,t,n,i,o,s){let r,a=0,l=0,c=Math.min(n-t,s-o);if(0==t&&0==o&&(a=function(e,t,n){for(let i=0;i<n;i++)if(!No(e[i],t[i]))return i;return n}(e,i,c)),n==e.length&&s==i.length&&(l=function(e,t,n){let i=e.length,o=t.length,s=0;for(;s<n&&No(e[--i],t[--o]);)s++;return s}(e,i,c-a)),o+=a,s-=l,(n-=l)-(t+=a)==0&&s-o==0)return[];if(t==n){for(r=Io(t,[],0);o<s;)r.removed.push(i[o++]);return[r]}if(o==s)return[Io(t,[],n-t)];let d=function(e){let t=e.length-1,n=e[0].length-1,i=e[t][n],o=[];for(;t>0||n>0;){if(0==t){o.push(2),n--;continue}if(0==n){o.push(3),t--;continue}let s,r=e[t-1][n-1],a=e[t-1][n],l=e[t][n-1];s=a<l?a<r?a:r:l<r?l:r,s==r?(r==i?o.push(0):(o.push(1),i=r),t--,n--):s==a?(o.push(3),t--,i=a):(o.push(2),n--,i=l)}return o.reverse(),o}(function(e,t,n,i,o,s){let r=s-o+1,a=n-t+1,l=new Array(r);for(let e=0;e<r;e++)l[e]=new Array(a),l[e][0]=e;for(let e=0;e<a;e++)l[0][e]=e;for(let n=1;n<r;n++)for(let s=1;s<a;s++)if(No(e[t+s-1],i[o+n-1]))l[n][s]=l[n-1][s-1];else{let e=l[n-1][s]+1,t=l[n][s-1]+1;l[n][s]=e<t?e:t}return l}(e,t,n,i,o,s));r=void 0;let h=[],p=t,u=o;for(let e=0;e<d.length;e++)switch(d[e]){case 0:r&&(h.push(r),r=void 0),p++,u++;break;case 1:r||(r=Io(p,[],0)),r.addedCount++,p++,r.removed.push(i[u]),u++;break;case 2:r||(r=Io(p,[],0)),r.addedCount++,p++;break;case 3:r||(r=Io(p,[],0)),r.removed.push(i[u]),u++}return r&&h.push(r),h}function Oo(e,t){return ko(e,0,e.length,t,0,t.length)}function No(e,t){return e===t}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/const Lo=Oo;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
function Do(e){return"slot"===e.localName}goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.ArraySplice"),Polymer.ArraySplice={calculateSplices:Lo};let $o=class{static getFlattenedNodes(e){const t=qt(e);return Do(e)?(e=e,t.assignedNodes({flatten:!0})):Array.from(t.childNodes).map(e=>Do(e)?qt(e=e).assignedNodes({flatten:!0}):[e]).reduce((e,t)=>e.concat(t),[])}constructor(e,t){this._shadyChildrenObserver=null,this._nativeChildrenObserver=null,this._connected=!1,this._target=e,this.callback=t,this._effectiveNodes=[],this._observer=null,this._scheduled=!1,this._boundSchedule=()=>{this._schedule()},this.connect(),this._schedule()}connect(){Do(this._target)?this._listenSlots([this._target]):qt(this._target).children&&(this._listenSlots(qt(this._target).children),window.ShadyDOM?this._shadyChildrenObserver=window.ShadyDOM.observeChildren(this._target,e=>{this._processMutations(e)}):(this._nativeChildrenObserver=new MutationObserver(e=>{this._processMutations(e)}),this._nativeChildrenObserver.observe(this._target,{childList:!0}))),this._connected=!0}disconnect(){Do(this._target)?this._unlistenSlots([this._target]):qt(this._target).children&&(this._unlistenSlots(qt(this._target).children),window.ShadyDOM&&this._shadyChildrenObserver?(window.ShadyDOM.unobserveChildren(this._shadyChildrenObserver),this._shadyChildrenObserver=null):this._nativeChildrenObserver&&(this._nativeChildrenObserver.disconnect(),this._nativeChildrenObserver=null)),this._connected=!1}_schedule(){this._scheduled||(this._scheduled=!0,Wt.run(()=>this.flush()))}_processMutations(e){this._processSlotMutations(e),this.flush()}_processSlotMutations(e){if(e)for(let t=0;t<e.length;t++){let n=e[t];n.addedNodes&&this._listenSlots(n.addedNodes),n.removedNodes&&this._unlistenSlots(n.removedNodes)}}flush(){if(!this._connected)return!1;window.ShadyDOM&&ShadyDOM.flush(),this._nativeChildrenObserver?this._processSlotMutations(this._nativeChildrenObserver.takeRecords()):this._shadyChildrenObserver&&this._processSlotMutations(this._shadyChildrenObserver.takeRecords()),this._scheduled=!1;let e={target:this._target,addedNodes:[],removedNodes:[]},t=this.constructor.getFlattenedNodes(this._target),n=Oo(t,this._effectiveNodes);for(let t,i=0;i<n.length&&(t=n[i]);i++)for(let n,i=0;i<t.removed.length&&(n=t.removed[i]);i++)e.removedNodes.push(n);for(let i,o=0;o<n.length&&(i=n[o]);o++)for(let n=i.index;n<i.index+i.addedCount;n++)e.addedNodes.push(t[n]);this._effectiveNodes=t;let i=!1;return(e.addedNodes.length||e.removedNodes.length)&&(i=!0,this.callback.call(this._target,e)),i}_listenSlots(e){for(let t=0;t<e.length;t++){let n=e[t];Do(n)&&n.addEventListener("slotchange",this._boundSchedule)}}_unlistenSlots(e){for(let t=0;t<e.length;t++){let n=e[t];Do(n)&&n.removeEventListener("slotchange",this._boundSchedule)}}};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.FlattenedNodesObserver"),Polymer.FlattenedNodesObserver=$o;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const Mo=function(){let e,t;do{e=window.ShadyDOM&&ShadyDOM.flush(),window.ShadyCSS&&window.ShadyCSS.ScopingShim&&window.ShadyCSS.ScopingShim.flush(),t=li()}while(e||t)},Fo=ai,Bo=Mo;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Flush"),Polymer.enqueueDebouncer=Fo,Polymer.flush=Bo;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const jo=Element.prototype,Ho=jo.matches||jo.matchesSelector||jo.mozMatchesSelector||jo.msMatchesSelector||jo.oMatchesSelector||jo.webkitMatchesSelector,Uo=function(e,t){return Ho.call(e,t)};class Go{constructor(e){window.ShadyDOM&&window.ShadyDOM.inUse&&window.ShadyDOM.patch(e),this.node=e}observeNodes(e){return new $o(this.node,e)}unobserveNodes(e){e.disconnect()}notifyObserver(){}deepContains(e){if(qt(this.node).contains(e))return!0;let t=e,n=e.ownerDocument;for(;t&&t!==n&&t!==this.node;)t=qt(t).parentNode||qt(t).host;return t===this.node}getOwnerRoot(){return qt(this.node).getRootNode()}getDistributedNodes(){return"slot"===this.node.localName?qt(this.node).assignedNodes({flatten:!0}):[]}getDestinationInsertionPoints(){let e=[],t=qt(this.node).assignedSlot;for(;t;)e.push(t),t=qt(t).assignedSlot;return e}importNode(e,t){let n=this.node instanceof Document?this.node:this.node.ownerDocument;return qt(n).importNode(e,t)}getEffectiveChildNodes(){return $o.getFlattenedNodes(this.node)}queryDistributedElements(e){let t=this.getEffectiveChildNodes(),n=[];for(let i,o=0,s=t.length;o<s&&(i=t[o]);o++)i.nodeType===Node.ELEMENT_NODE&&Uo(i,e)&&n.push(i);return n}get activeElement(){let e=this.node;return void 0!==e._activeElement?e._activeElement:e.activeElement}}function Vo(e,t){for(let n=0;n<t.length;n++){let i=t[n];Object.defineProperty(e,i,{get:function(){return this.node[i]},configurable:!0})}}class zo{constructor(e){this.event=e}get rootTarget(){return this.path[0]}get localTarget(){return this.event.target}get path(){return this.event.composedPath()}}Go.prototype.cloneNode,Go.prototype.appendChild,Go.prototype.insertBefore,Go.prototype.removeChild,Go.prototype.replaceChild,Go.prototype.setAttribute,Go.prototype.removeAttribute,Go.prototype.querySelector,Go.prototype.querySelectorAll,Go.prototype.parentNode,Go.prototype.firstChild,Go.prototype.lastChild,Go.prototype.nextSibling,Go.prototype.previousSibling,Go.prototype.firstElementChild,Go.prototype.lastElementChild,Go.prototype.nextElementSibling,Go.prototype.previousElementSibling,Go.prototype.childNodes,Go.prototype.children,Go.prototype.classList,Go.prototype.textContent,Go.prototype.innerHTML;let Wo=Go;if(window.ShadyDOM&&window.ShadyDOM.inUse&&window.ShadyDOM.noPatch&&window.ShadyDOM.Wrapper){class e extends window.ShadyDOM.Wrapper{}Object.getOwnPropertyNames(Go.prototype).forEach(t=>{"activeElement"!=t&&(e.prototype[t]=Go.prototype[t])}),Vo(e.prototype,["classList"]),Wo=e,Object.defineProperties(zo.prototype,{localTarget:{get(){const e=this.event.currentTarget,t=e&&qo(e).getOwnerRoot(),n=this.path;for(let e=0;e<n.length;e++){const i=n[e];if(qo(i).getOwnerRoot()===t)return i}},configurable:!0},path:{get(){return window.ShadyDOM.composedPath(this.event)},configurable:!0}})}else!function(e,t){for(let n=0;n<t.length;n++){let i=t[n];e[i]=function(){return this.node[i].apply(this.node,arguments)}}}(Go.prototype,["cloneNode","appendChild","insertBefore","removeChild","replaceChild","setAttribute","removeAttribute","querySelector","querySelectorAll"]),Vo(Go.prototype,["parentNode","firstChild","lastChild","nextSibling","previousSibling","firstElementChild","lastElementChild","nextElementSibling","previousElementSibling","childNodes","children","classList"]),function(e,t){for(let n=0;n<t.length;n++){let i=t[n];Object.defineProperty(e,i,{get:function(){return this.node[i]},set:function(e){this.node[i]=e},configurable:!0})}}(Go.prototype,["textContent","innerHTML","className"]);const qo=function(e){if((e=e||document)instanceof Wo)return e;if(e instanceof zo)return e;let t=e.__domApi;return t||(t=e instanceof Event?new zo(e):new Wo(e),e.__domApi=t),t},Ko=Wo,Yo=zo,Xo=qo,Jo=Uo,Zo=Mo,Qo=ai;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Legacy.PolymerDom"),Polymer.DomApi=Ko,Polymer.EventApi=Yo,Polymer.dom=Xo,Polymer.dom.matchesSelector=Jo,Polymer.dom.flush=Zo,Polymer.dom.addDebouncer=Qo;
/**
 * @fileoverview
 * @suppress {checkPrototypalTypes}
 * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
 * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
 * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
 * Google as part of the polymer project is also subject to an additional IP
 * rights grant found at http://polymer.github.io/PATENTS.txt
 */
const es=window.ShadyCSS&&window.ShadyCSS.cssBuild,ts=Me(e=>{const t=ii(zn(e));function n(e,t,n,i){n.computed&&(n.readOnly=!0),n.computed&&(e._hasReadOnlyEffect(t)?console.warn(`Cannot redefine computed property '${t}'.`):e._createComputedProperty(t,n.computed,i)),n.readOnly&&!e._hasReadOnlyEffect(t)?e._createReadOnlyProperty(t,!n.computed):!1===n.readOnly&&e._hasReadOnlyEffect(t)&&console.warn(`Cannot make readOnly property '${t}' non-readOnly.`),n.reflectToAttribute&&!e._hasReflectEffect(t)?e._createReflectedProperty(t):!1===n.reflectToAttribute&&e._hasReflectEffect(t)&&console.warn(`Cannot make reflected property '${t}' non-reflected.`),n.notify&&!e._hasNotifyEffect(t)?e._createNotifyingProperty(t):!1===n.notify&&e._hasNotifyEffect(t)&&console.warn(`Cannot make notify property '${t}' non-notify.`),n.observer&&e._createPropertyObserver(t,n.observer,i[n.observer]),e._addPropertyToAttributeMap(t)}return class extends t{static get polymerElementVersion(){return"3.4.1"}static _finalizeClass(){t._finalizeClass.call(this);const e=((n=this).hasOwnProperty(JSCompiler_renameProperty("__ownObservers",n))||(n.__ownObservers=n.hasOwnProperty(JSCompiler_renameProperty("observers",n))?n.observers:null),n.__ownObservers);var n;e&&this.createObservers(e,this._properties),this._prepareTemplate()}static _prepareTemplate(){let e=this.template;e&&("string"==typeof e?(console.error("template getter must return HTMLTemplateElement"),e=null):Ce||(e=e.cloneNode(!0))),this.prototype._template=e}static createProperties(e){for(let t in e)n(this.prototype,t,e[t],e)}static createObservers(e,t){const n=this.prototype;for(let i=0;i<e.length;i++)n._createMethodObserver(e[i],t)}static get template(){if(!this.hasOwnProperty(JSCompiler_renameProperty("_template",this))){const e=this.prototype.hasOwnProperty(JSCompiler_renameProperty("_template",this.prototype))?this.prototype._template:void 0;this._template=void 0!==e?e:this.hasOwnProperty(JSCompiler_renameProperty("is",this))&&function(e){let t=null;if(e&&(!ve||be)&&(t=Ge.import(e,"template"),ve&&!t))throw new Error(`strictTemplatePolicy: expecting dom-module or null template for ${e}`);return t}(this.is)||Object.getPrototypeOf(this.prototype).constructor.template}return this._template}static set template(e){this._template=e}static get importPath(){if(!this.hasOwnProperty(JSCompiler_renameProperty("_importPath",this))){const e=this.importMeta;if(e)this._importPath=oe(e.url);else{const e=Ge.import(this.is);this._importPath=e&&e.assetpath||Object.getPrototypeOf(this.prototype).constructor.importPath}}return this._importPath}constructor(){super(),this._template,this._importPath,this.rootPath,this.importPath,this.root,this.$}_initializeProperties(){this.constructor.finalize(),this.constructor._finalizeTemplate(this.localName),super._initializeProperties(),this.rootPath=pe,this.importPath=this.constructor.importPath;let e=function(e){if(!e.hasOwnProperty(JSCompiler_renameProperty("__propertyDefaults",e))){e.__propertyDefaults=null;let t=e._properties;for(let n in t){let i=t[n];"value"in i&&(e.__propertyDefaults=e.__propertyDefaults||{},e.__propertyDefaults[n]=i)}}return e.__propertyDefaults}(this.constructor);if(e)for(let t in e){let n=e[t];if(this._canApplyPropertyDefault(t)){let e="function"==typeof n.value?n.value.call(this):n.value;this._hasAccessor(t)?this._setPendingProperty(t,e,!0):this[t]=e}}}_canApplyPropertyDefault(e){return!this.hasOwnProperty(e)}static _processStyleText(e,t){return ie(e,t)}static _finalizeTemplate(e){const t=this.prototype._template;if(t&&!t.__polymerFinalized){t.__polymerFinalized=!0;const n=this.importPath;!function(e,t,n,i){if(!es){const o=t.content.querySelectorAll("style"),s=Ke(t),r=Ye(n),a=t.content.firstElementChild;for(let n=0;n<r.length;n++){let o=r[n];o.textContent=e._processStyleText(o.textContent,i),t.content.insertBefore(o,a)}let l=0;for(let t=0;t<s.length;t++){let n=s[t],r=o[l];r!==n?(n=n.cloneNode(!0),r.parentNode.insertBefore(n,r)):l++,n.textContent=e._processStyleText(n.textContent,i)}}if(window.ShadyCSS&&window.ShadyCSS.prepareTemplate(t,n),Le&&es&&he){const n=t.content.querySelectorAll("style");if(n){let t="";Array.from(n).forEach(e=>{t+=e.textContent,e.parentNode.removeChild(e)}),e._styleSheet=new CSSStyleSheet,e._styleSheet.replaceSync(t)}}}(this,t,e,n?ne(n):""),this.prototype._bindTemplate(t)}}connectedCallback(){window.ShadyCSS&&this._template&&window.ShadyCSS.styleElement(this),super.connectedCallback()}ready(){this._template&&(this.root=this._stampTemplate(this._template),this.$=this.root.$),super.ready()}_readyClients(){this._template&&(this.root=this._attachDom(this.root)),super._readyClients()}_attachDom(e){const t=qt(this);if(t.attachShadow)return e?(t.shadowRoot||(t.attachShadow({mode:"open",shadyUpgradeFragment:e}),t.shadowRoot.appendChild(e),this.constructor._styleSheet&&(t.shadowRoot.adoptedStyleSheets=[this.constructor._styleSheet])),Ae&&window.ShadyDOM&&window.ShadyDOM.flushInitial(t.shadowRoot),t.shadowRoot):null;throw new Error("ShadowDOM not available. PolymerElement can create dom as children instead of in ShadowDOM by setting `this.root = this;` before `ready`.")}updateStyles(e){window.ShadyCSS&&window.ShadyCSS.styleSubtree(this,e)}resolveUrl(e,t){return!t&&this.importPath&&(t=ne(this.importPath)),ne(e,t)}static _parseTemplateContent(e,n,i){return n.dynamicFns=n.dynamicFns||this._properties,t._parseTemplateContent.call(this,e,n,i)}static _addTemplatePropertyEffect(e,n,i){return!Se||n in this._properties||i.info.part.signature&&i.info.part.signature.static||i.info.part.hostProp||e.nestedTemplate||console.warn(`Property '${n}' used in template but not declared in 'properties'; `+"attribute will not be observed."),t._addTemplatePropertyEffect.call(this,e,n,i)}}}),ns=function(e){window.ShadyCSS&&window.ShadyCSS.styleDocument(e)},is=ts,os=ns;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.ElementMixin"),Polymer.ElementMixin=is,Polymer.updateStyles=os,Polymer.version="3.4.1";const ss=!(window.ShadyDOM&&window.ShadyDOM.inUse);let rs,as;function ls(e){rs=(!e||!e.shimcssproperties)&&(ss||Boolean(!navigator.userAgent.match(/AppleWebKit\/601|Edge\/15/)&&window.CSS&&CSS.supports&&CSS.supports("box-shadow","0 0 0 var(--foo)")))}window.ShadyCSS&&void 0!==window.ShadyCSS.cssBuild&&(as=window.ShadyCSS.cssBuild);const cs=Boolean(window.ShadyCSS&&window.ShadyCSS.disableRuntime);window.ShadyCSS&&void 0!==window.ShadyCSS.nativeCss?rs=window.ShadyCSS.nativeCss:window.ShadyCSS?(ls(window.ShadyCSS),window.ShadyCSS=void 0):ls(window.WebComponents&&window.WebComponents.flags);const ds=rs;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/class hs{constructor(){this.start=0,this.end=0,this.previous=null,this.parent=null,this.rules=null,this.parsedCssText="",this.cssText="",this.atRule=!1,this.type=0,this.keyframesName="",this.selector="",this.parsedSelector=""}}function ps(e){return function e(t,n){let i=n.substring(t.start,t.end-1);if(t.parsedCssText=t.cssText=i.trim(),t.parent){let e=t.previous?t.previous.end:t.parent.start;i=n.substring(e,t.start-1),i=function(e){return e.replace(/\\([0-9a-f]{1,6})\s/gi,(function(){let e=arguments[1],t=6-e.length;for(;t--;)e="0"+e;return"\\"+e}))}(i),i=i.replace(fs.multipleSpaces," "),i=i.substring(i.lastIndexOf(";")+1);let o=t.parsedSelector=t.selector=i.trim();t.atRule=0===o.indexOf(bs),t.atRule?0===o.indexOf(ys)?t.type=gs.MEDIA_RULE:o.match(fs.keyframesRule)&&(t.type=gs.KEYFRAMES_RULE,t.keyframesName=t.selector.split(fs.multipleSpaces).pop()):0===o.indexOf(vs)?t.type=gs.MIXIN_RULE:t.type=gs.STYLE_RULE}let o=t.rules;if(o)for(let t,i=0,s=o.length;i<s&&(t=o[i]);i++)e(t,n);return t}(function(e){let t=new hs;t.start=0,t.end=e.length;let n=t;for(let i=0,o=e.length;i<o;i++)if(e[i]===ms){n.rules||(n.rules=[]);let e=n,t=e.rules[e.rules.length-1]||null;n=new hs,n.start=i+1,n.parent=e,n.previous=t,e.rules.push(n)}else e[i]===_s&&(n.end=i+1,n=n.parent||t);return t}(e=e.replace(fs.comments,"").replace(fs.port,"")),e)}function us(e,t,n=""){let i="";if(e.cssText||e.rules){let n=e.rules;if(n&&!function(e){let t=e[0];return Boolean(t)&&Boolean(t.selector)&&0===t.selector.indexOf(vs)}(n))for(let e,o=0,s=n.length;o<s&&(e=n[o]);o++)i=us(e,t,i);else i=t?e.cssText:function(e){return function(e){return e.replace(fs.mixinApply,"").replace(fs.varApply,"")}(e=function(e){return e.replace(fs.customProp,"").replace(fs.mixinProp,"")}(e))}(e.cssText),i=i.trim(),i&&(i="  "+i+"\n")}return i&&(e.selector&&(n+=e.selector+" "+ms+"\n"),n+=i,e.selector&&(n+=_s+"\n\n")),n}const gs={STYLE_RULE:1,KEYFRAMES_RULE:7,MEDIA_RULE:4,MIXIN_RULE:1e3},ms="{",_s="}",fs={comments:/\/\*[^*]*\*+([^/*][^*]*\*+)*\//gim,port:/@import[^;]*;/gim,customProp:/(?:^[^;\-\s}]+)?--[^;{}]*?:[^{};]*?(?:[;\n]|$)/gim,mixinProp:/(?:^[^;\-\s}]+)?--[^;{}]*?:[^{};]*?{[^}]*?}(?:[;\n]|$)?/gim,mixinApply:/@apply\s*\(?[^);]*\)?\s*(?:[;\n]|$)?/gim,varApply:/[^;:]*?:[^;]*?var\([^;]*\)(?:[;\n]|$)?/gim,keyframesRule:/^@[^\s]*keyframes/,multipleSpaces:/\s+/g},vs="--",ys="@media",bs="@",ws=/(?:^|[;\s{]\s*)(--[\w-]*?)\s*:\s*(?:((?:'(?:\\'|.)*?'|"(?:\\"|.)*?"|\([^)]*?\)|[^};{])+)|\{([^}]*)\}(?:(?=[;\s}])|$))/gi,Cs=/(?:^|\W+)@apply\s*\(?([^);\n]*)\)?/gi,Es=/@media\s(.*)/,Ss=new Set;function As(e){const t=e.textContent;if(!Ss.has(t)){Ss.add(t);const e=document.createElement("style");e.setAttribute("shady-unscoped",""),e.textContent=t,document.head.appendChild(e)}}function xs(e){return e.hasAttribute("shady-unscoped")}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/function Ps(e,t){return e?("string"==typeof e&&(e=ps(e)),t&&Ts(e,t),us(e,ds)):""}function Rs(e){return!e.__cssRules&&e.textContent&&(e.__cssRules=ps(e.textContent)),e.__cssRules||null}function Ts(e,t,n,i){if(!e)return;let o=!1,s=e.type;if(i&&s===gs.MEDIA_RULE){let t=e.selector.match(Es);t&&(window.matchMedia(t[1]).matches||(o=!0))}s===gs.STYLE_RULE?t(e):n&&s===gs.KEYFRAMES_RULE?n(e):s===gs.MIXIN_RULE&&(o=!0);let r=e.rules;if(r&&!o)for(let e,o=0,s=r.length;o<s&&(e=r[o]);o++)Ts(e,t,n,i)}function Is(e,t){let n=0;for(let i=t,o=e.length;i<o;i++)if("("===e[i])n++;else if(")"===e[i]&&0==--n)return i;return-1}window.ShadyDOM&&window.ShadyDOM.wrap;function ks(e){if(void 0!==as)return as;if(void 0===e.__cssBuild){const t=e.getAttribute("css-build");if(t)e.__cssBuild=t;else{const t=function(e){const t="template"===e.localName?e.content.firstChild:e.firstChild;if(t instanceof Comment){const e=t.textContent.trim().split(":");if("css-build"===e[0])return e[1]}return""}(e);""!==t&&function(e){const t="template"===e.localName?e.content.firstChild:e.firstChild;t.parentNode.removeChild(t)}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/(e),e.__cssBuild=t}}return e.__cssBuild||""}function Os(e){return""!==ks(e)}function Ns(e,t){for(let n in t)null===n?e.style.removeProperty(n):e.style.setProperty(n,t[n])}function Ls(e,t){const n=window.getComputedStyle(e).getPropertyValue(t);return n?n.trim():""}const Ds=/;\s*/m,$s=/^\s*(initial)|(inherit)\s*$/,Ms=/\s*!important/;class Fs{constructor(){this._map={}}set(e,t){e=e.trim(),this._map[e]={properties:t,dependants:{}}}get(e){return e=e.trim(),this._map[e]||null}}let Bs=null;class js{constructor(){this._currentElement=null,this._measureElement=null,this._map=new Fs}detectMixin(e){return function(e){const t=Cs.test(e)||ws.test(e);return Cs.lastIndex=0,ws.lastIndex=0,t}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/(e)}gatherStyles(e){const t=function(e){const t=[],n=e.querySelectorAll("style");for(let e=0;e<n.length;e++){const i=n[e];xs(i)?ss||(As(i),i.parentNode.removeChild(i)):(t.push(i.textContent),i.parentNode.removeChild(i))}return t.join("").trim()}(e.content);if(t){const n=document.createElement("style");return n.textContent=t,e.content.insertBefore(n,e.content.firstChild),n}return null}transformTemplate(e,t){void 0===e._gatheredStyle&&(e._gatheredStyle=this.gatherStyles(e));const n=e._gatheredStyle;return n?this.transformStyle(n,t):null}transformStyle(e,t=""){let n=Rs(e);return this.transformRules(n,t),e.textContent=Ps(n),n}transformCustomStyle(e){let t=Rs(e);return Ts(t,e=>{":root"===e.selector&&(e.selector="html"),this.transformRule(e)}),e.textContent=Ps(t),t}transformRules(e,t){this._currentElement=t,Ts(e,e=>{this.transformRule(e)}),this._currentElement=null}transformRule(e){e.cssText=this.transformCssText(e.parsedCssText,e),":root"===e.selector&&(e.selector=":host > *")}transformCssText(e,t){return e=e.replace(ws,(e,n,i,o)=>this._produceCssProperties(e,n,i,o,t)),this._consumeCssProperties(e,t)}_getInitialValueForProperty(e){return this._measureElement||(this._measureElement=document.createElement("meta"),this._measureElement.setAttribute("apply-shim-measure",""),this._measureElement.style.all="initial",document.head.appendChild(this._measureElement)),window.getComputedStyle(this._measureElement).getPropertyValue(e)}_fallbacksFromPreviousRules(e){let t=e;for(;t.parent;)t=t.parent;const n={};let i=!1;return Ts(t,t=>{i=i||t===e,i||t.selector===e.selector&&Object.assign(n,this._cssTextToMap(t.parsedCssText))}),n}_consumeCssProperties(e,t){let n=null;for(;n=Cs.exec(e);){let i=n[0],o=n[1],s=n.index,r=s+i.indexOf("@apply"),a=s+i.length,l=e.slice(0,r),c=e.slice(a),d=t?this._fallbacksFromPreviousRules(t):{};Object.assign(d,this._cssTextToMap(l));let h=this._atApplyToCssProperties(o,d);e=`${l}${h}${c}`,Cs.lastIndex=s+h.length}return e}_atApplyToCssProperties(e,t){e=e.replace(Ds,"");let n=[],i=this._map.get(e);if(i||(this._map.set(e,{}),i=this._map.get(e)),i){let o,s,r;this._currentElement&&(i.dependants[this._currentElement]=!0);const a=i.properties;for(o in a)r=t&&t[o],s=[o,": var(",e,"_-_",o],r&&s.push(",",r.replace(Ms,"")),s.push(")"),Ms.test(a[o])&&s.push(" !important"),n.push(s.join(""))}return n.join("; ")}_replaceInitialOrInherit(e,t){let n=$s.exec(t);return n&&(t=n[1]?this._getInitialValueForProperty(e):"apply-shim-inherit"),t}_cssTextToMap(e,t=!1){let n,i,o=e.split(";"),s={};for(let e,r,a=0;a<o.length;a++)e=o[a],e&&(r=e.split(":"),r.length>1&&(n=r[0].trim(),i=r.slice(1).join(":"),t&&(i=this._replaceInitialOrInherit(n,i)),s[n]=i));return s}_invalidateMixinEntry(e){if(Bs)for(let t in e.dependants)t!==this._currentElement&&Bs(t)}_produceCssProperties(e,t,n,i,o){if(n&&function e(t,n){let i=t.indexOf("var(");if(-1===i)return n(t,"","","");let o=Is(t,i+3),s=t.substring(i+4,o),r=t.substring(0,i),a=e(t.substring(o+1),n),l=s.indexOf(",");return-1===l?n(r,s.trim(),"",a):n(r,s.substring(0,l).trim(),s.substring(l+1).trim(),a)}(n,(e,t)=>{t&&this._map.get(t)&&(i=`@apply ${t};`)}),!i)return e;let s=this._consumeCssProperties(""+i,o),r=e.slice(0,e.indexOf("--")),a=this._cssTextToMap(s,!0),l=a,c=this._map.get(t),d=c&&c.properties;d?l=Object.assign(Object.create(d),a):this._map.set(t,l);let h,p,u=[],g=!1;for(h in l)p=a[h],void 0===p&&(p="initial"),!d||h in d||(g=!0),u.push(`${t}_-_${h}: ${p}`);return g&&this._invalidateMixinEntry(c),c&&(c.properties=l),n&&(r=`${e};${r}`),`${r}${u.join("; ")};`}}js.prototype.detectMixin=js.prototype.detectMixin,js.prototype.transformStyle=js.prototype.transformStyle,js.prototype.transformCustomStyle=js.prototype.transformCustomStyle,js.prototype.transformRules=js.prototype.transformRules,js.prototype.transformRule=js.prototype.transformRule,js.prototype.transformTemplate=js.prototype.transformTemplate,js.prototype._separator="_-_",Object.defineProperty(js.prototype,"invalidCallback",{get:()=>Bs,set(e){Bs=e}});const Hs={},Us="_applyShimCurrentVersion",Gs="_applyShimNextVersion",Vs=Promise.resolve();
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/function zs(e){let t=Hs[e];t&&function(e){e[Us]=e[Us]||0,e._applyShimValidatingVersion=e._applyShimValidatingVersion||0,e[Gs]=(e[Gs]||0)+1}(t)}function Ws(e){return e[Us]===e[Gs]}function qs(e){return!Ws(e)&&e._applyShimValidatingVersion===e[Gs]}function Ks(e){e._applyShimValidatingVersion=e[Gs],e._validating||(e._validating=!0,Vs.then((function(){e[Us]=e[Gs],e._validating=!1})))}let Ys,Xs=null,Js=window.HTMLImports&&window.HTMLImports.whenReady||null;function Zs(e){requestAnimationFrame((function(){Js?Js(e):(Xs||(Xs=new Promise(e=>{Ys=e}),"complete"===document.readyState?Ys():document.addEventListener("readystatechange",()=>{"complete"===document.readyState&&Ys()})),Xs.then((function(){e&&e()})))}))}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/const Qs="__shadyCSSCachedStyle";let er=null,tr=null;class nr{constructor(){this.customStyles=[],this.enqueued=!1,Zs(()=>{window.ShadyCSS.flushCustomStyles&&window.ShadyCSS.flushCustomStyles()})}enqueueDocumentValidation(){!this.enqueued&&tr&&(this.enqueued=!0,Zs(tr))}addCustomStyle(e){e.__seenByShadyCSS||(e.__seenByShadyCSS=!0,this.customStyles.push(e),this.enqueueDocumentValidation())}getStyleForCustomStyle(e){if(e[Qs])return e[Qs];let t;return t=e.getStyle?e.getStyle():e,t}processStyles(){const e=this.customStyles;for(let t=0;t<e.length;t++){const n=e[t];if(n[Qs])continue;const i=this.getStyleForCustomStyle(n);if(i){const e=i.__appliedElement||i;er&&er(e),n[Qs]=e}}return e}}nr.prototype.addCustomStyle=nr.prototype.addCustomStyle,nr.prototype.getStyleForCustomStyle=nr.prototype.getStyleForCustomStyle,nr.prototype.processStyles=nr.prototype.processStyles,Object.defineProperties(nr.prototype,{transformCallback:{get:()=>er,set(e){er=e}},validateCallback:{get:()=>tr,set(e){let t=!1;tr||(t=!0),tr=e,t&&this.enqueueDocumentValidation()}}});const ir=new js;class or{constructor(){this.customStyleInterface=null,ir.invalidCallback=zs}ensure(){this.customStyleInterface||window.ShadyCSS.CustomStyleInterface&&(this.customStyleInterface=window.ShadyCSS.CustomStyleInterface,this.customStyleInterface.transformCallback=e=>{ir.transformCustomStyle(e)},this.customStyleInterface.validateCallback=()=>{requestAnimationFrame(()=>{this.customStyleInterface.enqueued&&this.flushCustomStyles()})})}prepareTemplate(e,t){if(this.ensure(),Os(e))return;Hs[t]=e;let n=ir.transformTemplate(e,t);e._styleAst=n}flushCustomStyles(){if(this.ensure(),!this.customStyleInterface)return;let e=this.customStyleInterface.processStyles();if(this.customStyleInterface.enqueued){for(let t=0;t<e.length;t++){let n=e[t],i=this.customStyleInterface.getStyleForCustomStyle(n);i&&ir.transformCustomStyle(i)}this.customStyleInterface.enqueued=!1}}styleSubtree(e,t){if(this.ensure(),t&&Ns(e,t),e.shadowRoot){this.styleElement(e);let t=e.shadowRoot.children||e.shadowRoot.childNodes;for(let e=0;e<t.length;e++)this.styleSubtree(t[e])}else{let t=e.children||e.childNodes;for(let e=0;e<t.length;e++)this.styleSubtree(t[e])}}styleElement(e){this.ensure();let{is:t}=function(e){let t=e.localName,n="",i="";return t?t.indexOf("-")>-1?n=t:(i=t,n=e.getAttribute&&e.getAttribute("is")||""):(n=e.is,i=e.extends),{is:n,typeExtension:i}}(e),n=Hs[t];if((!n||!Os(n))&&n&&!Ws(n)){qs(n)||(this.prepareTemplate(n,t),Ks(n));let i=e.shadowRoot;if(i){let e=i.querySelector("style");e&&(e.__cssRules=n._styleAst,e.textContent=Ps(n._styleAst))}}}styleDocument(e){this.ensure(),this.styleSubtree(document.body,e)}}if(!window.ShadyCSS||!window.ShadyCSS.ScopingShim){const e=new or;let t=window.ShadyCSS&&window.ShadyCSS.CustomStyleInterface;window.ShadyCSS={prepareTemplate(t,n,i){e.flushCustomStyles(),e.prepareTemplate(t,n)},prepareTemplateStyles(e,t,n){window.ShadyCSS.prepareTemplate(e,t,n)},prepareTemplateDom(e,t){},styleSubtree(t,n){e.flushCustomStyles(),e.styleSubtree(t,n)},styleElement(t){e.flushCustomStyles(),e.styleElement(t)},styleDocument(t){e.flushCustomStyles(),e.styleDocument(t)},getComputedStyleValue:(e,t)=>Ls(e,t),flushCustomStyles(){e.flushCustomStyles()},nativeCss:ds,nativeShadow:ss,cssBuild:as,disableRuntime:cs},t&&(window.ShadyCSS.CustomStyleInterface=t)}window.ShadyCSS.ApplyShim=ir;
/**
@license
Copyright (c) 2019 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const sr=window.ShadyDOM,rr=window.ShadyCSS;function ar(e,t){return qt(e).getRootNode()===t}
/**
 * @fileoverview
 * @suppress {checkPrototypalTypes}
 * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
 * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
 * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
 * Google as part of the polymer project is also subject to an additional IP
 * rights grant found at http://polymer.github.io/PATENTS.txt
 */
const lr=e=>{for(;e;){const t=Object.getOwnPropertyDescriptor(e,"observedAttributes");if(t)return t.get;e=Object.getPrototypeOf(e.prototype).constructor}return()=>[]};Me(e=>{const t=ts(e);let n=lr(t);return class extends t{constructor(){super(),this.__isUpgradeDisabled}static get observedAttributes(){return n.call(this).concat("disable-upgrade")}_initializeProperties(){this.hasAttribute("disable-upgrade")?this.__isUpgradeDisabled=!0:super._initializeProperties()}_enableProperties(){this.__isUpgradeDisabled||super._enableProperties()}_canApplyPropertyDefault(e){return super._canApplyPropertyDefault(e)&&!(this.__isUpgradeDisabled&&this._isPropertyPending(e))}attributeChangedCallback(e,t,n,i){"disable-upgrade"==e?this.__isUpgradeDisabled&&null==n&&(super._initializeProperties(),this.__isUpgradeDisabled=!1,qt(this).isConnected&&super.connectedCallback()):super.attributeChangedCallback(e,t,n,i)}connectedCallback(){this.__isUpgradeDisabled||super.connectedCallback()}disconnectedCallback(){this.__isUpgradeDisabled||super.disconnectedCallback()}}});let cr=window.ShadyCSS;const dr=Me(e=>{const t=oo(ts(e)),n=es?t:fo(t),i=lr(n),o={x:"pan-x",y:"pan-y",none:"none",all:"auto"};class s extends n{constructor(){super(),this.isAttached,this.__boundListeners,this._debouncers,this.__isUpgradeDisabled,this.__needsAttributesAtConnected,this._legacyForceObservedAttributes}static get importMeta(){return this.prototype.importMeta}created(){}__attributeReaction(e,t,n){(this.__dataAttributes&&this.__dataAttributes[e]||"disable-upgrade"===e)&&this.attributeChangedCallback(e,t,n,null)}setAttribute(e,t){if(Ne&&!this._legacyForceObservedAttributes){const n=this.getAttribute(e);super.setAttribute(e,t),this.__attributeReaction(e,n,String(t))}else super.setAttribute(e,t)}removeAttribute(e){if(Ne&&!this._legacyForceObservedAttributes){const t=this.getAttribute(e);super.removeAttribute(e),this.__attributeReaction(e,t,null)}else super.removeAttribute(e)}static get observedAttributes(){return Ne&&!this.prototype._legacyForceObservedAttributes?(this.hasOwnProperty(JSCompiler_renameProperty("__observedAttributes",this))||(this.__observedAttributes=[],Zn(this.prototype)),this.__observedAttributes):i.call(this).concat("disable-upgrade")}_enableProperties(){this.__isUpgradeDisabled||super._enableProperties()}_canApplyPropertyDefault(e){return super._canApplyPropertyDefault(e)&&!(this.__isUpgradeDisabled&&this._isPropertyPending(e))}connectedCallback(){this.__needsAttributesAtConnected&&this._takeAttributes(),this.__isUpgradeDisabled||(super.connectedCallback(),this.isAttached=!0,this.attached())}attached(){}disconnectedCallback(){this.__isUpgradeDisabled||(super.disconnectedCallback(),this.isAttached=!1,this.detached())}detached(){}attributeChangedCallback(e,t,n,i){t!==n&&("disable-upgrade"==e?this.__isUpgradeDisabled&&null==n&&(this._initializeProperties(),this.__isUpgradeDisabled=!1,qt(this).isConnected&&this.connectedCallback()):(super.attributeChangedCallback(e,t,n,i),this.attributeChanged(e,t,n)))}attributeChanged(e,t,n){}_initializeProperties(){if(Ce&&this.hasAttribute("disable-upgrade"))this.__isUpgradeDisabled=!0;else{let e=Object.getPrototypeOf(this);e.hasOwnProperty(JSCompiler_renameProperty("__hasRegisterFinished",e))||(this._registered(),e.__hasRegisterFinished=!0),super._initializeProperties(),this.root=this,this.created(),Ne&&!this._legacyForceObservedAttributes&&(this.hasAttributes()?this._takeAttributes():this.parentNode||(this.__needsAttributesAtConnected=!0)),this._applyListeners()}}_takeAttributes(){const e=this.attributes;for(let t=0,n=e.length;t<n;t++){const n=e[t];this.__attributeReaction(n.name,null,n.value)}}_registered(){}ready(){this._ensureAttributes(),super.ready()}_ensureAttributes(){}_applyListeners(){}serialize(e){return this._serializeValue(e)}deserialize(e,t){return this._deserializeValue(e,t)}reflectPropertyToAttribute(e,t,n){this._propertyToAttribute(e,t,n)}serializeValueToAttribute(e,t,n){this._valueToNodeAttribute(n||this,e,t)}extend(e,t){if(!e||!t)return e||t;let n=Object.getOwnPropertyNames(t);for(let i,o=0;o<n.length&&(i=n[o]);o++){let n=Object.getOwnPropertyDescriptor(t,i);n&&Object.defineProperty(e,i,n)}return e}mixin(e,t){for(let n in t)e[n]=t[n];return e}chainObject(e,t){return e&&t&&e!==t&&(e.__proto__=t),e}instanceTemplate(e){let t=this.constructor._contentForTemplate(e);return document.importNode(t,!0)}fire(e,t,n){n=n||{},t=null==t?{}:t;let i=new Event(e,{bubbles:void 0===n.bubbles||n.bubbles,cancelable:Boolean(n.cancelable),composed:void 0===n.composed||n.composed});i.detail=t;let o=n.node||this;return qt(o).dispatchEvent(i),i}listen(e,t,n){e=e||this;let i=this.__boundListeners||(this.__boundListeners=new WeakMap),o=i.get(e);o||(o={},i.set(e,o));let s=t+n;o[s]||(o[s]=this._addMethodEventListenerToNode(e,t,n,this))}unlisten(e,t,n){e=e||this;let i=this.__boundListeners&&this.__boundListeners.get(e),o=t+n,s=i&&i[o];s&&(this._removeEventListenerFromNode(e,t,s),i[o]=null)}setScrollDirection(e,t){Bi(t||this,o[e]||"auto")}$$(e){return this.root.querySelector(e)}get domHost(){let e=qt(this).getRootNode();return e instanceof DocumentFragment?e.host:e}distributeContent(){const e=qo(this);window.ShadyDOM&&e.shadowRoot&&ShadyDOM.flush()}getEffectiveChildNodes(){return qo(this).getEffectiveChildNodes()}queryDistributedElements(e){return qo(this).queryDistributedElements(e)}getEffectiveChildren(){return this.getEffectiveChildNodes().filter((function(e){return e.nodeType===Node.ELEMENT_NODE}))}getEffectiveTextContent(){let e=this.getEffectiveChildNodes(),t=[];for(let n,i=0;n=e[i];i++)n.nodeType!==Node.COMMENT_NODE&&t.push(n.textContent);return t.join("")}queryEffectiveChildren(e){let t=this.queryDistributedElements(e);return t&&t[0]}queryAllEffectiveChildren(e){return this.queryDistributedElements(e)}getContentChildNodes(e){let t=this.root.querySelector(e||"slot");return t?qo(t).getDistributedNodes():[]}getContentChildren(e){return this.getContentChildNodes(e).filter((function(e){return e.nodeType===Node.ELEMENT_NODE}))}isLightDescendant(e){return this!==e&&qt(this).contains(e)&&qt(this).getRootNode()===qt(e).getRootNode()}isLocalDescendant(e){return this.root===qt(e).getRootNode()}scopeSubtree(e,t=!1){return function(e,t=!1){if(!sr||!rr)return null;if(!sr.handlesDynamicScoping)return null;const n=rr.ScopingShim;if(!n)return null;const i=n.scopeForNode(e),o=qt(e).getRootNode(),s=e=>{if(!ar(e,o))return;const t=Array.from(sr.nativeMethods.querySelectorAll.call(e,"*"));t.push(e);for(let e=0;e<t.length;e++){const s=t[e];if(!ar(s,o))continue;const r=n.currentScopeForNode(s);r!==i&&(""!==r&&n.unscopeNode(s,r),n.scopeNode(s,i))}};if(s(e),t){const t=new MutationObserver(e=>{for(let t=0;t<e.length;t++){const n=e[t];for(let e=0;e<n.addedNodes.length;e++){const t=n.addedNodes[e];t.nodeType===Node.ELEMENT_NODE&&s(t)}}});return t.observe(e,{childList:!0,subtree:!0}),t}return null}(e,t)}getComputedStyleValue(e){return cr.getComputedStyleValue(this,e)}debounce(e,t,n){return this._debouncers=this._debouncers||{},this._debouncers[e]=si.debounce(this._debouncers[e],n>0?Gt.after(n):Wt,t.bind(this))}isDebouncerActive(e){this._debouncers=this._debouncers||{};let t=this._debouncers[e];return!(!t||!t.isActive())}flushDebouncer(e){this._debouncers=this._debouncers||{};let t=this._debouncers[e];t&&t.flush()}cancelDebouncer(e){this._debouncers=this._debouncers||{};let t=this._debouncers[e];t&&t.cancel()}async(e,t){return t>0?Gt.run(e.bind(this),t):~Wt.run(e.bind(this))}cancelAsync(e){e<0?Wt.cancel(~e):Gt.cancel(e)}create(e,t){let n=document.createElement(e);if(t)if(n.setProperties)n.setProperties(t);else for(let e in t)n[e]=t[e];return n}elementMatches(e,t){return Uo(t||this,e)}toggleAttribute(e,t){let n=this;return 3===arguments.length&&(n=arguments[2]),1==arguments.length&&(t=!n.hasAttribute(e)),t?(qt(n).setAttribute(e,""),!0):(qt(n).removeAttribute(e),!1)}toggleClass(e,t,n){n=n||this,1==arguments.length&&(t=!n.classList.contains(e)),t?n.classList.add(e):n.classList.remove(e)}transform(e,t){(t=t||this).style.webkitTransform=e,t.style.transform=e}translate3d(e,t,n,i){i=i||this,this.transform("translate3d("+e+","+t+","+n+")",i)}arrayDelete(e,t){let n;if(Array.isArray(e)){if(n=e.indexOf(t),n>=0)return e.splice(n,1)}else{if(n=ft(this,e).indexOf(t),n>=0)return this.splice(e,n,1)}return null}_logger(e,t){switch(Array.isArray(t)&&1===t.length&&Array.isArray(t[0])&&(t=t[0]),e){case"log":case"warn":case"error":console[e](...t)}}_log(...e){this._logger("log",e)}_warn(...e){this._logger("warn",e)}_error(...e){this._logger("error",e)}_logf(e,...t){return["[%s::%s]",this.is,e,...t]}}return s.prototype.is="",s}),hr=dr;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Legacy.LegacyElementMixin"),Polymer.LegacyElementMixin=hr;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const pr={attached:!0,detached:!0,ready:!0,created:!0,beforeRegister:!0,registered:!0,attributeChanged:!0,listeners:!0,hostAttributes:!0},ur={attached:!0,detached:!0,ready:!0,created:!0,beforeRegister:!0,registered:!0,attributeChanged:!0,behaviors:!0,_noAccessors:!0},gr=Object.assign({listeners:!0,hostAttributes:!0,properties:!0,observers:!0},ur);function mr(e,t){return yr({},dr(t),e)}function _r(e,t,n,i){!function(e,t,n){const i=e._noAccessors,o=Object.getOwnPropertyNames(e);for(let s=0;s<o.length;s++){let r=o[s];if(!(r in n))if(i)t[r]=e[r];else{let n=Object.getOwnPropertyDescriptor(e,r);n&&(n.configurable=!0,Object.defineProperty(t,r,n))}}}(t,e,i);for(let e in pr)t[e]&&(n[e]=n[e]||[],n[e].push(t[e]))}function fr(e,t){for(const n in t){const i=e[n],o=t[n];e[n]=!("value"in o)&&i&&"value"in i?Object.assign({value:i.value},o):o}}const vr=dr(HTMLElement);function yr(e,t,n){let i;const o={};class s extends t{static _finalizeClass(){if(this.hasOwnProperty(JSCompiler_renameProperty("generatedFrom",this))){if(i)for(let e,t=0;t<i.length;t++)e=i[t],e.properties&&this.createProperties(e.properties),e.observers&&this.createObservers(e.observers,e.properties);e.properties&&this.createProperties(e.properties),e.observers&&this.createObservers(e.observers,e.properties),this._prepareTemplate()}else t._finalizeClass.call(this)}static get properties(){const t={};if(i)for(let e=0;e<i.length;e++)fr(t,i[e].properties);return fr(t,e.properties),t}static get observers(){let t=[];if(i)for(let e,n=0;n<i.length;n++)e=i[n],e.observers&&(t=t.concat(e.observers));return e.observers&&(t=t.concat(e.observers)),t}created(){super.created();const e=o.created;if(e)for(let t=0;t<e.length;t++)e[t].call(this)}_registered(){const e=s.prototype;if(!e.hasOwnProperty(JSCompiler_renameProperty("__hasRegisterFinished",e))){e.__hasRegisterFinished=!0,super._registered(),Ce&&r(e);const t=Object.getPrototypeOf(this);let n=o.beforeRegister;if(n)for(let e=0;e<n.length;e++)n[e].call(t);if(n=o.registered,n)for(let e=0;e<n.length;e++)n[e].call(t)}}_applyListeners(){super._applyListeners();const e=o.listeners;if(e)for(let t=0;t<e.length;t++){const n=e[t];if(n)for(let e in n)this._addMethodEventListenerToNode(this,e,n[e])}}_ensureAttributes(){const e=o.hostAttributes;if(e)for(let t=e.length-1;t>=0;t--){const n=e[t];for(let e in n)this._ensureAttribute(e,n[e])}super._ensureAttributes()}ready(){super.ready();let e=o.ready;if(e)for(let t=0;t<e.length;t++)e[t].call(this)}attached(){super.attached();let e=o.attached;if(e)for(let t=0;t<e.length;t++)e[t].call(this)}detached(){super.detached();let e=o.detached;if(e)for(let t=0;t<e.length;t++)e[t].call(this)}attributeChanged(e,t,n){super.attributeChanged();let i=o.attributeChanged;if(i)for(let o=0;o<i.length;o++)i[o].call(this,e,t,n)}}if(n){Array.isArray(n)||(n=[n]);let e=t.prototype.behaviors;i=function e(t,n,i){n=n||[];for(let o=t.length-1;o>=0;o--){let s=t[o];s?Array.isArray(s)?e(s,n):n.indexOf(s)<0&&(!i||i.indexOf(s)<0)&&n.unshift(s):console.warn("behavior is null, check for missing or 404 import")}return n}(n,null,e),s.prototype.behaviors=e?e.concat(n):i}const r=t=>{i&&function(e,t,n){for(let i=0;i<t.length;i++)_r(e,t[i],n,gr)}(t,i,o),_r(t,e,o,ur)};return Ce||r(s.prototype),s.generatedFrom=e,s}const br=function(e,t){e||console.warn("Polymer.Class requires `info` argument");let n=t?t(vr):vr;return n=yr(e,n,e.behaviors),n.is=n.prototype.is=e.is,n};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Legacy.Class");const wr=br,Cr=mr;Polymer.Class=wr,Polymer.mixinBehaviors=Cr;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const Er=function(e){let t;return t="function"==typeof e?e:Er.Class(e),e._legacyForceObservedAttributes&&(t.prototype._legacyForceObservedAttributes=e._legacyForceObservedAttributes),customElements.define(t.is,t),t};Er.Class=br,
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Legacy.PolymerFn"),Polymer._polymerFn=Er;const Sr=window.onLegacyPolymerFunctionDefinedCallback;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
function Ar(e,t,n,i,o){let s;o&&(s="object"==typeof n&&null!==n,s&&(i=e.__dataTemp[t]));let r=i!==n&&(i==i||n==n);return s&&r&&(e.__dataTemp[t]=n),r}Sr&&Sr();const xr=Me(e=>class extends e{_shouldPropertyChange(e,t,n){return Ar(this,e,t,n,!0)}}),Pr=Me(e=>class extends e{static get properties(){return{mutableData:Boolean}}_shouldPropertyChange(e,t,n){return Ar(this,e,t,n,this.mutableData)}});xr._mutablePropertyChange=Ar;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Rr=Pr,Tr=xr;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Mixins.MutableData"),Polymer.MutableData=Tr,Polymer.OptionalMutableData=Rr;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let Ir=null;function kr(){return Ir}kr.prototype=Object.create(HTMLTemplateElement.prototype,{constructor:{value:kr,writable:!0}});const Or=zn(kr),Nr=xr(Or);const Lr=zn(class{});function Dr(e,t){for(let n=0;n<t.length;n++){let i=t[n];if(Boolean(e)!=Boolean(i.__hideTemplateChildren__))if(i.nodeType===Node.TEXT_NODE)e?(i.__polymerTextContent__=i.textContent,i.textContent=""):i.textContent=i.__polymerTextContent__;else if("slot"===i.localName)if(e)i.__polymerReplaced__=document.createComment("hidden-slot"),qt(qt(i).parentNode).replaceChild(i.__polymerReplaced__,i);else{const e=i.__polymerReplaced__;e&&qt(qt(e).parentNode).replaceChild(i,e)}else i.style&&(e?(i.__polymerDisplay__=i.style.display,i.style.display="none"):i.style.display=i.__polymerDisplay__);i.__hideTemplateChildren__=e,i._showHideChildren&&i._showHideChildren(e)}}class $r extends Lr{constructor(e){super(),this._configureProperties(e),this.root=this._stampTemplate(this.__dataHost);let t=[];this.children=t;for(let e=this.root.firstChild;e;e=e.nextSibling)t.push(e),e.__templatizeInstance=this;this.__templatizeOwner&&this.__templatizeOwner.__hideTemplateChildren__&&this._showHideChildren(!0);let n=this.__templatizeOptions;(e&&n.instanceProps||!n.instanceProps)&&this._enableProperties()}_configureProperties(e){if(this.__templatizeOptions.forwardHostProp)for(let e in this.__hostProps)this._setPendingProperty(e,this.__dataHost["_host_"+e]);for(let t in e)this._setPendingProperty(t,e[t])}forwardHostProp(e,t){this._setPendingPropertyOrPath(e,t,!1,!0)&&this.__dataHost._enqueueClient(this)}_addEventListenerToNode(e,t,n){if(this._methodHost&&this.__templatizeOptions.parentModel)this._methodHost._addEventListenerToNode(e,t,e=>{e.model=this,n(e)});else{let i=this.__dataHost.__dataHost;i&&i._addEventListenerToNode(e,t,n)}}_showHideChildren(e){Dr(e,this.children)}_setUnmanagedPropertyToNode(e,t,n){e.__hideTemplateChildren__&&e.nodeType==Node.TEXT_NODE&&"textContent"==t?e.__polymerTextContent__=n:super._setUnmanagedPropertyToNode(e,t,n)}get parentModel(){let e=this.__parentModel;if(!e){let t;e=this;do{e=e.__dataHost.__dataHost}while((t=e.__templatizeOptions)&&!t.parentModel);this.__parentModel=e}return e}dispatchEvent(e){return!0}}$r.prototype.__dataHost,$r.prototype.__templatizeOptions,$r.prototype._methodHost,$r.prototype.__templatizeOwner,$r.prototype.__hostProps;const Mr=xr($r);function Fr(e){let t=e.__dataHost;return t&&t._methodHost||t}function Br(e,t,n){let i=n.mutableData?Mr:$r;Gr.mixin&&(i=Gr.mixin(i));let o=class extends i{};return o.prototype.__templatizeOptions=n,o.prototype._bindTemplate(e),function(e,t,n,i){let o=n.hostProps||{};for(let t in i.instanceProps){delete o[t];let n=i.notifyInstanceProp;n&&e.prototype._addPropertyEffect(t,e.prototype.PROPERTY_EFFECT_TYPES.NOTIFY,{fn:Ur(t,n)})}if(i.forwardHostProp&&t.__dataHost)for(let t in o)n.hasHostProps||(n.hasHostProps=!0),e.prototype._addPropertyEffect(t,e.prototype.PROPERTY_EFFECT_TYPES.NOTIFY,{fn:function(e,t,n){e.__dataHost._setPendingPropertyOrPath("_host_"+t,n[t],!0,!0)}})}(o,e,t,n),o}function jr(e,t,n,i){let o=n.forwardHostProp;if(o&&t.hasHostProps){const s="template"==e.localName;let r=t.templatizeTemplateClass;if(!r){if(s){let e=n.mutableData?Nr:Or;class i extends e{}r=t.templatizeTemplateClass=i}else{const n=e.constructor;class i extends n{}r=t.templatizeTemplateClass=i}let a=t.hostProps;for(let e in a)r.prototype._addPropertyEffect("_host_"+e,r.prototype.PROPERTY_EFFECT_TYPES.PROPAGATE,{fn:Hr(e,o)}),r.prototype._createNotifyingProperty("_host_"+e);Se&&i&&function(e,t,n){const i=n.constructor._properties,{propertyEffects:o}=e,{instanceProps:s}=t;for(let e in o)if(!(i[e]||s&&s[e])){const t=o[e];for(let n=0;n<t.length;n++){const{part:i}=t[n].info;if(!i.signature||!i.signature.static){console.warn(`Property '${e}' used in template but not `+"declared in 'properties'; attribute will not be observed.");break}}}}(t,n,i)}if(e.__dataProto&&Object.assign(e.__data,e.__dataProto),s)!function(e,t){Ir=e,Object.setPrototypeOf(e,t.prototype),new t,Ir=null}(e,r),e.__dataTemp={},e.__dataPending=null,e.__dataOld=null,e._enableProperties();else{Object.setPrototypeOf(e,r.prototype);const n=t.hostProps;for(let t in n)if(t="_host_"+t,t in e){const n=e[t];delete e[t],e.__data[t]=n}}}}function Hr(e,t){return function(e,n,i){t.call(e.__templatizeOwner,n.substring("_host_".length),i[n])}}function Ur(e,t){return function(e,n,i){t.call(e.__templatizeOwner,e,n,i[n])}}function Gr(e,t,n){if(ve&&!Fr(e))throw new Error("strictTemplatePolicy: template owner not trusted");if(n=n||{},e.__templatizeOwner)throw new Error("A <template> can only be templatized once");e.__templatizeOwner=t;let i=(t?t.constructor:$r)._parseTemplate(e),o=i.templatizeInstanceClass;o||(o=Br(e,i,n),i.templatizeInstanceClass=o);const s=Fr(e);jr(e,i,n,s);let r=class extends o{};return r.prototype._methodHost=s,r.prototype.__dataHost=e,r.prototype.__templatizeOwner=t,r.prototype.__hostProps=i.hostProps,r=r,r}function Vr(e,t){let n;for(;t;)if(n=t.__dataHost?t:t.__templatizeInstance){if(n.__dataHost==e)return n;t=n.__dataHost}else t=qt(t).parentNode;return null}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/const zr=Gr,Wr=Vr,qr=$r;goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.Templatize"),Polymer.Templatize={templatize:zr,modelForElement:Wr},Polymer.TemplateInstanceBase=qr;const Kr={templatize(e,t){this._templatizerTemplate=e,this.ctor=Gr(e,this,{mutableData:Boolean(t),parentModel:this._parentModel,instanceProps:this._instanceProps,forwardHostProp:this._forwardHostPropV2,notifyInstanceProp:this._notifyInstancePropV2})},stamp(e){return new this.ctor(e)},modelForElement(e){return Vr(this._templatizerTemplate,e)}};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Legacy.TemplatizerBehavior"),Polymer.Templatizer=Kr;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let Yr=!1;function Xr(){if(Ce&&!le){if(!Yr){Yr=!0;const e=document.createElement("style");e.textContent="dom-bind,dom-if,dom-repeat{display:none;}",document.head.appendChild(e)}return!0}return!1}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/const Jr=oo(Pr(zn(HTMLElement)));class Zr extends Jr{static get observedAttributes(){return["mutable-data"]}constructor(){if(super(),ve)throw new Error("strictTemplatePolicy: dom-bind not allowed");this.root=null,this.$=null,this.__children=null}attributeChangedCallback(e,t,n,i){this.mutableData=!0}connectedCallback(){Xr()||(this.style.display="none"),this.render()}disconnectedCallback(){this.__removeChildren()}__insertChildren(){qt(qt(this).parentNode).insertBefore(this.root,this)}__removeChildren(){if(this.__children)for(let e=0;e<this.__children.length;e++)this.root.appendChild(this.__children[e])}render(){let e;if(!this.__children){if(e=e||this.querySelector("template"),!e){let t=new MutationObserver(()=>{if(e=this.querySelector("template"),!e)throw new Error("dom-bind requires a <template> child");t.disconnect(),this.render()});return void t.observe(this,{childList:!0})}this.root=this._stampTemplate(e),this.$=this.root.$,this.__children=[];for(let e=this.root.firstChild;e;e=e.nextSibling)this.__children[this.__children.length]=e;this._enableProperties()}this.__insertChildren(),this.dispatchEvent(new CustomEvent("dom-change",{bubbles:!0,composed:!0}))}}customElements.define("dom-bind",Zr),
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Elements.DomBind"),Polymer.DomBind=Zr;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
class Qr{constructor(e){this.value=e.toString()}toString(){return this.value}}function ea(e){if(e instanceof Qr)return e.value;throw new Error(`non-literal value passed to Polymer's htmlLiteral function: ${e}`)}const ta=function(e,...t){const n=document.createElement("template");return n.innerHTML=t.reduce((t,n,i)=>t+function(e){if(e instanceof HTMLTemplateElement)return e.innerHTML;if(e instanceof Qr)return ea(e);throw new Error(`non-template value passed to Polymer's html function: ${e}`)}(n)+e[i+1],e[0]),n},na=ta,ia=function(e,...t){return new Qr(t.reduce((t,n,i)=>t+ea(n)+e[i+1],e[0]))};goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Utils.HtmlTag"),Polymer.html=na,Polymer.htmlLiteral=ia;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const oa=ts(HTMLElement);
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.PolymerElement");const sa=oa;Polymer.Element=sa;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const ra=Pr(oa);class aa extends ra{static get is(){return"dom-repeat"}static get template(){return null}static get properties(){return{items:{type:Array},as:{type:String,value:"item"},indexAs:{type:String,value:"index"},itemsIndexAs:{type:String,value:"itemsIndex"},sort:{type:Function,observer:"__sortChanged"},filter:{type:Function,observer:"__filterChanged"},observe:{type:String,observer:"__observeChanged"},delay:Number,renderedItemCount:{type:Number,notify:!Oe,readOnly:!0},initialCount:{type:Number},targetFramerate:{type:Number,value:20},_targetFrameTime:{type:Number,computed:"__computeFrameTime(targetFramerate)"},notifyDomChange:{type:Boolean},reuseChunkedInstances:{type:Boolean}}}static get observers(){return["__itemsChanged(items.*)"]}constructor(){super(),this.__instances=[],this.__renderDebouncer=null,this.__itemsIdxToInstIdx={},this.__chunkCount=null,this.__renderStartTime=null,this.__itemsArrayChanged=!1,this.__shouldMeasureChunk=!1,this.__shouldContinueChunking=!1,this.__chunkingId=0,this.__sortFn=null,this.__filterFn=null,this.__observePaths=null,this.__ctor=null,this.__isDetached=!0,this.template=null,this._templateInfo}disconnectedCallback(){super.disconnectedCallback(),this.__isDetached=!0;for(let e=0;e<this.__instances.length;e++)this.__detachInstance(e)}connectedCallback(){if(super.connectedCallback(),Xr()||(this.style.display="none"),this.__isDetached){this.__isDetached=!1;let e=qt(qt(this).parentNode);for(let t=0;t<this.__instances.length;t++)this.__attachInstance(t,e)}}__ensureTemplatized(){if(!this.__ctor){const e=this;let t=this.template=e._templateInfo?e:this.querySelector("template");if(!t){let e=new MutationObserver(()=>{if(!this.querySelector("template"))throw new Error("dom-repeat requires a <template> child");e.disconnect(),this.__render()});return e.observe(this,{childList:!0}),!1}let n={};n[this.as]=!0,n[this.indexAs]=!0,n[this.itemsIndexAs]=!0,this.__ctor=Gr(t,this,{mutableData:this.mutableData,parentModel:!0,instanceProps:n,forwardHostProp:function(e,t){let n=this.__instances;for(let i,o=0;o<n.length&&(i=n[o]);o++)i.forwardHostProp(e,t)},notifyInstanceProp:function(e,t,n){if(gt(this.as,t)){let i=e[this.itemsIndexAs];t==this.as&&(this.items[i]=n);let o=ut(this.as,`${JSCompiler_renameProperty("items",this)}.${i}`,t);this.notifyPath(o,n)}}})}return!0}__getMethodHost(){return this.__dataHost._methodHost||this.__dataHost}__functionFromPropertyValue(e){if("string"==typeof e){let t=e,n=this.__getMethodHost();return function(){return n[t].apply(n,arguments)}}return e}__sortChanged(e){this.__sortFn=this.__functionFromPropertyValue(e),this.items&&this.__debounceRender(this.__render)}__filterChanged(e){this.__filterFn=this.__functionFromPropertyValue(e),this.items&&this.__debounceRender(this.__render)}__computeFrameTime(e){return Math.ceil(1e3/e)}__observeChanged(){this.__observePaths=this.observe&&this.observe.replace(".*",".").split(" ")}__handleObservedPaths(e){if(this.__sortFn||this.__filterFn)if(e){if(this.__observePaths){let t=this.__observePaths;for(let n=0;n<t.length;n++)0===e.indexOf(t[n])&&this.__debounceRender(this.__render,this.delay)}}else this.__debounceRender(this.__render,this.delay)}__itemsChanged(e){this.items&&!Array.isArray(this.items)&&console.warn("dom-repeat expected array for `items`, found",this.items),this.__handleItemPath(e.path,e.value)||("items"===e.path&&(this.__itemsArrayChanged=!0),this.__debounceRender(this.__render))}__debounceRender(e,t=0){this.__renderDebouncer=si.debounce(this.__renderDebouncer,t>0?Gt.after(t):Wt,e.bind(this)),ai(this.__renderDebouncer)}render(){this.__debounceRender(this.__render),Mo()}__render(){if(!this.__ensureTemplatized())return;let e=this.items||[];const t=this.__sortAndFilterItems(e),n=this.__calculateLimit(t.length);this.__updateInstances(e,n,t),this.initialCount&&(this.__shouldMeasureChunk||this.__shouldContinueChunking)&&(cancelAnimationFrame(this.__chunkingId),this.__chunkingId=requestAnimationFrame(()=>this.__continueChunking())),this._setRenderedItemCount(this.__instances.length),Oe&&!this.notifyDomChange||this.dispatchEvent(new CustomEvent("dom-change",{bubbles:!0,composed:!0}))}__sortAndFilterItems(e){let t=new Array(e.length);for(let n=0;n<e.length;n++)t[n]=n;return this.__filterFn&&(t=t.filter((t,n,i)=>this.__filterFn(e[t],n,i))),this.__sortFn&&t.sort((t,n)=>this.__sortFn(e[t],e[n])),t}__calculateLimit(e){let t=e;const n=this.__instances.length;if(this.initialCount){let i;!this.__chunkCount||this.__itemsArrayChanged&&!this.reuseChunkedInstances?(t=Math.min(e,this.initialCount),i=Math.max(t-n,0),this.__chunkCount=i||1):(i=Math.min(Math.max(e-n,0),this.__chunkCount),t=Math.min(n+i,e)),this.__shouldMeasureChunk=i===this.__chunkCount,this.__shouldContinueChunking=t<e,this.__renderStartTime=performance.now()}return this.__itemsArrayChanged=!1,t}__continueChunking(){if(this.__shouldMeasureChunk){const e=performance.now()-this.__renderStartTime,t=this._targetFrameTime/e;this.__chunkCount=Math.round(this.__chunkCount*t)||1}this.__shouldContinueChunking&&this.__debounceRender(this.__render)}__updateInstances(e,t,n){const i=this.__itemsIdxToInstIdx={};let o;for(o=0;o<t;o++){let t=this.__instances[o],s=n[o],r=e[s];i[s]=o,t?(t._setPendingProperty(this.as,r),t._setPendingProperty(this.indexAs,o),t._setPendingProperty(this.itemsIndexAs,s),t._flushProperties()):this.__insertInstance(r,o,s)}for(let e=this.__instances.length-1;e>=o;e--)this.__detachAndRemoveInstance(e)}__detachInstance(e){let t=this.__instances[e];const n=qt(t.root);for(let e=0;e<t.children.length;e++){let i=t.children[e];n.appendChild(i)}return t}__attachInstance(e,t){let n=this.__instances[e];t.insertBefore(n.root,this)}__detachAndRemoveInstance(e){this.__detachInstance(e),this.__instances.splice(e,1)}__stampInstance(e,t,n){let i={};return i[this.as]=e,i[this.indexAs]=t,i[this.itemsIndexAs]=n,new this.__ctor(i)}__insertInstance(e,t,n){const i=this.__stampInstance(e,t,n);let o=this.__instances[t+1],s=o?o.children[0]:this;return qt(qt(this).parentNode).insertBefore(i.root,s),this.__instances[t]=i,i}_showHideChildren(e){for(let t=0;t<this.__instances.length;t++)this.__instances[t]._showHideChildren(e)}__handleItemPath(e,t){let n=e.slice(6),i=n.indexOf("."),o=i<0?n:n.substring(0,i);if(o==parseInt(o,10)){let e=i<0?"":n.substring(i+1);this.__handleObservedPaths(e);let s=this.__itemsIdxToInstIdx[o],r=this.__instances[s];if(r){let n=this.as+(e?"."+e:"");r._setPendingPropertyOrPath(n,t,!1,!0),r._flushProperties()}return!0}}itemForElement(e){let t=this.modelForElement(e);return t&&t[this.as]}indexForElement(e){let t=this.modelForElement(e);return t&&t[this.indexAs]}modelForElement(e){return Vr(this.template,e)}}customElements.define(aa.is,aa),
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Elements.DomRepeat"),Polymer.DomRepeat=aa;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
class la extends oa{static get is(){return"dom-if"}static get template(){return null}static get properties(){return{if:{type:Boolean,observer:"__debounceRender"},restamp:{type:Boolean,observer:"__debounceRender"},notifyDomChange:{type:Boolean}}}constructor(){super(),this.__renderDebouncer=null,this._lastIf=!1,this.__hideTemplateChildren__=!1,this.__template,this._templateInfo}__debounceRender(){this.__renderDebouncer=si.debounce(this.__renderDebouncer,Wt,()=>this.__render()),ai(this.__renderDebouncer)}disconnectedCallback(){super.disconnectedCallback();const e=qt(this).parentNode;e&&(e.nodeType!=Node.DOCUMENT_FRAGMENT_NODE||qt(e).host)||this.__teardownInstance()}connectedCallback(){super.connectedCallback(),Xr()||(this.style.display="none"),this.if&&this.__debounceRender()}__ensureTemplate(){if(!this.__template){const e=this;let t=e._templateInfo?e:qt(e).querySelector("template");if(!t){let e=new MutationObserver(()=>{if(!qt(this).querySelector("template"))throw new Error("dom-if requires a <template> child");e.disconnect(),this.__render()});return e.observe(this,{childList:!0}),!1}this.__template=t}return!0}__ensureInstance(){let e=qt(this).parentNode;if(this.__hasInstance()){let t=this.__getInstanceNodes();if(t&&t.length){if(qt(this).previousSibling!==t[t.length-1])for(let n,i=0;i<t.length&&(n=t[i]);i++)qt(e).insertBefore(n,this)}}else{if(!e)return!1;if(!this.__ensureTemplate())return!1;this.__createAndInsertInstance(e)}return!0}render(){Mo()}__render(){if(this.if){if(!this.__ensureInstance())return}else this.restamp&&this.__teardownInstance();this._showHideChildren(),Oe&&!this.notifyDomChange||this.if==this._lastIf||(this.dispatchEvent(new CustomEvent("dom-change",{bubbles:!0,composed:!0})),this._lastIf=this.if)}__hasInstance(){}__getInstanceNodes(){}__createAndInsertInstance(e){}__teardownInstance(){}_showHideChildren(){}}const ca=ke?class extends la{constructor(){super(),this.__instance=null,this.__syncInfo=null}__hasInstance(){return Boolean(this.__instance)}__getInstanceNodes(){return this.__instance.templateInfo.childNodes}__createAndInsertInstance(e){const t=this.__dataHost||this;if(ve&&!this.__dataHost)throw new Error("strictTemplatePolicy: template owner not trusted");const n=t._bindTemplate(this.__template,!0);n.runEffects=(e,t,n)=>{let i=this.__syncInfo;if(this.if)i&&(this.__syncInfo=null,this._showHideChildren(),t=Object.assign(i.changedProps,t)),e(t,n);else if(this.__instance)if(i||(i=this.__syncInfo={runEffects:e,changedProps:{}}),n)for(const e in t){const t=dt(e);i.changedProps[t]=this.__dataHost[t]}else Object.assign(i.changedProps,t)},this.__instance=t._stampTemplate(this.__template,n),qt(e).insertBefore(this.__instance,this)}__syncHostProperties(){const e=this.__syncInfo;e&&(this.__syncInfo=null,e.runEffects(e.changedProps,!1))}__teardownInstance(){const e=this.__dataHost||this;this.__instance&&(e._removeBoundDom(this.__instance),this.__instance=null,this.__syncInfo=null)}_showHideChildren(){const e=this.__hideTemplateChildren__||!this.if;this.__instance&&Boolean(this.__instance.__hidden)!==e&&(this.__instance.__hidden=e,Dr(e,this.__instance.templateInfo.childNodes)),e||this.__syncHostProperties()}}:class extends la{constructor(){super(),this.__ctor=null,this.__instance=null,this.__invalidProps=null}__hasInstance(){return Boolean(this.__instance)}__getInstanceNodes(){return this.__instance.children}__createAndInsertInstance(e){this.__ctor||(this.__ctor=Gr(this.__template,this,{mutableData:!0,forwardHostProp:function(e,t){this.__instance&&(this.if?this.__instance.forwardHostProp(e,t):(this.__invalidProps=this.__invalidProps||Object.create(null),this.__invalidProps[dt(e)]=!0))}})),this.__instance=new this.__ctor,qt(e).insertBefore(this.__instance.root,this)}__teardownInstance(){if(this.__instance){let e=this.__instance.children;if(e&&e.length){let t=qt(e[0]).parentNode;if(t){t=qt(t);for(let n,i=0;i<e.length&&(n=e[i]);i++)t.removeChild(n)}}this.__invalidProps=null,this.__instance=null}}__syncHostProperties(){let e=this.__invalidProps;if(e){this.__invalidProps=null;for(let t in e)this.__instance._setPendingProperty(t,this.__dataHost[t]);this.__instance._flushProperties()}}_showHideChildren(){const e=this.__hideTemplateChildren__||!this.if;this.__instance&&Boolean(this.__instance.__hidden)!==e&&(this.__instance.__hidden=e,this.__instance._showHideChildren(e)),e||this.__syncHostProperties()}};customElements.define(ca.is,ca),
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Elements.DomIf"),Polymer.DomIf=ca;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let da=Me(e=>{let t=ts(e);return class extends t{static get properties(){return{items:{type:Array},multi:{type:Boolean,value:!1},selected:{type:Object,notify:!0},selectedItem:{type:Object,notify:!0},toggle:{type:Boolean,value:!1}}}static get observers(){return["__updateSelection(multi, items.*)"]}constructor(){super(),this.__lastItems=null,this.__lastMulti=null,this.__selectedMap=null}__updateSelection(e,t){let n=t.path;if(n==JSCompiler_renameProperty("items",this)){let n=t.base||[],i=this.__lastItems;if(e!==this.__lastMulti&&this.clearSelection(),i){let e=Oo(n,i);this.__applySplices(e)}this.__lastItems=n,this.__lastMulti=e}else if(t.path==`${JSCompiler_renameProperty("items",this)}.splices`)this.__applySplices(t.value.indexSplices);else{let e=n.slice(`${JSCompiler_renameProperty("items",this)}.`.length),t=parseInt(e,10);e.indexOf(".")<0&&e==t&&this.__deselectChangedIdx(t)}}__applySplices(e){let t=this.__selectedMap;for(let n=0;n<e.length;n++){let i=e[n];t.forEach((e,n)=>{e<i.index||(e>=i.index+i.removed.length?t.set(n,e+i.addedCount-i.removed.length):t.set(n,-1))});for(let e=0;e<i.addedCount;e++){let n=i.index+e;t.has(this.items[n])&&t.set(this.items[n],n)}}this.__updateLinks();let n=0;t.forEach((e,i)=>{e<0?(this.multi?this.splice(JSCompiler_renameProperty("selected",this),n,1):this.selected=this.selectedItem=null,t.delete(i)):n++})}__updateLinks(){if(this.__dataLinkedPaths={},this.multi){let e=0;this.__selectedMap.forEach(t=>{t>=0&&this.linkPaths(`${JSCompiler_renameProperty("items",this)}.${t}`,`${JSCompiler_renameProperty("selected",this)}.${e++}`)})}else this.__selectedMap.forEach(e=>{this.linkPaths(JSCompiler_renameProperty("selected",this),`${JSCompiler_renameProperty("items",this)}.${e}`),this.linkPaths(JSCompiler_renameProperty("selectedItem",this),`${JSCompiler_renameProperty("items",this)}.${e}`)})}clearSelection(){this.__dataLinkedPaths={},this.__selectedMap=new Map,this.selected=this.multi?[]:null,this.selectedItem=null}isSelected(e){return this.__selectedMap.has(e)}isIndexSelected(e){return this.isSelected(this.items[e])}__deselectChangedIdx(e){let t=this.__selectedIndexForItemIndex(e);if(t>=0){let e=0;this.__selectedMap.forEach((n,i)=>{t==e++&&this.deselect(i)})}}__selectedIndexForItemIndex(e){let t=this.__dataLinkedPaths[`${JSCompiler_renameProperty("items",this)}.${e}`];if(t)return parseInt(t.slice(`${JSCompiler_renameProperty("selected",this)}.`.length),10)}deselect(e){let t=this.__selectedMap.get(e);if(t>=0){let n;this.__selectedMap.delete(e),this.multi&&(n=this.__selectedIndexForItemIndex(t)),this.__updateLinks(),this.multi?this.splice(JSCompiler_renameProperty("selected",this),n,1):this.selected=this.selectedItem=null}}deselectIndex(e){this.deselect(this.items[e])}select(e){this.selectIndex(this.items.indexOf(e))}selectIndex(e){let t=this.items[e];this.isSelected(t)?this.toggle&&this.deselectIndex(e):(this.multi||this.__selectedMap.clear(),this.__selectedMap.set(t,e),this.__updateLinks(),this.multi?this.push(JSCompiler_renameProperty("selected",this),t):this.selected=this.selectedItem=t)}}}),ha=da(oa);class pa extends ha{static get is(){return"array-selector"}static get template(){return null}}customElements.define(pa.is,pa),
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Elements.ArraySelector"),Polymer.ArraySelectorMixin=da,Polymer.ArraySelector=pa;const ua=new nr;window.ShadyCSS||(window.ShadyCSS={prepareTemplate(e,t,n){},prepareTemplateDom(e,t){},prepareTemplateStyles(e,t,n){},styleSubtree(e,t){ua.processStyles(),Ns(e,t)},styleElement(e){ua.processStyles()},styleDocument(e){ua.processStyles(),Ns(document.body,e)},getComputedStyleValue:(e,t)=>Ls(e,t),flushCustomStyles(){},nativeCss:ds,nativeShadow:ss,cssBuild:as,disableRuntime:cs}),window.ShadyCSS.CustomStyleInterface=ua;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const ga=window.ShadyCSS.CustomStyleInterface;class ma extends HTMLElement{constructor(){super(),this._style=null,ga.addCustomStyle(this)}getStyle(){if(this._style)return this._style;const e=this.querySelector("style");if(!e)return null;this._style=e;const t=e.getAttribute("include");return t&&(e.removeAttribute("include"),e.textContent=Je(t)+e.textContent),this.ownerDocument!==window.document&&window.document.head.appendChild(this),this._style}}
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
let _a;window.customElements.define("custom-style",ma),
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Elements.CustomStyle"),Polymer.CustomStyle=ma,_a=xr._mutablePropertyChange;const fa={_shouldPropertyChange(e,t,n){return _a(this,e,t,n,!0)}},va={properties:{mutableData:Boolean},_shouldPropertyChange(e,t,n){return _a(this,e,t,n,this.mutableData)}};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
goog.declareModuleId("HtmlImportsNamespace.Polymer.Lib.Legacy.MutableDataBehavior"),Polymer.MutableDataBehavior=fa,Polymer.OptionalMutableDataBehavior=va;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const ya=dr(HTMLElement).prototype;
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/goog.declareModuleId("HtmlImportsNamespace.Polymer.Polymer");const ba=ya;Polymer.Base=ba;
/**
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
var wa=Element.prototype,Ca=wa.matches||wa.matchesSelector||wa.mozMatchesSelector||wa.msMatchesSelector||wa.oMatchesSelector||wa.webkitMatchesSelector;const Ea=new class{getTabbableNodes(e){var t=[];return this._collectTabbableNodes(e,t)?this._sortByTabIndex(t):t}isFocusable(e){return Ca.call(e,"input, select, textarea, button, object")?Ca.call(e,":not([disabled])"):Ca.call(e,"a[href], area[href], iframe, [tabindex], [contentEditable]")}isTabbable(e){return this.isFocusable(e)&&Ca.call(e,':not([tabindex="-1"])')&&this._isVisible(e)}_normalizedTabIndex(e){if(this.isFocusable(e)){var t=e.getAttribute("tabindex")||0;return Number(t)}return-1}_collectTabbableNodes(e,t){if(e.nodeType!==Node.ELEMENT_NODE)return!1;var n=e;if(!this._isVisible(n))return!1;var i,o=this._normalizedTabIndex(n),s=o>0;o>=0&&t.push(n),i="content"===n.localName||"slot"===n.localName?qo(n).getDistributedNodes():qo(n.root||n).children;for(var r=0;r<i.length;r++)s=this._collectTabbableNodes(i[r],t)||s;return s}_isVisible(e){var t=e.style;return"hidden"!==t.visibility&&"none"!==t.display&&("hidden"!==(t=window.getComputedStyle(e)).visibility&&"none"!==t.display)}_sortByTabIndex(e){var t=e.length;if(t<2)return e;var n=Math.ceil(t/2),i=this._sortByTabIndex(e.slice(0,n)),o=this._sortByTabIndex(e.slice(n));return this._mergeSortByTabIndex(i,o)}_mergeSortByTabIndex(e,t){for(var n=[];e.length>0&&t.length>0;)this._hasLowerTabOrder(e[0],t[0])?n.push(t.shift()):n.push(e.shift());return n.concat(e,t)}_hasLowerTabOrder(e,t){var n=Math.max(e.tabIndex,0),i=Math.max(t.tabIndex,0);return 0===n||0===i?i>n:n>i}};
/**
@license
Copyright (c) 2018 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function Sa(e){const t=window;t.HTMLImports?t.HTMLImports.whenReady(e):e()}function Aa(e,t,n,i=!1){let o=document.head.querySelector('link[href="'+e+'"][import-href]');o||(o=document.createElement("link"),o.setAttribute("rel","import"),o.setAttribute("href",e),o.setAttribute("import-href","")),i&&o.setAttribute("async","");const s=function(){o.removeEventListener("load",r),o.removeEventListener("error",a)},r=function(e){s(),o.__dynamicImportLoaded=!0,t&&Sa(()=>{t(e)})},a=function(e){s(),o.parentNode&&o.parentNode.removeChild(o),n&&Sa(()=>{n(e)})};return o.addEventListener("load",r),o.addEventListener("error",a),null===o.parentNode?document.head.appendChild(o):o.__dynamicImportLoaded&&o.dispatchEvent(new Event("load")),o}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var xa,Pa,Ra,Ta,Ia,ka,Oa,Na,La,Da,$a,Ma,Fa,Ba,ja,Ha,Ua,Ga,Va,za,Wa,qa,Ka,Ya,Xa,Ja,Za,Qa,el,tl,nl,il;Polymer.IronFocusablesHelper=Ea,goog.declareModuleId("HtmlImportsNamespace.IronOverlayBehavior.IronFocusablesHelper"),window.Polymer.importHref=Aa,function(){var e=this||self,t=function(t,n){t=t.split(".");var i,o=e;t[0]in o||void 0===o.execScript||o.execScript("var "+t[0]);for(;t.length&&(i=t.shift());)t.length||void 0===n?o=o[i]&&o[i]!==Object.prototype[i]?o[i]:o[i]={}:o[i]=n},n=function(e,t,n){return e.call.apply(e.bind,arguments)},i=function(e,t,n){if(!e)throw Error();if(2<arguments.length){var i=Array.prototype.slice.call(arguments,2);return function(){var n=Array.prototype.slice.call(arguments);return Array.prototype.unshift.apply(n,i),e.apply(t,n)}}return function(){return e.apply(t,arguments)}},o=function(e,t,s){return(o=Function.prototype.bind&&-1!=Function.prototype.bind.toString().indexOf("native code")?n:i).apply(null,arguments)},s={align:1,alt:1,"aria-activedescendant":10,"aria-atomic":1,"aria-autocomplete":1,"aria-busy":1,"aria-checked":1,"aria-disabled":1,"aria-dropeffect":1,"aria-expanded":1,"aria-haspopup":1,"aria-hidden":1,"aria-invalid":1,"aria-label":1,"aria-level":1,"aria-live":1,"aria-multiline":1,"aria-multiselectable":1,"aria-orientation":1,"aria-posinset":1,"aria-pressed":1,"aria-readonly":1,"aria-relevant":1,"aria-required":1,"aria-selected":1,"aria-setsize":1,"aria-sort":1,"aria-valuemax":1,"aria-valuemin":1,"aria-valuenow":1,"aria-valuetext":1,autocapitalize:1,autocomplete:1,autocorrect:1,autofocus:1,bgcolor:1,border:1,checked:1,class:1,color:1,cols:1,colspan:1,contenteditable:1,dir:8,disabled:1,draggable:1,enctype:1,face:1,for:10,formenctype:1,frameborder:1,height:1,hidden:1,href:4,hreflang:1,id:10,ismap:1,itemid:1,itemprop:1,itemref:1,itemscope:1,itemtype:1,label:1,lang:1,list:10,loop:1,max:1,maxlength:1,min:1,multiple:1,muted:1,name:10,placeholder:1,preload:1,rel:1,required:1,reversed:1,role:1,rows:1,rowspan:1,selected:1,shape:1,size:1,sizes:1,span:1,spellcheck:1,src:4,start:1,step:1,style:5,summary:1,tabindex:1,target:8,title:1,translate:1,valign:1,value:1,width:1,wrap:1},r={a:{href:[{c:3}]},area:{href:[{c:3}]},audio:{src:[{c:3}]},blockquote:{cite:[{c:3}]},button:{formaction:[{c:3}],formmethod:[{c:1}],type:[{c:1}]},command:{type:[{c:1}]},content:{select:[{c:1}]},del:{cite:[{c:3}]},details:{open:[{c:1}]},form:{action:[{c:3}],method:[{c:1}]},iframe:{srcdoc:[{c:2}]},img:{src:[{c:3}],srcset:[{c:11}]},input:{formaction:[{c:3}],formmethod:[{c:1}],pattern:[{c:1}],readonly:[{c:1}],src:[{c:3}],type:[{c:1}]},ins:{cite:[{c:3}]},li:{type:[{c:1}]},link:{href:[{c:3,f:"rel",g:"alternate"},{c:3,f:"rel",g:"author"},{c:3,f:"rel",g:"bookmark"},{c:3,f:"rel",g:"canonical"},{c:3,f:"rel",g:"cite"},{c:3,f:"rel",g:"help"},{c:3,f:"rel",g:"icon"},{c:3,f:"rel",g:"license"},{c:3,f:"rel",g:"next"},{c:3,f:"rel",g:"prefetch"},{c:3,f:"rel",g:"dns-prefetch"},{c:3,f:"rel",g:"prerender"},{c:3,f:"rel",g:"preconnect"},{c:3,f:"rel",g:"preload"},{c:3,f:"rel",g:"prev"},{c:3,f:"rel",g:"search"},{c:3,f:"rel",g:"subresource"}],media:[{c:1}],nonce:[{c:1}],type:[{c:1}]},menuitem:{icon:[{c:3}]},ol:{type:[{c:1}]},q:{cite:[{c:3}]},script:{nonce:[{c:1}],type:[{c:1}]},source:{media:[{c:1}],src:[{c:3}]},style:{media:[{c:1}],nonce:[{c:1}]},table:{cellpadding:[{c:1}],cellspacing:[{c:1}]},textarea:{readonly:[{c:1}]},time:{datetime:[{c:1}]},video:{autoplay:[{c:1}],controls:[{c:1}],poster:[{c:3}],src:[{c:3}]}},a={a:1,abbr:1,address:1,applet:4,area:5,article:1,aside:1,audio:1,b:1,base:4,bdi:1,bdo:1,blockquote:1,body:1,br:5,button:1,canvas:1,caption:1,cite:1,code:1,col:5,colgroup:1,command:1,content:1,data:1,datalist:1,dd:1,del:1,details:1,dfn:1,dialog:1,div:1,dl:1,dt:1,em:1,embed:4,fieldset:1,figcaption:1,figure:1,font:1,footer:1,form:1,frame:1,frameset:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,head:1,header:1,hr:5,html:1,i:1,iframe:1,img:5,input:5,ins:1,kbd:1,keygen:5,label:1,legend:1,li:1,link:5,main:1,map:1,mark:1,math:4,menu:1,menuitem:1,meta:4,meter:1,nav:1,noscript:1,object:4,ol:1,optgroup:1,option:1,output:1,p:1,param:5,picture:1,pre:1,progress:1,q:1,rb:1,rp:1,rt:1,rtc:1,ruby:1,s:1,samp:1,script:3,section:1,select:1,slot:1,small:1,source:5,span:1,strong:1,style:2,sub:1,summary:1,sup:1,svg:4,table:1,tbody:1,td:1,template:4,textarea:6,tfoot:1,th:1,thead:1,time:1,title:6,tr:1,track:5,u:1,ul:1,var:1,video:1,wbr:5},l=[{auto:!0,ltr:!0,rtl:!0},{_self:!0,_blank:!0}],c={"*":{dir:0,target:1}},d=function(){if(!u){var e=p,t={};for(n in e)t[n]=e[n];for(u=t,e=0,t=h.length;e<t;++e){var n=h[e];u[n.toLowerCase()]=n}}return u},h="aLink accessKey allowFullscreen bgColor cellPadding cellSpacing codeBase codeType contentEditable crossOrigin dateTime dirName formAction formEnctype formMethod formNoValidate formTarget frameBorder innerHTML innerText inputMode isMap longDesc marginHeight marginWidth maxLength mediaGroup minLength noHref noResize noShade noValidate noWrap nodeValue outerHTML outerText readOnly tabIndex textContent trueSpeed useMap vAlign vLink valueAsDate valueAsNumber valueType".split(" "),p={accept_charset:"acceptCharset",char:"ch",charoff:"chOff",checked:"defaultChecked",class:"className",for:"htmlFor",http_equiv:"httpEquiv",muted:"defaultMuted",selected:"defaultSelected",value:"defaultValue"},u=null,g=null,m={},_=!1,f=0,v=/^(?!(?:annotation-xml|color-profile|font-face|font-face(?:-(?:src|uri|format|name))?|missing-glyph)$)[a-z][a-z.0-9_\u00b7\u00c0-\u00d6\u00d8-\u00f6\u00f8-\u037d\u200c\u200d\u203f-\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\udfff\uf900-\ufdcf\ufdf0-\ufffd]*-[\-a-z.0-9_\u00b7\u00c0-\u00d6\u00d8-\u00f6\u00f8-\u037d\u200c\u200d\u203f-\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\udfff\uf900-\ufdcf\ufdf0-\ufffd]*$/,y=function(e,t){var n=window.customElements;if(_){for(var i=window.Polymer.telemetry.registrations,o=i.length,s=f;s<o;++s)m[i[s].is]=m;f=o}return n&&n.get(e)||m[e]===m?2:"HTMLUnknownElement"===t.name?1:"HTMLElement"===t.name&&v.test(e)?3:0},b=/(?!,)([^\t\n\f\r ]+)(?:[\t\n\f\r ]+([.0-9+\-]+[a-z]?))?/gi,w=/[\t\n\f\r ]+/,C=/[\t\n\f\r ,]+/g,E=function(e){return(e=e.split(w,2))?{url:e[0],metadata:e[1]}:null},S=function(e){var t=String(e.url).replace(C,encodeURIComponent);if(e=e.metadata){if(C.lastIndex=0,C.test(e))return null;t+=" "+e}return t},A=function(e,t,n){return n},x=function(e){function t(e){var t=this.getAttribute(e);return!t||/[\[\{]/.test(e)?null:t}var n=e.reportHandler||void 0,i=e.safeTypesBridge||A,h=/^$/;if(e=e.allowedIdentifierPrefixes)for(var p=0,u=e.length;p<u;++p)h=new RegExp(h.source+"|^"+String(e[p]).replace(/([-()\[\]{}+?*.$\^|,:#<!\\])/g,"\\$1").replace(/\x08/g,"\\x08"));n&&n(!1,"initResin");var m={},_=[,{h:null,j:function(e,t,n){return n},l:null,m:null},{h:null,j:null,l:null,m:"HTML"},{h:null,j:null,l:"about:invalid#zClosurez",m:"URL"},{h:null,j:null,l:"about:invalid#zClosurez",m:"RESOURCE_URL"},{h:null,j:null,l:"zClosurez",m:"STYLE"},,{h:null,j:null,l:" /*zClosurez*/ ",m:"JAVASCRIPT"},{h:null,j:function(e,t,n){n=String(n).toLowerCase();var i=null;return(e=c[e])&&(i=e[t]),(t=("number"==typeof i||((e=c["*"])&&(i=e[t]),"number"==typeof i))&&!0===l[i][String(n).toLowerCase()])?n:"zClosurez"},l:"zClosurez",m:null},{h:null,j:null,l:"zClosurez",m:"CONSTANT"},{h:null,j:function(e,t,n){return h.test(n)?n:"zClosurez"},l:"zClosurez",m:"CONSTANT"},{h:function(e,t,o){var s=o;if("string"==typeof s&&(s=(s=s.match(b))?s.map(E).filter(Boolean):[]),!Array.isArray(s))return"about:invalid#zClosurez";var r=s;s=[];var a=[],l={};if(Array.isArray(r))for(var c=0,d=r.length;c<d;++c){var h=r[c],p=h&&h.url;if(p){var u=i(p,"URL",l);if(u){var g=u!==l;(g?s:a).push({url:g?u:p,metadata:h.metadata})}}}else a.push(r);if(r=a.length?JSON.stringify(a):null,a=m,s.length){if(!Array.isArray(s))throw Error();a=s.map(S).filter(Boolean).join(" , ")||m}return r&&n&&n(!0,'Failed to sanitize attribute value of <%s>: <%s %s="%O">: %s',e,e,t,o,r),a===m?"about:invalid#zClosurez":a},j:null,l:null,m:null}],f={},v=document.createElement("polyresinuncustomized");return function(e,l,c,h){if(!h&&h!==document.all)return h;var p=e.nodeType;if(p!==Node.ELEMENT_NODE){if(p===Node.TEXT_NODE){if(l=!(p=e.parentElement),p&&p.nodeType===Node.ELEMENT_NODE){var u=p.localName;switch(y(u,p.constructor)){case 0:case 1:l=1===(p=Object.hasOwnProperty.call(a,u)?a[u]:null)||6===p;break;case 3:case 2:l=!0}}if(l)return""+i(h,"STRING",h)}return n&&n(!0,"Failed to sanitize %s %s%s node to value %O",e.parentElement&&e.parentElement.nodeName,"#text","",h),"zClosurez"}p=e.localName;var b=e.localName;if(e.getAttribute("is")||2!==y(b,e.constructor)){var w=f[b];w||(w=f[b]=document.createElement(b)),b=w}else b=v;switch(c){case"attribute":w=String(l).toLowerCase();var C=d()[w];if(("string"==typeof C?C:function(e){return String(e).replace(/\-([a-z])/g,(function(e,t){return t.toUpperCase()}))}(w))in b)break;return h;case"property":if(l in b)break;if(w=l.toLowerCase(),(w="string"==typeof(w=d()[w])?w:null)&&w in b)break;return h;default:throw Error(c+": "+typeof c)}if("attribute"==c)l=l.toLowerCase();else{if(!(c=g)){for(u in b={},c=d())b[c[u]]=u;c=g=b}l="string"==typeof(u=c[l])?u:String(l).replace(/([A-Z])/g,"-$1").toLowerCase()}e:{if(e=o(t,e),Object.hasOwnProperty.call(r,p)&&(u=r[p],Object.hasOwnProperty.call(u,l)&&(u=u[l])instanceof Array)){for(c=null,b=!1,w=0,C=u.length;w<C;++w){var E=u[w],S=E.f;if(!S){c=E.c;break e}if(null===c&&(c={}),(S=Object.hasOwnProperty.call(c,S)?c[S]:c[S]=e(S))===E.g){c=E.c;break e}null==S&&(b=!0)}if(b){c=null;break e}}c="number"==typeof(e=s[l])?e:null}return u=m,e=null,null!=c&&(b=(c=_[c]).m,e=c.l,b&&(u=i(h,b,m)),u===m&&(c.j?(u=""+i(h,"STRING",h),u=c.j(p,l,u)):c.h&&(u=c.h(p,l,h)),u===e&&(u=m))),u===m&&(u=e||"zClosurez",n&&n(!0,'Failed to sanitize attribute of <%s>: <%s %s="%O">',p,p,l,h)),u}};t("security.polymer_resin.install",(function(e){var t=x(e||{});if(/^1\./.test(Polymer.version)){_=!0;var n=Polymer.Base._computeFinalAnnotationValue;if(e=function(e,i,o,s){o=n.call(this,e,i,o,s);var r="property";return s&&s.propertyName?i=s.propertyName:r=s&&s.kind||"property",t(e,i,r,o)},Polymer.Base._computeFinalAnnotationValue=e,Polymer.Base._computeFinalAnnotationValue!==e)throw Error("Cannot replace _computeFinalAnnotationValue.  Is Polymer frozen?")}else{var i=Polymer.sanitizeDOMValue||Polymer.Settings&&Polymer.Settings.sanitizeDOMValue;if(e=function(e,n,o,s){return e=i?i.call(Polymer,e,n,o,s):e,s?t(s,n,o,e):"zClosurez"},Polymer.Settings&&Polymer.Settings.o)Polymer.Settings.o(e);else if(Polymer.sanitizeDOMValue=e,Polymer.sanitizeDOMValue!==e)throw Error("Cannot install sanitizeDOMValue.  Is Polymer frozen?")}})),t("security.polymer_resin.CONSOLE_LOGGING_REPORT_HANDLER",(function(e,t,n){for(var i=[t],o=2,s=arguments.length;o<s;++o)i[o-1]=arguments[o];e?console.warn.apply(console,i):console.log.apply(console,i)}))}.call(window),function(e){e.FILES="files",e.COMMENT_THREADS="comments",e.FINDINGS="findings"}(xa||(xa={})),function(e){e.CHANGE_LOG="_changeLog"}(Pa||(Pa={})),function(e){e.TAG_DELETE_REVIEWER="autogenerated:gerrit:deleteReviewer",e.TAG_NEW_PATCHSET="autogenerated:gerrit:newPatchSet",e.TAG_NEW_WIP_PATCHSET="autogenerated:gerrit:newWipPatchSet",e.TAG_REVIEWER_UPDATE="autogenerated:gerrit:reviewerUpdate",e.TAG_SET_PRIVATE="autogenerated:gerrit:setPrivate",e.TAG_UNSET_PRIVATE="autogenerated:gerrit:unsetPrivate",e.TAG_SET_READY="autogenerated:gerrit:setReadyForReview",e.TAG_SET_WIP="autogenerated:gerrit:setWorkInProgress",e.TAG_SET_ASSIGNEE="autogenerated:gerrit:setAssignee",e.TAG_UNSET_ASSIGNEE="autogenerated:gerrit:deleteAssignee"}(Ra||(Ra={})),function(e){e.KEEP_VISIBLE="keep-visible",e.NEVER="never"}(Ta||(Ta={})),function(e){e.ABANDONED="ABANDONED",e.MERGED="MERGED",e.NEW="NEW"}(Ia||(Ia={})),function(e){e.PATCHSET_LEVEL_COMMENTS="/PATCHSET_LEVEL",e.COMMIT_MESSAGE="/COMMIT_MSG",e.MERGE_LIST="/MERGE_LIST"}(ka||(ka={})),function(e){e.OK="OK",e.NOT_READY="NOT_READY",e.RULE_ERROR="RULE_ERROR"}(Oa||(Oa={})),function(e){e.REVIEWER="REVIEWER",e.CC="CC",e.REMOVED="REMOVED"}(Na||(Na={})),function(e){e.REWORK="REWORK",e.TRIVIAL_REBASE="TRIVIAL_REBASE",e.MERGE_FIRST_PARENT_UPDATE="MERGE_FIRST_PARENT_UPDATE",e.NO_CODE_CHANGE="NO_CODE_CHANGE",e.NO_CHANGE="NO_CHANGE"}(La||(La={})),function(e){e.FIXED="FIXED",e.FIX_FAILED="FIX_FAILED"}(Da||(Da={})),function(e){e.ADDED="A",e.DELETED="D",e.RENAMED="R",e.COPIED="C",e.REWRITTEN="W",e.UNMODIFIED="U"}($a||($a={})),function(e){e.BAD="BAD",e.OK="OK",e.TRUSTED="TRUSTED"}(Ma||(Ma={})),function(e){e.USERNAME="USERNAME",e.FIRST_NAME="FIRST_NAME",e.FULL_NAME="FULL_NAME"}(Fa||(Fa={})),function(e){e.ACTIVE="ACTIVE",e.READ_ONLY="READ_ONLY",e.HIDDEN="HIDDEN"}(Ba||(Ba={})),function(e){e.LEFT="left",e.RIGHT="right"}(ja||(ja={})),function(e){e.STRING="STRING",e.INT="INT",e.LONG="LONG",e.BOOLEAN="BOOLEAN",e.LIST="LIST",e.ARRAY="ARRAY"}(Ha||(Ha={})),function(e){e.MERGE_IF_NECESSARY="MERGE_IF_NECESSARY",e.FAST_FORWARD_ONLY="FAST_FORWARD_ONLY",e.REBASE_IF_NECESSARY="REBASE_IF_NECESSARY",e.REBASE_ALWAYS="REBASE_ALWAYS",e.MERGE_ALWAYS="MERGE_ALWAYS ",e.CHERRY_PICK="CHERRY_PICK",e.INHERIT="INHERIT"}(Ua||(Ua={})),function(e){e.TRUE="TRUE",e.FALSE="FALSE",e.INHERITED="INHERITED"}(Ga||(Ga={})),function(e){e.SERVICE_USER="SERVICE_USER"}(Va||(Va={})),function(e){e.ALLOW="ALLOW",e.DENY="DENY",e.BLOCK="BLOCK",e.INTERACTIVE="INTERACTIVE",e.BATCH="BATCH"}(za||(za={})),function(e){e.BATCH="BATCH",e.INTERACTIVE="INTERACTIVE"}(Wa||(Wa={})),function(e){e.HEAD="HEAD",e.POST="POST",e.GET="GET",e.DELETE="DELETE",e.PUT="PUT"}(qa||(qa={})),function(e){e.REVISION="REVISION",e.PARENT="PARENT"}(Ka||(Ka={})),function(e){e.DARK="DARK",e.LIGHT="LIGHT"}(Ya||(Ya={})),function(e){e.STD="STD",e.US="US",e.ISO="ISO",e.EURO="EURO",e.UK="UK"}(Xa||(Xa={})),function(e){e.HHMM_12="HHMM_12",e.HHMM_24="HHMM_24"}(Ja||(Ja={})),function(e){e.SIDE_BY_SIDE="SIDE_BY_SIDE",e.UNIFIED="UNIFIED_DIFF"}(Za||(Za={})),function(e){e.ENABLED="ENABLED",e.CC_ON_OWN_COMMENTS="CC_ON_OWN_COMMENTS",e.DISABLED="DISABLED"}(Qa||(Qa={})),function(e){e.AUTO_MERGE="AUTO_MERGE",e.FIRST_PARENT="FIRST_PARENT"}(el||(el={})),function(e){e.IGNORE_NONE="IGNORE_NONE",e.IGNORE_TRAILING="IGNORE_TRAILING",e.IGNORE_LEADING_AND_TRAILING="IGNORE_LEADING_AND_TRAILING",e.IGNORE_ALL="IGNORE_ALL"}(tl||(tl={})),function(e){e.PUBLISH="PUBLISH",e.PUBLISH_ALL_REVISIONS="PUBLISH_ALL_REVISIONS",e.KEEP="KEEP"}(nl||(nl={})),function(e){e.NONE="NONE",e.OWNER="OWNER",e.OWNER_REVIEWERS="OWNER_REVIEWERS",e.ALL="ALL"}(il||(il={}));function ol(e,t){return(null==t?void 0:t.name)?t.name:(null==t?void 0:t.username)?t.username:(null==t?void 0:t.email)?t.email:e&&e.user&&"Anonymous Coward"!==e.user.anonymous_coward_name?e.user.anonymous_coward_name:"Anonymous"}function sl(e,t,n=!1){var i;if(null==t?void 0:t.display_name)return t.display_name;if(!t||!t.name)return ol(e,t);const o=null===(i=null==e?void 0:e.accounts)||void 0===i?void 0:i.default_display_name;return n||o===Fa.FIRST_NAME?t.name.trim().split(" ")[0]:o===Fa.USERNAME&&t.username?t.username:t.name}function rl(e,t){return[ol(e,t),al(t.email),t.status?"("+t.status+")":""].filter(e=>e.length>0).join(" ")}function al(e){return void 0!==e?"<"+e+">":""}function ll(e){return(e.name||"")+" (group)"}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const cl=/[\uD800-\uDBFF][\uDC00-\uDFFF]/,dl={getLength(e){return this.getStringLength(e.textContent||"")},getStringLength:e=>e.replace(cl,"_").length,annotateWithElement(e,t,n,i){const o=i.tagName,s=i.attributes||{};let r;if(e instanceof Element)r=Array.from(e.childNodes);else{if(!(e instanceof Text))return;r=[e],e=e.parentNode}const a=[];for(let e of r){const i=this.getLength(e);if(t>0&&i<=t)t-=i;else if(t>0&&(e=this.splitNode(e,t),t=0),this.getLength(e)>n&&this.splitNode(e,n),a.push(e),!(n-=this.getLength(e)))break}const l=document.createElement(o),c=ge;for(let[e,t]of Object.entries(s))t&&(c&&(t=c(t,e,"attribute",l)),l.setAttribute(e,t));for(const t of a)e.replaceChild(l,t),l.appendChild(t)},annotateElement(e,t,n,i){const o=[].slice.apply(e.childNodes);let s,r;for(const e of o)if(s=this.getLength(e),s<=t)t-=s;else{if(r=Math.min(n,s-t),e instanceof Text?this._annotateText(e,t,r,i):e instanceof HTMLElement&&this.annotateElement(e,t,r,i),!(r<n))break;n-=r,t=0}},wrapInHighlight(e,t){let n;return e instanceof Text||"HL"!==e.tagName?(n=document.createElement("HL"),n.className=t,e.parentElement&&e.parentElement.replaceChild(n,e),n.appendChild(e)):(n=e,n.classList.add(t)),n},splitAndWrapInHighlight(e,t,n,i){return this.getLength(e)===t||0===t?this.wrapInHighlight(e,n):(i?this.splitNode(e,t):e=this.splitNode(e,t),this.wrapInHighlight(e,n))},splitNode(e,t){if(e instanceof Text)return this.splitTextNode(e,t);const n=e.cloneNode(!1);e.parentElement&&e.parentElement.insertBefore(n,e.nextSibling);let i=e.firstChild;for(;i&&(this.getLength(i)<=t||0===this.getLength(i));)t-=this.getLength(i),i=i.nextSibling;for(i&&this.getLength(i)>t&&n.appendChild(this.splitNode(i,t));i&&i.nextSibling;)n.appendChild(i.nextSibling);return n},splitTextNode(e,t){var n;if(null===(n=e.textContent)||void 0===n?void 0:n.match(cl)){const n=Array.from(e.textContent),i=n.splice(t),o=e.parentNode;e.textContent=n.join("");const s=document.createTextNode(i.join(""));return o&&o.insertBefore(s,e.nextSibling),s}return e.splitText(t)},_annotateText(e,t,n,i){const o=this.getLength(e);0===t&&o===n?this.wrapInHighlight(e,i):0===t?this.splitAndWrapInHighlight(e,n,i,!0):t+n===o?this.splitAndWrapInHighlight(e,t,i,!1):this.splitAndWrapInHighlight(this.splitTextNode(e,t),n,i,!0)}};
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class hl{constructor(e){this.element=e,this._promises=new Map}_getChangedEventName(e){return e.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()+"-changed"}_elementHasProperty(e){return void 0!==this.element[e]}_reportValue(e,t){try{e(t)}catch(e){console.info(e)}}bind(e,t){const n=this._getChangedEventName(e),i=e=>this._reportValue(t,e.detail.value);return this.element.addEventListener(n,i),this._elementHasProperty(e)&&this._reportValue(t,this.element[e]),()=>this.element.removeEventListener(n,i)}get(e){if(this._elementHasProperty(e))return Promise.resolve(this.element[e]);if(!this._promises.has(e)){let t;const n=new Promise(e=>t=e),i=this.bind(e,e=>{t(e),i()});this._promises.set(e,n)}return this._promises.get(e)}set(e,t){this.element[e]=t,this.element.dispatchEvent(new CustomEvent(this._getChangedEventName(e),{detail:{value:t}}))}}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const pl="FILE";var ul;!function(e){e.ADD="add",e.BOTH="both",e.BLANK="blank",e.REMOVE="remove"}(ul||(ul={}));class gl{constructor(e,t=0,n=0){this.type=e,this.beforeNumber=t,this.afterNumber=n,this.hasIntralineInfo=!1,this.highlights=[],this.text=""}}gl.Type=ul,gl.File=pl;const ml=new gl(ul.BLANK);
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */var _l;function fl(e,t){return t===ja.LEFT?e.left:e.right}function vl(e,t,n){if(0===e.length)return[];t=Math.max(t,0);let i=[],o=e,s=[];(n=Math.max(n,t))-t>1?(t&&([i,o]=yl(o,t)),n&&([o,s]=yl(o,n-t))):[o,s]=[[],o];const r=[...i];if(o.length){const e=new bl(_l.CONTEXT_CONTROL,[]);e.contextGroups=o,r.push(e)}return r.push(...s),r}function yl(e,t){if(0===e.length)return[[],[]];const n=(e[0].lineRange.left.start||0)+t,i=(e[0].lineRange.right.start||0)+t,o=[],s=[];for(const t of e){if((t.lineRange.left.end||0)<n||(t.lineRange.right.end||0)<i){o.push(t);continue}if(n<=(t.lineRange.left.start||0)||i<=(t.lineRange.right.start||0)){s.push(t);continue}const e=[],r=[];for(const o of t.lines)o.beforeNumber&&o.beforeNumber<n||o.afterNumber&&o.afterNumber<i?e.push(o):r.push(o);e.length&&o.push(e.length===t.lines.length?t:t.cloneWithLines(e)),r.length&&s.push(r.length===t.lines.length?t:t.cloneWithLines(r))}return[o,s]}!function(e){e.BOTH="both",e.CONTEXT_CONTROL="contextControl",e.DELTA="delta"}(_l||(_l={}));class bl{constructor(e,t=[]){this.type=e,this.dueToRebase=!1,this.dueToMove=!1,this.ignoredWhitespaceOnly=!1,this.keyLocation=!1,this.lines=[],this.adds=[],this.removes=[],this.contextGroups=[],this.lineRange={left:{start:null,end:null},right:{start:null,end:null}},t.forEach(e=>this.addLine(e))}cloneWithLines(e){const t=new bl(this.type,e);return t.dueToRebase=this.dueToRebase,t.ignoredWhitespaceOnly=this.ignoredWhitespaceOnly,t}addLine(e){if(this.lines.push(e),(this.type===_l.BOTH||this.type===_l.CONTEXT_CONTROL)&&(e.type===ul.ADD||e.type===ul.REMOVE))throw Error("Cannot add delta line to a non-delta group.");e.type===ul.ADD?this.adds.push(e):e.type===ul.REMOVE&&this.removes.push(e),this._updateRange(e)}getSideBySidePairs(){if(this.type===_l.BOTH||this.type===_l.CONTEXT_CONTROL)return this.lines.map(e=>({left:e,right:e}));const e=[];let t=0,n=0;for(;t<this.removes.length||n<this.adds.length;)e.push({left:this.removes[t]||ml,right:this.adds[n]||ml}),t++,n++;return e}_updateRange(e){"FILE"!==e.beforeNumber&&"FILE"!==e.afterNumber&&(e.type!==ul.ADD&&e.type!==ul.BOTH||((null===this.lineRange.right.start||e.afterNumber<this.lineRange.right.start)&&(this.lineRange.right.start=e.afterNumber),(null===this.lineRange.right.end||e.afterNumber>this.lineRange.right.end)&&(this.lineRange.right.end=e.afterNumber)),e.type!==ul.REMOVE&&e.type!==ul.BOTH||((null===this.lineRange.left.start||e.beforeNumber<this.lineRange.left.start)&&(this.lineRange.left.start=e.beforeNumber),(null===this.lineRange.left.end||e.beforeNumber>this.lineRange.left.end)&&(this.lineRange.left.end=e.beforeNumber)))}}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const wl=/\t|[\uD800-\uDBFF][\uDC00-\uDFFF]/;var Cl;!function(e){e.ABOVE="above",e.BELOW="below",e.ALL="all"}(Cl||(Cl={}));class El{constructor(e,t,n,i=[]){if(this.layers=i,this._diff=e,this._numLinesLeft=this._diff.content?this._diff.content.reduce((e,t)=>{const n=t.a||t.ab;return e+(n?n.length:0)},0):0,this._prefs=t,this._outputEl=n,this.groups=[],this._blameInfo=null,isNaN(t.tab_size)||t.tab_size<=0)throw Error("Invalid tab size from preferences.");if(isNaN(t.line_length)||t.line_length<=0)throw Error("Invalid line length from preferences.");this._layerUpdateListener=(e,t,n)=>this._handleLayerUpdate(e,t,n);for(const e of this.layers)e.addListener&&e.addListener(this._layerUpdateListener)}clear(){for(const e of this.layers)e.removeListener&&e.removeListener(this._layerUpdateListener)}emitGroup(e,t){const n=this.buildSectionElement(e);this._outputEl.insertBefore(n,t),e.element=n}getGroupsByLineRange(e,t,n){const i=[];for(let o=0;o<this.groups.length;o++){const s=this.groups[o];if(0===s.lines.length)continue;let r=0,a=0;if(n){const e=fl(s.lineRange,n);r=e.start||0,a=e.end||0}0===r&&(r=a),0===a&&(a=r),e<=a&&t>=r&&i.push(s)}return i}getContentTdByLine(e,t,n=this._outputEl){const i=t?`.${t}`:"";return n.querySelector(`td.lineNum[data-value="${e}"]${i} ~ td.content`)}getContentByLine(e,t,n){const i=this.getContentTdByLine(e,t,n);return i?i.querySelector(".contentText"):null}findLinesByRange(e,t,n,i,o){const s=this.getGroupsByLineRange(e,t,n);for(const r of s){let s=null;for(const a of r.lines){if("left"===n&&a.type===ul.ADD||"right"===n&&a.type===ul.REMOVE)continue;const l="left"===n?a.beforeNumber:a.afterNumber;l<e||l>t||(i&&i.push(a),o&&(s=s?this._getNextContentOnSide(s,n):this.getContentByLine(l,n,r.element),s&&o.push(s)))}}}_renderContentByRange(e,t,n){const i=[],o=[];let s,r;this.findLinesByRange(e,t,n,i,o);for(let e=0;e<i.length;e++){if(s=i[e],r=o[e],!r||!r.parentElement)continue;const t=this._getLineNumberEl(r,n);r.parentElement.replaceChild(this._createTextEl(t,s,n).firstChild,r)}}getSectionsByLineRange(e,t,n){return this.getGroupsByLineRange(e,t,n).map(e=>e.element)}_createContextControl(e,t){const n=t[0].lineRange.left.start,i=t[t.length-1].lineRange.left.end,o=i-n+1;0===o&&console.error("context group without lines");const s=this._createElement("td"),r=o>10;return r&&n>1&&s.appendChild(this._createContextButton(Cl.ABOVE,e,t,o)),s.appendChild(this._createContextButton(Cl.ALL,e,t,o)),r&&i<this._numLinesLeft&&s.appendChild(this._createContextButton(Cl.BELOW,e,t,o)),s}_createContextButton(e,t,n,i){const o=this._createElement("gr-button","showContext");o.setAttribute("link","true"),o.setAttribute("no-uppercase","true");let s="",r=[];if(e===El.ContextButtonType.ALL){const e=this._createElement("iron-icon","showContext");e.setAttribute("icon","gr-icons:unfold-more"),o.appendChild(e),s=`Show ${i} common line`,i>1&&(s+="s"),r.push(...n)}else e===El.ContextButtonType.ABOVE?(s="+10 above",r=vl(n,10,i)):e===El.ContextButtonType.BELOW&&(s="+10 below",r=vl(n,0,i-10));const a=this._createElement("span","showContext");return a.textContent=s,o.appendChild(a),o.addEventListener("tap",e=>{e.detail={groups:r,section:t,numLines:i}}),o}_createLineEl(e,t,n,i){const o=this._createElement("td");if(e.type===ul.BLANK)return o;if(e.type===ul.BOTH||e.type===n){if(this._decorateLineEl(o,t,i),o.classList.add("lineNum"),!1===this._prefs.show_file_comment_button&&"FILE"===t)return o;const n=this._createElement("button");o.appendChild(n),n.tabIndex=-1,this._decorateLineEl(n,t,i),n.classList.add("lineNumButton"),n.textContent="FILE"===t?"File":t.toString(),t>0&&(e.type===ul.REMOVE?n.setAttribute("aria-label",`${t} removed`):e.type===ul.ADD&&n.setAttribute("aria-label",`${t} added`))}return o}_decorateLineEl(e,t,n){e.classList.add(n),e.dataset.value=t.toString()}_createTextEl(e,t,n){const i=this._createElement("td");if(t.type!==ul.BLANK&&i.classList.add("content"),t.hasIntralineInfo||i.classList.add("no-intraline-info"),i.classList.add(t.type),"FILE"!==t.beforeNumber){const o=this._prefs.line_wrapping?1/0:this._prefs.line_length,s=this._formatText(t.text,this._prefs.tab_size,o);if(n&&s.setAttribute("data-side",n),e)for(const n of this.layers)"function"==typeof n.annotate&&n.annotate(s,e,t);else console.error("The lineNumberEl is null, skipping layer annotations.");i.appendChild(s)}else i.classList.add("file");return i}_formatText(e,t,n){const i=this._createElement("div","contentText");let o=0,s=0;for(const r of e.split(wl)){if(r){let e=0,t=n-o;for(;t<r.length;)i.appendChild(document.createTextNode(r.substring(e,t))),i.appendChild(this._createElement("span","br")),o=0,e=t,t+=n;i.appendChild(document.createTextNode(r.substring(e))),o+=r.length-e,s+=r.length}if(s<e.length)if(e.startsWith("\t",s)){let e=t-o%t;o+e>n&&(i.appendChild(this._createElement("span","br")),o=0,e=t),i.appendChild(this._getTabWrapper(e)),o+=e,s++}else o>=n&&(i.appendChild(this._createElement("span","br")),o=0),i.appendChild(document.createTextNode(e.substring(s,s+2))),s+=2,o+=1}return i}_getTabWrapper(e){const t=this._createElement("span","tab");return t.setAttribute("style",`tab-size: ${e}; -moz-tab-size: ${e};`),t.innerText="\t",t}_createElement(e,t){const n=document.createElement(e);if(n.classList.add("style-scope","gr-diff"),t)for(const e of t.split(" "))n.classList.add(e);return n}_handleLayerUpdate(e,t,n){this._renderContentByRange(e,t,n)}_isTotal(e){return!(e.type!==_l.DELTA||e.adds.length&&e.removes.length||!e.adds.length&&!e.removes.length)}setBlame(e){if(this._blameInfo=e,e)for(const t of e)for(const e of t.ranges)for(let n=e.start;n<=e.end;n++){const e=this._getBlameByLineNum(n);if(!e)continue;for(;e.hasChildNodes();)e.removeChild(e.lastChild);const i=this._getBlameForBaseLine(n,t);i&&e.appendChild(i)}}_buildMoveControls(e){const t=e.adds.length>0,{numberOfCells:n,movedOutIndex:i,movedInIndex:o}=this._getMoveControlsConfig();let s,r,a;t?(s="movedIn",a=o,r="Moved in"):(s="movedOut",a=i,r="Moved out");const l=document.createElement("tr"),c=[...Array(n).keys()].map(()=>document.createElement("td"));return l.classList.add("moveControls",s),c[a].classList.add("moveDescription"),c[a].textContent=r,c.forEach(e=>{l.appendChild(e)}),l}_getBlameByLineNum(e){return this._outputEl.querySelector(`td.blame[data-line-number="${e}"]`)}_getBlameCommitForBaseLine(e){if(!this._blameInfo)return null;for(const t of this._blameInfo)for(const n of t.ranges)if(n.start<=e&&n.end>=e)return t;return null}_getBlameForBaseLine(e,t=this._getBlameCommitForBaseLine(e)){if(!t)return null;const n=t.ranges.some(t=>t.start===e),i=new Date(1e3*t.time).toLocaleDateString(),o=this._createElement("span",n?"startOfRange":""),s=this._createElement("a","blameDate");s.innerText=`${i}`,s.setAttribute("href",`${j()}/q/${t.id}`),o.appendChild(s);const r=t.author.split(" ")[0],a=this._createElement("span","blameAuthor");a.innerText=` ${r}`,o.appendChild(a);const l=this._createElement("span","blameHoverCard");l.innerText=`Commit ${t.id}\nAuthor: ${t.author}\nDate: ${i}\n\n${t.commit_msg}`;const c=this._createElement("gr-hovercard");return c.appendChild(l),o.appendChild(c),o}_createBlameCell(e){const t=this._createElement("td","blame");if(t.setAttribute("data-line-number",e.toString()),e){const n=this._getBlameForBaseLine(e);n&&t.appendChild(n)}return t}_getLineNumberEl(e,t){let n=e;for(;n&&!n.classList.contains("diff-row");)n=n.parentElement;return n?n.querySelector(".lineNum."+t):null}}El.GroupType={ADDED:"b",BOTH:"ab",REMOVED:"a"},El.Highlights={ADDED:"edit_b",REMOVED:"edit_a"},El.ContextButtonType={ABOVE:"above",BELOW:"below",ALL:"all"};
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Sl extends El{constructor(e,t,n,i=[]){super(e,t,n,i),this.layers=i}_getMoveControlsConfig(){return{numberOfCells:4,movedOutIndex:1,movedInIndex:3}}buildSectionElement(e){const t=this._createElement("tbody","section");if(t.classList.add(e.type),this._isTotal(e)&&t.classList.add("total"),e.dueToRebase&&t.classList.add("dueToRebase"),e.dueToMove&&(t.classList.add("dueToMove"),t.appendChild(this._buildMoveControls(e))),e.ignoredWhitespaceOnly&&t.classList.add("ignoredWhitespaceOnly"),e.type===_l.CONTEXT_CONTROL)return t.appendChild(this._createContextRow(t,e.contextGroups)),t;const n=e.getSideBySidePairs();for(let e=0;e<n.length;e++)t.appendChild(this._createRow(n[e].left,n[e].right));return t}addColumns(e,t){const n=4*t,i=document.createElement("colgroup");let o=this._createElement("col","blame");i.appendChild(o),o=document.createElement("col"),o.setAttribute("width",n.toString()),i.appendChild(o),i.appendChild(document.createElement("col")),o=document.createElement("col"),o.setAttribute("width",n.toString()),i.appendChild(o),i.appendChild(document.createElement("col")),e.appendChild(i)}_createRow(e,t){const n=this._createElement("tr");return n.classList.add("diff-row","side-by-side"),n.setAttribute("left-type",e.type),n.setAttribute("right-type",t.type),n.tabIndex=-1,n.appendChild(this._createBlameCell(e.beforeNumber)),this._appendPair(n,e,e.beforeNumber,ja.LEFT),this._appendPair(n,t,t.afterNumber,ja.RIGHT),n}_appendPair(e,t,n,i){const o=this._createLineEl(t,n,t.type,i);e.appendChild(o),e.appendChild(this._createTextEl(o,t,i))}_createContextRow(e,t){const n=this._createElement("tr");return n.classList.add("diff-row","side-by-side"),n.setAttribute("left-type",_l.CONTEXT_CONTROL),n.setAttribute("right-type",_l.CONTEXT_CONTROL),n.tabIndex=-1,n.appendChild(this._createBlameCell(0)),n.appendChild(this._createElement("td","contextLineNum")),n.appendChild(this._createContextControl(e,t)),n.appendChild(this._createElement("td","contextLineNum")),n.appendChild(this._createContextControl(e,t)),n}_getNextContentOnSide(e,t){let n=e.parentElement.parentElement;for(;n=n.nextSibling;){const e=n.querySelector('td.content .contentText[data-side="'+t+'"]');if(e)return e}return null}}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const Al=/^image\/(bmp|gif|x-icon|jpeg|jpg|png|tiff|webp)$/;class xl extends Sl{constructor(e,t,n,i,o){super(e,t,n,[]),this._baseImage=i,this._revisionImage=o}renderDiff(){const e=this._createElement("tbody","image-diff");this._emitImagePair(e),this._emitImageLabels(e),this._outputEl.appendChild(e),this._outputEl.appendChild(this._createEndpoint())}_createEndpoint(){const e=this._createElement("tbody"),t=this._createElement("tr"),n=this._createElement("td");n.setAttribute("colspan","4");const i=this._createElement("gr-endpoint-decorator");return i.setAttribute("name","image-diff"),i.appendChild(this._createEndpointParam("baseImage",this._baseImage)),i.appendChild(this._createEndpointParam("revisionImage",this._revisionImage)),n.appendChild(i),t.appendChild(n),e.appendChild(t),e}_createEndpointParam(e,t){const n=this._createElement("gr-endpoint-param");return n.name=e,n.value=t,n}_emitImagePair(e){const t=this._createElement("tr");t.appendChild(this._createElement("td","left lineNum blank")),t.appendChild(this._createImageCell(this._baseImage,"left",e)),t.appendChild(this._createElement("td","right lineNum blank")),t.appendChild(this._createImageCell(this._revisionImage,"right",e)),e.appendChild(t)}_createImageCell(e,t,n){const i=this._createElement("td",t);if(e&&Al.test(e.type)){const o=this._createElement("img");o.onload=()=>{e._height=o.naturalHeight,e._width=o.naturalWidth,this._updateImageLabel(n,t,e)},o.setAttribute("src",`data:${e.type};base64, ${e.body}`),o.addEventListener("error",e=>{o.remove(),i.textContent="[Image failed to load] "+e.type}),i.appendChild(o)}return i}_updateImageLabel(e,t,n){const i=e.querySelector("."+t+" span.label");this._setLabelText(i,n)}_setLabelText(e,t){e.textContent=function(e){var t;if(e){const n=null!==(t=e.type)&&void 0!==t?t:e._expectedType;return e._width&&e._height?`${e._width}×${e._height} ${n}`:n}return"No image"}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */(t)}_emitImageLabels(e){var t,n,i,o;const s=this._createElement("tr");let r=!1;this._baseImage&&this._revisionImage&&this._baseImage._name!==this._revisionImage._name&&(r=!0),s.appendChild(this._createElement("td","left lineNum blank"));let a,l=this._createElement("td","left"),c=this._createElement("label"),d=this._createElement("span","label");r&&(a=this._createElement("span","name"),a.textContent=null!==(n=null===(t=this._baseImage)||void 0===t?void 0:t._name)&&void 0!==n?n:"",c.appendChild(a),c.appendChild(this._createElement("br"))),this._setLabelText(d,this._baseImage),c.appendChild(d),l.appendChild(c),s.appendChild(l),s.appendChild(this._createElement("td","right lineNum blank")),l=this._createElement("td","right"),c=this._createElement("label"),d=this._createElement("span","label"),r&&(a=this._createElement("span","name"),a.textContent=null!==(o=null===(i=this._revisionImage)||void 0===i?void 0:i._name)&&void 0!==o?o:"",c.appendChild(a),c.appendChild(this._createElement("br"))),this._setLabelText(d,this._revisionImage),c.appendChild(d),l.appendChild(c),s.appendChild(l),e.appendChild(s)}}class Pl extends El{constructor(e,t,n,i=[]){super(e,t,n,i),this.layers=i}_getMoveControlsConfig(){return{numberOfCells:3,movedOutIndex:2,movedInIndex:2}}buildSectionElement(e){const t=this._createElement("tbody","section");if(t.classList.add(e.type),this._isTotal(e)&&t.classList.add("total"),e.dueToRebase&&t.classList.add("dueToRebase"),e.dueToMove&&(t.classList.add("dueToMove"),t.appendChild(this._buildMoveControls(e))),e.ignoredWhitespaceOnly&&t.classList.add("ignoredWhitespaceOnly"),e.type===_l.CONTEXT_CONTROL)return t.appendChild(this._createContextRow(t,e.contextGroups)),t;for(let n=0;n<e.lines.length;++n){const i=e.lines[n];e.ignoredWhitespaceOnly&&i.type===ul.REMOVE||t.appendChild(this._createRow(i))}return t}addColumns(e,t){const n=4*t,i=document.createElement("colgroup");let o=this._createElement("col","blame");i.appendChild(o),o=document.createElement("col"),o.setAttribute("width",n.toString()),i.appendChild(o),o=document.createElement("col"),o.setAttribute("width",n.toString()),i.appendChild(o),i.appendChild(document.createElement("col")),e.appendChild(i)}_createRow(e){const t=this._createElement("tr",e.type);t.classList.add("diff-row","unified"),t.tabIndex=-1,t.appendChild(this._createBlameCell(e.beforeNumber));let n=this._createLineEl(e,e.beforeNumber,ul.REMOVE,ja.LEFT);return t.appendChild(n),n=this._createLineEl(e,e.afterNumber,ul.ADD,ja.RIGHT),t.appendChild(n),t.appendChild(this._createTextEl(n,e)),t}_createContextRow(e,t){const n=this._createElement("tr",_l.CONTEXT_CONTROL);return n.classList.add("diff-row","unified"),n.tabIndex=-1,n.appendChild(this._createBlameCell(0)),n.appendChild(this._createElement("td","contextLineNum")),n.appendChild(this._createElement("td","contextLineNum")),n.appendChild(this._createContextControl(e,t)),n}_getNextContentOnSide(e,t){let n=e.parentElement.parentElement;for(;n=n.nextSibling;)if(n.classList.contains("both")||"left"===t&&n.classList.contains("remove")||"right"===t&&n.classList.contains("add"))return n.querySelector(".contentText");return null}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class Rl extends Pl{constructor(e,t,n){super(e,t,n)}buildSectionElement(){const e=this._createElement("tbody","binary-diff"),t=new gl(ul.BOTH,"FILE","FILE"),n=this._createRow(t);return n.querySelector("td.both.file").textContent=" Difference in binary files",e.appendChild(n),e}}var Tl,Il;!function(e){e.CHANGE_ACTIONS="changeactions",e.REPLY_DIALOG="replydialog"}(Tl||(Tl={})),function(e){e.HISTORY="history",e.LABEL_CHANGE="labelchange",e.SHOW_CHANGE="showchange",e.SUBMIT_CHANGE="submitchange",e.SHOW_REVISION_ACTIONS="show-revision-actions",e.COMMIT_MSG_EDIT="commitmsgedit",e.COMMENT="comment",e.REVERT="revert",e.REVERT_SUBMISSION="revert_submission",e.POST_REVERT="postrevert",e.ANNOTATE_DIFF="annotatediff",e.ADMIN_MENU_LINKS="admin-menu-links",e.HIGHLIGHTJS_LOADED="highlightjs-loaded"}(Il||(Il={}));class kl{constructor(e,t){this.plugin=e,this.setEl(t)}setEl(e){e?(this._el=e,this.RevisionActions=e.RevisionActions,this.ChangeActions=e.ChangeActions,this.ActionType=e.ActionType):console.warn("changeActions() is not ready")}ensureEl(){if(!this._el){const e=document.createElement("gr-js-api-interface");this.setEl(e.getElement(Tl.CHANGE_ACTIONS))}return this._el}addPrimaryActionKey(e){const t=this.ensureEl();t.primaryActionKeys.includes(e)||t.push("primaryActionKeys",e)}removePrimaryActionKey(e){const t=this.ensureEl();t.primaryActionKeys=t.primaryActionKeys.filter(t=>t!==e)}hideQuickApproveAction(){this.ensureEl().hideQuickApproveAction()}setActionOverflow(e,t,n){return this.ensureEl().setActionOverflow(e,t,n)}setActionPriority(e,t,n){return this.ensureEl().setActionPriority(e,t,n)}setActionHidden(e,t,n){return this.ensureEl().setActionHidden(e,t,n)}add(e,t){return this.ensureEl().addActionButton(e,t)}remove(e){return this.ensureEl().removeActionButton(e)}addTapListener(e,t){this.ensureEl().addEventListener(e+"-tap",t)}removeTapListener(e,t){this.ensureEl().removeEventListener(e+"-tap",t)}setLabel(e,t){this.ensureEl().setActionButtonProp(e,"label",t)}setTitle(e,t){this.ensureEl().setActionButtonProp(e,"title",t)}setEnabled(e,t){this.ensureEl().setActionButtonProp(e,"enabled",t)}setIcon(e,t){this.ensureEl().setActionButtonProp(e,"icon",t)}getActionDetails(e){const t=this.ensureEl();return t.getActionDetails(e)||t.getActionDetails(this.plugin.getPluginName()+"~"+e)}}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class Ol{constructor(e,t){this.plugin=e,this.sharedApiElement=t}get _el(){return this.sharedApiElement.getElement(Tl.REPLY_DIALOG)}getLabelValue(e){return this._el.getLabelValue(e)}setLabelValue(e,t){this._el.setLabelValue(e,t)}send(e){this._el.send(e)}addReplyTextChangedCallback(e){const t=this.plugin.hook("reply-text"),n=t=>{e(t.detail.value)};t.onAttached(e=>{e.content&&e.content.addEventListener("value-changed",n)}),t.onDetached(e=>{e.content&&e.content.removeEventListener("value-changed",n)})}addLabelValuesChangedCallback(e){const t=this.plugin.hook("reply-label-scores"),n=t=>{e(t.detail)};t.onAttached(e=>{e.content&&e.content.addEventListener("labels-changed",n)}),t.onDetached(e=>{e.content&&e.content.removeEventListener("labels-changed",n)})}showMessage(e){return this._el.setPluginMessage(e)}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const Nl={Actions:{OPEN:{label:"Add/Open/Upload",id:"open"},DELETE:{label:"Delete",id:"delete"},RENAME:{label:"Rename",id:"rename"},RESTORE:{label:"Restore",id:"restore"}}};
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class Ll{constructor(e){this._plugin=e,this._hooks={}}_getHookName(e,t){if(t)return e+" "+t;return(this._plugin.getPluginName()||"unknown_plugin").toLowerCase()+"-autogenerated-"+e}getDomHook(e,t){const n=this._getHookName(e,t);return this._hooks[n]||(this._hooks[n]=new Dl(n,t)),this._hooks[n]}}class Dl{constructor(e,t){this._instances=[],this._attachCallbacks=[],this._detachCallbacks=[],this._lastAttachedPromise=null,t?this._moduleName=t:(this._moduleName=e,this._createPlaceholder(e))}_createPlaceholder(e){class t extends oa{static get is(){return e}static get properties(){return{plugin:Object,content:Object}}}customElements.define(t.is,t)}handleInstanceDetached(e){const t=this._instances.indexOf(e);-1!==t&&this._instances.splice(t,1),this._detachCallbacks.forEach(t=>t(e))}handleInstanceAttached(e){this._instances.push(e),this._attachCallbacks.forEach(t=>t(e))}getLastAttached(){if(this._instances.length)return Promise.resolve(this._instances.slice(-1)[0]);if(!this._lastAttachedPromise){let e;const t=new Promise(t=>{e=t,this._attachCallbacks.push(e)});this._lastAttachedPromise=t.then(t=>{this._lastAttachedPromise=null;const n=this._attachCallbacks.indexOf(e);return-1!==n&&this._attachCallbacks.splice(n,1),t})}return this._lastAttachedPromise}getAllAttached(){return this._instances}onAttached(e){return this._attachCallbacks.push(e),this}onDetached(e){return this._detachCallbacks.push(e),this}getModuleName(){return this._moduleName}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class $l{constructor(){this._etags=new Map,this._payloadCache=new Map}getOptions(e,t){const n=this._etags.get(e);if(!n)return t;const i={...t};return i.headers=i.headers||new Headers,i.headers.set("If-None-Match",n),i}collect(e,t,n){if(!t||!t.ok||200!==t.status)return;this._payloadCache.set(e,n);const i=t.headers&&t.headers.get("etag");i?(this._etags.set(e,i),this._truncateCache()):this._etags.delete(e)}getCachedPayload(e){return this._payloadCache.get(e)}_truncateCache(){for(const e of this._etags.keys()){if(this._etags.size<=30)break;this._etags.delete(e),this._payloadCache.delete(e)}}}
/**
 * @license
 * Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
 * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
 * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
 * Google as part of the polymer project is also subject to an additional IP
 * rights grant found at http://polymer.github.io/PATENTS.txt
 */function Ml(e){return t=>{if(e)if(t.hasOwnProperty("is")){if(e!==t.is)throw new Error("custom element tag names do not match: "+`(${e} !== ${t.is})`)}else Object.defineProperty(t,"is",{value:e});window.customElements.define(t.is,t)}}function Fl(e,t,n){e.constructor.hasOwnProperty("properties")||Object.defineProperty(e.constructor,"properties",{value:{}}),e.constructor.properties[t]=Object.assign({},e.constructor.properties[t],n)}function Bl(e){return(t,n)=>{Fl(t,n,e)}}function jl(...e){return(t,n)=>{t.constructor.hasOwnProperty("observers")||Object.defineProperty(t.constructor,"observers",{value:[]}),t.constructor.observers.push(`${n}(${e.join(",")})`)}}function Hl(e,...t){return(n,i,o)=>{const s=`__compute${i}`;Object.defineProperty(n,s,{value:o.get}),o.get=void 0,Fl(n,i,{computed:`${s}(${[e,...t].join(",")})`})}}Ul((e,t)=>e.querySelector(t)),Ul((e,t)=>e.querySelectorAll(t));function Ul(e){return t=>(n,i)=>{Object.defineProperty(n,i,{get(){return e(this.shadowRoot,t)},enumerable:!0,configurable:!0})}}var Gl=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Vl=class extends oa{constructor(){super(...arguments),this.logoUrl="",this.title=""}static get template(){return ta`
      <style>
        img {
          width: 1em;
          height: 1em;
          vertical-align: middle;
        }
        .title {
          margin-left: var(--spacing-xs);
        }
      </style>
      <span>
        <img src="[[logoUrl]]" hidden$="[[!logoUrl]]" />
        <span class="title">[[title]]</span>
      </span>
    `}};Gl([Bl({type:String})],Vl.prototype,"logoUrl",void 0),Gl([Bl({type:String})],Vl.prototype,"title",void 0),Vl=Gl([Ml("gr-custom-plugin-header")],Vl);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class zl{constructor(e){this.plugin=e}setHeaderLogoAndTitle(e,t){this.plugin.hook("header-title",{replace:!0}).onAttached(n=>{const i=document.createElement("gr-custom-plugin-header");i.logoUrl=e,i.title=t,n.appendChild(i)})}}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class Wl{constructor(){this._data=new Map,window.INITIAL_DATA&&Object.entries(window.INITIAL_DATA).forEach(e=>this._cache().set(e[0],e[1]))}_cache(){return this._data.has(window.CANONICAL_PATH)||this._data.set(window.CANONICAL_PATH,new Map),this._data.get(window.CANONICAL_PATH)}has(e){return this._cache().has(e)}get(e){return this._cache().get(e)}set(e,t){this._cache().set(e,t)}delete(e){this._cache().delete(e)}invalidatePrefix(e){const t=new Map;for(const[n,i]of this._cache().entries())n.startsWith(e)||t.set(n,i);this._data.set(window.CANONICAL_PATH,t)}}class ql{constructor(){this._data={}}testOnlyGetData(){return this._data}has(e){return!!this._data[e]}get(e){return this._data[e]}set(e,t){this._data[e]=t}invalidatePrefix(e){const t={};Object.entries(this._data).forEach(([n,i])=>{n.startsWith(e)||(t[n]=i)}),this._data=t}}class Kl{constructor(e,t,n,i){this._cache=e,this._auth=t,this._fetchPromisesCache=n,this._restApiInterface=i}fetch(e){const t=Date.now(),n=this._auth.fetch(e.url,e.fetchOptions);return n.then(n=>this._logCall(e,t,n?n.status:null)),n}_logCall(e,t,n){const i=e.fetchOptions&&e.fetchOptions.method?e.fetchOptions.method:"GET",o=Date.now(),s=o-t,r=new Date(t),a=new Date(o);console.info(["HTTP",n,i,`${s}ms`,e.anonymizedUrl||e.url,`(${r.toISOString()}, ${a.toISOString()})`].join(" ")),e.anonymizedUrl&&this.dispatchEvent(new CustomEvent("rpc-log",{detail:{status:n,method:i,elapsed:s,anonymizedUrl:e.anonymizedUrl},composed:!0,bubbles:!0}))}fetchRawJSON(e){const t=this.urlWithParams(e.url,e.params),n={url:t,fetchOptions:e.fetchOptions,anonymizedUrl:e.reportUrlAsIs?t:e.anonymizedUrl};return this.fetch(n).then(t=>{if(!e.cancelCondition||!e.cancelCondition())return t;t.body&&t.body.cancel()}).catch(t=>{throw e.errFn?e.errFn.call(void 0,null,t):this.dispatchEvent(new CustomEvent("network-error",{detail:{error:t},composed:!0,bubbles:!0})),t})}fetchJSON(e,t){return t||(e=this.addAcceptJsonHeader(e)),this.fetchRawJSON(e).then(t=>{if(t)return t.ok?this.getResponseObject(t):e.errFn?void e.errFn.call(null,t):void this.dispatchEvent(new CustomEvent("server-error",{detail:{request:e,response:t},composed:!0,bubbles:!0}))})}urlWithParams(e,t){if(!t)return j()+e;const n=[];for(const e in t){if(!o(t,e))continue;const i=t[e];if(null==i){n.push(this.encodeRFC5987(e));continue}const s=[].concat(i);for(const t of s)n.push(`${this.encodeRFC5987(e)}=${this.encodeRFC5987(t)}`)}return j()+e+"?"+n.join("&")}encodeRFC5987(e){return encodeURIComponent(e).replace(/['()*]/g,e=>"%"+e.charCodeAt(0).toString(16))}getResponseObject(e){return this.readResponsePayload(e).then(e=>e.parsed)}readResponsePayload(e){return e.text().then(e=>{let t;try{t=this.parsePrefixedJSON(e)}catch(e){t=null}return{parsed:t,raw:e}})}parsePrefixedJSON(e){return JSON.parse(e.substring(")]}'".length))}addAcceptJsonHeader(e){return e.fetchOptions||(e.fetchOptions={}),e.fetchOptions.headers||(e.fetchOptions.headers=new Headers),e.fetchOptions.headers.has("Accept")||e.fetchOptions.headers.append("Accept","application/json"),e}dispatchEvent(e,t){return this._restApiInterface.dispatchEvent(e,t)}fetchCacheURL(e){return this._fetchPromisesCache.has(e.url)?this._fetchPromisesCache.get(e.url):this._cache.has(e.url)?Promise.resolve(this._cache.get(e.url)):(this._fetchPromisesCache.set(e.url,this.fetchJSON(e).then(t=>(void 0!==t&&this._cache.set(e.url,t),this._fetchPromisesCache.set(e.url,void 0),t)).catch(t=>{throw this._fetchPromisesCache.set(e.url,void 0),t})),this._fetchPromisesCache.get(e.url))}send(e){const t={method:e.method};if(e.body&&(t.headers=new Headers,t.headers.set("Content-Type",e.contentType||"application/json"),t.body="string"==typeof e.body?e.body:JSON.stringify(e.body)),e.headers){t.headers||(t.headers=new Headers);for(const n in e.headers)o(e.headers,n)&&t.headers.set(n,e.headers[n])}const n=e.url.startsWith("http")?e.url:j()+e.url,i={url:n,fetchOptions:t,anonymizedUrl:e.reportUrlAsIs?n:e.anonymizedUrl},s=this.fetch(i).then(t=>{if(!t.ok){if(e.errFn)return void e.errFn.call(void 0,t);this.dispatchEvent(new CustomEvent("server-error",{detail:{request:i,response:t},composed:!0,bubbles:!0}))}return t}).catch(t=>{if(this.dispatchEvent(new CustomEvent("network-error",{detail:{error:t},composed:!0,bubbles:!0})),e.errFn)return e.errFn.call(void 0,null,t);throw t});return e.parseResponse?s.then(e=>this.getResponseObject(e)):s}invalidateFetchPromisesPrefix(e){this._fetchPromisesCache.invalidatePrefix(e),this._cache.invalidatePrefix(e)}}
/**
 * @license
 * Copyright (c) 2009 "Cowboy" Ben Alman
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
/*!
 * JavaScript Linkify - v0.3 - 6/27/2009
 * http://benalman.com/projects/javascript-linkify/
 * 
 * Copyright (c) 2009 "Cowboy" Ben Alman
 * Dual licensed under the MIT and GPL licenses.
 * http://benalman.com/about/license/
 * 
 * Some regexps adapted from http://userscripts.org/scripts/review/7122
 */var Yl,Xl,Jl,Zl;window.linkify=(Yl=new RegExp("(?:(?:mailto:)?[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:(?:(?:[^\\s!@#$%^&*()_=+[\\]{}\\\\|;:'\",.<>/?]+)\\.)+(?:ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)|(?:(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5]))(?:\\?[^#<>\\s]*)?(?:#[^<>\\s]*)?(?!\\w)|\\b[a-z\\d.-]+://[^<>\\s]+|\\b(?:(?:(?:[^\\s!@#$%^&*()_=+[\\]{}\\\\|;:'\",.<>/?]+)\\.)+(?:ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)|(?:(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5]))(?:[;/][^#?<>\\s]*)?(?:\\?[^#<>\\s]*)?(?:#[^<>\\s]*)?(?!\\w))","ig"),Xl=new RegExp("^[a-z\\d.-]+://","i"),Jl={"'":"`",">":"<",")":"(","]":"[","}":"{","»":"«","›":"‹"},Zl={callback:function(e,t){return t?'<a href="'+t+'" title="'+t+'">'+e+"</a>":e},punct_regexp:/(?:[!?.,:;'"]|(?:&|&amp;)(?:lt|gt|quot|apos|raquo|laquo|rsaquo|lsaquo);)$/},function(e,t){t=t||{};var n,i,o,s,r,a,l,c,d,h,p,u,g="",m=[];for(i in Zl)void 0===t[i]&&(t[i]=Zl[i]);for(;n=Yl.exec(e);)if(o=n[0],l=(a=Yl.lastIndex)-o.length,!/[\/:]/.test(e.charAt(l-1))){do{c=o,u=o.substr(-1),(p=Jl[u])&&(d=o.match(new RegExp("\\"+p+"(?!$)","g")),h=o.match(new RegExp("\\"+u,"g")),(d?d.length:0)<(h?h.length:0)&&(o=o.substr(0,o.length-1),a--)),t.punct_regexp&&(o=o.replace(t.punct_regexp,(function(e){return a-=e.length,""})))}while(o.length&&o!==c);s=o,Xl.test(s)||(s=(-1!==s.indexOf("@")?s.indexOf("mailto:")?"mailto:":"":s.indexOf("irc.")?s.indexOf("ftp.")?"http://":"ftp://":"irc://")+s),r!=l&&(m.push([e.slice(r,l)]),r=a),m.push([o,s])}for(m.push([e.substr(r)]),i=0;i<m.length;i++)g+=t.callback.apply(window,m[i]);return g||e});
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ql=/^(.*)(https?:\/\/|mailto:)/;class ec{constructor(e,t,n){this.linkConfig=e,this.callback=t,this.removeZeroWidthSpace=n,this.baseUrl=j(),Object.preventExtensions(this)}addText(e,t){e&&this.callback(e,t)}processLinks(e,t){this.sortArrayReverse(t);const n=document.createDocumentFragment();let i=e.length;t.forEach(t=>{t.position+t.length!==i&&n.insertBefore(document.createTextNode(e.slice(t.position+t.length,i)),n.firstChild),n.insertBefore(t.html,n.firstChild),i=t.position}),0!==i&&n.insertBefore(document.createTextNode(e.slice(0,i)),n.firstChild),this.callback(null,null,n)}sortArrayReverse(e){e.sort((e,t)=>t.position-e.position)}addItem(e,t,n,i,o,s){if(t){const n=document.createElement("a");n.setAttribute("href",t),n.textContent=e,n.target="_blank",n.rel="noopener",s.push({html:n,position:i,length:o})}else if(n){const e=document.createDocumentFragment(),t=document.createElement("div");for(t.innerHTML=n;t.firstChild;)e.appendChild(t.firstChild);s.push({html:e,position:i,length:o})}}addLink(e,t,n,i,o){e&&!this.hasOverlap(n,i,o)&&(this.baseUrl&&t.startsWith("/")&&!t.startsWith(this.baseUrl)&&(t=this.baseUrl+t),this.addItem(e,t,null,n,i,o))}addHTML(e,t,n,i){this.hasOverlap(t,n,i)||(this.baseUrl&&e.match(/<a href="\//g)&&!new RegExp(`<a href="${this.baseUrl}`,"g").test(e)&&(e=e.replace(/<a href="\//g,`<a href="${this.baseUrl}/`)),this.addItem(null,null,e,t,n,i))}hasOverlap(e,t,n){const i=e+t;for(let t=0;t<n.length;t++){const o=n[t].position,s=n[t].position+n[t].length;if(e>=o&&e<s||i>o&&i<=s||e===o&&e===s)return!0}return!1}parse(e){e&&window.linkify(e,{callback:(e,t)=>this.parseChunk(e,t)})}parseChunk(e,t){if(this.removeZeroWidthSpace&&(e=e.replace(/^(CC|R)=\u200B/gm,"$1=")),t){const n=Ql.exec(t);if(n){const i=n[1];return i.length>0&&(this.parseLinks(i,{}),e=e.substring(i.length),t=t.substring(i.length)),void this.addText(e,t)}}this.parseLinks(e,this.linkConfig)}parseLinks(e,t){const n=[];for(const i in t){if(null!=t[i].enabled&&0==t[i].enabled)continue;const o=t[i].html,s=t[i].link;o?t[i].html=o.replace(/<a href="#\//g,'<a href="/'):s&&"#"===s[0]&&(t[i].link=s.substr(1));const r=new RegExp(t[i].match,"g");let a,l=e,c=0;for(;a=r.exec(l);){l=l.substr(a.index+a[0].length);let e=a[0].replace(r,t[i].html||t[i].link);if(t[i].html){let t;for(t=0;t<e.length&&e[t]===a[0][t];t++);e=e.slice(t),this.addHTML(e,c+a.index+t,a[0].length-t,n)}else{if(!t[i].link)throw Error("linkconfig entry "+i+" doesn’t contain a link or html attribute.");this.addLink(a[0],e,c+a.index,a[0].length,n)}c=c+a.index+a[0].length}}this.processLinks(e,n)}}function tc(e){return void 0!==e}var nc,ic;!function(e){e.COVERED="COVERED",e.NOT_COVERED="NOT_COVERED",e.PARTIALLY_COVERED="PARTIALLY_COVERED",e.NOT_INSTRUMENTED="NOT_INSTRUMENTED"}(nc||(nc={})),function(e){e.AUTH="AUTH",e.NETWORK="NETWORK",e.GENERIC="GENERIC"}(ic||(ic={}));
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class oc{constructor(){this._endpoints=new Map,this._callbacks=new Map,this._dynamicPlugins=new Map,this._importedUrls=new Set,this._pluginLoaded=!1}setPluginsReady(){this._pluginLoaded=!0}onNewEndpoint(e,t){this._callbacks.has(e)||this._callbacks.set(e,[]),this._callbacks.get(e).push(t)}onDetachedEndpoint(e,t){if(this._callbacks.has(e)){const n=this._callbacks.get(e).filter(e=>e!==t);this._callbacks.set(e,n)}}_getOrCreateModuleInfo(e,t){const{endpoint:n,slot:i,type:o,moduleName:s,domHook:r}=t,a=this._endpoints.get(n).find(t=>t.plugin===e&&t.moduleName===s&&t.domHook===r&&t.slot===i);if(a)return a;{const t={moduleName:s,plugin:e,pluginUrl:e._url,type:o,domHook:r,slot:i};return this._endpoints.get(n).push(t),t}}registerModule(e,t){const n=t.endpoint,i=t.dynamicEndpoint;i&&(this._dynamicPlugins.has(i)||this._dynamicPlugins.set(i,new Set),this._dynamicPlugins.get(i).add(n)),this._endpoints.has(n)||this._endpoints.set(n,[]);const o=this._getOrCreateModuleInfo(e,t);this._pluginLoaded&&this._callbacks.has(n)&&this._callbacks.get(n).forEach(e=>e(o))}getDynamicEndpoints(e){const t=this._dynamicPlugins.get(e);return t?Array.from(t):[]}getDetails(e,t){const n=t&&t.type,i=t&&t.moduleName;return this._endpoints.has(e)?this._endpoints.get(e).filter(e=>!(n&&e.type!==n||i&&i!==e.moduleName)):[]}getModules(e,t){const n=this.getDetails(e,t);return n.length?n.map(e=>e.moduleName):[]}getPlugins(e,t){const n=this.getDetails(e,t);return n.length?Array.from(new Set(n.map(e=>e.pluginUrl))).filter(tc):[]}importUrl(e){let t;return Promise.race([new Promise((t,n)=>{this._importedUrls.add(e.href),Aa(e.href,t,n)}),new Promise(e=>t=setTimeout(e,3e3))]).finally(()=>{t&&clearTimeout(t)})}getAndImportPlugins(e,t){return Promise.all(this.getPlugins(e,t).map(e=>this._importedUrls.has(e.href)?Promise.resolve():(null==e?void 0:e.pathname.endsWith(".html"))?this.importUrl(e):Promise.resolve()))}}let sc=new oc;function rc(){return sc}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ac=864e5;function lc(e){return new Date(e.replace(" ","T")+"Z")}function cc(e){return e instanceof Date&&!isNaN(e.valueOf())}function dc(e,t){const n={};t.includes("MM")&&(t.includes("MMM")?n.month="short":n.month="2-digit"),t.includes("YY")&&(t.includes("YYYY")?n.year="numeric":n.year="2-digit"),t.includes("DD")&&(n.day="2-digit"),t.includes("HH")&&(n.hour="2-digit",n.hour12=!1),t.includes("h")&&(n.hour="numeric",n.hour12=!0),t.includes("mm")&&(n.minute="2-digit"),t.includes("ss")&&(n.second="2-digit");let i="en-US";t.includes("HH")&&(i="en-GB");const o=new Intl.DateTimeFormat(i,n).formatToParts(e).filter(e=>"literal"!==e.type).reduce((e,t)=>(e[t.type]=t.value,e),{});return t.includes("YY")&&(t=t.includes("YYYY")?t.replace("YYYY",o.year):t.replace("YY",o.year)),t.includes("DD")&&(t=t.replace("DD",o.day)),t.includes("HH")&&(t=t.replace("HH",o.hour)),t.includes("h")&&(t=t.replace("h",o.hour)),t.includes("mm")&&(t=t.replace("mm",o.minute)),t.includes("ss")&&(t=t.replace("ss",o.second)),t.includes("A")&&(t=o.dayperiod?t.replace("A",o.dayperiod.toUpperCase()):t.replace("A",o.dayPeriod.toUpperCase())),t.includes("MM")&&(t=t.includes("MMM")?t.replace("MMM",o.month):t.replace("MM",o.month)),t}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function hc(e){if(e._account_id)return e._account_id;if(e.email)return e.email;throw new Error("Account has neither _account_id nor email.")}function pc(e){var t;return!!(null===(t=null==e?void 0:e.tags)||void 0===t?void 0:t.includes(Va.SERVICE_USER))}function uc(e){return(null==e?void 0:e.filter(e=>!pc(e)))||[]}function gc(e,t,n){var i;return function(e){var t;return!!(null===(t=null==e?void 0:e.change)||void 0===t?void 0:t.enable_attention_set)}(e)&&function(e){return!!e&&!!e._account_id&&!pc(e)}(t)&&!!t._account_id&&!!(null===(i=null==n?void 0:n.attention_set)||void 0===i?void 0:i.hasOwnProperty(t._account_id))}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */function mc(e){return!(!e.updates||!e.updates.length)}class _c{constructor(e){this._batch=null,this._updateItems=null,this._lastState={},this.result={...e}}_filterRemovedMessages(){this.result.messages=this.result.messages.filter(e=>e.tag!==Ra.TAG_DELETE_REVIEWER)}_startBatch(e){return this._updateItems={},{author:e.updated_by,date:e.updated,type:"REVIEWER_UPDATE",tag:Ra.TAG_REVIEWER_UPDATE}}_completeBatch(e){const t=[];for(const e in this._updateItems){if(!o(this._updateItems,e))continue;const n=this._updateItems[e];this._lastState[e]!==n.state&&(this._lastState[e]=n.state,t.push(n))}t.length&&(e.updates=t)}_groupUpdates(){const e=this.result.reviewer_updates.reduce((e,t)=>{this._batch||(this._batch=this._startBatch(t));const n=lc(t.updated).getTime(),i=lc(this._batch.date).getTime(),o=hc(t.reviewer);(n-i>6e3||t.updated_by._account_id!==this._batch.author._account_id)&&(this._completeBatch(this._batch),mc(this._batch)&&e.push(this._batch),this._batch=this._startBatch(t));const s=this._updateItems;return s[o]={reviewer:t.reviewer,state:t.state},this._lastState[o]&&(s[o].prev_state=this._lastState[o]),e},[]),t=this._batch;return this._completeBatch(t),mc(t)&&e.push(t),this.result.reviewer_updates=e,e}_getUpdateMessage(e,t){return"REMOVED"!==e&&e?"REMOVED"===t?e?`Removed from ${e.toLowerCase()}: `:"Removed : ":`Moved from ${e.toLowerCase()} to ${t.toLowerCase()}: `:`Added to ${t.toLowerCase()}: `}_groupUpdatesByMessage(e){return e.reduce((e,t)=>{const n=this._getUpdateMessage(t.prev_state,t.state);return e[n]||(e[n]=[]),e[n].push(t.reviewer),e},{})}_formatUpdates(){const e=this.result.reviewer_updates;for(const t of e){const e=this._groupUpdatesByMessage(t.updates),n=[];for(const t in e)o(e,t)&&n.push({message:t,reviewers:e[t]});t.updates=n}}_advanceUpdates(){const e=this.result.reviewer_updates,t=this.result.messages;t.forEach((n,i)=>{const o=lc(n.date).getTime(),s=i===t.length-1?null:lc(t[i+1].date).getTime();for(const t of e){const e=lc(t.date).getTime();if(e>=o&&(!s||e<s)){const e=lc(t.date).getTime()-500;t.date=new Date(e).toISOString().replace("T"," ").replace("Z","000000")}if(s&&e>s)break}})}static parse(e){if(!e||!function(e){return!!(e.messages&&e.reviewer_updates&&e.reviewer_updates.length)}(e))return e;const t=new _c(e);return t._filterRemovedMessages(),t._groupUpdates(),t._formatUpdates(),t._advanceUpdates(),t.result}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const fc=document.createElement("template");fc.innerHTML='<dom-module id="shared-styles">\n  <template>\n    <style>\n\n      /* CSS reset */\n\n      html, body, button, div, span, applet, object, iframe, h1, h2, h3,\n      h4, h5, h6, p, blockquote, pre, a, abbr, acronym, address, big, cite,\n      code, del, dfn, em, img, ins, kbd, q, s, samp, small, strike, strong, sub,\n      sup, tt, var, b, u, i, center, dl, dt, dd, ol, ul, li, fieldset, form,\n      label, legend, table, caption, tbody, tfoot, thead, tr, th, td, article,\n      aside, canvas, details, embed, figure, figcaption, footer, header, hgroup,\n      main, menu, nav, output, ruby, section, summary, time, mark, audio, video {\n        border: 0;\n        box-sizing: border-box;\n        font-size: 100%;\n        font: inherit;\n        margin: 0;\n        padding: 0;\n        vertical-align: baseline;\n      }\n      *::after,\n      *::before {\n        box-sizing: border-box;\n      }\n      input {\n        background-color: var(--background-color-primary);\n        border: 1px solid var(--border-color);\n        border-radius: var(--border-radius);\n        box-sizing: border-box;\n        color: var(--primary-text-color);\n        margin: 0;\n        padding: var(--spacing-s);\n      }\n      iron-autogrow-textarea {\n        background-color: inherit;\n        color: var(--primary-text-color);\n        border: 1px solid var(--border-color);\n        border-radius: var(--border-radius);\n        padding: 0;\n        box-sizing: border-box;\n        /* iron-autogrow-textarea has a "-webkit-appearance: textarea" :host\n           css rule, which prevents overriding the border color. Clear that. */\n        -webkit-appearance: none;\n\n        --iron-autogrow-textarea: {\n          box-sizing: border-box;\n          padding: var(--spacing-s);\n        };\n      }\n      a {\n        color: var(--link-color);\n      }\n      input,\n      textarea,\n      select,\n      button {\n        font: inherit;\n      }\n      ol, ul {\n        list-style: none;\n      }\n      blockquote, q {\n        quotes: none;\n      }\n      blockquote:before, blockquote:after,\n      q:before, q:after {\n        content: \'\';\n        content: none;\n      }\n      table {\n        border-collapse: collapse;\n        border-spacing: 0;\n      }\n\n      /* Fonts */\n\n      .font-normal {\n        font-size: var(--font-size-normal);\n        font-weight: var(--font-weight-normal);\n        line-height: var(--line-height-normal);\n      }\n      .font-small {\n        font-size: var(--font-size-small);\n        font-weight: var(--font-weight-normal);\n        line-height: var(--line-height-small);\n      }\n      .heading-1 {\n        font-family: var(--header-font-family);\n        font-size: var(--font-size-h1);\n        font-weight: var(--font-weight-h1);\n        line-height: var(--line-height-h1);\n      }\n      .heading-2 {\n        font-family: var(--header-font-family);\n        font-size: var(--font-size-h2);\n        font-weight: var(--font-weight-h2);\n        line-height: var(--line-height-h2);\n      }\n      .heading-3 {\n        font-family: var(--header-font-family);\n        font-size: var(--font-size-h3);\n        font-weight: var(--font-weight-h3);\n        line-height: var(--line-height-h3);\n      }\n      iron-icon {\n        color: var(--deemphasized-text-color);\n        --iron-icon-height: 20px;\n        --iron-icon-width: 20px;\n      }\n\n      /* Stopgap solution until we remove hidden$ attributes. */\n\n      :host([hidden]),\n      [hidden] {\n        display: none !important;\n      }\n      .separator {\n        border-left: 1px solid var(--border-color);\n        height: 20px;\n        margin: 0 8px;\n      }\n      .separator.transparent {\n        border-color: transparent;\n      }\n      paper-toggle-button {\n        --paper-toggle-button-checked-bar-color: var(--link-color);\n        --paper-toggle-button-checked-button-color: var(--link-color);\n      }\n      paper-tabs {\n        font-size: var(--font-size-h3);\n        font-weight: var(--font-weight-h3);\n        line-height: var(--line-height-h3);\n        --paper-font-common-base: {\n          font-family: var(--header-font-family);\n          -webkit-font-smoothing: initial;\n        };\n        --paper-tab-content-focused: {\n          /* paper-tabs uses 700 here, which can look awkward */\n          font-weight: var(--font-weight-h3);\n        };\n        --paper-tab-content-unselected: {\n          /* paper-tabs uses 0.8 here, but we want to control the color directly */\n          opacity: 1;\n          color: var(--deemphasized-text-color);\n        };\n      }\n      iron-autogrow-textarea {\n        /** This is needed for firefox */\n        --iron-autogrow-textarea_-_white-space: pre-wrap;\n      }\n      strong {\n        font-weight: var(--font-weight-bold);\n      }\n\n      /** BEGIN: loading spiner */\n      .loadingSpin {\n        border: 2px solid var(--disabled-button-background-color);\n        border-top: 2px solid var(--primary-button-background-color);\n        border-radius: 50%;\n        width: 10px;\n        height: 10px;\n        animation: spin 2s linear infinite;\n        margin-right: var(--spacing-s);\n      }\n      @keyframes spin {\n        0% { transform: rotate(0deg); }\n        100% { transform: rotate(360deg); }\n      }\n      /** END: loading spiner */\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(fc.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const vc=ta`
  <style include="shared-styles">
    :host {
      background: var(--dialog-background-color);
      border-radius: var(--border-radius);
      box-shadow: var(--elevation-level-5);
    }

    @media screen and (max-width: 50em) {
      :host {
        height: 100%;
        left: 0;
        position: fixed;
        right: 0;
        top: 0;
        border-radius: 0;
        box-shadow: none;
      }
    }
  </style>
  <slot></slot>
`
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/,yc={properties:{sizingTarget:{type:Object,value:function(){return this}},fitInto:{type:Object,value:window},noOverlap:{type:Boolean},positionTarget:{type:Element},horizontalAlign:{type:String},verticalAlign:{type:String},dynamicAlign:{type:Boolean},horizontalOffset:{type:Number,value:0,notify:!0},verticalOffset:{type:Number,value:0,notify:!0},autoFitOnAttach:{type:Boolean,value:!1},_fitInfo:{type:Object}},get _fitWidth(){return this.fitInto===window?this.fitInto.innerWidth:this.fitInto.getBoundingClientRect().width},get _fitHeight(){return this.fitInto===window?this.fitInto.innerHeight:this.fitInto.getBoundingClientRect().height},get _fitLeft(){return this.fitInto===window?0:this.fitInto.getBoundingClientRect().left},get _fitTop(){return this.fitInto===window?0:this.fitInto.getBoundingClientRect().top},get _defaultPositionTarget(){var e=qo(this).parentNode;return e&&e.nodeType===Node.DOCUMENT_FRAGMENT_NODE&&(e=e.host),e},get _localeHorizontalAlign(){if(this._isRTL){if("right"===this.horizontalAlign)return"left";if("left"===this.horizontalAlign)return"right"}return this.horizontalAlign},get __shouldPosition(){return(this.horizontalAlign||this.verticalAlign)&&this.positionTarget},get _isRTL(){return void 0===this._memoizedIsRTL&&(this._memoizedIsRTL="rtl"==window.getComputedStyle(this).direction),this._memoizedIsRTL},attached:function(){this.positionTarget=this.positionTarget||this._defaultPositionTarget,this.autoFitOnAttach&&("none"===window.getComputedStyle(this).display?setTimeout(function(){this.fit()}.bind(this)):(window.ShadyDOM&&ShadyDOM.flush(),this.fit()))},detached:function(){this.__deferredFit&&(clearTimeout(this.__deferredFit),this.__deferredFit=null)},fit:function(){this.position(),this.constrain(),this.center()},_discoverInfo:function(){if(!this._fitInfo){var e=window.getComputedStyle(this),t=window.getComputedStyle(this.sizingTarget);this._fitInfo={inlineStyle:{top:this.style.top||"",left:this.style.left||"",position:this.style.position||""},sizerInlineStyle:{maxWidth:this.sizingTarget.style.maxWidth||"",maxHeight:this.sizingTarget.style.maxHeight||"",boxSizing:this.sizingTarget.style.boxSizing||""},positionedBy:{vertically:"auto"!==e.top?"top":"auto"!==e.bottom?"bottom":null,horizontally:"auto"!==e.left?"left":"auto"!==e.right?"right":null},sizedBy:{height:"none"!==t.maxHeight,width:"none"!==t.maxWidth,minWidth:parseInt(t.minWidth,10)||0,minHeight:parseInt(t.minHeight,10)||0},margin:{top:parseInt(e.marginTop,10)||0,right:parseInt(e.marginRight,10)||0,bottom:parseInt(e.marginBottom,10)||0,left:parseInt(e.marginLeft,10)||0}}}},resetFit:function(){var e=this._fitInfo||{};for(var t in e.sizerInlineStyle)this.sizingTarget.style[t]=e.sizerInlineStyle[t];for(var t in e.inlineStyle)this.style[t]=e.inlineStyle[t];this._fitInfo=null},refit:function(){var e=this.sizingTarget.scrollLeft,t=this.sizingTarget.scrollTop;this.resetFit(),this.fit(),this.sizingTarget.scrollLeft=e,this.sizingTarget.scrollTop=t},position:function(){if(this.__shouldPosition){this._discoverInfo(),this.style.position="fixed",this.sizingTarget.style.boxSizing="border-box",this.style.left="0px",this.style.top="0px";var e=this.getBoundingClientRect(),t=this.__getNormalizedRect(this.positionTarget),n=this.__getNormalizedRect(this.fitInto),i=this._fitInfo.margin,o={width:e.width+i.left+i.right,height:e.height+i.top+i.bottom},s=this.__getPosition(this._localeHorizontalAlign,this.verticalAlign,o,e,t,n),r=s.left+i.left,a=s.top+i.top,l=Math.min(n.right-i.right,r+e.width),c=Math.min(n.bottom-i.bottom,a+e.height);r=Math.max(n.left+i.left,Math.min(r,l-this._fitInfo.sizedBy.minWidth)),a=Math.max(n.top+i.top,Math.min(a,c-this._fitInfo.sizedBy.minHeight)),this.sizingTarget.style.maxWidth=Math.max(l-r,this._fitInfo.sizedBy.minWidth)+"px",this.sizingTarget.style.maxHeight=Math.max(c-a,this._fitInfo.sizedBy.minHeight)+"px",this.style.left=r-e.left+"px",this.style.top=a-e.top+"px"}},constrain:function(){if(!this.__shouldPosition){this._discoverInfo();var e=this._fitInfo;e.positionedBy.vertically||(this.style.position="fixed",this.style.top="0px"),e.positionedBy.horizontally||(this.style.position="fixed",this.style.left="0px"),this.sizingTarget.style.boxSizing="border-box";var t=this.getBoundingClientRect();e.sizedBy.height||this.__sizeDimension(t,e.positionedBy.vertically,"top","bottom","Height"),e.sizedBy.width||this.__sizeDimension(t,e.positionedBy.horizontally,"left","right","Width")}},_sizeDimension:function(e,t,n,i,o){this.__sizeDimension(e,t,n,i,o)},__sizeDimension:function(e,t,n,i,o){var s=this._fitInfo,r=this.__getNormalizedRect(this.fitInto),a="Width"===o?r.width:r.height,l=t===i,c=l?a-e[i]:e[n],d=s.margin[l?n:i],h="offset"+o,p=this[h]-this.sizingTarget[h];this.sizingTarget.style["max"+o]=a-d-c-p+"px"},center:function(){if(!this.__shouldPosition){this._discoverInfo();var e=this._fitInfo.positionedBy;if(!e.vertically||!e.horizontally){this.style.position="fixed",e.vertically||(this.style.top="0px"),e.horizontally||(this.style.left="0px");var t=this.getBoundingClientRect(),n=this.__getNormalizedRect(this.fitInto);if(!e.vertically){var i=n.top-t.top+(n.height-t.height)/2;this.style.top=i+"px"}if(!e.horizontally){var o=n.left-t.left+(n.width-t.width)/2;this.style.left=o+"px"}}}},__getNormalizedRect:function(e){return e===document.documentElement||e===window?{top:0,left:0,width:window.innerWidth,height:window.innerHeight,right:window.innerWidth,bottom:window.innerHeight}:e.getBoundingClientRect()},__getOffscreenArea:function(e,t,n){var i=Math.min(0,e.top)+Math.min(0,n.bottom-(e.top+t.height)),o=Math.min(0,e.left)+Math.min(0,n.right-(e.left+t.width));return Math.abs(i)*t.width+Math.abs(o)*t.height},__getPosition:function(e,t,n,i,o,s){var r,a=[{verticalAlign:"top",horizontalAlign:"left",top:o.top+this.verticalOffset,left:o.left+this.horizontalOffset},{verticalAlign:"top",horizontalAlign:"right",top:o.top+this.verticalOffset,left:o.right-n.width-this.horizontalOffset},{verticalAlign:"bottom",horizontalAlign:"left",top:o.bottom-n.height-this.verticalOffset,left:o.left+this.horizontalOffset},{verticalAlign:"bottom",horizontalAlign:"right",top:o.bottom-n.height-this.verticalOffset,left:o.right-n.width-this.horizontalOffset}];if(this.noOverlap){for(var l=0,c=a.length;l<c;l++){var d={};for(var h in a[l])d[h]=a[l][h];a.push(d)}a[0].top=a[1].top+=o.height,a[2].top=a[3].top-=o.height,a[4].left=a[6].left+=o.width,a[5].left=a[7].left-=o.width}t="auto"===t?null:t,(e="auto"===e?null:e)&&"center"!==e||(a.push({verticalAlign:"top",horizontalAlign:"center",top:o.top+this.verticalOffset+(this.noOverlap?o.height:0),left:o.left-i.width/2+o.width/2+this.horizontalOffset}),a.push({verticalAlign:"bottom",horizontalAlign:"center",top:o.bottom-n.height-this.verticalOffset-(this.noOverlap?o.height:0),left:o.left-i.width/2+o.width/2+this.horizontalOffset})),t&&"middle"!==t||(a.push({verticalAlign:"middle",horizontalAlign:"left",top:o.top-i.height/2+o.height/2+this.verticalOffset,left:o.left+this.horizontalOffset+(this.noOverlap?o.width:0)}),a.push({verticalAlign:"middle",horizontalAlign:"right",top:o.top-i.height/2+o.height/2+this.verticalOffset,left:o.right-n.width-this.horizontalOffset-(this.noOverlap?o.width:0)})),"middle"===t&&"center"===e&&a.push({verticalAlign:"middle",horizontalAlign:"center",top:o.top-i.height/2+o.height/2+this.verticalOffset,left:o.left-i.width/2+o.width/2+this.horizontalOffset});for(l=0;l<a.length;l++){var p=a[l],u=p.verticalAlign===t,g=p.horizontalAlign===e;if(!this.dynamicAlign&&!this.noOverlap&&u&&g){r=p;break}var m=(!t||u)&&(!e||g);if(this.dynamicAlign||m){if(p.offscreenArea=this.__getOffscreenArea(p,n,s),0===p.offscreenArea&&m){r=p;break}r=r||p;var _=p.offscreenArea-r.offscreenArea;(_<0||0===_&&(u||g))&&(r=p)}}return r}};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
var bc=new Set;const wc={properties:{_parentResizable:{type:Object,observer:"_parentResizableChanged"},_notifyingDescendant:{type:Boolean,value:!1}},listeners:{"iron-request-resize-notifications":"_onIronRequestResizeNotifications"},created:function(){this._interestedResizables=[],this._boundNotifyResize=this.notifyResize.bind(this),this._boundOnDescendantIronResize=this._onDescendantIronResize.bind(this)},attached:function(){this._requestResizeNotifications()},detached:function(){this._parentResizable?this._parentResizable.stopResizeNotificationsFor(this):(bc.delete(this),window.removeEventListener("resize",this._boundNotifyResize)),this._parentResizable=null},notifyResize:function(){this.isAttached&&(this._interestedResizables.forEach((function(e){this.resizerShouldNotify(e)&&this._notifyDescendant(e)}),this),this._fireResize())},assignParentResizable:function(e){this._parentResizable&&this._parentResizable.stopResizeNotificationsFor(this),this._parentResizable=e,e&&-1===e._interestedResizables.indexOf(this)&&(e._interestedResizables.push(this),e._subscribeIronResize(this))},stopResizeNotificationsFor:function(e){var t=this._interestedResizables.indexOf(e);t>-1&&(this._interestedResizables.splice(t,1),this._unsubscribeIronResize(e))},_subscribeIronResize:function(e){e.addEventListener("iron-resize",this._boundOnDescendantIronResize)},_unsubscribeIronResize:function(e){e.removeEventListener("iron-resize",this._boundOnDescendantIronResize)},resizerShouldNotify:function(e){return!0},_onDescendantIronResize:function(e){this._notifyingDescendant?e.stopPropagation():le||this._fireResize()},_fireResize:function(){this.fire("iron-resize",null,{node:this,bubbles:!1})},_onIronRequestResizeNotifications:function(e){var t=qo(e).rootTarget;t!==this&&(t.assignParentResizable(this),this._notifyDescendant(t),e.stopPropagation())},_parentResizableChanged:function(e){e&&window.removeEventListener("resize",this._boundNotifyResize)},_notifyDescendant:function(e){this.isAttached&&(this._notifyingDescendant=!0,e.notifyResize(),this._notifyingDescendant=!1)},_requestResizeNotifications:function(){if(this.isAttached)if("loading"===document.readyState){var e=this._requestResizeNotifications.bind(this);document.addEventListener("readystatechange",(function t(){document.removeEventListener("readystatechange",t),e()}))}else this._findParent(),this._parentResizable?this._parentResizable._interestedResizables.forEach((function(e){e!==this&&e._findParent()}),this):(bc.forEach((function(e){e!==this&&e._findParent()}),this),window.addEventListener("resize",this._boundNotifyResize),this.notifyResize())},_findParent:function(){this.assignParentResizable(null),this.fire("iron-request-resize-notifications",null,{node:this,bubbles:!0,cancelable:!0}),this._parentResizable?bc.delete(this):bc.add(this)}};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/Er({_template:ta`
    <style>
      :host {
        position: fixed;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background-color: var(--iron-overlay-backdrop-background-color, #000);
        opacity: 0;
        transition: opacity 0.2s;
        pointer-events: none;
        @apply --iron-overlay-backdrop;
      }

      :host(.opened) {
        opacity: var(--iron-overlay-backdrop-opacity, 0.6);
        pointer-events: auto;
        @apply --iron-overlay-backdrop-opened;
      }
    </style>

    <slot></slot>
`,is:"iron-overlay-backdrop",properties:{opened:{reflectToAttribute:!0,type:Boolean,value:!1,observer:"_openedChanged"}},listeners:{transitionend:"_onTransitionend"},created:function(){this.__openedRaf=null},attached:function(){this.opened&&this._openedChanged(this.opened)},prepare:function(){this.opened&&!this.parentNode&&qo(document.body).appendChild(this)},open:function(){this.opened=!0},close:function(){this.opened=!1},complete:function(){this.opened||this.parentNode!==document.body||qo(this.parentNode).removeChild(this)},_onTransitionend:function(e){e&&e.target===this&&this.complete()},_openedChanged:function(e){if(e)this.prepare();else{var t=window.getComputedStyle(this);"0s"!==t.transitionDuration&&0!=t.opacity||this.complete()}this.isAttached&&(this.__openedRaf&&(window.cancelAnimationFrame(this.__openedRaf),this.__openedRaf=null),this.scrollTop=this.scrollTop,this.__openedRaf=window.requestAnimationFrame(function(){this.__openedRaf=null,this.toggleClass("opened",this.opened)}.bind(this)))}});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
var Cc={"U+0008":"backspace","U+0009":"tab","U+001B":"esc","U+0020":"space","U+007F":"del"},Ec={8:"backspace",9:"tab",13:"enter",27:"esc",33:"pageup",34:"pagedown",35:"end",36:"home",32:"space",37:"left",38:"up",39:"right",40:"down",46:"del",106:"*"},Sc={shift:"shiftKey",ctrl:"ctrlKey",alt:"altKey",meta:"metaKey"},Ac=/[a-z0-9*]/,xc=/U\+/,Pc=/^arrow/,Rc=/^space(bar)?/,Tc=/^escape$/;function Ic(e,t){var n="";if(e){var i=e.toLowerCase();" "===i||Rc.test(i)?n="space":Tc.test(i)?n="esc":1==i.length?t&&!Ac.test(i)||(n=i):n=Pc.test(i)?i.replace("arrow",""):"multiply"==i?"*":i}return n}function kc(e,t){return e.key?Ic(e.key,t):e.detail&&e.detail.key?Ic(e.detail.key,t):(n=e.keyIdentifier,i="",n&&(n in Cc?i=Cc[n]:xc.test(n)?(n=parseInt(n.replace("U+","0x"),16),i=String.fromCharCode(n).toLowerCase()):i=n.toLowerCase()),i||function(e){var t="";return Number(e)&&(t=e>=65&&e<=90?String.fromCharCode(32+e):e>=112&&e<=123?"f"+(e-112+1):e>=48&&e<=57?String(e-48):e>=96&&e<=105?String(e-96):Ec[e]),t}(e.keyCode)||"");var n,i}function Oc(e,t){return kc(t,e.hasModifiers)===e.key&&(!e.hasModifiers||!!t.shiftKey==!!e.shiftKey&&!!t.ctrlKey==!!e.ctrlKey&&!!t.altKey==!!e.altKey&&!!t.metaKey==!!e.metaKey)}function Nc(e){return e.trim().split(" ").map((function(e){return function(e){return 1===e.length?{combo:e,key:e,event:"keydown"}:e.split("+").reduce((function(e,t){var n=t.split(":"),i=n[0],o=n[1];return i in Sc?(e[Sc[i]]=!0,e.hasModifiers=!0):(e.key=i,e.event=o||"keydown"),e}),{combo:e.split(":").shift()})}(e)}))}const Lc={properties:{keyEventTarget:{type:Object,value:function(){return this}},stopKeyboardEventPropagation:{type:Boolean,value:!1},_boundKeyHandlers:{type:Array,value:function(){return[]}},_imperativeKeyBindings:{type:Object,value:function(){return{}}}},observers:["_resetKeyEventListeners(keyEventTarget, _boundKeyHandlers)"],keyBindings:{},registered:function(){this._prepKeyBindings()},attached:function(){this._listenKeyEventListeners()},detached:function(){this._unlistenKeyEventListeners()},addOwnKeyBinding:function(e,t){this._imperativeKeyBindings[e]=t,this._prepKeyBindings(),this._resetKeyEventListeners()},removeOwnKeyBindings:function(){this._imperativeKeyBindings={},this._prepKeyBindings(),this._resetKeyEventListeners()},keyboardEventMatchesKeys:function(e,t){for(var n=Nc(t),i=0;i<n.length;++i)if(Oc(n[i],e))return!0;return!1},_collectKeyBindings:function(){var e=this.behaviors.map((function(e){return e.keyBindings}));return-1===e.indexOf(this.keyBindings)&&e.push(this.keyBindings),e},_prepKeyBindings:function(){for(var e in this._keyBindings={},this._collectKeyBindings().forEach((function(e){for(var t in e)this._addKeyBinding(t,e[t])}),this),this._imperativeKeyBindings)this._addKeyBinding(e,this._imperativeKeyBindings[e]);for(var t in this._keyBindings)this._keyBindings[t].sort((function(e,t){var n=e[0].hasModifiers;return n===t[0].hasModifiers?0:n?-1:1}))},_addKeyBinding:function(e,t){Nc(e).forEach((function(e){this._keyBindings[e.event]=this._keyBindings[e.event]||[],this._keyBindings[e.event].push([e,t])}),this)},_resetKeyEventListeners:function(){this._unlistenKeyEventListeners(),this.isAttached&&this._listenKeyEventListeners()},_listenKeyEventListeners:function(){this.keyEventTarget&&Object.keys(this._keyBindings).forEach((function(e){var t=this._keyBindings[e],n=this._onKeyBindingEvent.bind(this,t);this._boundKeyHandlers.push([this.keyEventTarget,e,n]),this.keyEventTarget.addEventListener(e,n)}),this)},_unlistenKeyEventListeners:function(){for(var e,t,n,i;this._boundKeyHandlers.length;)t=(e=this._boundKeyHandlers.pop())[0],n=e[1],i=e[2],t.removeEventListener(n,i)},_onKeyBindingEvent:function(e,t){if(this.stopKeyboardEventPropagation&&t.stopPropagation(),!t.defaultPrevented)for(var n=0;n<e.length;n++){var i=e[n][0],o=e[n][1];if(Oc(i,t)&&(this._triggerKeyHandler(i,o,t),t.defaultPrevented))return}},_triggerKeyHandler:function(e,t,n){var i=Object.create(e);i.keyboardEvent=n;var o=new CustomEvent(e.event,{detail:i,cancelable:!0});this[t].call(this,o),o.defaultPrevented&&n.preventDefault()}};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/const Dc=new class{constructor(){this._overlays=[],this._minimumZ=101,this._backdropElement=null,$i(document.documentElement,"tap",(function(){})),document.addEventListener("tap",this._onCaptureClick.bind(this),!0),document.addEventListener("focus",this._onCaptureFocus.bind(this),!0),document.addEventListener("keydown",this._onCaptureKeyDown.bind(this),!0)}get backdropElement(){return this._backdropElement||(this._backdropElement=document.createElement("iron-overlay-backdrop")),this._backdropElement}get deepActiveElement(){var e=document.activeElement;for(e&&e instanceof Element!=!1||(e=document.body);e.root&&qo(e.root).activeElement;)e=qo(e.root).activeElement;return e}_bringOverlayAtIndexToFront(e){var t=this._overlays[e];if(t){var n=this._overlays.length-1,i=this._overlays[n];if(i&&this._shouldBeBehindOverlay(t,i)&&n--,!(e>=n)){var o=Math.max(this.currentOverlayZ(),this._minimumZ);for(this._getZ(t)<=o&&this._applyOverlayZ(t,o);e<n;)this._overlays[e]=this._overlays[e+1],e++;this._overlays[n]=t}}}addOrRemoveOverlay(e){e.opened?this.addOverlay(e):this.removeOverlay(e)}addOverlay(e){var t=this._overlays.indexOf(e);if(t>=0)return this._bringOverlayAtIndexToFront(t),void this.trackBackdrop();var n=this._overlays.length,i=this._overlays[n-1],o=Math.max(this._getZ(i),this._minimumZ),s=this._getZ(e);if(i&&this._shouldBeBehindOverlay(e,i)){this._applyOverlayZ(i,o),n--;var r=this._overlays[n-1];o=Math.max(this._getZ(r),this._minimumZ)}s<=o&&this._applyOverlayZ(e,o),this._overlays.splice(n,0,e),this.trackBackdrop()}removeOverlay(e){var t=this._overlays.indexOf(e);-1!==t&&(this._overlays.splice(t,1),this.trackBackdrop())}currentOverlay(){var e=this._overlays.length-1;return this._overlays[e]}currentOverlayZ(){return this._getZ(this.currentOverlay())}ensureMinimumZ(e){this._minimumZ=Math.max(this._minimumZ,e)}focusOverlay(){var e=this.currentOverlay();e&&e._applyFocus()}trackBackdrop(){var e=this._overlayWithBackdrop();(e||this._backdropElement)&&(this.backdropElement.style.zIndex=this._getZ(e)-1,this.backdropElement.opened=!!e,this.backdropElement.prepare())}getBackdrops(){for(var e=[],t=0;t<this._overlays.length;t++)this._overlays[t].withBackdrop&&e.push(this._overlays[t]);return e}backdropZ(){return this._getZ(this._overlayWithBackdrop())-1}_overlayWithBackdrop(){for(var e=this._overlays.length-1;e>=0;e--)if(this._overlays[e].withBackdrop)return this._overlays[e]}_getZ(e){var t=this._minimumZ;if(e){var n=Number(e.style.zIndex||window.getComputedStyle(e).zIndex);n==n&&(t=n)}return t}_setZ(e,t){e.style.zIndex=t}_applyOverlayZ(e,t){this._setZ(e,t+2)}_overlayInPath(e){e=e||[];for(var t=0;t<e.length;t++)if(e[t]._manager===this)return e[t]}_onCaptureClick(e){var t=this._overlays.length-1;if(-1!==t)for(var n,i=qo(e).path;(n=this._overlays[t])&&this._overlayInPath(i)!==n&&(n._onCaptureClick(e),n.allowClickThrough);)t--}_onCaptureFocus(e){var t=this.currentOverlay();t&&t._onCaptureFocus(e)}_onCaptureKeyDown(e){var t=this.currentOverlay();t&&(Lc.keyboardEventMatchesKeys(e,"esc")?t._onCaptureEsc(e):Lc.keyboardEventMatchesKeys(e,"tab")&&t._onCaptureTab(e))}_shouldBeBehindOverlay(e,t){return!e.alwaysOnTop&&t.alwaysOnTop}};
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/var $c,Mc,Fc={pageX:0,pageY:0},Bc=null,jc=[],Hc=["wheel","mousewheel","DOMMouseScroll","touchstart","touchmove"];function Uc(e){Vc.indexOf(e)>=0||(0===Vc.length&&function(){$c=$c||qc.bind(void 0);for(var e=0,t=Hc.length;e<t;e++)document.addEventListener(Hc[e],$c,{capture:!0,passive:!1})}(),Vc.push(e),Mc=Vc[Vc.length-1],zc=[],Wc=[])}function Gc(e){var t=Vc.indexOf(e);-1!==t&&(Vc.splice(t,1),Mc=Vc[Vc.length-1],zc=[],Wc=[],0===Vc.length&&function(){for(var e=0,t=Hc.length;e<t;e++)document.removeEventListener(Hc[e],$c,{capture:!0,passive:!1})}())}const Vc=[];let zc=null,Wc=null;function qc(e){if(e.cancelable&&function(e){var t=qo(e).rootTarget;"touchmove"!==e.type&&Bc!==t&&(Bc=t,jc=function(e){for(var t=[],n=e.indexOf(Mc),i=0;i<=n;i++)if(e[i].nodeType===Node.ELEMENT_NODE){var o=e[i],s=o.style;"scroll"!==s.overflow&&"auto"!==s.overflow&&(s=window.getComputedStyle(o)),"scroll"!==s.overflow&&"auto"!==s.overflow||t.push(o)}return t}(qo(e).path));if(!jc.length)return!0;if("touchstart"===e.type)return!1;var n=function(e){var t={deltaX:e.deltaX,deltaY:e.deltaY};if("deltaX"in e);else if("wheelDeltaX"in e&&"wheelDeltaY"in e)t.deltaX=-e.wheelDeltaX,t.deltaY=-e.wheelDeltaY;else if("wheelDelta"in e)t.deltaX=0,t.deltaY=-e.wheelDelta;else if("axis"in e)t.deltaX=1===e.axis?e.detail:0,t.deltaY=2===e.axis?e.detail:0;else if(e.targetTouches){var n=e.targetTouches[0];t.deltaX=Fc.pageX-n.pageX,t.deltaY=Fc.pageY-n.pageY}return t}
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/(e);return!function(e,t,n){if(!t&&!n)return;for(var i=Math.abs(n)>=Math.abs(t),o=0;o<e.length;o++){var s=e[o];if(i?n<0?s.scrollTop>0:s.scrollTop<s.scrollHeight-s.clientHeight:t<0?s.scrollLeft>0:s.scrollLeft<s.scrollWidth-s.clientWidth)return s}}(jc,n.deltaX,n.deltaY)}(e)&&e.preventDefault(),e.targetTouches){var t=e.targetTouches[0];Fc.pageX=t.pageX,Fc.pageY=t.pageY}}const Kc={properties:{opened:{observer:"_openedChanged",type:Boolean,value:!1,notify:!0},canceled:{observer:"_canceledChanged",readOnly:!0,type:Boolean,value:!1},withBackdrop:{observer:"_withBackdropChanged",type:Boolean},noAutoFocus:{type:Boolean,value:!1},noCancelOnEscKey:{type:Boolean,value:!1},noCancelOnOutsideClick:{type:Boolean,value:!1},closingReason:{type:Object},restoreFocusOnClose:{type:Boolean,value:!1},allowClickThrough:{type:Boolean},alwaysOnTop:{type:Boolean},scrollAction:{type:String},_manager:{type:Object,value:Dc},_focusedChild:{type:Object}},listeners:{"iron-resize":"_onIronResize"},observers:["__updateScrollObservers(isAttached, opened, scrollAction)"],get backdropElement(){return this._manager.backdropElement},get _focusNode(){return this._focusedChild||qo(this).querySelector("[autofocus]")||this},get _focusableNodes(){return Ea.getTabbableNodes(this)},ready:function(){this.__isAnimating=!1,this.__shouldRemoveTabIndex=!1,this.__firstFocusableNode=this.__lastFocusableNode=null,this.__rafs={},this.__restoreFocusNode=null,this.__scrollTop=this.__scrollLeft=null,this.__onCaptureScroll=this.__onCaptureScroll.bind(this),this.__rootNodes=null,this._ensureSetup()},attached:function(){this.opened&&this._openedChanged(this.opened),this._observer=qo(this).observeNodes(this._onNodesChange)},detached:function(){for(var e in this._observer&&qo(this).unobserveNodes(this._observer),this._observer=null,this.__rafs)null!==this.__rafs[e]&&cancelAnimationFrame(this.__rafs[e]);this.__rafs={},this._manager.removeOverlay(this),this.__isAnimating&&(this.opened?this._finishRenderOpened():(this._applyFocus(),this._finishRenderClosed()))},toggle:function(){this._setCanceled(!1),this.opened=!this.opened},open:function(){this._setCanceled(!1),this.opened=!0},close:function(){this._setCanceled(!1),this.opened=!1},cancel:function(e){this.fire("iron-overlay-canceled",e,{cancelable:!0}).defaultPrevented||(this._setCanceled(!0),this.opened=!1)},invalidateTabbables:function(){this.__firstFocusableNode=this.__lastFocusableNode=null},_ensureSetup:function(){this._overlaySetup||(this._overlaySetup=!0,this.style.outline="none",this.style.display="none")},_openedChanged:function(e){e?this.removeAttribute("aria-hidden"):this.setAttribute("aria-hidden","true"),this.isAttached&&(this.__isAnimating=!0,this.__deraf("__openedChanged",this.__openedChanged))},_canceledChanged:function(){this.closingReason=this.closingReason||{},this.closingReason.canceled=this.canceled},_withBackdropChanged:function(){this.withBackdrop&&!this.hasAttribute("tabindex")?(this.setAttribute("tabindex","-1"),this.__shouldRemoveTabIndex=!0):this.__shouldRemoveTabIndex&&(this.removeAttribute("tabindex"),this.__shouldRemoveTabIndex=!1),this.opened&&this.isAttached&&this._manager.trackBackdrop()},_prepareRenderOpened:function(){this.__restoreFocusNode=this._manager.deepActiveElement,this._preparePositioning(),this.refit(),this._finishPositioning(),this.noAutoFocus&&document.activeElement===this._focusNode&&(this._focusNode.blur(),this.__restoreFocusNode.focus())},_renderOpened:function(){this._finishRenderOpened()},_renderClosed:function(){this._finishRenderClosed()},_finishRenderOpened:function(){this.notifyResize(),this.__isAnimating=!1,this.fire("iron-overlay-opened")},_finishRenderClosed:function(){this.style.display="none",this.style.zIndex="",this.notifyResize(),this.__isAnimating=!1,this.fire("iron-overlay-closed",this.closingReason)},_preparePositioning:function(){this.style.transition=this.style.webkitTransition="none",this.style.transform=this.style.webkitTransform="none",this.style.display=""},_finishPositioning:function(){this.style.display="none",this.scrollTop=this.scrollTop,this.style.transition=this.style.webkitTransition="",this.style.transform=this.style.webkitTransform="",this.style.display="",this.scrollTop=this.scrollTop},_applyFocus:function(){if(this.opened)this.noAutoFocus||this._focusNode.focus();else{if(this.restoreFocusOnClose&&this.__restoreFocusNode){var e=this._manager.deepActiveElement;(e===document.body||Yc(this,e))&&this.__restoreFocusNode.focus()}this.__restoreFocusNode=null,this._focusNode.blur(),this._focusedChild=null}},_onCaptureClick:function(e){this.noCancelOnOutsideClick||this.cancel(e)},_onCaptureFocus:function(e){if(this.withBackdrop){var t=qo(e).path;-1===t.indexOf(this)?(e.stopPropagation(),this._applyFocus()):this._focusedChild=t[0]}},_onCaptureEsc:function(e){this.noCancelOnEscKey||this.cancel(e)},_onCaptureTab:function(e){if(this.withBackdrop){this.__ensureFirstLastFocusables();var t=e.shiftKey,n=t?this.__firstFocusableNode:this.__lastFocusableNode,i=t?this.__lastFocusableNode:this.__firstFocusableNode,o=!1;if(n===i)o=!0;else{var s=this._manager.deepActiveElement;o=s===n||s===this}o&&(e.preventDefault(),this._focusedChild=i,this._applyFocus())}},_onIronResize:function(){this.opened&&!this.__isAnimating&&this.__deraf("refit",this.refit)},_onNodesChange:function(){this.opened&&!this.__isAnimating&&(this.invalidateTabbables(),this.notifyResize())},__ensureFirstLastFocusables:function(){var e=this._focusableNodes;this.__firstFocusableNode=e[0],this.__lastFocusableNode=e[e.length-1]},__openedChanged:function(){this.opened?(this._prepareRenderOpened(),this._manager.addOverlay(this),this._applyFocus(),this._renderOpened()):(this._manager.removeOverlay(this),this._applyFocus(),this._renderClosed())},__deraf:function(e,t){var n=this.__rafs;null!==n[e]&&cancelAnimationFrame(n[e]),n[e]=requestAnimationFrame(function(){n[e]=null,t.call(this)}.bind(this))},__updateScrollObservers:function(e,t,n){e&&t&&this.__isValidScrollAction(n)?("lock"===n&&(this.__saveScrollPosition(),Uc(this)),this.__addScrollListeners()):(Gc(this),this.__removeScrollListeners())},__addScrollListeners:function(){if(!this.__rootNodes){if(this.__rootNodes=[],le)for(var e=this;e;)e.nodeType===Node.DOCUMENT_FRAGMENT_NODE&&e.host&&this.__rootNodes.push(e),e=e.host||e.assignedSlot||e.parentNode;this.__rootNodes.push(document)}this.__rootNodes.forEach((function(e){e.addEventListener("scroll",this.__onCaptureScroll,{capture:!0,passive:!0})}),this)},__removeScrollListeners:function(){this.__rootNodes&&this.__rootNodes.forEach((function(e){e.removeEventListener("scroll",this.__onCaptureScroll,{capture:!0,passive:!0})}),this),this.isAttached||(this.__rootNodes=null)},__isValidScrollAction:function(e){return"lock"===e||"refit"===e||"cancel"===e},__onCaptureScroll:function(e){if(!(this.__isAnimating||qo(e).path.indexOf(this)>=0))switch(this.scrollAction){case"lock":this.__restoreScrollPosition();break;case"refit":this.__deraf("refit",this.refit);break;case"cancel":this.cancel(e)}},__saveScrollPosition:function(){document.scrollingElement?(this.__scrollTop=document.scrollingElement.scrollTop,this.__scrollLeft=document.scrollingElement.scrollLeft):(this.__scrollTop=Math.max(document.documentElement.scrollTop,document.body.scrollTop),this.__scrollLeft=Math.max(document.documentElement.scrollLeft,document.body.scrollLeft))},__restoreScrollPosition:function(){document.scrollingElement?(document.scrollingElement.scrollTop=this.__scrollTop,document.scrollingElement.scrollLeft=this.__scrollLeft):(document.documentElement.scrollTop=document.body.scrollTop=this.__scrollTop,document.documentElement.scrollLeft=document.body.scrollLeft=this.__scrollLeft)}},Yc=(e,t)=>{for(let i=t;i;i=(n=i).assignedSlot||n.parentNode||n.host)if(i===e)return!0;var n;return!1},Xc=[yc,wc,Kc];var Jc=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Zc=class extends((e=>mr([Xc],e))(oo(dr(oa)))){constructor(){super(...arguments),this._fullScreenOpen=!1,this._boundHandleClose=()=>super.close()}static get template(){return vc}get _focusableNodes(){return this.focusableNodes?this.focusableNodes:window.Polymer.IronFocusablesHelper.getTabbableNodes(this)}created(){super.created(),this.addEventListener("iron-overlay-closed",()=>this._overlayClosed()),this.addEventListener("iron-overlay-cancelled",()=>this._overlayClosed())}open(){return window.addEventListener("popstate",this._boundHandleClose),new Promise((e,t)=>{super.open.apply(this),this._isMobile()&&(this.dispatchEvent(new CustomEvent("fullscreen-overlay-opened",{composed:!0,bubbles:!0})),this._fullScreenOpen=!0),this._awaitOpen(e,t)})}_isMobile(){return window.matchMedia("(max-width: 50em)")}_overlayClosed(){window.removeEventListener("popstate",this._boundHandleClose),this._fullScreenOpen&&(this.dispatchEvent(new CustomEvent("fullscreen-overlay-closed",{composed:!0,bubbles:!0})),this._fullScreenOpen=!1)}setFocusStops(e){this.focusableNodes=[e.start,e.end]}_awaitOpen(e,t){let n=0;const i=()=>{this.async(()=>{"none"!==this.style.display?e.call(this):n++<10?i.call(this):t(new Error("gr-overlay _awaitOpen failed to resolve"))},5)};i.call(this)}_id(){return this.getAttribute("id")||"global"}};Jc([Bl({type:Boolean})],Zc.prototype,"_fullScreenOpen",void 0),Zc=Jc([Ml("gr-overlay")],Zc);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Qc=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <gr-overlay id="overlay" with-backdrop="">
    <slot></slot>
  </gr-overlay>
`;let ed=class extends(oo(dr(oa))){static get template(){return Qc}get opened(){return this.$.overlay.opened}open(){return this.$.overlay.open()}close(){this.$.overlay.close()}};ed=(window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r})([Ml("gr-plugin-popup")],ed);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class td{constructor(e,t=null){this.plugin=e,this._moduleName=t,this._openingPromise=null,this._popup=null}_getElement(){return qo(this._popup)}open(){return this._openingPromise||(this._openingPromise=this.plugin.hook("plugin-overlay").getLastAttached().then(e=>{const t=document.createElement("gr-plugin-popup");if(this._moduleName){t.appendChild(document.createElement(this._moduleName)).plugin=this.plugin}return this._popup=e.appendChild(t),Mo(),this._popup.open().then(()=>this)})),this._openingPromise}close(){this._popup&&(this._popup.close(),this._openingPromise=null)}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const nd={computePluralString(e,t){return this.computeString(e,t)+(e>1?"s":"")},computeString:(e,t)=>0===e?"":`${e} ${t}`,computeShortString:(e,t)=>0===e?"":`${e}${t}`};
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */function id(e){const t=e;return void 0!==t._account_id||void 0!==t.email}function od(e){return void 0!==e.account}function sd(e){return void 0!==e.group}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */var rd;!function(e){e.REVIEWER="reviewers",e.CC="ccs",e.ANY="any"}(rd||(rd={}));class ad{constructor(e,t){this._restAPI=e,this._apiCall=t,this._loggedIn=!1,this._initialized=!1}static create(e,t,n){switch(n){case rd.REVIEWER:return new ad(e,n=>e.getChangeSuggestedReviewers(t,n));case rd.CC:return new ad(e,n=>e.getChangeSuggestedCCs(t,n));case rd.ANY:return new ad(e,n=>e.getSuggestedAccounts(`cansee:${t} ${n}`));default:throw new Error(`Unknown users type: ${n}`)}}init(){if(this._initPromise)return this._initPromise;const e=this._restAPI.getConfig().then(e=>{this._config=e}),t=this._restAPI.getLoggedIn().then(e=>{this._loggedIn=e});return this._initPromise=Promise.all([e,t]).then(()=>{this._initialized=!0}),this._initPromise}getSuggestions(e){return this._initialized&&this._loggedIn?this._apiCall(e).then(e=>e||[]):Promise.resolve([])}makeSuggestionItem(e){return od(e)?{name:rl(this._config,e.account),value:e}:sd(e)?{name:ll(e.group),value:e}:void 0!==e._account_id?{name:rl(this._config,e),value:{account:e,count:1}}:void s(e,"Received an incorrect suggestion")}}
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const ld={getCookie(e){const t=e+"=",n=document.cookie.split(";");for(let e=0;e<n.length;e++){let i=n[e];for(;" "===i.charAt(0);)i=i.substring(1);if(i.startsWith(t))return i.substring(t.length,i.length)}return""},makeCancelable(e){let t,n=!1;const i=new Promise((i,o)=>{t=o,e.then(e=>{n||i(e),n=!0},e=>{n||o(e),n=!0})});return i.cancel=()=>{n||(t({isCanceled:!0}),n=!0)},i}};var cd,dd;cd=window,dd=function(){var e=Array.isArray||function(e){return"[object Array]"==Object.prototype.toString.call(e)},t=g,n=a,i=function(e){return l(a(e))},o=l,s=u,r=new RegExp(["(\\\\.)","([\\/.])?(?:(?:\\:(\\w+)(?:\\(((?:\\\\.|[^()])+)\\))?|\\(((?:\\\\.|[^()])+)\\))([+*?])?|(\\*))"].join("|"),"g");function a(e){for(var t,n=[],i=0,o=0,s="";null!=(t=r.exec(e));){var a=t[0],l=t[1],c=t.index;if(s+=e.slice(o,c),o=c+a.length,l)s+=l[1];else{s&&(n.push(s),s="");var h=t[2],p=t[3],u=t[4],g=t[5],m=t[6],_=t[7],f="+"===m||"*"===m,v="?"===m||"*"===m,y=h||"/",b=u||g||(_?".*":"[^"+y+"]+?");n.push({name:p||i++,prefix:h||"",delimiter:y,optional:v,repeat:f,pattern:d(b)})}}return o<e.length&&(s+=e.substr(o)),s&&n.push(s),n}function l(t){for(var n=new Array(t.length),i=0;i<t.length;i++)"object"==typeof t[i]&&(n[i]=new RegExp("^"+t[i].pattern+"$"));return function(i){for(var o="",s=i||{},r=0;r<t.length;r++){var a=t[r];if("string"!=typeof a){var l,c=s[a.name];if(null==c){if(a.optional)continue;throw new TypeError('Expected "'+a.name+'" to be defined')}if(e(c)){if(!a.repeat)throw new TypeError('Expected "'+a.name+'" to not repeat, but received "'+c+'"');if(0===c.length){if(a.optional)continue;throw new TypeError('Expected "'+a.name+'" to not be empty')}for(var d=0;d<c.length;d++){if(l=encodeURIComponent(c[d]),!n[r].test(l))throw new TypeError('Expected all "'+a.name+'" to match "'+a.pattern+'", but received "'+l+'"');o+=(0===d?a.prefix:a.delimiter)+l}}else{if(l=encodeURIComponent(c),!n[r].test(l))throw new TypeError('Expected "'+a.name+'" to match "'+a.pattern+'", but received "'+l+'"');o+=a.prefix+l}}else o+=a}return o}}function c(e){return e.replace(/([.+*?=^!:${}()[\]|\/])/g,"\\$1")}function d(e){return e.replace(/([=!:$\/()])/g,"\\$1")}function h(e,t){return e.keys=t,e}function p(e){return e.sensitive?"":"i"}function u(e,t){for(var n=(t=t||{}).strict,i=!1!==t.end,o="",s=e[e.length-1],r="string"==typeof s&&/\/$/.test(s),a=0;a<e.length;a++){var l=e[a];if("string"==typeof l)o+=c(l);else{var d=c(l.prefix),h=l.pattern;l.repeat&&(h+="(?:"+d+h+")*"),o+=h=l.optional?d?"(?:"+d+"("+h+"))?":"("+h+")?":d+"("+h+")"}}return n||(o=(r?o.slice(0,-2):o)+"(?:\\/(?=$))?"),o+=i?"$":n&&r?"":"(?=\\/|$)",new RegExp("^"+o,p(t))}function g(t,n,i){return e(n=n||[])?i||(i={}):(i=n,n=[]),t instanceof RegExp?function(e,t){var n=e.source.match(/\((?!\?)/g);if(n)for(var i=0;i<n.length;i++)t.push({name:i,prefix:null,delimiter:null,optional:!1,repeat:!1,pattern:null});return h(e,t)}(t,n):e(t)?function(e,t,n){for(var i=[],o=0;o<e.length;o++)i.push(g(e[o],t,n).source);return h(new RegExp("(?:"+i.join("|")+")",p(n)),t)}(t,n,i):function(e,t,n){for(var i=a(e),o=u(i,n),s=0;s<i.length;s++)"string"!=typeof i[s]&&t.push(i[s]);return h(o,t)}(t,n,i)}t.parse=n,t.compile=i,t.tokensToFunction=o,t.tokensToRegExp=s;var m,_="undefined"!=typeof document,f="undefined"!=typeof window,v="undefined"!=typeof history,y="undefined"!=typeof process,b=_&&document.ontouchstart?"touchstart":"click",w=f&&!(!window.history.location&&!window.location);function C(){this.callbacks=[],this.exits=[],this.current="",this.len=0,this._decodeURLComponents=!0,this._base="",this._strict=!1,this._running=!1,this._hashbang=!1,this.clickHandler=this.clickHandler.bind(this),this._onpopstate=this._onpopstate.bind(this)}function E(e,t){if("function"==typeof e)return E.call(this,"*",e);if("function"==typeof t)for(var n=new x(e,null,this),i=1;i<arguments.length;++i)this.callbacks.push(n.middleware(arguments[i]));else"string"==typeof e?this["string"==typeof t?"redirect":"show"](e,t):this.start(e)}function S(e){if(!e.handled){var t=this._window;(this._hashbang?w&&this._getBase()+t.location.hash.replace("#!",""):w&&t.location.pathname+t.location.search)!==e.canonicalPath&&(this.stop(),e.handled=!1,w&&(t.location.href=e.canonicalPath))}}function A(e,t,n){var i=this.page=n||E,o=i._window,s=i._hashbang,r=i._getBase();"/"===e[0]&&0!==e.indexOf(r)&&(e=r+(s?"#!":"")+e);var a=e.indexOf("?");this.canonicalPath=e;var l=new RegExp("^"+r.replace(/([.+*?=^!:${}()[\]|/\\])/g,"\\$1"));if(this.path=e.replace(l,"")||"/",s&&(this.path=this.path.replace("#!","")||"/"),this.title=_&&o.document.title,this.state=t||{},this.state.path=e,this.querystring=~a?i._decodeURLEncodedURIComponent(e.slice(a+1)):"",this.pathname=i._decodeURLEncodedURIComponent(~a?e.slice(0,a):e),this.params={},this.hash="",!s){if(!~this.path.indexOf("#"))return;var c=this.path.split("#");this.path=this.pathname=c[0],this.hash=i._decodeURLEncodedURIComponent(c[1])||"",this.querystring=this.querystring.split("#")[0]}}function x(e,n,i){this.page=i||P;var o=n||{};o.strict=o.strict||i._strict,this.path="*"===e?"(.*)":e,this.method="GET",this.regexp=t(this.path,this.keys=[],o)}C.prototype.configure=function(e){var t=e||{};this._window=t.window||f&&window,this._decodeURLComponents=!1!==t.decodeURLComponents,this._popstate=!1!==t.popstate&&f,this._click=!1!==t.click&&_,this._hashbang=!!t.hashbang;var n=this._window;this._popstate?n.addEventListener("popstate",this._onpopstate,!1):f&&n.removeEventListener("popstate",this._onpopstate,!1),this._click?n.document.addEventListener(b,this.clickHandler,!1):_&&n.document.removeEventListener(b,this.clickHandler,!1),this._hashbang&&f&&!v?n.addEventListener("hashchange",this._onpopstate,!1):f&&n.removeEventListener("hashchange",this._onpopstate,!1)},C.prototype.base=function(e){if(0===arguments.length)return this._base;this._base=e},C.prototype._getBase=function(){var e=this._base;if(e)return e;var t=f&&this._window&&this._window.location;return f&&this._hashbang&&t&&"file:"===t.protocol&&(e=t.pathname),e},C.prototype.strict=function(e){if(0===arguments.length)return this._strict;this._strict=e},C.prototype.start=function(e){var t=e||{};if(this.configure(t),!1!==t.dispatch){var n;if(this._running=!0,w){var i=this._window.location;n=this._hashbang&&~i.hash.indexOf("#!")?i.hash.substr(2)+i.search:this._hashbang?i.search+i.hash:i.pathname+i.search+i.hash}this.replace(n,null,!0,t.dispatch)}},C.prototype.stop=function(){if(this._running){this.current="",this.len=0,this._running=!1;var e=this._window;this._click&&e.document.removeEventListener(b,this.clickHandler,!1),f&&e.removeEventListener("popstate",this._onpopstate,!1),f&&e.removeEventListener("hashchange",this._onpopstate,!1)}},C.prototype.show=function(e,t,n,i){var o=new A(e,t,this),s=this.prevContext;return this.prevContext=o,this.current=o.path,!1!==n&&this.dispatch(o,s),!1!==o.handled&&!1!==i&&o.pushState(),o},C.prototype.back=function(e,t){var n=this;if(this.len>0){var i=this._window;v&&i.history.back(),this.len--}else e?setTimeout((function(){n.show(e,t)})):setTimeout((function(){n.show(n._getBase(),t)}))},C.prototype.redirect=function(e,t){var n=this;"string"==typeof e&&"string"==typeof t&&E.call(this,e,(function(e){setTimeout((function(){n.replace(t)}),0)})),"string"==typeof e&&void 0===t&&setTimeout((function(){n.replace(e)}),0)},C.prototype.replace=function(e,t,n,i){var o=new A(e,t,this),s=this.prevContext;return this.prevContext=o,this.current=o.path,o.init=n,o.save(),!1!==i&&this.dispatch(o,s),o},C.prototype.dispatch=function(e,t){var n=0,i=0,o=this;function s(){var t=o.callbacks[n++];if(e.path===o.current)return t?void t(e,s):S.call(o,e);e.handled=!1}t?function e(){var n=o.exits[i++];if(!n)return s();n(t,e)}():s()},C.prototype.exit=function(e,t){if("function"==typeof e)return this.exit("*",e);for(var n=new x(e,null,this),i=1;i<arguments.length;++i)this.exits.push(n.middleware(arguments[i]))},C.prototype.clickHandler=function(e){if(1===this._which(e)&&!(e.metaKey||e.ctrlKey||e.shiftKey||e.defaultPrevented)){var t=e.target,n=e.path||(e.composedPath?e.composedPath():null);if(n)for(var i=0;i<n.length;i++)if(n[i].nodeName&&"A"===n[i].nodeName.toUpperCase()&&n[i].href){t=n[i];break}for(;t&&"A"!==t.nodeName.toUpperCase();)t=t.parentNode;if(t&&"A"===t.nodeName.toUpperCase()){var o="object"==typeof t.href&&"SVGAnimatedString"===t.href.constructor.name;if(!t.hasAttribute("download")&&"external"!==t.getAttribute("rel")){var s=t.getAttribute("href");if((this._hashbang||!this._samePath(t)||!t.hash&&"#"!==s)&&!(s&&s.indexOf("mailto:")>-1)&&(o?!t.target.baseVal:!t.target)&&(o||this.sameOrigin(t.href))){var r=o?t.href.baseVal:t.pathname+t.search+(t.hash||"");r="/"!==r[0]?"/"+r:r,y&&r.match(/^\/[a-zA-Z]:\//)&&(r=r.replace(/^\/[a-zA-Z]:\//,"/"));var a=r,l=this._getBase();0===r.indexOf(l)&&(r=r.substr(l.length)),this._hashbang&&(r=r.replace("#!","")),(!l||a!==r||w&&"file:"===this._window.location.protocol)&&(e.preventDefault(),this.show(a))}}}}},C.prototype._onpopstate=(m=!1,f?(_&&"complete"===document.readyState?m=!0:window.addEventListener("load",(function(){setTimeout((function(){m=!0}),0)})),function(e){if(m)if(e.state){var t=e.state.path;this.replace(t,e.state)}else if(w){var n=this._window.location;this.show(n.pathname+n.search+n.hash,void 0,void 0,!1)}}):function(){}),C.prototype._which=function(e){return null==(e=e||f&&this._window.event).which?e.button:e.which},C.prototype._toURL=function(e){var t=this._window;if("function"==typeof URL&&w)return new URL(e,t.location.toString());if(_){var n=t.document.createElement("a");return n.href=e,n}},C.prototype.sameOrigin=function(e){if(!e||!w)return!1;var t=this._toURL(e),n=this._window.location;return n.protocol===t.protocol&&n.hostname===t.hostname&&(n.port===t.port||""===n.port&&80===t.port)},C.prototype._samePath=function(e){if(!w)return!1;var t=this._window.location;return e.pathname===t.pathname&&e.search===t.search},C.prototype._decodeURLEncodedURIComponent=function(e){return"string"!=typeof e?e:this._decodeURLComponents?decodeURIComponent(e.replace(/\+/g," ")):e},A.prototype.pushState=function(){var e=this.page,t=e._window,n=e._hashbang;e.len++,v&&t.history.pushState(this.state,this.title,n&&"/"!==this.path?"#!"+this.path:this.canonicalPath)},A.prototype.save=function(){var e=this.page;v&&e._window.history.replaceState(this.state,this.title,e._hashbang&&"/"!==this.path?"#!"+this.path:this.canonicalPath)},x.prototype.middleware=function(e){var t=this;return function(n,i){if(t.match(n.path,n.params))return e(n,i);i()}},x.prototype.match=function(e,t){var n=this.keys,i=e.indexOf("?"),o=~i?e.slice(0,i):e,s=this.regexp.exec(decodeURIComponent(o));if(!s)return!1;delete t[0];for(var r=1,a=s.length;r<a;++r){var l=n[r-1],c=this.page._decodeURLEncodedURIComponent(s[r]);void 0===c&&hasOwnProperty.call(t,l.name)||(t[l.name]=c)}return!0};var P=function e(){var t=new C;function n(){return E.apply(t,arguments)}return n.callbacks=t.callbacks,n.exits=t.exits,n.base=t.base.bind(t),n.strict=t.strict.bind(t),n.start=t.start.bind(t),n.stop=t.stop.bind(t),n.show=t.show.bind(t),n.back=t.back.bind(t),n.redirect=t.redirect.bind(t),n.replace=t.replace.bind(t),n.dispatch=t.dispatch.bind(t),n.exit=t.exit.bind(t),n.configure=t.configure.bind(t),n.sameOrigin=t.sameOrigin.bind(t),n.clickHandler=t.clickHandler.bind(t),n.create=e,Object.defineProperty(n,"len",{get:function(){return t.len},set:function(e){t.len=e}}),Object.defineProperty(n,"current",{get:function(){return t.current},set:function(e){t.current=e}}),n.Context=A,n.Route=x,n}(),R=P,T=P;return R.default=T,R},"object"==typeof exports&&"undefined"!=typeof module?module.exports=dd():"function"==typeof define&&define.amd?define(dd):cd.page=dd();
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const hd=window.page;
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class pd{constructor(e){this.plugin=e,this.menuLinks=[],this.plugin.on("admin-menu-links",this)}addMenuLink(e,t,n){this.menuLinks.push({text:e,url:t,capability:n||null})}getMenuLinks(){return this.menuLinks.slice(0)}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class ud{constructor(e,t,n,i,o){this._contentEl=e,this._lineNumberEl=t,this.line=n,this.path=i,this.changeNum=Number(o),isNaN(this.changeNum)&&console.error(`GrAnnotationActionsContext: Invalid changeNum: ${o}`)}annotateRange(e,t,n,i){var o;(null===(o=this._contentEl)||void 0===o?void 0:o.getAttribute("data-side"))===i&&dl.annotateElement(this._contentEl,e,t,n.getClassName(this._contentEl))}annotateLineNumber(e,t){var n;(null===(n=this._lineNumberEl)||void 0===n?void 0:n.classList.contains(t))&&e.apply(this._lineNumberEl)}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class gd{constructor(e){this.plugin=e,this.annotationLayers=[],this.coverageProvider=null,this.addLayerFunc=()=>{},e.on("annotatediff",this)}addLayer(e){return this.addLayerFunc=e,this}addNotifier(e){return e((e,t,n,i)=>this.notify(e,t,n,i)),this}setCoverageProvider(e){return this.coverageProvider&&console.warn("Overwriting an existing coverage provider."),this.coverageProvider=e,this}getCoverageProvider(){return this.coverageProvider}enableToggleCheckbox(e,t){return this.plugin.hook("annotation-toggler").onAttached(n=>{if(!n.content)return void console.error("plugin endpoint without content.");if(!n.content.hidden)return void console.error(n.content.id+" is already enabled. Cannot re-enable.");n.content.removeAttribute("hidden");const i=n.content.querySelector("#annotation-label");i&&(i.textContent=e||"Enable");const o=n.content.querySelector("#annotation-checkbox");t(o)}),this}notify(e,t,n,i){for(const o of this.annotationLayers)o.path===e&&o.notifyListeners(t,n,i)}getLayer(e,t){const n=new md(e,t,this.addLayerFunc);return this.annotationLayers.push(n),n}disposeLayer(e){this.annotationLayers=this.annotationLayers.filter(t=>t.path!==e)}}class md{constructor(e,t,n){this.path=e,this.changeNum=t,this.addLayerFunc=n,this.listeners=[],this.listeners=[]}addListener(e){this.listeners.push(e)}removeListener(e){this.listeners=this.listeners.filter(t=>t!==e)}annotate(e,t,n){const i=new ud(e,t,n,this.path,this.changeNum);this.addLayerFunc(i)}notifyListeners(e,t,n){for(const i of this.listeners)i(e,t,n)}}class _d{constructor(e){this.plugin=e,this._hook=null}_createHook(){this._hook=this.plugin.hook("change-metadata-item")}onLabelsChanged(e){return this._hook||this._createHook(),this._hook.onAttached(t=>this.plugin.attributeHelper(t).bind("labels",e)),this}}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class fd{constructor(e){this._restAPI=e}getSuggestions(e){return this._restAPI.getSuggestedAccounts(`${e}`).then(e=>e||[])}makeSuggestionItem(e){return{name:rl(void 0,e),value:{account:e,count:1}}}}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class vd{constructor(e){this._restAPI=e}getSuggestions(e){return this._restAPI.getSuggestedGroups(`${e}`).then(e=>{if(!e)return[];return Object.keys(e).map(t=>({...e[t],name:t}))})}makeSuggestionItem(e){return{name:e.name,value:{group:{name:e.name,id:e.id}}}}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class yd{constructor(e){this.element=e}on(e,t){return this._listen(this.element,t,{event:e})}onTap(e){return this.onClick(e)}onClick(e){return this._listen(this.element,e)}captureTap(e){this.captureClick(e)}captureClick(e){const t=this.element.parentElement;return this._listen(t,e,{capture:!0})}_listen(e,t,n){const i=null==n?void 0:n.capture,o=(null==n?void 0:n.event)||"click",s=e=>{if(e.path&&-1!==e.path.indexOf(this.element)){let n=!0;try{n=t(e)}catch(e){console.warn(`Plugin error handing event: ${e}`)}!1===n&&(e.stopImmediatePropagation(),e.stopPropagation(),e.preventDefault())}};e.addEventListener(o,s,i);return()=>e.removeEventListener(o,s,i)}}let bd=null;function wd(){return bd||(bd=document.createElement("gr-rest-api-interface")),bd}class Cd{constructor(e=""){this.prefix=e}getLoggedIn(){return wd().getLoggedIn()}getVersion(){return wd().getVersion()}getConfig(){return wd().getConfig()}invalidateReposCache(){wd().invalidateReposCache()}getAccount(){return wd().getAccount()}getAccountCapabilities(e){return wd().getAccountCapabilities(e)}getRepos(e,t,n){return wd().getRepos(e,t,n)}fetch(e,t,n,i,o){return wd().send(e,this.prefix+t,n,i,o)}send(e,t,n,i,o){return this.fetch(e,t,n,i,o).then(e=>{if(!e)throw new Error("errFn must throw an exception");return e.status<200||e.status>=300?e.text().then(t=>t?Promise.reject(new Error(t)):Promise.reject(new Error(`${e.status}`))):wd().getResponseObject(e)})}get(e){return this.send(qa.GET,e)}post(e,t,n,i){return this.send(qa.POST,e,t,n,i)}put(e,t,n,i){return this.send(qa.PUT,e,t,n,i)}delete(e){return this.fetch(qa.DELETE,e).then(e=>204!==e.status?e.text().then(t=>t?Promise.reject(new Error(t)):Promise.reject(new Error(`${e.status}`))):e)}}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const Ed=ta`
  <style include="shared-styles">
    :host {
      display: block;
      margin-bottom: var(--spacing-xxl);
    }
  </style>
  <h3>[[title]]</h3>
  <gr-button on-click="_handleClick">[[title]]</gr-button>
`;var Sd=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Ad=class extends oa{constructor(){super(...arguments),this.title=""}static get template(){return Ed}_handleClick(){this.dispatchEvent(new CustomEvent("command-tap",{composed:!0,bubbles:!0}))}};Sd([Bl({type:String})],Ad.prototype,"title",void 0),Ad=Sd([Ml("gr-plugin-repo-command")],Ad);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class xd{constructor(e){this.plugin=e}_createHook(e){return this.plugin.hook("repo-command").onAttached(t=>{const n=document.createElement("gr-plugin-repo-command");n.title=e,t.appendChild(n)})}createCommand(e,t){return this._hook?(console.warn("Already set up."),this._hook):(this._hook=this._createHook(e),this._hook.onAttached(e=>{!1===t(e.repoName,e.config)&&(e.hidden=!0)}),this)}onTap(e){return this._hook?(this._hook.onAttached(t=>{this.plugin.eventHelper(t).on("command-tap",e)}),this):(console.warn("Call createCommand first."),this)}}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const Pd=ta`
  <style>
    :host {
      display: block;
      margin-bottom: var(--spacing-xxl);
    }
  </style>
  <h2 id="[[anchor]]" class="heading-2">[[title]]</h2>
  <slot></slot>
`;var Rd=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Td=class extends(oo(dr(oa))){constructor(){super(...arguments),this.title=""}static get template(){return Pd}};Rd([Bl({type:String})],Td.prototype,"anchor",void 0),Rd([Bl({type:String})],Td.prototype,"title",void 0),Td=Rd([Ml("gr-settings-item")],Td);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Id=document.createElement("template");Id.innerHTML='<dom-module id="gr-page-nav-styles">\n  <template>\n    <style>\n      .navStyles ul {\n        padding: var(--spacing-l) 0;\n      }\n      .navStyles li {\n        border-bottom: 1px solid transparent;\n        border-top: 1px solid transparent;\n        display: block;\n        padding: 0 var(--spacing-xl);\n      }\n      .navStyles li a {\n        display: block;\n        overflow: hidden;\n        text-overflow: ellipsis;\n        white-space: nowrap;\n      }\n      .navStyles .subsectionItem {\n        padding-left: var(--spacing-xxl);\n      }\n      .navStyles .hideSubsection {\n        display: none;\n      }\n      .navStyles li.sectionTitle {\n        padding: 0 var(--spacing-xxl) 0 var(--spacing-l);\n      }\n      .navStyles li.sectionTitle:not(:first-child) {\n        margin-top: var(--spacing-l);\n      }\n      .navStyles .title {\n        font-weight: var(--font-weight-bold);\n        margin: var(--spacing-s) 0;\n      }\n      .navStyles .selected {\n        background-color: var(--view-background-color);\n        border-bottom: 1px solid var(--border-color);\n        border-top: 1px solid var(--border-color);\n        font-weight: var(--font-weight-bold);\n      }\n      .navStyles a {\n        color: var(--primary-text-color);\n        display: inline-block;\n        margin: var(--spacing-s) 0;\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(Id.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const kd=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-page-nav-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div class="navStyles">
    <li><a href$="[[href]]">[[title]]</a></li>
  </div>
`;var Od=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Nd=class extends(oo(dr(oa))){constructor(){super(...arguments),this.title=""}static get template(){return kd}};Od([Bl({type:String})],Nd.prototype,"href",void 0),Od([Bl({type:String})],Nd.prototype,"title",void 0),Nd=Od([Ml("gr-settings-menu-item")],Nd);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Settings
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Ld{constructor(e){this.plugin=e,this._title="(no title)",this._token=e.getPluginName()+Math.random().toString(36).substr(5)}title(e){return this._title=e,this}token(e){return this._token=e,this}module(e){return this._moduleName=e,this}build(){if(!this._moduleName)throw new Error("Settings screen custom element not defined!");const e=`x/${this.plugin.getPluginName()}/${this._token}`;this.plugin.hook("settings-menu-item").onAttached(t=>{const n=document.createElement("gr-settings-menu-item");n.title=this._title,n.setAttribute("href",`#${e}`),t.appendChild(n)});const t=this._moduleName;return this.plugin.hook("settings-screen").onAttached(n=>{const i=document.createElement("gr-settings-item");i.title=this._title,i.anchor=e,i.appendChild(document.createElement(t)),n.appendChild(i)})}}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const Dd=!window.ShadyDOM||!window.ShadyDOM.inUse;let $d=0;class Md{constructor(e){this.rulesStr=e,this.className="",this.className=`__pg_js_api_class_${$d}`,$d++}getClassName(e){let t=Dd?e.getRootNode():document.body;t===document&&(t=document.head);const n=t;if(n.__pg_js_api_style_tags||(n.__pg_js_api_style_tags={}),!n.__pg_js_api_style_tags[this.className]){const e=document.createElement("style");e.innerHTML=`.${this.className} { ${this.rulesStr} }`,n.appendChild(e),n.__pg_js_api_style_tags[this.className]=!0}return this.className}apply(e){e.classList.add(this.getClassName(e))}}class Fd{css(e){return new Md(e)}}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */let Bd,jd;function Hd(){return Bd||(Bd=document.createElement("gr-rest-api-interface")),Bd}function Ud(e){if(!(e instanceof URL))try{e=new URL(e)}catch(e){return console.warn(e),null}if("preloaded:"===e.protocol)return e.pathname;const t=j();let n=e.pathname.replace(t,"");return window.ASSETS_PATH&&e.href.includes(window.ASSETS_PATH)&&(n=e.href.replace(window.ASSETS_PATH,"")),["/static/gerrit-theme.html","/static/gerrit-theme.js"].includes(n)?"gerrit-theme":n.startsWith("/plugins")?n.split("/")[2].split(".")[0]:(console.warn("Plugin not being loaded from /plugins base path:",e.href,"— Unable to determine name."),null)}function Gd(e,t,n,i){return Hd().send(e,t,i).then(e=>e.status<200||e.status>=300?e.text().then(t=>t?Promise.reject(new Error(t)):Promise.reject(new Error(`${e.status}`))):Hd().getResponseObject(e)).then(e=>(n&&n(e),e))}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function Vd(e){return"shadowRoot"in e}function zd(e){if(!e)return"";let t=e.path;if(!t||!t.length){t=[];let n=e.target;for(;n;)t.push(n),n=n.parentNode||n.host}return t.reduce((e,t)=>{const n=function(e){let t="",n="",i="";if(e instanceof Element&&(t=e.tagName,n=e.id,i=e.className),!t||"GR-APP"===t||e instanceof DocumentFragment||e instanceof HTMLSlotElement)return"";let o="";return t&&(o+=t.toLowerCase()),n&&(o+=`#${n}`),i&&(o+=`.${i.replace(/ /g,".")}`),o}(t);return n?e?`${n}>${e}`:n:e},"")}function Wd(e,t,n){let i=e.classList.contains(t);for(;!i&&e.parentElement&&(!n||e.parentElement!==n);)i=e.classList.contains(t),e=e.parentElement;return i}function qd(e="",t="generated_"){return`${t}${e.replace(/[^a-zA-Z0-9-_]/g,"_")}`}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Kd{constructor(e){this.plugin=e,this.reporting=n.reportingService}reportInteraction(e,t){return this.reporting.reportInteraction(`${this.plugin.getPluginName()}-${e}`,t)}reportLifeCycle(e,t){return this.reporting.reportLifeCycle(`${this.plugin.getPluginName()}-${e}`,t)}}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */var Yd;!function(e){e.DECORATE="decorate",e.REPLACE="replace",e.STYLE="style"}(Yd||(Yd={}));class Xd{constructor(e){var t;if(this._name="NULL",this.sharedApiElement=(jd||(jd=document.createElement("gr-js-api-interface")),jd),this._domHooks=new Ll(this),!e)return console.warn("Plugin not being loaded from /plugins base path.","Unable to determine name."),this;this._url=new URL(e),this._name=null!==(t=Ud(this._url))&&void 0!==t?t:"NULL"}getPluginName(){return this._name}registerStyleModule(e,t){rc().registerModule(this,{endpoint:e,type:Yd.STYLE,moduleName:t})}registerCustomComponent(e,t,n){return this._registerCustomComponent(e,t,n)}registerDynamicCustomComponent(e,t,n){const i=`${e}-${this.getPluginName()}`;return this._registerCustomComponent(i,t,n,e)}_registerCustomComponent(e,t,n,i){const o=n&&n.replace?Yd.REPLACE:Yd.DECORATE,s=n&&n.slot||"",r=this._domHooks.getDomHook(e,t);return t=t||r.getModuleName(),rc().registerModule(this,{slot:s,endpoint:e,type:o,moduleName:t,domHook:r,dynamicEndpoint:i}),r}hook(e,t){return this.registerCustomComponent(e,void 0,t)}getServerInfo(){return document.createElement("gr-rest-api-interface").getConfig()}on(e,t){this.sharedApiElement.addEventCallback(e,t)}url(e){if(!this._url)throw new Error("plugin url not set");const t="/plugins/"+this._name+(e||"/"),n=window.location.origin+`${j()}${t}`;return window.location.origin===this._url.origin?n:"preloaded:"===this._url.protocol?window.ASSETS_PATH?`${window.ASSETS_PATH}${t}`:n:this._url.href.split("/plugins/"+this._name)[0]+t}screenUrl(e){const t=e?"/"+e:"";return`${location.origin}${j()}/x/${this.getPluginName()}${t}`}_send(e,t,n,i){return Gd(e,this.url(t),n,i)}get(e,t){return console.warn(".get() is deprecated! Use .restApi().get()"),this._send(qa.GET,e,t)}post(e,t,n){return console.warn(".post() is deprecated! Use .restApi().post()"),this._send(qa.POST,e,n,t)}put(e,t,n){return console.warn(".put() is deprecated! Use .restApi().put()"),this._send(qa.PUT,e,n,t)}delete(e,t){return console.warn(".delete() is deprecated! Use plugin.restApi().delete()"),this.restApi().delete(this.url(e)).then(e=>(t&&t(e),e))}annotationApi(){return new gd(this)}changeActions(){return new kl(this,this.sharedApiElement.getElement(Tl.CHANGE_ACTIONS))}changeReply(){return new Ol(this,this.sharedApiElement)}reporting(){return new Kd(this)}theme(){return new zl(this)}project(){return new xd(this)}changeMetadata(){return new _d(this)}admin(){return new pd(this)}settings(){return new Ld(this)}styles(){return new Fd}restApi(e){return new Cd(e)}attributeHelper(e){return new hl(e)}eventHelper(e){return new yd(e)}popup(e){return void 0!==e&&"string"!=typeof e?(console.error(".popup(element) deprecated, use .popup(moduleName)!"),Promise.resolve(null)):new td(this,e).open()}screen(e,t){if(!t||"string"==typeof t)return this.registerCustomComponent(this._getScreenName(e),t);console.error(".screen(pattern, callback) deprecated, use .screen(screenName, moduleName)!")}_getScreenName(e){return`${this.getPluginName()}-screen-${e}`}}
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */var Jd;!function(e){e.PENDING="PENDING",e.LOADED="LOADED",e.LOAD_FAILED="LOAD_FAILED"}(Jd||(Jd={}));class Zd{constructor(){this._pluginListLoaded=!1,this._plugins=new Map,this._reporting=null,this._loadingPromise=null,this._loadingResolver=null}_getReporting(){return this._reporting||(this._reporting=n.reportingService),this._reporting}_getPluginKeyFromUrl(e){return Ud(e)||`__$$__${e}`}loadPlugins(e=[],t={}){this._pluginListLoaded=!0,e.forEach(e=>{const n=this._urlFor(e,window.ASSETS_PATH);if(this.isPluginPreloaded(n))return;const i=this._getPluginKeyFromUrl(n);this._plugins.has(i)||(this._plugins.set(i,{name:i,url:n,state:Jd.PENDING,plugin:null}),this._isPathEndsWith(n,".html")?this._importHtmlPlugin(e,t&&t[e]):this._isPathEndsWith(n,".js")?this._loadJsPlugin(e):this._failToLoad(`Unrecognized plugin path ${e}`,e))}),this.awaitPluginsLoaded().then(()=>{console.info("Plugins loaded"),this._getReporting().pluginsLoaded(this._getAllInstalledPluginNames())})}_isPathEndsWith(e,t){if(!(e instanceof URL))try{e=new URL(e)}catch(e){return console.warn(e),!1}return e.pathname&&e.pathname.endsWith(t)}_getAllInstalledPluginNames(){const e=[];for(const t of this._plugins.values())t.state===Jd.LOADED&&e.push(t.name);return e}install(e,t,n){var i;const o=document.currentScript,s=null!==(i=null==o?void 0:o.__importElement)&&void 0!==i?i:o;if(!n&&s&&s.src&&(n=s.src),(!n||n.startsWith("data:"))&&s&&s.baseURI&&(n=s&&s.baseURI),!n)return void this._failToLoad("Failed to determine src.");if(t&&"0.1"!==t)return void this._failToLoad(`Plugin ${n} install error: only version 0.1 is supported in PolyGerrit. ${t} was given.`,n);const r=this._urlFor(n),a=this.getPlugin(r);let l=a&&a.plugin;l||(l=new Xd(r));try{e(l),this._pluginInstalled(r,l)}catch(e){this._failToLoad(`${e.name}: ${e.message}`,n)}}arePluginsLoaded(){if(!this._pluginListLoaded)return!1;for(const e of this._plugins.values())if(e.state===Jd.PENDING)return!1;return!0}_checkIfCompleted(){this.arePluginsLoaded()&&(rc().setPluginsReady(),this._loadingResolver&&(this._loadingResolver(),this._loadingResolver=null,this._loadingPromise=null))}_timeout(){const e=[];for(const t of this._plugins.values())t.state===Jd.PENDING&&(this._updatePluginState(t.url,Jd.LOAD_FAILED),this._checkIfCompleted(),e.push(t.url));return`Timeout when loading plugins: ${e.join(",")}`}_failToLoad(e,t){document.dispatchEvent(new CustomEvent("show-alert",{detail:{message:`Plugin install error: ${e} from ${t}`}})),t&&this._updatePluginState(t,Jd.LOAD_FAILED),this._checkIfCompleted()}_updatePluginState(e,t){const n=this._getPluginKeyFromUrl(e);return this._plugins.has(n)?this._plugins.get(n).state=t:(console.info(`Plugin loaded separately: ${e}`),this._plugins.set(n,{name:n,url:e,state:t,plugin:null})),this._plugins.get(n)}_pluginInstalled(e,t){this._updatePluginState(e,Jd.LOADED).plugin=t,this._getReporting().pluginLoaded(t.getPluginName()||e),console.info(`Plugin ${t.getPluginName()||e} installed.`),this._checkIfCompleted()}installPreloadedPlugins(){const e=window.Gerrit;if(e&&e._preloadedPlugins)for(const t of Object.keys(e._preloadedPlugins)){const n=e._preloadedPlugins[t];this.install(n,"0.1","preloaded:"+t)}}isPluginPreloaded(e){const t=Ud(this._urlFor(e)),n=window.Gerrit;return!(!t||!n._preloadedPlugins)&&o(n._preloadedPlugins,t)}isPluginEnabled(e){const t=this._urlFor(e);if(this.isPluginPreloaded(t))return!0;const n=this._getPluginKeyFromUrl(t);return this._plugins.has(n)}getPlugin(e){const t=this._urlFor(e),n=this._getPluginKeyFromUrl(t);return this._plugins.get(n)}isPluginLoaded(e){const t=this._urlFor(e),n=this._getPluginKeyFromUrl(t);return!!this._plugins.has(n)&&this._plugins.get(n).state===Jd.LOADED}_importHtmlPlugin(e,t={}){const n=this._urlFor(e,window.ASSETS_PATH),i=this._urlFor(e);let o=void 0;n!==i&&(o=()=>this._loadHtmlPlugin(i,t.sync)),this._loadHtmlPlugin(n,t.sync,o)}_loadHtmlPlugin(e,t,n){n||(n=()=>{this._failToLoad(`${e} import error`,e)}),Aa(e,()=>{},n,!t)}_loadJsPlugin(e){const t=this._urlFor(e,window.ASSETS_PATH),n=this._urlFor(e);let i=void 0;t!==n&&(i=()=>this._createScriptTag(n)),this._createScriptTag(t,i)}_createScriptTag(e,t){t||(t=()=>this._failToLoad(`${e} load error`,e));const n=document.createElement("script");return n.defer=!0,n.setAttribute("src",e),n.setAttribute("crossorigin","anonymous"),n.onerror=t,document.body.appendChild(n)}_urlFor(e,t){const n=!(e.endsWith("static/gerrit-theme.html")||e.endsWith("static/gerrit-theme.js"))&&t;return e.startsWith("preloaded:")||e.startsWith("http")?e.includes(location.host)&&n&&t?e.replace(location.origin,t):e:(e.startsWith("/")||(e="/"+e),n&&t?t+e:window.location.origin+j()+e)}awaitPluginsLoaded(){if(this._checkIfCompleted(),this.arePluginsLoaded())return Promise.resolve();if(!this._loadingPromise){let e;this._loadingPromise=Promise.race([new Promise(e=>this._loadingResolver=e),new Promise((t,n)=>e=setTimeout(()=>{n(new Error(this._timeout()))},1e4))]).finally(()=>{e&&clearTimeout(e)})}return this._loadingPromise}}let Qd=new Zd;function eh(){return Qd}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class th{constructor(e,t,n,i){this.plugin=e,this.action=t,this.change=n,this.revision=i,this._popups=[]}popup(e){this.plugin.popup().then(t=>{const n=t._getElement();if(!n)throw new Error("Popup element not found");n.appendChild(e),this._popups.push(t)})}hide(){for(const e of this._popups)e.close();this._popups.splice(0)}refresh(){window.location.reload()}textfield(){return document.createElement("paper-input")}br(){return document.createElement("br")}msg(e){const t=document.createElement("gr-label");return t.appendChild(document.createTextNode(e)),t}div(...e){const t=document.createElement("div");for(const n of e)t.appendChild(n);return t}button(e,t){const n=t&&t.onclick,i=document.createElement("gr-button");return i.appendChild(document.createTextNode(e)),n&&this.plugin.eventHelper(i).onTap(n),i}checkbox(){const e=document.createElement("input");return e.type="checkbox",e}label(e,t){return this.div(e,this.msg(t))}prependLabel(e,t){return this.label(t,e)}call(e,t){this.action.method&&(this.action.__url?this.plugin.restApi().send(this.action.method,this.action.__url,e).then(t).catch(e=>{document.dispatchEvent(new CustomEvent("show-alert",{detail:{message:`Plugin network error: ${e}`}}))}):console.warn(`Unable to ${this.action.method} to ${this.action.__key}!`))}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const nh=()=>{console.warn("Use of uninitialized routing")},ih=()=>(nh(),""),oh=()=>(nh(),""),sh=()=>(nh(),[]),rh=()=>(nh(),{}),ah=/\${user}/g,lh=[{name:"Has draft comments",query:"has:draft",selfOnly:!0,hideIfEmpty:!0,suffixForDashboard:"limit:10"},{name:"Your Turn",query:"attention:${user}",hideIfEmpty:!1,suffixForDashboard:"limit:25",attentionSetOnly:!0},{name:"Assigned reviews",query:"assignee:${user} (-is:wip OR owner:self OR assignee:self) is:open -is:ignored",hideIfEmpty:!0,suffixForDashboard:"limit:25",assigneeOnly:!0},{name:"Work in progress",query:"is:open owner:${user} is:wip",selfOnly:!0,hideIfEmpty:!0,suffixForDashboard:"limit:25"},{name:"Outgoing reviews",query:"is:open owner:${user} -is:wip -is:ignored",isOutgoing:!0,suffixForDashboard:"limit:25"},{name:"Incoming reviews",query:"is:open -owner:${user} -is:wip -is:ignored (reviewer:${user} OR assignee:${user})",suffixForDashboard:"limit:25"},{name:"CCed on",query:"is:open -is:ignored cc:${user}",suffixForDashboard:"limit:10"},{name:"Recently closed",query:"is:closed -is:ignored (-is:wip OR owner:self) (owner:${user} OR reviewer:${user} OR assignee:${user} OR cc:${user})",suffixForDashboard:"-age:4w limit:10"}];function ch(e){return e.view===dh.DIFF}var dh,hh,ph,uh;!function(e){e.ADMIN="admin",e.AGREEMENTS="agreements",e.CHANGE="change",e.DASHBOARD="dashboard",e.DIFF="diff",e.DOCUMENTATION_SEARCH="documentation-search",e.EDIT="edit",e.GROUP="group",e.PLUGIN_SCREEN="plugin-screen",e.REPO="repo",e.ROOT="root",e.SEARCH="search",e.SETTINGS="settings"}(dh||(dh={})),function(e){e.MEMBERS="members",e.LOG="log"}(hh||(hh={})),function(e){e.ACCESS="access",e.BRANCHES="branches",e.COMMANDS="commands",e.DASHBOARDS="dashboards",e.TAGS="tags"}(ph||(ph={})),function(e){e.CHANGE="change",e.FILE="file",e.PATCHSET="patchset"}(uh||(uh={}));const gh={View:dh,GroupDetailView:hh,RepoDetailView:ph,WeblinkType:uh,_navigate:ih,_generateUrl:oh,_generateWeblinks:sh,mapCommentlinks:rh,_checkPatchRange(e,t){if(t&&!e)throw new Error("Cannot use base patch number without patch number.")},setup(e,t,n,i){this._navigate=e,this._generateUrl=t,this._generateWeblinks=n,this.mapCommentlinks=i},destroy(){this._navigate=ih,this._generateUrl=oh,this._generateWeblinks=sh,this.mapCommentlinks=rh},_getUrlFor(e){return this._generateUrl(e)},getUrlForSearchQuery(e,t){return this._getUrlFor({view:dh.SEARCH,query:e,offset:t})},getUrlForProjectChanges(e,t,n){return this._getUrlFor({view:dh.SEARCH,project:e,statuses:t?["open"]:[],host:n})},getUrlForBranch(e,t,n,i){return this._getUrlFor({view:dh.SEARCH,branch:e,project:t,statuses:n?[n]:void 0,host:i})},getUrlForTopic(e,t){return this._getUrlFor({view:dh.SEARCH,topic:e,statuses:["open","merged"],host:t})},getUrlForHashtag(e){return this._getUrlFor({view:dh.SEARCH,hashtag:e,statuses:["open","merged"]})},navigateToStatusSearch(e){this._navigate(this._getUrlFor({view:dh.SEARCH,statuses:[e]}))},navigateToSearchQuery(e,t){return this._navigate(this.getUrlForSearchQuery(e,t))},navigateToUserDashboard(){return this._navigate(this.getUrlForUserDashboard("self"))},getUrlForChange(e,t,n,i,o){return"PARENT"===n&&(n=void 0),this._checkPatchRange(t,n),this._getUrlFor({view:dh.CHANGE,changeNum:e._number,project:e.project,patchNum:t,basePatchNum:n,edit:i,host:e.internalHost||void 0,messageHash:o})},getUrlForChangeById(e,t,n){return this._getUrlFor({view:dh.CHANGE,changeNum:e,project:t,patchNum:n})},navigateToChange(e,t,n,i,o){this._navigate(this.getUrlForChange(e,t,n,i),o)},getUrlForDiff(e,t,n,i,o){return this.getUrlForDiffById(e._number,e.project,t,n,i,o)},getUrlForComment(e,t,n){return this._getUrlFor({view:dh.DIFF,changeNum:e,project:t,commentId:n})},getUrlForDiffById(e,t,n,i,o,s,r){return"PARENT"===o&&(o=void 0),this._checkPatchRange(i,o),this._getUrlFor({view:dh.DIFF,changeNum:e,project:t,path:n,patchNum:i,basePatchNum:o,lineNum:s,leftSide:r})},getEditUrlForDiff(e,t,n,i){return this.getEditUrlForDiffById(e._number,e.project,t,n,i)},getEditUrlForDiffById(e,t,n,i,o){return this._getUrlFor({view:dh.EDIT,changeNum:e,project:t,path:n,patchNum:i||"edit",lineNum:o})},navigateToDiff(e,t,n,i,o){this._navigate(this.getUrlForDiff(e,t,n,i,o))},getUrlForOwner(e){return this._getUrlFor({view:dh.SEARCH,owner:e})},getUrlForUserDashboard(e){return this._getUrlFor({view:dh.DASHBOARD,user:e})},getUrlForRoot(){return this._getUrlFor({view:dh.ROOT})},getUrlForRepoDashboard(e,t){return this._getUrlFor({view:dh.DASHBOARD,repo:e,dashboard:t})},navigateToRelativeUrl(e){if(!e.startsWith("/"))throw new Error("navigateToRelativeUrl with non-relative URL");this._navigate(e)},getUrlForRepo(e){return this._getUrlFor({view:dh.REPO,repoName:e})},navigateToRepo(e){this._navigate(this.getUrlForRepo(e))},getUrlForRepoTags(e){return this._getUrlFor({view:dh.REPO,repoName:e,detail:ph.TAGS})},getUrlForRepoBranches(e){return this._getUrlFor({view:dh.REPO,repoName:e,detail:gh.RepoDetailView.BRANCHES})},getUrlForRepoAccess(e){return this._getUrlFor({view:dh.REPO,repoName:e,detail:gh.RepoDetailView.ACCESS})},getUrlForRepoCommands(e){return this._getUrlFor({view:dh.REPO,repoName:e,detail:gh.RepoDetailView.COMMANDS})},getUrlForRepoDashboards(e){return this._getUrlFor({view:dh.REPO,repoName:e,detail:gh.RepoDetailView.DASHBOARDS})},getUrlForGroup(e){return this._getUrlFor({view:dh.GROUP,groupId:e})},getUrlForGroupLog(e){return this._getUrlFor({view:dh.GROUP,groupId:e,detail:gh.GroupDetailView.LOG})},getUrlForGroupMembers(e){return this._getUrlFor({view:dh.GROUP,groupId:e,detail:hh.MEMBERS})},getUrlForSettings(){return this._getUrlFor({view:dh.SETTINGS})},getFileWebLinks(e,t,n,i){const o={type:uh.FILE,repo:e,commit:t,file:n};return i&&(o.options=i),[].concat(this._generateWeblinks(o))},getPatchSetWeblink(e,t,n){const i={type:uh.PATCHSET,repo:e,commit:t};n&&(i.options=n);const o=this._generateWeblinks(i);return Array.isArray(o)?o.pop():o},getChangeWeblinks(e,t,n){const i={type:uh.CHANGE,repo:e,commit:t};return n&&(i.options=n),[].concat(this._generateWeblinks(i))},getUserDashboard(e="self",t=lh,n="",i={}){const o=i.change&&!!i.change.enable_attention_set,s=i.change&&!!i.change.enable_assignee;return{title:n,sections:t=t.filter(e=>o||!e.attentionSetOnly).filter(e=>s||!e.assigneeOnly).filter(t=>"self"===e||!t.selfOnly).map(t=>({...t,name:t.name,query:t.query.replace(ah,e)}))}}},mh=()=>document.body
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */function _h(e,t){return!e&&!t||!(!e||!t)&&(e.start_line===t.start_line&&e.start_character===t.start_character&&e.end_line===t.end_line&&e.end_character===t.end_character)}function fh(e){if(!e)return null;const t=e.getAttribute("data-value");if(!t)return null;if(t===pl)return pl;const n=Number(t);return Number.isInteger(n)?n:null}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const vh=["autogenerated:gerrit:newWipPatchSet","autogenerated:gerrit:setWorkInProgress"],yh=["autogenerated:gerrit:setReadyForReview"],bh="edit",wh="PARENT";function Ch(e,t){return void 0===e?e===t:`${e}`===`${t}`}function Eh(e){return"-"===`${e}`[0]}function Sh(e){return"number"==typeof e}function Ah(e,t){for(const n of e)if(Ch(n._number,t))return n;console.warn("no revision found")}function xh(e){const t=function(e){const t=function(e){const t=e.find(e=>"edit"===e._number);return t&&e.find(e=>e._number===t.basePatchNum)||null}(e);return t?t._number:-1}(e),n=e=>"edit"===e._number?2*t:2*(e._number-1)+1;return e.sort((e,t)=>n(t)-n(e))}function Ph(e){if(!e)return[];let t=[];if(e.revisions&&Object.keys(e.revisions).length){const n=e.revisions;t=xh(Object.keys(e.revisions).map(e=>({sha:e,...n[e]}))).map(e=>({num:e._number,desc:e.description,sha:e.sha}))}return Rh(e,t)}function Rh(e,t){if(!e.messages||!e.messages.length)return t;const n=new Map;let i=!!e.work_in_progress;for(let t=0;t<e.messages.length;t++){const o=e.messages[t];o.tag&&vh.includes(o.tag)?i=!0:o.tag&&yh.includes(o.tag)&&(i=!1),o._revision_number&&!1!==n.get(`${o._revision_number}`)&&n.set(`${o._revision_number}`,i)}for(let e=0;e<t.length;e++)t[e].wip=n.get(`${t[e].num}`);return t}function Th(e){if(e&&e.length)return"edit"===e[0].num?e[1].num:e[0].num}function Ih(e,t){const n=Th(Ph(e));return t.getChangeDetail(e._number).then(t=>{if(!t){const e=new Error("Change detail not found.");return Promise.reject(e)}const i=Th(Ph(t));if(!i||!n){const e=new Error("Unable to check for latest patchset.");return Promise.reject(e)}return{isLatest:i<=n,newStatus:e.status!==t.status?t.status:null,newMessages:(e.messages||[]).length<(t.messages||[]).length}})}function kh(e,t){return(t=t||[]).findIndex(t=>`${t._number}`===`${e}`)}function Oh(e){return-parseInt(`${e}`,10)}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */class Nh{constructor(e){this.change=e}getMaxParents(){return this.change&&this.change.revisions?Object.values(this.change.revisions).reduce((e,t)=>Math.max(t.commit?t.commit.parents.length:0,e),0):0}getParentCountMap(){const e={};return this.change&&this.change.revisions?(Object.values(this.change.revisions).forEach(t=>{t.commit&&(e[t._number]=t.commit.parents.length)}),e):{}}getParentCount(e){return this.getParentCountMap()[e]}getParentId(e,t){if(!this.change.revisions)return;const n=Object.values(this.change.revisions).find(t=>Ch(t._number,e));return n&&n.commit?n.commit.parents[t].commit:void 0}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */let Lh=void 0;function Dh(e){Lh=e}function $h(){return Lh}
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */window.addEventListener("WebComponentsReady",()=>{const e=document.createElement("div");e.setAttribute("style","width:100px;height:100px;overflow:scroll"),document.body.appendChild(e),Lh=e.offsetWidth===e.clientWidth,e.remove()});
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Mh=document.createElement("template");function Fh(){document.head.appendChild(
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function(){const e=document.createElement("template");return e.innerHTML="\n  <custom-style id=\"dark-theme\"><style is=\"custom-style\">\n    html {\n      /**\n       * Sections and variables must stay consistent with app-theme.js.\n       *\n       * Only modify color variables in this theme file. dark-theme extends\n       * app-theme, so there is no need to repeat all variables, but for colors\n       * it does make sense to list them all: If you override one color, then\n       * you probably want to override all.\n       */\n\n      /* text colors */\n      --primary-text-color: #e8eaed;\n      --link-color: #8ab4f8;\n      --comment-text-color: var(--primary-text-color);\n      --deemphasized-text-color: #9aa0a6;\n      --default-button-text-color: #8ab4f8;\n      --chip-selected-text-color: #d2e3fc;\n      --error-text-color: red;\n      --primary-button-text-color: black;\n        /* Used on text color for change list doesn't need user's attention. */\n      --reviewed-text-color: #dadce0;\n      --vote-text-color: black;\n      --status-text-color: black;\n      --tooltip-text-color: white;\n      --negative-red-text-color: #f28b82;\n      --positive-green-text-color: #81c995;\n\n      /* background colors */\n      /* primary background colors */\n      --background-color-primary: #202124;\n      --background-color-secondary: #2f3034;\n      --background-color-tertiary: #3b3d3f;\n      /* directly derived from primary background colors */\n      /*   empty, because inheriting from app-theme is just fine\n      /* unique background colors */\n      --assignee-highlight-color: #3a361c;\n      --chip-selected-background-color: #3c4455;\n      --edit-mode-background-color: #5c0a36;\n      --emphasis-color: #383f4a;\n      --hover-background-color: rgba(161, 194, 250, 0.2);\n      --disabled-button-background-color: #484a4d;\n      --primary-button-background-color: var(--link-color);\n      --selection-background-color: rgba(161, 194, 250, 0.1);\n      --tooltip-background-color: #111;\n      /* comment background colors */\n      --comment-background-color: #3c3f43;\n      --robot-comment-background-color: #1e3a5f;\n      --unresolved-comment-background-color: #614a19;\n      /* vote background colors */\n      --vote-color-approved: #7fb66b;\n      --vote-color-disliked: #bf6874;\n      --vote-color-neutral: #597280;\n      --vote-color-recommended: #3f6732;\n      --vote-color-rejected: #ac2d3e;\n\n      /* misc colors */\n      --border-color: #5f6368;\n      --comment-separator-color: var(--border-color);\n\n      /* status colors */\n      --status-merged: #5bb974;\n      --status-abandoned: #dadce0;\n      --status-wip: #bcaaa4;\n      --status-private: #d7aefb;\n      --status-conflict: #f28b82;\n      --status-active: #669df6;\n      --status-ready: #f439a0;\n      --status-custom: #af5cf7;\n\n      /* fonts */\n      --font-weight-bold: 700; /* 700 is the same as 'bold' */\n\n      /* spacing */\n\n      /* header and footer */\n      --footer-background-color: var(--background-color-tertiary);\n      --footer-border-top: 1px solid var(--border-color);\n      --header-background-color: var(--background-color-tertiary);\n      --header-border-bottom: 1px solid var(--border-color);\n      --header-padding: 0 var(--spacing-l);\n      --header-text-color: var(--primary-text-color);\n\n      /* diff colors */\n      --dark-add-highlight-color: #133820;\n      --dark-rebased-add-highlight-color: rgba(11, 255, 155, 0.15);\n      --dark-rebased-remove-highlight-color: rgba(255, 139, 6, 0.15);\n      --dark-remove-highlight-color: #62110f;\n      --diff-blank-background-color: var(--background-color-secondary);\n      --diff-context-control-background-color: #333311;\n      --diff-context-control-border-color: var(--border-color);\n      --diff-context-control-color: var(--deemphasized-text-color);\n      --diff-highlight-range-color: rgba(0, 100, 200, 0.5);\n      --diff-highlight-range-hover-color: rgba(0, 150, 255, 0.5);\n      --diff-selection-background-color: #3a71d8;\n      --diff-tab-indicator-color: var(--deemphasized-text-color);\n      --diff-trailing-whitespace-indicator: #ff9ad2;\n      --light-add-highlight-color: #0f401f;\n      --light-rebased-add-highlight-color: #487165;\n      --light-moved-add-highlight-color: #487165;\n      --light-remove-add-highlight-color: #2f3f2f;\n      --light-remove-highlight-color: #320404;\n      --coverage-covered: #112826;\n      --coverage-not-covered: #6b3600;\n\n      /* syntax colors */\n      --syntax-attr-color: #80cbbf;\n      --syntax-attribute-color: var(--primary-text-color);\n      --syntax-built_in-color: #f7c369;\n      --syntax-comment-color: var(--deemphasized-text-color);\n      --syntax-default-color: var(--primary-text-color);\n      --syntax-doctag-weight: bold;\n      --syntax-function-color: var(--primary-text-color);\n      --syntax-keyword-color: #cd4cf0;\n      --syntax-link-color: #c792ea;\n      --syntax-literal-color: #eefff7;\n      --syntax-meta-color: #6d7eee;\n      --syntax-meta-keyword-color: #eefff7;\n      --syntax-number-color: #00998a;\n      --syntax-params-color: var(--primary-text-color);\n      --syntax-regexp-color: #f77669;\n      --syntax-selector-attr-color: #80cbbf;\n      --syntax-selector-class-color: #ffcb68;\n      --syntax-selector-id-color: #f77669;\n      --syntax-selector-pseudo-color: #c792ea;\n      --syntax-string-color: #c3e88d;\n      --syntax-tag-color: #f77669;\n      --syntax-template-tag-color: #c792ea;\n      --syntax-template-variable-color: #f77669;\n      --syntax-title-color: #75a5ff;\n      --syntax-type-color: #dd5f5f;\n      --syntax-variable-color: #f77669;\n\n      /* misc */\n\n      /* paper and iron component overrides */\n      --iron-overlay-backdrop-background-color: white;\n\n      /* rules applied to <html> */\n      background-color: var(--view-background-color);\n    }\n  </style></custom-style>",e}().content)}Mh.innerHTML="\n<custom-style id=\"light-theme\"><style is=\"custom-style\">\n  html {\n    /**\n     * When adding a new color variable make sure to also add it to the other\n     * theme files in the same directory.\n     *\n     * For colors prefer lower case hex colors.\n     *\n     * Note that plugins might be using these variables, so removing a variable\n     * can be a breaking change that should go into the release notes.\n     */\n\n    /* text colors */\n    --primary-text-color: black;\n    --link-color: #2a66d9;\n    --comment-text-color: black;\n    --deemphasized-text-color: #5F6368;\n    --default-button-text-color: #2a66d9;\n    --chip-selected-text-color: var(--default-button-text-color);\n    --error-text-color: red;\n    --primary-button-text-color: white;\n      /* Used on text color for change list that doesn't need user's attention. */\n    --reviewed-text-color: black;\n    --vote-text-color: black;\n    --status-text-color: white;\n    --tooltip-text-color: white;\n    --negative-red-text-color: #d93025;\n    --positive-green-text-color: #188038;\n\n    /* background colors */\n    /* primary background colors */\n    --background-color-primary: #ffffff;\n    --background-color-secondary: #f8f9fa;\n    --background-color-tertiary: #f1f3f4;\n    /* directly derived from primary background colors */\n    --chip-background-color: var(--background-color-tertiary);\n    --default-button-background-color: var(--background-color-primary);\n    --dialog-background-color: var(--background-color-primary);\n    --dropdown-background-color: var(--background-color-primary);\n    --expanded-background-color: var(--background-color-tertiary);\n    --select-background-color: var(--background-color-secondary);\n    --shell-command-background-color: var(--background-color-secondary);\n    --shell-command-decoration-background-color: var(--background-color-tertiary);\n    --table-header-background-color: var(--background-color-secondary);\n    --table-subheader-background-color: var(--background-color-tertiary);\n    --view-background-color: var(--background-color-primary);\n    /* unique background colors */\n    --assignee-highlight-color: #fcfad6;\n    --chip-selected-background-color: #e8f0fe;\n    --edit-mode-background-color: #ebf5fb;\n    --emphasis-color: #fff9c4;\n    --hover-background-color: rgba(161, 194, 250, 0.2);\n    --disabled-button-background-color: #e8eaed;\n    --primary-button-background-color: #2a66d9;\n    --selection-background-color: rgba(161, 194, 250, 0.1);\n    --tooltip-background-color: #333;\n    /* comment background colors */\n    --comment-background-color: #e8eaed;\n    --robot-comment-background-color: #e8f0fe;\n    --unresolved-comment-background-color: #fef7e0;\n    /* vote background colors */\n    --vote-color-approved: #9fcc6b;\n    --vote-color-disliked: #f7c4cb;\n    --vote-color-neutral: #ebf5fb;\n    --vote-color-recommended: #c9dfaf;\n    --vote-color-rejected: #f7a1ad;\n\n    /* misc colors */\n    --border-color: #e8e8e8;\n    --comment-separator-color: #dadce0;\n\n    /* status colors */\n    --status-merged: #188038;\n    --status-abandoned: #5f6368;\n    --status-wip: #795548;\n    --status-private: #a142f4;\n    --status-conflict: #d93025;\n    --status-active: #1976d2;\n    --status-ready: #b80672;\n    --status-custom: #681da8;\n\n    /* fonts */\n    --font-family: 'Roboto', -apple-system, BlinkMacSystemFont, 'Segoe UI', Helvetica, Arial, sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol';\n    --header-font-family: 'Open Sans', 'Roboto', -apple-system, BlinkMacSystemFont, 'Segoe UI', Helvetica, Arial, sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol';\n    --monospace-font-family: 'Roboto Mono', 'SF Mono', 'Lucida Console', Monaco, monospace;\n    --font-size-code: 12px;     /* 12px mono */\n    --font-size-mono: .929rem;  /* 13px mono */\n    --font-size-small: .857rem; /* 12px */\n    --font-size-normal: 1rem;   /* 14px */\n    --font-size-h3: 1.143rem;   /* 16px */\n    --font-size-h2: 1.429rem;   /* 20px */\n    --font-size-h1: 1.714rem;   /* 24px */\n    --line-height-code: 1.334;      /* 16px */\n    --line-height-mono: 1.286rem;   /* 18px */\n    --line-height-small: 1.143rem;  /* 16px */\n    --line-height-normal: 1.429rem; /* 20px */\n    --line-height-h3: 1.714rem;     /* 24px */\n    --line-height-h2: 2rem;         /* 28px */\n    --line-height-h1: 2.286rem;     /* 32px */\n    --font-weight-normal: 400; /* 400 is the same as 'normal' */\n    --font-weight-bold: 500;\n    --font-weight-h1: 400;\n    --font-weight-h2: 400;\n    --font-weight-h3: 400;\n\n    /* spacing */\n    --spacing-xxs: 1px;\n    --spacing-xs: 2px;\n    --spacing-s: 4px;\n    --spacing-m: 8px;\n    --spacing-l: 12px;\n    --spacing-xl: 16px;\n    --spacing-xxl: 24px;\n\n    /* header and footer */\n    --footer-background-color: transparent;\n    --footer-border-top: none;\n    --header-background-color: var(--background-color-tertiary);\n    --header-border-bottom: 1px solid var(--border-color);\n    --header-border-image: '';\n    --header-box-shadow: none;\n    --header-padding: 0 var(--spacing-l);\n    --header-icon-size: 0em;\n    --header-icon: none;\n    --header-text-color: black;\n    --header-title-content: 'Gerrit';\n    --header-title-font-size: 1.75rem;\n\n    /* diff colors */\n    --dark-add-highlight-color: #aaf2aa;\n    --dark-rebased-add-highlight-color: #d7d7f9;\n    --dark-rebased-remove-highlight-color: #f7e8b7;\n    --dark-remove-highlight-color: #ffcdd2;\n    --diff-blank-background-color: var(--background-color-secondary);\n    --diff-context-control-background-color: #fff7d4;\n    --diff-context-control-border-color: #f6e6a5;\n    --diff-context-control-color: var(--deemphasized-text-color);\n    --diff-highlight-range-color: rgba(255, 213, 0, 0.5);\n    --diff-highlight-range-hover-color: rgba(255, 255, 0, 0.5);\n    --diff-selection-background-color: #c7dbf9;\n    --diff-tab-indicator-color: var(--deemphasized-text-color);\n    --diff-trailing-whitespace-indicator: #ff9ad2;\n    --light-add-highlight-color: #d8fed8;\n    --light-rebased-add-highlight-color: #eef;\n    --light-moved-add-highlight-color: #eef;\n    --light-remove-add-highlight-color: #fff8dc;\n    --light-remove-highlight-color: #ffebee;\n    --coverage-covered: #e0f2f1;\n    --coverage-not-covered: #ffd1a4;\n\n    /* syntax colors */\n    --syntax-attr-color: #219;\n    --syntax-attribute-color: var(--primary-text-color);\n    --syntax-built_in-color: #30a;\n    --syntax-comment-color: #3f7f5f;\n    --syntax-default-color: var(--primary-text-color);\n    --syntax-doctag-weight: bold;\n    --syntax-function-color: var(--primary-text-color);\n    --syntax-keyword-color: #9e0069;\n    --syntax-link-color: #219;\n    --syntax-literal-color: #219;\n    --syntax-meta-color: #ff1717;\n    --syntax-meta-keyword-color: #219;\n    --syntax-number-color: #164;\n    --syntax-params-color: var(--primary-text-color);\n    --syntax-regexp-color: #fa8602;\n    --syntax-selector-attr-color: #fa8602;\n    --syntax-selector-class-color: #164;\n    --syntax-selector-id-color: #2a00ff;\n    --syntax-selector-pseudo-color: #fa8602;\n    --syntax-string-color: #2a00ff;\n    --syntax-tag-color: #170;\n    --syntax-template-tag-color: #fa8602;\n    --syntax-template-variable-color: #0000c0;\n    --syntax-title-color: #0000c0;\n    --syntax-type-color: #2a66d9;\n    --syntax-variable-color: var(--primary-text-color);\n\n    /* elevation */\n    --elevation-level-1: 0px 1px 2px 0px rgba(60, 64, 67, .30), 0px 1px 3px 1px rgba(60, 64, 67, .15);\n    --elevation-level-2: 0px 1px 2px 0px rgba(60, 64, 67, .30), 0px 2px 6px 2px rgba(60, 64, 67, .15);\n    --elevation-level-3: 0px 1px 3px 0px rgba(60, 64, 67, .30), 0px 4px 8px 3px rgba(60, 64, 67, .15);\n    --elevation-level-4: 0px 2px 3px 0px rgba(60, 64, 67, .30), 0px 6px 10px 4px rgba(60, 64, 67, .15);\n    --elevation-level-5: 0px 4px 4px 0px rgba(60, 64, 67, .30), 0px 8px 12px 6px rgba(60, 64, 67, .15);\n\n    /* misc */\n    --border-radius: 4px;\n    --reply-overlay-z-index: 1000;\n\n    /* paper and iron component overrides */\n    --iron-overlay-backdrop-background-color: black;\n    --iron-overlay-backdrop-opacity: 0.32;\n    --iron-overlay-backdrop: {\n      transition: none;\n    };\n  }\n  @media screen and (max-width: 50em) {\n    html {\n      --spacing-xxs: 1px;\n      --spacing-xs: 1px;\n      --spacing-s: 2px;\n      --spacing-m: 4px;\n      --spacing-l: 8px;\n      --spacing-xl: 12px;\n      --spacing-xxl: 16px;\n    }\n  }\n</style></custom-style>",document.head.appendChild(Mh.content);
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Bh=document.createElement("template");Bh.innerHTML="<dom-module id=\"gr-menu-page-styles\">\n  <template>\n    <style>\n      :host {\n        display: block;\n      }\n      main {\n        margin: var(--spacing-xxl) auto;\n        max-width: 50em;\n      }\n      .mainHeader {\n        margin-left: 14em;\n        padding: var(--spacing-l) 0 var(--spacing-l) var(--spacing-xxl);\n      }\n      main.table,\n      .mainHeader {\n        margin-top: 0;\n        margin-right: 0;\n        margin-left: 14em;\n        max-width: none;\n      }\n      h2.edited:after {\n        color: var(--deemphasized-text-color);\n        content: ' *';\n      }\n      .loading {\n        color: var(--deemphasized-text-color);\n        padding: var(--spacing-l);\n      }\n      @media only screen and (max-width: 67em) {\n        main {\n          margin: var(--spacing-xxl) 0 var(--spacing-xxl) 15em;\n        }\n        main.table {\n          margin-left: 14em;\n        }\n      }\n      @media only screen and (max-width: 53em) {\n        .loading {\n          padding: 0 var(--spacing-l);\n        }\n        main {\n          margin: var(--spacing-xxl) var(--spacing-l);\n        }\n        main.table {\n          margin: 0;\n        }\n        .mainHeader {\n          margin-left: 0;\n          padding: var(--spacing-m) 0 var(--spacing-m) var(--spacing-l);\n        }\n      }\n    </style>\n  </template>\n</dom-module>",document.head.appendChild(Bh.content);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const jh={properties:{focused:{type:Boolean,value:!1,notify:!0,readOnly:!0,reflectToAttribute:!0},disabled:{type:Boolean,value:!1,notify:!0,observer:"_disabledChanged",reflectToAttribute:!0},_oldTabIndex:{type:String},_boundFocusBlurHandler:{type:Function,value:function(){return this._focusBlurHandler.bind(this)}}},observers:["_changedControlState(focused, disabled)"],ready:function(){this.addEventListener("focus",this._boundFocusBlurHandler,!0),this.addEventListener("blur",this._boundFocusBlurHandler,!0)},_focusBlurHandler:function(e){this._setFocused("focus"===e.type)},_disabledChanged:function(e,t){this.setAttribute("aria-disabled",e?"true":"false"),this.style.pointerEvents=e?"none":"",e?(this._oldTabIndex=this.getAttribute("tabindex"),this._setFocused(!1),this.tabIndex=-1,this.blur()):void 0!==this._oldTabIndex&&(null===this._oldTabIndex?this.removeAttribute("tabindex"):this.setAttribute("tabindex",this._oldTabIndex))},_changedControlState:function(){this._controlStateChanged&&this._controlStateChanged()}};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style>
      :host {
        position: fixed;
      }

      #contentWrapper ::slotted(*) {
        overflow: auto;
      }

      #contentWrapper.animating ::slotted(*) {
        overflow: hidden;
        pointer-events: none;
      }
    </style>

    <div id="contentWrapper">
      <slot id="content" name="dropdown-content"></slot>
    </div>
`,is:"iron-dropdown",behaviors:[jh,Lc,Xc,[{properties:{animationConfig:{type:Object},entryAnimation:{observer:"_entryAnimationChanged",type:String},exitAnimation:{observer:"_exitAnimationChanged",type:String}},_entryAnimationChanged:function(){this.animationConfig=this.animationConfig||{},this.animationConfig.entry=[{name:this.entryAnimation,node:this}]},_exitAnimationChanged:function(){this.animationConfig=this.animationConfig||{},this.animationConfig.exit=[{name:this.exitAnimation,node:this}]},_copyProperties:function(e,t){for(var n in t)e[n]=t[n]},_cloneConfig:function(e){var t={isClone:!0};return this._copyProperties(t,e),t},_getAnimationConfigRecursive:function(e,t,n){var i;if(this.animationConfig)if(this.animationConfig.value&&"function"==typeof this.animationConfig.value)this._warn(this._logf("playAnimation","Please put 'animationConfig' inside of your components 'properties' object instead of outside of it."));else if(i=e?this.animationConfig[e]:this.animationConfig,Array.isArray(i)||(i=[i]),i)for(var o,s=0;o=i[s];s++)if(o.animatable)o.animatable._getAnimationConfigRecursive(o.type||e,t,n);else if(o.id){var r=t[o.id];r?(r.isClone||(t[o.id]=this._cloneConfig(r),r=t[o.id]),this._copyProperties(r,o)):t[o.id]=o}else n.push(o)},getAnimationConfig:function(e){var t={},n=[];for(var i in this._getAnimationConfigRecursive(e,t,n),t)n.push(t[i]);return n}},{_configureAnimations:function(e){var t=[],n=[];if(e.length>0)for(let t,i=0;t=e[i];i++){let e=document.createElement(t.name);if(e.isNeonAnimation){let i=null;e.configure||(e.configure=function(e){return null}),i=e.configure(t),n.push({result:i,config:t,neonAnimation:e})}else console.warn(this.is+":",t.name,"not found!")}for(var i=0;i<n.length;i++){let e=n[i].result,o=n[i].config,s=n[i].neonAnimation;try{"function"!=typeof e.cancel&&(e=document.timeline.play(e))}catch(t){e=null,console.warn("Couldnt play","(",o.name,").",t)}e&&t.push({neonAnimation:s,config:o,animation:e})}return t},_shouldComplete:function(e){for(var t=!0,n=0;n<e.length;n++)if("finished"!=e[n].animation.playState){t=!1;break}return t},_complete:function(e){for(var t=0;t<e.length;t++)e[t].neonAnimation.complete(e[t].config);for(t=0;t<e.length;t++)e[t].animation.cancel()},playAnimation:function(e,t){var n=this.getAnimationConfig(e);if(n){this._active=this._active||{},this._active[e]&&(this._complete(this._active[e]),delete this._active[e]);var i=this._configureAnimations(n);if(0!=i.length){this._active[e]=i;for(var o=0;o<i.length;o++)i[o].animation.onfinish=function(){this._shouldComplete(i)&&(this._complete(i),delete this._active[e],this.fire("neon-animation-finish",t,{bubbles:!1}))}.bind(this)}else this.fire("neon-animation-finish",t,{bubbles:!1})}},cancelAnimation:function(){for(var e in this._active){var t=this._active[e];for(var n in t)t[n].animation.cancel()}this._active={}}}]],properties:{horizontalAlign:{type:String,value:"left",reflectToAttribute:!0},verticalAlign:{type:String,value:"top",reflectToAttribute:!0},openAnimationConfig:{type:Object},closeAnimationConfig:{type:Object},focusTarget:{type:Object},noAnimations:{type:Boolean,value:!1},allowOutsideScroll:{type:Boolean,value:!1,observer:"_allowOutsideScrollChanged"}},listeners:{"neon-animation-finish":"_onNeonAnimationFinish"},observers:["_updateOverlayPosition(positionTarget, verticalAlign, horizontalAlign, verticalOffset, horizontalOffset)"],get containedElement(){for(var e=qo(this.$.content).getDistributedNodes(),t=0,n=e.length;t<n;t++)if(e[t].nodeType===Node.ELEMENT_NODE)return e[t]},ready:function(){this.scrollAction||(this.scrollAction=this.allowOutsideScroll?"refit":"lock"),this._readied=!0},attached:function(){this.sizingTarget&&this.sizingTarget!==this||(this.sizingTarget=this.containedElement||this)},detached:function(){this.cancelAnimation()},_openedChanged:function(){this.opened&&this.disabled?this.cancel():(this.cancelAnimation(),this._updateAnimationConfig(),Kc._openedChanged.apply(this,arguments))},_renderOpened:function(){!this.noAnimations&&this.animationConfig.open?(this.$.contentWrapper.classList.add("animating"),this.playAnimation("open")):Kc._renderOpened.apply(this,arguments)},_renderClosed:function(){!this.noAnimations&&this.animationConfig.close?(this.$.contentWrapper.classList.add("animating"),this.playAnimation("close")):Kc._renderClosed.apply(this,arguments)},_onNeonAnimationFinish:function(){this.$.contentWrapper.classList.remove("animating"),this.opened?this._finishRenderOpened():this._finishRenderClosed()},_updateAnimationConfig:function(){for(var e=this.containedElement,t=[].concat(this.openAnimationConfig||[]).concat(this.closeAnimationConfig||[]),n=0;n<t.length;n++)t[n].node=e;this.animationConfig={open:this.openAnimationConfig,close:this.closeAnimationConfig}},_updateOverlayPosition:function(){this.isAttached&&this.notifyResize()},_allowOutsideScrollChanged:function(e){this._readied&&(e?this.scrollAction&&"lock"!==this.scrollAction||(this.scrollAction="refit"):this.scrollAction="lock")},_applyFocus:function(){var e=this.focusTarget||this.containedElement;e&&this.opened&&!this.noAutoFocus?e.focus():Kc._applyFocus.apply(this,arguments)}});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Hh=ta`
<custom-style>
  <style is="custom-style">
    [hidden] {
      display: none !important;
    }
  </style>
</custom-style>
<custom-style>
  <style is="custom-style">
    html {

      --layout: {
        display: -ms-flexbox;
        display: -webkit-flex;
        display: flex;
      };

      --layout-inline: {
        display: -ms-inline-flexbox;
        display: -webkit-inline-flex;
        display: inline-flex;
      };

      --layout-horizontal: {
        @apply --layout;

        -ms-flex-direction: row;
        -webkit-flex-direction: row;
        flex-direction: row;
      };

      --layout-horizontal-reverse: {
        @apply --layout;

        -ms-flex-direction: row-reverse;
        -webkit-flex-direction: row-reverse;
        flex-direction: row-reverse;
      };

      --layout-vertical: {
        @apply --layout;

        -ms-flex-direction: column;
        -webkit-flex-direction: column;
        flex-direction: column;
      };

      --layout-vertical-reverse: {
        @apply --layout;

        -ms-flex-direction: column-reverse;
        -webkit-flex-direction: column-reverse;
        flex-direction: column-reverse;
      };

      --layout-wrap: {
        -ms-flex-wrap: wrap;
        -webkit-flex-wrap: wrap;
        flex-wrap: wrap;
      };

      --layout-wrap-reverse: {
        -ms-flex-wrap: wrap-reverse;
        -webkit-flex-wrap: wrap-reverse;
        flex-wrap: wrap-reverse;
      };

      --layout-flex-auto: {
        -ms-flex: 1 1 auto;
        -webkit-flex: 1 1 auto;
        flex: 1 1 auto;
      };

      --layout-flex-none: {
        -ms-flex: none;
        -webkit-flex: none;
        flex: none;
      };

      --layout-flex: {
        -ms-flex: 1 1 0.000000001px;
        -webkit-flex: 1;
        flex: 1;
        -webkit-flex-basis: 0.000000001px;
        flex-basis: 0.000000001px;
      };

      --layout-flex-2: {
        -ms-flex: 2;
        -webkit-flex: 2;
        flex: 2;
      };

      --layout-flex-3: {
        -ms-flex: 3;
        -webkit-flex: 3;
        flex: 3;
      };

      --layout-flex-4: {
        -ms-flex: 4;
        -webkit-flex: 4;
        flex: 4;
      };

      --layout-flex-5: {
        -ms-flex: 5;
        -webkit-flex: 5;
        flex: 5;
      };

      --layout-flex-6: {
        -ms-flex: 6;
        -webkit-flex: 6;
        flex: 6;
      };

      --layout-flex-7: {
        -ms-flex: 7;
        -webkit-flex: 7;
        flex: 7;
      };

      --layout-flex-8: {
        -ms-flex: 8;
        -webkit-flex: 8;
        flex: 8;
      };

      --layout-flex-9: {
        -ms-flex: 9;
        -webkit-flex: 9;
        flex: 9;
      };

      --layout-flex-10: {
        -ms-flex: 10;
        -webkit-flex: 10;
        flex: 10;
      };

      --layout-flex-11: {
        -ms-flex: 11;
        -webkit-flex: 11;
        flex: 11;
      };

      --layout-flex-12: {
        -ms-flex: 12;
        -webkit-flex: 12;
        flex: 12;
      };

      /* alignment in cross axis */

      --layout-start: {
        -ms-flex-align: start;
        -webkit-align-items: flex-start;
        align-items: flex-start;
      };

      --layout-center: {
        -ms-flex-align: center;
        -webkit-align-items: center;
        align-items: center;
      };

      --layout-end: {
        -ms-flex-align: end;
        -webkit-align-items: flex-end;
        align-items: flex-end;
      };

      --layout-baseline: {
        -ms-flex-align: baseline;
        -webkit-align-items: baseline;
        align-items: baseline;
      };

      /* alignment in main axis */

      --layout-start-justified: {
        -ms-flex-pack: start;
        -webkit-justify-content: flex-start;
        justify-content: flex-start;
      };

      --layout-center-justified: {
        -ms-flex-pack: center;
        -webkit-justify-content: center;
        justify-content: center;
      };

      --layout-end-justified: {
        -ms-flex-pack: end;
        -webkit-justify-content: flex-end;
        justify-content: flex-end;
      };

      --layout-around-justified: {
        -ms-flex-pack: distribute;
        -webkit-justify-content: space-around;
        justify-content: space-around;
      };

      --layout-justified: {
        -ms-flex-pack: justify;
        -webkit-justify-content: space-between;
        justify-content: space-between;
      };

      --layout-center-center: {
        @apply --layout-center;
        @apply --layout-center-justified;
      };

      /* self alignment */

      --layout-self-start: {
        -ms-align-self: flex-start;
        -webkit-align-self: flex-start;
        align-self: flex-start;
      };

      --layout-self-center: {
        -ms-align-self: center;
        -webkit-align-self: center;
        align-self: center;
      };

      --layout-self-end: {
        -ms-align-self: flex-end;
        -webkit-align-self: flex-end;
        align-self: flex-end;
      };

      --layout-self-stretch: {
        -ms-align-self: stretch;
        -webkit-align-self: stretch;
        align-self: stretch;
      };

      --layout-self-baseline: {
        -ms-align-self: baseline;
        -webkit-align-self: baseline;
        align-self: baseline;
      };

      /* multi-line alignment in main axis */

      --layout-start-aligned: {
        -ms-flex-line-pack: start;  /* IE10 */
        -ms-align-content: flex-start;
        -webkit-align-content: flex-start;
        align-content: flex-start;
      };

      --layout-end-aligned: {
        -ms-flex-line-pack: end;  /* IE10 */
        -ms-align-content: flex-end;
        -webkit-align-content: flex-end;
        align-content: flex-end;
      };

      --layout-center-aligned: {
        -ms-flex-line-pack: center;  /* IE10 */
        -ms-align-content: center;
        -webkit-align-content: center;
        align-content: center;
      };

      --layout-between-aligned: {
        -ms-flex-line-pack: justify;  /* IE10 */
        -ms-align-content: space-between;
        -webkit-align-content: space-between;
        align-content: space-between;
      };

      --layout-around-aligned: {
        -ms-flex-line-pack: distribute;  /* IE10 */
        -ms-align-content: space-around;
        -webkit-align-content: space-around;
        align-content: space-around;
      };

      /*******************************
                Other Layout
      *******************************/

      --layout-block: {
        display: block;
      };

      --layout-invisible: {
        visibility: hidden !important;
      };

      --layout-relative: {
        position: relative;
      };

      --layout-fit: {
        position: absolute;
        top: 0;
        right: 0;
        bottom: 0;
        left: 0;
      };

      --layout-scroll: {
        -webkit-overflow-scrolling: touch;
        overflow: auto;
      };

      --layout-fullbleed: {
        margin: 0;
        height: 100vh;
      };

      /* fixed position */

      --layout-fixed-top: {
        position: fixed;
        top: 0;
        left: 0;
        right: 0;
      };

      --layout-fixed-right: {
        position: fixed;
        top: 0;
        right: 0;
        bottom: 0;
      };

      --layout-fixed-bottom: {
        position: fixed;
        right: 0;
        bottom: 0;
        left: 0;
      };

      --layout-fixed-left: {
        position: fixed;
        top: 0;
        bottom: 0;
        left: 0;
      };

    }
  </style>
</custom-style>`;Hh.setAttribute("style","display: none;"),document.head.appendChild(Hh.content);var Uh=document.createElement("style");Uh.textContent="[hidden] { display: none !important; }",document.head.appendChild(Uh);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Gh=ta`
<custom-style>
  <style is="custom-style">
    html {

      /* Material Design color palette for Google products */

      --google-red-100: #f4c7c3;
      --google-red-300: #e67c73;
      --google-red-500: #db4437;
      --google-red-700: #c53929;

      --google-blue-100: #c6dafc;
      --google-blue-300: #7baaf7;
      --google-blue-500: #4285f4;
      --google-blue-700: #3367d6;

      --google-green-100: #b7e1cd;
      --google-green-300: #57bb8a;
      --google-green-500: #0f9d58;
      --google-green-700: #0b8043;

      --google-yellow-100: #fce8b2;
      --google-yellow-300: #f7cb4d;
      --google-yellow-500: #f4b400;
      --google-yellow-700: #f09300;

      --google-grey-100: #f5f5f5;
      --google-grey-300: #e0e0e0;
      --google-grey-500: #9e9e9e;
      --google-grey-700: #616161;

      /* Material Design color palette from online spec document */

      --paper-red-50: #ffebee;
      --paper-red-100: #ffcdd2;
      --paper-red-200: #ef9a9a;
      --paper-red-300: #e57373;
      --paper-red-400: #ef5350;
      --paper-red-500: #f44336;
      --paper-red-600: #e53935;
      --paper-red-700: #d32f2f;
      --paper-red-800: #c62828;
      --paper-red-900: #b71c1c;
      --paper-red-a100: #ff8a80;
      --paper-red-a200: #ff5252;
      --paper-red-a400: #ff1744;
      --paper-red-a700: #d50000;

      --paper-pink-50: #fce4ec;
      --paper-pink-100: #f8bbd0;
      --paper-pink-200: #f48fb1;
      --paper-pink-300: #f06292;
      --paper-pink-400: #ec407a;
      --paper-pink-500: #e91e63;
      --paper-pink-600: #d81b60;
      --paper-pink-700: #c2185b;
      --paper-pink-800: #ad1457;
      --paper-pink-900: #880e4f;
      --paper-pink-a100: #ff80ab;
      --paper-pink-a200: #ff4081;
      --paper-pink-a400: #f50057;
      --paper-pink-a700: #c51162;

      --paper-purple-50: #f3e5f5;
      --paper-purple-100: #e1bee7;
      --paper-purple-200: #ce93d8;
      --paper-purple-300: #ba68c8;
      --paper-purple-400: #ab47bc;
      --paper-purple-500: #9c27b0;
      --paper-purple-600: #8e24aa;
      --paper-purple-700: #7b1fa2;
      --paper-purple-800: #6a1b9a;
      --paper-purple-900: #4a148c;
      --paper-purple-a100: #ea80fc;
      --paper-purple-a200: #e040fb;
      --paper-purple-a400: #d500f9;
      --paper-purple-a700: #aa00ff;

      --paper-deep-purple-50: #ede7f6;
      --paper-deep-purple-100: #d1c4e9;
      --paper-deep-purple-200: #b39ddb;
      --paper-deep-purple-300: #9575cd;
      --paper-deep-purple-400: #7e57c2;
      --paper-deep-purple-500: #673ab7;
      --paper-deep-purple-600: #5e35b1;
      --paper-deep-purple-700: #512da8;
      --paper-deep-purple-800: #4527a0;
      --paper-deep-purple-900: #311b92;
      --paper-deep-purple-a100: #b388ff;
      --paper-deep-purple-a200: #7c4dff;
      --paper-deep-purple-a400: #651fff;
      --paper-deep-purple-a700: #6200ea;

      --paper-indigo-50: #e8eaf6;
      --paper-indigo-100: #c5cae9;
      --paper-indigo-200: #9fa8da;
      --paper-indigo-300: #7986cb;
      --paper-indigo-400: #5c6bc0;
      --paper-indigo-500: #3f51b5;
      --paper-indigo-600: #3949ab;
      --paper-indigo-700: #303f9f;
      --paper-indigo-800: #283593;
      --paper-indigo-900: #1a237e;
      --paper-indigo-a100: #8c9eff;
      --paper-indigo-a200: #536dfe;
      --paper-indigo-a400: #3d5afe;
      --paper-indigo-a700: #304ffe;

      --paper-blue-50: #e3f2fd;
      --paper-blue-100: #bbdefb;
      --paper-blue-200: #90caf9;
      --paper-blue-300: #64b5f6;
      --paper-blue-400: #42a5f5;
      --paper-blue-500: #2196f3;
      --paper-blue-600: #1e88e5;
      --paper-blue-700: #1976d2;
      --paper-blue-800: #1565c0;
      --paper-blue-900: #0d47a1;
      --paper-blue-a100: #82b1ff;
      --paper-blue-a200: #448aff;
      --paper-blue-a400: #2979ff;
      --paper-blue-a700: #2962ff;

      --paper-light-blue-50: #e1f5fe;
      --paper-light-blue-100: #b3e5fc;
      --paper-light-blue-200: #81d4fa;
      --paper-light-blue-300: #4fc3f7;
      --paper-light-blue-400: #29b6f6;
      --paper-light-blue-500: #03a9f4;
      --paper-light-blue-600: #039be5;
      --paper-light-blue-700: #0288d1;
      --paper-light-blue-800: #0277bd;
      --paper-light-blue-900: #01579b;
      --paper-light-blue-a100: #80d8ff;
      --paper-light-blue-a200: #40c4ff;
      --paper-light-blue-a400: #00b0ff;
      --paper-light-blue-a700: #0091ea;

      --paper-cyan-50: #e0f7fa;
      --paper-cyan-100: #b2ebf2;
      --paper-cyan-200: #80deea;
      --paper-cyan-300: #4dd0e1;
      --paper-cyan-400: #26c6da;
      --paper-cyan-500: #00bcd4;
      --paper-cyan-600: #00acc1;
      --paper-cyan-700: #0097a7;
      --paper-cyan-800: #00838f;
      --paper-cyan-900: #006064;
      --paper-cyan-a100: #84ffff;
      --paper-cyan-a200: #18ffff;
      --paper-cyan-a400: #00e5ff;
      --paper-cyan-a700: #00b8d4;

      --paper-teal-50: #e0f2f1;
      --paper-teal-100: #b2dfdb;
      --paper-teal-200: #80cbc4;
      --paper-teal-300: #4db6ac;
      --paper-teal-400: #26a69a;
      --paper-teal-500: #009688;
      --paper-teal-600: #00897b;
      --paper-teal-700: #00796b;
      --paper-teal-800: #00695c;
      --paper-teal-900: #004d40;
      --paper-teal-a100: #a7ffeb;
      --paper-teal-a200: #64ffda;
      --paper-teal-a400: #1de9b6;
      --paper-teal-a700: #00bfa5;

      --paper-green-50: #e8f5e9;
      --paper-green-100: #c8e6c9;
      --paper-green-200: #a5d6a7;
      --paper-green-300: #81c784;
      --paper-green-400: #66bb6a;
      --paper-green-500: #4caf50;
      --paper-green-600: #43a047;
      --paper-green-700: #388e3c;
      --paper-green-800: #2e7d32;
      --paper-green-900: #1b5e20;
      --paper-green-a100: #b9f6ca;
      --paper-green-a200: #69f0ae;
      --paper-green-a400: #00e676;
      --paper-green-a700: #00c853;

      --paper-light-green-50: #f1f8e9;
      --paper-light-green-100: #dcedc8;
      --paper-light-green-200: #c5e1a5;
      --paper-light-green-300: #aed581;
      --paper-light-green-400: #9ccc65;
      --paper-light-green-500: #8bc34a;
      --paper-light-green-600: #7cb342;
      --paper-light-green-700: #689f38;
      --paper-light-green-800: #558b2f;
      --paper-light-green-900: #33691e;
      --paper-light-green-a100: #ccff90;
      --paper-light-green-a200: #b2ff59;
      --paper-light-green-a400: #76ff03;
      --paper-light-green-a700: #64dd17;

      --paper-lime-50: #f9fbe7;
      --paper-lime-100: #f0f4c3;
      --paper-lime-200: #e6ee9c;
      --paper-lime-300: #dce775;
      --paper-lime-400: #d4e157;
      --paper-lime-500: #cddc39;
      --paper-lime-600: #c0ca33;
      --paper-lime-700: #afb42b;
      --paper-lime-800: #9e9d24;
      --paper-lime-900: #827717;
      --paper-lime-a100: #f4ff81;
      --paper-lime-a200: #eeff41;
      --paper-lime-a400: #c6ff00;
      --paper-lime-a700: #aeea00;

      --paper-yellow-50: #fffde7;
      --paper-yellow-100: #fff9c4;
      --paper-yellow-200: #fff59d;
      --paper-yellow-300: #fff176;
      --paper-yellow-400: #ffee58;
      --paper-yellow-500: #ffeb3b;
      --paper-yellow-600: #fdd835;
      --paper-yellow-700: #fbc02d;
      --paper-yellow-800: #f9a825;
      --paper-yellow-900: #f57f17;
      --paper-yellow-a100: #ffff8d;
      --paper-yellow-a200: #ffff00;
      --paper-yellow-a400: #ffea00;
      --paper-yellow-a700: #ffd600;

      --paper-amber-50: #fff8e1;
      --paper-amber-100: #ffecb3;
      --paper-amber-200: #ffe082;
      --paper-amber-300: #ffd54f;
      --paper-amber-400: #ffca28;
      --paper-amber-500: #ffc107;
      --paper-amber-600: #ffb300;
      --paper-amber-700: #ffa000;
      --paper-amber-800: #ff8f00;
      --paper-amber-900: #ff6f00;
      --paper-amber-a100: #ffe57f;
      --paper-amber-a200: #ffd740;
      --paper-amber-a400: #ffc400;
      --paper-amber-a700: #ffab00;

      --paper-orange-50: #fff3e0;
      --paper-orange-100: #ffe0b2;
      --paper-orange-200: #ffcc80;
      --paper-orange-300: #ffb74d;
      --paper-orange-400: #ffa726;
      --paper-orange-500: #ff9800;
      --paper-orange-600: #fb8c00;
      --paper-orange-700: #f57c00;
      --paper-orange-800: #ef6c00;
      --paper-orange-900: #e65100;
      --paper-orange-a100: #ffd180;
      --paper-orange-a200: #ffab40;
      --paper-orange-a400: #ff9100;
      --paper-orange-a700: #ff6500;

      --paper-deep-orange-50: #fbe9e7;
      --paper-deep-orange-100: #ffccbc;
      --paper-deep-orange-200: #ffab91;
      --paper-deep-orange-300: #ff8a65;
      --paper-deep-orange-400: #ff7043;
      --paper-deep-orange-500: #ff5722;
      --paper-deep-orange-600: #f4511e;
      --paper-deep-orange-700: #e64a19;
      --paper-deep-orange-800: #d84315;
      --paper-deep-orange-900: #bf360c;
      --paper-deep-orange-a100: #ff9e80;
      --paper-deep-orange-a200: #ff6e40;
      --paper-deep-orange-a400: #ff3d00;
      --paper-deep-orange-a700: #dd2c00;

      --paper-brown-50: #efebe9;
      --paper-brown-100: #d7ccc8;
      --paper-brown-200: #bcaaa4;
      --paper-brown-300: #a1887f;
      --paper-brown-400: #8d6e63;
      --paper-brown-500: #795548;
      --paper-brown-600: #6d4c41;
      --paper-brown-700: #5d4037;
      --paper-brown-800: #4e342e;
      --paper-brown-900: #3e2723;

      --paper-grey-50: #fafafa;
      --paper-grey-100: #f5f5f5;
      --paper-grey-200: #eeeeee;
      --paper-grey-300: #e0e0e0;
      --paper-grey-400: #bdbdbd;
      --paper-grey-500: #9e9e9e;
      --paper-grey-600: #757575;
      --paper-grey-700: #616161;
      --paper-grey-800: #424242;
      --paper-grey-900: #212121;

      --paper-blue-grey-50: #eceff1;
      --paper-blue-grey-100: #cfd8dc;
      --paper-blue-grey-200: #b0bec5;
      --paper-blue-grey-300: #90a4ae;
      --paper-blue-grey-400: #78909c;
      --paper-blue-grey-500: #607d8b;
      --paper-blue-grey-600: #546e7a;
      --paper-blue-grey-700: #455a64;
      --paper-blue-grey-800: #37474f;
      --paper-blue-grey-900: #263238;

      /* opacity for dark text on a light background */
      --dark-divider-opacity: 0.12;
      --dark-disabled-opacity: 0.38; /* or hint text or icon */
      --dark-secondary-opacity: 0.54;
      --dark-primary-opacity: 0.87;

      /* opacity for light text on a dark background */
      --light-divider-opacity: 0.12;
      --light-disabled-opacity: 0.3; /* or hint text or icon */
      --light-secondary-opacity: 0.7;
      --light-primary-opacity: 1.0;

    }

  </style>
</custom-style>
`;Gh.setAttribute("style","display: none;"),document.head.appendChild(Gh.content);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Vh=ta`
<custom-style>
  <style is="custom-style">
    html {
      /*
       * You can use these generic variables in your elements for easy theming.
       * For example, if all your elements use \`--primary-text-color\` as its main
       * color, then switching from a light to a dark theme is just a matter of
       * changing the value of \`--primary-text-color\` in your application.
       */
      --primary-text-color: var(--light-theme-text-color);
      --primary-background-color: var(--light-theme-background-color);
      --secondary-text-color: var(--light-theme-secondary-color);
      --disabled-text-color: var(--light-theme-disabled-color);
      --divider-color: var(--light-theme-divider-color);
      --error-color: var(--paper-deep-orange-a700);

      /*
       * Primary and accent colors. Also see color.js for more colors.
       */
      --primary-color: var(--paper-indigo-500);
      --light-primary-color: var(--paper-indigo-100);
      --dark-primary-color: var(--paper-indigo-700);

      --accent-color: var(--paper-pink-a200);
      --light-accent-color: var(--paper-pink-a100);
      --dark-accent-color: var(--paper-pink-a400);


      /*
       * Material Design Light background theme
       */
      --light-theme-background-color: #ffffff;
      --light-theme-base-color: #000000;
      --light-theme-text-color: var(--paper-grey-900);
      --light-theme-secondary-color: #737373;  /* for secondary text and icons */
      --light-theme-disabled-color: #9b9b9b;  /* disabled/hint text */
      --light-theme-divider-color: #dbdbdb;

      /*
       * Material Design Dark background theme
       */
      --dark-theme-background-color: var(--paper-grey-900);
      --dark-theme-base-color: #ffffff;
      --dark-theme-text-color: #ffffff;
      --dark-theme-secondary-color: #bcbcbc;  /* for secondary text and icons */
      --dark-theme-disabled-color: #646464;  /* disabled/hint text */
      --dark-theme-divider-color: #3c3c3c;

      /*
       * Deprecated values because of their confusing names.
       */
      --text-primary-color: var(--dark-theme-text-color);
      --default-primary-color: var(--primary-color);
    }
  </style>
</custom-style>`;
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
if(Vh.setAttribute("style","display: none;"),document.head.appendChild(Vh.content),!window.polymerSkipLoadingFontRoboto){const e=document.createElement("link");e.rel="stylesheet",e.type="text/css",e.crossOrigin="anonymous",e.href="https://fonts.googleapis.com/css?family=Roboto+Mono:400,700|Roboto:400,300,300italic,400italic,500,500italic,700,700italic",document.head.appendChild(e)}
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/const zh=ta`<custom-style>
  <style is="custom-style">
    html {

      /* Shared Styles */
      --paper-font-common-base: {
        font-family: 'Roboto', 'Noto', sans-serif;
        -webkit-font-smoothing: antialiased;
      };

      --paper-font-common-code: {
        font-family: 'Roboto Mono', 'Consolas', 'Menlo', monospace;
        -webkit-font-smoothing: antialiased;
      };

      --paper-font-common-expensive-kerning: {
        text-rendering: optimizeLegibility;
      };

      --paper-font-common-nowrap: {
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
      };

      /* Material Font Styles */

      --paper-font-display4: {
        @apply --paper-font-common-base;
        @apply --paper-font-common-nowrap;

        font-size: 112px;
        font-weight: 300;
        letter-spacing: -.044em;
        line-height: 120px;
      };

      --paper-font-display3: {
        @apply --paper-font-common-base;
        @apply --paper-font-common-nowrap;

        font-size: 56px;
        font-weight: 400;
        letter-spacing: -.026em;
        line-height: 60px;
      };

      --paper-font-display2: {
        @apply --paper-font-common-base;

        font-size: 45px;
        font-weight: 400;
        letter-spacing: -.018em;
        line-height: 48px;
      };

      --paper-font-display1: {
        @apply --paper-font-common-base;

        font-size: 34px;
        font-weight: 400;
        letter-spacing: -.01em;
        line-height: 40px;
      };

      --paper-font-headline: {
        @apply --paper-font-common-base;

        font-size: 24px;
        font-weight: 400;
        letter-spacing: -.012em;
        line-height: 32px;
      };

      --paper-font-title: {
        @apply --paper-font-common-base;
        @apply --paper-font-common-nowrap;

        font-size: 20px;
        font-weight: 500;
        line-height: 28px;
      };

      --paper-font-subhead: {
        @apply --paper-font-common-base;

        font-size: 16px;
        font-weight: 400;
        line-height: 24px;
      };

      --paper-font-body2: {
        @apply --paper-font-common-base;

        font-size: 14px;
        font-weight: 500;
        line-height: 24px;
      };

      --paper-font-body1: {
        @apply --paper-font-common-base;

        font-size: 14px;
        font-weight: 400;
        line-height: 20px;
      };

      --paper-font-caption: {
        @apply --paper-font-common-base;
        @apply --paper-font-common-nowrap;

        font-size: 12px;
        font-weight: 400;
        letter-spacing: 0.011em;
        line-height: 20px;
      };

      --paper-font-menu: {
        @apply --paper-font-common-base;
        @apply --paper-font-common-nowrap;

        font-size: 13px;
        font-weight: 500;
        line-height: 24px;
      };

      --paper-font-button: {
        @apply --paper-font-common-base;
        @apply --paper-font-common-nowrap;

        font-size: 14px;
        font-weight: 500;
        letter-spacing: 0.018em;
        line-height: 24px;
        text-transform: uppercase;
      };

      --paper-font-code2: {
        @apply --paper-font-common-code;

        font-size: 14px;
        font-weight: 700;
        line-height: 20px;
      };

      --paper-font-code1: {
        @apply --paper-font-common-code;

        font-size: 14px;
        font-weight: 500;
        line-height: 20px;
      };

    }

  </style>
</custom-style>`;zh.setAttribute("style","display: none;"),document.head.appendChild(zh.content);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Wh=document.createElement("template");Wh.setAttribute("style","display: none;"),Wh.innerHTML="<dom-module id=\"paper-item-shared-styles\">\n  <template>\n    <style>\n      :host, .paper-item {\n        display: block;\n        position: relative;\n        min-height: var(--paper-item-min-height, 48px);\n        padding: 0px 16px;\n      }\n\n      .paper-item {\n        @apply --paper-font-subhead;\n        border:none;\n        outline: none;\n        background: white;\n        width: 100%;\n        text-align: left;\n      }\n\n      :host([hidden]), .paper-item[hidden] {\n        display: none !important;\n      }\n\n      :host(.iron-selected), .paper-item.iron-selected {\n        font-weight: var(--paper-item-selected-weight, bold);\n\n        @apply --paper-item-selected;\n      }\n\n      :host([disabled]), .paper-item[disabled] {\n        color: var(--paper-item-disabled-color, var(--disabled-text-color));\n\n        @apply --paper-item-disabled;\n      }\n\n      :host(:focus), .paper-item:focus {\n        position: relative;\n        outline: 0;\n\n        @apply --paper-item-focused;\n      }\n\n      :host(:focus):before, .paper-item:focus:before {\n        @apply --layout-fit;\n\n        background: currentColor;\n        content: '';\n        opacity: var(--dark-divider-opacity);\n        pointer-events: none;\n\n        @apply --paper-item-focused-before;\n      }\n    </style>\n  </template>\n</dom-module>",document.head.appendChild(Wh.content);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const qh={properties:{pressed:{type:Boolean,readOnly:!0,value:!1,reflectToAttribute:!0,observer:"_pressedChanged"},toggles:{type:Boolean,value:!1,reflectToAttribute:!0},active:{type:Boolean,value:!1,notify:!0,reflectToAttribute:!0},pointerDown:{type:Boolean,readOnly:!0,value:!1},receivedFocusFromKeyboard:{type:Boolean,readOnly:!0},ariaActiveAttribute:{type:String,value:"aria-pressed",observer:"_ariaActiveAttributeChanged"}},listeners:{down:"_downHandler",up:"_upHandler",tap:"_tapHandler"},observers:["_focusChanged(focused)","_activeChanged(active, ariaActiveAttribute)"],keyBindings:{"enter:keydown":"_asyncClick","space:keydown":"_spaceKeyDownHandler","space:keyup":"_spaceKeyUpHandler"},_mouseEventRe:/^mouse/,_tapHandler:function(){this.toggles?this._userActivate(!this.active):this.active=!1},_focusChanged:function(e){this._detectKeyboardFocus(e),e||this._setPressed(!1)},_detectKeyboardFocus:function(e){this._setReceivedFocusFromKeyboard(!this.pointerDown&&e)},_userActivate:function(e){this.active!==e&&(this.active=e,this.fire("change"))},_downHandler:function(e){this._setPointerDown(!0),this._setPressed(!0),this._setReceivedFocusFromKeyboard(!1)},_upHandler:function(){this._setPointerDown(!1),this._setPressed(!1)},_spaceKeyDownHandler:function(e){var t=e.detail.keyboardEvent,n=qo(t).localTarget;this.isLightDescendant(n)||(t.preventDefault(),t.stopImmediatePropagation(),this._setPressed(!0))},_spaceKeyUpHandler:function(e){var t=e.detail.keyboardEvent,n=qo(t).localTarget;this.isLightDescendant(n)||(this.pressed&&this._asyncClick(),this._setPressed(!1))},_asyncClick:function(){this.async((function(){this.click()}),1)},_pressedChanged:function(e){this._changedButtonState()},_ariaActiveAttributeChanged:function(e,t){t&&t!=e&&this.hasAttribute(t)&&this.removeAttribute(t)},_activeChanged:function(e,t){this.toggles?this.setAttribute(this.ariaActiveAttribute,e?"true":"false"):this.removeAttribute(this.ariaActiveAttribute),this._changedButtonState()},_controlStateChanged:function(){this.disabled?this._setPressed(!1):this._changedButtonState()},_changedButtonState:function(){this._buttonStateChanged&&this._buttonStateChanged()}},Kh=[Lc,qh];
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style include="paper-item-shared-styles">
      :host {
        @apply --layout-horizontal;
        @apply --layout-center;
        @apply --paper-font-subhead;

        @apply --paper-item;
      }
    </style>
    <slot></slot>
`,is:"paper-item",behaviors:[[Kh,jh,{hostAttributes:{role:"option",tabindex:"0"}}]]});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
class Yh{constructor(e){this.selection=[],this.selectCallback=e}get(){return this.multi?this.selection.slice():this.selection[0]}clear(e){this.selection.slice().forEach((function(t){(!e||e.indexOf(t)<0)&&this.setItemSelected(t,!1)}),this)}isSelected(e){return this.selection.indexOf(e)>=0}setItemSelected(e,t){if(null!=e&&t!==this.isSelected(e)){if(t)this.selection.push(e);else{var n=this.selection.indexOf(e);n>=0&&this.selection.splice(n,1)}this.selectCallback&&this.selectCallback(e,t)}}select(e){this.multi?this.toggle(e):this.get()!==e&&(this.setItemSelected(this.get(),!1),this.setItemSelected(e,!0))}toggle(e){this.setItemSelected(e,!this.isSelected(e))}}
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Xh={properties:{attrForSelected:{type:String,value:null},selected:{type:String,notify:!0},selectedItem:{type:Object,readOnly:!0,notify:!0},activateEvent:{type:String,value:"tap",observer:"_activateEventChanged"},selectable:String,selectedClass:{type:String,value:"iron-selected"},selectedAttribute:{type:String,value:null},fallbackSelection:{type:String,value:null},items:{type:Array,readOnly:!0,notify:!0,value:function(){return[]}},_excludedLocalNames:{type:Object,value:function(){return{template:1,"dom-bind":1,"dom-if":1,"dom-repeat":1}}}},observers:["_updateAttrForSelected(attrForSelected)","_updateSelected(selected)","_checkFallback(fallbackSelection)"],created:function(){this._bindFilterItem=this._filterItem.bind(this),this._selection=new Yh(this._applySelection.bind(this))},attached:function(){this._observer=this._observeItems(this),this._addListener(this.activateEvent)},detached:function(){this._observer&&qo(this).unobserveNodes(this._observer),this._removeListener(this.activateEvent)},indexOf:function(e){return this.items?this.items.indexOf(e):-1},select:function(e){this.selected=e},selectPrevious:function(){var e=this.items.length,t=e-1;void 0!==this.selected&&(t=(Number(this._valueToIndex(this.selected))-1+e)%e),this.selected=this._indexToValue(t)},selectNext:function(){var e=0;void 0!==this.selected&&(e=(Number(this._valueToIndex(this.selected))+1)%this.items.length),this.selected=this._indexToValue(e)},selectIndex:function(e){this.select(this._indexToValue(e))},forceSynchronousItemUpdate:function(){this._observer&&"function"==typeof this._observer.flush?this._observer.flush():this._updateItems()},get _shouldUpdateSelection(){return null!=this.selected},_checkFallback:function(){this._updateSelected()},_addListener:function(e){this.listen(this,e,"_activateHandler")},_removeListener:function(e){this.unlisten(this,e,"_activateHandler")},_activateEventChanged:function(e,t){this._removeListener(t),this._addListener(e)},_updateItems:function(){var e=qo(this).queryDistributedElements(this.selectable||"*");e=Array.prototype.filter.call(e,this._bindFilterItem),this._setItems(e)},_updateAttrForSelected:function(){this.selectedItem&&(this.selected=this._valueForItem(this.selectedItem))},_updateSelected:function(){this._selectSelected(this.selected)},_selectSelected:function(e){if(this.items){var t=this._valueToItem(this.selected);t?this._selection.select(t):this._selection.clear(),this.fallbackSelection&&this.items.length&&void 0===this._selection.get()&&(this.selected=this.fallbackSelection)}},_filterItem:function(e){return!this._excludedLocalNames[e.localName]},_valueToItem:function(e){return null==e?null:this.items[this._valueToIndex(e)]},_valueToIndex:function(e){if(!this.attrForSelected)return Number(e);for(var t,n=0;t=this.items[n];n++)if(this._valueForItem(t)==e)return n},_indexToValue:function(e){if(!this.attrForSelected)return e;var t=this.items[e];return t?this._valueForItem(t):void 0},_valueForItem:function(e){if(!e)return null;if(!this.attrForSelected){var t=this.indexOf(e);return-1===t?null:t}var n=e[Nt(this.attrForSelected)];return null!=n?n:e.getAttribute(this.attrForSelected)},_applySelection:function(e,t){this.selectedClass&&this.toggleClass(this.selectedClass,t,e),this.selectedAttribute&&this.toggleAttribute(this.selectedAttribute,t,e),this._selectionChange(),this.fire("iron-"+(t?"select":"deselect"),{item:e})},_selectionChange:function(){this._setSelectedItem(this._selection.get())},_observeItems:function(e){return qo(e).observeNodes((function(e){this._updateItems(),this._updateSelected(),this.fire("iron-items-changed",e,{bubbles:!1,cancelable:!1})}))},_activateHandler:function(e){for(var t=e.target,n=this.items;t&&t!=this;){var i=n.indexOf(t);if(i>=0){var o=this._indexToValue(i);return void this._itemActivate(o,t)}t=t.parentNode}},_itemActivate:function(e,t){this.fire("iron-activate",{selected:e,item:t},{cancelable:!0}).defaultPrevented||this.select(e)}},Jh={properties:{multi:{type:Boolean,value:!1,observer:"multiChanged"},selectedValues:{type:Array,notify:!0,value:function(){return[]}},selectedItems:{type:Array,readOnly:!0,notify:!0,value:function(){return[]}}},observers:["_updateSelected(selectedValues.splices)"],select:function(e){this.multi?this._toggleSelected(e):this.selected=e},multiChanged:function(e){this._selection.multi=e,this._updateSelected()},get _shouldUpdateSelection(){return null!=this.selected||null!=this.selectedValues&&this.selectedValues.length},_updateAttrForSelected:function(){this.multi?this.selectedItems&&this.selectedItems.length>0&&(this.selectedValues=this.selectedItems.map((function(e){return this._indexToValue(this.indexOf(e))}),this).filter((function(e){return null!=e}),this)):Xh._updateAttrForSelected.apply(this)},_updateSelected:function(){this.multi?this._selectMulti(this.selectedValues):this._selectSelected(this.selected)},_selectMulti:function(e){e=e||[];var t=(this._valuesToItems(e)||[]).filter((function(e){return null!=e}));this._selection.clear(t);for(var n=0;n<t.length;n++)this._selection.setItemSelected(t[n],!0);this.fallbackSelection&&!this._selection.get().length&&(this._valueToItem(this.fallbackSelection)&&this.select(this.fallbackSelection))},_selectionChange:function(){var e=this._selection.get();this.multi?(this._setSelectedItems(e),this._setSelectedItem(e.length?e[0]:null)):null!=e?(this._setSelectedItems([e]),this._setSelectedItem(e)):(this._setSelectedItems([]),this._setSelectedItem(null))},_toggleSelected:function(e){var t=this.selectedValues.indexOf(e);t<0?this.push("selectedValues",e):this.splice("selectedValues",t,1)},_valuesToItems:function(e){return null==e?null:e.map((function(e){return this._valueToItem(e)}),this)}},Zh=[Xh,Jh],Qh={properties:{focusedItem:{observer:"_focusedItemChanged",readOnly:!0,type:Object},attrForItemTitle:{type:String},disabled:{type:Boolean,value:!1,observer:"_disabledChanged"}},_MODIFIER_KEYS:["Alt","AltGraph","CapsLock","Control","Fn","FnLock","Hyper","Meta","NumLock","OS","ScrollLock","Shift","Super","Symbol","SymbolLock"],_SEARCH_RESET_TIMEOUT_MS:1e3,_previousTabIndex:0,hostAttributes:{role:"menu"},observers:["_updateMultiselectable(multi)"],listeners:{focus:"_onFocus",keydown:"_onKeydown","iron-items-changed":"_onIronItemsChanged"},keyBindings:{up:"_onUpKey",down:"_onDownKey",esc:"_onEscKey","shift+tab:keydown":"_onShiftTabDown"},attached:function(){this._resetTabindices()},select:function(e){this._defaultFocusAsync&&(this.cancelAsync(this._defaultFocusAsync),this._defaultFocusAsync=null);var t=this._valueToItem(e);t&&t.hasAttribute("disabled")||(this._setFocusedItem(t),Jh.select.apply(this,arguments))},_resetTabindices:function(){var e=this.multi?this.selectedItems&&this.selectedItems[0]:this.selectedItem;this.items.forEach((function(t){t.setAttribute("tabindex",t===e?"0":"-1"),t.setAttribute("aria-selected",this._selection.isSelected(t))}),this)},_updateMultiselectable:function(e){e?this.setAttribute("aria-multiselectable","true"):this.removeAttribute("aria-multiselectable")},_focusWithKeyboardEvent:function(e){if(-1===this._MODIFIER_KEYS.indexOf(e.key)){this.cancelDebouncer("_clearSearchText");for(var t,n=this._searchText||"",i=(n+=(e.key&&1==e.key.length?e.key:String.fromCharCode(e.keyCode)).toLocaleLowerCase()).length,o=0;t=this.items[o];o++)if(!t.hasAttribute("disabled")){var s=this.attrForItemTitle||"textContent",r=(t[s]||t.getAttribute(s)||"").trim();if(!(r.length<i)&&r.slice(0,i).toLocaleLowerCase()==n){this._setFocusedItem(t);break}}this._searchText=n,this.debounce("_clearSearchText",this._clearSearchText,this._SEARCH_RESET_TIMEOUT_MS)}},_clearSearchText:function(){this._searchText=""},_focusPrevious:function(){for(var e=this.items.length,t=Number(this.indexOf(this.focusedItem)),n=1;n<e+1;n++){var i=this.items[(t-n+e)%e];if(!i.hasAttribute("disabled")){var o=qo(i).getOwnerRoot()||document;if(this._setFocusedItem(i),qo(o).activeElement==i)return}}},_focusNext:function(){for(var e=this.items.length,t=Number(this.indexOf(this.focusedItem)),n=1;n<e+1;n++){var i=this.items[(t+n)%e];if(!i.hasAttribute("disabled")){var o=qo(i).getOwnerRoot()||document;if(this._setFocusedItem(i),qo(o).activeElement==i)return}}},_applySelection:function(e,t){t?e.setAttribute("aria-selected","true"):e.setAttribute("aria-selected","false"),Xh._applySelection.apply(this,arguments)},_focusedItemChanged:function(e,t){t&&t.setAttribute("tabindex","-1"),!e||e.hasAttribute("disabled")||this.disabled||(e.setAttribute("tabindex","0"),e.focus())},_onIronItemsChanged:function(e){e.detail.addedNodes.length&&this._resetTabindices()},_onShiftTabDown:function(e){var t=this.getAttribute("tabindex");Qh._shiftTabPressed=!0,this._setFocusedItem(null),this.setAttribute("tabindex","-1"),this.async((function(){this.setAttribute("tabindex",t),Qh._shiftTabPressed=!1}),1)},_onFocus:function(e){if(!Qh._shiftTabPressed){var t=qo(e).rootTarget;(t===this||void 0===t.tabIndex||this.isLightDescendant(t))&&(this._defaultFocusAsync=this.async((function(){var e=this.multi?this.selectedItems&&this.selectedItems[0]:this.selectedItem;this._setFocusedItem(null),e?this._setFocusedItem(e):this.items[0]&&this._focusNext()})))}},_onUpKey:function(e){this._focusPrevious(),e.detail.keyboardEvent.preventDefault()},_onDownKey:function(e){this._focusNext(),e.detail.keyboardEvent.preventDefault()},_onEscKey:function(e){var t=this.focusedItem;t&&t.blur()},_onKeydown:function(e){this.keyboardEventMatchesKeys(e,"up down esc")||this._focusWithKeyboardEvent(e),e.stopPropagation()},_activateHandler:function(e){Xh._activateHandler.call(this,e),e.stopPropagation()},_disabledChanged:function(e){e?(this._previousTabIndex=this.hasAttribute("tabindex")?this.tabIndex:0,this.removeAttribute("tabindex")):this.hasAttribute("tabindex")||this.setAttribute("tabindex",this._previousTabIndex)},_shiftTabPressed:!1},ep=[Zh,Lc,Qh];
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style>
      :host {
        display: block;
        padding: 8px 0;

        background: var(--paper-listbox-background-color, var(--primary-background-color));
        color: var(--paper-listbox-color, var(--primary-text-color));

        @apply --paper-listbox;
      }
    </style>

    <slot></slot>
`,is:"paper-listbox",behaviors:[ep],hostAttributes:{role:"listbox"}});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const tp=ta`
<custom-style>
  <style is="custom-style">
    html {

      --shadow-transition: {
        transition: box-shadow 0.28s cubic-bezier(0.4, 0, 0.2, 1);
      };

      --shadow-none: {
        box-shadow: none;
      };

      /* from http://codepen.io/shyndman/pen/c5394ddf2e8b2a5c9185904b57421cdb */

      --shadow-elevation-2dp: {
        box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14),
                    0 1px 5px 0 rgba(0, 0, 0, 0.12),
                    0 3px 1px -2px rgba(0, 0, 0, 0.2);
      };

      --shadow-elevation-3dp: {
        box-shadow: 0 3px 4px 0 rgba(0, 0, 0, 0.14),
                    0 1px 8px 0 rgba(0, 0, 0, 0.12),
                    0 3px 3px -2px rgba(0, 0, 0, 0.4);
      };

      --shadow-elevation-4dp: {
        box-shadow: 0 4px 5px 0 rgba(0, 0, 0, 0.14),
                    0 1px 10px 0 rgba(0, 0, 0, 0.12),
                    0 2px 4px -1px rgba(0, 0, 0, 0.4);
      };

      --shadow-elevation-6dp: {
        box-shadow: 0 6px 10px 0 rgba(0, 0, 0, 0.14),
                    0 1px 18px 0 rgba(0, 0, 0, 0.12),
                    0 3px 5px -1px rgba(0, 0, 0, 0.4);
      };

      --shadow-elevation-8dp: {
        box-shadow: 0 8px 10px 1px rgba(0, 0, 0, 0.14),
                    0 3px 14px 2px rgba(0, 0, 0, 0.12),
                    0 5px 5px -3px rgba(0, 0, 0, 0.4);
      };

      --shadow-elevation-12dp: {
        box-shadow: 0 12px 16px 1px rgba(0, 0, 0, 0.14),
                    0 4px 22px 3px rgba(0, 0, 0, 0.12),
                    0 6px 7px -4px rgba(0, 0, 0, 0.4);
      };

      --shadow-elevation-16dp: {
        box-shadow: 0 16px 24px 2px rgba(0, 0, 0, 0.14),
                    0  6px 30px 5px rgba(0, 0, 0, 0.12),
                    0  8px 10px -5px rgba(0, 0, 0, 0.4);
      };

      --shadow-elevation-24dp: {
        box-shadow: 0 24px 38px 3px rgba(0, 0, 0, 0.14),
                    0 9px 46px 8px rgba(0, 0, 0, 0.12),
                    0 11px 15px -7px rgba(0, 0, 0, 0.4);
      };
    }
  </style>
</custom-style>`;tp.setAttribute("style","display: none;"),document.head.appendChild(tp.content);
/**
@license
Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const np=ta`
<dom-module id="paper-material-styles">
  <template>
    <style>
      html {
        --paper-material: {
          display: block;
          position: relative;
        };
        --paper-material-elevation-1: {
          @apply --shadow-elevation-2dp;
        };
        --paper-material-elevation-2: {
          @apply --shadow-elevation-4dp;
        };
        --paper-material-elevation-3: {
          @apply --shadow-elevation-6dp;
        };
        --paper-material-elevation-4: {
          @apply --shadow-elevation-8dp;
        };
        --paper-material-elevation-5: {
          @apply --shadow-elevation-16dp;
        };
      }
      .paper-material {
        @apply --paper-material;
      }
      .paper-material[elevation="1"] {
        @apply --paper-material-elevation-1;
      }
      .paper-material[elevation="2"] {
        @apply --paper-material-elevation-2;
      }
      .paper-material[elevation="3"] {
        @apply --paper-material-elevation-3;
      }
      .paper-material[elevation="4"] {
        @apply --paper-material-elevation-4;
      }
      .paper-material[elevation="5"] {
        @apply --paper-material-elevation-5;
      }

      /* Duplicate the styles because of https://github.com/webcomponents/shadycss/issues/193 */
      :host {
        --paper-material: {
          display: block;
          position: relative;
        };
        --paper-material-elevation-1: {
          @apply --shadow-elevation-2dp;
        };
        --paper-material-elevation-2: {
          @apply --shadow-elevation-4dp;
        };
        --paper-material-elevation-3: {
          @apply --shadow-elevation-6dp;
        };
        --paper-material-elevation-4: {
          @apply --shadow-elevation-8dp;
        };
        --paper-material-elevation-5: {
          @apply --shadow-elevation-16dp;
        };
      }
      :host(.paper-material) {
        @apply --paper-material;
      }
      :host(.paper-material[elevation="1"]) {
        @apply --paper-material-elevation-1;
      }
      :host(.paper-material[elevation="2"]) {
        @apply --paper-material-elevation-2;
      }
      :host(.paper-material[elevation="3"]) {
        @apply --paper-material-elevation-3;
      }
      :host(.paper-material[elevation="4"]) {
        @apply --paper-material-elevation-4;
      }
      :host(.paper-material[elevation="5"]) {
        @apply --paper-material-elevation-5;
      }
    </style>
  </template>
</dom-module>`;np.setAttribute("style","display: none;"),document.head.appendChild(np.content);
/**
@license
Copyright (c) 2014 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
var ip={distance:function(e,t,n,i){var o=e-n,s=t-i;return Math.sqrt(o*o+s*s)},now:window.performance&&window.performance.now?window.performance.now.bind(window.performance):Date.now};function op(e){this.element=e,this.width=this.boundingRect.width,this.height=this.boundingRect.height,this.size=Math.max(this.width,this.height)}function sp(e){this.element=e,this.color=window.getComputedStyle(e).color,this.wave=document.createElement("div"),this.waveContainer=document.createElement("div"),this.wave.style.backgroundColor=this.color,this.wave.classList.add("wave"),this.waveContainer.classList.add("wave-container"),qo(this.waveContainer).appendChild(this.wave),this.resetInteractionState()}op.prototype={get boundingRect(){return this.element.getBoundingClientRect()},furthestCornerDistanceFrom:function(e,t){var n=ip.distance(e,t,0,0),i=ip.distance(e,t,this.width,0),o=ip.distance(e,t,0,this.height),s=ip.distance(e,t,this.width,this.height);return Math.max(n,i,o,s)}},sp.MAX_RADIUS=300,sp.prototype={get recenters(){return this.element.recenters},get center(){return this.element.center},get mouseDownElapsed(){var e;return this.mouseDownStart?(e=ip.now()-this.mouseDownStart,this.mouseUpStart&&(e-=this.mouseUpElapsed),e):0},get mouseUpElapsed(){return this.mouseUpStart?ip.now()-this.mouseUpStart:0},get mouseDownElapsedSeconds(){return this.mouseDownElapsed/1e3},get mouseUpElapsedSeconds(){return this.mouseUpElapsed/1e3},get mouseInteractionSeconds(){return this.mouseDownElapsedSeconds+this.mouseUpElapsedSeconds},get initialOpacity(){return this.element.initialOpacity},get opacityDecayVelocity(){return this.element.opacityDecayVelocity},get radius(){var e=this.containerMetrics.width*this.containerMetrics.width,t=this.containerMetrics.height*this.containerMetrics.height,n=1.1*Math.min(Math.sqrt(e+t),sp.MAX_RADIUS)+5,i=1.1-n/sp.MAX_RADIUS*.2,o=this.mouseInteractionSeconds/i,s=n*(1-Math.pow(80,-o));return Math.abs(s)},get opacity(){return this.mouseUpStart?Math.max(0,this.initialOpacity-this.mouseUpElapsedSeconds*this.opacityDecayVelocity):this.initialOpacity},get outerOpacity(){var e=.3*this.mouseUpElapsedSeconds,t=this.opacity;return Math.max(0,Math.min(e,t))},get isOpacityFullyDecayed(){return this.opacity<.01&&this.radius>=Math.min(this.maxRadius,sp.MAX_RADIUS)},get isRestingAtMaxRadius(){return this.opacity>=this.initialOpacity&&this.radius>=Math.min(this.maxRadius,sp.MAX_RADIUS)},get isAnimationComplete(){return this.mouseUpStart?this.isOpacityFullyDecayed:this.isRestingAtMaxRadius},get translationFraction(){return Math.min(1,this.radius/this.containerMetrics.size*2/Math.sqrt(2))},get xNow(){return this.xEnd?this.xStart+this.translationFraction*(this.xEnd-this.xStart):this.xStart},get yNow(){return this.yEnd?this.yStart+this.translationFraction*(this.yEnd-this.yStart):this.yStart},get isMouseDown(){return this.mouseDownStart&&!this.mouseUpStart},resetInteractionState:function(){this.maxRadius=0,this.mouseDownStart=0,this.mouseUpStart=0,this.xStart=0,this.yStart=0,this.xEnd=0,this.yEnd=0,this.slideDistance=0,this.containerMetrics=new op(this.element)},draw:function(){var e,t,n;this.wave.style.opacity=this.opacity,e=this.radius/(this.containerMetrics.size/2),t=this.xNow-this.containerMetrics.width/2,n=this.yNow-this.containerMetrics.height/2,this.waveContainer.style.webkitTransform="translate("+t+"px, "+n+"px)",this.waveContainer.style.transform="translate3d("+t+"px, "+n+"px, 0)",this.wave.style.webkitTransform="scale("+e+","+e+")",this.wave.style.transform="scale3d("+e+","+e+",1)"},downAction:function(e){var t=this.containerMetrics.width/2,n=this.containerMetrics.height/2;this.resetInteractionState(),this.mouseDownStart=ip.now(),this.center?(this.xStart=t,this.yStart=n,this.slideDistance=ip.distance(this.xStart,this.yStart,this.xEnd,this.yEnd)):(this.xStart=e?e.detail.x-this.containerMetrics.boundingRect.left:this.containerMetrics.width/2,this.yStart=e?e.detail.y-this.containerMetrics.boundingRect.top:this.containerMetrics.height/2),this.recenters&&(this.xEnd=t,this.yEnd=n,this.slideDistance=ip.distance(this.xStart,this.yStart,this.xEnd,this.yEnd)),this.maxRadius=this.containerMetrics.furthestCornerDistanceFrom(this.xStart,this.yStart),this.waveContainer.style.top=(this.containerMetrics.height-this.containerMetrics.size)/2+"px",this.waveContainer.style.left=(this.containerMetrics.width-this.containerMetrics.size)/2+"px",this.waveContainer.style.width=this.containerMetrics.size+"px",this.waveContainer.style.height=this.containerMetrics.size+"px"},upAction:function(e){this.isMouseDown&&(this.mouseUpStart=ip.now())},remove:function(){qo(qo(this.waveContainer).parentNode).removeChild(this.waveContainer)}},Er({_template:ta`
    <style>
      :host {
        display: block;
        position: absolute;
        border-radius: inherit;
        overflow: hidden;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;

        /* See PolymerElements/paper-behaviors/issues/34. On non-Chrome browsers,
         * creating a node (with a position:absolute) in the middle of an event
         * handler "interrupts" that event handler (which happens when the
         * ripple is created on demand) */
        pointer-events: none;
      }

      :host([animating]) {
        /* This resolves a rendering issue in Chrome (as of 40) where the
           ripple is not properly clipped by its parent (which may have
           rounded corners). See: http://jsbin.com/temexa/4

           Note: We only apply this style conditionally. Otherwise, the browser
           will create a new compositing layer for every ripple element on the
           page, and that would be bad. */
        -webkit-transform: translate(0, 0);
        transform: translate3d(0, 0, 0);
      }

      #background,
      #waves,
      .wave-container,
      .wave {
        pointer-events: none;
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
      }

      #background,
      .wave {
        opacity: 0;
      }

      #waves,
      .wave {
        overflow: hidden;
      }

      .wave-container,
      .wave {
        border-radius: 50%;
      }

      :host(.circle) #background,
      :host(.circle) #waves {
        border-radius: 50%;
      }

      :host(.circle) .wave-container {
        overflow: hidden;
      }
    </style>

    <div id="background"></div>
    <div id="waves"></div>
`,is:"paper-ripple",behaviors:[Lc],properties:{initialOpacity:{type:Number,value:.25},opacityDecayVelocity:{type:Number,value:.8},recenters:{type:Boolean,value:!1},center:{type:Boolean,value:!1},ripples:{type:Array,value:function(){return[]}},animating:{type:Boolean,readOnly:!0,reflectToAttribute:!0,value:!1},holdDown:{type:Boolean,value:!1,observer:"_holdDownChanged"},noink:{type:Boolean,value:!1},_animating:{type:Boolean},_boundAnimate:{type:Function,value:function(){return this.animate.bind(this)}}},get target(){return this.keyEventTarget},keyBindings:{"enter:keydown":"_onEnterKeydown","space:keydown":"_onSpaceKeydown","space:keyup":"_onSpaceKeyup"},attached:function(){11==qo(this).parentNode.nodeType?this.keyEventTarget=qo(this).getOwnerRoot().host:this.keyEventTarget=qo(this).parentNode;var e=this.keyEventTarget;this.listen(e,"up","uiUpAction"),this.listen(e,"down","uiDownAction")},detached:function(){this.unlisten(this.keyEventTarget,"up","uiUpAction"),this.unlisten(this.keyEventTarget,"down","uiDownAction"),this.keyEventTarget=null},get shouldKeepAnimating(){for(var e=0;e<this.ripples.length;++e)if(!this.ripples[e].isAnimationComplete)return!0;return!1},simulatedRipple:function(){this.downAction(null),this.async((function(){this.upAction()}),1)},uiDownAction:function(e){this.noink||this.downAction(e)},downAction:function(e){this.holdDown&&this.ripples.length>0||(this.addRipple().downAction(e),this._animating||(this._animating=!0,this.animate()))},uiUpAction:function(e){this.noink||this.upAction(e)},upAction:function(e){this.holdDown||(this.ripples.forEach((function(t){t.upAction(e)})),this._animating=!0,this.animate())},onAnimationComplete:function(){this._animating=!1,this.$.background.style.backgroundColor="",this.fire("transitionend")},addRipple:function(){var e=new sp(this);return qo(this.$.waves).appendChild(e.waveContainer),this.$.background.style.backgroundColor=e.color,this.ripples.push(e),this._setAnimating(!0),e},removeRipple:function(e){var t=this.ripples.indexOf(e);t<0||(this.ripples.splice(t,1),e.remove(),this.ripples.length||this._setAnimating(!1))},animate:function(){if(this._animating){var e,t;for(e=0;e<this.ripples.length;++e)(t=this.ripples[e]).draw(),this.$.background.style.opacity=t.outerOpacity,t.isOpacityFullyDecayed&&!t.isRestingAtMaxRadius&&this.removeRipple(t);this.shouldKeepAnimating||0!==this.ripples.length?window.requestAnimationFrame(this._boundAnimate):this.onAnimationComplete()}},animateRipple:function(){return this.animate()},_onEnterKeydown:function(){this.uiDownAction(),this.async(this.uiUpAction,1)},_onSpaceKeydown:function(){this.uiDownAction()},_onSpaceKeyup:function(){this.uiUpAction()},_holdDownChanged:function(e,t){void 0!==t&&(e?this.downAction():this.upAction())}});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const rp={properties:{noink:{type:Boolean,observer:"_noinkChanged"},_rippleContainer:{type:Object}},_buttonStateChanged:function(){this.focused&&this.ensureRipple()},_downHandler:function(e){qh._downHandler.call(this,e),this.pressed&&this.ensureRipple(e)},ensureRipple:function(e){if(!this.hasRipple()){this._ripple=this._createRipple(),this._ripple.noink=this.noink;var t=this._rippleContainer||this.root;if(t&&qo(t).appendChild(this._ripple),e){var n=qo(this._rippleContainer||this),i=qo(e).rootTarget;n.deepContains(i)&&this._ripple.uiDownAction(e)}}},getRipple:function(){return this.ensureRipple(),this._ripple},hasRipple:function(){return Boolean(this._ripple)},_createRipple:function(){return document.createElement("paper-ripple")},_noinkChanged:function(e){this.hasRipple()&&(this._ripple.noink=e)}},ap={properties:{elevation:{type:Number,reflectToAttribute:!0,readOnly:!0}},observers:["_calculateElevation(focused, disabled, active, pressed, receivedFocusFromKeyboard)","_computeKeyboardClass(receivedFocusFromKeyboard)"],hostAttributes:{role:"button",tabindex:"0",animated:!0},_calculateElevation:function(){var e=1;this.disabled?e=0:this.active||this.pressed?e=4:this.receivedFocusFromKeyboard&&(e=3),this._setElevation(e)},_computeKeyboardClass:function(e){this.toggleClass("keyboard-focus",e)},_spaceKeyDownHandler:function(e){qh._spaceKeyDownHandler.call(this,e),this.hasRipple()&&this.getRipple().ripples.length<1&&this._ripple.uiDownAction()},_spaceKeyUpHandler:function(e){qh._spaceKeyUpHandler.call(this,e),this.hasRipple()&&this._ripple.uiUpAction()}},lp=[Kh,jh,rp,ap],cp=ta`
  <style include="paper-material-styles">
    /* Need to specify the same specificity as the styles imported from paper-material. */
    :host {
      @apply --layout-inline;
      @apply --layout-center-center;
      position: relative;
      box-sizing: border-box;
      min-width: 5.14em;
      margin: 0 0.29em;
      background: transparent;
      -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
      -webkit-tap-highlight-color: transparent;
      font: inherit;
      text-transform: uppercase;
      outline-width: 0;
      border-radius: 3px;
      -moz-user-select: none;
      -ms-user-select: none;
      -webkit-user-select: none;
      user-select: none;
      cursor: pointer;
      z-index: 0;
      padding: 0.7em 0.57em;

      @apply --paper-font-common-base;
      @apply --paper-button;
    }

    :host([elevation="1"]) {
      @apply --paper-material-elevation-1;
    }

    :host([elevation="2"]) {
      @apply --paper-material-elevation-2;
    }

    :host([elevation="3"]) {
      @apply --paper-material-elevation-3;
    }

    :host([elevation="4"]) {
      @apply --paper-material-elevation-4;
    }

    :host([elevation="5"]) {
      @apply --paper-material-elevation-5;
    }

    :host([hidden]) {
      display: none !important;
    }

    :host([raised].keyboard-focus) {
      font-weight: bold;
      @apply --paper-button-raised-keyboard-focus;
    }

    :host(:not([raised]).keyboard-focus) {
      font-weight: bold;
      @apply --paper-button-flat-keyboard-focus;
    }

    :host([disabled]) {
      background: none;
      color: #a8a8a8;
      cursor: auto;
      pointer-events: none;

      @apply --paper-button-disabled;
    }

    :host([disabled][raised]) {
      background: #eaeaea;
    }


    :host([animated]) {
      @apply --shadow-transition;
    }

    paper-ripple {
      color: var(--paper-button-ink-color);
    }
  </style>

  <slot></slot>`;
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/cp.setAttribute("strip-whitespace",""),Er({_template:cp,is:"paper-button",behaviors:[lp],properties:{raised:{type:Boolean,reflectToAttribute:!0,value:!1,observer:"_calculateElevation"}},_calculateElevation:function(){this.raised?ap._calculateElevation.apply(this):this._setElevation(0)}});
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const dp=ta`
  <style include="shared-styles">
    /* general styles for all buttons */
    :host {
      --background-color: var(
        --button-background-color,
        var(--default-button-background-color)
      );
      --text-color: var(--default-button-text-color);
      display: inline-block;
      position: relative;
    }
    :host([hidden]) {
      display: none;
    }
    :host([no-uppercase]) paper-button {
      text-transform: none;
    }
    paper-button {
      /* The next lines contains a copy of paper-button style.
          Without a copy, the @apply works incorrectly with Polymer 2.
          @apply is deprecated and is not recommended to use. It is expected
          that @apply will be replaced with the ::part CSS pseudo-element.
          After replacement copied lines can be removed.
        */
      @apply --layout-inline;
      @apply --layout-center-center;
      position: relative;
      box-sizing: border-box;
      min-width: 5.14em;
      margin: 0 0.29em;
      background: transparent;
      -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
      -webkit-tap-highlight-color: transparent;
      font: inherit;
      text-transform: uppercase;
      outline-width: 0;
      border-radius: var(--border-radius);
      -moz-user-select: none;
      -ms-user-select: none;
      -webkit-user-select: none;
      user-select: none;
      cursor: pointer;
      z-index: 0;
      padding: var(--spacing-m);

      @apply --paper-font-common-base;
      @apply --paper-button;
      /* End of copy*/

      /* paper-button sets this to anti-aliased, which appears different than
          bold font elsewhere on macOS. */
      -webkit-font-smoothing: initial;
      align-items: center;
      background-color: var(--background-color);
      color: var(--text-color);
      display: flex;
      font-family: inherit;
      justify-content: center;
      margin: var(--margin, 0);
      min-width: var(--border, 0);
      padding: var(--padding, 4px 8px);
      @apply --gr-button;
    }
    /* https://github.com/PolymerElements/paper-button/blob/2.x/paper-button.html */
    /* BEGIN: Copy from paper-button */
    paper-button[elevation='1'] {
      @apply --paper-material-elevation-1;
    }
    paper-button[elevation='2'] {
      @apply --paper-material-elevation-2;
    }
    paper-button[elevation='3'] {
      @apply --paper-material-elevation-3;
    }
    paper-button[elevation='4'] {
      @apply --paper-material-elevation-4;
    }
    paper-button[elevation='5'] {
      @apply --paper-material-elevation-5;
    }
    /* END: Copy from paper-button */
    paper-button:hover {
      background: linear-gradient(rgba(0, 0, 0, 0.12), rgba(0, 0, 0, 0.12)),
        var(--background-color);
    }

    /* Some mobile browsers treat focused element as hovered element.
      As a result, element remains hovered after click (has grey background in default theme).
      Use @media (hover:none) to remove background if
      user's primary input mechanism can't hover over elements.
      See: https://developer.mozilla.org/en-US/docs/Web/CSS/@media/hover

      Note 1: not all browsers support this media query
      (see https://caniuse.com/#feat=css-media-interaction).
      If browser doesn't support it, then the whole content of @media .. is ignored.
      This is why the default behavior is placed outside of @media.
      */
    @media (hover: none) {
      paper-button:hover {
        background: transparent;
      }
    }

    :host([primary]) {
      --background-color: var(--primary-button-background-color);
      --text-color: var(--primary-button-text-color);
    }
    :host([link][primary]) {
      --text-color: var(--primary-button-background-color);
    }

    /* Keep below color definition for primary so that this takes precedence
        when disabled. */
    :host([disabled]),
    :host([loading]) {
      --background-color: var(--disabled-button-background-color);
      --text-color: var(--deemphasized-text-color);
      cursor: default;
    }

    /* Styles for link buttons specifically */
    :host([link]) {
      --background-color: transparent;
      --margin: 0;
      --padding: var(--spacing-s);
    }
    :host([disabled][link]),
    :host([loading][link]) {
      --background-color: transparent;
      --text-color: var(--deemphasized-text-color);
      cursor: default;
    }

    /* Styles for the optional down arrow */
    :host(:not([down-arrow])) .downArrow {
      display: none;
    }
    :host([down-arrow]) .downArrow {
      border-top: 0.36em solid #ccc;
      border-left: 0.36em solid transparent;
      border-right: 0.36em solid transparent;
      margin-bottom: var(--spacing-xxs);
      margin-left: var(--spacing-m);
      transition: border-top-color 200ms;
    }
    :host([down-arrow]) paper-button:hover .downArrow {
      border-top-color: var(--deemphasized-text-color);
    }
  </style>
  <paper-button raised="[[!link]]" disabled="[[_disabled]]" tabindex="-1">
    <template is="dom-if" if="[[loading]]">
      <span class="loadingSpin"></span>
    </template>
    <slot></slot>
    <i class="downArrow"></i>
  </paper-button>
`
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,hp=ta`
  <style include="shared-styles">
    :host {
      --gr-tooltip-arrow-size: 0.5em;
      --gr-tooltip-arrow-center-offset: 0;

      background-color: var(--tooltip-background-color);
      box-shadow: var(--elevation-level-2);
      color: var(--tooltip-text-color);
      font-size: var(--font-size-small);
      position: absolute;
      z-index: 1000;
      max-width: var(--tooltip-max-width);
    }
    :host .tooltip {
      padding: var(--spacing-m) var(--spacing-l);
    }
    :host .arrowPositionBelow,
    :host([position-below]) .arrowPositionAbove {
      display: none;
    }
    :host([position-below]) .arrowPositionBelow {
      display: initial;
    }
    .arrow {
      border-left: var(--gr-tooltip-arrow-size) solid transparent;
      border-right: var(--gr-tooltip-arrow-size) solid transparent;
      height: 0;
      position: absolute;
      left: calc(50% - var(--gr-tooltip-arrow-size));
      margin-left: var(--gr-tooltip-arrow-center-offset);
      width: 0;
    }
    .arrowPositionAbove {
      border-top: var(--gr-tooltip-arrow-size) solid
        var(--tooltip-background-color);
      bottom: calc(-1 * var(--gr-tooltip-arrow-size));
    }
    .arrowPositionBelow {
      border-bottom: var(--gr-tooltip-arrow-size) solid
        var(--tooltip-background-color);
      top: calc(-1 * var(--gr-tooltip-arrow-size));
    }
  </style>
  <div class="tooltip">
    <i class="arrowPositionBelow arrow"></i>
    [[text]]
    <i class="arrowPositionAbove arrow"></i>
  </div>
`;var pp=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let up=class extends(oo(dr(oa))){constructor(){super(...arguments),this.text="",this.maxWidth="",this.positionBelow=!1}static get template(){return hp}_updateWidth(e){this.updateStyles({"--tooltip-max-width":e})}};pp([Bl({type:String})],up.prototype,"text",void 0),pp([Bl({type:String})],up.prototype,"maxWidth",void 0),pp([Bl({type:Boolean,reflectToAttribute:!0})],up.prototype,"positionBelow",void 0),pp([jl("maxWidth")],up.prototype,"_updateWidth",null),up=pp([Ml("gr-tooltip")],up);var gp=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const mp=Me(e=>{class t extends e{constructor(...e){super(),this.hasTooltip=!1,this.positionBelow=!1,this._isTouchDevice="ontouchstart"in document.documentElement,this._tooltip=null,this._titleText="",this._hasSetupTooltipListeners=!1,this.windowScrollHandler=()=>this._handleWindowScroll(),this.showHandler=()=>this._handleShowTooltip(),this.hideHandler=()=>this._handleHideTooltip()}disconnectedCallback(){super.disconnectedCallback(),this._handleHideTooltip(),this.mouseenterHandler&&this.removeEventListener("mouseenter",this.mouseenterHandler),window.removeEventListener("scroll",this.windowScrollHandler)}_setupTooltipListeners(){if(this.mouseenterHandler||(this.mouseenterHandler=this.showHandler),!this.hasTooltip)return this.removeEventListener("mouseenter",this.mouseenterHandler),void(this._hasSetupTooltipListeners=!1);this._hasSetupTooltipListeners||(this._hasSetupTooltipListeners=!0,this.addEventListener("mouseenter",this.mouseenterHandler))}_handleShowTooltip(){if(this._isTouchDevice)return;if(!this.hasAttribute("title")||""===this.getAttribute("title")||this._tooltip)return;this._titleText=this.getAttribute("title")||"",this.setAttribute("title","");const e=document.createElement("gr-tooltip");e.text=this._titleText,e.maxWidth=this.getAttribute("max-width")||"",e.positionBelow=this.hasAttribute("position-below"),e.style.visibility="hidden",mh().appendChild(e),this._positionTooltip(e),e.style.visibility="initial",this._tooltip=e,window.addEventListener("scroll",this.windowScrollHandler),this.addEventListener("mouseleave",this.hideHandler),this.addEventListener("click",this.hideHandler)}_handleHideTooltip(){var e;this._isTouchDevice||this.hasAttribute("title")&&this._titleText&&(window.removeEventListener("scroll",this.windowScrollHandler),this.removeEventListener("mouseleave",this.hideHandler),this.removeEventListener("click",this.hideHandler),this.setAttribute("title",this._titleText),(null===(e=this._tooltip)||void 0===e?void 0:e.parentNode)&&this._tooltip.parentNode.removeChild(this._tooltip),this._tooltip=null)}_handleWindowScroll(){this._tooltip&&this._positionTooltip(this._tooltip)}_positionTooltip(e){Mo();const t=this.getBoundingClientRect(),n=e.getBoundingClientRect();if(!e.parentElement)return;const i=e.parentElement.getBoundingClientRect(),o=t.top-i.top,s=t.left-i.left+(t.width-n.width)/2,r=i.width-s-n.width;s<0?e.updateStyles({"--gr-tooltip-arrow-center-offset":`${s}px`}):r<0&&e.updateStyles({"--gr-tooltip-arrow-center-offset":`${-.5*r}px`}),e.style.left=`${Math.max(0,s)}px`,this.positionBelow?e.style.top=`${o+t.height+7.2}px`:(e.style.top=`${Math.max(0,o)}px`,e.style.transform="translateY(calc(-100% - 7.2px))")}}return gp([Bl({type:Boolean})],t.prototype,"hasTooltip",void 0),gp([Bl({type:Boolean,reflectToAttribute:!0})],t.prototype,"positionBelow",void 0),gp([Bl({type:Boolean})],t.prototype,"_isTouchDevice",void 0),gp([Bl({type:Object})],t.prototype,"_tooltip",void 0),gp([Bl({type:String})],t.prototype,"_titleText",void 0),gp([Bl({type:Boolean})],t.prototype,"_hasSetupTooltipListeners",void 0),gp([jl("hasTooltip")],t.prototype,"_setupTooltipListeners",null),t});
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _p,fp=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};!function(e){e.DOC_ONLY="DOC_ONLY",e.GO_KEY="GO_KEY",e.V_KEY="V_KEY"}(_p||(_p={}));var vp,yp;!function(e){e.ACTIONS="Actions",e.DIFFS="Diffs",e.EVERYWHERE="Everywhere",e.FILE_LIST="File list",e.NAVIGATION="Navigation",e.REPLY_DIALOG="Reply dialog"}(vp||(vp={})),function(e){e.OPEN_SHORTCUT_HELP_DIALOG="OPEN_SHORTCUT_HELP_DIALOG",e.GO_TO_USER_DASHBOARD="GO_TO_USER_DASHBOARD",e.GO_TO_OPENED_CHANGES="GO_TO_OPENED_CHANGES",e.GO_TO_MERGED_CHANGES="GO_TO_MERGED_CHANGES",e.GO_TO_ABANDONED_CHANGES="GO_TO_ABANDONED_CHANGES",e.GO_TO_WATCHED_CHANGES="GO_TO_WATCHED_CHANGES",e.CURSOR_NEXT_CHANGE="CURSOR_NEXT_CHANGE",e.CURSOR_PREV_CHANGE="CURSOR_PREV_CHANGE",e.OPEN_CHANGE="OPEN_CHANGE",e.NEXT_PAGE="NEXT_PAGE",e.PREV_PAGE="PREV_PAGE",e.TOGGLE_CHANGE_REVIEWED="TOGGLE_CHANGE_REVIEWED",e.TOGGLE_CHANGE_STAR="TOGGLE_CHANGE_STAR",e.REFRESH_CHANGE_LIST="REFRESH_CHANGE_LIST",e.OPEN_REPLY_DIALOG="OPEN_REPLY_DIALOG",e.OPEN_DOWNLOAD_DIALOG="OPEN_DOWNLOAD_DIALOG",e.EXPAND_ALL_MESSAGES="EXPAND_ALL_MESSAGES",e.COLLAPSE_ALL_MESSAGES="COLLAPSE_ALL_MESSAGES",e.UP_TO_DASHBOARD="UP_TO_DASHBOARD",e.UP_TO_CHANGE="UP_TO_CHANGE",e.TOGGLE_DIFF_MODE="TOGGLE_DIFF_MODE",e.REFRESH_CHANGE="REFRESH_CHANGE",e.EDIT_TOPIC="EDIT_TOPIC",e.DIFF_AGAINST_BASE="DIFF_AGAINST_BASE",e.DIFF_AGAINST_LATEST="DIFF_AGAINST_LATEST",e.DIFF_BASE_AGAINST_LEFT="DIFF_BASE_AGAINST_LEFT",e.DIFF_RIGHT_AGAINST_LATEST="DIFF_RIGHT_AGAINST_LATEST",e.DIFF_BASE_AGAINST_LATEST="DIFF_BASE_AGAINST_LATEST",e.NEXT_LINE="NEXT_LINE",e.PREV_LINE="PREV_LINE",e.VISIBLE_LINE="VISIBLE_LINE",e.NEXT_CHUNK="NEXT_CHUNK",e.PREV_CHUNK="PREV_CHUNK",e.EXPAND_ALL_DIFF_CONTEXT="EXPAND_ALL_DIFF_CONTEXT",e.NEXT_COMMENT_THREAD="NEXT_COMMENT_THREAD",e.PREV_COMMENT_THREAD="PREV_COMMENT_THREAD",e.EXPAND_ALL_COMMENT_THREADS="EXPAND_ALL_COMMENT_THREADS",e.COLLAPSE_ALL_COMMENT_THREADS="COLLAPSE_ALL_COMMENT_THREADS",e.LEFT_PANE="LEFT_PANE",e.RIGHT_PANE="RIGHT_PANE",e.TOGGLE_LEFT_PANE="TOGGLE_LEFT_PANE",e.NEW_COMMENT="NEW_COMMENT",e.SAVE_COMMENT="SAVE_COMMENT",e.OPEN_DIFF_PREFS="OPEN_DIFF_PREFS",e.TOGGLE_DIFF_REVIEWED="TOGGLE_DIFF_REVIEWED",e.NEXT_FILE="NEXT_FILE",e.PREV_FILE="PREV_FILE",e.NEXT_FILE_WITH_COMMENTS="NEXT_FILE_WITH_COMMENTS",e.PREV_FILE_WITH_COMMENTS="PREV_FILE_WITH_COMMENTS",e.NEXT_UNREVIEWED_FILE="NEXT_UNREVIEWED_FILE",e.CURSOR_NEXT_FILE="CURSOR_NEXT_FILE",e.CURSOR_PREV_FILE="CURSOR_PREV_FILE",e.OPEN_FILE="OPEN_FILE",e.TOGGLE_FILE_REVIEWED="TOGGLE_FILE_REVIEWED",e.TOGGLE_ALL_INLINE_DIFFS="TOGGLE_ALL_INLINE_DIFFS",e.TOGGLE_INLINE_DIFF="TOGGLE_INLINE_DIFF",e.TOGGLE_HIDE_ALL_COMMENT_THREADS="TOGGLE_HIDE_ALL_COMMENT_THREADS",e.OPEN_FIRST_FILE="OPEN_FIRST_FILE",e.OPEN_LAST_FILE="OPEN_LAST_FILE",e.SEARCH="SEARCH",e.SEND_REPLY="SEND_REPLY",e.EMOJI_DROPDOWN="EMOJI_DROPDOWN",e.TOGGLE_BLAME="TOGGLE_BLAME"}(yp||(yp={}));const bp=new Map;function wp(e,t,n){bp.has(t)||bp.set(t,[]);const i=bp.get(t);i&&i.push({shortcut:e,text:n})}function Cp(e){const t=qo(e.detail?e.detail.keyboardEvent:e);return"event"in t&&t.event?t.event:t}wp(yp.SEARCH,vp.EVERYWHERE,"Search"),wp(yp.OPEN_SHORTCUT_HELP_DIALOG,vp.EVERYWHERE,"Show this dialog"),wp(yp.GO_TO_USER_DASHBOARD,vp.EVERYWHERE,"Go to User Dashboard"),wp(yp.GO_TO_OPENED_CHANGES,vp.EVERYWHERE,"Go to Opened Changes"),wp(yp.GO_TO_MERGED_CHANGES,vp.EVERYWHERE,"Go to Merged Changes"),wp(yp.GO_TO_ABANDONED_CHANGES,vp.EVERYWHERE,"Go to Abandoned Changes"),wp(yp.GO_TO_WATCHED_CHANGES,vp.EVERYWHERE,"Go to Watched Changes"),wp(yp.CURSOR_NEXT_CHANGE,vp.ACTIONS,"Select next change"),wp(yp.CURSOR_PREV_CHANGE,vp.ACTIONS,"Select previous change"),wp(yp.OPEN_CHANGE,vp.ACTIONS,"Show selected change"),wp(yp.NEXT_PAGE,vp.ACTIONS,"Go to next page"),wp(yp.PREV_PAGE,vp.ACTIONS,"Go to previous page"),wp(yp.OPEN_REPLY_DIALOG,vp.ACTIONS,"Open reply dialog to publish comments and add reviewers"),wp(yp.OPEN_DOWNLOAD_DIALOG,vp.ACTIONS,"Open download overlay"),wp(yp.EXPAND_ALL_MESSAGES,vp.ACTIONS,"Expand all messages"),wp(yp.COLLAPSE_ALL_MESSAGES,vp.ACTIONS,"Collapse all messages"),wp(yp.REFRESH_CHANGE,vp.ACTIONS,"Reload the change at the latest patch"),wp(yp.TOGGLE_CHANGE_REVIEWED,vp.ACTIONS,"Mark/unmark change as reviewed"),wp(yp.TOGGLE_FILE_REVIEWED,vp.ACTIONS,"Toggle review flag on selected file"),wp(yp.REFRESH_CHANGE_LIST,vp.ACTIONS,"Refresh list of changes"),wp(yp.TOGGLE_CHANGE_STAR,vp.ACTIONS,"Star/unstar change"),wp(yp.EDIT_TOPIC,vp.ACTIONS,"Add a change topic"),wp(yp.DIFF_AGAINST_BASE,vp.ACTIONS,"Diff against base"),wp(yp.DIFF_AGAINST_LATEST,vp.ACTIONS,"Diff against latest patchset"),wp(yp.DIFF_BASE_AGAINST_LEFT,vp.ACTIONS,"Diff base against left"),wp(yp.DIFF_RIGHT_AGAINST_LATEST,vp.ACTIONS,"Diff right against latest"),wp(yp.DIFF_BASE_AGAINST_LATEST,vp.ACTIONS,"Diff base against latest"),wp(yp.NEXT_LINE,vp.DIFFS,"Go to next line"),wp(yp.PREV_LINE,vp.DIFFS,"Go to previous line"),wp(yp.DIFF_AGAINST_BASE,vp.DIFFS,"Diff against base"),wp(yp.DIFF_AGAINST_LATEST,vp.DIFFS,"Diff against latest patchset"),wp(yp.DIFF_BASE_AGAINST_LEFT,vp.DIFFS,"Diff base against left"),wp(yp.DIFF_RIGHT_AGAINST_LATEST,vp.DIFFS,"Diff right against latest"),wp(yp.DIFF_BASE_AGAINST_LATEST,vp.DIFFS,"Diff base against latest"),wp(yp.VISIBLE_LINE,vp.DIFFS,"Move cursor to currently visible code"),wp(yp.NEXT_CHUNK,vp.DIFFS,"Go to next diff chunk"),wp(yp.PREV_CHUNK,vp.DIFFS,"Go to previous diff chunk"),wp(yp.EXPAND_ALL_DIFF_CONTEXT,vp.DIFFS,"Expand all diff context"),wp(yp.NEXT_COMMENT_THREAD,vp.DIFFS,"Go to next comment thread"),wp(yp.PREV_COMMENT_THREAD,vp.DIFFS,"Go to previous comment thread"),wp(yp.EXPAND_ALL_COMMENT_THREADS,vp.DIFFS,"Expand all comment threads"),wp(yp.COLLAPSE_ALL_COMMENT_THREADS,vp.DIFFS,"Collapse all comment threads"),wp(yp.TOGGLE_HIDE_ALL_COMMENT_THREADS,vp.DIFFS,"Hide/Display all comment threads"),wp(yp.LEFT_PANE,vp.DIFFS,"Select left pane"),wp(yp.RIGHT_PANE,vp.DIFFS,"Select right pane"),wp(yp.TOGGLE_LEFT_PANE,vp.DIFFS,"Hide/show left diff"),wp(yp.NEW_COMMENT,vp.DIFFS,"Draft new comment"),wp(yp.SAVE_COMMENT,vp.DIFFS,"Save comment"),wp(yp.OPEN_DIFF_PREFS,vp.DIFFS,"Show diff preferences"),wp(yp.TOGGLE_DIFF_REVIEWED,vp.DIFFS,"Mark/unmark file as reviewed"),wp(yp.TOGGLE_DIFF_MODE,vp.DIFFS,"Toggle unified/side-by-side diff"),wp(yp.NEXT_UNREVIEWED_FILE,vp.DIFFS,"Mark file as reviewed and go to next unreviewed file"),wp(yp.TOGGLE_BLAME,vp.DIFFS,"Toggle blame"),wp(yp.NEXT_FILE,vp.NAVIGATION,"Go to next file"),wp(yp.PREV_FILE,vp.NAVIGATION,"Go to previous file"),wp(yp.NEXT_FILE_WITH_COMMENTS,vp.NAVIGATION,"Go to next file that has comments"),wp(yp.PREV_FILE_WITH_COMMENTS,vp.NAVIGATION,"Go to previous file that has comments"),wp(yp.OPEN_FIRST_FILE,vp.NAVIGATION,"Go to first file"),wp(yp.OPEN_LAST_FILE,vp.NAVIGATION,"Go to last file"),wp(yp.UP_TO_DASHBOARD,vp.NAVIGATION,"Up to dashboard"),wp(yp.UP_TO_CHANGE,vp.NAVIGATION,"Up to change"),wp(yp.CURSOR_NEXT_FILE,vp.FILE_LIST,"Select next file"),wp(yp.CURSOR_PREV_FILE,vp.FILE_LIST,"Select previous file"),wp(yp.OPEN_FILE,vp.FILE_LIST,"Go to selected file"),wp(yp.TOGGLE_ALL_INLINE_DIFFS,vp.FILE_LIST,"Show/hide all inline diffs"),wp(yp.TOGGLE_HIDE_ALL_COMMENT_THREADS,vp.FILE_LIST,"Hide/Display all comment threads"),wp(yp.TOGGLE_INLINE_DIFF,vp.FILE_LIST,"Show/hide selected inline diff"),wp(yp.SEND_REPLY,vp.REPLY_DIALOG,"Send reply"),wp(yp.EMOJI_DROPDOWN,vp.REPLY_DIALOG,"Emoji dropdown");const Ep=new class{constructor(){this.activeHosts=new Map,this.bindings=new Map,this.listeners=new Set}bindShortcut(e,...t){this.bindings.set(e,t)}getBindingsForShortcut(e){return this.bindings.get(e)}attachHost(e){if(!("keyboardShortcuts"in e))return;const t=e.keyboardShortcuts();return this.activeHosts.set(e,new Map(Object.entries(t))),this.notifyListeners(),t}detachHost(e){return!!this.activeHosts.delete(e)&&(this.notifyListeners(),!0)}addListener(e){this.listeners.add(e),e(this.directoryView())}removeListener(e){return this.listeners.delete(e)}getDescription(e,t){const n=bp.get(e);let i="";if(n){const e=n.find(e=>e.shortcut===t);i=e?e.text:""}return i}getShortcut(e){const t=this.bindings.get(e);return t?t.map(e=>this.describeBinding(e).join("+")).join(","):""}activeShortcutsBySection(){const e=new Set;this.activeHosts.forEach(t=>{t.forEach((t,n)=>e.add(n))});const t=new Map;return bp.forEach((n,i)=>{n.forEach(n=>{e.has(n.shortcut)&&(t.has(i)||t.set(i,[]),t.get(i).push(n))})}),t}directoryView(){const e=new Map;return this.activeShortcutsBySection().forEach((t,n)=>{const i=[];t.forEach(e=>{const t=this.describeBindings(e.shortcut);t&&this.distributeBindingDesc(t).forEach(t=>{i.push({binding:t,text:e.text})})}),e.set(n,i)}),e}distributeBindingDesc(e){if(1===e.length||this.comboSetDisplayWidth(e)<21)return[e];const t=[e[0]];for(let n=1;n<e.length;n++)if(t.push(e[n]),this.comboSetDisplayWidth(t)>=21)return t.pop(),[t].concat(this.distributeBindingDesc(e.slice(n)));return[]}comboSetDisplayWidth(e){return e.reduce((e,t)=>e+(e=>e.reduce((e,t)=>e+t.length,0))(t),0)+2*(e.length-1)}describeBindings(e){const t=this.bindings.get(e);return t?t[0]===_p.GO_KEY?t.slice(1).map(e=>this._describeKey(e)).map(e=>["g"].concat(e)):t[0]===_p.V_KEY?t.slice(1).map(e=>this._describeKey(e)).map(e=>["v"].concat(e)):t.filter(e=>e!==_p.DOC_ONLY).map(e=>this.describeBinding(e)):null}_describeKey(e){switch(e){case"shift":return"Shift";case"meta":return"Meta";case"ctrl":return"Ctrl";case"enter":return"Enter";case"up":return"↑";case"down":return"↓";case"left":return"←";case"right":return"→";default:return e}}describeBinding(e){return 1===e.length?[e]:e.split(":")[0].split("+").map(e=>this._describeKey(e))}notifyListeners(){const e=this.directoryView();this.listeners.forEach(t=>t(e))}};var Sp;!function(e){e.SHIFT_KEY="shiftKey",e.CTRL_KEY="ctrlKey",e.META_KEY="metaKey"}(Sp||(Sp={}));const Ap=Me(e=>{class t extends e{constructor(){super(...arguments),this._shortcut_go_key_last_pressed=null,this._shortcut_v_key_last_pressed=null,this._shortcut_go_table=new Map,this._shortcut_v_table=new Map,this.Shortcut=yp,this.ShortcutSection=vp}modifierPressed(e){const t=Cp(e);return t.altKey||t.ctrlKey||t.metaKey||t.shiftKey||!!this._inGoKeyMode()||!!this.inVKeyMode()}isModifierPressed(e,t){return Cp(e)[t]}shouldSuppressKeyboardShortcut(e){const t=Cp(e),n=qo(t).rootTarget,i=n.tagName,o=n.getAttribute("type");if("INPUT"===i&&"checkbox"!==o||"TEXTAREA"===i||13===t.keyCode&&"A"===i)return!0;for(let e=0;t.path&&e<t.path.length;e++)if("GR-OVERLAY"===t.path[e].tagName)return!0;return this.dispatchEvent(new CustomEvent("shortcut-triggered",{detail:{event:t,goKey:this._inGoKeyMode(),vKey:this.inVKeyMode()},composed:!0,bubbles:!0})),!1}getKeyboardEvent(e){return Cp(e)}getRootTarget(e){return qo(Cp(e)).rootTarget}bindShortcut(e,...t){Ep.bindShortcut(e,...t)}createTitle(e,t){const n=Ep.getDescription(t,e),i=Ep.getShortcut(e);return n&&i?`${n} (shortcut: ${i})`:""}_throttleWrap(e){let t;return n=>{void 0!==t&&Date.now()-t<500||(t=Date.now(),e(n))}}_addOwnKeyBindings(e,t){const n=Ep.getBindingsForShortcut(e);n&&n[0]!==_p.DOC_ONLY&&(n[0]===_p.GO_KEY?n.slice(1).forEach(e=>this._shortcut_go_table.set(e,t)):n[0]===_p.V_KEY?n.slice(1).forEach(e=>this._shortcut_v_table.set(e,t)):this.addOwnKeyBinding(n.join(" "),t))}connectedCallback(){super.connectedCallback();const e=Ep.attachHost(this);if(e){for(const t of Object.keys(e))this._addOwnKeyBindings(t,e[t]);this.addOwnKeyBinding("g:keydown","_handleGoKeyDown"),this.addOwnKeyBinding("g:keyup","_handleGoKeyUp"),this._shortcut_go_table.size>0&&this._shortcut_go_table.forEach((e,t)=>{this.addOwnKeyBinding(t,"_handleGoAction")}),this.addOwnKeyBinding("v:keydown","_handleVKeyDown"),this.addOwnKeyBinding("v:keyup","_handleVKeyUp"),this._shortcut_v_table.size>0&&this._shortcut_v_table.forEach((e,t)=>{this.addOwnKeyBinding(t,"_handleVAction")})}}disconnectedCallback(){super.disconnectedCallback(),Ep.detachHost(this)&&this.removeOwnKeyBindings()}keyboardShortcuts(){return{}}addKeyboardShortcutDirectoryListener(e){Ep.addListener(e)}removeKeyboardShortcutDirectoryListener(e){Ep.removeListener(e)}_handleVKeyDown(e){this.shouldSuppressKeyboardShortcut(e)||(this._shortcut_v_key_last_pressed=Date.now())}_handleVKeyUp(){setTimeout(()=>{this._shortcut_v_key_last_pressed=null},1e3)}inVKeyMode(){return this._shortcut_v_key_last_pressed&&Date.now()-this._shortcut_v_key_last_pressed<=1e3}_handleVAction(e){if(!this.inVKeyMode()||!this._shortcut_v_table.has(e.detail.key)||this.shouldSuppressKeyboardShortcut(e))return;e.preventDefault();const t=this._shortcut_v_table.get(e.detail.key);t&&this[t](e)}_handleGoKeyDown(e){this.shouldSuppressKeyboardShortcut(e)||(this._shortcut_go_key_last_pressed=Date.now())}_handleGoKeyUp(){setTimeout(()=>{this._shortcut_go_key_last_pressed=null},1e3)}_inGoKeyMode(){return this._shortcut_go_key_last_pressed&&Date.now()-this._shortcut_go_key_last_pressed<=1e3}_handleGoAction(e){if(!this._inGoKeyMode()||!this._shortcut_go_table.has(e.detail.key)||this.shouldSuppressKeyboardShortcut(e))return;e.preventDefault();const t=this._shortcut_go_table.get(e.detail.key);t&&this[t](e)}}return fp([Bl({type:Number})],t.prototype,"_shortcut_go_key_last_pressed",void 0),fp([Bl({type:Number})],t.prototype,"_shortcut_v_key_last_pressed",void 0),fp([Bl({type:Object})],t.prototype,"_shortcut_go_table",void 0),fp([Bl({type:Object})],t.prototype,"_shortcut_v_table",void 0),t}),xp=e=>Ap(mr([Lc],e));var Pp=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Rp=class extends(dr(xp(mp(oo(oa))))){constructor(){super(...arguments),this.downArrow=!1,this.link=!1,this.noUppercase=!1,this.loading=!1,this.disabled=null,this.tooltip="",this.reporting=n.reportingService}static get template(){return dp}get _disabled(){return this.disabled||this.loading}computeAriaDisabled(){return this._disabled}created(){super.created(),this._initialTabindex=this.getAttribute("tabindex")||"0",this.addEventListener("click",e=>this._handleAction(e)),this.addEventListener("keydown",e=>this._handleKeydown(e))}ready(){super.ready(),this._ensureAttribute("role","button"),this._ensureAttribute("tabindex","0")}_handleAction(e){if(this._disabled)return e.preventDefault(),e.stopPropagation(),void e.stopImmediatePropagation();this.reporting.reportInteraction("button-click",{path:zd(e)})}_disabledChanged(e){this.setAttribute("tabindex",e?"-1":this._initialTabindex||"0"),this.updateStyles()}_handleKeydown(e){this.modifierPressed(e)||13!==(e=this.getKeyboardEvent(e)).keyCode&&32!==e.keyCode||(e.preventDefault(),e.stopPropagation(),this.click())}};Pp([Bl({type:Boolean,reflectToAttribute:!0})],Rp.prototype,"downArrow",void 0),Pp([Bl({type:Boolean,reflectToAttribute:!0})],Rp.prototype,"link",void 0),Pp([Bl({type:Boolean})],Rp.prototype,"noUppercase",void 0),Pp([Bl({type:Boolean,reflectToAttribute:!0})],Rp.prototype,"loading",void 0),Pp([Bl({type:Boolean,reflectToAttribute:!0})],Rp.prototype,"disabled",void 0),Pp([Bl({type:String})],Rp.prototype,"tooltip",void 0),Pp([Bl({type:String})],Rp.prototype,"_initialTabindex",void 0),Pp([Hl("disabled","loading")],Rp.prototype,"_disabled",null),Pp([Bl({computed:"computeAriaDisabled(disabled, loading)",reflectToAttribute:!0,type:Boolean})],Rp.prototype,"ariaDisabled",void 0),Pp([jl("disabled")],Rp.prototype,"_disabledChanged",null),Rp=Pp([Ml("gr-button")],Rp);
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Tp=0,Ip=8,kp=1,Op=2,Np=3,Lp=4,Dp=7,$p=9,Mp=11,Fp=13,Bp=14,jp=16,Hp=18,Up=20,Gp=23;function Vp(...e){let t=0;for(let n=0;n<e.length;n++)t|=1<<e[n];return t.toString(16)}function zp(e,t,n){let i=`${j()}/changes/${encodeURIComponent(e)}~${t}`;return n&&(i+=`/revisions/${n}`),i}function Wp(e){return(null==e?void 0:e.status)===Ia.NEW}function qp(e,t){const n=[];return e.status===Ia.MERGED?n.push("Merged"):e.status===Ia.ABANDONED?n.push("Abandoned"):(!1===e.mergeable||t&&!1===t.mergeable)&&n.push("Merge Conflict"),e.work_in_progress&&n.push("WIP"),e.is_private&&n.push("Private"),n.length||!t?n:(e.submittable&&t.submitEnabled?n.push("Ready to submit"):n.push("Active"),n)}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Kp=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Yp="sendDiffDraft",Xp="Saving draft resulted in HTTP 200 (OK) but expected HTTP 201 (Created)",Jp=/^set-cookie$/i;let Zp=new Wl,Qp=new ql,eu={},tu=new $l,nu={};let iu=class extends(oo(dr(oa))){constructor(){super(),this.JSON_PREFIX=")]}'",this._cache=Zp,this._sharedFetchPromises=Qp,this._pendingRequests=eu,this._etags=tu,this._projectLookup=nu,this.authService=n.authService,this._restApiHelper=new Kl(this._cache,this.authService,this._sharedFetchPromises,this)}_fetchSharedCacheURL(e){return this._restApiHelper.fetchCacheURL(e)}getResponseObject(e){return this._restApiHelper.getResponseObject(e)}getConfig(e){return e?this._restApiHelper.fetchJSON({url:"/config/server/info",reportUrlAsIs:!0}):this._fetchSharedCacheURL({url:"/config/server/info",reportUrlAsIs:!0})}getRepo(e,t){return this._fetchSharedCacheURL({url:"/projects/"+encodeURIComponent(e),errFn:t,anonymizedUrl:"/projects/*"})}getProjectConfig(e,t){return this._fetchSharedCacheURL({url:"/projects/"+encodeURIComponent(e)+"/config",errFn:t,anonymizedUrl:"/projects/*/config"})}getRepoAccess(e){return this._fetchSharedCacheURL({url:"/access/?project="+encodeURIComponent(e),anonymizedUrl:"/access/?project=*"})}getRepoDashboards(e,t){return this._fetchSharedCacheURL({url:`/projects/${encodeURIComponent(e)}/dashboards?inherited`,errFn:t,anonymizedUrl:"/projects/*/dashboards?inherited"})}saveRepoConfig(e,t,n){const i=`/projects/${encodeURIComponent(e)}/config`;return this._cache.delete(i),this._restApiHelper.send({method:qa.PUT,url:i,body:t,errFn:n,anonymizedUrl:"/projects/*/config"})}runRepoGC(e,t){if(!e)return"";const n=encodeURIComponent(e);return this._restApiHelper.send({method:qa.POST,url:`/projects/${n}/gc`,body:"",errFn:t,anonymizedUrl:"/projects/*/gc"})}createRepo(e,t){if(!e.name)return"";const n=encodeURIComponent(e.name);return this._restApiHelper.send({method:qa.PUT,url:`/projects/${n}`,body:e,errFn:t,anonymizedUrl:"/projects/*"})}createGroup(e,t){if(!e.name)return"";const n=encodeURIComponent(e.name);return this._restApiHelper.send({method:qa.PUT,url:`/groups/${n}`,body:e,errFn:t,anonymizedUrl:"/groups/*"})}getGroupConfig(e,t){return this._restApiHelper.fetchJSON({url:`/groups/${encodeURIComponent(e)}/detail`,errFn:t,anonymizedUrl:"/groups/*/detail"})}deleteRepoBranches(e,t,n){if(!e||!t)return"";const i=encodeURIComponent(e),o=encodeURIComponent(t);return this._restApiHelper.send({method:qa.DELETE,url:`/projects/${i}/branches/${o}`,body:"",errFn:n,anonymizedUrl:"/projects/*/branches/*"})}deleteRepoTags(e,t,n){if(!e||!t)return"";const i=encodeURIComponent(e),o=encodeURIComponent(t);return this._restApiHelper.send({method:qa.DELETE,url:`/projects/${i}/tags/${o}`,body:"",errFn:n,anonymizedUrl:"/projects/*/tags/*"})}createRepoBranch(e,t,n,i){if(!e||!t||!n)return"";const o=encodeURIComponent(e),s=encodeURIComponent(t);return this._restApiHelper.send({method:qa.PUT,url:`/projects/${o}/branches/${s}`,body:n,errFn:i,anonymizedUrl:"/projects/*/branches/*"})}createRepoTag(e,t,n,i){if(!e||!t||!n)return"";const o=encodeURIComponent(e),s=encodeURIComponent(t);return this._restApiHelper.send({method:qa.PUT,url:`/projects/${o}/tags/${s}`,body:n,errFn:i,anonymizedUrl:"/projects/*/tags/*"})}getIsGroupOwner(e){const t={url:`/groups/?owned&g=${encodeURIComponent(e)}`,anonymizedUrl:"/groups/owned&g=*"};return this._fetchSharedCacheURL(t).then(t=>o(t,e))}getGroupMembers(e,t){const n=encodeURIComponent(e);return this._restApiHelper.fetchJSON({url:`/groups/${n}/members/`,errFn:t,anonymizedUrl:"/groups/*/members"})}getIncludedGroup(e){return this._restApiHelper.fetchJSON({url:`/groups/${encodeURIComponent(e)}/groups/`,anonymizedUrl:"/groups/*/groups"})}saveGroupName(e,t){const n=encodeURIComponent(e);return this._restApiHelper.send({method:qa.PUT,url:`/groups/${n}/name`,body:{name:t},anonymizedUrl:"/groups/*/name"})}saveGroupOwner(e,t){const n=encodeURIComponent(e);return this._restApiHelper.send({method:qa.PUT,url:`/groups/${n}/owner`,body:{owner:t},anonymizedUrl:"/groups/*/owner"})}saveGroupDescription(e,t){const n=encodeURIComponent(e);return this._restApiHelper.send({method:qa.PUT,url:`/groups/${n}/description`,body:{description:t},anonymizedUrl:"/groups/*/description"})}saveGroupOptions(e,t){const n=encodeURIComponent(e);return this._restApiHelper.send({method:qa.PUT,url:`/groups/${n}/options`,body:t,anonymizedUrl:"/groups/*/options"})}getGroupAuditLog(e,t){return this._fetchSharedCacheURL({url:`/groups/${e}/log.audit`,errFn:t,anonymizedUrl:"/groups/*/log.audit"})}saveGroupMember(e,t){const n=encodeURIComponent(e),i=encodeURIComponent(`${t}`);return this._restApiHelper.send({method:qa.PUT,url:`/groups/${n}/members/${i}`,parseResponse:!0,anonymizedUrl:"/groups/*/members/*"})}saveIncludedGroup(e,t,n){const i=encodeURIComponent(e),o=encodeURIComponent(t),s={method:qa.PUT,url:`/groups/${i}/groups/${o}`,errFn:n,anonymizedUrl:"/groups/*/groups/*"};return this._restApiHelper.send(s).then(e=>{if(null==e?void 0:e.ok)return this.getResponseObject(e)})}deleteGroupMember(e,t){const n=encodeURIComponent(e),i=encodeURIComponent(`${t}`);return this._restApiHelper.send({method:qa.DELETE,url:`/groups/${n}/members/${i}`,anonymizedUrl:"/groups/*/members/*"})}deleteIncludedGroup(e,t){const n=encodeURIComponent(e),i=encodeURIComponent(t);return this._restApiHelper.send({method:qa.DELETE,url:`/groups/${n}/groups/${i}`,anonymizedUrl:"/groups/*/groups/*"})}getVersion(){return this._fetchSharedCacheURL({url:"/config/server/version",reportUrlAsIs:!0})}getDiffPreferences(){return this.getLoggedIn().then(e=>{if(e)return this._fetchSharedCacheURL({url:"/accounts/self/preferences.diff",reportUrlAsIs:!0});const t={auto_hide_diff_table_header:!0,context:10,cursor_blink_rate:0,font_size:12,ignore_whitespace:tl.IGNORE_NONE,intraline_difference:!0,line_length:100,line_wrapping:!1,show_line_endings:!0,show_tabs:!0,show_whitespace_errors:!0,syntax_highlighting:!0,tab_size:8,theme:"DEFAULT"};return Promise.resolve(t)})}getEditPreferences(){return this.getLoggedIn().then(e=>{if(e)return this._fetchSharedCacheURL({url:"/accounts/self/preferences.edit",reportUrlAsIs:!0});return Promise.resolve({auto_close_brackets:!1,cursor_blink_rate:0,hide_line_numbers:!1,hide_top_menu:!1,indent_unit:2,indent_with_tabs:!1,key_map_type:"DEFAULT",line_length:100,line_wrapping:!1,match_brackets:!0,show_base:!1,show_tabs:!0,show_whitespace_errors:!0,syntax_highlighting:!0,tab_size:8,theme:"DEFAULT"})})}savePreferences(e,t){return e.download_scheme&&(e.download_scheme=e.download_scheme.toLowerCase()),this._restApiHelper.send({method:qa.PUT,url:"/accounts/self/preferences",body:e,errFn:t,reportUrlAsIs:!0})}saveDiffPreferences(e,t){return this._cache.delete("/accounts/self/preferences.diff"),this._restApiHelper.send({method:qa.PUT,url:"/accounts/self/preferences.diff",body:e,errFn:t,reportUrlAsIs:!0})}saveEditPreferences(e,t){return this._cache.delete("/accounts/self/preferences.edit"),this._restApiHelper.send({method:qa.PUT,url:"/accounts/self/preferences.edit",body:e,errFn:t,reportUrlAsIs:!0})}getAccount(){return this._fetchSharedCacheURL({url:"/accounts/self/detail",reportUrlAsIs:!0,errFn:e=>{e&&403!==e.status||this._cache.delete("/accounts/self/detail")}})}getAvatarChangeUrl(){return this._fetchSharedCacheURL({url:"/accounts/self/avatar.change.url",reportUrlAsIs:!0,errFn:e=>{e&&403!==e.status||this._cache.delete("/accounts/self/avatar.change.url")}})}getExternalIds(){return this._restApiHelper.fetchJSON({url:"/accounts/self/external.ids",reportUrlAsIs:!0})}deleteAccountIdentity(e){return this._restApiHelper.send({method:qa.POST,url:"/accounts/self/external.ids:delete",body:e,parseResponse:!0,reportUrlAsIs:!0})}getAccountDetails(e){return this._restApiHelper.fetchJSON({url:`/accounts/${encodeURIComponent(e)}/detail`,anonymizedUrl:"/accounts/*/detail"})}getAccountEmails(){return this._fetchSharedCacheURL({url:"/accounts/self/emails",reportUrlAsIs:!0})}addAccountEmail(e,t){return this._restApiHelper.send({method:qa.PUT,url:"/accounts/self/emails/"+encodeURIComponent(e),errFn:t,anonymizedUrl:"/account/self/emails/*"})}deleteAccountEmail(e,t){return this._restApiHelper.send({method:qa.DELETE,url:"/accounts/self/emails/"+encodeURIComponent(e),errFn:t,anonymizedUrl:"/accounts/self/email/*"})}setPreferredAccountEmail(e,t){const n=encodeURIComponent(e),i={method:qa.PUT,url:`/accounts/self/emails/${n}/preferred`,errFn:t,anonymizedUrl:"/accounts/self/emails/*/preferred"};return this._restApiHelper.send(i).then(()=>{const t=this._cache.get("/accounts/self/emails");if(t){const n=t.map(t=>t.email===e?{email:e,preferred:!0}:{email:e});this._cache.set("/accounts/self/emails",n)}})}_updateCachedAccount(e){const t=this._cache.get("/accounts/self/detail");t&&this._cache.set("/accounts/self/detail",{...t,...e})}setAccountName(e,t){const n={method:qa.PUT,url:"/accounts/self/name",body:{name:e},errFn:t,parseResponse:!0,reportUrlAsIs:!0};return this._restApiHelper.send(n).then(e=>this._updateCachedAccount({name:e}))}setAccountUsername(e,t){const n={method:qa.PUT,url:"/accounts/self/username",body:{username:e},errFn:t,parseResponse:!0,reportUrlAsIs:!0};return this._restApiHelper.send(n).then(e=>this._updateCachedAccount({username:e}))}setAccountDisplayName(e,t){const n={method:qa.PUT,url:"/accounts/self/displayname",body:{display_name:e},errFn:t,parseResponse:!0,reportUrlAsIs:!0};return this._restApiHelper.send(n).then(e=>this._updateCachedAccount({display_name:e}))}setAccountStatus(e,t){const n={method:qa.PUT,url:"/accounts/self/status",body:{status:e},errFn:t,parseResponse:!0,reportUrlAsIs:!0};return this._restApiHelper.send(n).then(e=>this._updateCachedAccount({status:e}))}getAccountStatus(e){return this._restApiHelper.fetchJSON({url:`/accounts/${encodeURIComponent(e)}/status`,anonymizedUrl:"/accounts/*/status"})}getAccountGroups(){return this._restApiHelper.fetchJSON({url:"/accounts/self/groups",reportUrlAsIs:!0})}getAccountAgreements(){return this._restApiHelper.fetchJSON({url:"/accounts/self/agreements",reportUrlAsIs:!0})}saveAccountAgreement(e){return this._restApiHelper.send({method:qa.PUT,url:"/accounts/self/agreements",body:e,reportUrlAsIs:!0})}getAccountCapabilities(e){let t="";return e&&(t="?q="+e.map(e=>encodeURIComponent(e)).join("&q=")),this._fetchSharedCacheURL({url:"/accounts/self/capabilities"+t,anonymizedUrl:"/accounts/self/capabilities?q=*"})}getLoggedIn(){return this.authService.authCheck()}getIsAdmin(){return this.getLoggedIn().then(e=>e?this.getAccountCapabilities():void 0).then(e=>e&&e.administrateServer)}getDefaultPreferences(){return this._fetchSharedCacheURL({url:"/config/server/preferences",reportUrlAsIs:!0})}getPreferences(){return this.getLoggedIn().then(e=>{if(e){const e={url:"/accounts/self/preferences",reportUrlAsIs:!0};return this._fetchSharedCacheURL(e).then(e=>{if(!e)return e;const t=e;return this._isNarrowScreen()?t.default_diff_view=Za.UNIFIED:t.default_diff_view=t.diff_view,t})}return{changes_per_page:25,default_diff_view:this._isNarrowScreen()?Za.UNIFIED:Za.SIDE_BY_SIDE,diff_view:Za.SIDE_BY_SIDE,size_bar_in_change_table:!0}})}getWatchedProjects(){return this._fetchSharedCacheURL({url:"/accounts/self/watched.projects",reportUrlAsIs:!0})}saveWatchedProjects(e,t){return this._restApiHelper.send({method:qa.POST,url:"/accounts/self/watched.projects",body:e,errFn:t,parseResponse:!0,reportUrlAsIs:!0})}deleteWatchedProjects(e,t){return this._restApiHelper.send({method:qa.POST,url:"/accounts/self/watched.projects:delete",body:e,errFn:t,reportUrlAsIs:!0})}_isNarrowScreen(){return window.innerWidth<850}getChanges(e,t,n,i){return this.getConfig(!1).then(o=>{i=i||this._getChangesOptionsHex(o),"n,z"===n&&(n=0);const s={O:i,S:n||0};return e&&(s.n=e),t&&t.length>0&&(s.q=t),{url:"/changes/",params:s,reportUrlAsIs:!0}}).then(e=>this._restApiHelper.fetchJSON(e,!0)).then(e=>{if(!e)return;const n=e=>{for(const t of e)this._maybeInsertInLookup(t)};if(t instanceof Array){const i=1===t.length?[e]:e;for(const e of i)n(e);return i}return n(e),e})}_maybeInsertInLookup(e){(null==e?void 0:e.project)&&e._number&&this.setInProjectLookup(e._number,e.project)}getChangeActionURL(e,t,n){return this._changeBaseURL(e,t).then(e=>e+n)}getChangeDetail(e,t,n){return this.getConfig(!1).then(i=>{const o=this._getChangeOptionsHex(i);return this._getChangeDetail(e,o,t,n).then(e=>_c.parse(e))})}_getChangesOptionsHex(e){if(window.DEFAULT_DETAIL_HEXES&&window.DEFAULT_DETAIL_HEXES.dashboardPage)return window.DEFAULT_DETAIL_HEXES.dashboardPage;const t=[Tp,Dp];return(null==e?void 0:e.change)&&e.change.enable_attention_set?t.push(Ip):t.push(Mp),Vp(...t)}_getChangeOptionsHex(e){var t;if(window.DEFAULT_DETAIL_HEXES&&window.DEFAULT_DETAIL_HEXES.changePage&&(!e||!e.receive||!e.receive.enable_signed_push))return window.DEFAULT_DETAIL_HEXES.changePage;const n=[Lp,Op,jp,Ip,Fp,$p,Up,Bp,Gp];return(null===(t=null==e?void 0:e.receive)||void 0===t?void 0:t.enable_signed_push)&&n.push(Hp),Vp(...n)}getDiffChangeDetail(e,t,n){var i;let o="";return o=(null===(i=window.DEFAULT_DETAIL_HEXES)||void 0===i?void 0:i.diffPage)?window.DEFAULT_DETAIL_HEXES.diffPage:Vp(Lp,Op,Gp),this._getChangeDetail(e,o,t,n)}_getChangeDetail(e,t,n,i){return this.getChangeActionURL(e,void 0,"/detail").then(e=>{const o={O:t},s=this._restApiHelper.urlWithParams(e,o),r={url:e,errFn:n,cancelCondition:i,params:o,fetchOptions:this._etags.getOptions(s),anonymizedUrl:"/changes/*~*/detail?O="+t};return this._restApiHelper.fetchRawJSON(r).then(e=>304===(null==e?void 0:e.status)?this._restApiHelper.parsePrefixedJSON(this._etags.getCachedPayload(s)):!e||e.ok?e?this._restApiHelper.readResponsePayload(e).then(t=>t?(this._etags.collect(s,e,t.raw),this._maybeInsertInLookup(t.parsed),t.parsed):null):Promise.resolve(null):void(n?n.call(null,e):this.dispatchEvent(new CustomEvent("server-error",{detail:{request:r,response:e},composed:!0,bubbles:!0}))))})}getChangeCommitInfo(e,t){return this._getChangeURLAndFetch({changeNum:e,endpoint:"/commit?links",patchNum:t,reportEndpointAsIs:!0})}getChangeFiles(e,t){let n=void 0;return Eh(t.basePatchNum)?n={parent:Oh(t.basePatchNum)}:Ch(t.basePatchNum,"PARENT")||(n={base:t.basePatchNum}),this._getChangeURLAndFetch({changeNum:e,endpoint:"/files",patchNum:t.patchNum,params:n,reportEndpointAsIs:!0})}getChangeEditFiles(e,t){let n="/edit?list",i=n;return"PARENT"!==t.basePatchNum&&(n+="&base="+encodeURIComponent(`${t.basePatchNum}`),i+="&base=*"),this._getChangeURLAndFetch({changeNum:e,endpoint:n,anonymizedEndpoint:i})}queryChangeFiles(e,t,n){return this._getChangeURLAndFetch({changeNum:e,endpoint:`/files?q=${encodeURIComponent(n)}`,patchNum:t,anonymizedEndpoint:"/files?q=*"})}getChangeOrEditFiles(e,t){return Ch(t.patchNum,"edit")?this.getChangeEditFiles(e,t).then(e=>e&&e.files):this.getChangeFiles(e,t)}getChangeRevisionActions(e,t){const n={changeNum:e,endpoint:"/actions",patchNum:t,reportEndpointAsIs:!0};return this._getChangeURLAndFetch(n)}getChangeSuggestedReviewers(e,t,n){return this._getChangeSuggestedGroup(Na.REVIEWER,e,t,n)}getChangeSuggestedCCs(e,t,n){return this._getChangeSuggestedGroup(Na.CC,e,t,n)}_getChangeSuggestedGroup(e,t,n,i){const o={n:6,"reviewer-state":e};return n&&(o.q=n),this._getChangeURLAndFetch({changeNum:t,endpoint:"/suggest_reviewers",errFn:i,params:o,reportEndpointAsIs:!0})}getChangeIncludedIn(e){return this._getChangeURLAndFetch({changeNum:e,endpoint:"/in",reportEndpointAsIs:!0})}_computeFilter(e){return e=(null==e?void 0:e.startsWith("^"))?"&r="+encodeURIComponent(e):e?"&m="+encodeURIComponent(e):""}_getGroupsUrl(e,t,n){return`/groups/?n=${t+1}&S=${n=n||0}`+this._computeFilter(e)}_getReposUrl(e,t,n){const i=/[@.\-\s/_]/g;if(n=n||0,e&&!e.includes(":")&&e.match(i)){const t=e;e="",t.split(i).forEach(t=>{t&&(e+=(""===e?"inname:":" AND inname:")+t)})}return e||(e="state:active OR state:read-only"),e=e.trim(),`/projects/?n=${t+1}&S=${n}`+`&query=${encodeURIComponent(e)}`}invalidateGroupsCache(){this._restApiHelper.invalidateFetchPromisesPrefix("/groups/?")}invalidateReposCache(){this._restApiHelper.invalidateFetchPromisesPrefix("/projects/?")}invalidateAccountsCache(){this._restApiHelper.invalidateFetchPromisesPrefix("/accounts/")}getGroups(e,t,n){const i=this._getGroupsUrl(e,t,n);return this._fetchSharedCacheURL({url:i,anonymizedUrl:"/groups/?*"})}getRepos(e,t,n){const i=this._getReposUrl(e,t,n);return this._fetchSharedCacheURL({url:i,anonymizedUrl:"/projects/?*"})}setRepoHead(e,t){return this._restApiHelper.send({method:qa.PUT,url:`/projects/${encodeURIComponent(e)}/HEAD`,body:{ref:t},anonymizedUrl:"/projects/*/HEAD"})}getRepoBranches(e,t,n,i,o){i=i||0;const s=n+1;e=this._computeFilter(e);const r=`/projects/${encodeURIComponent(t)}/branches?n=${s}&S=${i}${e}`;return this._restApiHelper.fetchJSON({url:r,errFn:o,anonymizedUrl:"/projects/*/branches?*"})}getRepoTags(e,t,n,i,o){i=i||0;const s=`/projects/${encodeURIComponent(t)}/tags`+`?n=${n+1}&S=${i}`+this._computeFilter(e);return this._restApiHelper.fetchJSON({url:s,errFn:o,anonymizedUrl:"/projects/*/tags"})}getPlugins(e,t,n,i){const o=`/plugins/?all&n=${t+1}&S=${n=n||0}${this._computeFilter(e)}`;return this._restApiHelper.fetchJSON({url:o,errFn:i,anonymizedUrl:"/plugins/?all"})}getRepoAccessRights(e,t){return this._restApiHelper.fetchJSON({url:`/projects/${encodeURIComponent(e)}/access`,errFn:t,anonymizedUrl:"/projects/*/access"})}setRepoAccessRights(e,t){return this._restApiHelper.send({method:qa.POST,url:`/projects/${encodeURIComponent(e)}/access`,body:t,anonymizedUrl:"/projects/*/access"})}setRepoAccessRightsForReview(e,t){return this._restApiHelper.send({method:qa.PUT,url:`/projects/${encodeURIComponent(e)}/access:review`,body:t,parseResponse:!0,anonymizedUrl:"/projects/*/access:review"})}getSuggestedGroups(e,t,n){const i={s:e};return t&&(i.n=t),this._restApiHelper.fetchJSON({url:"/groups/",errFn:n,params:i,reportUrlAsIs:!0})}getSuggestedProjects(e,t,n){const i={m:e,n:25,type:"ALL"};return t&&(i.n=t),this._restApiHelper.fetchJSON({url:"/projects/",errFn:n,params:i,reportUrlAsIs:!0})}getSuggestedAccounts(e,t,n){if(!e)return Promise.resolve([]);const i={suggest:null,q:e};return t&&(i.n=t),this._restApiHelper.fetchJSON({url:"/accounts/",errFn:n,params:i,anonymizedUrl:"/accounts/?n=*"})}addChangeReviewer(e,t){return this._sendChangeReviewerRequest(qa.POST,e,t)}removeChangeReviewer(e,t){return this._sendChangeReviewerRequest(qa.DELETE,e,t)}_sendChangeReviewerRequest(e,t,n){return this.getChangeActionURL(t,void 0,"/reviewers").then(t=>{let i;switch(e){case qa.POST:i={reviewer:n};break;case qa.DELETE:t+="/"+encodeURIComponent(n);break;default:s(e,`Unsupported HTTP method: ${e}`)}return this._restApiHelper.send({method:e,url:t,body:i})})}getRelatedChanges(e,t){return this._getChangeURLAndFetch({changeNum:e,endpoint:"/related",patchNum:t,reportEndpointAsIs:!0})}getChangesSubmittedTogether(e){return this._getChangeURLAndFetch({changeNum:e,endpoint:"/submitted_together?o=NON_VISIBLE_CHANGES",reportEndpointAsIs:!0})}getChangeConflicts(e){const t={O:Vp(kp,Np),q:`status:open conflicts:${e}`};return this._restApiHelper.fetchJSON({url:"/changes/",params:t,anonymizedUrl:"/changes/conflicts:*"})}getChangeCherryPicks(e,t,n){const i={O:Vp(kp,Np),q:[`project:${e}`,`change:${t}`,`-change:${n}`,"-is:abandoned"].join(" ")};return this._restApiHelper.fetchJSON({url:"/changes/",params:i,anonymizedUrl:"/changes/change:*"})}getChangesWithSameTopic(e,t){const n={O:Vp(Tp,kp,Np,Ip),q:["status:open",`-change:${t}`,`topic:"${e}"`].join(" ")};return this._restApiHelper.fetchJSON({url:"/changes/",params:n,anonymizedUrl:"/changes/topic:*"})}getReviewedFiles(e,t){return this._getChangeURLAndFetch({changeNum:e,endpoint:"/files?reviewed",patchNum:t,reportEndpointAsIs:!0})}saveFileReviewed(e,t,n,i,o){return this._getChangeURLAndSend({changeNum:e,method:i?qa.PUT:qa.DELETE,patchNum:t,endpoint:`/files/${encodeURIComponent(n)}/reviewed`,errFn:o,anonymizedEndpoint:"/files/*/reviewed"})}saveChangeReview(e,t,n,i){const o=[this.awaitPendingDiffDrafts(),this.getChangeActionURL(e,t,"/review")];return Promise.all(o).then(([,e])=>this._restApiHelper.send({method:qa.POST,url:e,body:n,errFn:i}))}getChangeEdit(e,t){const n=t?{"download-commands":!0}:void 0;return this.getLoggedIn().then(t=>t?this._getChangeURLAndFetch({changeNum:e,endpoint:"/edit/",params:n,reportEndpointAsIs:!0},!0):Promise.resolve(!1))}createChange(e,t,n,i,o,s,r,a){return this._restApiHelper.send({method:qa.POST,url:"/changes/",body:{project:e,branch:t,subject:n,topic:i,is_private:o,work_in_progress:s,base_change:r,base_commit:a},parseResponse:!0,reportUrlAsIs:!0})}getFileContent(e,t,n){return(Ch(n,"edit")?this._getFileInChangeEdit(e,t):this._getFileInRevision(e,t,n,e=>(404!==(null==e?void 0:e.status)&&this.dispatchEvent(new CustomEvent("server-error",{detail:{res:e},composed:!0,bubbles:!0})),e))).then(e=>{if(!e||!e.ok)return e;const t=e.headers.get("X-FYI-Content-Type");return this.getResponseObject(e).then(e=>({content:e,type:t,ok:!0}))})}_getFileInRevision(e,t,n,i){return this._getChangeURLAndSend({changeNum:e,method:qa.GET,patchNum:n,endpoint:`/files/${encodeURIComponent(t)}/content`,errFn:i,headers:{Accept:"application/json"},anonymizedEndpoint:"/files/*/content"})}_getFileInChangeEdit(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.GET,endpoint:"/edit/"+encodeURIComponent(t),headers:{Accept:"application/json"},anonymizedEndpoint:"/edit/*"})}rebaseChangeEdit(e){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,endpoint:"/edit:rebase",reportEndpointAsIs:!0})}deleteChangeEdit(e){return this._getChangeURLAndSend({changeNum:e,method:qa.DELETE,endpoint:"/edit",reportEndpointAsIs:!0})}restoreFileInChangeEdit(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,endpoint:"/edit",body:{restore_path:t},reportEndpointAsIs:!0})}renameFileInChangeEdit(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,endpoint:"/edit",body:{old_path:t,new_path:n},reportEndpointAsIs:!0})}deleteFileInChangeEdit(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.DELETE,endpoint:"/edit/"+encodeURIComponent(t),anonymizedEndpoint:"/edit/*"})}saveChangeEdit(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,endpoint:"/edit/"+encodeURIComponent(t),body:n,contentType:"text/plain",anonymizedEndpoint:"/edit/*"})}saveFileUploadChangeEdit(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,endpoint:"/edit/"+encodeURIComponent(t),body:{binary_content:n},anonymizedEndpoint:"/edit/*"})}getRobotCommentFixPreview(e,t,n){return this._getChangeURLAndFetch({changeNum:e,patchNum:t,endpoint:`/fixes/${encodeURIComponent(n)}/preview`,reportEndpointAsId:!0})}applyFixSuggestion(e,t,n){return this._getChangeURLAndSend({method:qa.POST,changeNum:e,patchNum:t,endpoint:`/fixes/${encodeURIComponent(n)}/apply`,reportEndpointAsId:!0})}saveChangeCommitMessageEdit(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,endpoint:"/edit:message",body:{message:t},reportEndpointAsIs:!0})}publishChangeEdit(e){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,endpoint:"/edit:publish",reportEndpointAsIs:!0})}putChangeCommitMessage(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,endpoint:"/message",body:{message:t},reportEndpointAsIs:!0})}deleteChangeCommitMessage(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.DELETE,endpoint:`/messages/${t}`,reportEndpointAsIs:!0})}saveChangeStarred(e,t){return this.getFromProjectLookup(e).then(n=>{const i=`/accounts/self/starred.changes/${n?encodeURIComponent(n)+"~":""}${e}`;return this._restApiHelper.send({method:t?qa.PUT:qa.DELETE,url:i,anonymizedUrl:"/accounts/self/starred.changes/*"})})}saveChangeReviewed(e,t){return this.getConfig().then(n=>{if(!(!!n&&!!n.change&&n.change.enable_attention_set))return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,endpoint:t?"/reviewed":"/unreviewed"})})}send(e,t,n,i,o,s){return this._restApiHelper.send({method:e,url:t,body:n,errFn:i,contentType:o,headers:s})}getDiff(e,t,n,i,o,s){const r={context:"ALL",intraline:null,whitespace:o||tl.IGNORE_NONE};Eh(t)?r.parent=Oh(t):Ch(t,"PARENT")||(r.base=t);const a={changeNum:e,endpoint:`/files/${encodeURIComponent(i)}/diff`,patchNum:n,errFn:s,params:r,anonymizedEndpoint:"/files/*/diff"};return"edit"===n&&(a.fetchOptions||(a.fetchOptions={}),a.fetchOptions.headers||(a.fetchOptions.headers=new Headers),a.fetchOptions.headers.append("Cache-Control","no-cache")),this._getChangeURLAndFetch(a)}getDiffComments(e,t,n,i){return t||n||i?this._getDiffComments(e,"/comments",t,n,i):this._getDiffComments(e,"/comments")}getDiffRobotComments(e,t,n,i){return t||n||i?this._getDiffComments(e,"/robotcomments",t,n,i):this._getDiffComments(e,"/robotcomments")}getDiffDrafts(e,t,n,i){return this.getLoggedIn().then(o=>o?t||n||i?this._getDiffComments(e,"/drafts",t,n,i):this._getDiffComments(e,"/drafts"):{})}_setRange(e,t){if(t.in_reply_to&&!t.range)for(let n=0;n<e.length;n++)if(e[n].id===t.in_reply_to){t.range=e[n].range;break}return t}_setRanges(e){(e=e||[]).sort((e,t)=>lc(e.updated).valueOf()-lc(t.updated).valueOf());for(const t of e)this._setRange(e,t);return e}_getDiffComments(e,t,n,i,o){const s=n=>this._getChangeURLAndFetch({changeNum:e,endpoint:t,patchNum:n,reportEndpointAsIs:!0},!0);if(!n&&!i&&!o)return s();function r(e){return e.side===Ka.PARENT}function a(e){return e.side!==Ka.PARENT}function l(e){e.path=o}const c=[];let d,h,p;return p=s(i).then(e=>{d=e&&o&&e[o]||[],d=this._setRanges(d),"PARENT"===n&&(h=d.filter(r),h.forEach(l)),d=d.filter(a),d.forEach(l)}),c.push(p),"PARENT"!==n&&(p=s(n).then(e=>{h=(e&&o&&e[o]||[]).filter(a),h=this._setRanges(h),h.forEach(l)}),c.push(p)),Promise.all(c).then(()=>Promise.resolve({baseComments:h,comments:d}))}_getDiffCommentsFetchURL(e,t,n){return this._changeBaseURL(e,n).then(e=>e+t)}saveDiffDraft(e,t,n){return this._sendDiffDraftRequest(qa.PUT,e,t,n)}deleteDiffDraft(e,t,n){return this._sendDiffDraftRequest(qa.DELETE,e,t,n)}hasPendingDiffDrafts(){const e=this._pendingRequests[Yp];return e&&e.length}awaitPendingDiffDrafts(){return Promise.all(this._pendingRequests[Yp]||[]).then(()=>{this._pendingRequests[Yp]=[]})}_sendDiffDraftRequest(e,t,n,i){const o=!i.id&&e===qa.PUT;let s,r="/drafts",a=r;i.id&&(r+=`/${i.id}`,a+="/*"),e===qa.PUT&&(s=i),this._pendingRequests[Yp]||(this._pendingRequests[Yp]=[]);const l={changeNum:t,method:e,patchNum:n,endpoint:r,body:s,anonymizedEndpoint:a},c=this._getChangeURLAndSend(l);return this._pendingRequests[Yp].push(c),o?this._failForCreate200(c):c}getCommitInfo(e,t){return this._restApiHelper.fetchJSON({url:"/projects/"+encodeURIComponent(e)+"/commits/"+encodeURIComponent(t),anonymizedUrl:"/projects/*/comments/*"})}_fetchB64File(e){return this._restApiHelper.fetch({url:j()+e}).then(e=>{if(!e.ok)return Promise.reject(new Error(e.statusText));const t=e.headers.get("X-FYI-Content-Type");return e.text().then(e=>({body:e,type:t}))})}getB64FileContents(e,t,n,i){const o="number"==typeof i?`?parent=${i}`:"";return this._changeBaseURL(e,t).then(e=>(e=`${e}/files/${encodeURIComponent(n)}/content${o}`,this._fetchB64File(e)))}getImagesForDiff(e,t,n){var i,o;let s,r;return s=(null===(i=t.meta_a)||void 0===i?void 0:i.content_type.startsWith("image/"))?"PARENT"===n.basePatchNum?this.getB64FileContents(e,n.patchNum,t.meta_a.name,1):this.getB64FileContents(e,n.basePatchNum,t.meta_a.name):Promise.resolve(null),r=(null===(o=t.meta_b)||void 0===o?void 0:o.content_type.startsWith("image/"))?this.getB64FileContents(e,n.patchNum,t.meta_b.name):Promise.resolve(null),Promise.all([s,r]).then(e=>({baseImage:e[0]?{...e[0],_expectedType:t.meta_a.content_type,_name:t.meta_a.name}:null,revisionImage:e[1]?{...e[1],_expectedType:t.meta_b.content_type,_name:t.meta_b.name}:null}))}_changeBaseURL(e,t,n){return(n?Promise.resolve(n):this.getFromProjectLookup(e)).then(n=>{let i=`/changes/${encodeURIComponent(n)}~${e}`;return t&&(i+=`/revisions/${t}`),i})}addToAttentionSet(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,endpoint:"/attention",body:{user:t,reason:n},reportUrlAsIs:!0})}removeFromAttentionSet(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.DELETE,endpoint:`/attention/${t}`,anonymizedEndpoint:"/attention/*",body:{reason:n}})}setChangeTopic(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,endpoint:"/topic",body:{topic:t},parseResponse:!0,reportUrlAsIs:!0})}setChangeHashtag(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,endpoint:"/hashtags",body:t,parseResponse:!0,reportUrlAsIs:!0})}deleteAccountHttpPassword(){return this._restApiHelper.send({method:qa.DELETE,url:"/accounts/self/password.http",reportUrlAsIs:!0})}generateAccountHttpPassword(){return this._restApiHelper.send({method:qa.PUT,url:"/accounts/self/password.http",body:{generate:!0},parseResponse:!0,reportUrlAsIs:!0})}getAccountSSHKeys(){return this._fetchSharedCacheURL({url:"/accounts/self/sshkeys",reportUrlAsIs:!0})}addAccountSSHKey(e){const t={method:qa.POST,url:"/accounts/self/sshkeys",body:e,contentType:"text/plain",reportUrlAsIs:!0};return this._restApiHelper.send(t).then(e=>!e||e.status<200&&e.status>=300?Promise.reject(new Error("error")):this.getResponseObject(e)).then(e=>e&&e.valid?e:Promise.reject(new Error("error")))}deleteAccountSSHKey(e){return this._restApiHelper.send({method:qa.DELETE,url:"/accounts/self/sshkeys/"+e,anonymizedUrl:"/accounts/self/sshkeys/*"})}getAccountGPGKeys(){return this._restApiHelper.fetchJSON({url:"/accounts/self/gpgkeys",reportUrlAsIs:!0})}addAccountGPGKey(e){const t={method:qa.POST,url:"/accounts/self/gpgkeys",body:e,reportUrlAsIs:!0};return this._restApiHelper.send(t).then(e=>!e||e.status<200&&e.status>=300?Promise.reject(new Error("error")):this.getResponseObject(e)).then(e=>e||Promise.reject(new Error("error")))}deleteAccountGPGKey(e){return this._restApiHelper.send({method:qa.DELETE,url:`/accounts/self/gpgkeys/${e}`,anonymizedUrl:"/accounts/self/gpgkeys/*"})}deleteVote(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.DELETE,endpoint:`/reviewers/${t}/votes/${encodeURIComponent(n)}`,anonymizedEndpoint:"/reviewers/*/votes/*"})}setDescription(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,patchNum:t,endpoint:"/description",body:{description:n},reportUrlAsIs:!0})}confirmEmail(e){const t={method:qa.PUT,url:"/config/server/email.confirm",body:{token:e},reportUrlAsIs:!0};return this._restApiHelper.send(t).then(e=>204===(null==e?void 0:e.status)?"Email confirmed successfully.":null)}getCapabilities(e){return this._restApiHelper.fetchJSON({url:"/config/server/capabilities",errFn:e,reportUrlAsIs:!0})}getTopMenus(e){return this._fetchSharedCacheURL({url:"/config/server/top-menus",errFn:e,reportUrlAsIs:!0})}setAssignee(e,t){return this._getChangeURLAndSend({changeNum:e,method:qa.PUT,endpoint:"/assignee",body:{assignee:t},reportUrlAsIs:!0})}deleteAssignee(e){return this._getChangeURLAndSend({changeNum:e,method:qa.DELETE,endpoint:"/assignee",reportUrlAsIs:!0})}probePath(e){return fetch(new Request(e,{method:qa.HEAD})).then(e=>e.ok)}startWorkInProgress(e,t){const n=t?{message:t}:{},i={changeNum:e,method:qa.POST,endpoint:"/wip",body:n,reportUrlAsIs:!0};return this._getChangeURLAndSend(i).then(e=>{if(204===(null==e?void 0:e.status))return"Change marked as Work In Progress."})}startReview(e,t,n){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,endpoint:"/ready",body:t,errFn:n,reportUrlAsIs:!0})}deleteComment(e,t,n,i){return this._getChangeURLAndSend({changeNum:e,method:qa.POST,patchNum:t,endpoint:`/comments/${n}/delete`,body:{reason:i},parseResponse:!0,anonymizedEndpoint:"/comments/*/delete"})}getChange(e,t){return this._restApiHelper.fetchJSON({url:`/changes/?q=change:${e}`,errFn:t,anonymizedUrl:"/changes/?q=change:*"}).then(e=>{const t=e;return t&&t.length?t[0]:null})}setInProjectLookup(e,t){this._projectLookup[e]&&this._projectLookup[e]!==t&&console.warn("Change set with multiple project nums.One of them must be invalid."),this._projectLookup[e]=t}getFromProjectLookup(e){const t=this._projectLookup[`${e}`];if(t)return Promise.resolve(t);return this.getChange(e,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(t=>{if(t&&t.project)return this.setInProjectLookup(e,t.project),t.project})}_getChangeURLAndSend(e){const t=e.patchNum?"/changes/*~*/revisions/*":"/changes/*~*",n=e.reportEndpointAsIs?e.endpoint:e.anonymizedEndpoint;return this._changeBaseURL(e.changeNum,e.patchNum).then(i=>{const o={method:e.method,url:i+e.endpoint,body:e.body,errFn:e.errFn,contentType:e.contentType,headers:e.headers,parseResponse:e.parseResponse,anonymizedUrl:n?`${t}${n}`:void 0};return this._restApiHelper.send(o)})}_getChangeURLAndFetch(e,t){const n=e.reportEndpointAsIs?e.endpoint:e.anonymizedEndpoint,i=e.patchNum?"/changes/*~*/revisions/*":"/changes/*~*";return this._changeBaseURL(e.changeNum,e.patchNum).then(o=>this._restApiHelper.fetchJSON({url:o+e.endpoint,errFn:e.errFn,params:e.params,fetchOptions:e.fetchOptions,anonymizedUrl:n?i+n:void 0},t))}executeChangeAction(e,t,n,i,o,s){return this._getChangeURLAndSend({changeNum:e,method:t,patchNum:i,endpoint:n,body:o,errFn:s})}getBlame(e,t,n,i){const o=encodeURIComponent(n);return this._getChangeURLAndFetch({changeNum:e,endpoint:`/files/${o}/blame`,patchNum:t,params:i?{base:"t"}:void 0,anonymizedEndpoint:"/files/*/blame"})}_failForCreate200(e){return e.then(e=>{if(200===e.status){const t=Array.from(e.headers.entries()).reduce((e,[t,n])=>(Jp.test(t)||(e[t]=n),e),{});throw new Error([Xp,JSON.stringify(t)].join("\n"))}return e})}getDashboard(e,t,n){const i="/projects/"+encodeURIComponent(e)+"/dashboards/"+encodeURIComponent(t);return this._fetchSharedCacheURL({url:i,errFn:n,anonymizedUrl:"/projects/*/dashboards/*"})}getDocumentationSearches(e){e=e.trim();const t=encodeURIComponent(e);return this._fetchSharedCacheURL({url:`/Documentation/?q=${t}`,anonymizedUrl:"/Documentation/?*"})}getMergeable(e){return this._getChangeURLAndFetch({changeNum:e,endpoint:"/revisions/current/mergeable",reportEndpointAsIs:!0})}deleteDraftComments(e){return this._restApiHelper.send({method:qa.POST,url:"/accounts/self/drafts:delete",body:{query:e}})}};Kp([Bl({type:Object})],iu.prototype,"_cache",void 0),Kp([Bl({type:Object})],iu.prototype,"_sharedFetchPromises",void 0),Kp([Bl({type:Object})],iu.prototype,"_pendingRequests",void 0),Kp([Bl({type:Object})],iu.prototype,"_etags",void 0),Kp([Bl({type:Object})],iu.prototype,"_projectLookup",void 0),iu=Kp([Ml("gr-rest-api-interface")],iu);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ou=ta`
  <style include="shared-styles">
    :host {
      color: inherit;
      display: inline;
    }
  </style>
  <span>
    [[_computeDateStr(dateStr, _timeFormat, _dateFormat, _relative,
    showDateAndTime)]]
  </span>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var su=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const ru="h:mm A",au="h:mm:ss A",lu="HH:mm",cu="HH:mm:ss",du={short:"MMM DD",full:"MMM DD, YYYY"},hu={short:"MM/DD",full:"MM/DD/YY"},pu={short:"MM-DD",full:"YYYY-MM-DD"},uu={short:"DD. MMM",full:"DD.MM.YYYY"},gu={short:"DD/MM",full:"DD/MM/YYYY"};let mu=class extends(mp(oo(dr(oa)))){constructor(){super(),this.dateStr=null,this.showDateAndTime=!1,this.hasTooltip=!1,this.title=""}static get template(){return ou}attached(){super.attached(),this._loadPreferences()}_getUtcOffsetString(){return function(){const e=-(new Date).getTimezoneOffset(),t=e=>{const t=Math.floor(Math.abs(e));return(t<10?"0":"")+t.toString()};return` UTC${e>=0?"+":"-"}${t(e/60)}:${t(e%60)}`}()}_loadPreferences(){return this._getLoggedIn().then(e=>e?Promise.all([this._loadTimeFormat(),this._loadRelative()]):(this._timeFormat=lu,this._dateFormat=du,void(this._relative=!1)))}_loadTimeFormat(){return this._getPreferences().then(e=>{if(!e)throw Error("Preferences is not set");this._decideTimeFormat(e.time_format),this._decideDateFormat(e.date_format)})}_decideTimeFormat(e){switch(e){case Ja.HHMM_12:this._timeFormat=ru;break;case Ja.HHMM_24:this._timeFormat=lu;break;default:s(e,`Invalid time format: ${e}`)}}_decideDateFormat(e){switch(e){case Xa.STD:this._dateFormat=du;break;case Xa.US:this._dateFormat=hu;break;case Xa.ISO:this._dateFormat=pu;break;case Xa.EURO:this._dateFormat=uu;break;case Xa.UK:this._dateFormat=gu;break;default:s(e,`Invalid date format: ${e}`)}}_loadRelative(){return this._getPreferences().then(e=>{this._relative=!(!e||!e.relative_date_in_change_table)})}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_getPreferences(){return this.$.restAPI.getPreferences()}_computeDateStr(e,t,n,i,o){if(!e||!t||!n)return"";const s=lc(e);if(!cc(s))return"";if(i)return function(e){const t=new Date,n=Math.round((t.valueOf()-e.valueOf())/1e3);if(n<=44)return"just now";if(n<=89)return"a minute ago";const i=Math.round(n/60);if(i<=44)return`${i} minutes ago`;if(i<=89)return"an hour ago";const o=Math.round(i/60);if(o<=21)return`${o} hours ago`;if(o<=35)return"a day ago";const s=Math.round(o/24);if(s<=25)return`${s} days ago`;if(s<=45)return"a month ago";const r=Math.round(s/30);return s<=319?`${r} months ago`:s<=547?"a year ago":`${Math.round(s/365)} years ago`}(s);const r=new Date;let a=n.full;return!function(e,t){return e.valueOf()-t.valueOf()<ac&&t.getDay()===e.getDay()}(r,s)?(function(e,t){return e.valueOf()-t.valueOf()<180*ac}(r,s)&&(a=n.short),(this.showDateAndTime||o)&&(a=`${a} ${t}`)):a=t,dc(s,a)}_timeToSecondsFormat(e){return e===ru?au:cu}_computeFullDateStr(e,t,n){if([e,t].includes(void 0)||!n)return;if(!e)return"";const i=lc(e);if(!cc(i))return"";let o=n.full+", ";return o+=this._timeToSecondsFormat(t),dc(i,o)+this._getUtcOffsetString()}};su([Bl({type:String,notify:!0})],mu.prototype,"dateStr",void 0),su([Bl({type:Boolean})],mu.prototype,"showDateAndTime",void 0),su([Bl({type:Boolean})],mu.prototype,"hasTooltip",void 0),su([Bl({type:String,reflectToAttribute:!0,computed:"_computeFullDateStr(dateStr, _timeFormat, _dateFormat)"})],mu.prototype,"title",void 0),su([Bl({type:Object})],mu.prototype,"_dateFormat",void 0),su([Bl({type:String})],mu.prototype,"_timeFormat",void 0),su([Bl({type:Boolean})],mu.prototype,"_relative",void 0),mu=su([Ml("gr-date-formatter")],mu);var _u=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let fu=class extends(oo(dr(oa))){static get template(){return ta` <slot></slot> `}get nativeSelect(){return this.querySelector("select")}_updateValue(){void 0!==this.bindValue&&(this.nativeSelect.value=this.bindValue,this.async(()=>{this.nativeSelect.value=this.bindValue},1))}_valueChanged(){this.bindValue=this.nativeSelect.value}focus(){this.nativeSelect.focus()}created(){super.created(),this.addEventListener("change",()=>this._valueChanged()),this.addEventListener("dom-change",()=>this._updateValue())}ready(){super.ready(),void 0===this.bindValue&&this.nativeSelect.options.length>0&&(this.bindValue=this.nativeSelect.value)}};_u([Bl({type:String,notify:!0})],fu.prototype,"bindValue",void 0),_u([jl("bindValue")],fu.prototype,"_updateValue",null),fu=_u([Ml("gr-select")],fu);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const vu=ta`
  <style include="shared-styles">
    :host {
      display: inline-block;
    }
    #triggerText {
      -moz-user-select: text;
      -ms-user-select: text;
      -webkit-user-select: text;
      user-select: text;
    }
    .dropdown-trigger {
      cursor: pointer;
      padding: 0;
    }
    .dropdown-content {
      background-color: var(--dropdown-background-color);
      box-shadow: var(--elevation-level-2);
      max-height: 70vh;
      margin-top: var(--spacing-xxl);
      min-width: 266px;
      @apply --dropdown-content-style;
    }
    paper-listbox {
      --paper-listbox: {
        padding: 0;
      }
    }
    paper-item {
      cursor: pointer;
      flex-direction: column;
      font-size: inherit;
      /* This variable was introduced in Dec 2019. We keep both min-height
         * rules around, because --paper-item-min-height is not yet upstreamed.
         */
      --paper-item-min-height: 0;
      --paper-item: {
        min-height: 0;
        padding: 10px 16px;
      }
      --paper-item-focused-before: {
        background-color: var(--selection-background-color);
      }
      --paper-item-focused: {
        background-color: var(--selection-background-color);
      }
    }
    paper-item:hover {
      background-color: var(--hover-background-color);
    }
    paper-item:not(:last-of-type) {
      border-bottom: 1px solid var(--border-color);
    }
    .bottomContent {
      color: var(--deemphasized-text-color);
    }
    .bottomContent,
    .topContent {
      display: flex;
      justify-content: space-between;
      flex-direction: row;
      width: 100%;
    }
    gr-button {
      --gr-button: {
        @apply --trigger-style;
      }
    }
    gr-date-formatter {
      color: var(--deemphasized-text-color);
      margin-left: var(--spacing-xxl);
      white-space: nowrap;
    }
    gr-select {
      display: none;
    }
    /* Because the iron dropdown 'area' includes the trigger, and the entire
       width of the dropdown, we want to treat tapping the area above the
       dropdown content as if it is tapping whatever content is underneath it.
       The next two styles allow this to happen. */
    iron-dropdown {
      max-width: none;
      pointer-events: none;
    }
    paper-listbox {
      pointer-events: auto;
    }
    @media only screen and (max-width: 50em) {
      gr-select {
        display: inline;
        @apply --gr-select-style;
      }
      gr-button,
      iron-dropdown {
        display: none;
      }
      select {
        @apply --native-select-style;
      }
    }
  </style>
  <gr-button
    disabled="[[disabled]]"
    down-arrow=""
    link=""
    id="trigger"
    class="dropdown-trigger"
    on-click="_showDropdownTapHandler"
    slot="dropdown-trigger"
  >
    <span id="triggerText">[[text]]</span>
    <gr-copy-clipboard
      hidden="[[!showCopyForTriggerText]]"
      hide-input=""
      text="[[text]]"
    ></gr-copy-clipboard>
  </gr-button>
  <iron-dropdown
    id="dropdown"
    vertical-align="top"
    allow-outside-scroll="true"
    on-click="_handleDropdownClick"
  >
    <paper-listbox
      class="dropdown-content"
      slot="dropdown-content"
      attr-for-selected="data-value"
      selected="{{value}}"
      on-tap="_handleDropdownTap"
    >
      <template
        is="dom-repeat"
        items="[[items]]"
        initial-count="[[initialCount]]"
      >
        <paper-item disabled="[[item.disabled]]" data-value$="[[item.value]]">
          <div class="topContent">
            <div>[[item.text]]</div>
            <template is="dom-if" if="[[item.date]]">
              <gr-date-formatter date-str="[[item.date]]"></gr-date-formatter>
            </template>
          </div>
          <template is="dom-if" if="[[item.bottomText]]">
            <div class="bottomContent">
              <div>[[item.bottomText]]</div>
            </div>
          </template>
        </paper-item>
      </template>
    </paper-listbox>
  </iron-dropdown>
  <gr-select bind-value="{{value}}">
    <select>
      <template is="dom-repeat" items="[[items]]">
        <option disabled$="[[item.disabled]]" value="[[item.value]]">
          [[_computeMobileText(item)]]
        </option>
      </template>
    </select>
  </gr-select>
`;var yu=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let bu=class extends(oo(dr(oa))){constructor(){super(...arguments),this.initialCount=75,this.disabled=!1,this.showCopyForTriggerText=!1}static get template(){return vu}_handleDropdownClick(){this.async(()=>{this.$.dropdown.close()},1)}_showDropdownTapHandler(){this._open()}_open(){this.$.dropdown.open()}_computeMobileText(e){return e.mobileText?e.mobileText:e.text}_handleValueChange(e,t){if(!e||!t)return;const n=t.find(t=>`${t.value}`===`${e}`);if(!n)return;this.text=n.triggerText?n.triggerText:n.text;const i={value:e};this.dispatchEvent(new CustomEvent("value-change",{detail:i,bubbles:!1}))}};yu([Bl({type:Number})],bu.prototype,"initialCount",void 0),yu([Bl({type:Object})],bu.prototype,"items",void 0),yu([Bl({type:String})],bu.prototype,"text",void 0),yu([Bl({type:Boolean})],bu.prototype,"disabled",void 0),yu([Bl({type:String,notify:!0})],bu.prototype,"value",void 0),yu([Bl({type:Boolean})],bu.prototype,"showCopyForTriggerText",void 0),yu([jl("value","items")],bu.prototype,"_handleValueChange",null),bu=yu([Ml("gr-dropdown-list")],bu);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
class wu{constructor(e){wu[" "](e),this.type=e&&e.type||"default",this.key=e&&e.key,e&&"value"in e&&(this.value=e.value)}get value(){var e=this.type,t=this.key;if(e&&t)return wu.types[e]&&wu.types[e][t]}set value(e){var t=this.type,n=this.key;t&&n&&(t=wu.types[t]=wu.types[t]||{},null==e?delete t[n]:t[n]=e)}get list(){if(this.type){var e=wu.types[this.type];return e?Object.keys(e).map((function(e){return Cu[this.type][e]}),this):[]}}byKey(e){return this.key=e,this.value}}wu[" "]=function(){},wu.types={};var Cu=wu.types;Er({is:"iron-meta",properties:{type:{type:String,value:"default"},key:{type:String},value:{type:String,notify:!0},self:{type:Boolean,observer:"_selfChanged"},__meta:{type:Boolean,computed:"__computeMeta(type, key, value)"}},hostAttributes:{hidden:!0},__computeMeta:function(e,t,n){var i=new wu({type:e,key:t});return void 0!==n&&n!==i.value?i.value=n:this.value!==i.value&&(this.value=i.value),i},get list(){return this.__meta&&this.__meta.list},_selfChanged:function(e){e&&(this.value=this)},byKey:function(e){return new wu({type:this.type,key:e}).value}}),
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style>
      :host {
        @apply --layout-inline;
        @apply --layout-center-center;
        position: relative;

        vertical-align: middle;

        fill: var(--iron-icon-fill-color, currentcolor);
        stroke: var(--iron-icon-stroke-color, none);

        width: var(--iron-icon-width, 24px);
        height: var(--iron-icon-height, 24px);
        @apply --iron-icon;
      }

      :host([hidden]) {
        display: none;
      }
    </style>
`,is:"iron-icon",properties:{icon:{type:String},theme:{type:String},src:{type:String},_meta:{value:ya.create("iron-meta",{type:"iconset"})}},observers:["_updateIcon(_meta, isAttached)","_updateIcon(theme, isAttached)","_srcChanged(src, isAttached)","_iconChanged(icon, isAttached)"],_DEFAULT_ICONSET:"icons",_iconChanged:function(e){var t=(e||"").split(":");this._iconName=t.pop(),this._iconsetName=t.pop()||this._DEFAULT_ICONSET,this._updateIcon()},_srcChanged:function(e){this._updateIcon()},_usesIconset:function(){return this.icon||!this.src},_updateIcon:function(){this._usesIconset()?(this._img&&this._img.parentNode&&qo(this.root).removeChild(this._img),""===this._iconName?this._iconset&&this._iconset.removeIcon(this):this._iconsetName&&this._meta&&(this._iconset=this._meta.byKey(this._iconsetName),this._iconset?(this._iconset.applyIcon(this,this._iconName,this.theme),this.unlisten(window,"iron-iconset-added","_updateIcon")):this.listen(window,"iron-iconset-added","_updateIcon"))):(this._iconset&&this._iconset.removeIcon(this),this._img||(this._img=document.createElement("img"),this._img.style.width="100%",this._img.style.height="100%",this._img.draggable=!1),this._img.src=this.src,qo(this.root).appendChild(this._img))}}),
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({is:"iron-iconset-svg",properties:{name:{type:String,observer:"_nameChanged"},size:{type:Number,value:24},rtlMirroring:{type:Boolean,value:!1},useGlobalRtlAttribute:{type:Boolean,value:!1}},created:function(){this._meta=new wu({type:"iconset",key:null,value:null})},attached:function(){this.style.display="none"},getIconNames:function(){return this._icons=this._createIconMap(),Object.keys(this._icons).map((function(e){return this.name+":"+e}),this)},applyIcon:function(e,t){this.removeIcon(e);var n=this._cloneIcon(t,this.rtlMirroring&&this._targetIsRTL(e));if(n){var i=qo(e.root||e);return i.insertBefore(n,i.childNodes[0]),e._svgIcon=n}return null},removeIcon:function(e){e._svgIcon&&(qo(e.root||e).removeChild(e._svgIcon),e._svgIcon=null)},_targetIsRTL:function(e){if(null==this.__targetIsRTL)if(this.useGlobalRtlAttribute){var t=document.body&&document.body.hasAttribute("dir")?document.body:document.documentElement;this.__targetIsRTL="rtl"===t.getAttribute("dir")}else e&&e.nodeType!==Node.ELEMENT_NODE&&(e=e.host),this.__targetIsRTL=e&&"rtl"===window.getComputedStyle(e).direction;return this.__targetIsRTL},_nameChanged:function(){this._meta.value=null,this._meta.key=this.name,this._meta.value=this,this.async((function(){this.fire("iron-iconset-added",this,{node:window})}))},_createIconMap:function(){var e=Object.create(null);return qo(this).querySelectorAll("[id]").forEach((function(t){e[t.id]=t})),e},_cloneIcon:function(e,t){return this._icons=this._icons||this._createIconMap(),this._prepareSvgClone(this._icons[e],this.size,t)},_prepareSvgClone:function(e,t,n){if(e){var i=e.cloneNode(!0),o=document.createElementNS("http://www.w3.org/2000/svg","svg"),s=i.getAttribute("viewBox")||"0 0 "+t+" "+t,r="pointer-events: none; display: block; width: 100%; height: 100%;";return n&&i.hasAttribute("mirror-in-rtl")&&(r+="-webkit-transform:scale(-1,1);transform:scale(-1,1);transform-origin:center;"),o.setAttribute("viewBox",s),o.setAttribute("preserveAspectRatio","xMidYMid meet"),o.setAttribute("focusable","false"),o.style.cssText=r,o.appendChild(i).removeAttribute("id"),o}return null}});
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Eu=document.createElement("template");Eu.innerHTML='<iron-iconset-svg name="gr-icons" size="24">\n  <svg>\n    <defs>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="expand-less"><path d="M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="expand-more"><path d="M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z"></path></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/icons/#unfold_more --\x3e\n      <g id="unfold-more"><path d="M0 0h24v24H0z" fill="none"></path><path d="M12 5.83L15.17 9l1.41-1.41L12 3 7.41 7.59 8.83 9 12 5.83zm0 12.34L8.83 15l-1.41 1.41L12 21l4.59-4.59L15.17 15 12 18.17z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="search"><path d="M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="settings"><path d="M19.43 12.98c.04-.32.07-.64.07-.98s-.03-.66-.07-.98l2.11-1.65c.19-.15.24-.42.12-.64l-2-3.46c-.12-.22-.39-.3-.61-.22l-2.49 1c-.52-.4-1.08-.73-1.69-.98l-.38-2.65C14.46 2.18 14.25 2 14 2h-4c-.25 0-.46.18-.49.42l-.38 2.65c-.61.25-1.17.59-1.69.98l-2.49-1c-.23-.09-.49 0-.61.22l-2 3.46c-.13.22-.07.49.12.64l2.11 1.65c-.04.32-.07.65-.07.98s.03.66.07.98l-2.11 1.65c-.19.15-.24.42-.12.64l2 3.46c.12.22.39.3.61.22l2.49-1c.52.4 1.08.73 1.69.98l.38 2.65c.03.24.24.42.49.42h4c.25 0 .46-.18.49-.42l.38-2.65c.61-.25 1.17-.59 1.69-.98l2.49 1c.23.09.49 0 .61-.22l2-3.46c.12-.22.07-.49-.12-.64l-2.11-1.65zM12 15.5c-1.93 0-3.5-1.57-3.5-3.5s1.57-3.5 3.5-3.5 3.5 1.57 3.5 3.5-1.57 3.5-3.5 3.5z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="create"><path d="M3 17.25V21h3.75L17.81 9.94l-3.75-3.75L3 17.25zM20.71 7.04c.39-.39.39-1.02 0-1.41l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-1.83 1.83 3.75 3.75 1.83-1.83z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="star"><path d="M12 17.27L18.18 21l-1.64-7.03L22 9.24l-7.19-.61L12 2 9.19 8.63 2 9.24l5.46 4.73L5.82 21z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="star-border"><path d="M22 9.24l-7.19-.62L12 2 9.19 8.63 2 9.24l5.46 4.73L5.82 21 12 17.27 18.18 21l-1.63-7.03L22 9.24zM12 15.4l-3.76 2.27 1-4.28-3.32-2.88 4.38-.38L12 6.1l1.71 4.04 4.38.38-3.32 2.88 1 4.28L12 15.4z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="close"><path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="chevron-left"><path d="M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="chevron-right"><path d="M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="more-vert"><path d="M12 8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="deleteEdit"><path d="M6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zM19 4h-3.5l-1-1h-5l-1 1H5v2h14V4z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/editor-icons.html --\x3e\n      <g id="publishEdit"><path d="M5 4v2h14V4H5zm0 10h4v6h6v-6h4l-7-7-7 7z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/editor-icons.html --\x3e\n      <g id="delete"><path d="M6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zM19 4h-3.5l-1-1h-5l-1 1H5v2h14V4z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="help"><path d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 17h-2v-2h2v2zm2.07-7.75l-.9.92C13.45 12.9 13 13.5 13 15h-2v-.5c0-1.1.45-2.1 1.17-2.83l1.24-1.26c.37-.36.59-.86.59-1.41 0-1.1-.9-2-2-2s-2 .9-2 2H8c0-2.21 1.79-4 4-4s4 1.79 4 4c0 .88-.36 1.68-.93 2.25z"></path></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/resources/icons/?icon=help_outline --\x3e\n      <g id="help-outline"><path d="M11 18h2v-2h-2v2zm1-16C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zm0-14c-2.21 0-4 1.79-4 4h2c0-1.1.9-2 2-2s2 .9 2 2c0 2-3 1.75-3 5h2c0-2.25 3-2.5 3-5 0-2.21-1.79-4-4-4z"/></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="info"><path d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-6h2v6zm0-8h-2V7h2v2z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="info-outline"><path d="M11 17h2v-6h-2v6zm1-15C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zM11 9h2V7h-2v2z"></path></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/icons/#ic_hourglass_full--\x3e\n      <g id="hourglass"><path d="M6 2v6h.01L6 8.01 10 12l-4 4 .01.01H6V22h12v-5.99h-.01L18 16l-4-4 4-3.99-.01-.01H18V2H6z"></path><path d="M0 0h24v24H0V0z" fill="none"></path></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/icons/#mode_comment--\x3e\n      <g id="comment"><path d="M21.99 4c0-1.1-.89-2-1.99-2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h14l4 4-.01-18z"></path><path d="M0 0h24v24H0z" fill="none"></path></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/icons/#calendar_today--\x3e\n      <g id="calendar"><path d="M20 3h-1V1h-2v2H7V1H5v2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 18H4V8h16v13z"></path><path d="M0 0h24v24H0z" fill="none"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="error"><path d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="lightbulb-outline"><path d="M9 21c0 .55.45 1 1 1h4c.55 0 1-.45 1-1v-1H9v1zm3-19C8.14 2 5 5.14 5 9c0 2.38 1.19 4.47 3 5.74V17c0 .55.45 1 1 1h6c.55 0 1-.45 1-1v-2.26c1.81-1.27 3-3.36 3-5.74 0-3.86-3.14-7-7-7zm2.85 11.1l-.85.6V16h-4v-2.3l-.85-.6C7.8 12.16 7 10.63 7 9c0-2.76 2.24-5 5-5s5 2.24 5 5c0 1.63-.8 3.16-2.15 4.1z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="side-by-side"><path d="M17.1578947,10.8888889 L2.84210526,10.8888889 C2.37894737,10.8888889 2,11.2888889 2,11.7777778 L2,17.1111111 C2,17.6 2.37894737,18 2.84210526,18 L17.1578947,18 C17.6210526,18 18,17.6 18,17.1111111 L18,11.7777778 C18,11.2888889 17.6210526,10.8888889 17.1578947,10.8888889 Z M17.1578947,2 L2.84210526,2 C2.37894737,2 2,2.4 2,2.88888889 L2,8.22222222 C2,8.71111111 2.37894737,9.11111111 2.84210526,9.11111111 L17.1578947,9.11111111 C17.6210526,9.11111111 18,8.71111111 18,8.22222222 L18,2.88888889 C18,2.4 17.6210526,2 17.1578947,2 Z M16.1973628,2 L2.78874238,2 C2.35493407,2 2,2.4 2,2.88888889 L2,8.22222222 C2,8.71111111 2.35493407,9.11111111 2.78874238,9.11111111 L16.1973628,9.11111111 C16.6311711,9.11111111 16.9861052,8.71111111 16.9861052,8.22222222 L16.9861052,2.88888889 C16.9861052,2.4 16.6311711,2 16.1973628,2 Z" id="Shape" transform="scale(1.2) translate(10.000000, 10.000000) rotate(-90.000000) translate(-10.000000, -10.000000)"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="unified"><path d="M4,2 L17,2 C18.1045695,2 19,2.8954305 19,4 L19,16 C19,17.1045695 18.1045695,18 17,18 L4,18 C2.8954305,18 2,17.1045695 2,16 L2,4 L2,4 C2,2.8954305 2.8954305,2 4,2 L4,2 Z M4,7 L4,9 L17,9 L17,7 L4,7 Z M4,11 L4,13 L17,13 L17,11 L4,11 Z" id="Combined-Shape" transform="scale(1.12, 1.2)"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="content-copy"><path d="M16 1H4c-1.1 0-2 .9-2 2v14h2V3h12V1zm3 4H8c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h11c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm0 16H8V7h11v14z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="check"><path d="M9 16.17L4.83 12l-1.42 1.41L9 19 21 7l-1.41-1.41z"></path></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons/blob/master/iron-icons.js --\x3e\n      <g id="check-circle"><path d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-2 15l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="robot"><path d="M4.137453,5.61015591 L4.54835569,1.5340419 C4.5717665,1.30180904 4.76724872,1.12504213 5.00065859,1.12504213 C5.23327176,1.12504213 5.42730868,1.30282046 5.44761309,1.53454578 L5.76084628,5.10933916 C6.16304484,5.03749412 6.57714381,5 7,5 L17,5 C20.8659932,5 24,8.13400675 24,12 L24,15.1250421 C24,18.9910354 20.8659932,22.1250421 17,22.1250421 L7,22.1250421 C3.13400675,22.1250421 2.19029351e-15,18.9910354 0,15.1250421 L0,12 C-3.48556243e-16,9.15382228 1.69864167,6.70438358 4.137453,5.61015591 Z M5.77553049,6.12504213 C3.04904264,6.69038358 1,9.10590202 1,12 L1,15.1250421 C1,18.4387506 3.6862915,21.1250421 7,21.1250421 L17,21.1250421 C20.3137085,21.1250421 23,18.4387506 23,15.1250421 L23,12 C23,8.6862915 20.3137085,6 17,6 L7,6 C6.60617231,6 6.2212068,6.03794347 5.84855971,6.11037415 L5.84984496,6.12504213 L5.77553049,6.12504213 Z M6.93003717,6.95027711 L17.1232083,6.95027711 C19.8638332,6.95027711 22.0855486,9.17199258 22.0855486,11.9126175 C22.0855486,14.6532424 19.8638332,16.8749579 17.1232083,16.8749579 L6.93003717,16.8749579 C4.18941226,16.8749579 1.9676968,14.6532424 1.9676968,11.9126175 C1.9676968,9.17199258 4.18941226,6.95027711 6.93003717,6.95027711 Z M7.60124392,14.0779303 C9.03787127,14.0779303 10.2024878,12.9691885 10.2024878,11.6014862 C10.2024878,10.2337839 9.03787127,9.12504213 7.60124392,9.12504213 C6.16461657,9.12504213 5,10.2337839 5,11.6014862 C5,12.9691885 6.16461657,14.0779303 7.60124392,14.0779303 Z M16.617997,14.1098288 C18.0638768,14.1098288 19.2359939,12.9939463 19.2359939,11.6174355 C19.2359939,10.2409246 18.0638768,9.12504213 16.617997,9.12504213 C15.1721172,9.12504213 14,10.2409246 14,11.6174355 C14,12.9939463 15.1721172,14.1098288 16.617997,14.1098288 Z M9.79751216,18.1250421 L15,18.1250421 L15,19.1250421 C15,19.6773269 14.5522847,20.1250421 14,20.1250421 L10.7975122,20.1250421 C10.2452274,20.1250421 9.79751216,19.6773269 9.79751216,19.1250421 L9.79751216,18.1250421 Z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="abandon"><path d="M17.65675,17.65725 C14.77275,20.54125 10.23775,20.75625 7.09875,18.31525 L18.31475,7.09925 C20.75575,10.23825 20.54075,14.77325 17.65675,17.65725 M6.34275,6.34325 C9.22675,3.45925 13.76275,3.24425 16.90075,5.68525 L5.68475,16.90125 C3.24375,13.76325 3.45875,9.22725 6.34275,6.34325 M19.07075,4.92925 C15.16575,1.02425 8.83375,1.02425 4.92875,4.92925 C1.02375,8.83425 1.02375,15.16625 4.92875,19.07125 C8.83375,22.97625 15.16575,22.97625 19.07075,19.07125 C22.97575,15.16625 22.97575,8.83425 19.07075,4.92925"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="edit"><path d="M3,17.2525 L3,21.0025 L6.75,21.0025 L17.81,9.9425 L14.06,6.1925 L3,17.2525 L3,17.2525 Z M20.71,7.0425 C21.1,6.6525 21.1,6.0225 20.71,5.6325 L18.37,3.2925 C17.98,2.9025 17.35,2.9025 16.96,3.2925 L15.13,5.1225 L18.88,8.8725 L20.71,7.0425 L20.71,7.0425 Z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="rebase"><path d="M15.5759,19.4241 L14.5861,20.4146 L11.7574,23.2426 L10.3434,21.8286 L12.171569,20 L7.82933006,20 C7.41754308,21.1652555 6.30635522,22 5,22 C3.343,22 2,20.657 2,19 C2,17.6936448 2.83474451,16.5824569 4,16.1706699 L4,7.82933006 C2.83474451,7.41754308 2,6.30635522 2,5 C2,3.343 3.343,2 5,2 C6.30635522,2 7.41754308,2.83474451 7.82933006,4 L12.1715,4 L10.3431,2.1716 L11.7571,0.7576 L15.36365,4.3633 L16.0000001,4.99920039 C16.0004321,3.34256796 17.3432665,2 19,2 C20.657,2 22,3.343 22,5 C22,6.30635522 21.1652555,7.41754308 20,7.82933006 L20,16.1706699 C21.1652555,16.5824569 22,17.6936448 22,19 C22,20.657 20.657,22 19,22 C17.343,22 16,20.657 16,19 L15.5759,19.4241 Z M12.1715,18 L10.3431,16.1716 L11.7571,14.7576 L15.36365,18.3633 L16.0000001,18.9992004 C16.0003407,17.6931914 16.8349823,16.5823729 18,16.1706699 L18,7.82933006 C16.8347445,7.41754308 16,6.30635522 16,5 L15.5759,5.4241 L14.5861,6.4146 L11.7574,9.2426 L10.3434,7.8286 L12.171569,6 L7.82933006,6 C7.52807271,6.85248394 6.85248394,7.52807271 6,7.82933006 L6,16.1706699 C6.85248394,16.4719273 7.52807271,17.1475161 7.82933006,18 L12.1715,18 Z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="rebaseEdit"><path d="M15.5759,19.4241 L14.5861,20.4146 L11.7574,23.2426 L10.3434,21.8286 L12.171569,20 L7.82933006,20 C7.41754308,21.1652555 6.30635522,22 5,22 C3.343,22 2,20.657 2,19 C2,17.6936448 2.83474451,16.5824569 4,16.1706699 L4,7.82933006 C2.83474451,7.41754308 2,6.30635522 2,5 C2,3.343 3.343,2 5,2 C6.30635522,2 7.41754308,2.83474451 7.82933006,4 L12.1715,4 L10.3431,2.1716 L11.7571,0.7576 L15.36365,4.3633 L16.0000001,4.99920039 C16.0004321,3.34256796 17.3432665,2 19,2 C20.657,2 22,3.343 22,5 C22,6.30635522 21.1652555,7.41754308 20,7.82933006 L20,16.1706699 C21.1652555,16.5824569 22,17.6936448 22,19 C22,20.657 20.657,22 19,22 C17.343,22 16,20.657 16,19 L15.5759,19.4241 Z M12.1715,18 L10.3431,16.1716 L11.7571,14.7576 L15.36365,18.3633 L16.0000001,18.9992004 C16.0003407,17.6931914 16.8349823,16.5823729 18,16.1706699 L18,7.82933006 C16.8347445,7.41754308 16,6.30635522 16,5 L15.5759,5.4241 L14.5861,6.4146 L11.7574,9.2426 L10.3434,7.8286 L12.171569,6 L7.82933006,6 C7.52807271,6.85248394 6.85248394,7.52807271 6,7.82933006 L6,16.1706699 C6.85248394,16.4719273 7.52807271,17.1475161 7.82933006,18 L12.1715,18 Z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="restore"><path d="M12,8 L12,13 L16.28,15.54 L17,14.33 L13.5,12.25 L13.5,8 L12,8 Z M13,3 C8.03,3 4,7.03 4,12 L1,12 L4.89,15.89 L4.96,16.03 L9,12 L6,12 C6,8.13 9.13,5 13,5 C16.87,5 20,8.13 20,12 C20,15.87 16.87,19 13,19 C11.07,19 9.32,18.21 8.06,16.94 L6.64,18.36 C8.27,19.99 10.51,21 13,21 C17.97,21 22,16.97 22,12 C22,7.03 17.97,3 13,3 Z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="revert"><path d="M12.3,8.5 C9.64999995,8.5 7.24999995,9.49 5.39999995,11.1 L1.79999995,7.5 L1.79999995,16.5 L10.8,16.5 L7.17999995,12.88 C8.56999995,11.72 10.34,11 12.3,11 C15.84,11 18.85,13.31 19.9,16.5 L22.27,15.72 C20.88,11.53 16.95,8.5 12.3,8.5"></path></g>\n      <g id="revert_submission"><path d="M12.3,8.5 C9.64999995,8.5 7.24999995,9.49 5.39999995,11.1 L1.79999995,7.5 L1.79999995,16.5 L10.8,16.5 L7.17999995,12.88 C8.56999995,11.72 10.34,11 12.3,11 C15.84,11 18.85,13.31 19.9,16.5 L22.27,15.72 C20.88,11.53 16.95,8.5 12.3,8.5"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="stopEdit"><path d="M4 4 20 4 20 20 4 20z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="submit"><path d="M22.23,5 L11.65,15.58 L7.47000001,11.41 L6.06000001,12.82 L11.65,18.41 L23.649,6.41 L22.23,5 Z M16.58,5 L10.239,11.34 L11.65,12.75 L17.989,6.41 L16.58,5 Z M0.400000006,12.82 L5.99000001,18.41 L7.40000001,17 L1.82000001,11.41 L0.400000006,12.82 Z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="review"><path d="M9 16.17L4.83 12l-1.42 1.41L9 19 21 7l-1.41-1.41z"></path></g>\n      \x3c!-- This is a custom PolyGerrit SVG --\x3e\n      <g id="zeroState"><path d="M22 9V7h-2V5c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2zm-4 10H4V5h14v14zM6 13h5v4H6zm6-6h4v3h-4zM6 7h5v5H6zm6 4h4v6h-4z"></path></g>\n      \x3c!-- This SVG is an adaptation of material.io https://material.io/icons/#label_important--\x3e\n      <g id="attention"><path d="M1 23 l13 0 c.67 0 1.27 -.33 1.63 -.84 l7.37 -10.16 l-7.37 -10.16 c-.36 -.51 -.96 -.84 -1.63 -.84 L1 1 L7 12 z"></path></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/icons/#pets--\x3e\n      <g id="pets"><circle cx="4.5" cy="9.5" r="2.5"/><circle cx="9" cy="5.5" r="2.5"/><circle cx="15" cy="5.5" r="2.5"/><circle cx="19.5" cy="9.5" r="2.5"/><path d="M17.34 14.86c-.87-1.02-1.6-1.89-2.48-2.91-.46-.54-1.05-1.08-1.75-1.32-.11-.04-.22-.07-.33-.09-.25-.04-.52-.04-.78-.04s-.53 0-.79.05c-.11.02-.22.05-.33.09-.7.24-1.28.78-1.75 1.32-.87 1.02-1.6 1.89-2.48 2.91-1.31 1.31-2.92 2.76-2.62 4.79.29 1.02 1.02 2.03 2.33 2.32.73.15 3.06-.44 5.54-.44h.18c2.48 0 4.81.58 5.54.44 1.31-.29 2.04-1.31 2.33-2.32.31-2.04-1.3-3.49-2.61-4.8z"/><path d="M0 0h24v24H0z" fill="none"/></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/icons/#visibility--\x3e\n      <g id="ready"><path d="M0 0h24v24H0z" fill="none"/><path d="M12 4.5C7 4.5 2.73 7.61 1 12c1.73 4.39 6 7.5 11 7.5s9.27-3.11 11-7.5c-1.73-4.39-6-7.5-11-7.5zM12 17c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></g>\n      \x3c!-- This SVG is a copy from iron-icons https://github.com/PolymerElements/iron-icons --\x3e\n      <g id="schedule"><path d="M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm.5-13H11v6l5.25 3.15.75-1.23-4.5-2.67z"></path></g>\n      \x3c!-- This SVG is a copy from material.io https://material.io/icons/#bug_report--\x3e\n      <g id="bug"><path d="M0 0h24v24H0z" fill="none"/><path d="M20 8h-2.81c-.45-.78-1.07-1.45-1.82-1.96L17 4.41 15.59 3l-2.17 2.17C12.96 5.06 12.49 5 12 5c-.49 0-.96.06-1.41.17L8.41 3 7 4.41l1.62 1.63C7.88 6.55 7.26 7.22 6.81 8H4v2h2.09c-.05.33-.09.66-.09 1v1H4v2h2v1c0 .34.04.67.09 1H4v2h2.81c1.04 1.79 2.97 3 5.19 3s4.15-1.21 5.19-3H20v-2h-2.09c.05-.33.09-.66.09-1v-1h2v-2h-2v-1c0-.34-.04-.67-.09-1H20V8zm-6 8h-4v-2h4v2zm0-4h-4v-2h4v2z"/></g>\n    </defs>\n  </svg>\n</iron-iconset-svg>',document.head.appendChild(Eu.content);var Su=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Au={},xu={};let Pu=class extends(oo(dr(oa))){handleEvent(e,t){eh().awaitPluginsLoaded().then(()=>{switch(e){case Il.HISTORY:this._handleHistory(t);break;case Il.SHOW_CHANGE:this._handleShowChange(t);break;case Il.COMMENT:this._handleComment(t);break;case Il.LABEL_CHANGE:this._handleLabelChange(t);break;case Il.SHOW_REVISION_ACTIONS:this._handleShowRevisionActions(t);break;case Il.HIGHLIGHTJS_LOADED:this._handleHighlightjsLoaded(t);break;default:console.warn("handleEvent called with unsupported event type:",e)}})}addElement(e,t){Au[e]=t}getElement(e){return Au[e]}addEventCallback(e,t){xu[e]||(xu[e]=[]),xu[e].push(t)}canSubmitChange(e,t){return!this._getEventCallbacks(Il.SUBMIT_CHANGE).some(n=>{try{return!1===n(e,t)}catch(e){console.error(e)}return!1})}_removeEventCallbacks(){for(const e of Object.values(Il))xu[e]=[]}_handleHistory(e){for(const t of this._getEventCallbacks(Il.HISTORY))try{t(e.path)}catch(e){console.error(e)}}_handleShowChange(e){const t={...e.change,get mergeable(){return console.warn("Accessing change.mergeable from SHOW_CHANGE is deprecated! Use info.mergeable instead."),e.info&&e.info.mergeable}},n=e.patchNum,i=e.info;let o;for(const e of Object.values(t.revisions||{}))if(Ch(e._number,n)){o=e;break}for(const e of this._getEventCallbacks(Il.SHOW_CHANGE))try{e(t,o,i)}catch(e){console.error(e)}}_handleShowRevisionActions(e){const t=this._getEventCallbacks(Il.SHOW_REVISION_ACTIONS);for(const n of t)try{n(e.revisionActions,e.change)}catch(e){console.error(e)}}handleCommitMessage(e,t){for(const n of this._getEventCallbacks(Il.COMMIT_MSG_EDIT))try{n(e,t)}catch(e){console.error(e)}}_handleComment(e){for(const t of this._getEventCallbacks(Il.COMMENT))try{t(e.node)}catch(e){console.error(e)}}_handleLabelChange(e){for(const t of this._getEventCallbacks(Il.LABEL_CHANGE))try{t(e.change)}catch(e){console.error(e)}}_handleHighlightjsLoaded(e){for(const t of this._getEventCallbacks(Il.HIGHLIGHTJS_LOADED))try{t(e.hljs)}catch(e){console.error(e)}}modifyRevertMsg(e,t,n){for(const i of this._getEventCallbacks(Il.REVERT))try{t=i(e,t,n)}catch(e){console.error(e)}return t}modifyRevertSubmissionMsg(e,t,n){for(const i of this._getEventCallbacks(Il.REVERT_SUBMISSION))try{t=i(e,t,n)}catch(e){console.error(e)}return t}getDiffLayers(e,t){const n=[];for(const i of this._getEventCallbacks(Il.ANNOTATE_DIFF)){const o=i;try{const i=o.getLayer(e,t);n.push(i)}catch(e){console.error(e)}}return n}disposeDiffLayers(e){for(const t of this._getEventCallbacks(Il.ANNOTATE_DIFF))try{t.disposeLayer(e)}catch(e){console.error(e)}}getCoverageAnnotationApi(){return eh().awaitPluginsLoaded().then(()=>this._getEventCallbacks(Il.ANNOTATE_DIFF).find(e=>e.getCoverageProvider()))}getAdminMenuLinks(){const e=[];for(const t of this._getEventCallbacks(Il.ADMIN_MENU_LINKS)){const n=t;e.push(...n.getMenuLinks())}return e}getLabelValuesPostRevert(e){let t={};for(const n of this._getEventCallbacks(Il.POST_REVERT))try{t=n(e)}catch(e){console.error(e)}return t}_getEventCallbacks(e){return xu[e]||[]}};
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function Ru(){const e=window.Gerrit;e.flushPreinstalls&&e.flushPreinstalls()}Pu=Su([Ml("gr-js-api-interface")],Pu);function Tu(){window.Gerrit=window.Gerrit||{},Ru(),function(e){e.css=t=>{if(console.warn("Gerrit.css(rulesStr) is deprecated!","Use plugin.styles().css(rulesStr)"),!e._customStyleSheet){const t=document.createElement("style");document.head.appendChild(t),e._customStyleSheet=t.sheet}const n=`__pg_js_api_class_${e._customStyleSheet.cssRules.length}`;return e._customStyleSheet.insertRule("."+n+"{"+t+"}",0),n},e.install=(e,t,n)=>{eh().install(e,t,n)},e.getLoggedIn=()=>(console.warn("Gerrit.getLoggedIn() is deprecated! Use plugin.restApi().getLoggedIn()"),document.createElement("gr-rest-api-interface").getLoggedIn()),e.get=(e,t)=>{console.warn(".get() is deprecated! Use plugin.restApi().get()"),Gd(qa.GET,e,t)},e.post=(e,t,n)=>{console.warn(".post() is deprecated! Use plugin.restApi().post()"),Gd(qa.POST,e,n,t)},e.put=(e,t,n)=>{console.warn(".put() is deprecated! Use plugin.restApi().put()"),Gd(qa.PUT,e,n,t)},e.delete=(e,t)=>{!function(e,t){console.warn(".delete() is deprecated! Use plugin.restApi().delete()"),Hd().send(qa.DELETE,e).then(e=>204!==e.status?e.text().then(t=>t?Promise.reject(new Error(t)):Promise.reject(new Error(`${e.status}`))):(t&&t(e),e))}(e,t)},e.awaitPluginsLoaded=()=>eh().awaitPluginsLoaded(),e._loadPlugins=(e,t)=>{eh().loadPlugins(e,t)},e._arePluginsLoaded=()=>eh().arePluginsLoaded(),e._isPluginPreloaded=e=>eh().isPluginPreloaded(e),e._isPluginEnabled=e=>eh().isPluginEnabled(e),e._isPluginLoaded=e=>eh().isPluginLoaded(e);const t=n.eventEmitter;e._eventEmitter=t,e.addListener=(e,n)=>t.addListener(e,n),e.dispatch=(e,n)=>t.dispatch(e,n),e.emit=(e,n)=>t.emit(e,n),e.off=(e,n)=>t.off(e,n),e.on=(e,n)=>t.on(e,n),e.once=(e,n)=>t.once(e,n),e.removeAllListeners=e=>t.removeAllListeners(e),e.removeListener=(e,n)=>t.removeListener(e,n)}
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */(window.Gerrit),eh().installPreloadedPlugins()}const Iu=ta`
  <style include="shared-styles">
    #nav {
      background-color: var(--table-header-background-color);
      border: 1px solid var(--border-color);
      border-top: none;
      height: 100%;
      position: absolute;
      top: 0;
      width: 14em;
    }
    #nav.pinned {
      position: fixed;
    }
    @media only screen and (max-width: 53em) {
      #nav {
        display: none;
      }
    }
  </style>
  <nav id="nav">
    <slot></slot>
  </nav>
`;var ku=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Ou=class extends(oo(dr(oa))){constructor(){super(),this.bodyScrollHandler=()=>this._handleBodyScroll()}static get template(){return Iu}attached(){super.attached(),window.addEventListener("scroll",this.bodyScrollHandler)}detached(){super.detached(),window.removeEventListener("scroll",this.bodyScrollHandler)}_handleBodyScroll(){if(void 0===this._headerHeight){let e=this._getOffsetTop(this);for(let t=this.offsetParent;t;t=this._getOffsetParent(t))e+=this._getOffsetTop(t);this._headerHeight=e}this.$.nav.classList.toggle("pinned",this._getScrollY()>=(this._headerHeight||0))}_getOffsetParent(e){if(e&&"offsetParent"in e)return e.offsetParent}_getOffsetTop(e){return e.offsetTop}_getScrollY(){return window.scrollY}};ku([Bl({type:Number})],Ou.prototype,"_headerHeight",void 0),Ou=ku([Ml("gr-page-nav")],Ou);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Nu=document.createElement("template");Nu.innerHTML='<dom-module id="gr-table-styles">\n  <template>\n    <style>\n      .genericList {\n        background-color: var(--background-color-primary);\n        border-collapse: collapse;\n        width: 100%;\n      }\n      .genericList th,\n      .genericList td {\n        padding: var(--spacing-m) 0;\n        vertical-align: middle;\n      }\n      .genericList tr {\n        border-bottom: 1px solid var(--border-color);\n      }\n      .genericList tr:hover {\n        background-color: var(--hover-background-color);\n      }\n      .genericList th {\n        white-space: nowrap;\n      }\n      .genericList th,\n      .genericList td {\n        padding-right: var(--spacing-l);\n      }\n      .genericList tr th:first-of-type,\n      .genericList tr td:first-of-type {\n        padding-left: var(--spacing-l);\n      }\n      .genericList tr:first-of-type {\n        border-top: 1px solid var(--border-color);\n      }\n      .genericList tr th:last-of-type,\n      .genericList tr td:last-of-type {\n        border-left: 1px solid var(--border-color);\n        text-align: center;\n        padding-left: var(--spacing-l);\n      }\n      .genericList tr th.delete,\n      .genericList tr td.delete {\n        padding-top: 0;\n        padding-bottom: 0;\n      }\n      .genericList tr th.delete,\n      .genericList tr td.delete,\n      .genericList tr.loadingMsg td,\n      .genericList tr.groupHeader td {\n        border-left: none;\n      }\n      .genericList .loading {\n        border: none;\n        display: none;\n      }\n      .genericList td {\n        flex-shrink: 0;\n      }\n      .genericList .topHeader,\n      .genericList .groupHeader {\n        color: var(--primary-text-color);\n        font-weight: var(--font-weight-bold);\n        text-align: left;\n        vertical-align: middle\n      }\n      .genericList .groupHeader {\n        background-color: var(--background-color-secondary);\n        font-family: var(--header-font-family);\n        font-size: var(--font-size-h3);\n        font-weight: var(--font-weight-h3);\n        line-height: var(--line-height-h3);\n      }\n      .genericList a {\n        color: var(--primary-text-color);\n        text-decoration: none;\n      }\n      .genericList a:hover {\n        text-decoration: underline;\n      }\n      .genericList .description {\n        width: 99%;\n      }\n      .genericList .loadingMsg {\n        color: var(--deemphasized-text-color);\n        display: block;\n        padding: var(--spacing-s) var(--spacing-l);\n      }\n      .genericList .loadingMsg:not(.loading) {\n        display: none;\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(Nu.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Lu=ta`
  <style include="shared-styles">
    :host {
      color: var(--primary-text-color);
      display: block;
      max-height: 90vh;
      overflow: auto;
    }
    .container {
      display: flex;
      flex-direction: column;
      max-height: 90vh;
      padding: var(--spacing-xl);
    }
    header {
      flex-shrink: 0;
      padding-bottom: var(--spacing-xl);
    }
    main {
      display: flex;
      flex-shrink: 1;
      width: 100%;
      flex: 1;
      /* IMPORTANT: required for firefox */
      min-height: 0px;
    }
    main .overflow-container {
      flex: 1;
      overflow: auto;
    }
    footer {
      display: flex;
      flex-shrink: 0;
      justify-content: flex-end;
      padding-top: var(--spacing-xl);
    }
    gr-button {
      margin-left: var(--spacing-l);
    }
    .hidden {
      display: none;
    }
  </style>
  <div class="container" on-keydown="_handleKeydown">
    <header class="heading-3"><slot name="header"></slot></header>
    <main>
      <div class="overflow-container">
        <slot name="main"></slot>
      </div>
    </main>
    <footer>
      <slot name="footer"></slot>
      <gr-button
        id="cancel"
        class$="[[_computeCancelClass(cancelLabel)]]"
        link=""
        on-click="_handleCancelTap"
      >
        [[cancelLabel]]
      </gr-button>
      <gr-button
        id="confirm"
        link=""
        primary=""
        on-click="_handleConfirm"
        disabled="[[disabled]]"
        title$="[[confirmTooltip]]"
      >
        [[confirmLabel]]
      </gr-button>
    </footer>
  </div>
`;var Du=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let $u=class extends(oo(dr(oa))){constructor(){super(...arguments),this.confirmLabel="Confirm",this.cancelLabel="Cancel",this.disabled=!1,this.confirmOnEnter=!1}static get template(){return Lu}ready(){super.ready(),this._ensureAttribute("role","dialog")}_handleConfirmTooltipUpdate(e){e?this.$.confirm.setAttribute("has-tooltip","true"):this.$.confirm.removeAttribute("has-tooltip")}_handleConfirm(e){this.disabled||(e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{composed:!0,bubbles:!1})))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}_handleKeydown(e){this.confirmOnEnter&&13===e.keyCode&&this._handleConfirm(e)}resetFocus(){this.$.confirm.focus()}_computeCancelClass(e){return e.length?"":"hidden"}};Du([Bl({type:String})],$u.prototype,"confirmLabel",void 0),Du([Bl({type:String})],$u.prototype,"cancelLabel",void 0),Du([Bl({type:Boolean})],$u.prototype,"disabled",void 0),Du([Bl({type:Boolean})],$u.prototype,"confirmOnEnter",void 0),Du([Bl({type:String})],$u.prototype,"confirmTooltip",void 0),Du([jl("confirmTooltip")],$u.prototype,"_handleConfirmTooltipUpdate",null),$u=Du([Ml("gr-dialog")],$u);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Mu=Er({_template:ta`
    <style>
      :host {
        display: inline-block;
        position: fixed;
        clip: rect(0px,0px,0px,0px);
      }
    </style>
    <div aria-live$="[[mode]]">[[_text]]</div>
`,is:"iron-a11y-announcer",properties:{mode:{type:String,value:"polite"},timeout:{type:Number,value:150},_text:{type:String,value:""}},created:function(){Mu.instance||(Mu.instance=this),document.addEventListener("iron-announce",this._onIronAnnounce.bind(this))},announce:function(e){this._text="",this.async((function(){this._text=e}),this.timeout)},_onIronAnnounce:function(e){e.detail&&e.detail.text&&this.announce(e.detail.text)}});Mu.instance=null,Mu.requestAvailability=function(){Mu.instance||(Mu.instance=document.createElement("iron-a11y-announcer")),document.body?document.body.appendChild(Mu.instance):document.addEventListener("load",(function(){document.body.appendChild(Mu.instance)}))};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
let Fu=null;const Bu={properties:{validator:{type:String},invalid:{notify:!0,reflectToAttribute:!0,type:Boolean,value:!1,observer:"_invalidChanged"}},registered:function(){Fu=new wu({type:"validator"})},_invalidChanged:function(){this.invalid?this.setAttribute("aria-invalid","true"):this.removeAttribute("aria-invalid")},get _validator(){return Fu&&Fu.byKey(this.validator)},hasValidator:function(){return null!=this._validator},validate:function(e){return void 0===e&&void 0!==this.value?this.invalid=!this._getValidity(this.value):this.invalid=!this._getValidity(e),!this.invalid},_getValidity:function(e){return!this.hasValidator()||this._validator.validate(e)}};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/Er({_template:ta`
    <style>
      :host {
        display: inline-block;
      }
    </style>
    <slot id="content"></slot>
`,is:"iron-input",behaviors:[Bu],properties:{bindValue:{type:String,value:""},value:{type:String,computed:"_computeValue(bindValue)"},allowedPattern:{type:String},autoValidate:{type:Boolean,value:!1},_inputElement:Object},observers:["_bindValueChanged(bindValue, _inputElement)"],listeners:{input:"_onInput",keypress:"_onKeypress"},created:function(){Mu.requestAvailability(),this._previousValidInput="",this._patternAlreadyChecked=!1},attached:function(){this._observer=qo(this).observeNodes(function(e){this._initSlottedInput()}.bind(this))},detached:function(){this._observer&&(qo(this).unobserveNodes(this._observer),this._observer=null)},get inputElement(){return this._inputElement},_initSlottedInput:function(){this._inputElement=this.getEffectiveChildren()[0],this.inputElement&&this.inputElement.value&&(this.bindValue=this.inputElement.value),this.fire("iron-input-ready")},get _patternRegExp(){var e;if(this.allowedPattern)e=new RegExp(this.allowedPattern);else switch(this.inputElement.type){case"number":e=/[0-9.,e-]/}return e},_bindValueChanged:function(e,t){t&&(void 0===e?t.value=null:e!==t.value&&(this.inputElement.value=e),this.autoValidate&&this.validate(),this.fire("bind-value-changed",{value:e}))},_onInput:function(){this.allowedPattern&&!this._patternAlreadyChecked&&(this._checkPatternValidity()||(this._announceInvalidCharacter("Invalid string of characters not entered."),this.inputElement.value=this._previousValidInput));this.bindValue=this._previousValidInput=this.inputElement.value,this._patternAlreadyChecked=!1},_isPrintable:function(e){var t=8==e.keyCode||9==e.keyCode||13==e.keyCode||27==e.keyCode,n=19==e.keyCode||20==e.keyCode||45==e.keyCode||46==e.keyCode||144==e.keyCode||145==e.keyCode||e.keyCode>32&&e.keyCode<41||e.keyCode>111&&e.keyCode<124;return!(t||0==e.charCode&&n)},_onKeypress:function(e){if(this.allowedPattern||"number"===this.inputElement.type){var t=this._patternRegExp;if(t&&!(e.metaKey||e.ctrlKey||e.altKey)){this._patternAlreadyChecked=!0;var n=String.fromCharCode(e.charCode);this._isPrintable(e)&&!t.test(n)&&(e.preventDefault(),this._announceInvalidCharacter("Invalid character "+n+" not entered."))}}},_checkPatternValidity:function(){var e=this._patternRegExp;if(!e)return!0;for(var t=0;t<this.inputElement.value.length;t++)if(!e.test(this.inputElement.value[t]))return!1;return!0},validate:function(){if(!this.inputElement)return this.invalid=!1,!0;var e=this.inputElement.checkValidity();return e&&(this.required&&""===this.bindValue?e=!1:this.hasValidator()&&(e=Bu.validate.call(this,this.bindValue))),this.invalid=!e,this.fire("iron-input-validate"),e},_announceInvalidCharacter:function(e){this.fire("iron-announce",{text:e})},_computeValue:function(e){return e}});
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ju=ta`
  <style include="shared-styles">
    #filter {
      max-width: 25em;
    }
    #filter:focus {
      outline: none;
    }
    #topContainer {
      align-items: center;
      display: flex;
      height: 3rem;
      justify-content: space-between;
      margin: 0 var(--spacing-l);
    }
    #createNewContainer:not(.show) {
      display: none;
    }
    a {
      color: var(--primary-text-color);
      text-decoration: none;
    }
    a:hover {
      text-decoration: underline;
    }
    nav {
      align-items: center;
      display: flex;
      height: 3rem;
      justify-content: flex-end;
      margin-right: 20px;
    }
    nav,
    iron-icon {
      color: var(--deemphasized-text-color);
    }
    iron-icon {
      height: 1.85rem;
      margin-left: 16px;
      width: 1.85rem;
    }
  </style>
  <div id="topContainer">
    <div class="filterContainer">
      <label>Filter:</label>
      <iron-input type="text" bind-value="{{filter}}">
        <input
          is="iron-input"
          type="text"
          id="filter"
          bind-value="{{filter}}"
        />
      </iron-input>
    </div>
    <div id="createNewContainer" class$="[[_computeCreateClass(createNew)]]">
      <gr-button primary="" link="" id="createNew" on-click="_createNewItem">
        Create New
      </gr-button>
    </div>
  </div>
  <slot></slot>
  <nav>
    Page [[_computePage(offset, itemsPerPage)]]
    <a
      id="prevArrow"
      href$="[[_computeNavLink(offset, -1, itemsPerPage, filter, path)]]"
      hidden$="[[_hidePrevArrow(loading, offset)]]"
      hidden=""
    >
      <iron-icon icon="gr-icons:chevron-left"></iron-icon>
    </a>
    <a
      id="nextArrow"
      href$="[[_computeNavLink(offset, 1, itemsPerPage, filter, path)]]"
      hidden$="[[_hideNextArrow(loading, items)]]"
      hidden=""
    >
      <iron-icon icon="gr-icons:chevron-right"></iron-icon>
    </a>
  </nav>
`;var Hu=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Uu=class extends(oo(dr(oa))){constructor(){super(...arguments),this.itemsPerPage=25}static get template(){return ju}detached(){super.detached(),this.cancelDebouncer("reload")}_filterChanged(e,t){(e||t)&&this._debounceReload(e)}_debounceReload(e){this.debounce("reload",()=>{if(this.path)return e?hd.show(`${this.path}/q/filter:`+G(e,!1)):hd.show(this.path)},200)}_createNewItem(){this.dispatchEvent(new CustomEvent("create-clicked",{composed:!0,bubbles:!0}))}_computeNavLink(e,t,n,i,o){e=+(e||0);const s=Math.max(0,e+n*t);let r=j()+o;return i&&(r+="/q/filter:"+G(i,!1)),s>0&&(r+=`,${s}`),r}_computeCreateClass(e){return e?"show":""}_hidePrevArrow(e,t){return e||0===t}_hideNextArrow(e,t){if(e||!t||!t.length)return!0;return t.length<this.itemsPerPage+1}_computePage(e,t){return e/t+1}};Hu([Bl({type:Boolean})],Uu.prototype,"createNew",void 0),Hu([Bl({type:Array})],Uu.prototype,"items",void 0),Hu([Bl({type:Number})],Uu.prototype,"itemsPerPage",void 0),Hu([Bl({type:String})],Uu.prototype,"filter",void 0),Hu([Bl({type:Number})],Uu.prototype,"offset",void 0),Hu([Bl({type:Boolean})],Uu.prototype,"loading",void 0),Hu([Bl({type:String})],Uu.prototype,"path",void 0),Hu([jl("filter")],Uu.prototype,"_filterChanged",null),Uu=Hu([Ml("gr-list-view")],Uu);
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Gu=document.createElement("template");Gu.innerHTML='<dom-module id="gr-form-styles">\n  <template>\n    <style>\n      .gr-form-styles input {\n        background-color: var(--view-background-color);\n        color: var(--primary-text-color);\n      }\n      .gr-form-styles select {\n        background-color: var(--select-background-color);\n        color: var(--primary-text-color);\n      }\n      .gr-form-styles h1,\n      .gr-form-styles h2 {\n        margin-bottom: var(--spacing-s);\n      }\n      .gr-form-styles h4 {\n        font-weight: var(--font-weight-bold);\n      }\n      .gr-form-styles fieldset {\n        border: none;\n        margin-bottom: var(--spacing-xxl);\n      }\n      .gr-form-styles section {\n        display: flex;\n        margin: var(--spacing-s) 0;\n        min-height: 2em;\n      }\n      .gr-form-styles section * {\n        vertical-align: middle;\n      }\n      .gr-form-styles .title,\n      .gr-form-styles .value {\n        display: inline-block;\n      }\n      .gr-form-styles .title {\n        color: var(--deemphasized-text-color);\n        font-weight: var(--font-weight-bold);\n        padding-right: var(--spacing-m);\n        width: 15em;\n      }\n      .gr-form-styles th {\n        color: var(--deemphasized-text-color);\n        text-align: left;\n        vertical-align: bottom;\n      }\n      .gr-form-styles td,\n      .gr-form-styles tfoot th {\n        padding: var(--spacing-s) 0;\n        vertical-align: middle;\n      }\n      .gr-form-styles .emptyHeader {\n        text-align: right;\n      }\n      .gr-form-styles table {\n        width: 50em;\n      }\n      .gr-form-styles th:first-child,\n      .gr-form-styles td:first-child {\n        width: 15em;\n      }\n      .gr-form-styles th:first-child input,\n      .gr-form-styles td:first-child input {\n        width: 14em;\n      }\n      .gr-form-styles input:not([type="checkbox"]),\n      .gr-form-styles select,\n      .gr-form-styles textarea {\n        border: 1px solid var(--border-color);\n        border-radius: var(--border-radius);\n        padding: var(--spacing-s);\n      }\n      .gr-form-styles td:last-child {\n        width: 5em;\n      }\n      .gr-form-styles th:last-child gr-button,\n      .gr-form-styles td:last-child gr-button {\n        width: 100%;\n      }\n      .gr-form-styles iron-autogrow-textarea {\n        height: auto;\n        min-height: 4em;\n      }\n      .gr-form-styles gr-autocomplete {\n        width: 14em;\n      }\n      @media only screen and (max-width: 40em) {\n        .gr-form-styles section {\n          margin-bottom: var(--spacing-l);\n        }\n        .gr-form-styles .title,\n        .gr-form-styles .value {\n          display: block;\n        }\n        .gr-form-styles table {\n          width: 100%;\n        }\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(Gu.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Vu=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    :host {
      display: inline-block;
    }
    input {
      width: 20em;
    }
  </style>
  <div class="gr-form-styles">
    <div id="form">
      <section>
        <span class="title">Group name</span>
        <iron-input bind-value="{{_name}}">
          <input is="iron-input" bind-value="{{_name}}" />
        </iron-input>
      </section>
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var zu=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Wu=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasNewGroupName=!1,this._name="",this._groupCreated=!1}static get template(){return Vu}_computeGroupUrl(e){return j()+"/admin/groups/"+G(e,!0)}_updateGroupName(e){this.hasNewGroupName=!!e}handleCreateGroup(){return this.$.restAPI.createGroup({name:this._name}).then(e=>{if(201===e.status)return this._groupCreated=!0,this.$.restAPI.getGroupConfig(this._name).then(e=>{hd.show(this._computeGroupUrl(e.group_id))})})}};zu([Bl({type:Boolean,notify:!0})],Wu.prototype,"hasNewGroupName",void 0),zu([Bl({type:String})],Wu.prototype,"_name",void 0),zu([Bl({type:Boolean})],Wu.prototype,"_groupCreated",void 0),zu([jl("_name")],Wu.prototype,"_updateGroupName",null),Wu=zu([Ml("gr-create-group-dialog")],Wu);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const qu=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-table-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <gr-list-view
    create-new="[[_createNewCapability]]"
    filter="[[_filter]]"
    items="[[_groups]]"
    items-per-page="[[_groupsPerPage]]"
    loading="[[_loading]]"
    offset="[[_offset]]"
    on-create-clicked="_handleCreateClicked"
    path="[[_path]]"
  >
    <table id="list" class="genericList">
      <tbody>
        <tr class="headerRow">
          <th class="name topHeader">Group Name</th>
          <th class="description topHeader">Group Description</th>
          <th class="visibleToAll topHeader">Visible To All</th>
        </tr>
        <tr id="loading" class$="loadingMsg [[computeLoadingClass(_loading)]]">
          <td>Loading...</td>
        </tr>
      </tbody>
      <tbody class$="[[computeLoadingClass(_loading)]]">
        <template is="dom-repeat" items="[[_shownGroups]]">
          <tr class="table">
            <td class="name">
              <a href$="[[_computeGroupUrl(item.id)]]">[[item.name]]</a>
            </td>
            <td class="description">[[item.description]]</td>
            <td class="visibleToAll">[[_visibleToAll(item)]]</td>
          </tr>
        </template>
      </tbody>
    </table>
  </gr-list-view>
  <gr-overlay id="createOverlay" with-backdrop="">
    <gr-dialog
      id="createDialog"
      class="confirmDialog"
      disabled="[[!_hasNewGroupName]]"
      confirm-label="Create"
      confirm-on-enter=""
      on-confirm="_handleCreateGroup"
      on-cancel="_handleCloseCreate"
    >
      <div class="header" slot="header">
        Create Group
      </div>
      <div class="main" slot="main">
        <gr-create-group-dialog
          has-new-group-name="{{_hasNewGroupName}}"
          id="createNewModal"
        ></gr-create-group-dialog>
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,Ku=Me(e=>class extends e{computeLoadingClass(e){return e?"loading":""}computeShownItems(e){return e.slice(0,25)}getUrl(e,t){return j()+e+G(t,!0)}getFilterValue(e){return e&&e.filter||""}getOffsetValue(e){return(null==e?void 0:e.offset)?Number(e.offset):0}});
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Yu=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Xu=class extends(Ku(oo(dr(oa)))){constructor(){super(...arguments),this._path="/admin/groups",this._createNewCapability=!1,this._groups=[],this._groupsPerPage=25,this._loading=!0,this._filter=""}static get template(){return qu}get _shownGroups(){return this.computeShownItems(this._groups)}attached(){super.attached(),this._getCreateGroupCapability(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Groups"},composed:!0,bubbles:!0})),this._maybeOpenCreateOverlay(this.params)}_paramsChanged(e){return this._loading=!0,this._filter=this.getFilterValue(e),this._offset=this.getOffsetValue(e),this._getGroups(this._filter,this._groupsPerPage,this._offset)}_maybeOpenCreateOverlay(e){(null==e?void 0:e.openCreateModal)&&this.$.createOverlay.open()}_computeGroupUrl(e){return gh.getUrlForGroup(decodeURIComponent(e))}_getCreateGroupCapability(){return this.$.restAPI.getAccount().then(e=>{if(e)return this.$.restAPI.getAccountCapabilities(["createGroup"]).then(e=>{(null==e?void 0:e.createGroup)&&(this._createNewCapability=!0)})})}_getGroups(e,t,n){return this._groups=[],this.$.restAPI.getGroups(e,t,n).then(e=>{e&&(this._groups=Object.keys(e).map(t=>{const n=e[t];return n.name=t,n}),this._loading=!1)})}_refreshGroupsList(){return this.$.restAPI.invalidateGroupsCache(),this._getGroups(this._filter,this._groupsPerPage,this._offset)}_handleCreateGroup(){this.$.createNewModal.handleCreateGroup().then(()=>{this._refreshGroupsList()})}_handleCloseCreate(){this.$.createOverlay.close()}_handleCreateClicked(){this.$.createOverlay.open()}_visibleToAll(e){var t;return!0===(null===(t=e.options)||void 0===t?void 0:t.visible_to_all)?"Y":"N"}};Yu([Bl({type:Object})],Xu.prototype,"params",void 0),Yu([Bl({type:Number})],Xu.prototype,"_offset",void 0),Yu([Bl({type:String})],Xu.prototype,"_path",void 0),Yu([Bl({type:Boolean})],Xu.prototype,"_hasNewGroupName",void 0),Yu([Bl({type:Boolean})],Xu.prototype,"_createNewCapability",void 0),Yu([Bl({type:Array})],Xu.prototype,"_groups",void 0),Yu([Hl("_groups")],Xu.prototype,"_shownGroups",null),Yu([Bl({type:Number})],Xu.prototype,"_groupsPerPage",void 0),Yu([Bl({type:Boolean})],Xu.prototype,"_loading",void 0),Yu([Bl({type:String})],Xu.prototype,"_filter",void 0),Yu([jl("params")],Xu.prototype,"_paramsChanged",null),Xu=Yu([Ml("gr-admin-group-list")],Xu),
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style>
      :host {
        display: inline-block;
        position: relative;
        width: 400px;
        border: 1px solid;
        padding: 2px;
        -moz-appearance: textarea;
        -webkit-appearance: textarea;
        overflow: hidden;
      }

      .mirror-text {
        visibility: hidden;
        word-wrap: break-word;
        @apply --iron-autogrow-textarea;
      }

      .fit {
        @apply --layout-fit;
      }

      textarea {
        position: relative;
        outline: none;
        border: none;
        resize: none;
        background: inherit;
        color: inherit;
        /* see comments in template */
        width: 100%;
        height: 100%;
        font-size: inherit;
        font-family: inherit;
        line-height: inherit;
        text-align: inherit;
        @apply --iron-autogrow-textarea;
      }

      textarea::-webkit-input-placeholder {
        @apply --iron-autogrow-textarea-placeholder;
      }

      textarea:-moz-placeholder {
        @apply --iron-autogrow-textarea-placeholder;
      }

      textarea::-moz-placeholder {
        @apply --iron-autogrow-textarea-placeholder;
      }

      textarea:-ms-input-placeholder {
        @apply --iron-autogrow-textarea-placeholder;
      }
    </style>

    <!-- the mirror sizes the input/textarea so it grows with typing -->
    <!-- use &#160; instead &nbsp; of to allow this element to be used in XHTML -->
    <div id="mirror" class="mirror-text" aria-hidden="true">&nbsp;</div>

    <!-- size the input/textarea with a div, because the textarea has intrinsic size in ff -->
    <div class="textarea-container fit">
      <textarea id="textarea" name$="[[name]]" aria-label$="[[label]]" autocomplete$="[[autocomplete]]" autofocus$="[[autofocus]]" autocapitalize$="[[autocapitalize]]" inputmode$="[[inputmode]]" placeholder$="[[placeholder]]" readonly$="[[readonly]]" required$="[[required]]" disabled$="[[disabled]]" rows$="[[rows]]" minlength$="[[minlength]]" maxlength$="[[maxlength]]"></textarea>
    </div>
`,is:"iron-autogrow-textarea",behaviors:[Bu,jh],properties:{value:{observer:"_valueChanged",type:String,notify:!0},bindValue:{observer:"_bindValueChanged",type:String,notify:!0},rows:{type:Number,value:1,observer:"_updateCached"},maxRows:{type:Number,value:0,observer:"_updateCached"},autocomplete:{type:String,value:"off"},autofocus:{type:Boolean,value:!1},autocapitalize:{type:String,value:"none"},inputmode:{type:String},placeholder:{type:String},readonly:{type:String},required:{type:Boolean},minlength:{type:Number},maxlength:{type:Number},label:{type:String}},listeners:{input:"_onInput"},get textarea(){return this.$.textarea},get selectionStart(){return this.$.textarea.selectionStart},get selectionEnd(){return this.$.textarea.selectionEnd},set selectionStart(e){this.$.textarea.selectionStart=e},set selectionEnd(e){this.$.textarea.selectionEnd=e},attached:function(){navigator.userAgent.match(/iP(?:[oa]d|hone)/)&&!navigator.userAgent.match(/OS 1[3456789]/)&&(this.$.textarea.style.marginLeft="-3px")},validate:function(){var e=this.$.textarea.validity.valid;return e&&(this.required&&""===this.value?e=!1:this.hasValidator()&&(e=Bu.validate.call(this,this.value))),this.invalid=!e,this.fire("iron-input-validate"),e},_bindValueChanged:function(e){this.value=e},_valueChanged:function(e){var t=this.textarea;t&&(t.value!==e&&(t.value=e||0===e?e:""),this.bindValue=e,this.$.mirror.innerHTML=this._valueForMirror(),this.fire("bind-value-changed",{value:this.bindValue}))},_onInput:function(e){var t=qo(e).path;this.value=t?t[0].value:e.target.value},_constrain:function(e){var t;for(e=e||[""],t=this.maxRows>0&&e.length>this.maxRows?e.slice(0,this.maxRows):e.slice(0);this.rows>0&&t.length<this.rows;)t.push("");return t.join("<br/>")+"&#160;"},_valueForMirror:function(){var e=this.textarea;if(e)return this.tokens=e&&e.value?e.value.replace(/&/gm,"&amp;").replace(/"/gm,"&quot;").replace(/'/gm,"&#39;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").split("\n"):[""],this._constrain(this.tokens)},_updateCached:function(){this.$.mirror.innerHTML=this._constrain(this.tokens)}});
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ju=document.createElement("template");Ju.innerHTML='<dom-module id="gr-subpage-styles">\n  <template>\n    <style>\n      main {\n        margin: var(--spacing-l);\n      }\n      .loading {\n        display: none;\n      }\n      #loading.loading {\n        display: block;\n      }\n      #loading:not(.loading) {\n        display: none;\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(Ju.content);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Zu={attached:function(){this.fire("addon-attached")},update:function(e){}};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/Er({_template:ta`
    <style>
      :host {
        display: inline-block;
        float: right;

        @apply --paper-font-caption;
        @apply --paper-input-char-counter;
      }

      :host([hidden]) {
        display: none !important;
      }

      :host(:dir(rtl)) {
        float: left;
      }
    </style>

    <span>[[_charCounterStr]]</span>
`,is:"paper-input-char-counter",behaviors:[Zu],properties:{_charCounterStr:{type:String,value:"0"}},update:function(e){if(e.inputElement){e.value=e.value||"";var t=e.value.toString().length.toString();e.inputElement.hasAttribute("maxlength")&&(t+="/"+e.inputElement.getAttribute("maxlength")),this._charCounterStr=t}}});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const Qu=ta`
<custom-style>
  <style is="custom-style">
    html {
      --paper-input-container-shared-input-style: {
        position: relative; /* to make a stacking context */
        outline: none;
        box-shadow: none;
        padding: 0;
        margin: 0;
        width: 100%;
        max-width: 100%;
        background: transparent;
        border: none;
        color: var(--paper-input-container-input-color, var(--primary-text-color));
        -webkit-appearance: none;
        text-align: inherit;
        vertical-align: var(--paper-input-container-input-align, bottom);

        @apply --paper-font-subhead;
      };
    }
  </style>
</custom-style>
`;Qu.setAttribute("style","display: none;"),document.head.appendChild(Qu.content),Er({_template:ta`
    <style>
      :host {
        display: block;
        padding: 8px 0;
        @apply --paper-input-container;
      }

      :host([inline]) {
        display: inline-block;
      }

      :host([disabled]) {
        pointer-events: none;
        opacity: 0.33;

        @apply --paper-input-container-disabled;
      }

      :host([hidden]) {
        display: none !important;
      }

      [hidden] {
        display: none !important;
      }

      .floated-label-placeholder {
        @apply --paper-font-caption;
      }

      .underline {
        height: 2px;
        position: relative;
      }

      .focused-line {
        @apply --layout-fit;
        border-bottom: 2px solid var(--paper-input-container-focus-color, var(--primary-color));

        -webkit-transform-origin: center center;
        transform-origin: center center;
        -webkit-transform: scale3d(0,1,1);
        transform: scale3d(0,1,1);

        @apply --paper-input-container-underline-focus;
      }

      .underline.is-highlighted .focused-line {
        -webkit-transform: none;
        transform: none;
        -webkit-transition: -webkit-transform 0.25s;
        transition: transform 0.25s;

        @apply --paper-transition-easing;
      }

      .underline.is-invalid .focused-line {
        border-color: var(--paper-input-container-invalid-color, var(--error-color));
        -webkit-transform: none;
        transform: none;
        -webkit-transition: -webkit-transform 0.25s;
        transition: transform 0.25s;

        @apply --paper-transition-easing;
      }

      .unfocused-line {
        @apply --layout-fit;
        border-bottom: 1px solid var(--paper-input-container-color, var(--secondary-text-color));
        @apply --paper-input-container-underline;
      }

      :host([disabled]) .unfocused-line {
        border-bottom: 1px dashed;
        border-color: var(--paper-input-container-color, var(--secondary-text-color));
        @apply --paper-input-container-underline-disabled;
      }

      .input-wrapper {
        @apply --layout-horizontal;
        @apply --layout-center;
        position: relative;
      }

      .input-content {
        @apply --layout-flex-auto;
        @apply --layout-relative;
        max-width: 100%;
      }

      .input-content ::slotted(label),
      .input-content ::slotted(.paper-input-label) {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        font: inherit;
        color: var(--paper-input-container-color, var(--secondary-text-color));
        -webkit-transition: -webkit-transform 0.25s, width 0.25s;
        transition: transform 0.25s, width 0.25s;
        -webkit-transform-origin: left top;
        transform-origin: left top;
        /* Fix for safari not focusing 0-height date/time inputs with -webkit-apperance: none; */
        min-height: 1px;

        @apply --paper-font-common-nowrap;
        @apply --paper-font-subhead;
        @apply --paper-input-container-label;
        @apply --paper-transition-easing;
      }


      .input-content ::slotted(label):before,
      .input-content ::slotted(.paper-input-label):before {
        @apply --paper-input-container-label-before;
      }

      .input-content ::slotted(label):after,
      .input-content ::slotted(.paper-input-label):after {
        @apply --paper-input-container-label-after;
      }

      .input-content.label-is-floating ::slotted(label),
      .input-content.label-is-floating ::slotted(.paper-input-label) {
        -webkit-transform: translateY(-75%) scale(0.75);
        transform: translateY(-75%) scale(0.75);

        /* Since we scale to 75/100 of the size, we actually have 100/75 of the
        original space now available */
        width: 133%;

        @apply --paper-input-container-label-floating;
      }

      :host(:dir(rtl)) .input-content.label-is-floating ::slotted(label),
      :host(:dir(rtl)) .input-content.label-is-floating ::slotted(.paper-input-label) {
        right: 0;
        left: auto;
        -webkit-transform-origin: right top;
        transform-origin: right top;
      }

      .input-content.label-is-highlighted ::slotted(label),
      .input-content.label-is-highlighted ::slotted(.paper-input-label) {
        color: var(--paper-input-container-focus-color, var(--primary-color));

        @apply --paper-input-container-label-focus;
      }

      .input-content.is-invalid ::slotted(label),
      .input-content.is-invalid ::slotted(.paper-input-label) {
        color: var(--paper-input-container-invalid-color, var(--error-color));
      }

      .input-content.label-is-hidden ::slotted(label),
      .input-content.label-is-hidden ::slotted(.paper-input-label) {
        visibility: hidden;
      }

      .input-content ::slotted(input),
      .input-content ::slotted(iron-input),
      .input-content ::slotted(textarea),
      .input-content ::slotted(iron-autogrow-textarea),
      .input-content ::slotted(.paper-input-input) {
        @apply --paper-input-container-shared-input-style;
        /* The apply shim doesn't apply the nested color custom property,
          so we have to re-apply it here. */
        color: var(--paper-input-container-input-color, var(--primary-text-color));
        @apply --paper-input-container-input;
      }

      .input-content ::slotted(input)::-webkit-outer-spin-button,
      .input-content ::slotted(input)::-webkit-inner-spin-button {
        @apply --paper-input-container-input-webkit-spinner;
      }

      .input-content.focused ::slotted(input),
      .input-content.focused ::slotted(iron-input),
      .input-content.focused ::slotted(textarea),
      .input-content.focused ::slotted(iron-autogrow-textarea),
      .input-content.focused ::slotted(.paper-input-input) {
        @apply --paper-input-container-input-focus;
      }

      .input-content.is-invalid ::slotted(input),
      .input-content.is-invalid ::slotted(iron-input),
      .input-content.is-invalid ::slotted(textarea),
      .input-content.is-invalid ::slotted(iron-autogrow-textarea),
      .input-content.is-invalid ::slotted(.paper-input-input) {
        @apply --paper-input-container-input-invalid;
      }

      .prefix ::slotted(*) {
        display: inline-block;
        @apply --paper-font-subhead;
        @apply --layout-flex-none;
        @apply --paper-input-prefix;
      }

      .suffix ::slotted(*) {
        display: inline-block;
        @apply --paper-font-subhead;
        @apply --layout-flex-none;

        @apply --paper-input-suffix;
      }

      /* Firefox sets a min-width on the input, which can cause layout issues */
      .input-content ::slotted(input) {
        min-width: 0;
      }

      .input-content ::slotted(textarea) {
        resize: none;
      }

      .add-on-content {
        position: relative;
      }

      .add-on-content.is-invalid ::slotted(*) {
        color: var(--paper-input-container-invalid-color, var(--error-color));
      }

      .add-on-content.is-highlighted ::slotted(*) {
        color: var(--paper-input-container-focus-color, var(--primary-color));
      }
    </style>

    <div class="floated-label-placeholder" aria-hidden="true" hidden="[[noLabelFloat]]">&nbsp;</div>

    <div class="input-wrapper">
      <span class="prefix"><slot name="prefix"></slot></span>

      <div class$="[[_computeInputContentClass(noLabelFloat,alwaysFloatLabel,focused,invalid,_inputHasContent)]]" id="labelAndInputContainer">
        <slot name="label"></slot>
        <slot name="input"></slot>
      </div>

      <span class="suffix"><slot name="suffix"></slot></span>
    </div>

    <div class$="[[_computeUnderlineClass(focused,invalid)]]">
      <div class="unfocused-line"></div>
      <div class="focused-line"></div>
    </div>

    <div class$="[[_computeAddOnContentClass(focused,invalid)]]">
      <slot name="add-on"></slot>
    </div>
`,is:"paper-input-container",properties:{noLabelFloat:{type:Boolean,value:!1},alwaysFloatLabel:{type:Boolean,value:!1},attrForValue:{type:String,value:"bind-value"},autoValidate:{type:Boolean,value:!1},invalid:{observer:"_invalidChanged",type:Boolean,value:!1},focused:{readOnly:!0,type:Boolean,value:!1,notify:!0},_addons:{type:Array},_inputHasContent:{type:Boolean,value:!1},_inputSelector:{type:String,value:"input,iron-input,textarea,.paper-input-input"},_boundOnFocus:{type:Function,value:function(){return this._onFocus.bind(this)}},_boundOnBlur:{type:Function,value:function(){return this._onBlur.bind(this)}},_boundOnInput:{type:Function,value:function(){return this._onInput.bind(this)}},_boundValueChanged:{type:Function,value:function(){return this._onValueChanged.bind(this)}}},listeners:{"addon-attached":"_onAddonAttached","iron-input-validate":"_onIronInputValidate"},get _valueChangedEvent(){return this.attrForValue+"-changed"},get _propertyForValue(){return Nt(this.attrForValue)},get _inputElement(){return qo(this).querySelector(this._inputSelector)},get _inputElementValue(){return this._inputElement[this._propertyForValue]||this._inputElement.value},ready:function(){this.__isFirstValueUpdate=!0,this._addons||(this._addons=[]),this.addEventListener("focus",this._boundOnFocus,!0),this.addEventListener("blur",this._boundOnBlur,!0)},attached:function(){this.attrForValue?this._inputElement.addEventListener(this._valueChangedEvent,this._boundValueChanged):this.addEventListener("input",this._onInput),this._inputElementValue&&""!=this._inputElementValue?this._handleValueAndAutoValidate(this._inputElement):this._handleValue(this._inputElement)},_onAddonAttached:function(e){this._addons||(this._addons=[]);var t=e.target;-1===this._addons.indexOf(t)&&(this._addons.push(t),this.isAttached&&this._handleValue(this._inputElement))},_onFocus:function(){this._setFocused(!0)},_onBlur:function(){this._setFocused(!1),this._handleValueAndAutoValidate(this._inputElement)},_onInput:function(e){this._handleValueAndAutoValidate(e.target)},_onValueChanged:function(e){var t=e.target;this.__isFirstValueUpdate&&(this.__isFirstValueUpdate=!1,void 0===t.value||""===t.value)||this._handleValueAndAutoValidate(e.target)},_handleValue:function(e){var t=this._inputElementValue;t||0===t||"number"===e.type&&!e.checkValidity()?this._inputHasContent=!0:this._inputHasContent=!1,this.updateAddons({inputElement:e,value:t,invalid:this.invalid})},_handleValueAndAutoValidate:function(e){var t;this.autoValidate&&e&&(t=e.validate?e.validate(this._inputElementValue):e.checkValidity(),this.invalid=!t);this._handleValue(e)},_onIronInputValidate:function(e){this.invalid=this._inputElement.invalid},_invalidChanged:function(){this._addons&&this.updateAddons({invalid:this.invalid})},updateAddons:function(e){for(var t,n=0;t=this._addons[n];n++)t.update(e)},_computeInputContentClass:function(e,t,n,i,o){var s="input-content";if(e)o&&(s+=" label-is-hidden"),i&&(s+=" is-invalid");else{var r=this.querySelector("label");t||o?(s+=" label-is-floating",this.$.labelAndInputContainer.style.position="static",i?s+=" is-invalid":n&&(s+=" label-is-highlighted")):(r&&(this.$.labelAndInputContainer.style.position="relative"),i&&(s+=" is-invalid"))}return n&&(s+=" focused"),s},_computeUnderlineClass:function(e,t){var n="underline";return t?n+=" is-invalid":e&&(n+=" is-highlighted"),n},_computeAddOnContentClass:function(e,t){var n="add-on-content";return t?n+=" is-invalid":e&&(n+=" is-highlighted"),n}}),
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style>
      :host {
        display: inline-block;
        visibility: hidden;

        color: var(--paper-input-container-invalid-color, var(--error-color));

        @apply --paper-font-caption;
        @apply --paper-input-error;
        position: absolute;
        left:0;
        right:0;
      }

      :host([invalid]) {
        visibility: visible;
      }

      #a11yWrapper {
        visibility: hidden;
      }

      :host([invalid]) #a11yWrapper {
        visibility: visible;
      }
    </style>

    <!--
    If the paper-input-error element is directly referenced by an
    \`aria-describedby\` attribute, such as when used as a paper-input add-on,
    then applying \`visibility: hidden;\` to the paper-input-error element itself
    does not hide the error.

    For more information, see:
    https://www.w3.org/TR/accname-1.1/#mapping_additional_nd_description
    -->
    <div id="a11yWrapper">
      <slot></slot>
    </div>
`,is:"paper-input-error",behaviors:[Zu],properties:{invalid:{readOnly:!0,reflectToAttribute:!0,type:Boolean}},update:function(e){this._setInvalid(e.invalid)}});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const eg={properties:{name:{type:String},value:{notify:!0,type:String},required:{type:Boolean,value:!1}},attached:function(){},detached:function(){}},tg={NextLabelID:1,NextAddonID:1,NextInputID:1},ng={properties:{label:{type:String},value:{notify:!0,type:String},disabled:{type:Boolean,value:!1},invalid:{type:Boolean,value:!1,notify:!0},allowedPattern:{type:String},type:{type:String},list:{type:String},pattern:{type:String},required:{type:Boolean,value:!1},errorMessage:{type:String},charCounter:{type:Boolean,value:!1},noLabelFloat:{type:Boolean,value:!1},alwaysFloatLabel:{type:Boolean,value:!1},autoValidate:{type:Boolean,value:!1},validator:{type:String},autocomplete:{type:String,value:"off"},autofocus:{type:Boolean,observer:"_autofocusChanged"},inputmode:{type:String},minlength:{type:Number},maxlength:{type:Number},min:{type:String},max:{type:String},step:{type:String},name:{type:String},placeholder:{type:String,value:""},readonly:{type:Boolean,value:!1},size:{type:Number},autocapitalize:{type:String,value:"none"},autocorrect:{type:String,value:"off"},autosave:{type:String},results:{type:Number},accept:{type:String},multiple:{type:Boolean},_ariaDescribedBy:{type:String,value:""},_ariaLabelledBy:{type:String,value:""},_inputId:{type:String,value:""}},listeners:{"addon-attached":"_onAddonAttached"},keyBindings:{"shift+tab:keydown":"_onShiftTabDown"},hostAttributes:{tabindex:0},get inputElement(){return this.$||(this.$={}),this.$.input||(this._generateInputId(),this.$.input=this.$$("#"+this._inputId)),this.$.input},get _focusableElement(){return this.inputElement},created:function(){this._typesThatHaveText=["date","datetime","datetime-local","month","time","week","file"]},attached:function(){this._updateAriaLabelledBy(),!oa&&this.inputElement&&-1!==this._typesThatHaveText.indexOf(this.inputElement.type)&&(this.alwaysFloatLabel=!0)},_appendStringWithSpace:function(e,t){return e=e?e+" "+t:t},_onAddonAttached:function(e){var t=qo(e).rootTarget;if(t.id)this._ariaDescribedBy=this._appendStringWithSpace(this._ariaDescribedBy,t.id);else{var n="paper-input-add-on-"+tg.NextAddonID++;t.id=n,this._ariaDescribedBy=this._appendStringWithSpace(this._ariaDescribedBy,n)}},validate:function(){return this.inputElement.validate()},_focusBlurHandler:function(e){jh._focusBlurHandler.call(this,e),this.focused&&!this._shiftTabPressed&&this._focusableElement&&this._focusableElement.focus()},_onShiftTabDown:function(e){var t=this.getAttribute("tabindex");this._shiftTabPressed=!0,this.setAttribute("tabindex","-1"),this.async((function(){this.setAttribute("tabindex",t),this._shiftTabPressed=!1}),1)},_handleAutoValidate:function(){this.autoValidate&&this.validate()},updateValueAndPreserveCaret:function(e){try{var t=this.inputElement.selectionStart;this.value=e,this.inputElement.selectionStart=t,this.inputElement.selectionEnd=t}catch(t){this.value=e}},_computeAlwaysFloatLabel:function(e,t){return t||e},_updateAriaLabelledBy:function(){var e,t=qo(this.root).querySelector("label");t?(t.id?e=t.id:(e="paper-input-label-"+tg.NextLabelID++,t.id=e),this._ariaLabelledBy=e):this._ariaLabelledBy=""},_generateInputId:function(){this._inputId&&""!==this._inputId||(this._inputId="input-"+tg.NextInputID++)},_onChange:function(e){this.shadowRoot&&this.fire(e.type,{sourceEvent:e},{node:this,bubbles:e.bubbles,cancelable:e.cancelable})},_autofocusChanged:function(){if(this.autofocus&&this._focusableElement){var e=document.activeElement;e instanceof HTMLElement&&e!==document.body&&e!==document.documentElement||this._focusableElement.focus()}}};
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({is:"paper-input",_template:ta`
    <style>
      :host {
        display: block;
      }

      :host([focused]) {
        outline: none;
      }

      :host([hidden]) {
        display: none !important;
      }

      input {
        /* Firefox sets a min-width on the input, which can cause layout issues */
        min-width: 0;
      }

      /* In 1.x, the <input> is distributed to paper-input-container, which styles it.
      In 2.x the <iron-input> is distributed to paper-input-container, which styles
      it, but in order for this to work correctly, we need to reset some
      of the native input's properties to inherit (from the iron-input) */
      iron-input > input {
        @apply --paper-input-container-shared-input-style;
        font-family: inherit;
        font-weight: inherit;
        font-size: inherit;
        letter-spacing: inherit;
        word-spacing: inherit;
        line-height: inherit;
        text-shadow: inherit;
        color: inherit;
        cursor: inherit;
      }

      input:disabled {
        @apply --paper-input-container-input-disabled;
      }

      input::-webkit-outer-spin-button,
      input::-webkit-inner-spin-button {
        @apply --paper-input-container-input-webkit-spinner;
      }

      input::-webkit-clear-button {
        @apply --paper-input-container-input-webkit-clear;
      }

      input::-webkit-calendar-picker-indicator {
        @apply --paper-input-container-input-webkit-calendar-picker-indicator;
      }

      input::-webkit-input-placeholder {
        color: var(--paper-input-container-color, var(--secondary-text-color));
      }

      input:-moz-placeholder {
        color: var(--paper-input-container-color, var(--secondary-text-color));
      }

      input::-moz-placeholder {
        color: var(--paper-input-container-color, var(--secondary-text-color));
      }

      input::-ms-clear {
        @apply --paper-input-container-ms-clear;
      }

      input::-ms-reveal {
        @apply --paper-input-container-ms-reveal;
      }

      input:-ms-input-placeholder {
        color: var(--paper-input-container-color, var(--secondary-text-color));
      }

      label {
        pointer-events: none;
      }
    </style>

    <paper-input-container id="container" no-label-float="[[noLabelFloat]]" always-float-label="[[_computeAlwaysFloatLabel(alwaysFloatLabel,placeholder)]]" auto-validate$="[[autoValidate]]" disabled$="[[disabled]]" invalid="[[invalid]]">

      <slot name="prefix" slot="prefix"></slot>

      <label hidden$="[[!label]]" aria-hidden="true" for$="[[_inputId]]" slot="label">[[label]]</label>

      <!-- Need to bind maxlength so that the paper-input-char-counter works correctly -->
      <iron-input bind-value="{{value}}" slot="input" class="input-element" id$="[[_inputId]]" maxlength$="[[maxlength]]" allowed-pattern="[[allowedPattern]]" invalid="{{invalid}}" validator="[[validator]]">
        <input aria-labelledby$="[[_ariaLabelledBy]]" aria-describedby$="[[_ariaDescribedBy]]" disabled$="[[disabled]]" title$="[[title]]" type$="[[type]]" pattern$="[[pattern]]" required$="[[required]]" autocomplete$="[[autocomplete]]" autofocus$="[[autofocus]]" inputmode$="[[inputmode]]" minlength$="[[minlength]]" maxlength$="[[maxlength]]" min$="[[min]]" max$="[[max]]" step$="[[step]]" name$="[[name]]" placeholder$="[[placeholder]]" readonly$="[[readonly]]" list$="[[list]]" size$="[[size]]" autocapitalize$="[[autocapitalize]]" autocorrect$="[[autocorrect]]" on-change="_onChange" tabindex$="[[tabIndex]]" autosave$="[[autosave]]" results$="[[results]]" accept$="[[accept]]" multiple$="[[multiple]]" role$="[[inputRole]]" aria-haspopup$="[[inputAriaHaspopup]]">
      </iron-input>

      <slot name="suffix" slot="suffix"></slot>

      <template is="dom-if" if="[[errorMessage]]">
        <paper-input-error aria-live="assertive" slot="add-on">[[errorMessage]]</paper-input-error>
      </template>

      <template is="dom-if" if="[[charCounter]]">
        <paper-input-char-counter slot="add-on"></paper-input-char-counter>
      </template>

    </paper-input-container>
  `,behaviors:[[jh,Lc,ng],eg],properties:{value:{type:String},inputRole:{type:String,value:void 0},inputAriaHaspopup:{type:String,value:void 0}},get _focusableElement(){return this.inputElement._inputElement},listeners:{"iron-input-ready":"_onIronInputReady"},_onIronInputReady:function(){this.$.nativeInput||(this.$.nativeInput=this.$$("input")),this.inputElement&&-1!==this._typesThatHaveText.indexOf(this.$.nativeInput.type)&&(this.alwaysFloatLabel=!0),this.inputElement.bindValue&&this.$.container._handleValueAndAutoValidate(this.inputElement)}});
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ig=ta``;var og,sg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};!function(e){e[e.MOVED=0]="MOVED",e[e.NO_STOPS=1]="NO_STOPS",e[e.CLIPPED=2]="CLIPPED",e[e.ABORTED=3]="ABORTED"}(og||(og={}));let rg=class extends(oo(dr(oa))){constructor(){super(...arguments),this.target=null,this._targetHeight=null,this.index=-1,this.cursorTargetClass=null,this.scrollMode=Ta.NEVER,this.focusOnMove=!1,this.stops=[]}static get template(){return ig}detached(){super.detached(),this.unsetCursor()}next(e={}){return this._moveCursor(1,e)}previous(e={}){return this._moveCursor(-1,e)}moveToVisibleArea(e){if(!this.stops||!this._isIntersectionObserverSupported())return;const t=e?this.stops.filter(e):this.stops,n=this._getWindowDims(),i=Math.round(n.innerHeight/2);let o=null,s=null,r=t.length;const a=new IntersectionObserver(e=>{e.forEach(e=>{if(a.unobserve(e.target),!(e.isIntersecting||e.intersectionRatio>0))return;const t=e.boundingClientRect.top+Math.round(e.boundingClientRect.height/2),n=Math.abs(t-i);(null===s||n<s)&&(o=e.target,s=n)}),r-=e.length,0===r&&o&&this.setCursor(o,!0)});t.forEach(e=>{a.observe(e)})}_isIntersectionObserverSupported(){return"IntersectionObserver"in window}setCursor(e,t){let n;t&&(n=this.scrollMode,this.scrollMode=Ta.NEVER),this.unsetCursor(),this.target=e,this._updateIndex(),this._decorateTarget(),t&&n&&(this.scrollMode=n)}unsetCursor(){this._unDecorateTarget(),this.index=-1,this.target=null,this._targetHeight=null}isAtStart(){return 0===this.index}isAtEnd(){return-1!==this.index&&this.index===this.stops.length-1}moveToStart(){this.stops.length&&this.setCursor(this.stops[0])}moveToEnd(){this.stops.length&&this.setCursor(this.stops[this.stops.length-1])}setCursorAtIndex(e,t){this.setCursor(this.stops[e],t)}_moveCursor(e,{filter:t,abort:n,getTargetHeight:i,clipToTop:o}={}){if(!this.stops.length)return this.unsetCursor(),og.NO_STOPS;let s=this.index;-1===this.index&&e<0&&(s=this.stops.length);let r=!1;do{if(s+=e,e>0&&s>=this.stops.length||e<0&&s<0){s=e<0||o?0:this.stops.length-1,r=!0;break}if(n&&n(this.stops[s]))return s=this.index,og.ABORTED}while(t&&!t(this.stops[s]));return this._unDecorateTarget(),this.index=s,this.target=this.stops[s],this._targetHeight=i?i(this.target):this.target.scrollHeight,this.focusOnMove&&this.target.focus(),this._decorateTarget(),r?og.CLIPPED:og.MOVED}_decorateTarget(){this.target&&this.cursorTargetClass&&this.target.classList.add(this.cursorTargetClass)}_unDecorateTarget(){this.target&&this.cursorTargetClass&&this.target.classList.remove(this.cursorTargetClass)}_updateIndex(){if(!this.target)return void(this.index=-1);const e=Array.prototype.indexOf.call(this.stops,this.target);-1===e?this.unsetCursor():this.index=e}_getTop(e){let t=e.offsetTop;for(let n=e.offsetParent;n;n=n.offsetParent)t+=n.offsetTop;return t}_targetIsVisible(e){const t=this._getWindowDims();return this.scrollMode===Ta.KEEP_VISIBLE&&e>t.pageYOffset&&e<t.pageYOffset+t.innerHeight}_calculateScrollToValue(e,t){return e+-this._getWindowDims().innerHeight/3+t.offsetHeight/2}_scrollToTarget(){if(!this.target||this.scrollMode===Ta.NEVER)return;const e=this._getWindowDims(),t=this._getTop(this.target),n=!this._targetHeight||this._targetIsVisible(t+this._targetHeight),i=this._calculateScrollToValue(t,this.target);this._targetIsVisible(t)&&(n||i<e.scrollY)||window.scrollTo(e.scrollX,i)}_getWindowDims(){return{scrollX:window.scrollX,scrollY:window.scrollY,innerHeight:window.innerHeight,pageYOffset:window.pageYOffset}}};sg([Bl({type:Object,notify:!0})],rg.prototype,"target",void 0),sg([Bl({type:Number})],rg.prototype,"_targetHeight",void 0),sg([Bl({type:Number,notify:!0})],rg.prototype,"index",void 0),sg([Bl({type:String})],rg.prototype,"cursorTargetClass",void 0),sg([Bl({type:String})],rg.prototype,"scrollMode",void 0),sg([Bl({type:Boolean})],rg.prototype,"focusOnMove",void 0),sg([Bl({type:Array})],rg.prototype,"stops",void 0),sg([jl("stops")],rg.prototype,"_updateIndex",null),sg([jl("target")],rg.prototype,"_scrollToTarget",null),rg=sg([Ml("gr-cursor-manager")],rg);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ag=ta`
  <style include="shared-styles">
    :host {
      z-index: 100;
    }
    :host([is-hidden]) {
      display: none;
    }
    ul {
      list-style: none;
    }
    li {
      border-bottom: 1px solid var(--border-color);
      cursor: pointer;
      display: flex;
      justify-content: space-between;
      padding: var(--spacing-m) var(--spacing-l);
    }
    li:last-of-type {
      border: none;
    }
    li:focus {
      outline: none;
    }
    li:hover {
      background-color: var(--hover-background-color);
    }
    li.selected {
      background-color: var(--selection-background-color);
    }
    .dropdown-content {
      background: var(--dropdown-background-color);
      box-shadow: var(--elevation-level-2);
      border-radius: var(--border-radius);
      max-height: 50vh;
      overflow: auto;
    }
    @media only screen and (max-height: 35em) {
      .dropdown-content {
        max-height: 80vh;
      }
    }
    .label {
      color: var(--deemphasized-text-color);
      padding-left: var(--spacing-l);
    }
    .hide {
      display: none;
    }
  </style>
  <div
    class="dropdown-content"
    slot="dropdown-content"
    id="suggestions"
    role="listbox"
  >
    <ul>
      <template is="dom-repeat" items="[[suggestions]]">
        <li
          data-index$="[[index]]"
          data-value$="[[item.dataValue]]"
          tabindex="-1"
          aria-label$="[[item.name]]"
          class="autocompleteOption"
          role="option"
          on-click="_handleClickItem"
        >
          <span>[[item.text]]</span>
          <span class$="label [[_computeLabelClass(item)]]"
            >[[item.label]]</span
          >
        </li>
      </template>
    </ul>
  </div>
  <gr-cursor-manager
    id="cursor"
    index="{{index}}"
    cursor-target-class="selected"
    scroll-mode="never"
    focus-on-move=""
    stops="[[_suggestionEls]]"
  ></gr-cursor-manager>
`;
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */var lg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let cg=class extends((e=>mr([yc],e))(xp(oo(dr(oa))))){constructor(){super(...arguments),this.index=null,this.isHidden=!0,this.verticalOffset=null,this.horizontalOffset=null,this.suggestions=[],this._suggestionEls=[]}static get template(){return ag}get keyBindings(){return{up:"_handleUp",down:"_handleDown",enter:"_handleEnter",esc:"_handleEscape",tab:"_handleTab"}}close(){this.isHidden=!0}open(){this.isHidden=!1,this._resetCursorStops(),this.refit()}getCurrentText(){return this.getCursorTarget().dataset.value}_handleUp(e){this.isHidden||(e.preventDefault(),e.stopPropagation(),this.cursorUp())}_handleDown(e){this.isHidden||(e.preventDefault(),e.stopPropagation(),this.cursorDown())}cursorDown(){this.isHidden||this.$.cursor.next()}cursorUp(){this.isHidden||this.$.cursor.previous()}_handleTab(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("item-selected",{detail:{trigger:"tab",selected:this.$.cursor.target},composed:!0,bubbles:!0}))}_handleEnter(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("item-selected",{detail:{trigger:"enter",selected:this.$.cursor.target},composed:!0,bubbles:!0}))}_handleEscape(){this._fireClose(),this.close()}_handleClickItem(e){e.preventDefault(),e.stopPropagation();let t=e.target;for(;!t.classList.contains("autocompleteOption");){if(!t||t===this)return;t=t.parentElement}this.dispatchEvent(new CustomEvent("item-selected",{detail:{trigger:"click",selected:t},composed:!0,bubbles:!0}))}_fireClose(){this.dispatchEvent(new CustomEvent("dropdown-closed",{composed:!0,bubbles:!0}))}getCursorTarget(){return this.$.cursor.target}_resetCursorStops(){this.suggestions.length>0?this.isHidden||(Mo(),this._suggestionEls=Array.from(this.$.suggestions.querySelectorAll("li")),this._resetCursorIndex()):this._suggestionEls=[]}_resetCursorIndex(){this.$.cursor.setCursorAtIndex(0)}_computeLabelClass(e){return e.label?"":"hide"}};lg([Bl({type:Number})],cg.prototype,"index",void 0),lg([Bl({type:Boolean,reflectToAttribute:!0})],cg.prototype,"isHidden",void 0),lg([Bl({type:Number})],cg.prototype,"verticalOffset",void 0),lg([Bl({type:Number})],cg.prototype,"horizontalOffset",void 0),lg([Bl({type:Array})],cg.prototype,"suggestions",void 0),lg([Bl({type:Array})],cg.prototype,"_suggestionEls",void 0),lg([jl("suggestions")],cg.prototype,"_resetCursorStops",null),cg=lg([Ml("gr-autocomplete-dropdown")],cg);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const dg=ta`
  <style include="shared-styles">
    .searchIcon {
      display: none;
    }
    .searchIcon.showSearchIcon {
      display: inline-block;
    }
    iron-icon {
      margin: 0 var(--spacing-xs);
      vertical-align: top;
    }
    paper-input.borderless {
      border: none;
      padding: 0;
    }
    paper-input {
      background-color: var(--view-background-color);
      color: var(--primary-text-color);
      border: 1px solid var(--border-color);
      border-radius: var(--border-radius);
      padding: var(--spacing-s);
      --paper-input-container: {
        padding: 0;
      }
      --paper-input-container-input: {
        font-size: var(--font-size-normal);
        line-height: var(--line-height-normal);
      }
      /* This is a hack for not being able to set height:0 on the underline
           of a paper-input 2.2.3 element. All the underline fixes below only
           actually work in 3.x.x, so the height must be adjusted directly as
           a workaround until we are on Polymer 3. */
      height: var(--line-height-normal);
      --paper-input-container-underline-height: 0;
      --paper-input-container-underline-wrapper-height: 0;
      --paper-input-container-underline-focus-height: 0;
      --paper-input-container-underline-legacy-height: 0;
      --paper-input-container-underline: {
        height: 0;
        display: none;
      }
      --paper-input-container-underline-focus: {
        height: 0;
        display: none;
      }
      --paper-input-container-underline-disabled: {
        height: 0;
        display: none;
      }
      /* Hide label for input. The label is still visible for
      screen readers. Workaround found at:
      https://github.com/PolymerElements/paper-input/issues/478 */
      --paper-input-container-label: {
        display: none;
      }
    }
    paper-input.warnUncommitted {
      --paper-input-container-input: {
        color: var(--error-text-color);
        font-size: inherit;
      }
    }
  </style>
  <paper-input
    no-label-float=""
    id="input"
    class$="[[_computeClass(borderless)]]"
    disabled$="[[disabled]]"
    value="{{text}}"
    placeholder="[[placeholder]]"
    on-keydown="_handleKeydown"
    on-focus="_onInputFocus"
    on-blur="_onInputBlur"
    autocomplete="off"
    label="[[label]]"
  >
    <!-- prefix as attribute is required to for polymer 1 -->
    <div slot="prefix" prefix="">
      <iron-icon
        icon="gr-icons:search"
        class$="searchIcon [[_computeShowSearchIconClass(showSearchIcon)]]"
      >
      </iron-icon>
    </div>

    <!-- suffix as attribute is required to for polymer 1 -->
    <div slot="suffix" suffix="">
      <slot name="suffix"></slot>
    </div>
  </paper-input>
  <gr-autocomplete-dropdown
    vertical-align="top"
    vertical-offset="[[verticalOffset]]"
    horizontal-align="left"
    id="suggestions"
    on-item-selected="_handleItemSelect"
    on-keydown="_handleKeydown"
    suggestions="[[_suggestions]]"
    role="listbox"
    index="[[_index]]"
    position-target="[[_inputElement]]"
  >
  </gr-autocomplete-dropdown>
`;var hg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const pg=/(?:[^\s"]+|"[^"]*")+/g;let ug=class extends(xp(oo(dr(oa)))){constructor(){super(...arguments),this.query=()=>Promise.resolve([]),this.threshold=1,this.allowNonSuggestedValues=!1,this.borderless=!1,this.disabled=!1,this.showSearchIcon=!1,this.verticalOffset=31,this.text="",this.placeholder="",this.clearOnCommit=!1,this.tabComplete=!1,this.value="",this.multi=!1,this.warnUncommitted=!1,this.noDebounce=!1,this._suggestions=[],this._suggestionEls=[],this._disableSuggestions=!1,this._focused=!1,this.label="",this._selected=null}static get template(){return dg}get _nativeInput(){return this.$.input.$.nativeInput||this.$.input.inputElement}attached(){super.attached(),this.listen(document.body,"click","_handleBodyClick")}detached(){super.detached(),this.unlisten(document.body,"click","_handleBodyClick"),this.cancelDebouncer("update-suggestions")}get focusStart(){return this.$.input}focus(){this._nativeInput.focus()}selectAll(){const e=this._nativeInput;this.$.input.value&&e.setSelectionRange(0,this.$.input.value.length)}clear(){this.text=""}_handleItemSelect(e){"click"===e.detail.trigger&&(this._selected=e.detail.selected,this._commit())}get _inputElement(){return this.$&&this.$.input}setText(e){this._disableSuggestions=!0,this.text=e,this._disableSuggestions=!1}_onInputFocus(){this._focused=!0,this._updateSuggestions(this.text,this.threshold,this.noDebounce),this.$.input.classList.remove("warnUncommitted"),this.updateStyles()}_onInputBlur(){this.$.input.classList.toggle("warnUncommitted",this.warnUncommitted&&!!this.text.length&&!this._focused),this.updateStyles()}_updateSuggestions(e,t,n){if(void 0===e||void 0===t||void 0===n)return;if(this._suggestions=[],this._disableSuggestions)return;if(e.length<t)return void(this.value="");if(!this._focused)return;const i=()=>{this.query(e).then(t=>{if(e===this.text){for(const e of t)e.text=e.name;this._suggestions=t,Mo(),-1===this._index&&(this.value="")}})};n?i():this.debounce("update-suggestions",i,200)}_maybeOpenDropdown(e,t){return e.length>0&&t?this.$.suggestions.open():this.$.suggestions.close()}_computeClass(e){return e?"borderless":""}_handleKeydown(e){switch(this._focused=!0,e.keyCode){case 38:e.preventDefault(),this.$.suggestions.cursorUp();break;case 40:e.preventDefault(),this.$.suggestions.cursorDown();break;case 27:e.preventDefault(),this._cancel();break;case 9:this._suggestions.length>0&&this.tabComplete?(e.preventDefault(),this._handleInputCommit(!0),this.focus()):this._focused=!1;break;case 13:if(this.modifierPressed(e))break;e.preventDefault(),this._handleInputCommit();break;default:this.focus(),this._suggestions=[]}this.dispatchEvent(new CustomEvent("input-keydown",{detail:{keyCode:e.keyCode,input:this.$.input},composed:!0,bubbles:!0}))}_cancel(){this._suggestions.length?this.set("_suggestions",[]):this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!0}))}_handleInputCommit(e){!this.allowNonSuggestedValues&&this.$.suggestions.isHidden||(this._selected=this.$.suggestions.getCursorTarget(),this._commit(e))}_updateValue(e,t){if(!e)return;const n=Number(e.dataset.index);if(isNaN(n))return;const i=t[n].value;if(null!=i)if(this.multi){const e=this.text.match(pg);(null==e?void 0:e.length)&&(e[e.length-1]=i,this.value=e.join(" "))}else this.value=i}_handleBodyClick(e){const t=e.path;if(t){for(let e=0;e<t.length;e++)if(t[e]===this)return;this._focused=!1}}_commit(e){this._suggestions.length>0?this._updateValue(this._selected,this._suggestions):this.value=this.text||"";const t=this.value;if(this.multi)this.setText(this.value);else if(!this.clearOnCommit&&this._selected){const e=this._selected.dataset;if(e){const t=Number(e.index);if(isNaN(t))return;this.setText(this._suggestions[t].name||"")}}else this.clear();this._suggestions=[],e||this.dispatchEvent(new CustomEvent("commit",{detail:{value:t},composed:!0,bubbles:!0}))}_computeShowSearchIconClass(e){return e?"showSearchIcon":""}};hg([Bl({type:Object})],ug.prototype,"query",void 0),hg([Bl({type:Number})],ug.prototype,"threshold",void 0),hg([Bl({type:Boolean})],ug.prototype,"allowNonSuggestedValues",void 0),hg([Bl({type:Boolean})],ug.prototype,"borderless",void 0),hg([Bl({type:Boolean})],ug.prototype,"disabled",void 0),hg([Bl({type:Boolean})],ug.prototype,"showSearchIcon",void 0),hg([Bl({type:Number})],ug.prototype,"verticalOffset",void 0),hg([Bl({type:String,notify:!0})],ug.prototype,"text",void 0),hg([Bl({type:String})],ug.prototype,"placeholder",void 0),hg([Bl({type:Boolean})],ug.prototype,"clearOnCommit",void 0),hg([Bl({type:Boolean})],ug.prototype,"tabComplete",void 0),hg([Bl({type:String,notify:!0})],ug.prototype,"value",void 0),hg([Bl({type:Boolean})],ug.prototype,"multi",void 0),hg([Bl({type:Boolean})],ug.prototype,"warnUncommitted",void 0),hg([Bl({type:Boolean})],ug.prototype,"noDebounce",void 0),hg([Bl({type:Array})],ug.prototype,"_suggestions",void 0),hg([Bl({type:Array})],ug.prototype,"_suggestionEls",void 0),hg([Bl({type:Number})],ug.prototype,"_index",void 0),hg([Bl({type:Boolean})],ug.prototype,"_disableSuggestions",void 0),hg([Bl({type:Boolean})],ug.prototype,"_focused",void 0),hg([Bl({type:String})],ug.prototype,"label",void 0),hg([Bl({type:Object})],ug.prototype,"_selected",void 0),hg([jl("text","threshold","noDebounce")],ug.prototype,"_updateSuggestions",null),hg([jl("_suggestions","_focused")],ug.prototype,"_maybeOpenDropdown",null),ug=hg([Ml("gr-autocomplete")],ug);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const gg=ta`
  <style include="shared-styles">
    .text {
      align-items: center;
      display: flex;
      flex-wrap: wrap;
    }
    .copyText {
      flex-grow: 1;
      margin-right: var(--spacing-s);
    }
    .hideInput {
      display: none;
    }
    input#input {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      @apply --text-container-style;
      width: 100%;
    }
    /*
       * Typically icons are 20px, which is the normal line-height.
       * The copy icon is too prominent at 20px, so we choose 16px
       * here, but add 2x2px padding below, so the entire
       * component should still fit nicely into a normal inline
       * layout flow.
       */
    #icon {
      height: 16px;
      width: 16px;
    }
    gr-button {
      --gr-button: {
        padding: 2px;
      }
    }
  </style>
  <div class="text">
    <iron-input
      class="copyText"
      type="text"
      bind-value="[[text]]"
      on-tap="_handleInputClick"
      readonly=""
    >
      <input
        id="input"
        is="iron-input"
        class$="[[_computeInputClass(hideInput)]]"
        type="text"
        bind-value="[[text]]"
        on-click="_handleInputClick"
        readonly=""
      />
    </iron-input>
    <gr-button
      id="button"
      link=""
      has-tooltip="[[hasTooltip]]"
      class="copyToClipboard"
      title="[[buttonTitle]]"
      on-click="_copyToClipboard"
      aria-label="Click to copy to clipboard"
    >
      <iron-icon id="icon" icon="gr-icons:content-copy"></iron-icon>
    </gr-button>
  </div>
`;var mg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let _g=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasTooltip=!1,this.hideInput=!1}static get template(){return gg}focusOnCopy(){this.$.button.focus()}_computeInputClass(e){return e?"hideInput":""}_handleInputClick(e){e.preventDefault(),qo(e).rootTarget.select()}_copyToClipboard(e){e.preventDefault(),e.stopPropagation(),this.hideInput&&(this.$.input.style.display="block"),this.$.input.focus(),this.$.input.select(),document.execCommand("copy"),this.hideInput&&(this.$.input.style.display="none"),this.$.icon.icon="gr-icons:check",this.async(()=>this.$.icon.icon="gr-icons:content-copy",1e3)}};mg([Bl({type:String})],_g.prototype,"text",void 0),mg([Bl({type:String})],_g.prototype,"buttonTitle",void 0),mg([Bl({type:Boolean})],_g.prototype,"hasTooltip",void 0),mg([Bl({type:Boolean})],_g.prototype,"hideInput",void 0),_g=mg([Ml("gr-copy-clipboard")],_g);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const fg=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-subpage-styles">
    h3.edited:after {
      color: var(--deemphasized-text-color);
      content: ' *';
    }
    .inputUpdateBtn {
      margin-top: var(--spacing-s);
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <main class="gr-form-styles read-only">
    <div id="loading" class$="[[_computeLoadingClass(_loading)]]">
      Loading...
    </div>
    <div id="loadedContent" class$="[[_computeLoadingClass(_loading)]]">
      <h1 id="Title" class="heading-1">[[_groupName]]</h1>
      <h2 id="configurations" class="heading-2">General</h2>
      <div id="form">
        <fieldset>
          <h3 id="groupUUID" class="heading-3">Group UUID</h3>
          <fieldset>
            <gr-copy-clipboard
              id="uuid"
              text="[[_getGroupUUID(_groupConfig.id)]]"
            ></gr-copy-clipboard>
          </fieldset>
          <h3
            id="groupName"
            class$="heading-3 [[_computeHeaderClass(_rename)]]"
          >
            Group Name
          </h3>
          <fieldset>
            <span class="value">
              <gr-autocomplete
                id="groupNameInput"
                text="{{_groupConfig.name}}"
                disabled="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
              ></gr-autocomplete>
            </span>
            <span
              class="value"
              disabled$="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
            >
              <gr-button
                id="inputUpdateNameBtn"
                on-click="_handleSaveName"
                disabled="[[!_rename]]"
              >
                Rename Group</gr-button
              >
            </span>
          </fieldset>
          <h3
            id="groupOwner"
            class$="heading-3 [[_computeHeaderClass(_owner)]]"
          >
            Owners
          </h3>
          <fieldset>
            <span class="value">
              <gr-autocomplete
                id="groupOwnerInput"
                text="{{_groupConfig.owner}}"
                value="{{_groupConfigOwner}}"
                query="[[_query]]"
                disabled="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
              >
              </gr-autocomplete>
            </span>
            <span
              class="value"
              disabled$="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
            >
              <gr-button
                id="inputUpdateOwnerBtn"
                on-click="_handleSaveOwner"
                disabled="[[!_owner]]"
              >
                Change Owners</gr-button
              >
            </span>
          </fieldset>
          <h3 class$="heading-3 [[_computeHeaderClass(_description)]]">
            Description
          </h3>
          <fieldset>
            <div>
              <iron-autogrow-textarea
                class="description"
                autocomplete="on"
                bind-value="{{_groupConfig.description}}"
                disabled="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
              ></iron-autogrow-textarea>
            </div>
            <span
              class="value"
              disabled$="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
            >
              <gr-button
                on-click="_handleSaveDescription"
                disabled="[[!_description]]"
              >
                Save Description
              </gr-button>
            </span>
          </fieldset>
          <h3 id="options" class$="heading-3 [[_computeHeaderClass(_options)]]">
            Group Options
          </h3>
          <fieldset>
            <section>
              <span class="title">
                Make group visible to all registered users
              </span>
              <span class="value">
                <gr-select
                  id="visibleToAll"
                  bind-value="{{_groupConfig.options.visible_to_all}}"
                >
                  <select
                    disabled$="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
                  >
                    <template is="dom-repeat" items="[[_submitTypes]]">
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <span
              class="value"
              disabled$="[[_computeGroupDisabled(_groupOwner, _isAdmin, _groupIsInternal)]]"
            >
              <gr-button on-click="_handleSaveOptions" disabled="[[!_options]]">
                Save Group Options
              </gr-button>
            </span>
          </fieldset>
        </fieldset>
      </div>
    </div>
  </main>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var vg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const yg=/^[\da-f]{40}$/,bg={submitFalse:{value:!1,label:"False"},submitTrue:{value:!0,label:"True"}};let wg=class extends(oo(dr(oa))){constructor(){super(),this._rename=!1,this._groupIsInternal=!1,this._description=!1,this._owner=!1,this._options=!1,this._loading=!0,this._groupOwner=!1,this._submitTypes=Object.values(bg),this._isAdmin=!1,this._query=e=>this._getGroupSuggestions(e)}static get template(){return fg}attached(){super.attached(),this._loadGroup()}_loadGroup(){if(!this.groupId)return;const e=[];return this.$.restAPI.getGroupConfig(this.groupId,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(t=>t&&t.name?(this._groupName=t.name,this._groupIsInternal=!!t.id.match(yg),e.push(this.$.restAPI.getIsAdmin().then(e=>{this._isAdmin=!!e})),e.push(this.$.restAPI.getIsGroupOwner(t.name).then(e=>{this._groupOwner=!!e})),t.options&&!t.options.visible_to_all&&(t.options.visible_to_all=!1),this._groupConfig=t,this.dispatchEvent(new CustomEvent("title-change",{detail:{title:t.name},composed:!0,bubbles:!0})),Promise.all(e).then(()=>{this._loading=!1})):Promise.resolve())}_computeLoadingClass(e){return e?"loading":""}_isLoading(){return this._loading||void 0===this._loading}_handleSaveName(){const e=this._groupConfig;return this.groupId&&e&&e.name?this.$.restAPI.saveGroupName(this.groupId,e.name).then(t=>{200===t.status&&(this._groupName=e.name,this.dispatchEvent(new CustomEvent("name-changed",{detail:{name:e.name,external:!this._groupIsInternal},composed:!0,bubbles:!0})),this._rename=!1)}):Promise.reject(new Error("invalid groupId or config name"))}_handleSaveOwner(){if(!this.groupId||!this._groupConfig)return;let e=this._groupConfig.owner;return this._groupConfigOwner&&(e=decodeURIComponent(this._groupConfigOwner)),e?this.$.restAPI.saveGroupOwner(this.groupId,e).then(()=>{this._owner=!1}):void 0}_handleSaveDescription(){if(this.groupId&&this._groupConfig&&this._groupConfig.description)return this.$.restAPI.saveGroupDescription(this.groupId,this._groupConfig.description).then(()=>{this._description=!1})}_handleSaveOptions(){if(!this.groupId||!this._groupConfig||!this._groupConfig.options)return;const e={visible_to_all:this._groupConfig.options.visible_to_all};return this.$.restAPI.saveGroupOptions(this.groupId,e).then(()=>{this._options=!1})}_handleConfigName(){this._isLoading()||(this._rename=!0)}_handleConfigOwner(){this._isLoading()||(this._owner=!0)}_handleConfigDescription(){this._isLoading()||(this._description=!0)}_handleConfigOptions(){this._isLoading()||(this._options=!0)}_computeHeaderClass(e){return e?"edited":""}_getGroupSuggestions(e){return this.$.restAPI.getSuggestedGroups(e).then(e=>{const t=[];for(const n in e)o(e,n)&&t.push({name:n,value:decodeURIComponent(e[n].id)});return t})}_computeGroupDisabled(e,t,n){return!(n&&(t||e))}_getGroupUUID(e){if(e)return e.match(yg)?e:decodeURIComponent(e)}};vg([Bl({type:String})],wg.prototype,"groupId",void 0),vg([Bl({type:Boolean})],wg.prototype,"_rename",void 0),vg([Bl({type:Boolean})],wg.prototype,"_groupIsInternal",void 0),vg([Bl({type:Boolean})],wg.prototype,"_description",void 0),vg([Bl({type:Boolean})],wg.prototype,"_owner",void 0),vg([Bl({type:Boolean})],wg.prototype,"_options",void 0),vg([Bl({type:Boolean})],wg.prototype,"_loading",void 0),vg([Bl({type:Object})],wg.prototype,"_groupConfig",void 0),vg([Bl({type:String})],wg.prototype,"_groupConfigOwner",void 0),vg([Bl({type:Object})],wg.prototype,"_groupName",void 0),vg([Bl({type:Boolean})],wg.prototype,"_groupOwner",void 0),vg([Bl({type:Array})],wg.prototype,"_submitTypes",void 0),vg([Bl({type:Object})],wg.prototype,"_query",void 0),vg([Bl({type:Boolean})],wg.prototype,"_isAdmin",void 0),vg([jl("_groupConfig.name")],wg.prototype,"_handleConfigName",null),vg([jl("_groupConfig.owner","_groupConfigOwner")],wg.prototype,"_handleConfigOwner",null),vg([jl("_groupConfig.description")],wg.prototype,"_handleConfigDescription",null),vg([jl("_groupConfig.options.visible_to_all")],wg.prototype,"_handleConfigOptions",null),wg=vg([Ml("gr-group")],wg);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Cg=ta`
  <style include="shared-styles">
    :host {
      display: inline-block;
      border-radius: 50%;
      background-size: cover;
      background-color: var(--avatar-background-color, #f1f2f3);
    }
  </style>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Eg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Sg=class extends(oo(dr(oa))){constructor(){super(...arguments),this.imageSize=16,this._hasAvatars=!1}static get template(){return Cg}attached(){super.attached(),Promise.all([this._getConfig(),eh().awaitPluginsLoaded()]).then(([e])=>{this._hasAvatars=!!(e&&e.plugin&&e.plugin.has_avatars),this._updateAvatarURL()})}_getConfig(){return this.$.restAPI.getConfig()}_accountChanged(){this._updateAvatarURL()}_updateAvatarURL(){if(!this._hasAvatars||!this.account)return void(this.hidden=!0);this.hidden=!1;const e=this._buildAvatarURL(this.account);e&&(this.style.backgroundImage='url("'+e+'")')}_getAccounts(e){return e._account_id||e.email||e.username||e.name}_buildAvatarURL(e){if(!e)return"";const t=e.avatars||[];for(let e=0;e<t.length;e++)if(t[e].height===this.imageSize)return t[e].url;return this._getAccounts(e)?`${j()}/accounts/`+encodeURIComponent(`${this._getAccounts(e)}`)+`/avatar?s=${this.imageSize}`:""}};Eg([Bl({type:Object,observer:"_accountChanged"})],Sg.prototype,"account",void 0),Eg([Bl({type:Number})],Sg.prototype,"imageSize",void 0),Eg([Bl({type:Boolean})],Sg.prototype,"_hasAvatars",void 0),Sg=Eg([Ml("gr-avatar")],Sg);var Ag=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const xg=Me(e=>{class t extends e{constructor(){super(...arguments),this._target=null,this._isShowing=!1,this.offset=14,this.position="right",this.container=null,this.containerId="gr-hovercard-container",this._hideDebouncer=null,this._showDebouncer=null}attached(){super.attached(),this._target||(this._target=this.target),this.listen(this._target,"mouseenter","debounceShow"),this.listen(this._target,"focus","debounceShow"),this.listen(this._target,"mouseleave","debounceHide"),this.listen(this._target,"blur","debounceHide"),this.listen(this._target,"click","hide"),this.listen(this,"mouseenter","show"),this.listen(this,"mouseenter","lock"),this.listen(this,"mouseleave","hide"),this.listen(this,"mouseleave","unlock")}detached(){super.detached(),this.unlock()}ready(){super.ready(),this.container=mh().querySelector("#"+this.containerId),this.container||(this.container=document.createElement("div"),this.container.setAttribute("id",this.containerId),mh().appendChild(this.container))}removeListeners(){this.unlisten(this._target,"mouseenter","debounceShow"),this.unlisten(this._target,"focus","debounceShow"),this.unlisten(this._target,"mouseleave","debounceHide"),this.unlisten(this._target,"blur","debounceHide"),this.unlisten(this._target,"click","hide")}debounceHide(){this.cancelShowDebouncer(),this._isShowing&&!this._isScheduledToHide&&(this._isScheduledToHide=!0,this._hideDebouncer=si.debounce(this._hideDebouncer,Gt.after(500),()=>{this._isScheduledToHide&&this.hide()}))}cancelHideDebouncer(){this._hideDebouncer&&(this._hideDebouncer.cancel(),this._isScheduledToHide=!1)}dispatchEventThroughTarget(e,t){t||(t={}),this._target&&this._target.dispatchEvent(new CustomEvent(e,{detail:t,bubbles:!0,composed:!0}))}get target(){const e=this.parentNode,t=this.getRootNode();let n;return n=this.for?t.querySelector("#"+this.for):e&&e.nodeType!==Node.DOCUMENT_FRAGMENT_NODE?e:t.host,n}unlock(){Gc(this)}hide(e){var t;this.cancelHideDebouncer(),this.cancelShowDebouncer(),this._isShowing&&(e&&(e.relatedTarget===this||e.target===this&&e.relatedTarget===this._target)||(this._isShowing=!1,this.classList.remove("hovered"),this.style.cssText="",this.$.container.setAttribute("tabindex","-1"),(null===(t=this.container)||void 0===t?void 0:t.contains(this))&&this.container.removeChild(this)))}debounceShow(){this.debounceShowBy(550)}debounceShowBy(e){this.cancelHideDebouncer(),this._isShowing||this._isScheduledToShow||(this._isScheduledToShow=!0,this._showDebouncer=si.debounce(this._showDebouncer,Gt.after(e),()=>{this._isScheduledToShow&&this.show()}))}cancelShowDebouncer(){this._showDebouncer&&(this._showDebouncer.cancel(),this._isScheduledToShow=!1)}lock(){Uc(this)}show(){this.cancelHideDebouncer(),this.cancelShowDebouncer(),!this._isShowing&&this.container&&(this._isShowing=!0,this.setAttribute("tabindex","0"),this.container.appendChild(this),this.classList.add("hide"),this.classList.add("hovered"),Mo(),this.updatePosition(),this.classList.remove("hide"))}updatePosition(){const e=new Set([this.position,"right","bottom-right","top-right","bottom","top","bottom-left","top-left","left"]);for(const t of e)if(this.updatePositionTo(t),this._isInsideViewport())return;console.warn("Could not find a visible position for the hovercard.")}_isInsideViewport(){const e=this.getBoundingClientRect();if(e.top<0)return!1;if(e.left<0)return!1;const t=document.documentElement.getBoundingClientRect();return!(e.bottom>t.height)&&!(e.right>t.width)}updatePositionTo(e){if(!this._target)return;this.style.cssText="";const t=document.documentElement.getBoundingClientRect(),n=this._target.getBoundingClientRect(),i=this.getBoundingClientRect(),o=n.left-t.left,s=n.top-t.top;let r,a;switch(e){case"top":r=o+(n.width-i.width)/2,a=s-i.height-this.offset;break;case"bottom":r=o+(n.width-i.width)/2,a=s+n.height+this.offset;break;case"left":r=o-i.width-this.offset,a=s+(n.height-i.height)/2;break;case"right":r=o+n.width+this.offset,a=s+(n.height-i.height)/2;break;case"bottom-right":r=o+n.width+this.offset,a=s;break;case"bottom-left":r=o-i.width-this.offset,a=s;break;case"top-left":r=o-i.width-this.offset,a=s+n.height-i.height;break;case"top-right":r=o+n.width+this.offset,a=s+n.height-i.height}this.style.left=`${r}px`,this.style.top=`${a}px`}_forChanged(){this._target=this.target}}return Ag([Bl({type:Object})],t.prototype,"_target",void 0),Ag([Bl({type:Boolean})],t.prototype,"_isShowing",void 0),Ag([Bl({type:String})],t.prototype,"for",void 0),Ag([Bl({type:Number})],t.prototype,"offset",void 0),Ag([Bl({type:String})],t.prototype,"position",void 0),Ag([Bl({type:Object})],t.prototype,"container",void 0),Ag([Bl({type:String})],t.prototype,"containerId",void 0),Ag([jl("for")],t.prototype,"_forChanged",null),t}),Pg=document.createElement("dom-module");Pg.innerHTML='<template>\n    <style include="shared-styles">\n      :host {\n        position: absolute;\n        display: none;\n        z-index: 200;\n        max-width: 600px;\n        outline: none;\n      }\n      :host(.hovered) {\n        display: block;\n      }\n      :host(.hide) {\n        visibility: hidden;\n      }\n      /* You have to use a <div class="container"> in your hovercard in order\n         to pick up this consistent styling. */\n      #container {\n        background: var(--dialog-background-color);\n        border: 1px solid var(--border-color);\n        border-radius: var(--border-radius);\n        box-shadow: var(--elevation-level-5);\n      }\n    </style>\n  </template>',Pg.register("gr-hovercard-shared-style");
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Rg=ta`
  <style include="gr-hovercard-shared-style">
    .top,
    .attention,
    .status,
    .voteable {
      padding: var(--spacing-s) var(--spacing-l);
    }
    .top {
      display: flex;
      padding-top: var(--spacing-xl);
      min-width: 300px;
    }
    gr-avatar {
      height: 48px;
      width: 48px;
      margin-right: var(--spacing-l);
    }
    .title,
    .email {
      color: var(--deemphasized-text-color);
    }
    .action {
      border-top: 1px solid var(--border-color);
      padding: var(--spacing-s) var(--spacing-l);
      --gr-button: {
        padding: var(--spacing-s) var(--spacing-m);
      }
    }
    .attention {
      background-color: var(--emphasis-color);
    }
    .attention a {
      text-decoration: none;
    }
    iron-icon {
      vertical-align: top;
    }
    .status iron-icon {
      width: 14px;
      height: 14px;
      position: relative;
      top: 2px;
    }
    iron-icon.attentionIcon {
      width: 14px;
      height: 14px;
      position: relative;
      top: 3px;
    }
    .reason {
      padding-top: var(--spacing-s);
    }
  </style>
  <div id="container" role="tooltip" tabindex="-1">
    <template is="dom-if" if="[[_isShowing]]">
      <div class="top">
        <div class="avatar">
          <gr-avatar account="[[account]]" image-size="56"></gr-avatar>
        </div>
        <div class="account">
          <h3 class="name heading-3">[[account.name]]</h3>
          <div class="email">[[account.email]]</div>
        </div>
      </div>
      <template is="dom-if" if="[[account.status]]">
        <div class="status">
          <span class="title">
            <iron-icon icon="gr-icons:calendar"></iron-icon>
            Status:
          </span>
          <span class="value">[[account.status]]</span>
        </div>
      </template>
      <template is="dom-if" if="[[voteableText]]">
        <div class="voteable">
          <span class="title">Voteable:</span>
          <span class="value">[[voteableText]]</span>
        </div>
      </template>
      <template
        is="dom-if"
        if="[[_computeShowLabelNeedsAttention(_config, highlightAttention, account, change)]]"
      >
        <div class="attention">
          <div>
            <iron-icon
              class="attentionIcon"
              icon="gr-icons:attention"
            ></iron-icon>
            <span>
              [[_computeText(account, _selfAccount)]] turn to take action.
            </span>
            <a
              href="https://bugs.chromium.org/p/gerrit/issues/entry?template=Attention+Set"
              target="_blank"
            >
              <iron-icon
                icon="gr-icons:bug"
                title="report a problem"
              ></iron-icon>
            </a>
            <a
              href="https://gerrit-review.googlesource.com/Documentation/user-attention-set.html"
              target="_blank"
            >
              <iron-icon
                icon="gr-icons:help-outline"
                title="read documentation"
              ></iron-icon>
            </a>
          </div>
          <div class="reason">
            <span class="title">Reason:</span>
            <span class="value">[[_computeReason(change)]]</span>
            <template is="dom-if" if="[[_computeLastUpdate(change)]]">
              (<gr-date-formatter
                has-tooltip
                date-str="[[_computeLastUpdate(change)]]"
              ></gr-date-formatter
              >)
            </template>
          </div>
        </div>
      </template>
      <template
        is="dom-if"
        if="[[_computeShowActionAddToAttentionSet(_config, highlightAttention, account, change)]]"
      >
        <div class="action">
          <gr-button
            class="addToAttentionSet"
            link=""
            no-uppercase=""
            on-click="_handleClickAddToAttentionSet"
          >
            Add to attention set
          </gr-button>
        </div>
      </template>
      <template
        is="dom-if"
        if="[[_computeShowActionRemoveFromAttentionSet(_config, highlightAttention, account, change)]]"
      >
        <div class="action">
          <gr-button
            class="removeFromAttentionSet"
            link=""
            no-uppercase=""
            on-click="_handleClickRemoveFromAttentionSet"
          >
            Remove from attention set
          </gr-button>
        </div>
      </template>
    </template>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var Tg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Ig=class extends(oo(xg(dr(oa)))){constructor(){super(),this.highlightAttention=!1,this.reporting=n.reportingService}static get template(){return Rg}attached(){super.attached(),this.$.restAPI.getConfig().then(e=>{this._config=e}),this.$.restAPI.getAccount().then(e=>{this._selfAccount=e})}_computeText(e,t){return e&&t?e._account_id===t._account_id?"Your":"Their":""}get isAttentionSetEnabled(){return!(!this._config||!this._config.change||!this._config.change.enable_attention_set||!this.highlightAttention||!this.change||!this.account||pc(this.account))}get hasAttention(){var e;return!!(this.isAttentionSetEnabled&&(null===(e=this.change)||void 0===e?void 0:e.attention_set)&&this.account._account_id)&&o(this.change.attention_set,this.account._account_id)}_computeReason(e){if(!e||!e.attention_set||!this.account._account_id)return"";const t=e.attention_set[this.account._account_id];return t&&t.reason?t.reason:""}_computeLastUpdate(e){if(!e||!e.attention_set||!this.account._account_id)return"";const t=e.attention_set[this.account._account_id];return t&&t.last_update?t.last_update:""}_computeShowLabelNeedsAttention(){return this.isAttentionSetEnabled&&this.hasAttention}_computeShowActionAddToAttentionSet(){return this.isAttentionSetEnabled&&!this.hasAttention}_computeShowActionRemoveFromAttentionSet(){return this.isAttentionSetEnabled&&this.hasAttention}_handleClickAddToAttentionSet(){if(!this.change||!this.account._account_id)return;this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Saving attention set update ...",dismissOnNavigation:!0},composed:!0,bubbles:!0}));const e=`Added by ${sl(this._config,this._selfAccount)} using the hovercard menu`;this.change.attention_set||(this.change.attention_set={}),this.change.attention_set[this.account._account_id]={account:this.account,reason:e},this.dispatchEventThroughTarget("attention-set-updated"),this.reporting.reportInteraction("attention-hovercard-add",this._reportingDetails()),this.$.restAPI.addToAttentionSet(this.change._number,this.account._account_id,e).then(()=>{this.dispatchEventThroughTarget("hide-alert")}),this.hide()}_handleClickRemoveFromAttentionSet(){if(!this.change||!this.account._account_id)return;this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Saving attention set update ...",dismissOnNavigation:!0},composed:!0,bubbles:!0}));const e=`Removed by ${sl(this._config,this._selfAccount)} using the hovercard menu`;this.change.attention_set&&delete this.change.attention_set[this.account._account_id],this.dispatchEventThroughTarget("attention-set-updated"),this.reporting.reportInteraction("attention-hovercard-remove",this._reportingDetails()),this.$.restAPI.removeFromAttentionSet(this.change._number,this.account._account_id,e).then(()=>{this.dispatchEventThroughTarget("hide-alert")}),this.hide()}_reportingDetails(){const e=this.account._account_id,t=this.change&&this.change.owner&&this.change.owner._account_id||-1,n=this._selfAccount&&this._selfAccount._account_id||-1,i=(this.change&&this.change.reviewers&&this.change.reviewers.REVIEWER?[...this.change.reviewers.REVIEWER]:[]).map(e=>e._account_id).filter(e=>e!==t);return{actionByOwner:n===t,actionByReviewer:-1!==n&&i.includes(n),targetIsOwner:e===t,targetIsReviewer:i.includes(e),targetIsSelf:e===n}}};Tg([Bl({type:Object})],Ig.prototype,"account",void 0),Tg([Bl({type:Object})],Ig.prototype,"_selfAccount",void 0),Tg([Bl({type:Object})],Ig.prototype,"change",void 0),Tg([Bl({type:String})],Ig.prototype,"voteableText",void 0),Tg([Bl({type:Boolean})],Ig.prototype,"highlightAttention",void 0),Tg([Bl({type:Object})],Ig.prototype,"_config",void 0),Ig=Tg([Ml("gr-hovercard-account")],Ig);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const kg=ta`
  <style include="shared-styles">
    :host {
      display: inline-block;
      vertical-align: top;
      position: relative;
      border-radius: var(--label-border-radius);
      max-width: var(--account-max-length, 200px);
      box-sizing: border-box;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      padding: 0 var(--account-label-padding-horizontal, 0);
    }
    /* If the first element is the avatar, then we cancel the left padding, so
       we can fit nicely into the gr-account-chip rounding.
       The obvious alternative of 'chip has padding' and 'avatar gets negative
       margin' does not work, because we need 'overflow:hidden' on the label. */
    :host([cancel-left-padding]) {
      padding-left: 0;
    }
    :host::after {
      content: var(--account-label-suffix);
    }
    :host([deselected]) {
      background-color: var(--background-color-primary);
      border: 1px solid var(--comment-separator-color);
      border-radius: 8px;
      color: var(--deemphasized-text-color);
    }
    :host([selected]) {
      background-color: var(--chip-selected-background-color);
      border: 1px solid var(--chip-selected-background-color);
      border-radius: 8px;
      color: var(--chip-selected-text-color);
    }
    :host([selected]) iron-icon.attention {
      color: var(--chip-selected-text-color);
    }
    gr-avatar {
      height: calc(var(--line-height-normal) - 2px);
      width: calc(var(--line-height-normal) - 2px);
      vertical-align: top;
      position: relative;
      top: 1px;
    }
    .text {
      @apply --gr-account-label-text-style;
    }
    .text:hover {
      @apply --gr-account-label-text-hover-style;
    }
    #attentionButton {
      /* This negates the 4px horizontal padding, which we appreciate as a
         larger click target, but which we don't want to consume space. :-) */
      margin: 0 -4px 0 -4px;
      vertical-align: top;
    }
    iron-icon.attention {
      width: 12px;
      height: 12px;
    }
    iron-icon.status {
      width: 14px;
      height: 14px;
      vertical-align: top;
      position: relative;
      top: 2px;
    }
  </style>
  <span>
    <template is="dom-if" if="[[!hideHovercard]]">
      <gr-hovercard-account
        for="hovercardTarget"
        account="[[account]]"
        change="[[change]]"
        highlight-attention="[[highlightAttention]]"
        voteable-text="[[voteableText]]"
      >
      </gr-hovercard-account>
    </template>
    <template
      is="dom-if"
      if="[[_hasAttention(_config, highlightAttention, account, change, forceAttention)]]"
    >
      <gr-button
        id="attentionButton"
        link=""
        aria-label="Remove user from attention set"
        on-click="_handleRemoveAttentionClick"
        disabled="[[!_hasUnforcedAttention(_config, highlightAttention, account, change)]]"
        has-tooltip="[[_hasUnforcedAttention(_config, highlightAttention, account, change)]]"
        title="[[_computeAttentionIconTitle(_config, highlightAttention, account, change)]]"
        ><iron-icon class="attention" icon="gr-icons:attention"></iron-icon>
      </gr-button>
    </template>
  </span>
  <span id="hovercardTarget">
    <template is="dom-if" if="[[!hideAvatar]]">
      <gr-avatar account="[[account]]" image-size="32"></gr-avatar>
    </template>
    <span class="text">
      <span class="name">[[_computeName(account, _config, firstName)]]</span>
      <template is="dom-if" if="[[!hideStatus]]">
        <template is="dom-if" if="[[account.status]]">
          <iron-icon class="status" icon="gr-icons:calendar"></iron-icon>
        </template>
      </template>
    </span>
  </span>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Og=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Ng=class extends(oo(dr(oa))){constructor(){super(),this.forceAttention=!1,this.firstName=!1,this.highlightAttention=!1,this.hideHovercard=!1,this.hideAvatar=!1,this.cancelLeftPadding=!1,this.hideStatus=!1,this.reporting=n.reportingService}static get template(){return kg}ready(){super.ready(),this.$.restAPI.getConfig().then(e=>{this._config=e}),this.$.restAPI.getAccount().then(e=>{this._selfAccount=e}),this.addEventListener("attention-set-updated",()=>{this.change={...this.change}})}_isAttentionSetEnabled(e,t,n,i){return!(!e||!e.change||!e.change.enable_attention_set||!t||!i||!n||pc(n))}_computeCancelLeftPadding(e,t,n,i,o,s){return!e&&!this._hasAttention(t,n,i,o,s)}_hasAttention(e,t,n,i,o){return o||this._hasUnforcedAttention(e,t,n,i)}_hasUnforcedAttention(e,t,n,i){return this._isAttentionSetEnabled(e,t,n,i)&&i.attention_set&&!!n._account_id&&o(i.attention_set,n._account_id)}_computeName(e,t,n){return sl(t,e,n)}_handleRemoveAttentionClick(e){if(e.preventDefault(),e.stopPropagation(),!this.account._account_id)return;this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Saving attention set update ...",dismissOnNavigation:!0},composed:!0,bubbles:!0}));const t=`Removed by ${sl(this._config,this._selfAccount)} by clicking the attention icon`;this.change.attention_set&&delete this.change.attention_set[this.account._account_id],this.change={...this.change},this.reporting.reportInteraction("attention-icon-remove",this._reportingDetails()),this.$.restAPI.removeFromAttentionSet(this.change._number,this.account._account_id,t).then(()=>{this.dispatchEvent(new CustomEvent("hide-alert",{bubbles:!0,composed:!0}))})}_reportingDetails(){var e;const t=this.account._account_id,n=this.change&&this.change.owner&&this.change.owner._account_id||-1,i=(null===(e=this._selfAccount)||void 0===e?void 0:e._account_id)||-1,o=(this.change&&this.change.reviewers&&this.change.reviewers.REVIEWER?[...this.change.reviewers.REVIEWER]:[]).map(e=>e._account_id).filter(e=>e!==n);return{actionByOwner:i===n,actionByReviewer:-1!==i&&o.includes(i),targetIsOwner:t===n,targetIsReviewer:o.includes(t),targetIsSelf:t===i}}_computeAttentionIconTitle(e,t,n,i){return this._hasUnforcedAttention(e,t,n,i)?"Click to remove the user from the attention set":'Disabled. Use "Modify" to make changes.'}};Og([Bl({type:Object})],Ng.prototype,"account",void 0),Og([Bl({type:Object})],Ng.prototype,"_selfAccount",void 0),Og([Bl({type:Object})],Ng.prototype,"change",void 0),Og([Bl({type:String})],Ng.prototype,"voteableText",void 0),Og([Bl({type:Boolean})],Ng.prototype,"forceAttention",void 0),Og([Bl({type:Boolean})],Ng.prototype,"firstName",void 0),Og([Bl({type:Boolean})],Ng.prototype,"highlightAttention",void 0),Og([Bl({type:Boolean})],Ng.prototype,"hideHovercard",void 0),Og([Bl({type:Boolean})],Ng.prototype,"hideAvatar",void 0),Og([Bl({type:Boolean,reflectToAttribute:!0,computed:"_computeCancelLeftPadding(hideAvatar, _config, highlightAttention, account, change, forceAttention)"})],Ng.prototype,"cancelLeftPadding",void 0),Og([Bl({type:Boolean})],Ng.prototype,"hideStatus",void 0),Og([Bl({type:Object})],Ng.prototype,"_config",void 0),Ng=Og([Ml("gr-account-label")],Ng);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Lg=ta`
  <style include="shared-styles">
    :host {
      display: inline-block;
      vertical-align: top;
    }
    a {
      color: var(--primary-text-color);
      text-decoration: none;
    }
    gr-account-label {
      --gr-account-label-text-hover-style: {
        text-decoration: underline;
      }
    }
  </style>
  <span>
    <a href$="[[_computeOwnerLink(account)]]">
      <gr-account-label
        account="[[account]]"
        change="[[change]]"
        force-attention="[[forceAttention]]"
        highlight-attention="[[highlightAttention]]"
        hide-avatar="[[hideAvatar]]"
        hide-status="[[hideStatus]]"
        first-name="[[firstName]]"
        voteable-text="[[voteableText]]"
      >
      </gr-account-label>
    </a>
  </span>
`
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var Dg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let $g=class extends(oo(dr(oa))){constructor(){super(...arguments),this.forceAttention=!1,this.highlightAttention=!1,this.hideAvatar=!1,this.hideStatus=!1,this.firstName=!1}static get template(){return Lg}_computeOwnerLink(e){if(e)return gh.getUrlForOwner(e.email||e.username||e.name||`${e._account_id}`)}};Dg([Bl({type:String})],$g.prototype,"voteableText",void 0),Dg([Bl({type:Object})],$g.prototype,"account",void 0),Dg([Bl({type:Object})],$g.prototype,"change",void 0),Dg([Bl({type:Boolean})],$g.prototype,"forceAttention",void 0),Dg([Bl({type:Boolean})],$g.prototype,"highlightAttention",void 0),Dg([Bl({type:Boolean})],$g.prototype,"hideAvatar",void 0),Dg([Bl({type:Boolean})],$g.prototype,"hideStatus",void 0),Dg([Bl({type:Boolean})],$g.prototype,"firstName",void 0),$g=Dg([Ml("gr-account-link")],$g);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Mg=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-table-styles">
    /* GenericList style centers the last column, but we don't want that here. */
    .genericList tr th:last-of-type,
    .genericList tr td:last-of-type {
      text-align: left;
    }
  </style>
  <table id="list" class="genericList">
    <tbody>
      <tr class="headerRow">
        <th class="date topHeader">Date</th>
        <th class="type topHeader">Type</th>
        <th class="member topHeader">Member</th>
        <th class="by-user topHeader">By User</th>
      </tr>
      <tr id="loading" class$="loadingMsg [[computeLoadingClass(_loading)]]">
        <td>Loading...</td>
      </tr>
    </tbody>
    <tbody class$="[[computeLoadingClass(_loading)]]">
      <template is="dom-repeat" items="[[_auditLog]]">
        <tr class="table">
          <td class="date">
            <gr-date-formatter has-tooltip="" date-str="[[item.date]]">
            </gr-date-formatter>
          </td>
          <td class="type">[[itemType(item.type)]]</td>
          <td class="member">
            <template is="dom-if" if="[[_isGroupEvent(item.type)]]">
              <a href$="[[_computeGroupUrl(item.member)]]">
                [[_getNameForGroup(item.member)]]
              </a>
            </template>
            <template is="dom-if" if="[[!_isGroupEvent(item.type)]]">
              <gr-account-link account="[[item.member]]"></gr-account-link>
              [[_getIdForUser(item.member)]]
            </template>
          </td>
          <td class="by-user">
            <gr-account-link account="[[item.user]]"></gr-account-link>
            [[_getIdForUser(item.user)]]
          </td>
        </tr>
      </template>
    </tbody>
  </table>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var Fg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Bg=["ADD_GROUP","REMOVE_GROUP"];let jg=class extends(Ku(oo(dr(oa)))){constructor(){super(...arguments),this._loading=!0}static get template(){return Mg}attached(){super.attached(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Audit Log"},composed:!0,bubbles:!0}))}ready(){super.ready(),this._getAuditLogs()}_getAuditLogs(){if(!this.groupId)return"";return this.$.restAPI.getGroupAuditLog(this.groupId,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(e=>{e?(this._auditLog=e,this._loading=!1):this._auditLog=[]})}itemType(e){let t;switch(e){case"ADD_GROUP":case"ADD_USER":t="Added";break;case"REMOVE_GROUP":case"REMOVE_USER":t="Removed";break;default:t=""}return t}_isGroupEvent(e){return-1!==Bg.indexOf(e)}_computeGroupUrl(e){return e&&e.url&&e.id?gh.getUrlForGroup(e.id):""}_getIdForUser(e){return e._account_id?` (${e._account_id})`:""}_getNameForGroup(e){return e&&e.name?e.name:e&&e.id?decodeURIComponent(e.id):""}};Fg([Bl({type:String})],jg.prototype,"groupId",void 0),Fg([Bl({type:Array})],jg.prototype,"_auditLog",void 0),Fg([Bl({type:Boolean})],jg.prototype,"_loading",void 0),jg=Fg([Ml("gr-group-audit-log")],jg);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Hg=ta`
  <style include="shared-styles">
    :host {
      display: block;
      width: 30em;
    }
  </style>
  <gr-dialog
    confirm-label="Delete [[_computeItemName(itemType)]]"
    confirm-on-enter=""
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">
      [[_computeItemName(itemType)]] Deletion
    </div>
    <div class="main" slot="main">
      <label for="branchInput">
        Do you really want to delete the following
        [[_computeItemName(itemType)]]?
      </label>
      <div>
        [[item]]
      </div>
    </div>
  </gr-dialog>
`;var Ug,Gg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};!function(e){e.BRANCHES="branches",e.ID="id",e.TAGS="tags"}(Ug||(Ug={}));let Vg=class extends(oo(dr(oa))){static get template(){return Hg}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{composed:!0,bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}_computeItemName(e){return e===Ug.BRANCHES?"Branch":e===Ug.TAGS?"Tag":e===Ug.ID?"ID":""}};Gg([Bl({type:String})],Vg.prototype,"item",void 0),Gg([Bl({type:String})],Vg.prototype,"itemType",void 0),Vg=Gg([Ml("gr-confirm-delete-item-dialog")],Vg);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const zg=ta`
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-table-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-subpage-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="shared-styles">
    .input {
      width: 15em;
    }
    gr-autocomplete {
      width: 20em;
    }
    a {
      color: var(--primary-text-color);
      text-decoration: none;
    }
    a:hover {
      text-decoration: underline;
    }
    th {
      border-bottom: 1px solid var(--border-color);
      font-weight: var(--font-weight-bold);
      text-align: left;
    }
    .canModify #groupMemberSearchInput,
    .canModify #saveGroupMember,
    .canModify .deleteHeader,
    .canModify .deleteColumn,
    .canModify #includedGroupSearchInput,
    .canModify #saveIncludedGroups,
    .canModify .deleteIncludedHeader,
    .canModify #saveIncludedGroups {
      display: none;
    }
  </style>
  <main
    class$="gr-form-styles [[_computeHideItemClass(_groupOwner, _isAdmin)]]"
  >
    <div id="loading" class$="[[_computeLoadingClass(_loading)]]">
      Loading...
    </div>
    <div id="loadedContent" class$="[[_computeLoadingClass(_loading)]]">
      <h1 id="Title" class="heading-1">[[_groupName]]</h1>
      <div id="form">
        <h3 id="members" class="heading-3">Members</h3>
        <fieldset>
          <span class="value">
            <gr-autocomplete
              id="groupMemberSearchInput"
              text="{{_groupMemberSearchName}}"
              value="{{_groupMemberSearchId}}"
              query="[[_queryMembers]]"
              placeholder="Name Or Email"
            >
            </gr-autocomplete>
          </span>
          <gr-button
            id="saveGroupMember"
            on-click="_handleSavingGroupMember"
            disabled="[[!_groupMemberSearchId]]"
          >
            Add
          </gr-button>
          <table id="groupMembers">
            <tbody>
              <tr class="headerRow">
                <th class="nameHeader">Name</th>
                <th class="emailAddressHeader">Email Address</th>
                <th class="deleteHeader">Delete Member</th>
              </tr>
            </tbody>
            <tbody>
              <template is="dom-repeat" items="[[_groupMembers]]">
                <tr>
                  <td class="nameColumn">
                    <gr-account-link account="[[item]]"></gr-account-link>
                  </td>
                  <td>[[item.email]]</td>
                  <td class="deleteColumn">
                    <gr-button
                      class="deleteMembersButton"
                      on-click="_handleDeleteMember"
                    >
                      Delete
                    </gr-button>
                  </td>
                </tr>
              </template>
            </tbody>
          </table>
        </fieldset>
        <h3 id="includedGroups" class="heading-3">Included Groups</h3>
        <fieldset>
          <span class="value">
            <gr-autocomplete
              id="includedGroupSearchInput"
              text="{{_includedGroupSearchName}}"
              value="{{_includedGroupSearchId}}"
              query="[[_queryIncludedGroup]]"
              placeholder="Group Name"
            >
            </gr-autocomplete>
          </span>
          <gr-button
            id="saveIncludedGroups"
            on-click="_handleSavingIncludedGroups"
            disabled="[[!_includedGroupSearchId]]"
          >
            Add
          </gr-button>
          <table id="includedGroups">
            <tbody>
              <tr class="headerRow">
                <th class="groupNameHeader">Group Name</th>
                <th class="descriptionHeader">Description</th>
                <th class="deleteIncludedHeader">
                  Delete Group
                </th>
              </tr>
            </tbody>
            <tbody>
              <template is="dom-repeat" items="[[_includedGroups]]">
                <tr>
                  <td class="nameColumn">
                    <template is="dom-if" if="[[item.url]]">
                      <a href$="[[_computeGroupUrl(item.url)]]" rel="noopener">
                        [[item.name]]
                      </a>
                    </template>
                    <template is="dom-if" if="[[!item.url]]">
                      [[item.name]]
                    </template>
                  </td>
                  <td>[[item.description]]</td>
                  <td class="deleteColumn">
                    <gr-button
                      class="deleteIncludedGroupButton"
                      on-click="_handleDeleteIncludedGroup"
                    >
                      Delete
                    </gr-button>
                  </td>
                </tr>
              </template>
            </tbody>
          </table>
        </fieldset>
      </div>
    </div>
  </main>
  <gr-overlay id="overlay" with-backdrop="">
    <gr-confirm-delete-item-dialog
      class="confirmDialog"
      on-confirm="_handleDeleteConfirm"
      on-cancel="_handleConfirmDialogCancel"
      item="[[_itemName]]"
      item-type="[[_itemType]]"
    ></gr-confirm-delete-item-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Wg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let qg=class extends(oo(dr(oa))){constructor(){super(),this._loading=!0,this._groupOwner=!1,this._isAdmin=!1,this._queryMembers=e=>this._getAccountSuggestions(e),this._queryIncludedGroup=e=>this._getGroupSuggestions(e)}static get template(){return zg}attached(){super.attached(),this._loadGroupDetails(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Members"},composed:!0,bubbles:!0}))}_loadGroupDetails(){if(!this.groupId)return;const e=[];return this.$.restAPI.getGroupConfig(this.groupId,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(t=>t&&t.name?(this._groupName=t.name,e.push(this.$.restAPI.getIsAdmin().then(e=>{this._isAdmin=!!e})),e.push(this.$.restAPI.getIsGroupOwner(this._groupName).then(e=>{this._groupOwner=!!e})),e.push(this.$.restAPI.getGroupMembers(this._groupName).then(e=>{this._groupMembers=e})),e.push(this.$.restAPI.getIncludedGroup(this._groupName).then(e=>{this._includedGroups=e})),Promise.all(e).then(()=>{this._loading=!1})):Promise.resolve())}_computeLoadingClass(e){return e?"loading":""}_isLoading(){return this._loading||void 0===this._loading}_computeGroupUrl(e){if(!e)return;return new RegExp("^(?:[a-z]+:)?//","i").test(e)?e:e.startsWith("#")?j()+e.slice(1):j()+e}_handleSavingGroupMember(){return this._groupName?this.$.restAPI.saveGroupMember(this._groupName,this._groupMemberSearchId).then(e=>{e&&this._groupName&&(this.$.restAPI.getGroupMembers(this._groupName).then(e=>{this._groupMembers=e}),this._groupMemberSearchName="",this._groupMemberSearchId=void 0)}):Promise.reject(new Error("group name undefined"))}_handleDeleteConfirm(){return this._groupName?(this.$.overlay.close(),"member"===this._itemType?this.$.restAPI.deleteGroupMember(this._groupName,this._itemId).then(e=>{204===e.status&&this._groupName&&this.$.restAPI.getGroupMembers(this._groupName).then(e=>{this._groupMembers=e})}):"includedGroup"===this._itemType?this.$.restAPI.deleteIncludedGroup(this._groupName,this._itemId).then(e=>{204!==e.status&&205!==e.status||!this._groupName||this.$.restAPI.getIncludedGroup(this._groupName).then(e=>{this._includedGroups=e})}):Promise.reject(new Error("Unrecognized item type"))):Promise.reject(new Error("group name undefined"))}_handleConfirmDialogCancel(){this.$.overlay.close()}_handleDeleteMember(e){const t=e.model.get("item._account_id"),n=e.model.get("item.name"),i=e.model.get("item.username"),o=e.model.get("item.email"),s=i||n||o||t;s&&(this._itemName=s,this._itemId=t,this._itemType="member",this.$.overlay.open())}_handleSavingIncludedGroups(){return this._groupName&&this._includedGroupSearchId?this.$.restAPI.saveIncludedGroup(this._groupName,this._includedGroupSearchId.replace(/\+/g," "),(e,t)=>{if(e){if(404===e.status)return this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Group may not exist, or you may not have permission to add it"},bubbles:!0,composed:!0})),e;throw Error(e.statusText)}throw t}).then(e=>{e&&this._groupName&&(this.$.restAPI.getIncludedGroup(this._groupName).then(e=>{this._includedGroups=e}),this._includedGroupSearchName="",this._includedGroupSearchId="")}):Promise.reject(new Error("group name or includedGroupSearchId undefined"))}_handleDeleteIncludedGroup(e){const t=decodeURIComponent(`${e.model.get("item.id")}`).replace(/\+/g," "),n=e.model.get("item.name")||t;n&&(this._itemName=n,this._itemId=t,this._itemType="includedGroup",this.$.overlay.open())}_getAccountSuggestions(e){return 0===e.length?Promise.resolve([]):this.$.restAPI.getSuggestedAccounts(e,15).then(e=>{const t=[];let n;if(!e)return[];for(const i in e)o(e,i)&&(n=void 0!==e[i].email?`${e[i].name} <${e[i].email}>`:e[i].name,t.push({name:n,value:e[i]._account_id}));return t})}_getGroupSuggestions(e){return this.$.restAPI.getSuggestedGroups(e).then(e=>{const t=[];for(const n in e)o(e,n)&&t.push({name:n,value:decodeURIComponent(e[n].id)});return t})}_computeHideItemClass(e,t){return t||e?"":"canModify"}};Wg([Bl({type:Number})],qg.prototype,"groupId",void 0),Wg([Bl({type:Number})],qg.prototype,"_groupMemberSearchId",void 0),Wg([Bl({type:String})],qg.prototype,"_groupMemberSearchName",void 0),Wg([Bl({type:String})],qg.prototype,"_includedGroupSearchId",void 0),Wg([Bl({type:String})],qg.prototype,"_includedGroupSearchName",void 0),Wg([Bl({type:Boolean})],qg.prototype,"_loading",void 0),Wg([Bl({type:String})],qg.prototype,"_groupName",void 0),Wg([Bl({type:Object})],qg.prototype,"_groupMembers",void 0),Wg([Bl({type:Object})],qg.prototype,"_includedGroups",void 0),Wg([Bl({type:String})],qg.prototype,"_itemName",void 0),Wg([Bl({type:String})],qg.prototype,"_itemType",void 0),Wg([Bl({type:Object})],qg.prototype,"_queryMembers",void 0),Wg([Bl({type:Object})],qg.prototype,"_queryIncludedGroup",void 0),Wg([Bl({type:Boolean})],qg.prototype,"_groupOwner",void 0),Wg([Bl({type:Boolean})],qg.prototype,"_isAdmin",void 0),qg=Wg([Ml("gr-group-members")],qg);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Kg=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-table-styles">
    .placeholder {
      color: var(--deemphasized-text-color);
    }
  </style>
  <gr-list-view
    filter="[[_filter]]"
    items-per-page="[[_pluginsPerPage]]"
    items="[[_plugins]]"
    loading="[[_loading]]"
    offset="[[_offset]]"
    path="[[_path]]"
  >
    <table id="list" class="genericList">
      <tbody>
        <tr class="headerRow">
          <th class="name topHeader">Plugin Name</th>
          <th class="version topHeader">Version</th>
          <th class="apiVersion topHeader">API Version</th>
          <th class="status topHeader">Status</th>
        </tr>
        <tr id="loading" class$="loadingMsg [[computeLoadingClass(_loading)]]">
          <td>Loading...</td>
        </tr>
      </tbody>
      <tbody class$="[[computeLoadingClass(_loading)]]">
        <template is="dom-repeat" items="[[_shownPlugins]]">
          <tr class="table">
            <td class="name">
              <template is="dom-if" if="[[item.index_url]]">
                <a href$="[[_computePluginUrl(item.index_url)]]">[[item.id]]</a>
              </template>
              <template is="dom-if" if="[[!item.index_url]]">
                [[item.id]]
              </template>
            </td>
            <td class="version">
              <template is="dom-if" if="[[item.version]]">
                [[item.version]]
              </template>
              <template is="dom-if" if="[[!item.version]]">
                <span class="placeholder">--</span>
              </template>
            </td>
            <td class="apiVersion">
              <template is="dom-if" if="[[item.api_version]]">
                [[item.api_version]]
              </template>
              <template is="dom-if" if="[[!item.api_version]]">
                <span class="placeholder">--</span>
              </template>
            </td>
            <td class="status">[[_status(item)]]</td>
          </tr>
        </template>
      </tbody>
    </table>
  </gr-list-view>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Yg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Xg=class extends(Ku(oo(dr(oa)))){constructor(){super(...arguments),this._offset=0,this._path="/admin/plugins",this._pluginsPerPage=25,this._loading=!0,this._filter=""}static get template(){return Kg}attached(){super.attached(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Plugins"},composed:!0,bubbles:!0}))}_paramsChanged(e){return this._loading=!0,this._filter=this.getFilterValue(e),this._offset=this.getOffsetValue(e),this._getPlugins(this._filter,this._pluginsPerPage,this._offset)}_getPlugins(e,t,n){return this.$.restAPI.getPlugins(e,t,n,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(e=>{e?(this._plugins=Object.keys(e).map(t=>({...e[t],name:t})),this._loading=!1):this._plugins=[]})}_status(e){return!0===e.disabled?"Disabled":"Enabled"}_computePluginUrl(e){return this.getUrl("/",e)}};Yg([Bl({type:Object,observer:"_paramsChanged"})],Xg.prototype,"params",void 0),Yg([Bl({type:Number})],Xg.prototype,"_offset",void 0),Yg([Bl({type:String})],Xg.prototype,"_path",void 0),Yg([Bl({type:Array})],Xg.prototype,"_plugins",void 0),Yg([Bl({type:Array,computed:"computeShownItems(_plugins)"})],Xg.prototype,"_shownPlugins",void 0),Yg([Bl({type:Number})],Xg.prototype,"_pluginsPerPage",void 0),Yg([Bl({type:Boolean})],Xg.prototype,"_loading",void 0),Yg([Bl({type:String})],Xg.prototype,"_filter",void 0),Xg=Yg([Ml("gr-plugin-list")],Xg);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Jg=ta` <slot></slot> `;var Zg=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Qg=class extends(oo(dr(oa))){constructor(){super(...arguments),this._domHooks=new Map,this._initializedPlugins=new Map,this._endpointCallBack=()=>{}}static get template(){return Jg}detached(){super.detached();for(const[e,t]of this._domHooks)t.handleInstanceDetached(e);rc().onDetachedEndpoint(this.name,this._endpointCallBack)}_initDecoration(e,t,n){const i=document.createElement(e);return this._initProperties(i,t,this.getContentChildren().find(e=>"GR-ENDPOINT-PARAM"!==e.nodeName)).then(e=>{const t=n?this.querySelector(`gr-endpoint-slot[name=${n}]`):null;return n&&(null==t?void 0:t.parentNode)?t.parentNode.insertBefore(e,t.nextSibling):this._appendChild(e),e})}_initReplacement(e,t){this.getContentChildNodes().filter(e=>"GR-ENDPOINT-PARAM"!==e.nodeName).forEach(e=>e.remove());const n=document.createElement(e);return this._initProperties(n,t).then(e=>this._appendChild(e))}_getEndpointParams(){return Array.from(this.querySelectorAll("gr-endpoint-param"))}_initProperties(e,t,n){const i=e;i.plugin=t,n&&(i.content=n);const o=this._getEndpointParams().map(e=>{const n=t.attributeHelper(e),o=e.getAttribute("name");if(!o)throw Error("plugin endpoint parameter missing a name");return n.get("value").then(()=>n.bind("value",e=>t.attributeHelper(i).set(o,e)))});let s;const r=new Promise(()=>s=setTimeout(()=>{console.warn("Timeout waiting for endpoint properties initialization: "+`plugin ${t.getPluginName()}, endpoint ${this.name}`)},1e4));return Promise.race([r,Promise.all(o)]).then(()=>i).finally(()=>{s&&clearTimeout(s)})}_appendChild(e){if(!this.root)throw Error("plugin endpoint decorator missing root");return this.root.appendChild(e)}_initModule({moduleName:e,plugin:t,type:n,domHook:i,slot:o}){const s=t.getPluginName()+"."+e;if(this._initializedPlugins.get(s))return;let r;switch(n){case"decorate":r=this._initDecoration(e,t,o);break;case"replace":r=this._initReplacement(e,t)}if(!r)throw Error(`unknown endpoint type ${n} used by plugin ${s}`);this._initializedPlugins.set(s,!0),r.then(e=>{i&&(i.handleInstanceAttached(e),this._domHooks.set(e,i))})}ready(){super.ready(),this._endpointCallBack=e=>this._initModule(e),rc().onNewEndpoint(this.name,this._endpointCallBack),this.name&&eh().awaitPluginsLoaded().then(()=>rc().getAndImportPlugins(this.name)).then(()=>rc().getDetails(this.name).forEach(this._initModule,this))}};Zg([Bl({type:String})],Qg.prototype,"name",void 0),Zg([Bl({type:Object})],Qg.prototype,"_domHooks",void 0),Zg([Bl({type:Object})],Qg.prototype,"_initializedPlugins",void 0),Qg=Zg([Ml("gr-endpoint-decorator")],Qg);var em=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let tm=class extends(oo(dr(oa))){constructor(){super(...arguments),this.name=""}_valueChanged(e){this.dispatchEvent(new CustomEvent("value-changed",{detail:{value:e}}))}};em([Bl({type:String,reflectToAttribute:!0})],tm.prototype,"name",void 0),em([Bl({type:Object,notify:!0,observer:"_valueChanged"})],tm.prototype,"value",void 0),tm=em([Ml("gr-endpoint-param")],tm);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const nm={observers:["_focusedChanged(receivedFocusFromKeyboard)"],_focusedChanged:function(e){e&&this.ensureRipple(),this.hasRipple()&&(this._ripple.holdDown=e)},_createRipple:function(){var e=rp._createRipple();return e.id="ink",e.setAttribute("center",""),e.classList.add("circle"),e}},im=[Kh,jh,rp,nm];
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({is:"paper-icon-button",_template:ta`
    <style>
      :host {
        display: inline-block;
        position: relative;
        padding: 8px;
        outline: none;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        cursor: pointer;
        z-index: 0;
        line-height: 1;

        width: 40px;
        height: 40px;

        /*
          NOTE: Both values are needed, since some phones require the value to
          be \`transparent\`.
        */
        -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
        -webkit-tap-highlight-color: transparent;

        /* Because of polymer/2558, this style has lower specificity than * */
        box-sizing: border-box !important;

        @apply --paper-icon-button;
      }

      :host #ink {
        color: var(--paper-icon-button-ink-color, var(--primary-text-color));
        opacity: 0.6;
      }

      :host([disabled]) {
        color: var(--paper-icon-button-disabled-text, var(--disabled-text-color));
        pointer-events: none;
        cursor: auto;

        @apply --paper-icon-button-disabled;
      }

      :host([hidden]) {
        display: none !important;
      }

      :host(:hover) {
        @apply --paper-icon-button-hover;
      }

      iron-icon {
        --iron-icon-width: 100%;
        --iron-icon-height: 100%;
      }
    </style>

    <iron-icon id="icon" src="[[src]]" icon="[[icon]]"
               alt$="[[alt]]"></iron-icon>
  `,hostAttributes:{role:"button",tabindex:"0"},behaviors:[im],registered:function(){this._template.setAttribute("strip-whitespace","")},properties:{src:{type:String},icon:{type:String},alt:{type:String,observer:"_altChanged"}},_altChanged:function(e,t){var n=this.getAttribute("aria-label");n&&t!=n||this.setAttribute("aria-label",e)}});
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
const om=ta`<iron-iconset-svg name="paper-tabs" size="24">
<svg><defs>
<g id="chevron-left"><path d="M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"></path></g>
<g id="chevron-right"><path d="M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"></path></g>
</defs></svg>
</iron-iconset-svg>`;document.head.appendChild(om.content),
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style>
      :host {
        @apply --layout-inline;
        @apply --layout-center;
        @apply --layout-center-justified;
        @apply --layout-flex-auto;

        position: relative;
        padding: 0 12px;
        overflow: hidden;
        cursor: pointer;
        vertical-align: middle;

        @apply --paper-font-common-base;
        @apply --paper-tab;
      }

      :host(:focus) {
        outline: none;
      }

      :host([link]) {
        padding: 0;
      }

      .tab-content {
        height: 100%;
        transform: translateZ(0);
          -webkit-transform: translateZ(0);
        transition: opacity 0.1s cubic-bezier(0.4, 0.0, 1, 1);
        @apply --layout-horizontal;
        @apply --layout-center-center;
        @apply --layout-flex-auto;
        @apply --paper-tab-content;
      }

      :host(:not(.iron-selected)) > .tab-content {
        opacity: 0.8;

        @apply --paper-tab-content-unselected;
      }

      :host(:focus) .tab-content {
        opacity: 1;
        font-weight: 700;

        @apply --paper-tab-content-focused;
      }

      paper-ripple {
        color: var(--paper-tab-ink, var(--paper-yellow-a100));
      }

      .tab-content > ::slotted(a) {
        @apply --layout-flex-auto;

        height: 100%;
      }
    </style>

    <div class="tab-content">
      <slot></slot>
    </div>
`,is:"paper-tab",behaviors:[jh,Kh,rp],properties:{link:{type:Boolean,value:!1,reflectToAttribute:!0}},hostAttributes:{role:"tab"},listeners:{down:"_updateNoink",tap:"_onTap"},attached:function(){this._updateNoink()},get _parentNoink(){var e=qo(this).parentNode;return!!e&&!!e.noink},_updateNoink:function(){this.noink=!!this.noink||!!this._parentNoink},_onTap:function(e){if(this.link){var t=this.queryEffectiveChildren("a");if(!t)return;if(e.target===t)return;t.click()}}}),
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
*/
Er({_template:ta`
    <style>
      :host {
        @apply --layout;
        @apply --layout-center;

        height: 48px;
        font-size: 14px;
        font-weight: 500;
        overflow: hidden;
        -moz-user-select: none;
        -ms-user-select: none;
        -webkit-user-select: none;
        user-select: none;

        /* NOTE: Both values are needed, since some phones require the value to be \`transparent\`. */
        -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
        -webkit-tap-highlight-color: transparent;

        @apply --paper-tabs;
      }

      :host(:dir(rtl)) {
        @apply --layout-horizontal-reverse;
      }

      #tabsContainer {
        position: relative;
        height: 100%;
        white-space: nowrap;
        overflow: hidden;
        @apply --layout-flex-auto;
        @apply --paper-tabs-container;
      }

      #tabsContent {
        height: 100%;
        -moz-flex-basis: auto;
        -ms-flex-basis: auto;
        flex-basis: auto;
        @apply --paper-tabs-content;
      }

      #tabsContent.scrollable {
        position: absolute;
        white-space: nowrap;
      }

      #tabsContent:not(.scrollable),
      #tabsContent.scrollable.fit-container {
        @apply --layout-horizontal;
      }

      #tabsContent.scrollable.fit-container {
        min-width: 100%;
      }

      #tabsContent.scrollable.fit-container > ::slotted(*) {
        /* IE - prevent tabs from compressing when they should scroll. */
        -ms-flex: 1 0 auto;
        -webkit-flex: 1 0 auto;
        flex: 1 0 auto;
      }

      .hidden {
        display: none;
      }

      .not-visible {
        opacity: 0;
        cursor: default;
      }

      paper-icon-button {
        width: 48px;
        height: 48px;
        padding: 12px;
        margin: 0 4px;
      }

      #selectionBar {
        position: absolute;
        height: 0;
        bottom: 0;
        left: 0;
        right: 0;
        border-bottom: 2px solid var(--paper-tabs-selection-bar-color, var(--paper-yellow-a100));
          -webkit-transform: scale(0);
        transform: scale(0);
          -webkit-transform-origin: left center;
        transform-origin: left center;
          transition: -webkit-transform;
        transition: transform;

        @apply --paper-tabs-selection-bar;
      }

      #selectionBar.align-bottom {
        top: 0;
        bottom: auto;
      }

      #selectionBar.expand {
        transition-duration: 0.15s;
        transition-timing-function: cubic-bezier(0.4, 0.0, 1, 1);
      }

      #selectionBar.contract {
        transition-duration: 0.18s;
        transition-timing-function: cubic-bezier(0.0, 0.0, 0.2, 1);
      }

      #tabsContent > ::slotted(:not(#selectionBar)) {
        height: 100%;
      }
    </style>

    <paper-icon-button icon="paper-tabs:chevron-left" class$="[[_computeScrollButtonClass(_leftHidden, scrollable, hideScrollButtons)]]" on-up="_onScrollButtonUp" on-down="_onLeftScrollButtonDown" tabindex="-1"></paper-icon-button>

    <div id="tabsContainer" on-track="_scroll" on-down="_down">
      <div id="tabsContent" class$="[[_computeTabsContentClass(scrollable, fitContainer)]]">
        <div id="selectionBar" class$="[[_computeSelectionBarClass(noBar, alignBottom)]]" on-transitionend="_onBarTransitionEnd"></div>
        <slot></slot>
      </div>
    </div>

    <paper-icon-button icon="paper-tabs:chevron-right" class$="[[_computeScrollButtonClass(_rightHidden, scrollable, hideScrollButtons)]]" on-up="_onScrollButtonUp" on-down="_onRightScrollButtonDown" tabindex="-1"></paper-icon-button>
`,is:"paper-tabs",behaviors:[wc,[ep,{hostAttributes:{role:"menubar"},keyBindings:{left:"_onLeftKey",right:"_onRightKey"},_onUpKey:function(e){this.focusedItem.click(),e.detail.keyboardEvent.preventDefault()},_onDownKey:function(e){this.focusedItem.click(),e.detail.keyboardEvent.preventDefault()},get _isRTL(){return"rtl"===window.getComputedStyle(this).direction},_onLeftKey:function(e){this._isRTL?this._focusNext():this._focusPrevious(),e.detail.keyboardEvent.preventDefault()},_onRightKey:function(e){this._isRTL?this._focusPrevious():this._focusNext(),e.detail.keyboardEvent.preventDefault()},_onKeydown:function(e){this.keyboardEventMatchesKeys(e,"up down left right esc")||this._focusWithKeyboardEvent(e)}}]],properties:{noink:{type:Boolean,value:!1,observer:"_noinkChanged"},noBar:{type:Boolean,value:!1},noSlide:{type:Boolean,value:!1},scrollable:{type:Boolean,value:!1},fitContainer:{type:Boolean,value:!1},disableDrag:{type:Boolean,value:!1},hideScrollButtons:{type:Boolean,value:!1},alignBottom:{type:Boolean,value:!1},selectable:{type:String,value:"paper-tab"},autoselect:{type:Boolean,value:!1},autoselectDelay:{type:Number,value:0},_step:{type:Number,value:10},_holdDelay:{type:Number,value:1},_leftHidden:{type:Boolean,value:!1},_rightHidden:{type:Boolean,value:!1},_previousTab:{type:Object}},hostAttributes:{role:"tablist"},listeners:{"iron-resize":"_onTabSizingChanged","iron-items-changed":"_onTabSizingChanged","iron-select":"_onIronSelect","iron-deselect":"_onIronDeselect"},keyBindings:{"left:keyup right:keyup":"_onArrowKeyup"},created:function(){this._holdJob=null,this._pendingActivationItem=void 0,this._pendingActivationTimeout=void 0,this._bindDelayedActivationHandler=this._delayedActivationHandler.bind(this),this.addEventListener("blur",this._onBlurCapture.bind(this),!0)},ready:function(){this.setScrollDirection("y",this.$.tabsContainer)},detached:function(){this._cancelPendingActivation()},_noinkChanged:function(e){qo(this).querySelectorAll("paper-tab").forEach(e?this._setNoinkAttribute:this._removeNoinkAttribute)},_setNoinkAttribute:function(e){e.setAttribute("noink","")},_removeNoinkAttribute:function(e){e.removeAttribute("noink")},_computeScrollButtonClass:function(e,t,n){return!t||n?"hidden":e?"not-visible":""},_computeTabsContentClass:function(e,t){return e?"scrollable"+(t?" fit-container":""):" fit-container"},_computeSelectionBarClass:function(e,t){return e?"hidden":t?"align-bottom":""},_onTabSizingChanged:function(){this.debounce("_onTabSizingChanged",(function(){this._scroll(),this._tabChanged(this.selectedItem)}),10)},_onIronSelect:function(e){this._tabChanged(e.detail.item,this._previousTab),this._previousTab=e.detail.item,this.cancelDebouncer("tab-changed")},_onIronDeselect:function(e){this.debounce("tab-changed",(function(){this._tabChanged(null,this._previousTab),this._previousTab=null}),1)},_activateHandler:function(){this._cancelPendingActivation(),Qh._activateHandler.apply(this,arguments)},_scheduleActivation:function(e,t){this._pendingActivationItem=e,this._pendingActivationTimeout=this.async(this._bindDelayedActivationHandler,t)},_delayedActivationHandler:function(){var e=this._pendingActivationItem;this._pendingActivationItem=void 0,this._pendingActivationTimeout=void 0,e.fire(this.activateEvent,null,{bubbles:!0,cancelable:!0})},_cancelPendingActivation:function(){void 0!==this._pendingActivationTimeout&&(this.cancelAsync(this._pendingActivationTimeout),this._pendingActivationItem=void 0,this._pendingActivationTimeout=void 0)},_onArrowKeyup:function(e){this.autoselect&&this._scheduleActivation(this.focusedItem,this.autoselectDelay)},_onBlurCapture:function(e){e.target===this._pendingActivationItem&&this._cancelPendingActivation()},get _tabContainerScrollSize(){return Math.max(0,this.$.tabsContainer.scrollWidth-this.$.tabsContainer.offsetWidth)},_scroll:function(e,t){if(this.scrollable){var n=t&&-t.ddx||0;this._affectScroll(n)}},_down:function(e){this.async((function(){this._defaultFocusAsync&&(this.cancelAsync(this._defaultFocusAsync),this._defaultFocusAsync=null)}),1)},_affectScroll:function(e){this.$.tabsContainer.scrollLeft+=e;var t=this.$.tabsContainer.scrollLeft;this._leftHidden=0===t,this._rightHidden=t===this._tabContainerScrollSize},_onLeftScrollButtonDown:function(){this._scrollToLeft(),this._holdJob=setInterval(this._scrollToLeft.bind(this),this._holdDelay)},_onRightScrollButtonDown:function(){this._scrollToRight(),this._holdJob=setInterval(this._scrollToRight.bind(this),this._holdDelay)},_onScrollButtonUp:function(){clearInterval(this._holdJob),this._holdJob=null},_scrollToLeft:function(){this._affectScroll(-this._step)},_scrollToRight:function(){this._affectScroll(this._step)},_tabChanged:function(e,t){if(!e)return this.$.selectionBar.classList.remove("expand"),this.$.selectionBar.classList.remove("contract"),void this._positionBar(0,0);var n=this.$.tabsContent.getBoundingClientRect(),i=n.width,o=e.getBoundingClientRect(),s=o.left-n.left;if(this._pos={width:this._calcPercent(o.width,i),left:this._calcPercent(s,i)},this.noSlide||null==t)return this.$.selectionBar.classList.remove("expand"),this.$.selectionBar.classList.remove("contract"),void this._positionBar(this._pos.width,this._pos.left);var r=t.getBoundingClientRect(),a=this.items.indexOf(t),l=this.items.indexOf(e);this.$.selectionBar.classList.add("expand");var c=a<l;this._isRTL&&(c=!c),c?this._positionBar(this._calcPercent(o.left+o.width-r.left,i)-5,this._left):this._positionBar(this._calcPercent(r.left+r.width-o.left,i)-5,this._calcPercent(s,i)+5),this.scrollable&&this._scrollToSelectedIfNeeded(o.width,s)},_scrollToSelectedIfNeeded:function(e,t){var n=t-this.$.tabsContainer.scrollLeft;n<0?this.$.tabsContainer.scrollLeft+=n:(n+=e-this.$.tabsContainer.offsetWidth)>0&&(this.$.tabsContainer.scrollLeft+=n)},_calcPercent:function(e,t){return 100*e/t},_positionBar:function(e,t){e=e||0,t=t||0,this._width=e,this._left=t,this.transform("translateX("+t+"%) scaleX("+e/100+")",this.$.selectionBar)},_onBarTransitionEnd:function(e){var t=this.$.selectionBar.classList;t.contains("expand")?(t.remove("expand"),t.add("contract"),this._positionBar(this._pos.width,this._pos.left)):t.contains("contract")&&t.remove("contract")}});
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const sm=ta`
  <style include="shared-styles">
    .commandContainer {
      margin-bottom: var(--spacing-m);
    }
    .commandContainer {
      background-color: var(--shell-command-background-color);
      /* Should be spacing-m larger than the :before width. */
      padding: var(--spacing-m) var(--spacing-m) var(--spacing-m)
        calc(3 * var(--spacing-m) + 0.5em);
      position: relative;
      width: 100%;
    }
    .commandContainer:before {
      content: '$';
      position: absolute;
      display: block;
      box-sizing: border-box;
      background: var(--shell-command-decoration-background-color);
      top: 0;
      bottom: 0;
      left: 0;
      /* Should be spacing-m smaller than the .commandContainer padding-left. */
      width: calc(2 * var(--spacing-m) + 0.5em);
      /* Should vertically match the padding of .commandContainer. */
      padding: var(--spacing-m);
      /* Should roughly match the height of .commandContainer without padding. */
      line-height: 26px;
    }
    .commandContainer gr-copy-clipboard {
      --text-container-style: {
        border: none;
      }
    }
  </style>
  <label>[[label]]</label>
  <div class="commandContainer">
    <gr-copy-clipboard text="[[command]]"></gr-copy-clipboard>
  </div>
`;var rm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let am=class extends(oo(dr(oa))){static get template(){return sm}focusOnCopy(){if(null!==this.shadowRoot){const e=this.shadowRoot.querySelector("gr-copy-clipboard");null!==e&&e.focusOnCopy()}}};rm([Bl({type:String})],am.prototype,"command",void 0),rm([Bl({type:String})],am.prototype,"label",void 0),am=rm([Ml("gr-shell-command")],am);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const lm=ta`
  <style include="shared-styles">
    paper-tabs {
      height: 3rem;
      margin-bottom: var(--spacing-m);
      --paper-tabs-selection-bar-color: var(--link-color);
    }
    paper-tab {
      max-width: 15rem;
      text-transform: uppercase;
      --paper-tab-ink: var(--link-color);
    }
    label,
    input {
      display: block;
    }
    label {
      font-weight: var(--font-weight-bold);
    }
    .schemes {
      display: flex;
      justify-content: space-between;
    }
    .commands {
      display: flex;
      flex-direction: column;
    }
    gr-shell-command {
      width: 60em;
      margin-bottom: var(--spacing-m);
    }
    .hidden {
      display: none;
    }
  </style>
  <div class="schemes">
    <paper-tabs
      id="downloadTabs"
      class$="[[_computeShowTabs(schemes)]]"
      selected="[[_computeSelected(schemes, selectedScheme)]]"
      on-selected-changed="_handleTabChange"
    >
      <template is="dom-repeat" items="[[schemes]]" as="scheme">
        <paper-tab data-scheme$="[[scheme]]">[[scheme]]</paper-tab>
      </template>
    </paper-tabs>
  </div>
  <div class="commands" hidden$="[[!schemes.length]]" hidden="">
    <template is="dom-repeat" items="[[commands]]" as="command">
      <gr-shell-command
        class$="[[_computeClass(command.title)]]"
        label="[[command.title]]"
        command="[[command.command]]"
      ></gr-shell-command>
    </template>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var cm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let dm=class extends(oo(dr(oa))){constructor(){super(...arguments),this._loggedIn=!1,this.schemes=[]}static get template(){return lm}attached(){super.attached(),this._getLoggedIn().then(e=>{this._loggedIn=e})}focusOnCopy(){this.shadowRoot.querySelector("gr-shell-command").focusOnCopy()}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_loggedInChanged(e){if(e)return this.$.restAPI.getPreferences().then(e=>{(null==e?void 0:e.download_scheme)&&(this.selectedScheme=e.download_scheme.toLowerCase())})}_handleTabChange(e){const t=this.schemes[e.detail.value];t&&t!==this.selectedScheme&&(this.set("selectedScheme",t),this._loggedIn&&this.$.restAPI.savePreferences({download_scheme:this.selectedScheme}))}_computeSelected(e,t){return`${e.findIndex(e=>e===t)||0}`}_computeShowTabs(e){return e.length>1?"":"hidden"}_computeClass(e){return"_label_"+e.replace(/[^a-z]+/gi,"").toLowerCase()}};cm([Bl({type:Array})],dm.prototype,"comamnds",void 0),cm([Bl({type:Boolean})],dm.prototype,"_loggedIn",void 0),cm([Bl({type:Array})],dm.prototype,"schemes",void 0),cm([Bl({type:String,notify:!0})],dm.prototype,"selectedScheme",void 0),cm([jl("_loggedIn")],dm.prototype,"_loggedInChanged",null),dm=cm([Ml("gr-download-commands")],dm);
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
const hm={properties:{checked:{type:Boolean,value:!1,reflectToAttribute:!0,notify:!0,observer:"_checkedChanged"},toggles:{type:Boolean,value:!0,reflectToAttribute:!0},value:{type:String,value:"on",observer:"_valueChanged"}},observers:["_requiredChanged(required)"],created:function(){this._hasIronCheckedElementBehavior=!0},_getValidity:function(e){return this.disabled||!this.required||this.checked},_requiredChanged:function(){this.required?this.setAttribute("aria-required","true"):this.removeAttribute("aria-required")},_checkedChanged:function(){this.active=this.checked,this.fire("iron-change")},_valueChanged:function(){void 0!==this.value&&null!==this.value||(this.value="on")}},pm=[im,[eg,Bu,hm],{_checkedChanged:function(){hm._checkedChanged.call(this),this.hasRipple()&&(this.checked?this._ripple.setAttribute("checked",""):this._ripple.removeAttribute("checked"))},_buttonStateChanged:function(){rp._buttonStateChanged.call(this),this.disabled||this.isAttached&&(this.checked=this.active)}}],um=ta`

    <style>
      :host {
        display: inline-block;
        @apply --layout-horizontal;
        @apply --layout-center;
        @apply --paper-font-common-base;
      }

      :host([disabled]) {
        pointer-events: none;
      }

      :host(:focus) {
        outline:none;
      }

      .toggle-bar {
        position: absolute;
        height: 100%;
        width: 100%;
        border-radius: 8px;
        pointer-events: none;
        opacity: 0.4;
        transition: background-color linear .08s;
        background-color: var(--paper-toggle-button-unchecked-bar-color, #000000);

        @apply --paper-toggle-button-unchecked-bar;
      }

      .toggle-button {
        position: absolute;
        top: -3px;
        left: 0;
        height: 20px;
        width: 20px;
        border-radius: 50%;
        box-shadow: 0 1px 5px 0 rgba(0, 0, 0, 0.6);
        transition: -webkit-transform linear .08s, background-color linear .08s;
        transition: transform linear .08s, background-color linear .08s;
        will-change: transform;
        background-color: var(--paper-toggle-button-unchecked-button-color, var(--paper-grey-50));

        @apply --paper-toggle-button-unchecked-button;
      }

      .toggle-button.dragging {
        -webkit-transition: none;
        transition: none;
      }

      :host([checked]:not([disabled])) .toggle-bar {
        opacity: 0.5;
        background-color: var(--paper-toggle-button-checked-bar-color, var(--primary-color));

        @apply --paper-toggle-button-checked-bar;
      }

      :host([disabled]) .toggle-bar {
        background-color: #000;
        opacity: 0.12;
      }

      :host([checked]) .toggle-button {
        -webkit-transform: translate(16px, 0);
        transform: translate(16px, 0);
      }

      :host([checked]:not([disabled])) .toggle-button {
        background-color: var(--paper-toggle-button-checked-button-color, var(--primary-color));

        @apply --paper-toggle-button-checked-button;
      }

      :host([disabled]) .toggle-button {
        background-color: #bdbdbd;
        opacity: 1;
      }

      .toggle-ink {
        position: absolute;
        top: -14px;
        left: -14px;
        right: auto;
        bottom: auto;
        width: 48px;
        height: 48px;
        opacity: 0.5;
        pointer-events: none;
        color: var(--paper-toggle-button-unchecked-ink-color, var(--primary-text-color));

        @apply --paper-toggle-button-unchecked-ink;
      }

      :host([checked]) .toggle-ink {
        color: var(--paper-toggle-button-checked-ink-color, var(--primary-color));

        @apply --paper-toggle-button-checked-ink;
      }

      .toggle-container {
        display: inline-block;
        position: relative;
        width: 36px;
        height: 14px;
        /* The toggle button has an absolute position of -3px; The extra 1px
        /* accounts for the toggle button shadow box. */
        margin: 4px 1px;
      }

      .toggle-label {
        position: relative;
        display: inline-block;
        vertical-align: middle;
        padding-left: var(--paper-toggle-button-label-spacing, 8px);
        pointer-events: none;
        color: var(--paper-toggle-button-label-color, var(--primary-text-color));
      }

      /* invalid state */
      :host([invalid]) .toggle-bar {
        background-color: var(--paper-toggle-button-invalid-bar-color, var(--error-color));
      }

      :host([invalid]) .toggle-button {
        background-color: var(--paper-toggle-button-invalid-button-color, var(--error-color));
      }

      :host([invalid]) .toggle-ink {
        color: var(--paper-toggle-button-invalid-ink-color, var(--error-color));
      }
    </style>

    <div class="toggle-container">
      <div id="toggleBar" class="toggle-bar"></div>
      <div id="toggleButton" class="toggle-button"></div>
    </div>

    <div class="toggle-label"><slot></slot></div>

  `;um.setAttribute("strip-whitespace",""),Er({_template:um,is:"paper-toggle-button",behaviors:[pm],hostAttributes:{role:"button","aria-pressed":"false",tabindex:0},properties:{},listeners:{track:"_ontrack"},attached:function(){Ao(this,(function(){Bi(this,"pan-y")}))},_ontrack:function(e){var t=e.detail;"start"===t.state?this._trackStart(t):"track"===t.state?this._trackMove(t):"end"===t.state&&this._trackEnd(t)},_trackStart:function(e){this._width=this.$.toggleBar.offsetWidth/2,this._trackChecked=this.checked,this.$.toggleButton.classList.add("dragging")},_trackMove:function(e){var t=e.dx;this._x=Math.min(this._width,Math.max(0,this._trackChecked?this._width+t:t)),this.translate3d(this._x+"px",0,0,this.$.toggleButton),this._userActivate(this._x>this._width/2)},_trackEnd:function(e){this.$.toggleButton.classList.remove("dragging"),this.transform("",this.$.toggleButton)},_createRipple:function(){this._rippleContainer=this.$.toggleButton;var e=rp._createRipple();return e.id="ink",e.setAttribute("recenters",""),e.classList.add("circle","toggle-ink"),e}});
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const gm=ta`
  <style>
    iron-icon {
      width: var(--line-height-normal);
      height: var(--line-height-normal);
      vertical-align: top;
    }
  </style>
  <slot></slot
  ><!--
 --><iron-icon icon="gr-icons:info" hidden$="[[!showIcon]]"></iron-icon>
`;var mm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let _m=class extends(mp(oo(dr(oa)))){constructor(){super(...arguments),this.showIcon=!1}static get template(){return gm}};mm([Bl({type:String,reflectToAttribute:!0})],_m.prototype,"maxWidth",void 0),mm([Bl({type:Boolean})],_m.prototype,"showIcon",void 0),_m=mm([Ml("gr-tooltip-content")],_m);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const fm=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    .wrapper {
      width: 30em;
    }
    .existingItems {
      background: var(--table-header-background-color);
      border: 1px solid var(--border-color);
      border-radius: var(--border-radius);
    }
    gr-button {
      float: right;
      margin-left: var(--spacing-m);
      width: 4.5em;
    }
    .row {
      align-items: center;
      display: flex;
      justify-content: space-between;
      padding: var(--spacing-m) 0;
      width: 100%;
    }
    .existingItems .row {
      padding: var(--spacing-m);
    }
    .existingItems .row:not(:first-of-type) {
      border-top: 1px solid var(--border-color);
    }
    input {
      flex-grow: 1;
    }
    .hide {
      display: none;
    }
    .placeholder {
      color: var(--deemphasized-text-color);
      padding-top: var(--spacing-m);
    }
  </style>
  <div class="wrapper gr-form-styles">
    <template is="dom-if" if="[[pluginOption.info.values.length]]">
      <div class="existingItems">
        <template is="dom-repeat" items="[[pluginOption.info.values]]">
          <div class="row">
            <span>[[item]]</span>
            <gr-button
              link=""
              disabled$="[[disabled]]"
              data-item$="[[item]]"
              on-click="_handleDelete"
              >Delete</gr-button
            >
          </div>
        </template>
      </div>
    </template>
    <template is="dom-if" if="[[!pluginOption.info.values.length]]">
      <div class="row placeholder">None configured.</div>
    </template>
    <div class$="row [[_computeShowInputRow(disabled)]]">
      <iron-input on-keydown="_handleInputKeydown" bind-value="{{_newValue}}">
        <input
          is="iron-input"
          id="input"
          on-keydown="_handleInputKeydown"
          bind-value="{{_newValue}}"
        />
      </iron-input>
      <gr-button
        id="addButton"
        disabled$="[[!_newValue.length]]"
        link=""
        on-click="_handleAddTap"
        >Add</gr-button
      >
    </div>
  </div>
`;var vm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let ym=class extends(oo(dr(oa))){constructor(){super(...arguments),this._newValue=""}static get template(){return fm}_computeDisabled(e){return!(e&&e.base&&e.base.info&&e.base.info.editable)}_handleAddTap(e){e.preventDefault(),this._handleAdd()}_handleInputKeydown(e){13===e.keyCode&&(e.preventDefault(),this._handleAdd())}_handleAdd(){this._newValue.length&&(this._dispatchChanged(this.pluginOption.info.values.concat([this._newValue])),this._newValue="")}_handleDelete(e){const t=qo(e).localTarget.dataset.item;this._dispatchChanged(this.pluginOption.info.values.filter(e=>e!==t))}_dispatchChanged(e){const{_key:t,info:n}=this.pluginOption,i={_key:t,info:{...n,values:e},notifyPath:`${t}.values`};this.dispatchEvent(new CustomEvent("plugin-config-option-changed",{detail:i}))}_computeShowInputRow(e){return e?"hide":""}};vm([Bl({type:String})],ym.prototype,"_newValue",void 0),vm([Bl({type:Object})],ym.prototype,"pluginOption",void 0),vm([Bl({type:Boolean,computed:"_computeDisabled(pluginOption.*)"})],ym.prototype,"disabled",void 0),ym=vm([Ml("gr-plugin-config-array-editor")],ym);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const bm=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-subpage-styles">
    .inherited {
      color: var(--deemphasized-text-color);
      margin-left: var(--spacing-m);
    }
    section.section:not(.ARRAY) .title {
      align-items: center;
      display: flex;
    }
    section.section.ARRAY .title {
      padding-top: var(--spacing-m);
    }
  </style>
  <div class="gr-form-styles">
    <fieldset>
      <h4>[[pluginData.name]]</h4>
      <template is="dom-repeat" items="[[_pluginConfigOptions]]" as="option">
        <section class$="section [[option.info.type]]">
          <span class="title">
            <gr-tooltip-content
              has-tooltip="[[option.info.description]]"
              show-icon="[[option.info.description]]"
              title="[[option.info.description]]"
            >
              <span>[[option.info.display_name]]</span>
            </gr-tooltip-content>
          </span>
          <span class="value">
            <template is="dom-if" if="[[_isArray(option.info.type)]]">
              <gr-plugin-config-array-editor
                on-plugin-config-option-changed="_handleArrayChange"
                plugin-option="[[option]]"
              ></gr-plugin-config-array-editor>
            </template>
            <template is="dom-if" if="[[_isBoolean(option.info.type)]]">
              <paper-toggle-button
                checked="[[_computeChecked(option.info.value)]]"
                on-change="_handleBooleanChange"
                data-option-key$="[[option._key]]"
                disabled$="[[_computeDisabled(option.info.editable)]]"
                on-tap="_onTapPluginBoolean"
              ></paper-toggle-button>
            </template>
            <template is="dom-if" if="[[_isList(option.info.type)]]">
              <gr-select
                bind-value$="[[option.info.value]]"
                on-change="_handleListChange"
              >
                <select
                  data-option-key$="[[option._key]]"
                  disabled$="[[_computeDisabled(option.info.editable)]]"
                >
                  <template
                    is="dom-repeat"
                    items="[[option.info.permitted_values]]"
                    as="value"
                  >
                    <option value$="[[value]]">[[value]]</option>
                  </template>
                </select>
              </gr-select>
            </template>
            <template is="dom-if" if="[[_isString(option.info.type)]]">
              <iron-input
                bind-value="[[option.info.value]]"
                on-input="_handleStringChange"
                data-option-key$="[[option._key]]"
                disabled$="[[_computeDisabled(option.info.editable)]]"
              >
                <input
                  is="iron-input"
                  value="[[option.info.value]]"
                  on-input="_handleStringChange"
                  data-option-key$="[[option._key]]"
                  disabled$="[[_computeDisabled(option.info.editable)]]"
                />
              </iron-input>
            </template>
            <template is="dom-if" if="[[option.info.inherited_value]]">
              <span class="inherited">
                (Inherited: [[option.info.inherited_value]])
              </span>
            </template>
          </span>
        </section>
      </template>
    </fieldset>
  </div>
`;var wm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Cm=class extends(oo(dr(oa))){static get template(){return bm}_computePluginConfigOptions(e){if(!e||!e.base||!e.base.config)return[];const t=e.base.config;return Object.keys(t).map(e=>({_key:e,info:t[e]}))}_isArray(e){return e===Ha.ARRAY}_isBoolean(e){return e===Ha.BOOLEAN}_isList(e){return e===Ha.LIST}_isString(e){return e===Ha.STRING||e===Ha.INT||e===Ha.LONG}_computeDisabled(e){return"false"===e}_computeChecked(e="false"){return JSON.parse(e)}_handleStringChange(e){const t=qo(e).localTarget,n=t.getAttribute("data-option-key"),i=this._buildConfigChangeInfo(t.value,n);this._handleChange(i)}_handleListChange(e){const t=qo(e).localTarget,n=t.getAttribute("data-option-key"),i=this._buildConfigChangeInfo(t.value,n);this._handleChange(i)}_handleBooleanChange(e){const t=qo(e).localTarget,n=t.getAttribute("data-option-key"),i=this._buildConfigChangeInfo(JSON.stringify(t.checked),n);this._handleChange(i)}_buildConfigChangeInfo(e,t){const n=this.pluginData.config[t];return n.value=null!==e?e:void 0,{_key:t,info:n,notifyPath:`${t}.value`}}_handleArrayChange(e){this._handleChange(e.detail)}_handleChange({_key:e,info:t,notifyPath:n}){const{name:i,config:o}=this.pluginData,s={name:i,config:{...o,[e]:t},notifyPath:`${i}.${n}`};this.dispatchEvent(new CustomEvent("plugin-config-changed",{detail:s,bubbles:!0,composed:!0}))}_onTapPluginBoolean(e){e.preventDefault()}};wm([Bl({type:Object})],Cm.prototype,"pluginData",void 0),wm([Bl({type:Array,computed:"_computePluginConfigOptions(pluginData.*)"})],Cm.prototype,"_pluginConfigOptions",void 0),Cm=wm([Ml("gr-repo-plugin-config")],Cm);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Em=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-subpage-styles">
    h2.edited:after {
      color: var(--deemphasized-text-color);
      content: ' *';
    }
    .loading,
    .hide {
      display: none;
    }
    #loading.loading {
      display: block;
    }
    #loading:not(.loading) {
      display: none;
    }
    #options .repositorySettings {
      display: none;
    }
    #options .repositorySettings.showConfig {
      display: block;
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <main class="gr-form-styles read-only">
    <style include="shared-styles">
      /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
    </style>
    <div class="info">
      <h1 id="Title" class="heading-1">
        [[repo]]
        <hr />
      </h1>
      <div>
        <a href$="[[_computeChangesUrl(repo)]]">(view changes)</a>
      </div>
    </div>
    <div id="loading" class$="[[_computeLoadingClass(_loading)]]">
      Loading...
    </div>
    <div id="loadedContent" class$="[[_computeLoadingClass(_loading)]]">
      <div id="downloadContent" class$="[[_computeHideClass(_schemes)]]">
        <h2 id="download" class="heading-2">Download</h2>
        <fieldset>
          <gr-download-commands
            id="downloadCommands"
            commands="[[_computeCommands(repo, _schemesObj, _selectedScheme)]]"
            schemes="[[_schemes]]"
            selected-scheme="{{_selectedScheme}}"
          ></gr-download-commands>
        </fieldset>
      </div>
      <h2
        id="configurations"
        class$="heading-2 [[_computeHeaderClass(_configChanged)]]"
      >
        Configurations
      </h2>
      <div id="form">
        <fieldset>
          <h3 id="Description" class="heading-3">Description</h3>
          <fieldset>
            <iron-autogrow-textarea
              id="descriptionInput"
              class="description"
              autocomplete="on"
              placeholder="<Insert repo description here>"
              bind-value="{{_repoConfig.description}}"
              disabled$="[[_readOnly]]"
            ></iron-autogrow-textarea>
          </fieldset>
          <h3 id="Options" class="heading-3">Repository Options</h3>
          <fieldset id="options">
            <section>
              <span class="title">State</span>
              <span class="value">
                <gr-select id="stateSelect" bind-value="{{_repoConfig.state}}">
                  <select disabled$="[[_readOnly]]">
                    <template is="dom-repeat" items="[[_states]]">
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">Submit type</span>
              <span class="value">
                <gr-select
                  id="submitTypeSelect"
                  bind-value="{{_repoConfig.submit_type}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatSubmitTypeSelect(_repoConfig)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">Allow content merges</span>
              <span class="value">
                <gr-select
                  id="contentMergeSelect"
                  bind-value="{{_repoConfig.use_content_merge.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.use_content_merge)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">
                Create a new change for every commit not in the target branch
              </span>
              <span class="value">
                <gr-select
                  id="newChangeSelect"
                  bind-value="{{_repoConfig.create_new_change_for_all_not_in_target.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.create_new_change_for_all_not_in_target)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">Require Change-Id in commit message</span>
              <span class="value">
                <gr-select
                  id="requireChangeIdSelect"
                  bind-value="{{_repoConfig.require_change_id.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.require_change_id)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section
              id="enableSignedPushSettings"
              class$="repositorySettings [[_computeRepositoriesClass(_repoConfig.enable_signed_push)]]"
            >
              <span class="title">Enable signed push</span>
              <span class="value">
                <gr-select
                  id="enableSignedPush"
                  bind-value="{{_repoConfig.enable_signed_push.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.enable_signed_push)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section
              id="requireSignedPushSettings"
              class$="repositorySettings [[_computeRepositoriesClass(_repoConfig.require_signed_push)]]"
            >
              <span class="title">Require signed push</span>
              <span class="value">
                <gr-select
                  id="requireSignedPush"
                  bind-value="{{_repoConfig.require_signed_push.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.require_signed_push)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">
                Reject implicit merges when changes are pushed for review</span
              >
              <span class="value">
                <gr-select
                  id="rejectImplicitMergesSelect"
                  bind-value="{{_repoConfig.reject_implicit_merges.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.reject_implicit_merges)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">
                Enable adding unregistered users as reviewers and CCs on
                changes</span
              >
              <span class="value">
                <gr-select
                  id="unRegisteredCcSelect"
                  bind-value="{{_repoConfig.enable_reviewer_by_email.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.enable_reviewer_by_email)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title"> Set all new changes private by default</span>
              <span class="value">
                <gr-select
                  id="setAllnewChangesPrivateByDefaultSelect"
                  bind-value="{{_repoConfig.private_by_default.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.private_by_default)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">
                Set new changes to "work in progress" by default</span
              >
              <span class="value">
                <gr-select
                  id="setAllNewChangesWorkInProgressByDefaultSelect"
                  bind-value="{{_repoConfig.work_in_progress_by_default.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.work_in_progress_by_default)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">Maximum Git object size limit</span>
              <span class="value">
                <iron-input
                  id="maxGitObjSizeIronInput"
                  bind-value="{{_repoConfig.max_object_size_limit.configured_value}}"
                  type="text"
                  disabled$="[[_readOnly]]"
                >
                  <input
                    id="maxGitObjSizeInput"
                    bind-value="{{_repoConfig.max_object_size_limit.configured_value}}"
                    is="iron-input"
                    type="text"
                    disabled$="[[_readOnly]]"
                  />
                </iron-input>
                <template
                  is="dom-if"
                  if="[[_repoConfig.max_object_size_limit.value]]"
                >
                  effective: [[_repoConfig.max_object_size_limit.value]] bytes
                </template>
              </span>
            </section>
            <section>
              <span class="title"
                >Match authored date with committer date upon submit</span
              >
              <span class="value">
                <gr-select
                  id="matchAuthoredDateWithCommitterDateSelect"
                  bind-value="{{_repoConfig.match_author_to_committer_date.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.match_author_to_committer_date)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">Reject empty commit upon submit</span>
              <span class="value">
                <gr-select
                  id="rejectEmptyCommitSelect"
                  bind-value="{{_repoConfig.reject_empty_commit.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.reject_empty_commit)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
          </fieldset>
          <h3 id="Options" class="heading-3">Contributor Agreements</h3>
          <fieldset id="agreements">
            <section>
              <span class="title">
                Require a valid contributor agreement to upload</span
              >
              <span class="value">
                <gr-select
                  id="contributorAgreementSelect"
                  bind-value="{{_repoConfig.use_contributor_agreements.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.use_contributor_agreements)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
            <section>
              <span class="title">Require Signed-off-by in commit message</span>
              <span class="value">
                <gr-select
                  id="useSignedOffBySelect"
                  bind-value="{{_repoConfig.use_signed_off_by.configured_value}}"
                >
                  <select disabled$="[[_readOnly]]">
                    <template
                      is="dom-repeat"
                      items="[[_formatBooleanSelect(_repoConfig.use_signed_off_by)]]"
                    >
                      <option value="[[item.value]]">[[item.label]]</option>
                    </template>
                  </select>
                </gr-select>
              </span>
            </section>
          </fieldset>
          <div
            class$="pluginConfig [[_computeHideClass(_pluginData)]]"
            on-plugin-config-changed="_handlePluginConfigChanged"
          >
            <h3 class="heading-3">Plugins</h3>
            <template is="dom-repeat" items="[[_pluginData]]" as="data">
              <gr-repo-plugin-config
                plugin-data="[[data]]"
              ></gr-repo-plugin-config>
            </template>
          </div>
          <gr-button
            on-click="_handleSaveRepoConfig"
            disabled$="[[_computeButtonDisabled(_readOnly, _configChanged)]]"
            >Save changes</gr-button
          >
        </fieldset>
        <gr-endpoint-decorator name="repo-config">
          <gr-endpoint-param
            name="repoName"
            value="[[repo]]"
          ></gr-endpoint-param>
          <gr-endpoint-param
            name="readOnly"
            value="[[_readOnly]]"
          ></gr-endpoint-param>
        </gr-endpoint-decorator>
      </div>
    </div>
  </main>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Sm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Am={active:{value:Ba.ACTIVE,label:"Active"},readOnly:{value:Ba.READ_ONLY,label:"Read Only"},hidden:{value:Ba.HIDDEN,label:"Hidden"}},xm={mergeIfNecessary:{value:"MERGE_IF_NECESSARY",label:"Merge if necessary"},fastForwardOnly:{value:"FAST_FORWARD_ONLY",label:"Fast forward only"},rebaseAlways:{value:"REBASE_ALWAYS",label:"Rebase Always"},rebaseIfNecessary:{value:"REBASE_IF_NECESSARY",label:"Rebase if necessary"},mergeAlways:{value:"MERGE_ALWAYS",label:"Merge always"},cherryPick:{value:"CHERRY_PICK",label:"Cherry pick"}};let Pm=class extends(oo(dr(oa))){constructor(){super(...arguments),this._configChanged=!1,this._loading=!0,this._loggedIn=!1,this._readOnly=!0,this._states=Object.values(Am),this._schemes=[],this._schemesDefault=[],this._selectedCommand="Clone"}static get template(){return Em}attached(){super.attached(),this._loadRepo(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:this.repo},composed:!0,bubbles:!0}))}_computePluginData(e){if(!e||!e.base)return[];const t=e.base;return Object.keys(t).map(e=>({name:e,config:t[e]}))}_loadRepo(){if(!this.repo)return Promise.resolve();const e=[];return e.push(this._getLoggedIn().then(e=>{if(this._loggedIn=e,e){const e=this.repo;if(!e)throw new Error("undefined repo");this.$.restAPI.getRepoAccess(e).then(t=>{t&&this.repo===e&&(this._readOnly=!t[e].is_owner)})}})),e.push(this.$.restAPI.getProjectConfig(this.repo,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(e=>{e&&(e.default_submit_type&&(e.submit_type=e.default_submit_type.configured_value),e.state||(e.state=Am.active.value),this._repoConfig=e,this._loading=!1)})),e.push(this.$.restAPI.getConfig().then(e=>{e&&(this._schemesObj=e.download.schemes)})),Promise.all(e)}_computeLoadingClass(e){return e?"loading":""}_computeHideClass(e){return e&&e.length?"":"hide"}_loggedInChanged(e){e&&this.$.restAPI.getPreferences().then(e=>{(null==e?void 0:e.download_scheme)&&(this._selectedScheme=e.download_scheme.toLowerCase())})}_formatBooleanSelect(e){if(!e)return;let t="Inherit";return void 0!==e.inherited_value&&(t=`Inherit (${e.inherited_value})`),[{label:t,value:"INHERIT"},{label:"True",value:"TRUE"},{label:"False",value:"FALSE"}]}_formatSubmitTypeSelect(e){if(!e)return;const t=Object.values(xm),n=e.default_submit_type;if(!n)return t;let i="Inherit";if(n.inherited_value){i=`Inherit (${n.inherited_value})`;for(const e of t)if(e.value===n.inherited_value){i=`Inherit (${e.label})`;break}}return[{label:i,value:"INHERIT"},...t]}_isLoading(){return this._loading||void 0===this._loading}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_formatRepoConfigForSave(e){const t={};for(const n of Object.keys(e)){const i=n;if("default_submit_type"!==i)if("plugin_config"===i)t.plugin_config_values=e.plugin_config;else if("object"==typeof e[i]){const n=e[i];n.configured_value&&(t[i]=n.configured_value)}else t[i]=e[i]}return t}_handleSaveRepoConfig(){return this._repoConfig&&this.repo?this.$.restAPI.saveRepoConfig(this.repo,this._formatRepoConfigForSave(this._repoConfig)).then(()=>{this._configChanged=!1}):Promise.reject(new Error("undefined repoConfig or repo"))}_handleConfigChanged(){this._isLoading()||(this._configChanged=!0)}_computeButtonDisabled(e,t){return e||!t}_computeHeaderClass(e){return e?"edited":""}_computeSchemes(e,t){return t?Object.keys(t):e}_schemesChanged(e){0!==e.length&&(this._selectedScheme&&e.includes(this._selectedScheme)||(this._selectedScheme=e.sort()[0]))}_computeCommands(e,t,n){if(!t||!e||!n)return[];const i=[];let s={};o(t,n)&&(s=t[n].clone_commands);for(const t in s)o(s,t)&&i.push({title:t,command:s[t].replace(/\${project}/gi,encodeURI(e)).replace(/\${project-base-name}/gi,encodeURI(e.substring(e.lastIndexOf("/")+1)))});return i}_computeRepositoriesClass(e){return e?"showConfig":""}_computeChangesUrl(e){return gh.getUrlForProjectChanges(e)}_handlePluginConfigChanged({detail:{name:e,config:t,notifyPath:n}}){var i;(null===(i=this._repoConfig)||void 0===i?void 0:i.plugin_config)&&(this._repoConfig.plugin_config[e]=t,this.notifyPath("_repoConfig.plugin_config."+n))}};Sm([Bl({type:String})],Pm.prototype,"repo",void 0),Sm([Bl({type:Boolean})],Pm.prototype,"_configChanged",void 0),Sm([Bl({type:Boolean})],Pm.prototype,"_loading",void 0),Sm([Bl({type:Boolean,observer:"_loggedInChanged"})],Pm.prototype,"_loggedIn",void 0),Sm([Bl({type:Object})],Pm.prototype,"_repoConfig",void 0),Sm([Bl({type:Array,computed:"_computePluginData(_repoConfig.plugin_config.*)"})],Pm.prototype,"_pluginData",void 0),Sm([Bl({type:Boolean})],Pm.prototype,"_readOnly",void 0),Sm([Bl({type:Array})],Pm.prototype,"_states",void 0),Sm([Bl({type:Array,computed:"_computeSchemes(_schemesDefault, _schemesObj)",observer:"_schemesChanged"})],Pm.prototype,"_schemes",void 0),Sm([Bl({type:Array})],Pm.prototype,"_schemesDefault",void 0),Sm([Bl({type:String})],Pm.prototype,"_selectedCommand",void 0),Sm([Bl({type:String})],Pm.prototype,"_selectedScheme",void 0),Sm([Bl({type:Object})],Pm.prototype,"_schemesObj",void 0),Sm([jl("_repoConfig.*")],Pm.prototype,"_handleConfigChanged",null),Pm=Sm([Ml("gr-repo")],Pm);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Rm=ta`
  <style include="shared-styles">
    :host {
      border-bottom: 1px solid var(--border-color);
      padding: var(--spacing-m);
      display: block;
    }
    #removeBtn {
      display: none;
    }
    .editing #removeBtn {
      display: flex;
    }
    #options {
      align-items: baseline;
      display: flex;
    }
    #options > * {
      margin-right: var(--spacing-m);
    }
    #mainContainer {
      align-items: baseline;
      display: flex;
      flex-wrap: nowrap;
      justify-content: space-between;
    }
    #deletedContainer.deleted {
      align-items: baseline;
      display: flex;
      justify-content: space-between;
    }
    #undoBtn,
    #force,
    #deletedContainer,
    #mainContainer.deleted {
      display: none;
    }
    #undoBtn.modified,
    #force.force {
      display: block;
    }
    .groupPath {
      color: var(--deemphasized-text-color);
    }
  </style>
  <style include="gr-form-styles">
    iron-autogrow-textarea {
      width: 14em;
    }
  </style>
  <div
    id="mainContainer"
    class$="gr-form-styles [[_computeSectionClass(editing, _deleted)]]"
  >
    <div id="options">
      <gr-select
        id="action"
        bind-value="{{rule.value.action}}"
        on-change="_handleValueChange"
      >
        <select disabled$="[[!editing]]">
          <template is="dom-repeat" items="[[_computeOptions(permission)]]">
            <option value="[[item]]">[[item]]</option>
          </template>
        </select>
      </gr-select>
      <template is="dom-if" if="[[label]]">
        <gr-select
          id="labelMin"
          bind-value="{{rule.value.min}}"
          on-change="_handleValueChange"
        >
          <select disabled$="[[!editing]]">
            <template is="dom-repeat" items="[[label.values]]">
              <option value="[[item.value]]">[[item.value]]</option>
            </template>
          </select>
        </gr-select>
        <gr-select
          id="labelMax"
          bind-value="{{rule.value.max}}"
          on-change="_handleValueChange"
        >
          <select disabled$="[[!editing]]">
            <template is="dom-repeat" items="[[label.values]]">
              <option value="[[item.value]]">[[item.value]]</option>
            </template>
          </select>
        </gr-select>
      </template>
      <template is="dom-if" if="[[hasRange]]">
        <iron-autogrow-textarea
          id="minInput"
          class="min"
          autocomplete="on"
          placeholder="Min value"
          bind-value="{{rule.value.min}}"
          disabled$="[[!editing]]"
        ></iron-autogrow-textarea>
        <iron-autogrow-textarea
          id="maxInput"
          class="max"
          autocomplete="on"
          placeholder="Max value"
          bind-value="{{rule.value.max}}"
          disabled$="[[!editing]]"
        ></iron-autogrow-textarea>
      </template>
      <a class="groupPath" href$="[[_computeGroupPath(groupId)]]">
        [[groupName]]
      </a>
      <gr-select
        id="force"
        class$="[[_computeForceClass(permission, rule.value.action)]]"
        bind-value="{{rule.value.force}}"
        on-change="_handleValueChange"
      >
        <select disabled$="[[!editing]]">
          <template
            is="dom-repeat"
            items="[[_computeForceOptions(permission, rule.value.action)]]"
          >
            <option value="[[item.value]]">[[item.name]]</option>
          </template>
        </select>
      </gr-select>
    </div>
    <gr-button link="" id="removeBtn" on-click="_handleRemoveRule"
      >Remove</gr-button
    >
  </div>
  <div
    id="deletedContainer"
    class$="gr-form-styles [[_computeSectionClass(editing, _deleted)]]"
  >
    [[groupName]] was deleted
    <gr-button link="" id="undoRemoveBtn" on-click="_handleUndoRemove"
      >Undo</gr-button
    >
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Tm;!function(e){e.ABANDON="abandon",e.ADD_PATCH_SET="addPatchSet",e.CREATE="create",e.CREATE_TAG="createTag",e.CREATE_SIGNED_TAG="createSignedTag",e.DELETE="delete",e.DELETE_CHANGES="deleteChanges",e.DELETE_OWN_CHANGES="deleteOwnChanges",e.EDIT_ASSIGNEE="editAssignee",e.EDIT_HASHTAGS="editHashtags",e.EDIT_TOPIC_NAME="editTopicName",e.FORGE_AUTHOR="forgeAuthor",e.FORGE_COMMITTER="forgeCommitter",e.FORGE_SERVER_AS_COMMITTER="forgeServerAsCommitter",e.OWNER="owner",e.PUBLISH_DRAFTS="publishDrafts",e.PUSH="push",e.PUSH_MERGE="pushMerge",e.READ="read",e.REBASE="rebase",e.REVERT="revert",e.REMOVE_REVIEWER="removeReviewer",e.SUBMIT="submit",e.SUBMIT_AS="submitAs",e.TOGGLE_WIP_STATE="toggleWipState",e.VIEW_PRIVATE_CHANGES="viewPrivateChanges",e.PRIORITY="priority"}(Tm||(Tm={}));const Im={[Tm.ABANDON]:{id:Tm.ABANDON,name:"Abandon"},[Tm.ADD_PATCH_SET]:{id:Tm.ADD_PATCH_SET,name:"Add Patch Set"},[Tm.CREATE]:{id:Tm.CREATE,name:"Create Reference"},[Tm.CREATE_TAG]:{id:Tm.CREATE_TAG,name:"Create Annotated Tag"},[Tm.CREATE_SIGNED_TAG]:{id:Tm.CREATE_SIGNED_TAG,name:"Create Signed Tag"},[Tm.DELETE]:{id:Tm.DELETE,name:"Delete Reference"},[Tm.DELETE_CHANGES]:{id:Tm.DELETE_CHANGES,name:"Delete Changes"},[Tm.DELETE_OWN_CHANGES]:{id:Tm.DELETE_OWN_CHANGES,name:"Delete Own Changes"},[Tm.EDIT_ASSIGNEE]:{id:Tm.EDIT_ASSIGNEE,name:"Edit Assignee"},[Tm.EDIT_HASHTAGS]:{id:Tm.EDIT_HASHTAGS,name:"Edit Hashtags"},[Tm.EDIT_TOPIC_NAME]:{id:Tm.EDIT_TOPIC_NAME,name:"Edit Topic Name"},[Tm.FORGE_AUTHOR]:{id:Tm.FORGE_AUTHOR,name:"Forge Author Identity"},[Tm.FORGE_COMMITTER]:{id:Tm.FORGE_COMMITTER,name:"Forge Committer Identity"},[Tm.FORGE_SERVER_AS_COMMITTER]:{id:Tm.FORGE_SERVER_AS_COMMITTER,name:"Forge Server Identity"},[Tm.OWNER]:{id:Tm.OWNER,name:"Owner"},[Tm.PUBLISH_DRAFTS]:{id:Tm.PUBLISH_DRAFTS,name:"Publish Drafts"},[Tm.PUSH]:{id:Tm.PUSH,name:"Push"},[Tm.PUSH_MERGE]:{id:Tm.PUSH_MERGE,name:"Push Merge Commit"},[Tm.READ]:{id:Tm.READ,name:"Read"},[Tm.REBASE]:{id:Tm.REBASE,name:"Rebase"},[Tm.REVERT]:{id:Tm.REVERT,name:"Revert"},[Tm.REMOVE_REVIEWER]:{id:Tm.REMOVE_REVIEWER,name:"Remove Reviewer"},[Tm.SUBMIT]:{id:Tm.SUBMIT,name:"Submit"},[Tm.SUBMIT_AS]:{id:Tm.SUBMIT_AS,name:"Submit (On Behalf Of)"},[Tm.TOGGLE_WIP_STATE]:{id:Tm.TOGGLE_WIP_STATE,name:"Toggle Work In Progress State"},[Tm.VIEW_PRIVATE_CHANGES]:{id:Tm.VIEW_PRIVATE_CHANGES,name:"View Private Changes"}};function km(e){return e?Object.keys(e).map(t=>({id:t,value:e[t]})).sort((e,t)=>e.id.localeCompare(t.id)):[]}var Om=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Nm=["BATCH","INTERACTIVE"],Lm="ALLOW",Dm="DENY",$m="BLOCK",Mm=[Lm,Dm,$m],Fm=[{name:"Allow pushing (but not force pushing)",value:!1},{name:"Allow pushing with or without force",value:!0}],Bm=[{name:"Block pushing with or without force",value:!1},{name:"Block force pushing",value:!0}],jm=[{name:"No Force Edit",value:!1},{name:"Force Edit",value:!0}];let Hm=class extends(oo(dr(oa))){constructor(){super(...arguments),this.editing=!1,this._deleted=!1}static get template(){return Rm}created(){super.created(),this.addEventListener("access-saved",()=>this._handleAccessSaved())}ready(){super.ready(),this.rule&&this._setupValues(this.rule)}attached(){super.attached(),!this._originalRuleValues&&this.rule&&this._setOriginalRuleValues(this.rule.value)}_setupValues(e){e.value||this._setDefaultRuleValues()}_computeForce(e,t){return Tm.PUSH===e&&t!==Dm||Tm.EDIT_TOPIC_NAME===e}_computeForceClass(e,t){return this._computeForce(e,t)?"force":""}_computeGroupPath(e){return`${j()}/admin/groups/${G(e,!0)}`}_handleAccessSaved(){this.rule&&this._setOriginalRuleValues(this.rule.value)}_handleEditingChanged(e,t){t&&(e||this._handleUndoChange())}_computeSectionClass(e,t){const n=[];return e&&n.push("editing"),t&&n.push("deleted"),n.join(" ")}_computeForceOptions(e,t){return e===Tm.PUSH?t===Lm?Fm:t===$m?Bm:[]:e===Tm.EDIT_TOPIC_NAME?jm:[]}_getDefaultRuleValues(e,t){const n=Lm,i={};return e===Tm.PRIORITY?(i.action=Nm[0],i):(t?(i.min=t.values[0].value,i.max=t.values[t.values.length-1].value):this._computeForce(e,n)&&(i.force=this._computeForceOptions(e,n)[0].value),i.action=Mm[0],i)}_setDefaultRuleValues(){this.set("rule.value",this._getDefaultRuleValues(this.permission,this.label))}_computeOptions(e){return"priority"===e?Nm:Mm}_handleRemoveRule(){this.rule&&(this.rule.value.added&&this.dispatchEvent(new CustomEvent("added-rule-removed",{bubbles:!0,composed:!0})),this._deleted=!0,this.rule.value.deleted=!0,this.dispatchEvent(new CustomEvent("access-modified",{bubbles:!0,composed:!0})))}_handleUndoRemove(){this.rule&&(this._deleted=!1,delete this.rule.value.deleted)}_handleUndoChange(){this.rule&&(this.rule.value.added||(this.set("rule.value",{...this._originalRuleValues}),this._deleted=!1,delete this.rule.value.deleted,delete this.rule.value.modified))}_handleValueChange(){this._originalRuleValues&&this.rule&&(this.rule.value.modified=!0,this.dispatchEvent(new CustomEvent("access-modified",{bubbles:!0,composed:!0})))}_setOriginalRuleValues(e){this._originalRuleValues={...e}}};Om([Bl({type:Boolean})],Hm.prototype,"hasRange",void 0),Om([Bl({type:Object})],Hm.prototype,"label",void 0),Om([Bl({type:Boolean,observer:"_handleEditingChanged"})],Hm.prototype,"editing",void 0),Om([Bl({type:String})],Hm.prototype,"groupId",void 0),Om([Bl({type:String})],Hm.prototype,"groupName",void 0),Om([Bl({type:String})],Hm.prototype,"permission",void 0),Om([Bl({type:Object,notify:!0})],Hm.prototype,"rule",void 0),Om([Bl({type:String})],Hm.prototype,"section",void 0),Om([Bl({type:Boolean})],Hm.prototype,"_deleted",void 0),Om([Bl({type:Object})],Hm.prototype,"_originalRuleValues",void 0),Om([jl("rule.value.*")],Hm.prototype,"_handleValueChange",null),Hm=Om([Ml("gr-rule-editor")],Hm);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Um=ta`
  <style include="shared-styles">
    :host {
      display: block;
      margin-bottom: var(--spacing-m);
    }
    .header {
      align-items: baseline;
      display: flex;
      justify-content: space-between;
      margin: var(--spacing-s) var(--spacing-m);
    }
    .rules {
      background: var(--table-header-background-color);
      border: 1px solid var(--border-color);
      border-bottom: 0;
    }
    .editing .rules {
      border-bottom: 1px solid var(--border-color);
    }
    .title {
      margin-bottom: var(--spacing-s);
    }
    #addRule,
    #removeBtn {
      display: none;
    }
    .right {
      display: flex;
      align-items: center;
    }
    .editing #removeBtn {
      display: block;
      margin-left: var(--spacing-xl);
    }
    .editing #addRule {
      display: block;
      padding: var(--spacing-m);
    }
    #deletedContainer,
    .deleted #mainContainer {
      display: none;
    }
    .deleted #deletedContainer {
      align-items: baseline;
      border: 1px solid var(--border-color);
      display: flex;
      justify-content: space-between;
      padding: var(--spacing-m);
    }
    #mainContainer {
      display: block;
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-menu-page-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <section
    id="permission"
    class$="gr-form-styles [[_computeSectionClass(editing, _deleted)]]"
  >
    <div id="mainContainer">
      <div class="header">
        <span class="title">[[name]]</span>
        <div class="right">
          <template
            is="dom-if"
            if="[[!_permissionIsOwnerOrGlobal(permission.id, section)]]"
          >
            <paper-toggle-button
              id="exclusiveToggle"
              checked="{{permission.value.exclusive}}"
              on-change="_handleValueChange"
              disabled$="[[!editing]]"
              on-tap="_onTapExclusiveToggle"
            ></paper-toggle-button
            >Exclusive
          </template>
          <gr-button link="" id="removeBtn" on-click="_handleRemovePermission"
            >Remove</gr-button
          >
        </div>
      </div>
      <!-- end header -->
      <div class="rules">
        <template is="dom-repeat" items="{{_rules}}" as="rule">
          <gr-rule-editor
            has-range="[[_computeHasRange(name)]]"
            label="[[_label]]"
            editing="[[editing]]"
            group-id="[[rule.id]]"
            group-name="[[_computeGroupName(groups, rule.id)]]"
            permission="[[permission.id]]"
            rule="{{rule}}"
            section="[[section]]"
            on-added-rule-removed="_handleAddedRuleRemoved"
          ></gr-rule-editor>
        </template>
        <div id="addRule">
          <gr-autocomplete
            id="groupAutocomplete"
            text="{{_groupFilter}}"
            query="[[_query]]"
            placeholder="Add group"
            on-commit="_handleAddRuleItem"
          >
          </gr-autocomplete>
        </div>
        <!-- end addRule -->
      </div>
      <!-- end rules -->
    </div>
    <!-- end mainContainer -->
    <div id="deletedContainer">
      <span>[[name]] was deleted</span>
      <gr-button link="" id="undoRemoveBtn" on-click="_handleUndoRemove"
        >Undo</gr-button
      >
    </div>
    <!-- end deletedContainer -->
  </section>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var Gm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Vm=["QUERY LIMIT","BATCH CHANGES LIMIT"];let zm=class extends(oo(dr(oa))){constructor(){super(),this.editing=!1,this._deleted=!1,this._query=()=>this._getGroupSuggestions()}static get template(){return Um}created(){super.created(),this.addEventListener("access-saved",()=>this._handleAccessSaved())}ready(){super.ready(),this._setupValues()}_setupValues(){this.permission&&(this._originalExclusiveValue=!!this.permission.value.exclusive,Mo())}_handleAccessSaved(){this._setupValues()}_permissionIsOwnerOrGlobal(e,t){return"owner"===e||"GLOBAL_CAPABILITIES"===t}_handleEditingChanged(e,t){if(t&&this.permission&&this._rules&&!e){this._deleted=!1,delete this.permission.value.deleted,this._groupFilter="",this._rules=this._rules.filter(e=>!e.value.added);for(const e of Object.keys(this.permission.value.rules))this.permission.value.rules[e].added&&delete this.permission.value.rules[e];this.set(["permission","value","exclusive"],this._originalExclusiveValue)}}_handleAddedRuleRemoved(e){if(!this._rules)return;const t=e.model.index;this._rules=this._rules.slice(0,t).concat(this._rules.slice(t+1,this._rules.length))}_handleValueChange(){this.permission&&(this.permission.value.modified=!0,this.dispatchEvent(new CustomEvent("access-modified",{bubbles:!0,composed:!0})))}_handleRemovePermission(){this.permission&&(this.permission.value.added&&this.dispatchEvent(new CustomEvent("added-permission-removed",{bubbles:!0,composed:!0})),this._deleted=!0,this.permission.value.deleted=!0,this.dispatchEvent(new CustomEvent("access-modified",{bubbles:!0,composed:!0})))}_handleRulesChanged(){this._rules&&(this._groupsWithRules=this._computeGroupsWithRules(this._rules))}_sortPermission(e){this._rules=km(e.value.rules)}_computeSectionClass(e,t){const n=[];return e&&n.push("editing"),t&&n.push("deleted"),n.join(" ")}_handleUndoRemove(){this.permission&&(this._deleted=!1,delete this.permission.value.deleted)}_computeLabel(e,t){if(!(t&&e&&e.value&&e.value.label))return;const n=e.value.label;return t[n]?{name:n,values:this._computeLabelValues(t[n].values)}:void 0}_computeLabelValues(e){const t=[],n=Object.keys(e).sort((e,t)=>parseInt(e,10)-parseInt(t,10));for(const i of n){let n=e[i];n||(n=""),t.push({value:parseInt(i,10),text:n})}return t}_computeGroupsWithRules(e){const t={};for(const n of e)t[n.id]=!0;return t}_computeGroupName(e,t){return e&&e[t]&&e[t].name?e[t].name:t}_getGroupSuggestions(){return this.$.restAPI.getSuggestedGroups(this._groupFilter||"",20).then(e=>{const t=[];for(const n in e)o(e,n)&&t.push({name:n,value:e[n]});return t.filter(e=>this._groupsWithRules&&!this._groupsWithRules[e.value.id]).map(e=>({name:e.name,value:e.value.id}))})}_handleAddRuleItem(e){if(!this.permission||!this._rules)return;const t=decodeURIComponent(e.detail.value).replace(/\+/g," ");this.permission.value.rules[t]={},this.push("_rules",{id:t}),this.groups&&!this.groups[t]&&(this.groups[t]={name:this.$.groupAutocomplete.text}),Mo();const n=this._rules[this._rules.length-1].value;n.added=!0,this.permission.value.rules[t]=n,this.dispatchEvent(new CustomEvent("access-modified",{bubbles:!0,composed:!0}))}_computeHasRange(e){return!!e&&Vm.includes(e.toUpperCase())}_onTapExclusiveToggle(e){e.preventDefault()}};Gm([Bl({type:Object})],zm.prototype,"labels",void 0),Gm([Bl({type:String})],zm.prototype,"name",void 0),Gm([Bl({type:Object,observer:"_sortPermission",notify:!0})],zm.prototype,"permission",void 0),Gm([Bl({type:Object})],zm.prototype,"groups",void 0),Gm([Bl({type:String})],zm.prototype,"section",void 0),Gm([Bl({type:Boolean,observer:"_handleEditingChanged"})],zm.prototype,"editing",void 0),Gm([Bl({type:Object,computed:"_computeLabel(permission, labels)"})],zm.prototype,"_label",void 0),Gm([Bl({type:String})],zm.prototype,"_groupFilter",void 0),Gm([Bl({type:Object})],zm.prototype,"_query",void 0),Gm([Bl({type:Array})],zm.prototype,"_rules",void 0),Gm([Bl({type:Object})],zm.prototype,"_groupsWithRules",void 0),Gm([Bl({type:Boolean})],zm.prototype,"_deleted",void 0),Gm([Bl({type:Boolean})],zm.prototype,"_originalExclusiveValue",void 0),Gm([jl("_rules.splices")],zm.prototype,"_handleRulesChanged",null),zm=Gm([Ml("gr-permission")],zm);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Wm=ta`
  <style include="shared-styles">
    :host {
      display: block;
      margin-bottom: var(--spacing-l);
    }
    fieldset {
      border: 1px solid var(--border-color);
    }
    .name {
      align-items: center;
      display: flex;
    }
    .header,
    #deletedContainer {
      align-items: center;
      background: var(--table-header-background-color);
      border-bottom: 1px dotted var(--border-color);
      display: flex;
      justify-content: space-between;
      min-height: 3em;
      padding: 0 var(--spacing-m);
    }
    #deletedContainer {
      border-bottom: 0;
    }
    .sectionContent {
      padding: var(--spacing-m);
    }
    #editBtn,
    .editing #editBtn.global,
    #deletedContainer,
    .deleted #mainContainer,
    #addPermission,
    #deleteBtn,
    .editingRef .name,
    .editRefInput {
      display: none;
    }
    .editing #editBtn,
    .editingRef .editRefInput {
      display: flex;
    }
    .deleted #deletedContainer {
      display: flex;
    }
    .editing #addPermission,
    #mainContainer,
    .editing #deleteBtn {
      display: block;
    }
    .editing #deleteBtn,
    #undoRemoveBtn {
      padding-right: var(--spacing-m);
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <fieldset
    id="section"
    class$="gr-form-styles [[_computeSectionClass(editing, canUpload, ownerOf, _editingRef, _deleted)]]"
  >
    <div id="mainContainer">
      <div class="header">
        <div class="name">
          <h3 class="heading-3">[[_computeSectionName(section.id)]]</h3>
          <gr-button
            id="editBtn"
            link=""
            class$="[[_computeEditBtnClass(section.id)]]"
            on-click="editReference"
          >
            <iron-icon id="icon" icon="gr-icons:create"></iron-icon>
          </gr-button>
        </div>
        <iron-input
          class="editRefInput"
          bind-value="{{section.id}}"
          type="text"
          on-input="_handleValueChange"
        >
          <input
            class="editRefInput"
            bind-value="{{section.id}}"
            is="iron-input"
            type="text"
            on-input="_handleValueChange"
          />
        </iron-input>
        <gr-button link="" id="deleteBtn" on-click="_handleRemoveReference"
          >Remove</gr-button
        >
      </div>
      <!-- end header -->
      <div class="sectionContent">
        <template is="dom-repeat" items="{{_permissions}}" as="permission">
          <gr-permission
            name="[[_computePermissionName(section.id, permission, capabilities)]]"
            permission="{{permission}}"
            labels="[[labels]]"
            section="[[section.id]]"
            editing="[[editing]]"
            groups="[[groups]]"
            on-added-permission-removed="_handleAddedPermissionRemoved"
          >
          </gr-permission>
        </template>
        <div id="addPermission">
          Add permission:
          <select id="permissionSelect">
            <!-- called with a third parameter so that permissions update
                  after a new section is added. -->
            <template
              is="dom-repeat"
              items="[[_computePermissions(section.id, capabilities, labels, section.value.permissions.*)]]"
            >
              <option value="[[item.value.id]]">[[item.value.name]]</option>
            </template>
          </select>
          <gr-button link="" id="addBtn" on-click="_handleAddPermission"
            >Add</gr-button
          >
        </div>
        <!-- end addPermission -->
      </div>
      <!-- end sectionContent -->
    </div>
    <!-- end mainContainer -->
    <div id="deletedContainer">
      <span>[[_computeSectionName(section.id)]] was deleted</span>
      <gr-button link="" id="undoRemoveBtn" on-click="_handleUndoRemove"
        >Undo</gr-button
      >
    </div>
    <!-- end deletedContainer -->
  </fieldset>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var qm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Km="GLOBAL_CAPABILITIES";let Ym=class extends(oo(dr(oa))){constructor(){super(...arguments),this.editing=!1,this._editingRef=!1,this._deleted=!1}static get template(){return Wm}created(){super.created(),this.addEventListener("access-saved",()=>this._handleAccessSaved())}_updateSection(e){this._permissions=km(e.value.permissions),this._originalId=e.id}_handleAccessSaved(){this.section&&this._updateSection(this.section)}_handleValueChange(){this.section&&(this.section.value.added||(this.section.value.modified=this.section.id!==this._originalId,this.dispatchEvent(new CustomEvent("access-modified",{bubbles:!0,composed:!0}))),this.section.value.updatedId=this.section.id)}_handleEditingChanged(e,t){if(t&&this.section&&this._permissions&&!e){this._editingRef=!1,this._deleted=!1,delete this.section.value.deleted,this.set(["section","id"],this._originalId),this._permissions=this._permissions.filter(e=>!e.value.added);for(const e of Object.keys(this.section.value.permissions))this.section.value.permissions[e].added&&delete this.section.value.permissions[e]}}_computePermissions(e,t,n){let i;const o=this.section;if(!o||!o.value)return[];if(e===Km)i=km(t);else{i=this._computeLabelOptions(n).concat(km(Im))}return i.filter(e=>!o.value.permissions[e.id])}_computeHideEditClass(e){return"GLOBAL_CAPABILITIES"===e.id?"hide":""}_handleAddedPermissionRemoved(e){if(!this._permissions)return;const t=e.model.index;this._permissions=this._permissions.slice(0,t).concat(this._permissions.slice(t+1,this._permissions.length))}_computeLabelOptions(e){const t=[];if(!e)return[];for(const n of Object.keys(e))t.push({id:"label-"+n,value:{name:`Label ${n}`,id:"label-"+n}}),t.push({id:"labelAs-"+n,value:{name:`Label ${n} (On Behalf Of)`,id:"labelAs-"+n}});return t}_computePermissionName(e,t,n){if(e===Km)return n[t.id].name;if(Im[t.id])return Im[t.id].name;if(t.value.label){let e="";return t.id.startsWith("labelAs-")&&(e="(On Behalf Of)"),`Label ${t.value.label}${e}`}}_computeSectionName(e){return e||(this._editingRef=!0,e="refs/heads/*",this.set("section.id",e)),e===Km?"Global Capabilities":e.startsWith("refs/")?`Reference: ${e}`:e}_handleRemoveReference(){this.section&&(this.section.value.added&&this.dispatchEvent(new CustomEvent("added-section-removed",{bubbles:!0,composed:!0})),this._deleted=!0,this.section.value.deleted=!0,this.dispatchEvent(new CustomEvent("access-modified",{bubbles:!0,composed:!0})))}_handleUndoRemove(){this.section&&(this._deleted=!1,delete this.section.value.deleted)}editRefInput(){return this.root.querySelector(oa?"iron-input.editRefInput":"input[is=iron-input].editRefInput")}editReference(){this._editingRef=!0,this.editRefInput().focus()}_isEditEnabled(e,t,n){return e||t&&t.indexOf(n)>=0}_computeSectionClass(e,t,n,i,o){const s=[];return e&&this.section&&this._isEditEnabled(t,n,this.section.id)&&s.push("editing"),i&&s.push("editingRef"),o&&s.push("deleted"),s.join(" ")}_computeEditBtnClass(e){return e===Km?"global":""}_handleAddPermission(){const e=this.$.permissionSelect.value,t={id:e,value:{rules:{},added:!0}};e.startsWith("label")&&(t.value.label=e.replace("label-","").replace("labelAs-","")),this.push("_permissions",t),this.set(["section.value.permissions",t.id],t.value)}};qm([Bl({type:Object})],Ym.prototype,"capabilities",void 0),qm([Bl({type:Object,notify:!0,observer:"_updateSection"})],Ym.prototype,"section",void 0),qm([Bl({type:Object})],Ym.prototype,"groups",void 0),qm([Bl({type:Object})],Ym.prototype,"labels",void 0),qm([Bl({type:Boolean,observer:"_handleEditingChanged"})],Ym.prototype,"editing",void 0),qm([Bl({type:Boolean})],Ym.prototype,"canUpload",void 0),qm([Bl({type:Array})],Ym.prototype,"ownerOf",void 0),qm([Bl({type:String})],Ym.prototype,"_originalId",void 0),qm([Bl({type:Boolean})],Ym.prototype,"_editingRef",void 0),qm([Bl({type:Boolean})],Ym.prototype,"_deleted",void 0),qm([Bl({type:Array})],Ym.prototype,"_permissions",void 0),Ym=qm([Ml("gr-access-section")],Ym);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Xm=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-subpage-styles">
    gr-button,
    #inheritsFrom,
    #editInheritFromInput,
    .editing #inheritFromName,
    .weblinks,
    .editing .invisible {
      display: none;
    }
    #inheritsFrom.show {
      display: flex;
      min-height: 2em;
      align-items: center;
    }
    .weblink {
      margin-right: var(--spacing-xs);
    }
    gr-access-section {
      margin-top: var(--spacing-l);
    }
    .weblinks.show,
    .referenceContainer {
      display: block;
    }
    .rightsText {
      margin-right: var(--spacing-s);
    }

    .editing gr-button,
    .admin #editBtn {
      display: inline-block;
      margin: var(--spacing-l) 0;
    }
    .editing #editInheritFromInput {
      display: inline-block;
    }
  </style>
  <style include="gr-menu-page-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <main class$="[[_computeMainClass(_ownerOf, _canUpload, _editing)]]">
    <div id="loading" class$="[[_computeLoadingClass(_loading)]]">
      Loading...
    </div>
    <div id="loadedContent" class$="[[_computeLoadingClass(_loading)]]">
      <h3
        id="inheritsFrom"
        class$="heading-3 [[_computeShowInherit(_inheritsFrom)]]"
      >
        <span class="rightsText">Rights Inherit From</span>
        <a
          href$="[[_computeParentHref(_inheritsFrom.name)]]"
          rel="noopener"
          id="inheritFromName"
        >
          [[_inheritsFrom.name]]</a
        >
        <gr-autocomplete
          id="editInheritFromInput"
          text="{{_inheritFromFilter}}"
          query="[[_query]]"
          on-commit="_handleUpdateInheritFrom"
        ></gr-autocomplete>
      </h3>
      <div class$="weblinks [[_computeWebLinkClass(_weblinks)]]">
        History:
        <template is="dom-repeat" items="[[_weblinks]]" as="link">
          <a
            href="[[link.url]]"
            class="weblink"
            rel="noopener"
            target="[[link.target]]"
          >
            [[link.name]]
          </a>
        </template>
      </div>
      <template
        is="dom-repeat"
        items="{{_sections}}"
        initial-count="5"
        target-framerate="60"
        as="section"
      >
        <gr-access-section
          capabilities="[[_capabilities]]"
          section="{{section}}"
          labels="[[_labels]]"
          can-upload="[[_canUpload]]"
          editing="[[_editing]]"
          owner-of="[[_ownerOf]]"
          groups="[[_groups]]"
          on-added-section-removed="_handleAddedSectionRemoved"
        ></gr-access-section>
      </template>
      <div class="referenceContainer">
        <gr-button id="addReferenceBtn" on-click="_handleCreateSection"
          >Add Reference</gr-button
        >
      </div>
      <div>
        <gr-button id="editBtn" on-click="_handleEdit"
          >[[_editOrCancel(_editing)]]</gr-button
        >
        <gr-button
          id="saveBtn"
          primary=""
          class$="[[_computeSaveBtnClass(_ownerOf)]]"
          on-click="_handleSave"
          disabled="[[!_modified]]"
          >Save</gr-button
        >
        <gr-button
          id="saveReviewBtn"
          primary=""
          class$="[[_computeSaveReviewBtnClass(_canUpload)]]"
          on-click="_handleSaveForReview"
          disabled="[[!_modified]]"
          >Save for review</gr-button
        >
      </div>
    </div>
  </main>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Jm=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Zm=class extends(oo(dr(oa))){constructor(){super(),this._canUpload=!1,this._editing=!1,this._modified=!1,this._loading=!0,this._query=()=>this._getInheritFromSuggestions()}static get template(){return Xm}created(){super.created(),this.addEventListener("access-modified",()=>this._handleAccessModified())}_handleAccessModified(){this._modified=!0}_repoChanged(e){return this._loading=!0,e?this._reload(e):Promise.resolve()}_reload(e){const t=e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))};this._editing=!1,this._sections=[];const n=this.$.restAPI.getRepoAccessRights(e,t).then(e=>e?(this._inheritsFrom=e.inherits_from?{...e.inherits_from}:null,this._originalInheritsFrom=e.inherits_from?{...e.inherits_from}:null,this._inheritFromFilter=e.inherits_from?e.inherits_from.name:"",this._local=e.local,this._groups=e.groups,this._weblinks=e.config_web_links||[],this._canUpload=e.can_upload,this._ownerOf=e.owner_of||[],km(this._local)):Promise.resolve(void 0)),i=this.$.restAPI.getCapabilities(t).then(e=>e||Promise.resolve(void 0)),o=this.$.restAPI.getRepo(e,t).then(e=>e?e.labels:Promise.resolve(void 0));return Promise.all([n,i,o]).then(([e,t,n])=>{this._capabilities=t,this._labels=n,this._sections=e,this._loading=!1})}_handleUpdateInheritFrom(e){const t={id:e.detail.value,name:this._inheritFromFilter};if(this._inheritsFrom){const e=this._inheritsFrom;e.id=t.id,e.name=t.name}else this._inheritsFrom=t;this._handleAccessModified()}_getInheritFromSuggestions(){return this.$.restAPI.getRepos(this._inheritFromFilter,50).then(e=>{const t=[];if(!e)return t;for(const n of e)t.push({name:n.name,value:n.id});return t})}_computeLoadingClass(e){return e?"loading":""}_handleEdit(){this._editing=!this._editing}_editOrCancel(e){return e?"Cancel":"Edit"}_computeWebLinkClass(e){return e&&e.length?"show":""}_computeShowInherit(e){return e?"show":""}_handleAddedSectionRemoved(e){if(!this._sections)return;const t=Number(e.model.index);isNaN(t)||(this._sections=this._sections.slice(0,t).concat(this._sections.slice(t+1,this._sections.length)))}_handleEditingChanged(e,t){if(t&&!e&&(this._sections&&(this._sections=this._sections.filter(e=>!e.value.added)),this._inheritsFrom&&(this._inheritsFrom={...this._originalInheritsFrom},this._inheritFromFilter="name"in this._inheritsFrom?this._inheritsFrom.name:void 0),this._local))for(const e of Object.keys(this._local))this._local[e].added&&delete this._local[e]}_updateRemoveObj(e,t){let n=e.remove;for(const e of t)n[e]||(e===t[t.length-1]?"permissions"===t[t.length-2]?n[e]={rules:{}}:1===t.length?n[e]={permissions:{}}:n[e]={}:n[e]={}),n=n[e];return e}_updateAddObj(e,t,n){let i=e.add;for(const e of t)i[e]||(e===t[t.length-1]?i[e]=n:i[e]={}),i=i[e];return e}_recursivelyRemoveDeleted(e){for(const t in e){if(!o(e,t))continue;const n=e[t];if("object"==typeof n){if(n.deleted)return void delete e[t];this._recursivelyRemoveDeleted(n)}}}_recursivelyUpdateAddRemoveObj(e,t,n=[]){for(const i in e){if(!o(e,i))continue;const s=e[i];if("object"==typeof s){const e=s.updatedId,o=e||i;if(s.deleted){this._updateRemoveObj(t,n.concat(i));continue}if(s.modified){this._updateRemoveObj(t,n.concat(i)),this._updateAddObj(t,n.concat(o),s),e&&e!==i&&this._recursivelyRemoveDeleted(t.add[e]);continue}if(s.added){this._updateAddObj(t,n.concat(o),s),this._recursivelyRemoveDeleted(t.add[i]);continue}this._recursivelyUpdateAddRemoveObj(s,t,n.concat(i))}}}_computeAddAndRemove(){const e={add:{},remove:{}},t=this._originalInheritsFrom?V(this._originalInheritsFrom.id):null,n=this._inheritsFrom?V(this._inheritsFrom.id):null,i=t&&t!==n||!t&&n;return this._local?(this._recursivelyUpdateAddRemoveObj(this._local,e),i&&(e.parent=n),e):e}_handleCreateSection(){if(!this._local)return;let e="refs/for/*";for(;this._local[e];)e=`${e}*`;const t={permissions:{},added:!0};this.push("_sections",{id:e,value:t}),this.set(["_local",e],t),Mo(),this.root.querySelector("gr-access-section:last-of-type").editReference()}_getObjforSave(){const e=this._computeAddAndRemove();if(!Object.keys(e.add).length&&!Object.keys(e.remove).length&&!e.parent)return void this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"No changes to save."},bubbles:!0,composed:!0}));const t={add:e.add,remove:e.remove};return e.parent&&(t.parent=e.parent),t}_handleSave(e){const t=this._getObjforSave();if(!t)return;const n=e&&e.target;n&&(n.loading=!0);const i=this.repo;return i?this.$.restAPI.setRepoAccessRights(i,t).then(()=>{this._reload(i)}).finally(()=>{this._modified=!1,n&&(n.loading=!1)}):Promise.resolve()}_handleSaveForReview(e){const t=this._getObjforSave();if(!t)return;const n=e&&e.target;return n&&(n.loading=!0),this.repo?this.$.restAPI.setRepoAccessRightsForReview(this.repo,t).then(e=>{gh.navigateToChange(e)}).finally(()=>{this._modified=!1,n&&(n.loading=!1)}):void 0}_computeSaveReviewBtnClass(e){return e?"":"invisible"}_computeSaveBtnClass(e){return e&&0===e.length?"invisible":""}_computeMainClass(e,t,n){const i=[];return(e&&e.length>0||t)&&i.push("admin"),n&&i.push("editing"),i.join(" ")}_computeParentHref(e){return j()+`/admin/repos/${G(e,!0)},access`}};Jm([Bl({type:String,observer:"_repoChanged"})],Zm.prototype,"repo",void 0),Jm([Bl({type:String})],Zm.prototype,"path",void 0),Jm([Bl({type:Boolean})],Zm.prototype,"_canUpload",void 0),Jm([Bl({type:String})],Zm.prototype,"_inheritFromFilter",void 0),Jm([Bl({type:Object})],Zm.prototype,"_query",void 0),Jm([Bl({type:Array})],Zm.prototype,"_ownerOf",void 0),Jm([Bl({type:Object})],Zm.prototype,"_capabilities",void 0),Jm([Bl({type:Object})],Zm.prototype,"_groups",void 0),Jm([Bl({type:Object})],Zm.prototype,"_inheritsFrom",void 0),Jm([Bl({type:Object})],Zm.prototype,"_labels",void 0),Jm([Bl({type:Object})],Zm.prototype,"_local",void 0),Jm([Bl({type:Boolean,observer:"_handleEditingChanged"})],Zm.prototype,"_editing",void 0),Jm([Bl({type:Boolean})],Zm.prototype,"_modified",void 0),Jm([Bl({type:Array})],Zm.prototype,"_sections",void 0),Jm([Bl({type:Array})],Zm.prototype,"_weblinks",void 0),Jm([Bl({type:Boolean})],Zm.prototype,"_loading",void 0),Zm=Jm([Ml("gr-repo-access")],Zm);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Qm=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    input:not([type='checkbox']),
    gr-autocomplete,
    iron-autogrow-textarea {
      width: 100%;
    }
    .value {
      width: 32em;
    }
    .hide {
      display: none;
    }
    @media only screen and (max-width: 40em) {
      .value {
        width: 29em;
      }
    }
  </style>
  <div class="gr-form-styles">
    <section class$="[[_computeBranchClass(baseChange)]]">
      <span class="title">Select branch for new change</span>
      <span class="value">
        <gr-autocomplete
          id="branchInput"
          text="{{branch}}"
          query="[[_query]]"
          placeholder="Destination branch"
        >
        </gr-autocomplete>
      </span>
    </section>
    <section class$="[[_computeBranchClass(baseChange)]]">
      <span class="title">Provide base commit sha1 for change</span>
      <span class="value">
        <iron-input
          maxlength="40"
          placeholder="(optional)"
          bind-value="{{baseCommit}}"
        >
          <input
            is="iron-input"
            id="baseCommitInput"
            maxlength="40"
            placeholder="(optional)"
            bind-value="{{baseCommit}}"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Enter topic for new change</span>
      <span class="value">
        <iron-input
          maxlength="1024"
          placeholder="(optional)"
          bind-value="{{topic}}"
        >
          <input
            is="iron-input"
            id="tagNameInput"
            maxlength="1024"
            placeholder="(optional)"
            bind-value="{{topic}}"
          />
        </iron-input>
      </span>
    </section>
    <section id="description">
      <span class="title">Description</span>
      <span class="value">
        <iron-autogrow-textarea
          id="messageInput"
          class="message"
          autocomplete="on"
          rows="4"
          max-rows="15"
          bind-value="{{subject}}"
          placeholder="Insert the description of the change."
        >
        </iron-autogrow-textarea>
      </span>
    </section>
    <section class$="[[_computePrivateSectionClass(_privateChangesEnabled)]]">
      <label class="title" for="privateChangeCheckBox">Private change</label>
      <span class="value">
        <input
          type="checkbox"
          id="privateChangeCheckBox"
          checked$="[[_formatBooleanString(privateByDefault)]]"
        />
      </span>
    </section>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var e_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let t_=class extends(oo(dr(oa))){constructor(){super(),this.canCreate=!1,this._query=e=>this._getRepoBranchesSuggestions(e)}static get template(){return Qm}attached(){if(super.attached(),!this.repoName)return Promise.resolve();const e=[];return e.push(this.$.restAPI.getProjectConfig(this.repoName).then(e=>{e&&(this.privateByDefault=e.private_by_default)})),e.push(this.$.restAPI.getConfig().then(e=>{e&&(this._privateChangesEnabled=e&&e.change&&!e.change.disable_private_changes)})),Promise.all(e)}_computeBranchClass(e){return e?"hide":""}_allowCreate(e,t){this.canCreate=!!e&&!!t}handleCreateChange(){if(!this.repoName||!this.branch||!this.subject)return Promise.resolve();const e=this.$.privateChangeCheckBox.checked;return this.$.restAPI.createChange(this.repoName,this.branch,this.subject,this.topic,e,!0,this.baseChange,this.baseCommit||void 0).then(e=>{e&&gh.navigateToChange(e)})}_getRepoBranchesSuggestions(e){return this.repoName?(e.startsWith("refs/heads/")&&(e=e.substring("refs/heads/".length)),this.$.restAPI.getRepoBranches(e,this.repoName,15).then(e=>{if(!e)return[];const t=[];let n;for(const i in e)o(e,i)&&(n=e[i].ref.startsWith("refs/heads/")?e[i].ref.substring("refs/heads/".length):e[i].ref,t.push({name:n}));return t})):Promise.reject(new Error("missing repo name"))}_formatBooleanString(e){return!(!e||e.configured_value!==Ga.TRUE)||(!e||e.configured_value!==Ga.FALSE)&&(!(!e||e.configured_value!==Ga.INHERITED)&&!(!e||!e.inherited_value))}_computePrivateSectionClass(e){return e?"hide":""}};e_([Bl({type:String})],t_.prototype,"repoName",void 0),e_([Bl({type:String})],t_.prototype,"branch",void 0),e_([Bl({type:Object})],t_.prototype,"_repoConfig",void 0),e_([Bl({type:String})],t_.prototype,"subject",void 0),e_([Bl({type:String})],t_.prototype,"topic",void 0),e_([Bl({type:Object})],t_.prototype,"_query",void 0),e_([Bl({type:String})],t_.prototype,"baseChange",void 0),e_([Bl({type:String})],t_.prototype,"baseCommit",void 0),e_([Bl({type:Object})],t_.prototype,"privateByDefault",void 0),e_([Bl({type:Boolean,notify:!0})],t_.prototype,"canCreate",void 0),e_([Bl({type:Boolean})],t_.prototype,"_privateChangesEnabled",void 0),e_([jl("branch","subject")],t_.prototype,"_allowCreate",null),t_=e_([Ml("gr-create-change-dialog")],t_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const n_=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-subpage-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    #form gr-button {
      margin-bottom: var(--spacing-xxl);
    }
  </style>
  <main class="gr-form-styles read-only">
    <h1 id="Title" class="heading-1">Repository Commands</h1>
    <div id="loading" class$="[[_computeLoadingClass(_loading)]]">
      Loading...
    </div>
    <div id="loadedContent" class$="[[_computeLoadingClass(_loading)]]">
      <h2 id="options" class="heading-2">Command</h2>
      <div id="form">
        <h3>Create change</h3>
        <gr-button loading="[[_creatingChange]]" on-click="_createNewChange">
          Create change
        </gr-button>
        <h3>Edit repo config</h3>
        <gr-button
          id="editRepoConfig"
          loading="[[_editingConfig]]"
          on-click="_handleEditRepoConfig"
        >
          Edit repo config
        </gr-button>
        <h3 hidden="[[!_repoConfig.actions.gc.enabled]]">
          [[_repoConfig.actions.gc.label]]
        </h3>
        <gr-button
          hidden="[[!_repoConfig.actions.gc.enabled]]"
          title="[[_repoConfig.actions.gc.title]]"
          loading="[[_runningGC]]"
          on-click="_handleRunningGC"
        >
          [[_repoConfig.actions.gc.label]]
        </gr-button>
        <gr-endpoint-decorator name="repo-command">
          <gr-endpoint-param name="config" value="[[_repoConfig]]">
          </gr-endpoint-param>
          <gr-endpoint-param name="repoName" value="[[repo]]">
          </gr-endpoint-param>
        </gr-endpoint-decorator>
      </div>
    </div>
  </main>
  <gr-overlay id="createChangeOverlay" with-backdrop="">
    <gr-dialog
      id="createChangeDialog"
      confirm-label="Create"
      disabled="[[!_canCreate]]"
      on-confirm="_handleCreateChange"
      on-cancel="_handleCloseCreateChange"
    >
      <div class="header" slot="header">
        Create Change
      </div>
      <div class="main" slot="main">
        <gr-create-change-dialog
          id="createNewChangeModal"
          can-create="{{_canCreate}}"
          repo-name="[[repo]]"
        ></gr-create-change-dialog>
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var i_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let o_=class extends(oo(dr(oa))){constructor(){super(...arguments),this._loading=!0,this._canCreate=!1,this._creatingChange=!1,this._editingConfig=!1,this._runningGC=!1}static get template(){return n_}attached(){super.attached(),this._loadRepo(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Repo Commands"},composed:!0,bubbles:!0}))}_loadRepo(){this.$.restAPI.getProjectConfig(this.repo,e=>{this.isConnected&&this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(e=>{e&&this.isConnected&&(this._repoConfig=e,this._loading=!1)})}_computeLoadingClass(e){return e?"loading":""}_isLoading(){return this._loading}_handleRunningGC(){return this._runningGC=!0,this.$.restAPI.runRepoGC(this.repo).then(e=>{200===(null==e?void 0:e.status)&&this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Garbage collection completed successfully."},bubbles:!0,composed:!0}))}).finally(()=>{this._runningGC=!1})}_createNewChange(){this.$.createChangeOverlay.open()}_handleCreateChange(){this._creatingChange=!0,this.$.createNewChangeModal.handleCreateChange().finally(()=>{this._creatingChange=!1}),this._handleCloseCreateChange()}_handleCloseCreateChange(){this.$.createChangeOverlay.close()}_handleEditRepoConfig(){return this._editingConfig=!0,this.$.restAPI.createChange(this.repo,"refs/meta/config","Edit Repo Config",void 0,!1,!0).then(e=>{const t=e?"Navigating to change":"Failed to create change.";this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:t},bubbles:!0,composed:!0})),e&&gh.navigateToRelativeUrl(gh.getEditUrlForDiff(e,"project.config",1))}).finally(()=>{this._editingConfig=!1})}};i_([Bl({type:String})],o_.prototype,"repo",void 0),i_([Bl({type:Boolean})],o_.prototype,"_loading",void 0),i_([Bl({type:Object})],o_.prototype,"_repoConfig",void 0),i_([Bl({type:Boolean})],o_.prototype,"_canCreate",void 0),i_([Bl({type:Boolean})],o_.prototype,"_creatingChange",void 0),i_([Bl({type:Boolean})],o_.prototype,"_editingConfig",void 0),i_([Bl({type:Boolean})],o_.prototype,"_runningGC",void 0),o_=i_([Ml("gr-repo-commands")],o_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const s_=ta`
  <style include="shared-styles">
    :host {
      display: block;
      margin-bottom: var(--spacing-xxl);
    }
    .loading #dashboards,
    #loadingContainer {
      display: none;
    }
    .loading #loadingContainer {
      display: block;
    }
  </style>
  <style include="gr-table-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <table id="list" class$="genericList [[_computeLoadingClass(_loading)]]">
    <tbody>
      <tr class="headerRow">
        <th class="topHeader">Dashboard name</th>
        <th class="topHeader">Dashboard title</th>
        <th class="topHeader">Dashboard description</th>
        <th class="topHeader">Inherited from</th>
        <th class="topHeader">Default</th>
      </tr>
      <tr id="loadingContainer">
        <td>Loading...</td>
      </tr>
    </tbody>
    <tbody id="dashboards">
      <template is="dom-repeat" items="[[_dashboards]]">
        <tr class="groupHeader">
          <td colspan="5">[[item.section]]</td>
        </tr>
        <template is="dom-repeat" items="[[item.dashboards]]">
          <tr class="table">
            <td class="name">
              <a href$="[[_getUrl(item.project, item.id)]]">[[item.path]]</a>
            </td>
            <td class="title">[[item.title]]</td>
            <td class="desc">[[item.description]]</td>
            <td class="inherited">
              [[_computeInheritedFrom(item.project, item.defining_project)]]
            </td>
            <td class="default">[[_computeIsDefault(item.is_default)]]</td>
          </tr>
        </template>
      </template>
    </tbody>
  </table>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var r_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let a_=class extends(oo(dr(oa))){constructor(){super(...arguments),this._loading=!0}static get template(){return s_}_repoChanged(e){if(this._loading=!0,!e)return Promise.resolve();return this.$.restAPI.getRepoDashboards(e,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(e=>{if(!e)return;const t=e.concat.apply([],e).sort((e,t)=>e.id<t.id?-1:1),n={};t.forEach(e=>{n[e.ref]||(n[e.ref]=[]),n[e.ref].push(e)});const i=[];Object.keys(n).sort().forEach(e=>{i.push({section:e,dashboards:n[e]})}),this._dashboards=i,this._loading=!1,Mo()})}_getUrl(e,t){return e&&t?gh.getUrlForRepoDashboard(e,t):""}_computeLoadingClass(e){return e?"loading":""}_computeInheritedFrom(e,t){return e===t?"":t}_computeIsDefault(e){return e?"✓":""}};r_([Bl({type:String,observer:"_repoChanged"})],a_.prototype,"repo",void 0),r_([Bl({type:Boolean})],a_.prototype,"_loading",void 0),r_([Bl({type:Array})],a_.prototype,"_dashboards",void 0),a_=r_([Ml("gr-repo-dashboards")],a_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const l_=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    :host {
      display: inline-block;
    }
    input {
      width: 20em;
    }
    /* Add css selector with #id to increase priority
      (otherwise ".gr-form-styles section" rule wins) */
    .hideItem,
    #itemAnnotationSection.hideItem {
      display: none;
    }
  </style>
  <div class="gr-form-styles">
    <div id="form">
      <section id="itemNameSection">
        <span class="title">[[detailType]] name</span>
        <iron-input
          placeholder="[[detailType]] Name"
          bind-value="{{_itemName}}"
        >
          <input
            is="iron-input"
            placeholder="[[detailType]] Name"
            bind-value="{{_itemName}}"
          />
        </iron-input>
      </section>
      <section id="itemRevisionSection">
        <span class="title">Initial Revision</span>
        <iron-input
          placeholder="Revision (Branch or SHA-1)"
          bind-value="{{_itemRevision}}"
        >
          <input
            is="iron-input"
            placeholder="Revision (Branch or SHA-1)"
            bind-value="{{_itemRevision}}"
          />
        </iron-input>
      </section>
      <section
        id="itemAnnotationSection"
        class$="[[_computeHideItemClass(itemDetail)]]"
      >
        <span class="title">Annotation</span>
        <iron-input
          placeholder="Annotation (Optional)"
          bind-value="{{_itemAnnotation}}"
        >
          <input
            is="iron-input"
            placeholder="Annotation (Optional)"
            bind-value="{{_itemAnnotation}}"
          />
        </iron-input>
      </section>
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var c_,d_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};!function(e){e.branches="branches",e.tags="tags"}(c_||(c_={}));let h_=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasNewItemName=!1}static get template(){return l_}_updateItemName(e){this.hasNewItemName=!!e}handleCreateItem(){if(!this.repoName)throw new Error("repoName name is not set");if(!this._itemName)throw new Error("itemName name is not set");const e=this._itemRevision?this._itemRevision:"HEAD",t=`${j()}/admin/repos/${G(this.repoName,!0)}`;if(this.itemDetail===c_.branches)return this.$.restAPI.createRepoBranch(this.repoName,this._itemName,{revision:e}).then(e=>{201===e.status&&hd.show(`${t},branches`)});if(this.itemDetail===c_.tags)return this.$.restAPI.createRepoTag(this.repoName,this._itemName,{revision:e,message:this._itemAnnotation||void 0}).then(e=>{201===e.status&&hd.show(`${t},tags`)});throw new Error(`Invalid itemDetail: ${this.itemDetail}`)}_computeHideItemClass(e){return e===c_.branches?"hideItem":""}};d_([Bl({type:String})],h_.prototype,"detailType",void 0),d_([Bl({type:String})],h_.prototype,"repoName",void 0),d_([Bl({type:Boolean,notify:!0})],h_.prototype,"hasNewItemName",void 0),d_([Bl({type:String})],h_.prototype,"itemDetail",void 0),d_([Bl({type:String})],h_.prototype,"_itemName",void 0),d_([Bl({type:String})],h_.prototype,"_itemRevision",void 0),d_([Bl({type:String})],h_.prototype,"_itemAnnotation",void 0),d_([jl("_itemName")],h_.prototype,"_updateItemName",null),h_=d_([Ml("gr-create-pointer-dialog")],h_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const p_=ta`
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-table-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="shared-styles">
    .tags td.name {
      min-width: 25em;
    }
    td.name,
    td.revision,
    td.message {
      word-break: break-word;
    }
    td.revision.tags {
      width: 27em;
    }
    td.message,
    td.tagger {
      max-width: 15em;
    }
    .editing .editItem {
      display: inherit;
    }
    .editItem,
    .editing .editBtn,
    .canEdit .revisionNoEditing,
    .editing .revisionWithEditing,
    .revisionEdit,
    .hideItem {
      display: none;
    }
    .revisionEdit gr-button {
      margin-left: var(--spacing-m);
    }
    .editBtn {
      margin-left: var(--spacing-l);
    }
    .canEdit .revisionEdit {
      align-items: center;
      display: flex;
    }
    .deleteButton:not(.show) {
      display: none;
    }
    .tagger.hide {
      display: none;
    }
  </style>
  <style include="gr-table-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <gr-list-view
    create-new="[[_loggedIn]]"
    filter="[[_filter]]"
    items-per-page="[[_itemsPerPage]]"
    items="[[_items]]"
    loading="[[_loading]]"
    offset="[[_offset]]"
    on-create-clicked="_handleCreateClicked"
    path="[[_getPath(_repo, detailType)]]"
  >
    <table id="list" class="genericList gr-form-styles">
      <tbody>
        <tr class="headerRow">
          <th class="name topHeader">Name</th>
          <th class="revision topHeader">Revision</th>
          <th class$="message topHeader [[_hideIfBranch(detailType)]]">
            Message
          </th>
          <th class$="tagger topHeader [[_hideIfBranch(detailType)]]">
            Tagger
          </th>
          <th class="repositoryBrowser topHeader">
            Repository Browser
          </th>
          <th class="delete topHeader"></th>
        </tr>
        <tr id="loading" class$="loadingMsg [[computeLoadingClass(_loading)]]">
          <td>Loading...</td>
        </tr>
      </tbody>
      <tbody class$="[[computeLoadingClass(_loading)]]">
        <template is="dom-repeat" items="[[_shownItems]]">
          <tr class="table">
            <td class$="[[detailType]] name">
              [[_stripRefs(item.ref, detailType)]]
            </td>
            <td
              class$="[[detailType]] revision [[_computeCanEditClass(item.ref, detailType, _isOwner)]]"
            >
              <span class="revisionNoEditing">
                [[item.revision]]
              </span>
              <span class$="revisionEdit [[_computeEditingClass(_isEditing)]]">
                <span class="revisionWithEditing">
                  [[item.revision]]
                </span>
                <gr-button
                  link=""
                  on-click="_handleEditRevision"
                  class="editBtn"
                >
                  edit
                </gr-button>
                <iron-input bind-value="{{_revisedRef}}" class="editItem">
                  <input is="iron-input" bind-value="{{_revisedRef}}" />
                </iron-input>
                <gr-button
                  link=""
                  on-click="_handleCancelRevision"
                  class="cancelBtn editItem"
                >
                  Cancel
                </gr-button>
                <gr-button
                  link=""
                  on-click="_handleSaveRevision"
                  class="saveBtn editItem"
                  disabled="[[!_revisedRef]]"
                >
                  Save
                </gr-button>
              </span>
            </td>
            <td class$="message [[_hideIfBranch(detailType)]]">
              [[_computeMessage(item.message)]]
            </td>
            <td class$="tagger [[_hideIfBranch(detailType)]]">
              <div class$="tagger [[_computeHideTagger(item.tagger)]]">
                <gr-account-link account="[[item.tagger]]"> </gr-account-link>
                (<gr-date-formatter
                  has-tooltip=""
                  date-str="[[item.tagger.date]]"
                >
                </gr-date-formatter
                >)
              </div>
            </td>
            <td class="repositoryBrowser">
              <template
                is="dom-repeat"
                items="[[_computeWeblink(item)]]"
                as="link"
              >
                <a
                  href$="[[link.url]]"
                  class="webLink"
                  rel="noopener"
                  target="_blank"
                >
                  ([[link.name]])
                </a>
              </template>
            </td>
            <td class="delete">
              <gr-button
                link=""
                class$="deleteButton [[_computeHideDeleteClass(_isOwner, item.can_delete)]]"
                on-click="_handleDeleteItem"
              >
                Delete
              </gr-button>
            </td>
          </tr>
        </template>
      </tbody>
    </table>
    <gr-overlay id="overlay" with-backdrop="">
      <gr-confirm-delete-item-dialog
        class="confirmDialog"
        on-confirm="_handleDeleteItemConfirm"
        on-cancel="_handleConfirmDialogCancel"
        item="[[_refName]]"
        item-type="[[detailType]]"
      ></gr-confirm-delete-item-dialog>
    </gr-overlay>
  </gr-list-view>
  <gr-overlay id="createOverlay" with-backdrop="">
    <gr-dialog
      id="createDialog"
      disabled="[[!_hasNewItemName]]"
      confirm-label="Create"
      on-confirm="_handleCreateItem"
      on-cancel="_handleCloseCreate"
    >
      <div class="header" slot="header">
        Create [[_computeItemName(detailType)]]
      </div>
      <div class="main" slot="main">
        <gr-create-pointer-dialog
          id="createNewModal"
          detail-type="[[_computeItemName(detailType)]]"
          has-new-item-name="{{_hasNewItemName}}"
          item-detail="[[detailType]]"
          repo-name="[[_repo]]"
        ></gr-create-pointer-dialog>
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var u_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let g_=class extends(Ku(oo(dr(oa)))){constructor(){super(...arguments),this._editing=!1,this._isOwner=!1,this._loggedIn=!1,this._itemsPerPage=25,this._loading=!0}static get template(){return p_}_determineIfOwner(e){return this.$.restAPI.getRepoAccess(e).then(t=>this._isOwner=!!t&&!!t[e].is_owner)}_paramsChanged(e){return(null==e?void 0:e.repo)?(this._repo=e.repo,this._getLoggedIn().then(e=>{this._loggedIn=e,e&&this._repo&&this._determineIfOwner(this._repo)}),this.detailType=e.detail,this._filter=this.getFilterValue(e),this._offset=this.getOffsetValue(e),this.detailType?this._getItems(this._filter,this._repo,this._itemsPerPage,this._offset,this.detailType):Promise.reject(new Error("undefined detailType"))):Promise.reject(new Error("undefined repo"))}_getItems(e,t,n,i,o){if(void 0===e||!t||void 0===i)return Promise.reject(new Error("filter or repo or offset undefined"));this._loading=!0,this._items=[],Mo();const s=e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))};return o===ph.BRANCHES?this.$.restAPI.getRepoBranches(e,t,n,i,s).then(e=>{e&&(this._items=e,this._loading=!1)}):o===ph.TAGS?this.$.restAPI.getRepoTags(e,t,n,i,s).then(e=>{e&&(this._items=e,this._loading=!1)}):Promise.reject(new Error("unknown detail type"))}_getPath(e){return`/admin/repos/${G(e,!1)},${this.detailType}`}_computeWeblink(e){if(!e.web_links)return"";const t=e.web_links;return t.length?t:null}_computeMessage(e){if(e)return e.split("-----BEGIN PGP SIGNATURE-----")[0]}_stripRefs(e,t){if(t===ph.BRANCHES)return e.replace("refs/heads/","");if(t===ph.TAGS)return e.replace("refs/tags/","");throw new Error("unknown detailType")}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_computeEditingClass(e){return e?"editing":""}_computeCanEditClass(e,t,n){return n&&"HEAD"===this._stripRefs(e,t)?"canEdit":""}_handleEditRevision(e){this._revisedRef=e.model.get("item.revision"),this._isEditing=!0}_handleCancelRevision(){this._isEditing=!1}_handleSaveRevision(e){this._revisedRef&&this._repo&&this._setRepoHead(this._repo,this._revisedRef,e)}_setRepoHead(e,t,n){return this.$.restAPI.setRepoHead(e,t).then(e=>{e.status<400&&(this._isEditing=!1,n.model.set("item.revision",t),this._getItems(this._filter,this._repo,this._itemsPerPage,this._offset,this.detailType))})}_computeItemName(e){if(e===ph.BRANCHES)return"Branch";if(e===ph.TAGS)return"Tag";throw new Error("unknown detailType")}_handleDeleteItemConfirm(){return this.$.overlay.close(),this._repo&&this._refName?this.detailType===ph.BRANCHES?this.$.restAPI.deleteRepoBranches(this._repo,this._refName).then(e=>{204===e.status&&this._getItems(this._filter,this._repo,this._itemsPerPage,this._offset,this.detailType)}):this.detailType===ph.TAGS?this.$.restAPI.deleteRepoTags(this._repo,this._refName).then(e=>{204===e.status&&this._getItems(this._filter,this._repo,this._itemsPerPage,this._offset,this.detailType)}):Promise.reject(new Error("unknown detail type")):Promise.reject(new Error("undefined repo or refName"))}_handleConfirmDialogCancel(){this.$.overlay.close()}_handleDeleteItem(e){const t=this._stripRefs(e.model.get("item.ref"),this.detailType);t&&(this._refName=t,this.$.overlay.open())}_computeHideDeleteClass(e,t){return t||e?"show":""}_handleCreateItem(){this.$.createNewModal.handleCreateItem(),this._handleCloseCreate()}_handleCloseCreate(){this.$.createOverlay.close()}_handleCreateClicked(){this.$.createOverlay.open()}_hideIfBranch(e){return e===ph.BRANCHES?"hideItem":""}_computeHideTagger(e){return e?"":"hide"}};u_([Bl({type:Object,observer:"_paramsChanged"})],g_.prototype,"params",void 0),u_([Bl({type:String})],g_.prototype,"detailType",void 0),u_([Bl({type:Boolean})],g_.prototype,"_editing",void 0),u_([Bl({type:Boolean})],g_.prototype,"_isOwner",void 0),u_([Bl({type:Boolean})],g_.prototype,"_loggedIn",void 0),u_([Bl({type:Number})],g_.prototype,"_offset",void 0),u_([Bl({type:String})],g_.prototype,"_repo",void 0),u_([Bl({type:Array})],g_.prototype,"_items",void 0),u_([Bl({type:Array,computed:"computeShownItems(_items)"})],g_.prototype,"_shownItems",void 0),u_([Bl({type:Number})],g_.prototype,"_itemsPerPage",void 0),u_([Bl({type:Boolean})],g_.prototype,"_loading",void 0),u_([Bl({type:String})],g_.prototype,"_filter",void 0),u_([Bl({type:String})],g_.prototype,"_refName",void 0),u_([Bl({type:Boolean})],g_.prototype,"_hasNewItemName",void 0),u_([Bl({type:Boolean})],g_.prototype,"_isEditing",void 0),u_([Bl({type:String})],g_.prototype,"_revisedRef",void 0),g_=u_([Ml("gr-repo-detail-list")],g_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const m_=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    :host {
      display: inline-block;
    }
    input {
      width: 20em;
    }
    gr-autocomplete {
      width: 20em;
    }
  </style>

  <div class="gr-form-styles">
    <div id="form">
      <section>
        <span class="title">Repository name</span>
        <iron-input autocomplete="on" bind-value="{{_repoConfig.name}}">
          <input
            is="iron-input"
            id="repoNameInput"
            autocomplete="on"
            bind-value="{{_repoConfig.name}}"
          />
        </iron-input>
      </section>
      <section>
        <span class="title">Rights inherit from</span>
        <span class="value">
          <gr-autocomplete
            id="rightsInheritFromInput"
            text="{{_repoConfig.parent}}"
            query="[[_query]]"
            placeholder="Optional, defaults to 'All-Projects'"
          >
          </gr-autocomplete>
        </span>
      </section>
      <section>
        <span class="title">Owner</span>
        <span class="value">
          <gr-autocomplete
            id="ownerInput"
            text="{{_repoOwner}}"
            value="{{_repoOwnerId}}"
            query="[[_queryGroups]]"
          >
          </gr-autocomplete>
        </span>
      </section>
      <section>
        <span class="title">Create initial empty commit</span>
        <span class="value">
          <gr-select
            id="initialCommit"
            bind-value="{{_repoConfig.create_empty_commit}}"
          >
            <select>
              <option value="false">False</option>
              <option value="true">True</option>
            </select>
          </gr-select>
        </span>
      </section>
      <section>
        <span class="title">Only serve as parent for other repositories</span>
        <span class="value">
          <gr-select
            id="parentRepo"
            bind-value="{{_repoConfig.permissions_only}}"
          >
            <select>
              <option value="false">False</option>
              <option value="true">True</option>
            </select>
          </gr-select>
        </span>
      </section>
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var __=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let f_=class extends(oo(dr(oa))){constructor(){super(),this.hasNewRepoName=!1,this._repoConfig={create_empty_commit:!0,permissions_only:!1,name:""},this._repoCreated=!1,this._query=e=>this._getRepoSuggestions(e),this._queryGroups=e=>this._getGroupSuggestions(e)}static get template(){return m_}_computeRepoUrl(e){return j()+"/admin/repos/"+G(e,!0)}_updateRepoName(e){this.hasNewRepoName=!!e}_repoOwnerIdUpdate(e){e?this.set("_repoConfig.owners",[e]):this.set("_repoConfig.owners",void 0)}handleCreateRepo(){return this.$.restAPI.createRepo(this._repoConfig).then(e=>{201===e.status&&(this._repoCreated=!0,hd.show(this._computeRepoUrl(this._repoConfig.name)))})}_getRepoSuggestions(e){return this.$.restAPI.getSuggestedProjects(e).then(e=>{const t=[];for(const n in e)o(e,n)&&t.push({name:n,value:e[n]});return t})}_getGroupSuggestions(e){return this.$.restAPI.getSuggestedGroups(e).then(e=>{const t=[];for(const n in e)o(e,n)&&t.push({name:n,value:decodeURIComponent(e[n].id)});return t})}};__([Bl({type:Boolean,notify:!0})],f_.prototype,"hasNewRepoName",void 0),__([Bl({type:Object})],f_.prototype,"_repoConfig",void 0),__([Bl({type:Boolean})],f_.prototype,"_repoCreated",void 0),__([Bl({type:String})],f_.prototype,"_repoOwner",void 0),__([Bl({type:String})],f_.prototype,"_repoOwnerId",void 0),__([Bl({type:Object})],f_.prototype,"_query",void 0),__([Bl({type:Object})],f_.prototype,"_queryGroups",void 0),__([jl("_repoConfig.name")],f_.prototype,"_updateRepoName",null),__([jl("_repoOwnerId")],f_.prototype,"_repoOwnerIdUpdate",null),f_=__([Ml("gr-create-repo-dialog")],f_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const v_=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-table-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style>
    .genericList tr td:last-of-type {
      text-align: left;
    }
    .genericList tr th:last-of-type {
      text-align: left;
    }
    .readOnly {
      text-align: center;
    }
    .changesLink,
    .name,
    .repositoryBrowser,
    .readOnly {
      white-space: nowrap;
    }
  </style>
  <gr-list-view
    create-new="[[_createNewCapability]]"
    filter="[[_filter]]"
    items-per-page="[[_reposPerPage]]"
    items="[[_repos]]"
    loading="[[_loading]]"
    offset="[[_offset]]"
    on-create-clicked="_handleCreateClicked"
    path="[[_path]]"
  >
    <table id="list" class="genericList">
      <tbody>
        <tr class="headerRow">
          <th class="name topHeader">Repository Name</th>
          <th class="repositoryBrowser topHeader">Repository Browser</th>
          <th class="changesLink topHeader">Changes</th>
          <th class="topHeader readOnly">Read only</th>
          <th class="description topHeader">Repository Description</th>
        </tr>
        <tr id="loading" class$="loadingMsg [[computeLoadingClass(_loading)]]">
          <td>Loading...</td>
        </tr>
      </tbody>
      <tbody class$="[[computeLoadingClass(_loading)]]">
        <template is="dom-repeat" items="[[_shownRepos]]">
          <tr class="table">
            <td class="name">
              <a href$="[[_computeRepoUrl(item.name)]]">[[item.name]]</a>
            </td>
            <td class="repositoryBrowser">
              <template
                is="dom-repeat"
                items="[[_computeWeblink(item)]]"
                as="link"
              >
                <a
                  href$="[[link.url]]"
                  class="webLink"
                  rel="noopener"
                  target="_blank"
                >
                  [[link.name]]
                </a>
              </template>
            </td>
            <td class="changesLink">
              <a href$="[[_computeChangesLink(item.name)]]">view all</a>
            </td>
            <td class="readOnly">[[_readOnly(item)]]</td>
            <td class="description">[[item.description]]</td>
          </tr>
        </template>
      </tbody>
    </table>
  </gr-list-view>
  <gr-overlay id="createOverlay" with-backdrop="">
    <gr-dialog
      id="createDialog"
      class="confirmDialog"
      disabled="[[!_hasNewRepoName]]"
      confirm-label="Create"
      on-confirm="_handleCreateRepo"
      on-cancel="_handleCloseCreate"
    >
      <div class="header" slot="header">
        Create Repository
      </div>
      <div class="main" slot="main">
        <gr-create-repo-dialog
          has-new-repo-name="{{_hasNewRepoName}}"
          id="createNewModal"
        ></gr-create-repo-dialog>
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var y_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let b_=class extends(Ku(oo(dr(oa)))){constructor(){super(...arguments),this._path="/admin/repos",this._hasNewRepoName=!1,this._createNewCapability=!1,this._repos=[],this._reposPerPage=25,this._loading=!0,this._filter=""}static get template(){return v_}get _shownRepos(){return this.computeShownItems(this._repos)}attached(){super.attached(),this._getCreateRepoCapability(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Repos"},composed:!0,bubbles:!0})),this._maybeOpenCreateOverlay(this.params)}_paramsChanged(e){return this._loading=!0,this._filter=this.getFilterValue(e),this._offset=this.getOffsetValue(e),this._getRepos(this._filter,this._reposPerPage,this._offset)}_maybeOpenCreateOverlay(e){(null==e?void 0:e.openCreateModal)&&this.$.createOverlay.open()}_computeRepoUrl(e){return this.getUrl(this._path+"/",e)}_computeChangesLink(e){return gh.getUrlForProjectChanges(e)}_getCreateRepoCapability(){return this.$.restAPI.getAccount().then(e=>{if(e)return this.$.restAPI.getAccountCapabilities(["createProject"]).then(e=>{(null==e?void 0:e.createProject)&&(this._createNewCapability=!0)})})}_getRepos(e,t,n){return this._repos=[],this.$.restAPI.getRepos(e,t,n).then(t=>{e===this._filter&&t&&(this._repos=t,this._loading=!1)})}_refreshReposList(){return this.$.restAPI.invalidateReposCache(),this._getRepos(this._filter,this._reposPerPage,this._offset)}_handleCreateRepo(){this.$.createNewModal.handleCreateRepo().then(()=>{this._refreshReposList()})}_handleCloseCreate(){this.$.createOverlay.close()}_handleCreateClicked(){this.$.createOverlay.open()}_readOnly(e){return e.state===Ba.READ_ONLY?"Y":""}_computeWeblink(e){if(!e.web_links)return"";const t=e.web_links;return t.length?t:null}};y_([Bl({type:Object})],b_.prototype,"params",void 0),y_([Bl({type:Number})],b_.prototype,"_offset",void 0),y_([Bl({type:String})],b_.prototype,"_path",void 0),y_([Bl({type:Boolean})],b_.prototype,"_hasNewRepoName",void 0),y_([Bl({type:Boolean})],b_.prototype,"_createNewCapability",void 0),y_([Bl({type:Array})],b_.prototype,"_repos",void 0),y_([Bl({type:Number})],b_.prototype,"_reposPerPage",void 0),y_([Bl({type:Boolean})],b_.prototype,"_loading",void 0),y_([Bl({type:String})],b_.prototype,"_filter",void 0),y_([Hl("_repos")],b_.prototype,"_shownRepos",null),y_([jl("params")],b_.prototype,"_paramsChanged",null),b_=y_([Ml("gr-repo-list")],b_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const w_=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-menu-page-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-page-nav-styles">
    gr-dropdown-list {
      --trigger-style: {
        text-transform: none;
      }
    }
    .breadcrumbText {
      /* Same as dropdown trigger so chevron spacing is consistent. */
      padding: 5px 4px;
    }
    iron-icon {
      margin: 0 var(--spacing-xs);
    }
    .breadcrumb {
      align-items: center;
      display: flex;
    }
    .mainHeader {
      align-items: baseline;
      border-bottom: 1px solid var(--border-color);
      display: flex;
    }
    .selectText {
      display: none;
    }
    .selectText.show {
      display: inline-block;
    }
    main.breadcrumbs:not(.table) {
      margin-top: var(--spacing-l);
    }
  </style>
  <gr-page-nav class="navStyles">
    <ul class="sectionContent">
      <template id="adminNav" is="dom-repeat" items="[[_filteredLinks]]">
        <li class$="sectionTitle [[_computeSelectedClass(item.view, params)]]">
          <a class="title" href="[[_computeLinkURL(item)]]" rel="noopener"
            >[[item.name]]</a
          >
        </li>
        <template is="dom-repeat" items="[[item.children]]" as="child">
          <li class$="[[_computeSelectedClass(child.view, params)]]">
            <a href$="[[_computeLinkURL(child)]]" rel="noopener"
              >[[child.name]]</a
            >
          </li>
        </template>
        <template is="dom-if" if="[[item.subsection]]">
          <!--If a section has a subsection, render that.-->
          <li class$="[[_computeSelectedClass(item.subsection.view, params)]]">
            <a
              class="title"
              href$="[[_computeLinkURL(item.subsection)]]"
              rel="noopener"
            >
              [[item.subsection.name]]</a
            >
          </li>
          <!--Loop through the links in the sub-section.-->
          <template
            is="dom-repeat"
            items="[[item.subsection.children]]"
            as="child"
          >
            <li
              class$="subsectionItem [[_computeSelectedClass(child.view, params, child.detailType)]]"
            >
              <a href$="[[_computeLinkURL(child)]]">[[child.name]]</a>
            </li>
          </template>
        </template>
      </template>
    </ul>
  </gr-page-nav>
  <template is="dom-if" if="[[_subsectionLinks.length]]">
    <section class="mainHeader">
      <span class="breadcrumb">
        <span class="breadcrumbText">[[_breadcrumbParentName]]</span>
        <iron-icon icon="gr-icons:chevron-right"></iron-icon>
      </span>
      <gr-dropdown-list
        lowercase=""
        id="pageSelect"
        value="[[_computeSelectValue(params)]]"
        items="[[_subsectionLinks]]"
        on-value-change="_handleSubsectionChange"
      >
      </gr-dropdown-list>
    </section>
  </template>
  <template is="dom-if" if="[[_showRepoList]]" restamp="true">
    <main class="table">
      <gr-repo-list class="table" params="[[params]]"></gr-repo-list>
    </main>
  </template>
  <template is="dom-if" if="[[_showGroupList]]" restamp="true">
    <main class="table">
      <gr-admin-group-list class="table" params="[[params]]">
      </gr-admin-group-list>
    </main>
  </template>
  <template is="dom-if" if="[[_showPluginList]]" restamp="true">
    <main class="table">
      <gr-plugin-list class="table" params="[[params]]"></gr-plugin-list>
    </main>
  </template>
  <template is="dom-if" if="[[_showRepoMain]]" restamp="true">
    <main class="breadcrumbs">
      <gr-repo repo="[[params.repo]]"></gr-repo>
    </main>
  </template>
  <template is="dom-if" if="[[_showGroup]]" restamp="true">
    <main class="breadcrumbs">
      <gr-group
        group-id="[[params.groupId]]"
        on-name-changed="_updateGroupName"
      ></gr-group>
    </main>
  </template>
  <template is="dom-if" if="[[_showGroupMembers]]" restamp="true">
    <main class="breadcrumbs">
      <gr-group-members group-id="[[params.groupId]]"></gr-group-members>
    </main>
  </template>
  <template is="dom-if" if="[[_showRepoDetailList]]" restamp="true">
    <main class="table breadcrumbs">
      <gr-repo-detail-list
        params="[[params]]"
        class="table"
      ></gr-repo-detail-list>
    </main>
  </template>
  <template is="dom-if" if="[[_showGroupAuditLog]]" restamp="true">
    <main class="table breadcrumbs">
      <gr-group-audit-log
        group-id="[[params.groupId]]"
        class="table"
      ></gr-group-audit-log>
    </main>
  </template>
  <template is="dom-if" if="[[_showRepoCommands]]" restamp="true">
    <main class="breadcrumbs">
      <gr-repo-commands repo="[[params.repo]]"></gr-repo-commands>
    </main>
  </template>
  <template is="dom-if" if="[[_showRepoAccess]]" restamp="true">
    <main class="breadcrumbs">
      <gr-repo-access path="[[path]]" repo="[[params.repo]]"></gr-repo-access>
    </main>
  </template>
  <template is="dom-if" if="[[_showRepoDashboards]]" restamp="true">
    <main class="table breadcrumbs">
      <gr-repo-dashboards repo="[[params.repo]]"></gr-repo-dashboards>
    </main>
  </template>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,C_=[{name:"Repositories",noBaseUrl:!0,url:"/admin/repos",view:"gr-repo-list",viewableToAll:!0},{name:"Groups",section:"Groups",noBaseUrl:!0,url:"/admin/groups",view:"gr-admin-group-list"},{name:"Plugins",capability:"viewPlugins",section:"Plugins",noBaseUrl:!0,url:"/admin/plugins",view:"gr-plugin-list"}];function E_(e,t,n,i){return e?t().then(e=>S_(t=>!t.capability||o(e,t.capability),n,i)):Promise.resolve(S_(e=>!!e.viewableToAll,n,i))}function S_(e,t,n){let i,o=C_.slice(0);const s=e=>"/"!==e.url[0];o.push(...t().map(e=>({url:e.url,name:e.text,capability:e.capability||null,noBaseUrl:!s(e),view:null,viewableToAll:!e.capability,target:s(e)?"_blank":null}))),o=o.filter(e);const r=[],a=n&&n.repoName,l=n&&n.groupId,c=n&&n.groupName,d=n&&n.groupIsInternal,h=n&&n.isAdmin,p=n&&n.groupOwner;if(!a&&!l)return{links:o,expandedSection:i};for(const e of o){const t={...e};"Repositories"===t.name&&a?(t.subsection=x_(a),i=t.subsection):"Groups"===t.name&&l&&c&&(t.subsection=A_(l,c,d,h,p),i=t.subsection),r.push(t)}return{links:r,expandedSection:i}}function A_(e,t,n,i,o){const s=[],r={name:t,view:gh.View.GROUP,url:gh.getUrlForGroup(e),children:s};return n&&s.push({name:"Members",detailType:gh.GroupDetailView.MEMBERS,view:gh.View.GROUP,url:gh.getUrlForGroupMembers(e)}),n&&(i||o)&&s.push({name:"Audit Log",detailType:gh.GroupDetailView.LOG,view:gh.View.GROUP,url:gh.getUrlForGroupLog(e)}),r}function x_(e){return{name:e,view:gh.View.REPO,url:gh.getUrlForRepo(e),children:[{name:"Access",view:gh.View.REPO,detailType:gh.RepoDetailView.ACCESS,url:gh.getUrlForRepoAccess(e)},{name:"Commands",view:gh.View.REPO,detailType:gh.RepoDetailView.COMMANDS,url:gh.getUrlForRepoCommands(e)},{name:"Branches",view:gh.View.REPO,detailType:gh.RepoDetailView.BRANCHES,url:gh.getUrlForRepoBranches(e)},{name:"Tags",view:gh.View.REPO,detailType:gh.RepoDetailView.TAGS,url:gh.getUrlForRepoTags(e)},{name:"Dashboards",view:gh.View.REPO,detailType:gh.RepoDetailView.DASHBOARDS,url:gh.getUrlForRepoDashboards(e)}]}}
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */const P_=/^[\da-f]{40}$/;class R_ extends(oo(dr(oa))){static get template(){return w_}static get is(){return"gr-admin-view"}static get properties(){return{params:Object,path:String,adminView:String,_breadcrumbParentName:String,_repoName:String,_groupId:{type:Number,observer:"_computeGroupName"},_groupIsInternal:Boolean,_groupName:String,_groupOwner:{type:Boolean,value:!1},_subsectionLinks:Array,_filteredLinks:Array,_showDownload:{type:Boolean,value:!1},_isAdmin:{type:Boolean,value:!1},_showGroup:Boolean,_showGroupAuditLog:Boolean,_showGroupList:Boolean,_showGroupMembers:Boolean,_showRepoAccess:Boolean,_showRepoCommands:Boolean,_showRepoDashboards:Boolean,_showRepoDetailList:Boolean,_showRepoMain:Boolean,_showRepoList:Boolean,_showPluginList:Boolean}}static get observers(){return["_paramsChanged(params)"]}attached(){super.attached(),this.reload()}reload(){const e=[this.$.restAPI.getAccount(),eh().awaitPluginsLoaded()];return Promise.all(e).then(e=>{let t;return this._account=e[0],this._repoName?t={repoName:this._repoName}:this._groupId&&(t={groupId:this._groupId,groupName:this._groupName,groupIsInternal:this._groupIsInternal,isAdmin:this._isAdmin,groupOwner:this._groupOwner}),E_(this._account,e=>this.$.restAPI.getAccountCapabilities(e),()=>this.$.jsAPI.getAdminMenuLinks(),t).then(e=>{this._filteredLinks=e.links,this._breadcrumbParentName=e.expandedSection?e.expandedSection.name:"",e.expandedSection?this._subsectionLinks=[e.expandedSection].concat(e.expandedSection.children).map(e=>({text:e.detailType?e.name:"Home",value:e.view+(e.detailType||""),view:e.view,url:e.url,detailType:e.detailType,parent:this._groupId||this._repoName||""})):this._subsectionLinks=[]})})}_computeSelectValue(e){if(e&&e.view)return e.view+(e.detail||"")}_selectedIsCurrentPage(e){return e.parent===(this._repoName||this._groupId)&&e.view===this.params.view&&e.detailType===this.params.detail}_handleSubsectionChange(e){const t=this._subsectionLinks.find(t=>t.value===e.detail.value);this._selectedIsCurrentPage(t)||gh.navigateToRelativeUrl(t.url)}_paramsChanged(e){const t=e.view===gh.View.GROUP,n=e.view===gh.View.REPO,i=e.view===gh.View.ADMIN;this.set("_showGroup",t&&!e.detail),this.set("_showGroupAuditLog",t&&e.detail===gh.GroupDetailView.LOG),this.set("_showGroupMembers",t&&e.detail===gh.GroupDetailView.MEMBERS),this.set("_showGroupList",i&&"gr-admin-group-list"===e.adminView),this.set("_showRepoAccess",n&&e.detail===gh.RepoDetailView.ACCESS),this.set("_showRepoCommands",n&&e.detail===gh.RepoDetailView.COMMANDS),this.set("_showRepoDetailList",n&&(e.detail===gh.RepoDetailView.BRANCHES||e.detail===gh.RepoDetailView.TAGS)),this.set("_showRepoDashboards",n&&e.detail===gh.RepoDetailView.DASHBOARDS),this.set("_showRepoMain",n&&!e.detail),this.set("_showRepoList",i&&"gr-repo-list"===e.adminView),this.set("_showPluginList",i&&"gr-plugin-list"===e.adminView);let o=!1;e.repo!==this._repoName&&(this._repoName=e.repo||"",o=!0),e.groupId!==this._groupId&&(this._groupId=e.groupId||"",o=!0),!this._breadcrumbParentName||e.groupId||e.repo||(o=!0),o&&this.reload()}_computeURLHelper(e,t){return"//"+e+j()+t}_computeRelativeURL(e){const t=window.location.host;return this._computeURLHelper(t,e)}_computeLinkURL(e){return e&&void 0!==e.url?e.target||!e.noBaseUrl?e.url:this._computeRelativeURL(e.url):""}_computeSelectedClass(e,t,n){return t?t.view===gh.View.GROUP&&e===gh.View.GROUP?t.detail||n?t.detail===n?"selected":"":"selected":t.view===gh.View.REPO&&e===gh.View.REPO?t.detail||n?t.detail===n?"selected":"":"selected":t.detailType&&t.detailType!==n?"":e===t.adminView?"selected":"":""}_computeGroupName(e){if(!e)return"";const t=[];this.$.restAPI.getGroupConfig(e).then(e=>{if(e&&e.name)return this._groupName=e.name,this._groupIsInternal=!!e.id.match(P_),this.reload(),t.push(this.$.restAPI.getIsAdmin().then(e=>{this._isAdmin=e})),t.push(this.$.restAPI.getIsGroupOwner(e.name).then(e=>{this._groupOwner=e})),Promise.all(t).then(()=>{this.reload()})})}_updateGroupName(e){this._groupName=e.detail.name,this.reload()}}customElements.define(R_.is,R_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const T_=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-table-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <gr-list-view
    filter="[[_filter]]"
    items="false"
    offset="0"
    loading="[[_loading]]"
    path="/Documentation"
  >
    <table id="list" class="genericList">
      <tbody>
        <tr class="headerRow">
          <th class="name topHeader">Name</th>
          <th class="name topHeader"></th>
          <th class="name topHeader"></th>
        </tr>
        <tr id="loading" class$="loadingMsg [[computeLoadingClass(_loading)]]">
          <td>Loading...</td>
        </tr>
      </tbody>
      <tbody class$="[[computeLoadingClass(_loading)]]">
        <template is="dom-repeat" items="[[_documentationSearches]]">
          <tr class="table">
            <td class="name">
              <a href$="[[_computeSearchUrl(item.url)]]">[[item.title]]</a>
            </td>
            <td></td>
            <td></td>
          </tr>
        </template>
      </tbody>
    </table>
  </gr-list-view>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var I_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let k_=class extends(Ku(oo(dr(oa)))){constructor(){super(...arguments),this._loading=!0,this._filter=""}static get template(){return T_}attached(){super.attached(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Documentation Search"}}))}_paramsChanged(e){return this._loading=!0,this._filter=this.getFilterValue(e),this._getDocumentationSearches(this._filter)}_getDocumentationSearches(e){return this._documentationSearches=[],this.$.restAPI.getDocumentationSearches(e).then(t=>{e===this._filter&&t&&(this._documentationSearches=t,this._loading=!1)})}_computeSearchUrl(e){return e?`${j()}/${e}`:""}};I_([Bl({type:Object,observer:"_paramsChanged"})],k_.prototype,"params",void 0),I_([Bl({type:Array})],k_.prototype,"_documentationSearches",void 0),I_([Bl({type:Boolean})],k_.prototype,"_loading",void 0),I_([Bl({type:String})],k_.prototype,"_filter",void 0),k_=I_([Ml("gr-documentation-search")],k_);
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const O_=document.createElement("template");O_.innerHTML='<dom-module id="gr-change-list-styles">\n  <template>\n    <style>\n      gr-change-list-item {\n        border-top: 1px solid var(--border-color);\n      }\n      gr-change-list-item[selected],\n      gr-change-list-item:focus {\n        background-color: var(--selection-background-color);\n      }\n      .groupTitle td,\n      .cell {\n        vertical-align: middle;\n      }\n      .groupTitle td:not(.label):not(.endpoint),\n      .cell:not(.label):not(.endpoint) {\n        padding-right: 8px;\n      }\n      .groupTitle td {\n        color: var(--deemphasized-text-color);\n        text-align: left;\n      }\n      .groupHeader {\n        background-color: transparent;\n        font-size: var(--font-size-h3);\n        font-weight: var(--font-weight-h3);\n        line-height: var(--line-height-h3);\n      }\n      .groupContent {\n        background-color: var(--background-color-primary);\n        box-shadow: var(--elevation-level-1);\n      }\n      .groupHeader a {\n        color: var(--primary-text-color);\n        text-decoration: none;\n      }\n      .groupHeader a:hover {\n        text-decoration: underline;\n      }\n      .groupTitle td,\n      .cell {\n        padding: var(--spacing-s) 0;\n      }\n      .groupHeader .cell {\n        padding-top: var(--spacing-l);\n      }\n      .star {\n        padding: 0;\n      }\n      gr-change-star {\n        vertical-align: middle;\n      }\n      .owner {\n        --account-max-length: 120px;\n      }\n      .branch,\n      .star,\n      .label,\n      .number,\n      .owner,\n      .assignee,\n      .updated,\n      .size,\n      .status,\n      .repo {\n        white-space: nowrap;\n      }\n      .star {\n        vertical-align: middle;\n      }\n      .leftPadding {\n        width: var(--spacing-l);\n      }\n      .star {\n        width: 30px;\n      }\n      .reviewers div {\n        overflow: hidden;\n      }\n      .label, .endpoint {\n        border-left: 1px solid var(--border-color);\n      }\n      .groupTitle td.label,\n      .label {\n        text-align: center;\n        width: 3rem;\n      }\n      .truncatedRepo {\n        display: none;\n      }\n      @media only screen and (max-width: 150em) {\n        .assignee,\n        .branch {\n          overflow: hidden;\n          max-width: 18rem;\n          text-overflow: ellipsis;\n        }\n        .truncatedRepo {\n          display: inline-block;\n        }\n        .fullRepo {\n          display: none;\n        }\n      }\n      @media only screen and (max-width: 100em) {\n        .assignee,\n        .branch {\n          max-width: 10rem;\n        }\n      }\n      @media only screen and (max-width: 50em) {\n        :host {\n          font-family: var(--header-font-family);\n          font-size: var(--font-size-h3);\n          font-weight: var(--font-weight-h3);\n          line-height: var(--line-height-h3);\n        }\n        gr-change-list-item {\n          flex-wrap: wrap;\n          justify-content: space-between;\n          padding: var(--spacing-xs) var(--spacing-m);\n        }\n        gr-change-list-item[selected],\n        gr-change-list-item:focus {\n          background-color: var(--view-background-color);\n          border: none;\n          border-top: 1px solid var(--border-color);\n        }\n        gr-change-list-item:hover {\n          background-color: var(--view-background-color);\n        }\n        .cell {\n          align-items: center;\n          display: flex;\n        }\n        .groupTitle,\n        .leftPadding,\n        .status,\n        .repo,\n        .branch,\n        .updated,\n        .label,\n        .assignee,\n        .groupHeader .star,\n        .noChanges .star {\n          display: none;\n        }\n        .groupHeader .cell,\n        .noChanges .cell {\n          padding-left: var(--spacing-m);\n        }\n        .subject {\n          margin-bottom: var(--spacing-xs);\n          width: calc(100% - 2em);\n        }\n        .owner,\n        .size {\n          max-width: none;\n        }\n        .noChanges .cell {\n          display: block;\n          height: auto;\n        }\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(O_.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const N_=ta`
  <style include="shared-styles">
    button {
      background-color: transparent;
      cursor: pointer;
    }
    iron-icon.active {
      fill: var(--link-color);
    }
    iron-icon {
      vertical-align: top;
      --iron-icon-height: var(
        --gr-change-star-size,
        var(--line-height-normal, 20px)
      );
      --iron-icon-width: var(
        --gr-change-star-size,
        var(--line-height-normal, 20px)
      );
    }
  </style>
  <button
    role="checkbox"
    title="[[createTitle(Shortcut.TOGGLE_CHANGE_STAR,
      ShortcutSection.ACTIONS)]]"
    aria-label="[[_computeAriaLabel(change.starred)]]"
    on-click="toggleStar"
  >
    <iron-icon
      class$="[[_computeStarClass(change.starred)]]"
      icon$="[[_computeStarIcon(change.starred)]]"
    ></iron-icon>
  </button>
`;var L_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let D_=class extends(xp(oo(dr(oa)))){static get template(){return N_}_computeStarClass(e){return e?"active":""}_computeStarIcon(e){return`gr-icons:star${e?"":"-border"}`}_computeAriaLabel(e){return e?"Unstar this change":"Star this change"}toggleStar(){if(!this.change)return;const e=!this.change.starred;this.set("change.starred",e),this.dispatchEvent(new CustomEvent("toggle-star",{bubbles:!0,composed:!0,detail:{change:this.change,starred:e}}))}};L_([Bl({type:Object,notify:!0})],D_.prototype,"change",void 0),D_=L_([Ml("gr-change-star")],D_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const $_=ta`
  <style include="shared-styles">
    .chip {
      border-radius: var(--border-radius);
      background-color: var(--chip-background-color);
      padding: 0 var(--spacing-m);
      white-space: nowrap;
    }
    :host(.merged) .chip {
      background-color: var(--status-merged);
      color: var(--status-merged);
    }
    :host(.abandoned) .chip {
      background-color: var(--status-abandoned);
      color: var(--status-abandoned);
    }
    :host(.wip) .chip {
      background-color: var(--status-wip);
      color: var(--status-wip);
    }
    :host(.private) .chip {
      background-color: var(--status-private);
      color: var(--status-private);
    }
    :host(.merge-conflict) .chip {
      background-color: var(--status-conflict);
      color: var(--status-conflict);
    }
    :host(.active) .chip {
      background-color: var(--status-active);
      color: var(--status-active);
    }
    :host(.ready-to-submit) .chip {
      background-color: var(--status-ready);
      color: var(--status-ready);
    }
    :host(.custom) .chip {
      background-color: var(--status-custom);
      color: var(--status-custom);
    }
    :host([flat]) .chip {
      background-color: transparent;
      padding: 0;
    }
    :host(:not([flat])) .chip {
      color: var(--status-text-color);
    }
  </style>
  <gr-tooltip-content
    has-tooltip=""
    position-below=""
    title="[[tooltipText]]"
    max-width="40em"
  >
    <div class="chip" aria-label$="Label: [[status]]">
      [[_computeStatusString(status)]]
    </div>
  </gr-tooltip-content>
`;var M_,F_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};!function(e){e.MERGED="Merged",e.ABANDONED="Abandoned",e.MERGE_CONFLICT="Merge Conflict",e.WIP="WIP",e.PRIVATE="Private"}(M_||(M_={}));let B_=class extends(oo(dr(oa))){constructor(){super(...arguments),this.flat=!1,this.tooltipText=""}static get template(){return $_}_computeStatusString(e){return e!==M_.WIP||this.flat?e:"Work in Progress"}_toClassName(e){return e?e.toLowerCase().replace(/\s/g,"-"):""}_updateChipDetails(e,t){switch(t&&this.classList.remove(this._toClassName(t)),this.classList.add(this._toClassName(e)),e){case M_.WIP:this.tooltipText="This change isn't ready to be reviewed or submitted. It will not appear on dashboards unless you are CC'ed or assigned, and email notifications will be silenced until the review is started.";break;case M_.PRIVATE:this.tooltipText='This change is only visible to its owner and current reviewers (or anyone with "View Private Changes" permission).';break;case M_.MERGE_CONFLICT:this.tooltipText='This change has merge conflicts. Download the patch and run "git rebase master". Upload a new patchset after resolving all merge conflicts.';break;default:this.tooltipText=""}}};F_([Bl({type:Boolean,reflectToAttribute:!0})],B_.prototype,"flat",void 0),F_([Bl({type:String,observer:"_updateChipDetails"})],B_.prototype,"status",void 0),F_([Bl({type:String})],B_.prototype,"tooltipText",void 0),B_=F_([Ml("gr-change-status")],B_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const j_=ta` [[_computeDisplayText(text, limit)]] `;var H_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let U_=class extends(mp(oo(dr(oa)))){constructor(){super(...arguments),this.text="",this.limit=null,this.tooltip="",this.hasTooltip=!1,this.disableTooltip=!1}static get template(){return j_}_updateTitle(e,t,n){[e,n,t].includes(void 0)||(this.hasTooltip=!!t||!!n&&e.length>n,this.hasTooltip&&!this.disableTooltip?n&&e.length>n?this.title=`${e}${t?` (${t})`:""}`:this.title=t:this.title="")}_computeDisplayText(e,t){return t&&e&&e.length>t?e.substr(0,t-1)+"…":e}};H_([Bl({type:String})],U_.prototype,"text",void 0),H_([Bl({type:Number})],U_.prototype,"limit",void 0),H_([Bl({type:String})],U_.prototype,"tooltip",void 0),H_([Bl({type:Boolean})],U_.prototype,"hasTooltip",void 0),H_([Bl({type:Boolean})],U_.prototype,"disableTooltip",void 0),H_([jl("text","tooltip","limit")],U_.prototype,"_updateTitle",null),U_=H_([Ml("gr-limited-text")],U_);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const G_=ta`
  <style include="shared-styles">
    :host {
      display: table-row;
      color: var(--primary-text-color);
    }
    :host(:focus) {
      outline: none;
    }
    :host(:hover) {
      background-color: var(--hover-background-color);
    }
    :host([needs-review]) {
      font-weight: var(--font-weight-bold);
      color: var(--primary-text-color);
    }
    :host([highlight]) {
      background-color: var(--assignee-highlight-color);
    }
    .container {
      position: relative;
    }
    .content {
      overflow: hidden;
      position: absolute;
      text-overflow: ellipsis;
      white-space: nowrap;
      width: 100%;
    }
    .content a {
      display: block;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
      width: 100%;
    }
    .comments,
    .reviewers {
      white-space: nowrap;
    }
    .reviewers {
      --account-max-length: 90px;
    }
    .spacer {
      height: 0;
      overflow: hidden;
    }
    .status {
      align-items: center;
      display: inline-flex;
    }
    .status .comma {
      padding-right: var(--spacing-xs);
    }
    /* Used to hide the leading separator comma for statuses. */
    .status .comma:first-of-type {
      display: none;
    }
    .size gr-tooltip-content {
      margin: -0.4rem -0.6rem;
      max-width: 2.5rem;
      padding: var(--spacing-m) var(--spacing-l);
    }
    a {
      color: inherit;
      cursor: pointer;
      text-decoration: none;
    }
    a:hover {
      text-decoration: underline;
    }
    .u-monospace {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
    }
    .u-green,
    .u-green iron-icon {
      color: var(--positive-green-text-color);
    }
    .u-red,
    .u-red iron-icon {
      color: var(--negative-red-text-color);
    }
    .u-gray-background {
      background-color: var(--table-header-background-color);
    }
    .comma,
    .placeholder {
      color: var(--deemphasized-text-color);
    }
    .cell.label {
      font-weight: var(--font-weight-normal);
    }
    .cell.label iron-icon {
      vertical-align: top;
    }
    @media only screen and (max-width: 50em) {
      :host {
        display: flex;
      }
    }
  </style>
  <style include="gr-change-list-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <td aria-hidden="true" class="cell leftPadding"></td>
  <td class="cell star" hidden$="[[!showStar]]" hidden="">
    <gr-change-star change="{{change}}"></gr-change-star>
  </td>
  <td class="cell number" hidden$="[[!showNumber]]" hidden="">
    <a href$="[[changeURL]]">[[change._number]]</a>
  </td>
  <td
    class="cell subject"
    hidden$="[[isColumnHidden('Subject', visibleChangeTableColumns)]]"
  >
    <div class="container">
      <div class="content">
        <a
          title$="[[change.subject]]"
          href$="[[changeURL]]"
          on-click="_handleChangeClick"
        >
          [[change.subject]]
        </a>
      </div>
      <div class="spacer">
        [[change.subject]]
      </div>
      <span>&nbsp;</span>
    </div>
  </td>
  <td
    class="cell status"
    hidden$="[[isColumnHidden('Status', visibleChangeTableColumns)]]"
  >
    <template is="dom-repeat" items="[[statuses]]" as="status">
      <div class="comma">,</div>
      <gr-change-status flat="" status="[[status]]"></gr-change-status>
    </template>
    <template is="dom-if" if="[[!statuses.length]]">
      <span class="placeholder">--</span>
    </template>
  </td>
  <td
    class="cell owner"
    hidden$="[[isColumnHidden('Owner', visibleChangeTableColumns)]]"
  >
    <gr-account-link
      highlight-attention
      change="[[change]]"
      account="[[change.owner]]"
    ></gr-account-link>
  </td>
  <td
    class="cell assignee"
    hidden$="[[isColumnHidden('Assignee', visibleChangeTableColumns)]]"
  >
    <template is="dom-if" if="[[change.assignee]]">
      <gr-account-link
        id="assigneeAccountLink"
        account="[[change.assignee]]"
      ></gr-account-link>
    </template>
    <template is="dom-if" if="[[!change.assignee]]">
      <span class="placeholder">--</span>
    </template>
  </td>
  <td
    class="cell reviewers"
    hidden$="[[isColumnHidden('Reviewers', visibleChangeTableColumns)]]"
  >
    <div>
      <template
        is="dom-repeat"
        items="[[_computePrimaryReviewers(change)]]"
        as="reviewer"
        indexAs="index"
      >
        <gr-account-link
          hide-avatar=""
          hide-status=""
          first-name
          highlight-attention
          change="[[change]]"
          account="[[reviewer]]"
        ></gr-account-link
        ><span
          hidden$="[[_computeCommaHidden(index, change)]]"
          aria-hidden="true"
          >,
        </span>
      </template>
      <template is="dom-if" if="[[_computeAdditionalReviewersCount(change)]]">
        <span title="[[_computeAdditionalReviewersTitle(change, config)]]">
          +[[_computeAdditionalReviewersCount(change, config)]]
        </span>
      </template>
    </div>
  </td>
  <td
    class="cell comments"
    hidden$="[[isColumnHidden('Comments', visibleChangeTableColumns)]]"
  >
    <iron-icon
      hidden$="[[!change.unresolved_comment_count]]"
      icon="gr-icons:comment"
    ></iron-icon>
    <span>[[_computeComments(change.unresolved_comment_count)]]</span>
  </td>
  <td
    class="cell repo"
    hidden$="[[isColumnHidden('Repo', visibleChangeTableColumns)]]"
  >
    <a class="fullRepo" href$="[[_computeRepoUrl(change)]]">
      [[_computeRepoDisplay(change)]]
    </a>
    <a
      class="truncatedRepo"
      href$="[[_computeRepoUrl(change)]]"
      title$="[[_computeRepoDisplay(change)]]"
    >
      [[_computeRepoDisplay(change, 'true')]]
    </a>
  </td>
  <td
    class="cell branch"
    hidden$="[[isColumnHidden('Branch', visibleChangeTableColumns)]]"
  >
    <a href$="[[_computeRepoBranchURL(change)]]">
      [[change.branch]]
    </a>
    <template is="dom-if" if="[[change.topic]]">
      (<a href$="[[_computeTopicURL(change)]]"
        ><!--
       --><gr-limited-text limit="50" text="[[change.topic]]"> </gr-limited-text
        ><!--
     --></a
      >)
    </template>
  </td>
  <td
    class="cell updated"
    hidden$="[[isColumnHidden('Updated', visibleChangeTableColumns)]]"
  >
    <gr-date-formatter
      has-tooltip=""
      date-str="[[change.updated]]"
    ></gr-date-formatter>
  </td>
  <td
    class="cell size"
    hidden$="[[isColumnHidden('Size', visibleChangeTableColumns)]]"
  >
    <gr-tooltip-content has-tooltip="" title="[[_computeSizeTooltip(change)]]">
      <template is="dom-if" if="[[_changeSize]]">
        <span>[[_changeSize]]</span>
      </template>
      <template is="dom-if" if="[[!_changeSize]]">
        <span class="placeholder">--</span>
      </template>
    </gr-tooltip-content>
  </td>
  <template is="dom-repeat" items="[[labelNames]]" as="labelName">
    <td
      title$="[[_computeLabelTitle(change, labelName)]]"
      class$="[[_computeLabelClass(change, labelName)]]"
    >
      <template is="dom-if" if="[[_computeHasLabelIcon(change, labelName)]]">
        <iron-icon icon="[[_computeLabelIcon(change, labelName)]]"></iron-icon>
      </template>
      <template is="dom-if" if="[[!_computeHasLabelIcon(change, labelName)]]">
        <span>[[_computeLabelValue(change, labelName)]]</span>
      </template>
    </td>
  </template>
  <template
    is="dom-repeat"
    items="[[_dynamicCellEndpoints]]"
    as="pluginEndpointName"
  >
    <td class="cell endpoint">
      <gr-endpoint-decorator name$="[[pluginEndpointName]]">
        <gr-endpoint-param name="change" value="[[change]]">
        </gr-endpoint-param>
      </gr-endpoint-decorator>
    </td>
  </template>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var V_=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const z_=Me(e=>{class t extends e{constructor(){super(...arguments),this.columnNames=["Subject","Status","Owner","Assignee","Reviewers","Comments","Repo","Branch","Updated","Size"]}getComplementColumns(e){return this.columnNames.filter(t=>!e.includes(t))}isColumnHidden(e,t){return!(!t||!e)&&!t.includes(e)}isColumnEnabled(e,t,n){return!t||!t.change||("Assignee"===e?!!t.change.enable_assignee:"Comments"===e?n.includes("comments-column"):"Reviewers"!==e||!!t.change.enable_attention_set)}getEnabledColumns(e,t,n){return e.filter(e=>this.isColumnEnabled(e,t,n))}getVisibleColumns(e){const t=e.indexOf("Project");if(-1===t)return e;const n=[...e];return n[t]="Repo",n}}return V_([Bl({type:Array})],t.prototype,"columnNames",void 0),t});
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */function W_(e,t){if(e===ka.COMMIT_MESSAGE)return-1;if(t===ka.COMMIT_MESSAGE)return 1;if(e===ka.MERGE_LIST)return-1;if(t===ka.MERGE_LIST)return 1;const n=e.lastIndexOf("."),i=e.substr(n+1),o=e.substr(0,n)||e,s=t.lastIndexOf("."),r=t.substr(s+1),a=t.substr(0,s)||t,l=["h","hxx","hpp"];if(o.length>0&&o===a){if(l.includes(i)&&l.includes(r))return e.localeCompare(t);if(l.includes(i))return-1;if(l.includes(r))return 1}return o.localeCompare(a)||e.localeCompare(t)}function q_(e,t){t&&Object.keys(t).forEach(t=>{o(e,t)||t===ka.PATCHSET_LEVEL_COMMENTS||(e[t]={status:$a.UNMODIFIED})})}function K_(e){return e===ka.COMMIT_MESSAGE?"Commit message":e===ka.MERGE_LIST?"Merge list":e}function Y_(e){return!!e&&(e===ka.COMMIT_MESSAGE||e===ka.MERGE_LIST)}function X_(e){return J_(K_(e))}function J_(e,t=1){const n=e.split("/");if(n.length<=t)return e;const i=n.length-t;return`…/${n.slice(i).join("/")}`}
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */var Z_,Q_,ef=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};!function(e){e[e.XS=10]="XS",e[e.SMALL=50]="SMALL",e[e.MEDIUM=250]="MEDIUM",e[e.LARGE=1e3]="LARGE"}(Z_||(Z_={})),function(e){e.NOT_APPLICABLE="NOT_APPLICABLE",e.APPROVED="APPROVED",e.POSITIVE="POSITIVE",e.NEUTRAL="NEUTRAL",e.UNRESOLVED_COMMENTS="UNRESOLVED_COMMENTS",e.NEGATIVE="NEGATIVE",e.REJECTED="REJECTED"}(Q_||(Q_={}));let tf=class extends(z_(oo(dr(oa)))){constructor(){super(...arguments),this.account=null,this.showStar=!1,this.showNumber=!1,this.reporting=n.reportingService}static get template(){return G_}attached(){super.attached(),eh().awaitPluginsLoaded().then(()=>{this._dynamicCellEndpoints=rc().getDynamicEndpoints("change-list-item-cell")})}_changeStatuses(e){return e?qp(e):[]}_computeChangeURL(e){return e?gh.getUrlForChange(e):""}_computeLabelTitle(e,t){var n,i;const o=null===(n=null==e?void 0:e.labels)||void 0===n?void 0:n[t],s=this._computeLabelCategory(e,t);if(!o||s===Q_.NOT_APPLICABLE)return"Label not applicable";if(s===Q_.UNRESOLVED_COMMENTS){const t=null!==(i=null==e?void 0:e.unresolved_comment_count)&&void 0!==i?i:0;return`${t} unresolved comment${t>1?"s":""}`}const r=o.rejected||o.approved||o.disliked||o.recommended;return r&&r.name?`${t}\nby ${r.name}`:t}_computeLabelClass(e,t){const n=["cell","label"];switch(this._computeLabelCategory(e,t)){case Q_.NOT_APPLICABLE:n.push("u-gray-background");break;case Q_.APPROVED:n.push("u-green");break;case Q_.POSITIVE:n.push("u-monospace"),n.push("u-green");break;case Q_.NEGATIVE:n.push("u-monospace"),n.push("u-red");break;case Q_.REJECTED:n.push("u-red")}return n.sort().join(" ")}_computeHasLabelIcon(e,t){return""!==this._computeLabelIcon(e,t)}_computeLabelIcon(e,t){switch(this._computeLabelCategory(e,t)){case Q_.APPROVED:return"gr-icons:check";case Q_.UNRESOLVED_COMMENTS:return"gr-icons:comment";case Q_.REJECTED:return"gr-icons:close";default:return""}}_computeLabelCategory(e,t){var n;const i=null===(n=null==e?void 0:e.labels)||void 0===n?void 0:n[t];return i?i.rejected?Q_.REJECTED:i.value&&i.value<0?Q_.NEGATIVE:(null==e?void 0:e.unresolved_comment_count)&&"Code-Review"===t?Q_.UNRESOLVED_COMMENTS:i.approved?Q_.APPROVED:i.value&&i.value>0?Q_.POSITIVE:Q_.NEUTRAL:Q_.NOT_APPLICABLE}_computeLabelValue(e,t){var n;const i=null===(n=null==e?void 0:e.labels)||void 0===n?void 0:n[t];switch(this._computeLabelCategory(e,t)){case Q_.NOT_APPLICABLE:return"";case Q_.APPROVED:return"✓";case Q_.POSITIVE:return`+${null==i?void 0:i.value}`;case Q_.NEUTRAL:return"";case Q_.UNRESOLVED_COMMENTS:return"u";case Q_.NEGATIVE:return`${null==i?void 0:i.value}`;case Q_.REJECTED:return"✕"}}_computeRepoUrl(e){return e?gh.getUrlForProjectChanges(e.project,!0,e.internalHost):""}_computeRepoBranchURL(e){return e?gh.getUrlForBranch(e.branch,e.project,void 0,e.internalHost):""}_computeTopicURL(e){return(null==e?void 0:e.topic)?gh.getUrlForTopic(e.topic,e.internalHost):""}_computeRepoDisplay(e,t){if(!(null==e?void 0:e.project))return"";let n="";return e.internalHost&&(n+=e.internalHost+"/"),n+=t?J_(e.project,2):e.project,n}_computeSizeTooltip(e){return!e||e.insertions+e.deletions===0||isNaN(e.insertions+e.deletions)?"Size unknown":`added ${e.insertions}, removed ${e.deletions} lines`}_hasAttention(e){return!!(this.change&&this.change.attention_set&&e._account_id)&&o(this.change.attention_set,e._account_id)}_computeReviewers(e){if(!(null==e?void 0:e.reviewers)||!(null==e?void 0:e.reviewers.REVIEWER))return[];const t=[...e.reviewers.REVIEWER].filter(t=>!(e.owner&&e.owner._account_id===t._account_id||pc(t)));return t.sort((e,t)=>{if(this.account){if(e._account_id===this.account._account_id)return-1;if(t._account_id===this.account._account_id)return 1}return this._hasAttention(e)&&!this._hasAttention(t)?-1:this._hasAttention(t)&&!this._hasAttention(e)?1:(e.name||"").localeCompare(t.name||"")}),t}_computePrimaryReviewers(e){return this._computeReviewers(e).slice(0,2)}_computeAdditionalReviewers(e){return this._computeReviewers(e).slice(2)}_computeAdditionalReviewersCount(e){return this._computeAdditionalReviewers(e).length}_computeAdditionalReviewersTitle(e,t){return e&&t?this._computeAdditionalReviewers(e).map(e=>sl(t,e,!0)).join(", "):""}_computeComments(e){return!e||e<1?"":`${e} unresolved`}_computeChangeSize(e){if(!e)return null;const t=e.insertions+e.deletions;return isNaN(t)||0===t?null:t<Z_.XS?"XS":t<Z_.SMALL?"S":t<Z_.MEDIUM?"M":t<Z_.LARGE?"L":"XL"}toggleReviewed(){var e;const t=!(null===(e=this.change)||void 0===e?void 0:e.reviewed);this.set("change.reviewed",t),this.dispatchEvent(new CustomEvent("toggle-reviewed",{bubbles:!0,composed:!0,detail:{change:this.change,reviewed:t}}))}_handleChangeClick(){const e=this.account&&this.account._account_id||-1,t=this.change&&this.change.owner&&this.change.owner._account_id||-1;this.reporting.reportInteraction("change-row-clicked",{section:this.sectionName,isOwner:e===t})}_computeCommaHidden(e,t){if(void 0===e)return!1;if(void 0===t)return!1;const n=this._computeAdditionalReviewersCount(t);return e===this._computePrimaryReviewers(t).length-1&&0===n}};ef([Bl({type:Object})],tf.prototype,"account",void 0),ef([Bl({type:Array})],tf.prototype,"visibleChangeTableColumns",void 0),ef([Bl({type:Array})],tf.prototype,"labelNames",void 0),ef([Bl({type:Object})],tf.prototype,"change",void 0),ef([Bl({type:Object})],tf.prototype,"config",void 0),ef([Bl({type:String})],tf.prototype,"sectionName",void 0),ef([Bl({type:String,computed:"_computeChangeURL(change)"})],tf.prototype,"changeURL",void 0),ef([Bl({type:Array,computed:"_changeStatuses(change)"})],tf.prototype,"statuses",void 0),ef([Bl({type:Boolean})],tf.prototype,"showStar",void 0),ef([Bl({type:Boolean})],tf.prototype,"showNumber",void 0),ef([Bl({type:String,computed:"_computeChangeSize(change)"})],tf.prototype,"_changeSize",void 0),ef([Bl({type:Array})],tf.prototype,"_dynamicCellEndpoints",void 0),tf=ef([Ml("gr-change-list-item")],tf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const nf=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-change-list-styles">
    #changeList {
      border-collapse: collapse;
      width: 100%;
    }
    .section-count-label {
      color: var(--deemphasized-text-color);
      font-family: var(--font-family);
      font-size: var(--font-size-small);
      font-weight: var(--font-weight-normal);
      line-height: var(--line-height-small);
    }
    a.section-title:hover {
      text-decoration: none;
    }
    a.section-title:hover .section-count-label {
      text-decoration: none;
    }
    a.section-title:hover .section-name {
      text-decoration: underline;
    }
  </style>
  <table id="changeList">
    <template
      is="dom-repeat"
      items="[[sections]]"
      as="changeSection"
      index-as="sectionIndex"
    >
      <template is="dom-if" if="[[changeSection.name]]">
        <tbody>
          <tr class="groupHeader">
            <td aria-hidden="true" class="leftPadding"></td>
            <td
              aria-hidden="true"
              class="star"
              hidden$="[[!showStar]]"
              hidden=""
            ></td>
            <td
              class="cell"
              colspan$="[[_computeColspan(changeTableColumns, labelNames)]]"
            >
              <a
                href$="[[_sectionHref(changeSection.query)]]"
                class="section-title"
              >
                <span class="section-name">[[changeSection.name]]</span>
                <span class="section-count-label"
                  >[[changeSection.countLabel]]</span
                >
              </a>
            </td>
          </tr>
        </tbody>
      </template>
      <tbody class="groupContent">
        <template is="dom-if" if="[[_isEmpty(changeSection)]]">
          <tr class="noChanges">
            <td aria-hidden="true" class="leftPadding"></td>
            <td aria-hidden="true" class="star" hidden></td>
            <td
              class="cell"
              colspan$="[[_computeColspan(changeTableColumns, labelNames)]]"
            >
              <template
                is="dom-if"
                if="[[_getSpecialEmptySlot(changeSection)]]"
              >
                <slot name="[[_getSpecialEmptySlot(changeSection)]]"></slot>
              </template>
              <template
                is="dom-if"
                if="[[!_getSpecialEmptySlot(changeSection)]]"
              >
                No changes
              </template>
            </td>
          </tr>
        </template>
        <template is="dom-if" if="[[!_isEmpty(changeSection)]]">
          <tr class="groupTitle">
            <td aria-hidden="true" class="leftPadding"></td>
            <td
              aria-label="Star status column"
              class="star"
              hidden$="[[!showStar]]"
              hidden=""
            ></td>
            <td class="number" hidden$="[[!showNumber]]" hidden="">#</td>
            <template is="dom-repeat" items="[[changeTableColumns]]" as="item">
              <td
                class$="[[_lowerCase(item)]]"
                hidden$="[[isColumnHidden(item, visibleChangeTableColumns)]]"
              >
                [[item]]
              </td>
            </template>
            <template is="dom-repeat" items="[[labelNames]]" as="labelName">
              <td class="label" title$="[[labelName]]">
                [[_computeLabelShortcut(labelName)]]
              </td>
            </template>
            <template
              is="dom-repeat"
              items="[[_dynamicHeaderEndpoints]]"
              as="pluginHeader"
            >
              <td class="endpoint">
                <gr-endpoint-decorator name$="[[pluginHeader]]">
                </gr-endpoint-decorator>
              </td>
            </template>
          </tr>
        </template>
        <template is="dom-repeat" items="[[changeSection.results]]" as="change">
          <gr-change-list-item
            account="[[account]]"
            selected$="[[_computeItemSelected(sectionIndex, index, selectedIndex)]]"
            highlight$="[[_computeItemHighlight(account, change)]]"
            needs-review$="[[_computeItemNeedsReview(account, change, showReviewedState, _config)]]"
            change="[[change]]"
            config="[[_config]]"
            section-name="[[changeSection.name]]"
            visible-change-table-columns="[[visibleChangeTableColumns]]"
            show-number="[[showNumber]]"
            show-star="[[showStar]]"
            tabindex$="[[_computeTabIndex(sectionIndex, index, selectedIndex)]]"
            label-names="[[labelNames]]"
          ></gr-change-list-item>
        </template>
      </tbody>
    </template>
  </table>
  <gr-cursor-manager
    id="cursor"
    index="{{selectedIndex}}"
    scroll-mode="keep-visible"
    focus-on-move=""
  ></gr-cursor-manager>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var of=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const sf=["MERGED","ABANDONED"];let rf=class extends(z_(xp(oo(dr(oa))))){constructor(){super(...arguments),this.account=void 0,this.sections=[],this.showStar=!1,this.showReviewedState=!1,this.keyEventTarget=document.body,this.flagsService=n.flagsService}static get template(){return nf}keyboardShortcuts(){return{[yp.CURSOR_NEXT_CHANGE]:"_nextChange",[yp.CURSOR_PREV_CHANGE]:"_prevChange",[yp.NEXT_PAGE]:"_nextPage",[yp.PREV_PAGE]:"_prevPage",[yp.OPEN_CHANGE]:"_openChange",[yp.TOGGLE_CHANGE_REVIEWED]:"_toggleChangeReviewed",[yp.TOGGLE_CHANGE_STAR]:"_toggleChangeStar",[yp.REFRESH_CHANGE_LIST]:"_refreshChangeList"}}created(){super.created(),this.addEventListener("keydown",e=>this._scopedKeydownHandler(e))}ready(){super.ready(),this.$.restAPI.getConfig().then(e=>{this._config=e})}attached(){super.attached(),eh().awaitPluginsLoaded().then(()=>{this._dynamicHeaderEndpoints=rc().getDynamicEndpoints("change-list-header")})}_scopedKeydownHandler(e){13===e.keyCode&&this._openChange(e)}_lowerCase(e){return e.toLowerCase()}_computePreferences(e,t,n){if(n&&(this.changeTableColumns=this.columnNames,this.showNumber=!1,this.visibleChangeTableColumns=this.getEnabledColumns(this.columnNames,n,this.flagsService.enabledExperiments),e&&t&&(this.showNumber=!(!t||!t.legacycid_in_change_table),t.change_table&&t.change_table.length>0))){const e=this.getVisibleColumns(t.change_table);this.visibleChangeTableColumns=this.getEnabledColumns(e,n,this.flagsService.enabledExperiments)}}_computeColspan(e,t){if(e&&t)return e.length+t.length+3}_computeLabelNames(e){if(!e)return[];let t=[];const n=function(e){return!t.includes(e)};for(const i of e)if(i.results)for(const e of i.results){if(!e.labels)continue;const i=Object.keys(e.labels);t=t.concat(i.filter(n))}return t.sort()}_computeLabelShortcut(e){return e.startsWith("Invalid-Prolog-Rules-Label-Name--")&&(e=e.slice("Invalid-Prolog-Rules-Label-Name--".length)),e.split("-").reduce((e,t)=>t?e+t[0].toUpperCase():e,"").slice(0,5)}_changesChanged(e){this.sections=e?[{results:e}]:[]}_processQuery(e){let t=e.split(" ");const n=["limit:","age:","-age:"];return t=t.filter(e=>!n.some(t=>e.startsWith(t))),t.join(" ")}_sectionHref(e){return gh.getUrlForSearchQuery(this._processQuery(e))}_computeItemAbsoluteIndex(e,t){let n=0;for(let t=0;t<e;t++)n+=this.sections[t].results.length;return n+t}_computeItemSelected(e,t,n){return this._computeItemAbsoluteIndex(e,t)===n}_computeTabIndex(e,t,n){return this._computeItemSelected(e,t,n)?0:void 0}_computeItemNeedsReview(e,t,n,i){return!(!!i&&!!i.change&&i.change.enable_attention_set)&&n&&!t.reviewed&&!t.work_in_progress&&Wp(t)&&(!e||e._account_id!==t.owner._account_id)}_computeItemHighlight(e,t){return!!(t&&t.assignee&&e&&-1===sf.indexOf(t.status))&&e._account_id===t.assignee._account_id}_nextChange(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.$.cursor.next())}_prevChange(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.$.cursor.previous())}_openChange(e){if(this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e))return;e.preventDefault();const t=this._changeForIndex(this.selectedIndex);t&&gh.navigateToChange(t)}_nextPage(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)&&!this.isModifierPressed(e,Sp.SHIFT_KEY)||(e.preventDefault(),this.dispatchEvent(new CustomEvent("next-page",{composed:!0,bubbles:!0})))}_prevPage(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)&&!this.isModifierPressed(e,Sp.SHIFT_KEY)||(e.preventDefault(),this.dispatchEvent(new CustomEvent("previous-page",{composed:!0,bubbles:!0})))}_toggleChangeReviewed(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._toggleReviewedForIndex(this.selectedIndex))}_toggleReviewedForIndex(e){const t=this._getListItems();void 0===e||e>=t.length||!t[e]||t[e].toggleReviewed()}_refreshChangeList(e){this.shouldSuppressKeyboardShortcut(e)||(e.preventDefault(),this._reloadWindow())}_reloadWindow(){window.location.reload()}_toggleChangeStar(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._toggleStarForIndex(this.selectedIndex))}_toggleStarForIndex(e){var t;const n=this._getListItems();if(void 0===e||e>=n.length||!n[e])return;const i=n[e],o=null===(t=null==i?void 0:i.shadowRoot)||void 0===t?void 0:t.querySelector("gr-change-star");o&&o.toggleStar()}_changeForIndex(e){const t=this._getListItems();return void 0!==e&&e<t.length&&t[e]?t[e].change:null}_getListItems(){var e;const t=null===(e=this.root)||void 0===e?void 0:e.querySelectorAll("gr-change-list-item");return t?Array.from(t):[]}_sectionsChanged(){Ao(this,()=>{this.$.cursor.stops=this._getListItems(),this.$.cursor.moveToStart()})}_getSpecialEmptySlot(e){return e.isOutgoing?"empty-outgoing":"Your Turn"===e.name?"empty-your-turn":""}_isEmpty(e){var t;return!(null===(t=e.results)||void 0===t?void 0:t.length)}};of([Bl({type:Object})],rf.prototype,"account",void 0),of([Bl({type:Array,observer:"_changesChanged"})],rf.prototype,"changes",void 0),of([Bl({type:Array})],rf.prototype,"sections",void 0),of([Bl({type:Array,computed:"_computeLabelNames(sections)"})],rf.prototype,"labelNames",void 0),of([Bl({type:Array})],rf.prototype,"_dynamicHeaderEndpoints",void 0),of([Bl({type:Number,notify:!0})],rf.prototype,"selectedIndex",void 0),of([Bl({type:Boolean})],rf.prototype,"showNumber",void 0),of([Bl({type:Boolean})],rf.prototype,"showStar",void 0),of([Bl({type:Boolean})],rf.prototype,"showReviewedState",void 0),of([Bl({type:Object})],rf.prototype,"keyEventTarget",void 0),of([Bl({type:Array})],rf.prototype,"changeTableColumns",void 0),of([Bl({type:Array})],rf.prototype,"visibleChangeTableColumns",void 0),of([Bl({type:Object})],rf.prototype,"preferences",void 0),of([Bl({type:Object})],rf.prototype,"_config",void 0),of([jl("account","preferences","_config")],rf.prototype,"_computePreferences",null),of([jl("sections.*")],rf.prototype,"_sectionsChanged",null),rf=of([Ml("gr-change-list")],rf);
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const af=document.createElement("template");af.innerHTML='<dom-module id="dashboard-header-styles">\n  <template>\n    <style>\n      :host {\n        background-color: var(--view-background-color);\n        display: block;\n        min-height: 9em;\n        width: 100%;\n      }\n      gr-avatar {\n        display: inline-block;\n        height: 7em;\n        left: 1em;\n        margin: 1em;\n        top: 1em;\n        width: 7em;\n      }\n      .info {\n        display: inline-block;\n        padding: var(--spacing-l);\n        vertical-align: top;\n      }\n      .info > div > span {\n        display: inline-block;\n        font-weight: var(--font-weight-bold);\n        text-align: right;\n        width: 4em;\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(af.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const lf=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="dashboard-header-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div class="info">
    <h1 class="heading-1">
      [[repo]]
      <hr />
    </h1>
    <div><span>Detail:</span> <a href$="[[_repoUrl]]">Repo settings</a></div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var cf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let df=class extends(oo(dr(oa))){constructor(){super(...arguments),this._repoUrl=null}static get template(){return lf}_repoChanged(e){this._repoUrl=e?gh.getUrlForRepo(e):null}};cf([Bl({type:String,observer:"_repoChanged"})],df.prototype,"repo",void 0),cf([Bl({type:String})],df.prototype,"_repoUrl",void 0),df=cf([Ml("gr-repo-header")],df);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const hf=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="dashboard-header-styles">
    .status.hide,
    .name.hide,
    .dashboardLink.hide {
      display: none;
    }
  </style>
  <gr-avatar
    account="[[_accountDetails]]"
    image-size="100"
    aria-label="Account avatar"
  ></gr-avatar>
  <div class="info">
    <h1 class="heading-1">
      [[_computeDetail(_accountDetails, 'name')]]
    </h1>
    <hr />
    <div class$="status [[_computeStatusClass(_status)]]">
      <span>Status:</span> [[_status]]
    </div>
    <div>
      <span>Email:</span>
      <a href="mailto:[[_computeDetail(_accountDetails, 'email')]]"
        ><!--
          -->[[_computeDetail(_accountDetails, 'email')]]</a
      >
    </div>
    <div>
      <span>Joined:</span>
      <gr-date-formatter
        date-str="[[_computeDetail(_accountDetails, 'registered_on')]]"
      >
      </gr-date-formatter>
    </div>
    <gr-endpoint-decorator name="user-header">
      <gr-endpoint-param name="accountDetails" value="[[_accountDetails]]">
      </gr-endpoint-param>
      <gr-endpoint-param name="loggedIn" value="[[loggedIn]]">
      </gr-endpoint-param>
    </gr-endpoint-decorator>
  </div>
  <div class="info">
    <div class$="[[_computeDashboardLinkClass(showDashboardLink, loggedIn)]]">
      <a href$="[[_computeDashboardUrl(_accountDetails)]]">View dashboard</a>
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var pf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let uf=class extends(oo(dr(oa))){constructor(){super(...arguments),this.showDashboardLink=!1,this.loggedIn=!1,this._accountDetails=null,this._status=""}static get template(){return hf}_accountChanged(e){if(!e)return this._accountDetails=null,void(this._status="");this.$.restAPI.getAccountDetails(e).then(e=>{var t;this._accountDetails=null!=e?e:null,this._status=null!==(t=null==e?void 0:e.status)&&void 0!==t?t:""})}_computeDetail(e,t){return e?e[t]:""}_computeStatusClass(e){return e?"":"hide"}_computeDashboardUrl(e){if(!e)return null;const t=e._account_id;if(t)return gh.getUrlForUserDashboard(String(t));const n=e.email;return n?gh.getUrlForUserDashboard(n):null}_computeDashboardLinkClass(e,t){return e&&t?"dashboardLink":"dashboardLink hide"}};pf([Bl({type:String,observer:"_accountChanged"})],uf.prototype,"userId",void 0),pf([Bl({type:Boolean})],uf.prototype,"showDashboardLink",void 0),pf([Bl({type:Boolean})],uf.prototype,"loggedIn",void 0),pf([Bl({type:Object})],uf.prototype,"_accountDetails",void 0),pf([Bl({type:String})],uf.prototype,"_status",void 0),uf=pf([Ml("gr-user-header")],uf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const gf=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    .loading {
      color: var(--deemphasized-text-color);
      padding: var(--spacing-l);
    }
    gr-change-list {
      width: 100%;
    }
    gr-user-header,
    gr-repo-header {
      border-bottom: 1px solid var(--border-color);
    }
    nav {
      align-items: center;
      display: flex;
      height: 3rem;
      justify-content: flex-end;
      margin-right: 20px;
    }
    nav,
    iron-icon {
      color: var(--deemphasized-text-color);
    }
    iron-icon {
      height: 1.85rem;
      margin-left: 16px;
      width: 1.85rem;
    }
    .hide {
      display: none;
    }
    @media only screen and (max-width: 50em) {
      .loading,
      .error {
        padding: 0 var(--spacing-l);
      }
    }
  </style>
  <div class="loading" hidden$="[[!_loading]]" hidden="">Loading...</div>
  <div hidden$="[[_loading]]" hidden="">
    <gr-repo-header
      repo="[[_repo]]"
      class$="[[_computeHeaderClass(_repo)]]"
    ></gr-repo-header>
    <gr-user-header
      user-id="[[_userId]]"
      show-dashboard-link=""
      logged-in="[[_loggedIn]]"
      class$="[[_computeHeaderClass(_userId)]]"
    ></gr-user-header>
    <gr-change-list
      account="[[account]]"
      changes="{{_changes}}"
      preferences="[[preferences]]"
      selected-index="{{viewState.selectedChangeIndex}}"
      show-star="[[_loggedIn]]"
      on-toggle-star="_handleToggleStar"
      on-toggle-reviewed="_handleToggleReviewed"
    ></gr-change-list>
    <nav class$="[[_computeNavClass(_loading)]]">
      Page [[_computePage(_offset, _changesPerPage)]]
      <a
        id="prevArrow"
        href$="[[_computeNavLink(_query, _offset, -1, _changesPerPage)]]"
        class$="[[_computePrevArrowClass(_offset)]]"
      >
        <iron-icon icon="gr-icons:chevron-left" aria-label="Older"> </iron-icon>
      </a>
      <a
        id="nextArrow"
        href$="[[_computeNavLink(_query, _offset, 1, _changesPerPage)]]"
        class$="[[_computeNextArrowClass(_changes)]]"
      >
        <iron-icon icon="gr-icons:chevron-right" aria-label="Newer">
        </iron-icon>
      </a>
    </nav>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,mf={CHANGE_ID:/^\s*i?[0-9a-f]{7,40}\s*$/i,CHANGE_NUM:/^\s*[1-9][0-9]*\s*$/g,COMMIT:/[0-9a-f]{40}/},_f=/^owner:\s?("[^"]+"|[^ ]+)$/,ff=/^project:\s?("[^"]+"|[^ ]+)(\sstatus\s?:(open|"open"))?$/,vf=/\blimit:(\d+)/i;class yf extends(oo(dr(oa))){static get template(){return gf}static get is(){return"gr-change-list-view"}static get properties(){return{params:{type:Object,observer:"_paramsChanged"},_loggedIn:{type:Boolean,computed:"_computeLoggedIn(account)"},account:{type:Object,value:null},viewState:{type:Object,notify:!0,value:()=>({})},preferences:Object,_changesPerPage:Number,_query:{type:String,value:""},_offset:Number,_changes:{type:Array,observer:"_changesChanged"},_loading:{type:Boolean,value:!0},_userId:{type:String,value:null},_repo:{type:String,value:null}}}created(){super.created(),this.addEventListener("next-page",()=>this._handleNextPage()),this.addEventListener("previous-page",()=>this._handlePreviousPage())}attached(){super.attached(),this._loadPreferences()}_paramsChanged(e){e.view===gh.View.SEARCH&&(this._loading=!0,this._query=e.query,this._offset=e.offset||0,this.viewState.query==this._query&&this.viewState.offset==this._offset||(this.set("viewState.selectedChangeIndex",0),this.set("viewState.query",this._query),this.set("viewState.offset",this._offset)),this.async(()=>this.dispatchEvent(new CustomEvent("title-change",{detail:{title:this._query},composed:!0,bubbles:!0}))),this._getPreferences().then(e=>(this._changesPerPage=e.changes_per_page,this._getChanges())).then(e=>{if(e=e||[],this._query&&1===e.length)for(const t in mf)if(mf.hasOwnProperty(t)&&this._query.match(mf[t]))return void gh.navigateToChange(e[0],null,null,null,!0);this._changes=e,this._loading=!1}))}_loadPreferences(){return this.$.restAPI.getLoggedIn().then(e=>{e?this._getPreferences().then(e=>{this.preferences=e}):this.preferences={}})}_getChanges(){return this.$.restAPI.getChanges(this._changesPerPage,this._query,this._offset)}_getPreferences(){return this.$.restAPI.getPreferences()}_limitFor(e,t){const n=e.match(vf);return n?parseInt(n[1],10):t}_computeNavLink(e,t,n,i){t=+(t||0);const o=this._limitFor(e,i),s=Math.max(0,t+o*n);return gh.getUrlForSearchQuery(e,s)}_computePrevArrowClass(e){return 0===e?"hide":""}_computeNextArrowClass(e){return e.length&&e[e.length-1]._more_changes?"":"hide"}_computeNavClass(e){return!e&&this._changes&&this._changes.length?"":"hide"}_handleNextPage(){this.$.nextArrow.hidden||hd.show(this._computeNavLink(this._query,this._offset,1,this._changesPerPage))}_handlePreviousPage(){this.$.prevArrow.hidden||hd.show(this._computeNavLink(this._query,this._offset,-1,this._changesPerPage))}_changesChanged(e){if(this._userId=null,this._repo=null,e&&e.length){if(_f.test(this._query)){const t=e[0].owner,n=t._account_id?t._account_id:t.email;if(n)return void(this._userId=n)}ff.test(this._query)&&(this._repo=e[0].project)}}_computeHeaderClass(e){return e?"":"hide"}_computePage(e,t){return e/t+1}_computeLoggedIn(e){return!!(e&&Object.keys(e).length>0)}_handleToggleStar(e){this.$.restAPI.saveChangeStarred(e.detail.change._number,e.detail.starred)}_handleToggleReviewed(e){this.$.restAPI.saveChangeReviewed(e.detail.change._number,e.detail.reviewed)}}customElements.define(yf.is,yf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const bf=ta`
  <style include="shared-styles">
    ol {
      list-style: decimal;
      margin-left: var(--spacing-l);
    }
    p {
      margin-bottom: var(--spacing-m);
    }
    #commandsDialog {
      max-width: 40em;
    }
  </style>
  <gr-overlay id="commandsOverlay" with-backdrop="">
    <gr-dialog
      id="commandsDialog"
      confirm-label="Done"
      cancel-label=""
      confirm-on-enter=""
      on-confirm="_handleClose"
    >
      <div class="header" slot="header">
        Create change commands
      </div>
      <div class="main" slot="main">
        <ol>
          <li>
            <p>
              Make the changes to the files on your machine
            </p>
          </li>
          <li>
            <p>
              If you are making a new commit use
            </p>
            <gr-shell-command
              command="[[_createNewCommitCommand]]"
            ></gr-shell-command>
            <p>
              Or to amend an existing commit use
            </p>
            <gr-shell-command
              command="[[_amendExistingCommitCommand]]"
            ></gr-shell-command>
            <p>
              Please make sure you add a commit message as it becomes the
              description for your change.
            </p>
          </li>
          <li>
            <p>
              Push the change for code review
            </p>
            <gr-shell-command command="[[_pushCommand]]"></gr-shell-command>
          </li>
          <li>
            <p>
              Close this dialog and you should be able to see your recently
              created change in the 'Outgoing changes' section on the 'Your
              changes' page.
            </p>
          </li>
        </ol>
      </div>
    </gr-dialog>
  </gr-overlay>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var wf,Cf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};!function(e){e.CREATE="git commit",e.AMEND="git commit --amend",e.PUSH_PREFIX="git push origin HEAD:refs/for/"}(wf||(wf={}));let Ef=class extends(oo(dr(oa))){constructor(){super(...arguments),this._createNewCommitCommand=wf.CREATE,this._amendExistingCommitCommand=wf.AMEND}static get template(){return bf}open(){this.$.commandsOverlay.open()}_handleClose(){this.$.commandsOverlay.close()}_computePushCommand(e){return wf.PUSH_PREFIX+e}};Cf([Bl({type:String})],Ef.prototype,"branch",void 0),Cf([Bl({type:String})],Ef.prototype,"_createNewCommitCommand",void 0),Cf([Bl({type:String})],Ef.prototype,"_amendExistingCommitCommand",void 0),Cf([Bl({type:String,computed:"_computePushCommand(branch)"})],Ef.prototype,"_pushCommand",void 0),Ef=Cf([Ml("gr-create-commands-dialog")],Ef);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Sf=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    #graphic,
    #help {
      display: inline-block;
      margin: var(--spacing-m);
    }
    #graphic #circle {
      align-items: center;
      background-color: var(--chip-background-color);
      border-radius: 50%;
      display: flex;
      height: 10em;
      justify-content: center;
      width: 10em;
    }
    #graphic iron-icon {
      color: #9e9e9e;
      height: 5em;
      width: 5em;
    }
    #graphic p {
      color: var(--deemphasized-text-color);
      text-align: center;
    }
    #help {
      padding-top: var(--spacing-xl);
      vertical-align: top;
    }
    #help p {
      margin-bottom: var(--spacing-m);
      max-width: 35em;
    }
    @media only screen and (max-width: 50em) {
      #graphic {
        display: none;
      }
    }
  </style>
  <div id="graphic">
    <div id="circle">
      <iron-icon id="icon" icon="gr-icons:zeroState"></iron-icon>
    </div>
    <p>
      No outgoing changes yet
    </p>
  </div>
  <div id="help">
    <h2 class="heading-3">Push your first change for code review</h2>
    <p>
      Pushing a change for review is easy, but a little different from other git
      code review tools. Click on the \`Create Change' button and follow the
      step by step instructions.
    </p>
    <gr-button on-click="_handleCreateTap">Create Change</gr-button>
  </div>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;let Af=class extends(oo(dr(oa))){static get template(){return Sf}_handleCreateTap(e){e.preventDefault(),this.dispatchEvent(new CustomEvent("create-tap",{bubbles:!0,composed:!0}))}};Af=(window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r})([Ml("gr-create-change-help")],Af);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const xf=ta`
  <style include="shared-styles">
    :host {
      display: block;
      width: 12em;
    }
    #container {
      background: var(--chip-background-color);
      border-radius: 1em;
      padding: var(--spacing-m);
    }
    #header {
      color: var(--deemphasized-text-color);
      font-weight: var(--font-weight-bold);
      font-size: var(--font-size-small);
    }
    #body {
      display: flex;
    }
    #trigger {
      color: var(--deemphasized-text-color);
      cursor: pointer;
      padding-left: var(--spacing-s);
    }
    #trigger:hover {
      color: var(--primary-text-color);
    }
  </style>
  <div id="container">
    <div id="header">[[label]]</div>
    <div id="body">
      <gr-autocomplete
        id="autocomplete"
        threshold="0"
        query="[[query]]"
        disabled="[[disabled]]"
        placeholder="[[placeholder]]"
        borderless=""
      ></gr-autocomplete>
      <div id="trigger" on-click="_handleTriggerClick">▼</div>
    </div>
  </div>
`;var Pf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Rf=class extends(oo(dr(oa))){constructor(){super(...arguments),this.query=()=>Promise.resolve([]),this.text=""}static get template(){return xf}_handleTriggerClick(e){e.stopPropagation(),this.$.autocomplete.focus()}setText(e){this.$.autocomplete.setText(e)}clear(){this.setText("")}};Pf([Bl({type:Object})],Rf.prototype,"query",void 0),Pf([Bl({type:String,notify:!0})],Rf.prototype,"text",void 0),Pf([Bl({type:String})],Rf.prototype,"label",void 0),Pf([Bl({type:String})],Rf.prototype,"placeholder",void 0),Pf([Bl({type:Boolean})],Rf.prototype,"disabled",void 0),Rf=Pf([Ml("gr-labeled-autocomplete")],Rf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Tf=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    gr-labeled-autocomplete,
    iron-icon {
      display: inline-block;
    }
    iron-icon {
      margin-bottom: var(--spacing-l);
    }
  </style>
  <div>
    <gr-labeled-autocomplete
      id="repoInput"
      label="Repository"
      placeholder="Select repo"
      on-commit="_repoCommitted"
      query="[[_repoQuery]]"
    >
    </gr-labeled-autocomplete>
    <iron-icon icon="gr-icons:chevron-right"></iron-icon>
    <gr-labeled-autocomplete
      id="branchInput"
      label="Branch"
      placeholder="Select branch"
      disabled="[[_branchDisabled]]"
      on-commit="_branchCommitted"
      query="[[_query]]"
    >
    </gr-labeled-autocomplete>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var If=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let kf=class extends(oo(dr(oa))){constructor(){super(),this._query=e=>this._getRepoBranchesSuggestions(e),this._repoQuery=e=>this._getRepoSuggestions(e)}static get template(){return Tf}attached(){super.attached(),this.repo&&this.$.repoInput.setText(this.repo)}ready(){super.ready(),this._branchDisabled=!this.repo}_getRepoBranchesSuggestions(e){return this.repo?(e.startsWith("refs/heads/")&&(e=e.substring("refs/heads/".length)),this.$.restAPI.getRepoBranches(e,this.repo,15).then(e=>this._branchResponseToSuggestions(e))):Promise.resolve([])}_getRepoSuggestions(e){return this.$.restAPI.getRepos(e,15).then(e=>this._repoResponseToSuggestions(e))}_repoResponseToSuggestions(e){return e?e.map(e=>({name:e.name,value:V(e.id)})):[]}_branchResponseToSuggestions(e){return e?e.map(e=>{let t;return t=e.ref.startsWith("refs/heads/")?e.ref.substring("refs/heads/".length):e.ref,{name:t,value:t}}):[]}_repoCommitted(e){this.repo=e.detail.value}_branchCommitted(e){this.branch=e.detail.value}_repoChanged(){this.$.branchInput.clear(),this._branchDisabled=!this.repo}};If([Bl({type:String,notify:!0,observer:"_repoChanged"})],kf.prototype,"repo",void 0),If([Bl({type:String,notify:!0})],kf.prototype,"branch",void 0),If([Bl({type:Boolean})],kf.prototype,"_branchDisabled",void 0),If([Bl({type:Object})],kf.prototype,"_query",void 0),If([Bl({type:Object})],kf.prototype,"_repoQuery",void 0),kf=If([Ml("gr-repo-branch-picker")],kf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Of=ta`
  <style include="shared-styles"></style>
  <gr-overlay id="createOverlay" with-backdrop="">
    <gr-dialog
      confirm-label="View commands"
      on-confirm="_pickerConfirm"
      on-cancel="_handleClose"
      disabled="[[!_repoAndBranchSelected]]"
    >
      <div class="header" slot="header">
        Create change
      </div>
      <div class="main" slot="main">
        <gr-repo-branch-picker
          repo="{{_repo}}"
          branch="{{_branch}}"
        ></gr-repo-branch-picker>
        <p>
          If you haven't done so, you will need to clone the repository.
        </p>
      </div>
    </gr-dialog>
  </gr-overlay>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var Nf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Lf=class extends(oo(dr(oa))){constructor(){super(...arguments),this._repoAndBranchSelected=!1}static get template(){return Of}open(){this._repo="",this._branch="",this.$.createOverlay.open()}_handleClose(){this.$.createOverlay.close()}_pickerConfirm(e){this.$.createOverlay.close();const t={repo:this._repo,branch:this._branch};e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{detail:t,bubbles:!1}))}_computeRepoAndBranchSelected(e,t){return!(!e||!t)}};Nf([Bl({type:String})],Lf.prototype,"_repo",void 0),Nf([Bl({type:String})],Lf.prototype,"_branch",void 0),Nf([Bl({type:Boolean,computed:"_computeRepoAndBranchSelected(_repo, _branch)"})],Lf.prototype,"_repoAndBranchSelected",void 0),Lf=Nf([Ml("gr-create-destination-dialog")],Lf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Df=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    .loading {
      color: var(--deemphasized-text-color);
      padding: var(--spacing-l);
    }
    gr-change-list {
      width: 100%;
    }
    gr-user-header {
      border-bottom: 1px solid var(--border-color);
    }
    .banner {
      align-items: center;
      background-color: var(--comment-background-color);
      border-bottom: 1px solid var(--border-color);
      display: flex;
      justify-content: space-between;
      padding: var(--spacing-xs) var(--spacing-l);
    }
    .banner gr-button {
      --gr-button: {
        color: var(--primary-text-color);
      }
    }
    .hide {
      display: none;
    }
    #emptyOutgoing {
      display: block;
    }
    #emptyYourTurn {
      text-align: center;
    }
    @media only screen and (max-width: 50em) {
      .loading {
        padding: 0 var(--spacing-l);
      }
    }
  </style>
  <div class$="banner [[_computeBannerClass(_showDraftsBanner)]]">
    <div>
      You have draft comments on closed changes.
      <a href$="[[_computeDraftsLink(_showDraftsBanner)]]" target="_blank"
        >(view all)</a
      >
    </div>
    <div>
      <gr-button class="delete" link="" on-click="_handleOpenDeleteDialog"
        >Delete All</gr-button
      >
    </div>
  </div>
  <div class="loading" hidden$="[[!_loading]]">Loading...</div>
  <div hidden$="[[_loading]]" hidden="">
    <gr-user-header
      user-id="[[params.user]]"
      class$="[[_computeUserHeaderClass(params)]]"
    ></gr-user-header>
    <gr-change-list
      show-star=""
      show-reviewed-state=""
      account="[[account]]"
      preferences="[[preferences]]"
      selected-index="{{viewState.selectedChangeIndex}}"
      sections="[[_results]]"
      on-toggle-star="_handleToggleStar"
      on-toggle-reviewed="_handleToggleReviewed"
    >
      <div id="emptyOutgoing" slot="empty-outgoing">
        <template is="dom-if" if="[[_showNewUserHelp]]">
          <gr-create-change-help
            on-create-tap="createChangeTap"
          ></gr-create-change-help>
        </template>
        <template is="dom-if" if="[[!_showNewUserHelp]]">
          No changes
        </template>
      </div>
      <div id="emptyYourTurn" slot="empty-your-turn">
        <span>&#x1f389; No changes need your attention &#x1f389;</span>
      </div>
    </gr-change-list>
  </div>
  <gr-overlay id="confirmDeleteOverlay" with-backdrop="">
    <gr-dialog
      id="confirmDeleteDialog"
      confirm-label="Delete"
      on-confirm="_handleConfirmDelete"
      on-cancel="_closeConfirmDeleteOverlay"
    >
      <div class="header" slot="header">
        Delete comments
      </div>
      <div class="main" slot="main">
        Are you sure you want to delete all your draft comments in closed
        changes? This action cannot be undone.
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-create-destination-dialog
    id="destinationDialog"
    on-confirm="_handleDestinationConfirm"
  ></gr-create-destination-dialog>
  <gr-create-commands-dialog id="commandsDialog"></gr-create-commands-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,$f=/\$\{project\}/g;class Mf extends(oo(dr(oa))){static get template(){return Df}static get is(){return"gr-dashboard-view"}static get properties(){return{account:{type:Object,value:null},preferences:Object,viewState:Object,params:{type:Object},createChangeTap:{type:Function,value(){return e=>this._createChangeTap(e)}},_results:Array,_loading:{type:Boolean,value:!0},_showDraftsBanner:{type:Boolean,value:!1},_showNewUserHelp:{type:Boolean,value:!1}}}constructor(){super(),this.reporting=n.reportingService}static get observers(){return["_paramsChanged(params.*)"]}attached(){super.attached(),this._loadPreferences(),this.addEventListener("reload",e=>{e.stopPropagation(),this._reload()})}_loadPreferences(){return this.$.restAPI.getLoggedIn().then(e=>{e?this.$.restAPI.getPreferences().then(e=>{this.preferences=e}):this.preferences={}})}_getProjectDashboard(e,t){return this.$.restAPI.getDashboard(e,t,e=>{this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}).then(t=>{if(t)return{title:t.title,sections:t.sections.map(n=>{const i=t.foreach?" "+t.foreach:"";return{name:n.name,query:(n.query+i).replace($f,e)}})}})}_computeTitle(e){return e&&"self"!==e?"Dashboard for "+e:"My Reviews"}_isViewActive(e){return e.view===gh.View.DASHBOARD}_paramsChanged(e){const t=e.base;return this._isViewActive(t)?this._reload():Promise.resolve()}_reload(){this._loading=!0;const{project:e,dashboard:t,title:n,user:i,sections:o}=this.params,s=e?this._getProjectDashboard(e,t):this.$.restAPI.getConfig().then(e=>Promise.resolve(gh.getUserDashboard(i,o,n||this._computeTitle(i),e))),r=!e&&"self"===i;return s.then(e=>(e&&e.title&&this.dispatchEvent(new CustomEvent("title-change",{detail:{title:e.title},composed:!0,bubbles:!0})),this._fetchDashboardChanges(e,r))).then(()=>{this._maybeShowDraftsBanner(),this.reporting.dashboardDisplayed()}).catch(e=>{this.dispatchEvent(new CustomEvent("title-change",{detail:{title:n||this._computeTitle(i)},composed:!0,bubbles:!0})),console.warn(e)}).then(()=>{this._loading=!1})}_fetchDashboardChanges(e,t){if(!e)return Promise.resolve();let n;return window.PRELOADED_QUERIES&&window.PRELOADED_QUERIES.dashboardQuery?(n=window.PRELOADED_QUERIES.dashboardQuery,window.PRELOADED_QUERIES.dashboardQuery=void 0):(n=e.sections.map(e=>e.suffixForDashboard?e.query+" "+e.suffixForDashboard:e.query),t&&n.push("owner:self limit:1")),this.$.restAPI.getChanges(null,n).then(n=>{if(t){const e=n.pop();this._showNewUserHelp=0==e.length}this._results=n.map((t,n)=>({name:e.sections[n].name,countLabel:this._computeSectionCountLabel(t),query:e.sections[n].query,results:t,isOutgoing:e.sections[n].isOutgoing})).filter((t,n)=>n<e.sections.length&&(!e.sections[n].hideIfEmpty||t.results.length))})}_computeSectionCountLabel(e){if(!e||!e.length||0==e.length)return"";const t=e[e.length-1]._more_changes;return`(${e.length}${t?" and more":""})`}_computeUserHeaderClass(e){return e&&!e.project&&e.user&&"self"!==e.user?"":"hide"}_handleToggleStar(e){this.$.restAPI.saveChangeStarred(e.detail.change._number,e.detail.starred)}_handleToggleReviewed(e){this.$.restAPI.saveChangeReviewed(e.detail.change._number,e.detail.reviewed)}_maybeShowDraftsBanner(){if(this._showDraftsBanner=!1,"self"!==this.params.user)return;const e=this._results.find(e=>"has:draft"===e.query);e&&e.results.length&&e.results.filter(e=>!Wp(e)).length&&(this._showDraftsBanner=!0)}_computeBannerClass(e){return e?"":"hide"}_handleOpenDeleteDialog(){this.$.confirmDeleteOverlay.open()}_handleConfirmDelete(){return this.$.confirmDeleteDialog.disabled=!0,this.$.restAPI.deleteDraftComments("-is:open").then(()=>{this._closeConfirmDeleteOverlay(),this._reload()})}_closeConfirmDeleteOverlay(){this.$.confirmDeleteOverlay.close()}_computeDraftsLink(){return gh.getUrlForSearchQuery("has:draft -is:open")}_createChangeTap(e){this.$.destinationDialog.open()}_handleDestinationConfirm(e){this.$.commandsDialog.branch=e.detail.branch,this.$.commandsDialog.open()}}customElements.define(Mf.is,Mf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ff=ta`
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Bf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};function jf(e){return!!e&&!!e.robot_id}function Hf(e){return!!e&&!!e.__draft}function Uf(e){return!!e.path}function Gf(e){return e.slice(0).sort((e,t)=>{var n,i;const o=!!e.__draft;if(o!==!!t.__draft)return o?1:-1;const s=e.updated&&lc(e.updated)||e.__date,r=t.updated&&lc(t.updated)||t.__date,a=s.valueOf()-r.valueOf();if(0!==a)return a;const l=null!==(n=e.id)&&void 0!==n?n:"",c=null!==(i=t.id)&&void 0!==i?i:"";return l.localeCompare(c)})}class Vf{constructor(e,t,n,i){this._comments=this._addPath(e),this._robotComments=this._addPath(t),this._drafts=this._addPath(n),this._changeNum=i}_addPath(e={}){const t={};for(const n of Object.keys(e)){const i=e[n]||[];i.length&&(t[n]=i.map(e=>({...e,path:n})))}return t}get comments(){return this._comments}get drafts(){return this._drafts}get robotComments(){return this._robotComments}findCommentById(e){const t=t=>{let n;for(const i of Object.keys(t))n=n||t[i].find(t=>t.id===e);return n};return t(this._comments)||t(this._robotComments)}getPaths(e){const t=[this.comments,this.drafts,this.robotComments],n={};for(const i of t)for(const t in i)o(i,t)&&i[t].some(t=>!e||this._isInPatchRange(t,e))&&(n[t]=!0);return n}getAllPublishedComments(e){return this.getAllComments(!1,e)}getCommentsForThread(e){const t=this.getAllThreadsForChange().find(t=>t.rootId===e);return t?t.comments:null}getAllComments(e,t){const n=this.getPaths(),i={};for(const o of Object.keys(n))i[o]=this.getAllCommentsForPath(o,t,e);return i}getAllDrafts(e){const t=this.getPaths(),n={};for(const i of Object.keys(t))n[i]=this.getAllDraftsForPath(i,e);return n}getAllCommentsForPath(e,t,n){const i=this._comments[e]||[],o=this._robotComments[e]||[];let s=i.concat(o);if(n){const t=this.getAllDraftsForPath(e);s=s.concat(t)}return t&&(s=s.filter(e=>Ch(e.patch_set,t))),s.map(e=>({...e}))}getAllCommentsForFile(e,t){let n=this.getAllCommentsForPath(e.path,e.patchNum,t);return e.basePath&&(n=n.concat(this.getAllCommentsForPath(e.basePath,e.patchNum,t))),n}getAllDraftsForPath(e,t){let n=this._drafts[e]||[];return t&&(n=n.filter(e=>Ch(e.patch_set,t))),n.map(e=>({...e,__draft:!0}))}getAllDraftsForFile(e){let t=this.getAllDraftsForPath(e.path,e.patchNum);return e.basePath&&(t=t.concat(this.getAllDraftsForPath(e.basePath,e.patchNum))),t}getCommentsBySideForPath(e,t,n){let i=[],o=[],s=[];this.comments&&this.comments[e]&&(i=this.comments[e]),this.drafts&&this.drafts[e]&&(o=this.drafts[e]),this.robotComments&&this.robotComments[e]&&(s=this.robotComments[e]),o.forEach(e=>{e.__draft=!0});const r=i.concat(o).concat(s).map(e=>({...e})),a=r.filter(e=>this._isInBaseOfPatchRange(e,t)),l=r.filter(e=>this._isInRevisionOfPatchRange(e,t));return{meta:{changeNum:this._changeNum,path:e,patchRange:t,projectConfig:n},left:a,right:l}}getCommentsBySideForFile(e,t,n){const i=this.getCommentsBySideForPath(e.path,t,n);if(e.basePath){const o=this.getCommentsBySideForPath(e.basePath,t,n);i.left=i.left.concat(o.left),i.right=i.right.concat(o.right)}return i}_commentObjToArrayWithFile(e){let t=[];for(const n of Object.keys(e)){const i=[];for(const t of e[n])i.push({...t,__path:n});t=t.concat(i)}return t}_commentObjToArray(e){let t=[];for(const n of Object.keys(e))t=t.concat(e[n]);return t}computeCommentCount(e){if(Uf(e))return this.getAllCommentsForFile(e).length;const t=this.getAllPublishedComments(e.patchNum);return this._commentObjToArray(t).length}computeDraftCount(e){if(e&&Uf(e))return this.getAllDraftsForFile(e).length;const t=this.getAllDrafts(e&&e.patchNum);return this._commentObjToArray(t).length}computeUnresolvedNum(e){let t=[],n=[];return Uf(e)?(t=this.getAllCommentsForFile(e),n=this.getAllDraftsForFile(e)):t=this._commentObjToArray(this.getAllPublishedComments(e.patchNum)),t=t.concat(n),this.getCommentThreads(Gf(t)).filter(e=>e.comments.length&&e.comments[e.comments.length-1].unresolved).length}getAllThreadsForChange(){const e=Gf(this._commentObjToArrayWithFile(this.getAllComments(!0)));return this.getCommentThreads(e)}getCommentThreads(e){const t=[],n={};for(const i of e){if(!i.id)continue;if(i.in_reply_to){const e=n[i.in_reply_to];if(e){e.comments.push(i),n[i.id]=e;continue}}if(!i.__path&&!i.path)throw new Error('Comment missing required "path".');const e={comments:[i],patchNum:i.patch_set,path:i.__path||i.path,line:i.line,rootId:i.id};i.side&&(e.commentSide=i.side),t.push(e),n[i.id]=e}return t}_isInBaseOfPatchRange(e,t){return e.parent&&e.side===Ka.PARENT?Eh(t.basePatchNum)&&e.parent===Oh(t.basePatchNum):!("PARENT"!==t.basePatchNum||e.side!==Ka.PARENT||!Ch(e.patch_set,t.patchNum))||"PARENT"!==t.basePatchNum&&e.side!==Ka.PARENT&&Ch(e.patch_set,t.basePatchNum)}_isInRevisionOfPatchRange(e,t){return e.side!==Ka.PARENT&&Ch(e.patch_set,t.patchNum)}_isInPatchRange(e,t){return this._isInBaseOfPatchRange(e,t)||this._isInRevisionOfPatchRange(e,t)}}Vf.prototype.findCommentById;let zf=class extends(oo(dr(oa))){static get template(){return Ff}created(){super.created(),this.addEventListener("reload-drafts",e=>this.reloadDrafts(e))}loadAll(e){const t=[];return t.push(this.$.restAPI.getDiffComments(e)),t.push(this.$.restAPI.getDiffRobotComments(e)),t.push(this.$.restAPI.getDiffDrafts(e)),Promise.all(t).then(([t,n,i])=>(this._changeComments=new Vf(t,n,i,e),this._changeComments))}reloadDrafts(e){if(!this._changeComments)return this.loadAll(e);const t=this._changeComments;return this.$.restAPI.getDiffDrafts(e).then(n=>(this._changeComments=new Vf(t.comments,t.robotComments,n,e),this._changeComments))}};Bf([Bl({type:Object})],zf.prototype,"_changeComments",void 0),zf=Bf([Ml("gr-comment-api")],zf);var Wf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const qf=new Map;qf.set("respectfultip",12096e5),qf.set("draft",864e5),qf.set("editablecontent",864e5);let Kf=class extends(oo(dr(oa))){constructor(){super(...arguments),this._lastCleanup=0,this._storage=window.localStorage,this._exceededQuota=!1}getDraftComment(e){return this._cleanupItems(),this._getObject(this._getDraftKey(e))}setDraftComment(e,t){const n=this._getDraftKey(e);this._setObject(n,{message:t,updated:Date.now()})}eraseDraftComment(e){const t=this._getDraftKey(e);this._storage.removeItem(t)}getEditableContentItem(e){return this._cleanupItems(),this._getObject(this._getEditableContentKey(e))}setEditableContentItem(e,t){this._setObject(this._getEditableContentKey(e),{message:t,updated:Date.now()})}getRespectfulTipVisibility(){return this._cleanupItems(),this._getObject("respectfultip:visibility")}setRespectfulTipVisibility(e=0){this._cleanupItems(),this._setObject("respectfultip:visibility",{updated:Date.now()+864e5*e})}eraseEditableContentItem(e){this._storage.removeItem(this._getEditableContentKey(e))}_getDraftKey(e){const t=e.range?`${e.range.start_line}-${e.range.start_character}`+`-${e.range.end_character}-${e.range.end_line}`:null;let n=["draft",e.changeNum,e.patchNum,e.path,e.line||""].join(":");return t&&(n=n+":"+t),n}_getEditableContentKey(e){return`editablecontent:${e}`}_cleanupItems(){this._lastCleanup&&Date.now()-this._lastCleanup<864e5||(this._lastCleanup=Date.now(),Object.keys(this._storage).forEach(e=>{const t=qf.entries();for(const[n,i]of t)if(e.startsWith(n)){const t=this._getObject(e);(!t||Date.now()-t.updated>i)&&this._storage.removeItem(e)}}))}_getObject(e){const t=this._storage.getItem(e);return t?JSON.parse(t):null}_setObject(e,t){if(!this._exceededQuota)try{this._storage.setItem(e,JSON.stringify(t))}catch(e){if(22===e.code)return this._exceededQuota=!0,void console.warn("Local storage quota exceeded: disabling");throw e}}};Wf([Bl({type:Number})],Kf.prototype,"_lastCleanup",void 0),Wf([Bl({type:Object})],Kf.prototype,"_storage",void 0),Wf([Bl({type:Boolean})],Kf.prototype,"_exceededQuota",void 0),Kf=Wf([Ml("gr-storage")],Kf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Yf=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) iron-autogrow-textarea {
      opacity: 0.5;
    }
    .viewer {
      background-color: var(--view-background-color);
      border: 1px solid var(--view-background-color);
      border-radius: var(--border-radius);
      box-shadow: var(--elevation-level-1);
      padding: var(--spacing-m);
    }
    :host([collapsed]) .viewer {
      max-height: 36em;
      overflow: hidden;
    }
    .editor iron-autogrow-textarea {
      background-color: var(--view-background-color);
      width: 100%;

      /* You have to also repeat everything from shared-styles here, because
           you can only *replace* --iron-autogrow-textarea vars as a whole. */
      --iron-autogrow-textarea: {
        box-sizing: border-box;
        padding: var(--spacing-m);
        overflow-y: hidden;
        white-space: pre;
      }
    }
    .editButtons {
      display: flex;
      justify-content: space-between;
    }
  </style>
  <div class="viewer" hidden$="[[editing]]">
    <slot></slot>
  </div>
  <div class="editor" hidden$="[[!editing]]">
    <iron-autogrow-textarea
      autocomplete="on"
      bind-value="{{_newContent}}"
      disabled="[[disabled]]"
    ></iron-autogrow-textarea>
    <div class="editButtons">
      <gr-button primary="" on-click="_handleSave" disabled="[[_saveDisabled]]"
        >Save</gr-button
      >
      <gr-button on-click="_handleCancel" disabled="[[disabled]]"
        >Cancel</gr-button
      >
    </div>
  </div>
  <gr-storage id="storage"></gr-storage>
`;var Xf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Jf=class extends(oo(dr(oa))){constructor(){super(...arguments),this.disabled=!1,this.editing=!1}static get template(){return Yf}_contentChanged(){this.editing=!1,this._newContent=""}focusTextarea(){this.shadowRoot.querySelector("iron-autogrow-textarea").textarea.focus()}_newContentChanged(e){if(!this.storageKey)return;const t=this.storageKey;this.debounce("store",()=>{e.length?this.$.storage.setEditableContentItem(t,e):this.$.storage.eraseEditableContentItem(t)},400)}_editingChanged(e){if(!e||this._newContent)return;let t;if(this.storageKey){const e=this.$.storage.getEditableContentItem(this.storageKey);(null==e?void 0:e.message)&&(t=e.message,this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Content restored from a previous edit."},bubbles:!0,composed:!0})))}t||(t=this.content||""),this._newContent=this.removeZeroWidthSpace?t.replace(/^R=\u200B/gm,"R="):t}_computeSaveDisabled(e,t,n){return e||!n||t===n}_handleSave(e){e.preventDefault(),this.dispatchEvent(new CustomEvent("editable-content-save",{detail:{content:this._newContent},composed:!0,bubbles:!0}))}_handleCancel(e){e.preventDefault(),this.editing=!1,this.dispatchEvent(new CustomEvent("editable-content-cancel",{composed:!0,bubbles:!0}))}};Xf([Bl({type:String,notify:!0,observer:"_contentChanged"})],Jf.prototype,"content",void 0),Xf([Bl({type:Boolean,reflectToAttribute:!0})],Jf.prototype,"disabled",void 0),Xf([Bl({type:Boolean,observer:"_editingChanged"})],Jf.prototype,"editing",void 0),Xf([Bl({type:Boolean})],Jf.prototype,"removeZeroWidthSpace",void 0),Xf([Bl({type:String})],Jf.prototype,"storageKey",void 0),Xf([Bl({type:Boolean,computed:"_computeSaveDisabled(disabled, content, _newContent)"})],Jf.prototype,"_saveDisabled",void 0),Xf([Bl({type:String,observer:"_newContentChanged"})],Jf.prototype,"_newContent",void 0),Jf=Xf([Ml("gr-editable-content")],Jf);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Zf=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([pre]) span {
      white-space: var(--linked-text-white-space, pre-wrap);
      word-wrap: var(--linked-text-word-wrap, break-word);
    }
    :host([disabled]) a {
      color: inherit;
      text-decoration: none;
      pointer-events: none;
    }
  </style>
  <span id="output"></span>
`;var Qf=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let ev=class extends(oo(dr(oa))){constructor(){super(...arguments),this.content=null,this.pre=!1,this.disabled=!1}static get template(){return Zf}_contentChanged(e){this.config&&(this.$.output.textContent=e)}_contentOrConfigChanged(e,t){if(!t)return;if(!gh.mapCommentlinks)return;t=gh.mapCommentlinks(t);const n=this.$.output;n.textContent="",new ec(t,(e,t,n)=>this._handleParseResult(e,t,n),this.removeZeroWidthSpace).parse(e),n.querySelectorAll("a").forEach(e=>{e.hostname===window.location.hostname?e.removeAttribute("target"):e.setAttribute("target","_blank"),e.setAttribute("rel","noopener")})}_handleParseResult(e,t,n){const i=this.$.output;if(t){const n=document.createElement("a");n.setAttribute("href",t),n.textContent=e,n.target="_blank",n.setAttribute("rel","noopener"),i.appendChild(n)}else n&&i.appendChild(n)}};Qf([Bl({type:Boolean})],ev.prototype,"removeZeroWidthSpace",void 0),Qf([Bl({type:String})],ev.prototype,"content",void 0),Qf([Bl({type:Boolean,reflectToAttribute:!0})],ev.prototype,"pre",void 0),Qf([Bl({type:Boolean,reflectToAttribute:!0})],ev.prototype,"disabled",void 0),Qf([Bl({type:Object})],ev.prototype,"config",void 0),Qf([jl("content")],ev.prototype,"_contentChanged",null),Qf([jl("content","config")],ev.prototype,"_contentOrConfigChanged",null),ev=Qf([Ml("gr-linked-text")],ev);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const tv=ta`
  <style include="shared-styles">
    :host {
      display: inline-block;
    }
    .dropdown-trigger {
      text-decoration: none;
      width: 100%;
    }
    .dropdown-content {
      background-color: var(--dropdown-background-color);
      box-shadow: var(--elevation-level-2);
    }
    gr-button {
      @apply --gr-button;
    }
    gr-avatar {
      height: 2em;
      width: 2em;
      vertical-align: middle;
    }
    gr-button[link]:focus {
      outline: 5px auto -webkit-focus-ring-color;
    }
    ul {
      list-style: none;
    }
    .topContent,
    li {
      border-bottom: 1px solid var(--border-color);
    }
    li:last-of-type {
      border: none;
    }
    li .itemAction {
      cursor: pointer;
      display: block;
      padding: var(--spacing-m) var(--spacing-l);
    }
    li .itemAction {
      @apply --gr-dropdown-item;
    }
    li .itemAction.disabled {
      color: var(--deemphasized-text-color);
      cursor: default;
    }
    li .itemAction:link,
    li .itemAction:visited {
      text-decoration: none;
    }
    li .itemAction:not(.disabled):hover {
      background-color: var(--hover-background-color);
    }
    li:focus,
    li.selected {
      background-color: var(--selection-background-color);
      outline: none;
    }
    li:focus .itemAction,
    li.selected .itemAction {
      background-color: transparent;
    }
    .topContent {
      display: block;
      padding: var(--spacing-m) var(--spacing-l);
      @apply --gr-dropdown-item;
    }
    .bold-text {
      font-weight: var(--font-weight-bold);
    }
  </style>
  <gr-button
    link="[[link]]"
    class="dropdown-trigger"
    id="trigger"
    down-arrow="[[downArrow]]"
    on-click="_dropdownTriggerTapHandler"
  >
    <slot></slot>
  </gr-button>
  <iron-dropdown
    id="dropdown"
    vertical-align="top"
    vertical-offset="[[verticalOffset]]"
    allow-outside-scroll="true"
    horizontal-align="[[horizontalAlign]]"
    on-click="_handleDropdownClick"
  >
    <div class="dropdown-content" slot="dropdown-content">
      <ul>
        <template is="dom-if" if="[[topContent]]">
          <div class="topContent">
            <template
              is="dom-repeat"
              items="[[topContent]]"
              as="item"
              initial-count="75"
            >
              <div
                class$="[[_getClassIfBold(item.bold)]] top-item"
                tabindex="-1"
              >
                [[item.text]]
              </div>
            </template>
          </div>
        </template>
        <template
          is="dom-repeat"
          items="[[items]]"
          as="link"
          initial-count="75"
        >
          <li tabindex="-1">
            <gr-tooltip-content
              has-tooltip="[[_computeHasTooltip(link.tooltip)]]"
              title$="[[link.tooltip]]"
            >
              <span
                class$="itemAction [[_computeDisabledClass(link.id, disabledIds.*)]]"
                data-id$="[[link.id]]"
                on-click="_handleItemTap"
                hidden$="[[link.url]]"
                tabindex="-1"
                >[[link.name]]</span
              >
              <a
                class="itemAction"
                href$="[[_computeLinkURL(link)]]"
                download$="[[_computeIsDownload(link)]]"
                rel$="[[_computeLinkRel(link)]]"
                target$="[[link.target]]"
                hidden$="[[!link.url]]"
                tabindex="-1"
                >[[link.name]]</a
              >
            </gr-tooltip-content>
          </li>
        </template>
      </ul>
    </div>
  </iron-dropdown>
  <gr-cursor-manager
    id="cursor"
    cursor-target-class="selected"
    scroll-mode="never"
    focus-on-move=""
    stops="[[_listElements]]"
  ></gr-cursor-manager>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var nv=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let iv=class extends(xp(oo(dr(oa)))){constructor(){super(...arguments),this.horizontalAlign="left",this.link=!1,this.verticalOffset=40,this.disabledIds=[],this._listElements=[]}static get template(){return tv}get keyBindings(){return{down:"_handleDown","enter space":"_handleEnter",tab:"_handleTab",up:"_handleUp"}}_handleUp(e){this.$.dropdown.opened?(e.preventDefault(),e.stopPropagation(),this.$.cursor.previous()):this._open()}_handleDown(e){this.$.dropdown.opened?(e.preventDefault(),e.stopPropagation(),this.$.cursor.next()):this._open()}_handleTab(e){this.$.dropdown.opened&&(e.preventDefault(),e.stopPropagation())}_handleEnter(e){if(e.preventDefault(),e.stopPropagation(),this.$.dropdown.opened){if(null!==this.$.cursor.target){const e=this.$.cursor.target.querySelector(":not([hidden]) a");e&&e.click()}}else this._open()}_handleDropdownClick(){this._close()}_dropdownTriggerTapHandler(e){e.preventDefault(),e.stopPropagation(),this.$.dropdown.opened?this._close():this._open()}_open(){this.$.dropdown.open(),this._resetCursorStops(),this.$.cursor.setCursorAtIndex(0),null!==this.$.cursor.target&&this.$.cursor.target.focus()}_close(){this.async(()=>{this.$.dropdown.close()},1)}_getClassIfBold(e){return e?"bold-text":""}_computeURLHelper(e,t){return"//"+e+(t.startsWith(j())?"":j())+t}_computeRelativeURL(e){const t=window.location.host;return this._computeURLHelper(t,e)}_computeLinkURL(e){return void 0===e.url?"":e.target||!e.url.startsWith("/")?e.url:this._computeRelativeURL(e.url)}_computeLinkRel(e){return e.target?"noopener":e.external?"external":null}_handleItemTap(e){if(null===e.target||!this.items)return;const t=e.target.getAttribute("data-id"),n=this.items.find(e=>e.id===t);t&&!this.disabledIds.includes(t)&&(n&&this.dispatchEvent(new CustomEvent("tap-item",{detail:n,bubbles:!0,composed:!0})),this.dispatchEvent(new CustomEvent("tap-item-"+t)))}_computeDisabledClass(e,t){return t.base.includes(e)?"disabled":""}_resetCursorStops(){this.items&&this.items.length>0&&this.$.dropdown.opened&&(Mo(),this._listElements=null!==this.root?Array.from(this.root.querySelectorAll("li")):[])}_computeHasTooltip(e){return!!e}_computeIsDownload(e){return!!e.download}};nv([Bl({type:Array})],iv.prototype,"items",void 0),nv([Bl({type:Boolean})],iv.prototype,"downArrow",void 0),nv([Bl({type:Array})],iv.prototype,"topContent",void 0),nv([Bl({type:String})],iv.prototype,"horizontalAlign",void 0),nv([Bl({type:Boolean})],iv.prototype,"link",void 0),nv([Bl({type:Number})],iv.prototype,"verticalOffset",void 0),nv([Bl({type:Array})],iv.prototype,"disabledIds",void 0),nv([Bl({type:Array})],iv.prototype,"_listElements",void 0),nv([jl("items")],iv.prototype,"_resetCursorStops",null),iv=nv([Ml("gr-dropdown")],iv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ov=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    .main {
      display: flex;
      flex-direction: column;
      width: 100%;
    }
    label {
      cursor: pointer;
      display: block;
      width: 100%;
    }
    iron-autogrow-textarea {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      width: 73ch; /* Add a char to account for the border. */
    }
  </style>
  <gr-dialog
    confirm-label="Abandon"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">Abandon Change</div>
    <div class="main" slot="main">
      <label for="messageInput">Abandon Message</label>
      <iron-autogrow-textarea
        id="messageInput"
        class="message"
        autocomplete="on"
        placeholder="<Insert reasoning here>"
        bind-value="{{message}}"
      ></iron-autogrow-textarea>
    </div>
  </gr-dialog>
`;var sv=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let rv=class extends(xp(oo(dr(oa)))){static get template(){return ov}get keyBindings(){return{"ctrl+enter meta+enter":"_handleEnterKey"}}resetFocus(){this.$.messageInput.textarea.focus()}_handleEnterKey(){this._confirm()}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this._confirm()}_confirm(){this.dispatchEvent(new CustomEvent("confirm",{detail:{reason:this.message},composed:!0,bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}};sv([Bl({type:String})],rv.prototype,"message",void 0),rv=sv([Ml("gr-confirm-abandon-dialog")],rv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const av=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    label {
      cursor: pointer;
    }
    .main {
      display: flex;
      flex-direction: column;
      width: 100%;
    }
    .main label,
    .main input[type='text'] {
      display: block;
      width: 100%;
    }
    iron-autogrow-textarea {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      width: 73ch; /* Add a char to account for the border. */
    }
    .cherryPickTopicLayout {
      display: flex;
    }
    .cherryPickSingleChange,
    .cherryPickTopic {
      margin-left: var(--spacing-m);
      margin-bottom: var(--spacing-m);
    }
    .cherry-pick-topic-message {
      margin-bottom: var(--spacing-m);
    }
    label[for='messageInput'],
    label[for='baseInput'] {
      margin-top: var(--spacing-m);
    }
    .title {
      font-weight: var(--font-weight-bold);
    }
    tr > td {
      padding: var(--spacing-m);
    }
    th {
      color: var(--deemphasized-text-color);
    }
    table {
      border-collapse: collapse;
    }
    tr {
      border-bottom: 1px solid var(--border-color);
    }
    .error {
      color: var(--error-text-color);
    }
    .error-message {
      color: var(--error-text-color);
      margin: var(--spacing-m) 0 var(--spacing-m) 0;
    }
  </style>
  <gr-dialog
    confirm-label="Cherry Pick"
    cancel-label="[[_computeCancelLabel(_statuses)]]"
    disabled$="[[_computeDisableCherryPick(_cherryPickType, _duplicateProjectChanges, _statuses)]]"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header title" slot="header">
      Cherry Pick Change to Another Branch
    </div>
    <div class="main" slot="main">
      <template is="dom-if" if="[[_showCherryPickTopic]]">
        <div class="cherryPickTopicLayout">
          <input
            name="cherryPickOptions"
            type="radio"
            id="cherryPickSingleChange"
            on-change="_handlecherryPickSingleChangeClicked"
            checked=""
          />
          <label for="cherryPickSingleChange" class="cherryPickSingleChange">
            Cherry Pick single change
          </label>
        </div>
        <div class="cherryPickTopicLayout">
          <input
            name="cherryPickOptions"
            type="radio"
            id="cherryPickTopic"
            on-change="_handlecherryPickTopicClicked"
          />
          <label for="cherryPickTopic" class="cherryPickTopic">
            Cherry Pick entire topic ([[_changesCount]] Changes)
          </label>
        </div></template
      >

      <label for="branchInput">
        Cherry Pick to branch
      </label>
      <gr-autocomplete
        id="branchInput"
        text="{{branch}}"
        query="[[_query]]"
        placeholder="Destination branch"
      >
      </gr-autocomplete>
      <template is="dom-if" if="[[_invalidBranch]]">
        <span class="error"> Branch name cannot contain space or commas. </span>
      </template>
      <template
        is="dom-if"
        if="[[_computeIfSinglecherryPick(_cherryPickType)]]"
      >
        <label for="baseInput">
          Provide base commit sha1 for cherry-pick
        </label>
        <iron-input
          maxlength="40"
          placeholder="(optional)"
          bind-value="{{baseCommit}}"
        >
          <input
            is="iron-input"
            id="baseCommitInput"
            maxlength="40"
            placeholder="(optional)"
            bind-value="{{baseCommit}}"
          />
        </iron-input>
        <label for="messageInput">
          Cherry Pick Commit Message
        </label>
      </template>
      <template
        is="dom-if"
        if="[[_computeIfSinglecherryPick(_cherryPickType)]]"
      >
        <iron-autogrow-textarea
          id="messageInput"
          class="message"
          autocomplete="on"
          rows="4"
          max-rows="15"
          bind-value="{{message}}"
        ></iron-autogrow-textarea>
      </template>
      <template is="dom-if" if="[[_computeIfCherryPickTopic(_cherryPickType)]]">
        <span class="error-message"
          >[[_computeTopicErrorMessage(_duplicateProjectChanges)]]</span
        >
        <span class="cherry-pick-topic-message">
          Commit Message will be auto generated
        </span>
        <table>
          <thead>
            <tr>
              <th>Change</th>
              <th>Subject</th>
              <th>Project</th>
              <th>Status</th>
              <!-- Error Message -->
              <th></th>
            </tr>
          </thead>
          <tbody>
            <template is="dom-repeat" items="[[changes]]">
              <tr>
                <td><span> [[_getChangeId(item)]] </span></td>
                <td>
                  <span> [[_getTrimmedChangeSubject(item.subject)]] </span>
                </td>
                <td><span> [[item.project]] </span></td>
                <td>
                  <span class$="[[_computeStatusClass(item, _statuses)]]">
                    [[_computeStatus(item, _statuses)]]
                  </span>
                </td>
                <td>
                  <span class="error">
                    [[_computeError(item, _statuses)]]
                  </span>
                </td>
              </tr>
            </template>
          </tbody>
        </table>
      </template>
    </div>
  </gr-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var lv=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};var cv;!function(e){e[e.SINGLE_CHANGE=1]="SINGLE_CHANGE",e[e.TOPIC=2]="TOPIC"}(cv||(cv={}));let dv=class extends(oo(dr(oa))){constructor(){super(),this.changes=[],this._showCherryPickTopic=!1,this._cherryPickType=cv.SINGLE_CHANGE,this._duplicateProjectChanges=!1,this._invalidBranch=!1,this._statuses={},this.reporting=n.reportingService,this._query=e=>this._getProjectBranchesSuggestions(e)}static get template(){return av}updateChanges(e){this.changes=e,this._statuses={};const t={};this._duplicateProjectChanges=!1,e.forEach(e=>{t[e.project]&&(this._duplicateProjectChanges=!0),t[e.project]=!0}),this._changesCount=e.length,this._showCherryPickTopic=e.length>1}_updateBranch(e){this._invalidBranch=!(!e||![","," "].some(t=>e.includes(t)))}_computeTopicErrorMessage(e){return e?"Two changes cannot be of the same project":""}updateStatus(e,t){this._statuses={...this._statuses,[e.id]:t}}_computeStatus(e,t){return e&&t&&t[e.id]?t[e.id].status:"NOT STARTED"}_computeStatusClass(e,t){return e&&t&&t[e.id]&&"FAILED"===t[e.id].status?"error":""}_computeError(e,t){return e&&t&&t[e.id]&&"FAILED"===t[e.id].status?t[e.id].msg:""}_getChangeId(e){return e.change_id.substring(0,10)}_getTrimmedChangeSubject(e){return e?e.length<50?e:e.substring(0,50)+"...":""}_computeCancelLabel(e){return Object.values(e).some(e=>"RUNNING"===e.status)?"Close":"Cancel"}_computeDisableCherryPick(e,t,n){return!(e!==cv.TOPIC||!t)||!!n&&Object.values(n).some(e=>"RUNNING"===e.status)}_computeIfSinglecherryPick(e){return e===cv.SINGLE_CHANGE}_computeIfCherryPickTopic(e){return e===cv.TOPIC}_handlecherryPickSingleChangeClicked(){this._cherryPickType=cv.SINGLE_CHANGE}_handlecherryPickTopicClicked(){this._cherryPickType=cv.TOPIC}_computeMessage(e,t,n){if(void 0===e||void 0===t||void 0===n)return;let i=n;"MERGED"===e&&(i+="(cherry picked from commit "+t.toString()+")"),this.message=i}_generateRandomCherryPickTopic(e){const t=Math.random().toString(36).substr(2,10);return`cherrypick-${e.topic}-${t}`}_handleCherryPickFailed(e,t){t&&t.text().then(t=>{this.updateStatus(e,{status:"FAILED",msg:t})})}_handleCherryPickTopic(){const e=this._generateRandomCherryPickTopic(this.changes[0]);this.changes.forEach(t=>{this.updateStatus(t,{status:"RUNNING"});const n={destination:this.branch,base:null,topic:e,allow_conflicts:!0,allow_empty:!0},i=t.revisions[t.current_revision]._number;this.$.restAPI.executeChangeAction(t._number,qa.POST,"/cherrypick",i,n,e=>{this._handleCherryPickFailed(t,e)}).then(()=>{this.updateStatus(t,{status:"SUCCESSFUL"}),Object.values(this._statuses).find(e=>"SUCCESSFUL"!==e.status)||gh.navigateToSearchQuery(`topic: "${e}"`)})})}_handleConfirmTap(e){if(e.preventDefault(),e.stopPropagation(),this._cherryPickType===cv.TOPIC)return this.reporting.reportInteraction("cherry-pick-topic-clicked",{}),void this._handleCherryPickTopic();this.dispatchEvent(new CustomEvent("confirm",{composed:!0,bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}resetFocus(){this.$.branchInput.focus()}_getProjectBranchesSuggestions(e){return this.project?(e.startsWith("refs/heads/")&&(e=e.substring("refs/heads/".length)),this.$.restAPI.getRepoBranches(e,this.project,15).then(e=>{const t=[];if(!e)return[];let n;for(const i in e)o(e,i)&&(n=e[i].ref.startsWith("refs/heads/")?e[i].ref.substring("refs/heads/".length):e[i].ref,t.push({name:n}));return t})):(console.error("no project specified"),Promise.resolve([]))}};lv([Bl({type:String})],dv.prototype,"branch",void 0),lv([Bl({type:String})],dv.prototype,"baseCommit",void 0),lv([Bl({type:String})],dv.prototype,"changeStatus",void 0),lv([Bl({type:String})],dv.prototype,"commitMessage",void 0),lv([Bl({type:String})],dv.prototype,"commitNum",void 0),lv([Bl({type:String})],dv.prototype,"message",void 0),lv([Bl({type:String})],dv.prototype,"project",void 0),lv([Bl({type:Array})],dv.prototype,"changes",void 0),lv([Bl({type:Object})],dv.prototype,"_query",void 0),lv([Bl({type:Boolean})],dv.prototype,"_showCherryPickTopic",void 0),lv([Bl({type:Number})],dv.prototype,"_changesCount",void 0),lv([Bl({type:Number})],dv.prototype,"_cherryPickType",void 0),lv([Bl({type:Boolean})],dv.prototype,"_duplicateProjectChanges",void 0),lv([Bl({type:Object})],dv.prototype,"_statuses",void 0),lv([Bl({type:Boolean})],dv.prototype,"_invalidBranch",void 0),lv([Bl({type:Object})],dv.prototype,"reporting",void 0),lv([jl("branch")],dv.prototype,"_updateBranch",null),lv([jl("changeStatus","commitNum","commitMessage")],dv.prototype,"_computeMessage",null),dv=lv([Ml("gr-confirm-cherrypick-dialog")],dv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const hv=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    .main {
      display: flex;
      flex-direction: column;
      width: 100%;
    }
  </style>
  <gr-dialog
    confirm-label="Continue"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">Cherry Pick Conflict!</div>
    <div class="main" slot="main">
      <span>Cherry Pick failed! (merge conflicts)</span>

      <span
        >Please select "Continue" to continue with conflicts or select "cancel"
        to close the dialog.</span
      >
    </div>
  </gr-dialog>
`;let pv=class extends(oo(dr(oa))){static get template(){return hv}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{composed:!0,bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}};pv=(window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r})([Ml("gr-confirm-cherrypick-conflict-dialog")],pv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const uv=ta`
  <style include="shared-styles">
    :host {
      display: block;
      width: 30em;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    label {
      cursor: pointer;
    }
    .main {
      display: flex;
      flex-direction: column;
      width: 100%;
    }
    .main label,
    .main input[type='text'] {
      display: block;
      width: 100%;
    }
    .main .message {
      width: 100%;
    }
    .warning {
      color: var(--error-text-color);
    }
  </style>
  <gr-dialog
    confirm-label="Move Change"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">Move Change to Another Branch</div>
    <div class="main" slot="main">
      <p class="warning">
        Warning: moving a change will not change its parents.
      </p>
      <label for="branchInput">
        Move change to branch
      </label>
      <gr-autocomplete
        id="branchInput"
        text="{{branch}}"
        query="[[_query]]"
        placeholder="Destination branch"
      >
      </gr-autocomplete>
      <label for="messageInput">
        Move Change Message
      </label>
      <iron-autogrow-textarea
        id="messageInput"
        class="message"
        autocomplete="on"
        rows="4"
        max-rows="15"
        bind-value="{{message}}"
      ></iron-autogrow-textarea>
    </div>
  </gr-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var gv=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let mv=class extends(xp(oo(dr(oa)))){constructor(){super(),this._query=()=>this._getProjectBranchesSuggestions()}static get template(){return uv}get keyBindings(){return{"ctrl+enter meta+enter":"_handleConfirmTap"}}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{composed:!0,bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}_getProjectBranchesSuggestions(e){return this.project?e?(e.startsWith("refs/heads/")&&(e=e.substring("refs/heads/".length)),this.$.restAPI.getRepoBranches(e,this.project,15).then(e=>{const t=[];let n;return e&&e.forEach(e=>{n=e.ref.startsWith("refs/heads/")?e.ref.substring("refs/heads/".length):e.ref,t.push({name:n})}),t})):Promise.reject(new Error("Missing input")):Promise.reject(new Error("Missing project"))}};gv([Bl({type:String})],mv.prototype,"branch",void 0),gv([Bl({type:String})],mv.prototype,"message",void 0),gv([Bl({type:String})],mv.prototype,"project",void 0),gv([Bl({type:Object})],mv.prototype,"_query",void 0),mv=gv([Ml("gr-confirm-move-dialog")],mv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const _v=ta`
  <style include="shared-styles">
    :host {
      display: block;
      width: 30em;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    label {
      cursor: pointer;
    }
    .message {
      font-style: italic;
    }
    .parentRevisionContainer label,
    .parentRevisionContainer input[type='text'] {
      display: block;
      width: 100%;
    }
    .parentRevisionContainer label {
      margin-bottom: var(--spacing-xs);
    }
    .rebaseOption {
      margin: var(--spacing-m) 0;
    }
  </style>
  <gr-dialog
    id="confirmDialog"
    confirm-label="Rebase"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">Confirm rebase</div>
    <div class="main" slot="main">
      <div
        id="rebaseOnParent"
        class="rebaseOption"
        hidden$="[[!_displayParentOption(rebaseOnCurrent, hasParent)]]"
      >
        <input
          id="rebaseOnParentInput"
          name="rebaseOptions"
          type="radio"
          on-click="_handleRebaseOnParent"
        />
        <label id="rebaseOnParentLabel" for="rebaseOnParentInput">
          Rebase on parent change
        </label>
      </div>
      <div
        id="parentUpToDateMsg"
        class="message"
        hidden$="[[!_displayParentUpToDateMsg(rebaseOnCurrent, hasParent)]]"
      >
        This change is up to date with its parent.
      </div>
      <div
        id="rebaseOnTip"
        class="rebaseOption"
        hidden$="[[!_displayTipOption(rebaseOnCurrent, hasParent)]]"
      >
        <input
          id="rebaseOnTipInput"
          name="rebaseOptions"
          type="radio"
          disabled$="[[!_displayTipOption(rebaseOnCurrent, hasParent)]]"
          on-click="_handleRebaseOnTip"
        />
        <label id="rebaseOnTipLabel" for="rebaseOnTipInput">
          Rebase on top of the [[branch]] branch<span hidden$="[[!hasParent]]">
            (breaks relation chain)
          </span>
        </label>
      </div>
      <div
        id="tipUpToDateMsg"
        class="message"
        hidden$="[[_displayTipOption(rebaseOnCurrent, hasParent)]]"
      >
        Change is up to date with the target branch already ([[branch]])
      </div>
      <div id="rebaseOnOther" class="rebaseOption">
        <input
          id="rebaseOnOtherInput"
          name="rebaseOptions"
          type="radio"
          on-click="_handleRebaseOnOther"
        />
        <label id="rebaseOnOtherLabel" for="rebaseOnOtherInput">
          Rebase on a specific change, ref, or commit
          <span hidden$="[[!hasParent]]">
            (breaks relation chain)
          </span>
        </label>
      </div>
      <div class="parentRevisionContainer">
        <gr-autocomplete
          id="parentInput"
          query="[[_query]]"
          no-debounce=""
          text="{{_text}}"
          on-click="_handleEnterChangeNumberClick"
          allow-non-suggested-values=""
          placeholder="Change number, ref, or commit hash"
        >
        </gr-autocomplete>
      </div>
    </div>
  </gr-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var fv=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let vv=class extends(oo(dr(oa))){constructor(){super(),this._query=e=>this._getChangeSuggestions(e)}static get template(){return _v}fetchRecentChanges(){return this.$.restAPI.getChanges(void 0,"is:open -age:90d").then(e=>{if(!e)return[];const t=[];for(const n in e)o(e,n)&&t.push({name:`${e[n]._number}: ${e[n].subject}`,value:e[n]._number});return this._recentChanges=t,this._recentChanges})}_getRecentChanges(){return this._recentChanges?Promise.resolve(this._recentChanges):this.fetchRecentChanges()}_getChangeSuggestions(e){return this._getRecentChanges().then(t=>this._filterChanges(e,t))}_filterChanges(e,t){return t.filter(t=>t.name.includes(e)&&t.value!==this.changeNumber).map(e=>({name:e.name,value:`${e.value}`}))}_displayParentOption(e,t){return t&&e}_displayParentUpToDateMsg(e,t){return t&&!e}_displayTipOption(e,t){return!(!e&&!t)}_getSelectedBase(){return this.$.rebaseOnParentInput.checked?null:this.$.rebaseOnTipInput.checked?"":this._text?this._text.split(":")[0]:""}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{detail:{base:this._getSelectedBase()}})),this._text=""}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel")),this._text=""}_handleRebaseOnOther(){this.$.parentInput.focus()}_handleEnterChangeNumberClick(){this.$.rebaseOnOtherInput.checked=!0}_updateSelectedOption(e,t){void 0!==e&&void 0!==t&&(this._displayParentOption(e,t)?this.$.rebaseOnParentInput.checked=!0:this._displayTipOption(e,t)?this.$.rebaseOnTipInput.checked=!0:this.$.rebaseOnOtherInput.checked=!0)}};fv([Bl({type:String})],vv.prototype,"branch",void 0),fv([Bl({type:Number})],vv.prototype,"changeNumber",void 0),fv([Bl({type:Boolean})],vv.prototype,"hasParent",void 0),fv([Bl({type:Boolean})],vv.prototype,"rebaseOnCurrent",void 0),fv([Bl({type:String})],vv.prototype,"_text",void 0),fv([Bl({type:Object})],vv.prototype,"_query",void 0),fv([Bl({type:Array})],vv.prototype,"_recentChanges",void 0),fv([jl("rebaseOnCurrent","hasParent")],vv.prototype,"_updateSelectedOption",null),vv=fv([Ml("gr-confirm-rebase-dialog")],vv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const yv=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    label {
      cursor: pointer;
      display: block;
      width: 100%;
    }
    .revertSubmissionLayout {
      display: flex;
    }
    .label {
      margin-left: var(--spacing-m);
      margin-bottom: var(--spacing-m);
    }
    iron-autogrow-textarea {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      width: 73ch; /* Add a char to account for the border. */
    }
    .error {
      color: var(--error-text-color);
      margin-bottom: var(--spacing-m);
    }
  </style>
  <gr-dialog
    confirm-label="Revert"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">
      Revert Merged Change
    </div>
    <div class="main" slot="main">
      <div class="error" hidden$="[[!_showErrorMessage]]">
        <span> A reason is required </span>
      </div>
      <template is="dom-if" if="[[_showRevertSubmission]]">
        <div class="revertSubmissionLayout">
          <input
            name="revertOptions"
            type="radio"
            id="revertSingleChange"
            on-change="_handleRevertSingleChangeClicked"
            checked="[[_computeIfSingleRevert(_revertType)]]"
          />
          <label for="revertSingleChange" class="label revertSingleChange">
            Revert single change
          </label>
        </div>
        <div class="revertSubmissionLayout">
          <input
            name="revertOptions"
            type="radio"
            id="revertSubmission"
            on-change="_handleRevertSubmissionClicked"
            checked="[[_computeIfRevertSubmission(_revertType)]]"
          />
          <label for="revertSubmission" class="label revertSubmission">
            Revert entire submission ([[_changesCount]] Changes)
          </label>
        </div></template
      >
      <gr-endpoint-decorator name="confirm-revert-change">
        <label for="messageInput">
          Revert Commit Message
        </label>
        <iron-autogrow-textarea
          id="messageInput"
          class="message"
          autocomplete="on"
          max-rows="15"
          bind-value="{{_message}}"
        ></iron-autogrow-textarea>
      </gr-endpoint-decorator>
    </div>
  </gr-dialog>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
`;var bv=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const wv=1,Cv=2;let Ev=class extends(oo(dr(oa))){constructor(){super(...arguments),this._revertType=wv,this._showRevertSubmission=!1,this._showErrorMessage=!1,this._originalRevertMessages=[],this._revertMessages=[]}static get template(){return yv}_computeIfSingleRevert(e){return e===wv}_computeIfRevertSubmission(e){return e===Cv}_modifyRevertMsg(e,t,n){return this.$.jsAPI.modifyRevertMsg(e,n,t)}populate(e,t,n){this._changesCount=n.length,this._populateRevertSingleChangeMessage(e,t,e.current_revision),this._populateRevertSubmissionMessage(e,n,t)}_populateRevertSingleChangeMessage(e,t,n){const i=`Revert "${(t||"").split("\n")[0]}"`;if(!n)return void this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Unable to find the commit hash of this change."},composed:!0,bubbles:!0}));const o=`${i}\n\n${`This reverts commit ${n}.`}\n\n`+"Reason for revert: <INSERT REASONING HERE>\n";this._message=this._modifyRevertMsg(e,t,o),this._revertType=wv,this._showRevertSubmission=!1,this._revertMessages[this._revertType]=this._message,this._originalRevertMessages[this._revertType]=this._message}_getTrimmedChangeSubject(e){return e?e.length<50?e:e.substring(0,50)+"...":""}_modifyRevertSubmissionMsg(e,t,n){return this.$.jsAPI.modifyRevertSubmissionMsg(e,t,n)}_populateRevertSubmissionMessage(e,t,n){if(!e.current_revision)return void this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Unable to find the commit hash of this change."},composed:!0,bubbles:!0}));if(!t||t.length<=1)return;let i=`Revert submission ${e.submission_id}`+"\n\nReason for revert: <INSERT REASONING HERE>\n";i+="Reverted Changes:\n",t.forEach(e=>{i+=`${e.change_id.substring(0,10)}:`+`${this._getTrimmedChangeSubject(e.subject)}\n`}),this._message=this._modifyRevertSubmissionMsg(e,i,n),this._revertType=Cv,this._revertMessages[this._revertType]=this._message,this._originalRevertMessages[this._revertType]=this._message,this._showRevertSubmission=!0}_handleRevertSingleChangeClicked(){this._showErrorMessage=!1,this._message&&(this._revertMessages[Cv]=this._message),this._message=this._revertMessages[wv],this._revertType=wv}_handleRevertSubmissionClicked(){this._showErrorMessage=!1,this._revertType=Cv,this._message&&(this._revertMessages[wv]=this._message),this._message=this._revertMessages[Cv]}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this._message!==this._originalRevertMessages[this._revertType]?this.dispatchEvent(new CustomEvent("confirm",{detail:{revertType:this._revertType,message:this._message},composed:!0,bubbles:!1})):this._showErrorMessage=!0}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{detail:{revertType:this._revertType},composed:!0,bubbles:!1}))}};bv([Bl({type:String})],Ev.prototype,"_message",void 0),bv([Bl({type:Number})],Ev.prototype,"_revertType",void 0),bv([Bl({type:Boolean})],Ev.prototype,"_showRevertSubmission",void 0),bv([Bl({type:Number})],Ev.prototype,"_changesCount",void 0),bv([Bl({type:Boolean})],Ev.prototype,"_showErrorMessage",void 0),bv([Bl({type:Array})],Ev.prototype,"_originalRevertMessages",void 0),bv([Bl({type:Array})],Ev.prototype,"_revertMessages",void 0),Ev=bv([Ml("gr-confirm-revert-dialog")],Ev);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Sv=ta`
  <!-- TODO(taoalpha): move all shared styles to a style module. -->
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    label {
      cursor: pointer;
      display: block;
      width: 100%;
    }
    iron-autogrow-textarea {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      width: 73ch; /* Add a char to account for the border. */
    }
  </style>
  <gr-dialog
    confirm-label="Revert Submission"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">Revert Submission</div>
    <div class="main" slot="main">
      <label for="messageInput">
        Revert Commit Message
      </label>
      <iron-autogrow-textarea
        id="messageInput"
        class="message"
        autocomplete="on"
        max-rows="15"
        bind-value="{{message}}"
      ></iron-autogrow-textarea>
    </div>
  </gr-dialog>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
`;var Av=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let xv=class extends(oo(dr(oa))){static get template(){return Sv}_getTrimmedChangeSubject(e){return e?e.length<50?e:e.substring(0,50)+"...":""}_modifyRevertSubmissionMsg(e){return e&&this.message&&this.commitMessage?this.$.jsAPI.modifyRevertSubmissionMsg(e,this.message,this.commitMessage):this.message}_populateRevertSubmissionMessage(e,t){if(void 0===e)return;if(!e.current_revision)return void this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Unable to find the commit hash of this change."},composed:!0,bubbles:!0}));const n=`Revert submission ${e.submission_id}`;this.message=n+"\n\nReason for revert: <INSERT REASONING HERE>\n",(t=t||[]).length&&(this.message+="Reverted Changes:\n",t.forEach(e=>{this.message+=`${e.change_id.substring(0,10)}: `+`${this._getTrimmedChangeSubject(e.subject)}\n`})),this.message=this._modifyRevertSubmissionMsg(e)}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{composed:!0,bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}};Av([Bl({type:String})],xv.prototype,"message",void 0),Av([Bl({type:String})],xv.prototype,"commitMessage",void 0),xv=Av([Ml("gr-confirm-revert-submission-dialog")],xv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Pv=ta`
  <style include="shared-styles">
    #dialog {
      min-width: 40em;
    }
    p {
      margin-bottom: var(--spacing-l);
    }
    .warningBeforeSubmit {
      color: var(--error-text-color);
      vertical-align: top;
      margin-right: var(--spacing-s);
    }
    @media screen and (max-width: 50em) {
      #dialog {
        min-width: inherit;
        width: 100%;
      }
    }
  </style>
  <gr-dialog
    id="dialog"
    confirm-label="Continue"
    confirm-on-enter=""
    on-cancel="_handleCancelTap"
    on-confirm="_handleConfirmTap"
  >
    <div class="header" slot="header">
      [[action.label]]
    </div>
    <div class="main" slot="main">
      <gr-endpoint-decorator name="confirm-submit-change">
        <p>Ready to submit “<strong>[[change.subject]]</strong>”?</p>
        <template is="dom-if" if="[[change.is_private]]">
          <p>
            <iron-icon
              icon="gr-icons:error"
              class="warningBeforeSubmit"
            ></iron-icon>
            <strong>Heads Up!</strong>
            Submitting this private change will also make it public.
          </p>
        </template>
        <template is="dom-if" if="[[change.unresolved_comment_count]]">
          <p>
            <iron-icon
              icon="gr-icons:error"
              class="warningBeforeSubmit"
            ></iron-icon>
            [[_computeUnresolvedCommentsWarning(change)]]
          </p>
        </template>
        <template is="dom-if" if="[[_computeHasChangeEdit(change)]]">
          <iron-icon
            icon="gr-icons:error"
            class="warningBeforeSubmit"
          ></iron-icon>
          Your unpublished edit will not be submitted. Did you forget to click
          <b>PUBLISH</b>?
        </template>
        <gr-endpoint-param name="change" value="[[change]]"></gr-endpoint-param>
        <gr-endpoint-param name="action" value="[[action]]"></gr-endpoint-param>
      </gr-endpoint-decorator>
    </div>
  </gr-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Rv=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Tv=class extends(oo(dr(oa))){static get template(){return Pv}resetFocus(){this.$.dialog.resetFocus()}_computeHasChangeEdit(e){return!!e&&!!e.revisions&&Object.values(e.revisions).some(e=>"edit"===e._number)}_computeUnresolvedCommentsWarning(e){const t=e.unresolved_comment_count;return`Heads Up! ${t} unresolved comment${t&&t>1?"s":""}.`}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{bubbles:!1}))}};Rv([Bl({type:Object})],Tv.prototype,"change",void 0),Rv([Bl({type:Object})],Tv.prototype,"action",void 0),Tv=Rv([Ml("gr-confirm-submit-dialog")],Tv);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Iv=ta`
  <style include="shared-styles">
    :host {
      display: flex;
      font-family: var(--font-family);
    }
    #actionLoadingMessage,
    #mainContent,
    section {
      display: flex;
    }
    #actionLoadingMessage,
    gr-button,
    gr-dropdown {
      /* px because don't have the same font size */
      margin-left: 8px;
    }
    #actionLoadingMessage {
      align-items: center;
      color: var(--deemphasized-text-color);
    }
    #confirmSubmitDialog .changeSubject {
      margin: var(--spacing-l);
      text-align: center;
    }
    iron-icon {
      color: inherit;
      margin-right: var(--spacing-xs);
    }
    #moreActions iron-icon {
      margin: 0;
    }
    #moreMessage,
    .hidden {
      display: none;
    }
    @media screen and (max-width: 50em) {
      #mainContent {
        flex-wrap: wrap;
      }
      gr-button {
        --gr-button: {
          padding: var(--spacing-m);
          white-space: nowrap;
        }
      }
      gr-button,
      gr-dropdown {
        margin: 0;
      }
      #actionLoadingMessage {
        margin: var(--spacing-m);
        text-align: center;
      }
      #moreMessage {
        display: inline;
      }
    }
  </style>
  <div id="mainContent">
    <span id="actionLoadingMessage" hidden$="[[!_actionLoadingMessage]]">
      [[_actionLoadingMessage]]</span
    >
    <section
      id="primaryActions"
      hidden$="[[_shouldHideActions(_topLevelActions.*, _loading)]]"
    >
      <template is="dom-repeat" items="[[_topLevelPrimaryActions]]" as="action">
        <gr-button
          link=""
          title$="[[action.title]]"
          has-tooltip="[[_computeHasTooltip(action.title)]]"
          position-below="true"
          data-action-key$="[[action.__key]]"
          data-action-type$="[[action.__type]]"
          data-label$="[[action.label]]"
          disabled$="[[_calculateDisabled(action, _hasKnownChainState)]]"
          on-click="_handleActionTap"
        >
          <iron-icon
            class$="[[_computeHasIcon(action)]]"
            icon$="gr-icons:[[action.icon]]"
          ></iron-icon>
          [[action.label]]
        </gr-button>
      </template>
    </section>
    <section
      id="secondaryActions"
      hidden$="[[_shouldHideActions(_topLevelActions.*, _loading)]]"
    >
      <template
        is="dom-repeat"
        items="[[_topLevelSecondaryActions]]"
        as="action"
      >
        <gr-button
          link=""
          title$="[[action.title]]"
          has-tooltip="[[_computeHasTooltip(action.title)]]"
          position-below="true"
          data-action-key$="[[action.__key]]"
          data-action-type$="[[action.__type]]"
          data-label$="[[action.label]]"
          disabled$="[[_calculateDisabled(action, _hasKnownChainState)]]"
          on-click="_handleActionTap"
        >
          <iron-icon
            class$="[[_computeHasIcon(action)]]"
            icon$="gr-icons:[[action.icon]]"
          ></iron-icon>
          [[action.label]]
        </gr-button>
      </template>
    </section>
    <gr-button hidden$="[[!_loading]]" disabled=""
      >Loading actions...</gr-button
    >
    <gr-dropdown
      id="moreActions"
      link=""
      vertical-offset="32"
      horizontal-align="right"
      on-tap-item="_handleOverflowItemTap"
      hidden$="[[_shouldHideActions(_menuActions.*, _loading)]]"
      disabled-ids="[[_disabledMenuActions]]"
      items="[[_menuActions]]"
    >
      <iron-icon icon="gr-icons:more-vert" aria-labelledby="moreMessage">
      </iron-icon>
      <span id="moreMessage">More</span>
    </gr-dropdown>
  </div>
  <gr-overlay id="overlay" with-backdrop="">
    <gr-confirm-rebase-dialog
      id="confirmRebase"
      class="confirmDialog"
      change-number="[[change._number]]"
      on-confirm="_handleRebaseConfirm"
      on-cancel="_handleConfirmDialogCancel"
      branch="[[change.branch]]"
      has-parent="[[hasParent]]"
      rebase-on-current="[[_computeRebaseOnCurrent(_revisionRebaseAction)]]"
      hidden=""
    ></gr-confirm-rebase-dialog>
    <gr-confirm-cherrypick-dialog
      id="confirmCherrypick"
      class="confirmDialog"
      change-status="[[changeStatus]]"
      commit-message="[[commitMessage]]"
      commit-num="[[commitNum]]"
      on-confirm="_handleCherrypickConfirm"
      on-cancel="_handleConfirmDialogCancel"
      project="[[change.project]]"
      hidden=""
    ></gr-confirm-cherrypick-dialog>
    <gr-confirm-cherrypick-conflict-dialog
      id="confirmCherrypickConflict"
      class="confirmDialog"
      on-confirm="_handleCherrypickConflictConfirm"
      on-cancel="_handleConfirmDialogCancel"
      hidden=""
    ></gr-confirm-cherrypick-conflict-dialog>
    <gr-confirm-move-dialog
      id="confirmMove"
      class="confirmDialog"
      on-confirm="_handleMoveConfirm"
      on-cancel="_handleConfirmDialogCancel"
      project="[[change.project]]"
      hidden=""
    ></gr-confirm-move-dialog>
    <gr-confirm-revert-dialog
      id="confirmRevertDialog"
      class="confirmDialog"
      on-confirm="_handleRevertDialogConfirm"
      on-cancel="_handleConfirmDialogCancel"
      hidden=""
    ></gr-confirm-revert-dialog>
    <gr-confirm-revert-submission-dialog
      id="confirmRevertSubmissionDialog"
      class="confirmDialog"
      commit-message="[[commitMessage]]"
      on-confirm="_handleRevertSubmissionDialogConfirm"
      on-cancel="_handleConfirmDialogCancel"
      hidden=""
    ></gr-confirm-revert-submission-dialog>
    <gr-confirm-abandon-dialog
      id="confirmAbandonDialog"
      class="confirmDialog"
      on-confirm="_handleAbandonDialogConfirm"
      on-cancel="_handleConfirmDialogCancel"
      hidden=""
    ></gr-confirm-abandon-dialog>
    <gr-confirm-submit-dialog
      id="confirmSubmitDialog"
      class="confirmDialog"
      change="[[change]]"
      action="[[_revisionSubmitAction]]"
      on-cancel="_handleConfirmDialogCancel"
      on-confirm="_handleSubmitConfirm"
      hidden=""
    ></gr-confirm-submit-dialog>
    <gr-dialog
      id="createFollowUpDialog"
      class="confirmDialog"
      confirm-label="Create"
      on-confirm="_handleCreateFollowUpChange"
      on-cancel="_handleCloseCreateFollowUpChange"
    >
      <div class="header" slot="header">
        Create Follow-Up Change
      </div>
      <div class="main" slot="main">
        <gr-create-change-dialog
          id="createFollowUpChange"
          branch="[[change.branch]]"
          base-change="[[change.id]]"
          repo-name="[[change.project]]"
          private-by-default="[[privateByDefault]]"
        ></gr-create-change-dialog>
      </div>
    </gr-dialog>
    <gr-dialog
      id="confirmDeleteDialog"
      class="confirmDialog"
      confirm-label="Delete"
      confirm-on-enter=""
      on-cancel="_handleConfirmDialogCancel"
      on-confirm="_handleDeleteConfirm"
    >
      <div class="header" slot="header">
        Delete Change
      </div>
      <div class="main" slot="main">
        Do you really want to delete the change?
      </div>
    </gr-dialog>
    <gr-dialog
      id="confirmDeleteEditDialog"
      class="confirmDialog"
      confirm-label="Delete"
      confirm-on-enter=""
      on-cancel="_handleConfirmDialogCancel"
      on-confirm="_handleDeleteEditConfirm"
    >
      <div class="header" slot="header">
        Delete Change Edit
      </div>
      <div class="main" slot="main">
        Do you really want to delete the edit?
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,kv="OK",Ov="REJECT",Nv="NEED",Lv="IMPOSSIBLE",Dv="OPTIONAL",$v={ABANDON:"abandon",DELETE:"/",DELETE_EDIT:"deleteEdit",EDIT:"edit",FOLLOW_UP:"followup",IGNORE:"ignore",MOVE:"move",PRIVATE:"private",PRIVATE_DELETE:"private.delete",PUBLISH_EDIT:"publishEdit",REBASE:"rebase",REBASE_EDIT:"rebaseEdit",READY:"ready",RESTORE:"restore",REVERT:"revert",REVERT_SUBMISSION:"revert_submission",REVIEWED:"reviewed",STOP_EDIT:"stopEdit",SUBMIT:"submit",UNIGNORE:"unignore",UNREVIEWED:"unreviewed",WIP:"wip"},Mv={CHERRYPICK:"cherrypick",REBASE:"rebase",SUBMIT:"submit",DOWNLOAD:"download"},Fv={abandon:"Abandoning...",cherrypick:"Cherry-picking...",delete:"Deleting...",move:"Moving..",rebase:"Rebasing...",restore:"Restoring...",revert:"Reverting...",revert_submission:"Reverting Submission...",submit:"Submitting..."},Bv={CHANGE:"change",REVISION:"revision"},jv={__key:"review",__type:"change",enabled:!0,key:"review",label:"Quick approve",method:"POST"},Hv=2,Uv=0,Gv=3,Vv=-3,zv=1,Wv={enabled:!0,label:"Download patch",title:"Open download dialog",__key:"download",__primary:!1,__type:"revision"},qv={enabled:!0,label:"Rebase edit",title:"Rebase change edit",__key:"rebaseEdit",__primary:!1,__type:"change",method:"POST"},Kv={enabled:!0,label:"Publish edit",title:"Publish change edit",__key:"publishEdit",__primary:!1,__type:"change",method:"POST"},Yv={enabled:!0,label:"Delete edit",title:"Delete change edit",__key:"deleteEdit",__primary:!1,__type:"change",method:"DELETE"},Xv={enabled:!0,label:"Edit",title:"Edit this change",__key:"edit",__primary:!1,__type:"change"},Jv={enabled:!0,label:"Stop editing",title:"Stop editing this change",__key:"stopEdit",__primary:!1,__type:"change"},Zv=new Set([$v.ABANDON,$v.DELETE_EDIT,$v.EDIT,$v.PUBLISH_EDIT,$v.READY,$v.REBASE_EDIT,$v.RESTORE,$v.REVERT,$v.REVERT_SUBMISSION,$v.STOP_EDIT,jv.key,Mv.REBASE,Mv.SUBMIT]),Qv=1,ey=2,ty=[$v.REVERT_SUBMISSION],ny=[$v.REVIEWED,$v.UNREVIEWED];class iy extends(oo(dr(oa))){static get template(){return Iv}static get is(){return"gr-change-actions"}constructor(){super(),this.ActionType=Bv,this.ChangeActions=$v,this.RevisionActions=Mv,this.reporting=n.reportingService}static get properties(){return{change:Object,actions:{type:Object,value:()=>({})},primaryActionKeys:{type:Array,value:()=>[$v.READY,Mv.SUBMIT]},disableEdit:{type:Boolean,value:!1},_hasKnownChainState:{type:Boolean,value:!1},_hideQuickApproveAction:{type:Boolean,value:!1},changeNum:String,changeStatus:String,commitNum:String,hasParent:{type:Boolean,observer:"_computeChainState"},latestPatchNum:String,commitMessage:{type:String,value:""},revisionActions:{type:Object,notify:!0,value:()=>({})},_revisionSubmitAction:{type:Object,computed:"_getSubmitAction(revisionActions)"},_revisionRebaseAction:{type:Object,computed:"_getRebaseAction(revisionActions)"},privateByDefault:String,_loading:{type:Boolean,value:!0},_actionLoadingMessage:{type:String,value:""},_allActionValues:{type:Array,computed:"_computeAllActions(actions.*, revisionActions.*,primaryActionKeys.*, _additionalActions.*, change, _config, _actionPriorityOverrides.*)"},_topLevelActions:{type:Array,computed:"_computeTopLevelActions(_allActionValues.*, _hiddenActions.*, _overflowActions.*)",observer:"_filterPrimaryActions"},_topLevelPrimaryActions:Array,_topLevelSecondaryActions:Array,_menuActions:{type:Array,computed:"_computeMenuActions(_allActionValues.*, _hiddenActions.*, _overflowActions.*)"},_overflowActions:{type:Array,value:()=>[{type:Bv.CHANGE,key:$v.WIP},{type:Bv.CHANGE,key:$v.DELETE},{type:Bv.REVISION,key:Mv.CHERRYPICK},{type:Bv.CHANGE,key:$v.MOVE},{type:Bv.REVISION,key:Mv.DOWNLOAD},{type:Bv.CHANGE,key:$v.IGNORE},{type:Bv.CHANGE,key:$v.UNIGNORE},{type:Bv.CHANGE,key:$v.REVIEWED},{type:Bv.CHANGE,key:$v.UNREVIEWED},{type:Bv.CHANGE,key:$v.PRIVATE},{type:Bv.CHANGE,key:$v.PRIVATE_DELETE},{type:Bv.CHANGE,key:$v.FOLLOW_UP}]},_actionPriorityOverrides:{type:Array,value:()=>[]},_additionalActions:{type:Array,value:()=>[]},_hiddenActions:{type:Array,value:()=>[]},_disabledMenuActions:{type:Array,value:()=>[]},editPatchsetLoaded:{type:Boolean,value:!1},editMode:{type:Boolean,value:!1},editBasedOnCurrentPatchSet:{type:Boolean,value:!0},_config:Object}}static get observers(){return["_actionsChanged(actions.*, revisionActions.*, _additionalActions.*)","_changeChanged(change)","_editStatusChanged(editMode, editPatchsetLoaded, editBasedOnCurrentPatchSet, disableEdit, actions.*, change.*)"]}created(){super.created(),this.addEventListener("fullscreen-overlay-opened",()=>this._handleHideBackgroundContent()),this.addEventListener("fullscreen-overlay-closed",()=>this._handleShowBackgroundContent())}ready(){super.ready(),this.$.jsAPI.addElement(Tl.CHANGE_ACTIONS,this),this.$.restAPI.getConfig().then(e=>{this._config=e}),this._handleLoadingComplete()}_getSubmitAction(e){return this._getRevisionAction(e,"submit",null)}_getRebaseAction(e){return this._getRevisionAction(e,"rebase",null)}_getRevisionAction(e,t,n){if(e)return void 0===e[t]?n:e[t]}reload(){return this.changeNum&&this.latestPatchNum?(this._loading=!0,this._getRevisionActions().then(e=>{e&&(this.revisionActions=e,this._sendShowRevisionActions({change:this.change,revisionActions:e}),this._handleLoadingComplete())}).catch(e=>{throw this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Couldn’t load revision actions."},composed:!0,bubbles:!0})),this._loading=!1,e})):Promise.resolve()}_handleLoadingComplete(){eh().awaitPluginsLoaded().then(()=>this._loading=!1)}_sendShowRevisionActions(e){this.$.jsAPI.handleEvent(Il.SHOW_REVISION_ACTIONS,e)}_changeChanged(){this.reload()}addActionButton(e,t){if(e!==Bv.CHANGE&&e!==Bv.REVISION)throw Error(`Invalid action type: ${e}`);const n={enabled:!0,label:t,__type:e,__key:"__additionalAction_"+Math.random().toString(36).substr(2)};return this.push("_additionalActions",n),n.__key}removeActionButton(e){const t=this._indexOfActionButtonWithKey(e);-1!==t&&this.splice("_additionalActions",t,1)}setActionButtonProp(e,t,n){this.set(["_additionalActions",this._indexOfActionButtonWithKey(e),t],n)}setActionOverflow(e,t,n){if(e!==Bv.CHANGE&&e!==Bv.REVISION)throw Error(`Invalid action type given: ${e}`);const i=this._getActionOverflowIndex(e,t),o={type:e,key:t,overflow:n};n||-1===i?n&&this.push("_overflowActions",o):this.splice("_overflowActions",i,1)}setActionPriority(e,t,n){if(e!==Bv.CHANGE&&e!==Bv.REVISION)throw Error(`Invalid action type given: ${e}`);const i=this._actionPriorityOverrides.findIndex(n=>n.type===e&&n.key===t),o={type:e,key:t,priority:n};-1!==i?this.set("_actionPriorityOverrides",i,o):this.push("_actionPriorityOverrides",o)}setActionHidden(e,t,n){if(e!==Bv.CHANGE&&e!==Bv.REVISION)throw Error(`Invalid action type given: ${e}`);const i=this._hiddenActions.indexOf(t);n&&-1===i?this.push("_hiddenActions",t):n||-1===i||this.splice("_hiddenActions",i,1)}getActionDetails(e){return this.revisionActions[e]?this.revisionActions[e]:this.actions[e]?this.actions[e]:void 0}_indexOfActionButtonWithKey(e){for(let t=0;t<this._additionalActions.length;t++)if(this._additionalActions[t].__key===e)return t;return-1}_getRevisionActions(){return this.$.restAPI.getChangeRevisionActions(this.changeNum,this.latestPatchNum)}_shouldHideActions(e,t){return t||!e||!e.base||!e.base.length}_keyCount(e){return Object.keys(e&&e.base||{}).length}_actionsChanged(e,t,n){if([e,t,n].includes(void 0))return;const i=n&&n.base||[];this.hidden=0===this._keyCount(e)&&0===this._keyCount(t)&&0===i.length,this._actionLoadingMessage="",this._disabledMenuActions=[];const o=t.base||{};0!==Object.keys(o).length&&(o.download||this.set("revisionActions.download",Wv))}_deleteAndNotify(e){this.actions&&this.actions[e]&&(delete this.actions[e],this.notifyPath("actions."+e,!1))}_editStatusChanged(e,t,n,i){if(![e,n,i].includes(void 0)){if(i)return this._deleteAndNotify("publishEdit"),this._deleteAndNotify("rebaseEdit"),this._deleteAndNotify("deleteEdit"),this._deleteAndNotify("stopEdit"),void this._deleteAndNotify("edit");this.actions&&t?(Wp(this.change)&&(n?(this.actions.publishEdit||this.set("actions.publishEdit",Kv),this._deleteAndNotify("rebaseEdit")):(this.actions.rebaseEdit||this.set("actions.rebaseEdit",qv),this._deleteAndNotify("publishEdit"))),this.actions.deleteEdit||this.set("actions.deleteEdit",Yv)):(this._deleteAndNotify("publishEdit"),this._deleteAndNotify("rebaseEdit"),this._deleteAndNotify("deleteEdit")),this.actions&&Wp(this.change)?(t||e?this._deleteAndNotify("edit"):this.actions.edit||this.set("actions.edit",Xv),e&&!t?this.actions.stopEdit||this.set("actions.stopEdit",Jv):this._deleteAndNotify("stopEdit")):this._deleteAndNotify("edit")}}_getValuesFor(e){return Object.keys(e).map(t=>e[t])}_getLabelStatus(e){return e.approved?kv:e.rejected?Ov:e.optional?Dv:Nv}_getTopMissingApproval(){if(!this.change||!this.change.labels||!this.change.permitted_labels)return null;let e;for(const t in this.change.labels){if(!(t in this.change.permitted_labels))continue;if(0===this.change.permitted_labels[t].length)continue;const n=this._getLabelStatus(this.change.labels[t]);if(n===Nv){if(e)return null;e=t}else if(n===Ov||n===Lv)return null}if(e){const t=this.change.permitted_labels[e].slice(-1)[0];if(t===Object.keys(this.change.labels[e].values).slice(-1)[0])return{label:e,score:t}}return null}hideQuickApproveAction(){this._topLevelSecondaryActions=this._topLevelSecondaryActions.filter(e=>e.key!==jv.key),this._hideQuickApproveAction=!0}_getQuickApproveAction(){if(this._hideQuickApproveAction)return null;const e=this._getTopMissingApproval();if(!e)return null;const t={...jv};t.label=e.label+e.score;const n={drafts:"PUBLISH_ALL_REVISIONS",labels:{}};return n.labels[e.label]=e.score,t.payload=n,t}_getActionValues(e,t,n,i){if(!e||!t)return[];const o=e.base||{},s=t.base||[],r=[],a=this._getValuesFor(i===Bv.CHANGE?$v:Mv),l=[];Object.keys(o).forEach(e=>{if(o[e].__key=e,o[e].__type=i,o[e].__primary=s.includes(e),-1!==e.indexOf("~"))return this._populateActionUrl(o[e]),l.push(o[e]),void this._overflowActions.push({type:i,key:e});a.includes(e)&&(o[e].label=this._getActionLabel(o[e]),r.push({...o[e]}))});let c=n&&n.base||[];return c=c.filter(e=>e.__type===i).map(e=>(e.__primary=s.includes(e.__key),{...e})),r.concat(c).concat(l)}_populateActionUrl(e){const t=e.__type===Bv.REVISION?this.latestPatchNum:null;this.$.restAPI.getChangeActionURL(this.changeNum,t,"/"+e.__key).then(t=>e.__url=t)}_getActionLabel(e){return"Delete"===e.label?"Delete change":"WIP"===e.label?"Mark as work in progress":this._toSentenceCase(e.label)}_toSentenceCase(e){return e.length?e[0].toUpperCase()+e.slice(1).toLowerCase():""}_computeLoadingLabel(e){return Fv[e]||"Working..."}_canSubmitChange(){return this.$.jsAPI.canSubmitChange(this.change,this._getRevision(this.change,this.latestPatchNum))}_getRevision(e,t){for(const n of Object.values(e.revisions))if(Ch(n._number,t))return n;return null}showRevertDialog(){const e=`submissionid: "${this.change.submission_id}"`;this.$.restAPI.getChanges("",e).then(e=>{this.$.confirmRevertDialog.populate(this.change,this.commitMessage,e),this._showActionDialog(this.$.confirmRevertDialog)})}showRevertSubmissionDialog(){const e="submissionid:"+this.change.submission_id;this.$.restAPI.getChanges("",e).then(e=>{this.$.confirmRevertSubmissionDialog._populateRevertSubmissionMessage(this.change,e),this._showActionDialog(this.$.confirmRevertSubmissionDialog)})}_handleActionTap(e){e.preventDefault();let t=qo(e).localTarget;for(;"gr-button"!==t.tagName.toLowerCase();){if(!t.parentElement)return;t=t.parentElement}const n=t.getAttribute("data-action-key");if(n.startsWith("__additionalAction_")||-1!==n.indexOf("~"))return void this.dispatchEvent(new CustomEvent(`${n}-tap`,{detail:{node:t},composed:!0,bubbles:!0}));const i=t.getAttribute("data-action-type");this._handleAction(i,n)}_handleOverflowItemTap(e){e.preventDefault();const t=qo(e).localTarget,n=e.detail.action.__key;n.startsWith("__additionalAction_")||-1!==n.indexOf("~")?this.dispatchEvent(new CustomEvent(`${n}-tap`,{detail:{node:t},composed:!0,bubbles:!0})):this._handleAction(e.detail.action.__type,e.detail.action.__key)}_handleAction(e,t){switch(this.reporting.reportInteraction(`${e}-${t}`),e){case Bv.REVISION:this._handleRevisionAction(t);break;case Bv.CHANGE:this._handleChangeAction(t);break;default:this._fireAction(this._prependSlash(t),this.actions[t],!1)}}_handleChangeAction(e){let t;switch(e){case $v.REVERT:this.showRevertDialog();break;case $v.REVERT_SUBMISSION:this.showRevertSubmissionDialog();break;case $v.ABANDON:this._showActionDialog(this.$.confirmAbandonDialog);break;case jv.key:t=this._allActionValues.find(t=>t.key===e),this._fireAction(this._prependSlash(e),t,!0,t.payload);break;case $v.EDIT:this._handleEditTap();break;case $v.STOP_EDIT:this._handleStopEditTap();break;case $v.DELETE:this._handleDeleteTap();break;case $v.DELETE_EDIT:this._handleDeleteEditTap();break;case $v.FOLLOW_UP:this._handleFollowUpTap();break;case $v.WIP:this._handleWipTap();break;case $v.MOVE:this._handleMoveTap();break;case $v.PUBLISH_EDIT:this._handlePublishEditTap();break;case $v.REBASE_EDIT:this._handleRebaseEditTap();break;default:this._fireAction(this._prependSlash(e),this.actions[e],!1)}}_handleRevisionAction(e){switch(e){case Mv.REBASE:this._showActionDialog(this.$.confirmRebase),this.$.confirmRebase.fetchRecentChanges();break;case Mv.CHERRYPICK:this._handleCherrypickTap();break;case Mv.DOWNLOAD:this._handleDownloadTap();break;case Mv.SUBMIT:if(!this._canSubmitChange())return;this._showActionDialog(this.$.confirmSubmitDialog);break;default:this._fireAction(this._prependSlash(e),this.revisionActions[e],!0)}}_prependSlash(e){return"/"===e?e:`/${e}`}_computeChainState(e){this._hasKnownChainState=!0}_calculateDisabled(e,t){return"rebase"===e.__key?!1===t:!e.enabled}_handleConfirmDialogCancel(){this._hideAllDialogs()}_hideAllDialogs(){const e=this.root.querySelectorAll(".confirmDialog");for(const t of e)t.hidden=!0;this.$.overlay.close()}_handleRebaseConfirm(e){const t=this.$.confirmRebase,n={base:e.detail.base};this.$.overlay.close(),t.hidden=!0,this._fireAction("/rebase",this.revisionActions.rebase,!0,n)}_handleCherrypickConfirm(){this._handleCherryPickRestApi(!1)}_handleCherrypickConflictConfirm(){this._handleCherryPickRestApi(!0)}_handleCherryPickRestApi(e){const t=this.$.confirmCherrypick;t.branch?t.message?(this.$.overlay.close(),t.hidden=!0,this._fireAction("/cherrypick",this.revisionActions.cherrypick,!0,{destination:t.branch,base:t.baseCommit?t.baseCommit:null,message:t.message,allow_conflicts:e})):this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"The commit message can’t be empty."},composed:!0,bubbles:!0})):this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"The destination branch can’t be empty."},composed:!0,bubbles:!0}))}_handleMoveConfirm(){const e=this.$.confirmMove;e.branch?(this.$.overlay.close(),e.hidden=!0,this._fireAction("/move",this.actions.move,!1,{destination_branch:e.branch,message:e.message})):this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"The destination branch can’t be empty."},composed:!0,bubbles:!0}))}_handleRevertDialogConfirm(e){const t=e.detail.revertType,n=e.detail.message,i=this.$.confirmRevertDialog;switch(this.$.overlay.close(),i.hidden=!0,t){case Qv:this._fireAction("/revert",this.actions.revert,!1,{message:n});break;case ey:this._fireAction("/revert_submission",this.actions.revert_submission,!1,{message:n});break;default:console.error("invalid revert type")}}_handleRevertSubmissionDialogConfirm(){const e=this.$.confirmRevertSubmissionDialog;this.$.overlay.close(),e.hidden=!0,this._fireAction("/revert_submission",this.actions.revert_submission,!1,{message:e.message})}_handleAbandonDialogConfirm(){const e=this.$.confirmAbandonDialog;this.$.overlay.close(),e.hidden=!0,this._fireAction("/abandon",this.actions.abandon,!1,{message:e.message})}_handleCreateFollowUpChange(){this.$.createFollowUpChange.handleCreateChange(),this._handleCloseCreateFollowUpChange()}_handleCloseCreateFollowUpChange(){this.$.overlay.close()}_handleDeleteConfirm(){this._fireAction("/",this.actions[$v.DELETE],!1)}_handleDeleteEditConfirm(){this._hideAllDialogs(),this._fireAction("/edit",this.actions.deleteEdit,!1)}_handleSubmitConfirm(){this._canSubmitChange()&&(this._hideAllDialogs(),this._fireAction("/submit",this.revisionActions.submit,!0))}_getActionOverflowIndex(e,t){return this._overflowActions.findIndex(n=>n.type===e&&n.key===t)}_setLoadingOnButtonWithKey(e,t){this._actionLoadingMessage=this._computeLoadingLabel(t);let n=t;if(n===$v.REVERT_SUBMISSION&&(n=$v.REVERT),-1!==this._getActionOverflowIndex(e,n))return this.push("_disabledMenuActions","/"===n?"delete":n),()=>{this._actionLoadingMessage="",this._disabledMenuActions=[]};const i=this.shadowRoot.querySelector(`[data-action-key="${n}"]`);return i.setAttribute("loading",!0),i.disabled=!0,()=>{this._actionLoadingMessage="",i.removeAttribute("loading"),i.disabled=!1}}_fireAction(e,t,n,i){const o=this._setLoadingOnButtonWithKey(t.__type,t.__key);this._send(t.method,i,e,n,o,t).then(e=>this._handleResponse(t,e))}_showActionDialog(e){this._hideAllDialogs(),e.hidden=!1,this.$.overlay.open().then(()=>{e.resetFocus&&e.resetFocus()})}_setLabelValuesOnRevert(e){const t=this.$.jsAPI.getLabelValuesPostRevert(this.change);return t?this.$.restAPI.saveChangeReview(e,"current",{labels:t}):Promise.resolve()}_handleResponse(e,t){if(t)return this.$.restAPI.getResponseObject(t).then(t=>{switch(e.__key){case $v.REVERT:this._waitForChangeReachable(t._number).then(()=>this._setLabelValuesOnRevert(t._number)).then(()=>{gh.navigateToChange(t)});break;case Mv.CHERRYPICK:this._waitForChangeReachable(t._number).then(()=>{gh.navigateToChange(t)});break;case $v.DELETE:e.__type===Bv.CHANGE&&gh.navigateToRelativeUrl(gh.getUrlForRoot());break;case $v.WIP:case $v.DELETE_EDIT:case $v.PUBLISH_EDIT:case $v.REBASE_EDIT:case $v.REBASE:case $v.SUBMIT:this.dispatchEvent(new CustomEvent("reload",{detail:{clearPatchset:!0},bubbles:!1,composed:!0}));break;case $v.REVERT_SUBMISSION:if(!t.revert_changes||!t.revert_changes.length)return;gh.navigateToSearchQuery("topic: "+t.revert_changes[0].topic);break;default:this.dispatchEvent(new CustomEvent("reload",{detail:{action:e.__key,clearPatchset:!0},bubbles:!1,composed:!0}))}})}_handleShowRevertSubmissionChangesConfirm(){this._hideAllDialogs()}_handleResponseError(e,t,n){return e&&e.__key===Mv.CHERRYPICK&&t&&409===t.status&&n&&!n.allow_conflicts?this._showActionDialog(this.$.confirmCherrypickConflict):t.text().then(e=>{if(this.dispatchEvent(new CustomEvent("show-error",{detail:{message:`Could not perform action: ${e}`},composed:!0,bubbles:!0})),!e.startsWith("Change is already up to date"))throw Error(e)})}_send(e,t,n,i,o,s){const r=e=>{o.call(this),this._handleResponseError(s,e,t)};return Ih(this.change,this.$.restAPI).then(s=>{if(!s.isLatest)return this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Cannot set label: a newer patch has been uploaded to this change.",action:"Reload",callback:()=>{this.dispatchEvent(new CustomEvent("reload",{detail:{clearPatchset:!0},bubbles:!1,composed:!0}))}},composed:!0,bubbles:!0})),o(),Promise.resolve();const a=i?this.latestPatchNum:null;return this.$.restAPI.executeChangeAction(this.changeNum,e,n,a,t,r).then(e=>(o.call(this),e))})}_handleAbandonTap(){this._showActionDialog(this.$.confirmAbandonDialog)}_handleCherrypickTap(){this.$.confirmCherrypick.branch="";const e=`topic: "${this.change.topic}"`,t=Vp($p,Op);this.$.restAPI.getChanges("",e,void 0,t).then(e=>{this.$.confirmCherrypick.updateChanges(e),this._showActionDialog(this.$.confirmCherrypick)})}_handleMoveTap(){this.$.confirmMove.branch="",this.$.confirmMove.message="",this._showActionDialog(this.$.confirmMove)}_handleDownloadTap(){this.dispatchEvent(new CustomEvent("download-tap",{composed:!0,bubbles:!1}))}_handleDeleteTap(){this._showActionDialog(this.$.confirmDeleteDialog)}_handleDeleteEditTap(){this._showActionDialog(this.$.confirmDeleteEditDialog)}_handleFollowUpTap(){this._showActionDialog(this.$.createFollowUpDialog)}_handleWipTap(){this._fireAction("/wip",this.actions.wip,!1)}_handlePublishEditTap(){const e={notify:il.NONE};this._fireAction("/edit:publish",this.actions.publishEdit,!1,e)}_handleRebaseEditTap(){this._fireAction("/edit:rebase",this.actions.rebaseEdit,!1)}_handleHideBackgroundContent(){this.$.mainContent.classList.add("overlayOpen")}_handleShowBackgroundContent(){this.$.mainContent.classList.remove("overlayOpen")}_computeAllActions(e,t,n,i,o,s){if([e,t,n,i,o].includes(void 0))return[];const r=this._getActionValues(t,n,i,Bv.REVISION),a=this._getActionValues(e,n,i,Bv.CHANGE),l=this._getQuickApproveAction();return l&&a.unshift(l),r.concat(a).sort((e,t)=>this._actionComparator(e,t)).map(e=>(Zv.has(e.__key)&&(e.icon=e.__key),e.__key===$v.READY&&(e.label="Mark as Active"),e)).filter(e=>!this._shouldSkipAction(e,s))}_getActionPriority(e){if(e.__type&&e.__key){const t=this._actionPriorityOverrides.find(t=>t.type===e.__type&&t.key===e.__key);if(void 0!==t)return t.priority}return"review"===e.__key?Vv:e.__primary?Gv:e.__type===Bv.CHANGE?Hv:e.__type===Bv.REVISION?zv:Uv}_actionComparator(e,t){const n=this._getActionPriority(e)-this._getActionPriority(t);return 0===n?e.label>t.label?1:-1:n}_shouldSkipAction(e,t){const n=[...ty];return!!t&&!!t.change&&t.change.enable_attention_set&&n.push(...ny),n.includes(e.__key)}_computeTopLevelActions(e,t){const n=t.base||[];return e.base.filter(e=>!(-1!==this._getActionOverflowIndex(e.__type,e.__key)||n.includes(e.__key)))}_filterPrimaryActions(e){this._topLevelPrimaryActions=e.filter(e=>e.__primary),this._topLevelSecondaryActions=e.filter(e=>!e.__primary)}_computeMenuActions(e,t){const n=t.base||[];return e.base.filter(e=>-1!==this._getActionOverflowIndex(e.__type,e.__key)&&!n.includes(e.__key)).map(e=>{let t=e.__key;return"/"===t&&(t="delete"),{name:e.label,id:`${t}-${e.__type}`,action:e,tooltip:e.title}})}_computeRebaseOnCurrent(e){return e?!!e.enabled:null}_waitForChangeReachable(e){let t=5;return new Promise(n=>{const i=()=>{t--,this.$.restAPI.getChange(e,()=>{}).then(e=>{e?n(!0):t?this.async(i,1e3):n(!1)})};i()})}_handleEditTap(){this.dispatchEvent(new CustomEvent("edit-tap",{bubbles:!1}))}_handleStopEditTap(){this.dispatchEvent(new CustomEvent("stop-edit-tap",{bubbles:!1}))}_computeHasTooltip(e){return!!e}_computeHasIcon(e){return e.icon?"":"hidden"}}customElements.define(iy.is,iy);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const oy=document.createElement("template");oy.innerHTML='<dom-module id="gr-change-metadata-shared-styles">\n  <template>\n    <style include="shared-styles">\n      /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */\n    </style>\n    <style>\n      section {\n        display: table-row;\n      }\n\n      section:not(:first-of-type) .title,\n      section:not(:first-of-type) .value {\n        padding-top: var(--spacing-s);\n      }\n\n      .title,\n      .value {\n        display: table-cell;\n        vertical-align: top;\n      }\n\n      .title {\n        color: var(--deemphasized-text-color);\n        max-width: 20em;\n        padding-left: var(--metadata-horizontal-padding);\n        padding-right: var(--metadata-horizontal-padding);\n        word-break: break-word;\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(oy.content);
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const sy=document.createElement("template");sy.innerHTML='<dom-module id="gr-change-view-integration-shared-styles">\n  <template>\n    <style include="shared-styles">\n      /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */\n    </style>\n    <style>\n      :host {\n        border-top: 1px solid var(--border-color);\n        display: block;\n      }\n      .header {\n        color: var(--primary-text-color);\n        background-color: var(--table-header-background-color);\n        justify-content: space-between;\n        padding: var(--spacing-m) var(--spacing-l);\n        border-bottom: 1px solid var(--border-color);\n      }\n      .header .label {\n        font-family: var(--header-font-family);\n        font-size: var(--font-size-h3);\n        font-weight: var(--font-weight-h3);\n        line-height: var(--line-height-h3);\n        margin: 0 var(--spacing-l) 0 0;\n      }\n      .header .note {\n        color: var(--deemphasized-text-color);\n      }\n      .content {\n        background-color: var(--view-background-color);\n      }\n      .header a,\n      .content a {\n        color: var(--link-color);\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(sy.content);
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ry=document.createElement("template");ry.innerHTML='<dom-module id="gr-voting-styles">\n  <template>\n    <style>\n      :host {\n        --vote-chip-styles: {\n          border: 1px solid rgba(0,0,0,.12);\n          border-radius: 1em;\n          box-shadow: none;\n          box-sizing: border-box;\n          min-width: 3em;\n          color: var(--vote-text-color);\n        }\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(ry.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ay=ta` <slot></slot> `;var ly=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let cy=class extends(oo(dr(oa))){constructor(){super(...arguments),this._stylesApplied=[]}static get template(){return ay}_applyStyle(e){if(this._stylesApplied.includes(e))return;this._stylesApplied.push(e);const t=document.createElement("style");t.setAttribute("include",e);const n=document.createElement("custom-style");n.appendChild(t);const i=document.getElementsByTagName("body")[0];i.insertBefore(n,i.firstChild),ns()}_importAndApply(){rc().getAndImportPlugins(this.name).then(()=>{const e=rc().getModules(this.name);for(const t of e)this._applyStyle(t)})}attached(){super.attached(),this._importAndApply()}ready(){super.ready(),eh().awaitPluginsLoaded().then(()=>this._importAndApply())}};ly([Bl({type:String})],cy.prototype,"name",void 0),ly([Bl({type:Array})],cy.prototype,"_stylesApplied",void 0),cy=ly([Ml("gr-external-style")],cy);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const dy=ta`
  <style include="shared-styles">
    :host {
      display: block;
      overflow: hidden;
    }
    .container {
      align-items: center;
      background-color: var(--background-color-primary);
      /** round */
      border-radius: var(--account-chip-border-radius, 20px);
      border: 1px solid var(--border-color);
      display: inline-flex;
      padding: 0 1px;

      --account-label-padding-horizontal: 6px;
      --gr-account-label-text-style: {
        color: var(--deemphasized-text-color);
      }
    }
    :host([show-avatar]) .container {
    }
    :host([removable]) .container {
    }
    gr-button.remove {
      --gr-remove-button-style: {
        border: 0;
        color: var(--deemphasized-text-color);
        font-weight: var(--font-weight-normal);
        height: 0.6em;
        line-height: 10px;
        /* This cancels most of the --account-label-padding-horizontal. */
        margin-left: -4px;
        padding: 0 2px 0 0;
        text-decoration: none;
      }
    }

    gr-button.remove:hover,
    gr-button.remove:focus {
      --gr-button: {
        @apply --gr-remove-button-style;
        color: #333;
      }
    }
    gr-button.remove {
      --gr-button: {
        @apply --gr-remove-button-style;
      }
    }
    :host:focus {
      border-color: transparent;
      box-shadow: none;
      outline: none;
    }
    :host:focus .container,
    :host:focus gr-button {
      background: #ccc;
    }
    .transparentBackground,
    gr-button.transparentBackground {
      background-color: transparent;
    }
    :host([disabled]) {
      opacity: 0.6;
      pointer-events: none;
    }
    iron-icon {
      height: 1.2rem;
      width: 1.2rem;
    }
  </style>
  <div class$="container [[_getBackgroundClass(transparentBackground)]]">
    <gr-account-link
      account="[[account]]"
      change="[[change]]"
      force-attention="[[forceAttention]]"
      highlight-attention="[[highlightAttention]]"
      voteable-text="[[voteableText]]"
    >
    </gr-account-link>
    <gr-button
      id="remove"
      link=""
      hidden$="[[!removable]]"
      hidden=""
      aria-label="Remove"
      class$="remove [[_getBackgroundClass(transparentBackground)]]"
      on-click="_handleRemoveTap"
    >
      <iron-icon icon="gr-icons:close"></iron-icon>
    </gr-button>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var hy=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let py=class extends(oo(dr(oa))){constructor(){super(...arguments),this.forceAttention=!1,this.disabled=!1,this.removable=!1,this.highlightAttention=!1,this.transparentBackground=!1}static get template(){return dy}ready(){super.ready(),this._getHasAvatars().then(e=>{this.showAvatar=e})}_getBackgroundClass(e){return e?"transparentBackground":""}_handleRemoveTap(e){e.preventDefault(),this.dispatchEvent(new CustomEvent("remove",{detail:{account:this.account},composed:!0,bubbles:!0}))}_getHasAvatars(){return this.$.restAPI.getConfig().then(e=>Promise.resolve(!!(e&&e.plugin&&e.plugin.has_avatars)))}};hy([Bl({type:Object})],py.prototype,"account",void 0),hy([Bl({type:Object})],py.prototype,"change",void 0),hy([Bl({type:Boolean})],py.prototype,"forceAttention",void 0),hy([Bl({type:String})],py.prototype,"voteableText",void 0),hy([Bl({type:Boolean,reflectToAttribute:!0})],py.prototype,"disabled",void 0),hy([Bl({type:Boolean,reflectToAttribute:!0})],py.prototype,"removable",void 0),hy([Bl({type:Boolean})],py.prototype,"highlightAttention",void 0),hy([Bl({type:Boolean,reflectToAttribute:!0})],py.prototype,"showAvatar",void 0),hy([Bl({type:Boolean})],py.prototype,"transparentBackground",void 0),py=hy([Ml("gr-account-chip")],py);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const uy=ta`
  <style include="shared-styles">
    :host {
      align-items: center;
      display: inline-flex;
    }
    :host([uppercase]) label {
      text-transform: uppercase;
    }
    input,
    label {
      width: 100%;
    }
    label {
      color: var(--deemphasized-text-color);
      display: inline-block;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
      @apply --label-style;
    }
    label.editable {
      color: var(--link-color);
      cursor: pointer;
    }
    #dropdown {
      box-shadow: var(--elevation-level-2);
    }
    .inputContainer {
      background-color: var(--dialog-background-color);
      padding: var(--spacing-m);
      @apply --input-style;
    }
    .buttons {
      display: flex;
      justify-content: flex-end;
      padding-top: var(--spacing-l);
      width: 100%;
    }
    .buttons gr-button {
      margin-left: var(--spacing-m);
    }
    paper-input {
      --paper-input-container: {
        padding: 0;
        min-width: 15em;
      }
      --paper-input-container-input: {
        font-size: inherit;
      }
      --paper-input-container-focus-color: var(--link-color);
    }
  </style>
  <label
    class$="[[_computeLabelClass(readOnly, value, placeholder)]]"
    title$="[[_computeLabel(value, placeholder)]]"
    on-click="_showDropdown"
    >[[_computeLabel(value, placeholder)]]</label
  >
  <iron-dropdown
    id="dropdown"
    vertical-align="auto"
    horizontal-align="auto"
    vertical-offset="[[_verticalOffset]]"
    allow-outside-scroll="true"
    on-iron-overlay-canceled="_cancel"
  >
    <div class="dropdown-content" slot="dropdown-content">
      <div class="inputContainer">
        <paper-input
          id="input"
          label="[[labelText]]"
          maxlength="[[maxLength]]"
          value="{{_inputText}}"
        ></paper-input>
        <div class="buttons">
          <gr-button link="" id="cancelBtn" on-click="_cancel"
            >cancel</gr-button
          >
          <gr-button link="" id="saveBtn" on-click="_save">save</gr-button>
        </div>
      </div>
    </div>
  </iron-dropdown>
`;var gy=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let my=class extends(xp(oo(dr(oa)))){constructor(){super(...arguments),this.editing=!1,this.value="",this.placeholder="",this.readOnly=!1,this.uppercase=!1,this._verticalOffset=-30}static get template(){return uy}ready(){super.ready(),this._ensureAttribute("tabindex","0")}get keyBindings(){return{enter:"_handleEnter",esc:"_handleEsc"}}_usePlaceholder(e,t){return(!e||!e.length)&&t}_computeLabel(e,t){return this._usePlaceholder(e,t)?t:e||""}_showDropdown(){if(!this.readOnly&&!this.editing)return this._open().then(()=>{this._nativeInput.focus(),this.$.input.value&&this._nativeInput.setSelectionRange(0,this.$.input.value.length)})}open(){return this._open().then(()=>{this._nativeInput.focus()})}_open(){return this.$.dropdown.open(),this._inputText=this.value,this.editing=!0,new Promise(e=>{this._awaitOpen(e)})}_awaitOpen(e){let t=0;const n=()=>{this.async(()=>{"none"!==this.$.dropdown.style.display?e.call(this):t++<10&&n.call(this)},5)};n.call(this)}_id(){return this.getAttribute("id")||"global"}_save(){this.editing&&(this.$.dropdown.close(),this.value=this._inputText||"",this.editing=!1,this.dispatchEvent(new CustomEvent("changed",{detail:this.value,composed:!0,bubbles:!0})))}_cancel(){this.editing&&(this.$.dropdown.close(),this.editing=!1,this._inputText=this.value)}get _nativeInput(){return this.$.input.$.nativeInput||this.$.input.inputElement}_handleEnter(e){e=this.getKeyboardEvent(e),qo(e).rootTarget===this._nativeInput&&(e.preventDefault(),this._save())}_handleEsc(e){e=this.getKeyboardEvent(e),qo(e).rootTarget===this._nativeInput&&(e.preventDefault(),this._cancel())}_computeLabelClass(e,t,n){const i=[];return e||i.push("editable"),this._usePlaceholder(t,n)&&i.push("placeholder"),i.join(" ")}_updateTitle(e){this.setAttribute("title",this._computeLabel(e,this.placeholder))}};gy([Bl({type:String})],my.prototype,"labelText",void 0),gy([Bl({type:Boolean})],my.prototype,"editing",void 0),gy([Bl({type:String,notify:!0,observer:"_updateTitle"})],my.prototype,"value",void 0),gy([Bl({type:String})],my.prototype,"placeholder",void 0),gy([Bl({type:Boolean})],my.prototype,"readOnly",void 0),gy([Bl({type:Boolean,reflectToAttribute:!0})],my.prototype,"uppercase",void 0),gy([Bl({type:Number})],my.prototype,"maxLength",void 0),gy([Bl({type:String})],my.prototype,"_inputText",void 0),gy([Bl({type:Number})],my.prototype,"_verticalOffset",void 0),my=gy([Ml("gr-editable-label")],my);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const _y=ta`
  <style include="shared-styles">
    :host {
      display: block;
      overflow: hidden;
    }
    .container {
      align-items: center;
      background: var(--chip-background-color);
      border-radius: 0.75em;
      display: inline-flex;
      padding: 0 var(--spacing-m);
    }
    gr-button.remove {
      --gr-remove-button-style: {
        border: 0;
        color: var(--deemphasized-text-color);
        font-weight: var(--font-weight-normal);
        height: 0.6em;
        line-height: 10px;
        margin-left: var(--spacing-xs);
        padding: 0;
        text-decoration: none;
      }
    }

    gr-button.remove:hover,
    gr-button.remove:focus {
      --gr-button: {
        @apply --gr-remove-button-style;
        color: #333;
      }
    }
    gr-button.remove {
      --gr-button: {
        @apply --gr-remove-button-style;
      }
    }
    .transparentBackground,
    gr-button.transparentBackground {
      background-color: transparent;
    }
    :host([disabled]) {
      opacity: 0.6;
      pointer-events: none;
    }
    a {
      color: var(--linked-chip-text-color);
    }
    iron-icon {
      height: 1.2rem;
      width: 1.2rem;
    }
  </style>
  <div class$="container [[_getBackgroundClass(transparentBackground)]]">
    <a href$="[[href]]">
      <gr-limited-text limit="[[limit]]" text="[[text]]"></gr-limited-text>
    </a>
    <gr-button
      id="remove"
      link=""
      hidden$="[[!removable]]"
      hidden=""
      class$="remove [[_getBackgroundClass(transparentBackground)]]"
      on-click="_handleRemoveTap"
    >
      <iron-icon icon="gr-icons:close"></iron-icon>
    </gr-button>
  </div>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var fy=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let vy=class extends(oo(dr(oa))){constructor(){super(...arguments),this.disabled=!1,this.removable=!1,this.transparentBackground=!1}static get template(){return _y}_getBackgroundClass(e){return e?"transparentBackground":""}_handleRemoveTap(e){e.preventDefault(),this.dispatchEvent(new CustomEvent("remove",{composed:!0,bubbles:!0}))}};fy([Bl({type:String})],vy.prototype,"href",void 0),fy([Bl({type:Boolean,reflectToAttribute:!0})],vy.prototype,"disabled",void 0),fy([Bl({type:Boolean})],vy.prototype,"removable",void 0),fy([Bl({type:String})],vy.prototype,"text",void 0),fy([Bl({type:Boolean})],vy.prototype,"transparentBackground",void 0),fy([Bl({type:Number})],vy.prototype,"limit",void 0),vy=fy([Ml("gr-linked-chip")],vy);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const yy=ta` <slot></slot> `
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;let by=class extends(mp(oo(dr(oa)))){static get template(){return yy}};by=(window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r})([Ml("gr-label")],by);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const wy=ta`
  <style include="gr-voting-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="shared-styles">
    .placeholder {
      color: var(--deemphasized-text-color);
    }
    .hidden {
      display: none;
    }
    .voteChip {
      display: flex;
      justify-content: center;
      margin-right: var(--spacing-s);
      padding: 0;
      @apply --vote-chip-styles;
      border-width: 0;
    }
    .max {
      background-color: var(--vote-color-approved);
    }
    .min {
      background-color: var(--vote-color-rejected);
    }
    .positive {
      background-color: var(--vote-color-recommended);
    }
    .negative {
      background-color: var(--vote-color-disliked);
    }
    .hidden {
      display: none;
    }
    td {
      vertical-align: top;
    }
    tr {
      min-height: var(--line-height-normal);
    }
    gr-button {
      vertical-align: top;
      --gr-button: {
        height: var(--line-height-normal);
        width: var(--line-height-normal);
        padding: 0;
      }
    }
    gr-button[disabled] iron-icon {
      color: var(--border-color);
    }
    gr-account-link {
      --account-max-length: 120px;
      margin-right: var(--spacing-xs);
    }
    iron-icon {
      height: calc(var(--line-height-normal) - 2px);
      width: calc(var(--line-height-normal) - 2px);
    }
    .labelValueContainer:not(:first-of-type) td {
      padding-top: var(--spacing-s);
    }
  </style>
  <p
    class$="placeholder [[_computeShowPlaceholder(labelInfo, change.labels.*)]]"
  >
    No votes.
  </p>
  <table>
    <template
      is="dom-repeat"
      items="[[_mapLabelInfo(labelInfo, account, change.labels.*)]]"
      as="mappedLabel"
    >
      <tr class="labelValueContainer">
        <td>
          <gr-label
            has-tooltip=""
            title="[[_computeValueTooltip(labelInfo, mappedLabel.value)]]"
            class$="[[mappedLabel.className]] voteChip"
          >
            [[mappedLabel.value]]
          </gr-label>
        </td>
        <td>
          <gr-account-link account="[[mappedLabel.account]]"></gr-account-link>
        </td>
        <td>
          <gr-button
            link=""
            aria-label="Remove vote"
            on-click="_onDeleteVote"
            tooltip="Remove vote"
            data-account-id$="[[mappedLabel.account._account_id]]"
            class$="deleteBtn [[_computeDeleteClass(mappedLabel.account, mutable, change)]]"
          >
            <iron-icon icon="gr-icons:delete"></iron-icon>
          </gr-button>
        </td>
      </tr>
    </template>
  </table>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Cy,Ey=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};function Sy(e){return!e.values}!function(e){e.NEGATIVE="negative",e.POSITIVE="positive",e.MIN="min",e.MAX="max"}(Cy||(Cy={}));let Ay=class extends(oo(dr(oa))){constructor(){super(...arguments),this.label="",this.mutable=!1}static get template(){return wy}_mapLabelInfo(e,t){const n=[];if(!e||!t)return n;if(Sy(e)){if(e.rejected||e.approved){const t=e.approved||!e.rejected;return[{value:t?"👍️":"👎️",className:t?Cy.POSITIVE:Cy.NEGATIVE,account:t?e.approved:e.rejected}]}return n}const i=(e.all||[]).sort((e,t)=>(e.value||0)-(t.value||0)),o=Object.keys(e.values||{});for(const s of i)if(s.value&&s.value!==e.default_value){let e,i="";s.value>0?(i="+",e=parseInt(`${s.value}`,10)===parseInt(o[o.length-1],10)?Cy.MAX:Cy.POSITIVE):s.value<0&&(e=parseInt(`${s.value}`,10)===parseInt(o[0],10)?Cy.MIN:Cy.NEGATIVE);const r={value:`${i}${s.value}`,className:e,account:s};s._account_id===t._account_id?n.unshift(r):n.push(r)}return n}_computeDeleteClass(e,t,n){if(!t||!n||!n.removable_reviewers)return"hidden";return n.removable_reviewers.find(t=>t._account_id===e._account_id)?"":"hidden"}_onDeleteVote(e){if(!this.change)return;e.preventDefault();let t=qo(e).rootTarget;for(;!t.classList.contains("deleteBtn");){if(!t.parentElement)return;t=t.parentElement}t.disabled=!0;const n=parseInt(`${t.getAttribute("data-account-id")}`,10);this._xhrPromise=this.$.restAPI.deleteVote(this.change._number,n,this.label).then(e=>{t.disabled=!1,e.ok&&this.change&&gh.navigateToChange(this.change)}).catch(e=>{console.warn(e),t.disabled=!1})}_computeValueTooltip(e,t){var n;return e&&!Sy(e)&&(null===(n=e.values)||void 0===n?void 0:n[t])?e.values[t]:""}_computeShowPlaceholder(e){if(e&&Sy(e)&&(e.rejected||e.approved))return"hidden";if(e&&e.all)for(const t of e.all||[])if(t.value&&t.value!==e.default_value)return"hidden";return""}};Ey([Bl({type:Object})],Ay.prototype,"labelInfo",void 0),Ey([Bl({type:String})],Ay.prototype,"label",void 0),Ey([Bl({type:Object})],Ay.prototype,"change",void 0),Ey([Bl({type:Object})],Ay.prototype,"account",void 0),Ey([Bl({type:Boolean})],Ay.prototype,"mutable",void 0),Ay=Ey([Ml("gr-label-info")],Ay);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const xy=ta`
  <style include="shared-styles">
    :host {
      display: table;
      width: 100%;
    }
    .status {
      color: #ffa62f;
      display: inline-block;
      text-align: center;
      vertical-align: top;
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
    }
    .approved.status {
      color: var(--positive-green-text-color);
    }
    .rejected.status {
      color: var(--negative-red-text-color);
    }
    iron-icon {
      color: inherit;
    }
    .status iron-icon {
      vertical-align: top;
    }
    gr-endpoint-decorator.submit-requirement-endpoints,
    section {
      display: table-row;
    }
    .show-hide {
      float: right;
    }
    .title {
      min-width: 10em;
      padding: var(--spacing-s) var(--spacing-m) 0
        var(--requirements-horizontal-padding);
    }
    .value {
      padding: var(--spacing-s) 0 0 0;
    }
    .title,
    .value {
      display: table-cell;
      vertical-align: top;
    }
    .hidden {
      display: none;
    }
    .showHide {
      cursor: pointer;
    }
    .showHide .title {
      padding-bottom: var(--spacing-m);
      padding-top: var(--spacing-l);
    }
    .showHide .value {
      padding-top: 0;
      vertical-align: middle;
    }
    .showHide iron-icon {
      color: var(--deemphasized-text-color);
      float: right;
    }
    .spacer {
      height: var(--spacing-m);
    }
    gr-endpoint-param {
      display: none;
    }
  </style>
  <template is="dom-repeat" items="[[_requirements]]">
    <gr-endpoint-decorator
      class="submit-requirement-endpoints"
      name$="[[_computeSubmitRequirementEndpoint(item)]]"
    >
      <gr-endpoint-param name="change" value="[[change]]"></gr-endpoint-param>
      <gr-endpoint-param name="requirement" value="[[item]]">
      </gr-endpoint-param>
      <div class="title requirement">
        <span class$="status [[item.style]]">
          <iron-icon
            class="icon"
            icon="[[_computeRequirementIcon(item.satisfied)]]"
          ></iron-icon>
        </span>
        <gr-limited-text
          class="name"
          limit="25"
          tooltip="[[item.tooltip]]"
          text="[[item.fallback_text]]"
        ></gr-limited-text>
      </div>
      <div class="value">
        <gr-endpoint-slot name="value"></gr-endpoint-slot>
      </div>
    </gr-endpoint-decorator>
  </template>
  <template is="dom-repeat" items="[[_requiredLabels]]">
    <section>
      <div class="title">
        <span class$="status [[item.style]]">
          <iron-icon class="icon" icon="[[item.icon]]"></iron-icon>
        </span>
        <gr-limited-text
          class="name"
          limit="25"
          text="[[item.label]]"
        ></gr-limited-text>
      </div>
      <div class="value">
        <gr-label-info
          change="{{change}}"
          account="[[account]]"
          mutable="[[mutable]]"
          label="[[item.label]]"
          label-info="[[item.labelInfo]]"
        ></gr-label-info>
      </div>
    </section>
  </template>
  <section class="spacer"></section>
  <section
    class$="spacer [[_computeShowOptional(_optionalLabels.*)]]"
  ></section>
  <section
    show-bottom-border$="[[_showOptionalLabels]]"
    on-click="_handleShowHide"
    class$="showHide [[_computeShowOptional(_optionalLabels.*)]]"
  >
    <div class="title">Other labels</div>
    <div class="value">
      <iron-icon
        id="showHide"
        icon="[[_computeShowHideIcon(_showOptionalLabels)]]"
      >
      </iron-icon>
    </div>
  </section>
  <template is="dom-repeat" items="[[_optionalLabels]]">
    <section class$="optional [[_computeSectionClass(_showOptionalLabels)]]">
      <div class="title">
        <span class$="status [[item.style]]">
          <template is="dom-if" if="[[item.icon]]">
            <iron-icon class="icon" icon="[[item.icon]]"></iron-icon>
          </template>
          <template is="dom-if" if="[[!item.icon]]">
            <span>[[_computeLabelValue(item.labelInfo.value)]]</span>
          </template>
        </span>
        <gr-limited-text
          class="name"
          limit="25"
          text="[[item.label]]"
        ></gr-limited-text>
      </div>
      <div class="value">
        <gr-label-info
          change="{{change}}"
          account="[[account]]"
          mutable="[[mutable]]"
          label="[[item.label]]"
          label-info="[[item.labelInfo]]"
        ></gr-label-info>
      </div>
    </section>
  </template>
  <section
    class$="spacer [[_computeShowOptional(_optionalLabels.*)]] [[_computeSectionClass(_showOptionalLabels)]]"
  ></section>
`;var Py=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Ry=class extends(oo(dr(oa))){constructor(){super(...arguments),this._requiredLabels=[],this._optionalLabels=[],this._showOptionalLabels=!0}static get template(){return xy}_computeShowWip(e){return e.work_in_progress}_computeRequirements(e){const t=[];if(e.requirements)for(const n of e.requirements){const e="OK"===n.status,i=this._computeRequirementClass(e);t.push({...n,satisfied:e,style:i})}return e.work_in_progress&&t.push({type:"wip",fallback_text:"Work-in-progress",tooltip:"Change must not be in 'Work in Progress' state."}),t}_computeRequirementClass(e){return e?"approved":""}_computeRequirementIcon(e){return e?"gr-icons:check":"gr-icons:schedule"}_computeLabels(e){const t=e.base;this._optionalLabels=[],this._requiredLabels=[];for(const e in t){if(!o(t,e))continue;const n=t[e],i=this._computeLabelIcon(n),s=this._computeLabelClass(n),r=n.optional?"_optionalLabels":"_requiredLabels";this.push(r,{label:e,icon:i,style:s,labelInfo:n})}}_computeLabelIcon(e){return e.approved?"gr-icons:check":e.rejected?"gr-icons:close":"gr-icons:schedule"}_computeLabelClass(e){return e.approved?"approved":e.rejected?"rejected":""}_computeShowOptional(e){return e.base.length?"":"hidden"}_computeLabelValue(e){return`${e>0?"+":""}${e}`}_computeShowHideIcon(e){return e?"gr-icons:expand-less":"gr-icons:expand-more"}_computeSectionClass(e){return e?"":"hidden"}_handleShowHide(){this._showOptionalLabels=!this._showOptionalLabels}_computeSubmitRequirementEndpoint(e){return`submit-requirement-item-${e.type}`}};Py([Bl({type:Object})],Ry.prototype,"change",void 0),Py([Bl({type:Object})],Ry.prototype,"account",void 0),Py([Bl({type:Boolean})],Ry.prototype,"mutable",void 0),Py([Bl({type:Array,computed:"_computeRequirements(change)"})],Ry.prototype,"_requirements",void 0),Py([Bl({type:Array})],Ry.prototype,"_requiredLabels",void 0),Py([Bl({type:Array})],Ry.prototype,"_optionalLabels",void 0),Py([Bl({type:Boolean,computed:"_computeShowWip(change)"})],Ry.prototype,"_showWip",void 0),Py([Bl({type:Boolean})],Ry.prototype,"_showOptionalLabels",void 0),Py([jl("change.labels.*")],Ry.prototype,"_computeLabels",null),Ry=Py([Ml("gr-change-requirements")],Ry);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ty=ta`
  <style include="shared-styles">
    .container {
      align-items: center;
      display: flex;
    }
  </style>
  <div class="container">
    <template is="dom-if" if="[[_showWebLink]]">
      <a target="_blank" rel="noopener" href$="[[_webLink]]"
        >[[_computeShortHash(change, commitInfo, serverConfig)]]</a
      >
    </template>
    <template is="dom-if" if="[[!_showWebLink]]">
      [[_computeShortHash(change, commitInfo, serverConfig)]]
    </template>
    <gr-copy-clipboard
      has-tooltip=""
      button-title="Copy full SHA to clipboard"
      hide-input=""
      text="[[commitInfo.commit]]"
    >
    </gr-copy-clipboard>
  </div>
`;var Iy=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let ky=class extends(oo(dr(oa))){static get template(){return Ty}get _showWebLink(){if(!this.change||!this.commitInfo||!this.serverConfig)return!1;const e=this._getWeblink(this.change,this.commitInfo,this.serverConfig);return!!e&&!!e.url}get _webLink(){if(!this.change||!this.commitInfo||!this.serverConfig)return"";const{url:e}=this._getWeblink(this.change,this.commitInfo,this.serverConfig)||{};return e}_getWeblink(e,t,n){return gh.getPatchSetWeblink(e.project,t.commit,{weblinks:t.web_links,config:n})}_computeShortHash(e,t,n){if(!e||!t||!n)return"";const{name:i}=this._getWeblink(e,t,n)||{};return i}};Iy([Bl({type:Object})],ky.prototype,"change",void 0),Iy([Bl({type:Object})],ky.prototype,"commitInfo",void 0),Iy([Bl({type:Object})],ky.prototype,"serverConfig",void 0),Iy([Hl("change","commitInfo","serverConfig")],ky.prototype,"_showWebLink",null),Iy([Hl("change","commitInfo","serverConfig")],ky.prototype,"_webLink",null),ky=Iy([Ml("gr-commit-info")],ky);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Oy=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) {
      opacity: 0.8;
      pointer-events: none;
    }
    .container {
      display: block;
    }
    gr-button {
      --gr-button: {
        padding: 0px 0px;
      }
    }
    gr-account-chip {
      display: inline-block;
    }
  </style>
  <div class="container">
    <div>
      <template is="dom-repeat" items="[[_displayedReviewers]]" as="reviewer">
        <gr-account-chip
          class="reviewer"
          account="[[reviewer]]"
          change="[[change]]"
          on-remove="_handleRemove"
          highlight-attention
          voteable-text="[[_computeVoteableText(reviewer, change)]]"
          removable="[[_computeCanRemoveReviewer(reviewer, mutable)]]"
        >
        </gr-account-chip>
      </template>
    </div>
    <gr-button
      class="hiddenReviewers"
      link=""
      hidden$="[[!_hiddenReviewerCount]]"
      on-click="_handleViewAll"
      >and [[_hiddenReviewerCount]] more</gr-button
    >
    <div class="controlsContainer" hidden$="[[!mutable]]">
      <gr-button
        link=""
        id="addReviewer"
        class="addReviewer"
        on-click="_handleAddTap"
        >[[_addLabel]]</gr-button
      >
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Ny=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Ly=class extends(oo(dr(oa))){constructor(){super(...arguments),this.disabled=!1,this.mutable=!1,this.reviewersOnly=!1,this.ccsOnly=!1,this._displayedReviewers=[],this._reviewers=[],this._showInput=!1}static get template(){return Oy}get _addLabel(){return this.ccsOnly?"Add CC":"Add reviewer"}get _hiddenReviewerCount(){if(void 0!==this._reviewers&&void 0!==this._displayedReviewers)return this._reviewers.length-this._displayedReviewers.length}_permittedLabelsToNumericScores(e){return e?Object.keys(e).map(t=>({label:t,scores:e[t].map(e=>parseInt(e,10))})):[]}_getMaxPermittedScores(e){return this._permittedLabelsToNumericScores(e.permitted_labels).map(({label:e,scores:t})=>({[e]:t.reduce((e,t)=>Math.max(e,t))})).reduce((e,t)=>Object.assign(e,t),{})}_getReviewerPermittedScore(e,t,n){if(!t.labels)return NaN;const i=t.labels[n];if(!i.all)return NaN;const s=i.all.filter(t=>e._account_id===t._account_id).pop();return s?o(s,"permitted_voting_range")?s.permitted_voting_range?s.permitted_voting_range.max:NaN:o(s,"value")?0:NaN:NaN}_computeVoteableText(e,t){if(!t||!t.labels)return"";const n=[],i=this._getMaxPermittedScores(t);for(const o of Object.keys(t.labels)){const s=this._getReviewerPermittedScore(e,t,o);isNaN(s)||s<0||(s>0&&s===i[o]?n.push(`${o}: +${s}`):n.push(`${o}`))}return n.join(", ")}_reviewersChanged(e,t,n){if(void 0===e||void 0===t||void 0===n||void 0===this.change)return;let i=[];const o=e.base;for(const e in o)this.reviewersOnly&&"REVIEWER"!==e||this.ccsOnly&&"CC"!==e||"REVIEWER"!==e&&"CC"!==e||(i=i.concat(o[e]));this._reviewers=i.filter(e=>e._account_id!==t._account_id).sort((e,t)=>{const i=gc(n,e,this.change)?1:0,o=gc(n,t,this.change)?1:0,s=pc(e)?-2:0;return o-i+(pc(t)?-2:0)-s}),this._reviewers.length>8?this._displayedReviewers=this._reviewers.slice(0,6):this._displayedReviewers=this._reviewers}_computeCanRemoveReviewer(e,t){if(!t||void 0===this.change||void 0===this.change.removable_reviewers)return!1;let n;for(let t=0;t<this.change.removable_reviewers.length;t++)if(n=this.change.removable_reviewers[t],n._account_id===e._account_id||!e._account_id&&n.email===e.email)return!0;return!1}_handleRemove(e){e.preventDefault();const t=qo(e).rootTarget;if(!t.account||!this.change)return;const n=t.account._account_id;this.disabled=!0,n&&(this._xhrPromise=this._removeReviewer(n).then(e=>{if(this.disabled=!1,!e||!e.ok)return e;if(!this.change||!this.change.reviewers)return;const t=this.change.reviewers;for(const e of["REVIEWER","CC"]){t[e]=t[e]||[];for(let i=0;i<t[e].length;i++)if(t[e][i]._account_id===n){this.splice("change.reviewers."+e,i,1);break}}}).catch(e=>{throw this.disabled=!1,e}))}_handleAddTap(e){e.preventDefault();const t={reviewersOnly:!1,ccsOnly:!1};this.reviewersOnly&&(t.reviewersOnly=!0),this.ccsOnly&&(t.ccsOnly=!0),this.dispatchEvent(new CustomEvent("show-reply-dialog",{detail:{value:t},composed:!0,bubbles:!0}))}_handleViewAll(){this._displayedReviewers=this._reviewers}_removeReviewer(e){return this.change?this.$.restAPI.removeChangeReviewer(this.change._number,e):Promise.resolve(void 0)}};Ny([Bl({type:Object})],Ly.prototype,"change",void 0),Ny([Bl({type:Object})],Ly.prototype,"serverConfig",void 0),Ny([Bl({type:Boolean,reflectToAttribute:!0})],Ly.prototype,"disabled",void 0),Ny([Bl({type:Boolean})],Ly.prototype,"mutable",void 0),Ny([Bl({type:Boolean})],Ly.prototype,"reviewersOnly",void 0),Ny([Bl({type:Boolean})],Ly.prototype,"ccsOnly",void 0),Ny([Bl({type:Array})],Ly.prototype,"_displayedReviewers",void 0),Ny([Bl({type:Array})],Ly.prototype,"_reviewers",void 0),Ny([Bl({type:Boolean})],Ly.prototype,"_showInput",void 0),Ny([Bl({type:Object})],Ly.prototype,"_xhrPromise",void 0),Ny([Hl("ccsOnly")],Ly.prototype,"_addLabel",null),Ny([Hl("_reviewers","_displayedReviewers")],Ly.prototype,"_hiddenReviewerCount",null),Ny([jl("change.reviewers.*","change.owner","serverConfig")],Ly.prototype,"_reviewersChanged",null),Ly=Ny([Ml("gr-reviewer-list")],Ly);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Dy=ta`
  <style include="shared-styles">
    gr-autocomplete {
      display: inline-block;
      flex: 1;
      overflow: hidden;
    }
  </style>
  <gr-autocomplete
    id="input"
    borderless="[[borderless]]"
    placeholder="[[placeholder]]"
    threshold="[[suggestFrom]]"
    query="[[querySuggestions]]"
    allow-non-suggested-values="[[allowAnyInput]]"
    on-commit="_handleInputCommit"
    clear-on-commit=""
    warn-uncommitted=""
    text="{{_inputText}}"
    vertical-offset="24"
  >
  </gr-autocomplete>
`;var $y=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let My=class extends(oo(dr(oa))){constructor(){super(...arguments),this.suggestFrom=0,this.querySuggestions=()=>Promise.resolve([])}static get template(){return Dy}get focusStart(){return this.$.input.focusStart}focus(){this.$.input.focus()}clear(){this.$.input.clear()}setText(e){this.$.input.setText(e)}getText(){return this.$.input.text}_handleInputCommit(e){this.dispatchEvent(new CustomEvent("add",{detail:{value:e.detail.value},composed:!0,bubbles:!0})),this.$.input.focus()}_inputTextChanged(e){e.length&&this.allowAnyInput&&this.dispatchEvent(new CustomEvent("account-text-changed",{bubbles:!0,composed:!0}))}};$y([Bl({type:Boolean})],My.prototype,"allowAnyInput",void 0),$y([Bl({type:Boolean})],My.prototype,"borderless",void 0),$y([Bl({type:String})],My.prototype,"placeholder",void 0),$y([Bl({type:Number})],My.prototype,"suggestFrom",void 0),$y([Bl({type:Object,notify:!0})],My.prototype,"querySuggestions",void 0),$y([Bl({type:String,observer:"_inputTextChanged"})],My.prototype,"_inputText",void 0),My=$y([Ml("gr-account-entry")],My);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Fy=ta`
  <style include="shared-styles">
    gr-account-chip {
      display: inline-block;
      margin: var(--spacing-xs) var(--spacing-xs) var(--spacing-xs) 0;
    }
    gr-account-entry {
      display: flex;
      flex: 1;
      min-width: 10em;
      margin: var(--spacing-xs) var(--spacing-xs) var(--spacing-xs) 0;
    }
    .group {
      --account-label-suffix: ' (group)';
    }
    .pending-add {
      font-style: italic;
    }
    .list {
      align-items: center;
      display: flex;
      flex-wrap: wrap;
      @apply --account-list-style;
    }
  </style>
  <!--
      NOTE(Issue 6419): Nest the inner dom-repeat template in a div rather than
      as a direct child of the dom-module's template.
    -->
  <div class="list">
    <template id="chips" is="dom-repeat" items="[[accounts]]" as="account">
      <gr-account-chip
        account="[[account]]"
        class$="[[_computeChipClass(account)]]"
        data-account-id$="[[account._account_id]]"
        removable="[[_computeRemovable(account, readonly)]]"
        on-keydown="_handleChipKeydown"
        tabindex="-1"
      >
      </gr-account-chip>
    </template>
  </div>
  <gr-account-entry
    borderless=""
    hidden$="[[_computeEntryHidden(maxCount, accounts.*, readonly)]]"
    id="entry"
    placeholder="[[placeholder]]"
    on-add="_handleAdd"
    on-input-keydown="_handleInputKeydown"
    allow-any-input="[[allowAnyInput]]"
    query-suggestions="[[_querySuggestions]]"
  >
  </gr-account-entry>
  <slot></slot>
`;var By=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let jy=class extends(oo(dr(oa))){constructor(){super(),this.accounts=[],this.placeholder="",this.disabled=!1,this.pendingConfirmation=null,this.readonly=!1,this.allowAnyInput=!1,this.maxCount=0,this.skipSuggestOnEmpty=!1,this.reporting=n.reportingService,this._querySuggestions=e=>this._getSuggestions(e)}static get template(){return Fy}created(){super.created(),this.addEventListener("remove",e=>this._handleRemove(e))}get accountChips(){var e;return Array.from((null===(e=this.root)||void 0===e?void 0:e.querySelectorAll("gr-account-chip"))||[])}get focusStart(){return this.$.entry.focusStart}_getSuggestions(e){if(this.skipSuggestOnEmpty&&!e)return Promise.resolve([]);const t=this.suggestionsProvider;return t?t.getSuggestions(e).then(e=>e?(this.filter&&(e=e.filter(this.filter)),e.map(e=>t.makeSuggestionItem(e))):[]):Promise.resolve([])}_handleAdd(e){this.addAccountItem(e.detail.value)}addAccountItem(e){let t="unknown";if(e.account){const n={...e.account,_pendingAdd:!0};this.push("accounts",n),t="account"}else if(function(e){return!!e.group}(e)){if(e.confirm)return void(this.pendingConfirmation=e);const n={...e.group,_pendingAdd:!0,_group:!0};this.push("accounts",n),t="group"}else if(this.allowAnyInput){if(!e.includes("@"))return this.$.entry.setText(e),this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Please input a valid email."},bubbles:!0,composed:!0})),!1;{const n={email:e,_pendingAdd:!0};this.push("accounts",n),t="email"}}return this.reporting.reportInteraction(`Add to ${this.id}`,{itemTypeAdded:t}),this.pendingConfirmation=null,!0}confirmGroup(e){this.push("accounts",{...e,confirmed:!0,_pendingAdd:!0,_group:!0}),this.pendingConfirmation=null}_computeChipClass(e){const t=[];return e._group&&t.push("group"),e._pendingAdd&&t.push("pendingAdd"),t.join(" ")}_accountMatches(e,t){if(e&&t){if(e._account_id)return e._account_id===t._account_id;if(e.email)return e.email===t.email}return e===t}_computeRemovable(e,t){if(t)return!1;if(this.removableValues){for(let t=0;t<this.removableValues.length;t++)if(this._accountMatches(this.removableValues[t],e))return!0;return!!e._pendingAdd}return!0}_handleRemove(e){const t=e.detail.account;this.removeAccount(t),this.$.entry.focus()}removeAccount(e){if(e&&this._computeRemovable(e,this.readonly)){for(let t=0;t<this.accounts.length;t++){let n;const i=this.accounts[t];if(n=e._group?e.id===i.id:this._accountMatches(e,i),n)return this.splice("accounts",t,1),void this.reporting.reportInteraction(`Remove from ${this.id}`)}console.warn("received remove event for missing account",e)}}_getNativeInput(e){return e.$.nativeInput||e.inputElement}_handleInputKeydown(e){const t=this._getNativeInput(e.detail.input);if(t.selectionStart===t.selectionEnd&&0===t.selectionStart)switch(e.detail.keyCode){case 8:this.removeAccount(this.accounts[this.accounts.length-1]);break;case 37:this.accountChips[this.accountChips.length-1]&&this.accountChips[this.accountChips.length-1].focus()}}_handleChipKeydown(e){const t=e.target,n=this.accountChips,i=n.indexOf(t);switch(e.keyCode){case 8:case 13:case 32:case 46:this.removeAccount(t.account),n.splice(i,1),i<n.length?n[i].focus():i>0?n[i-1].focus():this.$.entry.focus();break;case 37:i>0&&(t.blur(),n[i-1].focus());break;case 39:t.blur(),i<n.length-1?n[i+1].focus():this.$.entry.focus()}}submitEntryText(){const e=this.$.entry.getText();if(!e.length)return!0;const t=this.addAccountItem(e);return t&&this.$.entry.clear(),t}additions(){return this.accounts.filter(e=>e._pendingAdd).map(e=>{if(function(e){const t=e;return!!t._group||!!t.id}(e))return{group:e};if(function(e){const t=e;return!!t._account||!!t._account_id||!!t.email}(e))return{account:e};throw new Error("AccountInput must be either Account or Group.")})}_computeEntryHidden(e,t,n){return e&&e<=t.base.length||n}};By([Bl({type:Array,notify:!0})],jy.prototype,"accounts",void 0),By([Bl({type:Object})],jy.prototype,"change",void 0),By([Bl({type:Object})],jy.prototype,"filter",void 0),By([Bl({type:String})],jy.prototype,"placeholder",void 0),By([Bl({type:Boolean})],jy.prototype,"disabled",void 0),By([Bl({type:Object})],jy.prototype,"suggestionsProvider",void 0),By([Bl({type:Object,notify:!0})],jy.prototype,"pendingConfirmation",void 0),By([Bl({type:Boolean})],jy.prototype,"readonly",void 0),By([Bl({type:Boolean})],jy.prototype,"allowAnyInput",void 0),By([Bl({type:Array})],jy.prototype,"removableValues",void 0),By([Bl({type:Number})],jy.prototype,"maxCount",void 0),By([Bl({type:Object})],jy.prototype,"_querySuggestions",void 0),By([Bl({type:Boolean})],jy.prototype,"skipSuggestOnEmpty",void 0),jy=By([Ml("gr-account-list")],jy);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Hy=ta`
  <style include="gr-change-metadata-shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="shared-styles">
    :host {
      display: table;
    }
    gr-change-requirements {
      --requirements-horizontal-padding: var(--metadata-horizontal-padding);
    }
    gr-editable-label {
      max-width: 9em;
    }
    .webLink {
      display: block;
    }
    /* CSS Mixins should be applied last. */
    section.assignee {
      @apply --change-metadata-assignee;
    }
    section.strategy {
      @apply --change-metadata-strategy;
    }
    section.topic {
      @apply --change-metadata-topic;
    }
    gr-account-chip[disabled],
    gr-linked-chip[disabled] {
      opacity: 0;
      pointer-events: none;
    }
    .hashtagChip {
      margin-bottom: var(--spacing-m);
    }
    #externalStyle {
      display: block;
    }
    .parentList.merge {
      list-style-type: decimal;
      padding-left: var(--spacing-l);
    }
    .parentList gr-commit-info {
      display: inline-block;
    }
    .hideDisplay,
    #parentNotCurrentMessage {
      display: none;
    }
    .icon {
      margin: -3px 0;
    }
    .icon.help,
    .icon.notTrusted {
      color: #ffa62f;
    }
    .icon.invalid {
      color: var(--negative-red-text-color);
    }
    .icon.trusted {
      color: var(--positive-green-text-color);
    }
    .parentList.notCurrent.nonMerge #parentNotCurrentMessage {
      --arrow-color: #ffa62f;
      display: inline-block;
    }
    .separatedSection {
      margin-top: var(--spacing-l);
      padding: var(--spacing-m) 0;
    }
    .hashtag gr-linked-chip,
    .topic gr-linked-chip {
      --linked-chip-text-color: var(--link-color);
    }
    gr-reviewer-list {
      --account-max-length: 120px;
      max-width: 285px;
    }
  </style>
  <gr-external-style id="externalStyle" name="change-metadata">
    <section>
      <span class="title">Updated</span>
      <span class="value">
        <gr-date-formatter
          has-tooltip=""
          date-str="[[change.updated]]"
        ></gr-date-formatter>
      </span>
    </section>
    <section>
      <span class="title">Owner</span>
      <span class="value">
        <gr-account-chip
          account="[[change.owner]]"
          change="[[change]]"
          highlight-attention
        ></gr-account-chip>
        <template is="dom-if" if="[[_pushCertificateValidation]]">
          <gr-tooltip-content
            has-tooltip=""
            title$="[[_pushCertificateValidation.message]]"
          >
            <iron-icon
              class$="icon [[_pushCertificateValidation.class]]"
              icon="[[_pushCertificateValidation.icon]]"
            >
            </iron-icon>
          </gr-tooltip-content>
        </template>
      </span>
    </section>
    <section class$="[[_computeShowRoleClass(change, _CHANGE_ROLE.UPLOADER)]]">
      <span class="title">Uploader</span>
      <span class="value">
        <gr-account-chip
          account="[[_getNonOwnerRole(change, _CHANGE_ROLE.UPLOADER)]]"
          change="[[change]]"
          highlight-attention
        ></gr-account-chip>
      </span>
    </section>
    <section class$="[[_computeShowRoleClass(change, _CHANGE_ROLE.AUTHOR)]]">
      <span class="title">Author</span>
      <span class="value">
        <gr-account-chip
          account="[[_getNonOwnerRole(change, _CHANGE_ROLE.AUTHOR)]]"
          change="[[change]]"
        ></gr-account-chip>
      </span>
    </section>
    <section class$="[[_computeShowRoleClass(change, _CHANGE_ROLE.COMMITTER)]]">
      <span class="title">Committer</span>
      <span class="value">
        <gr-account-chip
          account="[[_getNonOwnerRole(change, _CHANGE_ROLE.COMMITTER)]]"
          change="[[change]]"
        ></gr-account-chip>
      </span>
    </section>
    <template is="dom-if" if="[[_isAssigneeEnabled(serverConfig)]]">
      <section class="assignee">
        <span class="title">Assignee</span>
        <span class="value">
          <gr-account-list
            id="assigneeValue"
            placeholder="Set assignee..."
            max-count="1"
            skip-suggest-on-empty=""
            accounts="{{_assignee}}"
            readonly="[[_computeAssigneeReadOnly(_mutable, change)]]"
            suggestions-provider="[[_getReviewerSuggestionsProvider(change)]]"
          >
          </gr-account-list>
        </span>
      </section>
    </template>
    <section>
      <span class="title">Reviewers</span>
      <span class="value">
        <gr-reviewer-list
          change="{{change}}"
          mutable="[[_mutable]]"
          reviewers-only=""
          server-config="[[serverConfig]]"
        ></gr-reviewer-list>
      </span>
    </section>
    <section>
      <span class="title">CC</span>
      <span class="value">
        <gr-reviewer-list
          change="{{change}}"
          mutable="[[_mutable]]"
          ccs-only=""
          server-config="[[serverConfig]]"
        ></gr-reviewer-list>
      </span>
    </section>
    <template
      is="dom-if"
      if="[[_computeShowRepoBranchTogether(change.project, change.branch)]]"
    >
      <section>
        <span class="title">Repo | Branch</span>
        <span class="value">
          <a href$="[[_computeProjectUrl(change.project)]]"
            >[[change.project]]</a
          >
          |
          <a href$="[[_computeBranchUrl(change.project, change.branch)]]"
            >[[change.branch]]</a
          >
        </span>
      </section>
    </template>
    <template
      is="dom-if"
      if="[[!_computeShowRepoBranchTogether(change.project, change.branch)]]"
    >
      <section>
        <span class="title">Repo</span>
        <span class="value">
          <a href$="[[_computeProjectUrl(change.project)]]">
            <gr-limited-text
              limit="40"
              text="[[change.project]]"
            ></gr-limited-text>
          </a>
        </span>
      </section>
      <section>
        <span class="title">Branch</span>
        <span class="value">
          <a href$="[[_computeBranchUrl(change.project, change.branch)]]">
            <gr-limited-text
              limit="40"
              text="[[change.branch]]"
            ></gr-limited-text>
          </a>
        </span>
      </section>
    </template>
    <section>
      <span class="title">[[_computeParentsLabel(_currentParents)]]</span>
      <span class="value">
        <ol
          class$="[[_computeParentListClass(_currentParents, parentIsCurrent)]]"
        >
          <template is="dom-repeat" items="[[_currentParents]]" as="parent">
            <li>
              <gr-commit-info
                change="[[change]]"
                commit-info="[[parent]]"
                server-config="[[serverConfig]]"
              ></gr-commit-info>
              <gr-tooltip-content
                id="parentNotCurrentMessage"
                has-tooltip=""
                show-icon=""
                title$="[[_notCurrentMessage]]"
              ></gr-tooltip-content>
            </li>
          </template>
        </ol>
      </span>
    </section>
    <section class="topic">
      <span class="title">Topic</span>
      <span class="value">
        <template is="dom-if" if="[[_showTopicChip(change.*, _settingTopic)]]">
          <gr-linked-chip
            text="[[change.topic]]"
            limit="40"
            href="[[_computeTopicUrl(change.topic)]]"
            removable="[[!_topicReadOnly]]"
            on-remove="_handleTopicRemoved"
          ></gr-linked-chip>
        </template>
        <template is="dom-if" if="[[_showAddTopic(change.*, _settingTopic)]]">
          <gr-editable-label
            class="topicEditableLabel"
            label-text="Add a topic"
            value="[[change.topic]]"
            max-length="1024"
            placeholder="[[_computeTopicPlaceholder(_topicReadOnly)]]"
            read-only="[[_topicReadOnly]]"
            on-changed="_handleTopicChanged"
          ></gr-editable-label>
        </template>
      </span>
    </section>
    <template is="dom-if" if="[[_showCherryPickOf(change.*)]]">
      <section>
        <span class="title">Cherry pick of</span>
        <span class="value">
          <a
            href$="[[_computeCherryPickOfUrl(change.cherry_pick_of_change, change.cherry_pick_of_patch_set, change.project)]]"
          >
            <gr-limited-text
              text="[[change.cherry_pick_of_change]],[[change.cherry_pick_of_patch_set]]"
              limit="40"
            >
            </gr-limited-text>
          </a>
        </span>
      </section>
    </template>
    <section
      class="strategy"
      hidden$="[[_computeHideStrategy(change)]]"
      hidden=""
    >
      <span class="title">Strategy</span>
      <span class="value">[[_computeStrategy(change)]]</span>
    </section>
    <section class="hashtag">
      <span class="title">Hashtags</span>
      <span class="value">
        <template is="dom-repeat" items="[[change.hashtags]]">
          <gr-linked-chip
            class="hashtagChip"
            text="[[item]]"
            href="[[_computeHashtagUrl(item)]]"
            removable="[[!_hashtagReadOnly]]"
            on-remove="_handleHashtagRemoved"
            limit="40"
          >
          </gr-linked-chip>
        </template>
        <template is="dom-if" if="[[!_hashtagReadOnly]]">
          <gr-editable-label
            uppercase=""
            label-text="Add a hashtag"
            value="{{_newHashtag}}"
            placeholder="[[_computeHashtagPlaceholder(_hashtagReadOnly)]]"
            read-only="[[_hashtagReadOnly]]"
            on-changed="_handleHashtagChanged"
          ></gr-editable-label>
        </template>
      </span>
    </section>
    <div class="separatedSection">
      <gr-change-requirements
        change="{{change}}"
        account="[[account]]"
        mutable="[[_mutable]]"
      ></gr-change-requirements>
    </div>
    <section
      id="webLinks"
      hidden$="[[!_computeWebLinks(commitInfo, serverConfig)]]"
    >
      <span class="title">Links</span>
      <span class="value">
        <template
          is="dom-repeat"
          items="[[_computeWebLinks(commitInfo, serverConfig)]]"
          as="link"
        >
          <a href="[[link.url]]" class="webLink" rel="noopener" target="_blank">
            [[link.name]]
          </a>
        </template>
      </span>
    </section>
    <gr-endpoint-decorator name="change-metadata-item">
      <gr-endpoint-param name="labels" value="[[labels]]"></gr-endpoint-param>
      <gr-endpoint-param name="change" value="[[change]]"></gr-endpoint-param>
      <gr-endpoint-param
        name="revision"
        value="[[revision]]"
      ></gr-endpoint-param>
    </gr-endpoint-decorator>
  </gr-external-style>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,Uy={FAST_FORWARD_ONLY:"Fast Forward Only",MERGE_IF_NECESSARY:"Merge if Necessary",REBASE_IF_NECESSARY:"Rebase if Necessary",MERGE_ALWAYS:"Always Merge",REBASE_ALWAYS:"Rebase Always",CHERRY_PICK:"Cherry Pick"},Gy="BAD",Vy="OK",zy="TRUSTED";class Wy extends(oo(dr(oa))){static get template(){return Hy}static get is(){return"gr-change-metadata"}static get properties(){return{change:Object,labels:{type:Object,notify:!0},account:Object,revision:Object,commitInfo:Object,_mutable:{type:Boolean,computed:"_computeIsMutable(account)"},serverConfig:Object,parentIsCurrent:Boolean,_notCurrentMessage:{type:String,value:"Not current - rebase possible",readOnly:!0},_topicReadOnly:{type:Boolean,computed:"_computeTopicReadOnly(_mutable, change)"},_hashtagReadOnly:{type:Boolean,computed:"_computeHashtagReadOnly(_mutable, change)"},_pushCertificateValidation:{type:Object,computed:"_computePushCertificateValidation(serverConfig, change)"},_showRequirements:{type:Boolean,computed:"_computeShowRequirements(change)"},_assignee:Array,_isWip:{type:Boolean,computed:"_computeIsWip(change)"},_newHashtag:String,_settingTopic:{type:Boolean,value:!1},_currentParents:{type:Array,computed:"_computeParents(change, revision)"},_CHANGE_ROLE:{type:Object,readOnly:!0,value:{OWNER:"owner",UPLOADER:"uploader",AUTHOR:"author",COMMITTER:"committer"}}}}static get observers(){return["_changeChanged(change)","_labelsChanged(change.labels)","_assigneeChanged(_assignee.*)"]}_labelsChanged(e){this.labels={...e}||null}_changeChanged(e){this._assignee=e.assignee?[e.assignee]:[],this._settingTopic=!1}_assigneeChanged(e){if(!this.change||!this._isAssigneeEnabled(this.serverConfig))return;const t=e.base;if(t.length){const e=t[0];if(this.change.assignee&&e._account_id===this.change.assignee._account_id)return;this.set(["change","assignee"],e),this.$.restAPI.setAssignee(this.change._number,e._account_id)}else{if(!this.change.assignee)return;this.set(["change","assignee"],void 0),this.$.restAPI.deleteAssignee(this.change._number)}}_computeHideStrategy(e){return!Wp(e)}_computeWebLinks(e,t){if(!e)return null;const n=gh.getChangeWeblinks(this.change?this.change.repo:"",e.commit,{weblinks:e.web_links,config:t});return n.length?n:null}_isAssigneeEnabled(e){return e&&e.change&&!!e.change.enable_assignee}_computeStrategy(e){return Uy[e.submit_type]}_computeLabelNames(e){return Object.keys(e).sort()}_handleTopicChanged(e,t){const n=this.change.topic;t.length||(t=null),this._settingTopic=!0;const i=this.change._number;this.$.restAPI.setChangeTopic(i,t).then(e=>{this.change._number===i&&(this._settingTopic=!1,this.set(["change","topic"],e),e!==n&&this.dispatchEvent(new CustomEvent("topic-changed",{bubbles:!0,composed:!0})))})}_showAddTopic(e,t){return!(!!e&&!!e.base&&!!e.base.topic)&&!t}_showTopicChip(e,t){return!!e&&!!e.base&&!!e.base.topic&&!t}_showCherryPickOf(e){return!!(e&&e.base&&e.base.cherry_pick_of_change&&e.base.cherry_pick_of_patch_set)}_handleHashtagChanged(e){const t=this.change.hashtag;if(!this._newHashtag.length)return;const n=this._newHashtag;this._newHashtag="",this.$.restAPI.setChangeHashtag(this.change._number,{add:[n]}).then(e=>{this.set(["change","hashtags"],e),e!==t&&this.dispatchEvent(new CustomEvent("hashtag-changed",{bubbles:!0,composed:!0}))})}_computeTopicReadOnly(e,t){return!(e&&t&&t.actions&&t.actions.topic&&t.actions.topic.enabled)}_computeHashtagReadOnly(e,t){return!(e&&t&&t.actions&&t.actions.hashtags&&t.actions.hashtags.enabled)}_computeAssigneeReadOnly(e,t){return!(e&&t&&t.actions&&t.actions.assignee&&t.actions.assignee.enabled)}_computeTopicPlaceholder(e){return e?"No topic":"ADD TOPIC"}_computeHashtagPlaceholder(e){return e?"":"Add Hashtag"}_computeShowRequirements(e){if(e.status!==Ia.NEW)return!1;const t=!!e.requirements&&Object.keys(e.requirements).length>0,n=!!e.labels&&Object.keys(e.labels).length>0;return t||n||!!e.work_in_progress}_computePushCertificateValidation(e,t){if(!(t&&e&&e.receive&&e.receive.enable_signed_push))return null;const n=t.revisions[t.current_revision];if(!n.push_certificate||!n.push_certificate.key)return{class:"help",icon:"gr-icons:help",message:"This patch set was created without a push certificate"};const i=n.push_certificate.key;switch(i.status){case Gy:return{class:"invalid",icon:"gr-icons:close",message:this._problems("Push certificate is invalid",i)};case Vy:return{class:"notTrusted",icon:"gr-icons:info",message:this._problems("Push certificate is valid, but key is not trusted",i)};case zy:return{class:"trusted",icon:"gr-icons:check",message:this._problems("Push certificate is valid and key is trusted",i)};default:throw new Error(`unknown certificate status: ${i.status}`)}}_problems(e,t){return t&&t.problems&&0!==t.problems.length?[e+":"].concat(t.problems).join("\n"):e}_computeShowRepoBranchTogether(e,t){return!!e&&!!t&&e.length+t.length<40}_computeProjectUrl(e){return gh.getUrlForProjectChanges(e)}_computeBranchUrl(e,t){return this.change&&this.change.status?gh.getUrlForBranch(t,e,this.change.status==Ia.NEW?"open":this.change.status.toLowerCase()):""}_computeCherryPickOfUrl(e,t,n){return gh.getUrlForChangeById(e,n,t)}_computeTopicUrl(e){return gh.getUrlForTopic(e)}_computeHashtagUrl(e){return gh.getUrlForHashtag(e)}_handleTopicRemoved(e){const t=qo(e).rootTarget;t.disabled=!0,this.$.restAPI.setChangeTopic(this.change._number,null).then(()=>{t.disabled=!1,this.set(["change","topic"],""),this.dispatchEvent(new CustomEvent("topic-changed",{bubbles:!0,composed:!0}))}).catch(e=>{t.disabled=!1})}_handleHashtagRemoved(e){e.preventDefault();const t=qo(e).rootTarget;t.disabled=!0,this.$.restAPI.setChangeHashtag(this.change._number,{remove:[t.text]}).then(e=>{t.disabled=!1,this.set(["change","hashtags"],e)}).catch(e=>{t.disabled=!1})}_computeIsWip(e){return!!e.work_in_progress}_computeShowRoleClass(e,t){return this._getNonOwnerRole(e,t)?"":"hideDisplay"}_getNonOwnerRole(e,t){if(!e||!e.current_revision||!e.revisions[e.current_revision])return null;const n=e.revisions[e.current_revision];return n?t===this._CHANGE_ROLE.UPLOADER&&n.uploader&&e.owner._account_id!==n.uploader._account_id?n.uploader:t===this._CHANGE_ROLE.AUTHOR&&n.commit&&n.commit.author&&e.owner.email!==n.commit.author.email?n.commit.author:t===this._CHANGE_ROLE.COMMITTER&&n.commit&&n.commit.committer&&e.owner.email!==n.commit.committer.email?n.commit.committer:null:null}_computeParents(e,t){if(!t||!t.commit){if(!e||!e.current_revision)return[];if(!(t=e.revisions[e.current_revision])||!t.commit)return[]}return t.commit.parents}_computeParentsLabel(e){return e&&e.length>1?"Parents":"Parent"}_computeParentListClass(e,t){return void 0===e||void 0===t?"":["parentList",e&&e.length>1?"merge":"nonMerge",t?"current":"notCurrent"].join(" ")}_computeIsMutable(e){return!!Object.keys(e).length}editTopic(){this._topicReadOnly||this.change.topic||this.shadowRoot.querySelector(".topicEditableLabel").open()}_getReviewerSuggestionsProvider(e){const t=ad.create(this.$.restAPI,e._number,rd.ANY);return t.init(),t}}customElements.define(Wy.is,Wy);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const qy=ta`
  <style include="shared-styles">
    :host {
      display: block;
      padding: var(--spacing-m) 0;
    }
    section {
      display: flex;
      padding: var(--spacing-m) var(--spacing-xl);
    }
    .flexContainer {
      display: flex;
      justify-content: space-between;
      padding-top: var(--spacing-m);
    }
    .footer {
      justify-content: flex-end;
    }
    .closeButtonContainer {
      align-items: flex-end;
      display: flex;
      flex: 0;
      justify-content: flex-end;
    }
    .patchFiles,
    .archivesContainer {
      padding-bottom: var(--spacing-m);
    }
    .patchFiles {
      margin-right: var(--spacing-xxl);
    }
    .patchFiles a,
    .archives a {
      display: inline-block;
      margin-right: var(--spacing-l);
    }
    .patchFiles a:last-of-type,
    .archives a:last-of-type {
      margin-right: 0;
    }
    .hidden {
      display: none;
    }
  </style>
  <section>
    <h3 class="heading-3">
      Patch set [[patchNum]] of [[_computePatchSetQuantity(change.revisions)]]
    </h3>
  </section>
  <section class$="[[_computeShowDownloadCommands(_schemes)]]">
    <gr-download-commands
      id="downloadCommands"
      commands="[[_computeDownloadCommands(change, patchNum, _selectedScheme)]]"
      schemes="[[_schemes]]"
      selected-scheme="{{_selectedScheme}}"
    ></gr-download-commands>
  </section>
  <section class="flexContainer">
    <div
      class="patchFiles"
      hidden="[[_computeHidePatchFile(change, patchNum)]]"
    >
      <label>Patch file</label>
      <div>
        <a
          id="download"
          href$="[[_computeDownloadLink(change, patchNum)]]"
          download=""
        >
          [[_computeDownloadFilename(change, patchNum)]]
        </a>
        <a href$="[[_computeZipDownloadLink(change, patchNum)]]" download="">
          [[_computeZipDownloadFilename(change, patchNum)]]
        </a>
      </div>
    </div>
    <div
      class="archivesContainer"
      hidden$="[[!config.archives.length]]"
      hidden=""
    >
      <label>Archive</label>
      <div id="archives" class="archives">
        <template is="dom-repeat" items="[[config.archives]]" as="format">
          <a
            href$="[[_computeArchiveDownloadLink(change, patchNum, format)]]"
            download=""
          >
            [[format]]
          </a>
        </template>
      </div>
    </div>
  </section>
  <section class="footer">
    <span class="closeButtonContainer">
      <gr-button id="closeButton" link="" on-click="_handleCloseTap"
        >Close</gr-button
      >
    </span>
  </section>
`;var Ky=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Yy=class extends(oo(dr(oa))){static get template(){return qy}get _schemes(){if(void 0===this.change||void 0===this.patchNum)return[];for(const e of Object.values(this.change.revisions||{}))if(Ch(e._number,this.patchNum)){const t=e.fetch;if(t)return Object.keys(t).sort();break}return[]}ready(){super.ready(),this._ensureAttribute("role","dialog")}focus(){this._schemes.length?this.$.downloadCommands.focusOnCopy():this.$.download.focus()}getFocusStops(){return{start:this.$.downloadCommands.$.downloadTabs,end:this.$.closeButton}}_computeDownloadCommands(e,t,n){let i;if(!e||!n)return[];for(const s of Object.values(e.revisions||{}))if(Ch(s._number,t)&&s&&s.fetch&&o(s.fetch,n)){i=s.fetch[n].commands;break}const s=[];for(const e in i)i&&o(i,e)&&s.push({title:e,command:i[e]});return s}_computeZipDownloadLink(e,t){return this._computeDownloadLink(e,t,!0)}_computeZipDownloadFilename(e,t){return this._computeDownloadFilename(e,t,!0)}_computeDownloadLink(e,t,n){return void 0===e||void 0===t?"":zp(e.project,e._number,t)+"/patch?"+(n?"zip":"download")}_computeDownloadFilename(e,t,n){if(void 0===e||void 0===t)return"";let i="";for(const n in e.revisions)if(Ch(e.revisions[n]._number,t)){i=n.substr(0,7);break}return i+".diff."+(n?"zip":"base64")}_computeHidePatchFile(e,t){if(void 0===e||void 0===t)return!1;for(const n of Object.values(e.revisions||{}))if(Ch(n._number,t)){return 0===(n.commit&&n.commit.parents?n.commit.parents.length:0)}return!1}_computeArchiveDownloadLink(e,t,n){return void 0===e||void 0===t||void 0===n?"":zp(e.project,e._number,t)+"/archive?format="+n}_computePatchSetQuantity(e){return e?Object.keys(e).length:0}_handleCloseTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("close",{composed:!0,bubbles:!1}))}_schemesChanged(e){0!==e.length&&(this._selectedScheme&&e.includes(this._selectedScheme)||(this._selectedScheme=e.sort()[0]))}_computeShowDownloadCommands(e){return e.length?"":"hidden"}};Ky([Bl({type:Object})],Yy.prototype,"change",void 0),Ky([Bl({type:Object})],Yy.prototype,"config",void 0),Ky([Bl({type:String})],Yy.prototype,"patchNum",void 0),Ky([Bl({type:String})],Yy.prototype,"_selectedScheme",void 0),Ky([Hl("change","patchNum")],Yy.prototype,"_schemes",null),Ky([jl("_schemes")],Yy.prototype,"_schemesChanged",null),Yy=Ky([Ml("gr-download-dialog")],Yy);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Xy=ta`
  <style include="shared-styles">
    :host {
      /* Used to remove horizontal whitespace between the icons. */
      display: flex;
    }
    gr-button.selected iron-icon {
      color: var(--link-color);
    }
    iron-icon {
      height: 1.3rem;
      width: 1.3rem;
    }
  </style>
  <gr-button
    id="sideBySideBtn"
    link=""
    has-tooltip=""
    class$="[[_computeSideBySideSelected(mode)]]"
    title="Side-by-side diff"
    aria-pressed="[[isSideBySideSelected(mode)]]"
    on-click="_handleSideBySideTap"
  >
    <iron-icon icon="gr-icons:side-by-side"></iron-icon>
  </gr-button>
  <gr-button
    id="unifiedBtn"
    link=""
    has-tooltip=""
    title="Unified diff"
    class$="[[_computeUnifiedSelected(mode)]]"
    aria-pressed="[[isUnifiedSelected(mode)]]"
    on-click="_handleUnifiedTap"
  >
    <iron-icon icon="gr-icons:unified"></iron-icon>
  </gr-button>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Jy=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Zy=class extends(oo(dr(oa))){constructor(){super(...arguments),this.saveOnChange=!1}static get template(){return Xy}attached(){Mu.requestAvailability()}setMode(e){let t;this.saveOnChange&&this.mode&&this.mode!==e&&this.$.restAPI.savePreferences({diff_view:e}),this.mode=e,this.isUnifiedSelected(e)?t="Changed diff view to unified":this.isSideBySideSelected(e)&&(t="Changed diff view to side by side"),t&&this.fire("iron-announce",{text:t},{bubbles:!0})}_computeSideBySideSelected(e){return e===Za.SIDE_BY_SIDE?"selected":""}_computeUnifiedSelected(e){return e===Za.UNIFIED?"selected":""}isSideBySideSelected(e){return e===Za.SIDE_BY_SIDE}isUnifiedSelected(e){return e===Za.UNIFIED}_handleSideBySideTap(){this.setMode(Za.SIDE_BY_SIDE)}_handleUnifiedTap(){this.setMode(Za.UNIFIED)}};Jy([Bl({type:String,notify:!0})],Zy.prototype,"mode",void 0),Jy([Bl({type:Boolean})],Zy.prototype,"saveOnChange",void 0),Zy=Jy([Ml("gr-diff-mode-selector")],Zy);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Qy=ta`
  <style include="shared-styles">
    :host {
      align-items: center;
      display: flex;
    }
    select {
      max-width: 15em;
    }
    .arrow {
      color: var(--deemphasized-text-color);
      margin: 0 var(--spacing-m);
    }
    gr-dropdown-list {
      --trigger-style: {
        color: var(--deemphasized-text-color);
        text-transform: none;
        font-family: var(--font-family);
      }
      --trigger-hover-color: rgba(0, 0, 0, 0.6);
    }
    @media screen and (max-width: 50em) {
      .filesWeblinks {
        display: none;
      }
      gr-dropdown-list {
        --native-select-style: {
          max-width: 5.25em;
        }
        --dropdown-content-stype: {
          max-width: 300px;
        }
      }
    }
  </style>
  <span class="patchRange" aria-label="patch range starts with">
    <gr-dropdown-list
      id="basePatchDropdown"
      value="[[basePatchNum]]"
      on-value-change="_handlePatchChange"
      items="[[_baseDropdownContent]]"
    >
    </gr-dropdown-list>
  </span>
  <span is="dom-if" if="[[filesWeblinks.meta_a]]" class="filesWeblinks">
    <template is="dom-repeat" items="[[filesWeblinks.meta_a]]" as="weblink">
      <a target="_blank" rel="noopener" href$="[[weblink.url]]"
        >[[weblink.name]]</a
      >
    </template>
  </span>
  <span aria-hidden="true" class="arrow">→</span>
  <span class="patchRange" aria-label="patch range ends with">
    <gr-dropdown-list
      id="patchNumDropdown"
      value="[[patchNum]]"
      on-value-change="_handlePatchChange"
      items="[[_patchDropdownContent]]"
    >
    </gr-dropdown-list>
    <span is="dom-if" if="[[filesWeblinks.meta_b]]" class="filesWeblinks">
      <template is="dom-repeat" items="[[filesWeblinks.meta_b]]" as="weblink">
        <a target="_blank" href$="[[weblink.url]]">[[weblink.name]]</a>
      </template>
    </span>
  </span>
`;var eb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let tb=class extends(oo(dr(oa))){constructor(){super(),this.reporting=n.reportingService,this.reporting=n.reportingService}static get template(){return Qy}_getShaForPatch(e){return e.sha.substring(0,10)}_computeBaseDropdownContent(e,t,n,i,s){if(void 0===e||void 0===t||void 0===n||void 0===i||void 0===s)return;const r=s.getParentCountMap(),a=o(r,t)?r[t]:1,l=s.getMaxParents(),c=a>1,d=[];for(const o of e){const e=o.num,s=this._createDropdownEntry(e,"Patchset ",n,i,this._getShaForPatch(o));d.push({...s,disabled:this._computeLeftDisabled(o.num,t,n)})}d.push({text:c?"Auto Merge":"Base",value:"PARENT"});for(let e=0;c&&e<l;e++)d.push({disabled:e>=a,triggerText:`Parent ${e+1}`,text:`Parent ${e+1}`,mobileText:`Parent ${e+1}`,value:-(e+1)});return d}_computeMobileText(e,t,n){return`${e}`+`${this._computePatchSetCommentsString(t,e)}`+`${this._computePatchSetDescription(n,e,!0)}`}_computePatchDropdownContent(e,t,n,i){if(void 0===e||void 0===t||void 0===n||void 0===i)return;const o=[];for(const s of e){const e=s.num,r=this._createDropdownEntry(e,"edit"===e?"":"Patchset ",n,i,this._getShaForPatch(s));o.push({...r,disabled:this._computeRightDisabled(t,e,n)})}return o}_computeText(e,t,n,i){return`${t}${e}`+`${this._computePatchSetCommentsString(n,e)}`+` | ${i}`}_createDropdownEntry(e,t,n,i,o){const s={triggerText:`${t}${e}`,text:this._computeText(e,t,i,o),mobileText:this._computeMobileText(e,i,n),bottomText:`${this._computePatchSetDescription(n,e)}`,value:e},r=this._computePatchSetDate(n,e);return r&&(s.date=r),s}_updateSortedRevisions(e){const t=e.base;t&&(this._sortedRevisions=xh(Object.values(t)))}_computeLeftDisabled(e,t,n){return kh(e,n)<=kh(t,n)}_computeRightDisabled(e,t,n){return!Ch(e,"PARENT")&&(Eh(e)?!this.revisionInfo||this.revisionInfo.getParentCount(t)<Oh(e):kh(e,n)<=kh(t,n))}_computePatchSetCommentsString(e,t){if(!e)return;const n=e.computeCommentCount({patchNum:t}),i=nd.computePluralString(n,"comment"),o=e.computeUnresolvedNum({patchNum:t}),s=nd.computeString(o,"unresolved");return i.length||s.length?` (${i}`+(i&&s?", ":"")+`${s})`:""}_computePatchSetDescription(e,t,n){const i=Ah(e,t);return(null==i?void 0:i.description)?(n?" ":"")+i.description.substring(0,500):""}_computePatchSetDate(e,t){const n=Ah(e,t);return n?n.created:void 0}_handlePatchChange(e){var t,n;const i={patchNum:this.patchNum,basePatchNum:this.basePatchNum},o=qo(e).localTarget,s=e.detail.value,r=Th(this.availablePatches);if(o===this.$.patchNumDropdown){if(i.patchNum===e.detail.value)return;this.reporting.reportInteraction("right-patchset-changed",{previous:i.patchNum,current:e.detail.value,latest:r,commentCount:null===(t=this.changeComments)||void 0===t?void 0:t.computeCommentCount({patchNum:e.detail.value})}),i.patchNum=s}else{if(Ch(i.basePatchNum,s))return;this.reporting.reportInteraction("left-patchset-changed",{previous:i.basePatchNum,current:e.detail.value,commentCount:null===(n=this.changeComments)||void 0===n?void 0:n.computeCommentCount({patchNum:s})}),i.basePatchNum=s}this.dispatchEvent(new CustomEvent("patch-range-change",{detail:i,bubbles:!1}))}};eb([Bl({type:Array})],tb.prototype,"availablePatches",void 0),eb([Bl({type:Object,computed:"_computeBaseDropdownContent(availablePatches, patchNum,_sortedRevisions, changeComments, revisionInfo)"})],tb.prototype,"_baseDropdownContent",void 0),eb([Bl({type:Object,computed:"_computePatchDropdownContent(availablePatches,basePatchNum, _sortedRevisions, changeComments)"})],tb.prototype,"_patchDropdownContent",void 0),eb([Bl({type:String})],tb.prototype,"changeNum",void 0),eb([Bl({type:Object})],tb.prototype,"changeComments",void 0),eb([Bl({type:Object})],tb.prototype,"filesWeblinks",void 0),eb([Bl({type:String})],tb.prototype,"patchNum",void 0),eb([Bl({type:String})],tb.prototype,"basePatchNum",void 0),eb([Bl({type:Object})],tb.prototype,"revisions",void 0),eb([Bl({type:Object})],tb.prototype,"revisionInfo",void 0),eb([Bl({type:Array})],tb.prototype,"_sortedRevisions",void 0),eb([jl("revisions.*")],tb.prototype,"_updateSortedRevisions",null),tb=eb([Ml("gr-patch-range-select")],tb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const nb=ta`
  <style include="shared-styles">
    :host {
      align-items: center;
      display: flex;
      justify-content: flex-end;
    }
    .invisible {
      display: none;
    }
    gr-button {
      margin-left: var(--spacing-l);
      text-decoration: none;
    }
    gr-dialog {
      width: 50em;
    }
    gr-dialog .main {
      width: 100%;
    }
    gr-dialog .main > iron-input {
      width: 100%;
    }
    input {
      border: 1px solid var(--border-color);
      border-radius: var(--border-radius);
      margin: var(--spacing-m) 0;
      padding: var(--spacing-s);
      width: 100%;
      box-sizing: content-box;
    }
    #fileUploadBrowse {
      margin-left: 0;
    }
    #dragDropArea {
      border: 2px dashed var(--border-color);
      border-radius: var(--border-radius);
      margin-top: var(--spacing-l);
      padding: var(--spacing-xxl) var(--spacing-xxl);
      text-align: center;
    }
    #dragDropArea > p {
      font-weight: var(--font-weight-bold);
      padding: var(--spacing-s);
    }
    @media screen and (max-width: 50em) {
      gr-dialog {
        width: 100vw;
      }
    }
  </style>
  <template is="dom-repeat" items="[[_actions]]" as="action">
    <gr-button
      id$="[[action.id]]"
      class$="[[_computeIsInvisible(action.id, hiddenActions)]]"
      link=""
      on-click="_handleTap"
      >[[action.label]]</gr-button
    >
  </template>
  <gr-overlay id="overlay" with-backdrop="">
    <gr-dialog
      id="openDialog"
      class="invisible dialog"
      disabled$="[[!_isValidPath(_path)]]"
      confirm-label="Confirm"
      confirm-on-enter=""
      on-confirm="_handleOpenConfirm"
      on-cancel="_handleDialogCancel"
    >
      <div class="header" slot="header">
        Add a new file or open an existing file
      </div>
      <div class="main" slot="main">
        <gr-autocomplete
          placeholder="Enter an existing or new full file path."
          query="[[_query]]"
          text="{{_path}}"
        ></gr-autocomplete>
        <div id="dragDropArea" on-drop="_handleDragAndDropUpload">
          <p>Drag and drop a file here</p>
          <p>or</p>
          <p>
            <iron-input>
              <input
                is="iron-input"
                id="fileUploadInput"
                type="file"
                on-change="_handleFileUploadChanged"
                hidden
              />
            </iron-input>
            <label for="fileUploadInput">
              <gr-button id="fileUploadBrowse">Browse</gr-button>
            </label>
          </p>
        </div>
      </div>
    </gr-dialog>
    <gr-dialog
      id="deleteDialog"
      class="invisible dialog"
      disabled$="[[!_isValidPath(_path)]]"
      confirm-label="Delete"
      confirm-on-enter=""
      on-confirm="_handleDeleteConfirm"
      on-cancel="_handleDialogCancel"
    >
      <div class="header" slot="header">Delete a file from the repo</div>
      <div class="main" slot="main">
        <gr-autocomplete
          placeholder="Enter an existing full file path."
          query="[[_query]]"
          text="{{_path}}"
        ></gr-autocomplete>
      </div>
    </gr-dialog>
    <gr-dialog
      id="renameDialog"
      class="invisible dialog"
      disabled$="[[!_computeRenameDisabled(_path, _newPath)]]"
      confirm-label="Rename"
      confirm-on-enter=""
      on-confirm="_handleRenameConfirm"
      on-cancel="_handleDialogCancel"
    >
      <div class="header" slot="header">Rename a file in the repo</div>
      <div class="main" slot="main">
        <gr-autocomplete
          placeholder="Enter an existing full file path."
          query="[[_query]]"
          text="{{_path}}"
        ></gr-autocomplete>
        <iron-input
          class="newPathIronInput"
          bind-value="{{_newPath}}"
          placeholder="Enter the new path."
        >
          <input
            class="newPathInput"
            is="iron-input"
            bind-value="{{_newPath}}"
            placeholder="Enter the new path."
          />
        </iron-input>
      </div>
    </gr-dialog>
    <gr-dialog
      id="restoreDialog"
      class="invisible dialog"
      confirm-label="Restore"
      confirm-on-enter=""
      on-confirm="_handleRestoreConfirm"
      on-cancel="_handleDialogCancel"
    >
      <div class="header" slot="header">Restore this file?</div>
      <div class="main" slot="main">
        <iron-input disabled="" bind-value="{{_path}}">
          <input is="iron-input" disabled="" bind-value="{{_path}}" />
        </iron-input>
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var ib=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let ob=class extends(oo(dr(oa))){constructor(){super(),this.hiddenActions=[Nl.Actions.RESTORE.id],this._actions=Object.values(Nl.Actions),this._path="",this._newPath="",this._query=e=>this._queryFiles(e)}static get template(){return nb}_handleTap(e){switch(e.preventDefault(),qo(e).localTarget.id){case Nl.Actions.OPEN.id:return void this.openOpenDialog();case Nl.Actions.DELETE.id:return void this.openDeleteDialog();case Nl.Actions.RENAME.id:return void this.openRenameDialog();case Nl.Actions.RESTORE.id:return void this.openRestoreDialog()}}openOpenDialog(e){return e&&(this._path=e),this._showDialog(this.$.openDialog)}openDeleteDialog(e){return e&&(this._path=e),this._showDialog(this.$.deleteDialog)}openRenameDialog(e){return e&&(this._path=e),this._showDialog(this.$.renameDialog)}openRestoreDialog(e){return e&&(this._path=e),this._showDialog(this.$.restoreDialog)}_isValidPath(e){return!!e.length&&!e.endsWith("/")}_computeRenameDisabled(e,t){return this._isValidPath(e)&&this._isValidPath(t)}_getDialogFromEvent(e){return qo(e).path.find(e=>e instanceof Element&&(!!e.classList&&e.classList.contains("dialog")))}_showDialog(e){return this._hideAllDialogs(),this.$.overlay.open().then(()=>{e.classList.toggle("invisible",!1);const t=e.querySelector("gr-autocomplete");t&&t.focus(),this.async(()=>{this.$.overlay.center()},1)})}_hideAllDialogs(){const e=this.root.querySelectorAll(".dialog");for(const t of e)this._closeDialog(t)}_closeDialog(e,t=!1){if(e)return t&&(e.querySelectorAll("gr-autocomplete").forEach(e=>{e.text=""}),e.querySelectorAll("iron-input").forEach(e=>{e.bindValue=""})),e.classList.toggle("invisible",!0),this.$.overlay.close()}_handleDialogCancel(e){this._closeDialog(this._getDialogFromEvent(e))}_handleOpenConfirm(e){const t=gh.getEditUrlForDiff(this.change,this._path,this.patchNum);gh.navigateToRelativeUrl(t),this._closeDialog(this._getDialogFromEvent(e),!0)}_handleUploadConfirm(e,t){if(this.change&&e&&t)return this.$.restAPI.saveFileUploadChangeEdit(this.change._number,e,t).then(e=>{e&&e.ok&&(this._closeDialog(this.$.openDialog,!0),gh.navigateToChange(this.change))});this._closeDialog(this.$.openDialog,!0)}_handleDeleteConfirm(e){const t=this._getDialogFromEvent(e);this.$.restAPI.deleteFileInChangeEdit(this.change._number,this._path).then(e=>{e&&e.ok&&(this._closeDialog(t,!0),gh.navigateToChange(this.change))})}_handleRestoreConfirm(e){const t=this._getDialogFromEvent(e);this.$.restAPI.restoreFileInChangeEdit(this.change._number,this._path).then(e=>{e&&e.ok&&(this._closeDialog(t,!0),gh.navigateToChange(this.change))})}_handleRenameConfirm(e){const t=this._getDialogFromEvent(e);return this.$.restAPI.renameFileInChangeEdit(this.change._number,this._path,this._newPath).then(e=>{e&&e.ok&&(this._closeDialog(t,!0),gh.navigateToChange(this.change))})}_queryFiles(e){return this.$.restAPI.queryChangeFiles(this.change._number,this.patchNum,e).then(e=>{if(!e)throw new Error("Failed to retrieve files. Reponse not set.");return e.map(e=>({name:e}))})}_computeIsInvisible(e,t){return t.includes(e)?"invisible":""}_handleDragAndDropUpload(e){e.preventDefault(),e.stopPropagation(),e.dataTransfer&&this._fileUpload(e.dataTransfer.files)}_handleFileUploadChanged(e){if(!e.target)return;if(!(e.target instanceof HTMLInputElement))return;const t=e.target;t.files&&this._fileUpload(t.files)}_fileUpload(e){for(const t of e){if(!t)continue;let e=this._path;e||(e=t.name);const n=new FileReader;n.onload=t=>{if(!t)return;const n=t.target.result;"string"==typeof n&&this._handleUploadConfirm(e,n)},n.readAsDataURL(t)}}};ib([Bl({type:Object})],ob.prototype,"change",void 0),ib([Bl({type:String})],ob.prototype,"patchNum",void 0),ib([Bl({type:Array})],ob.prototype,"hiddenActions",void 0),ib([Bl({type:Array})],ob.prototype,"_actions",void 0),ib([Bl({type:String})],ob.prototype,"_path",void 0),ib([Bl({type:String})],ob.prototype,"_newPath",void 0),ib([Bl({type:Object})],ob.prototype,"_query",void 0),ob=ib([Ml("gr-edit-controls")],ob);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const sb=ta`
  <style include="shared-styles">
    .prefsButton {
      float: right;
    }
    .collapseToggleButton {
      text-decoration: none;
    }
    .patchInfoOldPatchSet.patchInfo-header {
      background-color: var(--emphasis-color);
    }
    .patchInfo-header {
      align-items: center;
      border-top: 1px solid var(--border-color);
      display: flex;
      padding: var(--spacing-s) var(--spacing-l);
    }
    .patchInfo-left {
      align-items: baseline;
      display: flex;
    }
    .patchInfoContent {
      align-items: center;
      display: flex;
      flex-wrap: wrap;
    }
    .patchInfo-header .container.latestPatchContainer {
      display: none;
    }
    .patchInfoOldPatchSet .container.latestPatchContainer {
      display: initial;
    }
    .latestPatchContainer a {
      text-decoration: none;
    }
    gr-editable-label.descriptionLabel {
      max-width: 100%;
    }
    .mobile {
      display: none;
    }
    .patchInfo-header .container {
      align-items: center;
      display: flex;
    }
    .downloadContainer,
    .uploadContainer,
    .includedInContainer {
      margin-right: 16px;
    }
    .includedInContainer.hide,
    .uploadContainer.hide {
      display: none;
    }
    .rightControls {
      align-self: flex-end;
      margin: auto 0 auto auto;
      align-items: center;
      display: flex;
      flex-wrap: wrap;
      font-weight: var(--font-weight-normal);
      justify-content: flex-end;
    }
    #collapseBtn,
    .expanded #expandBtn,
    .fileViewActions {
      display: none;
    }
    .expanded #expandBtn {
      display: none;
    }
    gr-linked-chip {
      --linked-chip-text-color: var(--primary-text-color);
    }
    .expanded #collapseBtn,
    .openFile .fileViewActions {
      align-items: center;
      display: flex;
    }
    .rightControls gr-button,
    gr-patch-range-select {
      margin: 0 -4px;
    }
    .fileViewActions gr-button {
      margin: 0;
      --gr-button: {
        padding: 2px 4px;
      }
    }
    .editMode .hideOnEdit {
      display: none;
    }
    .showOnEdit {
      display: none;
    }
    .editMode .showOnEdit {
      display: initial;
    }
    .editMode .showOnEdit.flexContainer {
      align-items: center;
      display: flex;
    }
    .label {
      font-weight: var(--font-weight-bold);
      margin-right: 24px;
    }
    gr-commit-info,
    gr-edit-controls {
      margin-right: -5px;
    }
    .fileViewActionsLabel {
      margin-right: var(--spacing-xs);
    }
    @media screen and (max-width: 50em) {
      .patchInfo-header .desktop {
        display: none;
      }
    }
  </style>
  <div
    class$="patchInfo-header [[_computeEditModeClass(editMode)]] [[_computePatchInfoClass(patchNum, allPatchSets)]]"
  >
    <div class="patchInfo-left">
      <div class="patchInfoContent">
        <gr-patch-range-select
          id="rangeSelect"
          change-comments="[[changeComments]]"
          change-num="[[changeNum]]"
          patch-num="[[patchNum]]"
          base-patch-num="[[basePatchNum]]"
          available-patches="[[allPatchSets]]"
          revisions="[[change.revisions]]"
          revision-info="[[revisionInfo]]"
          on-patch-range-change="_handlePatchChange"
        >
        </gr-patch-range-select>
        <span class="separator"></span>
        <gr-commit-info
          change="[[change]]"
          server-config="[[serverConfig]]"
          commit-info="[[commitInfo]]"
        ></gr-commit-info>
        <span class="container latestPatchContainer">
          <span class="separator"></span>
          <a href$="[[changeUrl]]">Go to latest patch set</a>
        </span>
        <span class="container descriptionContainer hideOnEdit">
          <span class="separator"></span>
          <template is="dom-if" if="[[_patchsetDescription]]">
            <gr-linked-chip
              id="descriptionChip"
              text="[[_patchsetDescription]]"
              removable="[[!_descriptionReadOnly]]"
              on-remove="_handleDescriptionRemoved"
            ></gr-linked-chip>
          </template>
          <template is="dom-if" if="[[!_patchsetDescription]]">
            <gr-editable-label
              id="descriptionLabel"
              uppercase=""
              class="descriptionLabel"
              label-text="Add patchset description"
              value="[[_patchsetDescription]]"
              placeholder="[[_computeDescriptionPlaceholder(_descriptionReadOnly)]]"
              read-only="[[_descriptionReadOnly]]"
              on-changed="_handleDescriptionChanged"
            ></gr-editable-label>
          </template>
        </span>
      </div>
    </div>
    <div class$="rightControls [[_computeExpandedClass(filesExpanded)]]">
      <template is="dom-if" if="[[editMode]]">
        <span class="showOnEdit flexContainer">
          <gr-edit-controls
            id="editControls"
            patch-num="[[patchNum]]"
            change="[[change]]"
          ></gr-edit-controls>
          <span class="separator"></span>
        </span>
      </template>
      <span class$="[[_computeUploadHelpContainerClass(change, account)]]">
        <gr-button link="" class="upload" on-click="_handleUploadTap"
          >Update Change</gr-button
        >
      </span>
      <span class="downloadContainer desktop">
        <gr-button
          link=""
          class="download"
          title="[[createTitle(Shortcut.OPEN_DOWNLOAD_DIALOG,
                ShortcutSection.ACTIONS)]]"
          on-click="_handleDownloadTap"
          >Download</gr-button
        >
      </span>
      <span class$="includedInContainer [[_hideIncludedIn(change)]] desktop">
        <gr-button link="" class="includedIn" on-click="_handleIncludedInTap"
          >Included In</gr-button
        >
      </span>
      <template
        is="dom-if"
        if="[[_fileListActionsVisible(shownFileCount, _maxFilesForBulkActions)]]"
      >
        <gr-button
          id="expandBtn"
          link=""
          title="[[createTitle(Shortcut.TOGGLE_ALL_INLINE_DIFFS,
                ShortcutSection.FILE_LIST)]]"
          on-click="_expandAllDiffs"
          >Expand All</gr-button
        >
        <gr-button
          id="collapseBtn"
          link=""
          on-click="_collapseAllDiffs"
          title="[[createTitle(Shortcut.TOGGLE_ALL_INLINE_DIFFS,
          ShortcutSection.FILE_LIST)]]"
          >Collapse All</gr-button
        >
      </template>
      <template
        is="dom-if"
        if="[[!_fileListActionsVisible(shownFileCount, _maxFilesForBulkActions)]]"
      >
        <div class="warning">
          Bulk actions disabled because there are too many files.
        </div>
      </template>
      <div class="fileViewActions">
        <span class="separator"></span>
        <span class="fileViewActionsLabel">Diff view:</span>
        <gr-diff-mode-selector
          id="modeSelect"
          mode="{{diffViewMode}}"
          save-on-change="[[!diffPrefsDisabled]]"
        ></gr-diff-mode-selector>
        <span
          id="diffPrefsContainer"
          class="hideOnEdit"
          hidden$="[[_computePrefsButtonHidden(diffPrefs, diffPrefsDisabled)]]"
          hidden=""
        >
          <gr-button
            link=""
            has-tooltip=""
            title="Diff preferences"
            class="prefsButton desktop"
            on-click="_handlePrefsTap"
            ><iron-icon icon="gr-icons:settings"></iron-icon
          ></gr-button>
        </span>
      </div>
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var rb;!function(e){e.ALL="all",e.NONE="none",e.SOME="some"}(rb||(rb={}));var ab=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let lb=class extends(xp(oo(dr(oa)))){constructor(){super(...arguments),this._maxFilesForBulkActions=225,this._patchsetDescription=""}static get template(){return sb}get _descriptionReadOnly(){return void 0!==this.loggedIn&&void 0!==this.change&&void 0!==this.account&&!(this.loggedIn&&this.account._account_id===this.change.owner._account_id)}setDiffViewMode(e){this.$.modeSelect.setMode(e)}_expandAllDiffs(){this.dispatchEvent(new CustomEvent("expand-diffs",{composed:!0,bubbles:!0}))}_collapseAllDiffs(){this.dispatchEvent(new CustomEvent("collapse-diffs",{composed:!0,bubbles:!0}))}_computeExpandedClass(e){const t=[];return e===rb.ALL&&t.push("expanded"),e!==rb.SOME&&e!==rb.ALL||t.push("openFile"),t.join(" ")}_computeDescriptionPlaceholder(e){return(e?"No":"Add")+" patchset description"}_computePatchSetDescription(e,t){if(void 0===e||void 0===e.revisions||void 0===t)return;const n=Ah(Object.values(e.revisions),t);this._patchsetDescription=(null==n?void 0:n.description)?n.description.substring(0,500):""}_handleDescriptionRemoved(e){return this._updateDescription("",e)}_getPatchsetHash(e,t){for(const n of Object.keys(e))if(e[n]===t)return n;throw new Error("patchset hash not found")}_handleDescriptionChanged(e){const t=e.detail.trim();this._updateDescription(t,e)}_updateDescription(e,t){if(!(this.change&&this.change.revisions&&this.patchNum&&this.changeNum))return;const n=qo(t).rootTarget;n&&(n.disabled=!0);const i=Ah(Object.values(this.change.revisions),this.patchNum),o=this._getPatchsetHash(this.change.revisions,i);return this.$.restAPI.setDescription(this.changeNum,this.patchNum,e).then(t=>{t.ok&&(n&&(n.disabled=!1),this.set(["change","revisions",o,"description"],e),this._patchsetDescription=e)}).catch(()=>{n&&(n.disabled=!1)})}_computePrefsButtonHidden(e,t){return t||!e}_fileListActionsVisible(e,t){return e<=t}_handlePatchChange(e){const{basePatchNum:t,patchNum:n}=e.detail;Ch(t,this.basePatchNum)&&Ch(n,this.patchNum)||!this.change||gh.navigateToChange(this.change,n,t)}_handlePrefsTap(e){e.preventDefault(),this.dispatchEvent(new CustomEvent("open-diff-prefs",{composed:!0,bubbles:!0}))}_handleIncludedInTap(e){e.preventDefault(),this.dispatchEvent(new CustomEvent("open-included-in-dialog",{composed:!0,bubbles:!0}))}_handleDownloadTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("open-download-dialog",{bubbles:!1}))}_computeEditModeClass(e){return e?"editMode":""}_computePatchInfoClass(e,t){return Ch(e,Th(t))?"":"patchInfoOldPatchSet"}_hideIncludedIn(e){return"MERGED"===(null==e?void 0:e.status)?"":"hide"}_handleUploadTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("open-upload-help-dialog",{bubbles:!1}))}_computeUploadHelpContainerClass(e,t){var n;const i="MERGED"===(null==e?void 0:e.status),o=(null===(n=null==e?void 0:e.owner)||void 0===n?void 0:n._account_id)||null,s=t&&t._account_id;return"uploadContainer desktop"+(!(o&&s&&o===s)||i?" hide":"")}};ab([Bl({type:Object})],lb.prototype,"account",void 0),ab([Bl({type:Array})],lb.prototype,"allPatchSets",void 0),ab([Bl({type:Object})],lb.prototype,"change",void 0),ab([Bl({type:String})],lb.prototype,"changeNum",void 0),ab([Bl({type:String})],lb.prototype,"changeUrl",void 0),ab([Bl({type:Object})],lb.prototype,"changeComments",void 0),ab([Bl({type:Object})],lb.prototype,"commitInfo",void 0),ab([Bl({type:Boolean})],lb.prototype,"editMode",void 0),ab([Bl({type:Boolean})],lb.prototype,"loggedIn",void 0),ab([Bl({type:Object})],lb.prototype,"serverConfig",void 0),ab([Bl({type:Number})],lb.prototype,"shownFileCount",void 0),ab([Bl({type:Object})],lb.prototype,"diffPrefs",void 0),ab([Bl({type:Boolean})],lb.prototype,"diffPrefsDisabled",void 0),ab([Bl({type:String,notify:!0})],lb.prototype,"diffViewMode",void 0),ab([Bl({type:String})],lb.prototype,"patchNum",void 0),ab([Bl({type:String})],lb.prototype,"basePatchNum",void 0),ab([Bl({type:String})],lb.prototype,"filesExpanded",void 0),ab([Bl({type:Number})],lb.prototype,"_maxFilesForBulkActions",void 0),ab([Bl({type:String})],lb.prototype,"_patchsetDescription",void 0),ab([Bl({type:Object})],lb.prototype,"revisionInfo",void 0),ab([Hl("loggedIn","change","account")],lb.prototype,"_descriptionReadOnly",null),ab([jl("change","patchNum")],lb.prototype,"_computePatchSetDescription",null),lb=ab([Ml("gr-file-list-header")],lb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const cb=ta`
  <gr-cursor-manager
    id="cursorManager"
    scroll-mode="[[_scrollMode]]"
    cursor-target-class="target-row"
    focus-on-move="[[_focusOnMove]]"
    target="{{diffRow}}"
  ></gr-cursor-manager>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var db=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const hb="SIDE_BY_SIDE",pb="UNIFIED_DIFF";let ub=class extends(oo(dr(oa))){constructor(){super(),this._preventAutoScrollOnManualScroll=!1,this.lastDisplayedNavigateToNextFileToast=null,this.side=ja.RIGHT,this.diffs=[],this.initialLineNumber=null,this._scrollMode=Ta.KEEP_VISIBLE,this._focusOnMove=!0,this._listeningForScroll=!1,this._boundHandleWindowScroll=()=>this._handleWindowScroll(),this._boundHandleDiffRenderStart=()=>this._handleDiffRenderStart(),this._boundHandleDiffRenderContent=()=>this._handleDiffRenderContent(),this._boundHandleDiffLineSelected=e=>this._handleDiffLineSelected(e)}static get template(){return cb}ready(){super.ready(),Ao(this,()=>{this.dispatchEvent(new CustomEvent("ready",{composed:!0,bubbles:!1}))})}connectedCallback(){super.connectedCallback(),window.addEventListener("scroll",this._boundHandleWindowScroll)}disconnectedCallback(){super.disconnectedCallback(),window.removeEventListener("scroll",this._boundHandleWindowScroll)}moveLeft(){this.side=ja.LEFT,this._isTargetBlank()&&this.moveUp()}moveRight(){this.side=ja.RIGHT,this._isTargetBlank()&&this.moveUp()}moveDown(){this._getViewMode()===hb?this.$.cursorManager.next({filter:e=>this._rowHasSide(e)}):this.$.cursorManager.next()}moveUp(){this._getViewMode()===hb?this.$.cursorManager.previous({filter:e=>this._rowHasSide(e)}):this.$.cursorManager.previous()}moveToVisibleArea(){this._getViewMode()===hb?this.$.cursorManager.moveToVisibleArea(e=>this._rowHasSide(e)):this.$.cursorManager.moveToVisibleArea()}moveToNextChunk(e,t){const n=this.$.cursorManager.next({filter:e=>this._isFirstRowOfChunk(e),getTargetHeight:e=>{var t;return(null===(t=null==e?void 0:e.parentNode)||void 0===t?void 0:t.scrollHeight)||0},clipToTop:e});t&&n===og.CLIPPED&&this.$.cursorManager.isAtEnd()&&(this.lastDisplayedNavigateToNextFileToast&&Date.now()-this.lastDisplayedNavigateToNextFileToast<=5e3&&(this.lastDisplayedNavigateToNextFileToast=null,this.dispatchEvent(new CustomEvent("navigate-to-next-unreviewed-file",{composed:!0,bubbles:!0}))),this.lastDisplayedNavigateToNextFileToast=Date.now(),this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Press n again to navigate to next unreviewed file"},composed:!0,bubbles:!0}))),this._fixSide()}moveToPreviousChunk(){this.$.cursorManager.previous({filter:e=>this._isFirstRowOfChunk(e)}),this._fixSide()}moveToNextCommentThread(){this.$.cursorManager.next({filter:e=>this._rowHasThread(e)}),this._fixSide()}moveToPreviousCommentThread(){this.$.cursorManager.previous({filter:e=>this._rowHasThread(e)}),this._fixSide()}moveToLineNumber(e,t,n){const i=this._findRowByNumberAndFile(e,t,n);i&&(this.side=t,this.$.cursorManager.setCursor(i))}getTargetLineElement(){let e=".lineNum";return this.diffRow?(this._getViewMode()===hb&&(e+=this.side===ja.LEFT?".left":".right"),this.diffRow.querySelector(e)):null}getTargetDiffElement(){var e;if(!this.diffRow)return null;const t=qo(this.diffRow).getOwnerRoot();return"GR-DIFF"===(null===(e=null==t?void 0:t.host)||void 0===e?void 0:e.tagName)?t.host:null}moveToFirstChunk(){this.$.cursorManager.moveToStart(),this.moveToNextChunk(!0)}moveToLastChunk(){this.$.cursorManager.moveToEnd(),this.moveToPreviousChunk()}reInitCursor(){this.diffRow||(this._scrollMode=this.initialLineNumber?Ta.KEEP_VISIBLE:Ta.NEVER,this.initialLineNumber?(this.moveToLineNumber(this.initialLineNumber,this.side),this.initialLineNumber=null):this.moveToFirstChunk()),this.reInit()}reInit(){this._scrollMode=Ta.KEEP_VISIBLE}_handleWindowScroll(){this._preventAutoScrollOnManualScroll&&(this._scrollMode=Ta.NEVER,this._focusOnMove=!1,this._preventAutoScrollOnManualScroll=!1)}reInitAndUpdateStops(){this.reInit(),this._updateStops()}handleDiffUpdate(){this._updateStops(),this.reInitCursor()}_handleDiffRenderStart(){this._preventAutoScrollOnManualScroll=!0}_handleDiffRenderContent(){this._updateStops(),this._focusOnMove=!0,this._preventAutoScrollOnManualScroll=!1}_handleDiffLineSelected(e){const t=e;this.moveToLineNumber(t.detail.number,t.detail.side,t.detail.path)}createCommentInPlace(){const e=this.diffs.find(e=>e.isRangeSelected());if(e)e.createRangeComment();else{const e=this.getTargetLineElement(),t=this.getTargetDiffElement();t&&e&&t.addDraftAtLine(e)}}getAddress(){if(!this.diffRow)return null;let e;if(this._getViewMode()===pb?(e=this.diffRow.querySelector(".lineNum.right"),e||(e=this.diffRow.querySelector(".lineNum.left"))):e=this.diffRow.querySelector(".lineNum."+this.side),!e)return null;const t=e.getAttribute("data-value");return t&&"FILE"!==t?{leftSide:e.matches(".left"),number:parseInt(t,10)}:null}_getViewMode(){return this.diffRow?this.diffRow.classList.contains("side-by-side")?hb:pb:null}_rowHasSide(e){const t=(this.side===ja.LEFT?".left":".right")+" + .content";return!!e.querySelector(t)}_isFirstRowOfChunk(e){const t=e.parentNode.classList;return t.contains("section")&&t.contains("delta")&&!e.previousSibling}_rowHasThread(e){return!!e.querySelector(".thread-group")}_fixSide(){this._getViewMode()===hb&&this._isTargetBlank()&&(this.side=this.side===ja.LEFT?ja.RIGHT:ja.LEFT)}_isTargetBlank(){if(!this.diffRow)return!1;const e=this._getActionsForRow();return this.side===ja.LEFT&&!e.left||this.side===ja.RIGHT&&!e.right}_rowChanged(e,t){t&&t.classList.remove("target-side-left","target-side-right"),this._updateSideClass()}_updateSideClass(){this.diffRow&&(this.toggleClass("target-side-left",this.side===ja.LEFT,this.diffRow),this.toggleClass("target-side-right",this.side===ja.RIGHT,this.diffRow))}_isActionType(e){return e!==ul.BLANK&&e!==_l.CONTEXT_CONTROL}_getActionsForRow(){const e={left:!1,right:!1};return this.diffRow&&(e.left=this._isActionType(this.diffRow.getAttribute("left-type")),e.right=this._isActionType(this.diffRow.getAttribute("right-type"))),e}_updateStops(){this.$.cursorManager.stops=this.diffs.reduce((e,t)=>e.concat(t.getCursorStops()),[])}_diffsChanged(e){if(!e)return;let t,n;this._updateStops();for(let i=0;e.indexSplices&&i<e.indexSplices.length;i++){for(t=e.indexSplices[i],n=0;n<(null==t?void 0:t.removed.length);n++)t.removed[n].removeEventListener("render-start",this._boundHandleDiffRenderStart),t.removed[n].removeEventListener("render-content",this._boundHandleDiffRenderContent),t.removed[n].removeEventListener("line-selected",this._boundHandleDiffLineSelected);for(n=t.index;n<t.index+t.addedCount;n++)this.diffs[n].addEventListener("render-start",this._boundHandleDiffRenderStart),this.diffs[n].addEventListener("render-content",this._boundHandleDiffRenderContent),this.diffs[n].addEventListener("line-selected",this._boundHandleDiffLineSelected)}}_findRowByNumberAndFile(e,t,n){let i,o;if(n){i=this.diffs.filter(e=>e.path===n)[0].getCursorStops()}else i=this.$.cursorManager.stops;for(let n=0;n<i.length;n++)if(o=`.lineNum.${t}[data-value="${e}"]`,i[n].querySelector(o))return i[n]}};db([Bl({type:String})],ub.prototype,"side",void 0),db([Bl({type:Object,notify:!0,observer:"_rowChanged"})],ub.prototype,"diffRow",void 0),db([Bl({type:Object})],ub.prototype,"diffs",void 0),db([Bl({type:Number})],ub.prototype,"initialLineNumber",void 0),db([Bl({type:String})],ub.prototype,"_scrollMode",void 0),db([Bl({type:Boolean})],ub.prototype,"_focusOnMove",void 0),db([Bl({type:Boolean})],ub.prototype,"_listeningForScroll",void 0),db([jl("side")],ub.prototype,"_updateSideClass",null),db([jl("diffs.splices")],ub.prototype,"_diffsChanged",null),ub=db([Ml("gr-diff-cursor")],ub);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const gb=ta`
  <style include="shared-styles">
    :host {
      display: block;
      font-family: var(--font-family);
    }
    p,
    ul,
    code,
    blockquote,
    gr-linked-text.pre {
      margin: 0 0 var(--spacing-m) 0;
    }
    p,
    ul,
    code,
    blockquote {
      max-width: var(--gr-formatted-text-prose-max-width, none);
    }
    :host(.noTrailingMargin) p:last-child,
    :host(.noTrailingMargin) ul:last-child,
    :host(.noTrailingMargin) blockquote:last-child,
    :host(.noTrailingMargin) gr-linked-text.pre:last-child {
      margin: 0;
    }
    code,
    blockquote {
      border-left: 1px solid #aaa;
      padding: 0 var(--spacing-m);
    }
    code {
      display: block;
      white-space: pre-wrap;
      color: var(--deemphasized-text-color);
    }
    li {
      list-style-type: disc;
      margin-left: var(--spacing-xl);
    }
    code,
    gr-linked-text.pre {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-code);
      line-height: var(--line-height-code);
    }
  </style>
  <div id="container"></div>
`;var mb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const _b=/^(`{1,3})([^`]+?)\1$/;let fb=class extends(oo(dr(oa))){constructor(){super(...arguments),this.noTrailingMargin=!1}static get template(){return gb}static get observers(){return["_contentOrConfigChanged(content, config)"]}ready(){super.ready(),this.noTrailingMargin&&this.classList.add("noTrailingMargin")}_contentChanged(e){this.config||this._contentOrConfigChanged(e)}_contentOrConfigChanged(e){const t=this.$.container;for(;t.firstChild;)t.removeChild(t.firstChild);for(const n of this._computeNodes(this._computeBlocks(e)))n&&t.appendChild(n)}_computeBlocks(e){if(!e)return[];const t=[],n=e.replace(/[\s\n\r\t]+$/g,"").split("\n");for(let e=0;e<n.length;e++)if(n[e].length){if(this._isCodeMarkLine(n[e])){let i=e+1;for(;!this._isCodeMarkLine(n[i])&&i<n.length;)i++;if(this._isCodeMarkLine(n[i])){t.push({type:"code",text:n.slice(e+1,i).join("\n")}),e=i;continue}}if(this._isSingleLineCode(n[e])){const i=n[e].match(_b)[2];t.push({type:"code",text:i})}else if(this._isList(n[e])){let i=e+1;for(;this._isList(n[i]);)i++;t.push(this._makeList(n.slice(e,i))),e=i-1}else if(this._isQuote(n[e])){let i=e+1;for(;this._isQuote(n[i]);)i++;const o=n.slice(e,i).map(e=>e.replace(/^[ ]?>[ ]?/,""));t.push({type:"quote",blocks:this._computeBlocks(o.join("\n"))}),e=i-1}else if(this._isPreFormat(n[e])){let i=e+1;for(;this._isPreFormat(n[i])||this._isRegularLine(n[i])&&n[i].length;)i++;t.push({type:"pre",text:n.slice(e,i).join("\n")}),e=i-1}else{let i=e+1;for(;this._isRegularLine(n[i]);)i++;t.push({type:"paragraph",text:n.slice(e,i).join("\n")}),e=i-1}}return t}_makeList(e){const t=[];for(let n=0;n<e.length;n++){let i=e[n];i=i.substring(1).trim(),t.push(i)}return{type:"list",items:t}}_isRegularLine(e){return void 0!==e&&!(this._isQuote(e)||this._isCodeMarkLine(e)||this._isSingleLineCode(e)||this._isList(e)||this._isPreFormat(e))}_isQuote(e){return e&&(e.startsWith("> ")||e.startsWith(" > "))}_isCodeMarkLine(e){return e&&"```"===e.trim()}_isSingleLineCode(e){return e&&_b.test(e)}_isPreFormat(e){return e&&/^[ \t]/.test(e)}_isList(e){return e&&/^[-*] /.test(e)}_makeLinkedText(e="",t){const n=document.createElement("gr-linked-text");return n.config=this.config,n.content=e,n.pre=!0,t&&n.classList.add("pre"),n}_computeNodes(e){return e.map(e=>{if("paragraph"===e.type){const t=document.createElement("p");return t.appendChild(this._makeLinkedText(e.text)),t}if("quote"===e.type){const t=document.createElement("blockquote");for(const n of this._computeNodes(e.blocks||[]))n&&t.appendChild(n);return t}if("code"===e.type){const t=document.createElement("code");return t.textContent=e.text||"",t}if("pre"===e.type)return this._makeLinkedText(e.text,!0);if("list"===e.type){const t=document.createElement("ul"),n=e.items||[];for(const e of n){const n=document.createElement("li");n.appendChild(this._makeLinkedText(e)),t.appendChild(n)}return t}return console.warn("Unrecognized type."),document.createElement("span")})}};mb([Bl({type:String,observer:"_contentChanged"})],fb.prototype,"content",void 0),mb([Bl({type:Object})],fb.prototype,"config",void 0),mb([Bl({type:Boolean})],fb.prototype,"noTrailingMargin",void 0),fb=mb([Ml("gr-formatted-text")],fb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const vb=ta`
  <style include="shared-styles">
    :host {
      display: flex;
      position: relative;
    }
    :host(.monospace) {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      font-weight: var(--font-weight-normal);
    }
    :host(.code) {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-code);
      line-height: var(--line-height-code);
      font-weight: var(--font-weight-normal);
    }
    #emojiSuggestions {
      font-family: var(--font-family);
    }
    gr-autocomplete {
      display: inline-block;
    }
    #textarea {
      background-color: var(--view-background-color);
      width: 100%;
    }
    #hiddenText #emojiSuggestions {
      visibility: visible;
      white-space: normal;
    }
    iron-autogrow-textarea {
      position: relative;
    }
    #textarea.noBorder {
      border: none;
    }
    #hiddenText {
      display: block;
      float: left;
      position: absolute;
      visibility: hidden;
      width: 100%;
      white-space: pre-wrap;
    }
  </style>
  <div id="hiddenText"></div>
  <!-- When the autocomplete is open, the span is moved at the end of
      hiddenText in order to correctly position the dropdown. After being moved,
      it is set as the positionTarget for the emojiSuggestions dropdown. -->
  <span id="caratSpan"></span>
  <gr-autocomplete-dropdown
    vertical-align="top"
    horizontal-align="left"
    dynamic-align=""
    id="emojiSuggestions"
    suggestions="[[_suggestions]]"
    index="[[_index]]"
    vertical-offset="[[_verticalOffset]]"
    on-dropdown-closed="_resetEmojiDropdown"
    on-item-selected="_handleEmojiSelect"
  >
  </gr-autocomplete-dropdown>
  <iron-autogrow-textarea
    id="textarea"
    autocomplete="[[autocomplete]]"
    placeholder="[[placeholder]]"
    disabled="[[disabled]]"
    rows="[[rows]]"
    max-rows="[[maxRows]]"
    value="{{text}}"
    on-bind-value-changed="_onValueChanged"
  ></iron-autogrow-textarea>
`;var yb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const bb=[{value:"😊",match:"smile :)"},{value:"👍",match:"thumbs up"},{value:"😄",match:"laugh :D"},{value:"🎉",match:"party"},{value:"😞",match:"sad :("},{value:"😂",match:"tears :')"},{value:"🙏",match:"pray"},{value:"😐",match:"neutral :|"},{value:"😮",match:"shock :O"},{value:"👎",match:"thumbs down"},{value:"😎",match:"cool |;)"},{value:"😕",match:"confused"},{value:"👌",match:"ok"},{value:"🔥",match:"fire"},{value:"👊",match:"fistbump"},{value:"💯",match:"100"},{value:"💔",match:"broken heart"},{value:"🍺",match:"beer"},{value:"✔",match:"check"},{value:"😋",match:"tongue"},{value:"😭",match:"crying :'("},{value:"🐨",match:"koala"},{value:"🤓",match:"glasses"},{value:"😆",match:"grin"},{value:"💩",match:"poop"},{value:"😢",match:"tear"},{value:"😒",match:"unamused"},{value:"😉",match:"wink ;)"},{value:"🍷",match:"wine"},{value:"😜",match:"winking tongue ;)"}];let wb=class extends(xp(oo(dr(oa)))){constructor(){super(),this.hideBorder=!1,this.monospace=!1,this.code=!1,this._colonIndex=null,this._hideAutocomplete=!0,this._verticalOffset=20,this.disableEnterKeyForSelectingEmoji=!1,this.reporting=n.reportingService}static get template(){return vb}get keyBindings(){return{esc:"_handleEscKey",tab:"_handleEnterByKey",enter:"_handleEnterByKey",up:"_handleUpKey",down:"_handleDownKey"}}ready(){super.ready(),this.monospace&&this.classList.add("monospace"),this.code&&this.classList.add("code"),this.hideBorder&&this.$.textarea.classList.add("noBorder")}closeDropdown(){return this.$.emojiSuggestions.close()}getNativeTextarea(){return this.$.textarea.textarea}putCursorAtEnd(){const e=this.getNativeTextarea();e.selectionStart=e.value.length,e.selectionEnd=e.selectionStart,this.async(()=>{e.focus()})}_handleEscKey(e){this._hideAutocomplete||(e.preventDefault(),e.stopPropagation(),this._resetEmojiDropdown())}_handleUpKey(e){this._hideAutocomplete||(e.preventDefault(),e.stopPropagation(),this.$.emojiSuggestions.cursorUp(),this.$.textarea.textarea.focus(),this.disableEnterKeyForSelectingEmoji=!1)}_handleDownKey(e){this._hideAutocomplete||(e.preventDefault(),e.stopPropagation(),this.$.emojiSuggestions.cursorDown(),this.$.textarea.textarea.focus(),this.disableEnterKeyForSelectingEmoji=!1)}_handleEnterByKey(e){this._hideAutocomplete||this.disableEnterKeyForSelectingEmoji||(e.preventDefault(),e.stopPropagation(),this._setEmoji(this.$.emojiSuggestions.getCurrentText()))}_handleEmojiSelect(e){this._setEmoji(e.detail.selected.dataset.value)}_setEmoji(e){if(null===this._colonIndex)return;const t=this._colonIndex;this.text=this._getText(e),this.$.textarea.selectionStart=t+1,this.$.textarea.selectionEnd=t+1,this.reporting.reportInteraction("select-emoji",{type:e}),this._resetEmojiDropdown()}_getText(e){return this.text?this.text.substr(0,this._colonIndex||0)+e+this.text.substr(this.$.textarea.selectionStart):""}_updateCaratPosition(){this._hideAutocomplete=!1,"string"==typeof this.$.textarea.value&&(this.$.hiddenText.textContent=this.$.textarea.value.substr(0,this.$.textarea.selectionStart));const e=this.$.caratSpan;this.$.hiddenText.appendChild(e),this.$.emojiSuggestions.positionTarget=e,this._openEmojiDropdown()}_getFontSize(){const e=getComputedStyle(this).fontSize||"12px";return parseInt(e.substr(0,e.length-2),10)}_getScrollTop(){return document.body.scrollTop}_onValueChanged(e){if(this.dispatchEvent(new CustomEvent("bind-value-changed",{detail:e,composed:!0,bubbles:!0})),null===e.currentTarget||!e.currentTarget.focused)return;const t=e.detail&&e.detail.value?e.detail.value[this.$.textarea.selectionStart-1]:"";":"!==t&&null===this._colonIndex||(":"===t&&(this.$.textarea.selectionStart<2||" "===e.detail.value[this.$.textarea.selectionStart-2])&&(this._colonIndex=this.$.textarea.selectionStart-1),null!==this._colonIndex&&(this._currentSearchString=e.detail.value.substr(this._colonIndex+1,this.$.textarea.selectionStart-this._colonIndex-1),this.$.textarea.selectionStart===this._currentSearchString.length+this._colonIndex+1&&" "!==this._currentSearchString&&"\n"!==this._currentSearchString&&":"===e.detail.value[this._colonIndex]&&this._suggestions&&this._suggestions.length?this.$.emojiSuggestions.isHidden&&this._updateCaratPosition():this._resetEmojiDropdown(),this.$.textarea.textarea.focus()))}_openEmojiDropdown(){this.$.emojiSuggestions.open(),this.reporting.reportInteraction("open-emoji-dropdown")}_formatSuggestions(e){const t=[];for(const n of e)n.dataValue=n.value,n.text=n.value+" "+n.match,t.push(n);this.set("_suggestions",t)}_determineSuggestions(e){if(e.length){const t=bb.filter(t=>t.match.includes(e)).slice(0,10);this._formatSuggestions(t),this.disableEnterKeyForSelectingEmoji=!1}else this._formatSuggestions(bb),this.disableEnterKeyForSelectingEmoji=!0}_resetEmojiDropdown(){Mo(),this._currentSearchString="",this._hideAutocomplete=!0,this.closeDropdown(),this._colonIndex=null,this.$.textarea.textarea.focus()}_handleTextChanged(e){this.dispatchEvent(new CustomEvent("value-changed",{detail:{value:e}}))}};yb([Bl({type:Boolean})],wb.prototype,"autocomplete",void 0),yb([Bl({type:Boolean})],wb.prototype,"disabled",void 0),yb([Bl({type:Number})],wb.prototype,"rows",void 0),yb([Bl({type:Number})],wb.prototype,"maxRows",void 0),yb([Bl({type:String})],wb.prototype,"placeholder",void 0),yb([Bl({type:String,notify:!0,observer:"_handleTextChanged"})],wb.prototype,"text",void 0),yb([Bl({type:Boolean})],wb.prototype,"hideBorder",void 0),yb([Bl({type:Boolean})],wb.prototype,"monospace",void 0),yb([Bl({type:Boolean})],wb.prototype,"code",void 0),yb([Bl({type:Number})],wb.prototype,"_colonIndex",void 0),yb([Bl({type:String,observer:"_determineSuggestions"})],wb.prototype,"_currentSearchString",void 0),yb([Bl({type:Boolean})],wb.prototype,"_hideAutocomplete",void 0),yb([Bl({type:Number})],wb.prototype,"_index",void 0),yb([Bl({type:Array})],wb.prototype,"_suggestions",void 0),yb([Bl({type:Number})],wb.prototype,"_verticalOffset",void 0),wb=yb([Ml("gr-textarea")],wb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Cb=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    :host([disabled]) {
      opacity: 0.5;
      pointer-events: none;
    }
    .main {
      display: flex;
      flex-direction: column;
      width: 100%;
    }
    p {
      margin-bottom: var(--spacing-l);
    }
    label {
      cursor: pointer;
      display: block;
      width: 100%;
    }
    iron-autogrow-textarea {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      width: 73ch; /* Add a char to account for the border. */
    }
  </style>
  <gr-dialog
    confirm-label="Delete"
    on-confirm="_handleConfirmTap"
    on-cancel="_handleCancelTap"
  >
    <div class="header" slot="header">Delete Comment</div>
    <div class="main" slot="main">
      <p>
        This is an admin function. Please only use in exceptional circumstances.
      </p>
      <label for="messageInput">Enter comment delete reason</label>
      <iron-autogrow-textarea
        id="messageInput"
        class="message"
        autocomplete="on"
        placeholder="<Insert reasoning here>"
        bind-value="{{message}}"
      ></iron-autogrow-textarea>
    </div>
  </gr-dialog>
`;var Eb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Sb=class extends(oo(dr(oa))){static get template(){return Cb}static get is(){return"gr-confirm-delete-comment-dialog"}resetFocus(){this.$.messageInput.textarea.focus()}_handleConfirmTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("confirm",{detail:{reason:this.message},composed:!0,bubbles:!1}))}_handleCancelTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1}))}};Eb([Bl({type:String})],Sb.prototype,"message",void 0),Sb=Eb([Ml("gr-confirm-delete-comment-dialog")],Sb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ab=ta`
  <style include="shared-styles">
    :host {
      display: block;
      font-family: var(--font-family);
      padding: var(--spacing-m);
    }
    :host([collapsed]) {
      padding: var(--spacing-s) var(--spacing-m);
    }
    :host([disabled]) {
      pointer-events: none;
    }
    :host([disabled]) .actions,
    :host([disabled]) .robotActions,
    :host([disabled]) .date {
      opacity: 0.5;
    }
    :host([discarding]) {
      display: none;
    }
    .body {
      padding-top: var(--spacing-m);
    }
    .header {
      align-items: center;
      cursor: pointer;
      display: flex;
    }
    .headerLeft > span {
      font-weight: var(--font-weight-bold);
    }
    .headerMiddle {
      color: var(--deemphasized-text-color);
      flex: 1;
      overflow: hidden;
    }
    .draftLabel,
    .draftTooltip {
      color: var(--deemphasized-text-color);
      display: none;
    }
    .date {
      justify-content: flex-end;
      text-align: right;
      white-space: nowrap;
    }
    span.date {
      color: var(--deemphasized-text-color);
    }
    span.date:hover {
      text-decoration: underline;
    }
    .actions,
    .robotActions {
      display: flex;
      justify-content: flex-end;
      padding-top: 0;
    }
    .robotActions {
      /* Better than the negative margin would be to remove the gr-button
       * padding, but then we would also need to fix the buttons that are
       * inserted by plugins. :-/ */
      margin: 4px 0 -4px;
    }
    .action {
      margin-left: var(--spacing-l);
    }
    .rightActions {
      display: flex;
      justify-content: flex-end;
    }
    .rightActions gr-button {
      --gr-button: {
        height: 20px;
        padding: 0 var(--spacing-s);
      }
    }
    .editMessage {
      display: none;
      margin: var(--spacing-m) 0;
      width: 100%;
    }
    .container:not(.draft) .actions .hideOnPublished {
      display: none;
    }
    .draft .reply,
    .draft .quote,
    .draft .ack,
    .draft .done {
      display: none;
    }
    .draft .draftLabel,
    .draft .draftTooltip {
      display: inline;
    }
    .draft:not(.editing):not(.unableToSave) .save,
    .draft:not(.editing) .cancel {
      display: none;
    }
    .editing .message,
    .editing .reply,
    .editing .quote,
    .editing .ack,
    .editing .done,
    .editing .edit,
    .editing .discard,
    .editing .unresolved {
      display: none;
    }
    .editing .editMessage {
      display: block;
    }
    .show-hide {
      margin-left: var(--spacing-s);
    }
    .robotId {
      color: var(--deemphasized-text-color);
      margin-bottom: var(--spacing-m);
    }
    .robotRun {
      margin-left: var(--spacing-m);
    }
    .robotRunLink {
      margin-left: var(--spacing-m);
    }
    input.show-hide {
      display: none;
    }
    label.show-hide {
      cursor: pointer;
      display: block;
    }
    label.show-hide iron-icon {
      vertical-align: top;
    }
    #container .collapsedContent {
      display: none;
    }
    #container.collapsed .body {
      padding-top: 0;
    }
    #container.collapsed .collapsedContent {
      display: block;
      overflow: hidden;
      padding-left: var(--spacing-m);
      text-overflow: ellipsis;
      white-space: nowrap;
    }
    #container.collapsed #deleteBtn,
    #container.collapsed .date,
    #container.collapsed .actions,
    #container.collapsed gr-formatted-text,
    #container.collapsed gr-textarea,
    #container.collapsed .respectfulReviewTip {
      display: none;
    }
    .resolve,
    .unresolved {
      align-items: center;
      display: flex;
      flex: 1;
      margin: 0;
    }
    .resolve label {
      color: var(--comment-text-color);
    }
    gr-dialog .main {
      display: flex;
      flex-direction: column;
      width: 100%;
    }
    #deleteBtn {
      display: none;
      --gr-button: {
        color: var(--deemphasized-text-color);
        padding: 0;
      }
    }
    #deleteBtn.showDeleteButtons {
      display: block;
    }

    /** Disable select for the caret and actions */
    .actions,
    .show-hide {
      -webkit-user-select: none;
      -moz-user-select: none;
      -ms-user-select: none;
      user-select: none;
    }

    .respectfulReviewTip {
      justify-content: space-between;
      display: flex;
      padding: var(--spacing-m);
      border: 1px solid var(--border-color);
      border-radius: var(--border-radius);
      margin-bottom: var(--spacing-m);
    }
    .respectfulReviewTip div {
      display: flex;
    }
    .respectfulReviewTip div iron-icon {
      margin-right: var(--spacing-s);
    }
    .respectfulReviewTip a {
      white-space: nowrap;
      margin-right: var(--spacing-s);
      padding-left: var(--spacing-m);
      text-decoration: none;
    }
    .pointer {
      cursor: pointer;
    }
    .patchset-text {
      color: var(--deemphasized-text-color);
      margin-left: var(--spacing-s);
    }
    .headerLeft gr-account-label {
      --gr-account-label-text-style: {
        font-weight: var(--font-weight-bold);
      }
      --account-max-length: 120px;
      width: 120px;
    }
    .draft gr-account-label {
      width: unset;
    }
  </style>
  <div id="container" class="container">
    <div class="header" id="header" on-click="_handleToggleCollapsed">
      <div class="headerLeft">
        <gr-account-label
          account="[[_getAuthor(comment, _selfAccount)]]"
          class$="[[_computeAccountLabelClass(draft)]]"
          hide-status=""
        >
        </gr-account-label>
        <gr-tooltip-content
          class="draftTooltip"
          has-tooltip=""
          title="[[_computeDraftTooltip(_unableToSave)]]"
          max-width="20em"
          show-icon=""
        >
          <span class="draftLabel">[[_computeDraftText(_unableToSave)]]</span>
        </gr-tooltip-content>
      </div>
      <div class="headerMiddle">
        <span class="collapsedContent">[[comment.message]]</span>
      </div>
      <div
        hidden$="[[_computeHideRunDetails(comment, collapsed)]]"
        class="runIdMessage message"
      >
        <div class="runIdInformation">
          <a class="robotRunLink" href$="[[comment.url]]">
            <span class="robotRun link">Run Details</span>
          </a>
        </div>
      </div>
      <gr-button
        id="deleteBtn"
        link=""
        class$="action delete [[_computeDeleteButtonClass(_isAdmin, draft)]]"
        hidden$="[[isRobotComment]]"
        on-click="_handleCommentDelete"
      >
        <iron-icon id="icon" icon="gr-icons:delete"></iron-icon>
      </gr-button>
      <template is="dom-if" if="[[showPatchset]]">
        <span class="patchset-text"> Patchset [[patchNum]]</span>
      </template>
      <span class="separator"></span>
      <template is="dom-if" if="[[comment.updated]]">
        <span class="date" tabindex="0" on-click="_handleAnchorClick">
          <gr-date-formatter
            has-tooltip=""
            date-str="[[comment.updated]]"
          ></gr-date-formatter>
        </span>
      </template>
      <div class="show-hide" tabindex="0">
        <label
          class="show-hide"
          aria-label="[[_computeShowHideAriaLabel(collapsed)]]"
        >
          <input
            type="checkbox"
            class="show-hide"
            checked$="[[collapsed]]"
            on-change="_handleToggleCollapsed"
          />
          <iron-icon id="icon" icon="[[_computeShowHideIcon(collapsed)]]">
          </iron-icon>
        </label>
      </div>
    </div>
    <div class="body">
      <template is="dom-if" if="[[isRobotComment]]">
        <div class="robotId" hidden$="[[collapsed]]">
          [[comment.author.name]]
        </div>
      </template>
      <template is="dom-if" if="[[editing]]">
        <gr-textarea
          id="editTextarea"
          class="editMessage"
          autocomplete="on"
          code=""
          disabled="{{disabled}}"
          rows="4"
          text="{{_messageText}}"
        ></gr-textarea>
        <template
          is="dom-if"
          if="[[_computeVisibilityOfTip(_showRespectfulTip, _respectfulTipDismissed)]]"
        >
          <div class="respectfulReviewTip">
            <div>
              <gr-tooltip-content
                has-tooltip=""
                title="Tips for respectful code reviews."
              >
                <iron-icon
                  class="pointer"
                  icon="gr-icons:lightbulb-outline"
                ></iron-icon>
              </gr-tooltip-content>
              [[_respectfulReviewTip]]
            </div>
            <div>
              <a
                tabindex="-1"
                on-click="_onRespectfulReadMoreClick"
                href="https://testing.googleblog.com/2019/11/code-health-respectful-reviews-useful.html"
                target="_blank"
              >
                Read more
              </a>
              <a
                tabindex="-1"
                class="close pointer"
                on-click="_dismissRespectfulTip"
                >Not helpful</a
              >
            </div>
          </div>
        </template>
      </template>
      <!--The message class is needed to ensure selectability from
        gr-diff-selection.-->
      <gr-formatted-text
        class="message"
        content="[[comment.message]]"
        no-trailing-margin="[[!comment.__draft]]"
        config="[[projectConfig.commentlinks]]"
      ></gr-formatted-text>
      <div class="actions humanActions" hidden$="[[!_showHumanActions]]">
        <div class="action resolve hideOnPublished">
          <label>
            <input
              type="checkbox"
              id="resolvedCheckbox"
              checked="[[resolved]]"
              on-change="_handleToggleResolved"
            />
            Resolved
          </label>
        </div>
        <template is="dom-if" if="[[draft]]">
          <div class="rightActions">
            <gr-button
              link=""
              class="action cancel hideOnPublished"
              on-click="_handleCancel"
              >Cancel</gr-button
            >
            <gr-button
              link=""
              class="action discard hideOnPublished"
              on-click="_handleDiscard"
              >Discard</gr-button
            >
            <gr-button
              link=""
              class="action edit hideOnPublished"
              on-click="_handleEdit"
              >Edit</gr-button
            >
            <gr-button
              link=""
              disabled$="[[_computeSaveDisabled(_messageText, comment, resolved)]]"
              class="action save hideOnPublished"
              on-click="_handleSave"
              >Save</gr-button
            >
          </div>
        </template>
      </div>
      <div class="robotActions" hidden$="[[!_showRobotActions]]">
        <template is="dom-if" if="[[isRobotComment]]">
          <gr-endpoint-decorator name="robot-comment-controls">
            <gr-endpoint-param name="comment" value="[[comment]]">
            </gr-endpoint-param>
          </gr-endpoint-decorator>
          <gr-button
            link=""
            secondary=""
            class="action show-fix"
            hidden$="[[_hasNoFix(comment)]]"
            on-click="_handleShowFix"
          >
            Show Fix
          </gr-button>
          <template is="dom-if" if="[[!_hasHumanReply]]">
            <gr-button
              link=""
              class="action fix"
              on-click="_handleFix"
              disabled="[[robotButtonDisabled]]"
            >
              Please Fix
            </gr-button>
          </template>
        </template>
      </div>
    </div>
  </div>
  <template is="dom-if" if="[[_enableOverlay]]">
    <gr-overlay id="confirmDeleteOverlay" with-backdrop="">
      <gr-confirm-delete-comment-dialog
        id="confirmDeleteComment"
        on-confirm="_handleConfirmDeleteComment"
        on-cancel="_handleCancelDeleteComment"
      >
      </gr-confirm-delete-comment-dialog>
    </gr-overlay>
    <gr-overlay id="confirmDiscardOverlay" with-backdrop="">
      <gr-dialog
        id="confirmDiscardDialog"
        confirm-label="Discard"
        confirm-on-enter=""
        on-confirm="_handleConfirmDiscard"
        on-cancel="_closeConfirmDiscardOverlay"
      >
        <div class="header" slot="header">
          Discard comment
        </div>
        <div class="main" slot="main">
          Are you sure you want to discard this draft comment?
        </div>
      </gr-dialog>
    </gr-overlay>
  </template>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-storage id="storage"></gr-storage>
`;var xb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Pb="Saving",Rb=["Assume competence.","Provide rationale or context.","Consider how comments may be interpreted.","Avoid harsh language.","Make your comments specific and actionable.","When disagreeing, explain the advantage of your approach."];let Tb=class extends(xp(oo(dr(oa)))){constructor(){super(...arguments),this.isRobotComment=!1,this.disabled=!1,this.draft=!1,this.editing=!1,this.discarding=!1,this.collapsed=!0,this._isAdmin=!1,this._messageText="",this._numPendingDraftRequests={number:0},this._enableOverlay=!1,this._overlays={},this._showRespectfulTip=!1,this.showPatchset=!0,this._respectfulTipDismissed=!1,this._unableToSave=!1,this.reporting=n.reportingService}static get template(){return Ab}get keyBindings(){return{"ctrl+enter meta+enter ctrl+s meta+s":"_handleSaveKey",esc:"_handleEsc"}}attached(){super.attached(),this.$.restAPI.getAccount().then(e=>{this._selfAccount=e}),this.editing?this.collapsed=!1:this.comment&&(this.collapsed=!!this.comment.collapsed),this._getIsAdmin().then(e=>{this._isAdmin=!!e})}detached(){super.detached(),this.cancelDebouncer("fire-update"),this.textarea&&this.textarea.closeDropdown()}_getAuthor(e){return e.author||this._selfAccount}_onEditingChange(e){if(this.dispatchEvent(new CustomEvent("comment-editing-changed",{detail:!!e,bubbles:!0,composed:!0})),!e)return;if(!this.$.storage.getRespectfulTipVisibility()){if(this.getRandomNum(0,3)>=1)return;this._showRespectfulTip=!0;const e=this.getRandomNum(0,Rb.length);this._respectfulReviewTip=Rb[e],this.reporting.reportInteraction("respectful-tip-appeared",{tip:this._respectfulReviewTip}),this.$.storage.setRespectfulTipVisibility()}}getRandomNum(e,t){return Math.floor(Math.random()*(t-e)+e)}_computeVisibilityOfTip(e,t){return e&&!t}_dismissRespectfulTip(){this._respectfulTipDismissed=!0,this.reporting.reportInteraction("respectful-tip-dismissed",{tip:this._respectfulReviewTip}),this.$.storage.setRespectfulTipVisibility(14)}_onRespectfulReadMoreClick(){this.reporting.reportInteraction("respectful-read-more-clicked")}get textarea(){var e;return null===(e=this.shadowRoot)||void 0===e?void 0:e.querySelector("#editTextarea")}get confirmDeleteOverlay(){var e;return this._overlays.confirmDelete||(this._enableOverlay=!0,Mo(),this._overlays.confirmDelete=null===(e=this.shadowRoot)||void 0===e?void 0:e.querySelector("#confirmDeleteOverlay")),this._overlays.confirmDelete}get confirmDiscardOverlay(){var e;return this._overlays.confirmDiscard||(this._enableOverlay=!0,Mo(),this._overlays.confirmDiscard=null===(e=this.shadowRoot)||void 0===e?void 0:e.querySelector("#confirmDiscardOverlay")),this._overlays.confirmDiscard}_computeShowHideIcon(e){return e?"gr-icons:expand-more":"gr-icons:expand-less"}_computeShowHideAriaLabel(e){return e?"Expand":"Collapse"}_calculateActionstoShow(e,t){[e,t].includes(void 0)||(this._showHumanActions=e&&!t,this._showRobotActions=e&&t)}_isRobotComment(e){this.isRobotComment=!!e.robot_id}isOnParent(){return"PARENT"===this.side}_getIsAdmin(){return this.$.restAPI.getIsAdmin()}_computeDraftTooltip(e){return e?"Unable to save draft. Please try to save again.":"This draft is only visible to you. To publish drafts, click the 'Reply'or 'Start review' button at the top of the change or press the 'A' key."}_computeDraftText(e){return"DRAFT"+(e?"(Failed to save)":"")}save(e){let t=e;return t||(t=this.comment),this.set("comment.message",this._messageText),this.editing=!1,this.disabled=!0,this._messageText?(this._xhrPromise=this._saveDraft(t).then(e=>{if(this.disabled=!1,e.ok)return this._eraseDraftComment(),this.$.restAPI.getResponseObject(e).then(e=>{var t;const n=e;if(!Hf(this.comment))throw new Error("Can only save drafts.");return n.__draft=!0,(null===(t=this.comment)||void 0===t?void 0:t.__draftID)&&(n.__draftID=this.comment.__draftID),n.__commentSide=this.commentSide,this.comment=n,this._fireSave(),e})}).catch(e=>{throw this.disabled=!1,e}),this._xhrPromise):this._discardDraft()}_eraseDraftComment(){var e;if(this.cancelDebouncer("store"),!(null===(e=this.comment)||void 0===e?void 0:e.path))throw new Error("Cannot erase Draft Comment");if(void 0===this.changeNum)throw new Error("undefined changeNum");this.$.storage.eraseDraftComment({changeNum:this.changeNum,patchNum:this._getPatchNum(),path:this.comment.path,line:this.comment.line,range:this.comment.range})}_commentChanged(e){this.editing=!!e.__editing,this.resolved=!e.unresolved,this.editing&&this._fireUpdate()}_computeHasHumanReply(){const e=this.comment;e&&this.comments&&(this._hasHumanReply=this.comments.some(t=>t.in_reply_to&&t.in_reply_to===e.id&&!t.robot_id))}_getEventPayload(){return{comment:this.comment,patchNum:this.patchNum}}_fireSave(){this.dispatchEvent(new CustomEvent("comment-save",{detail:this._getEventPayload(),composed:!0,bubbles:!0}))}_fireUpdate(){this.debounce("fire-update",()=>{this.dispatchEvent(new CustomEvent("comment-update",{detail:this._getEventPayload(),composed:!0,bubbles:!0}))})}_computeAccountLabelClass(e){return e?"draft":""}_draftChanged(e){this.$.container.classList.toggle("draft",e)}_editingChanged(e,t){var n;if(void 0!==t){if(this.$.container.classList.toggle("editing",e),this.comment&&this.comment.id){const t=null===(n=this.shadowRoot)||void 0===n?void 0:n.querySelector(".cancel");t&&(t.hidden=!e)}this.comment&&(this.comment.__editing=this.editing),!!e!=!!t&&this._fireUpdate(),e&&this.async(()=>{Mo(),this.textarea&&this.textarea.putCursorAtEnd()},1)}}_computeDeleteButtonClass(e,t){return e&&!t?"showDeleteButtons":""}_computeSaveDisabled(e,t,n){return!(!t||t.unresolved===n&&e)&&(!e||""===e.trim())}_handleSaveKey(e){this._computeSaveDisabled(this._messageText,this.comment,this.resolved)||(e.preventDefault(),this._handleSave(e))}_handleEsc(e){this._messageText.length||(e.preventDefault(),this._handleCancel(e))}_handleToggleCollapsed(){this.collapsed=!this.collapsed}_toggleCollapseClass(e){e?this.$.container.classList.add("collapsed"):this.$.container.classList.remove("collapsed")}_commentMessageChanged(e){this._messageText=e||""}_messageTextChanged(e,t){if(!this.comment||this.comment&&this.comment.id)return;const n=this.comment.patch_set?this.comment.patch_set:this._getPatchNum(),{path:i,line:o,range:s}=this.comment;i&&this.debounce("store",()=>{const e=this._messageText;if(void 0===this.changeNum)throw new Error("undefined changeNum");const r={changeNum:this.changeNum,patchNum:n,path:i,line:o,range:s};e&&e.length||!t?this.$.storage.setDraftComment(r,e):this.$.storage.eraseDraftComment(r)},400)}_handleAnchorClick(e){e.preventDefault(),this.comment&&this.dispatchEvent(new CustomEvent("comment-anchor-tap",{bubbles:!0,composed:!0,detail:{number:this.comment.line||"FILE",side:this.side}}))}_handleEdit(e){var t;e.preventDefault(),(null===(t=this.comment)||void 0===t?void 0:t.message)&&(this._messageText=this.comment.message),this.editing=!0,this.reporting.recordDraftInteraction()}_handleSave(e){var t;if(e.preventDefault(),this.disabled)return;const n=(null===(t=this.comment)||void 0===t?void 0:t.id)?"UpdateDraftComment":"CreateDraftComment",i=this.reporting.getTimer(n);return this.set("comment.__editing",!1),this.save().then(()=>{i.end()})}_handleCancel(e){var t;e.preventDefault(),(null===(t=this.comment)||void 0===t?void 0:t.message)&&0!==this.comment.message.trim().length&&this.comment.id?(this._messageText=this.comment.message,this.editing=!1):this._fireDiscard()}_fireDiscard(){this.cancelDebouncer("fire-update"),this.dispatchEvent(new CustomEvent("comment-discard",{detail:this._getEventPayload(),composed:!0,bubbles:!0}))}_handleFix(){this.dispatchEvent(new CustomEvent("create-fix-comment",{bubbles:!0,composed:!0,detail:this._getEventPayload()}))}_handleShowFix(){this.dispatchEvent(new CustomEvent("open-fix-preview",{bubbles:!0,composed:!0,detail:this._getEventPayload()}))}_hasNoFix(e){return!e||!e.fix_suggestions}_handleDiscard(e){e.preventDefault(),this.reporting.recordDraftInteraction(),this._messageText?this._openOverlay(this.confirmDiscardOverlay).then(()=>{var e;const t=null===(e=this.confirmDiscardOverlay)||void 0===e?void 0:e.querySelector("#confirmDiscardDialog");t&&t.resetFocus()}):this._discardDraft()}_handleConfirmDiscard(e){e.preventDefault();const t=this.reporting.getTimer("DiscardDraftComment");return this._closeConfirmDiscardOverlay(),this._discardDraft().then(()=>{t.end()})}_discardDraft(){return this.comment?Hf(this.comment)?(this.discarding=!0,this.editing=!1,this.disabled=!0,this._eraseDraftComment(),this.comment.id?(this._xhrPromise=this._deleteDraft(this.comment).then(e=>(this.disabled=!1,e.ok||(this.discarding=!1),this._fireDiscard(),e)).catch(e=>{throw this.disabled=!1,e}),this._xhrPromise):(this.disabled=!1,this._fireDiscard(),Promise.resolve())):Promise.reject(new Error("Cannot discard a non-draft comment.")):Promise.reject(new Error("undefined comment"))}_closeConfirmDiscardOverlay(){this._closeOverlay(this.confirmDiscardOverlay)}_getSavingMessage(e,t){return t?"Unable to save draft":0===e?"All changes saved":[Pb,e,1===e?"draft...":"drafts..."].join(" ")}_showStartRequest(){const e=++this._numPendingDraftRequests.number;this._updateRequestToast(e)}_showEndRequest(){const e=--this._numPendingDraftRequests.number;this._updateRequestToast(e)}_handleFailedDraftRequest(){this._numPendingDraftRequests.number--,this.cancelDebouncer("draft-toast"),this._updateRequestToast(this._numPendingDraftRequests.number,!0)}_updateRequestToast(e,t){const n=this._getSavingMessage(e,t);this.debounce("draft-toast",()=>{document.body.dispatchEvent(new CustomEvent("show-alert",{detail:{message:n},bubbles:!0,composed:!0}))},200)}_handleDraftFailure(){this.$.container.classList.add("unableToSave"),this._unableToSave=!0,this._handleFailedDraftRequest()}_saveDraft(e){if(!e||void 0===this.changeNum||void 0===this.patchNum)throw new Error("undefined draft or changeNum or patchNum");return this._showStartRequest(),this.$.restAPI.saveDiffDraft(this.changeNum,this.patchNum,e).then(e=>(e.ok?(this._unableToSave=!1,this.$.container.classList.remove("unableToSave"),this._showEndRequest()):this._handleDraftFailure(),e)).catch(e=>{throw this._handleDraftFailure(),e})}_deleteDraft(e){if(void 0===this.changeNum||void 0===this.patchNum)throw new Error("undefined changeNum or patchNum");if(this._showStartRequest(),!e.id)throw new Error("Missing id in comment draft.");return this.$.restAPI.deleteDiffDraft(this.changeNum,this.patchNum,{id:e.id}).then(e=>(e.ok?this._showEndRequest():this._handleFailedDraftRequest(),e))}_getPatchNum(){const e=this.isOnParent()?"PARENT":this.patchNum;if(void 0===e)throw new Error("patchNum undefined");return e}_loadLocalDraft(e,t,n){if([e,t,n].includes(void 0))return;if(!n||n.id||n.message||n.__otherEditing||!n.path)return void(n&&delete n.__otherEditing);const i=this.$.storage.getDraftComment({changeNum:e,patchNum:this._getPatchNum(),path:n.path,line:n.line,range:n.range});i&&this.set("comment.message",i.message)}_handleToggleResolved(){this.reporting.recordDraftInteraction(),this.resolved=!this.resolved;const e=this._getEventPayload();if(!e.comment)throw new Error("comment not defined in payload");e.comment.unresolved=!this.$.resolvedCheckbox.checked,this.dispatchEvent(new CustomEvent("comment-update",{detail:e,composed:!0,bubbles:!0})),this.editing||this.save(e.comment)}_handleCommentDelete(){this._openOverlay(this.confirmDeleteOverlay)}_handleCancelDeleteComment(){this._closeOverlay(this.confirmDeleteOverlay)}_openOverlay(e){return e?(mh().appendChild(e),e.open()):Promise.reject(new Error("undefined overlay"))}_computeHideRunDetails(e,t){return!e||!(e.robot_id&&e.url&&!t)}_closeOverlay(e){e&&(mh().removeChild(e),e.close())}_handleConfirmDeleteComment(){var e;const t=null===(e=this.confirmDeleteOverlay)||void 0===e?void 0:e.querySelector("#confirmDeleteComment");if(!t||!t.message)throw new Error("missing confirm delete dialog");if(!this.comment||!this.comment.id||void 0===this.changeNum||void 0===this.patchNum)throw new Error("undefined comment or id or changeNum or patchNum");this.$.restAPI.deleteComment(this.changeNum,this.patchNum,this.comment.id,t.message).then(e=>{this._handleCancelDeleteComment(),this.comment=e})}};xb([Bl({type:Number})],Tb.prototype,"changeNum",void 0),xb([Bl({type:Object,notify:!0,observer:"_commentChanged"})],Tb.prototype,"comment",void 0),xb([Bl({type:Array})],Tb.prototype,"comments",void 0),xb([Bl({type:Boolean,reflectToAttribute:!0})],Tb.prototype,"isRobotComment",void 0),xb([Bl({type:Boolean,reflectToAttribute:!0})],Tb.prototype,"disabled",void 0),xb([Bl({type:Boolean,observer:"_draftChanged"})],Tb.prototype,"draft",void 0),xb([Bl({type:Boolean,observer:"_editingChanged"})],Tb.prototype,"editing",void 0),xb([Bl({type:Boolean,reflectToAttribute:!0})],Tb.prototype,"discarding",void 0),xb([Bl({type:Boolean})],Tb.prototype,"hasChildren",void 0),xb([Bl({type:String})],Tb.prototype,"patchNum",void 0),xb([Bl({type:Boolean})],Tb.prototype,"showActions",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_showHumanActions",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_showRobotActions",void 0),xb([Bl({type:Boolean,reflectToAttribute:!0,observer:"_toggleCollapseClass"})],Tb.prototype,"collapsed",void 0),xb([Bl({type:Object})],Tb.prototype,"projectConfig",void 0),xb([Bl({type:Boolean})],Tb.prototype,"robotButtonDisabled",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_hasHumanReply",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_isAdmin",void 0),xb([Bl({type:Object})],Tb.prototype,"_xhrPromise",void 0),xb([Bl({type:String,observer:"_messageTextChanged"})],Tb.prototype,"_messageText",void 0),xb([Bl({type:String})],Tb.prototype,"commentSide",void 0),xb([Bl({type:String})],Tb.prototype,"side",void 0),xb([Bl({type:Boolean})],Tb.prototype,"resolved",void 0),xb([Bl({type:Object})],Tb.prototype,"_numPendingDraftRequests",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_enableOverlay",void 0),xb([Bl({type:Object})],Tb.prototype,"_overlays",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_showRespectfulTip",void 0),xb([Bl({type:Boolean})],Tb.prototype,"showPatchset",void 0),xb([Bl({type:String})],Tb.prototype,"_respectfulReviewTip",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_respectfulTipDismissed",void 0),xb([Bl({type:Boolean})],Tb.prototype,"_unableToSave",void 0),xb([Bl({type:Object})],Tb.prototype,"_selfAccount",void 0),xb([jl("editing")],Tb.prototype,"_onEditingChange",null),xb([jl("showActions","isRobotComment")],Tb.prototype,"_calculateActionstoShow",null),xb([jl("comment")],Tb.prototype,"_isRobotComment",null),xb([jl("comment","comments.*")],Tb.prototype,"_computeHasHumanReply",null),xb([jl("comment.message")],Tb.prototype,"_commentMessageChanged",null),xb([jl("changeNum","patchNum","comment")],Tb.prototype,"_loadLocalDraft",null),Tb=xb([Ml("gr-comment")],Tb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ib=ta`
  <style include="shared-styles">
    :host {
      font-family: var(--font-family);
      font-size: var(--font-size-normal);
      font-weight: var(--font-weight-normal);
      line-height: var(--line-height-normal);
    }
    gr-button {
      margin-left: var(--spacing-m);
    }
    gr-comment {
      border-bottom: 1px solid var(--comment-separator-color);
    }
    #actions {
      margin-left: auto;
      padding: var(--spacing-s) var(--spacing-m);
    }
    #container {
      background-color: var(--comment-background-color);
      color: var(--comment-text-color);
      display: var(--gr-comment-thread-display, block);
      margin: 0 var(--spacing-s) var(--spacing-s);
      white-space: normal;
      box-shadow: var(--elevation-level-2);
      border-radius: var(--border-radius);
      /** This is required for firefox to continue the inheritance */
      -webkit-user-select: inherit;
      -moz-user-select: inherit;
      -ms-user-select: inherit;
      user-select: inherit;
    }
    #container.unresolved {
      background-color: var(--unresolved-comment-background-color);
    }
    #container.robotComment {
      background-color: var(--robot-comment-background-color);
    }
    #commentInfoContainer {
      display: flex;
    }
    #unresolvedLabel {
      font-family: var(--font-family);
      margin: auto 0;
      padding: var(--spacing-m);
    }
    .pathInfo {
      display: flex;
      align-items: baseline;
      justify-content: space-between;
      padding: 0 var(--spacing-s) var(--spacing-s);
    }
    .descriptionText {
      margin-left: var(--spacing-m);
      font-style: italic;
    }
    .fileName {
      padding: var(--spacing-m) var(--spacing-s) var(--spacing-m);
    }
  </style>
  <template is="dom-if" if="[[showFilePath]]">
    <template is="dom-if" if="[[showFileName]]">
      <div class="fileName">
        <template is="dom-if" if="[[_isPatchsetLevelComment(path)]]">
          <span> [[_computeDisplayPath(path)]] </span>
        </template>
        <template is="dom-if" if="[[!_isPatchsetLevelComment(path)]]">
          <a href$="[[_getDiffUrlForPath(path)]]">
            [[_computeDisplayPath(path)]]
          </a>
        </template>
      </div>
    </template>
    <div class="pathInfo">
      <template is="dom-if" if="[[!_isPatchsetLevelComment(path)]]">
        <a
          href$="[[_getDiffUrlForComment(projectName, changeNum, path, patchNum)]]"
          >[[_computeDisplayLine()]]</a
        >
      </template>
    </div>
  </template>
  <div
    id="container"
    class$="[[_computeHostClass(unresolved, isRobotComment)]]"
  >
    <template
      id="commentList"
      is="dom-repeat"
      items="[[_orderedComments]]"
      as="comment"
    >
      <gr-comment
        comment="{{comment}}"
        comments="{{comments}}"
        robot-button-disabled="[[_shouldDisableAction(_showActions, _lastComment)]]"
        change-num="[[changeNum]]"
        patch-num="[[patchNum]]"
        draft="[[_isDraft(comment)]]"
        show-actions="[[_showActions]]"
        show-patchset="[[showPatchset]]"
        comment-side="[[comment.__commentSide]]"
        side="[[comment.side]]"
        project-config="[[_projectConfig]]"
        on-create-fix-comment="_handleCommentFix"
        on-comment-discard="_handleCommentDiscard"
        on-comment-save="_handleCommentSavedOrDiscarded"
      ></gr-comment>
    </template>
    <div
      id="commentInfoContainer"
      hidden$="[[_hideActions(_showActions, _lastComment)]]"
    >
      <span id="unresolvedLabel" hidden$="[[!unresolved]]">Unresolved</span>
      <div id="actions">
        <gr-button
          id="replyBtn"
          link=""
          class="action reply"
          on-click="_handleCommentReply"
          >Reply</gr-button
        >
        <gr-button
          id="quoteBtn"
          link=""
          class="action quote"
          on-click="_handleCommentQuote"
          >Quote</gr-button
        >
        <template is="dom-if" if="[[unresolved]]">
          <gr-button
            id="ackBtn"
            link=""
            class="action ack"
            on-click="_handleCommentAck"
            >Ack</gr-button
          >
          <gr-button
            id="doneBtn"
            link=""
            class="action done"
            on-click="_handleCommentDone"
            >Done</gr-button
          >
        </template>
      </div>
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-storage id="storage"></gr-storage>
`;var kb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Ob=/\n/g;let Nb=class extends(xp(oo(dr(oa)))){constructor(){super(...arguments),this.comments=[],this.keyEventTarget=document.body,this.isOnParent=!1,this.parentIndex=null,this.showFilePath=!1,this._orderedComments=[],this.isRobotComment=!1,this.showFileName=!0,this.showPatchset=!0,this.reporting=n.reportingService,this.flagsService=n.flagsService}static get template(){return Ib}get keyBindings(){return{"e shift+e":"_handleEKey"}}created(){super.created(),this.addEventListener("comment-update",e=>this._handleCommentUpdate(e))}attached(){super.attached(),this._getLoggedIn().then(e=>{this._showActions=e}),this._setInitialExpandedState()}addOrEditDraft(e,t){const n=this.comments[this.comments.length-1]||{};if(Hf(n)){const e=this._commentElWithDraftID(n.id||n.__draftID);if(!e)throw new Error("Failed to find draft.");e.editing=!0,e.collapsed=!1}else{const i=t||(n?n.range:void 0),o=n?n.unresolved:void 0;this.addDraft(e,i,o)}}addDraft(e,t,n){const i=this._newDraft(e,t);i.__editing=!0,i.unresolved=!1!==n||n,this.push("comments",i)}fireRemoveSelf(){this.dispatchEvent(new CustomEvent("thread-discard",{detail:{rootId:this.rootId},bubbles:!1}))}_getDiffUrlForPath(e){if(!this.changeNum)throw new Error("changeNum is missing");if(!this.projectName)throw new Error("projectName is missing");if(Hf(this.comments[0]))return gh.getUrlForDiffById(this.changeNum,this.projectName,e,this.patchNum);const t=this.comments[0].id;if(!t)throw new Error("A published comment is missing the id.");return gh.getUrlForComment(this.changeNum,this.projectName,t)}_getDiffUrlForComment(e,t,n,i){if(!e||!t||!n)return;if(this.comments.length&&"PARENT"===this.comments[0].side||Hf(this.comments[0]))return gh.getUrlForDiffById(t,e,n,i,void 0,this.lineNum);const o=this.comments[0].id;if(!o)throw new Error("A published comment is missing the id.");return gh.getUrlForComment(t,e,o)}_isPatchsetLevelComment(e){return e===ka.PATCHSET_LEVEL_COMMENTS}_computeDisplayPath(e){const t=K_(e);return t===ka.PATCHSET_LEVEL_COMMENTS?"Patchset":t}_computeDisplayLine(){return this.lineNum?`#${this.lineNum}`:this.lineNum||this.range?this.range?`#${this.range.end_line}`:"":this.path===ka.PATCHSET_LEVEL_COMMENTS?"":"FILE"}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_commentsChanged(){this._orderedComments=Gf(this.comments),this.updateThreadProperties()}updateThreadProperties(){this._orderedComments.length&&(this._lastComment=this._getLastComment(),this.unresolved=this._lastComment.unresolved,this.hasDraft=Hf(this._lastComment),this.isRobotComment=jf(this._lastComment))}_shouldDisableAction(e,t){return!e||!t||Hf(t)}_hideActions(e,t){return this._shouldDisableAction(e,t)||jf(t)}_getLastComment(){return this._orderedComments[this._orderedComments.length-1]||{}}_handleEKey(e){var t;if(!this.shouldSuppressKeyboardShortcut(e))if(null===(t=e.detail.keyboardEvent)||void 0===t?void 0:t.shiftKey)this._expandCollapseComments(!0);else{if(this.modifierPressed(e))return;this._expandCollapseComments(!1)}}_expandCollapseComments(e){var t;const n=null===(t=this.root)||void 0===t?void 0:t.querySelectorAll("gr-comment");if(n)for(const t of n)t.collapsed=e}_setInitialExpandedState(){if(this._orderedComments)for(let e=0;e<this._orderedComments.length;e++){const t=this._orderedComments[e],n=!!t.robot_id,i=!this.unresolved||this._orderedComments.length-e-1>=5;void 0===t.collapsed&&(t.collapsed=!n&&i)}}_createReplyComment(e,t,n){this.reporting.recordDraftInteraction();const i=this._orderedComments[this._orderedComments.length-1].id;if(!i)throw new Error("Cannot reply to comment without id.");const o=this._newReply(i,e,n);for(let e=0;e<this.comments.length;e++)if(this.comments[e].__editing){o.__otherEditing=!0;break}t&&(o.__editing=!0),this.push("comments",o),t||this.async(()=>{const e=this._commentElWithDraftID(o.__draftID);e&&e.save()},1)}_isDraft(e){return Hf(e)}_processCommentReply(e){const t=this._lastComment;if(!t)throw new Error("Failed to find last comment.");let n=void 0;if(e){const e=t.message;if(!e)throw new Error("Quoting empty comment.");n="> "+e.replace(Ob,"\n> ")+"\n\n"}this._createReplyComment(n,!0,t.unresolved)}_handleCommentReply(){this._processCommentReply()}_handleCommentQuote(){this._processCommentReply(!0)}_handleCommentAck(){this._createReplyComment("Ack",!1,!1)}_handleCommentDone(){this._createReplyComment("Done",!1,!1)}_handleCommentFix(e){const t="> "+e.detail.comment.message.replace(Ob,"\n> ")+"\n\n"+"Please fix.";this._createReplyComment(t,!1,!0)}_commentElWithDraftID(e){var t;if(!e)return null;const n=null===(t=this.root)||void 0===t?void 0:t.querySelectorAll("gr-comment");if(!n)return null;for(const t of n){const n=t.comment;if(!jf(n)&&((null==n?void 0:n.id)===e||Hf(n)&&(null==n?void 0:n.__draftID)===e))return t}return null}_newReply(e,t,n){const i=this._newDraft();return i.in_reply_to=e,void 0!==t&&(i.message=t),void 0!==n&&(i.unresolved=n),i}_newDraft(e,t){const n={__draft:!0,__draftID:Math.random().toString(36),__date:new Date};if(this.comments&&this.comments.length>=1){const e=this.comments[0];void 0!==e.path&&(n.path=e.path),void 0!==e.patch_set&&(n.patch_set=e.patch_set),void 0!==e.side&&(n.side=e.side),void 0!==e.__commentSide&&(n.__commentSide=e.__commentSide),void 0!==e.line&&(n.line=e.line),void 0!==e.range&&(n.range=e.range),void 0!==e.parent&&(n.parent=e.parent)}else n.path=this.path,n.patch_set=this.patchNum,n.side=this._getSide(this.isOnParent),n.__commentSide=this.commentSide,e&&(n.line=e),t&&(n.range=t),this.parentIndex&&(n.parent=this.parentIndex);return n}_getSide(e){return e?Ka.PARENT:Ka.REVISION}_computeRootId(e){if(!e.base.length)return this.rootId;const t=e.base[0];if(t.id)return t.id;if(Hf(t))return t.__draftID;throw new Error("Missing id in root comment.")}_handleCommentDiscard(e){var t;if(!this.changeNum)throw new Error("changeNum is missing");if(!this.patchNum)throw new Error("patchNum is missing");const n=qo(e).rootTarget,i=n.comment,o=this._indexOf(i,this.comments);if(-1===o)throw new Error("Cannot find comment "+JSON.stringify(n.comment));this.splice("comments",o,1),0===this.comments.length&&this.fireRemoveSelf(),this._handleCommentSavedOrDiscarded();for(const e of this.comments)if(e.__editing){const n={changeNum:this.changeNum,patchNum:this.patchNum,path:e.path,line:e.line};this.$.storage.setDraftComment(n,null!==(t=e.message)&&void 0!==t?t:"")}}_handleCommentSavedOrDiscarded(){this.dispatchEvent(new CustomEvent("thread-changed",{detail:{rootId:this.rootId,path:this.path},bubbles:!1}))}_handleCommentUpdate(e){const t=e.detail.comment,n=this._indexOf(t,this.comments);-1!==n?(this.set(["comments",n],t),this.updateThreadProperties()):console.warn("Comment update for another comment thread.")}_indexOf(e,t){if(!e)return-1;for(let n=0;n<t.length;n++){const i=t[n];if(Hf(i)&&Hf(e)&&i.__draftID===e.__draftID||i.id&&i.id===e.id)return n}return-1}_computeHostClass(e){return this.isRobotComment?"robotComment":e?"unresolved":""}_projectNameChanged(e){e&&this.$.restAPI.getProjectConfig(e).then(e=>{this._projectConfig=e})}};kb([Bl({type:Number})],Nb.prototype,"changeNum",void 0),kb([Bl({type:Array})],Nb.prototype,"comments",void 0),kb([Bl({type:Object,reflectToAttribute:!0})],Nb.prototype,"range",void 0),kb([Bl({type:Object})],Nb.prototype,"keyEventTarget",void 0),kb([Bl({type:String,reflectToAttribute:!0})],Nb.prototype,"commentSide",void 0),kb([Bl({type:String})],Nb.prototype,"patchNum",void 0),kb([Bl({type:String})],Nb.prototype,"path",void 0),kb([Bl({type:String,observer:"_projectNameChanged"})],Nb.prototype,"projectName",void 0),kb([Bl({type:Boolean,notify:!0,reflectToAttribute:!0})],Nb.prototype,"hasDraft",void 0),kb([Bl({type:Boolean})],Nb.prototype,"isOnParent",void 0),kb([Bl({type:Number})],Nb.prototype,"parentIndex",void 0),kb([Bl({type:String,notify:!0,computed:"_computeRootId(comments.*)"})],Nb.prototype,"rootId",void 0),kb([Bl({type:Boolean})],Nb.prototype,"showFilePath",void 0),kb([Bl({type:Number,reflectToAttribute:!0})],Nb.prototype,"lineNum",void 0),kb([Bl({type:Boolean,notify:!0,reflectToAttribute:!0})],Nb.prototype,"unresolved",void 0),kb([Bl({type:Boolean})],Nb.prototype,"_showActions",void 0),kb([Bl({type:Object})],Nb.prototype,"_lastComment",void 0),kb([Bl({type:Array})],Nb.prototype,"_orderedComments",void 0),kb([Bl({type:Object})],Nb.prototype,"_projectConfig",void 0),kb([Bl({type:Boolean,reflectToAttribute:!0})],Nb.prototype,"isRobotComment",void 0),kb([Bl({type:Boolean})],Nb.prototype,"showFileName",void 0),kb([Bl({type:Boolean})],Nb.prototype,"showPatchset",void 0),kb([jl("comments.*")],Nb.prototype,"_commentsChanged",null),Nb=kb([Ml("gr-comment-thread")],Nb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Lb=ta``;var Db=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const $b=new Map([[nc.COVERED,"Covered by tests."],[nc.NOT_COVERED,"Not covered by tests."],[nc.PARTIALLY_COVERED,"Partially covered by tests."],[nc.NOT_INSTRUMENTED,"Not instrumented by any tests."]]);let Mb=class extends(oo(dr(oa))){constructor(){super(...arguments),this.coverageRanges=[],this._lineNumber=0,this._index=0}static get template(){return Lb}annotate(e,t){if(!this.side||!t||!t.classList.contains(this.side))return;let n;const i=t.getAttribute("data-value");if(i&&(n=parseInt(i,10)),n&&!(n<1))for(n<this._lineNumber&&(this._index=0),this._lineNumber=n;this._index<this.coverageRanges.length;){const e=this.coverageRanges[this._index];if(!(this._lineNumber>e.code_range.end_line)){if(this._lineNumber<e.code_range.start_line)return;return t.classList.add(e.type),void(t.title=$b.get(e.type)||"")}this._index++}}};Db([Bl({type:Array})],Mb.prototype,"coverageRanges",void 0),Db([Bl({type:String})],Mb.prototype,"side",void 0),Db([Bl({type:Number})],Mb.prototype,"_lineNumber",void 0),Db([Bl({type:Number})],Mb.prototype,"_index",void 0),Mb=Db([Ml("gr-coverage-layer")],Mb);var Fb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Bb=class extends(oo(dr(oa))){constructor(){super(...arguments),this.context=3,this.groups=[],this.keyLocations={left:{},right:{}},this._asyncThreshold=64,this._nextStepHandle=null,this._processPromise=null}attached(){super.attached(),this.listen(window,"scroll","_handleWindowScroll")}detached(){super.detached(),this.cancel(),this.unlisten(window,"scroll","_handleWindowScroll")}_handleWindowScroll(){this._isScrolling=!0,this.debounce("resetIsScrolling",()=>{this._isScrolling=!1},50)}process(e,t){return this.cancel(),this.groups=[],this.push("groups",this._makeFileComments()),t?Promise.resolve():(this._processPromise=ld.makeCancelable(new Promise(t=>{const n={lineNums:{left:0,right:0},chunkIndex:0};e=this._splitLargeChunks(e),e=this._splitCommonChunksWithKeyLocations(e);let i=0;const o=()=>{if(this._isScrolling)return void(this._nextStepHandle=this.async(o,100));if(n.chunkIndex>=e.length)return t(),void(this._nextStepHandle=null);const s=this._processNext(n,e);for(const e of s.groups)this.push("groups",e),i+=e.lines.length;n.lineNums.left+=s.lineDelta.left,n.lineNums.right+=s.lineDelta.right,n.chunkIndex=s.newChunkIndex,i>=this._asyncThreshold?(i=0,this._nextStepHandle=this.async(o,1)):o.call(this)};o.call(this)})),this._processPromise.finally(()=>{this._processPromise=null}))}cancel(){null!==this._nextStepHandle&&(this.cancelAsync(this._nextStepHandle),this._nextStepHandle=null),this._processPromise&&this._processPromise.cancel()}_processNext(e,t){const n=this._firstUncollapsibleChunkIndex(t,e.chunkIndex);if(n===e.chunkIndex){const n=t[e.chunkIndex];return{lineDelta:{left:this._linesLeft(n).length,right:this._linesRight(n).length},groups:[this._chunkToGroup(n,e.lineNums.left+1,e.lineNums.right+1)],newChunkIndex:e.chunkIndex+1}}return this._processCollapsibleChunks(e,t,n)}_linesLeft(e){return e.ab||e.a||[]}_linesRight(e){return e.ab||e.b||[]}_firstUncollapsibleChunkIndex(e,t){let n=t;for(;n<e.length&&this._isCollapsibleChunk(e[n]);)n++;return n}_isCollapsibleChunk(e){return(e.ab||e.common)&&!e.keyLocation}_processCollapsibleChunks(e,t,n){const i=t.slice(e.chunkIndex,n),o=i.reduce((e,t)=>e+this._commonChunkLength(t),0);let s=this._chunksToGroups(i,e.lineNums.left+1,e.lineNums.right+1);if(-1!==this.context){s=vl(s,0===e.chunkIndex?0:this.context,o-(n===t.length?0:this.context))}return{lineDelta:{left:o,right:o},groups:s,newChunkIndex:n}}_commonChunkLength(e){return console.assert(!!e.ab||!!e.common),console.assert(!e.a||!!e.b&&e.a.length===e.b.length,"common chunk needs same number of a and b lines: ",e),this._linesLeft(e).length}_chunksToGroups(e,t,n){return e.map(e=>{const i=this._chunkToGroup(e,t,n),o=this._commonChunkLength(e);return t+=o,n+=o,i})}_chunkToGroup(e,t,n){const i=e.ab?_l.BOTH:_l.DELTA,o=this._linesFromChunk(e,t,n),s=new bl(i,o);return s.keyLocation=!!e.keyLocation,s.dueToRebase=!!e.due_to_rebase,s.dueToMove=!!e.due_to_move,s.ignoredWhitespaceOnly=!!e.common,s}_linesFromChunk(e,t,n){if(e.ab)return e.ab.map((e,i)=>this._lineFromRow(ul.BOTH,t,n,e,i));let i=[];return e.a&&(i=i.concat(this._linesFromRows(ul.REMOVE,e.a,t,e.edit_a))),e.b&&(i=i.concat(this._linesFromRows(ul.ADD,e.b,n,e.edit_b))),i}_linesFromRows(e,t,n,i){const o=i?this._convertIntralineInfos(t,i):void 0;return t.map((t,i)=>this._lineFromRow(e,n,n,t,i,o))}_lineFromRow(e,t,n,i,o,s){const r=new gl(e);return r.text=i,e!==ul.ADD&&(r.beforeNumber=t+o),e!==ul.REMOVE&&(r.afterNumber=n+o),s?(r.hasIntralineInfo=!0,r.highlights=s.filter(e=>e.contentIndex===o)):r.hasIntralineInfo=!1,r}_makeFileComments(){const e=new gl(ul.BOTH);return e.beforeNumber=pl,e.afterNumber=pl,new bl(_l.BOTH,[e])}_splitLargeChunks(e){const t=[];for(const n of e)if(n.ab)-1===this.context&&n.ab.length>240?(t.push({ab:n.ab.slice(0,120)}),t.push({ab:n.ab.slice(120)})):t.push(n);else for(const e of this._breakdownChunk(n))t.push(e);return t}_splitCommonChunksWithKeyLocations(e){const t=[];let n=1,i=1;for(const o of e){if(!o.ab&&!o.common){o.a&&(n+=o.a.length),o.b&&(i+=o.b.length),t.push(o);continue}if(o.common&&o.a.length!==o.b.length)throw new Error("DiffContent with common=true must always have equal length");const e=this._commonChunkLength(o),s=this._findChunkEndsAtKeyLocations(e,n,i);if(n+=e,i+=e,o.ab)t.push(...this._splitAtChunkEnds(o.ab,s).map(({lines:e,keyLocation:t})=>({...o,ab:e,keyLocation:t})));else if(o.common){const e=this._splitAtChunkEnds(o.a,s),n=this._splitAtChunkEnds(o.b,s);t.push(...e.map(({lines:e,keyLocation:t},i)=>({...o,a:e,b:n[i].lines,keyLocation:t})))}}return t}_findChunkEndsAtKeyLocations(e,t,n){const i=[];let o=0;for(let s=0;s<e;s++)(this.keyLocations[ja.LEFT][t+s]||this.keyLocations[ja.RIGHT][n+s])&&(s>o&&(i.push({offset:s,keyLocation:!1}),o=s),i.push({offset:s+1,keyLocation:!0}));return e>o&&i.push({offset:e,keyLocation:!1}),i}_splitAtChunkEnds(e,t){const n=[];let i=0;for(const{offset:o,keyLocation:s}of t)n.push({lines:e.slice(i,o),keyLocation:s}),i=o;return n}_convertIntralineInfos(e,t){let n=0,i=0;const o=[];for(const[s,r]of t){let t=e[n]+"\n",a=0;for(;a<s;)i!==t.length?(i++,a++):(i=0,t=e[++n]+"\n");let l={contentIndex:n,startIndex:i};for(a=0;t&&a<r;)i!==t.length?(i++,a++):(i=0,t=e[++n]+"\n",o.push(l),l={contentIndex:n,startIndex:i});l.endIndex=i,o.push(l)}return o}_breakdownChunk(e){let t=null;return e.a&&!e.b?t="a":e.b&&!e.a?t="b":e.ab&&(t="ab"),t?this._breakdown(e[t],120).map(n=>{const i={};return i[t]=n,e.due_to_rebase&&(i.due_to_rebase=!0),e.due_to_move&&(i.due_to_move=!0),i}):[e]}_breakdown(e,t){if(!e.length)return[];if(e.length<t)return[e];const n=e.slice(0,e.length-t),i=e.slice(e.length-t);return this._breakdown(n,t).concat([i])}};Fb([Bl({type:Number})],Bb.prototype,"context",void 0),Fb([Bl({type:Array,notify:!0})],Bb.prototype,"groups",void 0),Fb([Bl({type:Object})],Bb.prototype,"keyLocations",void 0),Fb([Bl({type:Number})],Bb.prototype,"_asyncThreshold",void 0),Fb([Bl({type:Number})],Bb.prototype,"_nextStepHandle",void 0),Fb([Bl({type:Object})],Bb.prototype,"_processPromise",void 0),Fb([Bl({type:Boolean})],Bb.prototype,"_isScrolling",void 0),Bb=Fb([Ml("gr-diff-processor")],Bb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const jb=ta`
  <style include="gr-hovercard-shared-style">
    #container {
      padding: var(--spacing-l);
    }
  </style>
  <div id="container" role="tooltip" tabindex="-1">
    <slot></slot>
  </div>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;let Hb=class extends(oo(xg(dr(oa)))){static get template(){return jb}};Hb=(window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r})([Ml("gr-hovercard")],Hb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ub=ta``;var Gb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Vb=/^(commentRanges\.#?\d+)\.hovering$/;let zb=class extends(oo(dr(oa))){constructor(){super(...arguments),this.commentRanges=[],this._listeners=[],this._rangesMap={left:{},right:{}}}static get template(){return Ub}get styleModuleName(){return"gr-ranged-comment-styles"}annotate(e,t,n){let i=[];(n.type===ul.REMOVE||n.type===ul.BOTH&&"right"!==e.getAttribute("data-side"))&&(i=i.concat(this._getRangesForLine(n,ja.LEFT))),(n.type===ul.ADD||n.type===ul.BOTH&&"left"!==e.getAttribute("data-side"))&&(i=i.concat(this._getRangesForLine(n,ja.RIGHT)));for(const t of i)dl.annotateElement(e,t.start,t.end-t.start,(t.hovering?"style-scope gr-diff rangeHighlight":"style-scope gr-diff range")+` ${qd(t.rootId)}`)}addListener(e){this._listeners.push(e)}removeListener(e){this._listeners=this._listeners.filter(t=>t!==e)}_notifyUpdateRange(e,t,n){for(const i of this._listeners)i(e,t,n)}_handleCommentRangesChange(e){if(!e)return;if("commentRanges"===e.path){const t=e.value;this._rangesMap={left:{},right:{}};for(const{side:e,range:n,rootId:i,hovering:o}of t)this._updateRangesMap({side:e,range:n,hovering:o,operation:(e,t,n,o)=>{e.push({start:t,end:n,hovering:o,rootId:i})}})}const t=e.path.match(Vb);if(t){const{side:e,range:n,hovering:i,rootId:o}=this.get(t[1]);this._updateRangesMap({side:e,range:n,hovering:i,skipLayerUpdate:!0,operation:(e,t,n,i)=>{const s=e.findIndex(e=>e.start===t&&e.end===n);e[s].hovering=i,e[s].rootId=o}})}if("commentRanges.splices"===e.path){const t=e.value;for(const e of t.indexSplices){const t=e.removed;for(const{side:e,range:n,hovering:i,rootId:o}of t)this._updateRangesMap({side:e,range:n,hovering:i,operation:(e,t,n)=>{const i=e.findIndex(e=>e.start===t&&e.end===n&&o===e.rootId);e.splice(i,1)}});const n=e.object.slice(e.index,e.index+e.addedCount);for(const{side:e,range:t,hovering:i,rootId:o}of n)this._updateRangesMap({side:e,range:t,hovering:i,operation:(e,t,n,i)=>{e.push({start:t,end:n,hovering:i,rootId:o})}})}}}_updateRangesMap(e){const{side:t,range:n,hovering:i,operation:o,skipLayerUpdate:s}=e,r=this._rangesMap[t]||(this._rangesMap[t]={});for(let e=n.start_line;e<=n.end_line;e++){o(r[e]||(r[e]=[]),e===n.start_line?n.start_character:0,e===n.end_line?n.end_character:-1,i)}s||this._notifyUpdateRange(n.start_line,n.end_line,t)}_getRangesForLine(e,t){const n=t===ja.LEFT?e.beforeNumber:e.afterNumber;return(this.get(["_rangesMap",t,n])||[]).map(i=>((i={...i}).end=-1===i.end?e.text.length:i.end,i.start>=i.end&&i.start<e.text.length&&(i.end=e.text.length,this.dispatchEvent(new CustomEvent("normalize-range",{bubbles:!0,composed:!0,detail:{lineNum:n,side:t}}))),i)).sort((e,t)=>e.hovering&&!t.hovering?1:0)}};Gb([Bl({type:Array})],zb.prototype,"commentRanges",void 0),Gb([Bl({type:Array})],zb.prototype,"_listeners",void 0),Gb([Bl({type:Object})],zb.prototype,"_rangesMap",void 0),Gb([jl("commentRanges.*")],zb.prototype,"_handleCommentRangesChange",null),zb=Gb([Ml("gr-ranged-comment-layer")],zb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Wb=ta`
  <div class="contentWrapper">
    <slot></slot>
  </div>
  <gr-ranged-comment-layer
    id="rangeLayer"
    comment-ranges="[[commentRanges]]"
  ></gr-ranged-comment-layer>
  <gr-coverage-layer
    id="coverageLayerLeft"
    coverage-ranges="[[_leftCoverageRanges]]"
    side="left"
  ></gr-coverage-layer>
  <gr-coverage-layer
    id="coverageLayerRight"
    coverage-ranges="[[_rightCoverageRanges]]"
    side="right"
  ></gr-coverage-layer>
  <gr-diff-processor id="processor" groups="{{_groups}}"></gr-diff-processor>
`;var qb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Kb="SIDE_BY_SIDE",Yb="UNIFIED_DIFF",Xb=/\s+$/;let Jb=class extends(oo(dr(oa))){constructor(){super(...arguments),this.baseImage=null,this.revisionImage=null,this._groups=[],this.layers=[],this._layers=[],this.commentRanges=[],this.coverageRanges=[],this._cancelableRenderPromise=null}static get template(){return Wb}detached(){super.detached(),this._builder&&this._builder.clear()}get diffElement(){return this.queryEffectiveChildren("#diffTable")}_computeLeftCoverageRanges(e){return e.filter(e=>e&&"left"===e.side)}_computeRightCoverageRanges(e){return e.filter(e=>e&&"right"===e.side)}render(e,t){if(this._setupAnnotationLayers(),this._showTabs=!!t.show_tabs,this._showTrailingWhitespace=!!t.show_whitespace_errors,this.cancel(),this._builder&&this._builder.clear(),!this.diff)throw Error("Cannot render a diff without DiffInfo.");this._builder=this._getDiffBuilder(this.diff,t),this.$.processor.context=t.context,this.$.processor.keyLocations=e,this._clearDiffContent(),this._builder.addColumns(this.diffElement,t.font_size);const n=!(!this.isImageDiff&&!this.diff.binary);return this.dispatchEvent(new CustomEvent("render-start",{bubbles:!0,composed:!0})),this._cancelableRenderPromise=ld.makeCancelable(this.$.processor.process(this.diff.content,n).then(()=>{this.isImageDiff&&this._builder.renderDiff(),this.dispatchEvent(new CustomEvent("render-content",{bubbles:!0,composed:!0}))})),this._cancelableRenderPromise.finally(()=>{this._cancelableRenderPromise=null}).catch(e=>{if(!e.isCanceled)return Promise.reject(e)})}_setupAnnotationLayers(){const e=[this._createTrailingWhitespaceLayer(),this._createIntralineLayer(),this._createTabIndicatorLayer(),this.$.rangeLayer,this.$.coverageLayerLeft,this.$.coverageLayerRight];this.layers&&e.push(...this.layers),this._layers=e}getLineElByChild(e){for(var t,n;e;){if(e instanceof Element){if(e.classList.contains("lineNum"))return e;if(e.classList.contains("section"))return null}e=null!==(n=null!==(t=e.previousSibling)&&void 0!==t?t:e.parentElement)&&void 0!==n?n:void 0}return null}getLineNumberByChild(e){return fh(this.getLineElByChild(e))}getContentTdByLine(e,t,n){return this._builder?this._builder.getContentTdByLine(e,t,n):null}_getDiffRowByChild(e){for(;!e.classList.contains("diff-row")&&e.parentElement;)e=e.parentElement;return e}getContentTdByLineEl(e){if(!e)return null;const t=fh(e);if(!t)return null;const n=this.getSideByLineEl(e),i=this._getDiffRowByChild(e);return this.getContentTdByLine(t,n,i)}getLineElByNumber(e,t){const n=t?"."+t:"";return this.diffElement.querySelector(`.lineNum[data-value="${e}"]${n}`)}getSideByLineEl(e){return e.classList.contains(ja.RIGHT)?ja.RIGHT:ja.LEFT}emitGroup(e,t){this._builder&&this._builder.emitGroup(e,t)}showContext(e,t){if(!this._builder)return;const n=this._builder.groups,i=n.findIndex(e=>e.element===t);n.splice(i,1,...e);for(const n of e)this._builder.emitGroup(n,t);t.parentNode&&t.parentNode.removeChild(t),this.async(()=>this.dispatchEvent(new CustomEvent("render-content",{composed:!0,bubbles:!0})),1)}cancel(){this.$.processor.cancel(),this._cancelableRenderPromise&&(this._cancelableRenderPromise.cancel(),this._cancelableRenderPromise=null)}_handlePreferenceError(e){const t=`The value of the '${e}' user preference is `+"invalid. Fix in diff preferences";throw this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:t},bubbles:!0,composed:!0})),Error(`Invalid preference value: ${e}`)}_getDiffBuilder(e,t){(isNaN(t.tab_size)||t.tab_size<=0)&&this._handlePreferenceError("tab size"),(isNaN(t.line_length)||t.line_length<=0)&&this._handlePreferenceError("diff width");const n={...t};"/COMMIT_MSG"===this.path&&(n.line_length=72);let i=null;if(this.isImageDiff)i=new xl(e,n,this.diffElement,this.baseImage,this.revisionImage);else{if(e.binary)return new Rl(e,n,this.diffElement);this.viewMode===Kb?i=new Sl(e,n,this.diffElement,this._layers):this.viewMode===Yb&&(i=new Pl(e,n,this.diffElement,this._layers))}if(!i)throw Error(`Unsupported diff view mode: ${this.viewMode}`);return i}_clearDiffContent(){this.diffElement.innerHTML=""}_groupsChanged(e){if(e&&this._builder)for(const t of e.indexSplices){let e;for(let n=0;n<t.addedCount;n++)e=t.object[t.index+n],this._builder.groups.push(e),this._builder.emitGroup(e,null)}}_createIntralineLayer(){return{annotate(e,t,n){for(const t of n.highlights){if(t.startIndex===t.endIndex)continue;const i=void 0===t.endIndex?n.text.length:t.endIndex;dl.annotateElement(e,t.startIndex,i-t.startIndex,"style-scope gr-diff intraline")}}}}_createTabIndicatorLayer(){const e=()=>this._showTabs;return{annotate(t,n,i){if(!e())return;const o=i.text.split("\t");if(o)for(let e=0,n=0;e<o.length-1;e++)n+=o[e].length,dl.annotateElement(t,n,1,"style-scope gr-diff tab-indicator"),n++}}}_createTrailingWhitespaceLayer(){const e=()=>this._showTrailingWhitespace;return{annotate(t,n,i){if(!e())return;const o=i.text.match(Xb);if(o){const e=dl.getStringLength(i.text.substr(0,o.index)),n=dl.getStringLength(o[0]);dl.annotateElement(t,e,n,"style-scope gr-diff trailing-whitespace")}}}}setBlame(e){this._builder&&this._builder.setBlame(e)}};qb([Bl({type:Object})],Jb.prototype,"diff",void 0),qb([Bl({type:String})],Jb.prototype,"changeNum",void 0),qb([Bl({type:String})],Jb.prototype,"patchNum",void 0),qb([Bl({type:String})],Jb.prototype,"viewMode",void 0),qb([Bl({type:Boolean})],Jb.prototype,"isImageDiff",void 0),qb([Bl({type:Object})],Jb.prototype,"baseImage",void 0),qb([Bl({type:Object})],Jb.prototype,"revisionImage",void 0),qb([Bl({type:Number})],Jb.prototype,"parentIndex",void 0),qb([Bl({type:String})],Jb.prototype,"path",void 0),qb([Bl({type:String})],Jb.prototype,"projectName",void 0),qb([Bl({type:Object})],Jb.prototype,"_builder",void 0),qb([Bl({type:Array})],Jb.prototype,"_groups",void 0),qb([Bl({type:Array})],Jb.prototype,"layers",void 0),qb([Bl({type:Array})],Jb.prototype,"_layers",void 0),qb([Bl({type:Boolean})],Jb.prototype,"_showTabs",void 0),qb([Bl({type:Boolean})],Jb.prototype,"_showTrailingWhitespace",void 0),qb([Bl({type:Array})],Jb.prototype,"commentRanges",void 0),qb([Bl({type:Array})],Jb.prototype,"coverageRanges",void 0),qb([Bl({type:Array,computed:"_computeLeftCoverageRanges(coverageRanges)"})],Jb.prototype,"_leftCoverageRanges",void 0),qb([Bl({type:Array,computed:"_computeRightCoverageRanges(coverageRanges)"})],Jb.prototype,"_rightCoverageRanges",void 0),qb([Bl({type:Object})],Jb.prototype,"_cancelableRenderPromise",void 0),qb([jl("_groups.splices")],Jb.prototype,"_groupsChanged",null),Jb=qb([Ml("gr-diff-builder")],Jb);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Zb=ta`
  <style include="shared-styles">
    :host {
      cursor: pointer;
      font-family: var(--font-family);
      position: absolute;
      white-space: nowrap;
    }
  </style>
  <gr-tooltip
    id="tooltip"
    text="Press c to comment"
    position-below="[[positionBelow]]"
  ></gr-tooltip>
`;var Qb=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let ew=class extends(oo(dr(oa))){constructor(){super(...arguments),this.keyEventTarget=document.body,this.positionBelow=!1}static get template(){return Zb}created(){super.created(),this.addEventListener("mousedown",e=>this._handleMouseDown(e))}placeAbove(e){Mo();const t=this._getTargetBoundingRect(e),n=this.$.tooltip.getBoundingClientRect(),i=this._getParentBoundingClientRect();null!==i&&(this.style.top=`${t.top-i.top-n.height-6}px`,this.style.left=`${t.left-i.left+(t.width-n.width)/2}px`)}placeBelow(e){Mo();const t=this._getTargetBoundingRect(e),n=this.$.tooltip.getBoundingClientRect(),i=this._getParentBoundingClientRect();null!==i&&(this.style.top=`${t.top-i.top+n.height-6}px`,this.style.left=`${t.left-i.left+(t.width-n.width)/2}px`)}_getParentBoundingClientRect(){return this.parentElement?this.parentElement.getBoundingClientRect():null!==this.parentNode?this.parentNode.host.getBoundingClientRect():null}_getTargetBoundingRect(e){let t;if(e instanceof Text){const n=document.createRange();n.selectNode(e),t=n.getBoundingClientRect(),n.detach()}else t=e.getBoundingClientRect();return t}_handleMouseDown(e){0===e.button&&(e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("create-comment-requested",{composed:!0,bubbles:!0})))}};Qb([Bl({type:Object})],ew.prototype,"keyEventTarget",void 0),Qb([Bl({type:Boolean})],ew.prototype,"positionBelow",void 0),ew=Qb([Ml("gr-selection-action-box")],ew);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const tw=ta`
  <style include="shared-styles">
    :host {
      position: relative;
    }
    gr-selection-action-box {
      /**
         * Needs z-index to appear above wrapped content, since it's inserted
         * into DOM before it.
         */
      z-index: 10;
    }
  </style>
  <div class="contentWrapper">
    <slot></slot>
  </div>
`,nw=/[\uD800-\uDBFF][\uDC00-\uDFFF]/;
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */function iw(e){const t=ow(e.startContainer),n=e.startOffset+sw(t,e.startContainer),i=ow(e.endContainer);return{startContainer:t,startOffset:n,endContainer:i,endOffset:e.endOffset+sw(i,e.endContainer)}}function ow(e){if(!e.parentElement)return e;let t;for(t=e instanceof Element?e:e.parentElement;t&&!t.classList.contains("contentText");){if(null===t.parentElement)return e;t=t.parentElement}return t||e}function sw(e,t){let n=0,i=[e];for(;i.length;){const e=i.pop();if(e===t)break;if((null==e?void 0:e.childNodes)&&0!==e.childNodes.length){const t=[];for(const n of e.childNodes)t.push(n);t.reverse(),i=i.concat(t)}else n+=rw(e)}return n}function rw(e){return e&&e.textContent?e.textContent.replace(nw,"_").length:0}var aw=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let lw=class extends(oo(dr(oa))){constructor(){super(...arguments),this.commentRanges=[]}static get template(){return tw}created(){super.created(),this.addEventListener("comment-thread-mouseleave",e=>this._handleCommentThreadMouseleave(e)),this.addEventListener("comment-thread-mouseenter",e=>this._handleCommentThreadMouseenter(e)),this.addEventListener("create-comment-requested",e=>this._handleRangeCommentRequest(e))}get diffBuilder(){return this._cachedDiffBuilder||(this._cachedDiffBuilder=this.querySelector("gr-diff-builder")),this._cachedDiffBuilder}handleSelectionChange(e,t){null!==e&&this.debounce("selectionChange",()=>this._handleSelection(e,t),10)}_getThreadEl(e){const t=qo(e).path||[];for(const e of t)if(e instanceof HTMLElement&&e.classList.contains("comment-thread"))return e;return null}_toggleRangeElHighlight(e,t=!1){let n=e.assignedSlot;for(;n&&"TABLE"!==n.nodeName;)n=n.parentElement;if(null==n?void 0:n.querySelectorAll)if(t){n.querySelectorAll(`.range.${qd(e.rootId)}`).forEach(e=>{e.classList.add("rangeHighlight"),e.classList.remove("range")})}else{n.querySelectorAll(`.rangeHighlight.${qd(e.rootId)}`).forEach(e=>{e.classList.remove("rangeHighlight"),e.classList.add("range")})}}_handleCommentThreadMouseenter(e){const t=this._getThreadEl(e),n=this._indexForThreadEl(t);void 0!==n&&this.set(["commentRanges",n,"hovering"],!0),this._toggleRangeElHighlight(t,!0)}_handleCommentThreadMouseleave(e){const t=this._getThreadEl(e),n=this._indexForThreadEl(t);void 0!==n&&this.set(["commentRanges",n,"hovering"],!1),this._toggleRangeElHighlight(t,!1)}_indexForThreadEl(e){const t=e.getAttribute("comment-side"),n=e.getAttribute("range");if(!n)return;const i=JSON.parse(n);return i?this._indexOfCommentRange(t,i):void 0}_indexOfCommentRange(e,t){return this.commentRanges.findIndex(n=>{return n.side===e&&(i=n.range,o=t,!i&&!o||!(!i||!o)&&i.start_line===o.start_line&&i.start_character===o.start_character&&i.end_line===o.end_line&&i.end_character===o.end_character);var i,o})}_getNormalizedRange(e){const t=e.rangeCount;if(0===t)return null;if(1===t)return this._normalizeRange(e.getRangeAt(0));{const n=this._normalizeRange(e.getRangeAt(0)),i=this._normalizeRange(e.getRangeAt(t-1));return{start:n.start,end:i.end}}}_normalizeRange(e){const t=iw(e);return this._fixTripleClickSelection({start:this._normalizeSelectionSide(t.startContainer,t.startOffset),end:this._normalizeSelectionSide(t.endContainer,t.endOffset)},e)}_fixTripleClickSelection(e,t){if(!e.start)return e;const n=e.start,i=e.end,o=!i&&0===t.endOffset&&t.endContainer instanceof HTMLElement&&"TD"===t.endContainer.nodeName&&(t.endContainer.classList.contains("left")||t.endContainer.classList.contains("right")),s=i&&0===n.column&&0===i.column&&i.line===n.line+1,r=t.cloneContents().querySelector(".contentText"),a=r&&this._getLength(r)||0;return a&&(s||o)&&(e.end={node:n.node,column:a,side:n.side,line:n.line}),e}_normalizeSelectionSide(e,t){let n;if(!e||!this.contains(e))return null;const i=this.diffBuilder.getLineElByChild(e);if(!i)return null;const o=this.diffBuilder.getSideByLineEl(i);if(!o)return null;const s=this.diffBuilder.getLineNumberByChild(i);if(!s||s===pl)return null;const r=this.diffBuilder.getContentTdByLineEl(i);if(!r)return null;const a=r.querySelector(".contentText");if(r.contains(e)){const i=r.querySelector(".comment-thread");(null==i?void 0:i.contains(e))?(n=this._getLength(a),e=a):n=this._convertOffsetToColumn(e,t)}else e=a,n=0;return{node:e,side:o,line:s,column:n}}_positionActionBox(e,t,n){t>1?e.placeAbove(n):(e.positionBelow=!0,e.placeBelow(n))}_isRangeValid(e){if(!(e&&e.start&&e.start.node&&e.end))return!1;const t=e.start,n=e.end;return!(t.side!==n.side||n.line<t.line||t.line===n.line&&t.column===n.column)}_handleSelection(e,t){const n=this._getNormalizedRange(e);if(!this._isRangeValid(n))return void this._removeActionBox();const i=e.getRangeAt(0),o=n.start,s=n.end;if(o.line===s.line-1&&0===s.column){const e=i.cloneContents().querySelector(".contentText");return void(t&&0===this._getLength(e)&&this._fireCreateRangeComment(o.side,{start_line:o.line,start_character:0,end_line:o.line,end_character:o.column}))}let r=this.shadowRoot.querySelector("gr-selection-action-box");r||(r=document.createElement("gr-selection-action-box"),this.root.insertBefore(r,this.root.firstElementChild)),this.selectedRange={range:{start_line:o.line,start_character:o.column,end_line:s.line,end_character:s.column},side:o.side},o.line===s.line?this._positionActionBox(r,o.line,i):o.node instanceof Text?(o.column&&this._positionActionBox(r,o.line,o.node.splitText(o.column)),o.node.parentElement.normalize()):o.node instanceof HTMLElement&&o.node.classList.contains("content")&&(o.node.firstChild instanceof Element||o.node.firstChild instanceof Text)?this._positionActionBox(r,o.line,o.node.firstChild):o.node instanceof Element||o.node instanceof Text?this._positionActionBox(r,o.line,o.node):(console.warn("Failed to position comment action box."),this._removeActionBox())}_fireCreateRangeComment(e,t){this.dispatchEvent(new CustomEvent("create-range-comment",{detail:{side:e,range:t},composed:!0,bubbles:!0})),this._removeActionBox()}_handleRangeCommentRequest(e){if(e.stopPropagation(),!this.selectedRange)throw Error("Selected Range is needed for new range comment!");const{side:t,range:n}=this.selectedRange;this._fireCreateRangeComment(t,n)}_removeActionBox(){this.selectedRange=void 0;const e=this.shadowRoot.querySelector("gr-selection-action-box");e&&this.root.removeChild(e)}_convertOffsetToColumn(e,t){var n;if(e instanceof Element&&e.classList.contains("content"))return t;for(;e.previousSibling||!(null===(n=e.parentElement)||void 0===n?void 0:n.classList.contains("content"));)e.previousSibling?(e=e.previousSibling,t+=this._getLength(e)):e=e.parentElement;return t}_getLength(e){return null===e?0:e instanceof Element&&e.classList.contains("content")?this._getLength(e.querySelector(".contentText")):dl.getLength(e)}};aw([Bl({type:Array,notify:!0})],lw.prototype,"commentRanges",void 0),aw([Bl({type:Boolean})],lw.prototype,"loggedIn",void 0),aw([Bl({type:Object})],lw.prototype,"_cachedDiffBuilder",void 0),aw([Bl({type:Object,notify:!0})],lw.prototype,"selectedRange",void 0),lw=aw([Ml("gr-diff-highlight")],lw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const cw=ta`
  <div class="contentWrapper">
    <slot></slot>
  </div>
`;var dw=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const hw={COMMENT:"selected-comment",LEFT:"selected-left",RIGHT:"selected-right",BLAME:"selected-blame"};let pw=class extends(oo(dr(oa))){constructor(){super(...arguments),this._linesCache={left:null,right:null}}static get template(){return cw}created(){super.created(),this.addEventListener("copy",e=>this._handleCopy(e)),$i(this,"down",e=>this._handleDown(e))}attached(){super.attached(),this.classList.add(hw.RIGHT)}get diffBuilder(){return this._cachedDiffBuilder||(this._cachedDiffBuilder=this.querySelector("gr-diff-builder")),this._cachedDiffBuilder}_diffChanged(){this._linesCache={left:null,right:null}}_handleDownOnRangeComment(e){var t;return"gr-comment-thread"===(null===(t=null==e?void 0:e.nodeName)||void 0===t?void 0:t.toLowerCase())&&(this._setClasses([hw.COMMENT,e.getAttribute("comment-side")===ja.LEFT?hw.LEFT:hw.RIGHT]),!0)}_handleDown(e){const t=e.target;if(!(t instanceof Element))return;if(this._handleDownOnRangeComment(t))return;const n=this.diffBuilder.getLineElByChild(t),i=this._elementDescendedFromClass(t,"blame");if(!n&&!i)return;const o=[];if(i)o.push(hw.BLAME);else if(n){const e=this._elementDescendedFromClass(t,"gr-comment"),i=this.diffBuilder.getSideByLineEl(n);o.push("left"===i?hw.LEFT:hw.RIGHT),e&&o.push(hw.COMMENT)}this._setClasses(o)}_setClasses(e){for(const t of Object.values(hw))e.includes(t)||this.classList.remove(t);for(const t of e)this.classList.contains(t)||this.classList.add(t)}_getCopyEventTarget(e){return qo(e).rootTarget}_elementDescendedFromClass(e,t){return Wd(e,t,this.diffBuilder.diffElement)}_handleCopy(e){let t=!1;const n=this._getCopyEventTarget(e);if(!(n instanceof Element))return;if(n instanceof HTMLTextAreaElement)return;if(!this._elementDescendedFromClass(n,"diff-row"))return;this.classList.contains(hw.COMMENT)&&(t=!0);const i=this.diffBuilder.getLineElByChild(n);if(!i)return;const o=this.diffBuilder.getSideByLineEl(i),s=this._getSelectedText(o,t);s&&e.clipboardData&&(e.clipboardData.setData("Text",s),e.preventDefault())}_getSelection(){const e=function(e,t){let n=[e];const i=new Set;for(;n.length;){const e=n.pop();if(!e||!e.querySelectorAll)continue;[...e.querySelectorAll(t)].forEach(e=>i.add(e));const o=[...e.querySelectorAll("*")].filter(Vd).map(e=>e.shadowRoot);n=n.concat(o),Vd(e)&&n.push(e.shadowRoot)}return[...i]}(document.body,"gr-diff");if(!e.length)return window.getSelection();const t=e.find(e=>{if(!e||!e.shadowRoot)return!1;const t=e.shadowRoot.getSelection();return t&&"None"!==t.type});return t?t.shadowRoot.getSelection():window.getSelection()}_getSelectedText(e,t){const n=this._getSelection();if(!n||1!==n.rangeCount)return"";if(t)return this._getCommentLines(n,e);const i=iw(n.getRangeAt(0)),o=this.diffBuilder.getLineElByChild(i.startContainer);if(!o)return;const s=this.diffBuilder.getLineElByChild(i.endContainer),r=!s&&0===i.endOffset&&"TD"===i.endContainer.nodeName&&i.endContainer instanceof HTMLTableCellElement&&(i.endContainer.classList.contains("left")||i.endContainer.classList.contains("right")),a=o.getAttribute("data-value");if(!a)return;const l=parseInt(a,10);let c;if(r)c=l+1;else if(s){const e=s.getAttribute("data-value");e&&(c=parseInt(e,10))}return this._getRangeFromDiff(l,i.startOffset,c,i.endOffset,e)}_getRangeFromDiff(e,t,n,i,o){const s=this._getDiffLines(o).slice(e-1,n);return s.length&&(s[s.length-1]=s[s.length-1].substring(0,i),s[0]=s[0].substring(t)),s.join("\n")}_getDiffLines(e){if(this._linesCache[e])return this._linesCache[e];if(!this.diff)return[];let t=[];for(const n of this.diff.content)n.ab?t=t.concat(n.ab):e===ja.LEFT&&n.a?t=t.concat(n.a):e===ja.RIGHT&&n.b&&(t=t.concat(n.b));return this._linesCache[e]=t,t}_getCommentLines(e,t){const n=iw(e.getRangeAt(0)),i=[],o=this.diffBuilder.diffElement.querySelectorAll(`.side-by-side [data-side="${t}"] .message *, .unified .message *`);for(let t=0;t<o.length;t++){const s=o[t];e.containsNode(s,!0)&&("container"!==s.parentElement.id&&"BLOCKQUOTE"!==s.parentElement.nodeName||i.length&&""!==i[i.length-1]&&i.push(""),"output"!==s.id||this._elementDescendedFromClass(s,"collapsed")||i.push(this._getTextContentForRange(s,e,n)))}return i.join("\n")}_getTextContentForRange(e,t,n){if(!t.containsNode(e,!0))return"";let i="";if(e instanceof Text)i=e.textContent||"",e===n.endContainer&&(i=i.substring(0,n.endOffset)),e===n.startContainer&&(i=i.substring(n.startOffset));else for(const o of e.childNodes)i+=this._getTextContentForRange(o,t,n);return i}};dw([Bl({type:Object})],pw.prototype,"diff",void 0),dw([Bl({type:Object})],pw.prototype,"_cachedDiffBuilder",void 0),dw([Bl({type:Object})],pw.prototype,"_linesCache",void 0),dw([jl("diff")],pw.prototype,"_diffChanged",null),pw=dw([Ml("gr-diff-selection")],pw);
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const uw=document.createElement("template");uw.innerHTML='<dom-module id="gr-syntax-theme">\n  <template>\n    <style>\n      /**\n       * @overview Highlight.js emits the following classes that do not have\n       * styles here:\n       *    subst, symbol, class, function, doctag, meta-string, section, name,\n       *    builtin-name, bulletm, code, formula, quote, addition, deletion,\n       *    attribute\n       * @see {@link http://highlightjs.readthedocs.io/en/latest/css-classes-reference.html}\n       */\n\n      .contentText {\n        color: var(--syntax-default-color);\n      }\n      .gr-syntax-attribute {\n        color: var(--syntax-attribute-color);\n      }\n      .gr-syntax-function {\n        color: var(--syntax-function-color);\n      }\n      .gr-syntax-meta {\n        color: var(--syntax-meta-color);\n      }\n      .gr-syntax-keyword,\n      .gr-syntax-name {\n        color: var(--syntax-keyword-color);\n      }\n      .gr-syntax-number {\n        color: var(--syntax-number-color);\n      }\n      .gr-syntax-selector-class {\n        color: var(--syntax-selector-class-color);\n      }\n      .gr-syntax-variable {\n        color: var(--syntax-variable-color);\n      }\n      .gr-syntax-template-variable {\n        color: var(--syntax-template-variable-color);\n      }\n      .gr-syntax-comment {\n        color: var(--syntax-comment-color);\n      }\n      .gr-syntax-string {\n        color: var(--syntax-string-color);\n      }\n      .gr-syntax-selector-id {\n        color: var(--syntax-selector-id-color);\n      }\n      .gr-syntax-built_in {\n        color: var(--syntax-built_in-color);\n      }\n      .gr-syntax-tag {\n        color: var(--syntax-tag-color);\n      }\n      .gr-syntax-link {\n        color: var(--syntax-link-color);\n      }\n      .gr-syntax-meta-keyword {\n        color: var(--syntax-meta-keyword-color);\n      }\n      .gr-syntax-type {\n        color: var(--syntax-type-color);\n      }\n      .gr-syntax-title {\n        color: var(--syntax-title-color);\n      }\n      .gr-syntax-attr {\n        color: var(--syntax-attr-color);\n      }\n      .gr-syntax-literal { /* XML/HTML Attribute */\n        color: var(--syntax-literal-color);\n      }\n      .gr-syntax-selector-pseudo {\n        color: var(--syntax-selector-pseudo-color);\n      }\n      .gr-syntax-regexp {\n        color: var(--syntax-regexp-color);\n      }\n      .gr-syntax-selector-attr {\n        color: var(--syntax-selector-attr-color);\n      }\n      .gr-syntax-template-tag {\n        color: var(--syntax-template-tag-color);\n      }\n      .gr-syntax-params {\n        color: var(--syntax-params-color);\n      }\n      .gr-syntax-doctag {\n        font-weight: var(--syntax-doctag-weight);\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(uw.content);
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const gw=document.createElement("template");gw.innerHTML='<dom-module id="gr-ranged-comment-theme">\n  <template>\n    <style>\n      .range {\n        background-color: var(--diff-highlight-range-color);\n        display: inline;\n      }\n      .rangeHighlight {\n        background-color: var(--diff-highlight-range-hover-color);\n        display: inline;\n      }\n    </style>\n  </template>\n</dom-module>',document.head.appendChild(gw.content);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const mw=ta`
  <style include="shared-styles">
    :host(.no-left) .sideBySide .left,
    :host(.no-left) .sideBySide .left + td,
    :host(.no-left) .sideBySide .right:not([data-value]),
    :host(.no-left) .sideBySide .right:not([data-value]) + td {
      display: none;
    }
    :host {
      font-family: var(--monospace-font-family, ''), 'Roboto Mono';
      font-size: var(--font-size, var(--font-size-code, 12px));
      line-height: var(--line-height-code, 1.334);
    }

    .thread-group {
      display: block;
      max-width: var(--content-width, 80ch);
      white-space: normal;
      background-color: var(--diff-blank-background-color);
    }
    .diffContainer {
      display: flex;
      font-family: var(--monospace-font-family);
      @apply --diff-container-styles;
    }
    .diffContainer.hiddenscroll {
      margin-bottom: var(--spacing-m);
    }
    table {
      border-collapse: collapse;
      border-right: 1px solid var(--border-color);
      table-layout: fixed;
    }
    .lineNumButton {
      display: block;
      width: 100%;
      height: 100%;
      background-color: var(--diff-blank-background-color);
    }
    /*
      The only way to focus this (clicking) will apply our own focus styling,
      so this default styling is not needed and distracting.
      */
    .lineNumButton:focus {
      outline: none;
    }
    .image-diff .gr-diff {
      text-align: center;
    }
    .image-diff img {
      box-shadow: var(--elevation-level-1);
      max-width: 50em;
    }
    .image-diff .right.lineNumButton {
      border-left: 1px solid var(--border-color);
    }
    .image-diff label,
    .binary-diff label {
      font-family: var(--font-family);
      font-style: italic;
    }
    .diff-row {
      outline: none;
      user-select: none;
    }
    .diff-row.target-row.target-side-left .lineNumButton.left,
    .diff-row.target-row.target-side-right .lineNumButton.right,
    .diff-row.target-row.unified .lineNumButton {
      background-color: var(--diff-selection-background-color);
      color: var(--primary-text-color);
    }
    .content {
      background-color: var(--diff-blank-background-color);
    }
    /*
      The file line, which has no contentText, add some margin before the first
      comment. We cannot add padding the container because we only want it if
      there is at least one comment thread, and the slotting makes :empty not
      work as expected.
     */
    .content.file slot:first-child::slotted(.comment-thread) {
      display: block;
      margin-top: var(--spacing-xs);
    }
    .contentText {
      background-color: var(--view-background-color);
    }
    .blank {
      background-color: var(--diff-blank-background-color);
    }
    .image-diff .content {
      background-color: var(--diff-blank-background-color);
    }
    .full-width {
      width: 100%;
    }
    .full-width .contentText {
      white-space: pre-wrap;
      word-wrap: break-word;
    }
    .lineNumButton,
    .content {
      vertical-align: top;
      white-space: pre;
    }
    .contextLineNum,
    .lineNumButton {
      -webkit-user-select: none;
      -moz-user-select: none;
      -ms-user-select: none;
      user-select: none;

      color: var(--deemphasized-text-color);
      padding: 0 var(--spacing-m);
      text-align: right;
    }
    .canComment .lineNumButton {
      cursor: pointer;
    }
    .content {
      /* Set min width since setting width on table cells still
           allows them to shrink. Do not set max width because
           CJK (Chinese-Japanese-Korean) glyphs have variable width */
      min-width: var(--content-width, 80ch);
      width: var(--content-width, 80ch);
    }
    .content.add .contentText .intraline,
      /* If there are no intraline info, consider everything changed */
      .content.add.no-intraline-info .contentText,
      .delta.total .content.add .contentText {
      background-color: var(--dark-add-highlight-color);
    }
    .content.add .contentText {
      background-color: var(--light-add-highlight-color);
    }
    .content.remove .contentText .intraline,
      /* If there are no intraline info, consider everything changed */
      .content.remove.no-intraline-info .contentText,
      .delta.total .content.remove .contentText {
      background-color: var(--dark-remove-highlight-color);
    }
    .content.remove .contentText {
      background-color: var(--light-remove-highlight-color);
    }

    /* dueToRebase */
    .dueToRebase .content.add .contentText .intraline,
    .delta.total.dueToRebase .content.add .contentText {
      background-color: var(--dark-rebased-add-highlight-color);
    }
    .dueToRebase .content.add .contentText {
      background-color: var(--light-rebased-add-highlight-color);
    }
    .dueToRebase .content.remove .contentText .intraline,
    .delta.total.dueToRebase .content.remove .contentText {
      background-color: var(--dark-rebased-remove-highlight-color);
    }
    .dueToRebase .content.remove .contentText {
      background-color: var(--light-remove-add-highlight-color);
    }

    /* dueToMove */
    .dueToMove .content.add .contentText,
    .dueToMove .moveControls.movedIn .moveDescription,
    .delta.total.dueToMove .content.add .contentText {
      background-color: var(--light-moved-add-highlight-color);
    }
    .dueToMove .content.remove .contentText,
    .dueToMove .moveControls.movedOut .moveDescription,
    .delta.total.dueToMove .content.remove .contentText {
      background-color: var(--light-remove-add-highlight-color);
    }
    .moveControls {
      text-align: right;
    }

    /* ignoredWhitespaceOnly */
    .ignoredWhitespaceOnly .content.add .contentText .intraline,
    .delta.total.ignoredWhitespaceOnly .content.add .contentText,
    .ignoredWhitespaceOnly .content.add .contentText,
    .ignoredWhitespaceOnly .content.remove .contentText .intraline,
    .delta.total.ignoredWhitespaceOnly .content.remove .contentText,
    .ignoredWhitespaceOnly .content.remove .contentText {
      background-color: var(--view-background-color);
    }

    .content .contentText:empty:after {
      /* Newline, to ensure empty lines are one line-height tall. */
      content: '\\A';
    }
    .contextControl {
      background-color: var(--diff-context-control-background-color);
      border: 1px solid var(--diff-context-control-border-color);
      color: var(--diff-context-control-color);
    }
    .contextControl gr-button {
      display: inline-block;
      text-decoration: none;
      vertical-align: top;
      line-height: var(--line-height-mono, 18px);
      --gr-button: {
        color: var(--diff-context-control-color);
        padding: var(--spacing-xxs) var(--spacing-l);
      }
    }
    .contextControl gr-button iron-icon {
      /* should match line-height of gr-button */
      width: var(--line-height-mono, 18px);
      height: var(--line-height-mono, 18px);
    }
    .contextControl td:not(.lineNumButton) {
      text-align: center;
    }
    .displayLine .diff-row.target-row td {
      box-shadow: inset 0 -1px var(--border-color);
    }
    .br:after {
      /* Line feed */
      content: '\\A';
    }
    .tab {
      display: inline-block;
    }
    .tab-indicator:before {
      color: var(--diff-tab-indicator-color);
      /* >> character */
      content: '\\00BB';
      position: absolute;
    }
    /* Is defined after other background-colors, such that this
         rule wins in case of same specificity. */
    .trailing-whitespace,
    .content .trailing-whitespace,
    .trailing-whitespace .intraline,
    .content .trailing-whitespace .intraline {
      border-radius: var(--border-radius, 4px);
      background-color: var(--diff-trailing-whitespace-indicator);
    }
    #diffHeader {
      background-color: var(--table-header-background-color);
      border-bottom: 1px solid var(--border-color);
      color: var(--link-color);
      padding: var(--spacing-m) 0 var(--spacing-m) 48px;
    }
    #loadingError,
    #sizeWarning {
      display: none;
      margin: var(--spacing-l) auto;
      max-width: 60em;
      text-align: center;
    }
    #loadingError {
      color: var(--error-text-color);
    }
    #sizeWarning gr-button {
      margin: var(--spacing-l);
    }
    #loadingError.showError,
    #sizeWarning.warn {
      display: block;
    }
    .target-row td.blame {
      background: var(--diff-selection-background-color);
    }
    col.blame {
      display: none;
    }
    td.blame {
      display: none;
      padding: 0 var(--spacing-m);
      white-space: pre;
    }
    :host(.showBlame) col.blame {
      display: table-column;
    }
    :host(.showBlame) td.blame {
      display: table-cell;
    }
    td.blame > span {
      opacity: 0.6;
    }
    td.blame > span.startOfRange {
      opacity: 1;
    }
    td.blame .blameDate {
      font-family: var(--monospace-font-family);
      color: var(--link-color);
      text-decoration: none;
    }
    .full-width td.blame {
      overflow: hidden;
      width: 200px;
    }
    /** Support the line length indicator **/
    .full-width td.content .contentText {
      /* Base 64 encoded 1x1px of #ddd */
      background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mO8+x8AAr8B3gzOjaQAAAAASUVORK5CYII=');
      background-position: var(--line-limit) 0;
      background-repeat: repeat-y;
    }
    .newlineWarning {
      color: var(--deemphasized-text-color);
      text-align: center;
    }
    .newlineWarning.hidden {
      display: none;
    }
    .lineNum.COVERED .lineNumButton {
      background-color: var(--coverage-covered, #e0f2f1);
    }
    .lineNum.NOT_COVERED .lineNumButton {
      background-color: var(--coverage-not-covered, #ffd1a4);
    }
    .lineNum.PARTIALLY_COVERED .lineNumButton {
      background: linear-gradient(
        to right bottom,
        var(--coverage-not-covered, #ffd1a4) 0%,
        var(--coverage-not-covered, #ffd1a4) 50%,
        var(--coverage-covered, #e0f2f1) 50%,
        var(--coverage-covered, #e0f2f1) 100%
      );
    }

    /** BEGIN: Select and copy for Polymer 2 */
    /** Below was copied and modified from the original css in gr-diff-selection.html */
    .content,
    .contextControl,
    .blame {
      -webkit-user-select: none;
      -moz-user-select: none;
      -ms-user-select: none;
      user-select: none;
    }

    .selected-left:not(.selected-comment)
      .side-by-side
      .left
      + .content
      .contentText,
    .selected-right:not(.selected-comment)
      .side-by-side
      .right
      + .content
      .contentText,
    .selected-left:not(.selected-comment)
      .unified
      .left.lineNum
      ~ .content:not(.both)
      .contentText,
    .selected-right:not(.selected-comment)
      .unified
      .right.lineNum
      ~ .content
      .contentText,
    .selected-left.selected-comment .side-by-side .left + .content .message,
    .selected-right.selected-comment
      .side-by-side
      .right
      + .content
      .message
      :not(.collapsedContent),
    .selected-comment .unified .message :not(.collapsedContent),
    .selected-blame .blame {
      -webkit-user-select: text;
      -moz-user-select: text;
      -ms-user-select: text;
      user-select: text;
    }

    /** Make comments selectable when selected */
    .selected-left.selected-comment
      ::slotted(gr-comment-thread[comment-side='left']),
    .selected-right.selected-comment
      ::slotted(gr-comment-thread[comment-side='right']) {
      -webkit-user-select: text;
      -moz-user-select: text;
      -ms-user-select: text;
      user-select: text;
    }
    /** END: Select and copy for Polymer 2 */

    .whitespace-change-only-message {
      background-color: var(--diff-context-control-background-color);
      border: 1px solid var(--diff-context-control-border-color);
      text-align: center;
    }
  </style>
  <style include="gr-syntax-theme">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-ranged-comment-theme">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div id="diffHeader" hidden$="[[_computeDiffHeaderHidden(_diffHeaderItems)]]">
    <template is="dom-repeat" items="[[_diffHeaderItems]]">
      <div>[[item]]</div>
    </template>
  </div>
  <div
    class$="[[_computeContainerClass(loggedIn, viewMode, displayLine)]]"
    on-tap="_handleTap"
  >
    <gr-diff-selection diff="[[diff]]">
      <gr-diff-highlight
        id="highlights"
        logged-in="[[loggedIn]]"
        comment-ranges="{{_commentRanges}}"
      >
        <gr-diff-builder
          id="diffBuilder"
          comment-ranges="[[_commentRanges]]"
          coverage-ranges="[[coverageRanges]]"
          project-name="[[projectName]]"
          diff="[[diff]]"
          path="[[path]]"
          change-num="[[changeNum]]"
          patch-num="[[patchRange.patchNum]]"
          view-mode="[[viewMode]]"
          is-image-diff="[[isImageDiff]]"
          base-image="[[baseImage]]"
          layers="[[layers]]"
          revision-image="[[revisionImage]]"
        >
          <table
            id="diffTable"
            class$="[[_diffTableClass]]"
            role="presentation"
          ></table>

          <template
            is="dom-if"
            if="[[showNoChangeMessage(loading, prefs, _diffLength, diff)]]"
          >
            <div class="whitespace-change-only-message">
              This file only contains whitespace changes. Modify the whitespace
              setting to see the changes.
            </div>
          </template>
        </gr-diff-builder>
      </gr-diff-highlight>
    </gr-diff-selection>
  </div>
  <div class$="[[_computeNewlineWarningClass(_newlineWarning, loading)]]">
    [[_newlineWarning]]
  </div>
  <div id="loadingError" class$="[[_computeErrorClass(errorMessage)]]">
    [[errorMessage]]
  </div>
  <div id="sizeWarning" class$="[[_computeWarningClass(_showWarning)]]">
    <p>
      Prevented render because "Whole file" is enabled and this diff is very
      large (about [[_diffLength]] lines).
    </p>
    <gr-button on-click="_handleLimitedBypass">
      Render with limited context
    </gr-button>
    <gr-button on-click="_handleFullBypass">
      Render anyway (may be slow)
    </gr-button>
  </div>
`;var _w=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};function fw(e){const t=e.getAttribute("comment-side");if(!t)throw Error("comment thread without side");if("left"!==t&&"right"!==t)throw Error(`unexpected value for side: ${t}`);return t}function vw(e){return e.nodeType===Node.ELEMENT_NODE&&e.classList.contains("comment-thread")}let yw=class extends(oo(dr(oa))){constructor(){super(...arguments),this.noAutoRender=!1,this.displayLine=!1,this.hidden=!1,this._commentRanges=[],this.coverageRanges=[],this.lineWrapping=!1,this.viewMode=Za.SIDE_BY_SIDE,this.loading=!1,this.loggedIn=!1,this._diffHeaderItems=[],this._diffTableClass="",this._safetyBypass=null,this.errorMessage=null,this.blame=null,this.showNewlineWarningLeft=!1,this.showNewlineWarningRight=!1,this._newlineWarning=null}static get template(){return mw}created(){super.created(),this.addEventListener("create-range-comment",e=>this._handleCreateRangeComment(e)),this.addEventListener("render-content",()=>this._handleRenderContent())}attached(){super.attached(),this._observeNodes()}detached(){super.detached(),this._unobserveIncrementalNodes(),this._unobserveNodes()}showNoChangeMessage(e,t,n,i){return!e&&i&&!i.binary&&t&&"IGNORE_NONE"!==t.ignore_whitespace&&0===n}_enableSelectionObserver(e,t){[e,t].includes(void 0)||(e&&t?(this.listen(document,"selectionchange","_handleSelectionChange"),this.listen(document,"mouseup","_handleMouseUp")):(this.unlisten(document,"selectionchange","_handleSelectionChange"),this.unlisten(document,"mouseup","_handleMouseUp")))}_handleSelectionChange(){const e=this._getShadowOrDocumentSelection();this.$.highlights.handleSelectionChange(e,!1)}_handleMouseUp(){const e=this._getShadowOrDocumentSelection();this.$.highlights.handleSelectionChange(e,!0)}_getShadowOrDocumentSelection(){return this.root instanceof ShadowRoot&&this.root.getSelection?this.root.getSelection():document.getSelection()}_observeNodes(){this._nodeObserver=qo(this).observeNodes(e=>{const t=e.addedNodes.filter(vw),n=e.removedNodes.filter(vw);this._updateRanges(t,n),this._redispatchHoverEvents(t)})}_updateRanges(e,t){function n(e){const t=fw(e),n=e.getAttribute("range");if(n)return{side:t,range:JSON.parse(n),hovering:!1,rootId:e.rootId}}const i=e.map(n).filter(e=>!!e),o=t.map(n).filter(e=>!!e);for(const e of o){const t=this._commentRanges.findIndex(t=>t.side===e.side&&_h(t.range,e.range));this.splice("_commentRanges",t,1)}i&&i.length&&this.push("_commentRanges",...i)}_computeKeyLocations(){const e={left:{},right:{}};if(this.lineOfInterest){e[this.lineOfInterest.leftSide?ja.LEFT:ja.RIGHT][this.lineOfInterest.number]=!0}const t=qo(this).getEffectiveChildNodes().filter(vw);for(const n of t){const t=fw(n),i=Number(n.getAttribute("line-num"))||pl,o=n.range||{};e[t][i]=!0,o.start_line&&(e[t][o.start_line]=!0)}return e}_redispatchHoverEvents(e){for(const t of e)t.addEventListener("mouseenter",()=>{t.dispatchEvent(new CustomEvent("comment-thread-mouseenter",{bubbles:!0,composed:!0}))}),t.addEventListener("mouseleave",()=>{t.dispatchEvent(new CustomEvent("comment-thread-mouseleave",{bubbles:!0,composed:!0}))})}cancel(){this.$.diffBuilder.cancel(),this.cancelDebouncer("renderDiffTable")}getCursorStops(){return this.hidden&&this.noAutoRender?[]:this.root?Array.from(this.root.querySelectorAll(":not(.contextControl) > .diff-row")).filter(e=>e.querySelector("button")):[]}isRangeSelected(){return!!this.$.highlights.selectedRange}toggleLeftDiff(){this.toggleClass("no-left")}_blameChanged(e){void 0!==e&&(this.$.diffBuilder.setBlame(e),e?this.classList.add("showBlame"):this.classList.remove("showBlame"))}_computeContainerClass(e,t,n){const i=["diffContainer"];return t===Za.UNIFIED&&i.push("unified"),t===Za.SIDE_BY_SIDE&&i.push("sideBySide"),$h()&&i.push("hiddenscroll"),e&&i.push("canComment"),n&&i.push("displayLine"),i.join(" ")}_handleTap(e){const t=qo(e).localTarget;if(t.classList.contains("showContext"))this.dispatchEvent(new CustomEvent("diff-context-expanded",{detail:{numLines:e.detail.numLines},composed:!0,bubbles:!0})),this.$.diffBuilder.showContext(e.detail.groups,e.detail.section);else if(t.classList.contains("lineNum")||t.classList.contains("lineNumButton"))this.addDraftAtLine(t);else if("HL"===t.tagName||t.classList.contains("content")||t.classList.contains("contentText")){const e=this.$.diffBuilder.getLineElByChild(t);e&&this._selectLine(e)}}_selectLine(e){this.dispatchEvent(new CustomEvent("line-selected",{detail:{side:e.classList.contains("left")?ja.LEFT:ja.RIGHT,number:e.getAttribute("data-value"),path:this.path},composed:!0,bubbles:!0}))}addDraftAtLine(e){if(this._selectLine(e),!this._isValidElForComment(e))return;const t=fh(e);null!==t?this._createComment(e,t===pl?void 0:t):this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Invalid line number"},composed:!0,bubbles:!0}))}createRangeComment(){if(!this.isRangeSelected())throw Error("Selection is needed for new range comment");const e=this.$.highlights.selectedRange;if(!e)throw Error("selected range not set");const{side:t,range:n}=e;this._createCommentForSelection(t,n)}_createCommentForSelection(e,t){const n=t.end_line,i=this.$.diffBuilder.getLineElByNumber(n,e);i&&this._isValidElForComment(i)&&this._createComment(i,n,e,t)}_handleCreateRangeComment(e){const t=e.detail.range,n=e.detail.side;this._createCommentForSelection(n,t)}_isValidElForComment(e){if(!this.loggedIn)return this.dispatchEvent(new CustomEvent("show-auth-required",{composed:!0,bubbles:!0})),!1;if(!this.patchRange)return this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Cannot create comment. Patch range undefined."},composed:!0,bubbles:!0})),!1;const t=e.classList.contains(ja.LEFT)?this.patchRange.basePatchNum:this.patchRange.patchNum,n=Ch(t,"edit"),i=Ch(t,"PARENT")&&Ch(this.patchRange.patchNum,"edit");return n?(this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"You cannot comment on an edit."},composed:!0,bubbles:!0})),!1):!i||(this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"You cannot comment on the base patchset of an edit."},composed:!0,bubbles:!0})),!1)}_createComment(e,t,n,i){const o=this.$.diffBuilder.getContentTdByLineEl(e);if(!o)throw Error("content el not found for line el");n=n||this._getCommentSideByLineAndContent(e,o);const s=this._getPatchNumByLineAndContent(e,o),r=this._getIsParentCommentByLineAndContent(e,o);this.dispatchEvent(new CustomEvent("create-comment",{bubbles:!0,composed:!0,detail:{lineNum:t,side:n,patchNum:s,isOnParent:r,range:i}}))}_getThreadGroupForLine(e){return e.querySelector(".thread-group")}_getOrCreateThreadGroup(e,t){let n=this._getThreadGroupForLine(e);return n||(n=document.createElement("div"),n.className="thread-group",n.setAttribute("data-side",t),e.appendChild(n)),n}_getPatchNumByLineAndContent(e,t){if(!this.patchRange)throw Error("patch range not set");let n=this.patchRange.patchNum;return!e.classList.contains(ja.LEFT)&&!t.classList.contains("remove")||"PARENT"===this.patchRange.basePatchNum||Eh(this.patchRange.basePatchNum)||(n=this.patchRange.basePatchNum),n}_getIsParentCommentByLineAndContent(e,t){if(!this.patchRange)throw Error("patch range not set");return(e.classList.contains(ja.LEFT)||t.classList.contains("remove"))&&("PARENT"===this.patchRange.basePatchNum||Eh(this.patchRange.basePatchNum))}_getCommentSideByLineAndContent(e,t){let n=ja.RIGHT;return(e.classList.contains(ja.LEFT)||t.classList.contains("remove"))&&(n=ja.LEFT),n}_prefsObserver(e,t){this._prefsEqual(e,t)||this._prefsChanged(e)}_prefsEqual(e,t){if(e===t)return!0;if(!e||!t)return!1;const n=Object.keys(e),i=Object.keys(t);return n.length===i.length&&n.every(n=>e[n]===t[n])&&i.every(n=>e[n]===t[n])}_pathObserver(){this._prefsChanged(this.prefs)}_viewModeObserver(){this._prefsChanged(this.prefs)}_cleanup(){this.cancel(),this.blame=null,this._safetyBypass=null,this._showWarning=!1,this.clearDiffContent()}_loadingChanged(e){e&&this._cleanup()}_lineWrappingObserver(){this._prefsChanged(this.prefs)}_prefsChanged(e){if(!e)return;this.blame=null;const t="/COMMIT_MSG"===this.path?72:e.line_length,n={};e.line_wrapping?(this._diffTableClass="full-width","SIDE_BY_SIDE"===this.viewMode&&(n["--content-width"]="none",n["--line-limit"]=`${t}ch`)):(this._diffTableClass="",n["--content-width"]=`${t}ch`),e.font_size&&(n["--font-size"]=`${e.font_size}px`),this.updateStyles(n),this.diff&&!this.noRenderOnPrefsChange&&this._debounceRenderDiffTable()}_diffChanged(e){e&&(this._cleanup(),this._diffLength=this.getDiffLength(e),this._debounceRenderDiffTable())}_debounceRenderDiffTable(){this.debounce("renderDiffTable",()=>this._renderDiffTable())}_renderDiffTable(){if(!this.prefs)return void this.dispatchEvent(new CustomEvent("render",{bubbles:!0,composed:!0}));if(-1===this.prefs.context&&this._diffLength&&this._diffLength>=1e4&&null===this._safetyBypass)return this._showWarning=!0,void this.dispatchEvent(new CustomEvent("render",{bubbles:!0,composed:!0}));this._showWarning=!1;const e=this._computeKeyLocations(),t=this._getBypassPrefs(this.prefs);this.$.diffBuilder.render(e,t).then(()=>{this.dispatchEvent(new CustomEvent("render",{bubbles:!0,composed:!0,detail:{contentRendered:!0}}))})}_handleRenderContent(){this._unobserveIncrementalNodes(),this._incrementalNodeObserver=qo(this).observeNodes(e=>{const t=e.addedNodes.filter(vw);let n;for(const e of t){const t=e.getAttribute("line-num")||"FILE",i=fw(e),o=this.$.diffBuilder.getLineElByNumber(t,i);if(!o){console.error("thread attached to line ",i,t," which does not exist.");continue}const s=this.$.diffBuilder.getContentTdByLineEl(o);if(!s)continue;const r=this._getOrCreateThreadGroup(s,i),a=document.createElement("slot"),l=e.getAttribute("slot");l&&(a.name=l),r.appendChild(a),n=e}n&&n.replaceWith&&n.replaceWith(n)})}_unobserveIncrementalNodes(){this._incrementalNodeObserver&&qo(this).unobserveNodes(this._incrementalNodeObserver)}_unobserveNodes(){this._nodeObserver&&qo(this).unobserveNodes(this._nodeObserver)}_getBypassPrefs(e){return null!==this._safetyBypass?{...e,context:this._safetyBypass}:e}clearDiffContent(){for(this._unobserveIncrementalNodes();this.$.diffTable.hasChildNodes();)this.$.diffTable.removeChild(this.$.diffTable.lastChild)}_computeDiffHeaderItems(e){const t=e.base;return t&&t.diff_header?t.diff_header.filter(e=>!(e.startsWith("diff --git ")||e.startsWith("index ")||e.startsWith("+++ ")||e.startsWith("--- ")||"Binary files differ"===e)):[]}_computeDiffHeaderHidden(e){return 0===e.length}_handleFullBypass(){this._safetyBypass=-1,this._debounceRenderDiffTable()}_handleLimitedBypass(){this._safetyBypass=10,this._debounceRenderDiffTable()}_computeWarningClass(e){return e?"warn":""}_computeErrorClass(e){return e?"showError":""}expandAllContext(){this._handleFullBypass()}_computeNewlineWarning(e,t){const n=[];return e&&n.push("No newline at end of base file."),t&&n.push("No newline at end of revision file."),n.length?n.join(" — "):null}_computeNewlineWarningClass(e,t){return t||!e?"newlineWarning hidden":"newlineWarning"}getDiffLength(e){return e?e.content.reduce((e,t)=>t.ab?e+t.ab.length:e+Math.max(t.a?t.a.length:0,t.b?t.b.length:0),0):0}};_w([Bl({type:String})],yw.prototype,"changeNum",void 0),_w([Bl({type:Boolean})],yw.prototype,"noAutoRender",void 0),_w([Bl({type:Object})],yw.prototype,"patchRange",void 0),_w([Bl({type:String,observer:"_pathObserver"})],yw.prototype,"path",void 0),_w([Bl({type:Object,observer:"_prefsObserver"})],yw.prototype,"prefs",void 0),_w([Bl({type:String})],yw.prototype,"projectName",void 0),_w([Bl({type:Boolean})],yw.prototype,"displayLine",void 0),_w([Bl({type:Boolean})],yw.prototype,"isImageDiff",void 0),_w([Bl({type:Boolean,reflectToAttribute:!0})],yw.prototype,"hidden",void 0),_w([Bl({type:Boolean})],yw.prototype,"noRenderOnPrefsChange",void 0),_w([Bl({type:Array})],yw.prototype,"_commentRanges",void 0),_w([Bl({type:Array})],yw.prototype,"coverageRanges",void 0),_w([Bl({type:Boolean,observer:"_lineWrappingObserver"})],yw.prototype,"lineWrapping",void 0),_w([Bl({type:String,observer:"_viewModeObserver"})],yw.prototype,"viewMode",void 0),_w([Bl({type:Object})],yw.prototype,"lineOfInterest",void 0),_w([Bl({type:Boolean,observer:"_loadingChanged"})],yw.prototype,"loading",void 0),_w([Bl({type:Boolean})],yw.prototype,"loggedIn",void 0),_w([Bl({type:Object,observer:"_diffChanged"})],yw.prototype,"diff",void 0),_w([Bl({type:Array,computed:"_computeDiffHeaderItems(diff.*)"})],yw.prototype,"_diffHeaderItems",void 0),_w([Bl({type:String})],yw.prototype,"_diffTableClass",void 0),_w([Bl({type:Object})],yw.prototype,"baseImage",void 0),_w([Bl({type:Object})],yw.prototype,"revisionImage",void 0),_w([Bl({type:Number})],yw.prototype,"_safetyBypass",void 0),_w([Bl({type:Boolean})],yw.prototype,"_showWarning",void 0),_w([Bl({type:String})],yw.prototype,"errorMessage",void 0),_w([Bl({type:Object,observer:"_blameChanged"})],yw.prototype,"blame",void 0),_w([Bl({type:Number})],yw.prototype,"parentIndex",void 0),_w([Bl({type:Boolean})],yw.prototype,"showNewlineWarningLeft",void 0),_w([Bl({type:Boolean})],yw.prototype,"showNewlineWarningRight",void 0),_w([Bl({type:String,computed:"_computeNewlineWarning(showNewlineWarningLeft, showNewlineWarningRight)"})],yw.prototype,"_newlineWarning",void 0),_w([Bl({type:Number})],yw.prototype,"_diffLength",void 0),_w([Bl({type:Object})],yw.prototype,"_incrementalNodeObserver",void 0),_w([Bl({type:Object})],yw.prototype,"_nodeObserver",void 0),_w([Bl({type:Array})],yw.prototype,"layers",void 0),_w([jl("loggedIn","isAttached")],yw.prototype,"_enableSelectionObserver",null),yw=_w([Ml("gr-diff")],yw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const bw=ta`
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
`;var ww=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Cw=class extends(oo(dr(oa))){constructor(){super(...arguments),this._hljsState={configured:!1,loading:!1,callbacks:[]}}static get template(){return bw}getHLJS(){return new Promise((e,t)=>{this._getHighlightLib()?e(this._getHighlightLib()):(this._hljsState.loading||(this._hljsState.loading=!0,this._loadScript(this._getHLJSUrl()).then(()=>this._onHLJSLibLoaded()).catch(t)),this._hljsState.callbacks.push(e))})}_onHLJSLibLoaded(){const e=this._getHighlightLib();this._hljsState.loading=!1,this.$.jsAPI.handleEvent(Il.HIGHLIGHTJS_LOADED,{hljs:e});for(const t of this._hljsState.callbacks)t(e);this._hljsState.callbacks=[]}_getHighlightLib(){const e=window.hljs;return e&&!this._hljsState.configured&&(this._hljsState.configured=!0,e.configure({classPrefix:"gr-diff gr-syntax gr-syntax-"})),e}_getLibRoot(){return window.STATIC_RESOURCE_PATH?window.STATIC_RESOURCE_PATH+"/":"/"}_loadScript(e){return new Promise((t,n)=>{const i=document.createElement("script");e?(i.setAttribute("src",e),i.onload=t,i.onerror=n,document.head.appendChild(i)):n(new Error("Unable to load blank script url."))})}_getHLJSUrl(){const e=this._getLibRoot();return e?e+"bower_components/highlightjs/highlight.min.js":null}};ww([Bl({type:Object})],Cw.prototype,"_hljsState",void 0),Cw=ww([Ml("gr-lib-loader")],Cw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ew=ta`
  <gr-lib-loader id="libLoader"></gr-lib-loader>
`;var Sw=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Aw=new Map([["application/dart","dart"],["application/json","json"],["application/x-powershell","powershell"],["application/typescript","typescript"],["application/xml","xml"],["application/xquery","xquery"],["application/x-erb","erb"],["text/css","css"],["text/html","html"],["text/javascript","js"],["text/jsx","jsx"],["text/tsx","jsx"],["text/x-c","cpp"],["text/x-c++src","cpp"],["text/x-clojure","clojure"],["text/x-cmake","cmake"],["text/x-coffeescript","coffeescript"],["text/x-common-lisp","lisp"],["text/x-crystal","crystal"],["text/x-csharp","csharp"],["text/x-csrc","cpp"],["text/x-d","d"],["text/x-diff","diff"],["text/x-django","django"],["text/x-dockerfile","dockerfile"],["text/x-ebnf","ebnf"],["text/x-elm","elm"],["text/x-erlang","erlang"],["text/x-fortran","fortran"],["text/x-fsharp","fsharp"],["text/x-go","go"],["text/x-groovy","groovy"],["text/x-haml","haml"],["text/x-handlebars","handlebars"],["text/x-haskell","haskell"],["text/x-haxe","haxe"],["text/x-ini","ini"],["text/x-java","java"],["text/x-julia","julia"],["text/x-kotlin","kotlin"],["text/x-latex","latex"],["text/x-less","less"],["text/x-lua","lua"],["text/x-mathematica","mathematica"],["text/x-nginx-conf","nginx"],["text/x-nsis","nsis"],["text/x-objectivec","objectivec"],["text/x-ocaml","ocaml"],["text/x-perl","perl"],["text/x-pgsql","pgsql"],["text/x-php","php"],["text/x-properties","properties"],["text/x-protobuf","protobuf"],["text/x-puppet","puppet"],["text/x-python","python"],["text/x-q","q"],["text/x-ruby","ruby"],["text/x-rustsrc","rust"],["text/x-scala","scala"],["text/x-scss","scss"],["text/x-scheme","scheme"],["text/x-shell","shell"],["text/x-soy","soy"],["text/x-spreadsheet","excel"],["text/x-sh","bash"],["text/x-sql","sql"],["text/x-swift","swift"],["text/x-systemverilog","sv"],["text/x-tcl","tcl"],["text/x-torque","torque"],["text/x-twig","twig"],["text/x-vb","vb"],["text/x-verilog","v"],["text/x-vhdl","vhdl"],["text/x-yaml","yaml"],["text/vbscript","vbscript"]]),xw=new Set(["gr-diff gr-syntax gr-syntax-attr","gr-diff gr-syntax gr-syntax-attribute","gr-diff gr-syntax gr-syntax-built_in","gr-diff gr-syntax gr-syntax-comment","gr-diff gr-syntax gr-syntax-doctag","gr-diff gr-syntax gr-syntax-function","gr-diff gr-syntax gr-syntax-keyword","gr-diff gr-syntax gr-syntax-link","gr-diff gr-syntax gr-syntax-literal","gr-diff gr-syntax gr-syntax-meta","gr-diff gr-syntax gr-syntax-meta-keyword","gr-diff gr-syntax gr-syntax-name","gr-diff gr-syntax gr-syntax-number","gr-diff gr-syntax gr-syntax-params","gr-diff gr-syntax gr-syntax-regexp","gr-diff gr-syntax gr-syntax-selector-attr","gr-diff gr-syntax gr-syntax-selector-class","gr-diff gr-syntax gr-syntax-selector-id","gr-diff gr-syntax gr-syntax-selector-pseudo","gr-diff gr-syntax gr-syntax-selector-tag","gr-diff gr-syntax gr-syntax-string","gr-diff gr-syntax gr-syntax-tag","gr-diff gr-syntax gr-syntax-template-tag","gr-diff gr-syntax gr-syntax-template-variable","gr-diff gr-syntax gr-syntax-title","gr-diff gr-syntax gr-syntax-type","gr-diff gr-syntax gr-syntax-variable"]),Pw=/^\s*#(if|define).*</,Rw=/L'(\\)?.'/g,Tw=/(@[^\s]+)\(([^)]+)\)/g,Iw=/</g;let kw=class extends(oo(dr(oa))){constructor(){super(...arguments),this.enabled=!0,this._baseRanges=[],this._revisionRanges=[],this._listeners=[],this._processHandle=null,this._processPromise=null}static get template(){return Ew}addListener(e){this.push("_listeners",e)}removeListener(e){this._listeners=this._listeners.filter(t=>t!==e)}annotate(e,t,n){if(!this.enabled)return;if(n.beforeNumber===pl)return;if(n.afterNumber===pl)return;let i;n.type===ul.REMOVE||n.type===ul.BOTH&&"right"!==e.getAttribute("data-side")?i="left":n.type!==ul.ADD&&"left"===e.getAttribute("data-side")||(i="right");let o=[];"left"===i&&this._baseRanges.length>=n.beforeNumber?o=this._baseRanges[n.beforeNumber-1]||[]:"right"===i&&this._revisionRanges.length>=n.afterNumber&&(o=this._revisionRanges[n.afterNumber-1]||[]);for(const t of o)dl.annotateElement(e,t.start,t.length,t.className)}_getLanguage(e){var t;return null!==(t=e.language)&&void 0!==t?t:Aw.get(e.content_type)}process(){var e;if(this.cancel(),this._baseRanges=[],this._revisionRanges=[],!this.enabled||!(null===(e=this.diff)||void 0===e?void 0:e.content.length))return Promise.resolve();if(this.diff.meta_a&&(this._baseLanguage=this._getLanguage(this.diff.meta_a)),this.diff.meta_b&&(this._revisionLanguage=this._getLanguage(this.diff.meta_b)),!this._baseLanguage&&!this._revisionLanguage)return Promise.resolve();const t={sectionIndex:0,lineIndex:0,baseContext:void 0,revisionContext:void 0,lineNums:{left:1,right:1},lastNotify:{left:1,right:1}},n=new Map;return this._processPromise=ld.makeCancelable(this._loadHLJS().then(()=>new Promise(e=>{const i=()=>{if(this._processHandle=null,this._processNextLine(t,n),t.lineIndex++,this._isSectionDone(t)&&(t.lineIndex=0,t.sectionIndex++),!this.diff||t.sectionIndex>=this.diff.content.length)return e(),void this._notify(t);t.lineIndex%100==0?(this._notify(t),this._processHandle=this.async(i,10)):i.call(this)};this._processHandle=this.async(i,1)}))),this._processPromise.finally(()=>{this._processPromise=null})}cancel(){null!==this._processHandle&&(this.cancelAsync(this._processHandle),this._processHandle=null),this._processPromise&&this._processPromise.cancel()}_diffChanged(){this.cancel(),this._baseRanges=[],this._revisionRanges=[]}_rangesFromString(e,t){const n=t.get(e);if(n)return n;const i=document.createElement("div");i.innerHTML=e;const o=this._rangesFromElement(i,0);return t.set(e,o),o}_rangesFromElement(e,t){let n=[];for(const i of e.childNodes){const e=dl.getLength(i);i instanceof Element&&"SPAN"===i.tagName&&"undefined"!==i.className&&(xw.has(i.className)&&n.push({start:t,length:e,className:i.className}),i.children.length&&(n=n.concat(this._rangesFromElement(i,t)))),t+=e}return n}_processNextLine(e,t){if(!this.diff)return;if(!this._hljs)return;let n,i;const o=this.diff.content[e.sectionIndex];let s;o.ab?(n=o.ab[e.lineIndex],i=o.ab[e.lineIndex],e.lineNums.left++,e.lineNums.right++):(o.a&&o.a.length>e.lineIndex&&(n=o.a[e.lineIndex],e.lineNums.left++),o.b&&o.b.length>e.lineIndex&&(i=o.b[e.lineIndex],e.lineNums.right++)),this._baseLanguage&&void 0!==n&&this._hljs.getLanguage(this._baseLanguage)&&(n=this._workaround(this._baseLanguage,n),s=this._hljs.highlight(this._baseLanguage,n,!0,e.baseContext),this.push("_baseRanges",this._rangesFromString(s.value,t)),e.baseContext=s.top),this._revisionLanguage&&void 0!==i&&this._hljs.getLanguage(this._revisionLanguage)&&(i=this._workaround(this._revisionLanguage,i),s=this._hljs.highlight(this._revisionLanguage,i,!0,e.revisionContext),this.push("_revisionRanges",this._rangesFromString(s.value,t)),e.revisionContext=s.top)}_workaround(e,t){return"cpp"===e?(Pw.test(t)&&(t=t.replace(Iw,"|")),Rw.test(t)&&(t=t.replace(Rw,'L"$1."')),t):"java"===e&&Tw.test(t)?t.replace(Tw,"$1 $2 "):"go"===e&&t.includes("'\\\\'")?t.replace("'\\\\'",'"\\\\"'):t}_isSectionDone(e){if(!this.diff)return!0;const t=this.diff.content[e.sectionIndex];return t.ab?e.lineIndex>=t.ab.length:(!t.a||e.lineIndex>=t.a.length)&&(!t.b||e.lineIndex>=t.b.length)}_notify(e){e.lineNums.left-e.lastNotify.left&&(this._notifyRange(e.lastNotify.left,e.lineNums.left,ja.LEFT),e.lastNotify.left=e.lineNums.left),e.lineNums.right-e.lastNotify.right&&(this._notifyRange(e.lastNotify.right,e.lineNums.right,ja.RIGHT),e.lastNotify.right=e.lineNums.right)}_notifyRange(e,t,n){for(const i of this._listeners)i(e,t,n)}_loadHLJS(){return this.$.libLoader.getHLJS().then(e=>{this._hljs=e})}};Sw([Bl({type:Object,observer:"_diffChanged"})],kw.prototype,"diff",void 0),Sw([Bl({type:Boolean})],kw.prototype,"enabled",void 0),Sw([Bl({type:Array})],kw.prototype,"_baseRanges",void 0),Sw([Bl({type:Array})],kw.prototype,"_revisionRanges",void 0),Sw([Bl({type:String})],kw.prototype,"_baseLanguage",void 0),Sw([Bl({type:String})],kw.prototype,"_revisionLanguage",void 0),Sw([Bl({type:Array})],kw.prototype,"_listeners",void 0),Sw([Bl({type:Number})],kw.prototype,"_processHandle",void 0),Sw([Bl({type:Object})],kw.prototype,"_processPromise",void 0),Sw([Bl({type:Object})],kw.prototype,"_hljs",void 0),kw=Sw([Ml("gr-syntax-layer")],kw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Ow=ta`
  <gr-diff
    id="diff"
    change-num="[[changeNum]]"
    no-auto-render="[[noAutoRender]]"
    patch-range="[[patchRange]]"
    path="[[path]]"
    prefs="[[prefs]]"
    project-name="[[projectName]]"
    display-line="[[displayLine]]"
    is-image-diff="[[isImageDiff]]"
    hidden$="[[hidden]]"
    no-render-on-prefs-change="[[noRenderOnPrefsChange]]"
    line-wrapping="[[lineWrapping]]"
    view-mode="[[viewMode]]"
    line-of-interest="[[lineOfInterest]]"
    logged-in="[[_loggedIn]]"
    loading="[[_loading]]"
    error-message="[[_errorMessage]]"
    base-image="[[_baseImage]]"
    revision-image="[[_revisionImage]]"
    coverage-ranges="[[_coverageRanges]]"
    blame="[[_blame]]"
    layers="[[_layers]]"
    diff="[[diff]]"
    show-newline-warning-left="[[_showNewlineWarningLeft(diff)]]"
    show-newline-warning-right="[[_showNewlineWarningRight(diff)]]"
  >
  </gr-diff>
  <gr-syntax-layer
    id="syntaxLayer"
    enabled="[[_syntaxHighlightingEnabled]]"
    diff="[[diff]]"
  ></gr-syntax-layer>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Nw=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const Lw="Diff Total Render",Dw="Diff Content Render",$w="Diff Syntax Render";function Mw(e){if(!e)return!1;const t=e.meta_a&&e.meta_a.content_type.startsWith("image/"),n=e.meta_b&&e.meta_b.content_type.startsWith("image/");return!(!e.binary||!t&&!n)}let Fw=class extends(oo(dr(oa))){constructor(){super(...arguments),this.noAutoRender=!1,this.displayLine=!1,this.filesWeblinks={},this.hidden=!1,this.noRenderOnPrefsChange=!1,this.lineWrapping=!1,this.viewMode=Za.SIDE_BY_SIDE,this._loggedIn=!1,this._loading=!1,this._errorMessage=null,this._baseImage=null,this._revisionImage=null,this._fetchDiffPromise=null,this._blame=null,this._coverageRanges=[],this._parentIndex=null,this._layers=[],this.reporting=n.reportingService}static get template(){return Ow}created(){super.created(),this.addEventListener("create-comment",e=>this._handleCreateComment(e)),this.addEventListener("comment-discard",e=>this._handleCommentDiscard(e)),this.addEventListener("comment-update",e=>this._handleCommentUpdate(e)),this.addEventListener("comment-save",e=>this._handleCommentSave(e)),this.addEventListener("render-start",()=>this._handleRenderStart()),this.addEventListener("render-content",()=>this._handleRenderContent()),this.addEventListener("normalize-range",e=>this._handleNormalizeRange(e)),this.addEventListener("diff-context-expanded",e=>this._handleDiffContextExpanded(e))}ready(){super.ready(),this._canReload()&&this.reload()}attached(){super.attached(),this._getLoggedIn().then(e=>{this._loggedIn=e})}detached(){super.detached(),this.clear()}reload(e){if(this.clear(),!this.path)throw new Error('Missing required "path" property.');if(!this.changeNum)throw new Error('Missing required "changeNum" prop.');this._loading=!0,this._errorMessage=null;const t=this._getIgnoreWhitespace(),n=[this.$.syntaxLayer];for(const e of this.$.jsAPI.getDiffLayers(this.path,this.changeNum))n.push(e);this._layers=n,e&&this._listenToViewportRender(),this._coverageRanges=[],this._getCoverageData();const i=this._getDiff().then(e=>(this._loadedWhitespaceLevel=t,this._reportDiff(e),e)).catch(e=>(this._handleGetDiffError(e),null)),o=i.then(e=>e?this._loadDiffAssets(e):null);return Promise.all([i,o]).then(t=>{const n=t[0];return n?(this.filesWeblinks=this._getFilesWeblinks(n),new Promise(t=>{const i=n=>{n.detail&&n.detail.contentRendered?(this.reporting.time($w),this.$.syntaxLayer.process().finally(()=>{this.reporting.timeEnd($w),this.reporting.timeEnd(Lw),t()})):(this.reporting.timeEnd(Lw),t()),this.removeEventListener("render",i),e&&this.reporting.diffViewContentDisplayed()};this.addEventListener("render",i),this.diff=n})):Promise.resolve()}).catch(e=>{console.warn("Error encountered loading diff:",e)}).then(()=>{this._loading=!1})}clear(){this.path&&this.$.jsAPI.disposeDiffLayers(this.path),this._layers=[]}_getCoverageData(){if(!this.changeNum)throw new Error('Missing required "changeNum" prop.');if(!this.path)throw new Error('Missing required "path" prop.');if(!this.patchRange)throw new Error('Missing required "patchRange".');const e=this.changeNum,t=this.path,n=Sh(this.patchRange.basePatchNum)?this.patchRange.basePatchNum:void 0,i=Sh(this.patchRange.patchNum)?this.patchRange.patchNum:void 0;this.$.jsAPI.getCoverageAnnotationApi().then(o=>{if(!o)return;const s=o.getCoverageProvider();return s?s(e,t,n,i).then(s=>{if(!this.patchRange)throw new Error('Missing "patchRange".');if(!s||e!==this.changeNum||t!==this.path||n!==this.patchRange.basePatchNum||i!==this.patchRange.patchNum)return;const r=this._coverageRanges;this._coverageRanges=s,r.forEach(e=>{o.notify(t,e.code_range.start_line,e.code_range.end_line,e.side)}),s.forEach(e=>{o.notify(t,e.code_range.start_line,e.code_range.end_line,e.side)})}):void 0}).catch(e=>{console.warn("Loading coverage ranges failed: ",e)})}_getFilesWeblinks(e){return this.projectName&&this.commitRange&&this.path?{meta_a:gh.getFileWebLinks(this.projectName,this.commitRange.baseCommit,this.path,{weblinks:e&&e.meta_a&&e.meta_a.web_links}),meta_b:gh.getFileWebLinks(this.projectName,this.commitRange.commit,this.path,{weblinks:e&&e.meta_b&&e.meta_b.web_links})}:{}}cancel(){this.$.diff.cancel(),this.$.syntaxLayer.cancel()}getCursorStops(){return this.$.diff.getCursorStops()}isRangeSelected(){return this.$.diff.isRangeSelected()}createRangeComment(){return this.$.diff.createRangeComment()}toggleLeftDiff(){this.$.diff.toggleLeftDiff()}loadBlame(){if(!this.changeNum)throw new Error('Missing required "changeNum" prop.');if(!this.patchRange)throw new Error('Missing required "patchRange".');if(!this.path)throw new Error('Missing required "path" property.');return this.$.restAPI.getBlame(this.changeNum,this.patchRange.patchNum,this.path,!0).then(e=>e&&e.length?(this._blame=e,e):(this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"No blame information for this diff."},composed:!0,bubbles:!0})),Promise.reject("No blame information for this diff.")))}clearBlame(){this._blame=null}getThreadEls(){return Array.from(this.$.diff.querySelectorAll(".comment-thread"))}addDraftAtLine(e){this.$.diff.addDraftAtLine(e)}clearDiffContent(){this.$.diff.clearDiffContent()}expandAllContext(){this.$.diff.expandAllContext()}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_canReload(){return!(!this.changeNum||!this.patchRange||!this.path||this.noAutoRender)}prefetchDiff(){this.changeNum&&this.patchRange&&this.path&&null===this._fetchDiffPromise&&(this._fetchDiffPromise=this._getDiff())}_getDiff(){if(null!==this._fetchDiffPromise){const e=this._fetchDiffPromise;return this._fetchDiffPromise=null,e}return new Promise((e,t)=>{if(!this.changeNum)throw new Error('Missing required "changeNum".');if(!this.patchRange)throw new Error('Missing required "patchRange".');if(!this.path)throw new Error('Missing required "path" property.');this.$.restAPI.getDiff(this.changeNum,this.patchRange.basePatchNum,this.patchRange.patchNum,this.path,this._getIgnoreWhitespace(),t).then(e)})}_handleGetDiffError(e){409!==e.status?this.showLoadFailure?this._errorMessage=["Encountered error when loading the diff:",e.status,e.statusText].join(" "):this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0})):this.dispatchEvent(new CustomEvent("server-error",{detail:{response:e},composed:!0,bubbles:!0}))}_reportDiff(e){if(!e||!e.content)return;let t=0,n=0;e.content.forEach(e=>{if(e.ab)return;const i=Math.max(e.a?e.a.length:0,e.b?e.b.length:0);e.due_to_rebase?n+=i:t+=i});const i=n+t,o=i?Math.round(100*n/i):0;if(!this.patchRange)throw new Error('Missing required "patchRange".');"PARENT"===this.patchRange.basePatchNum?this.reporting.reportInteraction("diff-against-parent"):0===o?this.reporting.reportInteraction("rebase-percent-zero"):this.reporting.reportInteraction("rebase-percent-nonzero",{percentRebaseDelta:o})}_loadDiffAssets(e){return Mw(e)?this._getImages(e).then(e=>{this._baseImage=e.baseImage,this._revisionImage=e.revisionImage}):(this._baseImage=null,this._revisionImage=null,Promise.resolve())}_computeIsImageDiff(e){return Mw(e)}_commentsChanged(e){const t=[];for(const n of[ja.LEFT,ja.RIGHT]){for(const t of e[n])t.__commentSide=n;t.push(...e[n])}this._clearThreads();const n=this._createThreads(t);for(const e of n){const t=this._createThreadElement(e);this._attachThreadElement(t)}}_createThreads(e){const t=Gf(e),n=[];for(const e of t){if(e.in_reply_to){const t=n.find(t=>t.comments.some(t=>t.id===e.in_reply_to));if(t){t.comments.push(e);continue}}if(!e.__commentSide)throw new Error('Missing "__commentSide".');const t={comments:[e],commentSide:e.__commentSide,patchNum:e.patch_set,lineNum:e.line,isOnParent:"PARENT"===e.side};e.range&&(t.range={...e.range}),n.push(t)}return n}_computeIsBlameLoaded(e){return!!e}_getImages(e){if(!this.changeNum)throw new Error('Missing required "changeNum" prop.');if(!this.patchRange)throw new Error('Missing required "patchRange".');return this.$.restAPI.getImagesForDiff(this.changeNum,e,this.patchRange)}_handleCreateComment(e){const{lineNum:t,side:n,patchNum:i,isOnParent:o,range:s}=e.detail;this._getOrCreateThread(i,t,n,s,o).addOrEditDraft(t,s),this.reporting.recordDraftInteraction()}_getOrCreateThread(e,t,n,i,o){let s=this._getThreadEl(t,n,i);return s||(s=this._createThreadElement({comments:[],commentSide:n,patchNum:e,lineNum:t,range:i,isOnParent:o}),this._attachThreadElement(s)),s}_attachThreadElement(e){this.$.diff.appendChild(e)}_clearThreads(){for(const e of this.getThreadEls()){const t=e.parentNode;t&&t.removeChild(e)}}_createThreadElement(e){const t=document.createElement("gr-comment-thread");t.className="comment-thread",t.setAttribute("slot",`${e.commentSide}-${e.lineNum}`),t.comments=e.comments,t.commentSide=e.commentSide,t.isOnParent=!!e.isOnParent,t.parentIndex=this._parentIndex,this.file&&this.file.basePath&&e.commentSide===ja.LEFT&&!e.isOnParent?t.path=this.file.basePath:t.path=this.path,t.changeNum=this.changeNum,t.patchNum=e.patchNum,t.showPatchset=!1,t.lineNum="FILE"!==e.lineNum?e.lineNum:void 0,t.projectName=this.projectName,t.range=e.range;const n=e=>{const t=e.currentTarget,i=t.parentNode;i&&i.removeChild(t),t.removeEventListener("thread-discard",n)};return t.addEventListener("thread-discard",n),t}_getThreadEl(e,t,n){let i;if(t===ja.LEFT)i={beforeNumber:e};else{if(t!==ja.RIGHT)throw new Error(`Unknown side: ${t}`);i={afterNumber:e}}const o=this._filterThreadElsForLocation(this.getThreadEls(),i,t).filter((function(e){const t=e.getAttribute("range");return _h(t?JSON.parse(t):void 0,n)}));return o.length?o[0]:null}_filterThreadElsForLocation(e,t,n){const i=[];return n!==ja.RIGHT&&i.push((function(e){return e.getAttribute("comment-side")===ja.LEFT&&e.getAttribute("line-num")===String(t.beforeNumber)})),n!==ja.LEFT&&i.push((function(e){return e.getAttribute("comment-side")===ja.RIGHT&&e.getAttribute("line-num")===String(t.afterNumber)})),"FILE"!==t.afterNumber&&"FILE"!==t.beforeNumber||i.push((function(e){return e.getAttribute("comment-side")===n&&!e.getAttribute("line-num")})),e.filter(e=>i.some(t=>t(e)))}_getIgnoreWhitespace(){return this.prefs&&this.prefs.ignore_whitespace?this.prefs.ignore_whitespace:tl.IGNORE_NONE}_whitespaceChanged(e,t,n){void 0!==e&&void 0!==t&&void 0!==n&&(this._fetchDiffPromise=null,e===t||n||this.reload())}_syntaxHighlightingChanged(e,t){void 0!==e&&void 0!==t&&"prefs.syntax_highlighting"===t.path&&(e||this.reload())}_computeParentIndex(e){return e.base&&Eh(e.base.basePatchNum)?Oh(e.base.basePatchNum):null}_handleCommentSave(e){const t=e.detail.comment,n=e.detail.comment.__commentSide,i=this._findDraftIndex(t,n);this.set(["comments",n,i],t),this._handleCommentSaveOrDiscard()}_handleCommentDiscard(e){const t=e.detail.comment;this._removeComment(t),this._handleCommentSaveOrDiscard()}_handleCommentUpdate(e){const t=e.detail.comment,n=e.detail.comment.__commentSide;let i=this._findCommentIndex(t,n);-1===i&&(i=this._findDraftIndex(t,n)),-1!==i?this.set(["comments",n,i],t):this.push(["comments",n],t)}_handleCommentSaveOrDiscard(){this.dispatchEvent(new CustomEvent("diff-comments-modified",{bubbles:!0,composed:!0}))}_removeComment(e){const t=e.__commentSide;if(!t)throw new Error('Missing required "side" in comment.');this._removeCommentFromSide(e,t)}_removeCommentFromSide(e,t){let n=this._findCommentIndex(e,t);-1===n&&(n=this._findDraftIndex(e,t)),-1!==n&&this.splice("comments."+t,n,1)}_findCommentIndex(e,t){return e.id&&this.comments&&this.comments[t]?this.comments[t].findIndex(t=>t.id===e.id):-1}_findDraftIndex(e,t){return Hf(e)&&e.__draftID&&this.comments&&this.comments[t]?this.comments[t].findIndex(t=>Hf(t)&&t.__draftID===e.__draftID):-1}_isSyntaxHighlightingEnabled(e,t){return!!(e&&e.base&&e.base.syntax_highlighting&&t)&&(!this._anyLineTooLong(t)&&this.$.diff.getDiffLength(t)<=2e4)}_anyLineTooLong(e){return!!e&&e.content.some(e=>(e.ab?e.ab:(e.a||[]).concat(e.b||[])).some(e=>e.length>=500))}_listenToViewportRender(){const e=t=>{t>120&&(this.reporting.diffViewDisplayed(),this.$.syntaxLayer.removeListener(e))};this.$.syntaxLayer.addListener(e)}_handleRenderStart(){this.reporting.time(Lw),this.reporting.time(Dw)}_handleRenderContent(){this.reporting.timeEnd(Dw)}_handleNormalizeRange(e){this.reporting.reportInteraction("normalize-range",{side:e.detail.side,lineNum:e.detail.lineNum})}_handleDiffContextExpanded(e){this.reporting.reportInteraction("diff-context-expanded",{numLines:e.detail.numLines})}_lastChunkForSide(e,t){if(!(null==e?void 0:e.content.length))return null;let n,i=e.content.length;do{i--,n=e.content[i]}while(i>=0&&!n.ab&&(t&&(!n.a||!n.a.length)||!t&&(!n.b||!n.b.length)));return-1===i?null:n}_hasTrailingNewlines(e,t){const n=this._lastChunkForSide(e,t);if(!n)return null;let i;return i=n.ab?n.ab:t?n.a:n.b,i?""===i[i.length-1]:null}_showNewlineWarningLeft(e){return!1===this._hasTrailingNewlines(e,!0)}_showNewlineWarningRight(e){return!1===this._hasTrailingNewlines(e,!1)}};Nw([Bl({type:Number})],Fw.prototype,"changeNum",void 0),Nw([Bl({type:Boolean})],Fw.prototype,"noAutoRender",void 0),Nw([Bl({type:Object})],Fw.prototype,"patchRange",void 0),Nw([Bl({type:Object})],Fw.prototype,"file",void 0),Nw([Bl({type:String})],Fw.prototype,"path",void 0),Nw([Bl({type:Object})],Fw.prototype,"prefs",void 0),Nw([Bl({type:String})],Fw.prototype,"projectName",void 0),Nw([Bl({type:Boolean})],Fw.prototype,"displayLine",void 0),Nw([Bl({type:Boolean,computed:"_computeIsImageDiff(diff)",notify:!0})],Fw.prototype,"isImageDiff",void 0),Nw([Bl({type:Object})],Fw.prototype,"commitRange",void 0),Nw([Bl({type:Object,notify:!0})],Fw.prototype,"filesWeblinks",void 0),Nw([Bl({type:Boolean,reflectToAttribute:!0})],Fw.prototype,"hidden",void 0),Nw([Bl({type:Boolean})],Fw.prototype,"noRenderOnPrefsChange",void 0),Nw([Bl({type:Object,observer:"_commentsChanged"})],Fw.prototype,"comments",void 0),Nw([Bl({type:Boolean})],Fw.prototype,"lineWrapping",void 0),Nw([Bl({type:String})],Fw.prototype,"viewMode",void 0),Nw([Bl({type:Object})],Fw.prototype,"lineOfInterest",void 0),Nw([Bl({type:Boolean})],Fw.prototype,"showLoadFailure",void 0),Nw([Bl({type:Boolean,notify:!0,computed:"_computeIsBlameLoaded(_blame)"})],Fw.prototype,"isBlameLoaded",void 0),Nw([Bl({type:Boolean})],Fw.prototype,"_loggedIn",void 0),Nw([Bl({type:Boolean})],Fw.prototype,"_loading",void 0),Nw([Bl({type:String})],Fw.prototype,"_errorMessage",void 0),Nw([Bl({type:Object})],Fw.prototype,"_baseImage",void 0),Nw([Bl({type:Object})],Fw.prototype,"_revisionImage",void 0),Nw([Bl({type:Object,notify:!0})],Fw.prototype,"diff",void 0),Nw([Bl({type:Object})],Fw.prototype,"_fetchDiffPromise",void 0),Nw([Bl({type:Object})],Fw.prototype,"_blame",void 0),Nw([Bl({type:Array})],Fw.prototype,"_coverageRanges",void 0),Nw([Bl({type:String})],Fw.prototype,"_loadedWhitespaceLevel",void 0),Nw([Bl({type:Number,computed:"_computeParentIndex(patchRange.*)"})],Fw.prototype,"_parentIndex",void 0),Nw([Bl({type:Boolean,computed:"_isSyntaxHighlightingEnabled(prefs.*, diff)"})],Fw.prototype,"_syntaxHighlightingEnabled",void 0),Nw([Bl({type:Array})],Fw.prototype,"_layers",void 0),Nw([jl("prefs.ignore_whitespace","_loadedWhitespaceLevel","noRenderOnPrefsChange")],Fw.prototype,"_whitespaceChanged",null),Nw([jl("noRenderOnPrefsChange","prefs.*")],Fw.prototype,"_syntaxHighlightingChanged",null),Fw=Nw([Ml("gr-diff-host")],Fw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Bw=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div id="diffPreferences" class="gr-form-styles">
    <section>
      <span class="title">Context</span>
      <span class="value">
        <gr-select id="contextSelect" bind-value="{{diffPrefs.context}}">
          <select
            on-keypress="_handleDiffPrefsChanged"
            on-change="_handleDiffPrefsChanged"
          >
            <option value="3">3 lines</option>
            <option value="10">10 lines</option>
            <option value="25">25 lines</option>
            <option value="50">50 lines</option>
            <option value="75">75 lines</option>
            <option value="100">100 lines</option>
            <option value="-1">Whole file</option>
          </select>
        </gr-select>
      </span>
    </section>
    <section>
      <span class="title">Fit to screen</span>
      <span class="value">
        <input
          id="lineWrappingInput"
          type="checkbox"
          checked="[[diffPrefs.line_wrapping]]"
          on-change="_handleLineWrappingTap"
        />
      </span>
    </section>
    <section>
      <span class="title">Diff width</span>
      <span class="value">
        <iron-input
          type="number"
          prevent-invalid-input=""
          allowed-pattern="[0-9]"
          bind-value="{{diffPrefs.line_length}}"
          on-keypress="_handleDiffPrefsChanged"
          on-change="_handleDiffPrefsChanged"
        >
          <input
            is="iron-input"
            type="number"
            id="columnsInput"
            prevent-invalid-input=""
            allowed-pattern="[0-9]"
            bind-value="{{diffPrefs.line_length}}"
            on-keypress="_handleDiffPrefsChanged"
            on-change="_handleDiffPrefsChanged"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Tab width</span>
      <span class="value">
        <iron-input
          type="number"
          prevent-invalid-input=""
          allowed-pattern="[0-9]"
          bind-value="{{diffPrefs.tab_size}}"
          on-keypress="_handleDiffPrefsChanged"
          on-change="_handleDiffPrefsChanged"
        >
          <input
            is="iron-input"
            type="number"
            id="tabSizeInput"
            prevent-invalid-input=""
            allowed-pattern="[0-9]"
            bind-value="{{diffPrefs.tab_size}}"
            on-keypress="_handleDiffPrefsChanged"
            on-change="_handleDiffPrefsChanged"
          />
        </iron-input>
      </span>
    </section>
    <section hidden$="[[!diffPrefs.font_size]]">
      <span class="title">Font size</span>
      <span class="value">
        <iron-input
          type="number"
          prevent-invalid-input=""
          allowed-pattern="[0-9]"
          bind-value="{{diffPrefs.font_size}}"
          on-keypress="_handleDiffPrefsChanged"
          on-change="_handleDiffPrefsChanged"
        >
          <input
            is="iron-input"
            type="number"
            id="fontSizeInput"
            prevent-invalid-input=""
            allowed-pattern="[0-9]"
            bind-value="{{diffPrefs.font_size}}"
            on-keypress="_handleDiffPrefsChanged"
            on-change="_handleDiffPrefsChanged"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Show tabs</span>
      <span class="value">
        <input
          id="showTabsInput"
          type="checkbox"
          checked="[[diffPrefs.show_tabs]]"
          on-change="_handleShowTabsTap"
        />
      </span>
    </section>
    <section>
      <span class="title">Show trailing whitespace</span>
      <span class="value">
        <input
          id="showTrailingWhitespaceInput"
          type="checkbox"
          checked="[[diffPrefs.show_whitespace_errors]]"
          on-change="_handleShowTrailingWhitespaceTap"
        />
      </span>
    </section>
    <section>
      <span class="title">Syntax highlighting</span>
      <span class="value">
        <input
          id="syntaxHighlightInput"
          type="checkbox"
          checked="[[diffPrefs.syntax_highlighting]]"
          on-change="_handleSyntaxHighlightTap"
        />
      </span>
    </section>
    <section>
      <span class="title">Automatically mark viewed files reviewed</span>
      <span class="value">
        <input
          id="automaticReviewInput"
          type="checkbox"
          checked="[[!diffPrefs.manual_review]]"
          on-change="_handleAutomaticReviewTap"
        />
      </span>
    </section>
    <section>
      <div class="pref">
        <span class="title">Ignore Whitespace</span>
        <span class="value">
          <gr-select bind-value="{{diffPrefs.ignore_whitespace}}">
            <select
              on-keypress="_handleDiffPrefsChanged"
              on-change="_handleDiffPrefsChanged"
            >
              <option value="IGNORE_NONE">None</option>
              <option value="IGNORE_TRAILING">Trailing</option>
              <option value="IGNORE_LEADING_AND_TRAILING"
                >Leading &amp; trailing</option
              >
              <option value="IGNORE_ALL">All</option>
            </select>
          </gr-select>
        </span>
      </div>
    </section>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var jw=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Hw=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasUnsavedChanges=!1}static get template(){return Bw}loadData(){return this.$.restAPI.getDiffPreferences().then(e=>{this.diffPrefs=e})}_handleDiffPrefsChanged(){this.hasUnsavedChanges=!0}_handleLineWrappingTap(){this.set("diffPrefs.line_wrapping",this.$.lineWrappingInput.checked),this._handleDiffPrefsChanged()}_handleShowTabsTap(){this.set("diffPrefs.show_tabs",this.$.showTabsInput.checked),this._handleDiffPrefsChanged()}_handleShowTrailingWhitespaceTap(){this.set("diffPrefs.show_whitespace_errors",this.$.showTrailingWhitespaceInput.checked),this._handleDiffPrefsChanged()}_handleSyntaxHighlightTap(){this.set("diffPrefs.syntax_highlighting",this.$.syntaxHighlightInput.checked),this._handleDiffPrefsChanged()}_handleAutomaticReviewTap(){this.set("diffPrefs.manual_review",!this.$.automaticReviewInput.checked),this._handleDiffPrefsChanged()}save(){return this.diffPrefs?this.$.restAPI.saveDiffPreferences(this.diffPrefs).then(e=>{this.hasUnsavedChanges=!1}):Promise.reject(new Error("Missing diff preferences"))}};jw([Bl({type:Boolean,notify:!0})],Hw.prototype,"hasUnsavedChanges",void 0),jw([Bl({type:Object})],Hw.prototype,"diffPrefs",void 0),Hw=jw([Ml("gr-diff-preferences")],Hw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Uw=ta`
  <style include="shared-styles">
    .diffHeader,
    .diffActions {
      padding: var(--spacing-l) var(--spacing-xl);
    }
    .diffHeader,
    .diffActions {
      background-color: var(--dialog-background-color);
    }
    .diffHeader {
      border-bottom: 1px solid var(--border-color);
      font-weight: var(--font-weight-bold);
    }
    .diffActions {
      border-top: 1px solid var(--border-color);
      display: flex;
      justify-content: flex-end;
    }
    .diffPrefsOverlay gr-button {
      margin-left: var(--spacing-l);
    }
    div.edited:after {
      color: var(--deemphasized-text-color);
      content: ' *';
    }
    #diffPreferences {
      display: flex;
      padding: var(--spacing-s) var(--spacing-xl);
    }
  </style>
  <gr-overlay id="diffPrefsOverlay" with-backdrop="">
    <div class$="diffHeader [[_computeHeaderClass(_diffPrefsChanged)]]">
      Diff Preferences
    </div>
    <gr-diff-preferences
      id="diffPreferences"
      diff-prefs="{{_editableDiffPrefs}}"
      has-unsaved-changes="{{_diffPrefsChanged}}"
    ></gr-diff-preferences>
    <div class="diffActions">
      <gr-button id="cancelButton" link="" on-click="_handleCancelDiff">
        Cancel
      </gr-button>
      <gr-button
        id="saveButton"
        link=""
        primary=""
        on-click="_handleSaveDiffPreferences"
        disabled$="[[!_diffPrefsChanged]]"
      >
        Save
      </gr-button>
    </div>
  </gr-overlay>
`;var Gw=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Vw=class extends(oo(dr(oa))){static get template(){return Uw}getFocusStops(){return{start:this.$.diffPreferences.$.contextSelect,end:this.$.saveButton.disabled?this.$.cancelButton:this.$.saveButton}}resetFocus(){this.$.diffPreferences.$.contextSelect.focus()}_computeHeaderClass(e){return e?"edited":""}_handleCancelDiff(e){e.stopPropagation(),this.$.diffPrefsOverlay.close()}_onDiffPrefsChanged(){this.$.diffPrefsOverlay.setFocusStops(this.getFocusStops())}open(){this._editableDiffPrefs=JSON.parse(JSON.stringify(this.diffPrefs)),this.$.diffPrefsOverlay.open().then(()=>{const e=this.getFocusStops();this.$.diffPrefsOverlay.setFocusStops(e),this.resetFocus()})}_handleSaveDiffPreferences(){this.diffPrefs=this._editableDiffPrefs,this.$.diffPreferences.save().then(()=>{this.dispatchEvent(new CustomEvent("reload-diff-preference",{composed:!0,bubbles:!1})),this.$.diffPrefsOverlay.close()})}};Gw([Bl({type:Object})],Vw.prototype,"diffPrefs",void 0),Gw([Bl({type:Object})],Vw.prototype,"_editableDiffPrefs",void 0),Gw([Bl({type:Boolean,observer:"_onDiffPrefsChanged"})],Vw.prototype,"_diffPrefsChanged",void 0),Vw=Gw([Ml("gr-diff-preferences-dialog")],Vw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const zw=ta`
  <style include="shared-styles">
    :host {
      align-items: center;
      display: flex;
      justify-content: flex-end;
    }
    #actions {
      margin-right: var(--spacing-l);
    }
    gr-button,
    gr-dropdown {
      --gr-button: {
        height: 1.8em;
      }
    }
    gr-dropdown {
      --gr-dropdown-item: {
        background-color: transparent;
        border: none;
        color: var(--link-color);
        text-transform: uppercase;
      }
    }
  </style>
  <gr-dropdown
    id="actions"
    items="[[_fileActions]]"
    down-arrow=""
    vertical-offset="20"
    on-tap-item="_handleActionTap"
    link=""
    >Actions</gr-dropdown
  >
`;var Ww=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let qw=class extends(oo(dr(oa))){constructor(){super(...arguments),this._allFileActions=Object.values(Nl.Actions)}static get template(){return zw}_handleActionTap(e){e.preventDefault(),e.stopPropagation(),this._dispatchFileAction(e.detail.id,this.filePath)}_dispatchFileAction(e,t){this.dispatchEvent(new CustomEvent("file-action-tap",{detail:{action:e,path:t},bubbles:!0,composed:!0}))}_computeFileActions(e){return e.map(e=>({name:e.label,id:e.id}))}};Ww([Bl({type:String})],qw.prototype,"filePath",void 0),Ww([Bl({type:Array})],qw.prototype,"_allFileActions",void 0),Ww([Bl({type:Array,computed:"_computeFileActions(_allFileActions)"})],qw.prototype,"_fileActions",void 0),qw=Ww([Ml("gr-edit-file-controls")],qw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Kw=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    .row {
      align-items: center;
      border-top: 1px solid var(--border-color);
      display: flex;
      min-height: calc(var(--line-height-normal) + 2 * var(--spacing-s));
      padding: var(--spacing-xs) var(--spacing-l);
    }
    /* The class defines a content visible only to screen readers */
    .noCommentsScreenReaderText {
      opacity: 0;
      max-width: 1px;
      overflow: hidden;
      display: none;
    }
    div[role='gridcell']
      > div.comments
      > span:empty
      + span:empty
      + span.noCommentsScreenReaderText {
      display: inline;
    }
    :host(.loading) .row {
      opacity: 0.5;
    }
    :host(.editMode) .hideOnEdit {
      display: none;
    }
    .showOnEdit {
      display: none;
    }
    :host(.editMode) .showOnEdit {
      display: initial;
    }
    .invisible {
      visibility: hidden;
    }
    .header-row {
      background-color: var(--background-color-secondary);
    }
    .controlRow {
      align-items: center;
      display: flex;
      height: 2.25em;
      justify-content: center;
    }
    .controlRow.invisible,
    .show-hide.invisible {
      display: none;
    }
    .reviewed,
    .status {
      align-items: center;
      display: inline-flex;
    }
    .reviewed {
      display: inline-block;
      text-align: left;
      width: 1.5em;
    }
    .status {
      display: inline-block;
      border-radius: var(--border-radius);
      margin-left: var(--spacing-s);
      padding: 0 var(--spacing-m);
      color: var(--primary-text-color);
      font-size: var(--font-size-small);
      background-color: var(--dark-add-highlight-color);
    }
    .status.invisible,
    .status.M {
      display: none;
    }
    .status.D,
    .status.R,
    .status.W {
      background-color: var(--dark-remove-highlight-color);
    }
    .status.U {
      background-color: var(--comment-background-color);
    }
    .file-row {
      cursor: pointer;
    }
    .file-row.expanded {
      border-bottom: 1px solid var(--border-color);
      position: -webkit-sticky;
      position: sticky;
      top: 0;
      /* Has to visible above the diff view, and by default has a lower
         z-index. setting to 1 places it directly above. */
      z-index: 1;
    }
    .file-row:hover {
      background-color: var(--hover-background-color);
    }
    .file-row.selected {
      background-color: var(--selection-background-color);
    }
    .file-row.expanded,
    .file-row.expanded:hover {
      background-color: var(--expanded-background-color);
    }
    .path {
      cursor: pointer;
      flex: 1;
      /* Wrap it into multiple lines if too long. */
      white-space: normal;
      word-break: break-word;
    }
    .oldPath {
      color: var(--deemphasized-text-color);
    }
    .header-stats {
      text-align: center;
      min-width: 7.5em;
    }
    .stats {
      text-align: right;
      min-width: 7.5em;
    }
    .comments {
      padding-left: var(--spacing-l);
      min-width: 7.5em;
    }
    .row:not(.header-row) .stats,
    .total-stats {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      display: flex;
    }
    .sizeBars {
      margin-left: var(--spacing-m);
      min-width: 7em;
      text-align: center;
    }
    .sizeBars.hide {
      display: none;
    }
    .added,
    .removed {
      display: inline-block;
      min-width: 3.5em;
    }
    .added {
      color: var(--positive-green-text-color);
    }
    .removed {
      color: var(--negative-red-text-color);
      text-align: left;
      min-width: 4em;
      padding-left: var(--spacing-s);
    }
    .drafts {
      color: #c62828;
      font-weight: var(--font-weight-bold);
    }
    .show-hide-icon:focus {
      outline: none;
    }
    .show-hide {
      margin-left: var(--spacing-s);
      width: 1.9em;
    }
    .fileListButton {
      margin: var(--spacing-m);
    }
    .totalChanges {
      justify-content: flex-end;
      text-align: right;
    }
    .warning {
      color: var(--deemphasized-text-color);
    }
    input.show-hide {
      display: none;
    }
    label.show-hide {
      cursor: pointer;
      display: block;
      min-width: 2em;
    }
    gr-diff {
      display: block;
      overflow-x: auto;
    }
    .truncatedFileName {
      display: none;
    }
    .mobile {
      display: none;
    }
    .reviewed {
      margin-left: var(--spacing-xxl);
      width: 15em;
    }
    .reviewedSwitch {
      color: var(--link-color);
      opacity: 0;
      justify-content: flex-end;
      width: 100%;
    }
    .reviewedSwitch:hover {
      cursor: pointer;
      opacity: 100;
    }
    .row:focus {
      outline: none;
    }
    .row:hover .reviewedSwitch,
    .row:focus-within .reviewedSwitch,
    .row.expanded .reviewedSwitch {
      opacity: 100;
    }
    .reviewedLabel {
      color: var(--deemphasized-text-color);
      margin-right: var(--spacing-l);
      opacity: 0;
    }
    .reviewedLabel.isReviewed {
      display: initial;
      opacity: 100;
    }
    .editFileControls {
      width: 7em;
    }
    .markReviewed:focus {
      outline: none;
    }
    .markReviewed,
    .pathLink {
      display: inline-block;
      margin: -2px 0;
      padding: var(--spacing-s) 0;
      text-decoration: none;
    }
    .pathLink:hover span.fullFileName,
    .pathLink:hover span.truncatedFileName {
      text-decoration: underline;
    }

    /** copy on file path **/
    .pathLink gr-copy-clipboard,
    .oldPath gr-copy-clipboard {
      display: inline-block;
      visibility: hidden;
      vertical-align: bottom;
      --gr-button: {
        padding: 0px;
      }
    }
    .row:focus-within gr-copy-clipboard,
    .row:hover gr-copy-clipboard {
      visibility: visible;
    }

    /** small screen breakpoint: 768px */
    @media screen and (max-width: 55em) {
      .desktop {
        display: none;
      }
      .mobile {
        display: block;
      }
      .row.selected {
        background-color: var(--view-background-color);
      }
      .stats {
        display: none;
      }
      .reviewed,
      .status {
        justify-content: flex-start;
      }
      .reviewed {
        display: none;
      }
      .comments {
        min-width: initial;
      }
      .expanded .fullFileName,
      .truncatedFileName {
        display: inline;
      }
      .expanded .truncatedFileName,
      .fullFileName {
        display: none;
      }
    }
    :host(.hideComments) {
      --gr-comment-thread-display: none;
    }
  </style>
  <div
    id="container"
    on-click="_handleFileListClick"
    role="grid"
    aria-label="Files list"
  >
    <div class="header-row row" role="row">
      <!-- endpoint: change-view-file-list-header-prepend -->
      <template is="dom-if" if="[[_showPrependedDynamicColumns]]">
        <template
          is="dom-repeat"
          items="[[_dynamicPrependedHeaderEndpoints]]"
          as="headerEndpoint"
        >
          <gr-endpoint-decorator name$="[[headerEndpoint]]" role="columnheader">
            <gr-endpoint-param
              name="change"
              value="[[change]]"
            ></gr-endpoint-param>
            <gr-endpoint-param name="patchRange" value="[[patchRange]]">
            </gr-endpoint-param>
          </gr-endpoint-decorator>
        </template>
      </template>
      <div class="path" role="columnheader">File</div>
      <div class="comments" role="columnheader">Comments</div>
      <div class="sizeBars" role="columnheader">Size</div>
      <div class="header-stats" role="columnheader">Delta</div>
      <!-- endpoint: change-view-file-list-header -->
      <template is="dom-if" if="[[_showDynamicColumns]]">
        <template
          is="dom-repeat"
          items="[[_dynamicHeaderEndpoints]]"
          as="headerEndpoint"
        >
          <gr-endpoint-decorator name$="[[headerEndpoint]]" role="columnheader">
          </gr-endpoint-decorator>
        </template>
      </template>
      <!-- Empty div here exists to keep spacing in sync with file rows. -->
      <div
        class="reviewed hideOnEdit"
        hidden$="[[!_loggedIn]]"
        aria-hidden="true"
      ></div>
      <div class="editFileControls showOnEdit" aria-hidden="true"></div>
      <div class="show-hide" aria-hidden="true"></div>
    </div>

    <template
      is="dom-repeat"
      items="[[_shownFiles]]"
      id="files"
      as="file"
      initial-count="[[fileListIncrement]]"
      target-framerate="1"
    >
      [[_reportRenderedRow(index)]]
      <div class="stickyArea">
        <div
          class$="file-row row [[_computePathClass(file.__path, _expandedFiles.*)]]"
          data-file$="[[_computeFileRange(file)]]"
          tabindex="-1"
          role="row"
        >
          <!-- endpoint: change-view-file-list-content-prepend -->
          <template is="dom-if" if="[[_showPrependedDynamicColumns]]">
            <template
              is="dom-repeat"
              items="[[_dynamicPrependedContentEndpoints]]"
              as="contentEndpoint"
            >
              <gr-endpoint-decorator name="[[contentEndpoint]]" role="gridcell">
                <gr-endpoint-param name="change" value="[[change]]">
                </gr-endpoint-param>
                <gr-endpoint-param name="changeNum" value="[[changeNum]]">
                </gr-endpoint-param>
                <gr-endpoint-param name="patchRange" value="[[patchRange]]">
                </gr-endpoint-param>
                <gr-endpoint-param name="path" value="[[file.__path]]">
                </gr-endpoint-param>
              </gr-endpoint-decorator>
            </template>
          </template>
          <!-- TODO: Remove data-url as it appears its not used -->
          <span
            data-url="[[_computeDiffURL(change, patchRange, file.__path, editMode)]]"
            class="path"
            role="gridcell"
          >
            <a
              class="pathLink"
              href$="[[_computeDiffURL(change, patchRange, file.__path, editMode)]]"
            >
              <span
                title$="[[_computeDisplayPath(file.__path)]]"
                class="fullFileName"
              >
                [[_computeDisplayPath(file.__path)]]
              </span>
              <span
                title$="[[_computeDisplayPath(file.__path)]]"
                class="truncatedFileName"
              >
                [[_computeTruncatedPath(file.__path)]]
              </span>
              <span
                class$="[[_computeStatusClass(file)]]"
                tabindex="0"
                title$="[[_computeFileStatusLabel(file.status)]]"
                aria-label$="[[_computeFileStatusLabel(file.status)]]"
              >
                [[_computeFileStatusLabel(file.status)]]
              </span>
              <gr-copy-clipboard
                hide-input=""
                text="[[file.__path]]"
              ></gr-copy-clipboard>
            </a>
            <template is="dom-if" if="[[file.old_path]]">
              <div class="oldPath" title$="[[file.old_path]]">
                [[file.old_path]]
                <gr-copy-clipboard
                  hide-input=""
                  text="[[file.old_path]]"
                ></gr-copy-clipboard>
              </div>
            </template>
          </span>
          <div role="gridcell">
            <div class="comments desktop">
              <span class="drafts"
                ><!-- This comments ensure that span is empty when the function
                returns empty string.
              -->[[_computeDraftsString(changeComments, patchRange,
                file.__path)]]<!-- This comments ensure that span is empty when
                the function returns empty string.
           --></span
              >
              <span
                ><!--
              -->[[_computeCommentsString(changeComments, patchRange,
                file.__path)]]<!--
           --></span
              >
              <span class="noCommentsScreenReaderText">
                <!-- Screen readers read the following content only if 2 other
              spans in the parent div is empty. The content is not visible on
              the page.
              Without this span, screen readers don't navigate correctly inside
              table, because empty div doesn't rendered. For example, VoiceOver
              jumps back to the whole table.
              We can use &nbsp instead, but it sounds worse.
              -->
                No comments
              </span>
            </div>
            <div class="comments mobile">
              <span class="drafts"
                ><!-- This comments ensure that span is empty when the function
                returns empty string.
              -->[[_computeDraftsStringMobile(changeComments, patchRange,
                file.__path)]]<!-- This comments ensure that span is empty when
                the function returns empty string.
           --></span
              >
              <span
                ><!--
             -->[[_computeCommentsStringMobile(changeComments, patchRange,
                file.__path)]]<!--
           --></span
              >
              <span class="noCommentsScreenReaderText">
                <!-- The same as for desktop comments -->
                No comments
              </span>
            </div>
          </div>
          <div role="gridcell">
            <!-- The content must be in a separate div. It guarantees, that
              gridcell always visible for screen readers.
              For example, without a nested div screen readers pronounce the
              "Commit message" row content with incorrect column headers.
            -->
            <div
              class$="[[_computeSizeBarsClass(_showSizeBars, file.__path)]]"
              aria-label="A bar that represents the addition and deletion ratio for the current file"
            >
              <svg width="61" height="8">
                <rect
                  x$="[[_computeBarAdditionX(file, _sizeBarLayout)]]"
                  y="0"
                  height="8"
                  fill="var(--positive-green-text-color)"
                  width$="[[_computeBarAdditionWidth(file, _sizeBarLayout)]]"
                ></rect>
                <rect
                  x$="[[_computeBarDeletionX(_sizeBarLayout)]]"
                  y="0"
                  height="8"
                  fill="var(--negative-red-text-color)"
                  width$="[[_computeBarDeletionWidth(file, _sizeBarLayout)]]"
                ></rect>
              </svg>
            </div>
          </div>
          <div class="stats" role="gridcell">
            <!-- The content must be in a separate div. It guarantees, that
            gridcell always visible for screen readers.
            For example, without a nested div screen readers pronounce the
            "Commit message" row content with incorrect column headers.
            -->
            <div class$="[[_computeClass('', file.__path)]]">
              <span
                class="added"
                tabindex="0"
                aria-label$="[[file.lines_inserted]] lines added"
                hidden$="[[file.binary]]"
              >
                +[[file.lines_inserted]]
              </span>
              <span
                class="removed"
                tabindex="0"
                aria-label$="[[file.lines_deleted]] lines removed"
                hidden$="[[file.binary]]"
              >
                -[[file.lines_deleted]]
              </span>
              <span
                class$="[[_computeBinaryClass(file.size_delta)]]"
                hidden$="[[!file.binary]]"
              >
                [[_formatBytes(file.size_delta)]] [[_formatPercentage(file.size,
                file.size_delta)]]
              </span>
            </div>
          </div>
          <!-- endpoint: change-view-file-list-content -->
          <template is="dom-if" if="[[_showDynamicColumns]]">
            <template
              is="dom-repeat"
              items="[[_dynamicContentEndpoints]]"
              as="contentEndpoint"
            >
              <div class$="[[_computeClass('', file.__path)]]" role="gridcell">
                <gr-endpoint-decorator name="[[contentEndpoint]]">
                  <gr-endpoint-param name="change" value="[[change]]">
                  </gr-endpoint-param>
                  <gr-endpoint-param name="changeNum" value="[[changeNum]]">
                  </gr-endpoint-param>
                  <gr-endpoint-param name="patchRange" value="[[patchRange]]">
                  </gr-endpoint-param>
                  <gr-endpoint-param name="path" value="[[file.__path]]">
                  </gr-endpoint-param>
                </gr-endpoint-decorator>
              </div>
            </template>
          </template>
          <div
            class="reviewed hideOnEdit"
            role="gridcell"
            hidden$="[[!_loggedIn]]"
          >
            <span
              class$="reviewedLabel [[_computeReviewedClass(file.isReviewed)]]"
              aria-hidden$="[[!file.isReviewed]]"
              >Reviewed</span
            >
            <!-- Do not use input type="checkbox" with hidden input and
                  visible label here. Screen readers don't read/interract
                  correctly with such input.
              -->
            <span
              class="reviewedSwitch"
              role="switch"
              tabindex="0"
              on-click="_reviewedClick"
              on-keydown="_reviewedClick"
              aria-label="Reviewed"
              aria-checked$="[[_booleanToString(file.isReviewed)]]"
            >
              <!-- Trick with tabindex to avoid outline on mouse focus, but
                preserve focus outline for keyboard navigation -->
              <span
                tabindex="-1"
                class="markReviewed"
                title$="[[_reviewedTitle(file.isReviewed)]]"
                >[[_computeReviewedText(file.isReviewed)]]</span
              >
            </span>
          </div>
          <div
            class="editFileControls showOnEdit"
            role="gridcell"
            aria-hidden$="[[!editMode]]"
          >
            <template is="dom-if" if="[[editMode]]">
              <gr-edit-file-controls
                class$="[[_computeClass('', file.__path)]]"
                file-path="[[file.__path]]"
              ></gr-edit-file-controls>
            </template>
          </div>
          <div class="show-hide" role="gridcell">
            <!-- Do not use input type="checkbox" with hidden input and
                visible label here. Screen readers don't read/interract
                correctly with such input.
            -->
            <span
              class="show-hide"
              data-path$="[[file.__path]]"
              data-expand="true"
              role="switch"
              tabindex="0"
              aria-checked$="[[_isFileExpandedStr(file.__path, _expandedFiles.*)]]"
              aria-label="Expand file"
              on-click="_expandedClick"
              on-keydown="_expandedClick"
            >
              <!-- Trick with tabindex to avoid outline on mouse focus, but
              preserve focus outline for keyboard navigation -->
              <iron-icon
                class="show-hide-icon"
                tabindex="-1"
                id="icon"
                icon="[[_computeShowHideIcon(file.__path, _expandedFiles.*)]]"
              >
              </iron-icon>
            </span>
          </div>
        </div>
        <template
          is="dom-if"
          if="[[_isFileExpanded(file.__path, _expandedFiles.*)]]"
        >
          <gr-diff-host
            no-auto-render=""
            show-load-failure=""
            display-line="[[_displayLine]]"
            hidden="[[!_isFileExpanded(file.__path, _expandedFiles.*)]]"
            change-num="[[changeNum]]"
            patch-range="[[patchRange]]"
            file="[[_computeFileRange(file)]]"
            path="[[file.__path]]"
            prefs="[[diffPrefs]]"
            project-name="[[change.project]]"
            no-render-on-prefs-change=""
            view-mode="[[diffViewMode]]"
          ></gr-diff-host>
        </template>
      </div>
    </template>
  </div>
  <div class="row totalChanges" hidden$="[[_hideChangeTotals]]">
    <div class="total-stats">
      <div>
        <span
          class="added"
          tabindex="0"
          aria-label$="Total [[_patchChange.inserted]] lines added"
        >
          +[[_patchChange.inserted]]
        </span>
        <span
          class="removed"
          tabindex="0"
          aria-label$="Total [[_patchChange.deleted]] lines removed"
        >
          -[[_patchChange.deleted]]
        </span>
      </div>
    </div>
    <!-- endpoint: change-view-file-list-summary -->
    <template is="dom-if" if="[[_showDynamicColumns]]">
      <template
        is="dom-repeat"
        items="[[_dynamicSummaryEndpoints]]"
        as="summaryEndpoint"
      >
        <gr-endpoint-decorator name="[[summaryEndpoint]]">
          <gr-endpoint-param
            name="change"
            value="[[change]]"
          ></gr-endpoint-param>
          <gr-endpoint-param name="patchRange" value="[[patchRange]]">
          </gr-endpoint-param>
        </gr-endpoint-decorator>
      </template>
    </template>
    <!-- Empty div here exists to keep spacing in sync with file rows. -->
    <div class="reviewed hideOnEdit" hidden$="[[!_loggedIn]]"></div>
    <div class="editFileControls showOnEdit"></div>
    <div class="show-hide"></div>
  </div>
  <div class="row totalChanges" hidden$="[[_hideBinaryChangeTotals]]">
    <div class="total-stats">
      <span
        class="added"
        aria-label$="Total bytes inserted: [[_formatBytes(_patchChange.size_delta_inserted)]] "
      >
        [[_formatBytes(_patchChange.size_delta_inserted)]]
        [[_formatPercentage(_patchChange.total_size,
        _patchChange.size_delta_inserted)]]
      </span>
      <span
        class="removed"
        aria-label$="Total bytes removed: [[_formatBytes(_patchChange.size_delta_deleted)]]"
      >
        [[_formatBytes(_patchChange.size_delta_deleted)]]
        [[_formatPercentage(_patchChange.total_size,
        _patchChange.size_delta_deleted)]]
      </span>
    </div>
  </div>
  <div
    class$="row controlRow [[_computeFileListControlClass(numFilesShown, _files)]]"
  >
    <gr-button
      class="fileListButton"
      id="incrementButton"
      link=""
      on-click="_incrementNumFilesShown"
    >
      [[_computeIncrementText(numFilesShown, _files)]]
    </gr-button>
    <gr-tooltip-content
      has-tooltip="[[_computeWarnShowAll(_files)]]"
      show-icon="[[_computeWarnShowAll(_files)]]"
      title$="[[_computeShowAllWarning(_files)]]"
    >
      <gr-button
        class="fileListButton"
        id="showAllButton"
        link=""
        on-click="_showAllFiles"
      >
        [[_computeShowAllText(_files)]] </gr-button
      ><!--
  --></gr-tooltip-content>
  </div>
  <gr-diff-preferences-dialog
    id="diffPreferencesDialog"
    diff-prefs="{{diffPrefs}}"
    on-reload-diff-preference="_handleReloadingDiffPreference"
  >
  </gr-diff-preferences-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-storage id="storage"></gr-storage>
  <gr-diff-cursor id="diffCursor"></gr-diff-cursor>
  <gr-cursor-manager
    id="fileCursor"
    scroll-mode="keep-visible"
    focus-on-move=""
    cursor-target-class="selected"
  ></gr-cursor-manager>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Yw={A:"Added",C:"Copied",D:"Deleted",M:"Modified",R:"Renamed",W:"Rewritten",U:"Unchanged"};class Xw extends(xp(oo(dr(oa)))){static get template(){return Kw}static get is(){return"gr-file-list"}static get properties(){return{patchRange:Object,patchNum:String,changeNum:String,changeComments:Object,drafts:Object,revisions:Array,projectConfig:Object,selectedIndex:{type:Number,notify:!0},keyEventTarget:{type:Object,value:()=>document.body},change:Object,diffViewMode:{type:String,notify:!0,observer:"_updateDiffPreferences"},editMode:{type:Boolean,observer:"_editModeChanged"},filesExpanded:{type:String,value:rb.NONE,notify:!0},_filesByPath:Object,_files:{type:Array,observer:"_filesChanged",value:()=>[]},_loggedIn:{type:Boolean,value:!1},_reviewed:{type:Array,value:()=>[]},diffPrefs:{type:Object,notify:!0,observer:"_updateDiffPreferences"},_userPrefs:Object,_showInlineDiffs:Boolean,numFilesShown:{type:Number,notify:!0},_patchChange:{type:Object,computed:"_calculatePatchChange(_files)"},fileListIncrement:Number,_hideChangeTotals:{type:Boolean,computed:"_shouldHideChangeTotals(_patchChange)"},_hideBinaryChangeTotals:{type:Boolean,computed:"_shouldHideBinaryChangeTotals(_patchChange)"},_shownFiles:{type:Array,computed:"_computeFilesShown(numFilesShown, _files)"},_reportinShownFilesIncrement:Number,_expandedFiles:{type:Array,value:()=>[]},_displayLine:Boolean,_loading:{type:Boolean,observer:"_loadingChanged"},_sizeBarLayout:{type:Object,computed:"_computeSizeBarLayout(_shownFiles.*)"},_showSizeBars:{type:Boolean,value:!0,computed:"_computeShowSizeBars(_userPrefs)"},_cancelForEachDiff:Function,_showDynamicColumns:{type:Boolean,computed:"_computeShowDynamicColumns(_dynamicHeaderEndpoints, _dynamicContentEndpoints, _dynamicSummaryEndpoints)"},_showPrependedDynamicColumns:{type:Boolean,computed:"_computeShowPrependedDynamicColumns(_dynamicPrependedHeaderEndpoints, _dynamicPrependedContentEndpoints)"},_dynamicHeaderEndpoints:{type:Array},_dynamicContentEndpoints:{type:Array},_dynamicSummaryEndpoints:{type:Array},_dynamicPrependedHeaderEndpoints:{type:Array},_dynamicPrependedContentEndpoints:{type:Array}}}static get observers(){return["_expandedFilesChanged(_expandedFiles.splices)","_computeFiles(_filesByPath, changeComments, patchRange, _reviewed, _loading)"]}get keyBindings(){return{esc:"_handleEscKey"}}keyboardShortcuts(){return{[yp.LEFT_PANE]:"_handleLeftPane",[yp.RIGHT_PANE]:"_handleRightPane",[yp.TOGGLE_INLINE_DIFF]:"_handleToggleInlineDiff",[yp.TOGGLE_ALL_INLINE_DIFFS]:"_handleToggleAllInlineDiffs",[yp.TOGGLE_HIDE_ALL_COMMENT_THREADS]:"_handleToggleHideAllCommentThreads",[yp.CURSOR_NEXT_FILE]:"_handleCursorNext",[yp.CURSOR_PREV_FILE]:"_handleCursorPrev",[yp.NEXT_LINE]:"_handleCursorNext",[yp.PREV_LINE]:"_handleCursorPrev",[yp.NEW_COMMENT]:"_handleNewComment",[yp.OPEN_LAST_FILE]:"_handleOpenLastFile",[yp.OPEN_FIRST_FILE]:"_handleOpenFirstFile",[yp.OPEN_FILE]:"_handleOpenFile",[yp.NEXT_CHUNK]:"_handleNextChunk",[yp.PREV_CHUNK]:"_handlePrevChunk",[yp.TOGGLE_FILE_REVIEWED]:"_handleToggleFileReviewed",[yp.TOGGLE_LEFT_PANE]:"_handleToggleLeftPane",[yp.EXPAND_ALL_COMMENT_THREADS]:null,[yp.COLLAPSE_ALL_COMMENT_THREADS]:null}}constructor(){super(),this.reporting=n.reportingService}created(){super.created(),this.addEventListener("keydown",e=>this._scopedKeydownHandler(e))}attached(){super.attached(),eh().awaitPluginsLoaded().then(()=>{this._dynamicHeaderEndpoints=rc().getDynamicEndpoints("change-view-file-list-header"),this._dynamicContentEndpoints=rc().getDynamicEndpoints("change-view-file-list-content"),this._dynamicPrependedHeaderEndpoints=rc().getDynamicEndpoints("change-view-file-list-header-prepend"),this._dynamicPrependedContentEndpoints=rc().getDynamicEndpoints("change-view-file-list-content-prepend"),this._dynamicSummaryEndpoints=rc().getDynamicEndpoints("change-view-file-list-summary"),this._dynamicHeaderEndpoints.length!==this._dynamicContentEndpoints.length&&console.warn("Different number of dynamic file-list header and content."),this._dynamicPrependedHeaderEndpoints.length!==this._dynamicPrependedContentEndpoints.length&&console.warn("Different number of dynamic file-list header and content."),this._dynamicHeaderEndpoints.length!==this._dynamicSummaryEndpoints.length&&console.warn("Different number of dynamic file-list headers and summary.")})}detached(){super.detached(),this._cancelDiffs()}_scopedKeydownHandler(e){13===e.keyCode&&this._handleOpenFile(e)}reload(){if(!this.changeNum||!this.patchRange.patchNum)return Promise.resolve();this._loading=!0,this.collapseAllDiffs();const e=[];return e.push(this._getFiles().then(e=>{this._filesByPath=e})),e.push(this._getLoggedIn().then(e=>this._loggedIn=e).then(e=>{if(e)return this._getReviewedFiles().then(e=>{this._reviewed=e})})),e.push(this._getDiffPreferences().then(e=>{this.diffPrefs=e})),e.push(this._getPreferences().then(e=>{this._userPrefs=e})),Promise.all(e).then(()=>{this._loading=!1,this._detectChromiteButler(),this.reporting.fileListDisplayed()})}_detectChromiteButler(){!!document.getElementById("butler-suggested-owners")&&this.reporting.reportExtension("butler")}get diffs(){const e=this.root.querySelectorAll("gr-diff-host");return Array.from(e).filter(e=>!!e&&!!e.style&&"none"!==e.style.display)}openDiffPrefs(){this.$.diffPreferencesDialog.open()}_calculatePatchChange(e){return e.filter(e=>!Y_(e.__path)).reduce((e,t)=>{const n=t.lines_inserted?t.lines_inserted:0,i=t.lines_deleted?t.lines_deleted:0,o=t.size&&t.binary?t.size:0,s=t.binary&&t.size_delta>0?t.size_delta:0,r=t.binary&&t.size_delta<0?t.size_delta:0;return{inserted:e.inserted+n,deleted:e.deleted+i,size_delta_inserted:e.size_delta_inserted+s,size_delta_deleted:e.size_delta_deleted+r,total_size:e.total_size+o}},{inserted:0,deleted:0,size_delta_inserted:0,size_delta_deleted:0,total_size:0})}_getDiffPreferences(){return this.$.restAPI.getDiffPreferences()}_getPreferences(){return this.$.restAPI.getPreferences()}_toggleFileExpanded(e){const t=this._expandedFiles.findIndex(t=>t.path===e.path);-1===t?this.push("_expandedFiles",e):this.splice("_expandedFiles",t,1)}_toggleFileExpandedByIndex(e){this._toggleFileExpanded(this._computeFileRange(this._files[e]))}_updateDiffPreferences(){this.diffs.length&&(this.reporting.time("ExpandAllDiffs"),this._renderInOrder(this._expandedFiles,this.diffs,this._expandedFiles.length))}_forEachDiff(e){const t=this.diffs;for(let n=0;n<t.length;n++)e(t[n])}expandAllDiffs(){this._showInlineDiffs=!0;const e=[];let t;for(let n=0;n<this._shownFiles.length;n++)t=this._shownFiles[n].__path,this._expandedFiles.some(e=>e.path===t)||e.push(this._computeFileRange(this._shownFiles[n]));this.splice(...["_expandedFiles",0,0].concat(e))}collapseAllDiffs(){this._showInlineDiffs=!1,this._expandedFiles=[],this.filesExpanded=this._computeExpandedFiles(this._expandedFiles.length,this._files.length),this.$.diffCursor.handleDiffUpdate()}_computeCommentsString(e,t,n){if([e,t,n].includes(void 0))return"";const i=e.computeUnresolvedNum({patchNum:t.basePatchNum,path:n})+e.computeUnresolvedNum({patchNum:t.patchNum,path:n}),o=e.computeCommentCount({patchNum:t.basePatchNum,path:n})+e.computeCommentCount({patchNum:t.patchNum,path:n}),s=nd.computePluralString(o,"comment"),r=nd.computeString(i,"unresolved");return s+(s&&r?" ":"")+(r?`(${r})`:"")}_computeDraftsString(e,t,n){if([e,t,n].includes(void 0))return"";const i=e.computeDraftCount({patchNum:t.basePatchNum,path:n})+e.computeDraftCount({patchNum:t.patchNum,path:n});return nd.computePluralString(i,"draft")}_computeDraftsStringMobile(e,t,n){if([e,t,n].includes(void 0))return"";const i=e.computeDraftCount({patchNum:t.basePatchNum,path:n})+e.computeDraftCount({patchNum:t.patchNum,path:n});return nd.computeShortString(i,"d")}_computeCommentsStringMobile(e,t,n){if([e,t,n].includes(void 0))return"";const i=e.computeCommentCount({patchNum:t.basePatchNum,path:n})+e.computeCommentCount({patchNum:t.patchNum,path:n});return nd.computeShortString(i,"c")}_reviewFile(e,t){if(this.editMode)return;const n=this._files.findIndex(t=>t.__path===e),i=t||!this._files[n].isReviewed;this.set(["_files",n,"isReviewed"],i),n<this._shownFiles.length&&this.notifyPath(`_shownFiles.${n}.isReviewed`),this._saveReviewedState(e,i)}_saveReviewedState(e,t){return this.$.restAPI.saveFileReviewed(this.changeNum,this.patchRange.patchNum,e,t)}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_getReviewedFiles(){return this.editMode?Promise.resolve([]):this.$.restAPI.getReviewedFiles(this.changeNum,this.patchRange.patchNum)}_getFiles(){return this.$.restAPI.getChangeOrEditFiles(this.changeNum,this.patchRange)}_normalizeChangeFilesResponse(e){if(!e)return[];const t=Object.keys(e).sort(W_),n=[];for(let i=0;i<t.length;i++){const o=e[t[i]];o.__path=t[i],o.lines_inserted=o.lines_inserted||0,o.lines_deleted=o.lines_deleted||0,o.size_delta=o.size_delta||0,n.push(o)}return n}_isClickEvent(e){if("click"===e.type)return!0;const t="Enter"===e.key||" "===e.key;return"keydown"===e.type&&t}_fileActionClick(e,t){if(this._isClickEvent(e)){const n=this._getFileRowFromEvent(e);if(!n)return;e.preventDefault(),e.stopPropagation(),this.$.fileCursor.setCursor(n.element),t(n.file)}}_reviewedClick(e){this._fileActionClick(e,e=>this._reviewFile(e.path))}_expandedClick(e){this._fileActionClick(e,e=>this._toggleFileExpanded(e))}_handleFileListClick(e){const t=this._getFileRowFromEvent(e);if(!t)return;const n=t.file;n.path&&!Wd(e.target,"pathLink")&&(Wd(e.target,"editFileControls")||(e.preventDefault(),this.$.fileCursor.setCursor(t.element),this._toggleFileExpanded(n)))}_getFileRowFromEvent(e){let t=e.target;for(;!t.classList.contains("file-row")&&t.parentElement;)t=t.parentElement;return t.dataset.file?{file:JSON.parse(t.dataset.file),element:t}:null}_computeFileRange(e){const t={path:e.__path};return e.old_path&&(t.basePath=e.old_path),t}_handleLeftPane(e){this.shouldSuppressKeyboardShortcut(e)||this._noDiffsExpanded()||(e.preventDefault(),this.$.diffCursor.moveLeft())}_handleRightPane(e){this.shouldSuppressKeyboardShortcut(e)||this._noDiffsExpanded()||(e.preventDefault(),this.$.diffCursor.moveRight())}_handleToggleInlineDiff(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||-1===this.$.fileCursor.index||(e.preventDefault(),this._toggleFileExpandedByIndex(this.$.fileCursor.index))}_handleToggleAllInlineDiffs(e){this.shouldSuppressKeyboardShortcut(e)||(e.preventDefault(),this._toggleInlineDiffs())}_handleToggleHideAllCommentThreads(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.toggleClass("hideComments"))}_handleCursorNext(e){if(!this.shouldSuppressKeyboardShortcut(e)&&!this.modifierPressed(e))if(this._showInlineDiffs)e.preventDefault(),this.$.diffCursor.moveDown(),this._displayLine=!0;else{if(40===this.getKeyboardEvent(e).keyCode)return;e.preventDefault(),this.$.fileCursor.next(),this.selectedIndex=this.$.fileCursor.index}}_handleCursorPrev(e){if(!this.shouldSuppressKeyboardShortcut(e)&&!this.modifierPressed(e))if(this._showInlineDiffs)e.preventDefault(),this.$.diffCursor.moveUp(),this._displayLine=!0;else{if(38===this.getKeyboardEvent(e).keyCode)return;e.preventDefault(),this.$.fileCursor.previous(),this.selectedIndex=this.$.fileCursor.index}}_handleNewComment(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.$.diffCursor.createCommentInPlace())}_handleOpenLastFile(e){this.shouldSuppressKeyboardShortcut(e)||this.getKeyboardEvent(e).metaKey||(e.preventDefault(),this._openSelectedFile(this._files.length-1))}_handleOpenFirstFile(e){this.shouldSuppressKeyboardShortcut(e)||this.getKeyboardEvent(e).metaKey||(e.preventDefault(),this._openSelectedFile(0))}_handleOpenFile(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._showInlineDiffs?this._openCursorFile():this._openSelectedFile())}_handleNextChunk(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)&&!this.isModifierPressed(e,"shiftKey")||this._noDiffsExpanded()||(e.preventDefault(),this.isModifierPressed(e,"shiftKey")?this.$.diffCursor.moveToNextCommentThread():this.$.diffCursor.moveToNextChunk())}_handlePrevChunk(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)&&!this.isModifierPressed(e,"shiftKey")||this._noDiffsExpanded()||(e.preventDefault(),this.isModifierPressed(e,"shiftKey")?this.$.diffCursor.moveToPreviousCommentThread():this.$.diffCursor.moveToPreviousChunk())}_handleToggleFileReviewed(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._files[this.$.fileCursor.index]&&this._reviewFile(this._files[this.$.fileCursor.index].__path))}_handleToggleLeftPane(e){this.shouldSuppressKeyboardShortcut(e)||(e.preventDefault(),this._forEachDiff(e=>{e.toggleLeftDiff()}))}_toggleInlineDiffs(){this._showInlineDiffs?this.collapseAllDiffs():this.expandAllDiffs()}_openCursorFile(){const e=this.$.diffCursor.getTargetDiffElement();gh.navigateToDiff(this.change,e.path,e.patchRange.patchNum,this.patchRange.basePatchNum)}_openSelectedFile(e){null!=e&&this.$.fileCursor.setCursorAtIndex(e),this._files[this.$.fileCursor.index]&&gh.navigateToDiff(this.change,this._files[this.$.fileCursor.index].__path,this.patchRange.patchNum,this.patchRange.basePatchNum)}_addDraftAtTarget(){const e=this.$.diffCursor.getTargetDiffElement(),t=this.$.diffCursor.getTargetLineElement();e&&t&&e.addDraftAtLine(t)}_shouldHideChangeTotals(e){return 0===e.inserted&&0===e.deleted}_shouldHideBinaryChangeTotals(e){return 0===e.size_delta_inserted&&0===e.size_delta_deleted}_computeFileStatus(e){return e||"M"}_computeDiffURL(e,t,n,i){if(![e,t,n,i].some(e=>void 0===e))return i&&n!==ka.MERGE_LIST?gh.getEditUrlForDiff(e,n,t.patchNum,t.basePatchNum):gh.getUrlForDiff(e,n,t.patchNum,t.basePatchNum)}_formatBytes(e){if(0==e)return"+/-0 B";const t=Math.floor(Math.log(Math.abs(e))/Math.log(1024));return(e>0?"+":"")+parseFloat((e/Math.pow(1024,t)).toFixed(1))+" "+["B","KiB","MiB","GiB","TiB","PiB","EiB","ZiB","YiB"][t]}_formatPercentage(e,t){const n=e-t;return 0===n?"":"("+(t>0?"+":"-")+Math.round(Math.abs(100*t/n))+"%)"}_computeBinaryClass(e){if(0!==e)return e>=0?"added":"removed"}_computeClass(e,t){const n=[];return e&&n.push(e),t!==ka.COMMIT_MESSAGE&&t!==ka.MERGE_LIST||n.push("invisible"),n.join(" ")}_computeStatusClass(e){return`${this._computeClass("status",e.__path)} ${this._computeFileStatus(e.status)}`}_computePathClass(e,t){return this._isFileExpanded(e,t)?"expanded":""}_computeShowHideIcon(e,t){return this._isFileExpanded(e,t)?"gr-icons:expand-less":"gr-icons:expand-more"}_computeFiles(e,t,n,i,o){if([e,t,n,i,o].includes(void 0))return;if(o||!t)return;const s=t.getPaths(n),r={...e};q_(r,s);const a=new Set(i||[]);for(const e in r)r.hasOwnProperty(e)&&(r[e].isReviewed=a.has(e));this._files=this._normalizeChangeFilesResponse(r)}_computeFilesShown(e,t){if([e,t].includes(void 0))return;const n=this._shownFiles?this._shownFiles.length:0,i=t.slice(0,e);return this.dispatchEvent(new CustomEvent("files-shown-changed",{detail:{length:i.length},composed:!0,bubbles:!0})),this.reporting.time("FileListRenderTime"),this._reportinShownFilesIncrement=Math.max(0,i.length-n),i}_updateDiffCursor(){this.$.diffCursor.splice(...["diffs",0,this.$.diffCursor.diffs.length].concat(this.diffs))}_filesChanged(){this._files&&this._files.length>0&&(Mo(),this.$.fileCursor.stops=Array.from(this.root.querySelectorAll(".file-row")),this.$.fileCursor.setCursorAtIndex(this.selectedIndex,!0))}_incrementNumFilesShown(){this.numFilesShown+=this.fileListIncrement}_computeFileListControlClass(e,t){return e>=t.length?"invisible":""}_computeIncrementText(e,t){if(!t)return"";return"Show "+Math.min(this.fileListIncrement,t.length-e)+" more"}_computeShowAllText(e){return e?"Show all "+e.length+" files":""}_computeWarnShowAll(e){return e.length>1e3}_computeShowAllWarning(e){return this._computeWarnShowAll(e)?"Warning: showing all "+e.length+" files may take several seconds.":""}_showAllFiles(){this.numFilesShown=this._files.length}_computeFileStatusLabel(e){const t=this._computeFileStatus(e);return Yw.hasOwnProperty(t)?Yw[t]:"Status Unknown"}_booleanToString(e){return e?"true":"false"}_isFileExpanded(e,t){return t.base.some(t=>t.path===e)}_isFileExpandedStr(e,t){return this._booleanToString(this._isFileExpanded(e,t))}_computeExpandedFiles(e,t){return 0===e?rb.NONE:e===t?rb.ALL:rb.SOME}_expandedFilesChanged(e){const t=this.diffs.filter(e=>-1===this._expandedFiles.findIndex(t=>t.path===e.path));if(this._clearCollapsedDiffs(t),!e)return;this.filesExpanded=this._computeExpandedFiles(this._expandedFiles.length,this._files.length);const n=e.indexSplices.map(e=>e.object.slice(e.index,e.index+e.addedCount)).reduce((e,t)=>e.concat(t),[]);Mo(),this.reporting.time("ExpandAllDiffs"),n.length&&this._renderInOrder(n,this.diffs,n.length),this._updateDiffCursor(),this.$.diffCursor.reInitAndUpdateStops()}_clearCollapsedDiffs(e){for(const t of e)t.cancel(),t.clearDiffContent()}_renderInOrder(e,t,n){let i=0;for(const n of e){const e=n.path,i=this._findDiffByPath(e,t);i&&i.prefetchDiff()}return new Promise(e=>{this.dispatchEvent(new CustomEvent("reload-drafts",{detail:{resolve:e},composed:!0,bubbles:!0}))}).then(()=>function e(t,n){if(!t.length)return Promise.resolve();let i=!1;return n(t[0],()=>{i=!0}).then(()=>i?Promise.resolve():e(t.slice(1),n))}(e,(e,o)=>{const s=e.path;this._cancelForEachDiff=o,i++,console.info("Expanding diff",i,"of",n,":",s);const r=this._findDiffByPath(s,t);if(!r)return console.warn(`Did not find <gr-diff-host> element for ${s}`),Promise.resolve();r.comments=this.changeComments.getCommentsBySideForFile(e,this.patchRange,this.projectConfig);const a=[r.reload()];return this._loggedIn&&!this.diffPrefs.manual_review&&a.push(this._reviewFile(s,!0)),Promise.all(a)}).then(()=>{this._cancelForEachDiff=null,this._nextRenderParams=null,console.info("Finished expanding",n,"diff(s)"),this.reporting.timeEndWithAverage("ExpandAllDiffs","ExpandAllPerDiff",n),this.$.diffCursor.reInitAndUpdateStops()}))}_cancelDiffs(){this._cancelForEachDiff&&this._cancelForEachDiff(),this._forEachDiff(e=>e.cancel())}_findDiffByPath(e,t){for(let n=0;n<t.length;n++)if(t[n].path===e)return t[n]}reloadCommentsForThreadWithRootId(e,t){if(!this._expandedFiles.some(e=>e.path===t))return;const n=this.diffs.find(e=>e.path===t).getThreadEls().find(t=>t.rootId===e);if(!n)return;const i=this.changeComments.getCommentsForThread(e);i?(n.comments=i.map(e=>Object.assign(e,{__commentSide:n.commentSide})),Mo()):n.fireRemoveSelf()}_handleEscKey(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._displayLine=!1)}_loadingChanged(e){this.debounce("loading-change",()=>{this.classList.toggle("loading",e&&!!this._files.length)},100)}_editModeChanged(e){this.classList.toggle("editMode",e)}_computeReviewedClass(e){return e?"isReviewed":""}_computeReviewedText(e){return e?"MARK UNREVIEWED":"MARK REVIEWED"}_showBarsForPath(e){return e!==ka.COMMIT_MESSAGE&&e!==ka.MERGE_LIST}_computeSizeBarLayout(e){if(!e||!e.base)return;const t={maxInserted:0,maxDeleted:0,maxAdditionWidth:0,maxDeletionWidth:0,deletionOffset:0};e.base.filter(e=>this._showBarsForPath(e.__path)).forEach(e=>{e.lines_inserted&&(t.maxInserted=Math.max(t.maxInserted,e.lines_inserted)),e.lines_deleted&&(t.maxDeleted=Math.max(t.maxDeleted,e.lines_deleted))});const n=t.maxInserted/(t.maxInserted+t.maxDeleted);return isNaN(n)||(t.maxAdditionWidth=60*n,t.maxDeletionWidth=60-t.maxAdditionWidth,t.deletionOffset=t.maxAdditionWidth+1),t}_computeBarAdditionWidth(e,t){if(0===t.maxInserted||!e.lines_inserted||!this._showBarsForPath(e.__path))return 0;const n=t.maxAdditionWidth*e.lines_inserted/t.maxInserted;return 0===n?0:Math.max(1.5,n)}_computeBarAdditionX(e,t){return t.maxAdditionWidth-this._computeBarAdditionWidth(e,t)}_computeBarDeletionWidth(e,t){if(0===t.maxDeleted||!e.lines_deleted||!this._showBarsForPath(e.__path))return 0;const n=t.maxDeletionWidth*e.lines_deleted/t.maxDeleted;return 0===n?0:Math.max(1.5,n)}_computeBarDeletionX(e){return e.deletionOffset}_computeShowSizeBars(e){return!!e.size_bar_in_change_table}_computeSizeBarsClass(e,t){let n="";return e?this._showBarsForPath(t)||(n="invisible"):n="hide",`sizeBars desktop ${n}`}_computeShowDynamicColumns(e,t,n){return e&&t&&n&&e.length&&e.length===t.length&&e.length===n.length}_computeShowPrependedDynamicColumns(e,t){return e&&t&&e.length&&e.length===t.length}_noDiffsExpanded(){return this.filesExpanded===rb.NONE}_reportRenderedRow(e){return e===this._shownFiles.length-1&&this.async(()=>{this.reporting.timeEndWithAverage("FileListRenderTime","FileListRenderTimePerFile",this._reportinShownFilesIncrement)},1),""}_reviewedTitle(e){return e?"Mark as not reviewed (shortcut: r)":"Mark as reviewed (shortcut: r)"}_handleReloadingDiffPreference(){this._getDiffPreferences().then(e=>{this.diffPrefs=e})}_computeDisplayPath(e){return K_(e)}_computeTruncatedPath(e){return X_(e)}}customElements.define(Xw.is,Xw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Jw=ta`
  <style include="shared-styles">
    :host {
      background-color: var(--dialog-background-color);
      display: block;
      max-height: 80vh;
      overflow-y: auto;
      padding: 4.5em var(--spacing-l) var(--spacing-l) var(--spacing-l);
    }
    header {
      background-color: var(--dialog-background-color);
      border-bottom: 1px solid var(--border-color);
      left: 0;
      padding: var(--spacing-l);
      position: absolute;
      right: 0;
      top: 0;
    }
    #title {
      display: inline-block;
      font-family: var(--header-font-family);
      font-size: var(--font-size-h3);
      font-weight: var(--font-weight-h3);
      line-height: var(--line-height-h3);
      margin-top: var(--spacing-xs);
    }
    #filterInput {
      display: inline-block;
      float: right;
      margin: 0 var(--spacing-l);
      padding: var(--spacing-xs);
    }
    .closeButtonContainer {
      float: right;
    }
    ul {
      margin-bottom: var(--spacing-l);
    }
    ul li {
      border: 1px solid var(--border-color);
      border-radius: var(--border-radius);
      background: var(--chip-background-color);
      display: inline-block;
      margin: 0 var(--spacing-xs) var(--spacing-s) var(--spacing-xs);
      padding: var(--spacing-xs) var(--spacing-s);
    }
    .loading.loaded {
      display: none;
    }
  </style>
  <header>
    <h1 id="title" class="heading-1">Included In:</h1>
    <span class="closeButtonContainer">
      <gr-button id="closeButton" link="" on-click="_handleCloseTap"
        >Close</gr-button
      >
    </span>
    <iron-input
      id="filterInput"
      placeholder="Filter"
      bind-value="{{_filterText}}"
    >
      <input
        is="iron-input"
        placeholder="Filter"
        bind-value="{{_filterText}}"
      />
    </iron-input>
  </header>
  <div class$="[[_computeLoadingClass(_loaded)]]">Loading...</div>
  <template
    is="dom-repeat"
    items="[[_computeGroups(_includedIn, _filterText)]]"
    as="group"
  >
    <div>
      <span>[[group.title]]:</span>
      <ul>
        <template is="dom-repeat" items="[[group.items]]">
          <li>[[item]]</li>
        </template>
      </ul>
    </div>
  </template>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var Zw=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let Qw=class extends(oo(dr(oa))){constructor(){super(...arguments),this._loaded=!1,this._filterText=""}static get template(){return Jw}loadData(){if(this.changeNum)return this._filterText="",this.$.restAPI.getChangeIncludedIn(this.changeNum).then(e=>{e&&(this._includedIn=e,this._loaded=!0)})}_resetData(){this._includedIn=void 0,this._loaded=!1}_computeGroups(e,t){if(!e||void 0===t)return[];const n=e=>!t.length||-1!==e.toLowerCase().indexOf(t.toLowerCase()),i=[{title:"Branches",items:e.branches.filter(n)},{title:"Tags",items:e.tags.filter(n)}];if(e.external)for(const t of Object.keys(e.external))i.push({title:t,items:e.external[t].filter(n)});return i.filter(e=>e.items.length)}_handleCloseTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("close",{composed:!0,bubbles:!1}))}_computeLoadingClass(e){return e?"loading loaded":"loading"}};Zw([Bl({type:Object,observer:"_resetData"})],Qw.prototype,"changeNum",void 0),Zw([Bl({type:Object})],Qw.prototype,"_includedIn",void 0),Zw([Bl({type:Boolean})],Qw.prototype,"_loaded",void 0),Zw([Bl({type:String})],Qw.prototype,"_filterText",void 0),Qw=Zw([Ml("gr-included-in-dialog")],Qw);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const eC=ta`
  <style include="gr-voting-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="shared-styles">
    :host {
      display: block;
      position: relative;
      cursor: pointer;
      overflow-y: hidden;
    }
    :host(.expanded) {
      cursor: auto;
    }
    .collapsed .contentContainer {
      align-items: center;
      color: var(--deemphasized-text-color);
      display: flex;
      white-space: nowrap;
    }
    .contentContainer {
      padding: var(--spacing-m) var(--spacing-l);
    }
    .collapsed .contentContainer {
      /* For expanded state we inherit the alternating background color
           that is set in gr-messages-list. */
      background-color: var(--background-color-primary);
    }
    .name {
      font-weight: var(--font-weight-bold);
    }
    .message {
      --gr-formatted-text-prose-max-width: 80ch;
    }
    .collapsed .message {
      max-width: none;
      overflow: hidden;
      text-overflow: ellipsis;
    }
    .collapsed .author,
    .collapsed .content,
    .collapsed .message,
    .collapsed .updateCategory,
    gr-account-chip {
      display: inline;
    }
    gr-button {
      margin: 0 -4px;
    }
    .collapsed gr-thread-list,
    .collapsed .replyBtn,
    .collapsed .deleteBtn,
    .collapsed .hideOnCollapsed,
    .hideOnOpen {
      display: none;
    }
    .replyBtn {
      margin-right: var(--spacing-m);
    }
    .collapsed .hideOnOpen {
      display: block;
    }
    .collapsed .content {
      flex: 1;
      margin-right: var(--spacing-m);
      min-width: 0;
      overflow: hidden;
    }
    .collapsed .content.messageContent {
      text-overflow: ellipsis;
    }
    .collapsed .dateContainer {
      position: static;
    }
    .collapsed .author {
      overflow: hidden;
      color: var(--primary-text-color);
      margin-right: var(--spacing-s);
    }
    .authorLabel {
      width: 140px;
    }
    .expanded .author {
      cursor: pointer;
      margin-bottom: var(--spacing-m);
    }
    .expanded .content {
      padding-left: 40px;
    }
    .dateContainer {
      position: absolute;
      /* right and top values should match .contentContainer padding */
      right: var(--spacing-l);
      top: var(--spacing-m);
    }
    .dateContainer .patchset {
      margin-right: var(--spacing-m);
      color: var(--deemphasized-text-color);
    }
    .dateContainer .patchset:before {
      content: 'Patchset ';
    }
    span.date {
      color: var(--deemphasized-text-color);
    }
    span.date:hover {
      text-decoration: underline;
    }
    .dateContainer iron-icon {
      cursor: pointer;
      vertical-align: top;
    }
    .score {
      border-radius: var(--border-radius);
      color: var(--vote-text-color);
      display: inline-block;
      padding: 0 var(--spacing-s);
      text-align: center;
    }
    .score,
    .commentsSummary {
      margin-right: var(--spacing-s);
      min-width: 115px;
    }
    .expanded .commentsSummary {
      display: none;
    }
    .commentsIcon {
      vertical-align: top;
    }
    .score.removed {
      background-color: var(--vote-color-neutral);
    }
    .score.negative {
      background-color: var(--vote-color-disliked);
    }
    .score.negative.min {
      background-color: var(--vote-color-rejected);
    }
    .score.positive {
      background-color: var(--vote-color-recommended);
    }
    .score.positive.max {
      background-color: var(--vote-color-approved);
    }
    gr-account-label {
      --gr-account-label-text-style: {
        font-weight: var(--font-weight-bold);
      }
    }
    @media screen and (max-width: 50em) {
      .expanded .content {
        padding-left: 0;
      }
      .score,
      .commentsSummary {
        min-width: 0px;
      }
      .authorLabel {
        width: 100px;
      }
      .dateContainer .patchset:before {
        content: 'PS ';
      }
    }
  </style>
  <div class$="[[_computeClass(_expanded)]]">
    <div class="contentContainer">
      <div class="author" on-click="_handleAuthorClick">
        <span hidden$="[[!showOnBehalfOf]]">
          <span class="name">[[message.real_author.name]]</span>
          on behalf of
        </span>
        <gr-account-label
          account="[[author]]"
          class="authorLabel"
        ></gr-account-label>
        <template
          is="dom-repeat"
          items="[[_getScores(message, labelExtremes)]]"
          as="score"
        >
          <span class$="score [[_computeScoreClass(score, labelExtremes)]]">
            [[score.label]] [[score.value]]
          </span>
        </template>
      </div>
      <template is="dom-if" if="[[_commentCountText]]">
        <div class="commentsSummary">
          <iron-icon icon="gr-icons:comment" class="commentsIcon"></iron-icon>
          <span class="numberOfComments">[[_commentCountText]]</span>
        </div>
      </template>
      <template is="dom-if" if="[[message.message]]">
        <div class="content messageContent">
          <div class="message hideOnOpen">[[_messageContentCollapsed]]</div>
          <gr-formatted-text
            no-trailing-margin=""
            class="message hideOnCollapsed"
            content="[[_messageContentExpanded]]"
            config="[[_projectConfig.commentlinks]]"
          ></gr-formatted-text>
          <template is="dom-if" if="[[_expanded]]">
            <template is="dom-if" if="[[_messageContentExpanded]]">
              <div
                class="replyActionContainer"
                hidden$="[[!showReplyButton]]"
                hidden=""
              >
                <gr-button
                  class="replyBtn"
                  link=""
                  small=""
                  on-click="_handleReplyTap"
                >
                  Reply
                </gr-button>
                <gr-button
                  disabled$="[[_isDeletingChangeMsg]]"
                  class="deleteBtn"
                  hidden$="[[!_isAdmin]]"
                  hidden=""
                  link=""
                  small=""
                  on-click="_handleDeleteMessage"
                >
                  Delete
                </gr-button>
              </div>
            </template>
            <gr-thread-list
              change="[[change]]"
              hidden$="[[!message.commentThreads.length]]"
              threads="[[message.commentThreads]]"
              change-num="[[changeNum]]"
              logged-in="[[_loggedIn]]"
              hide-toggle-buttons
              on-thread-list-modified="_onThreadListModified"
            >
            </gr-thread-list>
          </template>
        </div>
      </template>
      <template is="dom-if" if="[[_computeIsReviewerUpdate(message)]]">
        <div class="content">
          <template is="dom-repeat" items="[[message.updates]]" as="update">
            <div class="updateCategory">
              [[update.message]]
              <template
                is="dom-repeat"
                items="[[update.reviewers]]"
                as="reviewer"
              >
                <gr-account-chip account="[[reviewer]]"> </gr-account-chip>
              </template>
            </div>
          </template>
        </div>
      </template>
      <span class="dateContainer">
        <template is="dom-if" if="[[message._revision_number]]">
          <span class="patchset">[[message._revision_number]]</span>
        </template>
        <template is="dom-if" if="[[!message.id]]">
          <span class="date">
            <gr-date-formatter
              has-tooltip=""
              show-date-and-time=""
              date-str="[[message.date]]"
            ></gr-date-formatter>
          </span>
        </template>
        <template is="dom-if" if="[[message.id]]">
          <span class="date" on-click="_handleAnchorClick">
            <gr-date-formatter
              has-tooltip=""
              show-date-and-time=""
              date-str="[[message.date]]"
            ></gr-date-formatter>
          </span>
        </template>
        <iron-icon
          id="expandToggle"
          on-click="_toggleExpanded"
          title="Toggle expanded state"
          icon="[[_computeExpandToggleIcon(_expanded)]]"
        ></iron-icon>
      </span>
    </div>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var tC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const nC=/^(?:Uploaded\s*)?(?:P|p)atch (?:S|s)et \d+:\s*(.*)/,iC=/^(-?)([A-Za-z0-9-]+?)([+-]\d+)?[.]?$/;let oC=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hideAutomated=!1,this.hidden=!1,this.showReplyButton=!1,this._loggedIn=!1,this._isAdmin=!1,this._isDeletingChangeMsg=!1,this._expanded=!1,this._messageContentExpanded="",this._messageContentCollapsed="",this._commentCountText=""}static get template(){return eC}get author(){var e,t;return(null===(e=this.message)||void 0===e?void 0:e.author)||(null===(t=this.message)||void 0===t?void 0:t.updated_by)}get isAutomated(){return!!this.message&&this._computeIsAutomated(this.message)}get showOnBehalfOf(){return!!this.message&&this._computeShowOnBehalfOf(this.message)}created(){super.created(),this.addEventListener("click",e=>this._handleClick(e))}attached(){super.attached(),this.$.restAPI.getConfig().then(e=>{this.config=e}),this.$.restAPI.getLoggedIn().then(e=>{this._loggedIn=e}),this.$.restAPI.getIsAdmin().then(e=>{this._isAdmin=!!e})}_updateExpandedClass(e){e?this.classList.add("expanded"):this.classList.remove("expanded")}_computeCommentCountText(e){return 0===e?void 0:1===e?"1 comment":`${e} comments`}_onThreadListModified(){this.dispatchEvent(new CustomEvent("comment-refresh",{composed:!0,bubbles:!0}))}_computeMessageContentExpanded(e,t){return this._computeMessageContent(e,t,!0)}_patchsetCommentSummary(e=[]){var t;const n=null===(t=this.message)||void 0===t?void 0:t.id;if(!n)return"";const i=e.filter(e=>e.path===ka.PATCHSET_LEVEL_COMMENTS);for(const e of i)if(e.comments[0].change_message_id===n)return e.comments[0].message;for(const e of i)for(const t of e.comments)if(t.change_message_id===n)return t.message;return""}_computeMessageContentCollapsed(e,t,n){const i=this._computeMessageContent(e,t,!1);return i||!n?i:this._patchsetCommentSummary(n)}_computeMessageContent(e="",t="",n){const i=t.endsWith(":newPatchSet")||t.endsWith(":newWipPatchSet");return e.split("\n").filter(e=>!(!n&&e.startsWith(">"))&&((!e.startsWith("(")||!e.endsWith(" comment)"))&&((!e.startsWith("(")||!e.endsWith(" comments)"))&&!(!i&&e.match(nC))))).map(e=>(i&&(e=e.replace(nC,"$1")),e)).join("\n").trim()}_computeAuthor(e){return e.author||e.updated_by}_computeShowOnBehalfOf(e){const t=this._computeAuthor(e);return!(!t||!e.real_author||t._account_id===e.real_author._account_id)}_computeShowReplyButton(e,t){return e&&!!e.message&&t&&!this._computeIsAutomated(e)}_computeExpanded(e){return e}_handleClick(e){var t;null!==(t=this.message)&&void 0!==t&&t.expanded||(e.stopPropagation(),this.set("message.expanded",!0))}_handleAuthorClick(e){var t;(null===(t=this.message)||void 0===t?void 0:t.expanded)&&(e.stopPropagation(),this.set("message.expanded",!1))}_computeIsAutomated(e){return!!(e.reviewer||this._computeIsReviewerUpdate(e)||e.tag&&e.tag.startsWith("autogenerated"))}_computeIsHidden(e,t){return e&&t}_computeIsReviewerUpdate(e){return"REVIEWER_UPDATE"===e.type}_getScores(e,t){if(!e||!e.message||!t)return[];const n=e.message.split("\n",1)[0],i=nC;if(!n.match(i))return[];const s=n.split(i)[1];return s?s.split(" ").map(e=>e.match(iC)).filter(e=>e&&4===e.length&&o(t,e[2])).map(e=>({label:null==e?void 0:e[2],value:"-"===(null==e?void 0:e[1])?"removed":null==e?void 0:e[3]})):[]}_computeScoreClass(e,t){if(void 0===e||void 0===t)return"";if(!e.value)return"";if("removed"===e.value)return"removed";const n=[];if(Number(e.value)>0?n.push("positive"):Number(e.value)<0&&n.push("negative"),e.label){const i=t[e.label];if(i){const t=Number(e.value);t===i.max?n.push("max"):t===i.min&&n.push("min")}}return n.join(" ")}_computeClass(e){const t=[];return t.push(e?"expanded":"collapsed"),t.join(" ")}_handleAnchorClick(e){var t;e.preventDefault(),this.dispatchEvent(new CustomEvent("message-anchor-tap",{bubbles:!0,composed:!0,detail:{id:null===(t=this.message)||void 0===t?void 0:t.id}}))}_handleReplyTap(e){e.preventDefault(),this.dispatchEvent(new CustomEvent("reply",{detail:{message:this.message},composed:!0,bubbles:!0}))}_handleDeleteMessage(e){e.preventDefault(),this.message&&this.message.id&&this.changeNum&&(this._isDeletingChangeMsg=!0,this.$.restAPI.deleteChangeCommitMessage(this.changeNum,this.message.id).then(()=>{this._isDeletingChangeMsg=!1,this.dispatchEvent(new CustomEvent("change-message-deleted",{detail:{message:this.message},composed:!0,bubbles:!0}))}))}_projectNameChanged(e){this.$.restAPI.getProjectConfig(e).then(e=>{this._projectConfig=e})}_computeExpandToggleIcon(e){return e?"gr-icons:expand-less":"gr-icons:expand-more"}_toggleExpanded(e){var t;e.stopPropagation(),this.set("message.expanded",!(null===(t=this.message)||void 0===t?void 0:t.expanded))}};tC([Bl({type:Object})],oC.prototype,"change",void 0),tC([Bl({type:Number})],oC.prototype,"changeNum",void 0),tC([Bl({type:Object})],oC.prototype,"message",void 0),tC([Hl("message")],oC.prototype,"author",null),tC([Bl({type:Object})],oC.prototype,"config",void 0),tC([Bl({type:Boolean})],oC.prototype,"hideAutomated",void 0),tC([Bl({type:Boolean,reflectToAttribute:!0,computed:"_computeIsHidden(hideAutomated, isAutomated)"})],oC.prototype,"hidden",void 0),tC([Hl("message")],oC.prototype,"isAutomated",null),tC([Hl("message")],oC.prototype,"showOnBehalfOf",null),tC([Bl({type:Boolean,computed:"_computeShowReplyButton(message, _loggedIn)"})],oC.prototype,"showReplyButton",void 0),tC([Bl({type:String})],oC.prototype,"projectName",void 0),tC([Bl({type:Object})],oC.prototype,"labelExtremes",void 0),tC([Bl({type:Object})],oC.prototype,"_projectConfig",void 0),tC([Bl({type:Boolean})],oC.prototype,"_loggedIn",void 0),tC([Bl({type:Boolean})],oC.prototype,"_isAdmin",void 0),tC([Bl({type:Boolean})],oC.prototype,"_isDeletingChangeMsg",void 0),tC([Bl({type:Boolean,computed:"_computeExpanded(message.expanded)"})],oC.prototype,"_expanded",void 0),tC([Bl({type:String,computed:"_computeMessageContentExpanded(message.message, message.tag)"})],oC.prototype,"_messageContentExpanded",void 0),tC([Bl({type:String,computed:"_computeMessageContentCollapsed(message.message, message.tag, message.commentThreads)"})],oC.prototype,"_messageContentCollapsed",void 0),tC([Bl({type:String,computed:"_computeCommentCountText(message.commentThreads.length)"})],oC.prototype,"_commentCountText",void 0),tC([jl("message.expanded")],oC.prototype,"_updateExpandedClass",null),tC([jl("projectName")],oC.prototype,"_projectNameChanged",null),oC=tC([Ml("gr-message")],oC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const sC=ta`
  <style include="shared-styles">
    :host {
      display: flex;
      justify-content: space-between;
    }
    .header {
      align-items: center;
      border-top: 1px solid var(--border-color);
      border-bottom: 1px solid var(--border-color);
      display: flex;
      justify-content: space-between;
      padding: var(--spacing-s) var(--spacing-l);
    }
    .highlighted {
      animation: 3s fadeOut;
    }
    @keyframes fadeOut {
      0% {
        background-color: var(--emphasis-color);
      }
      100% {
        background-color: var(--view-background-color);
      }
    }
    .container {
      align-items: center;
      display: flex;
    }
    .hiddenEntries {
      color: var(--deemphasized-text-color);
    }
    gr-message:not(:last-of-type) {
      border-bottom: 1px solid var(--border-color);
    }
    gr-message {
      background-color: var(--background-color-secondary);
    }
  </style>
  <div class="header">
    <div id="showAllActivityToggleContainer" class="container">
      <template
        is="dom-if"
        if="[[_isVisibleShowAllActivityToggle(_combinedMessages)]]"
      >
        <paper-toggle-button
          class="showAllActivityToggle"
          checked="{{_showAllActivity}}"
          aria-labelledby="showAllEntriesLabel"
          role="switch"
          on-tap="_onTapShowAllActivityToggle"
        ></paper-toggle-button>
        <div id="showAllEntriesLabel" aria-hidden="true">
          <span>Show all entries</span>
          <span class="hiddenEntries" hidden$="[[_showAllActivity]]">
            ([[_computeHiddenEntriesCount(_combinedMessages)]] hidden)
          </span>
        </div>
        <span class="transparent separator"></span>
      </template>
    </div>
    <gr-button
      id="collapse-messages"
      link=""
      title="[[_expandAllTitle]]"
      on-click="_handleExpandCollapseTap"
    >
      [[_expandAllState]]
    </gr-button>
  </div>
  <template
    id="messageRepeat"
    is="dom-repeat"
    items="[[_combinedMessages]]"
    as="message"
    filter="_isMessageVisible"
  >
    <gr-message
      change="[[change]]"
      change-num="[[changeNum]]"
      message="[[message]]"
      project-name="[[projectName]]"
      show-reply-button="[[showReplyButtons]]"
      on-message-anchor-tap="_handleAnchorClick"
      label-extremes="[[_labelExtremes]]"
      data-message-id$="[[message.id]]"
    ></gr-message>
  </template>
`
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,rC="Expand All",aC="Collapse All";function lC(e,t,n){return[e,t,n].includes(void 0)?[]:void 0===e._index?[]:n.getAllThreadsForChange().filter(t=>t.comments.map(e=>(e.collapsed=!0,e)).some(t=>{const n=t.change_message_id===e.id;return t.collapsed=!n,n}))}function cC(e){if(!e.tag){return(e.commentThreads||[]).map(t=>t.comments.find(t=>t.change_message_id===e.id)).some(e=>e&&!!e.robot_id)?"autogenerated:has-robot-comments":void 0}return e.tag===Ra.TAG_NEW_WIP_PATCHSET?Ra.TAG_NEW_PATCHSET:e.tag===Ra.TAG_UNSET_ASSIGNEE?Ra.TAG_SET_ASSIGNEE:e.tag===Ra.TAG_UNSET_PRIVATE?Ra.TAG_SET_PRIVATE:e.tag===Ra.TAG_SET_WIP?Ra.TAG_SET_READY:e.tag.replace(/~.*/,"")}function dC(e,t){if(e._revision_number>0)return e._revision_number;let n=0;for(const i of t){if(i.date>e.date)break;i._revision_number>n&&(n=i._revision_number)}return n>0?n:void 0}function hC(e,t){if(!e.tag)return!0;const n=e._revision_number||0;return!t.filter(t=>t.tag===e.tag).some(e=>e._revision_number>n)}class pC extends(xp(oo(dr(oa)))){static get template(){return sC}static get is(){return"gr-messages-list"}static get properties(){return{change:Object,changeNum:Number,messages:{type:Array,value:()=>[]},reviewerUpdates:{type:Array,value:()=>[]},changeComments:Object,projectName:String,showReplyButtons:{type:Boolean,value:!1},labels:Object,_expandAllState:{type:String,value:rC},_expandAllTitle:{type:String,computed:"_computeExpandAllTitle(_expandAllState)"},_showAllActivity:{type:Boolean,value:!1,observer:"_observeShowAllActivity"},_combinedMessages:{type:Array,computed:"_computeCombinedMessages(messages, reviewerUpdates, changeComments)",observer:"_combinedMessagesChanged"},_labelExtremes:{type:Object,computed:"_computeLabelExtremes(labels.*)"}}}constructor(){super(),this.reporting=n.reportingService}scrollToMessage(e){const t=`[data-message-id="${e}"]`,n=this.shadowRoot.querySelector(t);if(!n&&this._showAllActivity)return void console.warn(`Failed to scroll to message: ${e}`);if(!n)return this._showAllActivity=!0,void setTimeout(()=>this.scrollToMessage(e));n.set("message.expanded",!0);let i=n.offsetTop;for(let e=n.offsetParent;e;e=e.offsetParent)i+=e.offsetTop;window.scrollTo(0,i),this._highlightEl(n)}_observeShowAllActivity(e){this.$.messageRepeat.render()}_isMessageVisible(e){return this._showAllActivity||e.isImportant}_computeCombinedMessages(e,t,n){if([e,t,n].some(e=>void 0===e))return[];let i,o,s=0,r=0,a=[];for(let t=0;t<e.length;t++)e[t]._index=t;for(;s<e.length||r<t.length;){if(s>=e.length){a=a.concat(t.slice(r));break}if(r>=t.length){a=a.concat(e.slice(s));break}i=i||lc(e[s].date),o=o||lc(t[r].date),o<i?(a.push(t[r++]),o=null):(a.push(e[s++]),i=null)}return a.forEach(e=>{void 0===e.expanded&&(e.expanded=!1),e.commentThreads=lC(e,a,n),e._revision_number=dC(e,a),e.tag=cC(e)}),a.forEach(e=>{e.isImportant=hC(e,a)}),a}_updateExpandedStateOfAllMessages(e){if(this._combinedMessages)for(let t=0;t<this._combinedMessages.length;t++)this._combinedMessages[t].expanded=e,this.notifyPath(`_combinedMessages.${t}.expanded`)}_computeExpandAllTitle(e){return e===aC?this.createTitle(yp.COLLAPSE_ALL_MESSAGES,vp.ACTIONS):e===rC?this.createTitle(yp.EXPAND_ALL_MESSAGES,vp.ACTIONS):""}_highlightEl(e){const t=this.root.querySelectorAll(".highlighted");for(const e of t)e.classList.remove("highlighted");e.addEventListener("animationend",(function t(){e.removeEventListener("animationend",t),e.classList.remove("highlighted")})),e.classList.add("highlighted")}handleExpandCollapse(e){this._expandAllState=e?aC:rC,this._updateExpandedStateOfAllMessages(e)}_handleExpandCollapseTap(e){e.preventDefault(),this.handleExpandCollapse(this._expandAllState===rC)}_handleAnchorClick(e){this.scrollToMessage(e.detail.id)}_isVisibleShowAllActivityToggle(e=[]){return e.some(e=>!e.isImportant)}_computeHiddenEntriesCount(e=[]){return e.filter(e=>!e.isImportant).length}_combinedMessagesChanged(e){if(e){if(0===e.length)return;const t=e.map(e=>e.tag||e.type||(e.comments?"comments":"none")).reduce((e,t)=>(e[t]=(e[t]||0)+1,e),{all:e.length});this.reporting.reportInteraction("messages-count",t)}}_computeLabelExtremes(e){const t={},n=e.base;if(!n)return t;for(const e of Object.keys(n)){if(!n[e]||!n[e].values)continue;const i=Object.keys(n[e].values).map(e=>parseInt(e,10));i.sort((e,t)=>e-t),i.length&&(t[e]={min:i[0],max:i[i.length-1]})}return t}_onTapShowAllActivityToggle(e){e.preventDefault()}}customElements.define(pC.is,pC);var uC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let gC=class extends oa{};uC([Bl({type:String})],gC.prototype,"name",void 0),gC=uC([Ml("gr-endpoint-slot")],gC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const mC=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    section {
      margin-bottom: 1.4em; /* Same as line height for collapse purposes */
    }
    a {
      display: block;
    }
    .changeContainer,
    a {
      max-width: 100%;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
    }
    .changeContainer {
      display: flex;
    }
    .arrowToCurrentChange {
      position: absolute;
    }
    h4,
    section div {
      display: flex;
    }
    h4:before,
    section div:before {
      content: ' ';
      flex-shrink: 0;
      width: 1.2em;
    }
    .note {
      color: var(--error-text-color);
    }
    .relatedChanges a {
      display: inline-block;
    }
    .strikethrough {
      color: var(--deemphasized-text-color);
      text-decoration: line-through;
    }
    .status {
      color: var(--deemphasized-text-color);
      font-weight: var(--font-weight-bold);
      margin-left: var(--spacing-xs);
    }
    .notCurrent {
      color: #e65100;
    }
    .indirectAncestor {
      color: #33691e;
    }
    .submittableCheck {
      padding-left: var(--spacing-s);
      color: var(--positive-green-text-color);
      display: none;
    }
    .submittableCheck.submittable {
      display: inline;
    }
    .hidden,
    .mobile {
      display: none;
    }
    @media screen and (max-width: 60em) {
      .mobile {
        display: block;
      }
    }
  </style>
  <div>
    <gr-endpoint-decorator name="related-changes-section">
      <gr-endpoint-param name="change" value="[[change]]"></gr-endpoint-param>
      <gr-endpoint-slot name="top"></gr-endpoint-slot>
      <section
        class="relatedChanges"
        hidden$="[[!_relatedResponse.changes.length]]"
        hidden=""
      >
        <h4>Relation chain</h4>
        <template
          is="dom-repeat"
          items="[[_relatedResponse.changes]]"
          as="related"
        >
          <template is="dom-if" if="[[_changesEqual(related, change)]]">
            <span
              role="img"
              class="arrowToCurrentChange"
              aria-label="Arrow marking current change"
              >➔</span
            >
          </template>
          <div class="rightIndent changeContainer">
            <a
              href$="[[_computeChangeURL(related._change_number, related.project, related._revision_number)]]"
              class$="[[_computeLinkClass(related)]]"
              title$="[[related.commit.subject]]"
            >
              [[related.commit.subject]]
            </a>
            <span class$="[[_computeChangeStatusClass(related)]]">
              ([[_computeChangeStatus(related)]])
            </span>
          </div>
        </template>
      </section>
      <section
        id="submittedTogether"
        class$="[[_computeSubmittedTogetherClass(_submittedTogether)]]"
      >
        <h4>Submitted together</h4>
        <template
          is="dom-repeat"
          items="[[_submittedTogether.changes]]"
          as="related"
        >
          <template is="dom-if" if="[[_changesEqual(related, change)]]">
            <span
              role="img"
              class="arrowToCurrentChange"
              aria-label="Arrow marking current change"
              >➔</span
            >
          </template>
          <div class="changeContainer">
            <a
              href$="[[_computeChangeURL(related._number, related.project)]]"
              class$="[[_computeLinkClass(related)]]"
              title$="[[related.project]]: [[related.branch]]: [[related.subject]]"
            >
              [[related.project]]: [[related.branch]]: [[related.subject]]
            </a>
            <span
              tabindex="-1"
              title="Submittable"
              class$="submittableCheck [[_computeLinkClass(related)]]"
              role="img"
              aria-label="Submittable"
              >✓</span
            >
          </div>
        </template>
        <template is="dom-if" if="[[_submittedTogether.non_visible_changes]]">
          <div class="note">
            [[_computeNonVisibleChangesNote(_submittedTogether.non_visible_changes)]]
          </div>
        </template>
      </section>
      <section hidden$="[[!_sameTopic.length]]" hidden="">
        <h4>Same topic</h4>
        <template is="dom-repeat" items="[[_sameTopic]]" as="change">
          <div>
            <a
              href$="[[_computeChangeURL(change._number, change.project)]]"
              class$="[[_computeLinkClass(change)]]"
              title$="[[change.project]]: [[change.branch]]: [[change.subject]]"
            >
              [[change.project]]: [[change.branch]]: [[change.subject]]
            </a>
          </div>
        </template>
      </section>
      <section hidden$="[[!_conflicts.length]]" hidden="">
        <h4>Merge conflicts</h4>
        <template is="dom-repeat" items="[[_conflicts]]" as="change">
          <div>
            <a
              href$="[[_computeChangeURL(change._number, change.project)]]"
              class$="[[_computeLinkClass(change)]]"
              title$="[[change.subject]]"
            >
              [[change.subject]]
            </a>
          </div>
        </template>
      </section>
      <section hidden$="[[!_cherryPicks.length]]" hidden="">
        <h4>Cherry picks</h4>
        <template is="dom-repeat" items="[[_cherryPicks]]" as="change">
          <div>
            <a
              href$="[[_computeChangeURL(change._number, change.project)]]"
              class$="[[_computeLinkClass(change)]]"
              title$="[[change.branch]]: [[change.subject]]"
            >
              [[change.branch]]: [[change.subject]]
            </a>
          </div>
        </template>
      </section>
      <gr-endpoint-slot name="bottom"></gr-endpoint-slot>
    </gr-endpoint-decorator>
  </div>
  <div hidden$="[[!loading]]">Loading...</div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var _C=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let fC=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasParent=!1,this.hidden=!1,this._relatedResponse={changes:[]},this._submittedTogether={changes:[],non_visible_changes:0},this._conflicts=[],this._cherryPicks=[],this._sameTopic=[]}static get template(){return mC}clear(){this.loading=!0,this.hidden=!0,this._relatedResponse={changes:[]},this._submittedTogether={changes:[],non_visible_changes:0},this._conflicts=[],this._cherryPicks=[],this._sameTopic=[]}reload(){if(!this.change||!this.patchNum)return Promise.resolve();const e=this.change;this.loading=!0;const t=[this.$.restAPI.getRelatedChanges(e._number,this.patchNum).then(t=>{if(!t)throw new Error("getRelatedChanges returned undefined response");this._relatedResponse=t,this._fireReloadEvent(),this.hasParent=this._calculateHasParent(e.change_id,t.changes)}),this.$.restAPI.getChangesSubmittedTogether(e._number).then(e=>{this._submittedTogether=e,this._fireReloadEvent()}),this.$.restAPI.getChangeCherryPicks(e.project,e.change_id,e._number).then(e=>{this._cherryPicks=e||[],this._fireReloadEvent()})];return Wp(e)&&this.mergeable&&t.push(this.$.restAPI.getChangeConflicts(e._number).then(e=>{this._conflicts=e||[],this._fireReloadEvent()})),t.push(this._getServerConfig().then(t=>{if(e.topic){if(!t)throw new Error("_getServerConfig returned undefined ");if(!t.change.submit_whole_topic)return this.$.restAPI.getChangesWithSameTopic(e.topic,e._number).then(e=>{this._sameTopic=e})}return this._sameTopic=[],Promise.resolve()})),Promise.all(t).then(()=>{this.loading=!1})}_fireReloadEvent(){Mo(),this.dispatchEvent(new CustomEvent("new-section-loaded"))}_calculateHasParent(e,t){return t.length>0&&t[t.length-1].change_id!==e}_getServerConfig(){return this.$.restAPI.getConfig()}_computeChangeURL(e,t,n){return gh.getUrlForChangeById(e,t,n)}_changesEqual(e,t){return this._getChangeNumber(e)===this._getChangeNumber(t)}_getChangeNumber(e){return e?void 0!==e._number?e._number:e._change_number:0}_computeLinkClass(e){const t=[];return e.status===Ia.ABANDONED&&t.push("strikethrough"),e.submittable&&t.push("submittable"),t.join(" ")}_computeChangeStatusClass(e){const t=["status"];return e._revision_number!==e._current_revision_number?t.push("notCurrent"):this._isIndirectAncestor(e)?t.push("indirectAncestor"):e.submittable?t.push("submittable"):e.status===Ia.NEW&&t.push("hidden"),t.join(" ")}_computeChangeStatus(e){switch(e.status){case Ia.MERGED:return"Merged";case Ia.ABANDONED:return"Abandoned"}return e._revision_number!==e._current_revision_number?"Not current":this._isIndirectAncestor(e)?"Indirect ancestor":e.submittable?"Submittable":""}attached(){super.attached(),this.addEventListener("new-section-loaded",()=>this._handleNewSectionLoaded())}_handleNewSectionLoaded(){this._resultsChanged(this._relatedResponse,this._submittedTogether,this._conflicts,this._cherryPicks,this._sameTopic)}_resultsChanged(e,t,n,i,o){if(!t||!o)return;const s=(t.changes||[]).length+(t.non_visible_changes||0),r=[e&&e.changes,s?[{}]:[],n,i,o];for(let e=0;e<r.length;e++)if(r[e]&&r[e].length>0)return this.hidden=!1,void this.dispatchEvent(new CustomEvent("update",{composed:!0,bubbles:!1}));this._computeHidden()}_computeHidden(){const e=rc().getDetails("related-changes-section");this.hidden=!e.some(e=>!e.domHook||e.domHook.getAllAttached().some(e=>!e.hidden))}_isIndirectAncestor(e){return this._connectedRevisions&&!this._connectedRevisions.includes(e.commit.commit)}_computeConnectedRevisions(e,t,n){if(void 0===e||void 0===t||void 0===n)return;const i=[];let o;if(!e)return[];for(const n in e.revisions)Ch(e.revisions[n]._number,t)&&(o=n);const s=n.map(e=>e.commit);let r=s.length-1;for(;r>=0;){const e=s[r].commit;if(i.push(e),e==o)break;r--}for(;r>=0;){for(let e=0;e<s[r].parents.length;e++)if(i.includes(s[r].parents[e].commit)){i.push(s[r].commit);break}--r}return i}_computeSubmittedTogetherClass(e){return!e||0===e.changes.length&&!e.non_visible_changes?"hidden":""}_computeNonVisibleChangesNote(e){return`(+ ${e} non-visible ${1===e?"change":"changes"})`}};_C([Bl({type:Object})],fC.prototype,"change",void 0),_C([Bl({type:Boolean,notify:!0})],fC.prototype,"hasParent",void 0),_C([Bl({type:String})],fC.prototype,"patchNum",void 0),_C([Bl({type:Boolean,reflectToAttribute:!0})],fC.prototype,"hidden",void 0),_C([Bl({type:Boolean,notify:!0})],fC.prototype,"loading",void 0),_C([Bl({type:Boolean})],fC.prototype,"mergeable",void 0),_C([Bl({type:Array,computed:"_computeConnectedRevisions(change, patchNum, _relatedResponse.changes)"})],fC.prototype,"_connectedRevisions",void 0),_C([Bl({type:Object})],fC.prototype,"_relatedResponse",void 0),_C([Bl({type:Object})],fC.prototype,"_submittedTogether",void 0),_C([Bl({type:Array})],fC.prototype,"_conflicts",void 0),_C([Bl({type:Array})],fC.prototype,"_cherryPicks",void 0),_C([Bl({type:Array})],fC.prototype,"_sameTopic",void 0),_C([jl("_relatedResponse","_submittedTogether","_conflicts","_cherryPicks","_sameTopic")],fC.prototype,"_resultsChanged",null),fC=_C([Ml("gr-related-changes-list")],fC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const vC=ta`
  <style include="shared-styles">
    gr-diff {
      --content-width: 90vw;
    }
    .diffContainer {
      padding: var(--spacing-l) 0;
      border-bottom: 1px solid var(--border-color);
    }
    .file-name {
      display: block;
      padding: var(--spacing-s) var(--spacing-l);
      background-color: var(--background-color-secondary);
      border-bottom: 1px solid var(--border-color);
    }
    .fixActions {
      display: flex;
      justify-content: flex-end;
    }
    gr-button {
      margin-left: var(--spacing-m);
    }
    .fix-picker {
      display: flex;
      align-items: center;
      margin-right: var(--spacing-l);
    }
  </style>
  <gr-overlay id="applyFixOverlay" with-backdrop="">
    <gr-dialog
      id="applyFixDialog"
      on-confirm="_handleApplyFix"
      confirm-label="[[_getApplyFixButtonLabel(_isApplyFixLoading)]]"
      disabled="[[_disableApplyFixButton]]"
      confirm-tooltip="[[_computeTooltip(change, _patchNum)]]"
      on-cancel="onCancel"
    >
      <div slot="header">[[_robotId]] - [[getFixDescription(_currentFix)]]</div>
      <div slot="main">
        <template is="dom-repeat" items="[[_currentPreviews]]">
          <div class="file-name">
            <span>[[item.filepath]]</span>
          </div>
          <div class="diffContainer">
            <gr-diff
              prefs="[[overridePartialPrefs(prefs)]]"
              change-num="[[changeNum]]"
              path="[[item.filepath]]"
              diff="[[item.preview]]"
            ></gr-diff>
          </div>
        </template>
      </div>
      <div
        slot="footer"
        class="fix-picker"
        hidden$="[[hasSingleFix(_fixSuggestions)]]"
      >
        <span
          >Suggested fix [[addOneTo(_selectedFixIdx)]] of
          [[_fixSuggestions.length]]</span
        >
        <gr-button
          id="prevFix"
          on-click="_onPrevFixClick"
          disabled$="[[_noPrevFix(_selectedFixIdx)]]"
        >
          <iron-icon icon="gr-icons:chevron-left"></iron-icon>
        </gr-button>
        <gr-button
          id="nextFix"
          on-click="_onNextFixClick"
          disabled$="[[_noNextFix(_selectedFixIdx, _fixSuggestions)]]"
        >
          <iron-icon icon="gr-icons:chevron-right"></iron-icon>
        </gr-button>
      </div>
    </gr-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var yC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let bC=class extends(oo(dr(oa))){constructor(){super(...arguments),this._currentPreviews=[],this._isApplyFixLoading=!1,this._selectedFixIdx=0}static get template(){return vC}open(e){const t=e.detail,n=t.comment;if(!t.patchNum||!n||!jf(n))return Promise.resolve();if(this._patchNum=t.patchNum,this._fixSuggestions=n.fix_suggestions,this._robotId=n.robot_id,!this._fixSuggestions||!this._fixSuggestions.length)return Promise.resolve();this._selectedFixIdx=0;const i=[];return i.push(this._showSelectedFixSuggestion(this._fixSuggestions[0]),this.$.applyFixOverlay.open()),Promise.all(i).then(()=>{this.$.applyFixOverlay.dispatchEvent(new CustomEvent("iron-resize",{composed:!0,bubbles:!0}))})}attached(){super.attached(),this.refitOverlay=()=>{this.$.applyFixOverlay.dispatchEvent(new CustomEvent("iron-resize",{composed:!0,bubbles:!0}))},this.addEventListener("diff-context-expanded",this.refitOverlay)}detached(){super.detached(),this.refitOverlay&&this.removeEventListener("diff-context-expanded",this.refitOverlay)}_showSelectedFixSuggestion(e){return this._currentFix=e,this._fetchFixPreview(e.fix_id)}_fetchFixPreview(e){return this.changeNum&&this._patchNum?this.$.restAPI.getRobotCommentFixPreview(this.changeNum,this._patchNum,e).then(e=>{e&&(this._currentPreviews=Object.keys(e).map(t=>({filepath:t,preview:e[t]})))}).catch(e=>{throw this._close(),e}):Promise.reject(new Error("Both _patchNum and changeNum must be set"))}hasSingleFix(e){return 1===(e||[]).length}overridePartialPrefs(e){return{...e,line_length:50}}onCancel(e){e&&e.stopPropagation(),this._close()}addOneTo(e){return e+1}_onPrevFixClick(e){e&&e.stopPropagation(),this._selectedFixIdx>=1&&this._fixSuggestions&&(this._selectedFixIdx-=1,this._showSelectedFixSuggestion(this._fixSuggestions[this._selectedFixIdx]))}_onNextFixClick(e){e&&e.stopPropagation(),this._fixSuggestions&&this._selectedFixIdx<this._fixSuggestions.length&&(this._selectedFixIdx+=1,this._showSelectedFixSuggestion(this._fixSuggestions[this._selectedFixIdx]))}_noPrevFix(e){return 0===e}_noNextFix(e,t){return!t||e===t.length-1}_close(){this._currentFix=void 0,this._currentPreviews=[],this._isApplyFixLoading=!1,this.dispatchEvent(new CustomEvent("close-fix-preview",{bubbles:!0,composed:!0})),this.$.applyFixOverlay.close()}_getApplyFixButtonLabel(e){return e?"Saving...":"Apply Fix"}_computeTooltip(e,t){if(!e||!t)return"";return e.revisions[e.current_revision]._number!==t?"Fix can only be applied to the latest patchset":""}_computeDisableApplyFixButton(e,t,n){if(!t||void 0===e||void 0===n)return!0;return n!==t.revisions[t.current_revision]._number||e}_handleApplyFix(e){e&&e.stopPropagation();const t=this.changeNum,n=this._patchNum,i=this.change;return t&&n&&i&&this._currentFix?(this._isApplyFixLoading=!0,this.$.restAPI.applyFixSuggestion(t,n,this._currentFix.fix_id).then(e=>{e&&e.ok&&(gh.navigateToChange(i,"edit",n),this._close()),this._isApplyFixLoading=!1})):Promise.reject(new Error("Not all required properties are set."))}getFixDescription(e){return e&&e.description?e.description:""}};yC([Bl({type:Object})],bC.prototype,"prefs",void 0),yC([Bl({type:Object})],bC.prototype,"change",void 0),yC([Bl({type:String})],bC.prototype,"changeNum",void 0),yC([Bl({type:Number})],bC.prototype,"_patchNum",void 0),yC([Bl({type:String})],bC.prototype,"_robotId",void 0),yC([Bl({type:Object})],bC.prototype,"_currentFix",void 0),yC([Bl({type:Array})],bC.prototype,"_currentPreviews",void 0),yC([Bl({type:Array})],bC.prototype,"_fixSuggestions",void 0),yC([Bl({type:Boolean})],bC.prototype,"_isApplyFixLoading",void 0),yC([Bl({type:Number})],bC.prototype,"_selectedFixIdx",void 0),yC([Bl({type:Boolean,computed:"_computeDisableApplyFixButton(_isApplyFixLoading, change, _patchNum)"})],bC.prototype,"_disableApplyFixButton",void 0),bC=yC([Ml("gr-apply-fix-dialog")],bC),
/**
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at
http://polymer.github.io/LICENSE.txt The complete set of authors may be found at
http://polymer.github.io/AUTHORS.txt The complete set of contributors may be
found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by Google as
part of the polymer project is also subject to an additional IP rights grant
found at http://polymer.github.io/PATENTS.txt
*/
Er({is:"iron-selector",behaviors:[Zh]});
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const wC=ta`
  <style include="gr-voting-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="shared-styles">
    .labelNameCell,
    .buttonsCell,
    .selectedValueCell {
      padding: var(--spacing-s) var(--spacing-m);
      display: table-cell;
    }
    /* We want the :hover highlight to extend to the border of the dialog. */
    .labelNameCell {
      padding-left: var(--spacing-xl);
    }
    .selectedValueCell {
      padding-right: var(--spacing-xl);
    }
    /* This is a trick to let the selectedValueCell take the remaining width. */
    .labelNameCell,
    .buttonsCell {
      white-space: nowrap;
    }
    .selectedValueCell {
      width: 75%;
    }
    .labelMessage {
      color: var(--deemphasized-text-color);
    }
    gr-button {
      min-width: 42px;
      box-sizing: border-box;
      --gr-button: {
        background-color: var(
          --button-background-color,
          var(--table-header-background-color)
        );
        padding: 0 var(--spacing-m);
        @apply --vote-chip-styles;
      }
    }
    gr-button.iron-selected[vote='max'] {
      --button-background-color: var(--vote-color-approved);
    }
    gr-button.iron-selected[vote='positive'] {
      --button-background-color: var(--vote-color-recommended);
    }
    gr-button.iron-selected[vote='min'] {
      --button-background-color: var(--vote-color-rejected);
    }
    gr-button.iron-selected[vote='negative'] {
      --button-background-color: var(--vote-color-disliked);
    }
    gr-button.iron-selected[vote='neutral'] {
      --button-background-color: var(--vote-color-neutral);
    }
    .placeholder {
      display: inline-block;
      width: 42px;
      height: 1px;
    }
    .placeholder::before {
      content: ' ';
    }
    .selectedValueCell {
      color: var(--deemphasized-text-color);
      font-style: italic;
    }
    .selectedValueCell.hidden {
      display: none;
    }
    @media only screen and (max-width: 50em) {
      .selectedValueCell {
        display: none;
      }
    }
  </style>
  <span class="labelNameCell" id="labelName" aria-hidden="true"
    >[[label.name]]</span
  >
  <div class="buttonsCell">
    <template
      is="dom-repeat"
      items="[[_computeBlankItems(permittedLabels, label.name, 'start')]]"
      as="value"
    >
      <span class="placeholder" data-label$="[[label.name]]"></span>
    </template>
    <iron-selector
      id="labelSelector"
      attr-for-selected="data-value"
      selected="[[_computeLabelValue(labels, permittedLabels, label)]]"
      hidden$="[[!_computeAnyPermittedLabelValues(permittedLabels, label.name)]]"
      on-selected-item-changed="_setSelectedValueText"
      role="radiogroup"
      aria-labelledby="labelName"
    >
      <template is="dom-repeat" items="[[_items]]" as="value">
        <gr-button
          role="radio"
          vote$="[[_computeVoteAttribute(value, index, _items.length)]]"
          has-tooltip=""
          data-name$="[[label.name]]"
          data-value$="[[value]]"
          title$="[[_computeLabelValueTitle(labels, label.name, value)]]"
        >
          [[value]]</gr-button
        >
      </template>
    </iron-selector>
    <template
      is="dom-repeat"
      items="[[_computeBlankItems(permittedLabels, label.name, 'end')]]"
      as="value"
    >
      <span class="placeholder" data-label$="[[label.name]]"></span>
    </template>
    <span
      class="labelMessage"
      hidden$="[[_computeAnyPermittedLabelValues(permittedLabels, label.name)]]"
    >
      You don't have permission to edit this label.
    </span>
  </div>
  <div
    class$="selectedValueCell [[_computeHiddenClass(permittedLabels, label.name)]]"
  >
    <span id="selectedValueLabel">[[_selectedValueText]]</span>
  </div>
`;var CC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let EC=class extends(oo(dr(oa))){constructor(){super(...arguments),this._selectedValueText="No value selected"}static get template(){return wC}get selectedItem(){if(this._ironSelector)return this._ironSelector.selectedItem}get selectedValue(){if(this._ironSelector)return this._ironSelector.selected}setSelectedValue(e){this._ironSelector&&this._ironSelector.select(e)}get _ironSelector(){return this.$&&this.$.labelSelector}_computeBlankItems(e,t,n){if(!(e&&e[t]&&e[t].length&&this.labelValues&&Object.keys(this.labelValues).length))return[];const i=this.labelValues[parseInt(e[t][0],10)];if("start"===n)return new Array(i);const o=this.labelValues[parseInt(e[t][e[t].length-1],10)];return new Array(Object.keys(this.labelValues).length-o-1)}_getLabelValue(e,t,n){return n.value?n.value:o(e[n.name],"default_value")&&o(t,n.name)?t[n.name].find(t=>parseInt(t,10)===e[n.name].default_value):void 0}_computeVoteAttribute(e,t,n){return e<0&&0===t?"min":e<0?"negative":e>0&&t===n-1?"max":e>0?"positive":"neutral"}_computeLabelValue(e,t,n){if(void 0===e||void 0===t||void 0===n)return null;if(!e[n.name])return null;const i=this._getLabelValue(e,t,n),o=t[n.name]?t[n.name].length:0;for(let e=0;e<o;e++){const o=t[n.name][e];if(o===i)return o}return null}_setSelectedValueText(e){const t=e.target.selectedItem;if(!t)return;if(!this.$.labelSelector.items)return;for(const e of this.$.labelSelector.items)t===e?e.setAttribute("aria-checked","true"):e.removeAttribute("aria-checked");this._selectedValueText=t.getAttribute("title")||"",this.updateStyles();const n=t.dataset.name,i=t.dataset.value;this.dispatchEvent(new CustomEvent("labels-changed",{detail:{name:n,value:i},bubbles:!0,composed:!0}))}_computeAnyPermittedLabelValues(e,t){return e&&o(e,t)&&e[t].length}_computeHiddenClass(e,t){return this._computeAnyPermittedLabelValues(e,t)?"":"hidden"}_computePermittedLabelValues(e,t){return void 0===e||void 0===t?[]:e[t]||[]}_computeLabelValueTitle(e,t,n){return e[t]&&e[t].values&&e[t].values[n]}};CC([Bl({type:Object})],EC.prototype,"label",void 0),CC([Bl({type:Object})],EC.prototype,"labels",void 0),CC([Bl({type:String,reflectToAttribute:!0})],EC.prototype,"name",void 0),CC([Bl({type:Object})],EC.prototype,"permittedLabels",void 0),CC([Bl({type:Object})],EC.prototype,"labelValues",void 0),CC([Bl({type:String})],EC.prototype,"_selectedValueText",void 0),CC([Bl({computed:"_computePermittedLabelValues(permittedLabels, label.name)",type:Array})],EC.prototype,"_items",void 0),EC=CC([Ml("gr-label-score-row")],EC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const SC=ta`
  <style include="shared-styles">
    .scoresTable {
      display: table;
      width: 100%;
    }
    .mergedMessage {
      font-style: italic;
      text-align: center;
      width: 100%;
    }
    gr-label-score-row:hover {
      background-color: var(--hover-background-color);
    }
    gr-label-score-row {
      display: table-row;
    }
    gr-label-score-row.no-access {
      display: var(--label-no-access-display, table-row);
    }
  </style>
  <div class="scoresTable">
    <template is="dom-repeat" items="[[_labels]]" as="label">
      <gr-label-score-row
        class$="[[_computeLabelAccessClass(label.name, permittedLabels)]]"
        label="[[label]]"
        name="[[label.name]]"
        labels="[[change.labels]]"
        permitted-labels="[[permittedLabels]]"
        label-values="[[_labelValues]]"
      ></gr-label-score-row>
    </template>
  </div>
  <div class="mergedMessage" hidden$="[[!_changeIsMerged(change.status)]]">
    Because this change has been merged, votes may not be decreased.
  </div>
`;var AC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let xC=class extends(oo(dr(oa))){static get template(){return SC}getLabelValues(){const e={};if(null===this.shadowRoot||!this.change)return e;for(const t in this.permittedLabels){if(!o(this.permittedLabels,t))continue;const n=this.shadowRoot.querySelector(`gr-label-score-row[name="${t}"]`);if(!n)continue;if(!n.selectedItem)continue;const i="string"==typeof n.selectedValue?parseInt(n.selectedValue,10):n.selectedValue;if(void 0===i)continue;const s=this._getVoteForAccount(this.change.labels,t,this.account);let r;r="string"==typeof s?parseInt(s,10):s,i!==r&&(e[t]=i)}return e}_getStringLabelValue(e,t,n){for(const i in e[t].values)if(parseInt(i,10)===n)return i;return n}_getVoteForAccount(e,t,n){if(!e)return null;const i=e[t];if(i.all&&i.all.length>0)for(let o=0;o<i.all.length;o++)if(n&&i.all[o]._account_id==n._account_id)return this._getStringLabelValue(e,t,i.all[o].value);return null}_computeLabels(e,t){if([e,t].includes(void 0))return;const n=e.base;return n?Object.keys(n).sort().map(e=>({name:e,value:this._getVoteForAccount(n,e,this.account)})):[]}_computeColumns(e){if(!e)return;const t=Object.keys(e),n=new Set;for(const i of t)for(const t of e[i])n.add(parseInt(t,10));const i=Array.from(n.values()).sort((e,t)=>e-t),o={};for(let e=0;e<i.length;e++)o[i[e]]=e;this._labelValues=o}_changeIsMerged(e){return"MERGED"===e}_computeLabelAccessClass(e,t){return t&&e?o(t,e)&&t[e].length?"access":"no-access":""}};AC([Bl({type:Array,computed:"_computeLabels(change.labels.*, account)"})],xC.prototype,"_labels",void 0),AC([Bl({type:Object,observer:"_computeColumns"})],xC.prototype,"permittedLabels",void 0),AC([Bl({type:Object})],xC.prototype,"change",void 0),AC([Bl({type:Object})],xC.prototype,"account",void 0),AC([Bl({type:Object})],xC.prototype,"_labelValues",void 0),xC=AC([Ml("gr-label-scores")],xC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const PC=ta`
  <style include="shared-styles">
    #threads {
      display: block;
      padding: var(--spacing-l);
    }
    gr-comment-thread {
      display: block;
      margin-bottom: var(--spacing-m);
      max-width: 80ch;
    }
    .header {
      align-items: center;
      background-color: var(--table-header-background-color);
      border-bottom: 1px solid var(--border-color);
      border-top: 1px solid var(--border-color);
      display: flex;
      justify-content: left;
      min-height: 3.2em;
      padding: var(--spacing-m) var(--spacing-l);
    }
    .toggleItem.draftToggle {
      display: none;
    }
    .toggleItem.draftToggle.show {
      display: flex;
    }
    .toggleItem {
      align-items: center;
      display: flex;
      margin-right: var(--spacing-l);
    }
    .draftsOnly:not(.unresolvedOnly) gr-comment-thread[has-draft],
    .unresolvedOnly:not(.draftsOnly) gr-comment-thread[unresolved],
    .draftsOnly.unresolvedOnly gr-comment-thread[has-draft][unresolved] {
      display: block;
    }
    .thread-separator {
      border-top: 1px solid var(--border-color);
      margin-top: var(--spacing-xl);
    }
  </style>
  <template is="dom-if" if="[[!hideToggleButtons]]">
    <div class="header">
      <div class="toggleItem">
        <paper-toggle-button
          id="unresolvedToggle"
          checked="{{_unresolvedOnly}}"
          on-tap="_onTapUnresolvedToggle"
          >Only unresolved threads</paper-toggle-button
        >
      </div>
      <div
        class$="toggleItem draftToggle [[_computeShowDraftToggle(loggedIn)]]"
      >
        <paper-toggle-button
          id="draftToggle"
          checked="{{_draftsOnly}}"
          on-tap="_onTapUnresolvedToggle"
          >Only threads with drafts</paper-toggle-button
        >
      </div>
    </div>
  </template>
  <div id="threads">
    <template is="dom-if" if="[[!threads.length]]">
      [[emptyThreadMsg]]
    </template>
    <template
      is="dom-repeat"
      items="[[_sortedThreads]]"
      as="thread"
      initial-count="10"
      target-framerate="60"
    >
      <template
        is="dom-if"
        if="[[_shouldShowThread(thread, _unresolvedOnly, _draftsOnly, onlyShowRobotCommentsWithHumanReply)]]"
      >
        <template
          is="dom-if"
          if="[[_shouldRenderSeparator(_sortedThreads, thread, _unresolvedOnly, _draftsOnly, onlyShowRobotCommentsWithHumanReply)]]"
        >
          <div class="thread-separator"></div>
        </template>
        <gr-comment-thread
          show-file-path=""
          change-num="[[changeNum]]"
          comments="[[thread.comments]]"
          comment-side="[[thread.commentSide]]"
          show-file-name="[[_isFirstThreadWithFileName(_sortedThreads, thread, _unresolvedOnly, _draftsOnly, onlyShowRobotCommentsWithHumanReply)]]"
          project-name="[[change.project]]"
          is-on-parent="[[_isOnParent(thread.commentSide)]]"
          line-num="[[thread.line]]"
          patch-num="[[thread.patchNum]]"
          path="[[thread.path]]"
          root-id="{{thread.rootId}}"
          on-thread-changed="_handleCommentsChanged"
          on-thread-discard="_handleThreadDiscard"
        ></gr-comment-thread>
      </template>
    </template>
  </div>
`
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var RC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let TC=class extends(oo(dr(oa))){constructor(){super(...arguments),this.threads=[],this._sortedThreads=[],this._unresolvedOnly=!1,this._draftsOnly=!1,this.onlyShowRobotCommentsWithHumanReply=!1,this.hideToggleButtons=!1,this.emptyThreadMsg="There are no inline comment threads on any diff for this change."}static get template(){return PC}_computeShowDraftToggle(e){return e?"show":""}_compareThreads(e,t){if(e.thread.path!==t.thread.path)return e.thread.path===ka.PATCHSET_LEVEL_COMMENTS?-1:t.thread.path===ka.PATCHSET_LEVEL_COMMENTS?1:e.thread.path.localeCompare(t.thread.path);if(e.thread.line!==t.thread.line)return e.thread.line&&t.thread.line?e.thread.line<t.thread.line?-1:1:e.thread.line?1:-1;if(e.thread.patchNum!==t.thread.patchNum)return e.thread.patchNum?t.thread.patchNum?e.thread.patchNum>t.thread.patchNum?-1:1:-1:1;if(t.unresolved!==e.unresolved){if(!e.unresolved)return 1;if(!t.unresolved)return-1}if(t.hasDraft!==e.hasDraft){if(!e.hasDraft)return 1;if(!t.hasDraft)return-1}return t.updated!==e.updated?e.updated?t.updated?t.updated.getTime()-e.updated.getTime():-1:1:t.thread.rootId!==e.thread.rootId?e.thread.rootId?t.thread.rootId?e.thread.rootId.localeCompare(t.thread.rootId):-1:1:0}_updateSortedThreads(e,t){if(!e||0===e.length)return void(this._sortedThreads=[]);if(this._sortedThreads.length===e.length){for(const t of e){const e=this._sortedThreads.findIndex(e=>e.rootId===t.rootId);this.set(`_sortedThreads.${e}`,{...t})}return}const n=e.map(e=>this._getThreadWithStatusInfo(e));this._sortedThreads=n.sort((e,t)=>this._compareThreads(e,t)).map(e=>e.thread)}_isFirstThreadWithFileName(e,t,n,i,o){const s=e.filter(e=>this._shouldShowThread(e,n,i,o)),r=s.findIndex(e=>e.rootId===t.rootId);return-1!==r&&(0===r||s[r-1].path!==s[r].path)}_shouldRenderSeparator(e,t,n,i,o){const s=e.filter(e=>this._shouldShowThread(e,n,i,o)).findIndex(e=>e.rootId===t.rootId);return-1!==s&&(s>0&&this._isFirstThreadWithFileName(e,t,n,i,o))}_shouldShowThread(e,t,n,i){if([e,t,n,i].includes(void 0))return!1;if(!n&&!t&&!i)return!0;const o=this._getThreadWithStatusInfo(e);if(o.isEditing)return!0;if(o.hasRobotComment&&i&&!o.hasHumanReplyToRobotComment)return!1;let s=!0;return n&&t?s=o.hasDraft&&o.unresolved:n?s=o.hasDraft:t&&(s=o.unresolved),s}_getThreadWithStatusInfo(e){const t=e.comments,n=t.length?t[t.length-1]:void 0;let i=!1,o=!1;t.forEach(e=>{e.robot_id?i=!0:i&&(o=!0)});let s=void 0;return n&&(Hf(n)&&(s=n.__date),n.updated&&(s=lc(n.updated))),{thread:e,hasRobotComment:i,hasHumanReplyToRobotComment:o,unresolved:!!n&&!!n.unresolved,isEditing:!!n&&!!n.__editing,hasDraft:!!n&&Hf(n),updated:s}}removeThread(e){for(let t=0;t<this.threads.length;t++)if(this.threads[t].rootId===e)return this.splice("threads",t,1),void Mo()}_handleThreadDiscard(e){this.removeThread(e.detail.rootId)}_handleCommentsChanged(e){this.dispatchEvent(new CustomEvent("thread-list-modified",{detail:{rootId:e.detail.rootId,path:e.detail.path}}))}_isOnParent(e){return!!e}_onTapUnresolvedToggle(e){e.preventDefault()}};RC([Bl({type:Object})],TC.prototype,"change",void 0),RC([Bl({type:Array})],TC.prototype,"threads",void 0),RC([Bl({type:String})],TC.prototype,"changeNum",void 0),RC([Bl({type:Boolean})],TC.prototype,"loggedIn",void 0),RC([Bl({type:Array})],TC.prototype,"_sortedThreads",void 0),RC([Bl({type:Boolean})],TC.prototype,"_unresolvedOnly",void 0),RC([Bl({type:Boolean})],TC.prototype,"_draftsOnly",void 0),RC([Bl({type:Boolean})],TC.prototype,"onlyShowRobotCommentsWithHumanReply",void 0),RC([Bl({type:Boolean})],TC.prototype,"hideToggleButtons",void 0),RC([Bl({type:String})],TC.prototype,"emptyThreadMsg",void 0),RC([jl("threads","threads.splices")],TC.prototype,"_updateSortedThreads",null),TC=RC([Ml("gr-thread-list")],TC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const IC=ta`
  <style include="shared-styles">
    :host {
      background-color: var(--dialog-background-color);
      display: block;
      max-height: 90vh;
    }
    :host([disabled]) {
      pointer-events: none;
    }
    :host([disabled]) .container {
      opacity: 0.5;
    }
    .container {
      display: flex;
      flex-direction: column;
      max-height: 100%;
    }
    section {
      border-top: 1px solid var(--border-color);
      flex-shrink: 0;
      padding: var(--spacing-m) var(--spacing-xl);
      width: 100%;
    }
    section.labelsContainer {
      /* We want the :hover highlight to extend to the border of the dialog. */
      padding: var(--spacing-m) 0;
    }
    .stickyBottom {
      background-color: var(--dialog-background-color);
      box-shadow: 0px 0px 8px 0px rgba(60, 64, 67, 0.15);
      bottom: 0;
      position: sticky;
      /* @see Issue 8602 */
      z-index: 1;
    }
    .actions {
      display: flex;
      justify-content: space-between;
    }
    .actions .right gr-button {
      margin-left: var(--spacing-l);
    }
    .peopleContainer,
    .labelsContainer {
      flex-shrink: 0;
    }
    .peopleContainer {
      border-top: none;
      display: table;
    }
    .peopleList {
      display: flex;
    }
    .peopleListLabel {
      color: var(--deemphasized-text-color);
      margin-top: var(--spacing-xs);
      min-width: 6em;
      padding-right: var(--spacing-m);
    }
    gr-account-list {
      display: flex;
      flex-wrap: wrap;
      flex: 1;
    }
    #reviewerConfirmationOverlay {
      padding: var(--spacing-l);
      text-align: center;
    }
    .reviewerConfirmationButtons {
      margin-top: var(--spacing-l);
    }
    .groupName {
      font-weight: var(--font-weight-bold);
    }
    .groupSize {
      font-style: italic;
    }
    .textareaContainer {
      min-height: 12em;
      position: relative;
    }
    .textareaContainer,
    #textarea,
    gr-endpoint-decorator[name='reply-text'] {
      display: flex;
      width: 100%;
    }
    gr-endpoint-decorator[name='reply-text'] {
      flex-direction: column;
    }
    #textarea {
      flex: 1;
    }
    .previewContainer gr-formatted-text {
      background: var(--table-header-background-color);
      padding: var(--spacing-l);
    }
    #checkingStatusLabel,
    #notLatestLabel {
      margin-left: var(--spacing-l);
    }
    #checkingStatusLabel {
      color: var(--deemphasized-text-color);
      font-style: italic;
    }
    #notLatestLabel,
    #savingLabel {
      color: var(--error-text-color);
    }
    #savingLabel {
      display: none;
    }
    #savingLabel.saving {
      display: inline;
    }
    #pluginMessage {
      color: var(--deemphasized-text-color);
      margin-left: var(--spacing-l);
      margin-bottom: var(--spacing-m);
    }
    #pluginMessage:empty {
      display: none;
    }
    .preview-formatting {
      margin-left: var(--spacing-m);
    }
    .attention-icon {
      width: 14px;
      height: 14px;
      vertical-align: top;
      position: relative;
      top: 3px;
      --iron-icon-height: 24px;
      --iron-icon-width: 24px;
    }
    .attention .edit-attention-button {
      vertical-align: top;
      --padding: 0px 4px;
    }
    .attention .edit-attention-button iron-icon {
      color: inherit;
    }
    .attention a,
    .attention-detail a {
      text-decoration: none;
    }
    .attentionSummary {
      display: flex;
      justify-content: space-between;
    }
    .attentionSummary gr-account-chip {
      display: inline-block;
      vertical-align: top;
      /* The account chip is misbehaving currently: It consumes 22px height, so
         it does not fit nicely into the 20px line-height of the standard
         inline layout flow. :-( */
      position: relative;
      top: -1px;
    }
    .attentionSummary,
    .attention-detail {
      --account-max-length: 150px;
    }
    .attention-detail .peopleList .accountList {
      display: flex;
      flex-wrap: wrap;
    }
    .attention-detail gr-account-label {
      display: inline-block;
      padding: var(--spacing-xs) var(--spacing-m);
      vertical-align: baseline;
      user-select: none;
      --label-border-radius: 8px;
    }
    .attention-detail gr-account-label:focus {
      outline: none;
    }
    .attention-detail gr-account-label:hover {
      box-shadow: var(--elevation-level-1);
      cursor: pointer;
    }
    .attention-detail .attentionDetailsTitle {
      display: flex;
      justify-content: space-between;
    }
    .attention-detail .selectUsers {
      color: var(--deemphasized-text-color);
      margin-bottom: var(--spacing-m);
    }
  </style>
  <div class="container" tabindex="-1">
    <section class="peopleContainer">
      <gr-endpoint-decorator name="reply-reviewers">
        <gr-endpoint-param name="change" value="[[change]]"></gr-endpoint-param>
        <gr-endpoint-param name="reviewers" value="[[_allReviewers]]">
        </gr-endpoint-param>
        <div class="peopleList">
          <div class="peopleListLabel">Reviewers</div>
          <gr-account-list
            id="reviewers"
            accounts="{{_reviewers}}"
            removable-values="[[change.removable_reviewers]]"
            filter="[[filterReviewerSuggestion]]"
            pending-confirmation="{{_reviewerPendingConfirmation}}"
            placeholder="Add reviewer..."
            on-account-text-changed="_handleAccountTextEntry"
            suggestions-provider="[[_getReviewerSuggestionsProvider(change)]]"
          >
          </gr-account-list>
          <gr-endpoint-slot name="right"></gr-endpoint-slot>
        </div>
        <gr-endpoint-slot name="below"></gr-endpoint-slot>
      </gr-endpoint-decorator>
      <div class="peopleList">
        <div class="peopleListLabel">CC</div>
        <gr-account-list
          id="ccs"
          accounts="{{_ccs}}"
          filter="[[filterCCSuggestion]]"
          pending-confirmation="{{_ccPendingConfirmation}}"
          allow-any-input=""
          placeholder="Add CC..."
          on-account-text-changed="_handleAccountTextEntry"
          suggestions-provider="[[_getCcSuggestionsProvider(change)]]"
        >
        </gr-account-list>
      </div>
      <gr-overlay
        id="reviewerConfirmationOverlay"
        on-iron-overlay-canceled="_cancelPendingReviewer"
      >
        <div class="reviewerConfirmation">
          Group
          <span class="groupName">
            [[_pendingConfirmationDetails.group.name]]
          </span>
          has
          <span class="groupSize">
            [[_pendingConfirmationDetails.count]]
          </span>
          members.
          <br />
          Are you sure you want to add them all?
        </div>
        <div class="reviewerConfirmationButtons">
          <gr-button on-click="_confirmPendingReviewer">Yes</gr-button>
          <gr-button on-click="_cancelPendingReviewer">No</gr-button>
        </div>
      </gr-overlay>
    </section>
    <section class="textareaContainer">
      <gr-endpoint-decorator name="reply-text">
        <gr-textarea
          id="textarea"
          class="message"
          autocomplete="on"
          placeholder="[[_messagePlaceholder]]"
          fixed-position-dropdown=""
          hide-border="true"
          monospace="true"
          disabled="{{disabled}}"
          rows="4"
          text="{{draft}}"
          on-bind-value-changed="_handleHeightChanged"
        >
        </gr-textarea>
      </gr-endpoint-decorator>
    </section>
    <section class="previewContainer">
      <template is="dom-if" if="[[_isPatchsetCommentsExperimentEnabled]]">
        <label>
          <input
            id="resolvedPatchsetLevelCommentCheckbox"
            type="checkbox"
            checked="{{_isResolvedPatchsetLevelComment::change}}"
          />
          Resolved
        </label>
      </template>
      <label class="preview-formatting">
        <input type="checkbox" checked="{{_previewFormatting::change}}" />
        Preview formatting
      </label>
      <gr-formatted-text
        content="[[draft]]"
        hidden$="[[!_previewFormatting]]"
        config="[[projectConfig.commentlinks]]"
      ></gr-formatted-text>
    </section>
    <section class="labelsContainer">
      <gr-endpoint-decorator name="reply-label-scores">
        <gr-label-scores
          id="labelScores"
          account="[[_account]]"
          change="[[change]]"
          on-labels-changed="_handleLabelsChanged"
          permitted-labels="[[permittedLabels]]"
        ></gr-label-scores>
      </gr-endpoint-decorator>
      <div id="pluginMessage">[[_pluginMessage]]</div>
    </section>
    <section
      class="draftsContainer"
      hidden$="[[_computeHideDraftList(draftCommentThreads)]]"
    >
      <div class="includeComments">
        <input
          type="checkbox"
          id="includeComments"
          checked="{{_includeComments::change}}"
        />
        <label for="includeComments"
          >Publish [[_computeDraftsTitle(draftCommentThreads)]]</label
        >
      </div>
      <gr-thread-list
        id="commentList"
        hidden$="[[!_includeComments]]"
        threads="[[draftCommentThreads]]"
        change="[[change]]"
        change-num="[[change._number]]"
        logged-in="true"
        hide-toggle-buttons=""
        on-thread-list-modified="_onThreadListModified"
      >
      </gr-thread-list>
      <span
        id="savingLabel"
        class$="[[_computeSavingLabelClass(_savingComments)]]"
      >
        Saving comments...
      </span>
    </section>
    <div class="stickyBottom">
      <section
        hidden$="[[!_showAttentionSummary(serverConfig, _attentionModified)]]"
        class="attention"
      >
        <div class="attentionSummary">
          <div>
            <template
              is="dom-if"
              if="[[_isNewAttentionEmpty(serverConfig, _currentAttentionSet, _newAttentionSet)]]"
            >
              <span>Do not update the attention set.</span>
            </template>
            <template
              is="dom-if"
              if="[[!_isNewAttentionEmpty(serverConfig, _currentAttentionSet, _newAttentionSet)]]"
            >
              <span>Bring to attention of</span>
              <template
                is="dom-repeat"
                items="[[_computeNewAttentionAccounts(serverConfig, _currentAttentionSet, _newAttentionSet)]]"
                as="account"
              >
                <gr-account-chip account="[[account]]" force-attention="">
                </gr-account-chip>
              </template>
            </template>
            <gr-button
              class="edit-attention-button"
              on-click="_handleAttentionModify"
              link=""
              position-below=""
              data-label="Edit"
              data-action-type="change"
              data-action-key="edit"
              title="Edit attention set changes"
              role="button"
              tabindex="0"
            >
              <iron-icon icon="gr-icons:edit"></iron-icon>
              Modify
            </gr-button>
          </div>
          <div>
            <a
              href="https://bugs.chromium.org/p/gerrit/issues/entry?template=Attention+Set"
              target="_blank"
            >
              <iron-icon
                icon="gr-icons:bug"
                title="report a problem"
              ></iron-icon>
            </a>
            <a
              href="https://gerrit-review.googlesource.com/Documentation/user-attention-set.html"
              target="_blank"
            >
              <iron-icon
                icon="gr-icons:help-outline"
                title="read documentation"
              ></iron-icon>
            </a>
          </div>
        </div>
      </section>
      <section
        hidden$="[[!_showAttentionDetails(serverConfig, _attentionModified)]]"
        class="attention-detail"
      >
        <div class="attentionDetailsTitle">
          <div>
            <span>Modify attention to</span>
          </div>
          <div></div>
          <div>
            <a
              href="https://bugs.chromium.org/p/gerrit/issues/entry?template=Attention+Set"
              target="_blank"
            >
              <iron-icon
                icon="gr-icons:bug"
                title="report a problem"
              ></iron-icon>
            </a>
            <a
              href="https://gerrit-review.googlesource.com/Documentation/user-attention-set.html"
              target="_blank"
            >
              <iron-icon
                icon="gr-icons:help-outline"
                title="read documentation"
              ></iron-icon>
            </a>
          </div>
        </div>
        <div class="selectUsers">
          <span
            >Select chips to set who will be in the attention set after sending
            this reply</span
          >
        </div>
        <div class="peopleList">
          <div class="peopleListLabel">Owner</div>
          <div>
            <gr-account-label
              account="[[_owner]]"
              force-attention="[[_computeHasNewAttention(_owner, _newAttentionSet)]]"
              selected$="[[_computeHasNewAttention(_owner, _newAttentionSet)]]"
              deselected$="[[!_computeHasNewAttention(_owner, _newAttentionSet)]]"
              hide-hovercard=""
              on-click="_handleAttentionClick"
            >
            </gr-account-label>
          </div>
        </div>
        <template is="dom-if" if="[[_uploader]]">
          <div class="peopleList">
            <div class="peopleListLabel">Uploader</div>
            <div>
              <gr-account-label
                account="[[_uploader]]"
                force-attention="[[_computeHasNewAttention(_uploader, _newAttentionSet)]]"
                selected$="[[_computeHasNewAttention(_uploader, _newAttentionSet)]]"
                deselected$="[[!_computeHasNewAttention(_uploader, _newAttentionSet)]]"
                hide-hovercard=""
                on-click="_handleAttentionClick"
              >
              </gr-account-label>
            </div>
          </div>
        </template>
        <div class="peopleList">
          <div class="peopleListLabel">Reviewers</div>
          <div>
            <template
              is="dom-repeat"
              items="[[_removeServiceUsers(_reviewers, _newAttentionSet)]]"
              as="account"
            >
              <gr-account-label
                account="[[account]]"
                force-attention="[[_computeHasNewAttention(account, _newAttentionSet)]]"
                selected$="[[_computeHasNewAttention(account, _newAttentionSet)]]"
                deselected$="[[!_computeHasNewAttention(account, _newAttentionSet)]]"
                hide-hovercard=""
                on-click="_handleAttentionClick"
              >
              </gr-account-label>
            </template>
          </div>
        </div>
        <template is="dom-if" if="[[_computeShowAttentionCcs(_ccs)]]">
          <div class="peopleList">
            <div class="peopleListLabel">CC</div>
            <div>
              <template
                is="dom-repeat"
                items="[[_removeServiceUsers(_ccs, _newAttentionSet)]]"
                as="account"
              >
                <gr-account-label
                  account="[[account]]"
                  force-attention="[[_computeHasNewAttention(account, _newAttentionSet)]]"
                  selected$="[[_computeHasNewAttention(account, _newAttentionSet)]]"
                  deselected$="[[!_computeHasNewAttention(account, _newAttentionSet)]]"
                  hide-hovercard=""
                  on-click="_handleAttentionClick"
                >
                </gr-account-label>
              </template>
            </div>
          </div>
        </template>
      </section>
      <section class="actions">
        <div class="left">
          <span
            id="checkingStatusLabel"
            hidden$="[[!_isState(knownLatestState, 'checking')]]"
          >
            Checking whether patch [[patchNum]] is latest...
          </span>
          <span
            id="notLatestLabel"
            hidden$="[[!_isState(knownLatestState, 'not-latest')]]"
          >
            [[_computePatchSetWarning(patchNum, _labelsChanged)]]
            <gr-button link="" on-click="_reload">Reload</gr-button>
          </span>
        </div>
        <div class="right">
          <gr-button
            link=""
            id="cancelButton"
            class="action cancel"
            on-click="_cancelTapHandler"
            >Cancel</gr-button
          >
          <template is="dom-if" if="[[canBeStarted]]">
            <!-- Use 'Send' here as the change may only about reviewers / ccs
                and when this button is visible, the next button will always
                be 'Start review' -->
            <gr-button
              link=""
              disabled="[[_isState(knownLatestState, 'not-latest')]]"
              class="action save"
              has-tooltip=""
              title="[[_saveTooltip]]"
              on-click="_saveClickHandler"
              >Save</gr-button
            >
          </template>
          <gr-button
            id="sendButton"
            primary=""
            disabled="[[_sendDisabled]]"
            class="action send"
            has-tooltip=""
            title$="[[_computeSendButtonTooltip(canBeStarted)]]"
            on-click="_sendTapHandler"
            >[[_sendButtonLabel]]</gr-button
          >
        </div>
      </section>
    </div>
  </div>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-storage id="storage"></gr-storage>
`
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var kC;!function(e){e.PATCHSET_COMMENTS="UiFeature__patchset_comments",e.PATCHSET_CHOICE_FOR_COMMENT_LINKS="UiFeature__patchset_choice_for_comment_links",e.NEW_CONTEXT_CONTROLS="UiFeature__new_context_controls"}(kC||(kC={}));var OC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};var NC,LC,DC;!function(e){e.ANY="any",e.BODY="body",e.CCS="cc",e.REVIEWERS="reviewers"}(NC||(NC={})),function(e){e.REVIEWER="REVIEWER",e.CC="CC"}(LC||(LC={})),function(e){e.LATEST="latest",e.CHECKING="checking",e.NOT_LATEST="not-latest"}(DC||(DC={}));const $C="Start review",MC="Send",FC="Save but do not send notification or change review state",BC="Mark as ready for review and send reply",jC="Send reply",HC=[LC.CC,LC.REVIEWER];let UC=class extends(xp(oo(dr(oa)))){constructor(){super(),this.FocusTarget=NC,this.reporting=n.reportingService,this.flagsService=n.flagsService,this.canBeStarted=!1,this.disabled=!1,this.draft="",this.quote="",this.underReview=!0,this._ccs=[],this._ccPendingConfirmation=null,this._pendingConfirmationDetails=null,this._includeComments=!0,this._reviewers=[],this._reviewerPendingConfirmation=null,this._previewFormatting=!1,this._reviewersPendingRemove={CC:[],REVIEWER:[]},this._savingComments=!1,this._reviewersMutated=!1,this._labelsChanged=!1,this._saveTooltip=FC,this._pluginMessage="",this._commentEditing=!1,this._attentionModified=!1,this._currentAttentionSet=new Set,this._newAttentionSet=new Set,this._isResolvedPatchsetLevelComment=!0,this._allReviewers=[],this._isPatchsetCommentsExperimentEnabled=!1,this.filterReviewerSuggestion=()=>this._filterReviewerSuggestionGenerator(!1),this.filterCCSuggestion=()=>this._filterReviewerSuggestionGenerator(!0)}static get template(){return IC}get keyBindings(){return{esc:"_handleEscKey","ctrl+enter meta+enter":"_handleEnterKey"}}attached(){super.attached(),Mu.requestAvailability(),this._getAccount().then(e=>{e&&(this._account=e)}),this.addEventListener("comment-editing-changed",e=>{this._commentEditing=e.detail}),this.addEventListener("add-reviewer",e=>{this.$.reviewers.addAccountItem({account:e.detail.reviewer})}),this.addEventListener("remove-reviewer",e=>{this.$.reviewers.removeAccount(e.detail.reviewer)})}ready(){super.ready(),this._isPatchsetCommentsExperimentEnabled=this.flagsService.isEnabled(kC.PATCHSET_COMMENTS),this.$.jsAPI.addElement(Tl.REPLY_DIALOG,this)}open(e){if(!this.change)throw new Error("missing required change property");this.knownLatestState=DC.CHECKING,Ih(this.change,this.$.restAPI).then(e=>{this.knownLatestState=e.isLatest?DC.LATEST:DC.NOT_LATEST}),this._focusOn(e),this.quote&&this.quote.length?(this.draft=this.quote,this.quote=""):this.draft=this._loadStoredDraft(),this.$.restAPI.hasPendingDiffDrafts()&&(this._savingComments=!0,this.$.restAPI.awaitPendingDiffDrafts().then(()=>{this.dispatchEvent(new CustomEvent("comment-refresh",{composed:!0,bubbles:!0})),this._savingComments=!1}))}focus(){this._focusOn(NC.ANY)}getFocusStops(){const e=this._sendDisabled?this.$.cancelButton:this.$.sendButton;return{start:this.$.reviewers.focusStart,end:e}}setLabelValue(e,t){var n;const i=null===(n=this.$.labelScores.shadowRoot)||void 0===n?void 0:n.querySelector(`gr-label-score-row[name="${e}"]`);i&&i.setSelectedValue(t)}getLabelValue(e){var t;const n=null===(t=this.$.labelScores.shadowRoot)||void 0===t?void 0:t.querySelector(`gr-label-score-row[name="${e}"]`);return n?n.selectedValue:null}_handleEscKey(){this.cancel()}_handleEnterKey(){this._submit()}_ccsChanged(e){this._reviewerTypeChanged(e,LC.CC)}_reviewersChanged(e){this._reviewerTypeChanged(e,LC.REVIEWER)}_reviewerTypeChanged(e,t){if(e&&e.indexSplices){let n,i,o;this._reviewersMutated=!0,this._processReviewerChange(e.indexSplices,t);const s=LC.REVIEWER===t;for(const t of e.indexSplices)for(let e=0;e<t.addedCount;e++){if(o=t.object[t.index+e],n=this._accountOrGroupKey(o),i=(s?this._ccs:this._reviewers).findIndex(e=>this._accountOrGroupKey(e)===n),i>=0){this.splice(s?"_ccs":"_reviewers",i,1);const e=s?"CC":"reviewer",t=s?"reviewer":"CC",r=`${o.name||o.email||n} moved from ${e} to ${t}.`;this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:r},composed:!0,bubbles:!0}))}}}}_processReviewerChange(e,t){for(const n of e)for(const e of n.removed){if(!this._reviewersPendingRemove[t])return void console.error("Invalid type "+t+" for reviewer.");this._reviewersPendingRemove[t].push(e)}}_purgeReviewersPendingRemove(e,t=new Map){let n;for(const i of HC){if(!e){n=this._reviewersPendingRemove[i];for(let e=0;e<n.length;e++){const o=n[e];id(o)&&t.get(hc(o))||this._removeAccount(o,i)}}this._reviewersPendingRemove[i]=[]}}_removeAccount(e,t){if(!this.change)throw new Error("missing required change property");if(!e._pendingAdd&&id(e))return this.$.restAPI.removeChangeReviewer(this.change._number,hc(e)).then(n=>{if(!(null==n?void 0:n.ok)||!this.change)return;const i=this.change.reviewers[t]||[];for(let n=0;n<i.length;n++)if(i[n]._account_id===e._account_id){this.splice(`change.reviewers.${t}`,n,1);break}})}_mapReviewer(e){if(e.account)return{reviewer:hc(e.account)};if(e.group){return{reviewer:decodeURIComponent(e.group.id),confirmed:e.group.confirmed}}throw new Error("Reviewer must be either an account or a group.")}send(e,t){this.reporting.time("SendReply");const n=this.$.labelScores.getLabelValues(),i={drafts:e?nl.PUBLISH_ALL_REVISIONS:nl.KEEP,labels:n};if(t&&(i.ready=!0),this._isAttentionSetEnabled(this.serverConfig)){const e=`${sl(this.serverConfig,this._account)} replied on the change`;i.ignore_automatic_attention_set_rules=!0,i.add_to_attention_set=[];for(const t of this._newAttentionSet)this._currentAttentionSet.has(t)||i.add_to_attention_set.push({user:t,reason:e});i.remove_from_attention_set=[];for(const t of this._currentAttentionSet)this._newAttentionSet.has(t)||i.remove_from_attention_set.push({user:t,reason:e});this.reportAttentionSetChanges(this._attentionModified,i.add_to_attention_set,i.remove_from_attention_set)}if(this.draft)if(this._isPatchsetCommentsExperimentEnabled){const e={message:this.draft,unresolved:!this._isResolvedPatchsetLevelComment};i.comments={[ka.PATCHSET_LEVEL_COMMENTS]:[e]}}else i.message=this.draft;const o=new Map;i.reviewers=this.$.reviewers.additions().map(e=>(e.account&&o.set(hc(e.account),!0),this._mapReviewer(e)));const s=this.$.ccs;if(s)for(const e of s.additions()){e.account&&o.set(hc(e.account),!0);const t=this._mapReviewer(e);t.state=Na.CC,i.reviewers.push(t)}this.disabled=!0;return this._saveReview(i,e=>this._handle400Error(e)).then(e=>e?e.ok?(this.draft="",this._includeComments=!0,this.dispatchEvent(new CustomEvent("send",{composed:!0,bubbles:!1})),this.fire("iron-announce",{text:"Reply sent"},{bubbles:!0}),o):(this.dispatchEvent(new CustomEvent("server-error",{detail:{response:e},composed:!0,bubbles:!0})),new Map):new Map).then(e=>(this.disabled=!1,e)).catch(e=>{throw this.disabled=!1,e})}_focusOn(e){if(e&&e!==NC.ANY||(e=this._chooseFocusTarget()),e===NC.BODY){const e=this.$.textarea;e.async(()=>e.getNativeTextarea().focus())}else if(e===NC.REVIEWERS){const e=this.$.reviewers.focusStart;e.async(()=>e.focus())}else if(e===NC.CCS){const e=this.$.ccs.focusStart;e.async(()=>e.focus())}}_chooseFocusTarget(){return this._account&&this.change&&this.change.owner&&this._account._account_id===this.change.owner._account_id&&(!this._reviewers||0===this._reviewers.length)?NC.REVIEWERS:NC.BODY}_isOwner(e,t){return!!(e&&t&&t.owner)&&e._account_id===t.owner._account_id}_handle400Error(e){if(!e)throw new Error("Reponse is empty.");return this.disabled=!1,this.$.restAPI.getResponseObject(e.clone()).then(t=>{const n=t;if(e&&400===e.status&&n&&n.reviewers){const t=[];Object.values(n.reviewers).forEach(e=>{var n;return t.push(null!==(n=e.error)&&void 0!==n?n:"no explanation")}),e={...e,ok:!1,text:()=>Promise.resolve(t.join(", "))}}this.dispatchEvent(new CustomEvent("server-error",{detail:{response:e},composed:!0,bubbles:!0}))})}_computeHideDraftList(e){return!e||0===e.length}_computeDraftsTitle(e){const t=e?e.length:0;return 0===t?"":1===t?"1 Draft":`${t} Drafts`}_computeMessagePlaceholder(e){return e?"Add a note for your reviewers...":"Say something nice..."}_changeUpdated(e,t){void 0!==e&&void 0!==t&&this._rebuildReviewerArrays(e.base,t)}_rebuildReviewerArrays(e,t){this._owner=t;const n=[],i=[];if(e)for(const o of Object.keys(e))if("REVIEWER"===o||"CC"===o){if(e[o])for(const s of e[o])if(s._account_id!==t._account_id)switch(o){case"REVIEWER":n.push(s);break;case"CC":i.push(s)}}else console.warn("unexpected reviewer state:",o);this._ccs=i,this._reviewers=n}_handleAttentionModify(){this._attentionModified=!0,this.dispatchEvent(new CustomEvent("iron-resize",{composed:!0,bubbles:!0}))}_showAttentionSummary(e,t){return this._isAttentionSetEnabled(e)&&!t}_showAttentionDetails(e,t){return this._isAttentionSetEnabled(e)&&t}_isAttentionSetEnabled(e){return!!e&&!!e.change&&e.change.enable_attention_set}_handleAttentionClick(e){var t,n;const i=null===(n=null===(t=e.target)||void 0===t?void 0:t.account)||void 0===n?void 0:n._account_id;if(!i)return;const o=i===(this._account&&this._account._account_id||-1)?"_SELF":"",s=i===(this.change&&this.change.owner&&this.change.owner._account_id||-1)?"_OWNER":"_REVIEWER";this._newAttentionSet.has(i)?(this._newAttentionSet.delete(i),this.reporting.reportInteraction("attention-set-chip",{action:`REMOVE${o}${s}`})):(this._newAttentionSet.add(i),this.reporting.reportInteraction("attention-set-chip",{action:`ADD${o}${s}`})),this._newAttentionSet=new Set(this._newAttentionSet)}_computeHasNewAttention(e,t){return t&&e&&e._account_id&&t.has(e._account_id)}_computeNewAttention(e,t,n,i,o){if(void 0===e||void 0===e._account_id||void 0===t||void 0===i||void 0===o)return;this._attentionModified=!1,this._currentAttentionSet=new Set(Object.keys(i.attention_set||{}).map(e=>parseInt(e)));const s=new Set(this._currentAttentionSet);i.status===Ia.NEW?(this._computeCommentAccounts(o).forEach(e=>s.add(e)),s.delete(e._account_id),t.base.filter(e=>e._pendingAdd&&e._account_id).forEach(e=>s.add(e._account_id)),this._uploader&&this._uploader._account_id!==e._account_id&&s.add(this._uploader._account_id),i.owner&&(this._isOwner(e,i)&&0!==s.size||s.add(i.owner._account_id))):(i.owner&&this._containsNewCommentThread(o)&&s.add(i.owner._account_id),s.delete(e._account_id));const r=this._allAccounts().map(e=>e._account_id).filter(e=>!!e);this._newAttentionSet=new Set([...s].filter(e=>r.includes(e)))}_computeCommentAccounts(e){const t=new Set;return e.forEach(e=>{e.comments.forEach(e=>{e.author&&t.add(e.author._account_id)})}),t}_containsNewCommentThread(e){return e.some(e=>!!e.comments&&!!e.comments[0]&&Hf(e.comments[0]))}_isNewAttentionEmpty(e,t,n){return 0===this._computeNewAttentionAccounts(e,t,n).length}_computeNewAttentionAccounts(e,t,n){return void 0===t||void 0===n?[]:[...n].filter(e=>!t.has(e)).map(e=>this._findAccountById(e)).filter(e=>!!e)}_findAccountById(e){return this._allAccounts().find(t=>t._account_id===e)}_allAccounts(){let e=[];return this.change&&this.change.owner&&e.push(this.change.owner),this._uploader&&e.push(this._uploader),this._reviewers&&(e=[...e,...this._reviewers]),this._ccs&&(e=[...e,...this._ccs]),uc(e.filter(id))}_removeServiceUsers(e,t){return uc(e)}_computeShowAttentionCcs(e){return uc(e).length>0}_computeUploader(e){if(!(e&&e.current_revision&&e.revisions&&e.revisions[e.current_revision]))return;const t=e.revisions[e.current_revision];return t.uploader&&e.owner._account_id!==t.uploader._account_id?t.uploader:void 0}_accountOrGroupKey(e){return id(e)?hc(e):void 0!==e.id?e.id:void s(e,"entry must be account or group")}_filterReviewerSuggestionGenerator(e){return t=>{var n;let i;if(od(t)){if(i=t.account,i._account_id===(null===(n=this._owner)||void 0===n?void 0:n._account_id))return!1}else{if(!sd(t))return console.warn("received suggestion that was neither account nor group:",t),!1;i=t.group}const o=this._accountOrGroupKey(i),s=e=>this._accountOrGroupKey(e)===o;return e?void 0===this._ccs.find(s):void 0===this._reviewers.find(s)}}_getAccount(){return this.$.restAPI.getAccount()}_cancelTapHandler(e){e.preventDefault(),this.cancel()}cancel(){if(!this.change)throw new Error("missing required change property");if(!this._owner)throw new Error("missing required _owner property");this.dispatchEvent(new CustomEvent("cancel",{composed:!0,bubbles:!1})),this.$.textarea.closeDropdown(),this._purgeReviewersPendingRemove(!0),this._rebuildReviewerArrays(this.change.reviewers,this._owner)}_saveClickHandler(e){e.preventDefault(),this.$.ccs.submitEntryText()&&this.send(this._includeComments,!1).then(e=>{this._purgeReviewersPendingRemove(!1,e)})}_sendTapHandler(e){e.preventDefault(),this._submit()}_submit(){if(this.$.ccs.submitEntryText()){if(!this._sendDisabled)return this.send(this._includeComments,this.canBeStarted).then(e=>{this._purgeReviewersPendingRemove(!1,e)}).catch(e=>{this.dispatchEvent(new CustomEvent("show-error",{bubbles:!0,composed:!0,detail:{message:`Error submitting review ${e}`}}))});this.dispatchEvent(new CustomEvent("show-alert",{bubbles:!0,composed:!0,detail:{message:"Cannot send an empty reply."}}))}}_saveReview(e,t){if(!this.change)throw new Error("missing required change property");if(!this.patchNum)throw new Error("missing required patchNum property");return this.$.restAPI.saveChangeReview(this.change._number,this.patchNum,e,t)}_reviewerPendingConfirmationUpdated(e){null===e?this.$.reviewerConfirmationOverlay.close():(this._pendingConfirmationDetails=this._ccPendingConfirmation||this._reviewerPendingConfirmation,this.$.reviewerConfirmationOverlay.open())}_confirmPendingReviewer(){return this._ccPendingConfirmation?(this.$.ccs.confirmGroup(this._ccPendingConfirmation.group),void this._focusOn(NC.CCS)):this._reviewerPendingConfirmation?(this.$.reviewers.confirmGroup(this._reviewerPendingConfirmation.group),void this._focusOn(NC.REVIEWERS)):void console.error("_confirmPendingReviewer called without pending confirm")}_cancelPendingReviewer(){this._ccPendingConfirmation=null,this._reviewerPendingConfirmation=null;const e=this._ccPendingConfirmation?NC.CCS:NC.REVIEWERS;this._focusOn(e)}_getStorageLocation(){if(!this.change)throw new Error("missing required change property");return{changeNum:this.change._number,patchNum:"@change",path:"@change"}}_loadStoredDraft(){var e;const t=this.$.storage.getDraftComment(this._getStorageLocation());return null!==(e=null==t?void 0:t.message)&&void 0!==e?e:""}_handleAccountTextEntry(){this._reviewersMutated=!0}_draftChanged(e,t){this.debounce("store",()=>{!e.length&&t?this.$.storage.eraseDraftComment(this._getStorageLocation()):e.length&&this.$.storage.setDraftComment(this._getStorageLocation(),this.draft)},400)}_handleHeightChanged(){this.dispatchEvent(new CustomEvent("autogrow",{composed:!0,bubbles:!0}))}_handleLabelsChanged(){this._labelsChanged=0!==Object.keys(this.$.labelScores.getLabelValues()).length}_isState(e,t){return e===t}_reload(){this.dispatchEvent(new CustomEvent("reload",{detail:{clearPatchset:!0},bubbles:!1,composed:!0})),this.cancel()}_computeSendButtonLabel(e){return e?MC+" and "+$C:MC}_computeSendButtonTooltip(e){return e?BC:jC}_computeSavingLabelClass(e){return e?"saving":""}_computeSendButtonDisabled(e,t,n,i,o,s,r,a,l){if(void 0===e||void 0===t||void 0===n||void 0===i||void 0===o||void 0===s||void 0===r||void 0===a||void 0===l)return;if(a||r)return!0;if(!0===e)return!1;return!(s&&t.length||n.length||i||o||l)}_computePatchSetWarning(e,t){let n=`Patch ${e} is not latest.`;return t&&(n+=" Voting will have no effect."),n}setPluginMessage(e){this._pluginMessage=e}_sendDisabledChanged(){this.dispatchEvent(new CustomEvent("send-disabled-changed"))}_getReviewerSuggestionsProvider(e){const t=ad.create(this.$.restAPI,e._number,rd.REVIEWER);return t.init(),t}_getCcSuggestionsProvider(e){const t=ad.create(this.$.restAPI,e._number,rd.CC);return t.init(),t}_onThreadListModified(){this.dispatchEvent(new CustomEvent("comment-refresh",{composed:!0,bubbles:!0}))}reportAttentionSetChanges(e,t,n){const i=e?["MODIFIED"]:["NOT_MODIFIED"],o=this.change&&this.change.owner&&this.change.owner._account_id||-1,s=this._account&&this._account._account_id||-1;for(const e of t||[]){const t=e.user,n=t===s?"_SELF":"",r=t===o?"_OWNER":"_REVIEWER";i.push("ADD"+n+r)}for(const e of n||[]){const t=e.user,n=t===s?"_SELF":"",r=t===o?"_OWNER":"_REVIEWER";i.push("REMOVE"+n+r)}this.reporting.reportInteraction("attention-set-actions",{actions:i})}_computeAllReviewers(){return[...this._reviewers]}};OC([Bl({type:Object})],UC.prototype,"change",void 0),OC([Bl({type:String})],UC.prototype,"patchNum",void 0),OC([Bl({type:Boolean})],UC.prototype,"canBeStarted",void 0),OC([Bl({type:Boolean,reflectToAttribute:!0})],UC.prototype,"disabled",void 0),OC([Bl({type:String,observer:"_draftChanged"})],UC.prototype,"draft",void 0),OC([Bl({type:String})],UC.prototype,"quote",void 0),OC([Bl({type:Object})],UC.prototype,"filterReviewerSuggestion",void 0),OC([Bl({type:Object})],UC.prototype,"filterCCSuggestion",void 0),OC([Bl({type:Object})],UC.prototype,"permittedLabels",void 0),OC([Bl({type:Object})],UC.prototype,"projectConfig",void 0),OC([Bl({type:Object})],UC.prototype,"serverConfig",void 0),OC([Bl({type:String})],UC.prototype,"knownLatestState",void 0),OC([Bl({type:Boolean})],UC.prototype,"underReview",void 0),OC([Bl({type:Object})],UC.prototype,"_account",void 0),OC([Bl({type:Array})],UC.prototype,"_ccs",void 0),OC([Bl({type:Object,observer:"_reviewerPendingConfirmationUpdated"})],UC.prototype,"_ccPendingConfirmation",void 0),OC([Bl({type:String,computed:"_computeMessagePlaceholder(canBeStarted)"})],UC.prototype,"_messagePlaceholder",void 0),OC([Bl({type:Object})],UC.prototype,"_owner",void 0),OC([Bl({type:Object,computed:"_computeUploader(change)"})],UC.prototype,"_uploader",void 0),OC([Bl({type:Object})],UC.prototype,"_pendingConfirmationDetails",void 0),OC([Bl({type:Boolean})],UC.prototype,"_includeComments",void 0),OC([Bl({type:Array})],UC.prototype,"_reviewers",void 0),OC([Bl({type:Object,observer:"_reviewerPendingConfirmationUpdated"})],UC.prototype,"_reviewerPendingConfirmation",void 0),OC([Bl({type:Boolean,observer:"_handleHeightChanged"})],UC.prototype,"_previewFormatting",void 0),OC([Bl({type:Object})],UC.prototype,"_reviewersPendingRemove",void 0),OC([Bl({type:String,computed:"_computeSendButtonLabel(canBeStarted)"})],UC.prototype,"_sendButtonLabel",void 0),OC([Bl({type:Boolean})],UC.prototype,"_savingComments",void 0),OC([Bl({type:Boolean})],UC.prototype,"_reviewersMutated",void 0),OC([Bl({type:Boolean})],UC.prototype,"_labelsChanged",void 0),OC([Bl({type:String,readOnly:!0})],UC.prototype,"_saveTooltip",void 0),OC([Bl({type:String})],UC.prototype,"_pluginMessage",void 0),OC([Bl({type:Boolean})],UC.prototype,"_commentEditing",void 0),OC([Bl({type:Boolean})],UC.prototype,"_attentionModified",void 0),OC([Bl({type:Object})],UC.prototype,"_currentAttentionSet",void 0),OC([Bl({type:Object})],UC.prototype,"_newAttentionSet",void 0),OC([Bl({type:Boolean,computed:"_computeSendButtonDisabled(canBeStarted, draftCommentThreads, draft, _reviewersMutated, _labelsChanged, _includeComments, disabled, _commentEditing, _attentionModified)",observer:"_sendDisabledChanged"})],UC.prototype,"_sendDisabled",void 0),OC([Bl({type:Array,observer:"_handleHeightChanged"})],UC.prototype,"draftCommentThreads",void 0),OC([Bl({type:Boolean})],UC.prototype,"_isResolvedPatchsetLevelComment",void 0),OC([Bl({type:Array,computed:"_computeAllReviewers(_reviewers.*)"})],UC.prototype,"_allReviewers",void 0),OC([jl("_ccs.splices")],UC.prototype,"_ccsChanged",null),OC([jl("_reviewers.splices")],UC.prototype,"_reviewersChanged",null),OC([jl("change.reviewers.*","change.owner")],UC.prototype,"_changeUpdated",null),OC([jl("_account","_reviewers.*","_ccs.*","change","draftCommentThreads")],UC.prototype,"_computeNewAttention",null),UC=OC([Ml("gr-reply-dialog")],UC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const GC=ta`
  <style include="shared-styles">
    :host {
      background-color: var(--dialog-background-color);
      display: block;
    }
    .main {
      width: 100%;
    }
    ol {
      margin-left: var(--spacing-xl);
      list-style: decimal;
    }
    p {
      margin-bottom: var(--spacing-m);
    }
  </style>
  <gr-dialog confirm-label="Done" cancel-label="" on-confirm="_handleCloseTap">
    <div class="header" slot="header">How to update this change:</div>
    <div class="main" slot="main">
      <ol>
        <li>
          <p>
            Checkout this change locally and make your desired modifications to
            the files.
          </p>
          <template is="dom-if" if="[[_fetchCommand]]">
            <gr-shell-command command="[[_fetchCommand]]"></gr-shell-command>
          </template>
        </li>
        <li>
          <p>
            Update the local commit with your modifications using the following
            command.
          </p>
          <gr-shell-command command="[[_commitCommand]]"></gr-shell-command>
          <p>
            Leave the "Change-Id:" line of the commit message as is.
          </p>
        </li>
        <li>
          <p>Push the updated commit to Gerrit.</p>
          <gr-shell-command command="[[_pushCommand]]"></gr-shell-command>
        </li>
        <li>
          <p>Refresh this page to view the the update.</p>
        </li>
      </ol>
    </div>
  </gr-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var VC=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const zC=["checkout","cherry pick","pull"];let WC=class extends(oo(dr(oa))){constructor(){super(...arguments),this._commitCommand="git add . && git commit --amend --no-edit"}static get template(){return GC}attached(){super.attached(),this.$.restAPI.getLoggedIn().then(e=>e?this.$.restAPI.getPreferences():Promise.resolve(void 0)).then(e=>{e&&(this._preferredDownloadScheme=e.download_scheme)})}_handleCloseTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("close",{composed:!0,bubbles:!1}))}_computeFetchCommand(e,t){if(!e||!e.fetch)return;if(!t){const n=Object.keys(e.fetch).sort();if(0===n.length)return;t=n[0]}if(!t||!e.fetch[t]||!e.fetch[t].commands)return;const n={};Object.entries(e.fetch[t].commands).forEach(([e,t])=>{n[e.toLowerCase()]=t});for(let e=0;e<zC.length;e++)if(n[zC[e]])return n[zC[e]]}_computePushCommand(e){return"git push origin HEAD:refs/for/"+e}};VC([Bl({type:Object})],WC.prototype,"revision",void 0),VC([Bl({type:String})],WC.prototype,"targetBranch",void 0),VC([Bl({type:String})],WC.prototype,"_commitCommand",void 0),VC([Bl({type:String,computed:"_computeFetchCommand(revision, _preferredDownloadScheme)"})],WC.prototype,"_fetchCommand",void 0),VC([Bl({type:String})],WC.prototype,"_preferredDownloadScheme",void 0),VC([Bl({type:String,computed:"_computePushCommand(targetBranch)"})],WC.prototype,"_pushCommand",void 0),WC=VC([Ml("gr-upload-help-dialog")],WC);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const qC=ta`
  <style include="shared-styles">
    .container:not(.loading) {
      background-color: var(--background-color-tertiary);
    }
    .container.loading {
      color: var(--deemphasized-text-color);
      padding: var(--spacing-l);
    }
    .header {
      align-items: center;
      background-color: var(--background-color-primary);
      border-bottom: 1px solid var(--border-color);
      display: flex;
      padding: var(--spacing-s) var(--spacing-l);
      z-index: 99; /* Less than gr-overlay's backdrop */
    }
    .header.editMode {
      background-color: var(--edit-mode-background-color);
    }
    .header .download {
      margin-right: var(--spacing-l);
    }
    gr-change-status {
      display: initial;
      margin-left: var(--spacing-s);
    }
    gr-change-status:first-child {
      margin-left: 0;
    }
    .headerTitle {
      align-items: center;
      display: flex;
      flex: 1;
    }
    .headerSubject {
      font-family: var(--header-font-family);
      font-size: var(--font-size-h3);
      font-weight: var(--font-weight-h3);
      line-height: var(--line-height-h3);
      margin-left: var(--spacing-l);
    }
    .changeNumberColon {
      color: transparent;
    }
    .changeCopyClipboard {
      margin-left: var(--spacing-s);
    }
    #replyBtn {
      margin-bottom: var(--spacing-l);
    }
    gr-change-star {
      margin-left: var(--spacing-s);
      --gr-change-star-size: var(--line-height-normal);
    }
    a.changeNumber {
      margin-left: var(--spacing-xs);
    }
    gr-reply-dialog {
      width: 60em;
    }
    .changeStatus {
      text-transform: capitalize;
    }
    /* Strong specificity here is needed due to
         https://github.com/Polymer/polymer/issues/2531 */
    .container .changeInfo {
      display: flex;
      background-color: var(--background-color-secondary);
      padding-right: var(--spacing-m);
    }
    section {
      background-color: var(--view-background-color);
      box-shadow: var(--elevation-level-1);
    }
    .changeId {
      color: var(--deemphasized-text-color);
      font-family: var(--font-family);
      margin-top: var(--spacing-l);
    }
    .changeMetadata {
      /* Limit meta section to half of the screen at max */
      max-width: 50%;
    }
    .commitMessage {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      margin-right: var(--spacing-l);
      margin-bottom: var(--spacing-l);
      /* Account for border and padding and rounding errors. */
      max-width: calc(72ch + 2px + 2 * var(--spacing-m) + 0.4px);
    }
    .commitMessage gr-linked-text {
      word-break: break-word;
    }
    #commitMessageEditor {
      /* Account for border and padding and rounding errors. */
      min-width: calc(72ch + 2px + 2 * var(--spacing-m) + 0.4px);
    }
    .editCommitMessage {
      margin-top: var(--spacing-l);

      --gr-button: {
        padding: 5px 0px;
      }
    }
    .changeStatuses,
    .commitActions,
    .statusText {
      align-items: center;
      display: flex;
    }
    .changeStatuses {
      flex-wrap: wrap;
    }
    .mainChangeInfo {
      display: flex;
      flex: 1;
      flex-direction: column;
      min-width: 0;
    }
    #commitAndRelated {
      align-content: flex-start;
      display: flex;
      flex: 1;
      overflow-x: hidden;
    }
    .relatedChanges {
      flex: 1 1 auto;
      overflow: hidden;
      padding: var(--spacing-l) 0;
    }
    .mobile {
      display: none;
    }
    .warning {
      color: var(--error-text-color);
    }
    hr {
      border: 0;
      border-top: 1px solid var(--border-color);
      height: 0;
      margin-bottom: var(--spacing-l);
    }
    #relatedChanges.collapsed {
      margin-bottom: var(--spacing-l);
      max-height: var(--relation-chain-max-height, 2em);
      overflow: hidden;
      position: relative; /* for arrowToCurrentChange to have position:absolute and be hidden */
    }
    .commitContainer {
      display: flex;
      flex-direction: column;
      flex-shrink: 0;
      margin: var(--spacing-l) 0;
      padding: 0 var(--spacing-l);
    }
    .collapseToggleContainer {
      display: flex;
      margin-bottom: 8px;
    }
    #relatedChangesToggle {
      display: none;
    }
    #relatedChangesToggle.showToggle {
      display: flex;
    }
    .collapseToggleContainer gr-button {
      display: block;
    }
    #relatedChangesToggle {
      margin-left: var(--spacing-l);
      padding-top: var(--related-change-btn-top-padding, 0);
    }
    .showOnEdit {
      display: none;
    }
    .scrollable {
      overflow: auto;
    }
    .text {
      white-space: pre;
    }
    gr-commit-info {
      display: inline-block;
    }
    paper-tabs {
      background-color: var(--background-color-tertiary);
      margin-top: var(--spacing-m);
      height: calc(var(--line-height-h3) + var(--spacing-m));
      --paper-tabs-selection-bar-color: var(--link-color);
    }
    paper-tab {
      box-sizing: border-box;
      max-width: 12em;
      --paper-tab-ink: var(--link-color);
    }
    gr-thread-list,
    gr-messages-list {
      display: block;
    }
    gr-thread-list {
      min-height: 250px;
    }
    #includedInOverlay {
      width: 65em;
    }
    #uploadHelpOverlay {
      width: 50em;
    }
    #metadata {
      --metadata-horizontal-padding: var(--spacing-l);
      padding-top: var(--spacing-l);
      width: 100%;
    }
    /* NOTE: If you update this breakpoint, also update the
      BREAKPOINT_RELATED_MED in the JS */
    @media screen and (max-width: 75em) {
      .relatedChanges {
        padding: 0;
      }
      #relatedChanges {
        padding-top: var(--spacing-l);
      }
      #commitAndRelated {
        flex-direction: column;
        flex-wrap: nowrap;
      }
      #commitMessageEditor {
        min-width: 0;
      }
      .commitMessage {
        margin-right: 0;
      }
      .mainChangeInfo {
        padding-right: 0;
      }
    }
    /* NOTE: If you update this breakpoint, also update the
      BREAKPOINT_RELATED_SMALL in the JS */
    @media screen and (max-width: 50em) {
      .mobile {
        display: block;
      }
      .header {
        align-items: flex-start;
        flex-direction: column;
        flex: 1;
        padding: var(--spacing-s) var(--spacing-l);
      }
      gr-change-star {
        vertical-align: middle;
      }
      .headerTitle {
        flex-wrap: wrap;
        font-family: var(--header-font-family);
        font-size: var(--font-size-h3);
        font-weight: var(--font-weight-h3);
        line-height: var(--line-height-h3);
      }
      .desktop {
        display: none;
      }
      .reply {
        display: block;
        margin-right: 0;
        /* px because don't have the same font size */
        margin-bottom: 6px;
      }
      .changeInfo-column:not(:last-of-type) {
        margin-right: 0;
        padding-right: 0;
      }
      .changeInfo,
      #commitAndRelated {
        flex-direction: column;
        flex-wrap: nowrap;
      }
      .commitContainer {
        margin: 0;
        padding: var(--spacing-l);
      }
      .changeMetadata {
        margin-top: var(--spacing-xs);
        max-width: none;
      }
      #metadata,
      .mainChangeInfo {
        padding: 0;
      }
      .commitActions {
        display: block;
        margin-top: var(--spacing-l);
        width: 100%;
      }
      .commitMessage {
        flex: initial;
        margin: 0;
      }
      /* Change actions are the only thing thant need to remain visible due
        to the fact that they may have the currently visible overlay open. */
      #mainContent.overlayOpen .hideOnMobileOverlay {
        display: none;
      }
      gr-reply-dialog {
        height: 100vh;
        min-width: initial;
        width: 100vw;
      }
      #replyOverlay {
        z-index: var(--reply-overlay-z-index);
      }
    }
    .patch-set-dropdown {
      margin: var(--spacing-m) 0 0 var(--spacing-m);
    }
    .show-robot-comments {
      margin: var(--spacing-m);
    }
  </style>
  <div class="container loading" hidden$="[[!_loading]]">Loading...</div>
  <!-- TODO(taoalpha): remove on-show-checks-table,
    Gerrit should not have any thing too special for a plugin,
    replace with a generic event: show-primary-tab. -->
  <div
    id="mainContent"
    class="container"
    on-show-checks-table="_setActivePrimaryTab"
    hidden$="{{_loading}}"
  >
    <section class="changeInfoSection">
      <div class$="[[_computeHeaderClass(_editMode)]]">
        <div class="headerTitle">
          <div class="changeStatuses">
            <template is="dom-repeat" items="[[_changeStatuses]]" as="status">
              <gr-change-status
                max-width="100"
                status="[[status]]"
              ></gr-change-status>
            </template>
          </div>
          <div class="statusText">
            <template
              is="dom-if"
              if="[[_computeShowCommitInfo(_changeStatus, _change.current_revision)]]"
            >
              <span class="text"> as </span>
              <gr-commit-info
                change="[[_change]]"
                commit-info="[[_computeMergedCommitInfo(_change.current_revision, _change.revisions)]]"
                server-config="[[_serverConfig]]"
              ></gr-commit-info>
            </template>
          </div>
          <gr-change-star
            id="changeStar"
            change="{{_change}}"
            on-toggle-star="_handleToggleStar"
            hidden$="[[!_loggedIn]]"
          ></gr-change-star>

          <a
            class="changeNumber"
            aria-label$="[[_computeChangePermalinkAriaLabel(_change._number)]]"
            href$="[[_computeChangeUrl(_change)]]"
            >[[_change._number]]</a
          >
          <span class="changeNumberColon">:&nbsp;</span>
          <span class="headerSubject">[[_change.subject]]</span>
          <gr-copy-clipboard
            class="changeCopyClipboard"
            hide-input=""
            text="[[_computeCopyTextForTitle(_change)]]"
          >
          </gr-copy-clipboard>
        </div>
        <!-- end headerTitle -->
        <div class="commitActions" hidden$="[[!_loggedIn]]">
          <gr-change-actions
            id="actions"
            change="[[_change]]"
            disable-edit="[[disableEdit]]"
            has-parent="[[hasParent]]"
            actions="[[_change.actions]]"
            revision-actions="{{_currentRevisionActions}}"
            change-num="[[_changeNum]]"
            change-status="[[_change.status]]"
            commit-num="[[_commitInfo.commit]]"
            latest-patch-num="[[_computeLatestPatchNum(_allPatchSets)]]"
            commit-message="[[_latestCommitMessage]]"
            edit-patchset-loaded="[[_hasEditPatchsetLoaded(_patchRange.*)]]"
            edit-mode="[[_editMode]]"
            edit-based-on-current-patch-set="[[_hasEditBasedOnCurrentPatchSet(_allPatchSets)]]"
            private-by-default="[[_projectConfig.private_by_default]]"
            on-edit-tap="_handleEditTap"
            on-stop-edit-tap="_handleStopEditTap"
            on-download-tap="_handleOpenDownloadDialog"
          ></gr-change-actions>
        </div>
        <!-- end commit actions -->
      </div>
      <!-- end header -->
      <div class="changeInfo">
        <div class="changeInfo-column changeMetadata hideOnMobileOverlay">
          <gr-change-metadata
            id="metadata"
            change="{{_change}}"
            account="[[_account]]"
            revision="[[_selectedRevision]]"
            commit-info="[[_commitInfo]]"
            server-config="[[_serverConfig]]"
            parent-is-current="[[_parentIsCurrent]]"
            on-show-reply-dialog="_handleShowReplyDialog"
          >
          </gr-change-metadata>
        </div>
        <div id="mainChangeInfo" class="changeInfo-column mainChangeInfo">
          <div id="commitAndRelated" class="hideOnMobileOverlay">
            <div class="commitContainer">
              <div>
                <gr-button
                  id="replyBtn"
                  class="reply"
                  title="[[createTitle(Shortcut.OPEN_REPLY_DIALOG,
                        ShortcutSection.ACTIONS)]]"
                  hidden$="[[!_loggedIn]]"
                  primary=""
                  disabled="[[_replyDisabled]]"
                  on-click="_handleReplyTap"
                  >[[_replyButtonLabel]]</gr-button
                >
              </div>
              <div id="commitMessage" class="commitMessage">
                <gr-editable-content
                  id="commitMessageEditor"
                  editing="[[_editingCommitMessage]]"
                  content="{{_latestCommitMessage}}"
                  storage-key="[[_computeCommitMessageKey(_change._number, _change.current_revision)]]"
                  remove-zero-width-space=""
                  collapsed$="[[_computeCommitMessageCollapsed(_commitCollapsed, _commitCollapsible)]]"
                >
                  <gr-linked-text
                    pre=""
                    content="[[_latestCommitMessage]]"
                    config="[[_projectConfig.commentlinks]]"
                    remove-zero-width-space=""
                  ></gr-linked-text>
                </gr-editable-content>
                <gr-button
                  link=""
                  class="editCommitMessage"
                  title="Edit commit message"
                  on-click="_handleEditCommitMessage"
                  hidden$="[[_hideEditCommitMessage]]"
                  >Edit</gr-button
                >
                <div
                  class="changeId"
                  hidden$="[[!_changeIdCommitMessageError]]"
                >
                  <hr />
                  Change-Id:
                  <span
                    class$="[[_computeChangeIdClass(_changeIdCommitMessageError)]]"
                    title$="[[_computeTitleAttributeWarning(_changeIdCommitMessageError)]]"
                  >
                    [[_change.change_id]]
                  </span>
                </div>
              </div>
              <div
                id="commitCollapseToggle"
                class="collapseToggleContainer"
                hidden$="[[!_commitCollapsible]]"
              >
                <gr-button
                  link=""
                  id="commitCollapseToggleButton"
                  class="collapseToggleButton"
                  on-click="_toggleCommitCollapsed"
                >
                  [[_computeCollapseText(_commitCollapsed)]]
                </gr-button>
              </div>
              <gr-endpoint-decorator name="commit-container">
                <gr-endpoint-param name="change" value="[[_change]]">
                </gr-endpoint-param>
                <gr-endpoint-param
                  name="revision"
                  value="[[_selectedRevision]]"
                >
                </gr-endpoint-param>
              </gr-endpoint-decorator>
            </div>
            <div class="relatedChanges">
              <gr-related-changes-list
                id="relatedChanges"
                class$="[[_computeRelatedChangesClass(_relatedChangesCollapsed)]]"
                change="[[_change]]"
                mergeable="[[_mergeable]]"
                has-parent="{{hasParent}}"
                on-update="_updateRelatedChangeMaxHeight"
                patch-num="[[_computeLatestPatchNum(_allPatchSets)]]"
                on-new-section-loaded="_computeShowRelatedToggle"
              >
              </gr-related-changes-list>
              <div id="relatedChangesToggle" class="collapseToggleContainer">
                <gr-button
                  link=""
                  id="relatedChangesToggleButton"
                  class="collapseToggleButton"
                  on-click="_toggleRelatedChangesCollapsed"
                >
                  [[_computeCollapseText(_relatedChangesCollapsed)]]
                </gr-button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>

    <paper-tabs id="primaryTabs" on-selected-changed="_setActivePrimaryTab">
      <paper-tab data-name$="[[_constants.PrimaryTab.FILES]]">Files</paper-tab>
      <paper-tab
        data-name$="[[_constants.PrimaryTab.COMMENT_THREADS]]"
        class="commentThreads"
      >
        <gr-tooltip-content
          has-tooltip=""
          title$="[[_computeTotalCommentCounts(_change.unresolved_comment_count, _changeComments)]]"
        >
          <span>Comments</span></gr-tooltip-content
        >
      </paper-tab>
      <template
        is="dom-repeat"
        items="[[_dynamicTabHeaderEndpoints]]"
        as="tabHeader"
      >
        <paper-tab data-name$="[[tabHeader]]">
          <gr-endpoint-decorator name$="[[tabHeader]]">
            <gr-endpoint-param name="change" value="[[_change]]">
            </gr-endpoint-param>
            <gr-endpoint-param name="revision" value="[[_selectedRevision]]">
            </gr-endpoint-param>
          </gr-endpoint-decorator>
        </paper-tab>
      </template>
      <paper-tab data-name$="[[_constants.PrimaryTab.FINDINGS]]">
        Findings
      </paper-tab>
    </paper-tabs>

    <section class="patchInfo">
      <div
        hidden$="[[!_isTabActive(_constants.PrimaryTab.FILES, _activeTabs)]]"
      >
        <gr-file-list-header
          id="fileListHeader"
          account="[[_account]]"
          all-patch-sets="[[_allPatchSets]]"
          change="[[_change]]"
          change-num="[[_changeNum]]"
          revision-info="[[_revisionInfo]]"
          change-comments="[[_changeComments]]"
          commit-info="[[_commitInfo]]"
          change-url="[[_computeChangeUrl(_change)]]"
          edit-mode="[[_editMode]]"
          logged-in="[[_loggedIn]]"
          server-config="[[_serverConfig]]"
          shown-file-count="[[_shownFileCount]]"
          diff-prefs="[[_diffPrefs]]"
          diff-view-mode="{{viewState.diffMode}}"
          patch-num="{{_patchRange.patchNum}}"
          base-patch-num="{{_patchRange.basePatchNum}}"
          files-expanded="[[_filesExpanded]]"
          diff-prefs-disabled="[[_diffPrefsDisabled]]"
          on-open-diff-prefs="_handleOpenDiffPrefs"
          on-open-download-dialog="_handleOpenDownloadDialog"
          on-open-upload-help-dialog="_handleOpenUploadHelpDialog"
          on-open-included-in-dialog="_handleOpenIncludedInDialog"
          on-expand-diffs="_expandAllDiffs"
          on-collapse-diffs="_collapseAllDiffs"
        >
        </gr-file-list-header>
        <gr-file-list
          id="fileList"
          class="hideOnMobileOverlay"
          diff-prefs="{{_diffPrefs}}"
          change="[[_change]]"
          change-num="[[_changeNum]]"
          patch-range="{{_patchRange}}"
          change-comments="[[_changeComments]]"
          drafts="[[_diffDrafts]]"
          revisions="[[_change.revisions]]"
          project-config="[[_projectConfig]]"
          selected-index="{{viewState.selectedFileIndex}}"
          diff-view-mode="[[viewState.diffMode]]"
          edit-mode="[[_editMode]]"
          num-files-shown="{{_numFilesShown}}"
          files-expanded="{{_filesExpanded}}"
          file-list-increment="{{_numFilesShown}}"
          on-files-shown-changed="_setShownFiles"
          on-file-action-tap="_handleFileActionTap"
          on-reload-drafts="_reloadDraftsWithCallback"
        >
        </gr-file-list>
      </div>
      <template
        is="dom-if"
        if="[[_isTabActive(_constants.PrimaryTab.COMMENT_THREADS, _activeTabs)]]"
      >
        <gr-thread-list
          threads="[[_commentThreads]]"
          change="[[_change]]"
          change-num="[[_changeNum]]"
          logged-in="[[_loggedIn]]"
          only-show-robot-comments-with-human-reply=""
          on-thread-list-modified="_handleReloadDiffComments"
        ></gr-thread-list>
      </template>
      <template
        is="dom-if"
        if="[[_isTabActive(_constants.PrimaryTab.FINDINGS, _activeTabs)]]"
      >
        <gr-dropdown-list
          class="patch-set-dropdown"
          items="[[_robotCommentsPatchSetDropdownItems]]"
          on-value-change="_handleRobotCommentPatchSetChanged"
          value="[[_currentRobotCommentsPatchSet]]"
        >
        </gr-dropdown-list>
        <gr-thread-list
          threads="[[_robotCommentThreads]]"
          change="[[_change]]"
          change-num="[[_changeNum]]"
          logged-in="[[_loggedIn]]"
          hide-toggle-buttons
          empty-thread-msg="[[_messages.NO_ROBOT_COMMENTS_THREADS_MSG]]"
          on-thread-list-modified="_handleReloadDiffComments"
        >
        </gr-thread-list>
        <template is="dom-if" if="[[_showRobotCommentsButton]]">
          <gr-button
            class="show-robot-comments"
            on-click="_toggleShowRobotComments"
          >
            [[_computeShowText(_showAllRobotComments)]]
          </gr-button>
        </template>
      </template>

      <template
        is="dom-if"
        if="[[_isTabActive(_selectedTabPluginHeader, _activeTabs)]]"
      >
        <gr-endpoint-decorator name$="[[_selectedTabPluginEndpoint]]">
          <gr-endpoint-param name="change" value="[[_change]]">
          </gr-endpoint-param>
          <gr-endpoint-param name="revision" value="[[_selectedRevision]]">
          </gr-endpoint-param>
        </gr-endpoint-decorator>
      </template>
    </section>

    <gr-endpoint-decorator name="change-view-integration">
      <gr-endpoint-param name="change" value="[[_change]]"> </gr-endpoint-param>
      <gr-endpoint-param name="revision" value="[[_selectedRevision]]">
      </gr-endpoint-param>
    </gr-endpoint-decorator>

    <paper-tabs id="secondaryTabs" on-selected-changed="_setActiveSecondaryTab">
      <paper-tab
        data-name$="[[_constants.SecondaryTab.CHANGE_LOG]]"
        class="changeLog"
      >
        Change Log
      </paper-tab>
    </paper-tabs>
    <section class="changeLog">
      <template
        is="dom-if"
        if="[[_isTabActive(_constants.SecondaryTab.CHANGE_LOG, _activeTabs)]]"
      >
        <gr-messages-list
          class="hideOnMobileOverlay"
          change="[[_change]]"
          change-num="[[_changeNum]]"
          labels="[[_change.labels]]"
          messages="[[_change.messages]]"
          reviewer-updates="[[_change.reviewer_updates]]"
          change-comments="[[_changeComments]]"
          project-name="[[_change.project]]"
          show-reply-buttons="[[_loggedIn]]"
          on-message-anchor-tap="_handleMessageAnchorTap"
          on-reply="_handleMessageReply"
        ></gr-messages-list>
      </template>
    </section>
  </div>

  <gr-apply-fix-dialog
    id="applyFixDialog"
    prefs="[[_diffPrefs]]"
    change="[[_change]]"
    change-num="[[_changeNum]]"
  ></gr-apply-fix-dialog>
  <gr-overlay id="downloadOverlay" with-backdrop="">
    <gr-download-dialog
      id="downloadDialog"
      change="[[_change]]"
      patch-num="[[_patchRange.patchNum]]"
      config="[[_serverConfig.download]]"
      on-close="_handleDownloadDialogClose"
    ></gr-download-dialog>
  </gr-overlay>
  <gr-overlay id="uploadHelpOverlay" with-backdrop="">
    <gr-upload-help-dialog
      revision="[[_currentRevision]]"
      target-branch="[[_change.branch]]"
      on-close="_handleCloseUploadHelpDialog"
    ></gr-upload-help-dialog>
  </gr-overlay>
  <gr-overlay id="includedInOverlay" with-backdrop="">
    <gr-included-in-dialog
      id="includedInDialog"
      change-num="[[_changeNum]]"
      on-close="_handleIncludedInDialogClose"
    ></gr-included-in-dialog>
  </gr-overlay>
  <gr-overlay
    id="replyOverlay"
    class="scrollable"
    no-cancel-on-outside-click=""
    no-cancel-on-esc-key=""
    scroll-action="lock"
    with-backdrop=""
  >
    <gr-reply-dialog
      id="replyDialog"
      change="{{_change}}"
      patch-num="[[_computeLatestPatchNum(_allPatchSets)]]"
      permitted-labels="[[_change.permitted_labels]]"
      draft-comment-threads="[[_draftCommentThreads]]"
      project-config="[[_projectConfig]]"
      server-config="[[_serverConfig]]"
      can-be-started="[[_canStartReview]]"
      on-send="_handleReplySent"
      on-cancel="_handleReplyCancel"
      on-autogrow="_handleReplyAutogrow"
      on-send-disabled-changed="_resetReplyOverlayFocusStops"
      hidden$="[[!_loggedIn]]"
    >
    </gr-reply-dialog>
  </gr-overlay>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-comment-api id="commentAPI"></gr-comment-api>
`
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,KC="mismatch",YC="missing",XC=/^(Change-Id\:\s|Link:.*\/id\/)(I[0-9a-f]{8,40})/gm,JC=/^(R|CC)=/gm,ZC=/[ \t]+$/gm,QC="A newer patch set has been uploaded",eE="This change has been restored",tE="This change has been abandoned",nE="This change has been merged",iE="There are new messages on this change",oE="SIDE_BY_SIDE",sE="UNIFIED_DIFF";class rE extends(xp(oo(dr(oa)))){static get template(){return qC}static get is(){return"gr-change-view"}static get properties(){return{params:{type:Object,observer:"_paramsChanged"},viewState:{type:Object,notify:!0,value:()=>({}),observer:"_viewStateChanged"},backPage:String,hasParent:Boolean,keyEventTarget:{type:Object,value:()=>document.body},disableEdit:{type:Boolean,value:!1},disableDiffPrefs:{type:Boolean,value:!1},_diffPrefsDisabled:{type:Boolean,computed:"_computeDiffPrefsDisabled(disableDiffPrefs, _loggedIn)"},_commentThreads:Array,_draftCommentThreads:{type:Array},_robotCommentThreads:{type:Array,computed:"_computeRobotCommentThreads(_commentThreads, _currentRobotCommentsPatchSet, _showAllRobotComments)"},_serverConfig:{type:Object,observer:"_startUpdateCheckTimer"},_diffPrefs:Object,_numFilesShown:{type:Number,value:200,observer:"_numFilesShownChanged"},_account:{type:Object,value:{}},_prefs:Object,_changeComments:Object,_canStartReview:{type:Boolean,computed:"_computeCanStartReview(_change)"},_change:{type:Object,observer:"_changeChanged"},_revisionInfo:{type:Object,computed:"_getRevisionInfo(_change)"},_commitInfo:Object,_currentRevision:{type:Object,computed:"_computeCurrentRevision(_change.current_revision, _change.revisions)",observer:"_handleCurrentRevisionUpdate"},_files:Object,_changeNum:String,_diffDrafts:{type:Object,value:()=>({})},_editingCommitMessage:{type:Boolean,value:!1},_hideEditCommitMessage:{type:Boolean,computed:"_computeHideEditCommitMessage(_loggedIn, _editingCommitMessage, _change, _editMode, _commitCollapsed, _commitCollapsible)"},_diffAgainst:String,_latestCommitMessage:{type:String,value:""},_constants:{type:Object,value:{SecondaryTab:Pa,PrimaryTab:xa}},_messages:{type:Object,value:{NO_ROBOT_COMMENTS_THREADS_MSG:"There are no findings for this patchset."}},_lineHeight:Number,_changeIdCommitMessageError:{type:String,computed:"_computeChangeIdCommitMessageError(_latestCommitMessage, _change)"},_patchRange:{type:Object},_filesExpanded:String,_basePatchNum:String,_selectedRevision:Object,_currentRevisionActions:Object,_allPatchSets:{type:Array,computed:"_computeAllPatchSets(_change, _change.revisions.*)"},_loggedIn:{type:Boolean,value:!1},_loading:Boolean,_projectConfig:Object,_replyButtonLabel:{type:String,value:"Reply",computed:"_computeReplyButtonLabel(_diffDrafts.*, _canStartReview)"},_selectedPatchSet:String,_shownFileCount:Number,_initialLoadComplete:{type:Boolean,value:!1},_replyDisabled:{type:Boolean,value:!0,computed:"_computeReplyDisabled(_serverConfig)"},_changeStatus:{type:String,computed:"_changeStatusString(_change)"},_changeStatuses:{type:String,computed:"_computeChangeStatusChips(_change, _mergeable, _submitEnabled)"},_commitCollapsed:{type:Boolean,value:!0},_commitCollapsible:{type:Boolean,computed:"_computeCommitCollapsible(_latestCommitMessage)"},_relatedChangesCollapsed:{type:Boolean,value:!0},_updateCheckTimerHandle:Number,_editMode:{type:Boolean,computed:"_computeEditMode(_patchRange.*, params.*)"},_showRelatedToggle:{type:Boolean,value:!1,observer:"_updateToggleContainerClass"},_parentIsCurrent:{type:Boolean,computed:"_isParentCurrent(_currentRevisionActions)"},_submitEnabled:{type:Boolean,computed:"_isSubmitEnabled(_currentRevisionActions)"},_mergeable:{type:Boolean,value:void 0},_showFileTabContent:{type:Boolean,value:!0},_dynamicTabHeaderEndpoints:{type:Array},_dynamicTabContentEndpoints:{type:Array},_selectedTabPluginEndpoint:{type:String},_selectedTabPluginHeader:{type:String},_robotCommentsPatchSetDropdownItems:{type:Array,value:()=>[],computed:"_computeRobotCommentsPatchSetDropdownItems(_change, _commentThreads)"},_currentRobotCommentsPatchSet:{type:Number},_activeTabs:{type:Array,value:[xa.FILES,Pa.CHANGE_LOG]},_showAllRobotComments:{type:Boolean,value:!1},_showRobotCommentsButton:{type:Boolean,value:!1}}}static get observers(){return["_labelsChanged(_change.labels.*)","_paramsAndChangeChanged(params, _change)","_patchNumChanged(_patchRange.patchNum)"]}keyboardShortcuts(){return{[yp.SEND_REPLY]:null,[yp.EMOJI_DROPDOWN]:null,[yp.REFRESH_CHANGE]:"_handleRefreshChange",[yp.OPEN_REPLY_DIALOG]:"_handleOpenReplyDialog",[yp.OPEN_DOWNLOAD_DIALOG]:"_handleOpenDownloadDialogShortcut",[yp.TOGGLE_DIFF_MODE]:"_handleToggleDiffMode",[yp.TOGGLE_CHANGE_STAR]:"_throttledToggleChangeStar",[yp.UP_TO_DASHBOARD]:"_handleUpToDashboard",[yp.EXPAND_ALL_MESSAGES]:"_handleExpandAllMessages",[yp.COLLAPSE_ALL_MESSAGES]:"_handleCollapseAllMessages",[yp.EXPAND_ALL_DIFF_CONTEXT]:"_expandAllDiffs",[yp.OPEN_DIFF_PREFS]:"_handleOpenDiffPrefsShortcut",[yp.EDIT_TOPIC]:"_handleEditTopic",[yp.DIFF_AGAINST_BASE]:"_handleDiffAgainstBase",[yp.DIFF_AGAINST_LATEST]:"_handleDiffAgainstLatest",[yp.DIFF_BASE_AGAINST_LEFT]:"_handleDiffBaseAgainstLeft",[yp.DIFF_RIGHT_AGAINST_LATEST]:"_handleDiffRightAgainstLatest",[yp.DIFF_BASE_AGAINST_LATEST]:"_handleDiffBaseAgainstLatest"}}constructor(){super(),this.reporting=n.reportingService}connectedCallback(){super.connectedCallback(),this._throttledToggleChangeStar=this._throttleWrap(e=>this._handleToggleChangeStar(e))}created(){super.created(),this.addEventListener("topic-changed",()=>this._handleTopicChanged()),this.addEventListener("fullscreen-overlay-opened",()=>this._handleHideBackgroundContent()),this.addEventListener("fullscreen-overlay-closed",()=>this._handleShowBackgroundContent()),this.addEventListener("diff-comments-modified",()=>this._handleReloadCommentThreads()),this.addEventListener("open-reply-dialog",e=>this._openReplyDialog())}attached(){super.attached(),this._getServerConfig().then(e=>{this._serverConfig=e}),this._getLoggedIn().then(e=>{this._loggedIn=e,e&&this.$.restAPI.getAccount().then(e=>{this._account=e}),this._setDiffViewMode()}),eh().awaitPluginsLoaded().then(()=>{this._dynamicTabHeaderEndpoints=rc().getDynamicEndpoints("change-view-tab-header"),this._dynamicTabContentEndpoints=rc().getDynamicEndpoints("change-view-tab-content"),this._dynamicTabContentEndpoints.length!==this._dynamicTabHeaderEndpoints.length&&console.warn("Different number of tab headers and tab content.")}).then(()=>this._initActiveTabs(this.params)),this.addEventListener("comment-save",e=>this._handleCommentSave(e)),this.addEventListener("comment-refresh",e=>this._reloadDrafts(e)),this.addEventListener("comment-discard",e=>this._handleCommentDiscard(e)),this.addEventListener("change-message-deleted",()=>this._reload()),this.addEventListener("editable-content-save",e=>this._handleCommitMessageSave(e)),this.addEventListener("editable-content-cancel",e=>this._handleCommitMessageCancel(e)),this.addEventListener("open-fix-preview",e=>this._onOpenFixPreview(e)),this.addEventListener("close-fix-preview",e=>this._onCloseFixPreview(e)),this.listen(window,"scroll","_handleScroll"),this.listen(document,"visibilitychange","_handleVisibilityChange"),this.addEventListener("show-primary-tab",e=>this._setActivePrimaryTab(e)),this.addEventListener("show-secondary-tab",e=>this._setActiveSecondaryTab(e)),this.addEventListener("reload",e=>{e.stopPropagation(),this._reload(!1,e.detail&&e.detail.clearPatchset)})}detached(){super.detached(),this.unlisten(window,"scroll","_handleScroll"),this.unlisten(document,"visibilitychange","_handleVisibilityChange"),this._updateCheckTimerHandle&&this._cancelUpdateCheckTimer()}get messagesList(){return this.shadowRoot.querySelector("gr-messages-list")}get threadList(){return this.shadowRoot.querySelector("gr-thread-list")}_changeStatusString(e){return function(e){return qp(e).join(", ")}(e)}_setDiffViewMode(e){if(e||!this.viewState.diffViewMode)return this._getPreferences().then(e=>{this.viewState.diffMode||this.set("viewState.diffMode",e.default_diff_view)}).then(()=>{this.viewState.diffMode||this.set("viewState.diffMode","SIDE_BY_SIDE")})}_onOpenFixPreview(e){this.$.applyFixDialog.open(e)}_onCloseFixPreview(e){this._reload()}_handleToggleDiffMode(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.viewState.diffMode===oE?this.$.fileListHeader.setDiffViewMode(sE):this.$.fileListHeader.setDiffViewMode(oE))}_isTabActive(e,t){return t.includes(e)}_setActiveTab(e,t){const{activeTabName:n,activeTabIndex:i,scrollIntoView:o}=t,s=e.querySelectorAll("paper-tab");let r=-1;if(void 0!==i)r=i;else for(let e=0;e<=s.length;e++){if(s[e].dataset.name===n){r=e;break}}if(-1===r)return void console.warn("tab not found with given info",t);const a=s[r].dataset.name;return o&&e.scrollIntoView(),e.selected!==r&&(e.selected=r,this.reporting.reportInteraction("show-tab",{tabName:a})),a}_setActivePrimaryTab(e){const t=this.shadowRoot.querySelector("#primaryTabs"),n=this._setActiveTab(t,{activeTabName:e.detail.tab,activeTabIndex:e.detail.value,scrollIntoView:e.detail.scrollIntoView});if(n){this._activeTabs=[n,this._activeTabs[1]];const e=(this._dynamicTabHeaderEndpoints||[]).indexOf(n);-1!==e?(this._selectedTabPluginEndpoint=this._dynamicTabContentEndpoints[e],this._selectedTabPluginHeader=this._dynamicTabHeaderEndpoints[e]):(this._selectedTabPluginEndpoint="",this._selectedTabPluginHeader="")}}_setActiveSecondaryTab(e){const t=this.shadowRoot.querySelector("#secondaryTabs"),n=this._setActiveTab(t,{activeTabName:e.detail.tab,activeTabIndex:e.detail.value,scrollIntoView:e.detail.scrollIntoView});n&&(this._activeTabs=[this._activeTabs[0],n])}_handleEditCommitMessage(){this._editingCommitMessage=!0,this.$.commitMessageEditor.focusTextarea()}_handleCommitMessageSave(e){const t=e.detail.content.replace(ZC,"");this.$.jsAPI.handleCommitMessage(this._change,t),this.$.commitMessageEditor.disabled=!0,this.$.restAPI.putChangeCommitMessage(this._changeNum,t).then(e=>{this.$.commitMessageEditor.disabled=!1,e.ok&&(this._latestCommitMessage=this._prepareCommitMsgForLinkify(t),this._editingCommitMessage=!1,this._reloadWindow())}).catch(e=>{this.$.commitMessageEditor.disabled=!1})}_reloadWindow(){window.location.reload()}_handleCommitMessageCancel(e){this._editingCommitMessage=!1}_computeChangeStatusChips(e,t,n){if([e,t].includes(void 0))return;if(null===t)return[];return qp(e,{includeDerived:!0,mergeable:!!t,submitEnabled:!!n})}_computeHideEditCommitMessage(e,t,n,i,o,s){return!!(!e||t||n&&n.status===Ia.MERGED||i||o&&s)}_robotCommentCountPerPatchSet(e){return e.reduce((e,t)=>{const n=t.comments,i=n.reduce((e,t)=>t.robot_id?e+1:e,0);return e[n[0].patch_set]=(e[n[0].patch_set]||0)+i,e},{})}_computeText(e,t){const n=this._robotCommentCountPerPatchSet(t)[e._number]||0;if(0===n)return`Patchset ${e._number}`;const i=1===n?"finding":"findings";return`Patchset ${e._number}`+` (${n} ${i})`}_computeRobotCommentsPatchSetDropdownItems(e,t){return e&&t&&e.revisions?Object.values(e.revisions).filter(e=>"edit"!==e._number).map(e=>({text:this._computeText(e,t),value:e._number})).sort((e,t)=>t.value-e.value):[]}_handleCurrentRevisionUpdate(e){this._currentRobotCommentsPatchSet=e._number}_handleRobotCommentPatchSetChanged(e){const t=parseInt(e.detail.value);t!==this._currentRobotCommentsPatchSet&&(this._currentRobotCommentsPatchSet=t)}_computeShowText(e){return e?"Show Less":"Show more"}_toggleShowRobotComments(){this._showAllRobotComments=!this._showAllRobotComments}_computeRobotCommentThreads(e,t,n){if(!e||!t)return[];const i=e.filter(e=>{const n=e.comments||[];return n.length&&n[0].robot_id&&n[0].patch_set===t});return this._showRobotCommentsButton=i.length>10,i.slice(0,n?void 0:10)}_handleReloadCommentThreads(){this._reloadDrafts().then(()=>{this._commentThreads=this._changeComments.getAllThreadsForChange(),Mo()})}_handleReloadDiffComments(e){this._reloadDrafts().then(()=>{this.$.fileList.reloadCommentsForThreadWithRootId(e.detail.rootId,e.detail.path),Mo()})}_computeTotalCommentCounts(e,t){if(!t)return;const n=t.computeDraftCount(),i=nd.computeString(e,"unresolved"),o=nd.computePluralString(n,"draft");return i+(i&&o?", ":"")+o}_handleCommentSave(e){const t=e.detail.comment;if(!t.__draft)return;t.patch_set=t.patch_set||this._patchRange.patchNum;const n={...this._diffDrafts};if(!n[t.path])return n[t.path]=[t],void(this._diffDrafts=n);for(let e=0;e<this._diffDrafts[t.path].length;e++)if(this._diffDrafts[t.path][e].id===t.id)return n[t.path][e]=t,void(this._diffDrafts=n);n[t.path].push(t),n[t.path].sort((e,t)=>(e.line||-1)-(t.line||-1)),this._diffDrafts=n}_handleCommentDiscard(e){const t=e.detail.comment;if(!t.__draft)return;if(!this._diffDrafts[t.path])return;let n=-1;for(let e=0;e<this._diffDrafts[t.path].length;e++)if(this._diffDrafts[t.path][e].id===t.id){n=e;break}if(-1===n)return;t.patch_set=t.patch_set||this._patchRange.patchNum;const i={...this._diffDrafts};i[t.path].splice(n,1),0===i[t.path].length&&delete i[t.path],this._diffDrafts=i}_handleReplyTap(e){e.preventDefault(),this._openReplyDialog(this.$.replyDialog.FocusTarget.ANY)}_handleOpenDiffPrefs(){this.$.fileList.openDiffPrefs()}_handleOpenIncludedInDialog(){this.$.includedInDialog.loadData().then(()=>{Mo(),this.$.includedInOverlay.refit()}),this.$.includedInOverlay.open()}_handleIncludedInDialogClose(e){this.$.includedInOverlay.close()}_handleOpenDownloadDialog(){this.$.downloadOverlay.open().then(()=>{this.$.downloadOverlay.setFocusStops(this.$.downloadDialog.getFocusStops()),this.$.downloadDialog.focus()})}_handleDownloadDialogClose(e){this.$.downloadOverlay.close()}_handleOpenUploadHelpDialog(e){this.$.uploadHelpOverlay.open()}_handleCloseUploadHelpDialog(e){this.$.uploadHelpOverlay.close()}_handleMessageReply(e){const t=e.detail.message.message.split("\n").map(e=>"> "+e).join("\n")+"\n\n";this.$.replyDialog.quote=t,this._openReplyDialog(this.$.replyDialog.FocusTarget.BODY)}_handleHideBackgroundContent(){this.$.mainContent.classList.add("overlayOpen")}_handleShowBackgroundContent(){this.$.mainContent.classList.remove("overlayOpen")}_handleReplySent(e){this.addEventListener("change-details-loaded",()=>{this.reporting.timeEnd("SendReply")},{once:!0}),this.$.replyOverlay.close(),this._reload()}_handleReplyCancel(e){this.$.replyOverlay.close()}_handleReplyAutogrow(e){this.debounce("reply-overlay-refit",()=>{this.$.replyOverlay.refit()},500)}_handleShowReplyDialog(e){let t=this.$.replyDialog.FocusTarget.REVIEWERS;e.detail.value&&e.detail.value.ccsOnly&&(t=this.$.replyDialog.FocusTarget.CCS),this._openReplyDialog(t)}_handleScroll(){this.debounce("scroll",()=>{this.viewState.scrollTop=document.body.scrollTop},150)}_setShownFiles(e){this._shownFileCount=e.detail.length}_expandAllDiffs(e){this.shouldSuppressKeyboardShortcut(e)||this.$.fileList.expandAllDiffs()}_collapseAllDiffs(){this.$.fileList.collapseAllDiffs()}_paramsChanged(e){if(e.view!==gh.View.CHANGE)return void(this._initialLoadComplete=!1);e.changeNum&&e.project&&this.$.restAPI.setInProjectLookup(e.changeNum,e.project);const t=this._patchRange&&void 0!==e.patchNum&&void 0!==e.basePatchNum&&(this._patchRange.patchNum!==e.patchNum||this._patchRange.basePatchNum!==e.basePatchNum),n=this._changeNum!==e.changeNum,i={patchNum:e.patchNum,basePatchNum:e.basePatchNum||"PARENT"};if(this.$.fileList.collapseAllDiffs(),this._patchRange=i,!n&&t)return null==i.patchNum&&(i.patchNum=Th(this._allPatchSets)),void this._reloadPatchNumDependentResources().then(()=>{this._sendShowChangeEvent()});this._initialLoadComplete=!1,this._changeNum=e.changeNum,this.$.relatedChanges.clear(),this._reload(!0).then(()=>{this._performPostLoadTasks()}),eh().awaitPluginsLoaded().then(()=>{this._initActiveTabs(e)})}_initActiveTabs(e={}){let t=xa.FILES;e.queryMap&&e.queryMap.has("tab")&&(t=e.queryMap.get("tab")),this._setActivePrimaryTab({detail:{tab:t}}),this._setActiveSecondaryTab({detail:{tab:Pa.CHANGE_LOG}})}_sendShowChangeEvent(){this.$.jsAPI.handleEvent(Il.SHOW_CHANGE,{change:this._change,patchNum:this._patchRange.patchNum,info:{mergeable:this._mergeable}})}_performPostLoadTasks(){this._maybeShowReplyDialog(),this._maybeShowRevertDialog(),this._maybeShowDownloadDialog(),this._sendShowChangeEvent(),this.async(()=>{this.viewState.scrollTop?document.documentElement.scrollTop=document.body.scrollTop=this.viewState.scrollTop:this._maybeScrollToMessage(window.location.hash),this._initialLoadComplete=!0})}_paramsAndChangeChanged(e,t){if([e,t].includes(void 0))return;const n=this.viewState.patchRange;this.viewState.changeNum===this._changeNum&&n&&n.basePatchNum===this._patchRange.basePatchNum&&n.patchNum===this._patchRange.patchNum||this._resetFileListViewState()}_viewStateChanged(e){this._numFilesShown=e.numFilesShown?e.numFilesShown:200}_numFilesShownChanged(e){this.viewState.numFilesShown=e}_handleMessageAnchorTap(e){const t="#message-"+e.detail.id,n=gh.getUrlForChange(this._change,this._patchRange.patchNum,this._patchRange.basePatchNum,this._editMode,t);history.replaceState(null,"",n)}_maybeScrollToMessage(e){e.startsWith("#message-")&&this.messagesList.scrollToMessage(e.substr("#message-".length))}_getLocationSearch(){return window.location.search}_getUrlParameter(e){const t=this._getLocationSearch().substring(1).split("&");for(let n=0;n<t.length;n++){const i=t[n].split("=");if(i[0]==e)return i[0]}return null}_maybeShowRevertDialog(){eh().awaitPluginsLoaded().then(()=>this._getLoggedIn()).then(e=>{e&&this._change&&this._change.status===Ia.MERGED&&this._getUrlParameter("revert")&&this.$.actions.showRevertDialog()})}_maybeShowReplyDialog(){this._getLoggedIn().then(e=>{e&&this.viewState.showReplyDialog&&(this._openReplyDialog(this.$.replyDialog.FocusTarget.ANY),this.async(()=>{this.$.replyOverlay.center()},100),this.async(()=>{this.$.replyOverlay.center()},1e3),this.set("viewState.showReplyDialog",!1))})}_maybeShowDownloadDialog(){this.viewState.showDownloadDialog&&(this._handleOpenDownloadDialog(),this.set("viewState.showDownloadDialog",!1))}_resetFileListViewState(){this.set("viewState.selectedFileIndex",0),this.set("viewState.scrollTop",0),this.viewState.changeNum&&this.viewState.changeNum!==this._changeNum&&(this._setDiffViewMode(!0),this.set("_numFilesShown",200)),this.set("viewState.changeNum",this._changeNum),this.set("viewState.patchRange",this._patchRange)}_changeChanged(e){if(!e||!this._patchRange||!this._allPatchSets)return;const t=this._getBasePatchNum(e,this._patchRange);this.set("_patchRange.patchNum",this._patchRange.patchNum||Th(this._allPatchSets)),this.set("_patchRange.basePatchNum",t);const n=e.subject+" ("+e.change_id.substr(0,9)+")";this.dispatchEvent(new CustomEvent("title-change",{detail:{title:n},composed:!0,bubbles:!0}))}_getBasePatchNum(e,t){if(t.basePatchNum&&"PARENT"!==t.basePatchNum)return t.basePatchNum;const n=this._getRevisionInfo(e);if(!n)return"PARENT";const i=n.getParentCountMap(),o=i.hasOwnProperty(1)?i[1]:1,s=this._prefs&&"FIRST_PARENT"===this._prefs.default_base_for_merges;return o>1&&s&&!t.patchNum?-1:"PARENT"}_computeChangeUrl(e){return gh.getUrlForChange(e)}_computeShowCommitInfo(e,t){return"Merged"===e&&t}_computeMergedCommitInfo(e,t){const n=t[e];return n&&n.commit?(n.commit.commit||(n.commit.commit=e),n.commit):{}}_computeChangeIdClass(e){return e===KC?"warning":""}_computeTitleAttributeWarning(e){return e===KC?"Change-Id mismatch":e===YC?"No Change-Id in commit message":void 0}_computeChangeIdCommitMessageError(e,t){if([e,t].includes(void 0))return;if(!e)return YC;let n,i;for(;i=XC.exec(e);)n=i[2];return n?n===t.change_id?null:KC:YC}_computeLabelNames(e){return Object.keys(e).sort()}_computeLabelValues(e,t){const n=[],i=t[e];if(!i)return n;const o=i.all||[];for(const i of o)if(i.value&&i.value!=t[e].default_value){let e,t="";i.value>0?(t="+",e="approved"):i.value<0&&(e="notApproved"),n.push({value:t+i.value,className:e,account:i})}return n}_computeReplyButtonLabel(e,t){if([e,t].includes(void 0))return"Reply";const n=e&&e.base||{},i=Object.keys(n).reduce((e,t)=>e+n[t].length,0);let o=t?"Start Review":"Reply";return i>0&&(o+=" ("+i+")"),o}_handleOpenReplyDialog(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||this._getLoggedIn().then(t=>{t?(e.preventDefault(),this._openReplyDialog(this.$.replyDialog.FocusTarget.ANY)):this.dispatchEvent(new CustomEvent("show-auth-required",{composed:!0,bubbles:!0}))})}_handleOpenDownloadDialogShortcut(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._handleOpenDownloadDialog())}_handleEditTopic(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.$.metadata.editTopic())}_handleDiffAgainstBase(e){this.shouldSuppressKeyboardShortcut(e)||(Ch(this._patchRange.basePatchNum,wh)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Base is already selected."},composed:!0,bubbles:!0})):gh.navigateToChange(this._change,this._patchRange.patchNum))}_handleDiffBaseAgainstLeft(e){this.shouldSuppressKeyboardShortcut(e)||(Ch(this._patchRange.basePatchNum,wh)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Left is already base."},composed:!0,bubbles:!0})):gh.navigateToChange(this._change,this._patchRange.basePatchNum))}_handleDiffAgainstLatest(e){if(this.shouldSuppressKeyboardShortcut(e))return;const t=Th(this._allPatchSets);Ch(this._patchRange.patchNum,t)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Latest is already selected."},composed:!0,bubbles:!0})):gh.navigateToChange(this._change,t,this._patchRange.basePatchNum)}_handleDiffRightAgainstLatest(e){if(this.shouldSuppressKeyboardShortcut(e))return;const t=Th(this._allPatchSets);Ch(this._patchRange.patchNum,t)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Right is already latest."},composed:!0,bubbles:!0})):gh.navigateToChange(this._change,t,this._patchRange.patchNum)}_handleDiffBaseAgainstLatest(e){if(this.shouldSuppressKeyboardShortcut(e))return;const t=Th(this._allPatchSets);Ch(this._patchRange.patchNum,t)&&Ch(this._patchRange.basePatchNum,wh)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Already diffing base against latest."},composed:!0,bubbles:!0})):gh.navigateToChange(this._change,t)}_handleRefreshChange(e){this.shouldSuppressKeyboardShortcut(e)||(e.preventDefault(),this._reload(!1,!0))}_handleToggleChangeStar(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.$.changeStar.toggleStar())}_handleUpToDashboard(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._determinePageBack())}_handleExpandAllMessages(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.messagesList.handleExpandCollapse(!0))}_handleCollapseAllMessages(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.messagesList.handleExpandCollapse(!1))}_handleOpenDiffPrefsShortcut(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||this._diffPrefsDisabled||(e.preventDefault(),this.$.fileList.openDiffPrefs())}_determinePageBack(){gh.navigateToRelativeUrl(this.backPage||gh.getUrlForRoot())}_handleLabelRemoved(e,t){for(const n of e)for(const e of n.removed){const n=t.split("."),i=n.splice(0,n.length-2),o=this.get(i);if(o.approved&&o.approved._account_id===e._account_id)return void this._reload()}}_labelsChanged(e){e&&(e.value&&e.value.indexSplices&&this._handleLabelRemoved(e.value.indexSplices,e.path),this.$.jsAPI.handleEvent(Il.LABEL_CHANGE,{change:this._change}))}_openReplyDialog(e){this.$.replyOverlay.open().finally(()=>{this._resetReplyOverlayFocusStops(),this.$.replyDialog.open(e),Mo(),this.$.replyOverlay.center()})}_handleGetChangeDetailError(e){this.dispatchEvent(new CustomEvent("page-error",{detail:{response:e},composed:!0,bubbles:!0}))}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_getServerConfig(){return this.$.restAPI.getConfig()}_getProjectConfig(){if(this._change)return this.$.restAPI.getProjectConfig(this._change.project).then(e=>{this._projectConfig=e})}_getPreferences(){return this.$.restAPI.getPreferences()}_prepareCommitMsgForLinkify(e){return e.replace(JC,"$1=​")}_processEdit(e,t){t&&(e.revisions[t.commit.commit]={_number:bh,basePatchNum:t.base_patch_set_number,commit:t.commit,fetch:t.fetch},this._patchRange.patchNum||e.current_revision!==t.base_revision||(e.current_revision=t.commit.commit,this.set("_patchRange.patchNum",bh),e.revisions[t.commit.commit].actions=e.revisions[t.base_revision].actions))}_getChangeDetail(){const e=this.$.restAPI.getChangeDetail(this._changeNum,e=>this._handleGetChangeDetailError(e)),t=this._getEdit(),n=this._getPreferences();return Promise.all([e,t,n]).then(([e,t,n])=>{if(this._prefs=n,!e)return"";this._processEdit(e,t),e.topic||(e.topic=null),e.reviewer_updates||(e.reviewer_updates=null);const i=this._getLatestRevisionSHA(e),o=e.revisions[i];o.commit&&o.commit.message?this._latestCommitMessage=this._prepareCommitMsgForLinkify(o.commit.message):this._latestCommitMessage=null;const s=getComputedStyle(this).lineHeight;this._lineHeight=parseInt(s.slice(0,s.length-2),10),this._change=e,this._patchRange&&this._patchRange.patchNum&&!Ch(this._patchRange.patchNum,o._number)?this._selectedRevision=Object.values(this._change.revisions).find(e=>{const t=this._patchRange.patchNum;return"edit"===t?e._number===t:e._number===parseInt(t,10)}):(o.commit.commit||(o.commit.commit=i),this._commitInfo=o.commit,this._selectedRevision=o)})}_isSubmitEnabled(e){return!!(e&&e.submit&&e.submit.enabled)}_isParentCurrent(e){return!e||!e.rebase||!e.rebase.enabled}_getEdit(){return this.$.restAPI.getChangeEdit(this._changeNum,!0)}_getLatestCommitMessage(){return this.$.restAPI.getChangeCommitInfo(this._changeNum,Th(this._allPatchSets)).then(e=>{if(!e)return Promise.resolve();this._latestCommitMessage=this._prepareCommitMsgForLinkify(e.message)})}_getLatestRevisionSHA(e){if(e.current_revision)return e.current_revision;let t=null,n=-1;for(const i in e.revisions)e.revisions.hasOwnProperty(i)&&e.revisions[i]._number>n&&(t=i,n=e.revisions[i]._number);return t}_getCommitInfo(){return this.$.restAPI.getChangeCommitInfo(this._changeNum,this._patchRange.patchNum).then(e=>{this._commitInfo=e})}_reloadDraftsWithCallback(e){return this._reloadDrafts().then(()=>e.detail.resolve())}_reloadComments(){return this._changeComments=void 0,this._commentThreads=void 0,this._diffDrafts=void 0,this._draftCommentThreads=void 0,this._robotCommentThreads=void 0,this.$.commentAPI.loadAll(this._changeNum).then(e=>this._recomputeComments(e))}_reloadDrafts(){return this.$.commentAPI.reloadDrafts(this._changeNum).then(e=>this._recomputeComments(e))}_recomputeComments(e){this._changeComments=e,this._diffDrafts={...this._changeComments.drafts},this._commentThreads=this._changeComments.getAllThreadsForChange(),this._draftCommentThreads=this._commentThreads.filter(e=>e.comments[e.comments.length-1].__draft).map(e=>{const t={...e},n=t.comments=e.comments.map(e=>({...e,collapsed:!0}));return n[n.length-1].collapsed=!1,t})}_reload(e,t){if(t)return void gh.navigateToChange(this._change);this._loading=!0,this._relatedChangesCollapsed=!0,this.reporting.time("ChangeReloaded"),this.reporting.time("ChangeDataLoaded");const n=[],i=this._getChangeDetail();n.push(i);const o=i.then(()=>{this._loading=!1,this.dispatchEvent(new CustomEvent("change-details-loaded",{bubbles:!0,composed:!0}))}).then(()=>{this.reporting.timeEnd("ChangeReloaded"),e&&this.reporting.changeDisplayed()}),s=i.then(()=>this._getProjectConfig());n.push(s);const r=this._reloadComments();let a;if(n.push(r),this._patchRange&&this._patchRange.patchNum){const e=this._reloadPatchNumDependentResources();n.push(e);const t=Promise.all([e,o]),i=t.then(()=>this._getMergeability());n.push(i);const s=t.then(()=>this.$.actions.reload());n.push(s),a=Promise.all([i,s])}else{const e=o.then(()=>this.$.fileList.reload());n.push(e);const t=o.then(()=>this._latestCommitMessage?Promise.resolve():this._getLatestCommitMessage());n.push(t);const i=o.then(()=>this._getMergeability());n.push(i),a=i}if(e){this._editingCommitMessage=!1;const e=a.then(()=>this.$.relatedChanges.reload());n.push(e)}return Promise.all(n).then(()=>{this.reporting.timeEnd("ChangeDataLoaded"),e&&this.reporting.changeFullyLoaded()}),a}_reloadPatchNumDependentResources(){return Promise.all([this._getCommitInfo(),this.$.fileList.reload()])}_getMergeability(){return this._change?this._change.status===Ia.MERGED||this._change.status===Ia.ABANDONED?(this._mergeable=!1,Promise.resolve()):(this._mergeable=null,this.$.restAPI.getMergeable(this._changeNum).then(e=>{this._mergeable=e.mergeable})):(this._mergeable=null,Promise.resolve())}_computeCanStartReview(e){return!!(e.actions&&e.actions.ready&&e.actions.ready.enabled)}_computeReplyDisabled(){return!1}_computeChangePermalinkAriaLabel(e){return"Change "+e}_computeCommitMessageCollapsed(e,t){return t&&e}_computeRelatedChangesClass(e){return e?"collapsed":""}_computeCollapseText(e){return e?"▼ Show more":"▲ Show less"}_computeCopyTextForTitle(e){return`${e._number}: ${e.subject} | `+`${location.protocol}//${location.host}`+`${this._computeChangeUrl(e)}`}_toggleCommitCollapsed(){this._commitCollapsed=!this._commitCollapsed,this._commitCollapsed&&window.scrollTo(0,0)}_toggleRelatedChangesCollapsed(){this._relatedChangesCollapsed=!this._relatedChangesCollapsed,this._relatedChangesCollapsed&&window.scrollTo(0,0)}_computeCommitCollapsible(e){return!!e&&e.split("\n").length>=30}_getOffsetHeight(e){return e.offsetHeight}_getScrollHeight(e){return e.scrollHeight}_getLineHeight(e){const t=getComputedStyle(e).lineHeight;return Math.round(t.slice(0,t.length-2))}_updateRelatedChangeMaxHeight(){let e;if(window.matchMedia("(max-width: 50em)").matches)e=400;else if(window.matchMedia("(max-width: 75em)").matches){e=Math.max(this._getOffsetHeight(this.$.mainChangeInfo)-this._getOffsetHeight(this.$.commitMessage)-60,100)}else e=this._commitCollapsible?this._getOffsetHeight(this.$.commitMessage):this._getOffsetHeight(this.$.commitAndRelated)-30;const t={},n=e%this._getLineHeight(this.$.relatedChanges);e-=n,t["--relation-chain-max-height"]=e+"px",this._commitCollapsible&&(t["--related-change-btn-top-padding"]=n+"px"),this.updateStyles(t)}_computeShowRelatedToggle(){return function(e,t){let n;return n=window.ShadyCSS?window.ShadyCSS.getComputedStyleValue(t,e):"getComputedStyleValue"in t?t.getComputedStyleValue(e):getComputedStyle(t).getPropertyValue(e),n}("--relation-chain-max-height",this)||this._updateRelatedChangeMaxHeight(),this._getScrollHeight(this.$.relatedChanges)?this._getScrollHeight(this.$.relatedChanges)>this._getOffsetHeight(this.$.relatedChanges)+this._getLineHeight(this.$.relatedChanges)?this._showRelatedToggle=!0:void(this._showRelatedToggle=!1):this._showRelatedToggle=!1}_updateToggleContainerClass(e){e?this.$.relatedChangesToggle.classList.add("showToggle"):this.$.relatedChangesToggle.classList.remove("showToggle")}_startUpdateCheckTimer(){!this._serverConfig||!this._serverConfig.change||void 0===this._serverConfig.change.update_delay||this._serverConfig.change.update_delay<=0||(this._updateCheckTimerHandle=this.async(()=>{const e=this._change;Ih(e,this.$.restAPI).then(t=>{let n=null;t.isLatest?t.newStatus===Ia.MERGED?n=nE:t.newStatus===Ia.ABANDONED?n=tE:t.newStatus===Ia.NEW?n=eE:t.newMessages&&(n=iE):n=QC;const i=e!==this._change;!n||this._loading||i?this._startUpdateCheckTimer():(this._cancelUpdateCheckTimer(),this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:n,dismissOnNavigation:!0,action:"Reload",callback:()=>{this._reload(!1,!0)}},composed:!0,bubbles:!0})))})},1e3*this._serverConfig.change.update_delay))}_cancelUpdateCheckTimer(){this._updateCheckTimerHandle&&this.cancelAsync(this._updateCheckTimerHandle),this._updateCheckTimerHandle=null}_handleVisibilityChange(){document.hidden&&this._updateCheckTimerHandle?this._cancelUpdateCheckTimer():this._updateCheckTimerHandle||this._startUpdateCheckTimer()}_handleTopicChanged(){this.$.relatedChanges.reload()}_computeHeaderClass(e){const t=["header"];return e&&t.push("editMode"),t.join(" ")}_computeEditMode(e,t){if([e,t].includes(void 0))return;if(t.base&&t.base.edit)return!0;return Ch((e.base||{}).patchNum,bh)}_handleFileActionTap(e){e.preventDefault();const t=this.$.fileListHeader.shadowRoot.querySelector("#editControls"),n=e.detail.path;switch(e.detail.action){case Nl.Actions.DELETE.id:t.openDeleteDialog(n);break;case Nl.Actions.OPEN.id:gh.navigateToRelativeUrl(gh.getEditUrlForDiff(this._change,n,this._patchRange.patchNum));break;case Nl.Actions.RENAME.id:t.openRenameDialog(n);break;case Nl.Actions.RESTORE.id:t.openRestoreDialog(n)}}_computeCommitMessageKey(e,t){return`c${e}_rev${t}`}_patchNumChanged(e){if(!this._selectedRevision)return;let t=parseInt(e,10);"edit"===e&&(t=e),t!==this._selectedRevision._number&&(this._selectedRevision=Object.values(this._change.revisions).find(e=>e._number===t))}_handleEditTap(){if(Object.values(this._change.revisions).find(e=>e._number===bh))return void gh.navigateToChange(this._change,bh);let e;Ch(this._patchRange.patchNum,Th(this._allPatchSets))||(e=this._patchRange.patchNum),gh.navigateToChange(this._change,e,null,!0)}_handleStopEditTap(){gh.navigateToChange(this._change,this._patchRange.patchNum)}_resetReplyOverlayFocusStops(){this.$.replyOverlay.setFocusStops(this.$.replyDialog.getFocusStops())}_handleToggleStar(e){this.$.restAPI.saveChangeStarred(e.detail.change._number,e.detail.starred)}_getRevisionInfo(e){return new Nh(e)}_computeCurrentRevision(e,t){return e&&t&&t[e]}_computeDiffPrefsDisabled(e,t){return e||!t}_computeLatestPatchNum(e){return Th(e)}_hasEditBasedOnCurrentPatchSet(e){return function(e){return!(!e||e.length<2)&&"edit"===e[0].num}(e)}_hasEditPatchsetLoaded(e){return function(e){const t=e.base;return!!t&&("edit"===t.patchNum||"edit"===t.basePatchNum)}(e)}_computeAllPatchSets(e){return Ph(e)}}customElements.define(rE.is,rE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const aE=ta`
  <style include="shared-styles">
    .main {
      max-height: 40em;
      max-width: 60em;
      overflow-y: auto;
      white-space: pre-wrap;
    }
    @media screen and (max-width: 50em) {
      .main {
        max-height: none;
        max-width: 50em;
      }
    }
    .signInLink {
      text-decoration: none;
    }
  </style>
  <gr-dialog
    id="dialog"
    cancel-label=""
    on-confirm="_handleConfirm"
    confirm-label="Dismiss"
    confirm-on-enter=""
  >
    <div class="header" slot="header">An error occurred</div>
    <div class="main" slot="main">[[text]]</div>
    <gr-button
      id="signIn"
      class$="signInLink"
      hidden$="[[!showSignInButton]]"
      link=""
      slot="footer"
    >
      <a href$="[[loginUrl]]" class="signInLink">Sign in</a>
    </gr-button>
  </gr-dialog>
`;var lE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let cE=class extends(oo(dr(oa))){constructor(){super(...arguments),this.loginUrl="/login",this.showSignInButton=!1}static get template(){return aE}_handleConfirm(){this.dispatchEvent(new CustomEvent("dismiss"))}};lE([Bl({type:String})],cE.prototype,"text",void 0),lE([Bl({type:String})],cE.prototype,"loginUrl",void 0),lE([Bl({type:Boolean})],cE.prototype,"showSignInButton",void 0),cE=lE([Ml("gr-error-dialog")],cE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const dE=ta`
  <style include="shared-styles">
    /**
       * ALERT: DO NOT ADD TRANSITION PROPERTIES WITHOUT PROPERLY UNDERSTANDING
       * HOW THEY ARE USED IN THE CODE.
       */
    :host([toast]) {
      background-color: var(--tooltip-background-color);
      bottom: 1.25rem;
      border-radius: var(--border-radius);
      box-shadow: var(--elevation-level-2);
      color: var(--view-background-color);
      left: 1.25rem;
      position: fixed;
      transform: translateY(5rem);
      transition: transform var(--gr-alert-transition-duration, 80ms) ease-out;
      z-index: 1000;
    }
    :host([shown]) {
      transform: translateY(0);
    }
    /**
       * NOTE: To avoid style being overwritten by outside of the shadow DOM
       * (as outside styles always win), .content-wrapper is introduced as a
       * wrapper around main content to have better encapsulation, styles that
       * may be affected by outside should be defined on it.
       * In this case, \`padding:0px\` is defined in main.css for all elements
       * with the universal selector: *.
       */
    .content-wrapper {
      padding: var(--spacing-l) var(--spacing-xl);
    }
    .text {
      color: var(--tooltip-text-color);
      display: inline-block;
      max-height: 10rem;
      max-width: 80vw;
      vertical-align: bottom;
      word-break: break-all;
    }
    .action {
      color: var(--link-color);
      font-weight: var(--font-weight-bold);
      margin-left: var(--spacing-l);
      text-decoration: none;
      --gr-button: {
        padding: 0;
      }
    }
  </style>
  <div class="content-wrapper">
    <span class="text">[[text]]</span>
    <gr-button
      link=""
      class="action"
      hidden$="[[_hideActionButton]]"
      on-click="_handleActionTap"
      >[[actionText]]</gr-button
    >
  </div>
`;var hE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let pE=class extends(oo(dr(oa))){constructor(){super(...arguments),this.shown=!0,this.toast=!0}static get template(){return dE}attached(){super.attached(),this._boundTransitionEndHandler=()=>this._handleTransitionEnd(),this.addEventListener("transitionend",this._boundTransitionEndHandler)}detached(){super.detached(),this._boundTransitionEndHandler&&this.removeEventListener("transitionend",this._boundTransitionEndHandler)}show(e,t,n){this.text=e,this.actionText=t,this._hideActionButton=!t,this._actionCallback=n,mh().appendChild(this),this.shown=!0}hide(){this.shown=!1,this._hasZeroTransitionDuration()&&mh().removeChild(this)}_hasZeroTransitionDuration(){const e=window.getComputedStyle(this);return 0===Math.round(100*parseFloat(e.transitionDuration))}_handleTransitionEnd(){this.shown||mh().removeChild(this)}_handleActionTap(e){e.preventDefault(),this._actionCallback&&this._actionCallback()}};hE([Bl({type:String})],pE.prototype,"text",void 0),hE([Bl({type:String})],pE.prototype,"actionText",void 0),hE([Bl({type:String})],pE.prototype,"type",void 0),hE([Bl({type:Boolean,reflectToAttribute:!0})],pE.prototype,"shown",void 0),hE([Bl({type:Boolean,reflectToAttribute:!0})],pE.prototype,"toast",void 0),hE([Bl({type:Boolean})],pE.prototype,"_hideActionButton",void 0),hE([Bl()],pE.prototype,"_boundTransitionEndHandler",void 0),hE([Bl()],pE.prototype,"_actionCallback",void 0),pE=hE([Ml("gr-alert")],pE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const uE=ta`
  <gr-overlay with-backdrop="" id="errorOverlay">
    <gr-error-dialog
      id="errorDialog"
      on-dismiss="_handleDismissErrorDialog"
      confirm-label="Dismiss"
      confirm-on-enter=""
      login-url="[[loginUrl]]"
    ></gr-error-dialog>
  </gr-overlay>
  <gr-overlay
    id="noInteractionOverlay"
    with-backdrop=""
    always-on-top=""
    no-cancel-on-esc-key=""
    no-cancel-on-outside-click=""
  >
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var gE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const mE={[ic.AUTH]:3,[ic.NETWORK]:2,[ic.GENERIC]:1};let _E=class extends(oo(dr(oa))){constructor(){super(),this._alertElement=null,this._hideAlertHandle=null,this._refreshingCredentials=!1,this._lastCredentialCheck=Date.now(),this.loginUrl="/login",this._authService=n.authService,this.reporting=n.reportingService,this.eventEmitter=n.eventEmitter}static get template(){return uE}attached(){super.attached(),this.listen(document,"server-error","_handleServerError"),this.listen(document,"network-error","_handleNetworkError"),this.listen(document,"show-alert","_handleShowAlert"),this.listen(document,"hide-alert","_hideAlert"),this.listen(document,"show-error","_handleShowErrorDialog"),this.listen(document,"visibilitychange","_handleVisibilityChange"),this.listen(document,"show-auth-required","_handleAuthRequired"),this._authErrorHandlerDeregistrationHook=this.eventEmitter.on("auth-error",e=>{this._handleAuthError(e.message,e.action)}),Mu.requestAvailability()}detached(){super.detached(),this._clearHideAlertHandle(),this.unlisten(document,"server-error","_handleServerError"),this.unlisten(document,"network-error","_handleNetworkError"),this.unlisten(document,"show-alert","_handleShowAlert"),this.unlisten(document,"hide-alert","_hideAlert"),this.unlisten(document,"show-error","_handleShowErrorDialog"),this.unlisten(document,"visibilitychange","_handleVisibilityChange"),this.unlisten(document,"show-auth-required","_handleAuthRequired"),this._authErrorHandlerDeregistrationHook&&this._authErrorHandlerDeregistrationHook()}_shouldSuppressError(e){return e.includes("too many files to find conflicts")}_handleAuthRequired(){this._showAuthErrorAlert("Log in is required to perform that action.","Log in.")}_handleAuthError(e,t){this.$.noInteractionOverlay.open().then(()=>{this._showAuthErrorAlert(e,t)})}_handleServerError(e){const{request:t,response:n}=e.detail;n.text().then(e=>{const i=t&&(t.anonymizedUrl||t.url),{status:o,statusText:s}=n;if(403!==n.status||this._authService.isAuthed||"Authentication required\n"!==e){if(403===n.status&&this._authService.isAuthed&&"Authentication required\n"===e)this._authService.clearCache(),this.$.restAPI.getLoggedIn();else if(!this._shouldSuppressError(e)){const t=n.headers&&n.headers.get("X-Gerrit-Trace");404===n.status?this._showNotFoundMessageWithTip({status:o,statusText:s,errorText:e,url:i,trace:t}):this._showErrorDialog(this._constructServerErrorMsg({status:o,statusText:s,errorText:e,url:i,trace:t}))}}else this._handleAuthRequired();console.info(`server error: ${e}`)})}_showNotFoundMessageWithTip({status:e,statusText:t,errorText:n,url:i,trace:o}){this.$.restAPI.getLoggedIn().then(s=>{const r=s?"You might have not enough privileges.":"You might have not enough privileges. Sign in and try again.";this._showErrorDialog(this._constructServerErrorMsg({status:e,statusText:t,errorText:n,url:i,trace:o,tip:r}),{showSignInButton:!s})})}_constructServerErrorMsg({errorText:e,status:t,statusText:n,url:i,trace:o,tip:s}){let r="";return s&&(r+=`${s}\n\n`),r+=`Error ${t}`,n&&(r+=` (${n})`),(e||i)&&(r+=": "),e&&(r+=e),i&&(r+=`\nEndpoint: ${i}`),o&&(r+=`\nTrace Id: ${o}`),r}_handleShowAlert(e){this._showAlert(e.detail.message,e.detail.action,e.detail.callback,e.detail.dismissOnNavigation)}_handleNetworkError(e){this._showAlert("Server unavailable"),console.error(e.detail.error.message)}_canOverride(e=ic.GENERIC,t=ic.GENERIC){return mE[e]>=mE[t]}_showAlert(e,t,n,i,o){if(this._alertElement){if(!this._canOverride(o,this._alertElement.type))return;this._hideAlert()}this._clearHideAlertHandle(),i?this.listen(document,"location-change","_hideAlert"):this._hideAlertHandle=this.async(this._hideAlert,5e3);const s=this._createToastAlert();s.show(e,t,n),this._alertElement=s,this.fire("iron-announce",{text:e},{bubbles:!0}),this.reporting.reportInteraction("show-alert",{text:e})}_hideAlert(){this._alertElement&&(this._alertElement.hide(),this._alertElement=null,this.unlisten(document,"location-change","_hideAlert"))}_clearHideAlertHandle(){null!==this._hideAlertHandle&&(this.cancelAsync(this._hideAlertHandle),this._hideAlertHandle=null)}_showAuthErrorAlert(e,t){this._alertElement&&this._alertElement.hide(),this._alertElement=this._createToastAlert(),this._alertElement.type=ic.AUTH,this._alertElement.show(e,t,()=>this._createLoginPopup()),this.fire("iron-announce",{text:e},{bubbles:!0}),this._refreshingCredentials=!0,this._requestCheckLoggedIn(),document.hidden||this._handleVisibilityChange()}_createToastAlert(){const e=document.createElement("gr-alert");return e.toast=!0,e}_handleVisibilityChange(){if(!1!==document.hidden)return;const e=Date.now()-this._lastCredentialCheck;!this._refreshingCredentials&&void 0!==this.knownAccountId&&e>6e5&&(this._lastCredentialCheck=Date.now(),this._checkSignedIn())}_requestCheckLoggedIn(){this.debounce("checkLoggedIn",this._checkSignedIn,6e4)}_checkSignedIn(){this._lastCredentialCheck=Date.now(),this.$.restAPI.invalidateAccountsCache(),this._authService.clearCache(),this.$.restAPI.getLoggedIn().then(e=>{this._refreshingCredentials&&(e?this.$.restAPI.getAccount().then(e=>{if(this._refreshingCredentials){if((null==e?void 0:e._account_id)!==this.knownAccountId)return void this._reloadPage();this._handleCredentialRefreshed()}}):this._requestCheckLoggedIn())})}_reloadPage(){window.location.reload()}_createLoginPopup(){const e=["width=690","height=500",`left=${window.screenLeft+(window.outerWidth-690)/2}`,`top=${window.screenTop+(window.outerHeight-500)/2}`];window.open(j()+"/login/%3FcloseAfterLogin","_blank",e.join(",")),this.listen(window,"focus","_handleWindowFocus")}_handleCredentialRefreshed(){this.unlisten(window,"focus","_handleWindowFocus"),this._refreshingCredentials=!1,this._hideAlert(),this._showAlert("Credentials refreshed."),this.$.noInteractionOverlay.close(),this._authService.clearCache()}_handleWindowFocus(){this.flushDebouncer("checkLoggedIn")}_handleShowErrorDialog(e){this._showErrorDialog(e.detail.message)}_handleDismissErrorDialog(){this.$.errorOverlay.close()}_showErrorDialog(e,t){this.reporting.reportErrorDialog(e),this.$.errorDialog.text=e,this.$.errorDialog.showSignInButton=!!t&&!!t.showSignInButton,this.$.errorOverlay.open()}};gE([Bl({type:Number})],_E.prototype,"knownAccountId",void 0),gE([Bl({type:Object})],_E.prototype,"_alertElement",void 0),gE([Bl({type:Number})],_E.prototype,"_hideAlertHandle",void 0),gE([Bl({type:Boolean})],_E.prototype,"_refreshingCredentials",void 0),gE([Bl({type:Number})],_E.prototype,"_lastCredentialCheck",void 0),gE([Bl({type:String})],_E.prototype,"loginUrl",void 0),_E=gE([Ml("gr-error-manager")],_E);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const fE=ta`
  <style include="shared-styles">
    .key {
      background-color: var(--chip-background-color);
      border: 1px solid var(--border-color);
      border-radius: var(--border-radius);
      display: inline-block;
      font-weight: var(--font-weight-bold);
      padding: var(--spacing-xxs) var(--spacing-m);
      text-align: center;
    }
  </style>
  <template is="dom-repeat" items="[[binding]]">
    <template is="dom-if" if="[[index]]">
      or
    </template>
    <template is="dom-repeat" items="[[_computeModifiers(item)]]" as="modifier">
      <span class="key modifier">[[modifier]]</span>
    </template>
    <span class="key">[[_computeKey(item)]]</span>
  </template>
`;var vE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let yE=class extends(oo(dr(oa))){constructor(){super(...arguments),this.binding=[]}static get template(){return fE}_computeModifiers(e){return e.slice(0,e.length-1)}_computeKey(e){return e[e.length-1]}};vE([Bl({type:Array})],yE.prototype,"binding",void 0),yE=vE([Ml("gr-key-binding-display")],yE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const bE=ta`
  <style include="shared-styles">
    :host {
      display: block;
      max-height: 100vh;
      overflow-y: auto;
    }
    header {
      padding: var(--spacing-l);
    }
    main {
      display: flex;
      padding: 0 var(--spacing-xxl) var(--spacing-xxl);
    }
    header {
      align-items: center;
      border-bottom: 1px solid var(--border-color);
      display: flex;
      justify-content: space-between;
    }
    table:last-of-type {
      margin-left: var(--spacing-xxl);
    }
    td {
      padding: var(--spacing-xs) 0;
    }
    td:first-child {
      padding-right: var(--spacing-m);
      text-align: right;
    }
    .header {
      font-weight: var(--font-weight-bold);
      padding-top: var(--spacing-l);
    }
    .modifier {
      font-weight: var(--font-weight-normal);
    }
  </style>
  <header>
    <h3 class="heading-3">Keyboard shortcuts</h3>
    <gr-button link="" on-click="_handleCloseTap">Close</gr-button>
  </header>
  <main>
    <table>
      <tbody>
        <template is="dom-repeat" items="[[_left]]">
          <tr>
            <td></td>
            <td class="header">[[item.section]]</td>
          </tr>
          <template is="dom-repeat" items="[[item.shortcuts]]" as="shortcut">
            <tr>
              <td>
                <gr-key-binding-display binding="[[shortcut.binding]]">
                </gr-key-binding-display>
              </td>
              <td>[[shortcut.text]]</td>
            </tr>
          </template>
        </template>
      </tbody>
    </table>
    <template is="dom-if" if="[[_right]]">
      <table>
        <tbody>
          <template is="dom-repeat" items="[[_right]]">
            <tr>
              <td></td>
              <td class="header">[[item.section]]</td>
            </tr>
            <template is="dom-repeat" items="[[item.shortcuts]]" as="shortcut">
              <tr>
                <td>
                  <gr-key-binding-display binding="[[shortcut.binding]]">
                  </gr-key-binding-display>
                </td>
                <td>[[shortcut.text]]</td>
              </tr>
            </template>
          </template>
        </tbody>
      </table>
    </template>
  </main>
  <footer></footer>
`;var wE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let CE=class extends(xp(oo(dr(oa)))){constructor(){super(),this.keyboardShortcutDirectoryListener=e=>this._onDirectoryUpdated(e)}static get template(){return bE}ready(){super.ready(),this._ensureAttribute("role","dialog")}attached(){super.attached(),this.addKeyboardShortcutDirectoryListener(this.keyboardShortcutDirectoryListener)}detached(){super.detached(),this.removeKeyboardShortcutDirectoryListener(this.keyboardShortcutDirectoryListener)}_handleCloseTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("close",{composed:!0,bubbles:!1}))}_onDirectoryUpdated(e){if(!e)return;const t=[],n=[];e.has(vp.EVERYWHERE)&&t.push({section:vp.EVERYWHERE,shortcuts:e.get(vp.EVERYWHERE)}),e.has(vp.NAVIGATION)&&t.push({section:vp.NAVIGATION,shortcuts:e.get(vp.NAVIGATION)}),e.has(vp.ACTIONS)&&n.push({section:vp.ACTIONS,shortcuts:e.get(vp.ACTIONS)}),e.has(vp.REPLY_DIALOG)&&n.push({section:vp.REPLY_DIALOG,shortcuts:e.get(vp.REPLY_DIALOG)}),e.has(vp.FILE_LIST)&&n.push({section:vp.FILE_LIST,shortcuts:e.get(vp.FILE_LIST)}),e.has(vp.DIFFS)&&n.push({section:vp.DIFFS,shortcuts:e.get(vp.DIFFS)}),this.set("_left",t),this.set("_right",n)}};wE([Bl({type:Array})],CE.prototype,"_left",void 0),wE([Bl({type:Array})],CE.prototype,"_right",void 0),CE=wE([Ml("gr-keyboard-shortcuts-dialog")],CE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const EE=ta`
  <style include="shared-styles">
    gr-dropdown {
      padding: 0 var(--spacing-m);
      --gr-button: {
        color: var(--header-text-color);
      }
      --gr-dropdown-item: {
        color: var(--primary-text-color);
      }
    }
    gr-avatar {
      height: 2em;
      width: 2em;
      vertical-align: middle;
    }
  </style>
  <gr-dropdown
    link=""
    items="[[links]]"
    top-content="[[topContent]]"
    on-tap-item-shortcuts="_handleShortcutsTap"
    horizontal-align="right"
  >
    <span hidden$="[[_hasAvatars]]" hidden="">[[_accountName(account)]]</span>
    <gr-avatar
      account="[[account]]"
      hidden$="[[!_hasAvatars]]"
      hidden=""
      image-size="56"
      aria-label="Account avatar"
    ></gr-avatar>
  </gr-dropdown>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var SE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const AE=/\${([\w]+)}/g;let xE=class extends(oo(dr(oa))){constructor(){super(...arguments),this._path="/",this._hasAvatars=!1,this._switchAccountUrl=""}static get template(){return EE}attached(){super.attached(),this._handleLocationChange(),this.listen(window,"location-change","_handleLocationChange"),this.$.restAPI.getConfig().then(e=>{this.config=e,e&&e.auth&&e.auth.switch_account_url?this._switchAccountUrl=e.auth.switch_account_url:this._switchAccountUrl="",this._hasAvatars=!!(e&&e.plugin&&e.plugin.has_avatars)})}detached(){super.detached(),this.unlisten(window,"location-change","_handleLocationChange")}_getLinks(e,t){if(void 0===e||void 0===t)return;const n=[];if(n.push({name:"Settings",url:"/settings/"}),n.push({name:"Keyboard Shortcuts",id:"shortcuts"}),e){const i={path:t},o=this._interpolateUrl(e,i);n.push({name:"Switch account",url:o,external:!0})}return n.push({name:"Sign out",url:"/logout"}),n}_getTopContent(e){return[{text:this._accountName(e),bold:!0},{text:(null==e?void 0:e.email)?e.email:""}]}_handleShortcutsTap(){this.dispatchEvent(new CustomEvent("show-keyboard-shortcuts",{bubbles:!0,composed:!0}))}_handleLocationChange(){this._path=window.location.pathname+window.location.search+window.location.hash}_interpolateUrl(e,t){return e.replace(AE,(e,n)=>t[n]||"")}_accountName(e){return ol(this.config,e)}};SE([Bl({type:Object})],xE.prototype,"account",void 0),SE([Bl({type:Object})],xE.prototype,"config",void 0),SE([Bl({type:Array,computed:"_getLinks(_switchAccountUrl, _path)"})],xE.prototype,"links",void 0),SE([Bl({type:Array,computed:"_getTopContent(account)"})],xE.prototype,"topContent",void 0),SE([Bl({type:String})],xE.prototype,"_path",void 0),SE([Bl({type:Boolean})],xE.prototype,"_hasAvatars",void 0),SE([Bl({type:String})],xE.prototype,"_switchAccountUrl",void 0),xE=SE([Ml("gr-account-dropdown")],xE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const PE=ta`
  <style include="shared-styles">
    form {
      display: flex;
    }
    gr-autocomplete {
      background-color: var(--view-background-color);
      border-radius: var(--border-radius);
      flex: 1;
      outline: none;
    }
  </style>
  <form>
    <gr-autocomplete
      label="[[label]]"
      show-search-icon=""
      id="searchInput"
      text="{{_inputVal}}"
      query="[[query]]"
      on-commit="_handleInputCommit"
      allow-non-suggested-values=""
      multi=""
      threshold="[[_threshold]]"
      tab-complete=""
      vertical-offset="30"
    >
      <a
        slot="suffix"
        href$="[[_computeHelpDocLink(docBaseUrl)]]"
        target="_blank"
        class="help"
      >
        <iron-icon
          icon="gr-icons:help-outline"
          title="read documentation"
        ></iron-icon>
      </a>
    </gr-autocomplete>
  </form>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var RE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const TE=["added:","age:","age:1week","assignee:","author:","branch:","bug:","cc:","cc:self","change:","cherrypickof:","comment:","commentby:","commit:","committer:","conflicts:","deleted:","delta:","dir:","directory:","ext:","extension:","file:","footer:","from:","has:","has:draft","has:edit","has:star","has:stars","has:unresolved","hashtag:","intopic:","is:","is:abandoned","is:assigned","is:closed","is:ignored","is:merged","is:open","is:owner","is:private","is:reviewed","is:reviewer","is:starred","is:submittable","is:watched","is:wip","label:","message:","onlyexts:","onlyextensions:","owner:","ownerin:","parentproject:","project:","projects:","query:","ref:","reviewedby:","reviewer:","reviewer:self","reviewerin:","size:","star:","status:","status:abandoned","status:closed","status:merged","status:open","status:reviewed","submissionid:","topic:","tr:"],IE=new Set(TE.concat(TE.map(e=>`-${e}`))),kE=/(?:[^\s"]+|"[^"]*")+\s*/g;let OE=class extends(xp(oo(dr(oa)))){constructor(){super(),this.value="",this.keyEventTarget=document.body,this.projectSuggestions=()=>Promise.resolve([]),this.groupSuggestions=()=>Promise.resolve([]),this.accountSuggestions=()=>Promise.resolve([]),this._threshold=1,this.label="",this.docBaseUrl=null,this.query=e=>this._getSearchSuggestions(e)}static get template(){return PE}attached(){super.attached(),this.$.restAPI.getConfig().then(e=>{const t=e&&e.change&&e.change.mergeability_computation_behavior;"API_REF_UPDATED_AND_CHANGE_REINDEX"!==t&&"REF_UPDATED_AND_CHANGE_REINDEX"!==t||this._addOperator("is:mergeable"),e&&U(e,this.$.restAPI).then(e=>{this.docBaseUrl=e})})}_computeHelpDocLink(e){let t=e||"https://gerrit-review.googlesource.com/documentation/";return t.endsWith("/")&&(t=t.substring(0,t.length-1)),`${t}/user-search.html`}_addOperator(e,t=!0){IE.add(e),t&&IE.add(`-${e}`)}keyboardShortcuts(){return{[yp.SEARCH]:"_handleSearch"}}_valueChanged(e){this._inputVal=e}_handleInputCommit(e){this._preventDefaultAndNavigateToInputVal(e)}_preventDefaultAndNavigateToInputVal(e){e.preventDefault();const t=qo(e).rootTarget;t.$.input?t.$.input.blur():t.blur();const n=this._inputVal&&this._inputVal.trim();if(n){if([...IE].some(e=>e.endsWith(":")&&e===n))return;this.dispatchEvent(new CustomEvent("handle-search",{detail:{inputVal:this._inputVal}}))}}_fetchSuggestions(e){const t=e.split(":"),n=t[0],i=t[1]||"";switch(n){case"ownerin":case"reviewerin":return this.groupSuggestions(n,i);case"parentproject":case"project":return this.projectSuggestions(n,i);case"author":case"cc":case"commentby":case"committer":case"from":case"owner":case"reviewedby":case"reviewer":return this.accountSuggestions(n,i);default:return Promise.resolve([...IE].filter(t=>t.includes(e)).map(e=>({text:e})))}}_getSearchSuggestions(e){const t=e.match(kE);if(null===t)return Promise.resolve([]);const n=t[t.length-1].toLowerCase();return this._fetchSuggestions(n).then(e=>e&&e.length?e.sort((e,t)=>{var i,o;const s=null===(i=e.text)||void 0===i?void 0:i.toLowerCase().indexOf(n),r=null===(o=t.text)||void 0===o?void 0:o.toLowerCase().indexOf(n);return void 0===s&&void 0===r?0:void 0===s&&void 0!==r?1:void 0!==s&&void 0===r?-1:s===r?e.text.localeCompare(t.text):-1===s?1:-1===r?-1:s-r}).slice(0,9).map(({text:e,label:t})=>({name:e,value:e,label:t})):[])}_handleSearch(e){const t=this.getKeyboardEvent(e);this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)&&!t.shiftKey||(e.preventDefault(),this.$.searchInput.focus(),this.$.searchInput.selectAll())}};RE([Bl({type:String,notify:!0,observer:"_valueChanged"})],OE.prototype,"value",void 0),RE([Bl({type:Object})],OE.prototype,"keyEventTarget",void 0),RE([Bl({type:Object})],OE.prototype,"query",void 0),RE([Bl({type:Object})],OE.prototype,"projectSuggestions",void 0),RE([Bl({type:Object})],OE.prototype,"groupSuggestions",void 0),RE([Bl({type:Object})],OE.prototype,"accountSuggestions",void 0),RE([Bl({type:String})],OE.prototype,"_inputVal",void 0),RE([Bl({type:Number})],OE.prototype,"_threshold",void 0),RE([Bl({type:String})],OE.prototype,"label",void 0),RE([Bl({type:String})],OE.prototype,"docBaseUrl",void 0),OE=RE([Ml("gr-search-bar")],OE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const NE=ta`
  <style include="shared-styles"></style>
  <gr-search-bar
    id="search"
    label="[[label]]"
    value="{{searchQuery}}"
    on-handle-search="_handleSearch"
    project-suggestions="[[_projectSuggestions]]"
    group-suggestions="[[_groupSuggestions]]"
    account-suggestions="[[_accountSuggestions]]"
  ></gr-search-bar>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;class LE extends(oo(dr(oa))){static get template(){return NE}static get is(){return"gr-smart-search"}static get properties(){return{searchQuery:String,_config:Object,_projectSuggestions:{type:Function,value(){return(e,t)=>this._fetchProjects(e,t)}},_groupSuggestions:{type:Function,value(){return(e,t)=>this._fetchGroups(e,t)}},_accountSuggestions:{type:Function,value(){return(e,t)=>this._fetchAccounts(e,t)}},label:{type:String,value:""}}}attached(){super.attached(),this.$.restAPI.getConfig().then(e=>{this._config=e})}_handleSearch(e){const t=e.detail.inputVal;t&&gh.navigateToSearchQuery(t)}_fetchProjects(e,t){return this.$.restAPI.getSuggestedProjects(t,10).then(t=>{if(!t)return[];return Object.keys(t).map(t=>({text:e+":"+t}))})}_fetchGroups(e,t){return 0===t.length?Promise.resolve([]):this.$.restAPI.getSuggestedGroups(t,10).then(t=>{if(!t)return[];return Object.keys(t).map(t=>({text:e+":"+t}))})}_fetchAccounts(e,t){return 0===t.length?Promise.resolve([]):this.$.restAPI.getSuggestedAccounts(t,10).then(t=>t?this._mapAccountsHelper(t,e):[]).then(n=>"self".startsWith(t)?n.concat([{text:e+":self"}]):"me".startsWith(t)?n.concat([{text:e+":me"}]):n)}_mapAccountsHelper(e,t){return e.map(e=>{const n=ol(this._serverConfig,e);return{label:e.name||"",text:e.email?`${t}:${e.email}`:`${t}:"${n}"`}})}}customElements.define(LE.is,LE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const DE=ta`
  <style include="shared-styles">
    :host {
      display: block;
    }
    nav {
      align-items: center;
      display: flex;
    }
    .bigTitle {
      color: var(--header-text-color);
      font-size: var(--header-title-font-size);
      text-decoration: none;
    }
    .bigTitle:hover {
      text-decoration: underline;
    }
    .titleText::before {
      background-image: var(--header-icon);
      background-size: var(--header-icon-size) var(--header-icon-size);
      background-repeat: no-repeat;
      content: '';
      display: inline-block;
      height: var(--header-icon-size);
      margin-right: calc(var(--header-icon-size) / 4);
      vertical-align: text-bottom;
      width: var(--header-icon-size);
    }
    .titleText::after {
      content: var(--header-title-content);
    }
    ul {
      list-style: none;
      padding-left: var(--spacing-l);
    }
    .links > li {
      cursor: default;
      display: inline-block;
      padding: 0;
      position: relative;
    }
    .linksTitle {
      display: inline-block;
      font-weight: var(--font-weight-bold);
      position: relative;
      text-transform: uppercase;
    }
    .linksTitle:hover {
      opacity: 0.75;
    }
    .rightItems {
      align-items: center;
      display: flex;
      flex: 1;
      justify-content: flex-end;
    }
    .rightItems gr-endpoint-decorator:not(:empty) {
      margin-left: var(--spacing-l);
    }
    gr-smart-search {
      flex-grow: 1;
      margin: 0 var(--spacing-m);
      max-width: 500px;
    }
    gr-dropdown,
    .browse {
      padding: var(--spacing-m);
    }
    gr-dropdown {
      --gr-dropdown-item: {
        color: var(--primary-text-color);
      }
    }
    .settingsButton {
      margin-left: var(--spacing-m);
    }
    .browse {
      color: var(--header-text-color);
      /* Same as gr-button */
      margin: 5px 4px;
      text-decoration: none;
    }
    .invisible,
    .settingsButton,
    gr-account-dropdown {
      display: none;
    }
    :host([loading]) .accountContainer,
    :host([logged-in]) .loginButton,
    :host([logged-in]) .registerButton {
      display: none;
    }
    :host([logged-in]) .settingsButton,
    :host([logged-in]) gr-account-dropdown {
      display: inline;
    }
    .accountContainer {
      align-items: center;
      display: flex;
      margin: 0 calc(0 - var(--spacing-m)) 0 var(--spacing-m);
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
    }
    .loginButton,
    .registerButton {
      padding: var(--spacing-m) var(--spacing-l);
    }
    .dropdown-trigger {
      text-decoration: none;
    }
    .dropdown-content {
      background-color: var(--view-background-color);
      box-shadow: var(--elevation-level-2);
    }
    /*
       * We are not using :host to do this, because :host has a lowest css priority
       * compared to others. This means that using :host to do this would break styles.
       */
    .linksTitle,
    .bigTitle,
    .loginButton,
    .registerButton,
    iron-icon,
    gr-account-dropdown {
      color: var(--header-text-color);
    }
    #mobileSearch {
      display: none;
    }
    @media screen and (max-width: 50em) {
      .bigTitle {
        font-family: var(--header-font-family);
        font-size: var(--font-size-h3);
        font-weight: var(--font-weight-h3);
        line-height: var(--line-height-h3);
      }
      gr-smart-search,
      .browse,
      .rightItems .hideOnMobile,
      .links > li.hideOnMobile {
        display: none;
      }
      #mobileSearch {
        display: inline-flex;
      }
      .accountContainer {
        margin-left: var(--spacing-m) !important;
      }
      gr-dropdown {
        padding: var(--spacing-m) 0 var(--spacing-m) var(--spacing-m);
      }
    }
  </style>
  <nav>
    <a href$="[[_computeRelativeURL('/')]]" class="bigTitle">
      <gr-endpoint-decorator name="header-title">
        <span class="titleText"></span>
      </gr-endpoint-decorator>
    </a>
    <ul class="links">
      <template is="dom-repeat" items="[[_links]]" as="linkGroup">
        <li class$="[[_computeLinkGroupClass(linkGroup)]]">
          <gr-dropdown
            link=""
            down-arrow=""
            items="[[linkGroup.links]]"
            horizontal-align="left"
          >
            <span class="linksTitle" id="[[linkGroup.title]]">
              [[linkGroup.title]]
            </span>
          </gr-dropdown>
        </li>
      </template>
    </ul>
    <div class="rightItems">
      <gr-endpoint-decorator
        class="hideOnMobile"
        name="header-small-banner"
      ></gr-endpoint-decorator>
      <gr-smart-search
        id="search"
        label="Search for changes"
        search-query="{{searchQuery}}"
      ></gr-smart-search>
      <gr-endpoint-decorator
        class="hideOnMobile"
        name="header-browse-source"
      ></gr-endpoint-decorator>
      <div class="accountContainer" id="accountContainer">
        <iron-icon
          id="mobileSearch"
          icon="gr-icons:search"
          on-tap="_onMobileSearchTap"
          role="button"
          aria-label="[[_computeShowHideAriaLabel(mobileSearchHidden)]]"
        ></iron-icon>
        <div class$="[[_computeIsInvisible(_registerURL)]]">
          <a class="registerButton" href$="[[_registerURL]]">
            [[_registerText]]
          </a>
        </div>
        <a class="loginButton" href$="[[loginUrl]]">Sign in</a>
        <a
          class="settingsButton"
          href$="[[_generateSettingsLink()]]"
          title="Settings"
          aria-label="Settings"
          role="button"
        >
          <iron-icon icon="gr-icons:settings"></iron-icon>
        </a>
        <template is="dom-if" if="[[_account]]">
          <gr-account-dropdown account="[[_account]]"></gr-account-dropdown>
        </template>
      </div>
    </div>
  </nav>
  <gr-js-api-interface id="jsAPI"></gr-js-api-interface>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,$E=[{title:"Changes",links:[{url:"/q/status:open+-is:wip",name:"Open"},{url:"/q/status:merged",name:"Merged"},{url:"/q/status:abandoned",name:"Abandoned"}]}],ME=[{url:"/index.html",name:"Table of Contents"},{url:"/user-search.html",name:"Searching"},{url:"/user-upload.html",name:"Uploading"},{url:"/access-control.html",name:"Access Control"},{url:"/rest-api.html",name:"REST API"},{url:"/intro-project-owner.html",name:"Project Owner Guide"}],FE=new Set(["LDAP","LDAP_BIND","CUSTOM_EXTENSION"]);class BE extends(oo(dr(oa))){static get template(){return DE}static get is(){return"gr-main-header"}static get properties(){return{searchQuery:{type:String,notify:!0},loggedIn:{type:Boolean,reflectToAttribute:!0},loading:{type:Boolean,reflectToAttribute:!0},_account:Object,_adminLinks:{type:Array,value:()=>[]},_defaultLinks:{type:Array,value:()=>$E},_docBaseUrl:{type:String,value:null},_links:{type:Array,computed:"_computeLinks(_defaultLinks, _userLinks, _adminLinks, _topMenus, _docBaseUrl)"},loginUrl:{type:String,value:"/login"},_userLinks:{type:Array,value:()=>[]},_topMenus:{type:Array,value:()=>[]},_registerText:{type:String,value:"Sign up"},_registerURL:{type:String,value:null},mobileSearchHidden:{type:Boolean,value:!1}}}static get observers(){return["_accountLoaded(_account)"]}ready(){super.ready(),this._ensureAttribute("role","banner")}attached(){super.attached(),this._loadAccount(),this._loadConfig()}detached(){super.detached()}reload(){this._loadAccount()}_computeRelativeURL(e){return"//"+window.location.host+j()+e}_computeLinks(e,t,n,i,o){if([e,t,n,i,o].includes(void 0))return;const s=e.map(e=>({title:e.title,links:e.links.slice()}));t&&t.length>0&&s.push({title:"Your",links:t.slice()});const r=this._getDocLinks(o,ME);r.length&&s.push({title:"Documentation",links:r,class:"hideOnMobile"}),s.push({title:"Browse",links:n.slice()});const a=[];s.forEach(e=>{a[e.title]=e.links});for(const e of i){const t=e.items.map(this._fixCustomMenuItem).filter(e=>!e.url.includes("${projectName}"));e.name in a?t.forEach(t=>{a[e.name].push(t)}):s.push({title:e.name,links:a[e.name]=t})}return s}_getDocLinks(e,t){return e&&t?t.map(t=>{let n=e;return n&&"/"===n[n.length-1]&&(n=n.substring(0,n.length-1)),{url:n+t.url,name:t.name,target:"_blank"}}):[]}_loadAccount(){this.loading=!0;const e=[this.$.restAPI.getAccount(),this.$.restAPI.getTopMenus(),eh().awaitPluginsLoaded()];return Promise.all(e).then(e=>{const t=e[0];return this._account=t,this.loggedIn=!!t,this.loading=!1,this._topMenus=e[1],E_(t,e=>this.$.restAPI.getAccountCapabilities(e),()=>this.$.jsAPI.getAdminMenuLinks()).then(e=>{this._adminLinks=e.links})})}_loadConfig(){this.$.restAPI.getConfig().then(e=>(this._retrieveRegisterURL(e),U(e,this.$.restAPI))).then(e=>{this._docBaseUrl=e})}_accountLoaded(e){e&&this.$.restAPI.getPreferences().then(e=>{this._userLinks=e&&e.my?e.my.map(this._fixCustomMenuItem):[]})}_retrieveRegisterURL(e){FE.has(e.auth.auth_type)&&(this._registerURL=e.auth.register_url,e.auth.register_text&&(this._registerText=e.auth.register_text))}_computeIsInvisible(e){return e?"":"invisible"}_fixCustomMenuItem(e){return e.url.startsWith("#")&&(e.url=e.url.slice(1)),delete e.target,e}_generateSettingsLink(){return j()+"/settings/"}_onMobileSearchTap(e){e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent("mobile-search",{composed:!0,bubbles:!1}))}_computeLinkGroupClass(e){return e&&e.class?e.class:""}_computeShowHideAriaLabel(e){return e?"Show Searchbar":"Hide Searchbar"}}customElements.define(BE.is,BE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const jE=ta`
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var HE=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const UE={ROOT:"/",DASHBOARD:/^\/dashboard\/(.+)$/,CUSTOM_DASHBOARD:/^\/dashboard\/?$/,PROJECT_DASHBOARD:/^\/p\/(.+)\/\+\/dashboard\/(.+)/,LEGACY_PROJECT_DASHBOARD:/^\/projects\/(.+),dashboards\/(.+)/,AGREEMENTS:/^\/settings\/agreements\/?/,NEW_AGREEMENTS:/^\/settings\/new-agreement\/?/,REGISTER:/^\/register(\/.*)?$/,LOG_IN_OR_OUT:/\/log(in|out)(\/(.+))?$/,DEFAULT:/.*/,GROUP:/^\/admin\/groups\/(?:uuid-)?([^,]+)$/,GROUP_SELF:/^\/groups\/self/,GROUP_INFO:/^\/admin\/groups\/(?:uuid-)?(.+),info$/,GROUP_AUDIT_LOG:/^\/admin\/groups\/(?:uuid-)?(.+),audit-log$/,GROUP_MEMBERS:/^\/admin\/groups\/(?:uuid-)?(.+),members$/,GROUP_LIST_OFFSET:/^\/admin\/groups(,(\d+))?(\/)?$/,GROUP_LIST_FILTER:"/admin/groups/q/filter::filter",GROUP_LIST_FILTER_OFFSET:"/admin/groups/q/filter::filter,:offset",LEGACY_CREATE_PROJECT:/^\/admin\/create-project\/?$/,LEGACY_CREATE_GROUP:/^\/admin\/create-group\/?$/,PROJECT_OLD:/^\/admin\/(projects)\/?(.+)?$/,REPO:/^\/admin\/repos\/([^,]+)$/,REPO_COMMANDS:/^\/admin\/repos\/(.+),commands$/,REPO_ACCESS:/^\/admin\/repos\/(.+),access$/,REPO_DASHBOARDS:/^\/admin\/repos\/(.+),dashboards$/,REPO_LIST_OFFSET:/^\/admin\/repos(,(\d+))?(\/)?$/,REPO_LIST_FILTER:"/admin/repos/q/filter::filter",REPO_LIST_FILTER_OFFSET:"/admin/repos/q/filter::filter,:offset",BRANCH_LIST_OFFSET:/^\/admin\/repos\/(.+),branches(,(.+))?$/,BRANCH_LIST_FILTER:"/admin/repos/:repo,branches/q/filter::filter",BRANCH_LIST_FILTER_OFFSET:"/admin/repos/:repo,branches/q/filter::filter,:offset",TAG_LIST_OFFSET:/^\/admin\/repos\/(.+),tags(,(.+))?$/,TAG_LIST_FILTER:"/admin/repos/:repo,tags/q/filter::filter",TAG_LIST_FILTER_OFFSET:"/admin/repos/:repo,tags/q/filter::filter,:offset",PLUGINS:/^\/plugins\/(.+)$/,PLUGIN_LIST:/^\/admin\/plugins(\/)?$/,PLUGIN_LIST_OFFSET:/^\/admin\/plugins(,(\d+))?(\/)?$/,PLUGIN_LIST_FILTER:"/admin/plugins/q/filter::filter",PLUGIN_LIST_FILTER_OFFSET:"/admin/plugins/q/filter::filter,:offset",QUERY:/^\/q\/([^,]+)(,(\d+))?$/,QUERY_LEGACY_SUFFIX:/^\/q\/.+,n,z$/,CHANGE_ID_QUERY:/^\/id\/(I[0-9a-f]{40})$/,CHANGE_LEGACY:/^\/c\/(\d+)\/?(((-?\d+|edit)(\.\.(\d+|edit))?))?\/?$/,CHANGE_NUMBER_LEGACY:/^\/(\d+)\/?/,CHANGE:/^\/c\/(.+)\/\+\/(\d+)(\/?((-?\d+|edit)(\.\.(\d+|edit))?))?\/?$/,CHANGE_EDIT:/^\/c\/(.+)\/\+\/(\d+)(\/(\d+))?,edit\/?$/,COMMENT:/^\/c\/(.+)\/\+\/(\d+)\/comment\/(\w+)\/?$/,DIFF:/^\/c\/(.+)\/\+\/(\d+)(\/((-?\d+|edit)(\.\.(\d+|edit))?(\/(.+))))\/?$/,DIFF_EDIT:/^\/c\/(.+)\/\+\/(\d+)\/(\d+|edit)\/(.+),edit(#\d+)?$/,DIFF_LEGACY:/^\/c\/(\d+)\/((-?\d+|edit)(\.\.(\d+|edit))?)\/(.+)/,DIFF_LEGACY_LINENUM:/^\/c\/((.+)\/\+\/)?(\d+)(\/?((-?\d+|edit)(\.\.(\d+|edit))?\/(.+))?)@[ab]?\d+$/,SETTINGS:/^\/settings\/?/,SETTINGS_LEGACY:/^\/settings\/VE\/(\S+)/,IMPROPERLY_ENCODED_PLUS:/^\/c\/(.+)\/ \/(.+)$/,PLUGIN_SCREEN:/^\/x\/([\w-]+)\/([\w-]+)\/?/,DOCUMENTATION_SEARCH_FILTER:"/Documentation/q/filter::filter",DOCUMENTATION_SEARCH:/^\/Documentation\/q\/(.*)$/,DOCUMENTATION:/^\/Documentation(\/)?(.+)?/},GE=/^([ab]?)(\d+)$/,VE=/\+/g,zE=/^\?*/,WE=/@([ab]?\d+)$/,qE=/,n,z$/,KE=/\${(project|repo)}/g,YE=document.querySelector("#app");YE||console.info("No gr-app found (running tests)"),window.addEventListener("WebComponentsReady",()=>{n.reportingService.timeEnd("WebComponentsReady")});let XE=class extends(oo(dr(oa))){constructor(){super(),this._app=YE,this._isInitialLoad=!0,this.reporting=n.reportingService}static get template(){return jE}start(){this._app&&this._startRouter()}_setParams(e){this._appElement().params=e}_appElement(){return document.getElementById("app-element")||document.getElementById("app").shadowRoot.getElementById("app-element")}_redirect(e){this._isRedirecting=!0,hd.redirect(e)}_generateUrl(e){const t=j();let n="";return e.view===dh.SEARCH?n=this._generateSearchUrl(e):e.view===dh.CHANGE?n=this._generateChangeUrl(e):e.view===dh.DASHBOARD?n=this._generateDashboardUrl(e):e.view===dh.DIFF||e.view===dh.EDIT?n=this._generateDiffOrEditUrl(e):e.view===dh.GROUP?n=this._generateGroupUrl(e):e.view===dh.REPO?n=this._generateRepoUrl(e):e.view===dh.ROOT?n="/":e.view===dh.SETTINGS?n=this._generateSettingsUrl():s(e,"Can't generate"),t+n}_generateWeblinks(e){switch(e.type){case uh.FILE:return this._getFileWebLinks(e);case uh.CHANGE:return this._getChangeWeblinks(e);case uh.PATCHSET:return this._getPatchSetWeblink(e);default:return console.warn(`Unsupported weblink ${e.type}!`),[]}}_getPatchSetWeblink(e){const{commit:t,options:n}=e,{weblinks:i,config:o}=n||{},s=t&&t.slice(0,7),r=this._getBrowseCommitWeblink(i,o);return r&&r.url?{name:s,url:r.url}:{name:s}}_firstCodeBrowserWeblink(e){const t=["gitiles","browse","gitweb"];for(let n=0;n<t.length;n++){const i=e.find(e=>e.name===t[n]);if(i)return i}return null}_getBrowseCommitWeblink(e,t){var n;if(!e)return null;let i;if(null===(n=null==t?void 0:t.gerrit)||void 0===n?void 0:n.primary_weblink_name){const n=t.gerrit.primary_weblink_name;i=e.find(e=>e.name===n)}return i||(i=this._firstCodeBrowserWeblink(e)),i||null}_getChangeWeblinks(e){var t,n;const i=null===(t=e.options)||void 0===t?void 0:t.weblinks,o=null===(n=e.options)||void 0===n?void 0:n.config;if(!i||!i.length)return[];const s=this._getBrowseCommitWeblink(i,o);return i.filter(e=>!s||!s.name||e.name!==s.name)}_getFileWebLinks(e){var t;return(null===(t=e.options)||void 0===t?void 0:t.weblinks)||[]}_generateSearchUrl(e){let t="";if(e.offset&&e.offset>0&&(t=`,${e.offset}`),e.query)return"/q/"+G(e.query,!0)+t;const n=[];return e.owner&&n.push("owner:"+G(e.owner,!1)),e.project&&n.push("project:"+G(e.project,!1)),e.branch&&n.push("branch:"+G(e.branch,!1)),e.topic&&n.push('topic:"'+G(e.topic,!1)+'"'),e.hashtag&&n.push('hashtag:"'+G(e.hashtag.toLowerCase(),!1)+'"'),e.statuses&&(1===e.statuses.length?n.push("status:"+G(e.statuses[0],!1)):e.statuses.length>1&&n.push("("+e.statuses.map(e=>`status:${G(e,!1)}`).join(" OR ")+")")),"/q/"+n.join("+")+t}_generateChangeUrl(e){let t=this._getPatchRangeExpression(e);t.length&&(t="/"+t);let n=`${t}`;if(e.querystring?n+="?"+e.querystring:e.edit&&(n+=",edit"),e.messageHash&&(n+=e.messageHash),e.project){return`/c/${G(e.project,!0)}/+/${e.changeNum}${n}`}return`/c/${e.changeNum}${n}`}_generateDashboardUrl(e){const t=e.repo||e.project||void 0;if(e.sections){const n=this._sectionsToEncodedParams(e.sections,t);return e.title&&n.push("title="+encodeURIComponent(e.title)),`/dashboard/${e.user?e.user:""}?${n.join("&")}`}if(t){return`/p/${G(t,!0)}/+/dashboard/${e.dashboard}`}return`/dashboard/${e.user||"self"}`}_sectionsToEncodedParams(e,t){return e.map(e=>{const n=t?e.query.replace(KE,t):e.query;return encodeURIComponent(e.name)+"="+encodeURIComponent(n)})}_generateDiffOrEditUrl(e){let t=this._getPatchRangeExpression(e);t.length&&(t="/"+t);let n=`${t}/${G(e.path||"",!0)}`;if(e.view===dh.EDIT&&(n+=",edit"),e.lineNum&&(n+="#",ch(e)&&e.leftSide&&(n+="b"),n+=e.lineNum),ch(e)&&e.commentId&&(n=`/comment/${e.commentId}`+n),e.project){return`/c/${G(e.project,!0)}/+/${e.changeNum}${n}`}return`/c/${e.changeNum}${n}`}_generateGroupUrl(e){let t=`/admin/groups/${G(`${e.groupId}`,!0)}`;return e.detail===hh.MEMBERS?t+=",members":e.detail===hh.LOG&&(t+=",audit-log"),t}_generateRepoUrl(e){let t=`/admin/repos/${G(`${e.repoName}`,!0)}`;return e.detail===ph.ACCESS?t+=",access":e.detail===ph.BRANCHES?t+=",branches":e.detail===ph.TAGS?t+=",tags":e.detail===ph.COMMANDS?t+=",commands":e.detail===ph.DASHBOARDS&&(t+=",dashboards"),t}_generateSettingsUrl(){return"/settings"}_getPatchRangeExpression(e){let t="";return e.patchNum&&(t=`${e.patchNum}`),e.basePatchNum&&(t=`${e.basePatchNum}..${t}`),t}_normalizeLegacyRouteParams(e){return e.changeNum?this.$.restAPI.getFromProjectLookup(e.changeNum).then(t=>{if(!t)return void this._show404();const n={...e,project:t};this._normalizePatchRangeParams(n),this._redirect(this._generateUrl(n))}):Promise.resolve()}_normalizePatchRangeParams(e){if(null===e.basePatchNum||void 0===e.basePatchNum)return!1;const t=null!==e.patchNum&&void 0!==e.patchNum;let n=!1;return e.patchNum&&Ch(e.basePatchNum,e.patchNum)?(n=!0,e.basePatchNum=null):t||(e.patchNum=e.basePatchNum,e.basePatchNum=null),n}_redirectToLogin(e){const t=j()||"";hd("/login/"+encodeURIComponent(e.substring(t.length)))}_getHashFromCanonicalPath(e){return e.split("#").slice(1).join("#")}_parseLineAddress(e){const t=e.match(GE);return t?{leftSide:!!t[1],lineNum:parseInt(t[2],10)}:null}_redirectIfNotLoggedIn(e){return this.$.restAPI.getLoggedIn().then(t=>t?Promise.resolve():(this._redirectToLogin(e.canonicalPath),Promise.reject(new Error)))}_loadUserMiddleware(e,t){this.$.restAPI.getLoggedIn().then(()=>{t()})}_queryStringMiddleware(e,t){let n=new Map;e.querystring&&(n=window.URLSearchParams?new URLSearchParams(e.querystring):new Map(this._parseQueryString(e.querystring))),e.queryMap=n,t()}_mapRoute(e,t,n){this[t]?hd(e,(e,t)=>this._loadUserMiddleware(e,t),(e,t)=>this._queryStringMiddleware(e,t),e=>{this.reporting.locationChanged(t),(n?this._redirectIfNotLoggedIn(e):Promise.resolve()).then(()=>{this[t](e)})}):console.error("Attempted to map route to unknown method: ",t)}_startRouter(){const e=j();e&&hd.base(e),gh.setup((e,t)=>{t?hd.redirect(e):hd.show(e)},e=>this._generateUrl(e),e=>this._generateWeblinks(e),e=>e),hd.exit("*",(e,t)=>{this._isRedirecting||this.reporting.beforeLocationChanged(),this._isRedirecting=!1,this._isInitialLoad=!1,t()}),hd((e,t)=>{document.body.scrollTop=0,e.hash.match(UE.PLUGIN_SCREEN)?this._redirect(e.hash):(this.async(()=>{this.dispatchEvent(new CustomEvent("location-change",{detail:{hash:window.location.hash,pathname:window.location.pathname},composed:!0,bubbles:!0}))},1),t())}),this._mapRoute(UE.ROOT,"_handleRootRoute"),this._mapRoute(UE.DASHBOARD,"_handleDashboardRoute"),this._mapRoute(UE.CUSTOM_DASHBOARD,"_handleCustomDashboardRoute"),this._mapRoute(UE.PROJECT_DASHBOARD,"_handleProjectDashboardRoute"),this._mapRoute(UE.LEGACY_PROJECT_DASHBOARD,"_handleLegacyProjectDashboardRoute"),this._mapRoute(UE.GROUP_INFO,"_handleGroupInfoRoute",!0),this._mapRoute(UE.GROUP_AUDIT_LOG,"_handleGroupAuditLogRoute",!0),this._mapRoute(UE.GROUP_MEMBERS,"_handleGroupMembersRoute",!0),this._mapRoute(UE.GROUP_LIST_OFFSET,"_handleGroupListOffsetRoute",!0),this._mapRoute(UE.GROUP_LIST_FILTER_OFFSET,"_handleGroupListFilterOffsetRoute",!0),this._mapRoute(UE.GROUP_LIST_FILTER,"_handleGroupListFilterRoute",!0),this._mapRoute(UE.GROUP_SELF,"_handleGroupSelfRedirectRoute",!0),this._mapRoute(UE.GROUP,"_handleGroupRoute",!0),this._mapRoute(UE.PROJECT_OLD,"_handleProjectsOldRoute"),this._mapRoute(UE.REPO_COMMANDS,"_handleRepoCommandsRoute",!0),this._mapRoute(UE.REPO_ACCESS,"_handleRepoAccessRoute"),this._mapRoute(UE.REPO_DASHBOARDS,"_handleRepoDashboardsRoute"),this._mapRoute(UE.BRANCH_LIST_OFFSET,"_handleBranchListOffsetRoute"),this._mapRoute(UE.BRANCH_LIST_FILTER_OFFSET,"_handleBranchListFilterOffsetRoute"),this._mapRoute(UE.BRANCH_LIST_FILTER,"_handleBranchListFilterRoute"),this._mapRoute(UE.TAG_LIST_OFFSET,"_handleTagListOffsetRoute"),this._mapRoute(UE.TAG_LIST_FILTER_OFFSET,"_handleTagListFilterOffsetRoute"),this._mapRoute(UE.TAG_LIST_FILTER,"_handleTagListFilterRoute"),this._mapRoute(UE.LEGACY_CREATE_GROUP,"_handleCreateGroupRoute",!0),this._mapRoute(UE.LEGACY_CREATE_PROJECT,"_handleCreateProjectRoute",!0),this._mapRoute(UE.REPO_LIST_OFFSET,"_handleRepoListOffsetRoute"),this._mapRoute(UE.REPO_LIST_FILTER_OFFSET,"_handleRepoListFilterOffsetRoute"),this._mapRoute(UE.REPO_LIST_FILTER,"_handleRepoListFilterRoute"),this._mapRoute(UE.REPO,"_handleRepoRoute"),this._mapRoute(UE.PLUGINS,"_handlePassThroughRoute"),this._mapRoute(UE.PLUGIN_LIST_OFFSET,"_handlePluginListOffsetRoute",!0),this._mapRoute(UE.PLUGIN_LIST_FILTER_OFFSET,"_handlePluginListFilterOffsetRoute",!0),this._mapRoute(UE.PLUGIN_LIST_FILTER,"_handlePluginListFilterRoute",!0),this._mapRoute(UE.PLUGIN_LIST,"_handlePluginListRoute",!0),this._mapRoute(UE.QUERY_LEGACY_SUFFIX,"_handleQueryLegacySuffixRoute"),this._mapRoute(UE.QUERY,"_handleQueryRoute"),this._mapRoute(UE.CHANGE_ID_QUERY,"_handleChangeIdQueryRoute"),this._mapRoute(UE.DIFF_LEGACY_LINENUM,"_handleLegacyLinenum"),this._mapRoute(UE.CHANGE_NUMBER_LEGACY,"_handleChangeNumberLegacyRoute"),this._mapRoute(UE.DIFF_EDIT,"_handleDiffEditRoute",!0),this._mapRoute(UE.CHANGE_EDIT,"_handleChangeEditRoute",!0),this._mapRoute(UE.COMMENT,"_handleCommentRoute"),this._mapRoute(UE.DIFF,"_handleDiffRoute"),this._mapRoute(UE.CHANGE,"_handleChangeRoute"),this._mapRoute(UE.CHANGE_LEGACY,"_handleChangeLegacyRoute"),this._mapRoute(UE.DIFF_LEGACY,"_handleDiffLegacyRoute"),this._mapRoute(UE.AGREEMENTS,"_handleAgreementsRoute",!0),this._mapRoute(UE.NEW_AGREEMENTS,"_handleNewAgreementsRoute",!0),this._mapRoute(UE.SETTINGS_LEGACY,"_handleSettingsLegacyRoute",!0),this._mapRoute(UE.SETTINGS,"_handleSettingsRoute",!0),this._mapRoute(UE.REGISTER,"_handleRegisterRoute"),this._mapRoute(UE.LOG_IN_OR_OUT,"_handlePassThroughRoute"),this._mapRoute(UE.IMPROPERLY_ENCODED_PLUS,"_handleImproperlyEncodedPlusRoute"),this._mapRoute(UE.PLUGIN_SCREEN,"_handlePluginScreen"),this._mapRoute(UE.DOCUMENTATION_SEARCH_FILTER,"_handleDocumentationSearchRoute"),this._mapRoute(UE.DOCUMENTATION_SEARCH,"_handleDocumentationSearchRedirectRoute"),this._mapRoute(UE.DOCUMENTATION,"_handleDocumentationRedirectRoute"),this._mapRoute(UE.DEFAULT,"_handleDefaultRoute"),hd.start()}_handleRootRoute(e){if(e.querystring.match(/^closeAfterLogin/))return window.close(),null;let t=this._getHashFromCanonicalPath(e.canonicalPath);if(t){"/"!==t[0]&&(t="/"+t),t.includes("/ /")&&e.canonicalPath.includes("/+/")&&(t=t.replace("/ /","/+/"));const n=j();let i=n+t;return t.startsWith("/VE/")&&(i=n+"/settings"+t),this._redirect(i),null}return this.$.restAPI.getLoggedIn().then(e=>{e?this._redirect("/dashboard/self"):this._redirect("/q/status:open+-is:wip")})}_decodeQueryString(e){return decodeURIComponent(e.replace(VE," "))}_parseQueryString(e){if(!(e=e.replace(zE,"")))return[];const t=[];return e.split("&").forEach(e=>{const n=e.indexOf("=");let i,o;n<0?(i=this._decodeQueryString(e),o=""):(i=this._decodeQueryString(e.substring(0,n)),o=this._decodeQueryString(e.substring(n+1))),i&&t.push([i,o])}),t}_handleDashboardRoute(e){return this.$.restAPI.getLoggedIn().then(t=>{t?this._setParams({view:dh.DASHBOARD,user:e.params[0]}):"self"===e.params[0].toLowerCase()?this._redirectToLogin(e.canonicalPath):this._redirect("/q/owner:"+encodeURIComponent(e.params[0]))})}_handleCustomDashboardRoute(e,t=window.location.search){const n=this._parseQueryString(t);let i="Custom Dashboard";const o=n.find(e=>"title"===e[0].toLowerCase());o&&(i=o[1]);const s=n.find(e=>"foreach"===e[0].toLowerCase());let r=null;s&&(r=s[1]);const a=n.filter(e=>e[0]&&e[1]&&"title"!==e[0].toLowerCase()&&"foreach"!==e[0].toLowerCase()).map(e=>{const t=r?`${r} ${e[1]}`:e[1];return{name:e[0],query:t}});return a.length>0?(this._setParams({view:dh.DASHBOARD,user:"self",sections:a,title:i}),Promise.resolve()):(this._redirect("/dashboard/self"),Promise.resolve())}_handleProjectDashboardRoute(e){const t=e.params[0];this._setParams({view:dh.DASHBOARD,project:t,dashboard:decodeURIComponent(e.params[1])}),this.reporting.setRepoName(t)}_handleLegacyProjectDashboardRoute(e){this._redirect("/p/"+e.params[0]+"/+/dashboard/"+e.params[1])}_handleGroupInfoRoute(e){this._redirect("/admin/groups/"+encodeURIComponent(e.params[0]))}_handleGroupSelfRedirectRoute(e){this._redirect("/settings/#Groups")}_handleGroupRoute(e){this._setParams({view:dh.GROUP,groupId:e.params[0]})}_handleGroupAuditLogRoute(e){this._setParams({view:dh.GROUP,detail:hh.LOG,groupId:e.params[0]})}_handleGroupMembersRoute(e){this._setParams({view:dh.GROUP,detail:hh.MEMBERS,groupId:e.params[0]})}_handleGroupListOffsetRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-admin-group-list",offset:e.params[1]||0,filter:null,openCreateModal:"create"===e.hash})}_handleGroupListFilterOffsetRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-admin-group-list",offset:e.params.offset,filter:e.params.filter})}_handleGroupListFilterRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-admin-group-list",filter:e.params.filter||null})}_handleProjectsOldRoute(e){let t="";e.params[1]&&(t=encodeURIComponent(e.params[1]),e.params[1].includes(",")&&(t=encodeURIComponent(e.params[1]).replace("%2C",","))),this._redirect(`/admin/repos/${t}`)}_handleRepoCommandsRoute(e){const t=e.params[0];this._setParams({view:dh.REPO,detail:ph.COMMANDS,repo:t}),this.reporting.setRepoName(t)}_handleRepoAccessRoute(e){const t=e.params[0];this._setParams({view:dh.REPO,detail:ph.ACCESS,repo:t}),this.reporting.setRepoName(t)}_handleRepoDashboardsRoute(e){const t=e.params[0];this._setParams({view:dh.REPO,detail:ph.DASHBOARDS,repo:t}),this.reporting.setRepoName(t)}_handleBranchListOffsetRoute(e){this._setParams({view:dh.REPO,detail:ph.BRANCHES,repo:e.params[0],offset:e.params[2]||0,filter:null})}_handleBranchListFilterOffsetRoute(e){this._setParams({view:dh.REPO,detail:ph.BRANCHES,repo:e.params.repo,offset:e.params.offset,filter:e.params.filter})}_handleBranchListFilterRoute(e){this._setParams({view:dh.REPO,detail:ph.BRANCHES,repo:e.params.repo,filter:e.params.filter||null})}_handleTagListOffsetRoute(e){this._setParams({view:dh.REPO,detail:ph.TAGS,repo:e.params[0],offset:e.params[2]||0,filter:null})}_handleTagListFilterOffsetRoute(e){this._setParams({view:dh.REPO,detail:ph.TAGS,repo:e.params.repo,offset:e.params.offset,filter:e.params.filter})}_handleTagListFilterRoute(e){this._setParams({view:dh.REPO,detail:ph.TAGS,repo:e.params.repo,filter:e.params.filter||null})}_handleRepoListOffsetRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-repo-list",offset:e.params[1]||0,filter:null,openCreateModal:"create"===e.hash})}_handleRepoListFilterOffsetRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-repo-list",offset:e.params.offset,filter:e.params.filter})}_handleRepoListFilterRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-repo-list",filter:e.params.filter||null})}_handleCreateProjectRoute(e){this._redirect("/admin/repos#create")}_handleCreateGroupRoute(e){this._redirect("/admin/groups#create")}_handleRepoRoute(e){const t=e.params[0];this._setParams({view:dh.REPO,repo:t}),this.reporting.setRepoName(t)}_handlePluginListOffsetRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-plugin-list",offset:e.params[1]||0,filter:null})}_handlePluginListFilterOffsetRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-plugin-list",offset:e.params.offset,filter:e.params.filter})}_handlePluginListFilterRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-plugin-list",filter:e.params.filter||null})}_handlePluginListRoute(e){this._setParams({view:dh.ADMIN,adminView:"gr-plugin-list"})}_handleQueryRoute(e){this._setParams({view:dh.SEARCH,query:e.params[0],offset:e.params[2]})}_handleChangeIdQueryRoute(e){this._setParams({view:gh.View.SEARCH,query:e.params[0]})}_handleQueryLegacySuffixRoute(e){this._redirect(e.path.replace(qE,""))}_handleChangeNumberLegacyRoute(e){this._redirect("/c/"+encodeURIComponent(e.params[0]))}_handleChangeRoute(e){const t={project:e.params[0],changeNum:e.params[1],basePatchNum:e.params[4],patchNum:e.params[6],view:dh.CHANGE,queryMap:e.queryMap};this.reporting.setRepoName(t.project),this._redirectOrNavigate(t)}_handleCommentRoute(e){const t={project:e.params[0],changeNum:e.params[1],commentId:e.params[2],view:dh.DIFF,commentLink:!0};this.reporting.setRepoName(t.project),this._redirectOrNavigate(t)}_handleDiffRoute(e){const t={project:e.params[0],changeNum:e.params[1],basePatchNum:e.params[4],patchNum:e.params[6],path:e.params[8],view:dh.DIFF},n=this._parseLineAddress(e.hash);n&&(t.leftSide=n.leftSide,t.lineNum=n.lineNum),this.reporting.setRepoName(t.project),this._redirectOrNavigate(t)}_handleChangeLegacyRoute(e){const t={changeNum:e.params[0],basePatchNum:e.params[3],patchNum:e.params[5],view:dh.CHANGE,querystring:e.querystring};this._normalizeLegacyRouteParams(t)}_handleLegacyLinenum(e){this._redirect(e.path.replace(WE,"#$1"))}_handleDiffLegacyRoute(e){const t={changeNum:e.params[0],basePatchNum:e.params[2],patchNum:e.params[4],path:e.params[5],view:dh.DIFF},n=this._parseLineAddress(e.hash);n&&(t.leftSide=n.leftSide,t.lineNum=n.lineNum),this._normalizeLegacyRouteParams(t)}_handleDiffEditRoute(e){const t=e.params[0];this._redirectOrNavigate({project:t,changeNum:e.params[1],patchNum:e.params[2],path:e.params[3],lineNum:e.hash,view:dh.EDIT}),this.reporting.setRepoName(t)}_handleChangeEditRoute(e){const t=e.params[0];this._redirectOrNavigate({project:t,changeNum:e.params[1],patchNum:e.params[3],view:dh.CHANGE,edit:!0}),this.reporting.setRepoName(t)}_redirectOrNavigate(e){this._normalizePatchRangeParams(e)?this._redirect(this._generateUrl(e)):this._setParams(e)}_handleAgreementsRoute(){this._redirect("/settings/#Agreements")}_handleNewAgreementsRoute(e){e.params.view=dh.AGREEMENTS,this._setParams(e.params)}_handleSettingsLegacyRoute(e){const t=e.params[0].replace(/ /g,"+");this._setParams({view:dh.SETTINGS,emailToken:t})}_handleSettingsRoute(e){this._setParams({view:dh.SETTINGS})}_handleRegisterRoute(e){this._setParams({justRegistered:!0});let t=e.params[0]||"/";t.startsWith("/register")&&(t="/"),"/"===t[0]&&this._redirect(j()+t)}_handlePassThroughRoute(){location.reload()}_handleImproperlyEncodedPlusRoute(e){let t=this._getHashFromCanonicalPath(e.canonicalPath);t.length&&(t="#"+t),this._redirect(`/c/${e.params[0]}/+/${e.params[1]}${t}`)}_handlePluginScreen(e){const t=dh.PLUGIN_SCREEN,n=e.params[0],i=e.params[1];this._setParams({view:t,plugin:n,screen:i})}_handleDocumentationSearchRoute(e){this._setParams({view:dh.DOCUMENTATION_SEARCH,filter:e.params.filter||null})}_handleDocumentationSearchRedirectRoute(e){this._redirect("/Documentation/q/filter:"+encodeURIComponent(e.params[0]))}_handleDocumentationRedirectRoute(e){e.params[1]?location.reload():this._redirect("/Documentation/index.html")}_handleDefaultRoute(){this._isInitialLoad?this._show404():this._handlePassThroughRoute()}_show404(){this._appElement().dispatchEvent(new CustomEvent("page-error",{detail:{response:{status:404}}}))}};HE([Bl({type:Object})],XE.prototype,"_app",void 0),HE([Bl({type:Boolean})],XE.prototype,"_isRedirecting",void 0),HE([Bl({type:Boolean})],XE.prototype,"_isInitialLoad",void 0),XE=HE([Ml("gr-router")],XE);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const JE=ta`
  <style include="shared-styles">
    :host {
      display: block;
      background-color: var(--view-background-color);
    }
    .hidden {
      display: none;
    }
    gr-patch-range-select {
      display: block;
    }
    gr-diff {
      border: none;
      --diff-container-styles: {
        border-bottom: 1px solid var(--border-color);
      }
    }
    .stickyHeader {
      background-color: var(--view-background-color);
      position: sticky;
      top: 0;
      /* TODO(dhruvsri): This is required only because of 'position:relative' in
         <gr-diff-highlight> (which could maybe be removed??). */
      z-index: 1;
      box-shadow: var(--elevation-level-1);
      /* This is just for giving the box-shadow some space. */
      margin-bottom: 2px;
    }
    header,
    .subHeader {
      align-items: center;
      display: flex;
      justify-content: space-between;
    }
    header {
      padding: var(--spacing-s) var(--spacing-xl);
      border-bottom: 1px solid var(--border-color);
    }
    .changeNumberColon {
      color: transparent;
    }
    .headerSubject {
      margin-right: var(--spacing-m);
      font-weight: var(--font-weight-bold);
    }
    .patchRangeLeft {
      align-items: center;
      display: flex;
    }
    .navLink:not([href]) {
      color: var(--deemphasized-text-color);
    }
    .navLinks {
      align-items: center;
      display: flex;
      white-space: nowrap;
    }
    .navLink {
      padding: 0 var(--spacing-xs);
    }
    .reviewed {
      display: inline-block;
      margin: 0 var(--spacing-xs);
      vertical-align: top;
      position: relative;
      top: 8px;
    }
    .jumpToFileContainer {
      display: inline-block;
    }
    .mobile {
      display: none;
    }
    gr-button {
      padding: var(--spacing-s) 0;
      text-decoration: none;
    }
    .loading {
      color: var(--deemphasized-text-color);
      font-family: var(--header-font-family);
      font-size: var(--font-size-h1);
      font-weight: var(--font-weight-h1);
      line-height: var(--line-height-h1);
      height: 100%;
      padding: var(--spacing-l);
      text-align: center;
    }
    .subHeader {
      background-color: var(--background-color-secondary);
      flex-wrap: wrap;
      padding: 0 var(--spacing-l);
    }
    .prefsButton {
      text-align: right;
    }
    .noOverflow {
      display: block;
      overflow: auto;
    }
    .editMode .hideOnEdit {
      display: none;
    }
    .blameLoader,
    .fileNum {
      display: none;
    }
    .blameLoader.show,
    .fileNum.show,
    .download,
    .preferences,
    .rightControls {
      align-items: center;
      display: flex;
    }
    .diffModeSelector,
    .editButton {
      align-items: center;
      display: flex;
    }
    .diffModeSelector span,
    .editButton span {
      margin-right: var(--spacing-xs);
    }
    .diffModeSelector.hide,
    .separator.hide {
      display: none;
    }
    gr-dropdown-list {
      --trigger-style: {
        text-transform: none;
      }
    }
    .editButtona a {
      text-decoration: none;
    }
    @media screen and (max-width: 50em) {
      header {
        padding: var(--spacing-s) var(--spacing-l);
      }
      .dash {
        display: none;
      }
      .desktop {
        display: none;
      }
      .fileNav {
        align-items: flex-start;
        display: flex;
        margin: 0 var(--spacing-xs);
      }
      .fullFileName {
        display: block;
        font-style: italic;
        min-width: 50%;
        padding: 0 var(--spacing-xxs);
        text-align: center;
        width: 100%;
        word-wrap: break-word;
      }
      .reviewed {
        vertical-align: -1px;
      }
      .mobileNavLink {
        color: var(--primary-text-color);
        font-family: var(--header-font-family);
        font-size: var(--font-size-h2);
        font-weight: var(--font-weight-h2);
        line-height: var(--line-height-h2);
        text-decoration: none;
      }
      .mobileNavLink:not([href]) {
        color: var(--deemphasized-text-color);
      }
      .jumpToFileContainer {
        display: block;
        width: 100%;
      }
      gr-dropdown-list {
        width: 100%;
        --gr-select-style: {
          display: block;
          width: 100%;
        }
        --native-select-style: {
          width: 100%;
        }
      }
    }
    :host(.hideComments) {
      --gr-comment-thread-display: none;
    }
  </style>
  <div class$="stickyHeader [[_computeContainerClass(_editMode)]]">
    <header>
      <div>
        <a
          href$="[[_computeChangePath(_change, _patchRange.*, _change.revisions)]]"
          >[[_changeNum]]</a
        ><!--
       --><span class="changeNumberColon">:</span>
        <span class="headerSubject">[[_change.subject]]</span>
        <input
          id="reviewed"
          class="reviewed hideOnEdit"
          type="checkbox"
          on-change="_handleReviewedChange"
          hidden$="[[!_loggedIn]]"
          hidden=""
          title="Toggle reviewed status of file"
          aria-label="file reviewed"
        /><!--
       -->
        <div class="jumpToFileContainer">
          <gr-dropdown-list
            id="dropdown"
            value="[[_path]]"
            on-value-change="_handleFileChange"
            items="[[_formattedFiles]]"
            initial-count="75"
            show-copy-for-trigger-text
          >
          </gr-dropdown-list>
        </div>
      </div>
      <div class="navLinks desktop">
        <span
          class$="fileNum [[_computeFileNumClass(_fileNum, _formattedFiles)]]"
        >
          File [[_fileNum]] of [[_formattedFiles.length]]
          <span class="separator"></span>
        </span>
        <a
          class="navLink"
          title="[[createTitle(Shortcut.PREV_FILE,
                    ShortcutSection.NAVIGATION)]]"
          href$="[[_computeNavLinkURL(_change, _path, _fileList, -1, 1)]]"
        >
          Prev</a
        >
        <span class="separator"></span>
        <a
          class="navLink"
          title="[[createTitle(Shortcut.UP_TO_CHANGE,
                ShortcutSection.NAVIGATION)]]"
          href$="[[_computeChangePath(_change, _patchRange.*, _change.revisions)]]"
        >
          Up</a
        >
        <span class="separator"></span>
        <a
          class="navLink"
          title="[[createTitle(Shortcut.NEXT_FILE,
                ShortcutSection.NAVIGATION)]]"
          href$="[[_computeNavLinkURL(_change, _path, _fileList, 1, 1)]]"
        >
          Next</a
        >
      </div>
    </header>
    <div class="subHeader">
      <div class="patchRangeLeft">
        <gr-patch-range-select
          id="rangeSelect"
          change-num="[[_changeNum]]"
          change-comments="[[_changeComments]]"
          patch-num="[[_patchRange.patchNum]]"
          base-patch-num="[[_patchRange.basePatchNum]]"
          files-weblinks="[[_filesWeblinks]]"
          available-patches="[[_allPatchSets]]"
          revisions="[[_change.revisions]]"
          revision-info="[[_revisionInfo]]"
          on-patch-range-change="_handlePatchChange"
        >
        </gr-patch-range-select>
        <span class="download desktop">
          <span class="separator"></span>
          <gr-dropdown
            link=""
            down-arrow=""
            items="[[_computeDownloadDropdownLinks(_change.project, _changeNum, _patchRange, _path, _diff)]]"
            horizontal-align="left"
          >
            <span class="downloadTitle">
              Download
            </span>
          </gr-dropdown>
        </span>
      </div>
      <div class="rightControls">
        <span
          class$="blameLoader [[_computeBlameLoaderClass(_isImageDiff, _path)]]"
        >
          <gr-button
            link=""
            id="toggleBlame"
            title="[[createTitle(Shortcut.TOGGLE_BLAME, ShortcutSection.DIFFS)]]"
            disabled="[[_isBlameLoading]]"
            on-click="_toggleBlame"
            >[[_computeBlameToggleLabel(_isBlameLoaded,
            _isBlameLoading)]]</gr-button
          >
        </span>
        <template is="dom-if" if="[[_computeCanEdit(_loggedIn, _change.*)]]">
          <span class="separator"></span>
          <span class="editButton">
            <gr-button
              link=""
              title="Edit current file"
              on-click="_goToEditFile"
              >edit</gr-button
            >
          </span>
        </template>
        <span class="separator"></span>
        <div class$="diffModeSelector [[_computeModeSelectHideClass(_diff)]]">
          <span>Diff view:</span>
          <gr-diff-mode-selector
            id="modeSelect"
            save-on-change="[[!_diffPrefsDisabled]]"
            mode="{{changeViewState.diffMode}}"
          ></gr-diff-mode-selector>
        </div>
        <span
          id="diffPrefsContainer"
          hidden$="[[_computePrefsButtonHidden(_prefs, _diffPrefsDisabled)]]"
          hidden=""
        >
          <span class="preferences desktop">
            <gr-button
              link=""
              class="prefsButton"
              has-tooltip=""
              title="Diff preferences"
              on-click="_handlePrefsTap"
              ><iron-icon icon="gr-icons:settings"></iron-icon
            ></gr-button>
          </span>
        </span>
        <gr-endpoint-decorator name="annotation-toggler">
          <span hidden="" id="annotation-span">
            <label for="annotation-checkbox" id="annotation-label"></label>
            <iron-input type="checkbox" disabled="">
              <input
                is="iron-input"
                type="checkbox"
                id="annotation-checkbox"
                disabled=""
              />
            </iron-input>
          </span>
        </gr-endpoint-decorator>
      </div>
    </div>
    <div class="fileNav mobile">
      <a
        class="mobileNavLink"
        href$="[[_computeNavLinkURL(_change, _path, _fileList, -1, 1)]]"
      >
        &lt;</a
      >
      <div class="fullFileName mobile">[[_computeDisplayPath(_path)]]</div>
      <a
        class="mobileNavLink"
        href$="[[_computeNavLinkURL(_change, _path, _fileList, 1, 1)]]"
      >
        &gt;</a
      >
    </div>
  </div>
  <div class="loading" hidden$="[[!_loading]]">Loading...</div>
  <gr-diff-host
    id="diffHost"
    hidden=""
    hidden$="[[_loading]]"
    is-image-diff="{{_isImageDiff}}"
    files-weblinks="{{_filesWeblinks}}"
    diff="{{_diff}}"
    change-num="[[_changeNum]]"
    commit-range="[[_commitRange]]"
    patch-range="[[_patchRange]]"
    file="[[_file]]"
    path="[[_path]]"
    prefs="[[_prefs]]"
    project-name="[[_change.project]]"
    view-mode="[[_diffMode]]"
    is-blame-loaded="{{_isBlameLoaded}}"
    on-comment-anchor-tap="_onLineSelected"
    on-line-selected="_onLineSelected"
  >
  </gr-diff-host>
  <gr-apply-fix-dialog
    id="applyFixDialog"
    prefs="[[_prefs]]"
    change="[[_change]]"
    change-num="[[_changeNum]]"
  >
  </gr-apply-fix-dialog>
  <gr-diff-preferences-dialog
    id="diffPreferencesDialog"
    diff-prefs="{{_prefs}}"
    on-reload-diff-preference="_handleReloadingDiffPreference"
  >
  </gr-diff-preferences-dialog>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-storage id="storage"></gr-storage>
  <gr-diff-cursor
    id="cursor"
    on-navigate-to-next-unreviewed-file="_handleNextUnreviewedFile"
  ></gr-diff-cursor>
  <gr-comment-api id="commentAPI"></gr-comment-api>
`
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,ZE="left",QE="right",eS="SIDE_BY_SIDE",tS="UNIFIED_DIFF";class nS extends(xp(oo(dr(oa)))){static get template(){return JE}static get is(){return"gr-diff-view"}static get properties(){return{params:{type:Object,observer:"_paramsChanged"},keyEventTarget:{type:Object,value:()=>document.body},changeViewState:{type:Object,notify:!0,value:()=>({}),observer:"_changeViewStateChanged"},disableDiffPrefs:{type:Boolean,value:!1},_diffPrefsDisabled:{type:Boolean,computed:"_computeDiffPrefsDisabled(disableDiffPrefs, _loggedIn)"},_patchRange:Object,_commitRange:Object,_change:Object,_changeComments:Object,_changeNum:String,_diff:Object,_formattedFiles:{type:Array,computed:"_formatFilesForDropdown(_files, _patchRange.patchNum, _changeComments)"},_fileList:{type:Array,computed:"_getSortedFileList(_files)"},_files:{type:Object,value:()=>({sortedFileList:[],changeFilesByPath:{}})},_file:{type:Object,computed:"_getCurrentFile(_files, _path)"},_path:{type:String,observer:"_pathChanged"},_fileNum:{type:Number,computed:"_computeFileNum(_path, _formattedFiles)"},_loggedIn:{type:Boolean,value:!1},_loading:{type:Boolean,value:!0},_prefs:Object,_projectConfig:Object,_userPrefs:Object,_diffMode:{type:String,computed:"_getDiffViewMode(changeViewState.diffMode, _userPrefs)"},_isImageDiff:Boolean,_filesWeblinks:Object,_commentMap:Object,_commentsForDiff:Object,_commentSkips:{type:Object,computed:"_computeCommentSkips(_commentMap, _fileList, _path)"},_editMode:{type:Boolean,computed:"_computeEditMode(_patchRange.*)"},_isBlameLoaded:Boolean,_isBlameLoading:{type:Boolean,value:!1},_allPatchSets:{type:Array,computed:"_computeAllPatchSets(_change, _change.revisions.*)"},_revisionInfo:{type:Object,computed:"_getRevisionInfo(_change)"},_reviewedFiles:{type:Object,value:()=>new Set},_focusLineNum:Number}}static get observers(){return["_getProjectConfig(_change.project)","_getFiles(_changeNum, _patchRange.*, _changeComments)","_setReviewedObserver(_loggedIn, params.*, _prefs, _patchRange.*)","_recomputeComments(_files.changeFilesByPath,_path, _patchRange, _projectConfig)"]}get keyBindings(){return{esc:"_handleEscKey"}}keyboardShortcuts(){return{[yp.LEFT_PANE]:"_handleLeftPane",[yp.RIGHT_PANE]:"_handleRightPane",[yp.NEXT_LINE]:"_handleNextLineOrFileWithComments",[yp.PREV_LINE]:"_handlePrevLineOrFileWithComments",[yp.VISIBLE_LINE]:"_handleVisibleLine",[yp.NEXT_FILE_WITH_COMMENTS]:"_handleNextLineOrFileWithComments",[yp.PREV_FILE_WITH_COMMENTS]:"_handlePrevLineOrFileWithComments",[yp.NEW_COMMENT]:"_handleNewComment",[yp.SAVE_COMMENT]:null,[yp.NEXT_FILE]:"_handleNextFile",[yp.PREV_FILE]:"_handlePrevFile",[yp.NEXT_CHUNK]:"_handleNextChunkOrCommentThread",[yp.NEXT_COMMENT_THREAD]:"_handleNextChunkOrCommentThread",[yp.PREV_CHUNK]:"_handlePrevChunkOrCommentThread",[yp.PREV_COMMENT_THREAD]:"_handlePrevChunkOrCommentThread",[yp.OPEN_REPLY_DIALOG]:"_handleOpenReplyDialogOrToggleLeftPane",[yp.TOGGLE_LEFT_PANE]:"_handleOpenReplyDialogOrToggleLeftPane",[yp.OPEN_DOWNLOAD_DIALOG]:"_handleOpenDownloadDialog",[yp.UP_TO_CHANGE]:"_handleUpToChange",[yp.OPEN_DIFF_PREFS]:"_handleCommaKey",[yp.TOGGLE_DIFF_MODE]:"_handleToggleDiffMode",[yp.TOGGLE_FILE_REVIEWED]:"_throttledToggleFileReviewed",[yp.EXPAND_ALL_DIFF_CONTEXT]:"_handleExpandAllDiffContext",[yp.NEXT_UNREVIEWED_FILE]:"_handleNextUnreviewedFile",[yp.TOGGLE_BLAME]:"_handleToggleBlame",[yp.TOGGLE_HIDE_ALL_COMMENT_THREADS]:"_handleToggleHideAllCommentThreads",[yp.DIFF_AGAINST_BASE]:"_handleDiffAgainstBase",[yp.DIFF_AGAINST_LATEST]:"_handleDiffAgainstLatest",[yp.DIFF_BASE_AGAINST_LEFT]:"_handleDiffBaseAgainstLeft",[yp.DIFF_RIGHT_AGAINST_LATEST]:"_handleDiffRightAgainstLatest",[yp.DIFF_BASE_AGAINST_LATEST]:"_handleDiffBaseAgainstLatest",[yp.EXPAND_ALL_COMMENT_THREADS]:null,[yp.COLLAPSE_ALL_COMMENT_THREADS]:null}}constructor(){super(),this.reporting=n.reportingService,this.flagsService=n.flagsService}connectedCallback(){super.connectedCallback(),this._throttledToggleFileReviewed=this._throttleWrap(e=>this._handleToggleFileReviewed(e))}attached(){super.attached(),this._getLoggedIn().then(e=>{this._loggedIn=e}),this.addEventListener("open-fix-preview",e=>this._onOpenFixPreview(e)),this.$.cursor.push("diffs",this.$.diffHost),this._onRenderHandler=()=>{this.$.cursor.reInitCursor()},this.$.diffHost.addEventListener("render",this._onRenderHandler)}detached(){this.$.diffHost.removeEventListener("render",this._onRenderHandler)}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_getProjectConfig(e){if(e)return this.$.restAPI.getProjectConfig(e).then(e=>{this._projectConfig=e})}_getChangeDetail(e){return this.$.restAPI.getDiffChangeDetail(e).then(e=>(this._change=e,e))}_getChangeEdit(e){return this.$.restAPI.getChangeEdit(this._changeNum)}_getSortedFileList(e){return e?e.sortedFileList:[]}_getCurrentFile(e,t){if([e,t].includes(void 0))return;const n=e.changeFilesByPath[t],i={path:t};return n&&n.old_path&&(i.basePath=n.old_path),i}_getFiles(e,t,n){if([e,t,t.base,n].some(e=>void 0===e))return Promise.resolve();if(!t.base.patchNum)return Promise.resolve();const i=t.base;return this.$.restAPI.getChangeFiles(e,i).then(e=>{if(!e)return;const t=n.getPaths(i),o={...e};q_(o,t),this._files={sortedFileList:Object.keys(o).sort(W_),changeFilesByPath:o}})}_getDiffPreferences(){return this.$.restAPI.getDiffPreferences().then(e=>{this._prefs=e})}_getPreferences(){return this.$.restAPI.getPreferences()}_getWindowWidth(){return window.innerWidth}_handleReviewedChange(e){this._setReviewed(qo(e).rootTarget.checked)}_setReviewed(e){this._editMode||(this.$.reviewed.checked=e,this._patchRange.patchNum&&this._saveReviewedState(e).catch(e=>{throw this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Couldn’t change file review status."},composed:!0,bubbles:!0})),e}))}_saveReviewedState(e){return this.$.restAPI.saveFileReviewed(this._changeNum,this._patchRange.patchNum,this._path,e)}_handleToggleFileReviewed(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._setReviewed(!this.$.reviewed.checked))}_handleEscKey(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.$.diffHost.displayLine=!1)}_handleLeftPane(e){this.shouldSuppressKeyboardShortcut(e)||(e.preventDefault(),this.$.cursor.moveLeft())}_handleRightPane(e){this.shouldSuppressKeyboardShortcut(e)||(e.preventDefault(),this.$.cursor.moveRight())}_handlePrevLineOrFileWithComments(e){this.shouldSuppressKeyboardShortcut(e)||(e.detail.keyboardEvent.shiftKey&&75===e.detail.keyboardEvent.keyCode?this._moveToPreviousFileWithComment():this.modifierPressed(e)||(e.preventDefault(),this.$.diffHost.displayLine=!0,this.$.cursor.moveUp()))}_handleVisibleLine(e){this.shouldSuppressKeyboardShortcut(e)||(e.preventDefault(),this.$.cursor.moveToVisibleArea())}_onOpenFixPreview(e){this.$.applyFixDialog.open(e)}_handleNextLineOrFileWithComments(e){this.shouldSuppressKeyboardShortcut(e)||(e.detail.keyboardEvent.shiftKey&&74===e.detail.keyboardEvent.keyCode?this._moveToNextFileWithComment():this.modifierPressed(e)||(e.preventDefault(),this.$.diffHost.displayLine=!0,this.$.cursor.moveDown()))}_moveToPreviousFileWithComment(){this._commentSkips&&(this._commentSkips.previous?gh.navigateToDiff(this._change,this._commentSkips.previous,this._patchRange.patchNum,this._patchRange.basePatchNum):this._navToChangeView())}_moveToNextFileWithComment(){this._commentSkips&&(this._commentSkips.next?gh.navigateToDiff(this._change,this._commentSkips.next,this._patchRange.patchNum,this._patchRange.basePatchNum):this._navToChangeView())}_handleNewComment(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this.$.cursor.createCommentInPlace())}_handlePrevFile(e){this.shouldSuppressKeyboardShortcut(e)||this.getKeyboardEvent(e).metaKey||(e.preventDefault(),this._navToFile(this._path,this._fileList,-1))}_handleNextFile(e){this.shouldSuppressKeyboardShortcut(e)||this.getKeyboardEvent(e).metaKey||(e.preventDefault(),this._navToFile(this._path,this._fileList,1))}_handleNextChunkOrCommentThread(e){if(!this.shouldSuppressKeyboardShortcut(e))if(e.preventDefault(),e.detail.keyboardEvent.shiftKey)this.$.cursor.moveToNextCommentThread();else{if(this.modifierPressed(e))return;this.$.cursor.moveToNextChunk(!1,!e.detail.keyboardEvent.repeat)}}_handlePrevChunkOrCommentThread(e){if(!this.shouldSuppressKeyboardShortcut(e))if(e.preventDefault(),e.detail.keyboardEvent.shiftKey)this.$.cursor.moveToPreviousCommentThread();else{if(this.modifierPressed(e))return;this.$.cursor.moveToPreviousChunk()}}_handleOpenReplyDialogOrToggleLeftPane(e){if(!this.shouldSuppressKeyboardShortcut(e))return e.detail.keyboardEvent.shiftKey?(e.preventDefault(),void this.$.diffHost.toggleLeftDiff()):void(this.modifierPressed(e)||this._loggedIn&&(this.set("changeViewState.showReplyDialog",!0),e.preventDefault(),this._navToChangeView()))}_handleOpenDownloadDialog(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(this.set("changeViewState.showDownloadDialog",!0),e.preventDefault(),this._navToChangeView())}_handleUpToChange(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._navToChangeView())}_handleCommaKey(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||this._diffPrefsDisabled||(e.preventDefault(),this.$.diffPreferencesDialog.open())}_handleToggleDiffMode(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||(e.preventDefault(),this._getDiffViewMode()===eS?this.$.modeSelect.setMode(tS):this.$.modeSelect.setMode(eS))}_navToChangeView(){this._changeNum&&this._patchRange.patchNum&&this._navigateToChange(this._change,this._patchRange,this._change&&this._change.revisions)}_navToFile(e,t,n){const i=this._getNavLinkPath(e,t,n);i&&(i.up?this._navigateToChange(this._change,this._patchRange,this._change&&this._change.revisions):gh.navigateToDiff(this._change,i.path,this._patchRange.patchNum,this._patchRange.basePatchNum))}_computeNavLinkURL(e,t,n,i,o){const s=this._getNavLinkPath(t,n,i,o);return s?s.up?this._getChangePath(this._change,this._patchRange,this._change&&this._change.revisions):this._getDiffUrl(this._change,this._patchRange,s.path):null}_goToEditFile(){const e=this.$.cursor.getAddress(),t=gh.getEditUrlForDiff(this._change,this._path,this._patchRange.patchNum,e&&e.number);return gh.navigateToRelativeUrl(t)}_getNavLinkPath(e,t,n,i){if(!e||!t||0===t.length)return null;let o=t.indexOf(e);if(-1===o){return{path:n>0?t[0]:t[t.length-1]}}return o+=n,o<0||o>t.length-1?i?null:{up:!0}:{path:t[o]}}_getReviewedFiles(e,t){return this.$.restAPI.getReviewedFiles(e,t).then(e=>(this._reviewedFiles=new Set(e),this._reviewedFiles))}_getReviewedStatus(e,t,n,i){return e?Promise.resolve(!1):this._getReviewedFiles(t,n).then(e=>e.has(i))}_initLineOfInterestAndCursor(e){this.$.diffHost.lineOfInterest=this._getLineOfInterest({leftSide:e}),this._initCursor({leftSide:e})}_displayDiffBaseAgainstLeftToast(){this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:`Patchset ${this._patchRange.basePatchNum} vs `+`${this._patchRange.patchNum} selected. Press v + ← to view `+`Base vs ${this._patchRange.basePatchNum}`},composed:!0,bubbles:!0}))}_displayDiffAgainstLatestToast(e){const t=Ch(this._patchRange.basePatchNum,"PARENT")?"Base":`Patchset ${this._patchRange.basePatchNum}`;this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:`${t} vs\n            ${this._patchRange.patchNum} selected\n. Press v + ↑ to view\n            ${t} vs Patchset ${e}`},composed:!0,bubbles:!0}))}_displayToasts(){if(!Ch(this._patchRange.basePatchNum,"PARENT"))return void this._displayDiffBaseAgainstLeftToast();const e=Th(this._allPatchSets);Ch(this._patchRange.patchNum,e)||this._displayDiffAgainstLatestToast(e)}_initCommitRange(){let e,t;if(this._patchRange&&this._patchRange.patchNum){for(const n in this._change.revisions){if(!this._change.revisions.hasOwnProperty(n))continue;const i=this._change.revisions[n],o=i._number.toString();if(o===this._patchRange.patchNum){e=n;const o=(i.commit||{}).parents||[];"PARENT"===this._patchRange.basePatchNum&&o.length&&(t=o[o.length-1].commit)}else o===this._patchRange.basePatchNum&&(t=n)}this._commitRange={commit:e,baseCommit:t}}}_initPatchRange(){let e;if(this.params.commentId){const t=this._changeComments.findCommentById(this.params.commentId);if(!t)return this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"comment not found"},composed:!0,bubbles:!0})),void gh.navigateToChange(this._change);this._path=t.path;const n=Th(this._allPatchSets);Ch(n,t.patch_set)?(this._patchRange={patchNum:n,basePatchNum:"PARENT"},e="left"===t.__commentSide):(this._patchRange={patchNum:n,basePatchNum:t.patch_set},e=!0),this._focusLineNum=t.line}else this.params.path&&(this._path=this.params.path),this.params.patchNum&&(this._patchRange={patchNum:this.params.patchNum,basePatchNum:this.params.basePatchNum||"PARENT"}),this.params.lineNum&&(this._focusLineNum=this.params.lineNum,e=this.params.leftSide);this._initLineOfInterestAndCursor(e),this._commentMap=this._getPaths(this._patchRange),this._commentsForDiff=this._getCommentsForPath(this._path,this._patchRange,this._projectConfig)}_isFileUnchanged(e){return!(!e||!e.content)&&!e.content.some(e=>e.a&&!e.common||e.b&&!e.common)}_paramsChanged(e){if(e.view!==gh.View.DIFF)return;if(this._change=void 0,this._files=void 0,this._path=void 0,this._patchRange=void 0,this._commitRange=void 0,this._changeComments=void 0,this._focusLineNum=void 0,e.changeNum&&e.project&&this.$.restAPI.setInProjectLookup(e.changeNum,e.project),this._changeNum=e.changeNum,this.classList.remove("hideComments"),!e.patchNum&&!e.commentLink)return void console.warn("invalid url, no patchNum found");const t=[];return t.push(this._getDiffPreferences()),t.push(this._getPreferences().then(e=>{this._userPrefs=e})),t.push(this._getChangeDetail(this._changeNum)),t.push(this._loadComments()),t.push(this._getChangeEdit(this._changeNum)),this.$.diffHost.cancel(),this.$.diffHost.clearDiffContent(),this._loading=!0,Promise.all(t).then(e=>{this._loading=!1,this._initPatchRange(),this._initCommitRange(),this.$.diffHost.comments=this._commentsForDiff;const t=e[4];return t&&this.set("_change.revisions."+t.commit.commit,{_number:bh,basePatchNum:t.base_patch_set_number,commit:t.commit}),this.$.diffHost.reload(!0)}).then(()=>{this.reporting.diffViewFullyLoaded(),this.reporting.diffViewDisplayed()}).then(()=>{if(this._isFileUnchanged(this._diff)&&e.commentLink)return this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:`File is unchanged between Patchset\n                  ${this._patchRange.basePatchNum} and\n                  ${this._patchRange.patchNum}. Showing diff of Base vs\n                  ${this._patchRange.basePatchNum}`},composed:!0,bubbles:!0})),void gh.navigateToDiff(this._change,this._path,this._patchRange.basePatchNum,"PARENT",this._focusLineNum);e.commentLink&&this._displayToasts(),this._isBlameLoaded&&this._loadBlame()})}_changeViewStateChanged(e){null===e.diffMode&&this.$.restAPI.getPreferences().then(e=>{this.set("changeViewState.diffMode",e.default_diff_view)})}_setReviewedObserver(e,t,n,i){if([e,t,n,i,i.base].includes(void 0))return;const o=i.base,s=t.base||{};e&&(n.manual_review?o.patchNum&&this._getReviewedStatus(this.editMode,this._changeNum,o.patchNum,this._path).then(e=>{this.$.reviewed.checked=e}):s.view===gh.View.DIFF&&this._setReviewed(!0))}_initCursor(e){void 0!==this._focusLineNum&&(e.leftSide?this.$.cursor.side=ZE:this.$.cursor.side=QE,this.$.cursor.initialLineNumber=this._focusLineNum)}_getLineOfInterest(e){return this._focusLineNum?{number:this._focusLineNum,leftSide:e.leftSide}:null}_pathChanged(e){e&&this.dispatchEvent(new CustomEvent("title-change",{detail:{title:X_(e)},composed:!0,bubbles:!0})),this._fileList&&0!=this._fileList.length&&this.set("changeViewState.selectedFileIndex",this._fileList.indexOf(e))}_getDiffUrl(e,t,n){return[e,t,n].includes(void 0)?"":gh.getUrlForDiff(e,n,t.patchNum,t.basePatchNum)}_patchRangeStr(e){let t=e.patchNum;return null!=e.basePatchNum&&"PARENT"!=e.basePatchNum&&(t=e.basePatchNum+".."+e.patchNum),t}_getChangeUrlRange(e,t){let n=void 0,i=void 0,o=-1;for(const e of Object.values(t||{}))o=Math.max(o,e._number);return"PARENT"===e.basePatchNum&&parseInt(e.patchNum,10)===o||(n=e.patchNum,i=e.basePatchNum),{patchNum:n,basePatchNum:i}}_getChangePath(e,t,n){if([e,t].includes(void 0))return"";const i=this._getChangeUrlRange(t,n);return gh.getUrlForChange(e,i.patchNum,i.basePatchNum)}_navigateToChange(e,t,n){const i=this._getChangeUrlRange(t,n);gh.navigateToChange(e,i.patchNum,i.basePatchNum)}_computeChangePath(e,t,n){return this._getChangePath(e,t.base,n)}_formatFilesForDropdown(e,t,n){if([e,t,n].includes(void 0))return;if(!e)return;const i=[];for(const o of e.sortedFileList)i.push({text:K_(o),mobileText:X_(o),value:o,bottomText:this._computeCommentString(n,t,o,e.changeFilesByPath[o])});return i}_computeCommentString(e,t,n,i){const o=e.computeUnresolvedNum({patchNum:t,path:n}),s=e.computeCommentCount({patchNum:t,path:n}),r=nd.computePluralString(s,"comment"),a=nd.computeString(o,"unresolved");return["U"===i.status?"no changes":"",r,a].filter(e=>e&&e.length>0).join(", ")}_computePrefsButtonHidden(e,t){return t||!e}_handleFileChange(e){const t=e.detail.value;t!==this._path&&gh.navigateToDiff(this._change,t,this._patchRange.patchNum,this._patchRange.basePatchNum)}_handleFileTap(e){this.async(()=>{this.$.dropdown.close()},1)}_handlePatchChange(e){const{basePatchNum:t,patchNum:n}=e.detail;Ch(t,this._patchRange.basePatchNum)&&Ch(n,this._patchRange.patchNum)||gh.navigateToDiff(this._change,this._path,n,t)}_handlePrefsTap(e){e.preventDefault(),this.$.diffPreferencesDialog.open()}_getDiffViewMode(){return this.changeViewState.diffMode?this.changeViewState.diffMode:this._userPrefs?(this.set("changeViewState.diffMode",this._userPrefs.default_diff_view),this._userPrefs.default_diff_view):"SIDE_BY_SIDE"}_computeModeSelectHideClass(e){return e.binary?"hide":""}_onLineSelected(e,t){if(!this._change)return;const n=t.number,i="LEFT"===t.side||"PARENT"===t.side,o=gh.getUrlForDiffById(this._changeNum,this._change.project,this._path,this._patchRange.patchNum,this._patchRange.basePatchNum,n,i);history.replaceState(null,"",o)}_computeDownloadDropdownLinks(e,t,n,i,o){if(!n||!n.patchNum)return[];const s=[{url:this._computeDownloadPatchLink(e,t,n,i),name:"Patch"}];if(o&&o.meta_a){let r=i;"RENAMED"===o.change_type&&(r=o.meta_a.name),s.push({url:this._computeDownloadFileLink(e,t,n,r,!0),name:"Left Content"})}return o&&o.meta_b&&s.push({url:this._computeDownloadFileLink(e,t,n,i,!1),name:"Right Content"}),s}_computeDownloadFileLink(e,t,n,i,o){let s=n.patchNum;const r="PARENT"===n.basePatchNum;o&&!r&&(s=n.basePatchNum);let a=zp(e,t,s)+`/files/${encodeURIComponent(i)}/download`;return o&&r&&(a+="?parent=1"),a}_computeDownloadPatchLink(e,t,n,i){let o=zp(e,t,n.patchNum);return o+="/patch?zip&path="+encodeURIComponent(i),o}_loadComments(){return this.$.commentAPI.loadAll(this._changeNum).then(e=>{this._changeComments=e})}_recomputeComments(e,t,n,i){if([e,t,n,i].includes(void 0))return;const o=e[t];o&&o.old_path&&(this._commentsForDiff=this._changeComments.getCommentsBySideForFile({path:t,basePath:o.old_path},n,i),this.$.diffHost.comments=this._commentsForDiff)}_getPaths(e){return this._changeComments.getPaths(e)}_getCommentsForPath(e,t,n){return this._changeComments.getCommentsBySideForPath(e,t,n)}_getDiffDrafts(){return this.$.restAPI.getDiffDrafts(this._changeNum)}_computeCommentSkips(e,t,n){if([e,t,n].includes(void 0))return;const i={previous:null,next:null};if(!t.length)return i;const o=t.indexOf(n);for(let n=o-1;n>=0;n--)if(e[t[n]]){i.previous=t[n];break}for(let n=o+1;n<t.length;n++)if(e[t[n]]){i.next=t[n];break}return i}_computeContainerClass(e){return e?"editMode":""}_computeEditMode(e){return Ch((e.base||{}).patchNum,bh)}_computeBlameToggleLabel(e,t){return e?"Hide blame":"Show blame"}_loadBlame(){this._isBlameLoading=!0,this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Loading blame..."},composed:!0,bubbles:!0})),this.$.diffHost.loadBlame().then(()=>{this._isBlameLoading=!1,this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Blame loaded"},composed:!0,bubbles:!0}))}).catch(()=>{this._isBlameLoading=!1})}_toggleBlame(){this._isBlameLoaded?this.$.diffHost.clearBlame():this._loadBlame()}_handleToggleBlame(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||this._toggleBlame()}_handleToggleHideAllCommentThreads(e){this.shouldSuppressKeyboardShortcut(e)||this.modifierPressed(e)||this.toggleClass("hideComments")}_handleDiffAgainstBase(e){this.shouldSuppressKeyboardShortcut(e)||(Ch(this._patchRange.basePatchNum,wh)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Base is already selected."},composed:!0,bubbles:!0})):gh.navigateToDiff(this._change,this._path,this._patchRange.patchNum))}_handleDiffBaseAgainstLeft(e){this.shouldSuppressKeyboardShortcut(e)||(Ch(this._patchRange.basePatchNum,wh)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Left is already base."},composed:!0,bubbles:!0})):gh.navigateToDiff(this._change,this._path,this._patchRange.basePatchNum))}_handleDiffAgainstLatest(e){if(this.shouldSuppressKeyboardShortcut(e))return;const t=Th(this._allPatchSets);Ch(this._patchRange.patchNum,t)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Latest is already selected."},composed:!0,bubbles:!0})):gh.navigateToDiff(this._change,this._path,t,this._patchRange.basePatchNum)}_handleDiffRightAgainstLatest(e){if(this.shouldSuppressKeyboardShortcut(e))return;const t=Th(this._allPatchSets);Ch(this._patchRange.patchNum,t)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Right is already latest."},composed:!0,bubbles:!0})):gh.navigateToDiff(this._change,this._path,t,this._patchRange.patchNum)}_handleDiffBaseAgainstLatest(e){if(this.shouldSuppressKeyboardShortcut(e))return;const t=Th(this._allPatchSets);Ch(this._patchRange.patchNum,t)&&Ch(this._patchRange.basePatchNum,wh)?this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Already diffing base against latest."},composed:!0,bubbles:!0})):gh.navigateToDiff(this._change,this._path,t)}_computeBlameLoaderClass(e,t){return Y_(t)||e?"":"show"}_getRevisionInfo(e){return new Nh(e)}_computeFileNum(e,t){if(![e,t].includes(void 0))return t.findIndex(({value:t})=>t===e)+1}_computeFileNumClass(e,t){return t&&e>0?"show":""}_handleExpandAllDiffContext(e){this.shouldSuppressKeyboardShortcut(e)||this.$.diffHost.expandAllContext()}_computeDiffPrefsDisabled(e,t){return e||!t}_handleNextUnreviewedFile(e){if(this.shouldSuppressKeyboardShortcut(e))return;this._setReviewed(!0);const t=this._fileList.filter(e=>e===this._path||!this._reviewedFiles.has(e));this._navToFile(this._path,t,1)}_handleReloadingDiffPreference(){this._getDiffPreferences()}_computeCanEdit(e,t){return![t,t.base].some(e=>void 0===e)&&(e&&Wp(t.base))}_computeIsLoggedIn(e){return!!e}_computeAllPatchSets(e){return Ph(e)}_computeDisplayPath(e){return K_(e)}}customElements.define(nS.is,nS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const iS=ta`
  <style include="shared-styles">
    textarea {
      border: none;
      box-sizing: border-box;
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-code);
      line-height: var(--line-height-code);
      min-height: 60vh;
      resize: none;
      white-space: pre;
      width: 100%;
    }
    textarea:focus {
      outline: none;
    }
  </style>
  <textarea
    id="textarea"
    value="[[fileContent]]"
    on-input="_handleTextareaInput"
  ></textarea>
`;var oS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let sS=class extends(oo(dr(oa))){constructor(){super(...arguments),this.fileContent=null}static get template(){return iS}_handleTextareaInput(e){this.dispatchEvent(new CustomEvent("content-change",{detail:{value:e.target.value},bubbles:!0,composed:!0}))}};oS([Bl({type:String})],sS.prototype,"fileContent",void 0),sS=oS([Ml("gr-default-editor")],sS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const rS=ta`
  <style include="shared-styles">
    :host {
      background-color: var(--view-background-color);
    }
    .stickyHeader {
      background-color: var(--edit-mode-background-color);
      border-bottom: 1px var(--border-color) solid;
      position: sticky;
      top: 0;
      z-index: 1;
    }
    header,
    .subHeader {
      align-items: center;
      display: flex;
      justify-content: space-between;
      padding: var(--spacing-m) var(--spacing-l);
    }
    header gr-editable-label {
      font-family: var(--header-font-family);
      font-size: var(--font-size-h3);
      font-weight: var(--font-weight-h3);
      line-height: var(--line-height-h3);
      --label-style: {
        text-overflow: initial;
        white-space: initial;
        word-break: break-all;
      }
      --input-style: {
        margin-top: var(--spacing-l);
      }
    }
    .textareaWrapper {
      border: 1px solid var(--border-color);
      border-radius: var(--border-radius);
      margin: var(--spacing-l);
    }
    .textareaWrapper .editButtons {
      display: none;
    }
    .controlGroup {
      align-items: center;
      display: flex;
      font-family: var(--header-font-family);
      font-size: var(--font-size-h3);
      font-weight: var(--font-weight-h3);
      line-height: var(--line-height-h3);
    }
    .rightControls {
      justify-content: flex-end;
    }
    @media screen and (max-width: 50em) {
      header,
      .subHeader {
        display: block;
      }
      .rightControls {
        float: right;
      }
    }
  </style>
  <div class="stickyHeader">
    <header>
      <span class="controlGroup">
        <span>Edit mode</span>
        <span class="separator"></span>
        <gr-editable-label
          label-text="File path"
          value="[[_path]]"
          placeholder="File path..."
          on-changed="_handlePathChanged"
        ></gr-editable-label>
      </span>
      <span class="controlGroup rightControls">
        <gr-button id="close" link="" on-click="_handleCloseTap"
          >Close</gr-button
        >
        <gr-button
          id="save"
          disabled$="[[_saveDisabled]]"
          primary=""
          link=""
          on-click="_saveEdit"
          >Save</gr-button
        >
      </span>
    </header>
  </div>
  <div class="textareaWrapper">
    <gr-endpoint-decorator id="editorEndpoint" name="editor">
      <gr-endpoint-param
        name="fileContent"
        value="[[_newContent]]"
      ></gr-endpoint-param>
      <gr-endpoint-param name="prefs" value="[[_prefs]]"></gr-endpoint-param>
      <gr-endpoint-param name="fileType" value="[[_type]]"></gr-endpoint-param>
      <gr-endpoint-param
        name="lineNum"
        value="[[_lineNum]]"
      ></gr-endpoint-param>
      <gr-default-editor
        id="file"
        file-content="[[_newContent]]"
      ></gr-default-editor>
    </gr-endpoint-decorator>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-storage id="storage"></gr-storage>
`;var aS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let lS=class extends(xp(oo(dr(oa)))){constructor(){super(...arguments),this._saving=!1,this._successfulSave=!1,this._saveDisabled=!0}static get template(){return rS}get keyBindings(){return{"ctrl+s meta+s":"_handleSaveShortcut"}}created(){super.created(),this.addEventListener("content-change",e=>{this._handleContentChange(e)})}attached(){super.attached(),this._getEditPrefs().then(e=>{this._prefs=e})}get storageKey(){return`c${this._changeNum}_ps${this._patchNum}_${this._path}`}_getLoggedIn(){return this.$.restAPI.getLoggedIn()}_getEditPrefs(){return this.$.restAPI.getEditPreferences()}_paramsChanged(e){if(e.view!==gh.View.EDIT)return;this._changeNum=e.changeNum,this._path=e.path,this._patchNum=e.patchNum||bh,this._lineNum="string"==typeof e.lineNum?parseInt(e.lineNum):e.lineNum,this.async(()=>{const t=`Editing ${X_(e.path)}`;this.dispatchEvent(new CustomEvent("title-change",{detail:{title:t},composed:!0,bubbles:!0}))});const t=[];return t.push(this._getChangeDetail(this._changeNum)),t.push(this._getFileData(this._changeNum,this._path,this._patchNum)),Promise.all(t)}_getChangeDetail(e){return this.$.restAPI.getDiffChangeDetail(e).then(e=>{this._change=e})}_handlePathChanged(e){if(void 0===this._changeNum||!this._path)return Promise.reject(new Error("changeNum or path undefined"));const t=e.detail;return t===this._path?Promise.resolve():this.$.restAPI.renameFileInChangeEdit(this._changeNum,this._path,t).then(e=>{e&&e.ok&&(this._successfulSave=!0,this._viewEditInChangeView())})}_viewEditInChangeView(){const e=this._successfulSave?bh:this._patchNum;this._change&&e&&gh.navigateToChange(this._change,e,void 0,e!==bh)}_getFileData(e,t,n){if(void 0===n)return Promise.reject(new Error("patchNum undefined"));const i=this.$.storage.getEditableContentItem(this.storageKey);return this.$.restAPI.getFileContent(e,t,n).then(e=>{const t=e&&e.content||"";i&&i.message&&i.message!==t?(this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:"Content restored from a previous edit."},bubbles:!0,composed:!0})),this._newContent=i.message):this._newContent=t,this._content=t,e&&e.ok&&e.type?this._type=e.type:this._type=""})}_saveEdit(){return void 0!==this._changeNum&&this._path?(this._saving=!0,this._showAlert("Saving changes..."),this.$.storage.eraseEditableContentItem(this.storageKey),this._newContent?this.$.restAPI.saveChangeEdit(this._changeNum,this._path,this._newContent).then(e=>{this._saving=!1,this._showAlert(e.ok?"All changes saved":"Failed to save changes"),e.ok&&(this._content=this._newContent,this._successfulSave=!0)}):Promise.reject(new Error("new content undefined"))):Promise.reject(new Error("changeNum or path undefined"))}_showAlert(e){this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:e},bubbles:!0,composed:!0}))}_computeSaveDisabled(e,t,n){return!![e,t,n].includes(void 0)||(!!n||e===t)}_handleCloseTap(){this._viewEditInChangeView()}_handleContentChange(e){this.debounce("store",()=>{const t=e.detail.value;t?(this.set("_newContent",e.detail.value),this.$.storage.setEditableContentItem(this.storageKey,t)):this.$.storage.eraseEditableContentItem(this.storageKey)},100)}_handleSaveShortcut(e){e.preventDefault(),this._saveDisabled||this._saveEdit()}};aS([Bl({type:Object,observer:"_paramsChanged"})],lS.prototype,"params",void 0),aS([Bl({type:Object})],lS.prototype,"_change",void 0),aS([Bl({type:Number})],lS.prototype,"_changeNum",void 0),aS([Bl({type:String})],lS.prototype,"_patchNum",void 0),aS([Bl({type:String})],lS.prototype,"_path",void 0),aS([Bl({type:String})],lS.prototype,"_type",void 0),aS([Bl({type:String})],lS.prototype,"_content",void 0),aS([Bl({type:String})],lS.prototype,"_newContent",void 0),aS([Bl({type:Boolean})],lS.prototype,"_saving",void 0),aS([Bl({type:Boolean})],lS.prototype,"_successfulSave",void 0),aS([Bl({type:Boolean,computed:"_computeSaveDisabled(_content, _newContent, _saving)"})],lS.prototype,"_saveDisabled",void 0),aS([Bl({type:Object})],lS.prototype,"_prefs",void 0),aS([Bl({type:Number})],lS.prototype,"_lineNum",void 0),lS=aS([Ml("gr-editor-view")],lS);var cS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let dS=class extends(oo(dr(oa))){_configChanged(e){const t=e.plugin,n=t&&t.html_resource_paths||[],i=this._handleMigrations(t&&t.js_resource_paths||[],n),o=!!e.default_theme&&!eh().isPluginPreloaded("preloaded:gerrit-theme"),s=(o?[e.default_theme]:[]).concat(i,n),r={};o&&(r[e.default_theme]={sync:!0}),eh().loadPlugins(s,r)}_handleMigrations(e,t){return e.filter(e=>{const n=e.replace(/\.js$/,".html");return!t.includes(n)})}};cS([Bl({type:Object,observer:"_configChanged"})],dS.prototype,"config",void 0),dS=cS([Ml("gr-plugin-host")],dS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const hS=ta`
  <style include="shared-styles">
    h1 {
      margin-bottom: var(--spacing-m);
    }
    h3 {
      margin-bottom: var(--spacing-m);
    }
    .agreementsUrl {
      border: 1px solid #b0bdcc;
      margin-bottom: var(--spacing-xl);
      margin-left: var(--spacing-xl);
      margin-right: var(--spacing-xl);
      padding: var(--spacing-s);
    }
    #claNewAgreementsLabel {
      font-weight: var(--font-weight-bold);
    }
    #claNewAgreement {
      display: none;
    }
    #claNewAgreement.show {
      display: block;
    }
    .contributorAgreementButton {
      font-weight: var(--font-weight-bold);
    }
    .alreadySubmittedText {
      color: var(--error-text-color);
      margin: 0 var(--spacing-xxl);
      padding: var(--spacing-m);
    }
    .alreadySubmittedText.hide,
    .hideAgreementsTextBox {
      display: none;
    }
    main {
      margin: var(--spacing-xxl) auto;
      max-width: 50em;
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <main>
    <h1 class="heading-1">New Contributor Agreement</h1>
    <h3 class="heading-3">Select an agreement type:</h3>
    <template
      is="dom-repeat"
      items="[[_serverConfig.auth.contributor_agreements]]"
    >
      <span class="contributorAgreementButton">
        <input
          id$="claNewAgreementsInput[[item.name]]"
          name="claNewAgreementsRadio"
          type="radio"
          data-name$="[[item.name]]"
          data-url$="[[item.url]]"
          on-click="_handleShowAgreement"
          disabled$="[[_disableAgreements(item, _groups, _signedAgreements)]]"
        />
        <label id="claNewAgreementsLabel">[[item.name]]</label>
      </span>
      <div
        class$="alreadySubmittedText [[_hideAgreements(item, _groups, _signedAgreements)]]"
      >
        Agreement already submitted.
      </div>
      <div class="agreementsUrl">
        [[item.description]]
      </div>
    </template>
    <div
      id="claNewAgreement"
      class$="[[_computeShowAgreementsClass(_showAgreements)]]"
    >
      <h3 class="heading-3">Review the agreement:</h3>
      <div id="agreementsUrl" class="agreementsUrl">
        <a href$="[[_agreementsUrl]]" target="blank" rel="noopener">
          Please review the agreement.</a
        >
      </div>
      <div
        class$="agreementsTextBox [[_computeHideAgreementClass(_agreementName, _serverConfig.auth.contributor_agreements)]]"
      >
        <h3 class="heading-3">Complete the agreement:</h3>
        <iron-input
          bind-value="{{_agreementsText}}"
          placeholder="Enter 'I agree' here"
        >
          <input
            id="input-agreements"
            is="iron-input"
            bind-value="{{_agreementsText}}"
            placeholder="Enter 'I agree' here"
          />
        </iron-input>
        <gr-button
          on-click="_handleSaveAgreements"
          disabled="[[_disableAgreementsText(_agreementsText)]]"
        >
          Submit
        </gr-button>
      </div>
    </div>
  </main>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var pS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let uS=class extends(oo(dr(oa))){constructor(){super(...arguments),this._showAgreements=!1}static get template(){return hS}attached(){super.attached(),this.loadData(),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"New Contributor Agreement"},composed:!0,bubbles:!0}))}loadData(){const e=[];return e.push(this.$.restAPI.getConfig(!0).then(e=>{this._serverConfig=e})),e.push(this.$.restAPI.getAccountGroups().then(e=>{e&&(this._groups=e.sort((e,t)=>(e.name||"").localeCompare(t.name||"")))})),e.push(this.$.restAPI.getAccountAgreements().then(e=>{this._signedAgreements=e||[]})),Promise.all(e)}_getAgreementsUrl(e){let t;return e?(t=e.startsWith("http:")||e.startsWith("https:")?e:j()+"/"+e,t):""}_handleShowAgreement(e){this._agreementName=e.target.getAttribute("data-name");const t=e.target.getAttribute("data-url");this._agreementsUrl=this._getAgreementsUrl(t),this._showAgreements=!0}_handleSaveAgreements(){this._createToast("Agreement saving...");const e=this._agreementName;return this.$.restAPI.saveAccountAgreement({name:e}).then(e=>{let t="Agreement failed to be submitted, please try again";200===e.status&&(t="Agreement has been successfully submitted."),this._createToast(t),this.loadData(),this._agreementsText="",this._showAgreements=!1})}_createToast(e){this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:e},bubbles:!0,composed:!0}))}_computeShowAgreementsClass(e){return e?"show":""}_disableAgreements(e,t,n){if(!t)return!1;for(const i of t)if(e&&e.auto_verify_group&&e.auto_verify_group.id===i.id||n.find(t=>t.name===e.name))return!0;return!1}_hideAgreements(e,t,n){return this._disableAgreements(e,t,n)?"":"hide"}_disableAgreementsText(e){return"i agree"!==e.toLowerCase()}_computeHideAgreementClass(e,t){return t&&t.some(t=>e===t.name&&!t.auto_verify_group)?"hideAgreementsTextBox":""}};pS([Bl({type:Object})],uS.prototype,"_groups",void 0),pS([Bl({type:Object})],uS.prototype,"_serverConfig",void 0),pS([Bl({type:String})],uS.prototype,"_agreementsText",void 0),pS([Bl({type:String})],uS.prototype,"_agreementName",void 0),pS([Bl({type:Array})],uS.prototype,"_signedAgreements",void 0),pS([Bl({type:Boolean})],uS.prototype,"_showAgreements",void 0),pS([Bl({type:String})],uS.prototype,"_agreementsUrl",void 0),uS=pS([Ml("gr-cla-view")],uS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const gS=ta`
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="shared-styles">
    :host {
      display: block;
    }
    main {
      max-width: 46em;
    }
    :host(.loading) main {
      display: none;
    }
    .loadingMessage {
      display: none;
      font-style: italic;
    }
    :host(.loading) .loadingMessage {
      display: block;
    }
    hr {
      margin-top: var(--spacing-l);
      margin-bottom: var(--spacing-l);
    }
    header {
      border-bottom: 1px solid var(--border-color);
      font-weight: var(--font-weight-bold);
      margin-bottom: var(--spacing-l);
    }
    .container {
      padding: var(--spacing-m) var(--spacing-xl);
    }
    footer {
      display: flex;
      justify-content: flex-end;
    }
    footer gr-button {
      margin-left: var(--spacing-l);
    }
    input {
      width: 20em;
    }
    section.hide {
      display: none;
    }
  </style>
  <div class="container gr-form-styles">
    <header>Please confirm your contact information</header>
    <div class="loadingMessage">Loading...</div>
    <main>
      <p>
        The following contact information was automatically obtained when you
        signed in to the site. This information is used to display who you are
        to others, and to send updates to code reviews you have either started
        or subscribed to.
      </p>
      <hr />
      <section>
        <div class="title">Full Name</div>
        <iron-input bind-value="{{_account.name}}">
          <input
            is="iron-input"
            id="name"
            bind-value="{{_account.name}}"
            disabled="[[_saving]]"
          />
        </iron-input>
      </section>
      <section class$="[[_computeUsernameClass(_usernameMutable)]]">
        <div class="title">Username</div>
        <iron-input bind-value="{{_account.username}}">
          <input
            is="iron-input"
            id="username"
            bind-value="{{_account.username}}"
            disabled="[[_saving]]"
          />
        </iron-input>
      </section>
      <section>
        <div class="title">Preferred Email</div>
        <select id="email" disabled="[[_saving]]">
          <option value="[[_account.email]]">[[_account.email]]</option>
          <template is="dom-repeat" items="[[_account.secondary_emails]]">
            <option value="[[item]]">[[item]]</option>
          </template>
        </select>
      </section>
      <hr />
      <p>
        More configuration options for Gerrit may be found in the
        <a on-click="close" href$="[[settingsUrl]]">settings</a>.
      </p>
    </main>
    <footer>
      <gr-button
        id="closeButton"
        link=""
        disabled="[[_saving]]"
        on-click="_handleClose"
        >Close</gr-button
      >
      <gr-button
        id="saveButton"
        primary=""
        link=""
        disabled="[[_computeSaveDisabled(_account.name, _account.email, _saving)]]"
        on-click="_handleSave"
        >Save</gr-button
      >
    </footer>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var mS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let _S=class extends(oo(dr(oa))){constructor(){super(...arguments),this._account={},this._loading=!0,this._saving=!1,this._usernameMutable=!1}static get template(){return gS}ready(){super.ready(),this._ensureAttribute("role","dialog")}_computeUsernameMutable(e,t){return void 0!==e&&(e.auth.editable_account_fields.includes("USER_NAME")&&!t)}loadData(){this._loading=!0;const e=this.$.restAPI.getAccount().then(e=>{this._account={...this._account,...e}}),t=this.$.restAPI.getConfig().then(e=>{this._serverConfig=e});return Promise.all([e,t]).then(()=>{this._loading=!1})}_save(){this._saving=!0;const e=[this.$.restAPI.setAccountName(this.$.name.value),this.$.restAPI.setPreferredAccountEmail(this.$.email.value||"")];return this._usernameMutable&&e.push(this.$.restAPI.setAccountUsername(this.$.username.value)),Promise.all(e).then(()=>{this._saving=!1,this.dispatchEvent(new CustomEvent("account-detail-update",{composed:!0,bubbles:!0}))})}_handleSave(e){e.preventDefault(),this._save().then(()=>this.close())}_handleClose(e){e.preventDefault(),this.close()}close(){this._saving=!0,this.dispatchEvent(new CustomEvent("close",{composed:!0,bubbles:!0}))}_computeSaveDisabled(e,t,n){return!e||!t||n}_computeUsernameClass(e){return e?"":"hide"}_loadingChanged(){this.classList.toggle("loading",this._loading)}};mS([Bl({type:String})],_S.prototype,"settingsUrl",void 0),mS([Bl({type:Object})],_S.prototype,"_account",void 0),mS([Bl({type:Boolean})],_S.prototype,"_loading",void 0),mS([Bl({type:Boolean})],_S.prototype,"_saving",void 0),mS([Bl({type:Object})],_S.prototype,"_serverConfig",void 0),mS([Bl({computed:"_computeUsernameMutable(_serverConfig,_account.username)",type:Boolean})],_S.prototype,"_usernameMutable",void 0),mS([jl("_loading")],_S.prototype,"_loadingChanged",null),_S=mS([Ml("gr-registration-dialog")],_S);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const fS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    #changeCols {
      width: auto;
    }
    #changeCols .visibleHeader {
      text-align: center;
    }
    .checkboxContainer {
      cursor: pointer;
      text-align: center;
    }
    .checkboxContainer input {
      cursor: pointer;
    }
    .checkboxContainer:hover {
      outline: 1px solid var(--border-color);
    }
  </style>
  <div class="gr-form-styles">
    <table id="changeCols">
      <thead>
        <tr>
          <th class="nameHeader">Column</th>
          <th class="visibleHeader">Visible</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>Number</td>
          <td
            class="checkboxContainer"
            on-click="_handleCheckboxContainerClick"
          >
            <input
              type="checkbox"
              name="number"
              on-click="_handleNumberCheckboxClick"
              checked$="[[showNumber]]"
            />
          </td>
        </tr>
        <template is="dom-repeat" items="[[columnNames]]">
          <tr>
            <td>[[item]]</td>
            <td
              class="checkboxContainer"
              on-click="_handleCheckboxContainerClick"
            >
              <input
                type="checkbox"
                name="[[item]]"
                on-click="_handleTargetClick"
                checked$="[[!isColumnHidden(item, displayedColumns)]]"
              />
            </td>
          </tr>
        </template>
      </tbody>
    </table>
  </div>
`;var vS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let yS=class extends(z_(oo(dr(oa)))){static get template(){return fS}_getDisplayedColumns(){return null===this.root?[]:Array.from(this.root.querySelectorAll(".checkboxContainer input:not([name=number])")).filter(e=>e.checked).map(e=>e.name)}_handleCheckboxContainerClick(e){if(null===e.target)return;const t=e.target.querySelector("input");t&&t.click()}_handleNumberCheckboxClick(e){this.showNumber=qo(e).rootTarget.checked}_handleTargetClick(){this.set("displayedColumns",this._getDisplayedColumns())}};vS([Bl({type:Array,notify:!0})],yS.prototype,"displayedColumns",void 0),vS([Bl({type:Boolean,notify:!0})],yS.prototype,"showNumber",void 0),yS=vS([Ml("gr-change-table-editor")],yS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const bS=ta`
  <style include="shared-styles">
    gr-avatar {
      height: 120px;
      width: 120px;
      margin-right: var(--spacing-xs);
      vertical-align: -0.25em;
    }
    div section.hide {
      display: none;
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div class="gr-form-styles">
    <section>
      <span class="title"></span>
      <span class="value">
        <gr-avatar account="[[_account]]" image-size="120"></gr-avatar>
      </span>
    </section>
    <section class$="[[_hideAvatarChangeUrl(_avatarChangeUrl)]]">
      <span class="title"></span>
      <span class="value">
        <a href$="[[_avatarChangeUrl]]">
          Change avatar
        </a>
      </span>
    </section>
    <section>
      <span class="title">ID</span>
      <span class="value">[[_account._account_id]]</span>
    </section>
    <section>
      <span class="title">Email</span>
      <span class="value">[[_account.email]]</span>
    </section>
    <section>
      <span class="title">Registered</span>
      <span class="value">
        <gr-date-formatter
          has-tooltip=""
          date-str="[[_account.registered_on]]"
        ></gr-date-formatter>
      </span>
    </section>
    <section id="usernameSection">
      <span class="title">Username</span>
      <span hidden$="[[usernameMutable]]" class="value">[[_username]]</span>
      <span hidden$="[[!usernameMutable]]" class="value">
        <iron-input on-keydown="_handleKeydown" bind-value="{{_username}}">
          <input
            is="iron-input"
            id="usernameInput"
            disabled="[[_saving]]"
            on-keydown="_handleKeydown"
            bind-value="{{_username}}"
          />
        </iron-input>
      </span>
    </section>
    <section id="nameSection">
      <span class="title">Full name</span>
      <span hidden$="[[nameMutable]]" class="value">[[_account.name]]</span>
      <span hidden$="[[!nameMutable]]" class="value">
        <iron-input on-keydown="_handleKeydown" bind-value="{{_account.name}}">
          <input
            is="iron-input"
            id="nameInput"
            disabled="[[_saving]]"
            on-keydown="_handleKeydown"
            bind-value="{{_account.name}}"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Display name</span>
      <span class="value">
        <iron-input
          on-keydown="_handleKeydown"
          bind-value="{{_account.display_name}}"
        >
          <input
            is="iron-input"
            id="displayNameInput"
            disabled="[[_saving]]"
            on-keydown="_handleKeydown"
            bind-value="{{_account.display_name}}"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Status (e.g. "Vacation")</span>
      <span class="value">
        <iron-input
          on-keydown="_handleKeydown"
          bind-value="{{_account.status}}"
        >
          <input
            is="iron-input"
            id="statusInput"
            disabled="[[_saving]]"
            on-keydown="_handleKeydown"
            bind-value="{{_account.status}}"
          />
        </iron-input>
      </span>
    </section>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var wS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let CS=class extends(oo(dr(oa))){constructor(){super(...arguments),this._loading=!1,this._saving=!1,this._avatarChangeUrl=""}static get template(){return bS}loadData(){const e=[];return this._loading=!0,e.push(this.$.restAPI.getConfig().then(e=>{this._serverConfig=e})),e.push(this.$.restAPI.getAccount().then(e=>{e&&(this._hasNameChange=!1,this._hasUsernameChange=!1,this._hasDisplayNameChange=!1,this._hasStatusChange=!1,e.username=e.username||"",this._account=e,this._username=e.username)})),e.push(this.$.restAPI.getAvatarChangeUrl().then(e=>{this._avatarChangeUrl=e||""})),Promise.all(e).then(()=>{this._loading=!1})}save(){return this.hasUnsavedChanges?(this._saving=!0,this._maybeSetName().then(()=>this._maybeSetUsername()).then(()=>this._maybeSetDisplayName()).then(()=>this._maybeSetStatus()).then(()=>{this._hasNameChange=!1,this._hasDisplayNameChange=!1,this._hasStatusChange=!1,this._saving=!1,this.dispatchEvent(new CustomEvent("account-detail-update",{composed:!0,bubbles:!0}))})):Promise.resolve()}_maybeSetName(){var e;return this._hasNameChange&&this.nameMutable&&(null===(e=this._account)||void 0===e?void 0:e.name)?this.$.restAPI.setAccountName(this._account.name):Promise.resolve()}_maybeSetUsername(){return this._hasUsernameChange&&this.usernameMutable&&this._username?this.$.restAPI.setAccountUsername(this._username):Promise.resolve()}_maybeSetDisplayName(){var e;return this._hasDisplayNameChange&&void 0!==(null===(e=this._account)||void 0===e?void 0:e.display_name)?this.$.restAPI.setAccountDisplayName(this._account.display_name):Promise.resolve()}_maybeSetStatus(){var e;return this._hasStatusChange&&void 0!==(null===(e=this._account)||void 0===e?void 0:e.status)?this.$.restAPI.setAccountStatus(this._account.status):Promise.resolve()}_computeHasUnsavedChanges(e,t,n,i){return e||t||n||i}_computeUsernameMutable(e,t){if(![e,t].includes(void 0))return e.auth.editable_account_fields.includes("USER_NAME")&&!t}_computeNameMutable(e){return e.auth.editable_account_fields.includes("FULL_NAME")}_statusChanged(){this._loading||(this._hasStatusChange=!0)}_displayNameChanged(){this._loading||(this._hasDisplayNameChange=!0)}_usernameChanged(){!this._loading&&this._account&&(this._hasUsernameChange=(this._account.username||"")!==(this._username||""))}_nameChanged(){this._loading||(this._hasNameChange=!0)}_handleKeydown(e){13===e.keyCode&&(e.stopPropagation(),this.save())}_hideAvatarChangeUrl(e){return e?"":"hide"}};wS([Bl({type:Boolean,notify:!0,computed:"_computeUsernameMutable(_serverConfig, _account.username)"})],CS.prototype,"usernameMutable",void 0),wS([Bl({type:Boolean,notify:!0,computed:"_computeNameMutable(_serverConfig)"})],CS.prototype,"nameMutable",void 0),wS([Bl({type:Boolean,notify:!0,computed:"_computeHasUnsavedChanges(_hasNameChange, _hasUsernameChange, _hasStatusChange, _hasDisplayNameChange)"})],CS.prototype,"hasUnsavedChanges",void 0),wS([Bl({type:Boolean})],CS.prototype,"_hasNameChange",void 0),wS([Bl({type:Boolean})],CS.prototype,"_hasUsernameChange",void 0),wS([Bl({type:Boolean})],CS.prototype,"_hasDisplayNameChange",void 0),wS([Bl({type:Boolean})],CS.prototype,"_hasStatusChange",void 0),wS([Bl({type:Boolean})],CS.prototype,"_loading",void 0),wS([Bl({type:Boolean})],CS.prototype,"_saving",void 0),wS([Bl({type:Object})],CS.prototype,"_account",void 0),wS([Bl({type:Object})],CS.prototype,"_serverConfig",void 0),wS([Bl({type:String,observer:"_usernameChanged"})],CS.prototype,"_username",void 0),wS([Bl({type:String})],CS.prototype,"_avatarChangeUrl",void 0),wS([jl("_account.status")],CS.prototype,"_statusChanged",null),wS([jl("_account.display_name")],CS.prototype,"_displayNameChanged",null),wS([jl("_account.name")],CS.prototype,"_nameChanged",null),CS=wS([Ml("gr-account-info")],CS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ES=ta`
  <style include="shared-styles">
    #agreements .nameColumn {
      min-width: 15em;
      width: auto;
    }
    #agreements .descriptionColumn {
      width: auto;
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div class="gr-form-styles">
    <table id="agreements">
      <thead>
        <tr>
          <th class="nameColumn">Name</th>
          <th class="descriptionColumn">Description</th>
        </tr>
      </thead>
      <tbody>
        <template is="dom-repeat" items="[[_agreements]]">
          <tr>
            <td class="nameColumn">
              <a href$="[[getUrlBase(item.url)]]" rel="external">
                [[item.name]]
              </a>
            </td>
            <td class="descriptionColumn">[[item.description]]</td>
          </tr>
        </template>
      </tbody>
    </table>
    <a href$="[[getUrl()]]">New Contributor Agreement</a>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;var SS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let AS=class extends(oo(dr(oa))){static get template(){return ES}attached(){super.attached(),this.loadData()}loadData(){return this.$.restAPI.getAccountAgreements().then(e=>{this._agreements=e})}getUrl(){return`${j()}/settings/new-agreement`}getUrlBase(e){return`${j()}/${e}`}};SS([Bl({type:Array})],AS.prototype,"_agreements",void 0),AS=SS([Ml("gr-agreements-list")],AS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const xS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div id="editPreferences" class="gr-form-styles">
    <section>
      <span class="title">Tab width</span>
      <span class="value">
        <iron-input
          type="number"
          prevent-invalid-input=""
          allowed-pattern="[0-9]"
          bind-value="{{editPrefs.tab_size}}"
          on-keypress="_handleEditPrefsChanged"
          on-change="_handleEditPrefsChanged"
        >
          <input
            is="iron-input"
            type="number"
            prevent-invalid-input=""
            allowed-pattern="[0-9]"
            bind-value="{{editPrefs.tab_size}}"
            on-keypress="_handleEditPrefsChanged"
            on-change="_handleEditPrefsChanged"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Columns</span>
      <span class="value">
        <iron-input
          type="number"
          prevent-invalid-input=""
          allowed-pattern="[0-9]"
          bind-value="{{editPrefs.line_length}}"
          on-keypress="_handleEditPrefsChanged"
          on-change="_handleEditPrefsChanged"
        >
          <input
            is="iron-input"
            type="number"
            prevent-invalid-input=""
            allowed-pattern="[0-9]"
            bind-value="{{editPrefs.line_length}}"
            on-keypress="_handleEditPrefsChanged"
            on-change="_handleEditPrefsChanged"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Indent unit</span>
      <span class="value">
        <iron-input
          type="number"
          prevent-invalid-input=""
          allowed-pattern="[0-9]"
          bind-value="{{editPrefs.indent_unit}}"
          on-keypress="_handleEditPrefsChanged"
          on-change="_handleEditPrefsChanged"
        >
          <input
            is="iron-input"
            type="number"
            prevent-invalid-input=""
            allowed-pattern="[0-9]"
            bind-value="{{editPrefs.indent_unit}}"
            on-keypress="_handleEditPrefsChanged"
            on-change="_handleEditPrefsChanged"
          />
        </iron-input>
      </span>
    </section>
    <section>
      <span class="title">Syntax highlighting</span>
      <span class="value">
        <input
          id="editSyntaxHighlighting"
          type="checkbox"
          checked$="[[editPrefs.syntax_highlighting]]"
          on-change="_handleEditSyntaxHighlightingChanged"
        />
      </span>
    </section>
    <section>
      <span class="title">Show tabs</span>
      <span class="value">
        <input
          id="editShowTabs"
          type="checkbox"
          checked$="[[editPrefs.show_tabs]]"
          on-change="_handleEditShowTabsChanged"
        />
      </span>
    </section>
    <section>
      <span class="title">Match brackets</span>
      <span class="value">
        <input
          id="showMatchBrackets"
          type="checkbox"
          checked$="[[editPrefs.match_brackets]]"
          on-change="_handleMatchBracketsChanged"
        />
      </span>
    </section>
    <section>
      <span class="title">Line wrapping</span>
      <span class="value">
        <input
          id="editShowLineWrapping"
          type="checkbox"
          checked$="[[editPrefs.line_wrapping]]"
          on-change="_handleEditLineWrappingChanged"
        />
      </span>
    </section>
    <section>
      <span class="title">Indent with tabs</span>
      <span class="value">
        <input
          id="showIndentWithTabs"
          type="checkbox"
          checked$="[[editPrefs.indent_with_tabs]]"
          on-change="_handleIndentWithTabsChanged"
        />
      </span>
    </section>
    <section>
      <span class="title">Auto close brackets</span>
      <span class="value">
        <input
          id="showAutoCloseBrackets"
          type="checkbox"
          checked$="[[editPrefs.auto_close_brackets]]"
          on-change="_handleAutoCloseBracketsChanged"
        />
      </span>
    </section>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var PS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let RS=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasUnsavedChanges=!1}static get template(){return xS}loadData(){return this.$.restAPI.getEditPreferences().then(e=>{this.editPrefs=e})}_handleEditPrefsChanged(){this.hasUnsavedChanges=!0}_handleEditSyntaxHighlightingChanged(){this.set("editPrefs.syntax_highlighting",this.$.editSyntaxHighlighting.checked),this._handleEditPrefsChanged()}_handleEditShowTabsChanged(){this.set("editPrefs.show_tabs",this.$.editShowTabs.checked),this._handleEditPrefsChanged()}_handleMatchBracketsChanged(){this.set("editPrefs.match_brackets",this.$.showMatchBrackets.checked),this._handleEditPrefsChanged()}_handleEditLineWrappingChanged(){this.set("editPrefs.line_wrapping",this.$.editShowLineWrapping.checked),this._handleEditPrefsChanged()}_handleIndentWithTabsChanged(){this.set("editPrefs.indent_with_tabs",this.$.showIndentWithTabs.checked),this._handleEditPrefsChanged()}_handleAutoCloseBracketsChanged(){this.set("editPrefs.auto_close_brackets",this.$.showAutoCloseBrackets.checked),this._handleEditPrefsChanged()}save(){return this.editPrefs?this.$.restAPI.saveEditPreferences(this.editPrefs).then(()=>{this.hasUnsavedChanges=!1}):Promise.reject(new Error("Missing edit preferences"))}};PS([Bl({type:Boolean,notify:!0})],RS.prototype,"hasUnsavedChanges",void 0),PS([Bl({type:Object})],RS.prototype,"editPrefs",void 0),RS=PS([Ml("gr-edit-preferences")],RS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const TS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    th {
      color: var(--deemphasized-text-color);
      text-align: left;
    }
    #emailTable .emailColumn {
      min-width: 32.5em;
      width: auto;
    }
    #emailTable .preferredHeader {
      text-align: center;
      width: 6em;
    }
    #emailTable .preferredControl {
      cursor: pointer;
      height: auto;
      text-align: center;
    }
    #emailTable .preferredControl .preferredRadio {
      height: auto;
    }
    .preferredControl:hover {
      outline: 1px solid var(--border-color);
    }
  </style>
  <div class="gr-form-styles">
    <table id="emailTable">
      <thead>
        <tr>
          <th class="emailColumn">Email</th>
          <th class="preferredHeader">Preferred</th>
          <th></th>
        </tr>
      </thead>
      <tbody>
        <template is="dom-repeat" items="[[_emails]]">
          <tr>
            <td class="emailColumn">[[item.email]]</td>
            <td
              class="preferredControl"
              on-click="_handlePreferredControlClick"
            >
              <iron-input
                class="preferredRadio"
                type="radio"
                on-change="_handlePreferredChange"
                name="preferred"
                bind-value="[[item.email]]"
                checked$="[[item.preferred]]"
              >
                <input
                  is="iron-input"
                  class="preferredRadio"
                  type="radio"
                  on-change="_handlePreferredChange"
                  name="preferred"
                  value="[[item.email]]"
                  checked$="[[item.preferred]]"
                />
              </iron-input>
            </td>
            <td>
              <gr-button
                data-index$="[[index]]"
                on-click="_handleDeleteButton"
                disabled="[[item.preferred]]"
                class="remove-button"
                >Delete</gr-button
              >
            </td>
          </tr>
        </template>
      </tbody>
    </table>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var IS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let kS=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasUnsavedChanges=!1,this._emails=[],this._emailsToRemove=[],this._newPreferred=null}static get template(){return TS}loadData(){return this.$.restAPI.getAccountEmails().then(e=>{this._emails=null!=e?e:[]})}save(){const e=[];for(const t of this._emailsToRemove)e.push(this.$.restAPI.deleteAccountEmail(t.email));return this._newPreferred&&e.push(this.$.restAPI.setPreferredAccountEmail(this._newPreferred)),Promise.all(e).then(()=>{this._emailsToRemove=[],this._newPreferred=null,this.hasUnsavedChanges=!1})}_handleDeleteButton(e){const t=qo(e).localTarget;if(!(t instanceof Element))return;const n=t.getAttribute("data-index");if(null===n)return;const i=parseInt(n,10),o=this._emails[i];this.push("_emailsToRemove",o),this.splice("_emails",i,1),this.hasUnsavedChanges=!0}_handlePreferredControlClick(e){e.target instanceof HTMLElement&&e.target.classList.contains("preferredControl")&&e.target.firstElementChild instanceof HTMLInputElement&&e.target.firstElementChild.click()}_handlePreferredChange(e){if(!(e.target instanceof HTMLInputElement))return;const t=e.target.value;for(let e=0;e<this._emails.length;e++)t===this._emails[e].email?(this.set(["_emails",e,"preferred"],!0),this._newPreferred=t,this.hasUnsavedChanges=!0):this._emails[e].preferred&&this.set(["_emails",e,"preferred"],!1)}};IS([Bl({type:Boolean,notify:!0})],kS.prototype,"hasUnsavedChanges",void 0),IS([Bl({type:Array})],kS.prototype,"_emails",void 0),IS([Bl({type:Array})],kS.prototype,"_emailsToRemove",void 0),IS([Bl({type:String})],kS.prototype,"_newPreferred",void 0),kS=IS([Ml("gr-email-editor")],kS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const OS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    .keyHeader {
      width: 9em;
    }
    .userIdHeader {
      width: 15em;
    }
    #viewKeyOverlay {
      padding: var(--spacing-xxl);
      width: 50em;
    }
    .publicKey {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      overflow-x: scroll;
      overflow-wrap: break-word;
      width: 30em;
    }
    .closeButton {
      bottom: 2em;
      position: absolute;
      right: 2em;
    }
    #existing {
      margin-bottom: var(--spacing-l);
    }
  </style>
  <div class="gr-form-styles">
    <fieldset id="existing">
      <table>
        <thead>
          <tr>
            <th class="idColumn">ID</th>
            <th class="fingerPrintColumn">Fingerprint</th>
            <th class="userIdHeader">User IDs</th>
            <th class="keyHeader">Public Key</th>
            <th></th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <template is="dom-repeat" items="[[_keys]]" as="key">
            <tr>
              <td class="idColumn">[[key.id]]</td>
              <td class="fingerPrintColumn">[[key.fingerprint]]</td>
              <td class="userIdHeader">
                <template is="dom-repeat" items="[[key.user_ids]]">
                  [[item]]
                </template>
              </td>
              <td class="keyHeader">
                <gr-button on-click="_showKey" data-index$="[[index]]" link=""
                  >Click to View</gr-button
                >
              </td>
              <td>
                <gr-copy-clipboard
                  has-tooltip=""
                  button-title="Copy GPG public key to clipboard"
                  hide-input=""
                  text="[[key.key]]"
                >
                </gr-copy-clipboard>
              </td>
              <td>
                <gr-button data-index$="[[index]]" on-click="_handleDeleteKey"
                  >Delete</gr-button
                >
              </td>
            </tr>
          </template>
        </tbody>
      </table>
      <gr-overlay id="viewKeyOverlay" with-backdrop="">
        <fieldset>
          <section>
            <span class="title">Status</span>
            <span class="value">[[_keyToView.status]]</span>
          </section>
          <section>
            <span class="title">Key</span>
            <span class="value">[[_keyToView.key]]</span>
          </section>
        </fieldset>
        <gr-button class="closeButton" on-click="_closeOverlay"
          >Close</gr-button
        >
      </gr-overlay>
      <gr-button on-click="save" disabled$="[[!hasUnsavedChanges]]"
        >Save changes</gr-button
      >
    </fieldset>
    <fieldset>
      <section>
        <span class="title">New GPG key</span>
        <span class="value">
          <iron-autogrow-textarea
            id="newKey"
            autocomplete="on"
            bind-value="{{_newKey}}"
            placeholder="New GPG Key"
          ></iron-autogrow-textarea>
        </span>
      </section>
      <gr-button
        id="addButton"
        disabled$="[[_computeAddButtonDisabled(_newKey)]]"
        on-click="_handleAddKey"
        >Add new GPG key</gr-button
      >
    </fieldset>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var NS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let LS=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasUnsavedChanges=!1,this._keys=[],this._newKey="",this._keysToRemove=[]}static get template(){return OS}loadData(){return this._keys=[],this.$.restAPI.getAccountGPGKeys().then(e=>{e&&(this._keys=Object.keys(e).map(t=>{const n=e[t];return n.id=t,n}))})}save(){const e=this._keysToRemove.map(e=>this.$.restAPI.deleteAccountGPGKey(e.id));return Promise.all(e).then(()=>{this._keysToRemove=[],this.hasUnsavedChanges=!1})}_showKey(e){const t=qo(e).localTarget,n=parseInt(t.getAttribute("data-index"),10);this._keyToView=this._keys[n],this.$.viewKeyOverlay.open()}_closeOverlay(){this.$.viewKeyOverlay.close()}_handleDeleteKey(e){const t=qo(e).localTarget,n=parseInt(t.getAttribute("data-index"),10);this.push("_keysToRemove",this._keys[n]),this.splice("_keys",n,1),this.hasUnsavedChanges=!0}_handleAddKey(){return this.$.addButton.disabled=!0,this.$.newKey.disabled=!0,this.$.restAPI.addAccountGPGKey({add:[this._newKey.trim()]}).then(()=>{this.$.newKey.disabled=!1,this._newKey="",this.loadData()}).catch(()=>{this.$.addButton.disabled=!1,this.$.newKey.disabled=!1})}_computeAddButtonDisabled(e){return!e.length}};NS([Bl({type:Boolean,notify:!0})],LS.prototype,"hasUnsavedChanges",void 0),NS([Bl({type:Array})],LS.prototype,"_keys",void 0),NS([Bl({type:Object})],LS.prototype,"_keyToView",void 0),NS([Bl({type:String})],LS.prototype,"_newKey",void 0),NS([Bl({type:Array})],LS.prototype,"_keysToRemove",void 0),LS=NS([Ml("gr-gpg-editor")],LS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const DS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    #groups .nameColumn {
      min-width: 11em;
      width: auto;
    }
    .descriptionHeader {
      min-width: 21.5em;
    }
    .visibleCell {
      text-align: center;
      width: 6em;
    }
  </style>
  <div class="gr-form-styles">
    <table id="groups">
      <thead>
        <tr>
          <th class="nameHeader">Name</th>
          <th class="descriptionHeader">Description</th>
          <th class="visibleCell">Visible to all</th>
        </tr>
      </thead>
      <tbody>
        <template is="dom-repeat" items="[[_groups]]">
          <tr>
            <td class="nameColumn">
              <a href$="[[_computeGroupPath(item)]]">
                [[item.name]]
              </a>
            </td>
            <td>[[item.description]]</td>
            <td class="visibleCell">[[_computeVisibleToAll(item)]]</td>
          </tr>
        </template>
      </tbody>
    </table>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var $S=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let MS=class extends(oo(dr(oa))){constructor(){super(...arguments),this._groups=[]}static get template(){return DS}loadData(){return this.$.restAPI.getAccountGroups().then(e=>{e&&(this._groups=e.sort((e,t)=>(e.name||"").localeCompare(t.name||"")))})}_computeVisibleToAll(e){return e.options&&e.options.visible_to_all?"Yes":"No"}_computeGroupPath(e){if(e&&e.id)return gh.getUrlForGroup(decodeURIComponent(e.id))}};$S([Bl({type:Array})],MS.prototype,"_groups",void 0),MS=$S([Ml("gr-group-list")],MS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const FS=ta`
  <style include="shared-styles">
    .password {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
    }
    #generatedPasswordOverlay {
      padding: var(--spacing-xxl);
      width: 50em;
    }
    #generatedPasswordDisplay {
      margin: var(--spacing-l) 0;
    }
    #generatedPasswordDisplay .title {
      width: unset;
    }
    #generatedPasswordDisplay .value {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
    }
    #passwordWarning {
      font-style: italic;
      text-align: center;
    }
    .closeButton {
      bottom: 2em;
      position: absolute;
      right: 2em;
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div class="gr-form-styles">
    <div hidden$="[[_passwordUrl]]">
      <section>
        <span class="title">Username</span>
        <span class="value">[[_username]]</span>
      </section>
      <gr-button id="generateButton" on-click="_handleGenerateTap"
        >Generate new password</gr-button
      >
    </div>
    <span hidden$="[[!_passwordUrl]]">
      <a href$="[[_passwordUrl]]" target="_blank" rel="noopener">
        Obtain password</a
      >
      (opens in a new tab)
    </span>
  </div>
  <gr-overlay
    id="generatedPasswordOverlay"
    on-iron-overlay-closed="_generatedPasswordOverlayClosed"
    with-backdrop=""
  >
    <div class="gr-form-styles">
      <section id="generatedPasswordDisplay">
        <span class="title">New Password:</span>
        <span class="value">[[_generatedPassword]]</span>
        <gr-copy-clipboard
          has-tooltip=""
          button-title="Copy password to clipboard"
          hide-input=""
          text="[[_generatedPassword]]"
        >
        </gr-copy-clipboard>
      </section>
      <section id="passwordWarning">
        This password will not be displayed again.<br />
        If you lose it, you will need to generate a new one.
      </section>
      <gr-button link="" class="closeButton" on-click="_closeOverlay"
        >Close</gr-button
      >
    </div>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var BS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let jS=class extends(oo(dr(oa))){constructor(){super(...arguments),this._passwordUrl=null}static get template(){return FS}attached(){super.attached(),this.loadData()}loadData(){const e=[];return e.push(this.$.restAPI.getAccount().then(e=>{e&&(this._username=e.username)})),e.push(this.$.restAPI.getConfig().then(e=>{this._passwordUrl=e&&e.auth.http_password_url||null})),Promise.all(e)}_handleGenerateTap(){this._generatedPassword="Generating...",this.$.generatedPasswordOverlay.open(),this.$.restAPI.generateAccountHttpPassword().then(e=>{this._generatedPassword=e})}_closeOverlay(){this.$.generatedPasswordOverlay.close()}_generatedPasswordOverlayClosed(){this._generatedPassword=""}};BS([Bl({type:String})],jS.prototype,"_username",void 0),BS([Bl({type:String})],jS.prototype,"_generatedPassword",void 0),BS([Bl({type:String})],jS.prototype,"_passwordUrl",void 0),jS=BS([Ml("gr-http-password")],jS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const HS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    tr th.emailAddressHeader,
    tr th.identityHeader {
      width: 15em;
      padding: 0 10px;
    }
    tr td.statusColumn,
    tr td.emailAddressColumn,
    tr td.identityColumn {
      word-break: break-word;
    }
    tr td.emailAddressColumn,
    tr td.identityColumn {
      padding: 4px 10px;
      width: 15em;
    }
    .deleteButton {
      float: right;
    }
    .deleteButton:not(.show) {
      display: none;
    }
    .space {
      margin-bottom: var(--spacing-l);
    }
  </style>
  <div class="gr-form-styles">
    <fieldset class="space">
      <table>
        <thead>
          <tr>
            <th class="statusHeader">Status</th>
            <th class="emailAddressHeader">Email Address</th>
            <th class="identityHeader">Identity</th>
            <th class="deleteHeader"></th>
          </tr>
        </thead>
        <tbody>
          <template
            is="dom-repeat"
            items="[[_identities]]"
            filter="filterIdentities"
          >
            <tr>
              <td class="statusColumn">
                [[_computeIsTrusted(item.trusted)]]
              </td>
              <td class="emailAddressColumn">[[item.email_address]]</td>
              <td class="identityColumn">
                [[_computeIdentity(item.identity)]]
              </td>
              <td class="deleteColumn">
                <gr-button
                  class$="deleteButton [[_computeHideDeleteClass(item.can_delete)]]"
                  on-click="_handleDeleteItem"
                >
                  Delete
                </gr-button>
              </td>
            </tr>
          </template>
        </tbody>
      </table>
    </fieldset>
    <template is="dom-if" if="[[_showLinkAnotherIdentity]]">
      <fieldset>
        <a href$="[[_computeLinkAnotherIdentity()]]">
          <gr-button id="linkAnotherIdentity" link=""
            >Link Another Identity</gr-button
          >
        </a>
      </fieldset>
    </template>
  </div>
  <gr-overlay id="overlay" with-backdrop="">
    <gr-confirm-delete-item-dialog
      class="confirmDialog"
      on-confirm="_handleDeleteItemConfirm"
      on-cancel="_handleConfirmDialogCancel"
      item="[[_idName]]"
      item-type="id"
    ></gr-confirm-delete-item-dialog>
  </gr-overlay>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var US=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const GS=["OPENID","OAUTH"];let VS=class extends(oo(dr(oa))){constructor(){super(...arguments),this._identities=[]}static get template(){return HS}loadData(){return this.$.restAPI.getExternalIds().then(e=>{this._identities=null!=e?e:[]})}_computeIdentity(e){return e&&e.startsWith("mailto:")?"":e}_computeHideDeleteClass(e){return e?"show":""}_handleDeleteItemConfirm(){return this.$.overlay.close(),this.$.restAPI.deleteAccountIdentity([this._idName]).then(()=>{this.loadData()})}_handleConfirmDialogCancel(){this.$.overlay.close()}_handleDeleteItem(e){const t=e.model.item.identity;t&&(this._idName=t,this.$.overlay.open())}_computeIsTrusted(e){return e?"":"Untrusted"}filterIdentities(e){return!e.identity.startsWith("username:")}_computeShowLinkAnotherIdentity(e){var t;return!(null===(t=null==e?void 0:e.auth)||void 0===t||!t.git_basic_auth_policy)&&GS.includes(e.auth.git_basic_auth_policy.toUpperCase())}_computeLinkAnotherIdentity(){const e=j()||"";let t=window.location.pathname;return e&&(t="/"+t.substring(e.length)),e+"/login/"+encodeURIComponent(t)+"?link"}};US([Bl({type:Array})],VS.prototype,"_identities",void 0),US([Bl({type:String})],VS.prototype,"_idName",void 0),US([Bl({type:Object})],VS.prototype,"serverConfig",void 0),US([Bl({type:Boolean,computed:"_computeShowLinkAnotherIdentity(serverConfig)"})],VS.prototype,"_showLinkAnotherIdentity",void 0),VS=US([Ml("gr-identities")],VS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const zS=ta`
  <style include="shared-styles">
    .buttonColumn {
      width: 2em;
    }
    .moveUpButton,
    .moveDownButton {
      width: 100%;
    }
    tbody tr:first-of-type td .moveUpButton,
    tbody tr:last-of-type td .moveDownButton {
      display: none;
    }
    td.urlCell {
      word-break: break-word;
    }
    .newUrlInput {
      min-width: 23em;
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div class="gr-form-styles">
    <table>
      <thead>
        <tr>
          <th class="nameHeader">Name</th>
          <th class="url-header">URL</th>
        </tr>
      </thead>
      <tbody>
        <template is="dom-repeat" items="[[menuItems]]">
          <tr>
            <td>[[item.name]]</td>
            <td class="urlCell">[[item.url]]</td>
            <td class="buttonColumn">
              <gr-button
                link=""
                data-index$="[[index]]"
                on-click="_handleMoveUpButton"
                class="moveUpButton"
                >↑</gr-button
              >
            </td>
            <td class="buttonColumn">
              <gr-button
                link=""
                data-index$="[[index]]"
                on-click="_handleMoveDownButton"
                class="moveDownButton"
                >↓</gr-button
              >
            </td>
            <td>
              <gr-button
                link=""
                data-index$="[[index]]"
                on-click="_handleDeleteButton"
                class="remove-button"
                >Delete</gr-button
              >
            </td>
          </tr>
        </template>
      </tbody>
      <tfoot>
        <tr>
          <th>
            <iron-input
              placeholder="New Title"
              on-keydown="_handleInputKeydown"
              bind-value="{{_newName}}"
            >
              <input
                is="iron-input"
                placeholder="New Title"
                on-keydown="_handleInputKeydown"
                bind-value="{{_newName}}"
              />
            </iron-input>
          </th>
          <th>
            <iron-input
              class="newUrlInput"
              placeholder="New URL"
              on-keydown="_handleInputKeydown"
              bind-value="{{_newUrl}}"
            >
              <input
                class="newUrlInput"
                is="iron-input"
                placeholder="New URL"
                on-keydown="_handleInputKeydown"
                bind-value="{{_newUrl}}"
              />
            </iron-input>
          </th>
          <th></th>
          <th></th>
          <th>
            <gr-button
              link=""
              disabled$="[[_computeAddDisabled(_newName, _newUrl)]]"
              on-click="_handleAddButton"
              >Add</gr-button
            >
          </th>
        </tr>
      </tfoot>
    </table>
  </div>
`;var WS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let qS=class extends(oo(dr(oa))){static get template(){return zS}_handleMoveUpButton(e){const t=qo(e).localTarget;if(!(t instanceof HTMLElement))return;const n=Number(t.dataset.index);if(0===n)return;const i=this.menuItems[n],o=this.menuItems[n-1];this.splice("menuItems",n-1,2,i,o)}_handleMoveDownButton(e){const t=qo(e).localTarget;if(!(t instanceof HTMLElement))return;const n=Number(t.dataset.index);if(n===this.menuItems.length-1)return;const i=this.menuItems[n],o=this.menuItems[n+1];this.splice("menuItems",n,2,o,i)}_handleDeleteButton(e){const t=qo(e).localTarget;if(!(t instanceof HTMLElement))return;const n=Number(t.dataset.index);this.splice("menuItems",n,1)}_handleAddButton(){this._computeAddDisabled(this._newName,this._newUrl)||(this.splice("menuItems",this.menuItems.length,0,{name:this._newName,url:this._newUrl,target:"_blank"}),this._newName="",this._newUrl="")}_computeAddDisabled(e,t){return!(null==e?void 0:e.length)||!(null==t?void 0:t.length)}_handleInputKeydown(e){13===e.keyCode&&(e.stopPropagation(),this._handleAddButton())}};WS([Bl({type:Array})],qS.prototype,"menuItems",void 0),WS([Bl({type:String})],qS.prototype,"_newName",void 0),WS([Bl({type:String})],qS.prototype,"_newUrl",void 0),qS=WS([Ml("gr-menu-editor")],qS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const KS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    .statusHeader {
      width: 4em;
    }
    .keyHeader {
      width: 7.5em;
    }
    #viewKeyOverlay {
      padding: var(--spacing-xxl);
      width: 50em;
    }
    .publicKey {
      font-family: var(--monospace-font-family);
      font-size: var(--font-size-mono);
      line-height: var(--line-height-mono);
      overflow-x: scroll;
      overflow-wrap: break-word;
      width: 30em;
    }
    .closeButton {
      bottom: 2em;
      position: absolute;
      right: 2em;
    }
    #existing {
      margin-bottom: var(--spacing-l);
    }
    #existing .commentColumn {
      min-width: 27em;
      width: auto;
    }
  </style>
  <div class="gr-form-styles">
    <fieldset id="existing">
      <table>
        <thead>
          <tr>
            <th class="commentColumn">Comment</th>
            <th class="statusHeader">Status</th>
            <th class="keyHeader">Public key</th>
            <th></th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <template is="dom-repeat" items="[[_keys]]" as="key">
            <tr>
              <td class="commentColumn">[[key.comment]]</td>
              <td>[[_getStatusLabel(key.valid)]]</td>
              <td>
                <gr-button link="" on-click="_showKey" data-index$="[[index]]"
                  >Click to View</gr-button
                >
              </td>
              <td>
                <gr-copy-clipboard
                  has-tooltip=""
                  button-title="Copy SSH public key to clipboard"
                  hide-input=""
                  text="[[key.ssh_public_key]]"
                >
                </gr-copy-clipboard>
              </td>
              <td>
                <gr-button
                  link=""
                  data-index$="[[index]]"
                  on-click="_handleDeleteKey"
                  >Delete</gr-button
                >
              </td>
            </tr>
          </template>
        </tbody>
      </table>
      <gr-overlay id="viewKeyOverlay" with-backdrop="">
        <fieldset>
          <section>
            <span class="title">Algorithm</span>
            <span class="value">[[_keyToView.algorithm]]</span>
          </section>
          <section>
            <span class="title">Public key</span>
            <span class="value publicKey">[[_keyToView.encoded_key]]</span>
          </section>
          <section>
            <span class="title">Comment</span>
            <span class="value">[[_keyToView.comment]]</span>
          </section>
        </fieldset>
        <gr-button class="closeButton" on-click="_closeOverlay"
          >Close</gr-button
        >
      </gr-overlay>
      <gr-button on-click="save" disabled$="[[!hasUnsavedChanges]]"
        >Save changes</gr-button
      >
    </fieldset>
    <fieldset>
      <section>
        <span class="title">New SSH key</span>
        <span class="value">
          <iron-autogrow-textarea
            id="newKey"
            autocomplete="on"
            bind-value="{{_newKey}}"
            placeholder="New SSH Key"
          ></iron-autogrow-textarea>
        </span>
      </section>
      <gr-button
        id="addButton"
        link=""
        disabled$="[[_computeAddButtonDisabled(_newKey)]]"
        on-click="_handleAddKey"
        >Add new SSH key</gr-button
      >
    </fieldset>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var YS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};let XS=class extends(oo(dr(oa))){constructor(){super(...arguments),this.hasUnsavedChanges=!1,this._keys=[],this._newKey="",this._keysToRemove=[]}static get template(){return KS}loadData(){return this.$.restAPI.getAccountSSHKeys().then(e=>{e&&(this._keys=e)})}save(){const e=this._keysToRemove.map(e=>this.$.restAPI.deleteAccountSSHKey(`${e.seq}`));return Promise.all(e).then(()=>{this._keysToRemove=[],this.hasUnsavedChanges=!1})}_getStatusLabel(e){return e?"Valid":"Invalid"}_showKey(e){const t=qo(e).localTarget,n=parseInt(t.getAttribute("data-index"),10);this._keyToView=this._keys[n],this.$.viewKeyOverlay.open()}_closeOverlay(){this.$.viewKeyOverlay.close()}_handleDeleteKey(e){const t=qo(e).localTarget,n=parseInt(t.getAttribute("data-index"),10);this.push("_keysToRemove",this._keys[n]),this.splice("_keys",n,1),this.hasUnsavedChanges=!0}_handleAddKey(){return this.$.addButton.disabled=!0,this.$.newKey.disabled=!0,this.$.restAPI.addAccountSSHKey(this._newKey.trim()).then(e=>{this.$.newKey.disabled=!1,this._newKey="",this.push("_keys",e)}).catch(()=>{this.$.addButton.disabled=!1,this.$.newKey.disabled=!1})}_computeAddButtonDisabled(e){return!e.length}};YS([Bl({type:Boolean,notify:!0})],XS.prototype,"hasUnsavedChanges",void 0),YS([Bl({type:Array})],XS.prototype,"_keys",void 0),YS([Bl({type:Object})],XS.prototype,"_keyToView",void 0),YS([Bl({type:String})],XS.prototype,"_newKey",void 0),YS([Bl({type:Array})],XS.prototype,"_keysToRemove",void 0),XS=YS([Ml("gr-ssh-editor")],XS);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const JS=ta`
  <style include="shared-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-form-styles">
    #watchedProjects .notifType {
      text-align: center;
      padding: 0 var(--spacing-s);
    }
    .notifControl {
      cursor: pointer;
      text-align: center;
    }
    .notifControl:hover {
      outline: 1px solid var(--border-color);
    }
    .projectFilter {
      color: var(--deemphasized-text-color);
      font-style: italic;
      margin-left: var(--spacing-l);
    }
    .newFilterInput {
      width: 100%;
    }
  </style>
  <div class="gr-form-styles">
    <table id="watchedProjects">
      <thead>
        <tr>
          <th>Repo</th>
          <template is="dom-repeat" items="[[_getTypes()]]">
            <th class="notifType">[[item.name]]</th>
          </template>
          <th></th>
        </tr>
      </thead>
      <tbody>
        <template
          is="dom-repeat"
          items="[[_projects]]"
          as="project"
          index-as="projectIndex"
        >
          <tr>
            <td>
              [[project.project]]
              <template is="dom-if" if="[[project.filter]]">
                <div class="projectFilter">[[project.filter]]</div>
              </template>
            </td>
            <template is="dom-repeat" items="[[_getTypes()]]" as="type">
              <td class="notifControl" on-click="_handleNotifCellClick">
                <input
                  type="checkbox"
                  data-index$="[[projectIndex]]"
                  data-key$="[[type.key]]"
                  on-change="_handleCheckboxChange"
                  checked$="[[_computeCheckboxChecked(project, type.key)]]"
                />
              </td>
            </template>
            <td>
              <gr-button
                link=""
                data-index$="[[projectIndex]]"
                on-click="_handleRemoveProject"
                >Delete</gr-button
              >
            </td>
          </tr>
        </template>
      </tbody>
      <tfoot>
        <tr>
          <th>
            <gr-autocomplete
              id="newProject"
              query="[[_query]]"
              threshold="1"
              allow-non-suggested-values=""
              tab-complete=""
              placeholder="Repo"
            ></gr-autocomplete>
          </th>
          <th colspan$="[[_getTypeCount()]]">
            <iron-input
              class="newFilterInput"
              placeholder="branch:name, or other search expression"
            >
              <input
                id="newFilter"
                class="newFilterInput"
                is="iron-input"
                placeholder="branch:name, or other search expression"
              />
            </iron-input>
          </th>
          <th>
            <gr-button link="" on-click="_handleAddProject">Add</gr-button>
          </th>
        </tr>
      </tfoot>
    </table>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`;var ZS=window&&window.__decorate||function(e,t,n,i){var o,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,n,r):o(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};const QS=[{name:"Changes",key:"notify_new_changes"},{name:"Patches",key:"notify_new_patch_sets"},{name:"Comments",key:"notify_all_comments"},{name:"Submits",key:"notify_submitted_changes"},{name:"Abandons",key:"notify_abandoned_changes"}];let eA=class extends(oo(dr(oa))){constructor(){super(),this.hasUnsavedChanges=!1,this._projectsToRemove=[],this._query=e=>this._getProjectSuggestions(e)}static get template(){return JS}loadData(){return this.$.restAPI.getWatchedProjects().then(e=>{this._projects=e})}save(){let e;return e=this._projectsToRemove.length?this.$.restAPI.deleteWatchedProjects(this._projectsToRemove):Promise.resolve(void 0),e.then(()=>this._projects?this.$.restAPI.saveWatchedProjects(this._projects):Promise.resolve(void 0)).then(e=>{this._projects=e,this._projectsToRemove=[],this.hasUnsavedChanges=!1})}_getTypes(){return QS}_getTypeCount(){return this._getTypes().length}_computeCheckboxChecked(e,t){return o(e,t)}_getProjectSuggestions(e){return this.$.restAPI.getSuggestedProjects(e).then(e=>{const t=[];for(const n in e)o(e,n)&&t.push({name:n,value:e[n].id});return t})}_handleRemoveProject(e){const t=qo(e).localTarget.getAttribute("data-index");if(null===t||!this._projects)return;const n=parseInt(t,10),i=this._projects[n];this.splice("_projects",n,1),this.push("_projectsToRemove",i),this.hasUnsavedChanges=!0}_canAddProject(e,t,n){if(null===e&&null===t)return!1;if(!e&&t)return!0;if(!this._projects)return!0;for(let t=0;t<this._projects.length;t++)if(this._projects[t].project===e&&this.areFiltersEqual(this._projects[t].filter,n))return!1;return!0}_getNewProjectIndex(e,t){if(!this._projects)return;let n;for(n=0;n<this._projects.length;n++){const i=this._projects[n].filter;if(this._projects[n].project>e||this._projects[n].project===e&&this.isFilterDefined(i)&&this.isFilterDefined(t)&&i>t)break}return n}_handleAddProject(){const e=this.$.newProject.value,t=this.$.newProject.text,n=this.$.newFilter.value||null;if(!this._canAddProject(e,t,n))return;const i=this._getNewProjectIndex(t,n);void 0!==i&&this.splice("_projects",i,0,{project:t,filter:n,_is_local:!0}),this.$.newProject.clear(),this.$.newFilter.value="",this.hasUnsavedChanges=!0}_handleCheckboxChange(e){const t=qo(e).localTarget;if(null===t)return;const n=t.getAttribute("data-index"),i=t.getAttribute("data-key");if(null===n||null===i)return;const o=parseInt(n,10),s=t.checked;this.set(["_projects",o,i],!!s),this.hasUnsavedChanges=!0}_handleNotifCellClick(e){if(null===e.target)return;const t=e.target.querySelector("input");t&&t.click()}isFilterDefined(e){return null!=e}areFiltersEqual(e,t){return!this.isFilterDefined(e)&&!this.isFilterDefined(t)||e===t}};ZS([Bl({type:Boolean,notify:!0})],eA.prototype,"hasUnsavedChanges",void 0),ZS([Bl({type:Array})],eA.prototype,"_projects",void 0),ZS([Bl({type:Array})],eA.prototype,"_projectsToRemove",void 0),ZS([Bl({type:Object})],eA.prototype,"_query",void 0),eA=ZS([Ml("gr-watched-projects-editor")],eA);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const tA=ta`
  <style include="shared-styles">
    :host {
      color: var(--primary-text-color);
    }
    h2 {
      font-family: var(--header-font-family);
      font-size: var(--font-size-h2);
      font-weight: var(--font-weight-h2);
      line-height: var(--line-height-h2);
    }
    .newEmailInput {
      width: 20em;
    }
    #email {
      margin-bottom: var(--spacing-l);
    }
    main section.darkToggle {
      display: block;
    }
    .filters p,
    .darkToggle p {
      margin-bottom: var(--spacing-l);
    }
    .queryExample em {
      color: violet;
    }
    .toggle {
      align-items: center;
      display: flex;
      margin-bottom: var(--spacing-l);
      margin-right: var(--spacing-l);
    }
  </style>
  <style include="gr-form-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-menu-page-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <style include="gr-page-nav-styles">
    /* Workaround for empty style block - see https://github.com/Polymer/tools/issues/408 */
  </style>
  <div class="loading" hidden$="[[!_loading]]">Loading...</div>
  <div hidden$="[[_loading]]" hidden="">
    <gr-page-nav class="navStyles">
      <ul>
        <li><a href="#Profile">Profile</a></li>
        <li><a href="#Preferences">Preferences</a></li>
        <li><a href="#DiffPreferences">Diff Preferences</a></li>
        <li><a href="#EditPreferences">Edit Preferences</a></li>
        <li><a href="#Menu">Menu</a></li>
        <li><a href="#ChangeTableColumns">Change Table Columns</a></li>
        <li><a href="#Notifications">Notifications</a></li>
        <li><a href="#EmailAddresses">Email Addresses</a></li>
        <template is="dom-if" if="[[_showHttpAuth(_serverConfig)]]">
          <li><a href="#HTTPCredentials">HTTP Credentials</a></li>
        </template>
        <li hidden$="[[!_serverConfig.sshd]]">
          <a href="#SSHKeys">
            SSH Keys
          </a>
        </li>
        <li hidden$="[[!_serverConfig.receive.enable_signed_push]]">
          <a href="#GPGKeys">
            GPG Keys
          </a>
        </li>
        <li><a href="#Groups">Groups</a></li>
        <li><a href="#Identities">Identities</a></li>
        <template
          is="dom-if"
          if="[[_serverConfig.auth.use_contributor_agreements]]"
        >
          <li>
            <a href="#Agreements">Agreements</a>
          </li>
        </template>
        <li><a href="#MailFilters">Mail Filters</a></li>
        <gr-endpoint-decorator name="settings-menu-item">
        </gr-endpoint-decorator>
      </ul>
    </gr-page-nav>
    <main class="gr-form-styles">
      <h1 class="heading-1">User Settings</h1>
      <section class="darkToggle">
        <div class="toggle">
          <paper-toggle-button
            aria-labelledby="darkThemeToggleLabel"
            checked="[[_isDark]]"
            on-change="_handleToggleDark"
            on-tap="_onTapDarkToggle"
          ></paper-toggle-button>
          <div id="darkThemeToggleLabel">Dark theme (alpha)</div>
        </div>
        <p>
          Gerrit's dark theme is in early alpha, and almost definitely will not
          play nicely with themes set by specific Gerrit hosts. Filing feedback
          via the link in the app footer is strongly encouraged!
        </p>
      </section>
      <h2 id="Profile" class$="[[_computeHeaderClass(_accountInfoChanged)]]">
        Profile
      </h2>
      <fieldset id="profile">
        <gr-account-info
          id="accountInfo"
          has-unsaved-changes="{{_accountInfoChanged}}"
        ></gr-account-info>
        <gr-button
          on-click="_handleSaveAccountInfo"
          disabled="[[!_accountInfoChanged]]"
          >Save changes</gr-button
        >
      </fieldset>
      <h2 id="Preferences" class$="[[_computeHeaderClass(_prefsChanged)]]">
        Preferences
      </h2>
      <fieldset id="preferences">
        <section>
          <span class="title">Changes per page</span>
          <span class="value">
            <gr-select bind-value="{{_localPrefs.changes_per_page}}">
              <select>
                <option value="10">10 rows per page</option>
                <option value="25">25 rows per page</option>
                <option value="50">50 rows per page</option>
                <option value="100">100 rows per page</option>
              </select>
            </gr-select>
          </span>
        </section>
        <section>
          <span class="title">Date/time format</span>
          <span class="value">
            <gr-select bind-value="{{_localPrefs.date_format}}">
              <select>
                <option value="STD">Jun 3 ; Jun 3, 2016</option>
                <option value="US">06/03 ; 06/03/16</option>
                <option value="ISO">06-03 ; 2016-06-03</option>
                <option value="EURO">3. Jun ; 03.06.2016</option>
                <option value="UK">03/06 ; 03/06/2016</option>
              </select>
            </gr-select>
            <gr-select bind-value="{{_localPrefs.time_format}}">
              <select>
                <option value="HHMM_12">4:10 PM</option>
                <option value="HHMM_24">16:10</option>
              </select>
            </gr-select>
          </span>
        </section>
        <section>
          <span class="title">Email notifications</span>
          <span class="value">
            <gr-select bind-value="{{_localPrefs.email_strategy}}">
              <select>
                <option value="CC_ON_OWN_COMMENTS">Every comment</option>
                <option value="ENABLED">Only comments left by others</option>
                <option value="DISABLED">None</option>
              </select>
            </gr-select>
          </span>
        </section>
        <section hidden$="[[!_localPrefs.email_format]]">
          <span class="title">Email format</span>
          <span class="value">
            <gr-select bind-value="{{_localPrefs.email_format}}">
              <select>
                <option value="HTML_PLAINTEXT">HTML and plaintext</option>
                <option value="PLAINTEXT">Plaintext only</option>
              </select>
            </gr-select>
          </span>
        </section>
        <section hidden$="[[!_localPrefs.default_base_for_merges]]">
          <span class="title">Default Base For Merges</span>
          <span class="value">
            <gr-select bind-value="{{_localPrefs.default_base_for_merges}}">
              <select>
                <option value="AUTO_MERGE">Auto Merge</option>
                <option value="FIRST_PARENT">First Parent</option>
              </select>
            </gr-select>
          </span>
        </section>
        <section>
          <span class="title">Show Relative Dates In Changes Table</span>
          <span class="value">
            <input
              id="relativeDateInChangeTable"
              type="checkbox"
              checked$="[[_localPrefs.relative_date_in_change_table]]"
              on-change="_handleRelativeDateInChangeTable"
            />
          </span>
        </section>
        <section>
          <span class="title">Diff view</span>
          <span class="value">
            <gr-select bind-value="{{_localPrefs.diff_view}}">
              <select>
                <option value="SIDE_BY_SIDE">Side by side</option>
                <option value="UNIFIED_DIFF">Unified diff</option>
              </select>
            </gr-select>
          </span>
        </section>
        <section>
          <span class="title">Show size bars in file list</span>
          <span class="value">
            <input
              id="showSizeBarsInFileList"
              type="checkbox"
              checked$="[[_localPrefs.size_bar_in_change_table]]"
              on-change="_handleShowSizeBarsInFileListChanged"
            />
          </span>
        </section>
        <section>
          <span class="title">Publish comments on push</span>
          <span class="value">
            <input
              id="publishCommentsOnPush"
              type="checkbox"
              checked$="[[_localPrefs.publish_comments_on_push]]"
              on-change="_handlePublishCommentsOnPushChanged"
            />
          </span>
        </section>
        <section>
          <span class="title"
            >Set new changes to "work in progress" by default</span
          >
          <span class="value">
            <input
              id="workInProgressByDefault"
              type="checkbox"
              checked$="[[_localPrefs.work_in_progress_by_default]]"
              on-change="_handleWorkInProgressByDefault"
            />
          </span>
        </section>
        <section>
          <span class="title">
            Insert Signed-off-by Footer For Inline Edit Changes
          </span>
          <span class="value">
            <input
              id="insertSignedOff"
              type="checkbox"
              checked$="[[_localPrefs.signed_off_by]]"
              on-change="_handleInsertSignedOff"
            />
          </span>
        </section>
        <gr-button
          id="savePrefs"
          on-click="_handleSavePreferences"
          disabled="[[!_prefsChanged]]"
          >Save changes</gr-button
        >
      </fieldset>
      <h2
        id="DiffPreferences"
        class$="[[_computeHeaderClass(_diffPrefsChanged)]]"
      >
        Diff Preferences
      </h2>
      <fieldset id="diffPreferences">
        <gr-diff-preferences
          id="diffPrefs"
          has-unsaved-changes="{{_diffPrefsChanged}}"
        ></gr-diff-preferences>
        <gr-button
          id="saveDiffPrefs"
          on-click="_handleSaveDiffPreferences"
          disabled$="[[!_diffPrefsChanged]]"
          >Save changes</gr-button
        >
      </fieldset>
      <h2
        id="EditPreferences"
        class$="[[_computeHeaderClass(_editPrefsChanged)]]"
      >
        Edit Preferences
      </h2>
      <fieldset id="editPreferences">
        <gr-edit-preferences
          id="editPrefs"
          has-unsaved-changes="{{_editPrefsChanged}}"
        ></gr-edit-preferences>
        <gr-button
          id="saveEditPrefs"
          on-click="_handleSaveEditPreferences"
          disabled$="[[!_editPrefsChanged]]"
          >Save changes</gr-button
        >
      </fieldset>
      <h2 id="Menu" class$="[[_computeHeaderClass(_menuChanged)]]">Menu</h2>
      <fieldset id="menu">
        <gr-menu-editor menu-items="{{_localMenu}}"></gr-menu-editor>
        <gr-button
          id="saveMenu"
          on-click="_handleSaveMenu"
          disabled="[[!_menuChanged]]"
          >Save changes</gr-button
        >
        <gr-button id="resetMenu" link="" on-click="_handleResetMenuButton"
          >Reset</gr-button
        >
      </fieldset>
      <h2
        id="ChangeTableColumns"
        class$="[[_computeHeaderClass(_changeTableChanged)]]"
      >
        Change Table Columns
      </h2>
      <fieldset id="changeTableColumns">
        <gr-change-table-editor
          show-number="{{_showNumber}}"
          displayed-columns="{{_localChangeTableColumns}}"
        >
        </gr-change-table-editor>
        <gr-button
          id="saveChangeTable"
          on-click="_handleSaveChangeTable"
          disabled="[[!_changeTableChanged]]"
          >Save changes</gr-button
        >
      </fieldset>
      <h2
        id="Notifications"
        class$="[[_computeHeaderClass(_watchedProjectsChanged)]]"
      >
        Notifications
      </h2>
      <fieldset id="watchedProjects">
        <gr-watched-projects-editor
          has-unsaved-changes="{{_watchedProjectsChanged}}"
          id="watchedProjectsEditor"
        ></gr-watched-projects-editor>
        <gr-button
          on-click="_handleSaveWatchedProjects"
          disabled$="[[!_watchedProjectsChanged]]"
          id="_handleSaveWatchedProjects"
          >Save changes</gr-button
        >
      </fieldset>
      <h2 id="EmailAddresses" class$="[[_computeHeaderClass(_emailsChanged)]]">
        Email Addresses
      </h2>
      <fieldset id="email">
        <gr-email-editor
          id="emailEditor"
          has-unsaved-changes="{{_emailsChanged}}"
        ></gr-email-editor>
        <gr-button on-click="_handleSaveEmails" disabled$="[[!_emailsChanged]]"
          >Save changes</gr-button
        >
      </fieldset>
      <fieldset id="newEmail">
        <section>
          <span class="title">New email address</span>
          <span class="value">
            <iron-input
              class="newEmailInput"
              bind-value="{{_newEmail}}"
              type="text"
              on-keydown="_handleNewEmailKeydown"
              placeholder="email@example.com"
            >
              <input
                class="newEmailInput"
                bind-value="{{_newEmail}}"
                is="iron-input"
                type="text"
                disabled="[[_addingEmail]]"
                on-keydown="_handleNewEmailKeydown"
                placeholder="email@example.com"
              />
            </iron-input>
          </span>
        </section>
        <section
          id="verificationSentMessage"
          hidden$="[[!_lastSentVerificationEmail]]"
        >
          <p>
            A verification email was sent to
            <em>[[_lastSentVerificationEmail]]</em>. Please check your inbox.
          </p>
        </section>
        <gr-button
          disabled="[[!_computeAddEmailButtonEnabled(_newEmail, _addingEmail)]]"
          on-click="_handleAddEmailButton"
          >Send verification</gr-button
        >
      </fieldset>
      <template is="dom-if" if="[[_showHttpAuth(_serverConfig)]]">
        <div>
          <h2 id="HTTPCredentials">HTTP Credentials</h2>
          <fieldset>
            <gr-http-password id="httpPass"></gr-http-password>
          </fieldset>
        </div>
      </template>
      <div hidden$="[[!_serverConfig.sshd]]">
        <h2 id="SSHKeys" class$="[[_computeHeaderClass(_keysChanged)]]">
          SSH keys
        </h2>
        <gr-ssh-editor
          id="sshEditor"
          has-unsaved-changes="{{_keysChanged}}"
        ></gr-ssh-editor>
      </div>
      <div hidden$="[[!_serverConfig.receive.enable_signed_push]]">
        <h2 id="GPGKeys" class$="[[_computeHeaderClass(_gpgKeysChanged)]]">
          GPG keys
        </h2>
        <gr-gpg-editor
          id="gpgEditor"
          has-unsaved-changes="{{_gpgKeysChanged}}"
        ></gr-gpg-editor>
      </div>
      <h2 id="Groups">Groups</h2>
      <fieldset>
        <gr-group-list id="groupList"></gr-group-list>
      </fieldset>
      <h2 id="Identities">Identities</h2>
      <fieldset>
        <gr-identities
          id="identities"
          server-config="[[_serverConfig]]"
        ></gr-identities>
      </fieldset>
      <template
        is="dom-if"
        if="[[_serverConfig.auth.use_contributor_agreements]]"
      >
        <h2 id="Agreements">Agreements</h2>
        <fieldset>
          <gr-agreements-list id="agreementsList"></gr-agreements-list>
        </fieldset>
      </template>
      <h2 id="MailFilters">Mail Filters</h2>
      <fieldset class="filters">
        <p>
          Gerrit emails include metadata about the change to support writing
          mail filters.
        </p>
        <p>
          Here are some example Gmail queries that can be used for filters or
          for searching through archived messages. View the
          <a
            href$="[[_getFilterDocsLink(_docsBaseUrl)]]"
            target="_blank"
            rel="nofollow"
            >Gerrit documentation</a
          >
          for the complete set of footers.
        </p>
        <table>
          <tbody>
            <tr>
              <th>Name</th>
              <th>Query</th>
            </tr>
            <tr>
              <td>Changes requesting my review</td>
              <td>
                <code class="queryExample">
                  "Gerrit-Reviewer: <em>Your Name</em>
                  &lt;<em>your.email@example.com</em>&gt;"
                </code>
              </td>
            </tr>
            <tr>
              <td>Changes requesting my attention</td>
              <td>
                <code class="queryExample">
                  "Gerrit-Attention: <em>Your Name</em>
                  &lt;<em>your.email@example.com</em>&gt;"
                </code>
              </td>
            </tr>
            <tr>
              <td>Changes from a specific owner</td>
              <td>
                <code class="queryExample">
                  "Gerrit-Owner: <em>Owner name</em>
                  &lt;<em>owner.email@example.com</em>&gt;"
                </code>
              </td>
            </tr>
            <tr>
              <td>Changes targeting a specific branch</td>
              <td>
                <code class="queryExample">
                  "Gerrit-Branch: <em>branch-name</em>"
                </code>
              </td>
            </tr>
            <tr>
              <td>Changes in a specific project</td>
              <td>
                <code class="queryExample">
                  "Gerrit-Project: <em>project-name</em>"
                </code>
              </td>
            </tr>
            <tr>
              <td>Messages related to a specific Change ID</td>
              <td>
                <code class="queryExample">
                  "Gerrit-Change-Id: <em>Change ID</em>"
                </code>
              </td>
            </tr>
            <tr>
              <td>Messages related to a specific change number</td>
              <td>
                <code class="queryExample">
                  "Gerrit-Change-Number: <em>change number</em>"
                </code>
              </td>
            </tr>
          </tbody>
        </table>
      </fieldset>
      <gr-endpoint-decorator name="settings-screen"> </gr-endpoint-decorator>
    </main>
  </div>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
`
/**
 * @license
 * Copyright (C) 2016 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */,nA=["changes_per_page","date_format","time_format","email_strategy","diff_view","publish_comments_on_push","work_in_progress_by_default","default_base_for_merges","signed_off_by","email_format","size_bar_in_change_table","relative_date_in_change_table"],iA=/^https?:/,oA=/\/$/,sA=["HTTP","HTTP_LDAP"];class rA extends(z_(oo(dr(oa)))){static get template(){return tA}static get is(){return"gr-settings-view"}static get properties(){return{prefs:{type:Object,value:()=>({})},params:{type:Object,value:()=>({})},_accountInfoChanged:Boolean,_changeTableColumnsNotDisplayed:Array,_localPrefs:{type:Object,value:()=>({})},_localChangeTableColumns:{type:Array,value:()=>[]},_localMenu:{type:Array,value:()=>[]},_loading:{type:Boolean,value:!0},_changeTableChanged:{type:Boolean,value:!1},_prefsChanged:{type:Boolean,value:!1},_diffPrefsChanged:Boolean,_editPrefsChanged:Boolean,_menuChanged:{type:Boolean,value:!1},_watchedProjectsChanged:{type:Boolean,value:!1},_keysChanged:{type:Boolean,value:!1},_gpgKeysChanged:{type:Boolean,value:!1},_newEmail:String,_addingEmail:{type:Boolean,value:!1},_lastSentVerificationEmail:{type:String,value:null},_serverConfig:Object,_docsBaseUrl:String,_emailsChanged:Boolean,_loadingPromise:Object,_showNumber:Boolean,_isDark:{type:Boolean,value:!1}}}static get observers(){return["_handlePrefsChanged(_localPrefs.*)","_handleMenuChanged(_localMenu.splices)","_handleChangeTableChanged(_localChangeTableColumns, _showNumber)"]}attached(){super.attached(),this.listen(window,"location-change","_handleLocationChange"),this.dispatchEvent(new CustomEvent("title-change",{detail:{title:"Settings"},composed:!0,bubbles:!0})),this._isDark=!!window.localStorage.getItem("dark-theme");const e=[this.$.accountInfo.loadData(),this.$.watchedProjectsEditor.loadData(),this.$.groupList.loadData(),this.$.identities.loadData(),this.$.editPrefs.loadData(),this.$.diffPrefs.loadData()];e.push(this.$.restAPI.getPreferences().then(e=>{this.prefs=e,this._showNumber=!!e.legacycid_in_change_table,this._copyPrefs("_localPrefs","prefs"),this._cloneMenu(e.my),this._cloneChangeTableColumns()})),e.push(this.$.restAPI.getConfig().then(e=>{this._serverConfig=e;const t=[];return this._serverConfig&&this._serverConfig.sshd&&t.push(this.$.sshEditor.loadData()),this._serverConfig&&this._serverConfig.receive&&this._serverConfig.receive.enable_signed_push&&t.push(this.$.gpgEditor.loadData()),t.push(U(e,this.$.restAPI).then(e=>{this._docsBaseUrl=e})),Promise.all(t)})),this.params.emailToken?e.push(this.$.restAPI.confirmEmail(this.params.emailToken).then(e=>{e&&this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:e},composed:!0,bubbles:!0})),this.$.emailEditor.loadData()})):e.push(this.$.emailEditor.loadData()),this._loadingPromise=Promise.all(e).then(()=>{this._loading=!1,this._handleLocationChange()})}detached(){super.detached(),this.unlisten(window,"location-change","_handleLocationChange")}_handleLocationChange(){const e=window.location.hash;if(e){const t=(this.shadowRoot||document).querySelector(e);t&&t.scrollIntoView()}}reloadAccountDetail(){Promise.all([this.$.accountInfo.loadData(),this.$.emailEditor.loadData()])}_isLoading(){return this._loading||void 0===this._loading}_copyPrefs(e,t){for(let n=0;n<nA.length;n++)this.set([e,nA[n]],this[t][nA[n]])}_cloneMenu(e){const t=[];for(const n of e)t.push({name:n.name,url:n.url,target:n.target});this._localMenu=t}_cloneChangeTableColumns(){let e=this.getVisibleColumns(this.prefs.change_table);0===e.length?(e=this.columnNames,this._changeTableColumnsNotDisplayed=[]):this._changeTableColumnsNotDisplayed=this.getComplementColumns(this.prefs.change_table),this._localChangeTableColumns=e}_formatChangeTableColumns(e){return e.map(e=>({column:e}))}_handleChangeTableChanged(){this._isLoading()||(this._changeTableChanged=!0)}_handlePrefsChanged(e){this._isLoading()||(this._prefsChanged=!0)}_handleRelativeDateInChangeTable(){this.set("_localPrefs.relative_date_in_change_table",this.$.relativeDateInChangeTable.checked)}_handleShowSizeBarsInFileListChanged(){this.set("_localPrefs.size_bar_in_change_table",this.$.showSizeBarsInFileList.checked)}_handlePublishCommentsOnPushChanged(){this.set("_localPrefs.publish_comments_on_push",this.$.publishCommentsOnPush.checked)}_handleWorkInProgressByDefault(){this.set("_localPrefs.work_in_progress_by_default",this.$.workInProgressByDefault.checked)}_handleInsertSignedOff(){this.set("_localPrefs.signed_off_by",this.$.insertSignedOff.checked)}_handleMenuChanged(){this._isLoading()||(this._menuChanged=!0)}_handleSaveAccountInfo(){this.$.accountInfo.save()}_handleSavePreferences(){return this._copyPrefs("prefs","_localPrefs"),this.$.restAPI.savePreferences(this.prefs).then(()=>{this._prefsChanged=!1})}_handleSaveChangeTable(){return this.set("prefs.change_table",this._localChangeTableColumns),this.set("prefs.legacycid_in_change_table",this._showNumber),this._cloneChangeTableColumns(),this.$.restAPI.savePreferences(this.prefs).then(()=>{this._changeTableChanged=!1})}_handleSaveDiffPreferences(){this.$.diffPrefs.save()}_handleSaveEditPreferences(){this.$.editPrefs.save()}_handleSaveMenu(){return this.set("prefs.my",this._localMenu),this._cloneMenu(this.prefs.my),this.$.restAPI.savePreferences(this.prefs).then(()=>{this._menuChanged=!1})}_handleResetMenuButton(){return this.$.restAPI.getDefaultPreferences().then(e=>{e&&e.my&&this._cloneMenu(e.my)})}_handleSaveWatchedProjects(){this.$.watchedProjectsEditor.save()}_computeHeaderClass(e){return e?"edited":""}_handleSaveEmails(){this.$.emailEditor.save()}_handleNewEmailKeydown(e){13===e.keyCode&&(e.stopPropagation(),this._handleAddEmailButton())}_isNewEmailValid(e){return e&&e.includes("@")}_computeAddEmailButtonEnabled(e,t){return this._isNewEmailValid(e)&&!t}_handleAddEmailButton(){this._isNewEmailValid(this._newEmail)&&(this._addingEmail=!0,this.$.restAPI.addAccountEmail(this._newEmail).then(e=>{this._addingEmail=!1,e.status<200||e.status>=300||(this._lastSentVerificationEmail=this._newEmail,this._newEmail="")}))}_getFilterDocsLink(e){let t=e;return t&&iA.test(t)||(t="https://gerrit-review.googlesource.com/Documentation"),t=t.replace(oA,""),t+"/user-notify.html"}_handleToggleDark(){this._isDark?(window.localStorage.removeItem("dark-theme"),function(){const e=document.head.querySelectorAll("#dark-theme");e.length&&e.forEach(e=>e.remove())}()):(window.localStorage.setItem("dark-theme","true"),Fh()),this._isDark=!!window.localStorage.getItem("dark-theme"),this.dispatchEvent(new CustomEvent("show-alert",{detail:{message:`Theme changed to ${this._isDark?"dark":"light"}.`},bubbles:!0,composed:!0}))}_showHttpAuth(e){return!!(e&&e.auth&&e.auth.git_basic_auth_policy)&&sA.includes(e.auth.git_basic_auth_policy.toUpperCase())}_onTapDarkToggle(e){e.preventDefault()}}customElements.define(rA.is,rA);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const aA=ta`
  <style include="shared-styles">
    :host {
      background-color: var(--background-color-tertiary);
      display: flex;
      flex-direction: column;
      min-height: 100%;
    }
    gr-main-header,
    footer {
      color: var(--primary-text-color);
    }
    gr-main-header {
      background: var(
        --header-background,
        var(--header-background-color, #eee)
      );
      padding: var(--header-padding);
      border-bottom: var(--header-border-bottom);
      border-image: var(--header-border-image);
      border-right: 0;
      border-left: 0;
      border-top: 0;
      box-shadow: var(--header-box-shadow);
    }
    footer {
      background: var(
        --footer-background,
        var(--footer-background-color, #eee)
      );
      border-top: var(--footer-border-top);
      display: flex;
      justify-content: space-between;
      padding: var(--spacing-m) var(--spacing-l);
      z-index: 100;
    }
    main {
      flex: 1;
      padding-bottom: var(--spacing-xxl);
      position: relative;
    }
    .errorView {
      align-items: center;
      display: none;
      flex-direction: column;
      justify-content: center;
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
    }
    .errorView.show {
      display: flex;
    }
    .errorEmoji {
      font-size: 2.6rem;
    }
    .errorText,
    .errorMoreInfo {
      margin-top: var(--spacing-m);
    }
    .errorText {
      font-family: var(--header-font-family);
      font-size: var(--font-size-h3);
      font-weight: var(--font-weight-h3);
      line-height: var(--line-height-h3);
    }
    .errorMoreInfo {
      color: var(--deemphasized-text-color);
    }
    .feedback {
      color: var(--error-text-color);
    }
  </style>
  <gr-endpoint-decorator name="banner"></gr-endpoint-decorator>
  <gr-main-header
    id="mainHeader"
    search-query="{{params.query}}"
    on-mobile-search="_mobileSearchToggle"
    on-show-keyboard-shortcuts="handleShowKeyboardShortcuts"
    mobile-search-hidden="[[!mobileSearch]]"
    login-url="[[_loginUrl]]"
  >
  </gr-main-header>
  <main>
    <template is="dom-if" if="[[mobileSearch]]">
      <gr-smart-search
        id="search"
        label="Search for changes"
        search-query="{{params.query}}"
        hidden="[[!mobileSearch]]"
      >
      </gr-smart-search>
    </template>
    <template is="dom-if" if="[[_showChangeListView]]" restamp="true">
      <gr-change-list-view
        params="[[params]]"
        account="[[_account]]"
        view-state="{{_viewState.changeListView}}"
      ></gr-change-list-view>
    </template>
    <template is="dom-if" if="[[_showDashboardView]]" restamp="true">
      <gr-dashboard-view
        account="[[_account]]"
        params="[[params]]"
        view-state="{{_viewState.dashboardView}}"
      ></gr-dashboard-view>
    </template>
    <template is="dom-if" if="[[_showChangeView]]" restamp="true">
      <gr-change-view
        params="[[params]]"
        view-state="{{_viewState.changeView}}"
        back-page="[[_lastSearchPage]]"
      ></gr-change-view>
    </template>
    <template is="dom-if" if="[[_showEditorView]]" restamp="true">
      <gr-editor-view params="[[params]]"></gr-editor-view>
    </template>
    <template is="dom-if" if="[[_showDiffView]]" restamp="true">
      <gr-diff-view
        params="[[params]]"
        change-view-state="{{_viewState.changeView}}"
      ></gr-diff-view>
    </template>
    <template is="dom-if" if="[[_showSettingsView]]" restamp="true">
      <gr-settings-view
        params="[[params]]"
        on-account-detail-update="_handleAccountDetailUpdate"
      >
      </gr-settings-view>
    </template>
    <template is="dom-if" if="[[_showAdminView]]" restamp="true">
      <gr-admin-view path="[[_path]]" params="[[params]]"></gr-admin-view>
    </template>
    <template is="dom-if" if="[[_showPluginScreen]]" restamp="true">
      <gr-endpoint-decorator name="[[_pluginScreenName]]">
        <gr-endpoint-param
          name="token"
          value="[[params.screen]]"
        ></gr-endpoint-param>
      </gr-endpoint-decorator>
    </template>
    <template is="dom-if" if="[[_showCLAView]]" restamp="true">
      <gr-cla-view></gr-cla-view>
    </template>
    <template is="dom-if" if="[[_showDocumentationSearch]]" restamp="true">
      <gr-documentation-search params="[[params]]"> </gr-documentation-search>
    </template>
    <div id="errorView" class="errorView">
      <div class="errorEmoji">[[_lastError.emoji]]</div>
      <div class="errorText">[[_lastError.text]]</div>
      <div class="errorMoreInfo">[[_lastError.moreInfo]]</div>
    </div>
  </main>
  <footer r="contentinfo">
    <div>
      Powered by
      <a href="https://www.gerritcodereview.com/" rel="noopener" target="_blank"
        >Gerrit Code Review</a
      >
      ([[_version]])
      <gr-endpoint-decorator name="footer-left"></gr-endpoint-decorator>
    </div>
    <div>
      <template is="dom-if" if="[[_feedbackUrl]]">
        <a
          class="feedback"
          href$="[[_feedbackUrl]]"
          rel="noopener"
          target="_blank"
          >Report bug</a
        >
        |
      </template>
      Press “?” for keyboard shortcuts
      <gr-endpoint-decorator name="footer-right"></gr-endpoint-decorator>
    </div>
  </footer>
  <template is="dom-if" if="[[loadKeyboardShortcutsDialog]]">
    <gr-overlay id="keyboardShortcuts" with-backdrop="">
      <gr-keyboard-shortcuts-dialog
        on-close="_handleKeyboardShortcutDialogClose"
      ></gr-keyboard-shortcuts-dialog>
    </gr-overlay>
  </template>
  <template is="dom-if" if="[[loadRegistrationDialog]]">
    <gr-overlay id="registrationOverlay" with-backdrop="">
      <gr-registration-dialog
        id="registrationDialog"
        settings-url="[[_settingsUrl]]"
        on-account-detail-update="_handleAccountDetailUpdate"
        on-close="_handleRegistrationDialogClose"
      >
      </gr-registration-dialog>
    </gr-overlay>
  </template>
  <gr-endpoint-decorator name="plugin-overlay"></gr-endpoint-decorator>
  <gr-error-manager
    id="errorManager"
    login-url="[[_loginUrl]]"
  ></gr-error-manager>
  <gr-rest-api-interface id="restAPI"></gr-rest-api-interface>
  <gr-router id="router"></gr-router>
  <gr-plugin-host id="plugins" config="[[_serverConfig]]"> </gr-plugin-host>
  <gr-lib-loader id="libLoader"></gr-lib-loader>
  <gr-external-style
    id="externalStyleForAll"
    name="app-theme"
  ></gr-external-style>
  <gr-external-style
    id="externalStyleForTheme"
    name="[[getThemeEndpoint()]]"
  ></gr-external-style>
`
/**
 * @license
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */;class lA extends(xp(oo(dr(oa)))){static get template(){return aA}static get is(){return"gr-app-element"}static get properties(){return{params:Object,keyEventTarget:{type:Object,value:()=>document.body},_account:{type:Object,observer:"_accountChanged"},_lastGKeyPressTimestamp:{type:Number,value:null},_serverConfig:Object,_version:String,_showChangeListView:Boolean,_showDashboardView:Boolean,_showChangeView:Boolean,_showDiffView:Boolean,_showSettingsView:Boolean,_showAdminView:Boolean,_showCLAView:Boolean,_showEditorView:Boolean,_showPluginScreen:Boolean,_showDocumentationSearch:Boolean,_viewState:Object,_lastError:Object,_lastSearchPage:String,_path:String,_pluginScreenName:{type:String,computed:"_computePluginScreenName(params)"},_settingsUrl:String,_feedbackUrl:String,mobileSearch:{type:Boolean,value:!1},_loginUrl:{type:String,value:"/login"},loadRegistrationDialog:{type:Boolean,value:!1},loadKeyboardShortcutsDialog:{type:Boolean,value:!1}}}static get observers(){return["_viewChanged(params.view)","_paramsChanged(params.*)"]}keyboardShortcuts(){return{[yp.OPEN_SHORTCUT_HELP_DIALOG]:"_showKeyboardShortcuts",[yp.GO_TO_USER_DASHBOARD]:"_goToUserDashboard",[yp.GO_TO_OPENED_CHANGES]:"_goToOpenedChanges",[yp.GO_TO_MERGED_CHANGES]:"_goToMergedChanges",[yp.GO_TO_ABANDONED_CHANGES]:"_goToAbandonedChanges",[yp.GO_TO_WATCHED_CHANGES]:"_goToWatchedChanges"}}constructor(){super(),this.reporting=n.reportingService}created(){super.created(),this._bindKeyboardShortcuts(),this.addEventListener("page-error",e=>this._handlePageError(e)),this.addEventListener("title-change",e=>this._handleTitleChange(e)),this.addEventListener("location-change",e=>this._handleLocationChange(e)),this.addEventListener("rpc-log",e=>this._handleRpcLog(e)),this.addEventListener("shortcut-triggered",e=>this._handleShortcutTriggered(e)),this.addEventListener("reload",e=>window.location.reload())}ready(){super.ready(),this._updateLoginUrl(),this.reporting.appStarted(),this.$.router.start(),this.$.restAPI.getAccount().then(e=>{this._account=e;const t=e?"user":"guest";this.reporting.reportLifeCycle(`Started as ${t}`)}),this.$.restAPI.getConfig().then(e=>{this._serverConfig=e,e&&e.gerrit&&e.gerrit.report_bug_url&&(this._feedbackUrl=e.gerrit.report_bug_url)}),this.$.restAPI.getVersion().then(e=>{this._version=e,this._logWelcome()}),window.localStorage.getItem("dark-theme")&&Fh(),this._settingsUrl=gh.getUrlForSettings(),this._viewState={changeView:{changeNum:null,patchRange:null,selectedFileIndex:0,showReplyDialog:!1,showDownloadDialog:!1,diffMode:null,numFilesShown:null,scrollTop:0},changeListView:{query:null,offset:0,selectedChangeIndex:0},dashboardView:{selectedChangeIndex:0}}}_bindKeyboardShortcuts(){this.bindShortcut(yp.SEND_REPLY,_p.DOC_ONLY,"ctrl+enter","meta+enter"),this.bindShortcut(yp.EMOJI_DROPDOWN,_p.DOC_ONLY,":"),this.bindShortcut(yp.OPEN_SHORTCUT_HELP_DIALOG,"?"),this.bindShortcut(yp.GO_TO_USER_DASHBOARD,_p.GO_KEY,"i"),this.bindShortcut(yp.GO_TO_OPENED_CHANGES,_p.GO_KEY,"o"),this.bindShortcut(yp.GO_TO_MERGED_CHANGES,_p.GO_KEY,"m"),this.bindShortcut(yp.GO_TO_ABANDONED_CHANGES,_p.GO_KEY,"a"),this.bindShortcut(yp.GO_TO_WATCHED_CHANGES,_p.GO_KEY,"w"),this.bindShortcut(yp.CURSOR_NEXT_CHANGE,"j"),this.bindShortcut(yp.CURSOR_PREV_CHANGE,"k"),this.bindShortcut(yp.OPEN_CHANGE,"o"),this.bindShortcut(yp.NEXT_PAGE,"n","]"),this.bindShortcut(yp.PREV_PAGE,"p","["),this.bindShortcut(yp.TOGGLE_CHANGE_REVIEWED,"r:keyup"),this.bindShortcut(yp.TOGGLE_CHANGE_STAR,"s:keydown"),this.bindShortcut(yp.REFRESH_CHANGE_LIST,"shift+r:keyup"),this.bindShortcut(yp.EDIT_TOPIC,"t"),this.bindShortcut(yp.OPEN_REPLY_DIALOG,"a:keyup"),this.bindShortcut(yp.OPEN_DOWNLOAD_DIALOG,"d:keyup"),this.bindShortcut(yp.EXPAND_ALL_MESSAGES,"x"),this.bindShortcut(yp.COLLAPSE_ALL_MESSAGES,"z"),this.bindShortcut(yp.REFRESH_CHANGE,"shift+r:keyup"),this.bindShortcut(yp.UP_TO_DASHBOARD,"u"),this.bindShortcut(yp.UP_TO_CHANGE,"u"),this.bindShortcut(yp.TOGGLE_DIFF_MODE,"m:keyup"),this.bindShortcut(yp.DIFF_AGAINST_BASE,_p.V_KEY,"down","s"),this.bindShortcut(yp.DIFF_AGAINST_LATEST,_p.V_KEY,"up","w"),this.bindShortcut(yp.DIFF_BASE_AGAINST_LEFT,_p.V_KEY,"left","a"),this.bindShortcut(yp.DIFF_RIGHT_AGAINST_LATEST,_p.V_KEY,"right","d"),this.bindShortcut(yp.DIFF_BASE_AGAINST_LATEST,_p.V_KEY,"b"),this.bindShortcut(yp.NEXT_LINE,"j","down"),this.bindShortcut(yp.PREV_LINE,"k","up"),this._isCursorManagerSupportMoveToVisibleLine()&&this.bindShortcut(yp.VISIBLE_LINE,"."),this.bindShortcut(yp.NEXT_CHUNK,"n"),this.bindShortcut(yp.PREV_CHUNK,"p"),this.bindShortcut(yp.EXPAND_ALL_DIFF_CONTEXT,"shift+x"),this.bindShortcut(yp.NEXT_COMMENT_THREAD,"shift+n"),this.bindShortcut(yp.PREV_COMMENT_THREAD,"shift+p"),this.bindShortcut(yp.EXPAND_ALL_COMMENT_THREADS,_p.DOC_ONLY,"e"),this.bindShortcut(yp.COLLAPSE_ALL_COMMENT_THREADS,_p.DOC_ONLY,"shift+e"),this.bindShortcut(yp.LEFT_PANE,"shift+left"),this.bindShortcut(yp.RIGHT_PANE,"shift+right"),this.bindShortcut(yp.TOGGLE_LEFT_PANE,"shift+a"),this.bindShortcut(yp.NEW_COMMENT,"c"),this.bindShortcut(yp.SAVE_COMMENT,"ctrl+enter","meta+enter","ctrl+s","meta+s"),this.bindShortcut(yp.OPEN_DIFF_PREFS,","),this.bindShortcut(yp.TOGGLE_DIFF_REVIEWED,"r:keyup"),this.bindShortcut(yp.NEXT_FILE,"]"),this.bindShortcut(yp.PREV_FILE,"["),this.bindShortcut(yp.NEXT_FILE_WITH_COMMENTS,"shift+j"),this.bindShortcut(yp.PREV_FILE_WITH_COMMENTS,"shift+k"),this.bindShortcut(yp.CURSOR_NEXT_FILE,"j","down"),this.bindShortcut(yp.CURSOR_PREV_FILE,"k","up"),this.bindShortcut(yp.OPEN_FILE,"o","enter"),this.bindShortcut(yp.TOGGLE_FILE_REVIEWED,"r:keyup"),this.bindShortcut(yp.NEXT_UNREVIEWED_FILE,"shift+m"),this.bindShortcut(yp.TOGGLE_ALL_INLINE_DIFFS,"shift+i:keyup"),this.bindShortcut(yp.TOGGLE_INLINE_DIFF,"i:keyup"),this.bindShortcut(yp.TOGGLE_BLAME,"b:keyup"),this.bindShortcut(yp.TOGGLE_HIDE_ALL_COMMENT_THREADS,"h"),this.bindShortcut(yp.OPEN_FIRST_FILE,"]"),this.bindShortcut(yp.OPEN_LAST_FILE,"["),this.bindShortcut(yp.SEARCH,"/")}_isCursorManagerSupportMoveToVisibleLine(){return"IntersectionObserver"in window}_accountChanged(e){e&&(this.$.restAPI.getPreferences(),this.$.restAPI.getDiffPreferences(),this.$.restAPI.getEditPreferences(),this.$.errorManager.knownAccountId=this._account&&this._account._account_id||null)}_viewChanged(e){this.$.errorView.classList.remove("show"),this.set("_showChangeListView",e===gh.View.SEARCH),this.set("_showDashboardView",e===gh.View.DASHBOARD),this.set("_showChangeView",e===gh.View.CHANGE),this.set("_showDiffView",e===gh.View.DIFF),this.set("_showSettingsView",e===gh.View.SETTINGS),this.set("_showAdminView",e===gh.View.ADMIN||e===gh.View.GROUP||e===gh.View.REPO),this.set("_showCLAView",e===gh.View.AGREEMENTS),this.set("_showEditorView",e===gh.View.EDIT);const t=e===gh.View.PLUGIN_SCREEN;if(this.set("_showPluginScreen",!1),t&&this.async(()=>this.set("_showPluginScreen",!0),1),this.set("_showDocumentationSearch",e===gh.View.DOCUMENTATION_SEARCH),this.params.justRegistered){this.loadRegistrationDialog=!0,Mo();const e=this.shadowRoot.querySelector("#registrationOverlay"),t=this.shadowRoot.querySelector("#registrationDialog");e.open(),t.loadData().then(()=>{e.refit()})}}_handleShortcutTriggered(e){const{event:t,goKey:n,vKey:i}=e.detail;let o=`${t.key}:${t.type}`;n&&(o="g+"+o),i&&(o="v+"+o),t.shiftKey&&(o="shift+"+o),t.ctrlKey&&(o="ctrl+"+o),t.metaKey&&(o="meta+"+o),t.altKey&&(o="alt+"+o),this.reporting.reportInteraction("shortcut-triggered",{key:o,from:e.path&&e.path[0]&&e.path[0].nodeName||"unknown"})}_handlePageError(e){const t=["_showChangeListView","_showDashboardView","_showChangeView","_showDiffView","_showSettingsView","_showAdminView"];for(const e of t)this.set(e,!1);this.$.errorView.classList.add("show");const n=e.detail.response,i={text:[n.status,n.statusText].join(" ")};404===n.status?(i.emoji="¯\\_(ツ)_/¯",this._lastError=i):(i.emoji="o_O",n.text().then(e=>{i.moreInfo=e,this._lastError=i}))}_handleLocationChange(e){this._updateLoginUrl();const t=e.detail.hash.substring(1);let n=e.detail.pathname;n.startsWith("/c/")&&parseInt(t,10)>0&&(n+="@"+t),this.set("_path",n)}_updateLoginUrl(){const e=j();this._loginUrl=e?e+"/login/"+encodeURIComponent("/"+window.location.pathname.substring(e.length)+window.location.search+window.location.hash):"/login/"+encodeURIComponent(window.location.pathname+window.location.search+window.location.hash)}_paramsChanged(e){const t=e.base;[gh.View.SEARCH,gh.View.DASHBOARD].includes(t.view)&&this.set("_lastSearchPage",location.pathname)}_handleTitleChange(e){e.detail.title?document.title=e.detail.title+" · Gerrit Code Review":document.title=""}handleShowKeyboardShortcuts(){this.loadKeyboardShortcutsDialog=!0,Mo(),this.shadowRoot.querySelector("#keyboardShortcuts").open()}_showKeyboardShortcuts(e){this.loadKeyboardShortcutsDialog=!0,Mo();const t=this.shadowRoot.querySelector("#keyboardShortcuts");t&&(t.opened?t.close():this.shouldSuppressKeyboardShortcut(e)||t.open())}_handleKeyboardShortcutDialogClose(){this.shadowRoot.querySelector("#keyboardShortcuts").close()}_handleAccountDetailUpdate(e){this.$.mainHeader.reload(),this.params.view===gh.View.SETTINGS&&this.shadowRoot.querySelector("gr-settings-view").reloadAccountDetail()}_handleRegistrationDialogClose(e){this.params.justRegistered=!1,this.shadowRoot.querySelector("#registrationOverlay").close()}_goToOpenedChanges(){gh.navigateToStatusSearch("open")}_goToUserDashboard(){gh.navigateToUserDashboard()}_goToMergedChanges(){gh.navigateToStatusSearch("merged")}_goToAbandonedChanges(){gh.navigateToStatusSearch("abandoned")}_goToWatchedChanges(){gh.navigateToSearchQuery("is:watched is:open")}_computePluginScreenName({plugin:e,screen:t}){return e&&t?`${e}-screen-${t}`:""}_logWelcome(){console.group("Runtime Info"),console.info("Gerrit UI (PolyGerrit)"),console.info(`Gerrit Server Version: ${this._version}`),window.VERSION_INFO&&console.info(`UI Version Info: ${window.VERSION_INFO}`),this._feedbackUrl&&console.info(`Please file bugs and feedback at: ${this._feedbackUrl}`),console.groupEnd()}_handleRpcLog(e){this.reporting.reportRpcTiming(e.detail.anonymizedUrl,e.detail.elapsed)}_mobileSearchToggle(e){this.mobileSearch=!this.mobileSearch}getThemeEndpoint(){return window.localStorage.getItem("dark-theme")?"app-theme-dark":"app-theme-light"}}customElements.define(lA.is,lA);
/**
 * @license
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const cA=ta`
  <gr-app-element id="app-element"></gr-app-element>
`;
/**
 * @license
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */window.goog=window.goog||{declareModuleId(e){}},Te=!1,fe(!0),security.polymer_resin.install({allowedIdentifierPrefixes:[""],reportHandler:security.polymer_resin.CONSOLE_LOGGING_REPORT_HANDLER,safeTypesBridge:function(e,n){if("URL"===n){let n=null;if(e instanceof t?n=e:"string"==typeof e&&(n=new t(e)),n)return n.toString()}if("STRING"===n||"CONSTANT"===n)return e;throw new Error(`Refused to bind value as ${n}: ${e}`)}});class dA extends(oo(dr(oa))){static get template(){return cA}static get is(){return"gr-app"}}customElements.define(dA.is,dA),window.GrDisplayNameUtils={getUserName:ol,getDisplayName:sl,getAccountDisplayName:rl,getGroupDisplayName:ll},window.GrAnnotation=dl,window.GrAttributeHelper=hl,window.GrDiffLine=gl,window.GrDiffLineType=ul,window.GrDiffGroup=bl,window.GrDiffGroupType=_l,window.GrDiffBuilder=El,window.GrDiffBuilderSideBySide=Sl,window.GrDiffBuilderImage=xl,window.GrDiffBuilderUnified=Pl,window.GrDiffBuilderBinary=Rl,window.GrChangeActionsInterface=kl,window.GrChangeReplyInterface=Ol,window.GrEditConstants=Nl,window.GrDomHooksManager=Ll,window.GrDomHook=Dl,window.GrEtagDecorator=$l,window.GrThemeApi=zl,window.SiteBasedCache=Wl,window.FetchPromisesCache=ql,window.GrRestApiHelper=Kl,window.GrLinkTextParser=ec,window.GrPluginEndpoints=oc,window.GrReviewerUpdatesParser=_c,window.GrPopupInterface=td,window.GrCountStringFormatter=nd,window.GrReviewerSuggestionsProvider=ad,window.util=ld,window.page=hd,window.Auth=n.authService,window.EventEmitter=n.eventEmitter,window.GrAdminApi=pd,window.GrAnnotationActionsContext=ud,window.GrAnnotationActionsInterface=gd,window.GrChangeMetadataApi=_d,window.GrEmailSuggestionsProvider=fd,window.GrGroupSuggestionsProvider=vd,window.GrEventHelper=yd,window.GrPluginRestApi=Cd,window.GrRepoApi=xd,window.GrSettingsApi=Ld,window.GrStylesApi=Fd,window.PluginLoader=Zd,window.GrPluginActionContext=th,window._apiUtils={getPluginNameFromUrl:Ud,send:Gd,getRestAPI:Hd,getBaseUrl:j,PRELOADED_PROTOCOL:"preloaded:",PLUGIN_LOADING_TIMEOUT_MS:1e4},window.Gerrit=window.Gerrit||{},window.Gerrit.Nav=gh,window.Gerrit.getRootElement=mh,window.Gerrit.Auth=n.authService,window.Gerrit._pluginLoader=eh(),window.Gerrit._endpoints=rc(),window.Gerrit.slotToContent=e=>e,window.Gerrit.rangesEqual=_h,window.Gerrit.SUGGESTIONS_PROVIDERS_USERS_TYPES=rd,window.Gerrit.RevisionInfo=Nh,window.Gerrit.CoverageType=nc,Object.defineProperty(window.Gerrit,"hiddenscroll",{get:$h,set:Dh}),Tu();